/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/platform","vs/base/common/path","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/resources","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/base/common/arrays","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/objects","fs","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/base/common/uuid","vs/base/common/json","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/process","vs/base/common/map","os","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","child_process","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/product/common/product","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/node/decoder","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","util","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/localizations/node/localizations","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/code/electron-browser/sharedProcess/contrib/nodeCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","path","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ee=function(K){for(var e=[],S=0,k=K.length;S<k;S++)e[S]=Z[K[S]];return e};define(Z[84],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function S(k,A){if(!k)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=S}),define(Z[62],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const S=Object.prototype.hasOwnProperty;function k(R){const d=[];for(let y in R)S.call(R,y)&&d.push(R[y]);return d}e.values=k;function A(R,d){for(let y in R)if(S.call(R,y)&&d({key:y,value:R[y]},function(){delete R[y]})===!1)return}e.forEach=A;function L(R,d){const y=Object.create(null);for(const I of R){const o=d(I);let C=y[o];C||(C=y[o]=[]),C.push(I)}return y}e.groupBy=L;function U(R){const d=Object.create(null);return R&&R.forEach((y,I)=>{d[I]=y}),d}e.fromMap=U;function T(R,d){const y=[],I=[];for(let o of R)d.has(o)||y.push(o);for(let o of d)R.has(o)||I.push(o);return{removed:y,added:I}}e.diffSets=T;function f(R,d){const y=[],I=[];for(let[o,C]of R)d.has(o)||y.push(C);for(let[o,C]of d)R.has(o)||I.push(C);return{removed:y,added:I}}e.diffMaps=f;class v{constructor(){this.map=new Map}add(d,y){let I=this.map.get(d);I||(I=new Set,this.map.set(d,I)),I.add(y)}delete(d,y){const I=this.map.get(d);!I||(I.delete(y),I.size===0&&this.map.delete(d))}forEach(d,y){const I=this.map.get(d);!I||I.forEach(y)}}e.SetMap=v}),define(Z[85],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function S(f){return(v,R,d)=>{let y=null,I=null;if(typeof d.value=="function"?(y="value",I=d.value):typeof d.get=="function"&&(y="get",I=d.get),!I)throw new Error("not supported");d[y]=f(I,R)}}e.createDecorator=S;let k=0;function A(){const f=`$memoize${k++}`;let v;const R=function(y,I,o){let C=null,b=null;if(typeof o.value=="function"?(C="value",b=o.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof o.get=="function"&&(C="get",b=o.get),!b)throw new Error("not supported");const E=`${f}:${I}`;o[C]=function(...p){return v=this,this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!0,enumerable:!1,writable:!0,value:b.apply(this,p)}),this[E]}};return R.clear=()=>{typeof v!="undefined"&&Object.getOwnPropertyNames(v).forEach(d=>{d.indexOf(f)===0&&delete v[d]})},R}e.createMemoizer=A;function L(f,v,R){return A()(f,v,R)}e.memoize=L;function U(f,v,R){return S((d,y)=>{const I=`$debounce$${y}`,o=`$debounce$result$${y}`;return function(...C){this[o]||(this[o]=R?R():void 0),clearTimeout(this[I]),v&&(this[o]=v(this[o],...C),C=[this[o]]),this[I]=setTimeout(()=>{d.apply(this,C),this[o]=R?R():void 0},f)}})}e.debounce=U;function T(f,v,R){return S((d,y)=>{const I=`$throttle$timer$${y}`,o=`$throttle$result$${y}`,C=`$throttle$lastRun$${y}`,b=`$throttle$pending$${y}`;return function(...E){if(this[o]||(this[o]=R?R():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),v&&(this[o]=v(this[o],...E)),!this[b]){const p=this[C]+f;p<=Date.now()?(this[C]=Date.now(),d.apply(this,[this[o]]),this[o]=R?R():void 0):(this[b]=!0,this[I]=setTimeout(()=>{this[b]=!1,this[C]=Date.now(),d.apply(this,[this[o]]),this[o]=R?R():void 0},p-Date.now()))}}})}e.throttle=T}),define(Z[11],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class S{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=S,e.errorHandler=new S;function k(n){e.errorHandler.setUnexpectedErrorHandler(n)}e.setUnexpectedErrorHandler=k;function A(n){f(n)||e.errorHandler.onUnexpectedError(n)}e.onUnexpectedError=A;function L(n){f(n)||e.errorHandler.onUnexpectedExternalError(n)}e.onUnexpectedExternalError=L;function U(n){if(n instanceof Error){let{name:t,message:i}=n;const s=n.stacktrace||n.stack;return{$isError:!0,name:t,message:i,stack:s}}return n}e.transformErrorForSerialization=U;const T="Canceled";function f(n){return n instanceof Error&&n.name===T&&n.message===T}e.isPromiseCanceledError=f;class v extends Error{constructor(){super(T);this.name=this.message}}e.CancellationError=v;function R(){const n=new Error(T);return n.name=n.message,n}e.canceled=R;function d(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}e.illegalArgument=d;function y(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}e.illegalState=y;function I(n){return n?new Error(`readonly property '${n} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=I;function o(n){const t=new Error(`${n} has been disposed`);return t.name="DISPOSED",t}e.disposed=o;function C(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}e.getErrorMessage=C;class b extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=b;class E extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=E;class p extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=p;function m(n){const t=n;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=m;function r(n,t=Object.create(null)){const i=new Error(n);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=r}),define(Z[18],ee([0,1,11]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function k($,H=0){return $[$.length-(1+H)]}e.tail=k;function A($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=A;function L($,H,q=(D,O)=>D===O){if($===H)return!0;if(!$||!H||$.length!==H.length)return!1;for(let D=0,O=$.length;D<O;D++)if(!q($[D],H[D]))return!1;return!0}e.equals=L;function U($,H,q){let D=0,O=$.length-1;for(;D<=O;){const F=(D+O)/2|0,N=q($[F],H);if(N<0)D=F+1;else if(N>0)O=F-1;else return F}return-(D+1)}e.binarySearch=U;function T($,H){let q=0,D=$.length;if(D===0)return 0;for(;q<D;){const O=Math.floor((q+D)/2);H($[O])?D=O:q=O+1}return q}e.findFirstInSorted=T;function f($,H,q){if($=$|0,$>=H.length)throw new TypeError("invalid index");let D=H[Math.floor(H.length*Math.random())],O=[],F=[],N=[];for(let V of H){const G=q(V,D);G<0?O.push(V):G>0?F.push(V):N.push(V)}return $<O.length?f($,O,q):$<O.length+N.length?N[0]:f($-(O.length+N.length),F,q)}e.quickSelect=f;function v($,H){const q=[];let D;for(const O of $.slice(0).sort(H))!D||H(D[0],O)!==0?(D=[O],q.push(D)):D.push(O);return q}e.groupBy=v;function R($,H,q){const D=[];function O(V,G,J){if(!(G===0&&J.length===0)){const Q=D[D.length-1];Q&&Q.start+Q.deleteCount===V?(Q.deleteCount+=G,Q.toInsert.push(...J)):D.push({start:V,deleteCount:G,toInsert:J})}}let F=0,N=0;for(;;){if(F===$.length){O(F,0,H.slice(N));break}if(N===H.length){O(F,$.length-F,[]);break}const V=$[F],G=H[N],J=q(V,G);J===0?(F+=1,N+=1):J<0?(O(F,1,[]),F+=1):J>0&&(O(F,0,[G]),N+=1)}return D}e.sortedDiff=R;function d($,H,q){const D=R($,H,q),O=[],F=[];for(const N of D)O.push(...$.slice(N.start,N.start+N.deleteCount)),F.push(...N.toInsert);return{removed:O,added:F}}e.delta=d;function y($,H,q){if(q===0)return[];const D=$.slice(0,q).sort(H);return o($,H,D,q,$.length),D}e.top=y;function I($,H,q,D,O){return q===0?Promise.resolve([]):new Promise((F,N)=>{(async()=>{const V=$.length,G=$.slice(0,q).sort(H);for(let J=q,Q=Math.min(q+D,V);J<V;J=Q,Q=Math.min(Q+D,V)){if(J>q&&await new Promise(ne=>setTimeout(ne)),O&&O.isCancellationRequested)throw(0,S.canceled)();o($,H,G,J,Q)}return G})().then(F,N)})}e.topAsync=I;function o($,H,q,D,O){for(const F=q.length;D<O;D++){const N=$[D];if(H(N,q[F-1])<0){q.pop();const V=T(q,G=>H(N,G)<0);q.splice(V,0,N)}}}function C($){return $.filter(H=>!!H)}e.coalesce=C;function b($){let H=0;for(let q=0;q<$.length;q++)$[q]&&($[H]=$[q],H+=1);$.length=H}e.coalesceInPlace=b;function E($,H,q){$.splice(q,0,$.splice(H,1)[0])}e.move=E;function p($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=p;function m($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=m;function r($,H){if(!H)return $.filter((D,O)=>$.indexOf(D)===O);const q=Object.create(null);return $.filter(D=>{const O=H(D);return q[O]?!1:(q[O]=!0,!0)})}e.distinct=r;function n($){const H=new Set;return $.filter(q=>H.has(q)?!1:(H.add(q),!0))}e.distinctES6=n;function t($){const H=Object.create(null);return q=>{const D=$(q);return H[D]?!1:(H[D]=!0,!0)}}e.uniqueFilter=t;function i($,H){for(let q=$.length-1;q>=0;q--){const D=$[q];if(H(D))return q}return-1}e.lastIndex=i;function s($,H){return $.length>0?$[0]:H}e.firstOrDefault=s;function c($,H,q=(D,O)=>D===O){let D=0;for(let O=0,F=Math.min($.length,H.length);O<F&&q($[O],H[O]);O++)D++;return D}e.commonPrefixLength=c;function a($){return[].concat(...$)}e.flatten=a;function l($,H){let q=typeof H=="number"?$:0;typeof H=="number"?q=$:(q=0,H=$);const D=[];if(q<=H)for(let O=q;O<H;O++)D.push(O);else for(let O=q;O>H;O--)D.push(O);return D}e.range=l;function h($,H,q){return $.reduce((D,O)=>(D[H(O)]=q?q(O):O,D),Object.create(null))}e.index=h;function g($,H){return $.push(H),()=>w($,H)}e.insert=g;function w($,H){const q=$.indexOf(H);if(q>-1)return $.splice(q,1),H}e.remove=w;function u($,H,q){const D=$.slice(0,H),O=$.slice(H);return D.concat(q,O)}e.arrayInsert=u;function P($,H){let q;if(typeof H=="number"){let D=H;q=()=>{const O=Math.sin(D++)*179426549;return O-Math.floor(O)}}else q=Math.random;for(let D=$.length-1;D>0;D-=1){const O=Math.floor(q()*(D+1)),F=$[D];$[D]=$[O],$[O]=F}}e.shuffle=P;function _($,H){const q=$.indexOf(H);q>-1&&($.splice(q,1),$.unshift(H))}e.pushToStart=_;function z($,H){const q=$.indexOf(H);q>-1&&($.splice(q,1),$.push(H))}e.pushToEnd=z;function B($,H){return Array.isArray($)?$.map(H):H($)}e.mapArrayOrNot=B;function M($){return Array.isArray($)?$:[$]}e.asArray=M;function j($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=j;function W($,H){for(const q of $){const D=H(q);if(D!==void 0)return D}}e.mapFind=W}),define(Z[63],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function S(k){const A=this;let L=!1,U;return function(){return L||(L=!0,U=k.apply(A,arguments)),U}}e.once=S}),define(Z[52],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(k){function A(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}k.is=A;const L=Object.freeze([]);function U(){return L}k.empty=U;function*T(n){yield n}k.single=T;function f(n){return n||L}k.from=f;function v(n){return!n||n[Symbol.iterator]().next().done===!0}k.isEmpty=v;function R(n){return n[Symbol.iterator]().next().value}k.first=R;function d(n,t){for(const i of n)if(t(i))return!0;return!1}k.some=d;function y(n,t){for(const i of n)if(t(i))return i}k.find=y;function*I(n,t){for(const i of n)t(i)&&(yield i)}k.filter=I;function*o(n,t){for(const i of n)yield t(i)}k.map=o;function*C(...n){for(const t of n)for(const i of t)yield i}k.concat=C;function*b(n){for(const t of n)for(const i of t)yield i}k.concatNested=b;function E(n,t,i){let s=i;for(const c of n)s=t(s,c);return s}k.reduce=E;function*p(n,t,i=n.length){for(t<0&&(t+=n.length),i<0?i+=n.length:i>n.length&&(i=n.length);t<i;t++)yield n[t]}k.slice=p;function m(n,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,n];const s=n[Symbol.iterator]();for(let c=0;c<t;c++){const a=s.next();if(a.done)return[i,k.empty()];i.push(a.value)}return[i,{[Symbol.iterator](){return s}}]}k.consume=m;function r(n,t,i=(s,c)=>s===c){const s=n[Symbol.iterator](),c=t[Symbol.iterator]();for(;;){const a=s.next(),l=c.next();if(a.done!==l.done)return!1;if(a.done)return!0;if(!i(a.value,l.value))return!1}}k.equals=r})(S=e.Iterable||(e.Iterable={}))}),define(Z[32],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S=e.ScanError||(e.ScanError={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function U(t,i=!1){let s=0,c=t.length,a="",l=0,h=16,g=0;function w(j){let W=0,$=0;for(;W<j;){const H=t.charCodeAt(s);if(H>=48&&H<=57)$=$*16+H-48;else if(H>=65&&H<=70)$=$*16+H-65+10;else if(H>=97&&H<=102)$=$*16+H-97+10;else break;s++,W++}return W<j&&($=-1),$}function u(j){s=j,a="",l=0,h=16,g=0}function P(){const j=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&v(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&v(t.charCodeAt(s)))for(s++;s<t.length&&v(t.charCodeAt(s));)s++;else return g=3,t.substring(j,s);let W=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&v(t.charCodeAt(s))){for(s++;s<t.length&&v(t.charCodeAt(s));)s++;W=s}else g=3;return t.substring(j,W)}function _(){let j="",W=s;for(;;){if(s>=c){j+=t.substring(W,s),g=2;break}const $=t.charCodeAt(s);if($===34){j+=t.substring(W,s),s++;break}if($===92){if(j+=t.substring(W,s),s++,s>=c){g=2;break}switch(t.charCodeAt(s++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:const q=w(4);q>=0?j+=String.fromCharCode(q):g=4;break;default:g=5}W=s;continue}if($>=0&&$<=31)if(f($)){j+=t.substring(W,s),g=2;break}else g=6;s++}return j}function z(){if(a="",g=0,l=s,s>=c)return l=c,h=17;let j=t.charCodeAt(s);if(T(j)){do s++,a+=String.fromCharCode(j),j=t.charCodeAt(s);while(T(j));return h=15}if(f(j))return s++,a+=String.fromCharCode(j),j===13&&t.charCodeAt(s)===10&&(s++,a+=`
`),h=14;switch(j){case 123:return s++,h=1;case 125:return s++,h=2;case 91:return s++,h=3;case 93:return s++,h=4;case 58:return s++,h=6;case 44:return s++,h=5;case 34:return s++,a=_(),h=10;case 47:const W=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<c&&!f(t.charCodeAt(s));)s++;return a=t.substring(W,s),h=12}if(t.charCodeAt(s+1)===42){s+=2;const $=c-1;let H=!1;for(;s<$;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,H=!0;break}s++}return H||(s++,g=1),a=t.substring(W,s),h=13}return a+=String.fromCharCode(j),s++,h=16;case 45:if(a+=String.fromCharCode(j),s++,s===c||!v(t.charCodeAt(s)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=P(),h=11;default:for(;s<c&&B(j);)s++,j=t.charCodeAt(s);if(l!==s){switch(a=t.substring(l,s),a){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return a+=String.fromCharCode(j),s++,h=16}}function B(j){if(T(j)||f(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let j;do j=z();while(j>=12&&j<=15);return j}return{setPosition:u,getPosition:()=>s,scan:i?M:z,getToken:()=>h,getTokenValue:()=>a,getTokenOffset:()=>l,getTokenLength:()=>s-l,getTokenError:()=>g}}e.createScanner=U;function T(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function v(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function d(t,i){const s=[],c=new Object;let a;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function g(w,u,P,_){l.value=w,l.offset=u,l.length=P,l.type=_,l.colonOffset=void 0,a=l}try{m(t,{onObjectBegin:(w,u)=>{if(i<=w)throw c;a=void 0,h=i>w,s.push("")},onObjectProperty:(w,u,P)=>{if(i<u||(g(w,u,P,"property"),s[s.length-1]=w,i<=u+P))throw c},onObjectEnd:(w,u)=>{if(i<=w)throw c;a=void 0,s.pop()},onArrayBegin:(w,u)=>{if(i<=w)throw c;a=void 0,s.push(0)},onArrayEnd:(w,u)=>{if(i<=w)throw c;a=void 0,s.pop()},onLiteralValue:(w,u,P)=>{if(i<u||(g(w,u,P,n(w)),i<=u+P))throw c},onSeparator:(w,u,P)=>{if(i<=u)throw c;if(w===":"&&a&&a.type==="property")a.colonOffset=u,h=!1,a=void 0;else if(w===","){const _=s[s.length-1];typeof _=="number"?s[s.length-1]=_+1:(h=!0,s[s.length-1]=""),a=void 0}}})}catch(w){if(w!==c)throw w}return{path:s,previousNode:a,isAtPropertyKey:h,matches:w=>{let u=0;for(let P=0;u<w.length&&P<s.length;P++)if(w[u]===s[P]||w[u]==="*")u++;else if(w[u]!=="**")return!1;return u===w.length}}}e.getLocation=d;function y(t,i=[],s=L.DEFAULT){let c=null,a=[];const l=[];function h(w){Array.isArray(a)?a.push(w):c!==null&&(a[c]=w)}return m(t,{onObjectBegin:()=>{const w={};h(w),l.push(a),a=w,c=null},onObjectProperty:w=>{c=w},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{const w=[];h(w),l.push(a),a=w,c=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:h,onError:(w,u,P)=>{i.push({error:w,offset:u,length:P})}},s),a[0]}e.parse=y;function I(t,i=[],s=L.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(w){c.type==="property"&&(c.length=w-c.offset,c=c.parent)}function l(w){return c.children.push(w),w}m(t,{onObjectBegin:w=>{c=l({type:"object",offset:w,length:-1,parent:c,children:[]})},onObjectProperty:(w,u,P)=>{c=l({type:"property",offset:u,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:w,offset:u,length:P,parent:c})},onObjectEnd:(w,u)=>{c.length=w+u-c.offset,c=c.parent,a(w+u)},onArrayBegin:(w,u)=>{c=l({type:"array",offset:w,length:-1,parent:c,children:[]})},onArrayEnd:(w,u)=>{c.length=w+u-c.offset,c=c.parent,a(w+u)},onLiteralValue:(w,u,P)=>{l({type:n(w),offset:u,length:P,parent:c,value:w}),a(u+P)},onSeparator:(w,u,P)=>{c.type==="property"&&(w===":"?c.colonOffset=u:w===","&&a(u))},onError:(w,u,P)=>{i.push({error:w,offset:u,length:P})}},s);const g=c.children[0];return g&&delete g.parent,g}e.parseTree=I;function o(t,i){if(!!t){let s=t;for(let c of i)if(typeof c=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let a=!1;for(const l of s.children)if(Array.isArray(l.children)&&l.children[0].value===c){s=l.children[1],a=!0;break}if(!a)return}else{const a=c;if(s.type!=="array"||a<0||!Array.isArray(s.children)||a>=s.children.length)return;s=s.children[a]}return s}}e.findNodeAtLocation=o;function C(t){if(!t.parent||!t.parent.children)return[];const i=C(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;i.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&i.push(s)}return i}e.getNodePath=C;function b(t){switch(t.type){case"array":return t.children.map(b);case"object":const i=Object.create(null);for(let s of t.children){const c=s.children[1];c&&(i[s.children[0].value]=b(c))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=b;function E(t,i,s=!1){return i>=t.offset&&i<t.offset+t.length||s&&i===t.offset+t.length}e.contains=E;function p(t,i,s=!1){if(E(t,i,s)){const c=t.children;if(Array.isArray(c))for(let a=0;a<c.length&&c[a].offset<=i;a++){const l=p(c[a],i,s);if(l)return l}return t}}e.findNodeAtOffset=p;function m(t,i,s=L.DEFAULT){const c=U(t,!1);function a(G){return G?()=>G(c.getTokenOffset(),c.getTokenLength()):()=>!0}function l(G){return G?J=>G(J,c.getTokenOffset(),c.getTokenLength()):()=>!0}const h=a(i.onObjectBegin),g=l(i.onObjectProperty),w=a(i.onObjectEnd),u=a(i.onArrayBegin),P=a(i.onArrayEnd),_=l(i.onLiteralValue),z=l(i.onSeparator),B=a(i.onComment),M=l(i.onError),j=s&&s.disallowComments,W=s&&s.allowTrailingComma;function $(){for(;;){const G=c.scan();switch(c.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:j||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(G){case 12:case 13:j?H(10):B();break;case 16:H(1);break;case 15:case 14:break;default:return G}}}function H(G,J=[],Q=[]){if(M(G),J.length+Q.length>0){let ne=c.getToken();for(;ne!==17;){if(J.indexOf(ne)!==-1){$();break}else if(Q.indexOf(ne)!==-1)break;ne=$()}}}function q(G){const J=c.getTokenValue();return G?_(J):g(J),$(),!0}function D(){switch(c.getToken()){case 11:let G=0;try{G=JSON.parse(c.getTokenValue()),typeof G!="number"&&(H(2),G=0)}catch(J){H(2)}_(G);break;case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return $(),!0}function O(){return c.getToken()!==10?(H(3,[],[2,5]),!1):(q(!1),c.getToken()===6?(z(":"),$(),V()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function F(){h(),$();let G=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(G||H(4,[],[]),z(","),$(),c.getToken()===2&&W)break}else G&&H(6,[],[]);O()||H(4,[],[2,5]),G=!0}return w(),c.getToken()!==2?H(7,[2],[]):$(),!0}function N(){u(),$();let G=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(G||H(4,[],[]),z(","),$(),c.getToken()===4&&W)break}else G&&H(6,[],[]);V()||H(4,[],[4,5]),G=!0}return P(),c.getToken()!==4?H(8,[4],[]):$(),!0}function V(){switch(c.getToken()){case 3:return N();case 1:return F();case 10:return q(!0);default:return D()}}return $(),c.getToken()===17?s.allowEmptyContent?!0:(H(4,[],[]),!1):V()?(c.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=m;function r(t,i){let s=U(t),c=[],a,l=0,h;do switch(h=s.getPosition(),a=s.scan(),a){case 12:case 13:case 17:l!==h&&c.push(t.substring(l,h)),i!==void 0&&c.push(s.getTokenValue().replace(/[^\r\n]/g,i)),l=s.getPosition();break}while(a!==17);return c.join("")}e.stripComments=r;function n(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=n}),define(Z[46],ee([0,1,32]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function k(f,v,R){let d,y,I,o,C;if(v){for(o=v.offset,C=o+v.length,I=o;I>0&&!T(f,I-1);)I--;let l=C;for(;l<f.length&&!T(f,l);)l++;y=f.substring(I,l),d=L(y,R)}else y=f,d=0,I=0,o=0,C=f.length;const b=U(R,f);let E=!1,p=0,m;R.insertSpaces?m=A(" ",R.tabSize||4):m="	";const r=(0,S.createScanner)(y,!1);let n=!1;function t(){return b+A(m,d+p)}function i(){let l=r.scan();for(E=!1;l===15||l===14;)E=E||l===14,l=r.scan();return n=l===16||r.getTokenError()!==0,l}const s=[];function c(l,h,g){!n&&h<C&&g>o&&f.substring(h,g)!==l&&s.push({offset:h,length:g-h,content:l})}let a=i();if(a!==17){const l=r.getTokenOffset()+I,h=A(m,d);c(h,I,l)}for(;a!==17;){let l=r.getTokenOffset()+r.getTokenLength()+I,h=i(),g="";for(;!E&&(h===12||h===13);){const u=r.getTokenOffset()+I;c(" ",l,u),l=r.getTokenOffset()+r.getTokenLength()+I,g=h===12?t():"",h=i()}if(h===2)a!==1&&(p--,g=t());else if(h===4)a!==3&&(p--,g=t());else{switch(a){case 3:case 1:p++,g=t();break;case 5:case 12:g=t();break;case 13:E?g=t():g=" ";break;case 6:g=" ";break;case 10:if(h===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?g=" ":h!==5&&h!==17&&(n=!0);break;case 16:n=!0;break}E&&(h===12||h===13)&&(g=t())}const w=r.getTokenOffset()+I;c(g,l,w),a=h}return s}e.format=k;function A(f,v){let R="";for(let d=0;d<v;d++)R+=f;return R}function L(f,v){let R=0,d=0;const y=v.tabSize||4;for(;R<f.length;){const I=f.charAt(R);if(I===" ")d++;else if(I==="	")d+=y;else break;R++}return Math.floor(d/y)}function U(f,v){for(let R=0;R<v.length;R++){const d=v.charAt(R);if(d==="\r")return R+1<v.length&&v.charAt(R+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return f&&f.eol||`
`}e.getEOL=U;function T(f,v){return`\r
`.indexOf(f.charAt(v))!==-1}e.isEOL=T}),define(Z[41],ee([0,1,32,46]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(v,R,d){return L(v,R,void 0,d)}e.removeProperty=A;function L(v,R,d,y,I){const o=R.slice(),C=[],b=(0,S.parseTree)(v,C);let E,p;for(;o.length>0&&(p=o.pop(),E=(0,S.findNodeAtLocation)(b,o),E===void 0&&d!==void 0);)typeof p=="string"?d={[p]:d}:d=[d];if(E)if(E.type==="object"&&typeof p=="string"&&Array.isArray(E.children)){const m=(0,S.findNodeAtLocation)(E,[p]);if(m!==void 0)if(d===void 0){if(!m.parent)throw new Error("Malformed AST");const r=E.children.indexOf(m.parent);let n,t=m.parent.offset+m.parent.length;if(r>0){const i=E.children[r-1];n=i.offset+i.length}else n=E.offset+1,E.children.length>1&&(t=E.children[1].offset);return U(v,{offset:n,length:t-n,content:""},y)}else return U(v,{offset:m.offset,length:m.length,content:JSON.stringify(d)},y);else{if(d===void 0)return[];const r=`${JSON.stringify(p)}: ${JSON.stringify(d)}`,n=I?I(E.children.map(i=>i.children[0].value)):E.children.length;let t;if(n>0){const i=E.children[n-1];t={offset:i.offset+i.length,length:0,content:","+r}}else E.children.length===0?t={offset:E.offset+1,length:0,content:r}:t={offset:E.offset+1,length:0,content:r+","};return U(v,t,y)}}else if(E.type==="array"&&typeof p=="number"&&Array.isArray(E.children))if(d!==void 0){const m=`${JSON.stringify(d)}`;let r;if(E.children.length===0||p===0)r={offset:E.offset+1,length:0,content:E.children.length===0?m:m+","};else{const n=p===-1||p>E.children.length?E.children.length:p,t=E.children[n-1];r={offset:t.offset+t.length,length:0,content:","+m}}return U(v,r,y)}else{const m=p,r=E.children[m];let n;if(E.children.length===1)n={offset:E.offset+1,length:E.length-2,content:""};else if(E.children.length-1===m){const t=E.children[m-1],i=t.offset+t.length,s=E.offset+E.length;n={offset:i,length:s-2-i,content:""}}else n={offset:r.offset,length:E.children[m+1].offset-r.offset,content:""};return U(v,n,y)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${E.type}`);else{if(d===void 0)throw new Error("Can not delete in empty document");return U(v,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(d)},y)}}e.setProperty=L;function U(v,R,d){let y=T(v,R),I=R.offset,o=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;I>0&&!(0,k.isEOL)(y,I-1);)I--;for(;o<y.length&&!(0,k.isEOL)(y,o);)o++}const C=(0,k.format)(y,{offset:I,length:o-I},d);for(let E=C.length-1;E>=0;E--){const p=C[E];y=T(y,p),I=Math.min(I,p.offset),o=Math.max(o,p.offset+p.length),o+=p.content.length-p.length}const b=v.length-(y.length-o)-I;return[{offset:I,length:b,content:y.substring(I,o)}]}e.withFormatting=U;function T(v,R){return v.substring(0,R.offset)+R.content+v.substring(R.offset+R.length)}e.applyEdit=T;function f(v,R){let d=R.slice(0).sort((I,o)=>{const C=I.offset-o.offset;return C===0?I.length-o.length:C}),y=v.length;for(let I=d.length-1;I>=0;I--){let o=d[I];if(o.offset+o.length<=y)v=T(v,o);else throw new Error("Overlapping edit");y=o.offset}return v}e.applyEdits=f}),define(Z[2],ee([0,1,63,52]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let L=null;function U(m){L=m}if(e.setDisposableTracker=U,A){const m="__is_disposable_tracked__";L=new class{trackDisposable(r){const n=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[m]||console.log(n)},3e3)}markTracked(r){if(r&&r!==C.None)try{r[m]=!0}catch(n){}}}}function T(m){!L||L.markTracked(m)}function f(m){return L&&L.trackDisposable(m),m}e.trackDisposable=f;class v extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=v;function R(m){return typeof m.dispose=="function"&&m.dispose.length===0}e.isDisposable=R;function d(m){if(k.Iterable.is(m)){let r=[];for(const n of m)if(n){T(n);try{n.dispose()}catch(t){r.push(t)}}if(r.length===1)throw r[0];if(r.length>1)throw new v(r);return Array.isArray(m)?[]:m}else if(m)return T(m),m.dispose(),m}e.dispose=d;function y(...m){return m.forEach(T),I(()=>d(m))}e.combinedDisposable=y;function I(m){const r=f({dispose:()=>{T(r),m()}});return r}e.toDisposable=I;class o{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(T(this),this._isDisposed=!0,this.clear())}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return T(r),this._isDisposed?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=o,o.DISABLE_DISPOSED_WARNING=!1;class C{constructor(){this._store=new o,f(this)}dispose(){T(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=C,C.None=Object.freeze({dispose(){}});class b{constructor(){this._isDisposed=!1,f(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){var n;this._isDisposed||r===this._value||((n=this._value)===null||n===void 0||n.dispose(),r&&T(r),this._value=r)}clear(){this.value=void 0}dispose(){var r;this._isDisposed=!0,T(this),(r=this._value)===null||r===void 0||r.dispose(),this._value=void 0}}e.MutableDisposable=b;class E{constructor(){this.references=new Map}acquire(r,...n){let t=this.references.get(r);t||(t={counter:0,object:this.createReferencedObject(r,...n)},this.references.set(r,t));const{object:i}=t,s=(0,S.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(r,t.object),this.references.delete(r))});return t.counter++,{object:i,dispose:s}}}e.ReferenceCollection=E;class p{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=p}),define(Z[64],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class S{constructor(L){this.element=L,this.next=S.Undefined,this.prev=S.Undefined}}S.Undefined=new S(void 0);class k{constructor(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===S.Undefined}clear(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,U){const T=new S(L);if(this._first===S.Undefined)this._first=T,this._last=T;else if(U){const v=this._last;this._last=T,T.prev=v,v.next=T}else{const v=this._first;this._first=T,T.next=v,v.prev=T}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(T))}}shift(){if(this._first!==S.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==S.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==S.Undefined&&L.next!==S.Undefined){const U=L.prev;U.next=L.next,L.next.prev=U}else L.prev===S.Undefined&&L.next===S.Undefined?(this._first=S.Undefined,this._last=S.Undefined):L.next===S.Undefined?(this._last=this._last.prev,this._last.next=S.Undefined):L.prev===S.Undefined&&(this._first=this._first.next,this._first.prev=S.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==S.Undefined;)yield L.element,L=L.next}}e.LinkedList=k});"use strict";(function(){function K(A){const L=[];typeof A=="number"&&L.push("code/timeOrigin",A);function U(f){L.push(f,Date.now())}function T(){const f=[];for(let v=0;v<L.length;v+=2)f.push({name:L[v],startTime:L[v+1]});return f}return{mark:U,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const U of performance.getEntriesByType("mark"))L.push({name:U.name,startTime:Math.round(A+U.startTime)});return L}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function S(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=S(k))})(),define(Z[7],ee([0,1]),function(K,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const k="en";let A=!1,L=!1,U=!1,T=!1,f=!1,v=!1,R=!1,d,y=k,I,o;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let C;typeof e.globals.vscode!="undefined"?C=e.globals.vscode.process:typeof process!="undefined"&&(C=process);const b=typeof((S=C==null?void 0:C.versions)===null||S===void 0?void 0:S.electron)=="string"&&C.type==="renderer";if(e.isElectronSandboxed=b&&(C==null?void 0:C.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const c=C==null?void 0:C.env.VSCODE_BROWSER_CODE_LOADING;if(typeof c=="string")return c==="none"||c==="code"||c==="bypassHeatCheck"||c==="bypassHeatCheckAndEagerCompile"?c:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!b)o=navigator.userAgent,A=o.indexOf("Windows")>=0,L=o.indexOf("Macintosh")>=0,R=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=o.indexOf("Linux")>=0,v=!0,d=navigator.language,y=d;else if(typeof C=="object"){A=C.platform==="win32",L=C.platform==="darwin",U=C.platform==="linux",T=U&&!!C.env.SNAP&&!!C.env.SNAP_REVISION,d=k,y=k;const c=C.env.VSCODE_NLS_CONFIG;if(c)try{const a=JSON.parse(c),l=a.availableLanguages["*"];d=a.locale,y=l||k,I=a._translationsConfigFile}catch(a){}f=!0}else console.error("Unable to resolve platform.");var E;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function p(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=p;let m=0;L?m=1:A?m=3:U&&(m=2),e.isWindows=A,e.isMacintosh=L,e.isLinux=U,e.isLinuxSnap=T,e.isNative=f,e.isWeb=v,e.isIOS=R,e.platform=m,e.userAgent=o,e.language=y;var r;(function(c){function a(){return e.language}c.value=a;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}c.isDefaultVariant=l;function h(){return e.language==="en"}c.isDefault=h})(r=e.Language||(e.Language={})),e.locale=d,e.translationsConfigFile=I,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",g=>{if(g.data&&g.data.vscodeSetImmediateId)for(let w=0,u=l.length;w<u;w++){const P=l[w];if(P.id===g.data.vscodeSetImmediateId){l.splice(w,1),P.callback();return}}});let h=0;return g=>{const w=++h;l.push({id:w,callback:g}),e.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(typeof(C==null?void 0:C.nextTick)=="function")return C.nextTick.bind(C);const a=Promise.resolve();return l=>a.then(l)}();var n;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||R?2:A?1:3;let t=!0,i=!1;function s(){if(!i){i=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,t=new Uint16Array(c.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(Z[36],ee([0,1,7]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let k;if(typeof S.globals.vscode!="undefined"){const A=S.globals.vscode.process;k={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(L){return(0,S.setImmediate)(L)}}}else typeof process!="undefined"?k={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:k={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},nextTick(A){return(0,S.setImmediate)(A)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=k.cwd,e.env=k.env,e.platform=k.platform,e.nextTick=k.nextTick}),define(Z[8],ee([0,1,36]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const k=65,A=97,L=90,U=122,T=46,f=47,v=92,R=58,d=63;class y extends Error{constructor(r,n,t){let i;typeof n=="string"&&n.indexOf("not ")===0?(i="must not be",n=n.replace(/^not /,"")):i="must be";const s=r.indexOf(".")!==-1?"property":"argument";let c=`The "${r}" ${s} ${i} of type ${n}`;c+=`. Received type ${typeof t}`,super(c),this.code="ERR_INVALID_ARG_TYPE"}}function I(m,r){if(typeof m!="string")throw new y(r,"string",m)}function o(m){return m===f||m===v}function C(m){return m===f}function b(m){return m>=k&&m<=L||m>=A&&m<=U}function E(m,r,n,t){let i="",s=0,c=-1,a=0,l=0;for(let h=0;h<=m.length;++h){if(h<m.length)l=m.charCodeAt(h);else{if(t(l))break;l=f}if(t(l)){if(!(c===h-1||a===1))if(a===2){if(i.length<2||s!==2||i.charCodeAt(i.length-1)!==T||i.charCodeAt(i.length-2)!==T){if(i.length>2){const g=i.lastIndexOf(n);g===-1?(i="",s=0):(i=i.slice(0,g),s=i.length-1-i.lastIndexOf(n)),c=h,a=0;continue}else if(i.length!==0){i="",s=0,c=h,a=0;continue}}r&&(i+=i.length>0?`${n}..`:"..",s=2)}else i.length>0?i+=`${n}${m.slice(c+1,h)}`:i=m.slice(c+1,h),s=h-c-1;c=h,a=0}else l===T&&a!==-1?++a:a=-1}return i}function p(m,r){if(r===null||typeof r!="object")throw new y("pathObject","Object",r);const n=r.dir||r.root,t=r.base||`${r.name||""}${r.ext||""}`;return n?n===r.root?`${n}${t}`:`${n}${m}${t}`:t}e.win32={resolve(...m){let r="",n="",t=!1;for(let i=m.length-1;i>=-1;i--){let s;if(i>=0){if(s=m[i],I(s,"path"),s.length===0)continue}else r.length===0?s=S.cwd():(s=S.env[`=${r}`]||S.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==r.toLowerCase()&&s.charCodeAt(2)===v)&&(s=`${r}\\`));const c=s.length;let a=0,l="",h=!1;const g=s.charCodeAt(0);if(c===1)o(g)&&(a=1,h=!0);else if(o(g))if(h=!0,o(s.charCodeAt(1))){let w=2,u=w;for(;w<c&&!o(s.charCodeAt(w));)w++;if(w<c&&w!==u){const P=s.slice(u,w);for(u=w;w<c&&o(s.charCodeAt(w));)w++;if(w<c&&w!==u){for(u=w;w<c&&!o(s.charCodeAt(w));)w++;(w===c||w!==u)&&(l=`\\\\${P}\\${s.slice(u,w)}`,a=w)}}}else a=1;else b(g)&&s.charCodeAt(1)===R&&(l=s.slice(0,2),a=2,c>2&&o(s.charCodeAt(2))&&(h=!0,a=3));if(l.length>0)if(r.length>0){if(l.toLowerCase()!==r.toLowerCase())continue}else r=l;if(t){if(r.length>0)break}else if(n=`${s.slice(a)}\\${n}`,t=h,h&&r.length>0)break}return n=E(n,!t,"\\",o),t?`${r}\\${n}`:`${r}${n}`||"."},normalize(m){I(m,"path");const r=m.length;if(r===0)return".";let n=0,t,i=!1;const s=m.charCodeAt(0);if(r===1)return C(s)?"\\":m;if(o(s))if(i=!0,o(m.charCodeAt(1))){let a=2,l=a;for(;a<r&&!o(m.charCodeAt(a));)a++;if(a<r&&a!==l){const h=m.slice(l,a);for(l=a;a<r&&o(m.charCodeAt(a));)a++;if(a<r&&a!==l){for(l=a;a<r&&!o(m.charCodeAt(a));)a++;if(a===r)return`\\\\${h}\\${m.slice(l)}\\`;a!==l&&(t=`\\\\${h}\\${m.slice(l,a)}`,n=a)}}}else n=1;else b(s)&&m.charCodeAt(1)===R&&(t=m.slice(0,2),n=2,r>2&&o(m.charCodeAt(2))&&(i=!0,n=3));let c=n<r?E(m.slice(n),!i,"\\",o):"";return c.length===0&&!i&&(c="."),c.length>0&&o(m.charCodeAt(r-1))&&(c+="\\"),t===void 0?i?`\\${c}`:c:i?`${t}\\${c}`:`${t}${c}`},isAbsolute(m){I(m,"path");const r=m.length;if(r===0)return!1;const n=m.charCodeAt(0);return o(n)||r>2&&b(n)&&m.charCodeAt(1)===R&&o(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let r,n;for(let s=0;s<m.length;++s){const c=m[s];I(c,"path"),c.length>0&&(r===void 0?r=n=c:r+=`\\${c}`)}if(r===void 0)return".";let t=!0,i=0;if(typeof n=="string"&&o(n.charCodeAt(0))){++i;const s=n.length;s>1&&o(n.charCodeAt(1))&&(++i,s>2&&(o(n.charCodeAt(2))?++i:t=!1))}if(t){for(;i<r.length&&o(r.charCodeAt(i));)i++;i>=2&&(r=`\\${r.slice(i)}`)}return e.win32.normalize(r)},relative(m,r){if(I(m,"from"),I(r,"to"),m===r)return"";const n=e.win32.resolve(m),t=e.win32.resolve(r);if(n===t||(m=n.toLowerCase(),r=t.toLowerCase(),m===r))return"";let i=0;for(;i<m.length&&m.charCodeAt(i)===v;)i++;let s=m.length;for(;s-1>i&&m.charCodeAt(s-1)===v;)s--;const c=s-i;let a=0;for(;a<r.length&&r.charCodeAt(a)===v;)a++;let l=r.length;for(;l-1>a&&r.charCodeAt(l-1)===v;)l--;const h=l-a,g=c<h?c:h;let w=-1,u=0;for(;u<g;u++){const _=m.charCodeAt(i+u);if(_!==r.charCodeAt(a+u))break;_===v&&(w=u)}if(u!==g){if(w===-1)return t}else{if(h>g){if(r.charCodeAt(a+u)===v)return t.slice(a+u+1);if(u===2)return t.slice(a+u)}c>g&&(m.charCodeAt(i+u)===v?w=u:u===2&&(w=3)),w===-1&&(w=0)}let P="";for(u=i+w+1;u<=s;++u)(u===s||m.charCodeAt(u)===v)&&(P+=P.length===0?"..":"\\..");return a+=w,P.length>0?`${P}${t.slice(a,l)}`:(t.charCodeAt(a)===v&&++a,t.slice(a,l))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const r=e.win32.resolve(m);if(r.length<=2)return m;if(r.charCodeAt(0)===v){if(r.charCodeAt(1)===v){const n=r.charCodeAt(2);if(n!==d&&n!==T)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(b(r.charCodeAt(0))&&r.charCodeAt(1)===R&&r.charCodeAt(2)===v)return`\\\\?\\${r}`;return m},dirname(m){I(m,"path");const r=m.length;if(r===0)return".";let n=-1,t=0;const i=m.charCodeAt(0);if(r===1)return o(i)?m:".";if(o(i)){if(n=t=1,o(m.charCodeAt(1))){let a=2,l=a;for(;a<r&&!o(m.charCodeAt(a));)a++;if(a<r&&a!==l){for(l=a;a<r&&o(m.charCodeAt(a));)a++;if(a<r&&a!==l){for(l=a;a<r&&!o(m.charCodeAt(a));)a++;if(a===r)return m;a!==l&&(n=t=a+1)}}}}else b(i)&&m.charCodeAt(1)===R&&(n=r>2&&o(m.charCodeAt(2))?3:2,t=n);let s=-1,c=!0;for(let a=r-1;a>=t;--a)if(o(m.charCodeAt(a))){if(!c){s=a;break}}else c=!1;if(s===-1){if(n===-1)return".";s=n}return m.slice(0,s)},basename(m,r){r!==void 0&&I(r,"ext"),I(m,"path");let n=0,t=-1,i=!0,s;if(m.length>=2&&b(m.charCodeAt(0))&&m.charCodeAt(1)===R&&(n=2),r!==void 0&&r.length>0&&r.length<=m.length){if(r===m)return"";let c=r.length-1,a=-1;for(s=m.length-1;s>=n;--s){const l=m.charCodeAt(s);if(o(l)){if(!i){n=s+1;break}}else a===-1&&(i=!1,a=s+1),c>=0&&(l===r.charCodeAt(c)?--c==-1&&(t=s):(c=-1,t=a))}return n===t?t=a:t===-1&&(t=m.length),m.slice(n,t)}for(s=m.length-1;s>=n;--s)if(o(m.charCodeAt(s))){if(!i){n=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":m.slice(n,t)},extname(m){I(m,"path");let r=0,n=-1,t=0,i=-1,s=!0,c=0;m.length>=2&&m.charCodeAt(1)===R&&b(m.charCodeAt(0))&&(r=t=2);for(let a=m.length-1;a>=r;--a){const l=m.charCodeAt(a);if(o(l)){if(!s){t=a+1;break}continue}i===-1&&(s=!1,i=a+1),l===T?n===-1?n=a:c!==1&&(c=1):n!==-1&&(c=-1)}return n===-1||i===-1||c===0||c===1&&n===i-1&&n===t+1?"":m.slice(n,i)},format:p.bind(null,"\\"),parse(m){I(m,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return r;const n=m.length;let t=0,i=m.charCodeAt(0);if(n===1)return o(i)?(r.root=r.dir=m,r):(r.base=r.name=m,r);if(o(i)){if(t=1,o(m.charCodeAt(1))){let w=2,u=w;for(;w<n&&!o(m.charCodeAt(w));)w++;if(w<n&&w!==u){for(u=w;w<n&&o(m.charCodeAt(w));)w++;if(w<n&&w!==u){for(u=w;w<n&&!o(m.charCodeAt(w));)w++;w===n?t=w:w!==u&&(t=w+1)}}}}else if(b(i)&&m.charCodeAt(1)===R){if(n<=2)return r.root=r.dir=m,r;if(t=2,o(m.charCodeAt(2))){if(n===3)return r.root=r.dir=m,r;t=3}}t>0&&(r.root=m.slice(0,t));let s=-1,c=t,a=-1,l=!0,h=m.length-1,g=0;for(;h>=t;--h){if(i=m.charCodeAt(h),o(i)){if(!l){c=h+1;break}continue}a===-1&&(l=!1,a=h+1),i===T?s===-1?s=h:g!==1&&(g=1):s!==-1&&(g=-1)}return a!==-1&&(s===-1||g===0||g===1&&s===a-1&&s===c+1?r.base=r.name=m.slice(c,a):(r.name=m.slice(c,s),r.base=m.slice(c,a),r.ext=m.slice(s,a))),c>0&&c!==t?r.dir=m.slice(0,c-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let r="",n=!1;for(let t=m.length-1;t>=-1&&!n;t--){const i=t>=0?m[t]:S.cwd();I(i,"path"),i.length!==0&&(r=`${i}/${r}`,n=i.charCodeAt(0)===f)}return r=E(r,!n,"/",C),n?`/${r}`:r.length>0?r:"."},normalize(m){if(I(m,"path"),m.length===0)return".";const r=m.charCodeAt(0)===f,n=m.charCodeAt(m.length-1)===f;return m=E(m,!r,"/",C),m.length===0?r?"/":n?"./":".":(n&&(m+="/"),r?`/${m}`:m)},isAbsolute(m){return I(m,"path"),m.length>0&&m.charCodeAt(0)===f},join(...m){if(m.length===0)return".";let r;for(let n=0;n<m.length;++n){const t=m[n];I(t,"path"),t.length>0&&(r===void 0?r=t:r+=`/${t}`)}return r===void 0?".":e.posix.normalize(r)},relative(m,r){if(I(m,"from"),I(r,"to"),m===r||(m=e.posix.resolve(m),r=e.posix.resolve(r),m===r))return"";const n=1,t=m.length,i=t-n,s=1,c=r.length-s,a=i<c?i:c;let l=-1,h=0;for(;h<a;h++){const w=m.charCodeAt(n+h);if(w!==r.charCodeAt(s+h))break;w===f&&(l=h)}if(h===a)if(c>a){if(r.charCodeAt(s+h)===f)return r.slice(s+h+1);if(h===0)return r.slice(s+h)}else i>a&&(m.charCodeAt(n+h)===f?l=h:h===0&&(l=0));let g="";for(h=n+l+1;h<=t;++h)(h===t||m.charCodeAt(h)===f)&&(g+=g.length===0?"..":"/..");return`${g}${r.slice(s+l)}`},toNamespacedPath(m){return m},dirname(m){if(I(m,"path"),m.length===0)return".";const r=m.charCodeAt(0)===f;let n=-1,t=!0;for(let i=m.length-1;i>=1;--i)if(m.charCodeAt(i)===f){if(!t){n=i;break}}else t=!1;return n===-1?r?"/":".":r&&n===1?"//":m.slice(0,n)},basename(m,r){r!==void 0&&I(r,"ext"),I(m,"path");let n=0,t=-1,i=!0,s;if(r!==void 0&&r.length>0&&r.length<=m.length){if(r===m)return"";let c=r.length-1,a=-1;for(s=m.length-1;s>=0;--s){const l=m.charCodeAt(s);if(l===f){if(!i){n=s+1;break}}else a===-1&&(i=!1,a=s+1),c>=0&&(l===r.charCodeAt(c)?--c==-1&&(t=s):(c=-1,t=a))}return n===t?t=a:t===-1&&(t=m.length),m.slice(n,t)}for(s=m.length-1;s>=0;--s)if(m.charCodeAt(s)===f){if(!i){n=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":m.slice(n,t)},extname(m){I(m,"path");let r=-1,n=0,t=-1,i=!0,s=0;for(let c=m.length-1;c>=0;--c){const a=m.charCodeAt(c);if(a===f){if(!i){n=c+1;break}continue}t===-1&&(i=!1,t=c+1),a===T?r===-1?r=c:s!==1&&(s=1):r!==-1&&(s=-1)}return r===-1||t===-1||s===0||s===1&&r===t-1&&r===n+1?"":m.slice(r,t)},format:p.bind(null,"/"),parse(m){I(m,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return r;const n=m.charCodeAt(0)===f;let t;n?(r.root="/",t=1):t=0;let i=-1,s=0,c=-1,a=!0,l=m.length-1,h=0;for(;l>=t;--l){const g=m.charCodeAt(l);if(g===f){if(!a){s=l+1;break}continue}c===-1&&(a=!1,c=l+1),g===T?i===-1?i=l:h!==1&&(h=1):i!==-1&&(h=-1)}if(c!==-1){const g=s===0&&n?1:s;i===-1||h===0||h===1&&i===c-1&&i===s+1?r.base=r.name=m.slice(g,c):(r.name=m.slice(g,i),r.base=m.slice(g,c),r.ext=m.slice(i,c))}return s>0?r.dir=m.slice(0,s-1):n&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=S.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=S.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=S.platform==="win32"?e.win32.join:e.posix.join,e.resolve=S.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=S.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=S.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=S.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=S.platform==="win32"?e.win32.extname:e.posix.extname,e.format=S.platform==="win32"?e.win32.format:e.posix.format,e.parse=S.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=S.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=S.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=S.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var k in S)(typeof exports=="object"?exports:K)[k]=S[k]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function S(k){if(e[k])return e[k].exports;var A=e[k]={i:k,l:!1,exports:{}};return K[k].call(A.exports,A,A.exports,S),A.l=!0,A.exports}return S.m=K,S.c=e,S.d=function(k,A,L){S.o(k,A)||Object.defineProperty(k,A,{enumerable:!0,get:L})},S.r=function(k){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},S.t=function(k,A){if(1&A&&(k=S(k)),8&A||4&A&&typeof k=="object"&&k&&k.__esModule)return k;var L=Object.create(null);if(S.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:k}),2&A&&typeof k!="string")for(var U in k)S.d(L,U,function(T){return k[T]}.bind(null,U));return L},S.n=function(k){var A=k&&k.__esModule?function(){return k.default}:function(){return k};return S.d(A,"a",A),A},S.o=function(k,A){return Object.prototype.hasOwnProperty.call(k,A)},S.p="",S(S.s=0)}([function(K,e,S){(function(k){var A;e=K.exports=Q,A=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,U=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],f=e.src=[],v=0,R=v++;f[R]="0|[1-9]\\d*";var d=v++;f[d]="[0-9]+";var y=v++;f[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=v++;f[I]="("+f[R]+")\\.("+f[R]+")\\.("+f[R]+")";var o=v++;f[o]="("+f[d]+")\\.("+f[d]+")\\.("+f[d]+")";var C=v++;f[C]="(?:"+f[R]+"|"+f[y]+")";var b=v++;f[b]="(?:"+f[d]+"|"+f[y]+")";var E=v++;f[E]="(?:-("+f[C]+"(?:\\."+f[C]+")*))";var p=v++;f[p]="(?:-?("+f[b]+"(?:\\."+f[b]+")*))";var m=v++;f[m]="[0-9A-Za-z-]+";var r=v++;f[r]="(?:\\+("+f[m]+"(?:\\."+f[m]+")*))";var n=v++,t="v?"+f[I]+f[E]+"?"+f[r]+"?";f[n]="^"+t+"$";var i="[v=\\s]*"+f[o]+f[p]+"?"+f[r]+"?",s=v++;f[s]="^"+i+"$";var c=v++;f[c]="((?:<|>)?=?)";var a=v++;f[a]=f[d]+"|x|X|\\*";var l=v++;f[l]=f[R]+"|x|X|\\*";var h=v++;f[h]="[v=\\s]*("+f[l]+")(?:\\.("+f[l]+")(?:\\.("+f[l]+")(?:"+f[E]+")?"+f[r]+"?)?)?";var g=v++;f[g]="[v=\\s]*("+f[a]+")(?:\\.("+f[a]+")(?:\\.("+f[a]+")(?:"+f[p]+")?"+f[r]+"?)?)?";var w=v++;f[w]="^"+f[c]+"\\s*"+f[h]+"$";var u=v++;f[u]="^"+f[c]+"\\s*"+f[g]+"$";var P=v++;f[P]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=v++;f[_]="(?:~>?)";var z=v++;f[z]="(\\s*)"+f[_]+"\\s+",T[z]=new RegExp(f[z],"g");var B=v++;f[B]="^"+f[_]+f[h]+"$";var M=v++;f[M]="^"+f[_]+f[g]+"$";var j=v++;f[j]="(?:\\^)";var W=v++;f[W]="(\\s*)"+f[j]+"\\s+",T[W]=new RegExp(f[W],"g");var $=v++;f[$]="^"+f[j]+f[h]+"$";var H=v++;f[H]="^"+f[j]+f[g]+"$";var q=v++;f[q]="^"+f[c]+"\\s*("+i+")$|^$";var D=v++;f[D]="^"+f[c]+"\\s*("+t+")$|^$";var O=v++;f[O]="(\\s*)"+f[c]+"\\s*("+i+"|"+f[h]+")",T[O]=new RegExp(f[O],"g");var F=v++;f[F]="^\\s*("+f[h]+")\\s+-\\s+("+f[h]+")\\s*$";var N=v++;f[N]="^\\s*("+f[g]+")\\s+-\\s+("+f[g]+")\\s*$";var V=v++;f[V]="(<|>)?=?\\s*\\*";for(var G=0;G<35;G++)A(G,f[G]),T[G]||(T[G]=new RegExp(f[G]));function J(X,se){if(X instanceof Q)return X;if(typeof X!="string"||X.length>L||!(se?T[s]:T[n]).test(X))return null;try{return new Q(X,se)}catch(re){return null}}function Q(X,se){if(X instanceof Q){if(X.loose===se)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof Q))return new Q(X,se);A("SemVer",X,se),this.loose=se;var re=X.trim().match(se?T[s]:T[n]);if(!re)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+re[1],this.minor=+re[2],this.patch=+re[3],this.major>U||this.major<0)throw new TypeError("Invalid major version");if(this.minor>U||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>U||this.patch<0)throw new TypeError("Invalid patch version");re[4]?this.prerelease=re[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var x=+me;if(x>=0&&x<U)return x}return me}):this.prerelease=[],this.build=re[5]?re[5].split("."):[],this.format()}e.parse=J,e.valid=function(X,se){var re=J(X,se);return re?re.version:null},e.clean=function(X,se){var re=J(X.trim().replace(/^[=v]+/,""),se);return re?re.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(X){return A("SemVer.compare",this.version,this.loose,X),X instanceof Q||(X=new Q(X,this.loose)),this.compareMain(X)||this.comparePre(X)},Q.prototype.compareMain=function(X){return X instanceof Q||(X=new Q(X,this.loose)),ie(this.major,X.major)||ie(this.minor,X.minor)||ie(this.patch,X.patch)},Q.prototype.comparePre=function(X){if(X instanceof Q||(X=new Q(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var se=0;do{var re=this.prerelease[se],me=X.prerelease[se];if(A("prerelease compare",se,re,me),re===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(re===void 0)return-1;if(re!==me)return ie(re,me)}while(++se)},Q.prototype.inc=function(X,se){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",se);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",se);break;case"prepatch":this.prerelease.length=0,this.inc("patch",se),this.inc("pre",se);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",se),this.inc("pre",se);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var re=this.prerelease.length;--re>=0;)typeof this.prerelease[re]=="number"&&(this.prerelease[re]++,re=-2);re===-1&&this.prerelease.push(0)}se&&(this.prerelease[0]===se?isNaN(this.prerelease[1])&&(this.prerelease=[se,0]):this.prerelease=[se,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,se,re,me){typeof re=="string"&&(me=re,re=void 0);try{return new Q(X,re).inc(se,me).version}catch(x){return null}},e.diff=function(X,se){if(Ee(X,se))return null;var re=J(X),me=J(se);if(re.prerelease.length||me.prerelease.length){for(var x in re)if((x==="major"||x==="minor"||x==="patch")&&re[x]!==me[x])return"pre"+x;return"prerelease"}for(var x in re)if((x==="major"||x==="minor"||x==="patch")&&re[x]!==me[x])return x},e.compareIdentifiers=ie;var ne=/^[0-9]+$/;function ie(X,se){var re=ne.test(X),me=ne.test(se);return re&&me&&(X=+X,se=+se),re&&!me?-1:me&&!re?1:X<se?-1:X>se?1:0}function ce(X,se,re){return new Q(X,re).compare(new Q(se,re))}function ue(X,se,re){return ce(X,se,re)>0}function ge(X,se,re){return ce(X,se,re)<0}function Ee(X,se,re){return ce(X,se,re)===0}function Ie(X,se,re){return ce(X,se,re)!==0}function Te(X,se,re){return ce(X,se,re)>=0}function Ae(X,se,re){return ce(X,se,re)<=0}function Ue(X,se,re,me){var x;switch(se){case"===":typeof X=="object"&&(X=X.version),typeof re=="object"&&(re=re.version),x=X===re;break;case"!==":typeof X=="object"&&(X=X.version),typeof re=="object"&&(re=re.version),x=X!==re;break;case"":case"=":case"==":x=Ee(X,re,me);break;case"!=":x=Ie(X,re,me);break;case">":x=ue(X,re,me);break;case">=":x=Te(X,re,me);break;case"<":x=ge(X,re,me);break;case"<=":x=Ae(X,re,me);break;default:throw new TypeError("Invalid operator: "+se)}return x}function ke(X,se){if(X instanceof ke){if(X.loose===se)return X;X=X.value}if(!(this instanceof ke))return new ke(X,se);A("comparator",X,se),this.loose=se,this.parse(X),this.semver===Me?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(X,se){return ie(se,X)},e.major=function(X,se){return new Q(X,se).major},e.minor=function(X,se){return new Q(X,se).minor},e.patch=function(X,se){return new Q(X,se).patch},e.compare=ce,e.compareLoose=function(X,se){return ce(X,se,!0)},e.rcompare=function(X,se,re){return ce(se,X,re)},e.sort=function(X,se){return X.sort(function(re,me){return e.compare(re,me,se)})},e.rsort=function(X,se){return X.sort(function(re,me){return e.rcompare(re,me,se)})},e.gt=ue,e.lt=ge,e.eq=Ee,e.neq=Ie,e.gte=Te,e.lte=Ae,e.cmp=Ue,e.Comparator=ke;var Me={};function De(X,se){if(X instanceof De)return X.loose===se?X:new De(X.raw,se);if(X instanceof ke)return new De(X.value,se);if(!(this instanceof De))return new De(X,se);if(this.loose=se,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(re){return this.parseRange(re.trim())},this).filter(function(re){return re.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Oe(X){return!X||X.toLowerCase()==="x"||X==="*"}function He(X,se,re,me,x,te,oe,ae,le,fe,ve,Se,we){return((se=Oe(re)?"":Oe(me)?">="+re+".0.0":Oe(x)?">="+re+"."+me+".0":">="+se)+" "+(ae=Oe(le)?"":Oe(fe)?"<"+(+le+1)+".0.0":Oe(ve)?"<"+le+"."+(+fe+1)+".0":Se?"<="+le+"."+fe+"."+ve+"-"+Se:"<="+ae)).trim()}function Ge(X,se){for(var re=0;re<X.length;re++)if(!X[re].test(se))return!1;if(se.prerelease.length){for(re=0;re<X.length;re++)if(A(X[re].semver),X[re].semver!==Me&&X[re].semver.prerelease.length>0){var me=X[re].semver;if(me.major===se.major&&me.minor===se.minor&&me.patch===se.patch)return!0}return!1}return!0}function je(X,se,re){try{se=new De(se,re)}catch(me){return!1}return se.test(X)}function $e(X,se,re,me){var x,te,oe,ae,le;switch(X=new Q(X,me),se=new De(se,me),re){case">":x=ue,te=Ae,oe=ge,ae=">",le=">=";break;case"<":x=ge,te=Te,oe=ue,ae="<",le="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(X,se,me))return!1;for(var fe=0;fe<se.set.length;++fe){var ve=se.set[fe],Se=null,we=null;if(ve.forEach(function(be){be.semver===Me&&(be=new ke(">=0.0.0")),Se=Se||be,we=we||be,x(be.semver,Se.semver,me)?Se=be:oe(be.semver,we.semver,me)&&(we=be)}),Se.operator===ae||Se.operator===le||(!we.operator||we.operator===ae)&&te(X,we.semver)||we.operator===le&&oe(X,we.semver))return!1}return!0}ke.prototype.parse=function(X){var se=this.loose?T[q]:T[D],re=X.match(se);if(!re)throw new TypeError("Invalid comparator: "+X);this.operator=re[1],this.operator==="="&&(this.operator=""),re[2]?this.semver=new Q(re[2],this.loose):this.semver=Me},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(X){return A("Comparator.test",X,this.loose),this.semver===Me||(typeof X=="string"&&(X=new Q(X,this.loose)),Ue(X,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(X,se){if(!(X instanceof ke))throw new TypeError("a Comparator is required");var re;if(this.operator==="")return re=new De(X.value,se),je(this.value,re,se);if(X.operator==="")return re=new De(this.value,se),je(X.semver,re,se);var me=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),x=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),te=this.semver.version===X.semver.version,oe=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),ae=Ue(this.semver,"<",X.semver,se)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),le=Ue(this.semver,">",X.semver,se)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return me||x||te&&oe||ae||le},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(X){var se=this.loose;X=X.trim(),A("range",X,se);var re=se?T[N]:T[F];X=X.replace(re,He),A("hyphen replace",X),X=X.replace(T[O],"$1$2$3"),A("comparator trim",X,T[O]),X=(X=(X=X.replace(T[z],"$1~")).replace(T[W],"$1^")).split(/\s+/).join(" ");var me=se?T[q]:T[D],x=X.split(" ").map(function(te){return function(oe,ae){return A("comp",oe),oe=function(le,fe){return le.trim().split(/\s+/).map(function(ve){return function(Se,we){A("caret",Se,we);var be=we?T[H]:T[$];return Se.replace(be,function(Pe,ye,pe,Ce,Re){var de;return A("caret",Se,Pe,ye,pe,Ce,Re),Oe(ye)?de="":Oe(pe)?de=">="+ye+".0.0 <"+(+ye+1)+".0.0":Oe(Ce)?de=ye==="0"?">="+ye+"."+pe+".0 <"+ye+"."+(+pe+1)+".0":">="+ye+"."+pe+".0 <"+(+ye+1)+".0.0":Re?(A("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),de=ye==="0"?pe==="0"?">="+ye+"."+pe+"."+Ce+Re+" <"+ye+"."+pe+"."+(+Ce+1):">="+ye+"."+pe+"."+Ce+Re+" <"+ye+"."+(+pe+1)+".0":">="+ye+"."+pe+"."+Ce+Re+" <"+(+ye+1)+".0.0"):(A("no pr"),de=ye==="0"?pe==="0"?">="+ye+"."+pe+"."+Ce+" <"+ye+"."+pe+"."+(+Ce+1):">="+ye+"."+pe+"."+Ce+" <"+ye+"."+(+pe+1)+".0":">="+ye+"."+pe+"."+Ce+" <"+(+ye+1)+".0.0"),A("caret return",de),de})}(ve,fe)}).join(" ")}(oe,ae),A("caret",oe),oe=function(le,fe){return le.trim().split(/\s+/).map(function(ve){return function(Se,we){var be=we?T[M]:T[B];return Se.replace(be,function(Pe,ye,pe,Ce,Re){var de;return A("tilde",Se,Pe,ye,pe,Ce,Re),Oe(ye)?de="":Oe(pe)?de=">="+ye+".0.0 <"+(+ye+1)+".0.0":Oe(Ce)?de=">="+ye+"."+pe+".0 <"+ye+"."+(+pe+1)+".0":Re?(A("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),de=">="+ye+"."+pe+"."+Ce+Re+" <"+ye+"."+(+pe+1)+".0"):de=">="+ye+"."+pe+"."+Ce+" <"+ye+"."+(+pe+1)+".0",A("tilde return",de),de})}(ve,fe)}).join(" ")}(oe,ae),A("tildes",oe),oe=function(le,fe){return A("replaceXRanges",le,fe),le.split(/\s+/).map(function(ve){return function(Se,we){Se=Se.trim();var be=we?T[u]:T[w];return Se.replace(be,function(Pe,ye,pe,Ce,Re,de){A("xRange",Se,Pe,ye,pe,Ce,Re,de);var Le=Oe(pe),_e=Le||Oe(Ce),Fe=_e||Oe(Re);return ye==="="&&Fe&&(ye=""),Le?Pe=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Fe?(_e&&(Ce=0),Fe&&(Re=0),ye===">"?(ye=">=",_e?(pe=+pe+1,Ce=0,Re=0):Fe&&(Ce=+Ce+1,Re=0)):ye==="<="&&(ye="<",_e?pe=+pe+1:Ce=+Ce+1),Pe=ye+pe+"."+Ce+"."+Re):_e?Pe=">="+pe+".0.0 <"+(+pe+1)+".0.0":Fe&&(Pe=">="+pe+"."+Ce+".0 <"+pe+"."+(+Ce+1)+".0"),A("xRange return",Pe),Pe})}(ve,fe)}).join(" ")}(oe,ae),A("xrange",oe),oe=function(le,fe){return A("replaceStars",le,fe),le.trim().replace(T[V],"")}(oe,ae),A("stars",oe),oe}(te,se)}).join(" ").split(/\s+/);return this.loose&&(x=x.filter(function(te){return!!te.match(me)})),x=x.map(function(te){return new ke(te,se)})},De.prototype.intersects=function(X,se){if(!(X instanceof De))throw new TypeError("a Range is required");return this.set.some(function(re){return re.every(function(me){return X.set.some(function(x){return x.every(function(te){return me.intersects(te,se)})})})})},e.toComparators=function(X,se){return new De(X,se).set.map(function(re){return re.map(function(me){return me.value}).join(" ").trim().split(" ")})},De.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new Q(X,this.loose));for(var se=0;se<this.set.length;se++)if(Ge(this.set[se],X))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(X,se,re){var me=null,x=null;try{var te=new De(se,re)}catch(oe){return null}return X.forEach(function(oe){te.test(oe)&&(me&&x.compare(oe)!==-1||(x=new Q(me=oe,re)))}),me},e.minSatisfying=function(X,se,re){var me=null,x=null;try{var te=new De(se,re)}catch(oe){return null}return X.forEach(function(oe){te.test(oe)&&(me&&x.compare(oe)!==1||(x=new Q(me=oe,re)))}),me},e.validRange=function(X,se){try{return new De(X,se).range||"*"}catch(re){return null}},e.ltr=function(X,se,re){return $e(X,se,"<",re)},e.gtr=function(X,se,re){return $e(X,se,">",re)},e.outside=$e,e.prerelease=function(X,se){var re=J(X,se);return re&&re.prerelease.length?re.prerelease:null},e.intersects=function(X,se,re){return X=new De(X,re),se=new De(se,re),X.intersects(se)},e.coerce=function(X){if(X instanceof Q)return X;if(typeof X!="string")return null;var se=X.match(T[P]);return se==null?null:J((se[1]||"0")+"."+(se[2]||"0")+"."+(se[3]||"0"))}}).call(this,S(1))},function(K,e){var S,k,A=K.exports={};function L(){throw new Error("setTimeout has not been defined")}function U(){throw new Error("clearTimeout has not been defined")}function T(b){if(S===setTimeout)return setTimeout(b,0);if((S===L||!S)&&setTimeout)return S=setTimeout,setTimeout(b,0);try{return S(b,0)}catch(E){try{return S.call(null,b,0)}catch(p){return S.call(this,b,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:L}catch(b){S=L}try{k=typeof clearTimeout=="function"?clearTimeout:U}catch(b){k=U}})();var f,v=[],R=!1,d=-1;function y(){R&&f&&(R=!1,f.length?v=f.concat(v):d=-1,v.length&&I())}function I(){if(!R){var b=T(y);R=!0;for(var E=v.length;E;){for(f=v,v=[];++d<E;)f&&f[d].run();d=-1,E=v.length}f=null,R=!1,function(p){if(k===clearTimeout)return clearTimeout(p);if((k===U||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(p);try{k(p)}catch(m){try{return k.call(null,p)}catch(r){return k.call(this,p)}}}(b)}}function o(b,E){this.fun=b,this.array=E}function C(){}A.nextTick=function(b){var E=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)E[p-1]=arguments[p];v.push(new o(b,E)),v.length!==1||R||T(I)},o.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=C,A.addListener=C,A.once=C,A.off=C,A.removeListener=C,A.removeAllListeners=C,A.emit=C,A.prependListener=C,A.prependOnceListener=C,A.listeners=function(b){return[]},A.binding=function(b){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(b){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(Z[86],ee([0,1,7]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=S.globals.performance&&typeof S.globals.performance.now=="function";class A{constructor(U){this._highResolution=k&&U,this._startTime=this._now(),this._stopTime=-1}static create(U=!0){return new A(U)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?S.globals.performance.now():Date.now()}}e.StopWatch=A}),define(Z[3],ee([0,1,11,63,2,64,86]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var T;(function(E){E.None=()=>A.Disposable.None;function p(M){return(j,W=null,$)=>{let H=!1,q;return q=M(D=>{if(!H)return q?q.dispose():H=!0,j.call(W,D)},null,$),H&&q.dispose(),q}}E.once=p;function m(M,j){return c((W,$=null,H)=>M(q=>W.call($,j(q)),null,H))}E.map=m;function r(M,j){return c((W,$=null,H)=>M(q=>{j(q),W.call($,q)},null,H))}E.forEach=r;function n(M,j){return c((W,$=null,H)=>M(q=>j(q)&&W.call($,q),null,H))}E.filter=n;function t(M){return M}E.signal=t;function i(...M){return(j,W=null,$)=>(0,A.combinedDisposable)(...M.map(H=>H(q=>j.call(W,q),null,$)))}E.any=i;function s(M,j,W){let $=W;return m(M,H=>($=j($,H),$))}E.reduce=s;function c(M){let j;const W=new y({onFirstListenerAdd(){j=M(W.fire,W)},onLastListenerRemove(){j.dispose()}});return W.event}E.snapshot=c;function a(M,j,W=100,$=!1,H){let q,D,O,F=0;const N=new y({leakWarningThreshold:H,onFirstListenerAdd(){q=M(V=>{F++,D=j(D,V),$&&!O&&(N.fire(D),D=void 0),clearTimeout(O),O=setTimeout(()=>{const G=D;D=void 0,O=void 0,(!$||F>1)&&N.fire(G),F=0},W)})},onLastListenerRemove(){q.dispose()}});return N.event}E.debounce=a;function l(M){const j=new Date().getTime();return m(p(M),W=>new Date().getTime()-j)}E.stopwatch=l;function h(M){let j=!0,W;return n(M,$=>{const H=j||$!==W;return j=!1,W=$,H})}E.latch=h;function g(M,j=!1,W=[]){let $=W.slice(),H=M(O=>{$?$.push(O):D.fire(O)});const q=()=>{$&&$.forEach(O=>D.fire(O)),$=null},D=new y({onFirstListenerAdd(){H||(H=M(O=>D.fire(O)))},onFirstListenerDidAdd(){$&&(j?setTimeout(q):q())},onLastListenerRemove(){H&&H.dispose(),H=null}});return D.event}E.buffer=g;class w{constructor(j){this.event=j}map(j){return new w(m(this.event,j))}forEach(j){return new w(r(this.event,j))}filter(j){return new w(n(this.event,j))}reduce(j,W){return new w(s(this.event,j,W))}latch(){return new w(h(this.event))}debounce(j,W=100,$=!1,H){return new w(a(this.event,j,W,$,H))}on(j,W,$){return this.event(j,W,$)}once(j,W,$){return p(this.event)(j,W,$)}}function u(M){return new w(M)}E.chain=u;function P(M,j,W=$=>$){const $=(...O)=>D.fire(W(...O)),H=()=>M.on(j,$),q=()=>M.removeListener(j,$),D=new y({onFirstListenerAdd:H,onLastListenerRemove:q});return D.event}E.fromNodeEventEmitter=P;function _(M,j,W=$=>$){const $=(...O)=>D.fire(W(...O)),H=()=>M.addEventListener(j,$),q=()=>M.removeEventListener(j,$),D=new y({onFirstListenerAdd:H,onLastListenerRemove:q});return D.event}E.fromDOMEventEmitter=_;function z(M){const j=new y;let W=!1;return M.then(void 0,()=>null).then(()=>{W?j.fire(void 0):setTimeout(()=>j.fire(void 0),0)}),W=!0,j.event}E.fromPromise=z;function B(M){return new Promise(j=>p(M)(j))}E.toPromise=B})(T=e.Event||(e.Event={}));class f{constructor(p){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${p}_${f._idPool++}`}start(p){this._stopWatch=new U.StopWatch(!0),this._listenerCount=p}stop(){if(this._stopWatch){const p=this._stopWatch.elapsed();this._elapsedOverall+=p,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${p.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let v=-1;function R(E){const p=v;return v=E,{dispose(){v=p}}}e.setGlobalLeakWarningThreshold=R;class d{constructor(p,m=Math.random().toString(18).slice(2,5)){this.customThreshold=p,this.name=m,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(p){let m=v;if(typeof this.customThreshold=="number"&&(m=this.customThreshold),!(m<=0||p<m)){this._stacks||(this._stacks=new Map);const r=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(r)||0;if(this._stacks.set(r,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=m*.5;let t,i=0;for(const[s,c]of this._stacks)(!t||i<c)&&(t=s,i=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(r)||0;this._stacks.set(r,t-1)}}}}class y{constructor(p){var m;this._disposed=!1,this._options=p,this._leakageMon=v>0?new d(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((m=this._options)===null||m===void 0?void 0:m._profName)?new f(this._options._profName):void 0}get event(){return this._event||(this._event=(p,m,r)=>{var n;this._listeners||(this._listeners=new L.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(m?[p,m]:p);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,p,m);const s=(n=this._leakageMon)===null||n===void 0?void 0:n.check(this._listeners.size);let c;return c={dispose:()=>{s&&s(),c.dispose=y._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},r instanceof A.DisposableStore?r.add(c):Array.isArray(r)&&r.push(c),c}),this._event}fire(p){var m,r;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new L.LinkedList);for(let n of this._listeners)this._deliveryQueue.push([n,p]);for((m=this._perfMon)===null||m===void 0||m.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[n,t]=this._deliveryQueue.shift();try{typeof n=="function"?n.call(void 0,t):n[0].call(n[1],t)}catch(i){(0,S.onUnexpectedError)(i)}}(r=this._perfMon)===null||r===void 0||r.stop()}}dispose(){var p,m,r;(p=this._listeners)===null||p===void 0||p.clear(),(m=this._deliveryQueue)===null||m===void 0||m.clear(),(r=this._leakageMon)===null||r===void 0||r.dispose(),this._disposed=!0}}e.Emitter=y,y._noop=function(){};class I extends y{constructor(p){super(p);this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=p==null?void 0:p.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const p=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(p))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(p){this._listeners&&(this._isPaused!==0?this._eventQueue.push(p):super.fire(p))}}e.PauseableEmitter=I;class o{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(p){const m={event:p,listener:null};this.events.push(m),this.hasListeners&&this.hook(m);const r=()=>{this.hasListeners&&this.unhook(m);const n=this.events.indexOf(m);this.events.splice(n,1)};return(0,A.toDisposable)((0,k.once)(r))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(p=>this.hook(p))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(p=>this.unhook(p))}hook(p){p.listener=p.event(m=>this.emitter.fire(m))}unhook(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=o;class C{constructor(){this.buffers=[]}wrapEvent(p){return(m,r,n)=>p(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>m.call(r,t)):m.call(r,t)},void 0,n)}bufferEvents(p){const m=[];this.buffers.push(m);const r=p();return this.buffers.pop(),m.forEach(n=>n()),r}}e.EventBufferer=C;class b{constructor(){this.listening=!1,this.inputEvent=T.None,this.inputEventListener=A.Disposable.None,this.emitter=new y({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(p){this.inputEvent=p,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=p(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=b}),define(Z[30],ee([0,1,3]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const k=Object.freeze(function(T,f){const v=setTimeout(T.bind(f),0);return{dispose(){clearTimeout(v)}}});var A;(function(T){function f(v){return v===T.None||v===T.Cancelled||v instanceof L?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}T.isCancellationToken=f,T.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),T.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(A=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new S.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class U{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=A.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=U}),define(Z[47],ee([0,1,11,2]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(E){const p=E;return p&&[p.on,p.pause,p.resume,p.destroy].every(m=>typeof m=="function")}e.isReadableStream=A;function L(E){const p=E;return p&&A(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean"}e.isReadableBufferedStream=L;function U(E,p){return new T(E,p)}e.newWriteableStream=U;class T{constructor(p,m){this.reducer=p,this.options=m,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){var m;if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof((m=this.options)===null||m===void 0?void 0:m.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(m=>m(p))}emitError(p){this.listeners.error.length===0?(0,S.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(m=>m(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,m){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(m),this.resume();break;case"end":this.listeners.end.push(m),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(m),this.state.flowing&&this.flowErrors();break}}removeListener(p,m){if(!this.state.destroyed){let r;switch(p){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const n=r.indexOf(m);n>=0&&r.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const m=[...this.pendingWritePromises];this.pendingWritePromises.length=0,m.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(E,p){const m=[];let r;for(;(r=E.read())!==null;)m.push(r);return p(m)}e.consumeReadable=f;function v(E,p,m){const r=[];let n;for(;(n=E.read())!==null&&r.length<m;)r.push(n);return n===null&&r.length>0?p(r):{read:()=>{if(r.length>0)return r.shift();if(typeof n!="undefined"){const t=n;return n=void 0,t}return E.read()}}}e.peekReadable=v;function R(E,p){return new Promise((m,r)=>{const n=[];d(E,{onData:t=>{p&&n.push(t)},onError:t=>{p?r(t):m(void 0)},onEnd:()=>{m(p?p(n):void 0)}})})}e.consumeStream=R;function d(E,p){E.on("error",m=>p.onError(m)),E.on("end",()=>p.onEnd()),E.on("data",m=>p.onData(m))}e.listenStream=d;function y(E,p){return new Promise((m,r)=>{const n=new k.DisposableStore,t=[],i=a=>{if(t.push(a),t.length>p)return n.dispose(),E.pause(),m({stream:E,buffer:t,ended:!1})},s=a=>r(a),c=()=>m({stream:E,buffer:t,ended:!0});n.add((0,k.toDisposable)(()=>E.removeListener("error",s))),E.on("error",s),n.add((0,k.toDisposable)(()=>E.removeListener("end",c))),E.on("end",c),n.add((0,k.toDisposable)(()=>E.removeListener("data",i))),E.on("data",i)})}e.peekStream=y;function I(E,p){const m=U(p);return m.end(E),m}e.toStream=I;function o(){const E=U(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=o;function C(E){let p=!1;return{read:()=>p?null:(p=!0,E)}}e.toReadable=C;function b(E,p,m){const r=U(m);return d(E,{onData:n=>r.write(p.data(n)),onError:n=>r.error(p.error?p.error(n):n),onEnd:()=>r.end()}),r}e.transform=b}),define(Z[21],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function S(x){return!x||typeof x!="string"?!0:x.trim().length===0}e.isFalsyOrWhitespace=S;const k=/{(\d+)}/g;function A(x,...te){return te.length===0?x:x.replace(k,function(oe,ae){const le=parseInt(ae,10);return isNaN(le)||le<0||le>=te.length?oe:te[le]})}e.format=A;function L(x){return x.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=L;function U(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=U;function T(x,te){let oe=0;const ae=te.charCodeAt(0);for(let le=x.length-1;le>=0;le--)x.charCodeAt(le)===ae&&oe++;return oe}e.count=T;function f(x,te,oe="\u2026"){return x.length<=te?x:`${x.substr(0,te)}${oe}`}e.truncate=f;function v(x,te=" "){const oe=R(x,te);return d(oe,te)}e.trim=v;function R(x,te){if(!x||!te)return x;const oe=te.length;if(oe===0||x.length===0)return x;let ae=0;for(;x.indexOf(te,ae)===ae;)ae=ae+oe;return x.substring(ae)}e.ltrim=R;function d(x,te){if(!x||!te)return x;const oe=te.length,ae=x.length;if(oe===0||ae===0)return x;let le=ae,fe=-1;for(;fe=x.lastIndexOf(te,le-1),!(fe===-1||fe+oe!==le);){if(fe===0)return"";le=fe}return x.substring(0,le)}e.rtrim=d;function y(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=y;function I(x){return x.replace(/\*/g,"")}e.stripWildcards=I;function o(x,te,oe={}){if(!x)throw new Error("Cannot create regex from empty string");te||(x=U(x)),oe.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let ae="";return oe.global&&(ae+="g"),oe.matchCase||(ae+="i"),oe.multiline&&(ae+="m"),oe.unicode&&(ae+="u"),new RegExp(x,ae)}e.createRegExp=o;function C(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}e.regExpLeadsToEndlessLoop=C;function b(x){return!!x.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function E(x){return(x.global?"g":"")+(x.ignoreCase?"i":"")+(x.multiline?"m":"")+(x.unicode?"u":"")}e.regExpFlags=E;function p(x){return x.split(/\r\n|\r|\n/)}e.splitLines=p;function m(x){for(let te=0,oe=x.length;te<oe;te++){const ae=x.charCodeAt(te);if(ae!==32&&ae!==9)return te}return-1}e.firstNonWhitespaceIndex=m;function r(x,te=0,oe=x.length){for(let ae=te;ae<oe;ae++){const le=x.charCodeAt(ae);if(le!==32&&le!==9)return x.substring(te,ae)}return x.substring(te,oe)}e.getLeadingWhitespace=r;function n(x,te=x.length-1){for(let oe=te;oe>=0;oe--){const ae=x.charCodeAt(oe);if(ae!==32&&ae!==9)return oe}return-1}e.lastNonWhitespaceIndex=n;function t(x,te){return x<te?-1:x>te?1:0}e.compare=t;function i(x,te,oe=0,ae=x.length,le=0,fe=te.length){for(;oe<ae&&le<fe;oe++,le++){let we=x.charCodeAt(oe),be=te.charCodeAt(le);if(we<be)return-1;if(we>be)return 1}const ve=ae-oe,Se=fe-le;return ve<Se?-1:ve>Se?1:0}e.compareSubstring=i;function s(x,te){return c(x,te,0,x.length,0,te.length)}e.compareIgnoreCase=s;function c(x,te,oe=0,ae=x.length,le=0,fe=te.length){for(;oe<ae&&le<fe;oe++,le++){let we=x.charCodeAt(oe),be=te.charCodeAt(le);if(we!==be){const Pe=we-be;if(!(Pe===32&&l(be))&&!(Pe===-32&&l(we)))return a(we)&&a(be)?Pe:i(x.toLowerCase(),te.toLowerCase(),oe,ae,le,fe)}}const ve=ae-oe,Se=fe-le;return ve<Se?-1:ve>Se?1:0}e.compareSubstringIgnoreCase=c;function a(x){return x>=97&&x<=122}e.isLowerAsciiLetter=a;function l(x){return x>=65&&x<=90}e.isUpperAsciiLetter=l;function h(x){return a(x)||l(x)}function g(x,te){return x.length===te.length&&w(x,te)}e.equalsIgnoreCase=g;function w(x,te,oe=x.length){for(let ae=0;ae<oe;ae++){const le=x.charCodeAt(ae),fe=te.charCodeAt(ae);if(le!==fe){if(h(le)&&h(fe)){const ve=Math.abs(le-fe);if(ve!==0&&ve!==32)return!1}else if(String.fromCharCode(le).toLowerCase()!==String.fromCharCode(fe).toLowerCase())return!1}}return!0}function u(x,te){const oe=te.length;return te.length>x.length?!1:w(x,te,oe)}e.startsWithIgnoreCase=u;function P(x,te){let oe,ae=Math.min(x.length,te.length);for(oe=0;oe<ae;oe++)if(x.charCodeAt(oe)!==te.charCodeAt(oe))return oe;return ae}e.commonPrefixLength=P;function _(x,te){let oe,ae=Math.min(x.length,te.length);const le=x.length-1,fe=te.length-1;for(oe=0;oe<ae;oe++)if(x.charCodeAt(le-oe)!==te.charCodeAt(fe-oe))return oe;return ae}e.commonSuffixLength=_;function z(x){return 55296<=x&&x<=56319}e.isHighSurrogate=z;function B(x){return 56320<=x&&x<=57343}e.isLowSurrogate=B;function M(x,te){return(x-55296<<10)+(te-56320)+65536}e.computeCodePoint=M;function j(x,te,oe){const ae=x.charCodeAt(oe);if(z(ae)&&oe+1<te){const le=x.charCodeAt(oe+1);if(B(le))return M(ae,le)}return ae}e.getNextCodePoint=j;function W(x,te){const oe=x.charCodeAt(te-1);if(B(oe)&&te>1){const ae=x.charCodeAt(te-2);if(z(ae))return M(ae,oe)}return oe}function $(x,te){const oe=re.getInstance(),ae=te,le=x.length,fe=j(x,le,te);te+=fe>=65536?2:1;let ve=oe.getGraphemeBreakType(fe);for(;te<le;){const Se=j(x,le,te),we=oe.getGraphemeBreakType(Se);if(X(ve,we))break;te+=Se>=65536?2:1,ve=we}return te-ae}e.nextCharLength=$;function H(x,te){const oe=re.getInstance(),ae=te,le=W(x,te);te-=le>=65536?2:1;let fe=oe.getGraphemeBreakType(le);for(;te>0;){const ve=W(x,te),Se=oe.getGraphemeBreakType(ve);if(X(Se,fe))break;te-=ve>=65536?2:1,fe=Se}return ae-te}e.prevCharLength=H;function q(x,te){const oe=re.getInstance(),ae=x.length,le=te,fe=j(x,ae,te),ve=oe.getGraphemeBreakType(fe);te+=fe>=65536?2:1;let Se=ve;for(;te<ae;){const be=j(x,ae,te),Pe=oe.getGraphemeBreakType(be);if(X(Se,Pe))break;te+=be>=65536?2:1,Se=Pe}const we=te;for(te=le,Se=ve;te>0;){const be=W(x,te),Pe=oe.getGraphemeBreakType(be);if(X(Pe,Se))break;te-=be>=65536?2:1,Se=Pe}return[te,we]}function D(x,te){return te>0&&B(x.charCodeAt(te))?q(x,te-1):q(x,te)}e.getCharContainingOffset=D;function O(x){const te=x.length;let oe=0,ae=0;for(;ae<te;){const ve=j(x,te,ae);ae+=ve>=65536?2:1,ve<128?oe+=1:ve<2048?oe+=2:ve<65536?oe+=3:oe+=4}const le=new Uint8Array(oe);ae=0;let fe=0;for(;ae<te;){const ve=j(x,te,ae);ae+=ve>=65536?2:1,ve<128?le[fe++]=ve:ve<2048?(le[fe++]=192|(ve&1984)>>>6,le[fe++]=128|(ve&63)>>>0):ve<65536?(le[fe++]=224|(ve&61440)>>>12,le[fe++]=128|(ve&4032)>>>6,le[fe++]=128|(ve&63)>>>0):(le[fe++]=240|(ve&1835008)>>>18,le[fe++]=128|(ve&258048)>>>12,le[fe++]=128|(ve&4032)>>>6,le[fe++]=128|(ve&63)>>>0)}return le}e.encodeUTF8=O;function F(x){const te=x.byteLength,oe=[];let ae=0;for(;ae<te;){const le=x[ae];let fe;if(le>=240&&ae+3<te?fe=(x[ae++]&7)<<18>>>0|(x[ae++]&63)<<12>>>0|(x[ae++]&63)<<6>>>0|(x[ae++]&63)<<0>>>0:le>=224&&ae+2<te?fe=(x[ae++]&15)<<12>>>0|(x[ae++]&63)<<6>>>0|(x[ae++]&63)<<0>>>0:le>=192&&ae+1<te?fe=(x[ae++]&31)<<6>>>0|(x[ae++]&63)<<0>>>0:fe=x[ae++],fe>=0&&fe<=55295||fe>=57344&&fe<=65535)oe.push(String.fromCharCode(fe));else if(fe>=65536&&fe<=1114111){const ve=fe-65536,Se=55296+((ve&1047552)>>>10),we=56320+((ve&1023)>>>0);oe.push(String.fromCharCode(Se)),oe.push(String.fromCharCode(we))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=F;const N=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function V(x){return N.test(x)}e.containsRTL=V;const G=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function J(x){return G.test(x)}e.containsEmoji=J;const Q=/^[\t\n\r\x20-\x7E]*$/;function ne(x){return Q.test(x)}e.isBasicASCII=ne,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ie(x){return e.UNUSUAL_LINE_TERMINATORS.test(x)}e.containsUnusualLineTerminators=ie;function ce(x){for(let te=0,oe=x.length;te<oe;te++)if(ue(x.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=ce;function ue(x){return x=+x,x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}e.isFullWidthCharacter=ue;function ge(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129003||x>=129280&&x<=129535||x>=129648&&x<=129750}e.isEmojiImprecise=ge;function Ee(x,te){if(x.length<te)return x;const oe=/\b/g;let ae=0;for(;oe.test(x)&&!(x.length-oe.lastIndex<te);)ae=oe.lastIndex,oe.lastIndex+=1;return x.substring(ae).replace(/^\s/,"")}e.lcut=Ee;const Ie=/\x1B\x5B[12]?K/g,Te=/\x1b\[\d+m/g,Ae=/\x1b\[0?m/g;function Ue(x){return x&&(x=x.replace(Ie,""),x=x.replace(Te,""),x=x.replace(Ae,"")),x}e.removeAnsiEscapeCodes=Ue,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Me(x){return ke(x)?x.substr(1):x}e.stripUTF8BOM=Me;function De(x,te){if(!x||!te||x.length<te.length)return!1;const oe=te.length,ae=x.toLowerCase();let le=0,fe=-1;for(;le<oe;){const ve=ae.indexOf(te[le],fe+1);if(ve<0)return!1;fe=ve,le++}return!0}e.fuzzyContains=De;function Oe(x,te=!1){return x?(te&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}e.containsUppercaseCharacter=Oe;function He(x){return x.charAt(0).toUpperCase()+x.slice(1)}e.uppercaseFirstLetter=He;function Ge(x,te=1){if(te===0)return"";let oe=-1;do oe=x.indexOf(`
`,oe+1),te--;while(te>0&&oe>=0);return oe===-1?x:(x[oe-1]==="\r"&&oe--,x.substr(0,oe))}e.getNLines=Ge;function je(x){const te=90-65+1;return x=x%(2*te),x<te?String.fromCharCode(97+x):String.fromCharCode(65+x-te)}e.singleLetterHash=je;function $e(x){return re.getInstance().getGraphemeBreakType(x)}e.getGraphemeBreakType=$e;function X(x,te){return x===0?te!==5&&te!==7:x===2&&te===3?!1:x===4||x===2||x===3||te===4||te===2||te===3?!0:!(x===8&&(te===8||te===9||te===11||te===12)||(x===11||x===9)&&(te===9||te===10)||(x===12||x===10)&&te===10||te===5||te===13||te===7||x===1||x===13&&te===14||x===6&&te===6)}e.breakBetweenGraphemeBreakType=X;var se;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(se=e.GraphemeBreakType||(e.GraphemeBreakType={}));class re{constructor(){this._data=me()}static getInstance(){return re._INSTANCE||(re._INSTANCE=new re),re._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const oe=this._data,ae=oe.length/3;let le=1;for(;le<=ae;)if(te<oe[3*le])le=2*le;else if(te>oe[3*le+1])le=2*le+1;else return oe[3*le+2];return 0}}re._INSTANCE=null;function me(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(Z[22],ee([0,1,21,47]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",L=typeof TextEncoder!="undefined",U=typeof TextDecoder!="undefined";let T,f;class v{constructor(a){this.buffer=a,this.byteLength=this.buffer.byteLength}static alloc(a){return A?new v(Buffer.allocUnsafe(a)):new v(new Uint8Array(a))}static wrap(a){return A&&!Buffer.isBuffer(a)&&(a=Buffer.from(a.buffer,a.byteOffset,a.byteLength)),new v(a)}static fromString(a,l){return!((l==null?void 0:l.dontUseNodeBuffer)||!1)&&A?new v(Buffer.from(a)):L?(T||(T=new TextEncoder),new v(T.encode(a))):new v(S.encodeUTF8(a))}static concat(a,l){if(typeof l=="undefined"){l=0;for(let w=0,u=a.length;w<u;w++)l+=a[w].byteLength}const h=v.alloc(l);let g=0;for(let w=0,u=a.length;w<u;w++){const P=a[w];h.set(P,g),g+=P.byteLength}return h}toString(){return A?this.buffer.toString():U?(f||(f=new TextDecoder),f.decode(this.buffer)):S.decodeUTF8(this.buffer)}slice(a,l){return new v(this.buffer.subarray(a,l))}set(a,l){a instanceof v?this.buffer.set(a.buffer,l):this.buffer.set(a,l)}readUInt32BE(a){return y(this.buffer,a)}writeUInt32BE(a,l){I(this.buffer,a,l)}readUInt32LE(a){return o(this.buffer,a)}writeUInt32LE(a,l){C(this.buffer,a,l)}readUInt8(a){return b(this.buffer,a)}writeUInt8(a,l){E(this.buffer,a,l)}}e.VSBuffer=v;function R(c,a){return c[a+0]<<0>>>0|c[a+1]<<8>>>0}e.readUInt16LE=R;function d(c,a,l){c[l+0]=a&255,a=a>>>8,c[l+1]=a&255}e.writeUInt16LE=d;function y(c,a){return c[a]*2**24+c[a+1]*2**16+c[a+2]*2**8+c[a+3]}e.readUInt32BE=y;function I(c,a,l){c[l+3]=a,a=a>>>8,c[l+2]=a,a=a>>>8,c[l+1]=a,a=a>>>8,c[l]=a}e.writeUInt32BE=I;function o(c,a){return c[a+0]<<0>>>0|c[a+1]<<8>>>0|c[a+2]<<16>>>0|c[a+3]<<24>>>0}e.readUInt32LE=o;function C(c,a,l){c[l+0]=a&255,a=a>>>8,c[l+1]=a&255,a=a>>>8,c[l+2]=a&255,a=a>>>8,c[l+3]=a&255}e.writeUInt32LE=C;function b(c,a){return c[a]}e.readUInt8=b;function E(c,a,l){c[l]=a}e.writeUInt8=E;function p(c){return k.consumeReadable(c,a=>v.concat(a))}e.readableToBuffer=p;function m(c){return k.toReadable(c)}e.bufferToReadable=m;function r(c){return k.consumeStream(c,a=>v.concat(a))}e.streamToBuffer=r;async function n(c){return c.ended?v.concat(c.buffer):v.concat([...c.buffer,await r(c.stream)])}e.bufferedStreamToBuffer=n;function t(c){return k.toStream(c,a=>v.concat(a))}e.bufferToStream=t;function i(c){return k.transform(c,{data:a=>typeof a=="string"?v.fromString(a):v.wrap(a)},a=>v.concat(a))}e.streamToBufferReadableStream=i;function s(c){return k.newWriteableStream(a=>v.concat(a),c)}e.newWriteableBufferStream=s}),define(Z[15],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function S(l){return Array.isArray(l)}e.isArray=S;function k(l){return typeof l=="string"}e.isString=k;function A(l){return Array.isArray(l)&&l.every(h=>k(h))}e.isStringArray=A;function L(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=L;function U(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=U;function T(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=T;function f(l){return l===!0||l===!1}e.isBoolean=f;function v(l){return typeof l=="undefined"}e.isUndefined=v;function R(l){return!d(l)}e.isDefined=R;function d(l){return v(l)||l===null}e.isUndefinedOrNull=d;function y(l,h){if(!l)throw new Error(h?`Unexpected type, expected '${h}'`:"Unexpected type")}e.assertType=y;function I(l){if(d(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=I;function o(...l){const h=[];for(let g=0;g<l.length;g++){const w=l[g];if(d(w))throw new Error(`Assertion Failed: argument at index ${g} is undefined or null`);h.push(w)}return h}e.assertAllDefined=o;const C=Object.prototype.hasOwnProperty;function b(l){if(!L(l))return!1;for(let h in l)if(C.call(l,h))return!1;return!0}e.isEmptyObject=b;function E(l){return typeof l=="function"}e.isFunction=E;function p(...l){return l.length>0&&l.every(E)}e.areFunctions=p;function m(l,h){const g=Math.min(l.length,h.length);for(let w=0;w<g;w++)r(l[w],h[w])}e.validateConstraints=m;function r(l,h){if(k(h)){if(typeof l!==h)throw new Error(`argument does not match constraint: typeof ${h}`)}else if(E(h)){try{if(l instanceof h)return}catch(g){}if(!d(l)&&l.constructor===h||h.length===1&&h.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=r;function n(l){let h=[],g=Object.getPrototypeOf(l);for(;Object.prototype!==g;)h=h.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return h}e.getAllPropertyNames=n;function t(l){const h=[];for(const g of n(l))typeof l[g]=="function"&&h.push(g);return h}e.getAllMethodNames=t;function i(l,h){const g=u=>function(){const P=Array.prototype.slice.call(arguments,0);return h(u,P)};let w={};for(const u of l)w[u]=g(u);return w}e.createProxyObject=i;function s(l){return l===null?void 0:l}e.withNullAsUndefined=s;function c(l){return typeof l=="undefined"?null:l}e.withUndefinedAsNull=c;function a(l){return class{constructor(){return new Proxy({},{get(h,g){if(h[g])return h[g];throw new Error(`Not Implemented: ${l}->${String(g)}`)}})}}}e.NotImplementedProxy=a}),define(Z[42],ee([0,1,7,21,8,15]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function U(i){return i===47||i===92}e.isPathSeparator=U;function T(i){return i.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=T;function f(i,s=A.posix.sep){if(!i)return"";const c=i.length,a=i.charCodeAt(0);if(U(a)){if(U(i.charCodeAt(1))&&!U(i.charCodeAt(2))){let h=3;const g=h;for(;h<c&&!U(i.charCodeAt(h));h++);if(g!==h&&!U(i.charCodeAt(h+1))){for(h+=1;h<c;h++)if(U(i.charCodeAt(h)))return i.slice(0,h+1).replace(/[\\/]/g,s)}}return s}else if(b(a)&&i.charCodeAt(1)===58)return U(i.charCodeAt(2))?i.slice(0,2)+s:i.slice(0,2);let l=i.indexOf("://");if(l!==-1){for(l+=3;l<c;l++)if(U(i.charCodeAt(l)))return i.slice(0,l+1)}return""}e.getRoot=f;function v(i){if(!S.isWindows||!i||i.length<5)return!1;let s=i.charCodeAt(0);if(s!==92||(s=i.charCodeAt(1),s!==92))return!1;let c=2;const a=c;for(;c<i.length&&(s=i.charCodeAt(c),s!==92);c++);return!(a===c||(s=i.charCodeAt(c+1),isNaN(s)||s===92))}e.isUNC=v;const R=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function I(i,s=S.isWindows){const c=s?R:d;return!(!i||i.length===0||/^\s+$/.test(i)||(c.lastIndex=0,c.test(i))||s&&y.test(i)||i==="."||i===".."||s&&i[i.length-1]==="."||s&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=I;function o(i,s,c){const a=i===s;return!c||a?a:!i||!s?!1:(0,k.equalsIgnoreCase)(i,s)}e.isEqual=o;function C(i,s,c,a=A.sep){if(i===s)return!0;if(!i||!s||s.length>i.length)return!1;if(c){if(!(0,k.startsWithIgnoreCase)(i,s))return!1;if(s.length===i.length)return!0;let h=s.length;return s.charAt(s.length-1)===a&&h--,i.charAt(h)===a}return s.charAt(s.length-1)!==a&&(s+=a),i.indexOf(s)===0}e.isEqualOrParent=C;function b(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=b;function E(i,s){return S.isWindows&&i.endsWith(":")&&(i+=A.sep),(0,A.isAbsolute)(i)||(i=(0,A.join)(s,i)),i=(0,A.normalize)(i),S.isWindows?(i=(0,k.rtrim)(i,A.sep),i.endsWith(":")&&(i+=A.sep)):(i=(0,k.rtrim)(i,A.sep),i||(i=A.sep)),i}e.sanitizeFilePath=E;function p(i){const s=(0,A.normalize)(i);return S.isWindows?i.length>3?!1:m(s)&&(i.length===2||s.charCodeAt(2)===92):s===A.posix.sep}e.isRootOrDriveLetter=p;function m(i){return S.isWindows?b(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=m;function r(i){return m(i)?i[0]:void 0}e.getDriveLetter=r;function n(i,s,c){return s.length>i.length?-1:i===s?0:(c&&(i=i.toLowerCase(),s=s.toLowerCase()),i.indexOf(s))}e.indexOfPath=n;function t(i){const s=i.split(":");let c,a,l;if(s.forEach(h=>{const g=Number(h);(0,L.isNumber)(g)?a===void 0?a=g:l===void 0&&(l=g):c=c?[c,h].join(":"):h}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:a!==void 0?a:void 0,column:l!==void 0?l:a!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(Z[26],ee([0,1,15]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function k(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const C=Array.isArray(o)?[]:{};return Object.keys(o).forEach(b=>{o[b]&&typeof o[b]=="object"?C[b]=k(o[b]):C[b]=o[b]}),C}e.deepClone=k;function A(o){if(!o||typeof o!="object")return o;const C=[o];for(;C.length>0;){const b=C.shift();Object.freeze(b);for(const E in b)if(L.call(b,E)){const p=b[E];typeof p=="object"&&!Object.isFrozen(p)&&C.push(p)}}return o}e.deepFreeze=A;const L=Object.prototype.hasOwnProperty;function U(o,C){return T(o,C,new Set)}e.cloneAndChange=U;function T(o,C,b){if((0,S.isUndefinedOrNull)(o))return o;const E=C(o);if(typeof E!="undefined")return E;if((0,S.isArray)(o)){const p=[];for(const m of o)p.push(T(m,C,b));return p}if((0,S.isObject)(o)){if(b.has(o))throw new Error("Cannot clone recursive data-structure");b.add(o);const p={};for(let m in o)L.call(o,m)&&(p[m]=T(o[m],C,b));return b.delete(o),p}return o}function f(o,C,b=!0){return(0,S.isObject)(o)?((0,S.isObject)(C)&&Object.keys(C).forEach(E=>{E in o?b&&((0,S.isObject)(o[E])&&(0,S.isObject)(C[E])?f(o[E],C[E],b):o[E]=C[E]):o[E]=C[E]}),o):C}e.mixin=f;function v(o,C){if(o===C)return!0;if(o==null||C===null||C===void 0||typeof o!=typeof C||typeof o!="object"||Array.isArray(o)!==Array.isArray(C))return!1;let b,E;if(Array.isArray(o)){if(o.length!==C.length)return!1;for(b=0;b<o.length;b++)if(!v(o[b],C[b]))return!1}else{const p=[];for(E in o)p.push(E);p.sort();const m=[];for(E in C)m.push(E);if(m.sort(),!v(p,m))return!1;for(b=0;b<p.length;b++)if(!v(o[p[b]],C[p[b]]))return!1}return!0}e.equals=v;function R(o){const C=new Set;return JSON.stringify(o,(b,E)=>{if((0,S.isObject)(E)||Array.isArray(E)){if(C.has(E))return"[Circular]";C.add(E)}return E})}e.safeStringify=R;function d(o,C,b){const E=C(o);return typeof E=="undefined"?b:E}e.getOrDefault=d;function y(o,C){const b=Object.create(null);return!o||!C||Object.keys(C).forEach(p=>{const m=o[p],r=C[p];v(m,r)||(b[p]=r)}),b}e.distinct=y;function I(o,C){const b=C.toLowerCase(),E=Object.keys(o).find(p=>p.toLowerCase()===b);return E?o[E]:o[C]}e.getCaseInsensitive=I}),define(Z[4],ee([0,1,7,8]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,L=/^\//,U=/^\/\//;function T(s,c){if(!s.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!A.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!L.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(U.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(s,c){return!s&&!c?"file":s}function v(s,c){switch(s){case"https":case"http":case"file":c?c[0]!==d&&(c=d+c):c=d;break}return c}const R="",d="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class I{constructor(c,a,l,h,g,w=!1){typeof c=="object"?(this.scheme=c.scheme||R,this.authority=c.authority||R,this.path=c.path||R,this.query=c.query||R,this.fragment=c.fragment||R):(this.scheme=f(c,w),this.authority=a||R,this.path=v(this.scheme,l||R),this.query=h||R,this.fragment=g||R,T(this,w))}static isUri(c){return c instanceof I?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}get fsPath(){return m(this,!1)}with(c){if(!c)return this;let{scheme:a,authority:l,path:h,query:g,fragment:w}=c;return a===void 0?a=this.scheme:a===null&&(a=R),l===void 0?l=this.authority:l===null&&(l=R),h===void 0?h=this.path:h===null&&(h=R),g===void 0?g=this.query:g===null&&(g=R),w===void 0?w=this.fragment:w===null&&(w=R),a===this.scheme&&l===this.authority&&h===this.path&&g===this.query&&w===this.fragment?this:new C(a,l,h,g,w)}static parse(c,a=!1){const l=y.exec(c);return l?new C(l[2]||R,i(l[4]||R),i(l[5]||R),i(l[7]||R),i(l[9]||R),a):new C(R,R,R,R,R)}static file(c){let a=R;if(S.isWindows&&(c=c.replace(/\\/g,d)),c[0]===d&&c[1]===d){const l=c.indexOf(d,2);l===-1?(a=c.substring(2),c=d):(a=c.substring(2,l),c=c.substring(l)||d)}return new C("file",a,c,R,R)}static from(c){return new C(c.scheme,c.authority,c.path,c.query,c.fragment)}static joinPath(c,...a){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return S.isWindows&&c.scheme==="file"?l=I.file(k.win32.join(m(c,!0),...a)).path:l=k.posix.join(c.path,...a),c.with({path:l})}toString(c=!1){return r(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof I)return c;{const a=new C(c);return a._formatted=c.external,a._fsPath=c._sep===o?c.fsPath:null,a}}else return c}}e.URI=I;const o=S.isWindows?1:void 0;class C extends I{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(c=!1){return c?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=o),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(s,c){let a,l=-1;for(let h=0;h<s.length;h++){const g=s.charCodeAt(h);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||c&&g===47)l!==-1&&(a+=encodeURIComponent(s.substring(l,h)),l=-1),a!==void 0&&(a+=s.charAt(h));else{a===void 0&&(a=s.substr(0,h));const w=b[g];w!==void 0?(l!==-1&&(a+=encodeURIComponent(s.substring(l,h)),l=-1),a+=w):l===-1&&(l=h)}}return l!==-1&&(a+=encodeURIComponent(s.substring(l))),a!==void 0?a:s}function p(s){let c;for(let a=0;a<s.length;a++){const l=s.charCodeAt(a);l===35||l===63?(c===void 0&&(c=s.substr(0,a)),c+=b[l]):c!==void 0&&(c+=s[a])}return c!==void 0?c:s}function m(s,c){let a;return s.authority&&s.path.length>1&&s.scheme==="file"?a=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?c?a=s.path.substr(1):a=s.path[1].toLowerCase()+s.path.substr(2):a=s.path,S.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=m;function r(s,c){const a=c?p:E;let l="",{scheme:h,authority:g,path:w,query:u,fragment:P}=s;if(h&&(l+=h,l+=":"),(g||h==="file")&&(l+=d,l+=d),g){let _=g.indexOf("@");if(_!==-1){const z=g.substr(0,_);g=g.substr(_+1),_=z.indexOf(":"),_===-1?l+=a(z,!1):(l+=a(z.substr(0,_),!1),l+=":",l+=a(z.substr(_+1),!1)),l+="@"}g=g.toLowerCase(),_=g.indexOf(":"),_===-1?l+=a(g,!1):(l+=a(g.substr(0,_),!1),l+=g.substr(_))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const _=w.charCodeAt(1);_>=65&&_<=90&&(w=`/${String.fromCharCode(_+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const _=w.charCodeAt(0);_>=65&&_<=90&&(w=`${String.fromCharCode(_+32)}:${w.substr(2)}`)}l+=a(w,!0)}return u&&(l+="?",l+=a(u,!1)),P&&(l+="#",l+=c?P:E(P,!1)),l}function n(s){try{return decodeURIComponent(s)}catch(c){return s.length>3?s.substr(0,3)+n(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(s){return s.match(t)?s.replace(t,c=>n(c)):s}}),define(Z[87],ee([0,1,4]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function k(v){const R=v;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.isRemoteConsoleLog=k;function A(v){const R=[];let d;try{const y=JSON.parse(v.arguments),I=y[y.length-1];I&&I.__$stack&&(y.pop(),d=I.__$stack),R.push(...y)}catch(y){R.push("Unable to log remote console arguments",v.arguments)}return{args:R,stack:d}}e.parse=A;function L(v){if(typeof v!="string")return L(A(v).stack);const R=v;if(R){const d=U(R),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(d||"");if(y&&y.length===4)return{uri:S.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=L;function U(v){if(!v)return v;const R=v.indexOf(`
`);return R===-1?v:v.substring(0,R)}function T(v,R){const{args:d,stack:y}=A(v),I=typeof d[0]=="string"&&d.length===1;let o=U(y);o&&(o=`(${o.trim()})`);let C=[];if(typeof d[0]=="string"?o&&I?C=[`%c[${R}] %c${d[0]} %c${o}`,f("blue"),f(""),f("grey")]:C=[`%c[${R}] %c${d[0]}`,f("blue"),f(""),...d.slice(1)]:C=[`%c[${R}]%`,f("blue"),...d],o&&!I&&C.push(o),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,C)}e.log=T;function f(v){return`color: ${v}`}}),define(Z[37],ee([0,1,4,21]),function(K,e,S,k){"use strict";var A,L;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function U(r,n,t){let i=r.get(n);return i===void 0&&(i=t,r.set(n,i)),i}e.getOrSet=U;function T(r){const n=[];return r.forEach((t,i)=>{n.push(`${i} => ${t}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.mapToString=T;function f(r){const n=[];return r.forEach(t=>{n.push(t)}),`Set(${r.size}) {${n.join(", ")}}`}e.setToString=f;class v{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const t=n.charCodeAt(0),i=this._value.charCodeAt(this._pos);return t-i}value(){return this._value[this._pos]}}e.StringIterator=v;class R{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,k.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class d{constructor(n=!0,t=!0){this._splitOnBackslash=n,this._caseSensitive=t}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,k.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var y;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(y||(y={}));class I{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,k.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=I;class o{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class C{constructor(n){this._iter=n}static forUris(n=()=>!1){return new C(new I(n))}static forPaths(){return new C(new d)}static forStrings(){return new C(new v)}static forConfigKeys(){return new C(new R)}clear(){this._root=void 0}set(n,t){const i=this._iter.reset(n);let s;for(this._root||(this._root=new o,this._root.segment=i.value()),s=this._root;;){const a=i.cmp(s.segment);if(a>0)s.left||(s.left=new o,s.left.segment=i.value()),s=s.left;else if(a<0)s.right||(s.right=new o,s.right.segment=i.value()),s=s.right;else if(i.hasNext())i.next(),s.mid||(s.mid=new o,s.mid.segment=i.value()),s=s.mid;else break}const c=s.value;return s.value=t,s.key=n,c}get(n){var t;return(t=this._getNode(n))===null||t===void 0?void 0:t.value}_getNode(n){const t=this._iter.reset(n);let i=this._root;for(;i;){const s=t.cmp(i.segment);if(s>0)i=i.left;else if(s<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else break}return i}has(n){const t=this._getNode(n);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,t){const i=this._iter.reset(n),s=[];let c=this._root;for(;c;){const a=i.cmp(c.segment);if(a>0)s.push([1,c]),c=c.left;else if(a<0)s.push([-1,c]),c=c.right;else if(i.hasNext())i.next(),s.push([0,c]),c=c.mid;else{for(t?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;s.length>0&&c.isEmpty();){let[l,h]=s.pop();switch(l){case 1:h.left=void 0;break;case 0:h.mid=void 0;break;case-1:h.right=void 0;break}c=h}break}}}findSubstr(n){const t=this._iter.reset(n);let i=this._root,s;for(;i;){const c=t.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(t.hasNext())t.next(),s=i.value||s,i=i.mid;else break}return i&&i.value||s}findSuperstr(n){const t=this._iter.reset(n);let i=this._root;for(;i;){const s=t.cmp(i.segment);if(s>0)i=i.left;else if(s<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(n){for(const[t,i]of this)n(i,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=C;class b{constructor(n,t){this[A]="ResourceMap",n instanceof b?(this.map=new Map(n.map),this.toKey=t!=null?t:b.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:b.defaultToKey)}set(n,t){return this.map.set(this.toKey(n),t),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,t){typeof t!="undefined"&&(n=n.bind(t));for(let[i,s]of this.map)n(s,S.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield S.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[S.URI.parse(n[0]),n[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[S.URI.parse(n[0]),n[1]]}}e.ResourceMap=b,b.defaultToKey=r=>r.toString();var E;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class p{constructor(){this[L]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,t=0){const i=this._map.get(n);if(!!i)return t!==0&&this.touch(i,t),i.value}set(n,t,i=0){let s=this._map.get(n);if(s)s.value=t,i!==0&&this.touch(s,i);else{switch(s={key:n,value:t,next:void 0,previous:void 0},i){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(n,s),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const t=this._map.get(n);if(!!t)return this._map.delete(n),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,t){const i=this._state;let s=this._head;for(;s;){if(t?n.bind(t)(s.value,s.key,this):n(s.value,s.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const n=this,t=this._state;let i=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const c={value:i.key,done:!1};return i=i.next,c}else return{value:void 0,done:!0}}};return s}values(){const n=this,t=this._state;let i=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const c={value:i.value,done:!1};return i=i.next,c}else return{value:void 0,done:!0}}};return s}entries(){const n=this,t=this._state;let i=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const c={value:[i.key,i.value],done:!1};return i=i.next,c}else return{value:void 0,done:!0}}};return s}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let t=this._head,i=this.size;for(;t&&i>n;)this._map.delete(t.key),t=t.next,i--;this._head=t,this._size=i,t&&(t.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const t=n.next,i=n.previous;if(!t||!i)throw new Error("Invalid list");t.previous=i,i.next=t}n.next=void 0,n.previous=void 0,this._state++}touch(n,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(n===this._head)return;const i=n.next,s=n.previous;n===this._tail?(s.next=void 0,this._tail=s):(i.previous=s,s.next=i),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(t===2){if(n===this._tail)return;const i=n.next,s=n.previous;n===this._head?(i.previous=void 0,this._head=i):(i.previous=s,s.next=i),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((t,i)=>{n.push([i,t])}),n}fromJSON(n){this.clear();for(const[t,i]of n)this.set(t,i)}}e.LinkedMap=p;class m extends p{constructor(n,t=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,t=2){return super.get(n,t)}peek(n){return super.get(n,0)}set(n,t){return super.set(n,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=m}),define(Z[88],ee([0,1,22,21,4]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(v){return JSON.stringify(v,T)}e.stringify=L;function U(v){let R=JSON.parse(v);return R=f(R),R}e.parse=U;function T(v,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,k.regExpFlags)(R)}:R}function f(v,R=0){if(!v||R>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return A.URI.revive(v);case 2:return new RegExp(v.source,v.flags)}if(v instanceof S.VSBuffer||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let d=0;d<v.length;++d)v[d]=f(v[d],R+1);else for(const d in v)Object.hasOwnProperty.call(v,d)&&(v[d]=f(v[d],R+1))}return v}e.revive=f}),define(Z[16],ee([0,1,4,7]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(T){T.inMemory="inmemory",T.vscode="vscode",T.internal="private",T.walkThrough="walkThrough",T.walkThroughSnippet="walkThroughSnippet",T.http="http",T.https="https",T.file="file",T.mailto="mailto",T.untitled="untitled",T.data="data",T.command="command",T.vscodeRemote="vscode-remote",T.vscodeRemoteResource="vscode-remote-resource",T.userData="vscode-userdata",T.vscodeCustomEditor="vscode-custom-editor",T.vscodeNotebook="vscode-notebook",T.vscodeNotebookCell="vscode-notebook-cell",T.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",T.vscodeSettings="vscode-settings",T.vscodeWorkspaceTrust="vscode-workspace-trust",T.webviewPanel="webview-panel",T.vscodeWebview="vscode-webview",T.extension="extension",T.vscodeFileResource="vscode-file"})(A=e.Schemas||(e.Schemas={}));class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,v,R){this._hosts[f]=v,this._ports[f]=R}setConnectionToken(f,v){this._connectionTokens[f]=v}rewrite(f){if(this._delegate)return this._delegate(f);const v=f.authority;let R=this._hosts[v];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const d=this._ports[v],y=this._connectionTokens[v];let I=`path=${encodeURIComponent(f.path)}`;return typeof y=="string"&&(I+=`&tkn=${encodeURIComponent(y)}`),S.URI.from({scheme:k.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${R}:${d}`,path:"/vscode-remote-resource",query:I})}}e.RemoteAuthorities=new L;class U{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(f,v,R){const d=this.toUri(f,v);return d.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(d):k.isNative&&(R||k.isPreferringBrowserCodeLoad)&&d.scheme===A.file?d.with({scheme:A.vscodeFileResource,authority:d.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):d}asFileUri(f,v){const R=this.toUri(f,v);return R.scheme===A.vscodeFileResource?R.with({scheme:A.file,authority:R.authority!==this.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(f,v){return S.URI.isUri(f)?f:S.URI.parse(v.toUrl(f))}}e.FileAccess=new U}),define(Z[65],ee([0,1,37]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const k=new S.LRUCache(1e4);function A(v){return f(v,"NFC",k)}e.normalizeNFC=A;const L=new S.LRUCache(1e4);function U(v){return f(v,"NFD",L)}e.normalizeNFD=U;const T=/[^\u0000-\u0080]/;function f(v,R,d){if(!e.canNormalize||!v)return v;const y=d.get(v);if(y)return y;let I;return T.test(v)?I=v.normalize(R):I=v,d.set(v,I),I}e.removeAccents=function(){if(e.canNormalize){const v=/[\u0300-\u036f]/g;return function(R){return U(R).replace(v,"")}}else return function(v){return v}}()}),define(Z[12],ee([0,1,42,8,4,21,16,7]),function(K,e,S,k,A,L,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(I){return(0,A.uriToFsPath)(I,!0)}e.originalFSPath=f;class v{constructor(o){this._ignorePathCasing=o}compare(o,C,b=!1){return o===C?0:(0,L.compare)(this.getComparisonKey(o,b),this.getComparisonKey(C,b))}isEqual(o,C,b=!1){return o===C?!0:!o||!C?!1:this.getComparisonKey(o,b)===this.getComparisonKey(C,b)}getComparisonKey(o,C=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:C?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,C,b=!1){if(o.scheme===C.scheme){if(o.scheme===U.Schemas.file)return S.isEqualOrParent(f(o),f(C),this._ignorePathCasing(o))&&o.query===C.query&&(b||o.fragment===C.fragment);if((0,e.isEqualAuthority)(o.authority,C.authority))return S.isEqualOrParent(o.path,C.path,this._ignorePathCasing(o),"/")&&o.query===C.query&&(b||o.fragment===C.fragment)}return!1}joinPath(o,...C){return A.URI.joinPath(o,...C)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return k.posix.basename(o.path)}extname(o){return k.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let C;return o.scheme===U.Schemas.file?C=A.URI.file(k.dirname(f(o))).path:(C=k.posix.dirname(o.path),o.authority&&C.length&&C.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),C="/")),o.with({path:C})}normalizePath(o){if(!o.path.length)return o;let C;return o.scheme===U.Schemas.file?C=A.URI.file(k.normalize(f(o))).path:C=k.posix.normalize(o.path),o.with({path:C})}relativePath(o,C){if(!(o.scheme!==C.scheme||!(0,e.isEqualAuthority)(o.authority,C.authority))){if(o.scheme===U.Schemas.file){const p=k.relative(f(o),f(C));return T.isWindows?S.toSlashes(p):p}let b=o.path||"/",E=C.path||"/";if(this._ignorePathCasing(o)){let p=0;for(const m=Math.min(b.length,E.length);p<m&&!(b.charCodeAt(p)!==E.charCodeAt(p)&&b.charAt(p).toLowerCase()!==E.charAt(p).toLowerCase());p++);b=E.substr(0,p)+b.substr(p)}return k.posix.relative(b,E)}}resolvePath(o,C){if(o.scheme===U.Schemas.file){const b=A.URI.file(k.resolve(f(o),C));return o.with({authority:b.authority,path:b.path})}return C.indexOf("/")===-1&&(C=S.toSlashes(C),/^[a-zA-Z]:(\/|$)/.test(C)&&(C="/"+C)),o.with({path:k.posix.resolve(o.path,C)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,C){return o===C||(0,L.equalsIgnoreCase)(o,C)}hasTrailingPathSeparator(o,C=k.sep){if(o.scheme===U.Schemas.file){const b=f(o);return b.length>S.getRoot(b).length&&b[b.length-1]===C}else{const b=o.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,C=k.sep){return(0,e.hasTrailingPathSeparator)(o,C)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,C=k.sep){let b=!1;if(o.scheme===U.Schemas.file){const E=f(o);b=E!==void 0&&E.length===S.getRoot(E).length&&E[E.length-1]===C}else{C="/";const E=o.path;b=E.length===1&&E.charCodeAt(E.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(o,C)?o.with({path:o.path+"/"}):o}}e.ExtUri=v,e.extUri=new v(()=>!1),e.extUriBiasedIgnorePathCase=new v(I=>I.scheme===U.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new v(I=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(I,o){const C=[];for(let b=0;b<I.length;b++){const E=o(I[b]);I.some((p,m)=>m===b?!1:(0,e.isEqualOrParent)(E,o(p)))||C.push(I[b])}return C}e.distinctParents=R;var d;(function(I){I.META_DATA_LABEL="label",I.META_DATA_DESCRIPTION="description",I.META_DATA_SIZE="size",I.META_DATA_MIME="mime";function o(C){const b=new Map;C.path.substring(C.path.indexOf(";")+1,C.path.lastIndexOf(";")).split(";").forEach(m=>{const[r,n]=m.split(":");r&&n&&b.set(r,n)});const p=C.path.substring(0,C.path.indexOf(";"));return p&&b.set(I.META_DATA_MIME,p),b}I.parseMetaData=o})(d=e.DataUri||(e.DataUri={}));function y(I,o,C){if(o){let b=I.path;return b&&b[0]!==k.posix.sep&&(b=k.posix.sep+b),I.with({scheme:C,authority:o,path:b})}return I.with({scheme:C})}e.toLocalResource=y}),define(Z[6],ee([0,1,30,11,3,2,64,12]),function(K,e,S,k,A,L,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function f(q){return!!q&&typeof q.then=="function"}e.isThenable=f;function v(q){const D=new S.CancellationTokenSource,O=q(D.token),F=new Promise((N,V)=>{D.token.onCancellationRequested(()=>{V((0,k.canceled)())}),Promise.resolve(O).then(G=>{D.dispose(),N(G)},G=>{D.dispose(),V(G)})});return new class{cancel(){D.cancel()}then(N,V){return F.then(N,V)}catch(N){return this.then(void 0,N)}finally(N){return F.finally(N)}}}e.createCancelablePromise=v;function R(q,D,O){return Promise.race([q,new Promise(F=>D.onCancellationRequested(()=>F(O)))])}e.raceCancellation=R;async function d(q){let D=-1;const O=q.map((N,V)=>N.then(G=>(D=V,G))),F=await Promise.race(O);return q.forEach((N,V)=>{V!==D&&N.cancel()}),F}e.raceCancellablePromises=d;function y(q,D,O){let F;const N=setTimeout(()=>{F==null||F(void 0),O==null||O()},D);return Promise.race([q.finally(()=>clearTimeout(N)),new Promise(V=>F=V)])}e.raceTimeout=y;function I(q){return new Promise((D,O)=>{const F=q();f(F)?F.then(D,O):D(F)})}e.asPromise=I;class o{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(D){if(this.activePromise){if(this.queuedPromiseFactory=D,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(O,O).then(F)})}return new Promise((O,F)=>{this.queuedPromise.then(O,F)})}return this.activePromise=D(),new Promise((O,F)=>{this.activePromise.then(N=>{this.activePromise=null,O(N)},N=>{this.activePromise=null,F(N)})})}}e.Throttler=o;class C{constructor(){this.current=Promise.resolve(null)}queue(D){return this.current=this.current.then(()=>D(),()=>D())}}e.Sequencer=C;class b{constructor(){this.promiseMap=new Map}queue(D,O){var F;const V=((F=this.promiseMap.get(D))!==null&&F!==void 0?F:Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(D)===V&&this.promiseMap.delete(D)});return this.promiseMap.set(D,V),V}}e.SequencerByKey=b;class E{constructor(D){this.defaultDelay=D,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(D,O=this.defaultDelay){return this.task=D,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,N)=>{this.doResolve=F,this.doReject=N}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},O),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,k.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=E;class p{constructor(D){this.delayer=new E(D),this.throttler=new o}trigger(D,O){return this.delayer.trigger(()=>this.throttler.queue(D),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=p;class m{constructor(){this._isOpen=!1,this._promise=new Promise((D,O)=>{this._completePromise=D})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=m;class r extends m{constructor(D){super();this._timeout=setTimeout(()=>this.open(),D)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function n(q,D){return D?new Promise((O,F)=>{const N=setTimeout(O,q);D.onCancellationRequested(()=>{clearTimeout(N),F((0,k.canceled)())})}):v(O=>n(q,O))}e.timeout=n;function t(q,D=0){const O=setTimeout(q,D);return(0,L.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=t;function i(q){return q.then(void 0,D=>{})}e.ignoreErrors=i;function s(q){const D=[];let O=0;const F=q.length;function N(){return O<F?q[O++]():null}function V(G){G!=null&&D.push(G);const J=N();return J?J.then(V):Promise.resolve(D)}return Promise.resolve(null).then(V)}e.sequence=s;function c(q,D=F=>!!F,O=null){let F=0;const N=q.length,V=()=>{if(F>=N)return Promise.resolve(O);const G=q[F++];return Promise.resolve(G()).then(Q=>D(Q)?Promise.resolve(Q):V())};return V()}e.first=c;function a(q,D=F=>!!F,O=null){if(q.length===0)return Promise.resolve(O);let F=q.length;const N=()=>{var V,G;F=-1;for(const J of q)(G=(V=J).cancel)===null||G===void 0||G.call(V)};return new Promise((V,G)=>{for(const J of q)J.then(Q=>{--F>=0&&D(Q)?(N(),V(Q)):F===0&&V(O)}).catch(Q=>{--F>=0&&(N(),G(Q))})})}e.firstParallel=a;class l{constructor(D){this._size=0,this.maxDegreeOfParalellism=D,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(D){return this._size++,new Promise((O,F)=>{this.outstandingPromises.push({factory:D,c:O,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const D=this.outstandingPromises.shift();this.runningPromises++;const O=D.factory();O.then(D.c,D.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=l;class h extends l{constructor(){super(1)}}e.Queue=h;class g{constructor(){this.queues=new Map}queueFor(D,O=T.extUri){const F=O.getComparisonKey(D);let N=this.queues.get(F);return N||(N=new h,A.Event.once(N.onFinished)(()=>{N==null||N.dispose(),this.queues.delete(F)}),this.queues.set(F,N)),N}dispose(){this.queues.forEach(D=>D.dispose()),this.queues.clear()}}e.ResourceQueue=g;class w{constructor(D,O){this._token=-1,typeof D=="function"&&typeof O=="number"&&this.setIfNotSet(D,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(D,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,D()},O)}setIfNotSet(D,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,D()},O))}}e.TimeoutTimer=w;class u{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(D,O){this.cancel(),this._token=setInterval(()=>{D()},O)}}e.IntervalTimer=u;class P{constructor(D,O){this.timeoutToken=-1,this.runner=D,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(D=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,D)}get delay(){return this.timeout}set delay(D){this.timeout=D}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=P;class _ extends P{constructor(D,O){super(D,O);this.units=[]}work(D){this.units.push(D),this.isScheduled()||this.schedule()}doRun(){const D=this.units;this.units=[],this.runner&&this.runner(D)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const q=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=D=>{const O=setTimeout(()=>D(q));let F=!1;return{dispose(){F||(F=!0,clearTimeout(O))}}}}else e.runWhenIdle=(q,D)=>{const O=requestIdleCallback(q,typeof D=="number"?{timeout:D}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(O))}}}}();class z{constructor(D){this._didRun=!1,this._executor=()=>{try{this._value=D()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=z;async function B(q,D,O){let F;for(let N=0;N<O;N++)try{return await q()}catch(V){F=V,await n(D)}throw F}e.retry=B;class M{hasPending(D){return this._pending?typeof D=="number"?this._pending.taskId===D:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var D;(D=this._pending)===null||D===void 0||D.cancel()}setPending(D,O,F){return this._pending={taskId:D,cancel:()=>F==null?void 0:F(),promise:O},O.then(()=>this.donePending(D),()=>this.donePending(D)),O}donePending(D){this._pending&&D===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const D=this._next;this._next=void 0,D.run().then(D.promiseResolve,D.promiseReject)}}setNext(D){if(this._next)this._next.run=D;else{let O,F;const N=new Promise((V,G)=>{O=V,F=G});this._next={run:D,promise:N,promiseResolve:O,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=M;class j{constructor(D){this.interval=D,this.lastIncrementTime=0,this.value=0}increment(){const D=Date.now();return D-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=D,this.value=0),this.value++,this.value}}e.IntervalCounter=j;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((D,O)=>{this.completeCallback=D,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(D){return new Promise(O=>{this.completeCallback(D),this.resolved=!0,O()})}error(D){return new Promise(O=>{this.errorCallback(D),this.rejected=!0,O()})}cancel(){new Promise(D=>{this.errorCallback((0,k.canceled)()),this.rejected=!0,D()})}}e.DeferredPromise=W;class $ extends A.Emitter{async fireAsync(D,O,F){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new U.LinkedList);for(const N of this._listeners)this._asyncDeliveryQueue.push([N,D]);for(;this._asyncDeliveryQueue.size>0&&!O.isCancellationRequested;){const[N,V]=this._asyncDeliveryQueue.shift(),G=[],J=Object.assign(Object.assign({},V),{waitUntil:Q=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");F&&(Q=F(Q,typeof N=="function"?N:N[0])),G.push(Q)}});try{typeof N=="function"?N.call(void 0,J):N[0].call(N[1],J)}catch(Q){(0,k.onUnexpectedError)(Q);continue}Object.freeze(G),await H.settled(G).catch(Q=>(0,k.onUnexpectedError)(Q))}}}}e.AsyncEmitter=$;var H;(function(q){async function D(V){return typeof Promise.allSettled=="function"?O(V):F(V)}q.allSettled=D;async function O(V){return Promise.allSettled(V)}async function F(V){return Promise.all(V.map(G=>G.then(J=>({status:"fulfilled",value:J}),J=>({status:"rejected",reason:J}))))}async function N(V){let G;const J=await Promise.all(V.map(Q=>Q.then(ne=>ne,ne=>{G||(G=ne)})));if(typeof G!="undefined")throw G;return J}q.settled=N})(H=e.Promises||(e.Promises={}))}),define(Z[89],ee([0,1,21,42,8,37,6]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function T(){return Object.create(null)}e.getEmptyExpression=T;const f="**",v="/",R="[/\\\\]",d="[^/\\\\]",y=/\//g;function I(O){switch(O){case 0:return"";case 1:return`${d}*?`;default:return`(?:${R}|${d}+${R}|${R}${d}+)*?`}}function o(O,F){if(!O)return[];const N=[];let V=!1,G=!1,J="";for(const Q of O){switch(Q){case F:if(!V&&!G){N.push(J),J="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":G=!0;break;case"]":G=!1;break}J+=Q}return J&&N.push(J),N}e.splitGlobAware=o;function C(O){if(!O)return"";let F="";const N=o(O,v);if(N.every(V=>V===f))F=".*";else{let V=!1;N.forEach((G,J)=>{if(G===f){V||(F+=I(2),V=!0);return}let Q=!1,ne="",ie=!1,ce="";for(const ue of G){if(ue!=="}"&&Q){ne+=ue;continue}if(ie&&(ue!=="]"||!ce)){let ge;ue==="-"?ge=ue:(ue==="^"||ue==="!")&&!ce?ge="^":ue===v?ge="":ge=S.escapeRegExpCharacters(ue),ce+=ge;continue}switch(ue){case"{":Q=!0;continue;case"[":ie=!0;continue;case"}":F+=`(?:${o(ne,",").map(Ie=>C(Ie)).join("|")})`,Q=!1,ne="";break;case"]":F+="["+ce+"]",ie=!1,ce="";break;case"?":F+=d;continue;case"*":F+=I(1);continue;default:F+=S.escapeRegExpCharacters(ue)}}J<N.length-1&&(N[J+1]!==f||J+2<N.length)&&(F+=R),V=!1})}return F}const b=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,m=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,n=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.LRUCache(1e4),i=function(){return!1},s=function(){return null};function c(O,F){if(!O)return s;let N;typeof O!="string"?N=O.pattern:N=O,N=N.trim();const V=`${N}_${!!F.trimForExclusions}`;let G=t.get(V);if(G)return a(G,O);let J;if(b.test(N)){const Q=N.substr(4);G=function(ne,ie){return typeof ne=="string"&&ne.endsWith(Q)?N:null}}else(J=E.exec(l(N,F)))?G=h(J[1],N):(F.trimForExclusions?m:p).test(N)?G=g(N,F):(J=r.exec(l(N,F)))?G=w(J[1].substr(1),N,!0):(J=n.exec(l(N,F)))?G=w(J[1],N,!1):G=u(N);return t.set(V,G),a(G,O)}function a(O,F){return typeof F=="string"?O:function(N,V){return k.isEqualOrParent(N,F.base)?O(A.relative(F.base,N),V):null}}function l(O,F){return F.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function h(O,F){const N=`/${O}`,V=`\\${O}`,G=function(Q,ne){return typeof Q!="string"?null:ne?ne===O?F:null:Q===O||Q.endsWith(N)||Q.endsWith(V)?F:null},J=[O];return G.basenames=J,G.patterns=[F],G.allBasenames=J,G}function g(O,F){const N=D(O.slice(1,-1).split(",").map(ne=>c(ne,F)).filter(ne=>ne!==s),O),V=N.length;if(!V)return s;if(V===1)return N[0];const G=function(ne,ie){for(let ce=0,ue=N.length;ce<ue;ce++)if(N[ce](ne,ie))return O;return null},J=N.find(ne=>!!ne.allBasenames);J&&(G.allBasenames=J.allBasenames);const Q=N.reduce((ne,ie)=>ie.allPaths?ne.concat(ie.allPaths):ne,[]);return Q.length&&(G.allPaths=Q),G}function w(O,F,N){const V=A.sep===A.posix.sep,G=V?O:O.replace(y,A.sep),J=A.sep+G,Q=A.posix.sep+O,ne=N?function(ie,ce){return typeof ie=="string"&&(ie===G||ie.endsWith(J)||!V&&(ie===O||ie.endsWith(Q)))?F:null}:function(ie,ce){return typeof ie=="string"&&(ie===G||!V&&ie===O)?F:null};return ne.allPaths=[(N?"*/":"./")+O],ne}function u(O){try{const F=new RegExp(`^${C(O)}$`);return function(N){return F.lastIndex=0,typeof N=="string"&&F.test(N)?O:null}}catch(F){return s}}function P(O,F,N){return!O||typeof F!="string"?!1:_(O)(F,void 0,N)}e.match=P;function _(O,F={}){if(!O)return i;if(typeof O=="string"||j(O)){const N=c(O,F);if(N===s)return i;const V=function(G,J){return!!N(G,J)};return N.allBasenames&&(V.allBasenames=N.allBasenames),N.allPaths&&(V.allPaths=N.allPaths),V}return H(O,F)}e.parse=_;function z(O){if(!!O){let F;return N=>(F||(F=(O()||Promise.resolve([])).then(V=>V?M(V):{})),F.then(V=>!!V[N]))}}e.hasSiblingPromiseFn=z;function B(O){if(!!O){let F;return N=>{if(!F){const V=O();F=V?M(V):{}}return!!F[N]}}}e.hasSiblingFn=B;function M(O){const F={};for(const N of O)F[N]=!0;return F}function j(O){const F=O;return F&&typeof F.base=="string"&&typeof F.pattern=="string"}e.isRelativePattern=j;function W(O){return O.allBasenames||[]}e.getBasenameTerms=W;function $(O){return O.allPaths||[]}e.getPathTerms=$;function H(O,F){const N=D(Object.getOwnPropertyNames(O).map(ne=>q(ne,O[ne],F)).filter(ne=>ne!==s)),V=N.length;if(!V)return s;if(!N.some(ne=>!!ne.requiresSiblings)){if(V===1)return N[0];const ne=function(ue,ge){for(let Ee=0,Ie=N.length;Ee<Ie;Ee++){const Te=N[Ee](ue,ge);if(Te)return Te}return null},ie=N.find(ue=>!!ue.allBasenames);ie&&(ne.allBasenames=ie.allBasenames);const ce=N.reduce((ue,ge)=>ge.allPaths?ue.concat(ge.allPaths):ue,[]);return ce.length&&(ne.allPaths=ce),ne}const G=function(ne,ie,ce){let ue;for(let ge=0,Ee=N.length;ge<Ee;ge++){const Ie=N[ge];Ie.requiresSiblings&&ce&&(ie||(ie=A.basename(ne)),ue||(ue=ie.substr(0,ie.length-A.extname(ne).length)));const Te=Ie(ne,ie,ue,ce);if(Te)return Te}return null},J=N.find(ne=>!!ne.allBasenames);J&&(G.allBasenames=J.allBasenames);const Q=N.reduce((ne,ie)=>ie.allPaths?ne.concat(ie.allPaths):ne,[]);return Q.length&&(G.allPaths=Q),G}function q(O,F,N){if(F===!1)return s;const V=c(O,N);if(V===s)return s;if(typeof F=="boolean")return V;if(F){const G=F.when;if(typeof G=="string"){const J=(Q,ne,ie,ce)=>{if(!ce||!V(Q,ne))return null;const ue=G.replace("$(basename)",ie),ge=ce(ue);return(0,U.isThenable)(ge)?ge.then(Ee=>Ee?O:null):ge?O:null};return J.requiresSiblings=!0,J}}return V}function D(O,F){const N=O.filter(ne=>!!ne.basenames);if(N.length<2)return O;const V=N.reduce((ne,ie)=>{const ce=ie.basenames;return ce?ne.concat(ce):ne},[]);let G;if(F){G=[];for(let ne=0,ie=V.length;ne<ie;ne++)G.push(F)}else G=N.reduce((ne,ie)=>{const ce=ie.patterns;return ce?ne.concat(ce):ne},[]);const J=function(ne,ie){if(typeof ne!="string")return null;if(!ie){let ue;for(ue=ne.length;ue>0;ue--){const ge=ne.charCodeAt(ue-1);if(ge===47||ge===92)break}ie=ne.substr(ue)}const ce=V.indexOf(ie);return ce!==-1?G[ce]:null};J.basenames=V,J.patterns=G,J.allBasenames=V;const Q=O.filter(ne=>!ne.basenames);return Q.push(J),Q}}),define(Z[90],ee([0,1,4]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(R){return R.toJSON()}class A{constructor(d){this._uriTransformer=d}transformIncoming(d){const y=this._uriTransformer.transformIncoming(d);return y===d?d:k(S.URI.from(y))}transformOutgoing(d){const y=this._uriTransformer.transformOutgoing(d);return y===d?d:k(S.URI.from(y))}transformOutgoingURI(d){const y=this._uriTransformer.transformOutgoing(d);return y===d?d:S.URI.from(y)}transformOutgoingScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function L(R,d,y){if(!R||y>200)return null;if(typeof R=="object"){if(R instanceof S.URI)return d.transformOutgoing(R);for(let I in R)if(Object.hasOwnProperty.call(R,I)){const o=L(R[I],d,y+1);o!==null&&(R[I]=o)}}return null}function U(R,d){const y=L(R,d,0);return y===null?R:y}e.transformOutgoingURIs=U;function T(R,d,y,I){if(!R||I>200)return null;if(typeof R=="object"){if(R.$mid===1)return y?S.URI.revive(d.transformIncoming(R)):d.transformIncoming(R);for(let o in R)if(Object.hasOwnProperty.call(R,o)){const C=T(R[o],d,y,I+1);C!==null&&(R[o]=C)}}return null}function f(R,d){const y=T(R,d,!1,0);return y===null?R:y}e.transformIncomingURIs=f;function v(R,d){const y=T(R,d,!0,0);return y===null?R:y}e.transformAndReviveIncomingURIs=v}),define(Z[31],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(f){return S.test(f)}e.isUUID=k;const A=new Uint8Array(16),L=[];for(let f=0;f<256;f++)L.push(f.toString(16).padStart(2,"0"));let U;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?U=crypto.getRandomValues.bind(crypto):U=function(f){for(let v=0;v<f.length;v++)f[v]=Math.floor(Math.random()*256);return f};function T(){U(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let f=0,v="";return v+=L[A[f++]],v+=L[A[f++]],v+=L[A[f++]],v+=L[A[f++]],v+="-",v+=L[A[f++]],v+=L[A[f++]],v+="-",v+=L[A[f++]],v+=L[A[f++]],v+="-",v+=L[A[f++]],v+=L[A[f++]],v+="-",v+=L[A[f++]],v+=L[A[f++]],v+=L[A[f++]],v+=L[A[f++]],v+=L[A[f++]],v+=L[A[f++]],v}e.generateUuid=T}),define(Z[66],ee([0,1,199]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class k{constructor(L="utf8"){this.stringDecoder=new S.StringDecoder(L),this.remaining=null}write(L){const U=[],T=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(T.length<1)return U;let f=0,v,R=f;for(;R<T.length;)if(v=T.charCodeAt(R),v===13||v===10){if(U.push(T.substring(f,R)),R++,R<T.length){const d=v;v=T.charCodeAt(R),(d===13&&v===10||d===10&&v===13)&&R++}f=R}else R++;return this.remaining=f<T.length?T.substr(f):null,U}end(){return this.remaining}}e.LineDecoder=k}),define(Z[91],ee([0,1,38]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const k=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(T){const f=T.replace(/\-/g,":").toLowerCase();return!k.has(f)}function L(){return new Promise(async(T,f)=>{const v=setTimeout(()=>f("Unable to retrieve mac address (timeout after 10s)"),1e4);try{T(await U())}catch(R){f(R)}finally{clearTimeout(v)}})}e.getMac=L;function U(){return new Promise((T,f)=>{try{const v=(0,S.networkInterfaces)();for(const[,R]of Object.entries(v))for(const d of R)if(A(d.mac))return T(d.mac);f("Unable to retrieve mac address (unexpected format)")}catch(v){f(v)}})}}),define(Z[92],ee([0,1,11,31,38,37,91]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(R){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(R)}value(){if(this._value===void 0){let R=0,d=0;const y=(0,A.networkInterfaces)();for(let I in y)if(Object.prototype.hasOwnProperty.call(y,I))for(const{mac:o,internal:C}of y[I])C||(d+=1,this._isVirtualMachineMacAdress(o.toUpperCase())&&(R+=1));this._value=d>0?R/d:0}return this._value}};let T;async function f(){return T||(T=(async()=>await v()||k.generateUuid())()),T}e.getMachineId=f;async function v(){try{const R=await new Promise((y,I)=>{K(["crypto"],y,I)}),d=await(0,U.getMac)();return R.createHash("sha256").update(d,"utf8").digest("hex")}catch(R){S.onUnexpectedError(R);return}}}),define(Z[23],ee([0,1,27,38,8,6,7,42,31,65,12,4]),function(K,e,S,k,A,L,U,T,f,v,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var y;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function I(W,$=y.UNLINK){if((0,T.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");return $===y.UNLINK?C(W):o(W)}e.rimraf=I;async function o(W){try{const $=(0,A.join)((0,k.tmpdir)(),(0,f.generateUuid)());try{await S.promises.rename(W,$)}catch(H){return C(W)}C($).catch(H=>{})}catch($){if($.code!=="ENOENT")throw $}}async function C(W){return S.promises.rmdir(W,{recursive:!0,maxRetries:3})}function b(W){if((0,T.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");S.rmdirSync(W,{recursive:!0})}e.rimrafSync=b;async function E(W,$){return r(await($?p(W):S.promises.readdir(W)))}e.readdir=E;async function p(W){try{return await S.promises.readdir(W,{withFileTypes:!0})}catch(q){console.warn("[node.js fs] readdir with filetypes failed with error: ",q)}const $=[],H=await E(W);for(const q of H){let D=!1,O=!1,F=!1;try{const N=await S.promises.lstat((0,A.join)(W,q));D=N.isFile(),O=N.isDirectory(),F=N.isSymbolicLink()}catch(N){console.warn("[node.js fs] unexpected error from lstat after readdir: ",N)}$.push({name:q,isFile:()=>D,isDirectory:()=>O,isSymbolicLink:()=>F})}return $}function m(W){return r(S.readdirSync(W))}e.readdirSync=m;function r(W){return W.map($=>typeof $=="string"?U.isMacintosh?(0,v.normalizeNFC)($):$:($.name=U.isMacintosh?(0,v.normalizeNFC)($.name):$.name,$))}async function n(W){const $=await E(W),H=[];for(const q of $)await i.existsDirectory((0,A.join)(W,q))&&H.push(q);return H}e.readDirsInDir=n;function t(W,$=1e3){return new Promise(H=>{let q=!1;const D=setInterval(()=>{q||(q=!0,S.access(W,O=>{q=!1,O&&(clearInterval(D),H(void 0))}))},$)})}e.whenDeleted=t;var i;(function(W){async function $(D){let O;try{if(O=await S.promises.lstat(D),!O.isSymbolicLink())return{stat:O}}catch(F){}try{return{stat:await S.promises.stat(D),symbolicLink:(O==null?void 0:O.isSymbolicLink())?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(U.isWindows&&F.code==="EACCES")try{return{stat:await S.promises.stat(await S.promises.readlink(D)),symbolicLink:{dangling:!1}}}catch(N){if(N.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw N}throw F}}W.stat=$;async function H(D){try{const{stat:O,symbolicLink:F}=await W.stat(D);return O.isFile()&&(F==null?void 0:F.dangling)!==!0}catch(O){}return!1}W.existsFile=H;async function q(D){try{const{stat:O,symbolicLink:F}=await W.stat(D);return O.isDirectory()&&(F==null?void 0:F.dangling)!==!0}catch(O){}return!1}W.existsDirectory=q})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new L.ResourceQueue;function c(W,$,H){return s.queueFor(d.URI.file(W),R.extUriBiasedIgnorePathCase).queue(()=>{const q=g(H);return new Promise((D,O)=>l(W,$,q,F=>F?O(F):D()))})}e.writeFile=c;let a=!0;function l(W,$,H,q){if(!a)return S.writeFile(W,$,{mode:H.mode,flag:H.flag},q);S.open(W,H.flag,H.mode,(D,O)=>{if(D)return q(D);S.writeFile(O,$,F=>{if(F)return S.close(O,()=>q(F));S.fdatasync(O,N=>(N&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",N),a=!1),S.close(O,V=>q(V))))})})}function h(W,$,H){const q=g(H);if(!a)return S.writeFileSync(W,$,{mode:q.mode,flag:q.flag});const D=S.openSync(W,q.flag,q.mode);try{S.writeFileSync(D,$);try{S.fdatasyncSync(D)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),a=!1}}finally{S.closeSync(D)}}e.writeFileSync=h;function g(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function w(W,$){if(W!==$){async function H(q){try{const D=await S.promises.lstat(q);if(D.isDirectory()||D.isSymbolicLink())return;const O=await S.promises.open(q,"a");try{await O.utimes(D.atime,new Date)}finally{await O.close()}}catch(D){}}try{await S.promises.rename(W,$),await H($)}catch(q){if(W.toLowerCase()!==$.toLowerCase()&&q.code==="EXDEV"||W.endsWith("."))await u(W,$,{preserveSymlinks:!1}),await I(W,y.MOVE),await H($);else throw q}}}e.move=w;async function u(W,$,H){return _(W,$,{root:{source:W,target:$},options:H,handledSourcePaths:new Set})}e.copy=u;const P=511;async function _(W,$,H){if(!H.handledSourcePaths.has(W)){H.handledSourcePaths.add(W);const{stat:q,symbolicLink:D}=await i.stat(W);if(D){if(H.options.preserveSymlinks)try{return await M(W,$,H)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(D.dangling)return}return q.isDirectory()?z(W,$,q.mode&P,H):B(W,$,q.mode&P)}}async function z(W,$,H,q){await S.promises.mkdir($,{recursive:!0,mode:H});const D=await E(W);for(const O of D)await _((0,A.join)(W,O),(0,A.join)($,O),q)}async function B(W,$,H){await S.promises.copyFile(W,$),await S.promises.chmod($,H)}async function M(W,$,H){let q=await S.promises.readlink(W);(0,T.isEqualOrParent)(q,H.root.source,!U.isLinux)&&(q=(0,A.join)(H.root.target,q.substr(H.root.source.length+1))),await S.promises.symlink(q,$)}async function j(W){try{return await S.promises.access(W),!0}catch($){return!1}}e.exists=j}),define(Z[93],ee([0,1,27,94,21,8,23]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function T(d){const y=(0,L.dirname)(d);if(d===y)return d;const I=((0,L.basename)(d)||d).toLowerCase();try{const C=(0,U.readdirSync)(y).filter(b=>b.toLowerCase()===I);if(C.length===1){const b=T(y);if(b)return(0,L.join)(b,C[0])}else if(C.length>1){const b=C.indexOf(I);if(b>=0){const E=T(y);if(E)return(0,L.join)(E,C[b])}}}catch(o){}return null}e.realcaseSync=T;async function f(d){try{return await(0,k.promisify)(S.realpath)(d)}catch(y){const I=R(d);return await S.promises.access(I,S.constants.R_OK),I}}e.realpath=f;function v(d){try{return S.realpathSync(d)}catch(y){const I=R(d);return S.accessSync(I,S.constants.R_OK),I}}e.realpathSync=v;function R(d){return(0,A.rtrim)((0,L.normalize)(d),L.sep)}}),define(Z[95],ee([0,1,48,16]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function A(U){return new Promise((T,f)=>{let v;const R=new Map;function d(o,C,b,E,p){const m=R.get(C);if(o===U||m){const r={name:y(b),cmd:b,pid:o,ppid:C,load:E,mem:p};R.set(o,r),o===U&&(v=r),m&&(m.children||(m.children=[]),m.children.push(r),m.children.length>1&&(m.children=m.children.sort((n,t)=>n.pid-t.pid)))}}function y(o){const C=/--disable-blink-features=Auxclick/,b=/\\watcher\\win32\\CodeHelper\.exe/,E=/--crashes-directory/,p=/\\pipe\\winpty-control/,m=/conhost\.exe/,r=/--type=([a-zA-Z-]+)/;if(b.exec(o))return"watcherService ";if(E.exec(o))return"electron-crash-reporter";if(p.exec(o))return"winpty-process";if(m.exec(o))return"console-window-host (Windows internal process)";let n=r.exec(o);if(n&&n.length===2)return n[1]==="renderer"?C.exec(o)?"shared-process":"window":n[1];const t=/[a-zA-Z-]+\.js/g;let i="";do n=t.exec(o),n&&(i+=n+" ");while(n);return i&&o.indexOf("node ")<0&&o.indexOf("node.exe")<0?`electron_node ${i}`:o}if(process.platform==="win32"){const o=C=>C.indexOf("\\\\?\\")===0||C.indexOf("\\??\\")===0?C.substr(4):C.indexOf('"\\\\?\\')===0||C.indexOf('"\\??\\')===0?'"'+C.substr(5):C;new Promise((C,b)=>{K(["windows-process-tree"],C,b)}).then(C=>{C.getProcessList(U,b=>{C.getProcessCpuUsage(b,E=>{const p=new Map;E.forEach(m=>{const r=o(m.commandLine||"");p.set(m.pid,{name:y(r),cmd:r,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),v=p.get(U),v?(p.forEach(m=>{const r=p.get(m.ppid);r&&(r.children||(r.children=[]),r.children.push(m))}),p.forEach(m=>{m.children&&(m.children=m.children.sort((r,n)=>r.pid-n.pid))}),T(v)):f(new Error(`Root process ${U} not found`))})},C.ProcessDataFlag.CommandLine|C.ProcessDataFlag.Memory)})}else{function I(){let o=[v];const C=[];for(;o.length;){const E=o.shift();E&&(C.push(E.pid),E.children&&(o=o.concat(E.children)))}let b=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);b+=" "+C.join(" "),(0,S.exec)(b,{},(E,p,m)=>{if(E||m)f(E||new Error(m.toString()));else{const r=p.toString().split(`
`);for(let n=0;n<C.length;n++){const t=R.get(C[n]);t.load=parseFloat(r[n])}if(!v){f(new Error(`Root process ${U} not found`));return}T(v)}})}(0,S.exec)("which ps",{},(o,C,b)=>{if(o||b)if(process.platform!=="linux")f(o||new Error(b.toString()));else{const E=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,S.exec)(E,{},(p,m,r)=>{p||r?f(p||new Error(r.toString())):(L(m,d),I())})}else{const E=C.toString().trim(),p="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${E} ${p}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,r,n)=>{m||n&&!n.includes("screen size is bogus")?f(m||new Error(n.toString())):(L(r,d),process.platform==="linux"?I():v?T(v):f(new Error(`Root process ${U} not found`)))})}})}})}e.listProcesses=A;function L(U,T){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,v=U.toString().split(`
`);for(const R of v){const d=f.exec(R.trim());d&&d.length===6&&T(parseInt(d[1]),parseInt(d[2]),d[5],parseFloat(d[3]),parseFloat(d[4]))}}}),define(Z[96],ee([0,1,8,27,7,65,2,23]),function(K,e,S,k,A,L,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function f(d,y,I){return R({path:d,isDirectory:!1},y,I)}e.watchFile=f;function v(d,y,I){return R({path:d,isDirectory:!0},y,I)}e.watchFolder=v,e.CHANGE_BUFFER_DELAY=100;function R(d,y,I){const o=(0,S.basename)(d.path),C=new Map;let b=!1,E=[(0,U.toDisposable)(()=>{C.forEach(p=>(0,U.dispose)(p)),C.clear()})];try{const p=(0,k.watch)(d.path);E.push((0,U.toDisposable)(()=>{p.removeAllListeners(),p.close()}));const m=new Set;d.isDirectory&&(0,T.readdir)(d.path).then(r=>r.forEach(n=>m.add(n))),p.on("error",(r,n)=>{b||I(`Failed to watch ${d.path} for changes using fs.watch() (${r}, ${n})`)}),p.on("change",(r,n)=>{if(!b){let t="";if(n&&(t=n.toString(),A.isMacintosh&&(t=(0,L.normalizeNFC)(t))),!(!t||r!=="change"&&r!=="rename")){const i=d.isDirectory?(0,S.join)(d.path,t):d.path;if(d.isDirectory)if(r==="rename"){const s=C.get(i);s&&(0,U.dispose)(s);const c=setTimeout(async()=>{C.delete(i);const a=await(0,T.exists)(i);if(!b){let l;a?m.has(t)?l="changed":(l="added",m.add(t)):(m.delete(t),l="deleted"),y(l,i)}},e.CHANGE_BUFFER_DELAY);C.set(i,(0,U.toDisposable)(()=>clearTimeout(c)))}else{let s;m.has(t)?s="changed":(s="added",m.add(t)),y(s,i)}else if(r==="rename"||t!==o){const s=setTimeout(async()=>{const c=await(0,T.exists)(i);b||(c?(y("changed",i),E=[R(d,y,I)]):y("deleted",i))},e.CHANGE_BUFFER_DELAY);(0,U.dispose)(E),E=[(0,U.toDisposable)(()=>clearTimeout(s))]}else y("changed",i)}}})}catch(p){(0,T.exists)(d.path).then(m=>{m&&!b&&I(`Failed to watch ${d.path} for changes using fs.watch() (${p.toString()})`)})}return(0,U.toDisposable)(()=>{b=!0,E=(0,U.dispose)(E)})}}),define(Z[34],ee([0,1,3,2,6,30,11,22,18,15,88,21]),function(K,e,S,k,A,L,U,T,f,v,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function I(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var o;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(o=e.ResponseType||(e.ResponseType={}));function C(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(b||(b={}));class E{constructor(D){this.buffer=D,this.pos=0}read(D){const O=this.buffer.slice(this.pos,this.pos+D);return this.pos+=O.byteLength,O}}class p{constructor(){this.buffers=[]}get buffer(){return T.VSBuffer.concat(this.buffers)}write(D){this.buffers.push(D)}}var m;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(m||(m={}));function r(q){const D=T.VSBuffer.alloc(4);return D.writeUInt32BE(q,0),D}function n(q){return q.read(4).readUInt32BE(0)}function t(q){const D=T.VSBuffer.alloc(1);return D.writeUInt8(q,0),D}const i={Undefined:t(m.Undefined),String:t(m.String),Buffer:t(m.Buffer),VSBuffer:t(m.VSBuffer),Array:t(m.Array),Object:t(m.Object)},s=typeof Buffer!="undefined";function c(q,D){if(typeof D=="undefined")q.write(i.Undefined);else if(typeof D=="string"){const O=T.VSBuffer.fromString(D);q.write(i.String),q.write(r(O.byteLength)),q.write(O)}else if(s&&Buffer.isBuffer(D)){const O=T.VSBuffer.wrap(D);q.write(i.Buffer),q.write(r(O.byteLength)),q.write(O)}else if(D instanceof T.VSBuffer)q.write(i.VSBuffer),q.write(r(D.byteLength)),q.write(D);else if(Array.isArray(D)){q.write(i.Array),q.write(r(D.length));for(const O of D)c(q,O)}else{const O=T.VSBuffer.fromString(JSON.stringify(D));q.write(i.Object),q.write(r(O.byteLength)),q.write(O)}}function a(q){switch(q.read(1).readUInt8(0)){case m.Undefined:return;case m.String:return q.read(n(q)).toString();case m.Buffer:return q.read(n(q)).buffer;case m.VSBuffer:return q.read(n(q));case m.Array:{const O=n(q),F=[];for(let N=0;N<O;N++)F.push(a(q));return F}case m.Object:return JSON.parse(q.read(n(q)).toString())}}class l{constructor(D,O,F=null,N=1e3){this.protocol=D,this.ctx=O,this.logger=F,this.timeoutDelay=N,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(V=>this.onRawMessage(V)),this.sendResponse({type:200})}registerChannel(D,O){this.channels.set(D,O),setTimeout(()=>this.flushPendingRequests(D),0)}sendResponse(D){switch(D.type){case 200:{const O=this.send([D.type]);this.logger&&this.logger.logOutgoing(O,0,1,C(D.type));return}case 201:case 202:case 204:case 203:{const O=this.send([D.type,D.id],D.data);this.logger&&this.logger.logOutgoing(O,D.id,1,C(D.type),D.data);return}}}send(D,O=void 0){const F=new p;return c(F,D),c(F,O),this.sendBuffer(F.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(O){return 0}}onRawMessage(D){const O=new E(D),F=a(O),N=a(O),V=F[0];switch(V){case 100:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${I(V)}: ${F[2]}.${F[3]}`,N),this.onPromise({type:V,id:F[1],channelName:F[2],name:F[3],arg:N});case 102:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${I(V)}: ${F[2]}.${F[3]}`,N),this.onEventListen({type:V,id:F[1],channelName:F[2],name:F[3],arg:N});case 101:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${I(V)}`),this.disposeActiveRequest({type:V,id:F[1]});case 103:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],1,`${I(V)}`),this.disposeActiveRequest({type:V,id:F[1]})}}onPromise(D){const O=this.channels.get(D.channelName);if(!O){this.collectPendingRequest(D);return}const F=new L.CancellationTokenSource;let N;try{N=O.call(this.ctx,D.name,D.arg,F.token)}catch(J){N=Promise.reject(J)}const V=D.id;N.then(J=>{this.sendResponse({id:V,data:J,type:201}),this.activeRequests.delete(D.id)},J=>{J instanceof Error?this.sendResponse({id:V,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.sendResponse({id:V,data:J,type:203}),this.activeRequests.delete(D.id)});const G=(0,k.toDisposable)(()=>F.cancel());this.activeRequests.set(D.id,G)}onEventListen(D){const O=this.channels.get(D.channelName);if(!O){this.collectPendingRequest(D);return}const F=D.id,V=O.listen(this.ctx,D.name,D.arg)(G=>this.sendResponse({id:F,data:G,type:204}));this.activeRequests.set(D.id,V)}disposeActiveRequest(D){const O=this.activeRequests.get(D.id);O&&(O.dispose(),this.activeRequests.delete(D.id))}collectPendingRequest(D){let O=this.pendingRequests.get(D.channelName);O||(O=[],this.pendingRequests.set(D.channelName,O));const F=setTimeout(()=>{console.error(`Unknown channel: ${D.channelName}`),D.type===100&&this.sendResponse({id:D.id,data:{name:"Unknown channel",message:`Channel name '${D.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:D,timeoutTimer:F})}flushPendingRequests(D){const O=this.pendingRequests.get(D);if(O){for(const F of O)switch(clearTimeout(F.timeoutTimer),F.request.type){case 100:this.onPromise(F.request);break;case 102:this.onEventListen(F.request);break}this.pendingRequests.delete(D)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var h;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class g{constructor(D,O=null){this.protocol=D,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(F=>this.onBuffer(F)),this.logger=O}getChannel(D){const O=this;return{call(F,N,V){return O.isDisposed?Promise.reject(U.canceled()):O.requestPromise(D,F,N,V)},listen(F,N){return O.isDisposed?Promise.reject(U.canceled()):O.requestEvent(D,F,N)}}}requestPromise(D,O,F,N=L.CancellationToken.None){const V=this.lastRequestId++,J={id:V,type:100,channelName:D,name:O,arg:F};if(N.isCancellationRequested)return Promise.reject(U.canceled());let Q;return new Promise((ie,ce)=>{if(N.isCancellationRequested)return ce(U.canceled());const ue=()=>{const Te=Ae=>{switch(Ae.type){case 201:this.handlers.delete(V),ie(Ae.data);break;case 202:this.handlers.delete(V);const Ue=new Error(Ae.data.message);Ue.stack=Ae.data.stack,Ue.name=Ae.data.name,ce(Ue);break;case 203:this.handlers.delete(V),ce(Ae.data);break}};this.handlers.set(V,Te),this.sendRequest(J)};let ge=null;this.state===b.Idle?ue():(ge=(0,A.createCancelablePromise)(Te=>this.whenInitialized()),ge.then(()=>{ge=null,ue()}));const Ee=()=>{ge?(ge.cancel(),ge=null):this.sendRequest({id:V,type:101}),ce(U.canceled())},Ie=N.onCancellationRequested(Ee);Q=(0,k.combinedDisposable)((0,k.toDisposable)(Ee),Ie),this.activeRequests.add(Q)}).finally(()=>{this.activeRequests.delete(Q)})}requestEvent(D,O,F){const N=this.lastRequestId++,G={id:N,type:102,channelName:D,name:O,arg:F};let J=null;const Q=new S.Emitter({onFirstListenerAdd:()=>{J=(0,A.createCancelablePromise)(ie=>this.whenInitialized()),J.then(()=>{J=null,this.activeRequests.add(Q),this.sendRequest(G)})},onLastListenerRemove:()=>{J?(J.cancel(),J=null):(this.activeRequests.delete(Q),this.sendRequest({id:N,type:103}))}}),ne=ie=>Q.fire(ie.data);return this.handlers.set(N,ne),Q.event}sendRequest(D){switch(D.type){case 100:case 102:{const O=this.send([D.type,D.id,D.channelName,D.name],D.arg);this.logger&&this.logger.logOutgoing(O,D.id,0,`${I(D.type)}: ${D.channelName}.${D.name}`,D.arg);return}case 101:case 103:{const O=this.send([D.type,D.id]);this.logger&&this.logger.logOutgoing(O,D.id,0,I(D.type));return}}}send(D,O=void 0){const F=new p;return c(F,D),c(F,O),this.sendBuffer(F.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(O){return 0}}onBuffer(D){const O=new E(D),F=a(O),N=a(O),V=F[0];switch(V){case 200:return this.logger&&this.logger.logIncoming(D.byteLength,0,0,C(V)),this.onResponse({type:F[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(D.byteLength,F[1],0,C(V),N),this.onResponse({type:F[0],id:F[1],data:N})}}onResponse(D){if(D.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(D.id);O&&O(D)}whenInitialized(){return this.state===b.Idle?Promise.resolve():S.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}e.ChannelClient=g;class w{constructor(D){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,D(({protocol:O,onDidClientDisconnect:F})=>{S.Event.once(O.onMessage)(V=>{const G=new E(V),J=a(G),Q=new l(O,J),ne=new g(O);this.channels.forEach((ce,ue)=>Q.registerChannel(ue,ce));const ie={channelServer:Q,channelClient:ne,ctx:J};this._connections.add(ie),this._onDidAddConnection.fire(ie),F(()=>{Q.dispose(),ne.dispose(),this._connections.delete(ie),this._onDidRemoveConnection.fire(ie)})})})}get connections(){const D=[];return this._connections.forEach(O=>D.push(O)),D}getChannel(D,O){const F=this;return{call(N,V,G){let J;if((0,v.isFunction)(O)){let ne=(0,f.getRandomElement)(F.connections.filter(O));J=ne?Promise.resolve(ne):S.Event.toPromise(S.Event.filter(F.onDidAddConnection,O))}else J=O.routeCall(F,N,V);const Q=J.then(ne=>ne.channelClient.getChannel(D));return P(Q).call(N,V,G)},listen(N,V){if((0,v.isFunction)(O))return F.getMulticastEvent(D,O,N,V);const G=O.routeEvent(F,N,V).then(J=>J.channelClient.getChannel(D));return P(G).listen(N,V)}}}getMulticastEvent(D,O,F,N){const V=this;let G=new k.DisposableStore;const J=new S.Emitter({onFirstListenerAdd:()=>{G=new k.DisposableStore;const Q=new S.EventMultiplexer,ne=new Map,ie=ue=>{const Ee=ue.channelClient.getChannel(D).listen(F,N),Ie=Q.add(Ee);ne.set(ue,Ie)},ce=ue=>{const ge=ne.get(ue);!ge||(ge.dispose(),ne.delete(ue))};V.connections.filter(O).forEach(ie),S.Event.filter(V.onDidAddConnection,O)(ie,void 0,G),V.onDidRemoveConnection(ce,void 0,G),Q.event(J.fire,J,G),G.add(Q)},onLastListenerRemove:()=>{G.dispose()}});return J.event}registerChannel(D,O){this.channels.set(D,O),this._connections.forEach(F=>{F.channelServer.registerChannel(D,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=w;class u{constructor(D,O,F=null){const N=new p;c(N,O),D.send(N.buffer),this.channelClient=new g(D,F),this.channelServer=new l(D,O,F)}getChannel(D){return this.channelClient.getChannel(D)}registerChannel(D,O){this.channelServer.registerChannel(D,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=u;function P(q){return{call(D,O,F){return q.then(N=>N.call(D,O,F))},listen(D,O){const F=new S.Relay;return q.then(N=>F.input=N.listen(D,O)),F.event}}}e.getDelayedChannel=P;function _(q){let D=!1;return{call(O,F,N){return D?q.call(O,F,N):(0,A.timeout)(0).then(()=>D=!0).then(()=>q.call(O,F,N))},listen(O,F){if(D)return q.listen(O,F);const N=new S.Relay;return(0,A.timeout)(0).then(()=>D=!0).then(()=>N.input=q.listen(O,F)),N.event}}}e.getNextTickChannel=_;class z{constructor(D){this.fn=D}routeCall(D){return this.route(D)}routeEvent(D){return this.route(D)}async route(D){for(const O of D.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await S.Event.toPromise(D.onDidAddConnection),await this.route(D)}}e.StaticRouter=z;var B;(function(q){function D(N,V){const G=N,J=V&&V.disableMarshalling,Q=new Map;for(const ne in G)F(ne)&&Q.set(ne,S.Event.buffer(G[ne],!0));return new class{listen(ne,ie){const ce=Q.get(ie);if(ce)return ce;throw new Error(`Event not found: ${ie}`)}call(ne,ie,ce){const ue=G[ie];if(typeof ue=="function"){if(!J&&Array.isArray(ce))for(let ge=0;ge<ce.length;ge++)ce[ge]=(0,R.revive)(ce[ge]);return ue.apply(G,ce)}throw new Error(`Method not found: ${ie}`)}}}q.fromService=D;function O(N,V){const G=V&&V.disableMarshalling;return new Proxy({},{get(J,Q){var ne;if(typeof Q=="string")return((ne=V==null?void 0:V.properties)===null||ne===void 0?void 0:ne.has(Q))?V.properties.get(Q):F(Q)?N.listen(Q):async function(...ie){let ce;V&&!(0,v.isUndefinedOrNull)(V.context)?ce=[V.context,...ie]:ce=ie;const ue=await N.call(Q,ce);return G?ue:(0,R.revive)(ue)};throw new Error(`Property not found: ${String(Q)}`)}})}q.toService=O;function F(N){return N[0]==="o"&&N[1]==="n"&&d.isUpperAsciiLetter(N.charCodeAt(2))}})(B=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){let D=q.toString();if(D!=="[object Object]")return D}return q}function W(q){return Array.isArray(q)?q.map(j):j(q)}function $(q,D,O,F,N,V,G){G=W(G);const J=M[N],Q=J[F%J.length];let ne=[`%c[${q}]%c[${String(D).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(F).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${Q}`];/\($/.test(V)?(ne=ne.concat(G),ne.push(")")):ne.push(G),console.log.apply(console,ne)}e.logWithColors=$;class H{constructor(D,O){this._outgoingPrefix=D,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(D,O,F,N,V){this._totalOutgoing+=D,$(this._outgoingPrefix,this._totalOutgoing,D,O,F,N,V)}logIncoming(D,O,F,N,V){this._totalIncoming+=D,$(this._incomingPrefix,this._totalIncoming,D,O,F,N,V)}}e.IPCLogger=H}),define(Z[97],ee([0,1,3,34,22]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(f){this.port=f,this.onMessage=S.Event.fromDOMEventEmitter(this.port,"message",v=>A.VSBuffer.wrap(v.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class U extends k.IPCClient{constructor(f,v){const R=new L(f);super(R,v);this.protocol=R}dispose(){this.protocol.disconnect()}}e.Client=U}),define(Z[98],ee([0,1,99,3,34,97]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class U extends A.IPCServer{static getOnDidClientConnect(){const f=k.Event.fromNodeEventEmitter(S.ipcRenderer,"vscode:createMessageChannel",(v,R)=>R);return k.Event.map(f,v=>{const{port1:R,port2:d}=new MessageChannel,I={protocol:new L.Protocol(R),onDidClientDisconnect:k.Event.fromDOMEventEmitter(R,"close")};return S.ipcRenderer.postMessage("vscode:createMessageChannelResult",v,[d]),I})}constructor(){super(U.getOnDidClientConnect())}}e.Server=U}),define(Z[100],ee([0,1,11,22]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function A(T,f){T.proxyAuthorization&&(T.headers=Object.assign(Object.assign({},T.headers||{}),{"Proxy-Authorization":T.proxyAuthorization}));const v=new XMLHttpRequest;return new Promise((R,d)=>{v.open(T.type||"GET",T.url||"",!0,T.user,T.password),L(v,T),v.responseType="arraybuffer",v.onerror=y=>d(new Error(v.statusText&&"XHR failed: "+v.statusText||"XHR failed")),v.onload=y=>{R({res:{statusCode:v.status,headers:U(v)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(v.response)))})},v.ontimeout=y=>d(new Error(`XHR timeout: ${T.timeout}ms`)),T.timeout&&(v.timeout=T.timeout),v.send(T.data),f.onCancellationRequested(()=>{v.abort(),d((0,S.canceled)())})})}e.request=A;function L(T,f){if(f.headers){e:for(let v in f.headers){switch(v){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}T.setRequestHeader(v,f.headers[v])}}}function U(T){const f=Object.create(null);for(const v of T.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(v){const R=v.indexOf(":");f[v.substr(0,R).trim().toLowerCase()]=v.substr(R+1).trim()}return f}}),define(Z[67],ee([0,1,2,3,6,15]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var U;(function(R){R[R.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(U=e.StorageHint||(e.StorageHint={}));var T;(function(R){R[R.None=0]="None",R[R.Initialized=1]="Initialized",R[R.Closed=2]="Closed"})(T||(T={}));class f extends S.Disposable{constructor(d,y=Object.create(null)){super();this.database=d,this.options=y,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=T.None,this.cache=new Map,this.flushDelayer=new A.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){var y,I;(y=d.changed)===null||y===void 0||y.forEach((o,C)=>this.accept(C,o)),(I=d.deleted)===null||I===void 0||I.forEach(o=>this.accept(o,void 0))}accept(d,y){if(this.state!==T.Closed){let I=!1;(0,L.isUndefinedOrNull)(y)?I=this.cache.delete(d):this.cache.get(d)!==y&&(this.cache.set(d,y),I=!0),I&&this._onDidChangeStorage.fire(d)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===T.None&&(this.state=T.Initialized,this.options.hint!==U.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,y){const I=this.cache.get(d);return(0,L.isUndefinedOrNull)(I)?y:I}getBoolean(d,y){const I=this.get(d);return(0,L.isUndefinedOrNull)(I)?y:I==="true"}getNumber(d,y){const I=this.get(d);return(0,L.isUndefinedOrNull)(I)?y:parseInt(I,10)}async set(d,y){if(this.state!==T.Closed){if((0,L.isUndefinedOrNull)(y))return this.delete(d);const I=String(y);if(this.cache.get(d)!==I)return this.cache.set(d,I),this.pendingInserts.set(d,I),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(d){if(this.state!==T.Closed&&!!this.cache.delete(d))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=T.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(d){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{var y;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(y=this.whenFlushedCallbacks.pop())===null||y===void 0||y()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class v{constructor(){this.onDidChangeItemsExternal=k.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((y,I)=>this.items.set(I,y)),d.delete&&d.delete.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=v}),define(Z[101],ee([13,14]),function(K,e){return K.create("vs/base/common/date",e)}),define(Z[53],ee([0,1,101]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,A=k*60,L=A*24,U=L*7,T=L*30,f=L*365;function v(d,y){typeof d!="number"&&(d=d.getTime());const I=Math.round((new Date().getTime()-d)/1e3);if(I<-30)return(0,S.localize)(0,null,v(new Date().getTime()+I*1e3,!1));if(I<30)return(0,S.localize)(1,null);let o;return I<k?(o=I,y?o===1?(0,S.localize)(2,null,o):(0,S.localize)(3,null,o):o===1?(0,S.localize)(4,null,o):(0,S.localize)(5,null,o)):I<A?(o=Math.floor(I/k),y?o===1?(0,S.localize)(6,null,o):(0,S.localize)(7,null,o):o===1?(0,S.localize)(8,null,o):(0,S.localize)(9,null,o)):I<L?(o=Math.floor(I/A),y?o===1?(0,S.localize)(10,null,o):(0,S.localize)(11,null,o):o===1?(0,S.localize)(12,null,o):(0,S.localize)(13,null,o)):I<U?(o=Math.floor(I/L),y?o===1?(0,S.localize)(14,null,o):(0,S.localize)(15,null,o):o===1?(0,S.localize)(16,null,o):(0,S.localize)(17,null,o)):I<T?(o=Math.floor(I/U),y?o===1?(0,S.localize)(18,null,o):(0,S.localize)(19,null,o):o===1?(0,S.localize)(20,null,o):(0,S.localize)(21,null,o)):I<f?(o=Math.floor(I/T),y?o===1?(0,S.localize)(22,null,o):(0,S.localize)(23,null,o):o===1?(0,S.localize)(24,null,o):(0,S.localize)(25,null,o)):(o=Math.floor(I/f),y?o===1?(0,S.localize)(26,null,o):(0,S.localize)(27,null,o):o===1?(0,S.localize)(28,null,o):(0,S.localize)(29,null,o))}e.fromNow=v;function R(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Z[102],ee([13,14]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(Z[43],ee([0,1,102,15,18]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function L(v,R){return R&&(v.stack||v.stacktrace)?S.localize(0,null,T(v),U(v.stack)||U(v.stacktrace)):T(v)}function U(v){return Array.isArray(v)?v.join(`
`):v}function T(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?S.localize(1,null,v.message):v.message||S.localize(2,null)}function f(v=null,R=!1){if(!v)return S.localize(3,null);if(Array.isArray(v)){const d=A.coalesce(v),y=f(d[0],R);return d.length>1?S.localize(4,null,y,d.length):y}if(k.isString(v))return v;if(v.detail){const d=v.detail;if(d.error)return L(d.error,R);if(d.exception)return L(d.exception,R)}return v.stack?L(v,R):v.message?v.message:S.localize(5,null)}e.toErrorMessage=f}),define(Z[103],ee([13,14]),function(K,e){return K.create("vs/base/node/processes",e)}),define(Z[104],ee([0,1,8,27,23,48,103,36,15,26,42,7,66,16]),function(K,e,S,k,A,L,U,T,f,v,R,d,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function o(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function C(n,t){if(d.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};t&&(i.cwd=t);const s=L.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],i);return new Promise(c=>{s.once("error",a=>{c({success:!1,error:a})}),s.once("exit",(a,l)=>{c(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?o(i.status):1})}else if(d.isLinux||d.isMacintosh)try{const i=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(s=>{L.execFile(i,[n.pid.toString()],{encoding:"utf8",shell:!0},(c,a,l)=>{s(c?{success:!1,error:c}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function b(n=T.env){return n.comspec||"cmd.exe"}e.getWindowsShell=b;class E{constructor(t,i,s,c){if(i!==void 0&&s!==void 0&&c!==void 0)this.cmd=t,this.args=i,this.shell=s,this.options=c;else{const a=t;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(T.env).forEach(l=>{a[l]=T.env[l]}),Object.keys(this.options.env).forEach(l=>{a[l]=this.options.env[l]}),this.options.env=a}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const i=t.lastIndexOf(S.sep);return i!==-1&&(t=t.substring(i+1)),E.WellKnowCommands[t]?t:"other"}start(t){return d.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(T.cwd()))?Promise.reject(new Error(U.localize(0,null))):this.useExec().then(i=>{let s,c;const a=new Promise((l,h)=>{s=l,c=h});if(i){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=L.exec(l,this.options,(h,g,w)=>{this.childProcess=null;const u=h;u&&u.killed?c({killed:this.terminateRequested,stdout:g.toString(),stderr:w.toString()}):this.handleExec(s,t,h,g,w)})}else{let l=null;const h=g=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(g,s,t,c);const w={terminated:this.terminateRequested};f.isNumber(g)&&(w.cmdCode=g),s(w)};if(this.shell&&d.isWindows){const g=v.deepClone(this.options);g.windowsVerbatimArguments=!0,g.detached=!1;let w=!1,u=!1;const P=[];let _=this.ensureQuotes(this.cmd);P.push(_.value),w=_.quoted,this.args&&this.args.forEach(B=>{_=this.ensureQuotes(B),P.push(_.value),u=u&&_.quoted});const z=["/s","/c"];w?u?z.push('"'+P.join(" ")+'"'):P.length>1?z.push('"'+P[0]+'" '+P.slice(1).join(" ")):z.push('"'+P[0]+'"'):z.push(P.join(" ")),l=L.spawn(b(),z,g)}else this.cmd&&(l=L.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(f.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",g=>{this.childProcess=null,c({terminated:this.terminateRequested,error:g})}),l.pid&&(this.childProcess.on("close",h),this.handleSpawn(l,s,t,c,!0)))}return a})}handleClose(t,i,s,c){}ensureQuotes(t){return E.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,C(t,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!d.isWindows)return t(!1);const i=L.spawn(b(),["/s","/c"]);i.on("error",s=>t(!0)),i.on("exit",s=>t(!1))})}}e.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class p extends E{constructor(t,i,s,c){super(t,i,s,c);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,i,s,c,a){[c,a].forEach((l,h)=>{const g=new y.LineDecoder;g.write(l).forEach(P=>{i({line:P,source:h===0?0:1})});const u=g.end();u&&i({line:u,source:h===0?0:1})}),t({terminated:this.terminateRequested,error:s})}handleSpawn(t,i,s,c,a){const l=new y.LineDecoder,h=new y.LineDecoder;t.stdout.on("data",g=>{l.write(g).forEach(u=>s({line:u,source:0}))}),t.stderr.on("data",g=>{h.write(g).forEach(u=>s({line:u,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=h}handleClose(t,i,s,c){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&s({line:a,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&s({line:l,source:1})}}e.LineProcess=p;function m(n){let t=[],i=!1;const s=function(c){if(i){t.push(c);return}(!n.send(c,l=>{if(l&&console.error(l),i=!1,t.length>0){const h=t.slice(0);t=[],h.forEach(g=>s(g))}})||d.isWindows)&&(i=!0)};return{send:s}}e.createQueuedSender=m;var r;(function(n){async function t(i,s,c){if(S.isAbsolute(i))return i;if(s===void 0&&(s=T.cwd()),S.dirname(i)!=="."||(c===void 0&&f.isString(T.env.PATH)&&(c=T.env.PATH.split(S.delimiter)),c===void 0||c.length===0))return S.join(s,i);async function l(h){return await A.exists(h)?!(await k.promises.stat(h)).isDirectory():!1}for(let h of c){let g;if(S.isAbsolute(h)?g=S.join(h,i):g=S.join(s,h,i),await l(g))return g;let w=g+".com";if(await l(w)||(w=g+".exe",await l(w)))return w}return S.join(s,i)}n.findExecutable=t})(r=e.win32||(e.win32={}))}),define(Z[49],ee([0,1,48,2,6,26,3,104,34,87,30,11,22,7]),function(K,e,S,k,A,L,U,T,f,v,R,d,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class o extends f.ChannelServer{constructor(E){super({send:p=>{try{process.send&&process.send(p.buffer.toString("base64"))}catch(m){}},onMessage:U.Event.fromNodeEventEmitter(process,"message",p=>y.VSBuffer.wrap(Buffer.from(p,"base64")))},E);process.once("disconnect",()=>this.dispose())}}e.Server=o;class C{constructor(E,p){this.modulePath=E,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new U.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const m=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new A.Delayer(m),this.child=null,this._client=null}getChannel(E){const p=this;return{call(m,r,n){return p.requestPromise(E,m,r,n)},listen(m,r){return p.requestEvent(E,m,r)}}}requestPromise(E,p,m,r=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(d.canceled());this.disposeDelayer.cancel();const n=this.getCachedChannel(E),t=(0,A.createCancelablePromise)(c=>n.call(p,m,c)),i=r.onCancellationRequested(()=>t.cancel()),s=(0,k.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{i.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(E,p,m){if(!this.disposeDelayer)return U.Event.None;this.disposeDelayer.cancel();let r;const n=new U.Emitter({onFirstListenerAdd:()=>{r=this.getCachedChannel(E).listen(p,m)(n.fire,n),this.activeRequests.add(r)},onLastListenerRemove:()=>{this.activeRequests.delete(r),r.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return n.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env=Object.assign(Object.assign({},(0,L.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(p.env=Object.assign(Object.assign({},p.env),this.options.env)),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),I.isMacintosh&&p.env&&delete p.env.DYLD_LIBRARY_PATH,this.child=(0,S.fork)(this.modulePath,E,p);const m=new U.Emitter;U.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,v.isRemoteConsoleLog)(a)){(0,v.log)(a,`IPC Library: ${this.options.serverName}`);return}m.fire(y.VSBuffer.wrap(Buffer.from(a,"base64")))});const n=this.options.useQueue?(0,T.createQueuedSender)(this.child):this.child,t=a=>this.child&&this.child.connected&&n.send(a.buffer.toString("base64")),i=m.event,s={send:t,onMessage:i};this._client=new f.ChannelClient(s);const c=()=>this.disposeClient();process.once("exit",c),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,l)=>{process.removeListener("exit",c),this.activeRequests.forEach(h=>(0,k.dispose)(h)),this.activeRequests.clear(),a!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:l})})}return this._client}getCachedChannel(E){let p=this.channels.get(E);return p||(p=this.client.getChannel(E),this.channels.set(E,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=C}),define(Z[105],ee([13,14]),function(K,e){return K.create("vs/base/node/zip",e)}),define(Z[106],ee([13,14]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[107],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[108],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[109],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[110],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[111],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[112],ee([13,14]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[113],ee([13,14]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(Z[114],ee([13,14]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(Z[115],ee([13,14]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(Z[116],ee([13,14]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[117],ee([13,14]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(Z[118],ee([13,14]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[119],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[120],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[121],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[122],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[123],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[124],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)});var he=this&&this.__decorate||function(K,e,S,k){var A=arguments.length,L=A<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,S):k,U;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(K,e,S,k);else for(var T=K.length-1;T>=0;T--)(U=K[T])&&(L=(A<3?U(L):A>3?U(e,S,L):U(e,S))||L);return A>3&&L&&Object.defineProperty(e,S,L),L};define(Z[125],ee([0,1,8,12,85,53,16,4,36]),function(K,e,S,k,A,L,U,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class v{constructor(o,C,b){this._args=o,this.paths=C,this.productService=b}get appRoot(){return(0,S.dirname)(U.FileAccess.asFileUri("",K).fsPath)}get userHome(){return T.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return T.URI.file((0,S.join)(this.userDataPath,"User"))}get tmpDir(){return T.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,k.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const o=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,S.join)(this.userDataPath,"logs",o)}return this.args.logsPath}get userDataSyncLogResource(){return T.URI.file((0,S.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(T.URI.file((0,S.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return T.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return T.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const o=f.env.VSCODE_PORTABLE;return o?T.URI.file((0,S.join)(o,"argv.json")):(0,k.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,k.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return T.URI.file((0,S.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,S.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const o=this.args["builtin-extensions-dir"];return o?(0,S.resolve)(o):(0,S.normalize)((0,S.join)(U.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const o=this.args["extensions-download-dir"];return o?(0,S.resolve)(o):(0,S.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const o=this.args["extensions-dir"];if(o)return(0,S.resolve)(o);const C=f.env.VSCODE_EXTENSIONS;if(C)return C;const b=f.env.VSCODE_PORTABLE;return b?(0,S.join)(b,"extensions"):(0,k.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const o=this.args.extensionDevelopmentPath;if(Array.isArray(o))return o.map(C=>/^[^:/?#]+?:\/\//.test(C)?T.URI.parse(C):T.URI.file((0,S.normalize)(C)))}get extensionDevelopmentKind(){var o;return(o=this.args.extensionDevelopmentKind)===null||o===void 0?void 0:o.map(C=>C==="ui"||C==="workspace"||C==="web"?C:"workspace")}get extensionTestsLocationURI(){const o=this.args.extensionTestsPath;if(o)return/^[^:/?#]+?:\/\//.test(o)?T.URI.parse(o):T.URI.file((0,S.normalize)(o))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const o=this.args["disable-extension"];if(o){if(typeof o=="string")return[o];if(Array.isArray(o)&&o.length>0)return o}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!f.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,k.joinPath)(T.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return T.URI.file((0,S.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}he([A.memoize],v.prototype,"appRoot",null),he([A.memoize],v.prototype,"userHome",null),he([A.memoize],v.prototype,"userDataPath",null),he([A.memoize],v.prototype,"appSettingsHome",null),he([A.memoize],v.prototype,"tmpDir",null),he([A.memoize],v.prototype,"userRoamingDataHome",null),he([A.memoize],v.prototype,"settingsResource",null),he([A.memoize],v.prototype,"userDataSyncHome",null),he([A.memoize],v.prototype,"userDataSyncLogResource",null),he([A.memoize],v.prototype,"sync",null),he([A.memoize],v.prototype,"machineSettingsResource",null),he([A.memoize],v.prototype,"globalStorageHome",null),he([A.memoize],v.prototype,"workspaceStorageHome",null),he([A.memoize],v.prototype,"keybindingsResource",null),he([A.memoize],v.prototype,"keyboardLayoutResource",null),he([A.memoize],v.prototype,"argvResource",null),he([A.memoize],v.prototype,"snippetsHome",null),he([A.memoize],v.prototype,"isExtensionDevelopment",null),he([A.memoize],v.prototype,"untitledWorkspacesHome",null),he([A.memoize],v.prototype,"installSourcePath",null),he([A.memoize],v.prototype,"builtinExtensionsPath",null),he([A.memoize],v.prototype,"extensionsPath",null),he([A.memoize],v.prototype,"extensionDevelopmentLocationURI",null),he([A.memoize],v.prototype,"extensionDevelopmentKind",null),he([A.memoize],v.prototype,"extensionTestsLocationURI",null),he([A.memoize],v.prototype,"debugExtensionHost",null),he([A.memoize],v.prototype,"serviceMachineIdResource",null),he([A.memoize],v.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=v;function R(I,o){return y(I["inspect-extensions"],I["inspect-brk-extensions"],5870,o,I.debugId)}e.parseExtensionHostPort=R;function d(I,o){return y(I["inspect-search"],I["inspect-brk-search"],5876,o)}e.parseSearchPort=d;function y(I,o,C,b,E){const m=Number(o||I)||(b?null:C),r=m?Boolean(!!o):!1;return{port:m,break:r,debugId:E}}}),function(){"use strict";function K(e,S,k,A){function L(T){const f=U(T),v=[f];return e.isAbsolute(f)||v.unshift(A),e.resolve(...v)}function U(T){const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");const v=T["user-data-dir"];if(v)return v;let R=process.env.VSCODE_APPDATA;if(!R)switch(process.platform){case"win32":if(R=process.env.APPDATA,!R){const d=process.env.USERPROFILE;if(typeof d!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");R=e.join(d,"AppData","Roaming")}break;case"darwin":R=e.join(S.homedir(),"Library","Application Support");break;case"linux":R=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(R,k)}return{getUserDataPath:L}}if(typeof define=="function")define(Z[126],ee([0,200,38,16,12,36]),function(e,S,k,A,L,U){const T=L.dirname(A.FileAccess.asFileUri("",e)),f=e.__$__nodeRequire(L.joinPath(T,"package.json").fsPath);return K(S,k,f.name,U.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),S=require("path"),k=require("os");module.exports=K(S,k,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[127],ee([0,1,38,126,125]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends A.AbstractNativeEnvironmentService{constructor(T,f){super(T,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,k.getUserDataPath)(T)},f)}}e.NativeEnvironmentService=L}),define(Z[128],ee([0,1,4]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const k=/^([^@:]+@)?([^:]+):/,A=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,U=/([^@:.]+\.[^@:.]+)(:\d+)?$/,T=/^\s*url\s*=\s*(.+\S)\s*$/mg,f=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function v(b){const E=b.match(U);return E?E[1]:null}function R(b){if(b.indexOf("://")===-1){const E=b.match(k);return E?v(E[2]):null}try{const E=S.URI.parse(b);if(E.authority)return v(E.authority)}catch(E){}return null}function d(b,E){const p=new Set;let m;for(;m=T.exec(b);){const n=R(m[1]);n&&p.add(n)}const r=new Set(E);return Array.from(p).map(n=>r.has(n)?n:n.replace(f,"a"))}e.getDomainsOfRemotes=d;function y(b){const E=b.match(L);return E?E[2]:null}function I(b,E,p){return b&&E?(p&&E.endsWith(".git")&&(E=E.substr(0,E.length-4)),E.indexOf("/")===0?`${b}${E}`:`${b}/${E}`):null}function o(b,E){if(b.indexOf("://")===-1){const p=b.match(A);if(p)return I(p[2],p[3],E)}try{const p=S.URI.parse(b);if(p.authority)return I(y(p.authority),p.path,E)}catch(p){}return null}function C(b,E=!1){const p=[];let m;for(;m=T.exec(b);){const r=o(m[1],E);r&&p.push(r)}return p}e.getRemotes=C}),define(Z[129],ee([0,1,3,4,90,26,2]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function T(o,C){return k.URI.revive(C?C.transformIncoming(o):o)}function f(o,C){return C?C.transformOutgoingURI(o):o}function v(o,C){C=C||A.DefaultURITransformer;const b=o.manifest,E=(0,A.transformAndReviveIncomingURIs)(Object.assign(Object.assign({},o),{manifest:void 0}),C);return Object.assign(Object.assign({},E),{manifest:b})}function R(o,C){return C?(0,L.cloneAndChange)(o,b=>b instanceof k.URI?C.transformOutgoingURI(b):void 0):o}class d{constructor(C,b){this.service=C,this.getUriTransformer=b,this.onInstallExtension=S.Event.buffer(C.onInstallExtension,!0),this.onDidInstallExtension=S.Event.buffer(C.onDidInstallExtension,!0),this.onUninstallExtension=S.Event.buffer(C.onUninstallExtension,!0),this.onDidUninstallExtension=S.Event.buffer(C.onDidUninstallExtension,!0)}listen(C,b){const E=this.getUriTransformer(C);switch(b){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return S.Event.map(this.onDidInstallExtension,p=>Object.assign(Object.assign({},p),{local:p.local?R(p.local,E):p.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(C,b,E){const p=this.getUriTransformer(C);switch(b){case"zip":return this.service.zip(v(E[0],p)).then(m=>f(m,p));case"unzip":return this.service.unzip(T(E[0],p));case"install":return this.service.install(T(E[0],p));case"getManifest":return this.service.getManifest(T(E[0],p));case"canInstall":return this.service.canInstall(E[0]);case"installFromGallery":return this.service.installFromGallery(E[0],E[1]);case"uninstall":return this.service.uninstall(v(E[0],p),E[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(v(E[0],p));case"getInstalled":return this.service.getInstalled(E[0]).then(m=>m.map(r=>R(r,p)));case"updateMetadata":return this.service.updateMetadata(v(E[0],p),E[1]).then(m=>R(m,p));case"updateExtensionScope":return this.service.updateExtensionScope(v(E[0],p),E[1]).then(m=>R(m,p));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class y extends U.Disposable{constructor(C){super();this.channel=C,this._onInstallExtension=this._register(new S.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new S.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new S.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new S.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(b=>this._onInstallExtension.fire(b))),this._register(this.channel.listen("onDidInstallExtension")(b=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},b),{local:b.local?v(b.local,null):b.local})))),this._register(this.channel.listen("onUninstallExtension")(b=>this._onUninstallExtension.fire(b))),this._register(this.channel.listen("onDidUninstallExtension")(b=>this._onDidUninstallExtension.fire(b)))}zip(C){return Promise.resolve(this.channel.call("zip",[C]).then(b=>k.URI.revive(b)))}unzip(C){return Promise.resolve(this.channel.call("unzip",[C]))}install(C){return Promise.resolve(this.channel.call("install",[C])).then(b=>v(b,null))}getManifest(C){return Promise.resolve(this.channel.call("getManifest",[C]))}async canInstall(C){return!0}installFromGallery(C,b){return Promise.resolve(this.channel.call("installFromGallery",[C,b])).then(E=>v(E,null))}uninstall(C,b){return Promise.resolve(this.channel.call("uninstall",[C,b]))}reinstallFromGallery(C){return Promise.resolve(this.channel.call("reinstallFromGallery",[C]))}getInstalled(C=null){return Promise.resolve(this.channel.call("getInstalled",[C])).then(b=>b.map(E=>v(E,null)))}updateMetadata(C,b){return Promise.resolve(this.channel.call("updateMetadata",[C,b])).then(E=>v(E,null))}updateExtensionScope(C,b){return Promise.resolve(this.channel.call("updateExtensionScope",[C,b])).then(E=>v(E,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=y;class I{constructor(C){this.service=C}listen(C,b){throw new Error("Invalid listen")}call(C,b,E){switch(b){case"getConfigBasedTips":return this.service.getConfigBasedTips(k.URI.revive(E[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=I}),define(Z[130],ee([0,1,26]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const k=/^%([\w\d.-]+)%$/i;function A(L,U){const T=f=>{if(typeof f=="string"){const v=k.exec(f);if(!!v)return U[v[1]]||f}};return(0,S.cloneAndChange)(L,T)}e.localizeManifest=A}),define(Z[131],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class S{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,U,T,f){return this.channel.call("promptImportantExtensionsInstallNotification",[L,U,T,f])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=S;class k{constructor(L){this.service=L}listen(L,U){throw new Error(`Event not found: ${U}`)}call(L,U,T){switch(U){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(T[0],T[1],T[2],T[3])}throw new Error(`Call not found: ${U}`)}}e.ExtensionRecommendationNotificationServiceChannel=k}),define(Z[68],ee([0,1,112]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function A(d){return d=d.trim(),d==="*"||k.test(d)}e.isValidVersionStr=A;function L(d){if(!A(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=d.match(k);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=L;function U(d){if(!d)return null;let y=d.majorBase,I=d.majorMustEqual,o=d.minorBase,C=d.minorMustEqual,b=d.patchBase,E=d.patchMustEqual;return d.hasCaret&&(y===0||(C=!1),E=!1),{majorBase:y,majorMustEqual:I,minorBase:o,minorMustEqual:C,patchBase:b,patchMustEqual:E,isMinimum:d.hasGreaterEquals}}e.normalizeVersion=U;function T(d,y){let I;typeof d=="string"?I=U(L(d)):I=d;let o;if(typeof y=="string"?o=U(L(y)):o=y,!I||!o)return!1;let C=I.majorBase,b=I.minorBase,E=I.patchBase,p=o.majorBase,m=o.minorBase,r=o.patchBase,n=o.majorMustEqual,t=o.minorMustEqual,i=o.patchMustEqual;return o.isMinimum?C>p?!0:C<p?!1:b>m?!0:b<m?!1:E>=r:(C===1&&p===0&&(!n||!t||!i)&&(p=1,m=0,r=0,n=!0,t=!1,i=!1),C<p?!1:C>p?!n:b<m?!1:b>m?!t:E<r?!1:E>r?!i:!0)}e.isValidVersion=T;function f(d,y,I){return y.isBuiltin||typeof y.main=="undefined"?!0:R(d,y.engines.vscode,I)}e.isValidExtensionVersion=f;function v(d,y){return d==="*"||R(y,d)}e.isEngineValid=v;function R(d,y,I=[]){let o=U(L(y));if(!o)return I.push(S.localize(0,null,y)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return I.push(S.localize(1,null,y)),!1}else if(!o.majorMustEqual)return I.push(S.localize(2,null,y)),!1;return T(d,o)?!0:(I.push(S.localize(3,null,d,y)),!1)}e.isVersionValid=R}),define(Z[132],ee([0,1,34,49,2,16]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class U extends A.Disposable{constructor(f,v,R,d){super();this.folders=f,this.onDidFilesChange=v,this.onLogMessage=R,this.verboseLogging=d,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new k.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=U.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(v=>!this.isDisposed&&this.onDidFilesChange(v))),this._register(this.service.onDidLogMessage(v=>this.onLogMessage(v))),this.setFolders(this.folders)}setVerboseLogging(f){this.verboseLogging=f,!this.isDisposed&&this.service&&this.service.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=U,U.MAX_RESTARTS=5}),define(Z[133],ee([0,1,34,49,2,16]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class U extends A.Disposable{constructor(f,v,R,d,y={}){super();this.folders=f,this.onDidFilesChange=v,this.onLogMessage=R,this.verboseLogging=d,this.watcherOptions=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new k.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=U.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(f.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(v=>!this.isDisposed&&this.onDidFilesChange(v))),this._register(this.service.onDidLogMessage(v=>this.onLogMessage(v))),this.service.setRoots(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=U,U.MAX_RESTARTS=5}),define(Z[134],ee([0,1,48,66,89,16]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class U{constructor(f,v,R,d,y){this.watchedFolder=f,this.eventCallback=R,this.logCallback=d,this.verboseLogging=y,this.restartCounter=0,Array.isArray(v)?this.ignored=v.map(I=>A.parse(I)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${f}`),this.startWatcher()}startWatcher(){const f=[this.watchedFolder];this.verboseLogging&&f.push("-verbose"),this.handle=S.spawn(L.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,f);const v=new k.LineDecoder;this.handle.stdout.on("data",R=>{const d=[];v.write(R).forEach(y=>{const I=y.split("|");if(I.length===2){const o=Number(I[0]),C=I[1];if(o>=0&&o<3){if(this.ignored&&this.ignored.some(b=>b(C))){this.verboseLogging&&this.log(C);return}d.push({type:U.changeTypeMap[o],path:C})}else this.log(I[1])}}),d.length>0&&this.eventCallback(d)}),this.handle.on("error",R=>this.onError(R)),this.handle.stderr.on("data",R=>this.onError(R)),this.handle.on("exit",(R,d)=>this.onExit(R,d))}onError(f){this.error("process error: "+f.toString())}onExit(f,v){this.handle&&(this.error(`terminated unexpectedly (code: ${f}, signal: ${v})`),this.restartCounter<=U.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(f){this.logCallback({type:"error",message:`[File Watcher (C#)] ${f}`})}log(f){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${f}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=U,U.MAX_RESTARTS=5,U.changeTypeMap=[0,1,2]}),define(Z[135],ee([0,1,134,8,21]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class L{constructor(T,f,v,R){this.onDidFilesChange=f,this.onLogMessage=v,this.verboseLogging=R,this.service=void 0,this.folder=T[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(k.posix.sep)&&(this.folder.path=(0,A.rtrim)(this.folder.path,k.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new S.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,T=>this.onFileEvents(T),T=>this.onLogMessage(T),this.verboseLogging)}setVerboseLogging(T){this.verboseLogging=T,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(T){this.isDisposed||T.length>0&&this.onDidFilesChange(T)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=L}),define(Z[50],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class S{constructor(L,U=[],T=!1){this.ctor=L,this.staticArguments=U,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=S;const k=(A,...L)=>new S(A,L);e.createSyncDescriptor=k}),define(Z[136],ee([0,1,50]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const k=[];function A(U,T,f){T instanceof S.SyncDescriptor||(T=new S.SyncDescriptor(T,[],f)),k.push([U,T])}e.registerSingleton=A;function L(){return k}e.getSingletonServiceDescriptors=L}),define(Z[137],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=S;class k{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let U of this._nodes.values())U.outgoing.size===0&&L.push(U);return L}insertEdge(L,U){const T=this.lookupOrInsertNode(L),f=this.lookupOrInsertNode(U);T.outgoing.set(this._hashFn(U),f),f.incoming.set(this._hashFn(L),T)}removeNode(L){const U=this._hashFn(L);this._nodes.delete(U);for(let T of this._nodes.values())T.outgoing.delete(U),T.incoming.delete(U)}lookupOrInsertNode(L){const U=this._hashFn(L);let T=this._nodes.get(U);return T||(T=new S(L),this._nodes.set(U,T)),T}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[U,T]of this._nodes)L.push(`${U}, (incoming)[${[...T.incoming.keys()].join(", ")}], (outgoing)[${[...T.outgoing.keys()].join(",")}]`);return L.join(`
`)}}e.Graph=k}),define(Z[5],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function f(v){return v[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=f})(S=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function k(T,f,v,R){f[S.DI_TARGET]===f?f[S.DI_DEPENDENCIES].push({id:T,index:v,optional:R}):(f[S.DI_DEPENDENCIES]=[{id:T,index:v,optional:R}],f[S.DI_TARGET]=f)}function A(T){if(S.serviceIds.has(T))return S.serviceIds.get(T);const f=function(v,R,d){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(f,v,d,!1)};return f.toString=()=>T,S.serviceIds.set(T,f),f}e.createDecorator=A;function L(T){return T}e.refineServiceDecorator=L;function U(T){return function(f,v,R){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");k(T,f,R,!0)}}e.optional=U}),define(Z[138],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,S.createDecorator)("checksumService")}),define(Z[139],ee([0,1,21,5,7]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let L=A.userAgent||"";const U=new Map;U.set("false",!1),U.set("true",!0),U.set("isMac",A.isMacintosh),U.set("isLinux",A.isLinux),U.set("isWindows",A.isWindows),U.set("isWeb",A.isWeb),U.set("isMacNative",A.isMacintosh&&!A.isWeb),U.set("isEdge",L.indexOf("Edg/")>=0),U.set("isFirefox",L.indexOf("Firefox")>=0),U.set("isChrome",L.indexOf("Chrome")>=0),U.set("isSafari",L.indexOf("Safari")>=0),U.set("isIPad",L.indexOf("iPad")>=0);const T=Object.prototype.hasOwnProperty;var f;(function(w){w[w.False=0]="False",w[w.True=1]="True",w[w.Defined=2]="Defined",w[w.Not=3]="Not",w[w.Equals=4]="Equals",w[w.NotEquals=5]="NotEquals",w[w.And=6]="And",w[w.Regex=7]="Regex",w[w.NotRegex=8]="NotRegex",w[w.Or=9]="Or",w[w.In=10]="In",w[w.NotIn=11]="NotIn",w[w.Greater=12]="Greater",w[w.GreaterEquals=13]="GreaterEquals",w[w.Smaller=14]="Smaller",w[w.SmallerEquals=15]="SmallerEquals"})(f=e.ContextKeyExprType||(e.ContextKeyExprType={}));class v{static false(){return d.INSTANCE}static true(){return y.INSTANCE}static has(u){return I.create(u)}static equals(u,P){return o.create(u,P)}static notEquals(u,P){return E.create(u,P)}static regex(u,P){return i.create(u,P)}static in(u,P){return C.create(u,P)}static not(u){return p.create(u)}static and(...u){return c.create(u)}static or(...u){return a.create(u)}static greater(u,P){return m.create(u,P)}static less(u,P){return n.create(u,P)}static deserialize(u,P=!1){if(!!u)return this._deserializeOrExpression(u,P)}static _deserializeOrExpression(u,P){let _=u.split("||");return a.create(_.map(z=>this._deserializeAndExpression(z,P)))}static _deserializeAndExpression(u,P){let _=u.split("&&");return c.create(_.map(z=>this._deserializeOne(z,P)))}static _deserializeOne(u,P){if(u=u.trim(),u.indexOf("!=")>=0){let _=u.split("!=");return E.create(_[0].trim(),this._deserializeValue(_[1],P))}if(u.indexOf("==")>=0){let _=u.split("==");return o.create(_[0].trim(),this._deserializeValue(_[1],P))}if(u.indexOf("=~")>=0){let _=u.split("=~");return i.create(_[0].trim(),this._deserializeRegexValue(_[1],P))}if(u.indexOf(" in ")>=0){let _=u.split(" in ");return C.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(u)){const _=u.split(">=");return r.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(u)){const _=u.split(">");return m.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(u)){const _=u.split("<=");return t.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(u)){const _=u.split("<");return n.create(_[0].trim(),_[1].trim())}return/^\!\s*/.test(u)?p.create(u.substr(1).trim()):I.create(u)}static _deserializeValue(u,P){if(u=u.trim(),u==="true")return!0;if(u==="false")return!1;let _=/^'([^']*)'$/.exec(u);return _?_[1].trim():u}static _deserializeRegexValue(u,P){if((0,S.isFalsyOrWhitespace)(u)){if(P)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let _=u.indexOf("/"),z=u.lastIndexOf("/");if(_===z||_<0){if(P)throw new Error(`bad regexp-value '${u}', missing /-enclosure`);return console.warn(`bad regexp-value '${u}', missing /-enclosure`),null}let B=u.slice(_+1,z),M=u[z+1]==="i"?"i":"";try{return new RegExp(B,M)}catch(j){if(P)throw new Error(`bad regexp-value '${u}', parse error: ${j}`);return console.warn(`bad regexp-value '${u}', parse error: ${j}`),null}}}e.ContextKeyExpr=v;function R(w,u){return w.cmp(u)}class d{constructor(){this.type=0}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}evaluate(u){return!1}serialize(){return"false"}keys(){return[]}map(u){return this}negate(){return y.INSTANCE}}e.ContextKeyFalseExpr=d,d.INSTANCE=new d;class y{constructor(){this.type=1}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}evaluate(u){return!0}serialize(){return"true"}keys(){return[]}map(u){return this}negate(){return d.INSTANCE}}e.ContextKeyTrueExpr=y,y.INSTANCE=new y;class I{constructor(u){this.key=u,this.type=2}static create(u){const P=U.get(u);return typeof P=="boolean"?P?y.INSTANCE:d.INSTANCE:new I(u)}cmp(u){return u.type!==this.type?this.type-u.type:h(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}evaluate(u){return!!u.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(u){return u.mapDefined(this.key)}negate(){return p.create(this.key)}}e.ContextKeyDefinedExpr=I;class o{constructor(u,P){this.key=u,this.value=P,this.type=4}static create(u,P){if(typeof P=="boolean")return P?I.create(u):p.create(u);const _=U.get(u);return typeof _=="boolean"?P===(_?"true":"false")?y.INSTANCE:d.INSTANCE:new o(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:g(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return u.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(u){return u.mapEquals(this.key,this.value)}negate(){return E.create(this.key,this.value)}}e.ContextKeyEqualsExpr=o;class C{constructor(u,P){this.key=u,this.valueKey=P,this.type=10}static create(u,P){return new C(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:g(this.key,this.valueKey,u.key,u.valueKey)}equals(u){return u.type===this.type?this.key===u.key&&this.valueKey===u.valueKey:!1}evaluate(u){const P=u.getValue(this.valueKey),_=u.getValue(this.key);return Array.isArray(P)?P.indexOf(_)>=0:typeof _=="string"&&typeof P=="object"&&P!==null?T.call(P,_):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(u){return u.mapIn(this.key,this.valueKey)}negate(){return b.create(this)}}e.ContextKeyInExpr=C;class b{constructor(u){this._actual=u,this.type=11}static create(u){return new b(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new b(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotInExpr=b;class E{constructor(u,P){this.key=u,this.value=P,this.type=5}static create(u,P){if(typeof P=="boolean")return P?p.create(u):I.create(u);const _=U.get(u);return typeof _=="boolean"?P===(_?"true":"false")?d.INSTANCE:y.INSTANCE:new E(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:g(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return u.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(u){return u.mapNotEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=E;class p{constructor(u){this.key=u,this.type=3}static create(u){const P=U.get(u);return typeof P=="boolean"?P?d.INSTANCE:y.INSTANCE:new p(u)}cmp(u){return u.type!==this.type?this.type-u.type:h(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}evaluate(u){return!u.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(u){return u.mapNot(this.key)}negate(){return I.create(this.key)}}e.ContextKeyNotExpr=p;class m{constructor(u,P){this.key=u,this.value=P,this.type=12}static create(u,P){return new m(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:g(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=m;class r{constructor(u,P){this.key=u,this.value=P,this.type=13}static create(u,P){return new r(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:g(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreaterEquals(this.key,this.value)}negate(){return n.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=r;class n{constructor(u,P){this.key=u,this.value=P,this.type=14}static create(u,P){return new n(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:g(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmaller(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeySmallerExpr=n;class t{constructor(u,P){this.key=u,this.value=P,this.type=15}static create(u,P){return new t(u,P)}cmp(u){return u.type!==this.type?this.type-u.type:g(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmallerEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(u,P){this.key=u,this.regexp=P,this.type=7}static create(u,P){return new i(u,P)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.key<u.key)return-1;if(this.key>u.key)return 1;const P=this.regexp?this.regexp.source:"",_=u.regexp?u.regexp.source:"";return P<_?-1:P>_?1:0}equals(u){if(u.type===this.type){const P=this.regexp?this.regexp.source:"",_=u.regexp?u.regexp.source:"";return this.key===u.key&&P===_}return!1}evaluate(u){let P=u.getValue(this.key);return this.regexp?this.regexp.test(P):!1}serialize(){const u=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${u}`}keys(){return[this.key]}map(u){return u.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=i;class s{constructor(u){this._actual=u,this.type=8}static create(u){return new s(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new s(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class c{constructor(u){this.expr=u,this.type=6}static create(u){return c._normalizeArr(u)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let P=0,_=this.expr.length;P<_;P++){const z=R(this.expr[P],u.expr[P]);if(z!==0)return z}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].equals(u.expr[P]))return!1;return!0}return!1}evaluate(u){for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].evaluate(u))return!1;return!0}static _normalizeArr(u){const P=[];let _=!1;for(const z of u)if(!!z){if(z.type===1){_=!0;continue}if(z.type===0)return d.INSTANCE;if(z.type===6){P.push(...z.expr);continue}P.push(z)}if(P.length===0&&_)return y.INSTANCE;if(P.length!==0){if(P.length===1)return P[0];for(P.sort(R);P.length>1;){const z=P[P.length-1];if(z.type!==9)break;P.pop();const B=P.pop(),M=a.create(z.expr.map(j=>c.create([j,B])));M&&(P.push(M),P.sort(R))}return P.length===1?P[0]:new c(P)}}serialize(){return this.expr.map(u=>u.serialize()).join(" && ")}keys(){const u=[];for(let P of this.expr)u.push(...P.keys());return u}map(u){return new c(this.expr.map(P=>P.map(u)))}negate(){let u=[];for(let P of this.expr)u.push(P.negate());return a.create(u)}}e.ContextKeyAndExpr=c;class a{constructor(u){this.expr=u,this.type=9}static create(u){const P=a._normalizeArr(u);if(P.length!==0)return P.length===1?P[0]:new a(P)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let P=0,_=this.expr.length;P<_;P++){const z=R(this.expr[P],u.expr[P]);if(z!==0)return z}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].equals(u.expr[P]))return!1;return!0}return!1}evaluate(u){for(let P=0,_=this.expr.length;P<_;P++)if(this.expr[P].evaluate(u))return!0;return!1}static _normalizeArr(u){let P=[],_=!1;if(u){for(let z=0,B=u.length;z<B;z++){const M=u[z];if(!!M){if(M.type===0){_=!0;continue}if(M.type===1)return[y.INSTANCE];if(M.type===9){P=P.concat(M.expr);continue}P.push(M)}}if(P.length===0&&_)return[d.INSTANCE];P.sort(R)}return P}serialize(){return this.expr.map(u=>u.serialize()).join(" || ")}keys(){const u=[];for(let P of this.expr)u.push(...P.keys());return u}map(u){return new a(this.expr.map(P=>P.map(u)))}negate(){let u=[];for(let _ of this.expr)u.push(_.negate());const P=_=>_.type===9?_.expr:[_];for(;u.length>1;){const _=u.shift(),z=u.shift(),B=[];for(const M of P(_))for(const j of P(z))B.push(v.and(M,j));u.unshift(v.or(...B))}return u[0]}}e.ContextKeyOrExpr=a;class l extends I{constructor(u,P,_){super(u);this._defaultValue=P,typeof _=="object"?l._info.push(Object.assign(Object.assign({},_),{key:u})):_!==!0&&l._info.push({key:u,description:_,type:P!=null?typeof P:void 0})}static all(){return l._info.values()}bindTo(u){return u.createKey(this.key,this._defaultValue)}getValue(u){return u.getContextKeyValue(this.key)}toNegated(){return v.not(this.key)}isEqualTo(u){return v.equals(this.key,u)}notEqualsTo(u){return v.notEquals(this.key,u)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(w,u){return w<u?-1:w>u?1:0}function g(w,u,P,_){return w<P?-1:w>P?1:u<_?-1:u>_?1:0}}),define(Z[69],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,S.createDecorator)(e.ID);function k(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=k}),define(Z[70],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,S.createDecorator)("downloadService")}),define(Z[9],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)});var Y=this&&this.__param||function(K,e){return function(S,k){e(S,k,K)}};define(Z[140],ee([0,1,9,8,23,11,2,6]),function(K,e,S,k,A,L,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let f=class extends U.Disposable{constructor(R){super();this.environmentService=R,this.cleanUpOldLogsSoon()}cleanUpOldLogsSoon(){let R=setTimeout(()=>{R=void 0;const d=(0,k.basename)(this.environmentService.logsPath),y=(0,k.dirname)(this.environmentService.logsPath);(0,A.readdir)(y).then(I=>{const C=I.filter(E=>/^\d{8}T\d{6}$/.test(E)).sort().filter((E,p)=>E!==d),b=C.slice(0,Math.max(0,C.length-9));return T.Promises.settled(b.map(E=>(0,A.rimraf)((0,k.join)(y,E))))}).then(null,L.onUnexpectedError)},10*1e3);this._register((0,U.toDisposable)(()=>{R&&(clearTimeout(R),R=void 0)}))}};f=he([Y(0,S.IEnvironmentService)],f),e.LogsDataCleaner=f}),define(Z[141],ee([0,1,27,9,8,23,11,2]),function(K,e,S,k,A,L,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let f=class rt extends T.Disposable{constructor(R,d){super();this.backupWorkspacesPath=R,this.environmentService=d,this.cleanUpStorageSoon()}cleanUpStorageSoon(){let R=setTimeout(()=>{R=void 0,(async()=>{try{const d=await S.promises.readFile(this.backupWorkspacesPath,"utf8"),I=JSON.parse(d).emptyWorkspaceInfos.map(b=>b.backupFolder),o=await(0,L.readdir)(this.environmentService.workspaceStorageHome.fsPath),C=[];o.forEach(b=>{b.length!==rt.NON_EMPTY_WORKSPACE_ID_LENGTH&&I.indexOf(b)===-1&&C.push((0,L.rimraf)((0,A.join)(this.environmentService.workspaceStorageHome.fsPath,b)))}),await Promise.all(C)}catch(d){(0,U.onUnexpectedError)(d)}})()},30*1e3);this._register((0,T.toDisposable)(()=>{R&&(clearTimeout(R),R=void 0)}))}};f.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,f=he([Y(1,k.INativeEnvironmentService)],f),e.StorageDataCleaner=f}),define(Z[29],ee([0,1,107,5,16]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function L(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=L;var U;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=5]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(U=e.SortBy||(e.SortBy={}));var T;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(T=e.SortOrder||(e.SortOrder={}));var f;(function(d){d.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var v;(function(d){d[d.None=0]="None",d[d.Install=1]="Install",d[d.Update=2]="Update"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class R extends Error{constructor(y,I){super(y);this.code=I}}e.ExtensionManagementError=R,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=A.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,S.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,S.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(Z[142],ee([0,1,2,29]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let A=class extends S.Disposable{constructor(U){super();this.extensionManagementService=U,this._register(U),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};A=he([Y(0,k.IExtensionManagementService)],A),e.DeprecatedExtensionsCleaner=A}),define(Z[71],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var k;(function(U){U[U.FILE=1]="FILE",U[U.WORKSPACE=2]="WORKSPACE",U[U.EXE=3]="EXE"})(k=e.RecommendationSource||(e.RecommendationSource={}));function A(U){switch(U){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=A;var L;(function(U){U.Ignored="ignored",U.Cancelled="cancelled",U.TooMany="toomany",U.IncompatibleWindow="incompatibleWindow",U.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,S.createDecorator)("IExtensionRecommendationNotificationService")}),define(Z[72],ee([0,1,21,5]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(L=e.ExtensionType||(e.ExtensionType={}));class U{constructor(R){this.value=R,this._lower=R.toLowerCase()}static equals(R,d){if(typeof R=="undefined"||R===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof R=="string"||typeof d=="string"){let y=typeof R=="string"?R:R.value,I=typeof d=="string"?d:d.value;return S.equalsIgnoreCase(y,I)}return R._lower===d._lower}static toKey(R){return typeof R=="string"?R.toLowerCase():R._lower}}e.ExtensionIdentifier=U;function T(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=T;function f(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=f,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[33],ee([0,1,21,72]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(I,o){return I.uuid&&o.uuid?I.uuid===o.uuid:I.id===o.id?!0:(0,S.compareIgnoreCase)(I.id,o.id)===0}e.areSameExtensions=A;class L{constructor(o,C){this.version=C,this.id=o.id,this.uuid=o.uuid}key(){return`${this.id}-${this.version}`}equals(o){return o instanceof L?A(this,o)&&this.version===o.version:!1}}e.ExtensionIdentifierWithVersion=L;function U(I,o){return`${I}.${o}`}e.getExtensionId=U;function T(I){return I.toLocaleLowerCase()}e.adoptToGalleryExtensionId=T;function f(I,o){return T(U(I,o))}e.getGalleryExtensionId=f;function v(I,o){const C=[],b=E=>{for(const p of C)if(p.some(m=>A(o(m),o(E))))return p;return null};for(const E of I){const p=b(E);p?p.push(E):C.push([E])}return C}e.groupByExtension=v;function R(I){return{id:I.identifier.id,name:I.manifest.name,galleryId:null,publisherId:I.publisherId,publisherName:I.manifest.publisher,publisherDisplayName:I.publisherDisplayName,dependencies:I.manifest.extensionDependencies&&I.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function d(I){return Object.assign({id:I.identifier.id,name:I.name,galleryId:I.identifier.uuid,publisherId:I.publisherId,publisherName:I.publisher,publisherDisplayName:I.publisherDisplayName,dependencies:!!(I.properties.dependencies&&I.properties.dependencies.length>0)},I.telemetryData)}e.getGalleryExtensionTelemetryData=d,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function y(I){const o=new Set;for(const C of I)C.malicious&&o.add(C.id.id);return o}e.getMaliciousExtensionsSet=y}),define(Z[143],ee([0,1,2,8,72,23]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class U extends S.Disposable{constructor(f,v){super();this.environmentService=f,this.extensionsManifestCache=(0,k.join)(this.environmentService.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this._register(v.onDidInstallExtension(R=>this.onDidInstallExtension(R))),this._register(v.onDidUninstallExtension(R=>this.onDidUnInstallExtension(R)))}onDidInstallExtension(f){f.error||this.invalidate()}onDidUnInstallExtension(f){f.error||this.invalidate()}invalidate(){L.rimraf(this.extensionsManifestCache,L.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=U}),define(Z[10],ee([0,1,114,8,4,5,21,15,37]),function(K,e,S,k,A,L,U,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,L.createDecorator)("fileService");function v(M){return M.create===!0}e.isFileOpenForWriteOptions=v;var R;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var d;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=y;function I(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=I;function o(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=o;function C(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=C;var b;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(j,W){super(j);this.code=W}}e.FileSystemProviderError=E;function p(M,j){const W=new E(M.toString(),j);return r(W,j),W}e.createFileSystemProviderError=p;function m(M){return M||p((0,S.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=m;function r(M,j){return M.name=j?`${j} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=r;function n(M){if(!M)return b.Unknown;if(M instanceof E)return M.code;const j=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!j)return b.Unknown;switch(j[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=n;function t(M){if(M instanceof h)return M.fileOperationResult;switch(n(M)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var i;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class s{constructor(j,W,$){this.resource=j,this.operation=W,this.target=$}isOperation(j){return this.operation===j}}e.FileOperationEvent=s;var c;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class a{constructor(j,W){this.ignorePathCasing=W,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=j;for(const $ of j)switch($.type){case 1:this.added||(this.added=f.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set($.resource,$);break;case 0:this.updated||(this.updated=f.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set($.resource,$);break;case 2:this.deleted||(this.deleted=f.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set($.resource,$);break}}contains(j,...W){return this.doContains(j,{includeChildren:!1},...W)}affects(j,...W){return this.doContains(j,{includeChildren:!0},...W)}doContains(j,W,...$){var H,q,D,O,F,N;if(!j)return!1;const V=$.length>0;return!!((!V||$.includes(1))&&(((H=this.added)===null||H===void 0?void 0:H.get(j))||W.includeChildren&&((q=this.added)===null||q===void 0?void 0:q.findSuperstr(j)))||(!V||$.includes(0))&&(((D=this.updated)===null||D===void 0?void 0:D.get(j))||W.includeChildren&&((O=this.updated)===null||O===void 0?void 0:O.findSuperstr(j)))||(!V||$.includes(2))&&(((F=this.deleted)===null||F===void 0?void 0:F.findSubstr(j))||W.includeChildren&&((N=this.deleted)===null||N===void 0?void 0:N.findSuperstr(j))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(j){const W=[],$=j===1?this.added:j===0?this.updated:this.deleted;if($)for(const[,H]of $)W.push(H);return W}filter(j){return new a(this.changes.filter(W=>j(W)),this.ignorePathCasing)}}e.FileChangesEvent=a;function l(M,j,W){return!M||!j||M===j||j.length>M.length?!1:(j.charAt(j.length-1)!==k.sep&&(j+=k.sep),W?(0,U.startsWithIgnoreCase)(M,j):M.indexOf(j)===0)}e.isParent=l;class h extends Error{constructor(j,W,$){super(j);this.fileOperationResult=W,this.options=$}static isFileOperationError(j){return j instanceof Error&&!(0,T.isUndefinedOrNull)(j.fileOperationResult)}}e.FileOperationError=h;var g;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(g=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var w;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(w=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function u(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=u;async function P(M,j){if(!j.canHandleResource(A.URI.from({scheme:M.scheme})))return new Promise(W=>{const $=j.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===M.scheme&&H.added&&($.dispose(),W())})})}e.whenProviderRegistered=P,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class _{static formatSize(j){return(0,T.isNumber)(j)||(j=0),j<_.KB?(0,S.localize)(1,null,j.toFixed(0)):j<_.MB?(0,S.localize)(2,null,(j/_.KB).toFixed(2)):j<_.GB?(0,S.localize)(3,null,(j/_.MB).toFixed(2)):j<_.TB?(0,S.localize)(4,null,(j/_.GB).toFixed(2)):(0,S.localize)(5,null,(j/_.TB).toFixed(2))}}e.ByteSize=_,_.KB=1024,_.MB=_.KB*_.KB,_.GB=_.MB*_.KB,_.TB=_.GB*_.KB;var z;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function B(M){return{maxFileSize:M===0?300*_.MB:16*_.GB,maxHeapSize:M===0?700*_.MB:2*700*_.MB}}e.getPlatformLimits=B}),define(Z[144],ee([0,1,145,47,10]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(T){this.fileService=T}checksum(T){return new Promise(async(f,v)=>{const R=(0,S.createHash)("md5"),d=(await this.fileService.readFileStream(T)).value;(0,k.listenStream)(d,{onData:y=>R.update(y.buffer),onError:y=>v(y),onEnd:()=>f(R.digest("base64").replace(/=+$/,""))})})}};L=he([Y(0,A.IFileService)],L),e.ChecksumService=L}),define(Z[73],ee([0,1,115,22,10,11]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function U(R,d,y,I,o,C){let b;try{await T(R,d,y,I,o,C)}catch(E){b=E}finally{b&&o.errorTransformer&&(b=o.errorTransformer(b)),typeof b!="undefined"&&y.error(b),y.end()}}e.readFileIntoStream=U;async function T(R,d,y,I,o,C){f(C);const b=await R.open(d,{create:!1});try{f(C);let E=0,p=0,m=o&&typeof o.length=="number"?o.length:void 0,r=k.VSBuffer.alloc(Math.min(o.bufferSize,typeof m=="number"?m:o.bufferSize)),n=o&&typeof o.position=="number"?o.position:0,t=0;do p=await R.read(b,n,r.buffer,t,r.byteLength-t),n+=p,t+=p,E+=p,typeof m=="number"&&(m-=p),t===r.byteLength&&(await y.write(I(r)),r=k.VSBuffer.alloc(Math.min(o.bufferSize,typeof m=="number"?m:o.bufferSize)),t=0);while(p>0&&(typeof m!="number"||m>0)&&f(C)&&v(E,o));if(t>0){let i=t;typeof m=="number"&&(i=Math.min(t,m)),y.write(I(r.slice(0,i)))}}catch(E){throw(0,A.ensureFileSystemProviderError)(E)}finally{await R.close(b)}}function f(R){if(R.isCancellationRequested)throw(0,L.canceled)();return!0}function v(R,d){if(d==null?void 0:d.limits){if(typeof d.limits.memory=="number"&&R>d.limits.memory)throw(0,A.createFileSystemProviderError)((0,S.localize)(0,null),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof d.limits.size=="number"&&R>d.limits.size)throw(0,A.createFileSystemProviderError)((0,S.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[74],ee([0,1,4,10,7]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function L(f){return f.map(v=>({type:v.type,resource:S.URI.file(v.path)}))}e.toFileChanges=L;function U(f){const v=new T;for(const R of f)v.processEvent(R);return v.normalize()}e.normalizeFileChanges=U;class T{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(v){const R=this.mapPathToChange.get(v.path);if(R){const d=R.type,y=v.type;d===1&&y===2?(this.mapPathToChange.delete(v.path),this.normalized.splice(this.normalized.indexOf(R),1)):d===2&&y===1?R.type=0:d===1&&y===0||(R.type=y)}else this.normalized.push(v),this.mapPathToChange.set(v.path,v)}normalize(){const v=[],R=[];return this.normalized.filter(d=>d.type!==2?(v.push(d),!1):!0).sort((d,y)=>d.path.length-y.path.length).filter(d=>R.some(y=>(0,k.isParent)(d.path,y,!A.isLinux))?!1:(R.push(d.path),!0)).concat(v)}}}),define(Z[146],ee([0,1,74,2,23,93,96,6,8]),function(K,e,S,k,A,L,U,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class v extends k.Disposable{constructor(d,y,I,o){super();this.path=d,this.onDidFilesChange=y,this.onLogMessage=I,this.verboseLogging=o,this.fileChangesDelayer=this._register(new T.ThrottledDelayer(U.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(d){this.verboseLogging=d}async startWatching(){try{const{stat:d,symbolicLink:y}=await A.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let I=this.path;if(y)try{I=await(0,L.realpath)(I)}catch(o){if(this.onError(o),y.dangling)return}d.isDirectory()?this._register((0,U.watchFolder)(I,(o,C)=>{this.onFileChange({type:o==="changed"?0:o==="added"?1:2,path:(0,f.join)(this.path,(0,f.basename)(C))})},o=>this.onError(o))):this._register((0,U.watchFile)(I,o=>{this.onFileChange({type:o==="changed"?0:2,path:this.path})},o=>this.onError(o)))}catch(d){d.code!=="ENOENT"&&this.onError(d)}}onFileChange(d){this.fileChangesBuffer.push(d),this.verboseLogging&&this.onVerbose(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`),this.fileChangesDelayer.trigger(async()=>{const y=this.fileChangesBuffer;this.fileChangesBuffer=[];const I=(0,S.normalizeFileChanges)(y);this.verboseLogging&&I.forEach(o=>{this.onVerbose(`>> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`)}),I.length>0&&this.onDidFilesChange(I)})}onError(d){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${d}`})}onVerbose(d){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=v}),define(Z[75],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...A){this._entries=new Map;for(let[L,U]of A)this.set(L,U)}set(A,L){const U=this._entries.get(A);return this._entries.set(A,L),U}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=S}),define(Z[147],ee([0,1,11,137,50,5,75,6]),function(K,e,S,k,A,L,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const f=!1;class v extends Error{constructor(o){super("cyclic dependency between services");this.message=o.toString()}}class R{constructor(o=new U.ServiceCollection,C=!1,b){this._activeInstantiations=new Set,this._services=o,this._strict=C,this._parent=b,this._services.set(L.IInstantiationService,this)}createChild(o){return new R(o,this._strict,this)}invokeFunction(o,...C){let b=y.traceInvocation(o),E=!1;try{return o({get:(m,r)=>{if(E)throw(0,S.illegalState)("service accessor is only valid during the invocation of its target method");const n=this._getOrCreateServiceInstance(m,b);if(!n&&r!==L.optional)throw new Error(`[invokeFunction] unknown service '${m}'`);return n}},...C)}finally{E=!0,b.stop()}}createInstance(o,...C){let b,E;return o instanceof A.SyncDescriptor?(b=y.traceCreation(o.ctor),E=this._createInstance(o.ctor,o.staticArguments.concat(C),b)):(b=y.traceCreation(o),E=this._createInstance(o,C,b)),b.stop(),E}_createInstance(o,C=[],b){let E=L._util.getServiceDependencies(o).sort((r,n)=>r.index-n.index),p=[];for(const r of E){let n=this._getOrCreateServiceInstance(r.id,b);if(!n&&this._strict&&!r.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${r.id}.`);p.push(n)}let m=E.length>0?E[0].index:C.length;if(C.length!==m){console.warn(`[createInstance] First service dependency of ${o.name} at position ${m+1} conflicts with ${C.length} static arguments`);let r=m-C.length;r>0?C=C.concat(new Array(r)):C=C.slice(0,m)}return new o(...[...C,...p])}_setServiceInstance(o,C){if(this._services.get(o)instanceof A.SyncDescriptor)this._services.set(o,C);else if(this._parent)this._parent._setServiceInstance(o,C);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let C=this._services.get(o);return!C&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):C}_getOrCreateServiceInstance(o,C){let b=this._getServiceInstanceOrDescriptor(o);return b instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,b,C.branch(o,!0)):(C.branch(o,!1),b)}_safeCreateAndCacheServiceInstance(o,C,b){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,C,b)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,C,b){const E=new k.Graph(r=>r.id.toString());let p=0;const m=[{id:o,desc:C,_trace:b}];for(;m.length;){const r=m.pop();if(E.lookupOrInsertNode(r),p++>1e3)throw new v(E);for(let n of L._util.getServiceDependencies(r.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(n.id);if(!t&&!n.optional&&console.warn(`[createInstance] ${o} depends on ${n.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const i={id:n.id,desc:t,_trace:r._trace.branch(n.id,!0)};E.insertEdge(r,i),m.push(i)}}}for(;;){const r=E.roots();if(r.length===0){if(!E.isEmpty())throw new v(E);break}for(const{data:n}of r){if(this._getServiceInstanceOrDescriptor(n.id)instanceof A.SyncDescriptor){const i=this._createServiceInstanceWithOwner(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this._setServiceInstance(n.id,i)}E.removeNode(n)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,C,b=[],E,p){if(this._services.get(o)instanceof A.SyncDescriptor)return this._createServiceInstance(C,b,E,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,C,b,E,p);throw new Error(`illegalState - creating UNKNOWN service instance ${C.name}`)}_createServiceInstance(o,C=[],b,E){if(b){const p=new T.IdleValue(()=>this._createInstance(o,C,E));return new Proxy(Object.create(null),{get(m,r){if(r in m)return m[r];let n=p.value,t=n[r];return typeof t!="function"||(t=t.bind(n),m[r]=t),t},set(m,r,n){return p.value[r]=n,!0}})}else return this._createInstance(o,C,E)}}e.InstantiationService=R;var d;(function(I){I[I.Creation=0]="Creation",I[I.Invocation=1]="Invocation",I[I.Branch=2]="Branch"})(d||(d={}));class y{constructor(o,C){this.type=o,this.name=C,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return f?new y(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):y._None}static traceCreation(o){return f?new y(0,o.name):y._None}branch(o,C){let b=new y(2,o.toString());return this._dep.push([o,C,b]),b}stop(){let o=Date.now()-this._start;y._totals+=o;let C=!1;function b(p,m){let r=[],n=new Array(p+1).join("	");for(const[t,i,s]of m._dep)if(i&&s){C=!0,r.push(`${n}CREATES -> ${t}`);let c=b(p+1,s);c&&r.push(c)}else r.push(`${n}uses -> ${t}`);return r.join(`
`)}let E=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(o>2||C)&&console.log(E.join(`
`))}}y._None=new class extends y{constructor(){super(-1,null)}stop(){}branch(){return this}},y._totals=0}),define(Z[148],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class S{constructor(A,L){this.server=A,this.router=L}getChannel(A){return this.server.getChannel(A,this.router)}registerChannel(A,L){this.server.registerChannel(A,L)}}e.MessagePortMainProcessService=S}),define(Z[149],ee([0,1,34,50,136,5]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class U{constructor(I,o,C){const b=C.getChannel(I);return T(o)?new o.channelClientCtor(b):S.ProxyChannel.toService(b,o==null?void 0:o.proxyOptions)}}function T(y){const I=y;return!!(I==null?void 0:I.channelClientCtor)}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let f=class extends U{constructor(I,o,C){super(I,o,C)}};f=he([Y(2,e.IMainProcessService)],f);function v(y,I,o){(0,A.registerSingleton)(y,new k.SyncDescriptor(f,[I,o],o==null?void 0:o.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=v,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let R=class extends U{constructor(I,o,C){super(I,o,C)}};R=he([Y(2,e.ISharedProcessService)],R);function d(y,I,o){(0,A.registerSingleton)(y,new k.SyncDescriptor(R,[I,o],o==null?void 0:o.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=d}),define(Z[54],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,S.createDecorator)("localizationsService");function k(A){if(typeof A.languageId!="string"||!Array.isArray(A.translations)||A.translations.length===0)return!1;for(const L of A.translations)if(typeof L.id!="string"||typeof L.path!="string")return!1;return!(A.languageName&&typeof A.languageName!="string"||A.localizedLanguageName&&typeof A.localizedLanguageName!="string")}e.isValidLocalization=k}),define(Z[150],ee([0,1,2,54]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let A=class extends S.Disposable{constructor(U){super();this.localizationsService=U,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};A=he([Y(0,k.ILocalizationsService)],A),e.LocalizationsUpdater=A}),define(Z[17],ee([0,1,5,2,7,3,43]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function T(){return new Date().toISOString()}var f;(function(n){n[n.Trace=0]="Trace",n[n.Debug=1]="Debug",n[n.Info=2]="Info",n[n.Warning=3]="Warning",n[n.Error=4]="Error",n[n.Critical=5]="Critical",n[n.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;class v extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=v;class R extends v{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(f.Trace)&&this.log(f.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(f.Debug)&&this.log(f.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(f.Info)&&this.log(f.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(f.Warning)&&this.log(f.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(f.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(f.Error,this.format(s))}else this.log(f.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(f.Critical)&&this.log(f.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let s=0;s<t.length;s++){let c=t[s];if(typeof c=="object")try{c=JSON.stringify(c)}catch(a){}i+=(s>0?" ":"")+c}return i}}e.AbstractMessageLogger=R;class d extends v{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...i){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${T()}][0m`,t,...i):console.log(`[main ${T()}]`,t,...i))}debug(t,...i){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${T()}][0m`,t,...i):console.log(`[main ${T()}]`,t,...i))}info(t,...i){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${T()}][0m`,t,...i):console.log(`[main ${T()}]`,t,...i))}warn(t,...i){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${T()}][0m`,t,...i):console.warn(`[main ${T()}]`,t,...i))}error(t,...i){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${T()}][0m`,t,...i):console.error(`[main ${T()}]`,t,...i))}critical(t,...i){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${T()}][0m`,t,...i):console.error(`[main ${T()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class y extends v{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=y;class I extends v{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,U.toErrorMessage)(t,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=I;class o extends v{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const s of this.logServices)s.trace(t,...i)}debug(t,...i){for(const s of this.logServices)s.debug(t,...i)}info(t,...i){for(const s of this.logServices)s.info(t,...i)}warn(t,...i){for(const s of this.logServices)s.warn(t,...i)}error(t,...i){for(const s of this.logServices)s.error(t,...i)}critical(t,...i){for(const s of this.logServices)s.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=o;class C extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=C;class b extends k.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(s))}))}createLogger(t,i){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(i==null?void 0:i.always)?f.Trace:this.logLevel,i),this.loggers.set(t.toString(),s),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class E{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return f.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=E;function p(n){if(n.verbose)return f.Trace;if(typeof n.logLevel=="string"){const t=m(n.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function m(n){switch(n){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=m;function r(n){switch(n){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=r}),define(Z[151],ee([0,1,27,2,10,29,9,4,12,33,17,31,55,7,6,11]),function(K,e,S,k,A,L,U,T,f,v,R,d,y,I,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let E=class extends k.Disposable{constructor(m,r,n,t){super();this.fileService=r,this.extensionGalleryService=n,this.logService=t,this.extensionsDownloadDir=T.URI.file(m.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(m,r){await this.cleanUpPromise;const n=this.getName(m),t=(0,f.joinPath)(this.extensionsDownloadDir,n);if(!await this.fileService.exists(t)){const i=(0,f.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(m,i,r);try{await this.rename(i,t,Date.now()+2*60*1e3)}catch(s){try{await this.fileService.del(i)}catch(c){}if(s.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",m.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,C.getErrorMessage)(s)}. Deleted the vsix from downloaded location`,i.path),s}}return t}async delete(m){}async rename(m,r,n){try{await S.promises.rename(m.fsPath,r.fsPath)}catch(t){if(I.isWindows&&t&&t.code==="EPERM"&&Date.now()<n)return this.logService.info(`Failed renaming ${m} to ${r} with 'EPERM' error. Trying again...`),this.rename(m,r,n);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const m=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(m.children){const r=[],n=[];for(const s of m.children){const c=this.parse(s.name);c&&n.push([c,s])}const t=(0,v.groupByExtension)(n,([s])=>s),i=[];for(const s of t)s.sort((c,a)=>y.rcompare(c[0].version,a[0].version)),r.push(...s.slice(1).map(c=>c[1].resource)),i.push(s[0][1]);i.sort((s,c)=>s.mtime-c.mtime),r.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(s=>s.resource)),await o.Promises.settled(r.map(s=>(this.logService.trace("Deleting vsix from cache",s.path),this.fileService.del(s))))}}catch(m){this.logService.error(m)}}getName(m){return this.cache?new v.ExtensionIdentifierWithVersion(m.identifier,m.version).key().toLowerCase():(0,d.generateUuid)()}parse(m){const r=b.exec(m);return r&&r[1]&&r[2]?new v.ExtensionIdentifierWithVersion({id:r[1]},r[2]):null}};E=he([Y(0,U.INativeEnvironmentService),Y(1,A.IFileService),Y(2,L.IExtensionGalleryService),Y(3,R.ILogService)],E),e.ExtensionsDownloader=E}),define(Z[152],ee([0,1,2,17,48,43,8,6,3,16,23,9]),function(K,e,S,k,A,L,U,T,f,v,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let y=class extends S.Disposable{constructor(o,C){super();this.environmentService=o,this.logService=C,this.processesLimiter=new T.Limiter(5)}async postUninstall(o){const C=this.parseScript(o,"uninstall");return C&&(this.logService.info(o.identifier.id,o.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(C.script,"uninstall",C.args,!0,o).then(()=>this.logService.info(o.identifier.id,o.manifest.version,"Finished running post uninstall script"),b=>this.logService.error(o.identifier.id,o.manifest.version,`Failed to run post uninstall script: ${b}`)))),(0,R.rimraf)(this.getExtensionStoragePath(o)).then(void 0,b=>this.logService.error("Error while removing extension storage path",b))}parseScript(o,C){const b=`vscode:${C}`;if(o.location.scheme===v.Schemas.file&&o.manifest&&o.manifest.scripts&&typeof o.manifest.scripts[b]=="string"){const E=o.manifest.scripts[b].split(" ");return E.length<2||E[0]!=="node"||!E[1]?(this.logService.warn(o.identifier.id,o.manifest.version,`${b} should be a node script`),null):{script:(0,U.join)(o.location.fsPath,E[1]),args:E.slice(2)||[]}}return null}runLifecycleHook(o,C,b,E,p){return new Promise((m,r)=>{const n=this.start(o,C,b,p);let t;const i=s=>{t&&(clearTimeout(t),t=null),s?r(s):m(void 0)};n.on("error",s=>{i((0,L.toErrorMessage)(s)||"Unknown")}),n.on("exit",(s,c)=>{i(s?`post-${C} process exited with code ${s}`:void 0)}),E&&(t=setTimeout(()=>{t=null,n.kill(),r("timed out")},5e3))})}start(o,C,b,E){const p={silent:!0,execArgv:void 0},m=(0,A.fork)(o,[`--type=extension-post-${C}`,...b],p);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const r=f.Event.fromNodeEventEmitter(m.stdout,"data"),n=f.Event.fromNodeEventEmitter(m.stderr,"data");r(s=>this.logService.info(E.identifier.id,E.manifest.version,`post-${C}`,s)),n(s=>this.logService.error(E.identifier.id,E.manifest.version,`post-${C}`,s));const t=f.Event.any(f.Event.map(r,s=>({data:`%c${s}`,format:[""]})),f.Event.map(n,s=>({data:`%c${s}`,format:["color: red"]})));return f.Event.debounce(t,(s,c)=>s?{data:s.data+c.data,format:[...s.format,...c.format]}:{data:c.data,format:c.format},100)(s=>{console.group(E.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),m}getExtensionStoragePath(o){return(0,U.join)(this.environmentService.globalStorageHome.fsPath,o.identifier.id.toLowerCase())}};y=he([Y(0,d.IEnvironmentService),Y(1,k.ILogService)],y),e.ExtensionsLifecycle=y}),define(Z[153],ee([0,1,2,9,3,10,4,33,12,17]),function(K,e,S,k,A,L,U,T,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let R=class extends S.Disposable{constructor(y,I,o,C){super();this.extensionsManagementService=y,this.logService=C,this._onDidChangeExtensionsByAnotherSource=this._register(new A.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(p=>{this.installedExtensions=p.map(m=>m.identifier),this.startTimestamp=Date.now()}),this._register(y.onInstallExtension(p=>this.onInstallExtension(p))),this._register(y.onDidInstallExtension(p=>this.onDidInstallExtension(p))),this._register(y.onDidUninstallExtension(p=>this.onDidUninstallExtension(p)));const b=U.URI.file(o.extensionsPath),E=new f.ExtUri(p=>!I.hasCapability(p,1024));this._register(I.watch(b)),this._register(A.Event.filter(I.onDidFilesChange,p=>p.changes.some(m=>this.doesChangeAffects(m,b,E)))(()=>this.onDidChange()))}doesChangeAffects(y,I,o){return o.isEqual(o.dirname(y.resource),I)?o.isEqual(y.resource,o.joinPath(I,".obsolete"))?!0:!(y.type!==1&&y.type!==2||o.basename(y.resource).startsWith(".")):!1}onInstallExtension(y){this.addInstallingExtension(y.identifier)}onDidInstallExtension(y){this.removeInstallingExtension(y.identifier),y.error||this.addInstalledExtension(y.identifier)}onDidUninstallExtension(y){y.error||this.removeInstalledExtension(y.identifier)}addInstallingExtension(y){this.removeInstallingExtension(y),this.installingExtensions.push(y)}removeInstallingExtension(y){this.installingExtensions=this.installingExtensions.filter(I=>!(0,T.areSameExtensions)(I,y))}addInstalledExtension(y){this.installedExtensions&&(this.removeInstalledExtension(y),this.installedExtensions.push(y))}removeInstalledExtension(y){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(I=>!(0,T.areSameExtensions)(I,y)))}async onDidChange(){if(this.installedExtensions){const y=await this.extensionsManagementService.getInstalled(1),I=y.filter(C=>[...this.installingExtensions,...this.installedExtensions].some(b=>(0,T.areSameExtensions)(b,C.identifier))?!1:C.installedTimestamp&&C.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",C.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",C.identifier.id),!1)),o=this.installedExtensions.filter(C=>this.installingExtensions.some(b=>(0,T.areSameExtensions)(b,C))?!1:y.every(b=>!(0,T.areSameExtensions)(b.identifier,C))?(this.logService.info("Detected extension removed from another source",C.id),!0):!1);this.installedExtensions=y.map(C=>C.identifier),(I.length||o.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:I,removed:o})}}};R=he([Y(1,L.IFileService),Y(2,k.INativeEnvironmentService),Y(3,v.ILogService)],R),e.ExtensionsWatcher=R}),define(Z[154],ee([0,1,113,155,2,10,3,12,37,18,17,22,47,6,30,16,73,52]),function(K,e,S,k,A,L,U,T,f,v,R,d,y,I,o,C,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let p=class extends A.Disposable{constructor(r){super();this.logService=r,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new U.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new U.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new U.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new U.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new U.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new U.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new I.ResourceQueue)}registerProvider(r,n){if(this.provider.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,k.mark)(`code/registerFilesystem/${r}`),this.provider.set(r,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:r,provider:n});const t=new A.DisposableStore;return t.add(n.onDidChangeFile(i=>this._onDidFilesChange.fire(new L.FileChangesEvent(i,!this.isPathCaseSensitive(n))))),t.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:r}))),typeof n.onDidErrorOccur=="function"&&t.add(n.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,A.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:r,provider:n}),this.provider.delete(r),(0,A.dispose)(t)})}async activateProvider(r){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:r,join(t){n.push(t)}}),!this.provider.has(r)&&await I.Promises.settled(n)}canHandleResource(r){return this.provider.has(r.scheme)}hasCapability(r,n){const t=this.provider.get(r.scheme);return!!(t&&t.capabilities&n)}listCapabilities(){return E.Iterable.map(this.provider,([r,n])=>({scheme:r,capabilities:n.capabilities}))}async withProvider(r){if(!(0,T.isAbsolutePath)(r))throw new L.FileOperationError((0,S.localize)(0,null,this.resourceForError(r)),8);await this.activateProvider(r.scheme);const n=this.provider.get(r.scheme);if(!n){const t=new Error;throw t.name="ENOPRO",t.message=(0,S.localize)(1,null,r.toString()),t}return n}async withReadProvider(r){const n=await this.withProvider(r);if((0,L.hasOpenReadWriteCloseCapability)(n)||(0,L.hasReadWriteCapability)(n)||(0,L.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(r){const n=await this.withProvider(r);if((0,L.hasOpenReadWriteCloseCapability)(n)||(0,L.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,n){try{return await this.doResolveFile(r,n)}catch(t){throw(0,L.toFileSystemProviderErrorCode)(t)===L.FileSystemProviderErrorCode.FileNotFound?new L.FileOperationError((0,S.localize)(2,null,this.resourceForError(r)),1):(0,L.ensureFileSystemProviderError)(t)}}async doResolveFile(r,n){const t=await this.withProvider(r),i=this.isPathCaseSensitive(t),s=n==null?void 0:n.resolveTo,c=n==null?void 0:n.resolveSingleChildDescendants,a=n==null?void 0:n.resolveMetadata,l=await t.stat(r);let h;return this.toFileStat(t,r,l,void 0,!!a,(g,w)=>(h||(h=f.TernarySearchTree.forUris(()=>!i),h.set(r,!0),(0,v.isNonEmptyArray)(s)&&s.forEach(u=>h.set(u,!0))),Boolean(h.findSuperstr(g.resource)||h.get(g.resource))?!0:g.isDirectory&&c?w===1:!1))}async toFileStat(r,n,t,i,s,c){const{providerExtUri:a}=this.getExtUri(r),l={resource:n,name:a.basename(n),isFile:(t.type&L.FileType.File)!=0,isDirectory:(t.type&L.FileType.Directory)!=0,isSymbolicLink:(t.type&L.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:(0,L.etag)({mtime:t.mtime,size:t.size})};if(l.isDirectory&&c(l,i)){try{const h=await r.readdir(n),g=await I.Promises.settled(h.map(async([w,u])=>{try{const P=a.joinPath(n,w),_=s?await r.stat(P):{type:u};return await this.toFileStat(r,P,_,h.length,s,c)}catch(P){return this.logService.trace(P),null}}));l.children=(0,v.coalesce)(g)}catch(h){this.logService.trace(h),l.children=[]}return l}return l}async resolveAll(r){return I.Promises.settled(r.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(r){const n=await this.withProvider(r);try{return!!await n.stat(r)}catch(t){return!1}}async canCreateFile(r,n){try{await this.doValidateCreateFile(r,n)}catch(t){return t}return!0}async doValidateCreateFile(r,n){if(!(n==null?void 0:n.overwrite)&&await this.exists(r))throw new L.FileOperationError((0,S.localize)(3,null,this.resourceForError(r)),3,n)}async createFile(r,n=d.VSBuffer.fromString(""),t){await this.doValidateCreateFile(r,t);const i=await this.writeFile(r,n);return this._onDidRunOperation.fire(new L.FileOperationEvent(r,0,i)),i}async writeFile(r,n,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),{providerExtUri:s}=this.getExtUri(i);try{await this.validateWriteFile(i,r,t)||await this.mkdirp(i,s.dirname(r));let a;if((0,L.hasReadWriteCapability)(i)&&!(n instanceof d.VSBuffer))if((0,y.isReadableStream)(n)){const l=await(0,y.peekStream)(n,3);l.ended?a=d.VSBuffer.concat(l.buffer):a=l}else a=(0,y.peekReadable)(n,l=>d.VSBuffer.concat(l),3);else a=n;!(0,L.hasOpenReadWriteCloseCapability)(i)||(0,L.hasReadWriteCapability)(i)&&a instanceof d.VSBuffer?await this.doWriteUnbuffered(i,r,t,a):await this.doWriteBuffered(i,r,t,a instanceof d.VSBuffer?(0,d.bufferToReadable)(a):a)}catch(c){throw new L.FileOperationError((0,S.localize)(4,null,this.resourceForError(r),(0,L.ensureFileSystemProviderError)(c).toString()),(0,L.toFileOperationResult)(c),t)}return this.resolve(r,{resolveMetadata:!0})}async validateWriteFile(r,n,t){if(!!(t==null?void 0:t.unlock)&&!(r.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(n)));let s;try{s=await r.stat(n)}catch(c){return}if((s.type&L.FileType.Directory)!=0)throw new L.FileOperationError((0,S.localize)(6,null,this.resourceForError(n)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==L.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==(0,L.etag)({mtime:t.mtime,size:s.size}))throw new L.FileOperationError((0,S.localize)(7,null),3,t);return s}async readFile(r,n){const t=await this.withReadProvider(r);return(n==null?void 0:n.atomic)?this.doReadFileAtomic(t,r,n):this.doReadFile(t,r,n)}async doReadFileAtomic(r,n,t){return new Promise((i,s)=>{this.writeQueue.queueFor(n,this.getExtUri(r).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(r,n,t);i(c)}catch(c){s(c)}})})}async doReadFile(r,n,t){const i=await this.doReadFileStream(r,n,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await(0,d.streamToBuffer)(i.value)})}async readFileStream(r,n){const t=await this.withReadProvider(r);return this.doReadFileStream(t,r,n)}async doReadFileStream(r,n,t){const i=new o.CancellationTokenSource,s=this.validateReadFile(n,t).then(a=>a,a=>{throw i.cancel(),a});let c;try{t&&typeof t.etag=="string"&&t.etag!==L.ETAG_DISABLED&&await s,!((0,L.hasOpenReadWriteCloseCapability)(r)||(0,L.hasFileReadStreamCapability)(r))||(0,L.hasReadWriteCapability)(r)&&(t==null?void 0:t.preferUnbuffered)?c=this.readFileUnbuffered(r,n,t):(0,L.hasFileReadStreamCapability)(r)?c=this.readFileStreamed(r,n,i.token,t):c=this.readFileBuffered(r,n,i.token,t);const a=await s;return Object.assign(Object.assign({},a),{value:c})}catch(a){throw c&&await(0,y.consumeStream)(c),new L.FileOperationError((0,S.localize)(8,null,this.resourceForError(n),(0,L.ensureFileSystemProviderError)(a).toString()),(0,L.toFileOperationResult)(a),t)}}readFileStreamed(r,n,t,i=Object.create(null)){const s=r.readFileStream(n,i,t);return(0,y.transform)(s,{data:c=>c instanceof d.VSBuffer?c:d.VSBuffer.wrap(c),error:c=>new L.FileOperationError((0,S.localize)(9,null,this.resourceForError(n),(0,L.ensureFileSystemProviderError)(c).toString()),(0,L.toFileOperationResult)(c),i)},c=>d.VSBuffer.concat(c))}readFileBuffered(r,n,t,i=Object.create(null)){const s=(0,d.newWriteableBufferStream)();return(0,b.readFileIntoStream)(r,n,s,c=>c,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:c=>new L.FileOperationError((0,S.localize)(10,null,this.resourceForError(n),(0,L.ensureFileSystemProviderError)(c).toString()),(0,L.toFileOperationResult)(c),i)}),t),s}readFileUnbuffered(r,n,t){const i=(0,y.newWriteableStream)(s=>d.VSBuffer.concat(s));return(async()=>{try{let s=await r.readFile(n);t&&typeof t.position=="number"&&(s=s.slice(t.position)),t&&typeof t.length=="number"&&(s=s.slice(0,t.length)),this.validateReadFileLimits(n,s.byteLength,t),i.end(d.VSBuffer.wrap(s))}catch(s){i.error(s),i.end()}})(),i}async validateReadFile(r,n){const t=await this.resolve(r,{resolveMetadata:!0});if(t.isDirectory)throw new L.FileOperationError((0,S.localize)(11,null,this.resourceForError(r)),0,n);if(n&&typeof n.etag=="string"&&n.etag!==L.ETAG_DISABLED&&n.etag===t.etag)throw new L.FileOperationError((0,S.localize)(12,null),2,n);return this.validateReadFileLimits(r,t.size,n),t}validateReadFileLimits(r,n,t){if(t==null?void 0:t.limits){let i;if(typeof t.limits.memory=="number"&&n>t.limits.memory&&(i=9),typeof t.limits.size=="number"&&n>t.limits.size&&(i=7),typeof i=="number")throw new L.FileOperationError((0,S.localize)(13,null,this.resourceForError(r)),i)}}async canMove(r,n,t){return this.doCanMoveCopy(r,n,"move",t)}async canCopy(r,n,t){return this.doCanMoveCopy(r,n,"copy",t)}async doCanMoveCopy(r,n,t,i){if(r.toString()!==n.toString())try{const s=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r):await this.withReadProvider(r),c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(s,r,c,n,t,i)}catch(s){return s}return!0}async move(r,n,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),c=await this.doMoveCopy(i,r,s,n,"move",!!t),a=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new L.FileOperationEvent(r,c==="move"?2:3,a)),a}async copy(r,n,t){const i=await this.withReadProvider(r),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),c=await this.doMoveCopy(i,r,s,n,"copy",!!t),a=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new L.FileOperationEvent(r,c==="copy"?3:2,a)),a}async doMoveCopy(r,n,t,i,s,c){if(n.toString()===i.toString())return s;const{exists:a,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(r,n,t,i,s,c);if(a&&!l&&c&&await this.del(i,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i)),s==="copy"){if(r===t&&(0,L.hasFileFolderCopyCapability)(r))await r.copy(n,i,{overwrite:c});else{const h=await this.resolve(n);h.isDirectory?await this.doCopyFolder(r,h,t,i):await this.doCopyFile(r,n,t,i)}return s}else return r===t?(await r.rename(n,i,{overwrite:c}),s):(await this.doMoveCopy(r,n,t,i,"copy",c),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(r,n,t,i){if((0,L.hasOpenReadWriteCloseCapability)(r)&&(0,L.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(r,n,t,i);if((0,L.hasOpenReadWriteCloseCapability)(r)&&(0,L.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(r,n,t,i);if((0,L.hasReadWriteCapability)(r)&&(0,L.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(r,n,t,i);if((0,L.hasReadWriteCapability)(r)&&(0,L.hasReadWriteCapability)(t))return this.doPipeUnbuffered(r,n,t,i)}async doCopyFolder(r,n,t,i){await t.mkdir(i),Array.isArray(n.children)&&await I.Promises.settled(n.children.map(async s=>{const c=this.getExtUri(t).providerExtUri.joinPath(i,s.name);return s.isDirectory?this.doCopyFolder(r,await this.resolve(s.resource),t,c):this.doCopyFile(r,s.resource,t,c)}))}async doValidateMoveCopy(r,n,t,i,s,c){let a=!1;if(r===t){const{providerExtUri:h,isPathCaseSensitive:g}=this.getExtUri(r);if(g||(a=h.isEqual(n,i)),a&&s==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(n),this.resourceForError(i)));if(!a&&h.isEqualOrParent(i,n))throw new Error((0,S.localize)(15,null,this.resourceForError(n),this.resourceForError(i)))}const l=await this.exists(i);if(l&&!a){if(!c)throw new L.FileOperationError((0,S.localize)(16,null,this.resourceForError(n),this.resourceForError(i)),4);if(r===t){const{providerExtUri:h}=this.getExtUri(r);if(h.isEqualOrParent(n,i))throw new Error((0,S.localize)(17,null,this.resourceForError(n),this.resourceForError(i)))}}return{exists:l,isSameResourceWithDifferentPathCase:a}}getExtUri(r){const n=this.isPathCaseSensitive(r);return{providerExtUri:n?T.extUri:T.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(r){return!!(r.capabilities&1024)}async createFolder(r){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);await this.mkdirp(n,r);const t=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new L.FileOperationEvent(r,0,t)),t}async mkdirp(r,n){const t=[],{providerExtUri:i}=this.getExtUri(r);for(;!i.isEqual(n,i.dirname(n));)try{if(((await r.stat(n)).type&L.FileType.Directory)==0)throw new Error((0,S.localize)(18,null,this.resourceForError(n)));break}catch(s){if((0,L.toFileSystemProviderErrorCode)(s)!==L.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(i.basename(n)),n=i.dirname(n)}for(let s=t.length-1;s>=0;s--){n=i.joinPath(n,t[s]);try{await r.mkdir(n)}catch(c){if((0,L.toFileSystemProviderErrorCode)(c)!==L.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(r,n){try{await this.doValidateDelete(r,n)}catch(t){return t}return!0}async doValidateDelete(r,n){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);if(!!(n==null?void 0:n.useTrash)&&!(t.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(r)));const s=await this.exists(r);if(!s)throw new L.FileOperationError((0,S.localize)(20,null,this.resourceForError(r)),1);if(!!!(n==null?void 0:n.recursive)&&s){const a=await this.resolve(r);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(r)))}return t}async del(r,n){const t=await this.doValidateDelete(r,n),i=!!(n==null?void 0:n.useTrash),s=!!(n==null?void 0:n.recursive);await t.delete(r,{recursive:s,useTrash:i}),this._onDidRunOperation.fire(new L.FileOperationEvent(r,1))}watch(r,n={recursive:!1,excludes:[]}){let t=!1,i=()=>{t=!0};return this.doWatch(r,n).then(s=>{t?(0,A.dispose)(s):i=()=>(0,A.dispose)(s)},s=>this.logService.error(s)),(0,A.toDisposable)(()=>i())}async doWatch(r,n){const t=await this.withProvider(r),i=this.toWatchKey(t,r,n),s=this.activeWatchers.get(i)||{count:0,disposable:t.watch(r,n)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,s),s.count+=1,(0,A.toDisposable)(()=>{s.count--,s.count===0&&((0,A.dispose)(s.disposable),this.activeWatchers.delete(i))})}toWatchKey(r,n,t){const{providerExtUri:i}=this.getExtUri(r);return[i.getComparisonKey(n),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(r=>(0,A.dispose)(r.disposable)),this.activeWatchers.clear()}async doWriteBuffered(r,n,t,i){return this.writeQueue.queueFor(n,this.getExtUri(r).providerExtUri).queue(async()=>{var s;const c=await r.open(n,{create:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1});try{(0,y.isReadableStream)(i)||(0,y.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(r,c,i):await this.doWriteReadableBufferedQueued(r,c,i)}catch(a){throw(0,L.ensureFileSystemProviderError)(a)}finally{await r.close(c)}})}async doWriteStreamBufferedQueued(r,n,t){let i=0,s;if((0,y.isReadableBufferedStream)(t)){if(t.buffer.length>0){const c=d.VSBuffer.concat(t.buffer);await this.doWriteBuffer(r,n,c,c.byteLength,i,0),i+=c.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise(async(c,a)=>{(0,y.listenStream)(s,{onData:async l=>{s.pause();try{await this.doWriteBuffer(r,n,l,l.byteLength,i,0)}catch(h){return a(h)}i+=l.byteLength,setTimeout(()=>s.resume())},onError:l=>a(l),onEnd:()=>c()})})}async doWriteReadableBufferedQueued(r,n,t){let i=0,s;for(;(s=t.read())!==null;)await this.doWriteBuffer(r,n,s,s.byteLength,i,0),i+=s.byteLength}async doWriteBuffer(r,n,t,i,s,c){let a=0;for(;a<i;)a+=await r.write(n,s+a,t.buffer,c+a,i-a)}async doWriteUnbuffered(r,n,t,i){return this.writeQueue.queueFor(n,this.getExtUri(r).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(r,n,t,i))}async doWriteUnbufferedQueued(r,n,t,i){var s;let c;i instanceof d.VSBuffer?c=i:(0,y.isReadableStream)(i)?c=await(0,d.streamToBuffer)(i):(0,y.isReadableBufferedStream)(i)?c=await(0,d.bufferedStreamToBuffer)(i):c=(0,d.readableToBuffer)(i),await r.writeFile(n,c.buffer,{create:!0,overwrite:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1})}async doPipeBuffered(r,n,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(r,n,t,i))}async doPipeBufferedQueued(r,n,t,i){let s,c;try{s=await r.open(n,{create:!1}),c=await t.open(i,{create:!0,unlock:!1});const a=d.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,h=0,g=0;do g=await r.read(s,l,a.buffer,h,a.byteLength-h),await this.doWriteBuffer(t,c,a,g,l,h),l+=g,h+=g,h===a.byteLength&&(h=0);while(g>0)}catch(a){throw(0,L.ensureFileSystemProviderError)(a)}finally{await I.Promises.settled([typeof s=="number"?r.close(s):Promise.resolve(),typeof c=="number"?t.close(c):Promise.resolve()])}}async doPipeUnbuffered(r,n,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(r,n,t,i))}async doPipeUnbufferedQueued(r,n,t,i){return t.writeFile(i,await r.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(r,n,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(r,n,t,i))}async doPipeUnbufferedToBufferedQueued(r,n,t,i){const s=await t.open(i,{create:!0,unlock:!1});try{const c=await r.readFile(n);await this.doWriteBuffer(t,s,d.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,L.ensureFileSystemProviderError)(c)}finally{await t.close(s)}}async doPipeBufferedToUnbuffered(r,n,t,i){const s=await(0,d.streamToBuffer)(this.readFileBuffered(r,n,o.CancellationToken.None));await this.doWriteUnbuffered(t,i,void 0,s)}throwIfFileSystemIsReadonly(r,n){if(r.capabilities&2048)throw new L.FileOperationError((0,S.localize)(22,null,this.resourceForError(n)),6);return r}resourceForError(r){return r.scheme===C.Schemas.file?r.fsPath:r.toString(!0)}};p=he([Y(0,R.ILogService)],p),e.FileService=p}),define(Z[156],ee([0,1,27,94,2,10,3,7,23,8,12,42,6,17,116,74,133,135,132,146,47,73,18,22]),function(K,e,S,k,A,L,U,T,f,v,R,d,y,I,o,C,b,E,p,m,r,n,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class s extends A.Disposable{constructor(a,l){var h;super();this.logService=a,this.options=l,this.BUFFER_SIZE=((h=this.options)===null||h===void 0?void 0:h.bufferSize)||64*1024,this.onDidChangeCapabilities=U.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new U.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new U.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new y.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,T.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(a){try{const{stat:l,symbolicLink:h}=await f.SymlinkSupport.stat(this.toFilePath(a));return{type:this.toType(l,h),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size}}catch(l){throw this.toFileSystemProviderError(l)}}async readdir(a){try{const l=await(0,f.readdir)(this.toFilePath(a),{withFileTypes:!0}),h=[];return await Promise.all(l.map(async g=>{try{let w;g.isSymbolicLink()?w=(await this.stat((0,R.joinPath)(a,g.name))).type:w=this.toType(g),h.push([g.name,w])}catch(w){this.logService.trace(w)}})),h}catch(l){throw this.toFileSystemProviderError(l)}}toType(a,l){let h;return(l==null?void 0:l.dangling)?h=L.FileType.Unknown:a.isFile()?h=L.FileType.File:a.isDirectory()?h=L.FileType.Directory:h=L.FileType.Unknown,l&&(h|=L.FileType.SymbolicLink),h}async readFile(a){try{const l=this.toFilePath(a);return await S.promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}}readFileStream(a,l,h){const g=(0,r.newWriteableStream)(w=>i.VSBuffer.concat(w.map(u=>i.VSBuffer.wrap(u))).buffer);return(0,n.readFileIntoStream)(this,a,g,w=>w.buffer,Object.assign(Object.assign({},l),{bufferSize:this.BUFFER_SIZE}),h),g}async writeFile(a,l,h){let g;try{const w=this.toFilePath(a);if(!h.create||!h.overwrite){if(await(0,f.exists)(w)){if(!h.overwrite)throw(0,L.createFileSystemProviderError)((0,o.localize)(0,null),L.FileSystemProviderErrorCode.FileExists)}else if(!h.create)throw(0,L.createFileSystemProviderError)((0,o.localize)(1,null),L.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(a,{create:!0,unlock:h.unlock}),await this.write(g,0,l,0,l.byteLength)}catch(w){throw await this.toFileSystemProviderWriteError(a,w)}finally{typeof g=="number"&&await this.close(g)}}async open(a,l){try{const h=this.toFilePath(a);if((0,L.isFileOpenForWriteOptions)(l)&&l.unlock)try{const{stat:u}=await f.SymlinkSupport.stat(h);u.mode&128||await S.promises.chmod(h,u.mode|128)}catch(u){this.logService.trace(u)}let g;if((0,L.isFileOpenForWriteOptions)(l)){if(T.isWindows)try{await S.promises.truncate(h,0),g="r+"}catch(u){u.code!=="ENOENT"&&this.logService.trace(u)}g||(g="w")}else g="r";const w=await(0,k.promisify)(S.open)(h,g);return this.mapHandleToPos.set(w,0),(0,L.isFileOpenForWriteOptions)(l)&&this.writeHandles.set(w,a),w}catch(h){throw(0,L.isFileOpenForWriteOptions)(l)?await this.toFileSystemProviderWriteError(a,h):this.toFileSystemProviderError(h)}}async close(a){try{if(this.mapHandleToPos.delete(a),this.writeHandles.delete(a)&&this.canFlush)try{await(0,k.promisify)(S.fdatasync)(a)}catch(l){this.canFlush=!1,this.logService.error(l)}return await(0,k.promisify)(S.close)(a)}catch(l){throw this.toFileSystemProviderError(l)}}async read(a,l,h,g,w){const u=this.normalizePos(a,l);let P=null;try{const _=await(0,k.promisify)(S.read)(a,h,g,w,u);return typeof _=="number"?P=_:P=_.bytesRead,P}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(a,u,P)}}normalizePos(a,l){return l===this.mapHandleToPos.get(a)?null:l}updatePos(a,l,h){const g=this.mapHandleToPos.get(a);typeof g=="number"&&(typeof l=="number"||(typeof h=="number"?this.mapHandleToPos.set(a,g+h):this.mapHandleToPos.delete(a)))}async write(a,l,h,g,w){return(0,y.retry)(()=>this.doWrite(a,l,h,g,w),100,3)}async doWrite(a,l,h,g,w){const u=this.normalizePos(a,l);let P=null;try{const _=await(0,k.promisify)(S.write)(a,h,g,w,u);return typeof _=="number"?P=_:P=_.bytesWritten,P}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(a),_)}finally{this.updatePos(a,u,P)}}async mkdir(a){try{await S.promises.mkdir(this.toFilePath(a))}catch(l){throw this.toFileSystemProviderError(l)}}async delete(a,l){try{const h=this.toFilePath(a);await this.doDelete(h,l)}catch(h){throw this.toFileSystemProviderError(h)}}async doDelete(a,l){l.recursive?await(0,f.rimraf)(a,f.RimRafMode.MOVE):await S.promises.unlink(a)}async rename(a,l,h){const g=this.toFilePath(a),w=this.toFilePath(l);if(g!==w)try{await this.validateTargetDeleted(a,l,"move",h.overwrite),await(0,f.move)(g,w)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,o.localize)(2,null,(0,v.basename)(g),(0,v.basename)((0,v.dirname)(w)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(a,l,h){const g=this.toFilePath(a),w=this.toFilePath(l);if(g!==w)try{await this.validateTargetDeleted(a,l,"copy",h.overwrite),await(0,f.copy)(g,w,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,o.localize)(3,null,(0,v.basename)(g),(0,v.basename)((0,v.dirname)(w)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(a,l,h,g){const w=this.toFilePath(a),u=this.toFilePath(l);let P=!1;if(!!(this.capabilities&1024)||(P=(0,d.isEqual)(w,u,!0)),P&&h==="copy")throw(0,L.createFileSystemProviderError)((0,o.localize)(4,null),L.FileSystemProviderErrorCode.FileExists);if(!P&&await(0,f.exists)(u)){if(!g)throw(0,L.createFileSystemProviderError)((0,o.localize)(5,null),L.FileSystemProviderErrorCode.FileExists);await this.delete(l,{recursive:!0,useTrash:!1})}}watch(a,l){return l.recursive?this.watchRecursive(a,l.excludes):this.watchNonRecursive(a)}watchRecursive(a,l){const h={path:this.toFilePath(a),excludes:l},g=(0,t.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,A.toDisposable)(()=>{g(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var a,l,h;if(this.recursiveWatcher instanceof p.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,A.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let g,w;((l=(a=this.options)===null||a===void 0?void 0:a.watcher)===null||l===void 0?void 0:l.usePolling)?(g=b.FileWatcher,w=(h=this.options)===null||h===void 0?void 0:h.watcher):this.recursiveFoldersToWatch.length===1?T.isWindows?g=E.FileWatcher:g=b.FileWatcher:g=p.FileWatcher,this.recursiveWatcher=new g(this.recursiveFoldersToWatch,u=>this._onDidChangeFile.fire((0,C.toFileChanges)(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===I.LogLevel.Trace,w),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)}))}}watchNonRecursive(a){const l=new m.FileWatcher(this.toFilePath(a),g=>this._onDidChangeFile.fire((0,C.toFileChanges)(g)),g=>{g.type==="error"&&this._onDidWatchErrorOccur.fire(g.message),this.logService[g.type](g.message)},this.logService.getLevel()===I.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{l.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)});return(0,A.combinedDisposable)(l,h)}toFilePath(a){return(0,v.normalize)(a.fsPath)}toFileSystemProviderError(a){if(a instanceof L.FileSystemProviderError)return a;let l;switch(a.code){case"ENOENT":l=L.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=L.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=L.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=L.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=L.FileSystemProviderErrorCode.NoPermissions;break;default:l=L.FileSystemProviderErrorCode.Unknown}return(0,L.createFileSystemProviderError)(a,l)}async toFileSystemProviderWriteError(a,l){let h=this.toFileSystemProviderError(l);if(a&&h.code===L.FileSystemProviderErrorCode.NoPermissions)try{const{stat:g}=await f.SymlinkSupport.stat(this.toFilePath(a));g.mode&128||(h=(0,L.createFileSystemProviderError)(l,L.FileSystemProviderErrorCode.FileWriteLocked))}catch(g){this.logService.trace(g)}return h}dispose(){super.dispose(),(0,A.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,A.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=s}),define(Z[157],ee([0,1,23,27,145,29,2,9,6,33,17,54,18,3,16,8]),function(K,e,S,k,A,L,U,T,f,v,R,d,y,I,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let b=class extends U.Disposable{constructor(m,r,n){super();this.extensionManagementService=m,this.logService=n,this._onDidLanguagesChange=this._register(new I.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new E(r,n)),this._register(m.onDidInstallExtension(({local:t})=>this.onDidInstallExtension(t))),this._register(m.onDidUninstallExtension(({identifier:t})=>this.onDidUninstallExtension(t)))}getLanguageIds(){return this.cache.getLanguagePacks().then(m=>{const r=["en",...Object.keys(m)];return(0,y.distinct)(r)})}onDidInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",m.identifier.id),this.update().then(r=>{r&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(m){this.cache.getLanguagePacks().then(r=>{Object.keys(r).some(n=>r[n]&&r[n].extensions.some(t=>(0,v.areSameExtensions)(t.extensionIdentifier,m)))&&(this.logService.debug("Removing language packs from the extension",m.id),this.update().then(n=>{n&&this._onDidLanguagesChange.fire()}))})}async update(){const[m,r]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),n=await this.cache.update(r);return!(0,y.equals)(Object.keys(m),Object.keys(n))}};b=he([Y(0,L.IExtensionManagementService),Y(1,T.INativeEnvironmentService),Y(2,R.ILogService)],b),e.LocalizationsService=b;let E=class extends U.Disposable{constructor(m,r){super();this.logService=r,this.languagePacks={},this.languagePacksFilePath=(0,C.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new f.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(r=>{Object.keys(r).forEach(n=>delete r[n]),this.createLanguagePacksFromExtensions(r,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...r){for(const n of r)n&&n.manifest&&n.manifest.contributes&&n.manifest.contributes.localizations&&n.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,n);Object.keys(m).forEach(n=>this.updateHash(m[n]))}createLanguagePacksFromExtension(m,r){const n=r.identifier,t=r.manifest.contributes&&r.manifest.contributes.localizations?r.manifest.contributes.localizations:[];for(const i of t)if(r.location.scheme===o.Schemas.file&&(0,d.isValidLocalization)(i)){let s=m[i.languageId];s||(s={hash:"",extensions:[],translations:{}},m[i.languageId]=s);let c=s.extensions.filter(a=>(0,v.areSameExtensions)(a.extensionIdentifier,n))[0];c?c.version=r.manifest.version:s.extensions.push({extensionIdentifier:n,version:r.manifest.version});for(const a of i.translations)s.translations[a.id]=(0,C.join)(r.location.fsPath,a.path)}}updateHash(m){if(m){const r=(0,A.createHash)("md5");for(const n of m.extensions)r.update(n.extensionIdentifier.uuid||n.extensionIdentifier.id).update(n.version);m.hash=r.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let r=null;return k.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,n=>n.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(n)).then(n=>{try{return JSON.parse(n)}catch(t){return{}}}).then(n=>(r=m(n),n)).then(n=>{for(const i of Object.keys(n))n[i]||delete n[i];this.languagePacks=n,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),(0,S.writeFile)(this.languagePacksFilePath,t)}).then(()=>r,n=>this.logService.error(n))})}};E=he([Y(0,T.INativeEnvironmentService),Y(1,R.ILogService)],E)}),define(Z[76],ee([0,1,17,3,4]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(y){this.service=y,this.onDidChangeLogLevel=k.Event.buffer(y.onDidChangeLogLevel,!0)}listen(y,I){switch(I){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${I}`)}async call(y,I,o){switch(I){case"setLevel":return this.service.setLevel(o)}throw new Error(`Call not found: ${I}`)}}e.LogLevelChannel=L;class U{constructor(y){this.channel=y}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(y){U.setLevel(this.channel,y)}static setLevel(y,I){return y.call("setLevel",I)}}e.LogLevelChannelClient=U;class T{constructor(y){this.loggerService=y,this.loggers=new Map}listen(y,I){throw new Error(`Event not found: ${I}`)}async call(y,I,o){switch(I){case"createLogger":this.createLogger(A.URI.revive(o[0]),o[1]);return;case"log":return this.log(A.URI.revive(o[0]),o[1]);case"consoleLog":return this.consoleLog(o[0],o[1])}throw new Error(`Call not found: ${I}`)}createLogger(y,I){this.loggers.set(y.toString(),this.loggerService.createLogger(y,I))}consoleLog(y,I){let o=console.log;switch(y){case S.LogLevel.Error:o=console.error;break;case S.LogLevel.Warning:o=console.warn;break;case S.LogLevel.Info:o=console.info;break}o.call(console,...I)}log(y,I){const o=this.loggers.get(y.toString());if(!o)throw new Error("Create the logger before logging");for(const[C,b]of I)switch(C){case S.LogLevel.Trace:o.trace(b);break;case S.LogLevel.Debug:o.debug(b);break;case S.LogLevel.Info:o.info(b);break;case S.LogLevel.Warning:o.warn(b);break;case S.LogLevel.Error:o.error(b);break;case S.LogLevel.Critical:o.critical(b);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=T;class f extends S.AbstractLoggerService{constructor(y,I,o){super(y,I);this.channel=o}createConsoleMainLogger(){return new S.AdapterLogger({log:(y,I)=>{this.channel.call("consoleLog",[y,I])}})}doCreateLogger(y,I,o){return new v(this.channel,y,I,o)}}e.LoggerChannelClient=f;class v extends S.AbstractMessageLogger{constructor(y,I,o,C){super(C==null?void 0:C.always);this.channel=y,this.file=I,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(o),this.channel.call("createLogger",[I,C]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(y,I){const o=[[y,I]];this.isLoggerCreated?this.doLog(o):this.buffer.push(...o)}doLog(y){this.channel.call("log",[this.file,y])}}class R extends S.LogService{constructor(y,I){super(I);this.parent=y,this._register(y.onDidChangeLogLevel(o=>I.setLevel(o)))}setLevel(y){super.setLevel(y),this.parent.setLevel(y)}}e.FollowerLogService=R}),define(Z[56],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,S.createDecorator)("nativeHostService")}),define(Z[57],ee([0,1,16,7,36,12]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let U;if(typeof k.globals.vscode!="undefined"){const T=k.globals.vscode.context.configuration();if(T)U=T.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(K==null?void 0:K.__$__nodeRequire)=="function"){const T=(0,L.dirname)(S.FileAccess.asFileUri("",K));U=K.__$__nodeRequire((0,L.joinPath)(T,"product.json").fsPath);const f=K.__$__nodeRequire((0,L.joinPath)(T,"package.json").fsPath);A.env.VSCODE_DEV&&Object.assign(U,{nameShort:`${U.nameShort} Dev`,nameLong:`${U.nameLong} Dev`,dataFolderName:`${U.dataFolderName}-dev`}),Object.assign(U,{version:f.version})}else U={},Object.keys(U).length===0&&Object.assign(U,{version:"1.56.0-dev",nameShort:k.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:k.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=U}),define(Z[28],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService")}),define(Z[158],ee([0,1,27,8,23,28,2,11,17,9]),function(K,e,S,k,A,L,U,T,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let R=class extends U.Disposable{constructor(y,I,o){super();this._environmentService=y,this._logService=I,this._productService=o,this._DataMaxAge=this._productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this._environmentService.isBuilt&&this._manageCachedDataSoon()}_manageCachedDataSoon(){let y=setTimeout(async()=>{y=void 0,this._logService.info("Starting to clean up unused language packs.");try{const I=Object.create(null),o=JSON.parse(await S.promises.readFile(k.join(this._environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let p of Object.keys(o)){const m=o[p];I[`${m.hash}.${p}`]=!0}const C=k.join(this._environmentService.userDataPath,"clp");if(!await A.exists(C))return;for(let p of await A.readdir(C)){if(I[p]){this._logService.info(`Skipping directory ${p}. Language pack still in use.`);continue}this._logService.info("Removing unused language pack:",p),await A.rimraf(k.join(C,p))}const E=Date.now();for(let p of Object.keys(I)){const m=k.join(C,p);for(let r of await A.readdir(m))if(r!=="tcf.json"){const n=k.join(m,r),t=await S.promises.stat(n);t.isDirectory()&&E-t.mtime.getTime()>this._DataMaxAge&&(this._logService.info("Removing language pack cache entry: ",k.join(p,r)),await A.rimraf(n))}}}catch(I){(0,T.onUnexpectedError)(I)}},40*1e3);this._register((0,U.toDisposable)(()=>{y!==void 0&&clearTimeout(y)}))}};R=he([Y(0,v.INativeEnvironmentService),Y(1,f.ILogService),Y(2,L.IProductService)],R),e.LanguagePackCachedDataCleaner=R}),define(Z[159],ee([0,1,27,8,11,2,23,28]),function(K,e,S,k,A,L,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeCachedDataCleaner=void 0;let f=class{constructor(R,d){this.nodeCachedDataDir=R,this.productService=d,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this._disposables=new L.DisposableStore,this._manageCachedDataSoon()}dispose(){this._disposables.dispose()}_manageCachedDataSoon(){if(!!this.nodeCachedDataDir){const R=(0,k.dirname)(this.nodeCachedDataDir),d=(0,k.basename)(this.nodeCachedDataDir);let y=setTimeout(()=>{y=void 0,(0,U.readdir)(R).then(I=>{const o=Date.now(),C=[];return I.forEach(b=>{if(b!==d){const E=(0,k.join)(R,b);C.push(S.promises.stat(E).then(p=>{if(p.isDirectory()&&o-p.mtime.getTime()>this._DataMaxAge)return(0,U.rimraf)(E)}))}}),Promise.all(C)}).then(void 0,A.onUnexpectedError)},30*1e3);this._disposables.add((0,L.toDisposable)(()=>{y&&(clearTimeout(y),y=void 0)}))}}};f=he([Y(1,T.IProductService)],f),e.NodeCachedDataCleaner=f}),define(Z[35],ee([0,1,15,84]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(U,T){k.ok(S.isString(U)),k.ok(S.isObject(T)),k.ok(!this.data.has(U),"There is already an extension with this id"),this.data.set(U,T)}knows(U){return this.data.has(U)}as(U){return this.data.get(U)||null}}e.Registry=new A}),define(Z[77],ee([0,1,35,3]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class L{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,v){this.schemasById[A(f)]=v,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const U=new L;S.Registry.add(e.Extensions.JSONContribution,U)}),define(Z[39],ee([0,1,106,3,35,15,77]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const f=A.Registry.as(U.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,p=!0){this.registerConfigurations([E],p)}registerConfigurations(E,p=!0){const m=[];E.forEach(r=>{m.push(...this.validateAndRegisterProperties(r,p,r.extensionInfo)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}deregisterConfigurations(E){const p=[],m=r=>{if(r.properties)for(const n in r.properties)p.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,r.properties[n]);r.allOf&&r.allOf.forEach(n=>m(n))};for(const r of E){m(r);const n=this.configurationContributors.indexOf(r);n!==-1&&this.configurationContributors.splice(n,1)}f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}registerDefaultConfigurations(E){const p=[],m=[];for(const r of E)for(const n in r)if(p.push(n),e.OVERRIDE_PROPERTY_PATTERN.test(n)){this.defaultValues[n]=Object.assign(Object.assign({},this.defaultValues[n]||{}),r[n]);const t={type:"object",default:this.defaultValues[n],description:S.localize(1,null,n),$ref:e.resourceLanguageSettingsSchemaId};m.push(d(n)),this.configurationProperties[n]=t,this.defaultLanguageConfigurationOverridesNode.properties[n]=t}else{this.defaultValues[n]=r[n];const t=this.configurationProperties[n];t&&(this.updatePropertyDefaultValue(n,t),this.updateSchema(n,t))}this.registerOverrideIdentifiers(m),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterDefaultConfigurations(E){const p=[];for(const m of E)for(const r in m)if(p.push(r),delete this.defaultValues[r],e.OVERRIDE_PROPERTY_PATTERN.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const n=this.configurationProperties[r];n&&(this.updatePropertyDefaultValue(r,n),this.updateSchema(r,n))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const p of E)this.overrideIdentifiers.add(p);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(E,p=!0,m,r=3){var n;r=L.isUndefinedOrNull(E.scope)?r:E.scope;let t=[],i=E.properties;if(i)for(let c in i){if(p&&o(c)){delete i[c];continue}const a=i[c];if(this.updatePropertyDefaultValue(c,a),e.OVERRIDE_PROPERTY_PATTERN.test(c)?a.scope=void 0:(a.scope=L.isUndefinedOrNull(a.scope)?r:a.scope,a.requireTrust=L.isUndefinedOrNull(a.requireTrust)?!!((n=m==null?void 0:m.requireTrustForConfigurations)===null||n===void 0?void 0:n.includes(c)):a.requireTrust),i[c].hasOwnProperty("included")&&!i[c].included){this.excludedConfigurationProperties[c]=i[c],delete i[c];continue}else this.configurationProperties[c]=i[c];!i[c].deprecationMessage&&i[c].markdownDeprecationMessage&&(i[c].deprecationMessage=i[c].markdownDeprecationMessage),t.push(c)}let s=E.allOf;if(s)for(let c of s)t.push(...this.validateAndRegisterProperties(c,p,m,r));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const p=m=>{let r=m.properties;if(r)for(const t in r)this.updateSchema(t,r[t]);let n=m.allOf;n&&n.forEach(p)};p(E)}updateSchema(E,p){switch(e.allSettings.properties[E]=p,p.scope){case 1:e.applicationSettings.properties[E]=p;break;case 2:e.machineSettings.properties[E]=p;break;case 6:e.machineOverridableSettings.properties[E]=p;break;case 3:e.windowSettings.properties[E]=p;break;case 4:e.resourceSettings.properties[E]=p;break;case 5:e.resourceSettings.properties[E]=p,this.resourceLanguageSettingsSchema.properties[E]=p;break}}removeFromSchema(E,p){switch(delete e.allSettings.properties[E],p.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const p=`[${E}]`,m={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(p,m),e.allSettings.properties[p]=m,e.applicationSettings.properties[p]=m,e.machineSettings.properties[p]=m,e.machineOverridableSettings.properties[p]=m,e.windowSettings.properties[p]=m,e.resourceSettings.properties[p]=m}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,p){let m=this.defaultValues[E];L.isUndefined(m)&&(m=p.default),L.isUndefined(m)&&(m=y(p.type)),p.default=m}}const R="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(R);function d(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=d;function y(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=y;const I=new v;A.Registry.add(e.Extensions.Configuration,I);function o(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?S.localize(5,null,b):I.getConfigurationProperties()[b]!==void 0?S.localize(6,null,b):null:S.localize(4,null)}e.validateProperty=o;function C(){const b=[],E=I.getConfigurationProperties();for(const p of Object.keys(E))b.push([p,E[p].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=C}),define(Z[24],ee([0,1,26,15,4,35,5,39]),function(K,e,S,k,A,L,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,U.createDecorator)("configurationService");function f(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof A.URI)}e.isConfigurationOverrides=f;var v;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(v=e.ConfigurationTarget||(e.ConfigurationTarget={}));function R(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=R;function d(i,s){const c=s?i?s.keys.filter(P=>i.keys.indexOf(P)===-1):[...s.keys]:[],a=i?s?i.keys.filter(P=>s.keys.indexOf(P)===-1):[...i.keys]:[],l=[];if(s&&i){for(const P of i.keys)if(s.keys.indexOf(P)!==-1){const _=E(i.contents,P),z=E(s.contents,P);S.equals(_,z)||l.push(P)}}const h=[],g=P=>{const _={};for(const z of P)for(const B of z.identifiers)_[n(B)]=z;return _},w=s?g(s.overrides):{},u=i?g(i.overrides):{};if(Object.keys(w).length)for(const P of c){const _=w[P];_&&h.push([(0,T.overrideIdentifierFromKey)(P),_.keys])}if(Object.keys(u).length)for(const P of a){const _=u[P];_&&h.push([(0,T.overrideIdentifierFromKey)(P),_.keys])}if(Object.keys(w).length&&Object.keys(u).length)for(const P of l){const _=u[P],z=w[P];if(_&&z){const B=d({contents:_.contents,keys:_.keys,overrides:[]},{contents:z.contents,keys:z.keys,overrides:[]});h.push([(0,T.overrideIdentifierFromKey)(P),[...B.added,...B.removed,...B.updated]])}}return{added:c,removed:a,updated:l,overrides:h}}e.compare=d;function y(i,s){const c=[];for(const a of Object.keys(i))if(T.OVERRIDE_PROPERTY_PATTERN.test(a)){const l={};for(const h in i[a])l[h]=i[a][h];c.push({identifiers:[(0,T.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(l),contents:I(l,s)})}return c}e.toOverrides=y;function I(i,s){const c=Object.create(null);for(let a in i)o(c,a,i[a],s);return c}e.toValuesTree=I;function o(i,s,c,a){const l=s.split("."),h=l.pop();let g=i;for(let w=0;w<l.length;w++){let u=l[w],P=g[u];switch(typeof P){case"undefined":P=g[u]=Object.create(null);break;case"object":break;default:a(`Ignoring ${s} as ${l.slice(0,w+1).join(".")} is ${JSON.stringify(P)}`);return}g=P}if(typeof g=="object"&&g!==null)try{g[h]=c}catch(w){a(`Ignoring ${s} as ${l.join(".")} is ${JSON.stringify(g)}`)}else a(`Ignoring ${s} as ${l.join(".")} is ${JSON.stringify(g)}`)}e.addToValueTree=o;function C(i,s){const c=s.split(".");b(i,c)}e.removeFromValueTree=C;function b(i,s){const c=s.shift();if(s.length===0){delete i[c];return}if(Object.keys(i).indexOf(c)!==-1){const a=i[c];typeof a=="object"&&!Array.isArray(a)&&(b(a,s),Object.keys(a).length===0&&delete i[c])}}function E(i,s,c){function a(g,w){let u=g;for(const P of w){if(typeof u!="object"||u===null)return;u=u[P]}return u}const l=s.split("."),h=a(i,l);return typeof h=="undefined"?c:h}e.getConfigurationValue=E;function p(i,s,c){Object.keys(s).forEach(a=>{a!=="__proto__"&&(a in i?k.isObject(i[a])&&k.isObject(s[a])?p(i[a],s[a],c):c&&(i[a]=s[a]):i[a]=s[a])})}e.merge=p;function m(){const i=L.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=m;function r(){const i=Object.create(null),s=L.Registry.as(T.Extensions.Configuration).getConfigurationProperties();for(let c in s){let a=s[c].default;o(i,c,a,l=>console.error(`Conflict in default settings: ${l}`))}return i}e.getDefaultValues=r;function n(i){return`[${i}]`}e.keyFromOverrideIdentifier=n;function t(i,s,c){const a=i.inspect(s),l=i.inspect(c);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:a.defaultValue}e.getMigratedSettingValue=t}),define(Z[160],ee([0,1,32,37,18,15,26,4,39,24,35,2,3]),function(K,e,S,k,A,L,U,T,f,v,R,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class I{constructor(t={},i=[],s=[]){this._contents=t,this._keys=i,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,v.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const s=this.getContentsForOverrideIdentifer(i);return s?t?(0,v.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const c of A.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[c],l=i[c];l&&(typeof a=="object"&&typeof l=="object"?(a=U.deepClone(a),this.mergeContents(a,l)):a=l),s[c]=a}return new I(s,this.keys,this.overrides)}merge(...t){const i=U.deepClone(this.contents),s=U.deepClone(this.overrides),c=[...this.keys];for(const a of t){this.mergeContents(i,a.contents);for(const l of a.overrides){const[h]=s.filter(g=>A.equals(g.identifiers,l.identifiers));h?this.mergeContents(h.contents,l.contents):s.push(U.deepClone(l))}for(const l of a.keys)c.indexOf(l)===-1&&c.push(l)}return new I(i,c,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const s of Object.keys(i)){if(s in t&&L.isObject(t[s])&&L.isObject(i[s])){this.mergeContents(t[s],i[s]);continue}t[s]=U.deepClone(i[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?U.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,v.addToValueTree)(this.contents,t,i,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,v.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let s=0;s<i;s++)t.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=I;class o extends I{constructor(){const t=(0,v.getDefaultValues)(),i=(0,v.getConfigurationKeys)(),s=[];for(const c of Object.keys(t))f.OVERRIDE_PROPERTY_PATTERN.test(c)&&s.push({identifiers:[(0,f.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(t[c]),contents:(0,v.toValuesTree)(t[c],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,i,s)}}e.DefaultConfigurationModel=o;class C{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new I}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!L.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:s,keys:c,overrides:a,untrusted:l}=this.doParseRaw(t,i);this._configurationModel=new I(s,c,a),this._untrustedConfigurations=l||[]}doParseContent(t){let i={},s=null,c=[],a=[],l=[];function h(w){Array.isArray(c)?c.push(w):s&&(c[s]=w)}let g={onObjectBegin:()=>{let w={};h(w),a.push(c),c=w,s=null},onObjectProperty:w=>{s=w},onObjectEnd:()=>{c=a.pop()},onArrayBegin:()=>{let w=[];h(w),a.push(c),c=w,s=null},onArrayEnd:()=>{c=a.pop()},onLiteralValue:h,onError:(w,u,P)=>{l.push({error:w,offset:u,length:P})}};if(t)try{S.visit(t,g),i=c[0]||{}}catch(w){console.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return i}doParseRaw(t,i){const s=R.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),c=this.filter(t,s,!0,i);t=c.raw;const a=(0,v.toValuesTree)(t,g=>console.error(`Conflict in settings file ${this._name}: ${g}`)),l=Object.keys(t),h=(0,v.toOverrides)(t,g=>console.error(`Conflict in settings file ${this._name}: ${g}`));return{contents:a,keys:l,overrides:h,untrusted:c.untrusted}}filter(t,i,s,c){if(!(c==null?void 0:c.scopes)&&!(c==null?void 0:c.isUntrusted))return{raw:t,untrusted:[]};const a={},l=[];for(let h in t)if(f.OVERRIDE_PROPERTY_PATTERN.test(h)&&s){const g=this.filter(t[h],i,!1,c);a[h]=g.raw,l.push(...g.untrusted)}else{const g=i[h],w=g?typeof g.scope!="undefined"?g.scope:3:void 0;(w===void 0||c.scopes===void 0||c.scopes.includes(w))&&(c.isUntrusted&&(g==null?void 0:g.requireTrust)?l.push(h):a[h]=t[h])}return{raw:a,untrusted:l}}}e.ConfigurationModelParser=C;class b extends d.Disposable{constructor(t,i,s,c){super();this.userSettingsResource=t,this.scopes=i,this.fileService=c,this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new C(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(y.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new I}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=b;class E{constructor(t,i,s=new I,c=new I,a=new k.ResourceMap,l=new I,h=new k.ResourceMap,g=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=c,this._folderConfigurations=a,this._memoryConfiguration=l,this._memoryConfigurationByResource=h,this._freeze=g,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(t)}updateValue(t,i,s={}){let c;s.resource?(c=this._memoryConfigurationByResource.get(s.resource),c||(c=new I,this._memoryConfigurationByResource.set(s.resource,c))):c=this._memoryConfiguration,i===void 0?c.removeValue(t):c.setValue(t,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,s){const c=this.getConsolidateConfigurationModel(i,s),a=this.getFolderConfigurationModelForResource(i.resource,s),l=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,h=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),g=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),w=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),u=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),P=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,_=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,z=i.overrideIdentifier?l.override(i.overrideIdentifier).getValue(t):l.getValue(t),B=c.getValue(t),M=A.distinct(A.flatten(c.overrides.map(j=>j.identifiers))).filter(j=>c.getOverrideValue(t,j)!==void 0);return{defaultValue:h,userValue:g,userLocalValue:w,userRemoteValue:u,workspaceValue:P,workspaceFolderValue:_,memoryValue:z,value:B,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:g!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:w!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:u!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:P!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:_!==void 0?{value:a==null?void 0:a.freeze().getValue(t),override:i.overrideIdentifier?a==null?void 0:a.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:l.getValue(t),override:i.overrideIdentifier?l.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:M.length?M:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=i.filter(c=>f.OVERRIDE_PROPERTY_PATTERN.test(c)).map(c=>{const a=(0,f.overrideIdentifierFromKey)(c),l=this._defaultConfiguration.getKeysForOverrideIdentifier(a),h=t.getKeysForOverrideIdentifier(a),g=[...h.filter(w=>l.indexOf(w)===-1),...l.filter(w=>h.indexOf(w)===-1),...l.filter(w=>!U.equals(this._defaultConfiguration.override(a).getValue(w),t.override(a).getValue(w)))];return[a,g]});return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:c,overrides:a}=(0,v.compare)(this.localUserConfiguration,t),l=[...i,...s,...c];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:c,overrides:a}=(0,v.compare)(this.remoteUserConfiguration,t);let l=[...i,...s,...c];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:c,overrides:a}=(0,v.compare)(this.workspaceConfiguration,t);let l=[...i,...s,...c];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:a}}compareAndUpdateFolderConfiguration(t,i){const s=this.folderConfigurations.get(t),{added:c,updated:a,removed:l,overrides:h}=(0,v.compare)(s,i);let g=[...c,...a,...l];return(g.length||!s)&&this.updateFolderConfiguration(t,i),{keys:g,overrides:h}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:c,removed:a,overrides:l}=(0,v.compare)(i,void 0);return{keys:[...s,...c,...a],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let s=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const c=i.getFolder(t);c&&(s=this.getFolderConsolidatedConfiguration(c.uri)||s);const a=this._memoryConfigurationByResource.get(t);a&&(s=s.merge(a))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(t);c?(i=s.merge(c),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=s}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:s,overrides:c,keys:a}=this._folderConfigurations.get(i);return t.push([i,{contents:s,overrides:c,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(c=>i.add(c))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),c=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((l,h)=>(l.set(T.URI.revive(h[0]),this.parseConfigurationModel(h[1])),l),new k.ResourceMap);return new E(i,s,new I,c,a,new I,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new I(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=E;function p(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const t=new Set,i=new Map;for(const c of n)c.keys.forEach(a=>t.add(a)),c.overrides.forEach(([a,l])=>{const h=(0,k.getOrSet)(i,a,new Set);l.forEach(g=>h.add(g))});const s=[];return i.forEach((c,a)=>s.push([a,[...c.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=p;class m{constructor(t,i,s,c){this.change=t,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=c,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(h=>a.add(h)),t.overrides.forEach(([,h])=>h.forEach(g=>a.add(g))),this.affectedKeys=[...a.values()];const l=new I;this.affectedKeys.forEach(h=>l.setValue(h,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const c=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,a=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!U.equals(c,a)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let s=(0,v.toValuesTree)({[i]:!0},()=>{}),c;for(;typeof s=="object"&&(c=Object.keys(s)[0]);){if(t=t[c],!t)return!1;s=s[c]}return!0}}e.ConfigurationChangeEvent=m;class r extends m{constructor(t,i,s,c){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=s,this.sourceConfig=c}}e.AllKeysConfigurationChangeEvent=r}),define(Z[161],ee([0,1,35,39,2,24,160,3,6,12]),function(K,e,S,k,A,L,U,T,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class R extends A.Disposable{constructor(y,I){super();this.settingsResource=y,this._onDidChangeConfiguration=this._register(new T.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new U.UserSettings(this.settingsResource,void 0,v.extUriBiasedIgnorePathCase,I)),this.configuration=new U.Configuration(new U.DefaultConfigurationModel,new U.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new f.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(S.Registry.as(k.Extensions.Configuration).onDidUpdateConfiguration(o=>this.onDidDefaultConfigurationChange(o))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const y=await this.userConfiguration.loadConfiguration();this.configuration=new U.Configuration(new U.DefaultConfigurationModel,y)}getConfigurationData(){return this.configuration.toData()}getValue(y,I){const o=typeof y=="string"?y:void 0,C=(0,L.isConfigurationOverrides)(y)?y:(0,L.isConfigurationOverrides)(I)?I:{};return this.configuration.getValue(o,C,void 0)}updateValue(y,I,o,C){return Promise.reject(new Error("not supported"))}inspect(y){return this.configuration.inspect(y,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const y=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(y)}onDidChangeUserConfiguration(y){const I=this.configuration.toData(),o=this.configuration.compareAndUpdateLocalUserConfiguration(y);this.trigger(o,I,1)}onDidDefaultConfigurationChange(y){const I=this.configuration.toData(),o=this.configuration.compareAndUpdateDefaultConfiguration(new U.DefaultConfigurationModel,y);this.trigger(o,I,6)}trigger(y,I,o){const C=new U.ConfigurationChangeEvent(y,{data:I},this.configuration);C.source=o,C.sourceConfig=this.getTargetConfiguration(o),this._onDidChangeConfiguration.fire(C)}getTargetConfiguration(y){switch(y){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=R}),define(Z[162],ee([0,1,24,17,100]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(T,f){this.configurationService=T,this.logService=f}request(T,f){return this.logService.trace("RequestService#request",T.url),T.proxyAuthorization||(T.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,A.request)(T,f)}async resolveProxy(T){}};L=he([Y(0,S.IConfigurationService),Y(1,k.ILogService)],L),e.RequestService=L}),define(Z[40],ee([0,1,117,5,39,35,22]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function T(o){return o.res.statusCode&&o.res.statusCode>=200&&o.res.statusCode<300||o.res.statusCode===1223}e.isSuccess=T;function f(o){return o.res.statusCode===204}async function v(o){if(!T(o))throw new Error("Server returned "+o.res.statusCode);return f(o)?null:(await(0,U.streamToBuffer)(o.stream)).toString()}e.asText=v;async function R(o){if(!T(o))throw new Error("Server returned "+o.res.statusCode);if(f(o))return null;const b=(await(0,U.streamToBuffer)(o.stream)).toString();try{return JSON.parse(b)}catch(E){throw E.message+=`:
`+b,E}}e.asJson=R;function d(o){I(o)}e.updateProxyConfigurationsScope=d;let y;function I(o){const C=L.Registry.as(A.Extensions.Configuration);y&&C.deregisterConfigurations([y]),y={id:"http",order:15,title:(0,S.localize)(0,null),type:"object",scope:o,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,S.localize)(1,null),requireTrust:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,S.localize)(2,null),requireTrust:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,S.localize)(3,null),requireTrust:!0},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[(0,S.localize)(4,null),(0,S.localize)(5,null),(0,S.localize)(6,null)],default:"override",description:(0,S.localize)(7,null),requireTrust:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,S.localize)(8,null),requireTrust:!0}}},C.registerConfiguration(y)}I(2)}),define(Z[163],ee([0,1,40,30,10,16]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let U=class{constructor(f,v){this.requestService=f,this.fileService=v}async download(f,v,R=k.CancellationToken.None){if(f.scheme===L.Schemas.file||f.scheme===L.Schemas.vscodeRemote){await this.fileService.copy(f,v);return}const d={type:"GET",url:f.toString()},y=await this.requestService.request(d,R);if(y.res.statusCode===200)await this.fileService.writeFile(v,y.stream);else{const I=await(0,S.asText)(y);throw new Error(`Expected 200, got back ${y.res.statusCode} instead.

${I}`)}}};U=he([Y(0,S.IRequestService),Y(1,A.IFileService)],U),e.DownloadService=U}),define(Z[164],ee([0,1,28,10,18,62,40,30,17,12,128,2]),function(K,e,S,k,A,L,U,T,f,v,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let y=class extends d.Disposable{constructor(o,C,b,E){super();this.fileService=o,this.productService=C,this.requestService=b,this.logService=E,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,L.forEach)(this.productService.configBasedExtensionTips,({value:p})=>this.allConfigBasedTips.set(p.configPath,p))}getConfigBasedTips(o){return this.getValidConfigBasedTips(o)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(o){const C=[];for(const[b,E]of this.allConfigBasedTips)try{const p=await this.fileService.readFile((0,v.joinPath)(o,b)),m=new Map;(0,L.forEach)(E.recommendations,({key:n,value:t})=>{if((0,A.isNonEmptyArray)(t.remotes))for(const i of t.remotes)m.set(i,{extensionId:n,extensionName:t.name,configName:E.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else C.push({extensionId:n,extensionName:t.name,configName:E.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const r=(0,R.getDomainsOfRemotes)(p.value.toString(),[...m.keys()]);for(const n of r){const t=m.get(n);t&&C.push(t)}}catch(p){}return C}async fetchWorkspacesTips(){var o,C;if(!((o=this.productService.extensionsGallery)===null||o===void 0?void 0:o.recommendationsUrl))return[];try{const b=await this.requestService.request({type:"GET",url:(C=this.productService.extensionsGallery)===null||C===void 0?void 0:C.recommendationsUrl},T.CancellationToken.None);if(b.res.statusCode!==200)return[];const E=await(0,U.asJson)(b);return E?E.workspaceRecommendations||[]:[]}catch(b){return this.logService.error(b),[]}}};y=he([Y(0,k.IFileService),Y(1,S.IProductService),Y(2,U.IRequestService),Y(3,f.ILogService)],y),e.ExtensionTipsService=y}),define(Z[44],ee([0,1,31,22]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function A(L,U,T){let f=T&&T.get("storage.serviceMachineId",0)||null;if(f)return f;try{const R=(await U.readFile(L.serviceMachineIdResource)).value.toString();f=(0,S.isUUID)(R)?R:null}catch(v){f=null}if(!f){f=(0,S.generateUuid)();try{await U.writeFile(L.serviceMachineIdResource,k.VSBuffer.fromString(f))}catch(v){}}return T&&T.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=A}),define(Z[19],ee([0,1,5,3,2,15,67,6]),function(K,e,S,k,A,L,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,S.createDecorator)("storageService");var v;(function(C){C[C.NONE=0]="NONE",C[C.SHUTDOWN=1]="SHUTDOWN"})(v=e.WillSaveStateReason||(e.WillSaveStateReason={}));var R;(function(C){C[C.GLOBAL=0]="GLOBAL",C[C.WORKSPACE=1]="WORKSPACE"})(R=e.StorageScope||(e.StorageScope={}));var d;(function(C){C[C.USER=0]="USER",C[C.MACHINE=1]="MACHINE"})(d=e.StorageTarget||(e.StorageTarget={}));class y extends A.Disposable{constructor(b={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=b,this._onDidChangeValue=this._register(new k.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new k.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new k.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new A.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,A.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,E){E===f?(b===0?this._globalKeyTargets=void 0:b===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:b})):this._onDidChangeValue.fire({scope:b,key:E,target:this.getKeyTargets(b)[E]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,E,p){var m;return(m=this.getStorage(E))===null||m===void 0?void 0:m.get(b,p)}getBoolean(b,E,p){var m;return(m=this.getStorage(E))===null||m===void 0?void 0:m.getBoolean(b,p)}getNumber(b,E,p){var m;return(m=this.getStorage(E))===null||m===void 0?void 0:m.getNumber(b,p)}store(b,E,p,m){if((0,L.isUndefinedOrNull)(E)){this.remove(b,p);return}this.withPausedEmitters(()=>{var r;this.updateKeyTarget(b,p,m),(r=this.getStorage(p))===null||r===void 0||r.set(b,E)})}remove(b,E){this.withPausedEmitters(()=>{var p;this.updateKeyTarget(b,E,void 0),(p=this.getStorage(E))===null||p===void 0||p.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,E){const p=[],m=this.getKeyTargets(b);for(const r of Object.keys(m))m[r]===E&&p.push(r);return p}updateKeyTarget(b,E,p){var m,r;const n=this.getKeyTargets(E);typeof p=="number"?n[b]!==p&&(n[b]=p,(m=this.getStorage(E))===null||m===void 0||m.set(f,JSON.stringify(n))):typeof n[b]=="number"&&(delete n[b],(r=this.getStorage(E))===null||r===void 0||r.set(f,JSON.stringify(n)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(b){return b===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(b){const E=this.get(f,b);if(E)try{return JSON.parse(E)}catch(p){}return Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(){var b,E,p,m;this._onWillSaveState.fire({reason:v.NONE}),await T.Promises.settled([(E=(b=this.getStorage(0))===null||b===void 0?void 0:b.whenFlushed())!==null&&E!==void 0?E:Promise.resolve(),(m=(p=this.getStorage(1))===null||p===void 0?void 0:p.whenFlushed())!==null&&m!==void 0?m:Promise.resolve()])}async logStorage(){var b,E,p,m,r,n;const t=(E=(b=this.getStorage(0))===null||b===void 0?void 0:b.items)!==null&&E!==void 0?E:new Map,i=(m=(p=this.getStorage(1))===null||p===void 0?void 0:p.items)!==null&&m!==void 0?m:new Map;return o(t,i,(r=this.getLogDetails(0))!==null&&r!==void 0?r:"",(n=this.getLogDetails(1))!==null&&n!==void 0?n:"")}}e.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class I extends y{constructor(){super();this.globalStorage=new U.Storage(new U.InMemoryStorageDatabase),this.workspaceStorage=new U.Storage(new U.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.globalStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b)))}getStorage(b){return b===0?this.globalStorage:this.workspaceStorage}getLogDetails(b){return b===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(b){}}e.InMemoryStorageService=I;async function o(C,b,E,p){const m=a=>{try{return JSON.parse(a)}catch(l){return a}},r=new Map,n=new Map;C.forEach((a,l)=>{r.set(l,a),n.set(l,m(a))});const t=new Map,i=new Map;b.forEach((a,l)=>{t.set(l,a),i.set(l,m(a))}),console.group(`Storage: Global (path: ${E})`);let s=[];r.forEach((a,l)=>{s.push({key:l,value:a})}),console.table(s),console.groupEnd(),console.log(n),console.group(`Storage: Workspace (path: ${p})`);let c=[];t.forEach((a,l)=>{c.push({key:l,value:a})}),console.table(c),console.groupEnd(),console.log(i)}e.logStorage=o}),define(Z[165],ee([0,1,3,2,29,33,19,15]),function(K,e,S,k,A,L,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let f=class extends k.Disposable{constructor(d){super();this._onDidChangeEnablement=new S.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new v(d)),this._register(this.storageManger.onDidChange(y=>this._onDidChangeEnablement.fire({extensions:y,source:"storage"})))}async enableExtension(d,y){return this._removeFromDisabledExtensions(d)?(this._onDidChangeEnablement.fire({extensions:[d],source:y}),!0):!1}async disableExtension(d,y){return this._addToDisabledExtensions(d)?(this._onDidChangeEnablement.fire({extensions:[d],source:y}),!0):!1}getDisabledExtensions(){return this._getExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(d){let y=this.getDisabledExtensions();return y.every(I=>!(0,L.areSameExtensions)(I,d))?(y.push(d),this._setDisabledExtensions(y),!0):!1}_removeFromDisabledExtensions(d){let y=this.getDisabledExtensions();for(let I=0;I<y.length;I++){const o=y[I];if((0,L.areSameExtensions)(o,d))return y.splice(I,1),this._setDisabledExtensions(y),!0}return!1}_setDisabledExtensions(d){this._setExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH,d)}_getExtensions(d){return this.storageManger.get(d,0)}_setExtensions(d,y){this.storageManger.set(d,y,0)}};f=he([Y(0,U.IStorageService)],f),e.GlobalExtensionEnablementService=f;class v extends k.Disposable{constructor(d){super();this.storageService=d,this.storage=Object.create(null),this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event,this._register(d.onDidChangeValue(y=>this.onDidStorageChange(y)))}get(d,y){let I;return y===0?((0,T.isUndefinedOrNull)(this.storage[d])&&(this.storage[d]=this._get(d,y)),I=this.storage[d]):I=this._get(d,y),JSON.parse(I)}set(d,y,I){let o=JSON.stringify(y.map(({id:b,uuid:E})=>({id:b,uuid:E})));this._get(d,I)!==o&&(I===0&&(y.length?this.storage[d]=o:delete this.storage[d]),this._set(d,y.length?o:void 0,I))}onDidStorageChange(d){if(d.scope===0&&!(0,T.isUndefinedOrNull)(this.storage[d.key])&&this._get(d.key,d.scope)!==this.storage[d.key]){const I=this.get(d.key,d.scope);delete this.storage[d.key];const o=this.get(d.key,d.scope),C=I.filter(E=>!o.some(p=>(0,L.areSameExtensions)(E,p))),b=o.filter(E=>!I.some(p=>(0,L.areSameExtensions)(p,E)));(C.length||b.length)&&this._onDidChange.fire([...C,...b])}}_get(d,y){return this.storageService.get(d,y,"[]")}_set(d,y,I){y?this.storageService.store(d,y,I,1):this.storageService.remove(d,I)}}e.StorageManager=v}),define(Z[166],ee([0,1,3,2]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class A extends k.Disposable{constructor(v,R){super();this.channel=v,this.workspace=R}async getItems(){const v={workspace:this.workspace},R=await this.channel.call("getItems",v);return new Map(R)}updateItems(v){const R={workspace:this.workspace};return v.insert&&(R.insert=Array.from(v.insert.entries())),v.delete&&(R.delete=Array.from(v.delete.values())),this.channel.call("updateItems",R)}}class L extends A{constructor(v){super(v,void 0);this._onDidChangeItemsExternal=this._register(new S.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(v=>this.onDidChangeGlobalStorage(v)))}onDidChangeGlobalStorage(v){(Array.isArray(v.changed)||Array.isArray(v.deleted))&&this._onDidChangeItemsExternal.fire({changed:v.changed?new Map(v.changed):void 0,deleted:v.deleted?new Set(v.deleted):void 0})}async close(){this.dispose()}}class U extends A{constructor(v,R){super(v,R);this.onDidChangeItemsExternal=S.Event.None}async close(){const v={workspace:this.workspace};return this.channel.call("close",v)}}class T extends k.Disposable{constructor(v,R){super();this.channel=v,this.workspace=R,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new L(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new U(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=T}),define(Z[167],ee([0,1,2,19,67,6,155,166,12]),function(K,e,S,k,A,L,U,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class v extends k.AbstractStorageService{constructor(d,y,I){super();this.mainProcessService=y,this.environmentService=I,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new S.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(d)}createGlobalStorage(){const d=new T.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),y=new A.Storage(d.globalStorage);return this._register(y.onDidChangeStorage(I=>this.emitDidChangeValue(0,I))),y}createWorkspaceStorage(d){const y=new T.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),d);if(y.workspaceStorage){const I=new A.Storage(y.workspaceStorage);return this.workspaceStorageDisposable.value=I.onDidChangeStorage(o=>this.emitDidChangeValue(1,o)),this.workspaceStorageId=d==null?void 0:d.id,I}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){var d,y;(0,U.mark)("code/willInitStorage");try{await L.Promises.settled([this.globalStorage.init(),(y=(d=this.workspaceStorage)===null||d===void 0?void 0:d.init())!==null&&y!==void 0?y:Promise.resolve()])}finally{(0,U.mark)("code/didInitStorage")}}getStorage(d){return d===0?this.globalStorage:this.workspaceStorage}getLogDetails(d){return d===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,f.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){var d,y;this.stopFlushWhenIdle(),this.emitWillSaveState(k.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.globalStorage.close(),(y=(d=this.workspaceStorage)===null||d===void 0?void 0:d.close())!==null&&y!==void 0?y:Promise.resolve()])}async migrate(d){var y;const I=this.workspaceStorage,o=(y=I==null?void 0:I.items)!==null&&y!==void 0?y:new Map;I&&(await I.close(),I.dispose()),this.workspaceStorage=this.createWorkspaceStorage(d),await this.workspaceStorage.init();for(const[C,b]of o)this.workspaceStorage.set(C,b)}}e.NativeStorageService=v}),define(Z[168],ee([0,1,7,36,31,4]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;async function U(f,v,R,d,y,I,o,C,b){const E=Object.create(null);E["common.machineId"]=I,E.sessionID=(0,A.generateUuid)()+Date.now(),E.commitHash=d,E.version=y,E["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,S.PlatformToString)(S.platform),E["common.nodePlatform"]=k.platform,E["common.nodeArch"]=R,E["common.product"]=b||"desktop";const p=T(o||[]);p&&(E["common.msftInternal"]=p);let m=0;const r=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>m++,enumerable:!0}}),S.isLinuxSnap&&(E["common.snap"]="true");try{const n=await f.readFile(L.URI.file(C));E["common.source"]=n.value.toString().slice(0,30)}catch(n){}return E}e.resolveCommonProperties=U;function T(f){const v=k.env.USERDNSDOMAIN;if(!v)return!1;const R=v.toLowerCase();return f.some(d=>R===d)}}),define(Z[25],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[169],ee([0,1,38,92,69,27,8,32,95,28,7,4,25,52,16,10,23]),function(K,e,S,k,A,L,U,T,f,v,R,d,y,I,o,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function E(t,i){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],c=new Map,a=new Map,l=2e4;function h(u,P,_,z){const B=P.substring(u.length+1);return new Promise(async M=>{var j,W,$;let H;try{H=await(0,b.readdir)(P,{withFileTypes:!0})}catch(O){M();return}if(z.count>=l){z.count+=H.length,z.maxReached=!0,M();return}let q=H.length;if(q===0){M();return}let D=H;z.count+H.length>l&&(z.maxReached=!0,q=l-z.count,D=H.slice(0,q)),z.count+=H.length;for(const O of D)if(O.isDirectory()){if(_.includes(O.name)||await h(u,(0,U.join)(P,O.name),_,z),--q==0){M();return}}else{const F=O.name.lastIndexOf(".");if(F>=0){const N=O.name.substring(F+1);N&&c.set(N,((j=c.get(N))!==null&&j!==void 0?j:0)+1)}for(const N of s)((W=N.relativePathPattern)===null||W===void 0?void 0:W.test(B))!==!1&&N.filePattern.test(O.name)&&a.set(N.tag,(($=a.get(N.tag))!==null&&$!==void 0?$:0)+1);if(--q==0){M();return}}})}const g={count:0,maxReached:!1};await h(t,t,i,g);const w=await r(t);return{configFiles:p(a),fileTypes:p(c),fileCount:g.count,maxFilesReached:g.maxReached,launchConfigFiles:w}}e.collectWorkspaceStats=E;function p(t){return[...I.Iterable.map(t.entries(),([i,s])=>({name:i,count:s}))].sort((i,s)=>s.count-i.count)}function m(){const t={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/C.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/C.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(k.virtualMachineHint.value()*100)}%`},i=S.cpus();return i&&i.length>0&&(t.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),t}e.getMachineInfo=m;function r(t){let i=new Map,s=(0,U.join)(t,".vscode","launch.json");return new Promise((c,a)=>{(0,L.exists)(s,l=>{if(l)(0,L.readFile)(s,(h,g)=>{if(h)return c([]);const w=[],u=(0,T.parse)(g.toString(),w);if(w.length)return console.log(`Unable to parse ${s}`),c([]);if((0,T.getNodeType)(u)==="object"&&u.configurations)for(const P of u.configurations){const _=P.type;_&&(i.has(_)?i.set(_,i.get(_)+1):i.set(_,1))}return c(p(i))});else return c([])})})}e.collectLaunchConfigs=r;let n=class{constructor(i,s){this.telemetryService=i,this.productService=s}formatMachineInfo(i){const s=[];return s.push(`OS Version:       ${i.os}`),s.push(`CPUs:             ${i.cpus}`),s.push(`Memory (System):  ${i.memory}`),s.push(`VM:               ${i.vmHint}`),s.join(`
`)}formatEnvironment(i){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const c=S.cpus();return c&&c.length>0&&s.push(`CPUs:             ${c[0].model} (${c.length} x ${c[0].speed})`),s.push(`Memory (System):  ${(S.totalmem()/C.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/C.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||s.push(`Load (avg):       ${S.loadavg().map(a=>Math.round(a)).join(", ")}`),s.push(`VM:               ${Math.round(k.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${i.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(i,s){return Promise.all([(0,f.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async c=>{let[a,l]=c,h=this.formatProcessList(i,a);return s.forEach(g=>{if((0,A.isRemoteDiagnosticError)(g))h+=`
${g.errorMessage}`,l+=`
${g.errorMessage}`;else if(h+=`

Remote: ${g.hostName}`,g.processes&&(h+=`
${this.formatProcessList(i,g.processes)}`),g.workspaceMetadata){l+=`
|  Remote: ${g.hostName}`;for(const w of Object.keys(g.workspaceMetadata)){const u=g.workspaceMetadata[w];let P=`${u.fileCount} files`;u.maxFilesReached&&(P=`more than ${P}`),l+=`|    Folder (${w}): ${P}`,l+=this.formatWorkspaceStats(u)}}}),{processInfo:h,workspaceInfo:l}})}async getSystemInfo(i,s){const{memory:c,vmHint:a,os:l,cpus:h}=m(),g={os:l,memory:c,cpus:h,vmHint:a,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:s};return R.isWindows||(g.load=`${S.loadavg().map(w=>Math.round(w)).join(", ")}`),R.isLinux&&(g.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(g)}async getDiagnostics(i,s){const c=[];return(0,f.listProcesses)(i.mainPID).then(async a=>(c.push(""),c.push(this.formatEnvironment(i)),c.push(""),c.push(this.formatProcessList(i,a)),i.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(c.push(""),c.push("Workspace Stats: "),c.push(await this.formatWorkspaceMetadata(i))),s.forEach(l=>{if((0,A.isRemoteDiagnosticError)(l))c.push(`
${l.errorMessage}`);else if(c.push(`

`),c.push(`Remote:           ${l.hostName}`),c.push(this.formatMachineInfo(l.machineInfo)),l.processes&&c.push(this.formatProcessList(i,l.processes)),l.workspaceMetadata)for(const h of Object.keys(l.workspaceMetadata)){const g=l.workspaceMetadata[h];let w=`${g.fileCount} files`;g.maxFilesReached&&(w=`more than ${w}`),c.push(`Folder (${h}): ${w}`),c.push(this.formatWorkspaceStats(g))}}),c.push(""),c.push(""),c.join(`
`)))}formatWorkspaceStats(i){const s=[],c=60;let a=0;const l=(u,P)=>{const _=` ${u}(${P})`;a+_.length>c?(s.push(h),h="|                 ",a=h.length):a+=_.length,h+=_};let h="|      File types:";const g=10;let w=i.fileTypes.length>g?g:i.fileTypes.length;for(let u=0;u<w;u++){const P=i.fileTypes[u];l(P.name,P.count)}if(s.push(h),i.configFiles.length>=0&&(h="|      Conf files:",a=0,i.configFiles.forEach(u=>{l(u.name,u.count)}),s.push(h)),i.launchConfigFiles.length>0){let u="|      Launch Configs:";i.launchConfigFiles.forEach(P=>{u+=P.count>1?` ${P.name}(${P.count})`:` ${P.name}`}),s.push(u)}return s.join(`
`)}expandGPUFeatures(i){const s=Math.max(...Object.keys(i).map(c=>c.length));return Object.keys(i).map(c=>`${c}:  ${" ".repeat(s-c.length)}  ${i[c]}`).join(`
                  `)}formatWorkspaceMetadata(i){const s=[],c=[];return i.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(s.push(`|  Window (${a.title})`),a.folderURIs.forEach(l=>{const h=d.URI.revive(l);if(h.scheme===o.Schemas.file){const g=h.fsPath;c.push(E(g,["node_modules",".git"]).then(w=>{let u=`${w.fileCount} files`;w.maxFilesReached&&(u=`more than ${u}`),s.push(`|    Folder (${(0,U.basename)(g)}): ${u}`),s.push(this.formatWorkspaceStats(w))}).catch(w=>{s.push(`|      Error: Unable to collect workspace stats for folder ${g} (${w.toString()})`)}))}else s.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(c).then(a=>s.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(i,s){const c=new Map;i.windows.forEach(l=>c.set(l.pid,l.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(i.mainPID,c,a,s,0),a.join(`
`)}formatProcessItem(i,s,c,a,l){const h=l===0;let g;h?g=a.pid===i?`${this.productService.applicationName} main`:"remote agent":(g=`${"  ".repeat(l)} ${a.name}`,a.name==="window"&&(g=`${g} (${s.get(a.pid)})`));const w=process.platform==="win32"?a.mem:S.totalmem()*(a.mem/100);c.push(`${a.load.toFixed(0).padStart(5," ")}	${(w/C.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${g}`),Array.isArray(a.children)&&a.children.forEach(u=>this.formatProcessItem(i,s,c,u,l+1))}async reportWorkspaceStats(i){for(const{uri:s}of i.folders){const c=d.URI.revive(s);if(c.scheme===o.Schemas.file){const a=c.fsPath;try{const l=await E(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),l.fileTypes.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:h.name,count:h.count})}),l.launchConfigFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:h.name,count:h.count})}),l.configFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:h.name,count:h.count})})}catch(l){}}}}};n=he([Y(0,y.ITelemetryService),Y(1,v.IProductService)],n),e.DiagnosticsService=n}),define(Z[170],ee([0,1,11,29,33,26,25,40,68,9,30,17,10,4,28,19,44,5,12]),function(K,e,S,k,A,L,U,T,f,v,R,d,y,I,o,C,b,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var m;(function(D){D[D.None=0]="None",D[D.IncludeVersions=1]="IncludeVersions",D[D.IncludeFiles=2]="IncludeFiles",D[D.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",D[D.IncludeSharedAccounts=8]="IncludeSharedAccounts",D[D.IncludeVersionProperties=16]="IncludeVersionProperties",D[D.ExcludeNonValidated=32]="ExcludeNonValidated",D[D.IncludeInstallationTargets=64]="IncludeInstallationTargets",D[D.IncludeAssetUri=128]="IncludeAssetUri",D[D.IncludeStatistics=256]="IncludeStatistics",D[D.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",D[D.Unpublished=4096]="Unpublished"})(m||(m={}));function r(...D){return String(D.reduce((O,F)=>O|F,0))}var n;(function(D){D[D.Tag=1]="Tag",D[D.ExtensionId=4]="ExtensionId",D[D.Category=5]="Category",D[D.ExtensionName=7]="ExtensionName",D[D.Target=8]="Target",D[D.Featured=9]="Featured",D[D.SearchText=10]="SearchText",D[D.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},c={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:m.None,criteria:[],assetTypes:[]};class a{constructor(O=c){this.state=O}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(O,F=this.state.pageSize){return new a(Object.assign(Object.assign({},this.state),{pageNumber:O,pageSize:F}))}withFilter(O,...F){const N=[...this.state.criteria,...F.length?F.map(V=>({filterType:O,value:V})):[{filterType:O}]];return new a(Object.assign(Object.assign({},this.state),{criteria:N}))}withSortBy(O){return new a(Object.assign(Object.assign({},this.state),{sortBy:O}))}withSortOrder(O){return new a(Object.assign(Object.assign({},this.state),{sortOrder:O}))}withFlags(...O){return new a(Object.assign(Object.assign({},this.state),{flags:O.reduce((F,N)=>F|N,0)}))}withAssetTypes(...O){return new a(Object.assign(Object.assign({},this.state),{assetTypes:O}))}get raw(){const{criteria:O,pageNumber:F,pageSize:N,sortBy:V,sortOrder:G,flags:J,assetTypes:Q}=this.state;return{filters:[{criteria:O,pageNumber:F,pageSize:N,sortBy:V,sortOrder:G}],assetTypes:Q,flags:J}}get searchText(){const O=this.state.criteria.filter(F=>F.filterType===n.SearchText)[0];return O&&O.value?O.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(O=>String(O.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function l(D,O){const F=(D||[]).filter(N=>N.statisticName===O)[0];return F?F.value:0}function h(D){const O="Microsoft.VisualStudio.Code.Translation.";return D.files.filter(N=>N.assetType.indexOf(O)===0).reduce((N,V)=>{const G=P(D,V.assetType);return G&&N.push([V.assetType.substring(O.length),G]),N},[])}function g(D){if(D.properties){const O=D.properties.filter(V=>V.key===t.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),N=O.filter(V=>F.test(V.value))[0];return N?{uri:N.value,fallbackUri:N.value}:null}return P(D,t.Repository)}function w(D){return{uri:`${D.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${D.fallbackAssetUri}/${t.VSIX}`}}function u(D){const O=P(D,t.Icon);if(O)return O;const F=k.DefaultIconPath;return{uri:F,fallbackUri:F}}function P(D,O){return D.files.filter(N=>N.assetType===O)[0]?{uri:`${D.assetUri}/${O}`,fallbackUri:`${D.fallbackAssetUri}/${O}`}:null}function _(D,O){const F=D.properties?D.properties.filter(V=>V.key===O):[],N=F.length>0&&F[0].value;return N?N.split(",").map(V=>(0,A.adoptToGalleryExtensionId)(V)):[]}function z(D){const O=D.properties?D.properties.filter(F=>F.key===i.Engine):[];return O.length>0&&O[0].value||""}function B(D){const O=D.properties?D.properties.filter(N=>N.key===i.LocalizedLanguages):[],F=O.length>0&&O[0].value||"";return F?F.split(","):[]}function M(D){return D.indexOf("preview")!==-1}function j(D){const O=D.properties?D.properties.find(F=>F.key===i.WebExtension):void 0;return!!O&&O.value==="true"}function W(D){return D.files.some(O=>O.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,p.joinPath)(I.URI.parse(D.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function $(D,O,F,N,V){const G={manifest:P(O,t.Manifest),readme:P(O,t.Details),changelog:P(O,t.Changelog),license:P(O,t.License),repository:g(O),download:w(O),icon:u(O),coreTranslations:h(O)};return{identifier:{id:(0,A.getGalleryExtensionId)(D.publisher.publisherName,D.extensionName),uuid:D.extensionId},name:D.extensionName,version:O.version,date:O.lastUpdated,displayName:D.displayName,publisherId:D.publisher.publisherId,publisher:D.publisher.publisherName,publisherDisplayName:D.publisher.displayName,description:D.shortDescription||"",installCount:l(D.statistics,"install"),rating:l(D.statistics,"averagerating"),ratingCount:l(D.statistics,"ratingcount"),assetUri:I.URI.parse(O.assetUri),webResource:W(O),assetTypes:O.files.map(({assetType:J})=>J),assets:G,properties:{dependencies:_(O,i.Dependency),extensionPack:_(O,i.ExtensionPack),engine:z(O),localizedLanguages:B(O),webExtension:j(O)},telemetryData:{index:(N.pageNumber-1)*N.pageSize+F,searchText:N.searchText,querySource:V},preview:M(D.flags)}}let H=class{constructor(O,F,N,V,G,J,Q){this.requestService=O,this.logService=F,this.environmentService=N,this.telemetryService=V,this.fileService=G,this.productService=J;const ne=J.extensionsGallery;this.extensionsGalleryUrl=ne&&ne.serviceUrl,this.extensionsControlUrl=ne&&ne.controlUrl,this.commonHeadersPromise=q(J.version,this.environmentService,this.fileService,Q)}api(O=""){return`${this.extensionsGalleryUrl}${O}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(O,F){const N=[];let{total:V,firstPage:G,getPage:J}=await this.query({names:O,pageSize:O.length},F);N.push(...G);for(let Q=1;N.length<V&&(G=await J(Q,F),G.length);Q++)N.push(...G);return N}async getCompatibleExtension(O,F){const N=await this.getCompatibleExtensionByEngine(O,F);return(N==null?void 0:N.properties.webExtension)?N.webResource?N:null:N}async getCompatibleExtensionByEngine(O,F){const N=(0,k.isIExtensionIdentifier)(O)?null:O;if(N&&N.properties.engine&&(0,f.isEngineValid)(N.properties.engine,this.productService.version))return N;const{id:V,uuid:G}=N?N.identifier:O;let J=new a().withFlags(m.IncludeAssetUri,m.IncludeStatistics,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");G?J=J.withFilter(n.ExtensionId,G):J=J.withFilter(n.ExtensionName,V);const{galleryExtensions:Q}=await this.queryGallery(J,R.CancellationToken.None),[ne]=Q;if(!ne||!ne.versions.length)return null;if(F){const ce=ne.versions.filter(ue=>ue.version===F)[0];if(ce){const ue=$(ne,ce,0,J);if(ue.properties.engine&&(0,f.isEngineValid)(ue.properties.engine,this.productService.version))return ue}return null}const ie=await this.getLastValidExtensionVersion(ne,ne.versions);return ie?$(ne,ie,0,J):null}async query(O,F){const N=R.CancellationToken.isCancellationToken(O)?{}:O,V=R.CancellationToken.isCancellationToken(O)?O:F;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let G=N.text||"";const J=(0,L.getOrDefault)(N,ge=>ge.pageSize,50);let Q=new a().withFlags(m.IncludeLatestVersionOnly,m.IncludeAssetUri,m.IncludeStatistics,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,J).withFilter(n.Target,"Microsoft.VisualStudio.Code");G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,Ee,Ie)=>(Q=Q.withFilter(n.Category,Ie||Ee),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,Ee,Ie)=>(Q=Q.withFilter(n.Tag,Ie||Ee),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(Q=Q.withFilter(n.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),Q=Q.withFilter(n.SearchText,G)),Q=Q.withSortBy(0)):N.ids?Q=Q.withFilter(n.ExtensionId,...N.ids):N.names?Q=Q.withFilter(n.ExtensionName,...N.names):Q=Q.withSortBy(4),typeof N.sortBy=="number"&&(Q=Q.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(Q=Q.withSortOrder(N.sortOrder));const{galleryExtensions:ne,total:ie}=await this.queryGallery(Q,V),ce=ne.map((ge,Ee)=>$(ge,ge.versions[0],Ee,Q,N.source)),ue=async(ge,Ee)=>{if(Ee.isCancellationRequested)throw(0,S.canceled)();const Ie=Q.withPage(ge+1),{galleryExtensions:Te}=await this.queryGallery(Ie,Ee);return Te.map((Ae,Ue)=>$(Ae,Ae.versions[0],Ue,Ie,N.source))};return{firstPage:ce,total:ie,pageSize:Q.pageSize,getPage:ue}}async queryGallery(O,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");O=O.withFlags(O.flags,m.ExcludeNonValidated).withFilter(n.ExcludeWithFlags,r(m.Unpublished));const N=await this.commonHeadersPromise,V=JSON.stringify(O.raw),G=Object.assign(Object.assign({},N),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(V.length)}),J=new Date().getTime();let Q,ne,ie=0;try{if(Q=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:V,headers:G},F),Q.res.statusCode&&Q.res.statusCode>=400&&Q.res.statusCode<500)return{galleryExtensions:[],total:ie};const ce=await(0,T.asJson)(Q);if(ce){const ue=ce.results[0],ge=ue.extensions,Ee=ue.resultMetadata&&ue.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return ie=Ee&&Ee.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:ie}}return{galleryExtensions:[],total:ie}}catch(ce){throw ne=ce,ce}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},O.telemetryData),{requestBodySize:String(V.length),duration:new Date().getTime()-J,success:!!Q&&(0,T.isSuccess)(Q),responseBodySize:Q==null?void 0:Q.res.headers["Content-Length"],statusCode:Q?String(Q.res.statusCode):void 0,errorCode:ne?(0,S.isPromiseCanceledError)(ne)?"canceled":(0,S.getErrorMessage)(ne).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ie)}))}}async reportStatistic(O,F,N,V){if(!!this.isEnabled()){const G=await this.commonHeadersPromise,J=Object.assign(Object.assign({},G),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${O}/extensions/${F}/${N}/stats?statType=${V}`),headers:J},R.CancellationToken.None)}catch(Q){}}}async download(O,F,N){this.logService.trace("ExtensionGalleryService#download",O.identifier.id);const V=(0,A.getGalleryExtensionTelemetryData)(O),G=new Date().getTime(),J=ce=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},V),{duration:ce})),Q=N===1?"install":N===2?"update":"",ne=Q?{uri:`${O.assets.download.uri}&${Q}=true`,fallbackUri:`${O.assets.download.fallbackUri}?${Q}=true`}:O.assets.download,ie=await this.getAsset(ne);await this.fileService.writeFile(F,ie.stream),J(new Date().getTime()-G)}async getReadme(O,F){if(O.assets.readme){const N=await this.getAsset(O.assets.readme,{},F);return await(0,T.asText)(N)||""}return""}async getManifest(O,F){if(O.assets.manifest){const N=await this.getAsset(O.assets.manifest,{},F),V=await(0,T.asText)(N);return V?JSON.parse(V):null}return null}async getCoreTranslation(O,F){const N=O.assets.coreTranslations.filter(V=>V[0]===F.toUpperCase())[0];if(N){const V=await this.getAsset(N[1]),G=await(0,T.asText)(V);return G?JSON.parse(G):null}return null}async getChangelog(O,F){if(O.assets.changelog){const N=await this.getAsset(O.assets.changelog,{},F);return await(0,T.asText)(N)||""}return""}async getAllVersions(O,F){let N=new a().withFlags(m.IncludeVersions,m.IncludeFiles,m.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");O.identifier.uuid?N=N.withFilter(n.ExtensionId,O.identifier.uuid):N=N.withFilter(n.ExtensionName,O.identifier.id);const V=[],{galleryExtensions:G}=await this.queryGallery(N,R.CancellationToken.None);return G.length&&(F?await Promise.all(G[0].versions.map(async J=>{let Q;try{Q=await this.getEngine(J)}catch(ne){}Q&&(0,f.isEngineValid)(Q,this.productService.version)&&V.push({version:J.version,date:J.lastUpdated})})):V.push(...G[0].versions.map(J=>({version:J.version,date:J.lastUpdated})))),V}async getAsset(O,F={},N=R.CancellationToken.None){const V=await this.commonHeadersPromise,G={type:"GET"},J=Object.assign(Object.assign({},V),F.headers||{});F=Object.assign(Object.assign(Object.assign({},F),G),{headers:J});const Q=O.uri,ne=O.fallbackUri,ie=Object.assign(Object.assign({},F),{url:Q});try{const ce=await this.requestService.request(ie,N);if(ce.res.statusCode===200)return ce;const ue=await(0,T.asText)(ce);throw new Error(`Expected 200, got back ${ce.res.statusCode} instead.

${ue}`)}catch(ce){if((0,S.isPromiseCanceledError)(ce))throw ce;const ue=(0,S.getErrorMessage)(ce);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Q,message:ue});const ge=Object.assign(Object.assign({},F),{url:ne});return this.requestService.request(ge,N)}}async getLastValidExtensionVersion(O,F){const N=this.getLastValidExtensionVersionFromProperties(O,F);return N||this.getLastValidExtensionVersionRecursively(O,F)}getLastValidExtensionVersionFromProperties(O,F){for(const N of F){const V=z(N);if(!V)return null;if((0,f.isEngineValid)(V,this.productService.version))return N}return null}async getEngine(O){const F=z(O);if(F)return F;const N=P(O,t.Manifest);if(!N)throw new Error("Manifest was not found");const V={"Accept-Encoding":"gzip"},G=await this.getAsset(N,{headers:V}),J=await(0,T.asJson)(G);if(J)return J.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(O,F){if(!F.length)return null;const N=F[0],V=await this.getEngine(N);return(0,f.isEngineValid)(V,this.productService.version)?(N.properties=N.properties||[],N.properties.push({key:i.Engine,value:V}),N):this.getLastValidExtensionVersionRecursively(O,F.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const O=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(O.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await(0,T.asJson)(O),N=new Map;if(F)for(const V of F.malicious){const G=N.get(V)||{id:{id:V},malicious:!0,slow:!1};G.malicious=!0,N.set(V,G)}return[...N.values()]}};H=he([Y(0,T.IRequestService),Y(1,d.ILogService),Y(2,v.IEnvironmentService),Y(3,U.ITelemetryService),Y(4,y.IFileService),Y(5,o.IProductService),Y(6,(0,E.optional)(C.IStorageService))],H),e.ExtensionGalleryService=H;async function q(D,O,F,N){const V={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D}`},G=await(0,b.getServiceMachineId)(O,F,N);return V["X-Market-User-Id"]=G,V}e.resolveMarketplaceHeaders=q}),define(Z[171],ee([0,1,4,8,28,9,36,10,7,18,29,62,40,17,164,6,25,71,108,19,3,56]),function(K,e,S,k,A,L,U,T,f,v,R,d,y,I,o,C,b,E,p,m,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",i="extensionTips/lastPromptedMediumImpExeTime";let s=class extends o.ExtensionTipsService{constructor(a,l,h,g,w,u,P,_,z,B){super(P,_,z,B);this.environmentService=a,this.telemetryService=l,this.extensionManagementService=h,this.storageService=g,this.nativeHostService=w,this.extensionRecommendationNotificationService=u,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,_.exeBasedExtensionTips&&(0,d.forEach)(_.exeBasedExtensionTips,({key:M,value:j})=>{const W=[],$=[],H=[];(0,d.forEach)(j.recommendations,({key:q,value:D})=>{D.important?j.important?W.push({extensionId:q,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):$.push({extensionId:q,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):H.push({extensionId:q,extensionName:D.name,isExtensionPack:!!D.isExtensionPack})}),W.length&&this.highImportanceExecutableTips.set(M,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:W}),$.length&&this.mediumImportanceExecutableTips.set(M,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:$}),H.length&&this.allOtherExecutableTips.set(M,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:H})}),(0,C.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...a,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),h=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(a,h),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,h)}groupImportantTipsByExe(a,l){const h=new Map;a.forEach(_=>h.set(_.extensionId.toLowerCase(),_));const{installed:g,uninstalled:w}=this.groupByInstalled([...h.keys()],l);for(const _ of g){const z=h.get(_);z&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:_,exeName:(0,k.basename)(z.windowsPath)})}for(const _ of w){const z=h.get(_);z&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:_,exeName:(0,k.basename)(z.windowsPath)})}const u=this.getPromptedExecutableTips(),P=new Map;for(const _ of w){const z=h.get(_);if(z&&(!u[z.exeName]||!u[z.exeName].includes(z.extensionId))){let B=P.get(z.exeName);B||(B=[],P.set(z.exeName,B)),B.push(z)}}return P}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size!==0){const[a,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(h=>{switch(h){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(a);break;case"incompatibleWindow":const g=r.Event.once(r.Event.latch(r.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(g(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const w=this._register((0,C.disposableTimeout)(()=>{w.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size!==0){const a=this.getLastPromptedMediumExeTime(),l=Date.now()-a,h=7*24*60*60*1e3;if(l<h){const u=this._register((0,C.disposableTimeout)(()=>{u.dispose(),this.promptMediumImportanceExeBasedTip()},h-l));return}const[g,w]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(w).then(u=>{switch(u){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(g),this.addToRecommendedExecutables(w[0].exeName,w);const P=this._register((0,C.disposableTimeout)(()=>{P.dispose(),this.promptMediumImportanceExeBasedTip()},h));break;case"ignored":this.mediumImportanceTipsByExe.delete(g),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const _=r.Event.once(r.Event.latch(r.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const z=this._register((0,C.disposableTimeout)(()=>{z.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}}promptExeRecommendations(a){const l=a.map(({extensionId:g})=>g.toLowerCase()),h=(0,p.localize)(0,null,a[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,h,`@exe:"${a[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let a=this.storageService.getNumber(i,0);return a||(a=Date.now(),this.updateLastPromptedMediumExeTime(a)),a}updateLastPromptedMediumExeTime(a){this.storageService.store(i,a,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(a,l){const h=this.getPromptedExecutableTips();h[a]=l.map(({extensionId:g})=>g.toLowerCase()),this.storageService.store(t,JSON.stringify(h),0,0)}groupByInstalled(a,l){const h=[],g=[],w=l.reduce((u,P)=>(u.add(P.identifier.id.toLowerCase()),u),new Set);return a.forEach(u=>{w.has(u.toLowerCase())?h.push(u):g.push(u)}),{installed:h,uninstalled:g}}async getValidExecutableBasedExtensionTips(a){const l=[],h=new Map;for(const g of a.keys()){const w=a.get(g);if(!(!w||!(0,v.isNonEmptyArray)(w.recommendations))){const u=[];f.isWindows?w.windowsPath&&u.push(w.windowsPath.replace("%USERPROFILE%",U.env.USERPROFILE).replace("%ProgramFiles(x86)%",U.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",U.env.ProgramFiles).replace("%APPDATA%",U.env.APPDATA).replace("%WINDIR%",U.env.WINDIR)):(u.push((0,k.join)("/usr/local/bin",g)),u.push((0,k.join)("/usr/bin",g)),u.push((0,k.join)(this.environmentService.userHome.fsPath,g)));for(const P of u){let _=h.get(P);if(_===void 0&&(_=await this.fileService.exists(S.URI.file(P)),h.set(P,_)),_)for(const{extensionId:z,extensionName:B,isExtensionPack:M}of w.recommendations)l.push({extensionId:z,extensionName:B,isExtensionPack:M,exeName:g,exeFriendlyName:w.exeFriendlyName,windowsPath:w.windowsPath})}}}return l}};s=he([Y(0,L.INativeEnvironmentService),Y(1,b.ITelemetryService),Y(2,R.IExtensionManagementService),Y(3,m.IStorageService),Y(4,n.INativeHostService),Y(5,E.IExtensionRecommendationNotificationService),Y(6,T.IFileService),Y(7,A.IProductService),Y(8,y.IRequestService),Y(9,I.ILogService)],s),e.ExtensionTipsService=s}),define(Z[78],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class S{constructor(L){this.appender=L}listen(L,U){throw new Error(`Event not found: ${U}`)}call(L,U,{eventName:T,data:f}){return this.appender.log(T,f),Promise.resolve(null)}}e.TelemetryAppenderChannel=S;class k{constructor(L){this.channel=L}log(L,U){return this.channel.call("log",{eventName:L,data:U}).then(void 0,T=>`Failed to log telemetry: ${console.warn(T)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=k}),define(Z[79],ee([0,1,57,118,21,5,24,39,2,26,35]),function(K,e,S,k,A,L,U,T,f,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let d=class{constructor(o,C){this._configurationService=C,this._experimentProperties={},this._disposables=new f.DisposableStore,this._cleanupPatterns=[],this._appender=o.appender,this._commonProperties=o.commonProperties||Promise.resolve({}),this._piiPaths=o.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!o.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let b of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(b),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(b=>{const E=/^[a-f0-9]+$/i.test(b["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!E})}))}setExperimentProperty(o,C){this._experimentProperties[o]=C}setEnabled(o){this._enabled=o}_updateUserOptIn(){var o;const C=(o=this._configurationService)===null||o===void 0?void 0:o.getValue(y);this._userOptIn=C?C.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const o=await this._commonProperties;let C=o.sessionID,b=o["common.instanceId"],E=o["common.machineId"],p=o["common.firstSessionDate"],m=o["common.msftInternal"];return{sessionId:C,instanceId:b,machineId:E,firstSessionDate:p,msftInternal:m}}dispose(){this._disposables.dispose()}publicLog(o,C,b){return this.isOptedIn?this._commonProperties.then(E=>{C=(0,v.mixin)(C,E),C=(0,v.mixin)(C,this._experimentProperties),C=(0,v.cloneAndChange)(C,p=>{if(typeof p=="string")return this._cleanupInfo(p,b)}),this._appender.log(o,C)},E=>{console.error(E)}):Promise.resolve(void 0)}publicLog2(o,C,b){return this.publicLog(o,C,b)}publicLogError(o,C){return this.sendErrorTelemetry?this.publicLog(o,C,!0):Promise.resolve(void 0)}publicLogError2(o,C){return this.publicLogError(o,C)}_cleanupInfo(o,C){let b=o;if(C){const E=[];for(let n of this._cleanupPatterns)for(;;){const t=n.exec(o);if(!t)break;E.push([t.index,n.lastIndex])}const p=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(b="";;){const n=m.exec(o);if(!n)break;!p.test(n[0])&&E.every(([t,i])=>n.index<t||n.index>=i)&&(b+=o.substring(r,n.index)+"<REDACTED: user-file-path>",r=m.lastIndex)}r<o.length&&(b+=o.substr(r))}for(let E of this._cleanupPatterns)b=b.replace(E,"");return b}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=he([Y(1,(0,L.optional)(U.IConfigurationService))],d),e.TelemetryService=d;const y="telemetry";R.Registry.as(T.Extensions.Configuration).registerConfiguration({id:y,order:110,type:"object",title:(0,k.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,k.localize)(2,null,S.default.privacyStatementUrl):(0,k.localize)(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(Z[58],ee([0,1,24,26,15,6]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(o,C){return Promise.resolve(void 0)}publicLog2(o,C){return this.publicLog(o,C)}publicLogError(o,C){return Promise.resolve(void 0)}publicLogError2(o,C){return this.publicLogError(o,C)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class U{async publicLog(C,b,E){}async publicLogError(C,b,E){}}e.NullEndpointTelemetryService=U;function T(...o){return{log:(C,b)=>o.forEach(E=>E.log(C,b)),flush:()=>L.Promises.settled(o.map(C=>C.flush()))}}e.combinedAppender=T,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(o,C){return C.onDidChangeConfiguration(b=>{b.source!==6&&o.publicLog2("updateConfiguration",{configurationSource:(0,S.ConfigurationTargetToString)(b.source),configurationKeys:y(b.sourceConfig)})})}e.configurationTelemetry=f;function v(o){const C=Object.create(null),b=Object.create(null),E=Object.create(null);d(o,E);for(let p in E){p=p.length>150?p.substr(p.length-149):p;const m=E[p];typeof m=="number"?b[p]=m:typeof m=="boolean"?b[p]=m?1:0:typeof m=="string"?C[p]=m.substring(0,1023):typeof m!="undefined"&&m!==null&&(C[p]=m)}return{properties:C,measurements:b}}e.validateTelemetryData=v;function R(o){if(!o)return"none";let C="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(E=>{o.indexOf(`${E}+`)===0&&(C=E)}),C}e.cleanRemoteAuthority=R;function d(o,C,b=0,E){if(!!o)for(let p of Object.getOwnPropertyNames(o)){const m=o[p],r=E?E+p:p;Array.isArray(m)?C[r]=(0,k.safeStringify)(m):m instanceof Date?C[r]=m.toISOString():(0,A.isObject)(m)?b<2?d(m,C,b+1,r+"."):C[r]=(0,k.safeStringify)(m):C[r]=m}}function y(o){if(!o)return[];const C=[];return I(C,"",o),C}function I(o,C,b){b&&typeof b=="object"&&!Array.isArray(b)?Object.keys(b).forEach(E=>I(o,C?`${C}.${E}`:E,b[E])):o.push(C)}}),define(Z[172],ee([0,1,2,9,17,58]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let U=class extends S.Disposable{constructor(f,v){super();this.logger=this._register(f.createLogger(v.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(f,v){this.logger.trace(`telemetry/${f}`,(0,L.validateTelemetryData)(v))}};U=he([Y(0,A.ILoggerService),Y(1,k.IEnvironmentService)],U),e.TelemetryLogAppender=U}),define(Z[173],ee([0,1,11,26,58]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function L(T){const f=await new Promise((R,d)=>{K(["applicationinsights"],R,d)});let v;return f.defaultClient?(v=new f.TelemetryClient(T),v.channel.setUseDiskRetryCaching(!0)):(f.setup(T).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),v=f.defaultClient),T.indexOf("AIF-")===0&&(v.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),v}class U{constructor(f,v,R){this._eventPrefix=f,this._defaultData=v,this._defaultData||(this._defaultData=Object.create(null)),typeof R=="function"?this._aiClient=R():this._aiClient=R,this._asyncAIClient=null}_withAIClient(f){if(!!this._aiClient){if(typeof this._aiClient!="string"){f(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=L(this._aiClient)),this._asyncAIClient.then(v=>{f(v)},v=>{(0,S.onUnexpectedError)(v),console.error(v)})}}log(f,v){!this._aiClient||(v=(0,k.mixin)(v,this._defaultData),v=(0,A.validateTelemetryData)(v),this._withAIClient(R=>R.trackEvent({name:this._eventPrefix+"/"+f,properties:v.properties,measurements:v.measurements})))}flush(){return this._aiClient?new Promise(f=>{this._withAIClient(v=>{v.flush({callback:()=>{this._aiClient=void 0,f(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=U}),define(Z[174],ee([0,1,49,78,16,79,24,25]),function(K,e,S,k,A,L,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let f=class{constructor(R,d){this.configurationService=R,this.telemetryService=d,this.customTelemetryServices=new Map}async getCustomTelemetryService(R){if(!this.customTelemetryServices.has(R.id)){const{machineId:d,sessionId:y}=await this.telemetryService.getTelemetryInfo(),I=Object.create(null);I["common.vscodemachineid"]=d,I["common.vscodesessionid"]=y;const o=[R.id,JSON.stringify(I),R.aiKey],b=new S.Client(A.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:o,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),E=new k.TelemetryAppenderClient(b);this.customTelemetryServices.set(R.id,new L.TelemetryService({appender:E,sendErrorTelemetry:R.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(R.id)}async publicLog(R,d,y){await(await this.getCustomTelemetryService(R)).publicLog(d,y)}async publicLogError(R,d,y){await(await this.getCustomTelemetryService(R)).publicLogError(d,y)}};f=he([Y(0,U.IConfigurationService),Y(1,T.ITelemetryService)],f),e.CustomEndpointTelemetryService=f}),define(Z[80],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FlowControlConstants=e.LocalReconnectConstants=e.HeartbeatConstants=e.IPtyService=e.ILocalTerminalService=e.TerminalIpcChannels=e.WindowsShellType=void 0;var k;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Log="log",f.Heartbeat="heartbeat"})(A=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.ILocalTerminalService=(0,S.createDecorator)("localTerminalService"),e.IPtyService=(0,S.createDecorator)("ptyService");var L;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(L=e.HeartbeatConstants||(e.HeartbeatConstants={}));var U;(function(f){f[f.ReconnectionGraceTime=6e4]="ReconnectionGraceTime",f[f.ReconnectionShortGraceTime=6e3]="ReconnectionShortGraceTime"})(U=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var T;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(T=e.FlowControlConstants||(e.FlowControlConstants={}))}),define(Z[175],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,S.createDecorator)("localPtyService")}),define(Z[176],ee([0,1,2,17,80,49,16,34,3,76]),function(K,e,S,k,A,L,U,T,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var R;(function(I){I[I.MaxRestarts=5]="MaxRestarts"})(R||(R={}));let d=0,y=class extends S.Disposable{constructor(o){super();this._logService=o,this._restartCount=0,this._isDisposed=!1,this._onPtyHostExit=this._register(new f.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new f.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new f.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new f.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onProcessData=this._register(new f.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessBinary=this._register(new f.Emitter),this.onProcessBinary=this._onProcessBinary.event,this._onProcessExit=this._register(new f.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new f.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new f.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new f.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new f.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new f.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new f.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new f.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._register((0,S.toDisposable)(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const o=new L.Client(U.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:d,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}});this._onPtyHostStart.fire(),T.ProxyChannel.toService(o.getChannel(A.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(o.onDidProcessExit(p=>{this._onPtyHostExit.fire(p.code),this._isDisposed||(this._restartCount<=R.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${p.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${p.code}, giving up`))}));const b=o.getChannel(A.TerminalIpcChannels.Log);this._register(this._logService.onDidChangeLogLevel(()=>{v.LogLevelChannelClient.setLevel(b,this._logService.getLevel())}));const E=T.ProxyChannel.toService(o.getChannel(A.TerminalIpcChannels.PtyHost));return this._register(E.onProcessData(p=>this._onProcessData.fire(p))),this._register(E.onProcessBinary(p=>this._onProcessBinary.fire(p))),this._register(E.onProcessExit(p=>this._onProcessExit.fire(p))),this._register(E.onProcessReady(p=>this._onProcessReady.fire(p))),this._register(E.onProcessTitleChanged(p=>this._onProcessTitleChanged.fire(p))),this._register(E.onProcessShellTypeChanged(p=>this._onProcessShellTypeChanged.fire(p))),this._register(E.onProcessOverrideDimensions(p=>this._onProcessOverrideDimensions.fire(p))),this._register(E.onProcessResolvedShellLaunchConfig(p=>this._onProcessResolvedShellLaunchConfig.fire(p))),this._register(E.onProcessReplay(p=>this._onProcessReplay.fire(p))),this._register(E.onProcessOrphanQuestion(p=>this._onProcessOrphanQuestion.fire(p))),[o,E]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(o,C,b,E,p,m,r,n,t,i){const s=setTimeout(()=>this._handleUnresponsiveCreateProcess(),A.HeartbeatConstants.CreateProcessTimeout),c=await this._proxy.createProcess(o,C,b,E,p,m,r,n,t,i);return clearTimeout(s),d=Math.max(d,c),c}attachToProcess(o){return this._proxy.attachToProcess(o)}detachFromProcess(o){return this._proxy.detachFromProcess(o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(o){return this._proxy.start(o)}shutdown(o,C){return this._proxy.shutdown(o,C)}input(o,C){return this._proxy.input(o,C)}resize(o,C,b){return this._proxy.resize(o,C,b)}acknowledgeDataEvent(o,C){return this._proxy.acknowledgeDataEvent(o,C)}getInitialCwd(o){return this._proxy.getInitialCwd(o)}getCwd(o){return this._proxy.getCwd(o)}getLatency(o){return this._proxy.getLatency(o)}orphanQuestionReply(o){return this._proxy.orphanQuestionReply(o)}setTerminalLayoutInfo(o){return this._proxy.setTerminalLayoutInfo(o)}processBinary(o,C){return this._proxy.processBinary(o,C)}async getTerminalLayoutInfo(o){return await this._proxy.getTerminalLayoutInfo(o)}async restartPtyHost(){this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier+A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${A.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}};y=he([Y(0,k.ILogService)],y),e.PtyHostService=y}),define(Z[51],ee([0,1,41]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function k(U,T,f,v){const R=(0,S.setProperty)(U,T,f,v)[0];return R&&(U=U.substring(0,R.offset)+R.content+U.substring(R.offset+R.length)),U}e.edit=k;function A(U,T,f){let v=f;for(;v>=0;){if(U.charAt(v)===T.charAt(T.length-1)&&T.length===1)return v+1;if(v--,T.length===2&&v>=0&&U.charAt(v)===T.charAt(0))return v+2}return 0}e.getLineStartOffset=A;function L(U,T,f){let v=f;for(;v>=0;)if(U.charAt(v)===T.charAt(T.length-1)&&T.length===1||(v++,T.length===2&&v>=0&&U.charAt(v)===T.charAt(1)))return v;return U.length-1}e.getLineEndOffset=L}),define(Z[177],ee([0,1,26,55]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(d,y,I,o,C){var b,E;const p=[],m=[],r=[];if(!y){const z=d.filter(({identifier:B})=>C.every(M=>M.toLowerCase()!==B.id.toLowerCase()));return{added:p,removed:m,updated:r,remote:z.length>0?z:null}}d=d.map(v),y=y.map(v),I=I?I.map(v):null;const n=new Map,t=z=>{z.uuid&&n.set(z.id.toLowerCase(),z.uuid)};d.forEach(({identifier:z})=>t(z)),y.forEach(({identifier:z})=>t(z)),I&&I.forEach(({identifier:z})=>t(z));const i=z=>{const B=z.identifier.uuid||n.get(z.identifier.id.toLowerCase());return B?`uuid:${B}`:`id:${z.identifier.id.toLowerCase()}`},s=(z,B)=>(z.set(i(B),B),z),c=d.reduce(s,new Map),a=y.reduce(s,new Map),l=y.reduce((z,B)=>{const M=i(B);B=(0,S.deepClone)(B);const j=c.get(M);return j&&(j.installed&&(B.installed=!0),B.version||(B.version=j.version)),s(z,B)},new Map),h=I?I.reduce(s,new Map):null,g=o.reduce(s,new Map),w=C.reduce((z,B)=>{const M=n.get(B.toLowerCase());return z.add(M?`uuid:${M}`:`id:${B.toLowerCase()}`)},new Set),u=L(c,a,w);if(u.added.size>0||u.removed.size>0||u.updated.size>0){const z=L(h,c,w),B=L(h,a,w),M=(j,W)=>{const $=c.get(j);if($){const H=a.get(j);return Object.assign(Object.assign({},W?H:$),{version:(H.version&&k.gt(H.version,$.version),$.version),state:U($,H,h==null?void 0:h.get(j))})}};for(const j of B.removed.values()){const W=c.get(j);W&&m.push(W.identifier)}for(const j of B.added.values())if(z.added.has(j)){if(u.updated.has(j)){const W=M(j,!0);W&&(r.push(R(W,j)),l.set(j,W))}}else{const W=a.get(j);W.installed&&p.push(R(W,j))}for(const j of B.updated.values()){const W=M(j,!0);W&&(r.push(R(W,j)),l.set(j,W))}for(const j of z.added.values())B.added.has(j)||l.set(j,c.get(j));for(const j of z.updated.values())if(!B.removed.has(j)&&!B.updated.has(j)){const W=M(j,!1);W&&(((b=l.get(j))===null||b===void 0?void 0:b.installed)&&(W.installed=!0),l.set(j,W))}for(const j of z.removed.values())!g.has(j)&&!B.updated.has(j)&&((E=h==null?void 0:h.get(j))===null||E===void 0?void 0:E.installed)&&l.delete(j)}const P=[],_=L(a,l,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&l.forEach((z,B)=>P.push(R(z,B))),{added:p,removed:m,updated:r,remote:P.length?P:null}}e.merge=A;function L(d,y,I,{checkInstalledProperty:o,checkVersionProperty:C}={checkInstalledProperty:!1,checkVersionProperty:!1}){const b=d?[...d.keys()].filter(n=>!I.has(n)):[],E=[...y.keys()].filter(n=>!I.has(n)),p=E.filter(n=>b.indexOf(n)===-1).reduce((n,t)=>(n.add(t),n),new Set),m=b.filter(n=>E.indexOf(n)===-1).reduce((n,t)=>(n.add(t),n),new Set),r=new Set;for(const n of b)if(!m.has(n)){const t=d.get(n),i=y.get(n);(!i||t.disabled!==i.disabled||!f(t.state,i.state)||C&&t.version!==i.version||o&&t.installed!==i.installed)&&r.add(n)}return{added:p,removed:m,updated:r}}function U(d,y,I){const o=d.state,C=y.state,b=I==null?void 0:I.state;if(!y.version||o&&k.gt(d.version,y.version))return o;if(C&&k.gt(y.version,d.version)||!o)return C;if(!C)return o;const E=(0,S.deepClone)(o),p=b?T(b,C):{added:Object.keys(C).reduce((r,n)=>(r.add(n),r),new Set),removed:new Set,updated:new Set},m=b?T(b,o):{added:Object.keys(o).reduce((r,n)=>(r.add(n),r),new Set),removed:new Set,updated:new Set};for(const r of[...p.added.values(),...p.updated.values()])E[r]=C[r];for(const r of p.removed.values())m.updated.has(r)||delete E[r];return E}function T(d,y){const I=Object.keys(d),o=Object.keys(y),C=o.filter(p=>I.indexOf(p)===-1).reduce((p,m)=>(p.add(m),p),new Set),b=I.filter(p=>o.indexOf(p)===-1).reduce((p,m)=>(p.add(m),p),new Set),E=new Set;for(const p of I)if(!b.has(p)){const m=d[p],r=y[p];(0,S.equals)(m,r)||E.add(p)}return{added:C,removed:b,updated:E}}function f(d={},y={}){const{added:I,removed:o,updated:C}=T(d,y);return I.size===0&&o.size===0&&C.size===0}function v(d){return Object.assign(Object.assign({},d),{disabled:!!d.disabled,installed:!!d.installed})}function R(d,y){const I={identifier:{id:d.identifier.id,uuid:y.startsWith("uuid:")?y.substring("uuid:".length):void 0}};return d.version&&(I.version=d.version),d.disabled&&(I.disabled=!0),d.installed&&(I.installed=!0),d.state&&(I.state=d.state),I}}),define(Z[81],ee([0,1,18,3,2,33,5,28,19]),function(K,e,S,k,A,L,U,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,U.createDecorator)("IExtensionsStorageSyncService");const v=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let R=class Je extends A.Disposable{constructor(y,I){super();this.storageService=y,this.productService=I,this._onDidChangeExtensionsStorage=this._register(new k.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(o=>this.onDidChangeStorageValue(o)))}static toKey(y){return`extensionKeys/${(0,L.adoptToGalleryExtensionId)(y.id)}@${y.version}`}static fromKey(y){const I=v.exec(y);if(I&&I[1])return{id:I[1],version:I[2]}}initialize(){const y=this.storageService.keys(0,1);for(const I of y){const o=Je.fromKey(I);o&&this.extensionsWithKeysForSync.add(o.id.toLowerCase())}}onDidChangeStorageValue(y){if(y.scope===0){if(this.extensionsWithKeysForSync.has(y.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const I=Je.fromKey(y.key);if(I){this.extensionsWithKeysForSync.add(I.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}}setKeysForSync(y,I){this.storageService.store(Je.toKey(y),JSON.stringify(I),0,1)}getKeysForSync(y){var I;const o=(I=this.productService.extensionSyncedKeys)===null||I===void 0?void 0:I[y.id.toLowerCase()],C=this.storageService.get(Je.toKey(y),0),b=C?JSON.parse(C):void 0;return b&&o?(0,S.distinct)([...b,...o]):b||o}};R=he([Y(0,f.IStorageService),Y(1,T.IProductService)],R),e.ExtensionsStorageSyncService=R}),define(Z[82],ee([0,1,18,24,5]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,A.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(T){this.configurationService=T}hasToNeverSyncExtension(T){return this.getConfiguredIgnoredExtensions().includes(T.toLowerCase())}hasToAlwaysSyncExtension(T){return this.getConfiguredIgnoredExtensions().includes(`-${T.toLowerCase()}`)}updateIgnoredExtensions(T,f){let v=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return v=v.filter(R=>R!==T&&R!==`-${T}`),f&&v.push(T.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",v.length?v:void 0,1)}updateSynchronizedExtensions(T,f){let v=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return v=v.filter(R=>R!==T&&R!==`-${T}`),f&&v.push(`-${T.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",v.length?v:void 0,1)}getIgnoredExtensions(T){const f=T.filter(y=>y.isMachineScoped).map(y=>y.identifier.id.toLowerCase()),v=this.getConfiguredIgnoredExtensions().map(y=>y.toLowerCase()),R=[],d=[];if(Array.isArray(v))for(const y of v)y.startsWith("-")?d.push(y.substring(1)):R.push(y);return(0,S.distinct)([...f,...R].filter(y=>d.indexOf(y)===-1))}getConfiguredIgnoredExtensions(){let T=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return T!==void 0||(T=this.configurationService.inspect("sync.ignoredExtensions").userValue,T!==void 0)?T:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(f=>f.toLowerCase())}};L=he([Y(0,k.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(Z[178],ee([0,1,26,32,18,139,51]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function T(r){return(0,k.parse)(r)||[]}e.parseKeybindings=T;async function f(r,n,t,i,s){const c=T(r),a=T(n),l=t?T(t):null,h=[...c,...a,...l||[]].map($=>$.key),g=await s.resolveUserBindings(h);let w=R(c,a,l,g);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:r,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:n,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:r,hasChanges:!0,hasConflicts:!1};const u=y(c),P=y(a),_=l?y(l):null,z=o(u,P,g),B=_?o(_,u,g):{added:[...u.keys()].reduce(($,H)=>($.add(H),$),new Set),removed:new Set,updated:new Set},M=_?o(_,P,g):{added:[...P.keys()].reduce(($,H)=>($.add(H),$),new Set),removed:new Set,updated:new Set},j=v(z,B,M);let W=r;for(const $ of j.removed.values())j.conflicts.has($)||(W=p(W,$,i));for(const $ of j.added.values())if(!j.conflicts.has($)){const H=P.get($);if(H.some(q=>q.command!==`-${$}`&&w.conflicts.has(g[q.key]))){j.conflicts.add($);continue}W=E(W,H,i)}for(const $ of j.updated.values())if(!j.conflicts.has($)){const H=P.get($);if(H.some(q=>q.command!==`-${$}`&&w.conflicts.has(g[q.key]))){j.conflicts.add($);continue}W=m(W,$,H,i)}return{mergeContent:W,hasChanges:!0,hasConflicts:j.conflicts.size>0}}e.merge=f;function v(r,n,t){const i=new Set,s=new Set,c=new Set,a=new Set;for(const l of n.removed.values())t.updated.has(l)&&a.add(l);for(const l of t.removed.values())a.has(l)||(n.updated.has(l)?a.add(l):s.add(l));for(const l of n.added.values())a.has(l)||t.added.has(l)&&r.updated.has(l)&&a.add(l);for(const l of t.added.values())a.has(l)||(n.added.has(l)?r.updated.has(l)&&a.add(l):i.add(l));for(const l of n.updated.values())a.has(l)||t.updated.has(l)&&r.updated.has(l)&&a.add(l);for(const l of t.updated.values())a.has(l)||(n.updated.has(l)?r.updated.has(l)&&a.add(l):c.add(l));return{added:i,removed:s,updated:c,conflicts:a}}function R(r,n,t,i){const s=new Set,c=d(r,i),a=d(n,i),l=t?d(t,i):null,h=I(c,a);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const g=l?I(l,c):{added:[...c.keys()].reduce((B,M)=>(B.add(M),B),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:s,removed:s,updated:s,conflicts:s};const w=l?I(l,a):{added:[...a.keys()].reduce((B,M)=>(B.add(M),B),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const{added:u,removed:P,updated:_,conflicts:z}=v(h,g,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:u,removed:P,updated:_,conflicts:z}}function d(r,n){const t=new Map;for(const i of r){const s=n[i.key];let c=t.get(s);c||(c=[],t.set(s,c)),c.push(i)}return t}function y(r){const n=new Map;for(const t of r){const i=t.command[0]==="-"?t.command.substring(1):t.command;let s=n.get(i);s||(s=[],n.set(i,s)),s.push(t)}return n}function I(r,n){const t=[...r.keys()],i=[...n.keys()],s=i.filter(l=>t.indexOf(l)===-1).reduce((l,h)=>(l.add(h),l),new Set),c=t.filter(l=>i.indexOf(l)===-1).reduce((l,h)=>(l.add(h),l),new Set),a=new Set;for(const l of t)if(!c.has(l)){const h=r.get(l).map(w=>Object.assign(Object.assign({},w),{key:l})),g=n.get(l).map(w=>Object.assign(Object.assign({},w),{key:l}));(0,A.equals)(h,g,(w,u)=>b(w,u))||a.add(l)}return{added:s,removed:c,updated:a}}function o(r,n,t){const i=[...r.keys()],s=[...n.keys()],c=s.filter(h=>i.indexOf(h)===-1).reduce((h,g)=>(h.add(g),h),new Set),a=i.filter(h=>s.indexOf(h)===-1).reduce((h,g)=>(h.add(g),h),new Set),l=new Set;for(const h of i)if(!a.has(h)){const g=r.get(h).map(u=>Object.assign(Object.assign({},u),{key:t[u.key]})),w=n.get(h).map(u=>Object.assign(Object.assign({},u),{key:t[u.key]}));C(g,w)||l.add(h)}return{added:c,removed:a,updated:l}}function C(r,n){return!(!(0,A.equals)(r.filter(({command:t})=>t[0]!=="-"),n.filter(({command:t})=>t[0]!=="-"),(t,i)=>b(t,i))||!(0,A.equals)(r.filter(({command:t})=>t[0]==="-"),n.filter(({command:t})=>t[0]==="-"),(t,i)=>b(t,i)))}function b(r,n){if(r.command!==n.command||r.key!==n.key)return!1;const t=L.ContextKeyExpr.deserialize(r.when),i=L.ContextKeyExpr.deserialize(n.when);return!(t&&!i||!t&&i||t&&i&&!t.equals(i)||!S.equals(r.args,n.args))}function E(r,n,t){for(const i of n)r=U.edit(r,[-1],i,t);return r}function p(r,n,t){const i=T(r);for(let s=i.length-1;s>=0;s--)(i[s].command===n||i[s].command===`-${n}`)&&(r=U.edit(r,[s],void 0,t));return r}function m(r,n,t,i){const s=T(r),c=s.findIndex(a=>a.command===n||a.command===`-${n}`);for(let a=s.length-1;a>=0;a--)(s[a].command===n||s[a].command===`-${n}`)&&(r=U.edit(r,[a],void 0,i));for(let a=t.length-1;a>=0;a--)r=U.edit(r,[c],t[a],i);return r}}),define(Z[179],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function S(L,U,T){const f={},v={},R=new Set;if(!U)return{local:{added:f,updated:v,removed:[...R.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const d=k(L,U);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{local:{added:f,updated:v,removed:[...R.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const y=k(T,L),I=k(T,U),o={},C={},b=new Set,E=new Set;for(const p of y.removed.values())I.updated.has(p)?f[p]=U[p]:b.add(p);for(const p of I.removed.values())E.has(p)||(y.updated.has(p)?E.add(p):R.add(p));for(const p of y.updated.values())E.has(p)||(I.updated.has(p)?d.updated.has(p)&&E.add(p):C[p]=L[p]);for(const p of I.updated.values())E.has(p)||(y.updated.has(p)?d.updated.has(p)&&E.add(p):L[p]!==void 0&&(v[p]=U[p]));for(const p of y.added.values())E.has(p)||(I.added.has(p)?d.updated.has(p)&&E.add(p):o[p]=L[p]);for(const p of I.added.values())E.has(p)||(y.added.has(p)?d.updated.has(p)&&E.add(p):f[p]=U[p]);return{local:{added:f,removed:[...R.values()],updated:v},remote:{added:o,removed:[...b.values()],updated:C},conflicts:[...E.values()]}}e.merge=S;function k(L,U){const T=L?Object.keys(L):[],f=U?Object.keys(U):[],v=f.filter(y=>T.indexOf(y)===-1).reduce((y,I)=>(y.add(I),y),new Set),R=T.filter(y=>f.indexOf(y)===-1).reduce((y,I)=>(y.add(I),y),new Set),d=new Set;for(const y of T)if(!R.has(y)){const I=L[y],o=U[y];I!==o&&d.add(y)}return{added:v,removed:R,updated:d}}function A(L,U){const{added:T,removed:f,updated:v}=k(L,U);return T.size===0&&f.size===0&&v.size===0}e.areSame=A}),define(Z[20],ee([0,1,5,29,35,39,123,77,12,18,15]),function(K,e,S,k,A,L,U,T,f,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function d(){const a=A.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(a).filter(l=>!!a[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=d;function y(){const a=A.Registry.as(L.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(a).filter(w=>!!a[w].ignoreSync),h=Object.keys(a).filter(w=>a[w].scope===2||a[w].scope===6),g=d();return(0,v.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...l,...h,...g])}e.getDefaultIgnoredSettings=y;function I(){const a="vscode://schemas/ignoredSettings",l=A.Registry.as(L.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:(0,U.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,U.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,U.localize)(2,null),items:[{type:"string",pattern:k.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,U.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,U.localize)(4,null),default:[],scope:1,$ref:a,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const h=A.Registry.as(T.Extensions.JSONContribution),g=()=>{const w=d(),u=y().filter(B=>B!==e.CONFIGURATION_SYNC_STORE_KEY),P=Object.keys(L.allSettings.properties).filter(B=>u.indexOf(B)===-1),_=u.filter(B=>w.indexOf(B)===-1),z={items:{type:"string",enum:[...P,..._.map(B=>`-${B}`)]}};h.registerSchema(a,z)};return l.onDidUpdateConfiguration(()=>g())}e.registerConfiguration=I;function o(a){return a&&(0,R.isObject)(a)&&(0,R.isString)(a.id)&&(0,R.isArray)(a.scopes)}e.isAuthenticationProvider=o;var C;(function(a){a.Settings="settings",a.Keybindings="keybindings",a.Snippets="snippets",a.Extensions="extensions",a.GlobalState="globalState"})(C=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"],e.IUserDataSyncStoreManagementService=(0,S.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,S.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,S.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function b(a){const l={};return l[e.HEADER_EXECUTION_ID]=a,l}e.createSyncHeaders=b;var E;(function(a){a.Unauthorized="Unauthorized",a.Conflict="Conflict",a.Gone="Gone",a.PreconditionFailed="PreconditionFailed",a.TooLarge="TooLarge",a.UpgradeRequired="UpgradeRequired",a.PreconditionRequired="PreconditionRequired",a.TooManyRequests="RemoteTooManyRequests",a.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",a.RequestFailed="RequestFailed",a.RequestCanceled="RequestCanceled",a.RequestTimeout="RequestTimeout",a.NoRef="NoRef",a.TurnedOff="TurnedOff",a.SessionExpired="SessionExpired",a.ServiceChanged="ServiceChanged",a.DefaultServiceChanged="DefaultServiceChanged",a.LocalTooManyRequests="LocalTooManyRequests",a.LocalPreconditionFailed="LocalPreconditionFailed",a.LocalInvalidContent="LocalInvalidContent",a.LocalError="LocalError",a.IncompatibleLocalContent="IncompatibleLocalContent",a.IncompatibleRemoteContent="IncompatibleRemoteContent",a.UnresolvedConflicts="UnresolvedConflicts",a.Unknown="Unknown"})(E=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class p extends Error{constructor(l,h,g,w){super(l);this.code=h,this.resource=g,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=p;class m extends p{constructor(l,h,g,w){super(l,g,void 0,w);this.url=h}}e.UserDataSyncStoreError=m;class r extends p{constructor(l,h){super(l,h)}}e.UserDataAutoSyncError=r,function(a){function l(h){if(h instanceof a)return h;const g=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(h.name);if(g&&g[1]){const w=g[2]==="unknown"?void 0:g[2],u=g[3]==="unknown"?void 0:g[3];return new a(h.message,g[1],w,u)}return new a(h.message,E.Unknown)}a.toUserDataSyncError=l}(p=e.UserDataSyncError||(e.UserDataSyncError={}));var n;(function(a){a.Uninitialized="uninitialized",a.Idle="idle",a.Syncing="syncing",a.HasConflicts="hasConflicts"})(n=e.SyncStatus||(e.SyncStatus={}));var t;(function(a){a[a.None=0]="None",a[a.Added=1]="Added",a[a.Modified=2]="Modified",a[a.Deleted=3]="Deleted"})(t=e.Change||(e.Change={}));var i;(function(a){a.Preview="preview",a.Conflict="conflict",a.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function s(a){return`sync.enable.${a}`}e.getEnablementKey=s,e.IUserDataSyncResourceEnablementService=(0,S.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,S.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,S.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,S.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,S.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,S.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function c(a,l){if(a.scheme!==e.USER_DATA_SYNC_SCHEME)return a=a.with({scheme:l.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(h=>(0,f.isEqualOrParent)(a,(0,f.joinPath)(l.userDataSyncHome,h,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=c}),define(Z[45],ee([0,1,2,10,22,4,20,9,12,6,3,25,32,119,24,15,21,18,44,19,30]),function(K,e,S,k,A,L,U,T,f,v,R,d,y,I,o,C,b,E,p,m,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function n(l){return!!(l&&l.version!==void 0&&typeof l.version=="number"&&l.content!==void 0&&typeof l.content=="string"&&(Object.keys(l).length===2||Object.keys(l).length===3&&l.machineId!==void 0&&typeof l.machineId=="string"))}e.isSyncData=n;function t(l,h,g){return g.joinPath(h.userDataSyncHome,l,`lastSync${l}.json`)}let i=class extends S.Disposable{constructor(h,g,w,u,P,_,z,B,M,j){super();this.resource=h,this.fileService=g,this.environmentService=w,this.userDataSyncStoreService=P,this.userDataSyncBackupStoreService=_,this.userDataSyncResourceEnablementService=z,this.telemetryService=B,this.logService=M,this.configurationService=j,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new v.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new R.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,b.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(w.userDataSyncHome,1024)?f.extUri:f.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(w.userDataSyncHome,h),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,U.PREVIEW_DIR_NAME),this.lastSyncResource=t(h,w,this.extUri),this.currentMachineIdPromise=(0,p.getServiceMachineId)(w,g,u)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const h=await this.syncPreviewPromise;this.syncPreviewPromise=null;const g=await this.performSync(h.remoteUserData,h.lastSyncUserData,!0);this.setStatus(g)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const h=await this.getLastSyncUserData();(h?(await this.doGenerateSyncResourcePreview(h,h,!0,r.CancellationToken.None)).resourcePreviews.some(({remoteChange:w})=>w!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(h){if(this._status!==h){const g=this._status;h==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),g==="hasConflicts"&&h==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=h,this._onDidChangStatus.fire(h)}}async sync(h,g={}){await this._sync(h,!0,g)}async preview(h,g={}){return this._sync(h,!1,g)}async apply(h,g={}){try{this.syncHeaders=Object.assign({},g);const w=await this.doApply(h);return this.setStatus(w),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(h,g,w){try{if(this.syncHeaders=Object.assign({},w),!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let u="idle";try{const P=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(h,P);return u=await this.performSync(_,P,g),u==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):u==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(u)}}finally{this.syncHeaders={}}}async replace(h){const g=await this.resolveContent(h);if(!g)return!1;const w=this.parseSyncData(g);if(!w)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const u=await this.getLastSyncUserData(),P=await this.getLatestRemoteUserData(null,u),_=await this.generateSyncPreview({ref:P.ref,syncData:w},u,r.CancellationToken.None),z=[];for(const B of _){const M=await this.getAcceptResult(B,B.remoteResource,void 0,r.CancellationToken.None),{remoteChange:j}=await this.getAcceptResult(B,B.previewResource,B.remoteContent,r.CancellationToken.None);z.push([B,Object.assign(Object.assign({},M),{remoteChange:j!==0?j:2})])}await this.applyResult(P,u,z,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async getLatestRemoteUserData(h,g){if(g){const w=h&&h.latest?h.latest[this.resource]:void 0;if(g.ref===w||w===void 0&&g.syncData===null)return g}return this.getRemoteUserData(g)}async performSync(h,g,w){if(h.syncData&&h.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new U.UserDataSyncError((0,I.localize)(0,null,this.resource,this.version,h.syncData.version),U.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(h,g,w)}catch(u){if(u instanceof U.UserDataSyncError)switch(u.code){case U.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(h,g,w);case U.UserDataSyncErrorCode.Conflict:case U.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),h=await this.getRemoteUserData(null),g=await this.getLastSyncUserData(),this.performSync(h,g,w)}throw u}}async doSync(h,g,w){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,v.createCancelablePromise)(P=>this.doGenerateSyncResourcePreview(h,g,w,P)));const u=await this.syncPreviewPromise;return this.updateConflicts(u.resourcePreviews),u.resourcePreviews.some(({mergeState:P})=>P==="conflict")?"hasConflicts":w?await this.doApply(!1):"syncing"}catch(u){throw this.syncPreviewPromise=null,u}}async merge(h){return await this.updateSyncResourcePreview(h,async g=>{const w=await this.getMergeResult(g,r.CancellationToken.None);await this.fileService.writeFile(g.previewResource,A.VSBuffer.fromString((w==null?void 0:w.content)||""));const u=w&&!w.hasConflicts?await this.getAcceptResult(g,g.previewResource,void 0,r.CancellationToken.None):void 0;return g.acceptResult=u,g.mergeState=w.hasConflicts?"conflict":u?"accepted":"preview",g.localChange=u?u.localChange:w.localChange,g.remoteChange=u?u.remoteChange:w.remoteChange,g}),this.syncPreviewPromise}async accept(h,g){return await this.updateSyncResourcePreview(h,async w=>{const u=await this.getAcceptResult(w,h,g,r.CancellationToken.None);return w.acceptResult=u,w.mergeState="accepted",w.localChange=u.localChange,w.remoteChange=u.remoteChange,w}),this.syncPreviewPromise}async discard(h){return await this.updateSyncResourcePreview(h,async g=>{const w=await this.getMergeResult(g,r.CancellationToken.None);return await this.fileService.writeFile(g.previewResource,A.VSBuffer.fromString(w.content||"")),g.acceptResult=void 0,g.mergeState="preview",g.localChange=w.localChange,g.remoteChange=w.remoteChange,g}),this.syncPreviewPromise}async updateSyncResourcePreview(h,g){if(!!this.syncPreviewPromise){let w=await this.syncPreviewPromise;const u=w.resourcePreviews.findIndex(({localResource:P,remoteResource:_,previewResource:z})=>this.extUri.isEqual(P,h)||this.extUri.isEqual(_,h)||this.extUri.isEqual(z,h));u!==-1&&(this.syncPreviewPromise=(0,v.createCancelablePromise)(async P=>{const _=[...w.resourcePreviews];return _[u]=await g(_[u]),Object.assign(Object.assign({},w),{resourcePreviews:_})}),w=await this.syncPreviewPromise,this.updateConflicts(w.resourcePreviews),w.resourcePreviews.some(({mergeState:P})=>P==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}}async doApply(h){if(!this.syncPreviewPromise)return"idle";const g=await this.syncPreviewPromise;return g.resourcePreviews.some(({mergeState:w})=>w==="conflict")?"hasConflicts":g.resourcePreviews.some(({mergeState:w})=>w!=="accepted")?"syncing":(await this.applyResult(g.remoteUserData,g.lastSyncUserData,g.resourcePreviews.map(w=>[w,w.acceptResult]),h),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(h){}}updateConflicts(h){const g=h.filter(({mergeState:w})=>w==="conflict");(0,E.equals)(this._conflicts,g,(w,u)=>this.extUri.isEqual(w.previewResource,u.previewResource))||(this._conflicts=g,this._onDidChangeConflicts.fire(g))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:g,ref:w})=>({created:g,uri:this.toRemoteBackupResource(w)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:g,ref:w})=>({created:g,uri:this.toLocalBackupResource(w)}))}toRemoteBackupResource(h){return L.URI.from({scheme:U.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${h}`})}toLocalBackupResource(h){return L.URI.from({scheme:U.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${h}`})}async getMachineId({uri:h}){const g=this.extUri.basename(h);if(this.extUri.isEqual(h,this.toRemoteBackupResource(g))){const{content:w}=await this.getUserData(g);if(w){const u=this.parseSyncData(w);return u==null?void 0:u.machineId}}}async resolveContent(h){const g=this.extUri.basename(h);if(this.extUri.isEqual(h,this.toRemoteBackupResource(g))){const{content:w}=await this.getUserData(g);return w}return this.extUri.isEqual(h,this.toLocalBackupResource(g))?this.userDataSyncBackupStoreService.resolveContent(this.resource,g):null}async resolvePreviewContent(h){const g=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(g)for(const w of g.resourcePreviews){if(this.extUri.isEqual(w.acceptedResource,h))return w.acceptResult?w.acceptResult.content:null;if(this.extUri.isEqual(w.remoteResource,h))return w.remoteContent;if(this.extUri.isEqual(w.localResource,h))return w.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(h){}}async doGenerateSyncResourcePreview(h,g,w,u){var P;const _=await this.currentMachineIdPromise,z=!!((P=h.syncData)===null||P===void 0?void 0:P.machineId)&&h.syncData.machineId===_,B=g===null&&z&&!this.hasSyncResourceStateVersionChanged?h:g,M=await this.generateSyncPreview(h,B,u),j=[];for(const W of M){const $=W.previewResource.with({scheme:U.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(W.localChange===0&&W.remoteChange===0)j.push(Object.assign(Object.assign({},W),{acceptedResource:$,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"}));else{const H=w?await this.getMergeResult(W,u):void 0;if(u.isCancellationRequested)break;await this.fileService.writeFile(W.previewResource,A.VSBuffer.fromString((H==null?void 0:H.content)||""));const q=H&&!H.hasConflicts?await this.getAcceptResult(W,W.previewResource,void 0,u):void 0;j.push(Object.assign(Object.assign({},W),{acceptResult:q,mergeState:(H==null?void 0:H.hasConflicts)?"conflict":q?"accepted":"preview",localChange:q?q.localChange:H?H.localChange:W.localChange,remoteChange:q?q.remoteChange:H?H.remoteChange:W.remoteChange}))}}return{remoteUserData:h,lastSyncUserData:g,resourcePreviews:j,isLastSyncFromCurrentMachine:z}}async getLastSyncUserData(){try{const h=await this.fileService.readFile(this.lastSyncResource),g=JSON.parse(h.value.toString()),w=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=g.version&&w&&g.version!==w,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${g.version} is not compatible with current sync state version ${w}.`),await this.resetLocal(),null;const u=g;if(u.content===null)return{ref:g.ref,syncData:null};const P=JSON.parse(u.content);if(n(P))return Object.assign(Object.assign({},g),{syncData:P,content:void 0})}catch(h){h instanceof k.FileOperationError&&h.fileOperationResult===1||this.logService.error(h)}return null}async updateLastSyncUserData(h,g={}){if(g.ref||g.content||g.version)throw new Error("Cannot have core properties as additional");const w=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),u=Object.assign({ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null,version:w},g);await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(u)))}async getRemoteUserData(h){const{ref:g,content:w}=await this.getUserData(h);let u=null;return w!==null&&(u=this.parseSyncData(w)),{ref:g,syncData:u}}parseSyncData(h){try{const g=JSON.parse(h);if(n(g))return g}catch(g){this.logService.error(g)}throw new U.UserDataSyncError((0,I.localize)(1,null),U.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(h){if((0,C.isString)(h)){const g=await this.userDataSyncStoreService.resolveContent(this.resource,h);return{ref:h,content:g}}else{const g=h?{ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,g,this.syncHeaders)}}async updateRemoteUserData(h,g){const w=await this.currentMachineIdPromise,u={version:this.version,machineId:w,content:h};return g=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(u),g,this.syncHeaders),{ref:g,syncData:u}}async backupLocal(h){const g={version:this.version,content:h};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(g))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};i=he([Y(1,k.IFileService),Y(2,T.IEnvironmentService),Y(3,m.IStorageService),Y(4,U.IUserDataSyncStoreService),Y(5,U.IUserDataSyncBackupStoreService),Y(6,U.IUserDataSyncResourceEnablementService),Y(7,d.ITelemetryService),Y(8,U.IUserDataSyncLogService),Y(9,o.IConfigurationService)],i),e.AbstractSynchroniser=i;let s=class extends i{constructor(h,g,w,u,P,_,z,B,M,j,W){super(g,w,u,P,_,z,B,M,j,W);this.file=h,this._register(this.fileService.watch(this.extUri.dirname(h))),this._register(this.fileService.onDidFilesChange($=>this.onFileChanges($)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(h){return null}}async updateLocalFileContent(h,g,w){try{g?await this.fileService.writeFile(this.file,A.VSBuffer.fromString(h),w?void 0:g):await this.fileService.createFile(this.file,A.VSBuffer.fromString(h),{overwrite:w})}catch(u){throw u instanceof k.FileOperationError&&u.fileOperationResult===1||u instanceof k.FileOperationError&&u.fileOperationResult===3?new U.UserDataSyncError(u.message,U.UserDataSyncErrorCode.LocalPreconditionFailed):u}}onFileChanges(h){!h.contains(this.file)||this.triggerLocalChange()}};s=he([Y(2,k.IFileService),Y(3,T.IEnvironmentService),Y(4,m.IStorageService),Y(5,U.IUserDataSyncStoreService),Y(6,U.IUserDataSyncBackupStoreService),Y(7,U.IUserDataSyncResourceEnablementService),Y(8,d.ITelemetryService),Y(9,U.IUserDataSyncLogService),Y(10,o.IConfigurationService)],s),e.AbstractFileSynchroniser=s;let c=class extends s{constructor(h,g,w,u,P,_,z,B,M,j,W,$){super(h,g,w,u,P,_,z,B,M,j,$);this.userDataSyncUtilService=W,this._formattingOptions=void 0}hasErrors(h){const g=[];return(0,y.parse)(h,g,{allowEmptyContent:!0,allowTrailingComma:!0}),g.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};c=he([Y(2,k.IFileService),Y(3,T.IEnvironmentService),Y(4,m.IStorageService),Y(5,U.IUserDataSyncStoreService),Y(6,U.IUserDataSyncBackupStoreService),Y(7,U.IUserDataSyncResourceEnablementService),Y(8,d.ITelemetryService),Y(9,U.IUserDataSyncLogService),Y(10,U.IUserDataSyncUtilService),Y(11,o.IConfigurationService)],c),e.AbstractJsonFileSynchroniser=c;let a=class{constructor(h,g,w,u){this.resource=h,this.environmentService=g,this.logService=w,this.fileService=u,this.extUri=this.fileService.hasCapability(g.userDataSyncHome,1024)?f.extUri:f.extUriIgnorePathCase,this.lastSyncResource=t(this.resource,g,f.extUri)}async initialize({ref:h,content:g}){if(!g){this.logService.info("Remote content does not exist.",this.resource);return}const w=this.parseSyncData(g);if(!!w){if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:h,syncData:w})}catch(P){this.logService.error(P)}}}parseSyncData(h){try{const g=JSON.parse(h);if(n(g))return g}catch(g){this.logService.error(g)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(h,g={}){const w=Object.assign({ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null},g);await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(w)))}};a=he([Y(1,T.IEnvironmentService),Y(2,U.IUserDataSyncLogService),Y(3,k.IFileService)],a),e.AbstractInitializer=a}),define(Z[180],ee([0,1,20,3,9,29,33,10,24,177,45,25,4,46,41,21,19,30,82,11,81,6]),function(K,e,S,k,A,L,U,T,f,v,R,d,y,I,o,C,b,E,p,m,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function t(l,h){const g=JSON.parse(l.content);if(l.version===1||l.version===2){const w=(await h.getInstalled(0)).filter(u=>u.isBuiltin);for(const u of g)l.version===1&&(u.enabled===!1&&(u.disabled=!0),delete u.enabled),l.version===2&&w.every(P=>!(0,U.areSameExtensions)(P.identifier,u.identifier))&&(u.installed=!0)}return g}function i(l,h,g){const w=g.get((0,U.getExtensionId)(l,h),0)||"{}";return JSON.parse(w)}function s(l,h,g,w){w.store((0,U.getExtensionId)(l,h),JSON.stringify(g),0,1)}let c=class nt extends R.AbstractSynchroniser{constructor(h,g,w,u,P,_,z,B,M,j,W,$,H,q){super("extensions",g,h,w,u,P,$,H,M,W);this.storageService=w,this.extensionManagementService=_,this.extensionEnablementService=z,this.ignoredExtensionsManagementService=B,this.extensionGalleryService=j,this.extensionsStorageSyncService=q,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.debounce(k.Event.any(k.Event.filter(this.extensionManagementService.onDidInstallExtension,D=>!!D.gallery),k.Event.filter(this.extensionManagementService.onDidUninstallExtension,D=>!D.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(h,g){const w=h.syncData?await t(h.syncData,this.extensionManagementService):null,u=(g==null?void 0:g.skippedExtensions)||[],P=(g==null?void 0:g.syncData)?await t(g.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(),z=this.getLocalExtensions(_),B=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);w?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{added:M,removed:j,updated:W,remote:$}=(0,v.merge)(z,w,P,u,B),H={added:M,removed:j,updated:W,remote:$,content:this.getPreviewContent(z,M,W,j),localChange:M.length>0||j.length>0||W.length>0?2:0,remoteChange:$!==null?2:0};return[{skippedExtensions:u,localResource:this.localResource,localContent:this.format(z),localExtensions:z,remoteResource:this.remoteResource,remoteContent:w?this.format(w):null,previewResource:this.previewResource,previewResult:H,localChange:H.localChange,remoteChange:H.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(h,g,w,u){const P=[...g,...w],_=new Set,z=B=>{_.add(B.id.toLowerCase()),B.uuid&&_.add(B.uuid)};P.forEach(({identifier:B})=>z(B)),u.forEach(z);for(const B of h)_.has(B.identifier.id.toLowerCase())||B.identifier.uuid&&_.has(B.identifier.uuid)||P.push(B);return this.format(P)}async getMergeResult(h,g){return Object.assign(Object.assign({},h.previewResult),{hasConflicts:!1})}async getAcceptResult(h,g,w,u){if(this.extUri.isEqual(g,this.localResource))return this.acceptLocal(h);if(this.extUri.isEqual(g,this.remoteResource))return this.acceptRemote(h);if(this.extUri.isEqual(g,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${g.toString()}`)}async acceptLocal(h){const g=await this.extensionManagementService.getInstalled(),w=this.ignoredExtensionsManagementService.getIgnoredExtensions(g),u=(0,v.merge)(h.localExtensions,null,null,h.skippedExtensions,w),{added:P,removed:_,updated:z,remote:B}=u;return{content:h.localContent,added:P,removed:_,updated:z,remote:B,localChange:P.length>0||_.length>0||z.length>0?2:0,remoteChange:B!==null?2:0}}async acceptRemote(h){const g=await this.extensionManagementService.getInstalled(),w=this.ignoredExtensionsManagementService.getIgnoredExtensions(g),u=h.remoteContent?JSON.parse(h.remoteContent):null;if(u!==null){const P=(0,v.merge)(h.localExtensions,u,h.localExtensions,[],w),{added:_,removed:z,updated:B,remote:M}=P;return{content:h.remoteContent,added:_,removed:z,updated:B,remote:M,localChange:_.length>0||z.length>0||B.length>0?2:0,remoteChange:M!==null?2:0}}else return{content:h.remoteContent,added:[],removed:[],updated:[],remote:null,localChange:0,remoteChange:0}}async applyResult(h,g,w,u){let{skippedExtensions:P,localExtensions:_}=w[0][0],{added:z,removed:B,updated:M,remote:j,localChange:W,remoteChange:$}=w[0][1];if(W===0&&$===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),W!==0&&(await this.backupLocal(JSON.stringify(_)),P=await this.updateLocalExtensions(z,B,M,P)),j){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const H=JSON.stringify(j);h=await this.updateRemoteUserData(H,u?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions`)}(g==null?void 0:g.ref)!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(h,{skippedExtensions:P}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions`))}async getAssociatedResources({uri:h}){return[{resource:this.extUri.joinPath(h,"extensions.json"),comparableResource:nt.EXTENSIONS_DATA_URI}]}async resolveContent(h){if(this.extUri.isEqual(h,nt.EXTENSIONS_DATA_URI)){const w=await this.extensionManagementService.getInstalled(),u=this.ignoredExtensionsManagementService.getIgnoredExtensions(w),P=this.getLocalExtensions(w).filter(_=>!u.some(z=>(0,U.areSameExtensions)({id:z},_.identifier)));return this.format(P)}if(this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h))return this.resolvePreviewContent(h);let g=await super.resolveContent(h);if(g)return g;if(g=await super.resolveContent(this.extUri.dirname(h)),g){const w=this.parseSyncData(g);if(w)switch(this.extUri.basename(h)){case"extensions.json":return this.format(this.parseExtensions(w))}}return null}format(h){h.sort((u,P)=>!u.identifier.uuid&&P.identifier.uuid?-1:u.identifier.uuid&&!P.identifier.uuid?1:(0,C.compare)(u.identifier.id,P.identifier.id));const g=JSON.stringify(h),w=(0,I.format)(g,void 0,{});return(0,o.applyEdits)(g,w)}async hasLocalData(){try{const h=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(h).some(w=>w.installed||w.disabled))return!0}catch(h){}return!1}async updateLocalExtensions(h,g,w,u){const P=[],_=[],z=await this.extensionManagementService.getInstalled();if(g.length){const M=z.filter(({identifier:j,isBuiltin:W})=>!W&&g.some($=>(0,U.areSameExtensions)(j,$)));await n.Promises.settled(M.map(async j=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,j.identifier.id),await this.extensionManagementService.uninstall(j,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,j.identifier.id),P.push(j.identifier)}))}(h.length||w.length)&&await n.Promises.settled([...h,...w].map(async M=>{const j=z.find($=>(0,U.areSameExtensions)($.identifier,M.identifier));if(j&&j.isBuiltin){M.state&&j.manifest.version===M.version&&this.updateExtensionState(M.state,j.manifest.publisher,j.manifest.name,j.manifest.version),M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id)),P.push(M.identifier);return}const W=await this.extensionGalleryService.getCompatibleExtension(M.identifier);if(M.state&&(j?j.manifest.version===M.version:!!W)){const $=j?j.manifest.publisher:W.publisher,H=j?j.manifest.name:W.name;this.updateExtensionState(M.state,$,H,j==null?void 0:j.manifest.version)}if(W)try{M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id,W.version),await this.extensionEnablementService.disableExtension(W.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id,W.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id,W.version),await this.extensionEnablementService.enableExtension(W.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id,W.version)),j||(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,M.identifier.id,W.version),await this.extensionManagementService.installFromGallery(W,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,M.identifier.id,W.version),P.push(W.identifier))}catch($){_.push(M),this.logService.error($),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,W.displayName||W.identifier.id)}else _.push(M)}));const B=[];for(const M of u)P.some(j=>(0,U.areSameExtensions)(j,M.identifier))||B.push(M);for(const M of _)B.some(j=>(0,U.areSameExtensions)(j.identifier,M.identifier))||B.push(M);return B}updateExtensionState(h,g,w,u){const P=i(g,w,this.storageService),_=u?this.extensionsStorageSyncService.getKeysForSync({id:(0,U.getGalleryExtensionId)(g,w),version:u}):void 0;_?_.forEach(z=>{P[z]=h[z]}):Object.keys(h).forEach(z=>P[z]=h[z]),s(g,w,P,this.storageService)}parseExtensions(h){return JSON.parse(h.content)}getLocalExtensions(h){const g=this.extensionEnablementService.getDisabledExtensions();return h.map(({identifier:w,isBuiltin:u,manifest:P})=>{const _={identifier:w,version:P.version};g.some(z=>(0,U.areSameExtensions)(z,w))&&(_.disabled=!0),u||(_.installed=!0);try{const z=this.extensionsStorageSyncService.getKeysForSync({id:w.id,version:P.version});if(z){const B=i(P.publisher,P.name,this.storageService);_.state=Object.keys(B).reduce((M,j)=>(z.includes(j)&&(M[j]=B[j]),M),{})}}catch(z){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,m.getErrorMessage)(z))}return _})}};c.EXTENSIONS_DATA_URI=y.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),c=he([Y(0,A.IEnvironmentService),Y(1,T.IFileService),Y(2,b.IStorageService),Y(3,S.IUserDataSyncStoreService),Y(4,S.IUserDataSyncBackupStoreService),Y(5,L.IExtensionManagementService),Y(6,L.IGlobalExtensionEnablementService),Y(7,p.IIgnoredExtensionsManagementService),Y(8,S.IUserDataSyncLogService),Y(9,L.IExtensionGalleryService),Y(10,f.IConfigurationService),Y(11,S.IUserDataSyncResourceEnablementService),Y(12,d.ITelemetryService),Y(13,r.IExtensionsStorageSyncService)],c),e.ExtensionsSynchroniser=c;let a=class extends R.AbstractInitializer{constructor(h,g,w,u,P,_,z,B){super("extensions",z,B,_);this.extensionManagementService=h,this.galleryService=g,this.extensionEnablementService=w,this.storageService=u,this.ignoredExtensionsManagementService=P}async doInitialize(h){const g=h.syncData?await t(h.syncData,this.extensionManagementService):null;if(!g){this.logService.info("Skipping initializing extensions because remote extensions does not exist.");return}await this.initializeRemoteExtensions(g)}async initializeRemoteExtensions(h){const g=[],w=await this.extensionManagementService.getInstalled(),u=new Map,P=[],_={names:[],uuids:[]},z=[];for(const B of h)if(!this.ignoredExtensionsManagementService.hasToNeverSyncExtension(B.identifier.id)){const M=w.find(j=>(0,U.areSameExtensions)(j.identifier,B.identifier));M?(P.push({syncExtension:B,installedExtension:M}),B.disabled&&z.push(B.identifier)):B.installed&&(u.set(B.identifier.id.toLowerCase(),B),B.identifier.uuid?_.uuids.push(B.identifier.uuid):_.names.push(B.identifier.id),B.disabled&&z.push(B.identifier))}for(const{syncExtension:B,installedExtension:M}of P)if(B.state){const j=i(M.manifest.publisher,M.manifest.name,this.storageService);Object.keys(B.state).forEach(W=>j[W]=B.state[W]),s(M.manifest.publisher,M.manifest.name,j,this.storageService)}if(z.length)for(const B of z)this.logService.trace("Disabling extension...",B.id),await this.extensionEnablementService.disableExtension(B),this.logService.info("Disabling extension",B.id);if(_.names.length||_.uuids.length){const B=(await this.galleryService.query({ids:_.uuids,names:_.names,pageSize:_.uuids.length+_.names.length},E.CancellationToken.None)).firstPage;for(const M of B)try{const j=u.get(M.identifier.id.toLowerCase());j.state&&s(M.publisher,M.name,j.state,this.storageService),this.logService.trace("Installing extension...",M.identifier.id);const W=await this.extensionManagementService.installFromGallery(M,{isMachineScoped:!1});z.some($=>(0,U.areSameExtensions)($,M.identifier))||g.push(W),this.logService.info("Installed extension.",M.identifier.id)}catch(j){this.logService.error(j)}}return g}};a=he([Y(0,L.IExtensionManagementService),Y(1,L.IExtensionGalleryService),Y(2,L.IGlobalExtensionEnablementService),Y(3,b.IStorageService),Y(4,p.IIgnoredExtensionsManagementService),Y(5,T.IFileService),Y(6,A.IEnvironmentService),Y(7,S.IUserDataSyncLogService)],a),e.ExtensionsInitializer=a}),define(Z[181],ee([0,1,26,20]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(T,f,v,R,d){if(!f)return{remote:Object.keys(T).length>0?T:null,local:{added:{},removed:[],updated:{}}};const y=L(T,f);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const I=v?L(v,f):{added:Object.keys(f).reduce((p,m)=>(p.add(m),p),new Set),removed:new Set,updated:new Set},o=v?L(v,T):{added:Object.keys(T).reduce((p,m)=>(p.add(m),p),new Set),removed:new Set,updated:new Set},C={added:{},removed:[],updated:{}},b=S.deepClone(f),E=!v;for(const p of o.added.values())p!==k.SYNC_SERVICE_URL_TYPE&&E&&I.added.has(p)||(b[p]=T[p]);for(const p of o.updated.values())b[p]=T[p];for(const p of o.removed.values())R.unregistered.includes(p)||delete b[p];for(const p of I.added.values()){const m=f[p];if(R.machine.includes(p)){d.info(`GlobalState: Skipped adding ${p} in local storage because it is declared as machine scoped.`);continue}if(!(v&&o.added.has(p))){const r=T[p];r&&r.value===m.value||p===k.SYNC_SERVICE_URL_TYPE&&E&&o.added.has(p)||(r?C.updated[p]=m:C.added[p]=m)}}for(const p of I.updated.values()){const m=f[p];if(R.machine.includes(p)){d.info(`GlobalState: Skipped updating ${p} in local storage because it is declared as machine scoped.`);continue}if(!(o.updated.has(p)||o.removed.has(p))){const r=T[p];r&&r.value===m.value||(C.updated[p]=m)}}for(const p of I.removed.values()){if(R.machine.includes(p)){d.trace(`GlobalState: Skipped removing ${p} in local storage because it is declared as machine scoped.`);continue}o.updated.has(p)||o.removed.has(p)||C.removed.push(p)}return{local:C,remote:U(b,f)?null:b}}e.merge=A;function L(T,f){const v=Object.keys(T),R=Object.keys(f),d=R.filter(o=>v.indexOf(o)===-1).reduce((o,C)=>(o.add(C),o),new Set),y=v.filter(o=>R.indexOf(o)===-1).reduce((o,C)=>(o.add(C),o),new Set),I=new Set;for(const o of v)if(!y.has(o)){const C=T[o],b=f[o];S.equals(C,b)||I.add(o)}return{added:d,removed:y,updated:I}}function U(T,f){const{added:v,removed:R,updated:d}=L(T,f);return v.size===0&&R.size===0&&d.size===0}}),define(Z[182],ee([0,1,20,22,3,9,10,51,181,32,45,25,24,4,46,41,19,7,44,31,17]),function(K,e,S,k,A,L,U,T,f,v,R,d,y,I,o,C,b,E,p,m,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const n="globalState.argv.",t=["locale"];function i(h){const g=h.storage?Object.keys(h.storage).sort():[],w={};g.forEach(_=>w[_]=h.storage[_]),h.storage=w;const u=JSON.stringify(h),P=(0,o.format)(u,void 0,{});return(0,C.applyEdits)(u,P)}const s=1;let c=class st extends R.AbstractSynchroniser{constructor(g,w,u,P,_,z,B,M,j){super("globalState",g,_,j,w,u,z,B,P,M);this.storageService=j,this.version=s,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(g.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(A.Event.any(A.Event.filter(g.onDidFilesChange,W=>W.contains(this.environmentService.argvResource)),A.Event.filter(j.onDidChangeValue,W=>W.scope===0&&W.target!==void 0?W.target===0:j.keys(0,0).includes(W.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(g,w,u){const P=g.syncData?JSON.parse(g.syncData.content):null,_=w&&w.syncData?JSON.parse(w.syncData.content):null,z=await this.getLocalGlobalState();P?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const B=this.getStorageKeys(_),{local:M,remote:j}=(0,f.merge)(z.storage,P?P.storage:null,_?_.storage:null,B,this.logService),W={content:null,local:M,remote:j,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:j!==null?2:0};return[{localResource:this.localResource,localContent:i(z),localUserData:z,remoteResource:this.remoteResource,remoteContent:P?i(P):null,previewResource:this.previewResource,previewResult:W,localChange:W.localChange,remoteChange:W.remoteChange,acceptedResource:this.acceptedResource,storageKeys:B}]}async getMergeResult(g,w){return Object.assign(Object.assign({},g.previewResult),{hasConflicts:!1})}async getAcceptResult(g,w,u,P){if(this.extUri.isEqual(w,this.localResource))return this.acceptLocal(g);if(this.extUri.isEqual(w,this.remoteResource))return this.acceptRemote(g);if(this.extUri.isEqual(w,this.previewResource))return g.previewResult;throw new Error(`Invalid Resource: ${w.toString()}`)}async acceptLocal(g){return{content:g.localContent,local:{added:{},removed:[],updated:{}},remote:g.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(g){if(g.remoteContent!==null){const w=JSON.parse(g.remoteContent),{local:u,remote:P}=(0,f.merge)(g.localUserData.storage,w.storage,null,g.storageKeys,this.logService);return{content:g.remoteContent,local:u,remote:P,localChange:Object.keys(u.added).length>0||Object.keys(u.updated).length>0||u.removed.length>0?2:0,remoteChange:P!==null?2:0}}else return{content:g.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(g,w,u,P){let{localUserData:_}=u[0][0],{local:z,remote:B,localChange:M,remoteChange:j}=u[0][1];if(M===0&&j===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),M!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(_)),await this.writeLocalGlobalState(z),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),j!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const W=JSON.stringify({storage:B});g=await this.updateRemoteUserData(W,P?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}(w==null?void 0:w.ref)!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:g}){return[{resource:this.extUri.joinPath(g,"globalState.json"),comparableResource:st.GLOBAL_STATE_DATA_URI}]}async resolveContent(g){if(this.extUri.isEqual(g,st.GLOBAL_STATE_DATA_URI)){const u=await this.getLocalGlobalState();return i(u)}if(this.extUri.isEqual(this.remoteResource,g)||this.extUri.isEqual(this.localResource,g)||this.extUri.isEqual(this.acceptedResource,g))return this.resolvePreviewContent(g);let w=await super.resolveContent(g);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(g)),w){const u=this.parseSyncData(w);if(u)switch(this.extUri.basename(g)){case"globalState.json":return i(JSON.parse(u.content))}}return null}async hasLocalData(){var g;try{const{storage:w}=await this.getLocalGlobalState();if(Object.keys(w).length>1||((g=w[`${n}.locale`])===null||g===void 0?void 0:g.value)!=="en")return!0}catch(w){}return!1}async getLocalGlobalState(){const g={},w=await this.getLocalArgvContent(),u=(0,v.parse)(w);for(const P of t)u[P]!==void 0&&(g[`${n}${P}`]={version:1,value:u[P]});for(const P of this.storageService.keys(0,0)){const _=this.storageService.get(P,0);_&&(g[P]={version:1,value:_})}return{storage:g}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(g){}return"{}"}async writeLocalGlobalState({added:g,removed:w,updated:u}){const P={},_={},z=(M,j)=>{for(const W of M){if(W.startsWith(n)){P[W.substring(n.length)]=j?j[W].value:void 0;continue}if(j){const $=j[W];$.value!==String(this.storageService.get(W,0))&&(_[W]=$.value)}else this.storageService.get(W,0)!==void 0&&(_[W]=void 0)}};if(z(Object.keys(g),g),z(Object.keys(u),u),z(w),Object.keys(P).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(P),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(_).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const M of Object.keys(_))this.storageService.store(M,_[M],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(_))}}async updateArgv(g){const w=await this.getLocalArgvContent();let u=w;for(const P of Object.keys(g))u=(0,T.edit)(u,[P],g[P],{});w!==u&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(u)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(g){const w=this.storageService.keys(0,0),u=this.storageService.keys(0,1),P=[...w,...u],_=(g==null?void 0:g.storage)?Object.keys(g.storage).filter(z=>!z.startsWith(n)&&!P.includes(z)&&this.storageService.get(z,0)!==void 0):[];if(!E.isWeb){const z=[...S.ALL_SYNC_RESOURCES.map(B=>(0,S.getEnablementKey)(B)),S.SYNC_SERVICE_URL_TYPE];_.push(...z),u.push(...z)}return{user:w,machine:u,unregistered:_}}};c.GLOBAL_STATE_DATA_URI=I.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),c=he([Y(0,U.IFileService),Y(1,S.IUserDataSyncStoreService),Y(2,S.IUserDataSyncBackupStoreService),Y(3,S.IUserDataSyncLogService),Y(4,L.IEnvironmentService),Y(5,S.IUserDataSyncResourceEnablementService),Y(6,d.ITelemetryService),Y(7,y.IConfigurationService),Y(8,b.IStorageService)],c),e.GlobalStateSynchroniser=c;let a=class extends R.AbstractInitializer{constructor(g,w,u,P){super("globalState",u,P,w);this.storageService=g}async doInitialize(g){const w=g.syncData?JSON.parse(g.syncData.content):null;if(!w){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const u={},P={};for(const _ of Object.keys(w.storage))_.startsWith(n)?u[_.substring(n.length)]=w.storage[_].value:this.storageService.get(_,0)===void 0&&(P[_]=w.storage[_].value);if(Object.keys(u).length){let _="{}";try{_=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(z){}for(const z of Object.keys(u))_=(0,T.edit)(_,[z],u[z],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(_))}if(Object.keys(P).length)for(const _ of Object.keys(P))this.storageService.store(_,P[_],0,0)}};a=he([Y(0,b.IStorageService),Y(1,U.IFileService),Y(2,L.IEnvironmentService),Y(3,S.IUserDataSyncLogService)],a),e.GlobalStateInitializer=a;let l=class{constructor(g,w,u,P,_){this.userDataSyncStoreClient=g,this.storageService=w,this.environmentService=u,this.fileService=P,this.logService=_}getSyncStoreType(g){var w;const u=this.parseGlobalState(g);return(w=u==null?void 0:u.storage[S.SYNC_SERVICE_URL_TYPE])===null||w===void 0?void 0:w.value}async sync(g){const w=(0,S.createSyncHeaders)((0,m.generateUuid)());try{return await this.doSync(g,w)}catch(u){if(u instanceof S.UserDataSyncError)switch(u.code){case S.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(g,w)}throw u}}async doSync(g,w){const u=await this.userDataSyncStoreClient.read("globalState",null,w),P=this.parseGlobalState(u)||{storage:{}};P.storage[S.SYNC_SERVICE_URL_TYPE]={value:g,version:s};const _=await(0,p.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),z={version:s,machineId:_,content:i(P)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(z),u.ref,w)}parseGlobalState({content:g}){if(!g)return null;const w=JSON.parse(g);if((0,R.isSyncData)(w))return w?JSON.parse(w.content):null;throw new Error("Invalid remote data")}};l=he([Y(1,b.IStorageService),Y(2,L.IEnvironmentService),Y(3,U.IFileService),Y(4,r.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(Z[183],ee([0,1,10,20,178,32,120,9,24,7,15,18,45,25,19,22,3]),function(K,e,S,k,A,L,U,T,f,v,R,d,y,I,o,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function E(r,n){const t=JSON.parse(r);if(!n)return(0,R.isUndefined)(t.all)?null:t.all;switch(v.OS){case 2:return(0,R.isUndefined)(t.mac)?null:t.mac;case 3:return(0,R.isUndefined)(t.linux)?null:t.linux;case 1:return(0,R.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=E;let p=class extends y.AbstractJsonFileSynchroniser{constructor(n,t,i,s,c,a,l,h,g,w){super(l.keybindingsResource,"keybindings",a,l,h,n,t,c,w,i,g,s);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(b.Event.filter(s.onDidChangeConfiguration,u=>u.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(n,t,i){const s=n.syncData?this.getKeybindingsContentFromSyncContent(n.syncData.content):null,c=t?this.getKeybindingsContentFromLastSyncUserData(t):null,a=await this.getLocalFileContent(),l=await this.getFormattingOptions();let h=null,g=!1,w=!1,u=!1;if(s){let _=a?a.value.toString():"[]";if(_=_||"[]",this.hasErrors(_))throw new k.UserDataSyncError((0,U.localize)(0,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!c||c!==_||c!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const z=await(0,A.merge)(_,s,c,l,this.userDataSyncUtilService);z.hasChanges&&(h=z.mergeContent,u=z.hasConflicts,g=u||z.mergeContent!==_,w=u||z.mergeContent!==s)}}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),h=a.value.toString(),w=!0);const P={content:h,localChange:g?a?2:1:0,remoteChange:w?2:0,hasConflicts:u};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:P.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:P.remoteChange,previewResource:this.previewResource,previewResult:P,acceptedResource:this.acceptedResource}]}async getMergeResult(n,t){return n.previewResult}async getAcceptResult(n,t,i,s){if(this.extUri.isEqual(t,this.localResource))return{content:n.fileContent?n.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:n.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:n.previewResult.content,localChange:n.previewResult.localChange,remoteChange:n.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(n,t,i,s){var c;const{fileContent:a}=i[0][0];let{content:l,localChange:h,remoteChange:g}=i[0][1];if(h===0&&g===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),l!==null&&(l=l.trim(),l=l||"[]",this.hasErrors(l)))throw new k.UserDataSyncError((0,U.localize)(1,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),a&&await this.backupLocal(this.toSyncContent(a.value.toString())),await this.updateLocalFileContent(l||"[]",a,s),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),g!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const w=this.toSyncContent(l||"[]",(c=n.syncData)===null||c===void 0?void 0:c.content);n=await this.updateRemoteUserData(w,s?null:n.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(w){}(t==null?void 0:t.ref)!==n.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(n,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const n=await this.getLocalFileContent();if(n){const t=(0,L.parse)(n.value.toString());if((0,d.isNonEmptyArray)(t))return!0}}catch(n){if(n.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:n}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(n,"keybindings.json"),comparableResource:t}]}async resolveContent(n){if(this.extUri.isEqual(this.remoteResource,n)||this.extUri.isEqual(this.localResource,n)||this.extUri.isEqual(this.acceptedResource,n))return this.resolvePreviewContent(n);let t=await super.resolveContent(n);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(n)),t){const i=this.parseSyncData(t);if(i)switch(this.extUri.basename(n)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(i.content)}}return null}getKeybindingsContentFromLastSyncUserData(n){return!n.syncData||n.platformSpecific!==void 0&&n.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(n.syncData.content)}getKeybindingsContentFromSyncContent(n){try{return E(n,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(n,t){let i={};try{i=JSON.parse(t||"{}")}catch(s){this.logService.error(s)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=n,v.OS){case 2:i.mac=n;break;case 3:i.linux=n;break;case 1:i.windows=n;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){let n=this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return n!==void 0||(n=this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,n!==void 0)?n:this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};p=he([Y(0,k.IUserDataSyncStoreService),Y(1,k.IUserDataSyncBackupStoreService),Y(2,k.IUserDataSyncLogService),Y(3,f.IConfigurationService),Y(4,k.IUserDataSyncResourceEnablementService),Y(5,S.IFileService),Y(6,T.IEnvironmentService),Y(7,o.IStorageService),Y(8,k.IUserDataSyncUtilService),Y(9,I.ITelemetryService)],p),e.KeybindingsSynchroniser=p;let m=class extends y.AbstractInitializer{constructor(n,t,i){super("keybindings",t,i,n)}async doInitialize(n){const t=n.syncData?this.getKeybindingsContentFromSyncContent(n.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,C.VSBuffer.fromString(t)),await this.updateLastSyncUserData(n)}async isEmpty(){try{const n=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,L.parse)(n.value.toString());return!(0,d.isNonEmptyArray)(t)}catch(n){return n.fileOperationResult===1}}getKeybindingsContentFromSyncContent(n){try{return E(n,!0)}catch(t){return this.logService.error(t),null}}};m=he([Y(0,S.IFileService),Y(1,T.IEnvironmentService),Y(2,k.IUserDataSyncLogService)],m),e.KeybindingsInitializer=m}),define(Z[184],ee([0,1,26,32,41,46,51,20,18]),function(K,e,S,k,A,L,U,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function v(l,h,g){let w=[];g?w=d(g):w=R(h);const u=[],P=[...(0,T.getDisallowedIgnoredSettings)()];if(Array.isArray(w))for(const _ of w)_.startsWith("-")?P.push(_.substring(1)):u.push(_);return(0,f.distinct)([...l,...u].filter(_=>P.indexOf(_)===-1))}e.getIgnoredSettings=v;function R(l){let h=l.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=l.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:l.getValue("settingsSync.ignoredSettings")||[]}function d(l){const h=(0,k.parse)(l);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function y(l,h,g,w){if(g.length){const u=a(h),P=(0,k.parse)(h),_=(0,k.parse)(l),z=[];for(const B of g){const M=P[B],j=_[B];M===void 0?l=U.edit(l,[B],void 0,w):j!==void 0?l=U.edit(l,[B],M,w):z.push(n(B,u))}z.sort((B,M)=>B.startOffset-M.startOffset),z.forEach(B=>l=E(B.setting.key,h,l,w))}return l}e.updateIgnoredSettings=y;function I(l,h,g,w,u,P){const _=y(l,h,w,P),z=g!==_,B=g!==h;if(!z&&!B)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(z&&!B)return{conflictsSettings:[],localContent:null,remoteContent:_,hasConflicts:!1};if(B&&!z)return{conflictsSettings:[],localContent:y(h,l,w,P),remoteContent:null,hasConflicts:!1};if(g===null&&C(l)){const ie=o(l,h,w)?null:y(h,l,w,P);return{conflictsSettings:[],localContent:ie,remoteContent:null,hasConflicts:!1}}let M=l,j=h;const W=(0,k.parse)(l),$=(0,k.parse)(h),H=g?(0,k.parse)(g):null,q=w.reduce((ie,ce)=>(ie.add(ce),ie),new Set),D=b(W,$,q),O=b(H,W,q),F=b(H,$,q),N=new Map,V=new Set,G=ie=>{V.add(ie);const ce=u.filter(({key:ue})=>ue===ie)[0];ce?(M=U.edit(M,[ie],ce.value,P),j=U.edit(j,[ie],ce.value,P)):N.set(ie,{key:ie,localValue:W[ie],remoteValue:$[ie]})};for(const ie of O.removed.values())F.updated.has(ie)?G(ie):j=U.edit(j,[ie],void 0,P);for(const ie of F.removed.values())V.has(ie)||(O.updated.has(ie)?G(ie):M=U.edit(M,[ie],void 0,P));for(const ie of O.updated.values())V.has(ie)||(F.updated.has(ie)?D.updated.has(ie)&&G(ie):j=U.edit(j,[ie],W[ie],P));for(const ie of F.updated.values())V.has(ie)||(O.updated.has(ie)?D.updated.has(ie)&&G(ie):M=U.edit(M,[ie],$[ie],P));for(const ie of O.added.values())V.has(ie)||(F.added.has(ie)?D.updated.has(ie)&&G(ie):j=E(ie,M,j,P));for(const ie of F.added.values())V.has(ie)||(O.added.has(ie)?D.updated.has(ie)&&G(ie):M=E(ie,j,M,P));const J=N.size>0||!o(M,j,w),Q=J||!o(M,l,[]),ne=J||!o(j,h,[]);return{localContent:Q?M:null,remoteContent:ne?j:null,conflictsSettings:[...N.values()],hasConflicts:J}}e.merge=I;function o(l,h,g){if(l===h)return!0;const w=(0,k.parse)(l),u=(0,k.parse)(h),P=g.reduce((B,M)=>(B.add(M),B),new Set),_=a(l).filter(B=>!(B.setting&&P.has(B.setting.key))),z=a(h).filter(B=>!(B.setting&&P.has(B.setting.key)));if(_.length!==z.length)return!1;for(let B=0;B<_.length;B++){const M=_[B],j=z[B];if(M.setting&&j.setting){if(M.setting.key!==j.setting.key||!S.equals(w[M.setting.key],u[M.setting.key]))return!1}else if(!M.setting&&!j.setting){if(M.value!==j.value)return!1}else return!1}return!0}e.areSame=o;function C(l){return l?a(l).length===0:!0}e.isEmpty=C;function b(l,h,g){const w=l?Object.keys(l).filter(B=>!g.has(B)):[],u=Object.keys(h).filter(B=>!g.has(B)),P=u.filter(B=>w.indexOf(B)===-1).reduce((B,M)=>(B.add(M),B),new Set),_=w.filter(B=>u.indexOf(B)===-1).reduce((B,M)=>(B.add(M),B),new Set),z=new Set;if(l){for(const B of w)if(!_.has(B)){const M=l[B],j=h[B];S.equals(M,j)||z.add(B)}}return{added:P,removed:_,updated:z}}function E(l,h,g,w){const u=(0,k.parse)(h),P=a(h),_=a(g),z=p(l,P,_);return m(g,l,u[l],z,_,w)}e.addSetting=E;function p(l,h,g){const w=h.findIndex(P=>{var _;return((_=P.setting)===null||_===void 0?void 0:_.key)===l}),u=h[w-1];if(u){if(u.setting){const _=n(u.setting.key,g);if(_)return{index:g.indexOf(_),insertAfter:!0}}else{const _=t(w,h);if(_){const z=n(_.setting.key,g);if(z){const B=i(g.indexOf(z),g),M=s(h,_,h[w]);if(B){const j=s(g,z,B),W=c(M,j);return W?{index:g.indexOf(W),insertAfter:!0}:{index:g.indexOf(B),insertAfter:!1}}else{const j=s(g,z,g[g.length-1]),W=c(M,j);return W?{index:g.indexOf(W),insertAfter:!0}:{index:g.length-1,insertAfter:!0}}}}}const P=h[w+1];if(P)if(P.setting){const _=n(P.setting.key,g);if(_)return{index:g.indexOf(_),insertAfter:!1}}else{const _=i(w,h);if(_){const z=n(_.setting.key,g);if(z){const B=t(g.indexOf(z),g),M=s(h,h[w],_);if(B){const j=s(g,B,z),W=c(M.reverse(),j.reverse());return W?{index:g.indexOf(W),insertAfter:!1}:{index:g.indexOf(B),insertAfter:!0}}else{const j=s(g,g[0],z),W=c(M.reverse(),j.reverse());return W?{index:g.indexOf(W),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:g.length-1,insertAfter:!0}}function m(l,h,g,w,u,P){let _;return w.index===-1?_=(0,A.setProperty)(l,[h],g,P):_=r(l,h,g,w,u,P).map(z=>(0,A.withFormatting)(l,z,P)[0]),(0,A.applyEdits)(l,_)}function r(l,h,g,w,u,P){var _;const z=`${JSON.stringify(h)}: ${JSON.stringify(g)}`,B=(0,L.getEOL)(P,l),M=u[w.index];if(w.insertAfter){const j=[];if(M.setting)j.push({offset:M.endOffset,length:0,content:","+z});else{const W=i(w.index,u),$=t(w.index,u),H=(_=$==null?void 0:$.setting)===null||_===void 0?void 0:_.commaOffset;$&&H===void 0&&j.push({offset:$.endOffset,length:0,content:","});const q=H!==void 0&&H>M.endOffset;j.push({offset:q?H+1:M.endOffset,length:0,content:W?B+z+",":B+z})}return j}else{if(M.setting)return[{offset:M.startOffset,length:0,content:z+","}];const j=(u[w.index-1]&&!u[w.index-1].setting?B:"")+z+(i(w.index,u)?",":"")+B;return[{offset:M.startOffset,length:0,content:j}]}}function n(l,h){return h.filter(g=>{var w;return((w=g.setting)===null||w===void 0?void 0:w.key)===l})[0]}function t(l,h){for(let g=l-1;g>=0;g--)if(h[g].setting)return h[g]}function i(l,h){for(let g=l+1;g<h.length;g++)if(h[g].setting)return h[g]}function s(l,h,g){const w=l.indexOf(h),u=l.indexOf(g);return l.filter((P,_)=>w<_&&_<u)}function c(l,h){if(l.length&&h.length){let g=0;for(;g<h.length&&g<l.length;g++)if(l[g].value!==h[g].value)return h[g-1];return h[g-1]}}function a(l){const h=[];let g=-1,w,u;const P={onObjectBegin:_=>{g++},onObjectProperty:(_,z,B)=>{g===0&&(w=z,u=_)},onObjectEnd:(_,z)=>{g--,g===0&&h.push({startOffset:w,endOffset:_+z,value:l.substring(w,_+z),setting:{key:u,commaOffset:void 0}})},onArrayBegin:(_,z)=>{g++},onArrayEnd:(_,z)=>{g--,g===0&&h.push({startOffset:w,endOffset:_+z,value:l.substring(w,_+z),setting:{key:u,commaOffset:void 0}})},onLiteralValue:(_,z,B)=>{g===0&&h.push({startOffset:w,endOffset:z+B,value:l.substring(w,z+B),setting:{key:u,commaOffset:void 0}})},onSeparator:(_,z,B)=>{if(g===0&&_===","){let M=h.length-1;for(;M>=0&&!h[M].setting;M--);const j=h[M];j&&h.splice(M,1,{startOffset:j.startOffset,endOffset:j.endOffset,value:j.value,setting:{key:j.setting.key,commaOffset:z}})}},onComment:(_,z)=>{g===0&&h.push({startOffset:_,endOffset:_+z,value:l.substring(_,_+z)})}};return(0,k.visit)(l,P),h}}),define(Z[185],ee([0,1,10,20,22,121,3,9,24,184,51,45,25,29,19,41]),function(K,e,S,k,A,L,U,T,f,v,R,d,y,I,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function b(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function E(n){const t=JSON.parse(n);return b(t)?t:{settings:n}}e.parseSettingsSyncContent=E;let p=class extends d.AbstractJsonFileSynchroniser{constructor(t,i,s,c,a,l,h,g,w,u,P){super(i.settingsResource,"settings",t,i,s,c,a,w,u,l,h,g);this.extensionManagementService=P,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,i,s){const c=await this.getLocalFileContent(),a=await this.getFormattingOptions(),l=this.getSettingsSyncContent(t),h=i?this.getSettingsSyncContent(i):null,g=await this.getIgnoredSettings();let w=null,u=!1,P=!1,_=!1;if(l){let B=c?c.value.toString().trim():"{}";B=B||"{}",this.validateContent(B),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const M=(0,v.merge)(B,l.settings,h?h.settings:null,g,[],a);w=M.localContent||M.remoteContent,u=M.localContent!==null,P=M.remoteContent!==null,_=M.hasConflicts}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),w=c.value.toString(),P=!0);const z={content:w,localChange:u?2:0,remoteChange:P?2:0,hasConflicts:_};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:l?l.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async getMergeResult(t,i){const s=await this.getFormattingOptions(),c=await this.getIgnoredSettings();return Object.assign(Object.assign({},t.previewResult),{content:t.previewResult.content?(0,v.updateIgnoredSettings)(t.previewResult.content,"{}",c,s):null})}async getAcceptResult(t,i,s,c){const a=await this.getFormattingOptions(),l=await this.getIgnoredSettings();if(this.extUri.isEqual(i,this.localResource))return{content:t.fileContent?(0,v.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",l,a):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(i,this.remoteResource))return{content:t.remoteContent!==null?(0,v.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",l,a):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(i,this.previewResource))return s===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:s!==null?(0,v.updateIgnoredSettings)(s,t.fileContent?t.fileContent.value.toString():"{}",l,a):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async applyResult(t,i,s,c){const{fileContent:a}=s[0][0];let{content:l,localChange:h,remoteChange:g}=s[0][1];if(h===0&&g===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),l=l?l.trim():"{}",l=l||"{}",this.validateContent(l),h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),a&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(a.value.toString()))),await this.updateLocalFileContent(l,a,c),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),g!==0){const w=await this.getFormattingOptions(),u=this.getSettingsSyncContent(t),P=await this.getIgnoredSettings(l);l=(0,v.updateIgnoredSettings)(l,u?u.settings:"{}",P,w),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(l)),c?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(w){}(i==null?void 0:i.ref)!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const i=await this.getFormattingOptions(),s=(0,R.edit)(t.value.toString(),[k.CONFIGURATION_SYNC_STORE_KEY],void 0,i);return!(0,v.isEmpty)(s)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const i=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:i}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let i=await super.resolveContent(t);if(i)return i;if(i=await super.resolveContent(this.extUri.dirname(t)),i){const s=this.parseSyncData(i);if(s){const c=this.parseSettingsSyncContent(s.content);if(c)switch(this.extUri.basename(t)){case"settings.json":return c.settings}}}return null}async resolvePreviewContent(t){let i=await super.resolvePreviewContent(t);if(i){const s=await this.getFormattingOptions(),c=await this.getIgnoredSettings();i=(0,v.updateIgnoredSettings)(i,"{}",c,s)}return i}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return E(t)}catch(i){this.logService.error(i)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const s=U.Event.any(U.Event.filter(this.extensionManagementService.onDidInstallExtension,c=>!!c.gallery),U.Event.filter(this.extensionManagementService.onDidUninstallExtension,c=>!c.error))(()=>{s.dispose(),this._defaultIgnoredSettings=void 0})}const i=await this._defaultIgnoredSettings;return(0,v.getIgnoredSettings)(i,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new k.UserDataSyncError((0,L.localize)(0,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const i=JSON.parse(t.value.toString());if(!r(i))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const s=this.parseSettingsSyncContent(i.content);if(!s||!s.settings)return;let c=s.settings;const a=await this.getFormattingOptions();for(const l in i)if(["version","content","machineId"].indexOf(l)===-1&&i[l]!==void 0){const h=(0,C.setProperty)(c,[l],i[l],a);h.length&&(c=(0,C.applyEdits)(c,h))}await this.fileService.writeFile(this.file,A.VSBuffer.fromString(c))}catch(t){}}};p=he([Y(0,S.IFileService),Y(1,T.IEnvironmentService),Y(2,o.IStorageService),Y(3,k.IUserDataSyncStoreService),Y(4,k.IUserDataSyncBackupStoreService),Y(5,k.IUserDataSyncLogService),Y(6,k.IUserDataSyncUtilService),Y(7,f.IConfigurationService),Y(8,k.IUserDataSyncResourceEnablementService),Y(9,y.ITelemetryService),Y(10,I.IExtensionManagementService)],p),e.SettingsSynchroniser=p;let m=class extends d.AbstractInitializer{constructor(t,i,s){super("settings",i,s,t)}async doInitialize(t){const i=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!i){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,A.VSBuffer.fromString(i.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,v.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return E(t)}catch(i){this.logService.error(i)}return null}};m=he([Y(0,S.IFileService),Y(1,T.IEnvironmentService),Y(2,k.IUserDataSyncLogService)],m),e.SettingsInitializer=m;function r(n){return!!(n&&n.version!==void 0&&typeof n.version=="number"&&n.content!==void 0&&typeof n.content=="string"&&n.machineId!==void 0&&typeof n.machineId=="string")}}),define(Z[186],ee([0,1,20,9,10,24,45,25,22,179,19,26,3]),function(K,e,S,k,A,L,U,T,f,v,R,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let I=class extends U.AbstractSynchroniser{constructor(b,E,p,m,r,n,t,i,s){super("snippets",E,b,p,m,r,i,s,n,t);this.version=1,this.snippetsFolder=b.snippetsHome,this._register(this.fileService.watch(b.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(y.Event.filter(this.fileService.onDidFilesChange,c=>c.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(b,E,p){const m=await this.getSnippetsFileContents(),r=this.toSnippetsContents(m),n=b.syncData?this.parseSnippets(b.syncData):null,t=E&&E.syncData?this.parseSnippets(E.syncData):null;n?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,v.merge)(r,n,t);return this.getResourcePreviews(i,m,n||{})}async getMergeResult(b,E){return b.previewResult}async getAcceptResult(b,E,p,m){if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:b.fileContent?b.fileContent.value.toString():null,localChange:0,remoteChange:b.fileContent?b.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:b.remoteContent,localChange:b.remoteContent!==null?b.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder))return p===void 0?{content:b.previewResult.content,localChange:b.previewResult.localChange,remoteChange:b.previewResult.remoteChange}:{content:p,localChange:p===null?b.fileContent!==null?3:0:2,remoteChange:p===null?b.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${E.toString()}`)}async applyResult(b,E,p,m){const r=p.map(([n,t])=>Object.assign(Object.assign({},n),{acceptResult:t}));r.every(({localChange:n,remoteChange:t})=>n===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),r.some(({localChange:n})=>n!==0)&&(await this.updateLocalBackup(r),await this.updateLocalSnippets(r,m)),r.some(({remoteChange:n})=>n!==0)&&(b=await this.updateRemoteSnippets(r,b,m)),(E==null?void 0:E.ref)!==b.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(b),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:n}of r)try{await this.fileService.del(n)}catch(t){}}getResourcePreviews(b,E,p){const m=new Map;for(const r of Object.keys(b.local.added)){const n={content:b.local.added[r],hasConflicts:!1,localChange:1,remoteChange:0};m.set(r,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:p[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(b.local.updated)){const n={content:b.local.updated[r],hasConflicts:!1,localChange:2,remoteChange:0};m.set(r,{localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[r],localContent:E[r].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:p[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of b.local.removed){const n={content:null,hasConflicts:!1,localChange:3,remoteChange:0};m.set(r,{localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[r],localContent:E[r].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(b.remote.added)){const n={content:b.remote.added[r],hasConflicts:!1,localChange:0,remoteChange:1};m.set(r,{localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[r],localContent:E[r].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(b.remote.updated)){const n={content:b.remote.updated[r],hasConflicts:!1,localChange:0,remoteChange:2};m.set(r,{localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[r],localContent:E[r].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:p[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of b.remote.removed){const n={content:null,hasConflicts:!1,localChange:0,remoteChange:3};m.set(r,{localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:p[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of b.conflicts){const n={content:E[r]?E[r].value.toString():null,hasConflicts:!0,localChange:E[r]?2:1,remoteChange:p[r]?2:1};m.set(r,{localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[r]||null,localContent:E[r]?E[r].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:p[r]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(E))if(!m.has(r)){const n={content:E[r]?E[r].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};m.set(r,{localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[r]||null,localContent:E[r]?E[r].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:p[r]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...m.values()]}async getAssociatedResources({uri:b}){let E=await super.resolveContent(b);if(E){const p=this.parseSyncData(E);if(p){const m=this.parseSnippets(p),r=[];for(const n of Object.keys(m)){const t=this.extUri.joinPath(b,n),i=this.extUri.joinPath(this.snippetsFolder,n),s=await this.fileService.exists(i);r.push({resource:t,comparableResource:s?i:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})})}return r}}return[]}async resolveContent(b){if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(b);let E=await super.resolveContent(b);if(E)return E;if(E=await super.resolveContent(this.extUri.dirname(b)),E){const p=this.parseSyncData(E);if(p)return this.parseSnippets(p)[this.extUri.basename(b)]||null}return null}async hasLocalData(){try{const b=await this.getSnippetsFileContents();if(Object.keys(b).length)return!0}catch(b){}return!1}async updateLocalBackup(b){const E={};for(const p of b)p.fileContent&&(E[this.extUri.basename(p.localResource)]=p.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(E)))}async updateLocalSnippets(b,E){for(const{fileContent:p,acceptResult:m,localResource:r,remoteResource:n,localChange:t}of b)if(t!==0){const i=n?this.extUri.basename(n):this.extUri.basename(r),s=this.extUri.joinPath(this.snippetsFolder,i);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(s)),await this.fileService.del(s),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(s))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(s)),await this.fileService.createFile(s,f.VSBuffer.fromString(m.content),{overwrite:E}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(s))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(s)),await this.fileService.writeFile(s,f.VSBuffer.fromString(m.content),E?void 0:p),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(s)))}}async updateRemoteSnippets(b,E,p){const m=E.syncData?this.parseSnippets(E.syncData):{},r=(0,d.deepClone)(m);for(const{acceptResult:n,localResource:t,remoteResource:i,remoteChange:s}of b)if(s!==0){const c=t?this.extUri.basename(t):this.extUri.basename(i);s===3?delete r[c]:r[c]=n.content}return(0,v.areSame)(m,r)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),E=await this.updateRemoteUserData(JSON.stringify(r),p?null:E.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),E}parseSnippets(b){return JSON.parse(b.content)}toSnippetsContents(b){const E={};for(const p of Object.keys(b))E[p]=b[p].value.toString();return E}async getSnippetsFileContents(){const b={};let E;try{E=await this.fileService.resolve(this.snippetsFolder)}catch(p){if(p instanceof A.FileOperationError&&p.fileOperationResult===1)return b;throw p}for(const p of E.children||[]){const m=p.resource,r=this.extUri.extname(m);if(r===".json"||r===".code-snippets"){const n=this.extUri.relativePath(this.snippetsFolder,m),t=await this.fileService.readFile(m);b[n]=t}}return b}};I=he([Y(0,k.IEnvironmentService),Y(1,A.IFileService),Y(2,R.IStorageService),Y(3,S.IUserDataSyncStoreService),Y(4,S.IUserDataSyncBackupStoreService),Y(5,S.IUserDataSyncLogService),Y(6,L.IConfigurationService),Y(7,S.IUserDataSyncResourceEnablementService),Y(8,T.ITelemetryService)],I),e.SnippetsSynchroniser=I;let o=class extends U.AbstractInitializer{constructor(b,E,p){super("snippets",E,p,b)}async doInitialize(b){const E=b.syncData?JSON.parse(b.syncData.content):null;if(!E){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const m of Object.keys(E)){const r=E[m];if(r){const n=this.extUri.joinPath(this.environmentService.snippetsHome,m);await this.fileService.createFile(n,f.VSBuffer.fromString(r)),this.logService.info("Created snippet",this.extUri.basename(n))}}await this.updateLastSyncUserData(b)}async isEmpty(){var b;try{return!((b=(await this.fileService.resolve(this.environmentService.snippetsHome)).children)===null||b===void 0?void 0:b.length)}catch(E){return E.fileOperationResult===1}}};o=he([Y(0,A.IFileService),Y(1,k.IEnvironmentService),Y(2,S.IUserDataSyncLogService)],o),e.SnippetsInitializer=o}),define(Z[59],ee([0,1,5,3,2,20]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,S.createDecorator)("IUserDataSyncAccountService");let U=class extends A.Disposable{constructor(f){super();this.userDataSyncStoreService=f,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(f.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(f.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(f){(f&&this._account?f.token!==this._account.token||f.authenticationProviderId!==this._account.authenticationProviderId:f!==this._account)&&(this._account=f,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(f))}};U=he([Y(0,L.IUserDataSyncStoreService)],U),e.UserDataSyncAccountService=U}),define(Z[187],ee([0,1,2,20,12,24,10,9,53,22,6]),function(K,e,S,k,A,L,U,T,f,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let d=class extends S.Disposable{constructor(I,o,C,b){super();this.environmentService=I,this.fileService=o,this.configurationService=C,this.logService=b,k.ALL_SYNC_RESOURCES.forEach(E=>this.cleanUpBackup(E))}async getAllRefs(I){const o=(0,A.joinPath)(this.environmentService.userDataSyncHome,I),C=await this.fileService.resolve(o);return C.children?C.children.filter(E=>E.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(E.name)).sort().reverse().map(E=>({ref:E.name,created:this.getCreationTime(E)})):[]}async resolveContent(I,o){if(!o){const C=await this.getAllRefs(I);C.length&&(o=C[C.length-1].ref)}if(o){const C=(0,A.joinPath)(this.environmentService.userDataSyncHome,I,o);return(await this.fileService.readFile(C)).value.toString()}return null}async backup(I,o){const C=(0,A.joinPath)(this.environmentService.userDataSyncHome,I),b=(0,A.joinPath)(C,`${(0,f.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(b,v.VSBuffer.fromString(o))}catch(E){this.logService.error(E)}try{this.cleanUpBackup(I)}catch(E){}}async cleanUpBackup(I){const o=(0,A.joinPath)(this.environmentService.userDataSyncHome,I);try{try{if(!await this.fileService.exists(o))return}catch(b){return}const C=await this.fileService.resolve(o);if(C.children){const b=C.children.filter(r=>r.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(r.name)).sort(),E=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let p=b.filter(r=>Date.now()-this.getCreationTime(r)>E);const m=b.length-p.length;m<10&&(p=p.slice(10-m)),await R.Promises.settled(p.map(async r=>{this.logService.info("Deleting from backup",r.resource.path),await this.fileService.del(r.resource)}))}}catch(C){this.logService.error(C)}}getCreationTime(I){return I.ctime||new Date(parseInt(I.name.substring(0,4)),parseInt(I.name.substring(4,6))-1,parseInt(I.name.substring(6,8)),parseInt(I.name.substring(9,11)),parseInt(I.name.substring(11,13)),parseInt(I.name.substring(13,15))).getTime()}};d=he([Y(0,T.IEnvironmentService),Y(1,U.IFileService),Y(2,L.IConfigurationService),Y(3,k.IUserDataSyncLogService)],d),e.UserDataSyncBackupStoreService=d}),define(Z[188],ee([0,1,4,2]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class A{constructor(y){this.service=y}listen(y,I){switch(I){case"onError":return this.service.onError}throw new Error(`Event not found: ${I}`)}call(y,I,o){switch(I){case"triggerSync":return this.service.triggerSync(o[0],o[1],o[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(o[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=A;class L{constructor(y){this.service=y}listen(y,I){throw new Error(`Event not found: ${I}`)}call(y,I,o){switch(I){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(o[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(S.URI.revive(o[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class U{constructor(y){this.channel=y}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(y){return this.channel.call("resolveUserKeybindings",[y])}async resolveFormattingOptions(y){return this.channel.call("resolveFormattingOptions",[y])}}e.UserDataSyncUtilServiceClient=U;class T{constructor(y){this.service=y}listen(y,I){switch(I){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${I}`)}async call(y,I,o){switch(I){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(o[0],o[1]);case"setEnablement":return this.service.setEnablement(o[0],o[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=T;class f{constructor(y){this.service=y}listen(y,I){switch(I){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${I}`)}call(y,I,o){switch(I){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(o)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=f;class v{constructor(y){this.service=y}listen(y,I){switch(I){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${I}`)}call(y,I,o){switch(I){case"switch":return this.service.switch(o[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=v;class R extends k.Disposable{constructor(y){super();this.channel=y,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(y){return this.channel.call("switch",[y])}async getPreviousUserDataSyncStore(){const y=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(y)}revive(y){return{url:S.URI.revive(y.url),type:y.type,defaultUrl:S.URI.revive(y.defaultUrl),insidersUrl:S.URI.revive(y.insidersUrl),stableUrl:S.URI.revive(y.stableUrl),canSwitch:y.canSwitch,authenticationProviders:y.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=R}),define(Z[189],ee([0,1,17,9]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let A=class extends S.AbstractLogger{constructor(U,T){super();this.logger=this._register(U.createLogger(T.userDataSyncLogResource,{name:"settingssync"}))}trace(U,...T){this.logger.trace(U,...T)}debug(U,...T){this.logger.debug(U,...T)}info(U,...T){this.logger.info(U,...T)}warn(U,...T){this.logger.warn(U,...T)}error(U,...T){this.logger.error(U,...T)}critical(U,...T){this.logger.critical(U,...T)}flush(){this.logger.flush()}};A=he([Y(0,S.ILoggerService),Y(1,k.IEnvironmentService)],A),e.UserDataSyncLogService=A}),define(Z[60],ee([0,1,5,2,44,9,10,19,20,124,28,7,21,3]),function(K,e,S,k,A,L,U,T,f,v,R,d,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,S.createDecorator)("IUserDataSyncMachinesService");const o="sync.currentMachineName";let C=class Ve extends k.Disposable{constructor(E,p,m,r,n,t){super();this.storageService=m,this.userDataSyncStoreService=r,this.logService=n,this.productService=t,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,A.getServiceMachineId)(E,p,m)}async getMachines(E){const p=await this.currentMachineIdPromise;return(await this.readMachinesData(E)).machines.map(r=>Object.assign(Object.assign({},r),{isCurrent:r.id===p}))}async addCurrentMachine(E){const p=await this.currentMachineIdPromise,m=await this.readMachinesData(E);m.machines.some(({id:r})=>r===p)||(m.machines.push({id:p,name:this.computeCurrentMachineName(m.machines)}),await this.writeMachinesData(m))}async removeCurrentMachine(E){const p=await this.currentMachineIdPromise,m=await this.readMachinesData(E),r=m.machines.filter(({id:n})=>n!==p);r.length!==m.machines.length&&(m.machines=r,await this.writeMachinesData(m))}async renameMachine(E,p,m){const r=await this.currentMachineIdPromise,n=await this.readMachinesData(m),t=n.machines.find(({id:i})=>i===E);t&&(t.name=p,await this.writeMachinesData(n),n.machines.some(({id:i})=>i===r)&&this.storageService.store(o,p,0,1))}async setEnablement(E,p){const m=await this.readMachinesData(),r=m.machines.find(({id:n})=>n===E);r&&(r.disabled=p?void 0:!0,await this.writeMachinesData(m))}computeCurrentMachineName(E){const p=this.storageService.get(o,0);if(p)return p;const m=`${this.productService.nameLong} (${(0,d.PlatformToString)(d.isWeb?0:d.platform)})`,r=new RegExp(`${(0,y.escapeRegExpCharacters)(m)}\\s#(\\d+)`);let n=0;for(const t of E){const i=r.exec(t.name),s=i?parseInt(i[1]):0;n=s>n?s:n}return`${m} #${n+1}`}async readMachinesData(E){this.userData=await this.readUserData(E);const p=this.parse(this.userData);if(p.version!==Ve.VERSION)throw new Error((0,v.localize)(0,null,this.productService.nameLong));return p}async writeMachinesData(E){var p;const m=JSON.stringify(E),r=await this.userDataSyncStoreService.write(Ve.RESOURCE,m,((p=this.userData)===null||p===void 0?void 0:p.ref)||null);this.userData={ref:r,content:m},this._onDidChange.fire()}async readUserData(E){if(this.userData){const p=E&&E.latest?E.latest[Ve.RESOURCE]:void 0;if(this.userData.ref===p)return this.userData;if(p===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ve.RESOURCE,this.userData)}parse(E){if(E.content!==null)try{return JSON.parse(E.content)}catch(p){this.logService.error(p)}return{version:Ve.VERSION,machines:[]}}};C.VERSION=1,C.RESOURCE="machines",C=he([Y(0,L.IEnvironmentService),Y(1,U.IFileService),Y(2,T.IStorageService),Y(3,f.IUserDataSyncStoreService),Y(4,f.IUserDataSyncLogService),Y(5,R.IProductService)],C),e.UserDataSyncMachinesService=C}),define(Z[83],ee([0,1,6,3,2,20,59,25,11,19,9,60,122,53,4,12,7,28]),function(K,e,S,k,A,L,U,T,f,v,R,d,y,I,o,C,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const p="sync.enable",m="sync.disableMachineEventually",r="sync.sessionId",n="sync.storeUrl",t="sync.productQuality";let i=class extends A.Disposable{constructor(l,h,g){super();this.storageService=l,this.environmentService=h,this.userDataSyncStoreManagementService=g,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(l.onDidChangeValue(w=>this.onDidStorageChange(w)))}isEnabled(l){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(p,0,!!l)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(l){l&&!this.canToggleEnablement()||this.storageService.store(p,l,0,1)}onDidStorageChange(l){if(l.scope===0&&p===l.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};i=he([Y(0,v.IStorageService),Y(1,R.IEnvironmentService),Y(2,L.IUserDataSyncStoreManagementService)],i),e.UserDataAutoSyncEnablementService=i;let s=class extends A.Disposable{constructor(l,h,g,w,u,P,_,z,B,M,j){var W;super();this.userDataSyncStoreManagementService=h,this.userDataSyncStoreService=g,this.userDataSyncResourceEnablementService=w,this.userDataSyncService=u,this.logService=P,this.userDataSyncAccountService=_,this.telemetryService=z,this.userDataSyncMachinesService=B,this.storageService=M,this.autoSync=this._register(new A.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=j,this.syncTriggerDelayer=this._register(new S.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=(W=h.userDataSyncStore)===null||W===void 0?void 0:W.url,this.previousProductQuality=this.productQuality,this.productQuality=l.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(h.onDidChangeUserDataSyncStore(()=>{var $,H;(0,C.isEqual)(this.syncUrl,($=h.userDataSyncStore)===null||$===void 0?void 0:$.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=(H=h.userDataSyncStore)===null||H===void 0?void 0:H.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(_.onDidChangeAccount(()=>this.updateAutoSync())),this._register(g.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(k.Event.debounce(u.onDidChangeLocal,($,H)=>$?[...$,H]:[H],1e3)($=>this.triggerSync($,!1,!1))),this._register(k.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,$])=>$)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const l=this.storageService.get(n,0);return l?o.URI.parse(l):void 0}set syncUrl(l){l?this.storageService.store(n,l.toString(),0,1):this.storageService.remove(n,0)}get productQuality(){return this.storageService.get(t,0)}set productQuality(l){l?this.storageService.store(t,l,0,1):this.storageService.remove(t,0)}updateAutoSync(){const{enabled:l,message:h}=this.isAutoSyncEnabled();l?this.autoSync.value===void 0&&(this.autoSync.value=new c(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(g=>this.onDidFinishSync(g))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(h&&this.logService.info(h),this.autoSync.clear()):h&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(h))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,I.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(l,h,g){try{this.userDataSyncAccountService.account&&!g&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(r,0),l?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(w){if(h)this.logService.error(w),this.updateEnablement(!1);else throw w}}updateEnablement(l){this.userDataAutoSyncEnablementService.isEnabled()!==l&&(this.telemetryService.publicLog2(p,{enabled:l}),this.userDataAutoSyncEnablementService.setEnablement(l),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(l){if(!l){this.successiveFailures=0;return}const h=L.UserDataSyncError.toUserDataSyncError(l);h instanceof L.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:h.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),h.code===L.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):h.code===L.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):h.code===L.UserDataSyncErrorCode.LocalTooManyRequests||h.code===L.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):h.code===L.UserDataSyncErrorCode.UpgradeRequired||h.code===L.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):h.code===L.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${h.resource} content with newer version than of client. Requires client upgrade.`)):h.code===L.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${h.resource} content with older version than of client. Requires server reset.`)):h.code===L.UserDataSyncErrorCode.ServiceChanged||h.code===L.UserDataSyncErrorCode.DefaultServiceChanged?b.isWeb&&h.code===L.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(h),this.successiveFailures++),this._onError.fire(h)}async disableMachineEventually(){this.storageService.store(m,!0,0,1),await(0,S.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(m,0,!1)}stopDisableMachineEventually(){this.storageService.remove(m,0)}async triggerSync(l,h,g){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(h&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...l),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",g)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};s=he([Y(0,E.IProductService),Y(1,L.IUserDataSyncStoreManagementService),Y(2,L.IUserDataSyncStoreService),Y(3,L.IUserDataSyncResourceEnablementService),Y(4,L.IUserDataSyncService),Y(5,L.IUserDataSyncLogService),Y(6,U.IUserDataSyncAccountService),Y(7,T.ITelemetryService),Y(8,d.IUserDataSyncMachinesService),Y(9,v.IStorageService),Y(10,L.IUserDataAutoSyncEnablementService)],s),e.UserDataAutoSyncService=s;class c extends A.Disposable{constructor(l,h,g,w,u,P,_,z){super();this.lastSyncUrl=l,this.interval=h,this.userDataSyncStoreManagementService=g,this.userDataSyncStoreService=w,this.userDataSyncService=u,this.userDataSyncMachinesService=P,this.logService=_,this.storageService=z,this.intervalHandler=this._register(new A.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,A.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(c.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,S.disposableTimeout)(()=>this.sync(c.INTERVAL_SYNCING,!1),this.interval)}sync(l,h){const g=(0,S.createCancelablePromise)(async w=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(u){if((0,f.isPromiseCanceledError)(u))return}return this.doSync(l,h,w)});return this.syncPromise=g,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){var l;return this.lastSyncUrl!==void 0&&!(0,C.isEqual)(this.lastSyncUrl,(l=this.userDataSyncStoreManagementService.userDataSyncStore)===null||l===void 0?void 0:l.url)}async hasDefaultServiceChanged(){const l=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),h=this.userDataSyncStoreManagementService.userDataSyncStore;return!!h&&!!l&&(!(0,C.isEqual)(h.defaultUrl,l.defaultUrl)||!(0,C.isEqual)(h.insidersUrl,l.insidersUrl)||!(0,C.isEqual)(h.stableUrl,l.stableUrl))}async doSync(l,h,g){this.logService.info(`Auto Sync: Triggered by ${l}`),this._onDidStartSync.fire();let w;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(h),g.isCancellationRequested)return;let u=this.syncTask.manifest;if(u===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new L.UserDataAutoSyncError((0,y.localize)(0,null),L.UserDataSyncErrorCode.DefaultServiceChanged):new L.UserDataAutoSyncError((0,y.localize)(1,null),L.UserDataSyncErrorCode.ServiceChanged):new L.UserDataAutoSyncError((0,y.localize)(2,null),L.UserDataSyncErrorCode.TurnedOff);const P=this.storageService.get(r,0);if(P&&u&&P!==u.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new L.UserDataAutoSyncError((0,y.localize)(3,null),L.UserDataSyncErrorCode.DefaultServiceChanged):new L.UserDataAutoSyncError((0,y.localize)(4,null),L.UserDataSyncErrorCode.ServiceChanged):new L.UserDataAutoSyncError((0,y.localize)(5,null),L.UserDataSyncErrorCode.SessionExpired);const _=await this.userDataSyncMachinesService.getMachines(u||void 0);if(g.isCancellationRequested)return;const z=_.find(B=>B.isCurrent);if(z==null?void 0:z.disabled)throw new L.UserDataAutoSyncError((0,y.localize)(6,null),L.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),u===null&&(u=await this.userDataSyncStoreService.manifest()),u&&u.session!==P&&this.storageService.store(r,u.session,0,1),g.isCancellationRequested)return;z||await this.userDataSyncMachinesService.addCurrentMachine(u||void 0)}catch(u){this.logService.error(u),w=u}this._onDidFinishSync.fire(w)}register(l){return super._register(l)}}c.INTERVAL_SYNCING="Interval"}),define(Z[190],ee([0,1,20,2,3,19,25,7]),function(K,e,S,k,A,L,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let f=class extends k.Disposable{constructor(R,d){super();this.storageService=R,this.telemetryService=d,this._onDidChangeResourceEnablement=new A.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(R.onDidChangeValue(y=>this.onDidStorageChange(y)))}isResourceEnabled(R){return this.storageService.getBoolean((0,S.getEnablementKey)(R),0,!0)}setResourceEnablement(R,d){if(this.isResourceEnabled(R)!==d){const y=(0,S.getEnablementKey)(R);this.telemetryService.publicLog2(y,{enabled:d}),this.storeResourceEnablement(y,d)}}getResourceSyncStateVersion(R){}storeResourceEnablement(R,d){this.storageService.store(R,d,0,T.isWeb?0:1)}onDidStorageChange(R){if(R.scope===0){const d=S.ALL_SYNC_RESOURCES.filter(y=>(0,S.getEnablementKey)(y)===R.key)[0];if(d){this._onDidChangeResourceEnablement.fire([d,this.isResourceEnabled(d)]);return}}}};f=he([Y(0,L.IStorageService),Y(1,U.ITelemetryService)],f),e.UserDataSyncResourceEnablementService=f}),define(Z[191],ee([0,1,20,2,5,3,180,183,182,43,25,18,19,185,12,186,31,6,11]),function(K,e,S,k,A,L,U,T,f,v,R,d,y,I,o,C,b,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const m="sync.lastSyncTime";let r=class extends k.Disposable{constructor(s,c,a,l,h,g){super();this.userDataSyncStoreService=s,this.userDataSyncStoreManagementService=c,this.instantiationService=a,this.logService=l,this.telemetryService=h,this.storageService=g,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(I.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(T.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(C.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(f.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(U.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(L.Event.any(...this.synchronisers.map(w=>L.Event.map(w.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(L.Event.any(...this.synchronisers.map(w=>L.Event.map(w.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(m,0,void 0),this.onDidChangeLocal=L.Event.any(...this.synchronisers.map(w=>L.Event.map(w.onDidChangeLocal,()=>w.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(s){await this.checkEnablement();const c=(0,b.generateUuid)();let a;try{const w=(0,S.createSyncHeaders)(c);s&&(w["Cache-Control"]="no-cache"),a=await this.userDataSyncStoreService.manifest(w)}catch(w){const u=S.UserDataSyncError.toUserDataSyncError(w);throw this.reportUserDataSyncError(u,c),u}let l=!1;const h=this;let g;return{manifest:a,run(){if(l)throw new Error("Can run a task only once");return g=(0,E.createCancelablePromise)(w=>h.sync(a,c,w)),g.finally(()=>g=void 0)},async stop(){if(g&&g.cancel(),h.status!=="idle")return h.stop()}}}async createManualSyncTask(){await this.checkEnablement();const s=(0,b.generateUuid)(),c=(0,S.createSyncHeaders)(s);let a;try{a=await this.userDataSyncStoreService.manifest(c)}catch(l){const h=S.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(h,s),h}return new n(s,a,c,this.synchronisers,this.logService)}async sync(s,c,a){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),!a.isCancellationRequested){const l=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const h=(0,S.createSyncHeaders)(c);for(const g of this.synchronisers){if(a.isCancellationRequested)return;try{await g.sync(s,h)}catch(w){if(w instanceof S.UserDataSyncError)switch(w.code){case S.UserDataSyncErrorCode.TooLarge:throw new S.UserDataSyncError(w.message,w.code,g.resource);case S.UserDataSyncErrorCode.TooManyRequests:case S.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case S.UserDataSyncErrorCode.LocalTooManyRequests:case S.UserDataSyncErrorCode.Gone:case S.UserDataSyncErrorCode.UpgradeRequired:case S.UserDataSyncErrorCode.IncompatibleRemoteContent:case S.UserDataSyncErrorCode.IncompatibleLocalContent:throw w}const u=S.UserDataSyncError.toUserDataSyncError(w);this.reportUserDataSyncError(u,c),this.logService.error(w),this.logService.error(`${g.resource}: ${(0,v.toErrorMessage)(w)}`),this._syncErrors.push([g.resource,u])}}this.logService.info(`Sync done. Took ${new Date().getTime()-l}ms`),this.updateLastSyncTime()}catch(h){const g=S.UserDataSyncError.toUserDataSyncError(h);throw this.reportUserDataSyncError(g,c),g}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}}async stop(){if(this.status!=="idle")for(const s of this.synchronisers)try{s.status!=="idle"&&await s.stop()}catch(c){this.logService.error(c)}}async replace(s){await this.checkEnablement();for(const c of this.synchronisers)if(await c.replace(s))return}async accept(s,c,a,l){await this.checkEnablement();const h=this.getSynchroniser(s);await h.accept(c,a),l&&await h.apply(!1,(0,S.createSyncHeaders)((0,b.generateUuid)()))}async resolveContent(s){for(const c of this.synchronisers){const a=await c.resolveContent(s);if(a)return a}return null}getRemoteSyncResourceHandles(s){return this.getSynchroniser(s).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(s){return this.getSynchroniser(s).getLocalSyncResourceHandles()}getAssociatedResources(s,c){return this.getSynchroniser(s).getAssociatedResources(c)}getMachineId(s,c){return this.getSynchroniser(s).getMachineId(c)}async hasLocalData(){const s=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const c of s)if(await c.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(s){this.logService.error(s)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(m,0);for(const s of this.synchronisers)try{await s.resetLocal()}catch(c){this.logService.error(`${s.resource}: ${(0,v.toErrorMessage)(c)}`),this.logService.error(c)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const s of this.synchronisers)if(await s.hasPreviouslySynced())return!0;return!1}setStatus(s){const c=this._status;this._status!==s&&(this._status=s,this._onDidChangeStatus.fire(s),c==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const s=this.computeStatus();this.setStatus(s)}updateConflicts(){const s=this.computeConflicts();(0,d.equals)(this._conflicts,s,([c,a],[l,h])=>c===c&&(0,d.equals)(a,h,(g,w)=>(0,o.isEqual)(g.previewResource,w.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(s))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(s=>s.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(s=>s.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(m,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(s,c){this.telemetryService.publicLog2("sync/error",{code:s.code,url:s instanceof S.UserDataSyncStoreError?s.url:void 0,resource:s.resource,executionId:c,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(s=>s.status==="hasConflicts").map(s=>[s.resource,s.conflicts.map(t)])}getSynchroniser(s){return this.synchronisers.find(c=>c.resource===s)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};r=he([Y(0,S.IUserDataSyncStoreService),Y(1,S.IUserDataSyncStoreManagementService),Y(2,A.IInstantiationService),Y(3,S.IUserDataSyncLogService),Y(4,R.ITelemetryService),Y(5,y.IStorageService)],r),e.UserDataSyncService=r;class n extends k.Disposable{constructor(s,c,a,l,h){super();this.id=s,this.manifest=c,this.syncHeaders=a,this.synchronisers=l,this.logService=h,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new L.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(s=>s.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(s=>s.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,E.createCancelablePromise)(s=>this.getPreviews(s))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(s){throw this.logService.error(s),s}}async accept(s,c){try{return await this.performAction(s,a=>a.accept(s,c))}catch(a){throw this.logService.error(a),a}}async merge(s){try{return s?await this.performAction(s,c=>c.merge(s)):await this.mergeAll()}catch(c){throw this.logService.error(c),c}}async discard(s){try{return await this.performAction(s,c=>c.discard(s))}catch(c){throw this.logService.error(c),c}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const s=[];for(const[,c]of this.previews)for(const a of c.resourcePreviews)a.mergeState==="conflict"&&s.push(a.previewResource);for(const c of s)await this.discard(c);return this.previews}catch(s){throw this.logService.error(s),s}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const s=[];for(const[c,a]of this.previews){this.synchronizingResources.push([c,a.resourcePreviews.map(g=>g.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(g=>g.resource===c);for(const g of a.resourcePreviews)(g.localChange!==0||g.remoteChange!==0)&&g.mergeState==="preview"&&await l.merge(g.previewResource);const h=await l.apply(!1,this.syncHeaders);h&&s.push(this.toSyncResourcePreview(l.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(g=>g[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=s,this.previews}catch(s){throw this.logService.error(s),s}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[s,c]of this.previews){this.synchronizingResources.push([s,c.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const a=this.synchronisers.find(l=>l.resource===s);for(const l of c.resourcePreviews)await a.accept(l.remoteResource);await a.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(s){throw this.logService.error(s),s}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[s,c]of this.previews){this.synchronizingResources.push([s,c.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const a=this.synchronisers.find(l=>l.resource===s);for(const l of c.resourcePreviews)await a.accept(l.localResource);await a.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(s){throw this.logService.error(s),s}}async stop(){for(const s of this.synchronisers)try{await s.stop()}catch(c){(0,p.isPromiseCanceledError)(c)||this.logService.error(c)}this.reset()}async performAction(s,c){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const a=this.previews.findIndex(([,z])=>z.resourcePreviews.some(({localResource:B,previewResource:M,remoteResource:j})=>(0,o.isEqual)(s,B)||(0,o.isEqual)(s,M)||(0,o.isEqual)(s,j)));if(a===-1)return this.previews;const[l,h]=this.previews[a],g=h.resourcePreviews.find(({localResource:z,remoteResource:B,previewResource:M})=>(0,o.isEqual)(z,s)||(0,o.isEqual)(B,s)||(0,o.isEqual)(M,s));if(!g)return this.previews;let w=this.synchronizingResources.find(z=>z[0]===l);w||(w=[l,[]],this.synchronizingResources.push(w)),w[1].some(z=>(0,o.isEqual)(z,g.localResource))||(w[1].push(g.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const u=this.synchronisers.find(z=>z.resource===this.previews[a][0]),P=await c(u);P?this.previews.splice(a,1,this.toSyncResourcePreview(u.resource,P)):this.previews.splice(a,1);const _=this.synchronizingResources.findIndex(z=>z[0]===l);return this.synchronizingResources[_][1].splice(w[1].findIndex(z=>(0,o.isEqual)(z,g.localResource)),1),w[1].length||(this.synchronizingResources.splice(_,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const s=[];for(const[c,a]of this.previews){this.synchronizingResources.push([c,a.resourcePreviews.map(g=>g.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(g=>g.resource===c);let h=a;for(const g of a.resourcePreviews)(g.localChange!==0||g.remoteChange!==0)&&g.mergeState==="preview"&&(h=await l.merge(g.previewResource));h&&s.push(this.toSyncResourcePreview(l.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(g=>g[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=s,this.previews}async getPreviews(s){const c=[];for(const a of this.synchronisers){if(s.isCancellationRequested)return[];const l=await a.preview(this.manifest,this.syncHeaders);l&&c.push(this.toSyncResourcePreview(a.resource,l))}return c}toSyncResourcePreview(s,c){return[s,{isLastSyncFromCurrentMachine:c.isLastSyncFromCurrentMachine,resourcePreviews:c.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(i){return{localResource:i.localResource,previewResource:i.previewResource,remoteResource:i.remoteResource,acceptedResource:i.acceptedResource,localChange:i.localChange,remoteChange:i.remoteChange,mergeState:i.mergeState}}}),define(Z[192],ee([0,1,3,20,4,2,15]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class T{constructor(d,y){this.service=d,this.logService=y,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new S.Emitter}listen(d,y){switch(y){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${y}`)}async call(d,y,I){try{return await this._call(d,y,I)}catch(o){throw this.logService.error(o),o}}async _call(d,y,I){switch(y){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(A.URI.revive(I[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(I[0],A.URI.revive(I[1]),I[2],I[3]);case"resolveContent":return this.service.resolveContent(A.URI.revive(I[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(I[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(I[0]);case"getAssociatedResources":return this.service.getAssociatedResources(I[0],{created:I[1].created,uri:A.URI.revive(I[1].uri)});case"getMachineId":return this.service.getMachineId(I[0],{created:I[1].created,uri:A.URI.revive(I[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(y.startsWith("manualSync/")){const o=y.substring("manualSync/".length),C=I[0],b=this.getManualSyncTask(C);switch(I=I.slice(1),o){case"preview":return b.preview();case"accept":return b.accept(A.URI.revive(I[0]),I[1]);case"merge":return b.merge(A.URI.revive(I[0]));case"discard":return b.discard(A.URI.revive(I[0]));case"discardConflicts":return b.discardConflicts();case"apply":return b.apply();case"pull":return b.pull();case"push":return b.push();case"stop":return b.stop();case"_getStatus":return b.status;case"dispose":return this.disposeManualSyncTask(b)}}throw new Error("Invalid call")}getManualSyncTask(d){const y=this.manualSyncTasks.get(this.createKey(d));if(!y)throw new Error(`Manual sync taks not found: ${d}`);return y.manualSyncTask}async createManualSyncTask(){const d=new L.DisposableStore,y=d.add(await this.service.createManualSyncTask());return d.add(y.onSynchronizeResources(I=>this.onManualSynchronizeResources.fire({manualSyncTaskId:y.id,data:I}))),this.manualSyncTasks.set(this.createKey(y.id),{manualSyncTask:y,disposables:d}),{id:y.id,manifest:y.manifest,status:y.status}}disposeManualSyncTask(d){var y;d.dispose();const I=this.createKey(d.id);(y=this.manualSyncTasks.get(I))===null||y===void 0||y.disposables.dispose(),this.manualSyncTasks.delete(I)}createKey(d){return`manualSyncTask-${d}`}}e.UserDataSyncChannel=T;class f extends L.Disposable{constructor(d){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new S.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new S.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new S.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new S.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(y,I,o){return d.call(y,I,o).then(null,C=>{throw k.UserDataSyncError.toUserDataSyncError(C)})},listen(y,I){return d.listen(y,I)}},this.channel.call("_getInitialData").then(([y,I,o])=>{this.updateStatus(y),this.updateConflicts(I),o&&this.updateLastSyncTime(o),this._register(this.channel.listen("onDidChangeStatus")(C=>this.updateStatus(C))),this._register(this.channel.listen("onDidChangeLastSyncTime")(C=>this.updateLastSyncTime(C)))}),this._register(this.channel.listen("onDidChangeConflicts")(y=>this.updateConflicts(y))),this._register(this.channel.listen("onSyncErrors")(y=>this._onSyncErrors.fire(y.map(([I,o])=>[I,k.UserDataSyncError.toUserDataSyncError(o)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:d,manifest:y,status:I}=await this.channel.call("createManualSyncTask"),o=this,C=new v(d,y,I,{async call(b,E,p){return o.channel.call(`manualSync/${b}`,[d,...(0,U.isArray)(E)?E:[E]],p)},listen(b,E){return S.Event.map(S.Event.filter(o.channel.listen(`manualSync/${b}`,E),p=>!C.isDiposed()&&p.manualSyncTaskId===d),p=>p.data)}});return C}replace(d){return this.channel.call("replace",[d])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(d,y,I,o){return this.channel.call("accept",[d,y,I,o])}resolveContent(d){return this.channel.call("resolveContent",[d])}async getLocalSyncResourceHandles(d){return(await this.channel.call("getLocalSyncResourceHandles",[d])).map(({created:I,uri:o})=>({created:I,uri:A.URI.revive(o)}))}async getRemoteSyncResourceHandles(d){return(await this.channel.call("getRemoteSyncResourceHandles",[d])).map(({created:I,uri:o})=>({created:I,uri:A.URI.revive(o)}))}async getAssociatedResources(d,y){return(await this.channel.call("getAssociatedResources",[d,y])).map(({resource:o,comparableResource:C})=>({resource:A.URI.revive(o),comparableResource:A.URI.revive(C)}))}async getMachineId(d,y){return this.channel.call("getMachineId",[d,y])}async updateStatus(d){this._status=d,this._onDidChangeStatus.fire(d)}async updateConflicts(d){this._conflicts=d.map(([y,I])=>[y,I.map(o=>Object.assign(Object.assign({},o),{localResource:A.URI.revive(o.localResource),remoteResource:A.URI.revive(o.remoteResource),previewResource:A.URI.revive(o.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(d){this._lastSyncTime!==d&&(this._lastSyncTime=d,this._onDidChangeLastSyncTime.fire(d))}}e.UserDataSyncChannelClient=f;class v extends L.Disposable{constructor(d,y,I,o){super();this.id=d,this.manifest=y,this._disposed=!1,this._status=I;const C=this;this.channel={async call(b,E,p){try{const m=await o.call(b,E,p);return C.isDiposed()||(C._status=await o.call("_getStatus")),m}catch(m){throw k.UserDataSyncError.toUserDataSyncError(m)}},listen(b,E){return o.listen(b,E)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const d=await this.channel.call("preview");return this.deserializePreviews(d)}async accept(d,y){const I=await this.channel.call("accept",[d,y]);return this.deserializePreviews(I)}async merge(d){const y=await this.channel.call("merge",[d]);return this.deserializePreviews(y)}async discard(d){const y=await this.channel.call("discard",[d]);return this.deserializePreviews(y)}async discardConflicts(){const d=await this.channel.call("discardConflicts");return this.deserializePreviews(d)}async apply(){const d=await this.channel.call("apply");return this.deserializePreviews(d)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(d){return d.map(([y,I])=>[y,{isLastSyncFromCurrentMachine:I.isLastSyncFromCurrentMachine,resourcePreviews:I.resourcePreviews.map(o=>Object.assign(Object.assign({},o),{localResource:A.URI.revive(o.localResource),remoteResource:A.URI.revive(o.remoteResource),previewResource:A.URI.revive(o.previewResource),acceptedResource:A.URI.revive(o.acceptedResource)}))}])}}}),define(Z[193],ee([0,1,2,20,40,12,30,24,28,44,9,10,19,31,7,3,6,15,4,11]),function(K,e,S,k,A,L,U,T,f,v,R,d,y,I,o,C,b,E,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const r="sync.previous.store",n="sync.donot-make-requests-until",t="sync.user-session-id",i="sync.machine-session-id",s=100,c=1e3*60*5;let a=class extends S.Disposable{constructor(P,_,z){super();this.productService=P,this.configurationService=_,this.storageService=z,this._onDidChangeUserDataSyncStore=this._register(new C.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(C.Event.filter(z.onDidChangeValue,B=>{var M;return B.key===k.SYNC_SERVICE_URL_TYPE&&B.scope===0&&this.userDataSyncStoreType!==((M=this.userDataSyncStore)===null||M===void 0?void 0:M.type)})(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(k.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(P){this.storageService.store(k.SYNC_SERVICE_URL_TYPE,P,0,o.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[k.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(k.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(P,_){P=o.isWeb&&(P==null?void 0:P.web)?Object.assign(Object.assign({},P),P.web):P;const z=Object.assign(Object.assign({},P||{}),_||{});if(z&&(0,E.isString)(z.url)&&(0,E.isObject)(z.authenticationProviders)&&Object.keys(z.authenticationProviders).every(B=>(0,E.isArray)(z.authenticationProviders[B].scopes))){const B=z,M=!!B.canSwitch&&!(_==null?void 0:_.url),j=B.url===B.insidersUrl?"insiders":"stable",W=(M?this.userDataSyncStoreType:void 0)||j,$=(_==null?void 0:_.url)||(W==="insiders"?B.insidersUrl:W==="stable"?B.stableUrl:B.url);return{url:p.URI.parse($),type:W,defaultType:j,defaultUrl:p.URI.parse(B.url),stableUrl:p.URI.parse(B.stableUrl),insidersUrl:p.URI.parse(B.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(B.authenticationProviders).reduce((H,q)=>(H.push({id:q,scopes:B.authenticationProviders[q].scopes}),H),[])}}}};a=he([Y(0,f.IProductService),Y(1,T.IConfigurationService),Y(2,y.IStorageService)],a),e.AbstractUserDataSyncStoreManagementService=a;let l=class extends a{constructor(P,_,z){super(P,_,z);const B=this.storageService.get(r,0);B&&(this.previousConfigurationSyncStore=JSON.parse(B));const M=this.productService[k.CONFIGURATION_SYNC_STORE_KEY];M?this.storageService.store(r,JSON.stringify(M),0,1):this.storageService.remove(r,0)}async switch(P){P!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=P,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};l=he([Y(0,f.IProductService),Y(1,T.IConfigurationService),Y(2,y.IStorageService)],l),e.UserDataSyncStoreManagementService=l;let h=class extends S.Disposable{constructor(P,_,z,B,M,j,W){super();this.requestService=z,this.logService=B,this.storageService=W,this._onTokenFailed=this._register(new C.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new C.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new C.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(P),this.commonHeadersPromise=(0,v.getServiceMachineId)(M,j,W).then($=>{const H={"X-Client-Name":`${_.applicationName}${o.isWeb?"-web":""}`,"X-Client-Version":_.version,"X-Machine-Id":$};return _.commit&&(H["X-Client-Commit"]=_.commit),H}),this.session=new w(s,c,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,S.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(P,_){this.authToken={token:P,type:_}}updateUserDataSyncStoreUrl(P){this.userDataSyncStoreUrl=P?(0,L.joinPath)(P,"v1"):void 0}initDonotMakeRequestsUntil(){const P=this.storageService.getNumber(n,0);P&&Date.now()<P&&this.setDonotMakeRequestsUntil(new Date(P))}setDonotMakeRequestsUntil(P){var _;((_=this._donotMakeRequestsUntil)===null||_===void 0?void 0:_.getTime())!==(P==null?void 0:P.getTime())&&(this._donotMakeRequestsUntil=P,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(n,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,b.createCancelablePromise)(z=>(0,b.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),z).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,z=>null)):this.storageService.remove(n,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(P){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource",P),z={},B=await this.request(_.toString(),{type:"GET",headers:z},[],U.CancellationToken.None);return(await(0,A.asJson)(B)||[]).map(({url:j,created:W})=>({ref:(0,L.relativePath)(_,_.with({path:j})),created:W*1e3}))}async resolveContent(P,_){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource",P,_).toString(),B={};B["Cache-Control"]="no-cache";const M=await this.request(z,{type:"GET",headers:B},[],U.CancellationToken.None);return await(0,A.asText)(M)}async delete(P){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource",P).toString(),z={};await this.request(_,{type:"DELETE",headers:z},[],U.CancellationToken.None)}async read(P,_,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const B=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource",P,"latest").toString();z=Object.assign({},z),z["Cache-Control"]="no-cache",_&&(z["If-None-Match"]=_.ref);const M=await this.request(B,{type:"GET",headers:z},[304],U.CancellationToken.None);if(M.res.statusCode===304)return _;const j=M.res.headers.etag;if(!j)throw new k.UserDataSyncStoreError("Server did not return the ref",B,k.UserDataSyncErrorCode.NoRef,M.res.headers[k.HEADER_OPERATION_ID]);const W=await(0,A.asText)(M);return{ref:j,content:W}}async write(P,_,z,B={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource",P).toString();B=Object.assign({},B),B["Content-Type"]="text/plain",z&&(B["If-Match"]=z);const j=await this.request(M,{type:"POST",data:_,headers:B},[],U.CancellationToken.None),W=j.res.headers.etag;if(!W)throw new k.UserDataSyncStoreError("Server did not return the ref",M,k.UserDataSyncErrorCode.NoRef,j.res.headers[k.HEADER_OPERATION_ID]);return W}async manifest(P={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,L.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();P=Object.assign({},P),P["Content-Type"]="application/json";const z=await this.request(_,{type:"GET",headers:P},[],U.CancellationToken.None),B=await(0,A.asJson)(z),M=this.storageService.get(t,0);return M&&B&&M!==B.session&&this.clearSession(),B===null&&M&&this.clearSession(),B&&this.storageService.store(t,B.session,0,1),B}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const P=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),_={"Content-Type":"text/plain"};await this.request(P,{type:"DELETE",headers:_},[],U.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(t,0),this.storageService.remove(i,0)}async request(P,_,z,B){if(!this.authToken)throw new k.UserDataSyncStoreError("No Auth Token Available",P,k.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too many requests (429).`,P,k.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0);const M=await this.commonHeadersPromise;_.headers=Object.assign(Object.assign(Object.assign({},_.headers||{}),M),{"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`}),this.addSessionHeaders(_.headers),this.logService.trace("Sending request to server",{url:P,type:_.type,headers:Object.assign(Object.assign({},_.headers),{authorization:void 0})});let j;try{j=await this.session.request(P,_,B)}catch(q){if(!(q instanceof k.UserDataSyncStoreError)){const D=(0,m.isPromiseCanceledError)(q)?k.UserDataSyncErrorCode.RequestCanceled:(0,m.getErrorMessage)(q).startsWith("XHR timeout")?k.UserDataSyncErrorCode.RequestTimeout:k.UserDataSyncErrorCode.RequestFailed;q=new k.UserDataSyncStoreError(`Connection refused for the request '${P}'.`,P,D,void 0)}throw this.logService.info("Request failed",P),q}const W=j.res.headers[k.HEADER_OPERATION_ID],$={url:P,status:j.res.statusCode,"execution-id":_.headers[k.HEADER_EXECUTION_ID],"operation-id":W},H=(0,A.isSuccess)(j)||j.res.statusCode&&z.indexOf(j.res.statusCode)!==-1;if(H?this.logService.trace("Request succeeded",$):this.logService.info("Request failed",$),j.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new k.UserDataSyncStoreError(`Request '${P}' failed because of Unauthorized (401).`,P,k.UserDataSyncErrorCode.Unauthorized,W);if(this._onTokenSucceed.fire(),j.res.statusCode===409)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,P,k.UserDataSyncErrorCode.Conflict,W);if(j.res.statusCode===410)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because the requested resource is not longer available (410).`,P,k.UserDataSyncErrorCode.Gone,W);if(j.res.statusCode===412)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,P,k.UserDataSyncErrorCode.PreconditionFailed,W);if(j.res.statusCode===413)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too large payload (413).`,P,k.UserDataSyncErrorCode.TooLarge,W);if(j.res.statusCode===426)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,P,k.UserDataSyncErrorCode.UpgradeRequired,W);if(j.res.statusCode===429){const q=j.res.headers["retry-after"];throw q?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(q)*1e3)),new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too many requests (429).`,P,k.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,W)):new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too many requests (429).`,P,k.UserDataSyncErrorCode.TooManyRequests,W)}if(!H)throw new k.UserDataSyncStoreError("Server returned "+j.res.statusCode,P,k.UserDataSyncErrorCode.Unknown,W);return j}addSessionHeaders(P){let _=this.storageService.get(i,0);_===void 0&&(_=(0,I.generateUuid)(),this.storageService.store(i,_,0,1)),P["X-Machine-Session-Id"]=_;const z=this.storageService.get(t,0);z!==void 0&&(P["X-User-Session-Id"]=z)}};h=he([Y(1,f.IProductService),Y(2,A.IRequestService),Y(3,k.IUserDataSyncLogService),Y(4,R.IEnvironmentService),Y(5,d.IFileService),Y(6,y.IStorageService)],h),e.UserDataSyncStoreClient=h;let g=class extends h{constructor(P,_,z,B,M,j,W){var $;super(($=P.userDataSyncStore)===null||$===void 0?void 0:$.url,_,z,B,M,j,W);this._register(P.onDidChangeUserDataSyncStore(()=>{var H;return this.updateUserDataSyncStoreUrl((H=P.userDataSyncStore)===null||H===void 0?void 0:H.url)}))}};g=he([Y(0,k.IUserDataSyncStoreManagementService),Y(1,f.IProductService),Y(2,A.IRequestService),Y(3,k.IUserDataSyncLogService),Y(4,R.IEnvironmentService),Y(5,d.IFileService),Y(6,y.IStorageService)],g),e.UserDataSyncStoreService=g;class w{constructor(P,_,z,B){this.limit=P,this.interval=_,this.requestService=z,this.logService=B,this.requests=[],this.startTime=void 0}request(P,_,z){if(this.isExpired()&&this.reset(),_.url=P,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new k.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,P,k.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(P),this.requestService.request(_,z)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=w}),define(Z[194],ee([0,1,20,3,56,83,59,25,19,60,28]),function(K,e,S,k,A,L,U,T,f,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let d=class extends L.UserDataAutoSyncService{constructor(I,o,C,b,E,p,m,r,n,t,i,s){super(I,o,C,b,E,m,r,n,t,i,s);this._register(k.Event.debounce(k.Event.any(k.Event.map(p.onDidFocusWindow,()=>"windowFocus"),k.Event.map(p.onDidOpenWindow,()=>"windowOpen")),(c,a)=>c?[...c,a]:[a],1e3)(c=>this.triggerSync(c,!0,!1)))}};d=he([Y(0,R.IProductService),Y(1,S.IUserDataSyncStoreManagementService),Y(2,S.IUserDataSyncStoreService),Y(3,S.IUserDataSyncResourceEnablementService),Y(4,S.IUserDataSyncService),Y(5,A.INativeHostService),Y(6,S.IUserDataSyncLogService),Y(7,U.IUserDataSyncAccountService),Y(8,T.ITelemetryService),Y(9,v.IUserDataSyncMachinesService),Y(10,f.IStorageService),Y(11,S.IUserDataAutoSyncEnablementService)],d),e.UserDataAutoSyncService=d}),define(Z[195],ee([0,1,3,2,6]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends k.Disposable{constructor({onDidOpenWindow:T,onDidFocusWindow:f,getActiveWindowId:v}){super();this.disposables=this._register(new k.DisposableStore),S.Event.latch(S.Event.any(T,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,A.createCancelablePromise)(()=>v()),(async()=>{try{const d=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:d}catch(d){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(T){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=T}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(Z[61],ee([0,1,105,8,27,6,23,201,202,15]),function(K,e,S,k,A,L,U,T,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class R extends Error{constructor(t,i){let s=i.message;switch(t){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s);this.type=t,this.cause=i}}e.ExtractError=R;function d(n){const t=n.externalFileAttributes>>16||33188;return[448,56,7].map(i=>t&i).reduce((i,s)=>i+s,t&61440)}function y(n){if(n instanceof R)return n;let t;return/end of central directory record signature not found/.test(n.message)&&(t="CorruptZip"),new R(t,n)}function I(n,t,i,s,c,a){const l=k.dirname(t),h=k.join(s,l);if(!h.startsWith(s))return Promise.reject(new Error(S.localize(0,null,t)));const g=k.join(s,t);let w;return a.onCancellationRequested(()=>{w&&w.destroy()}),Promise.resolve(A.promises.mkdir(h,{recursive:!0})).then(()=>new Promise((u,P)=>{if(!a.isCancellationRequested)try{w=(0,A.createWriteStream)(g,{mode:i}),w.once("close",()=>u()),w.once("error",P),n.once("error",P),n.pipe(w)}catch(_){P(_)}}))}function o(n,t,i,s){let c=(0,L.createCancelablePromise)(()=>Promise.resolve()),a=0;return s.onCancellationRequested(()=>{c.cancel(),n.close()}),new Promise((l,h)=>{const g=new L.Sequencer,w=u=>{u.isCancellationRequested||(a++,n.readEntry())};n.once("error",h),n.once("close",()=>c.then(()=>{s.isCancellationRequested||n.entryCount===a?l():h(new R("Incomplete",new Error(S.localize(1,null,a,n.entryCount))))},h)),n.readEntry(),n.on("entry",u=>{if(!s.isCancellationRequested){if(!i.sourcePathRegex.test(u.fileName)){w(s);return}const P=u.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(P)){const B=k.join(t,P);c=(0,L.createCancelablePromise)(M=>A.promises.mkdir(B,{recursive:!0}).then(()=>w(M)).then(void 0,h));return}const _=b(n,u),z=d(u);c=(0,L.createCancelablePromise)(B=>g.queue(()=>_.then(M=>I(M,P,z,t,i,B).then(()=>w(B)))).then(null,h))}})})}function C(n,t=!1){return new Promise((i,s)=>{(0,T.open)(n,t?{lazyEntries:!0}:void 0,(c,a)=>{c?s(y(c)):i((0,v.assertIsDefined)(a))})})}function b(n,t){return new Promise((i,s)=>{n.openReadStream(t,(c,a)=>{c?s(y(c)):i((0,v.assertIsDefined)(a))})})}function E(n,t){return new Promise((i,s)=>{const c=new f.ZipFile;t.forEach(l=>{l.contents?c.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&c.addFile(l.localPath,l.path)}),c.end();const a=(0,A.createWriteStream)(n);c.outputStream.pipe(a),c.outputStream.once("error",s),a.once("error",s),a.once("finish",()=>i(n))})}e.zip=E;function p(n,t,i={},s){const c=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=C(n,!0);return i.overwrite&&(a=a.then(l=>(0,U.rimraf)(t).then(()=>l))),a.then(l=>o(l,t,{sourcePathRegex:c},s))}e.extract=p;function m(n,t){return C(n).then(i=>new Promise((s,c)=>{i.on("entry",a=>{a.fileName===t&&b(i,a).then(l=>s(l),l=>c(l))}),i.once("close",()=>c(new Error(S.localize(2,null,t))))}))}function r(n,t){return m(n,t).then(i=>new Promise((s,c)=>{const a=[];i.once("error",c),i.on("data",l=>a.push(l)),i.on("end",()=>s(Buffer.concat(a)))}))}e.buffer=r}),define(Z[196],ee([0,1,61,110]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function A(L){return(0,S.buffer)(L,"extension/package.json").then(U=>{try{return JSON.parse(U.toString("utf8"))}catch(T){throw new Error((0,k.localize)(0,null))}})}e.getManifest=A}),define(Z[197],ee([0,1,27,55,2,23,8,17,29,33,6,4,9,130,111,28,61,7,18,16,10,12,31,11]),function(K,e,S,k,A,L,U,T,f,v,R,d,y,I,o,C,b,E,p,m,r,n,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const s="scanningSystem",c="scanningUser",a="extracting",l="deleting",h="renaming";let g=class extends A.Disposable{constructor(u,P,_,z,B){super();this.beforeRemovingExtension=u,this.fileService=P,this.logService=_,this.environmentService=z,this.productService=B,this._devSystemExtensionsPath=null,this.systemExtensionsPath=z.builtinExtensionsPath,this.extensionsPath=z.extensionsPath,this.uninstalledPath=U.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new R.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(u){const P=[];(u===null||u===0)&&P.push(this.scanSystemExtensions().then(null,_=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(_).message,s)))),(u===null||u===1)&&P.push(this.scanUserExtensions(!0).then(null,_=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(_).message,c))));try{const _=await Promise.all(P);return(0,p.flatten)(_)}catch(_){throw this.joinErrors(_)}}async scanUserExtensions(u){this.logService.trace("Started scanning user extensions");let[P,_]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return _=_.filter(z=>!P[new v.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]),u&&(_=(0,v.groupByExtension)(_,B=>B.identifier).map(B=>B.sort((M,j)=>k.rcompare(M.manifest.version,j.manifest.version))[0])),this.logService.trace("Scanned user extensions:",_.length),_}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(u,P,_){const z=u.key(),B=U.join(this.extensionsPath,`.${(0,t.generateUuid)()}`),M=U.join(this.extensionsPath,z);try{await L.rimraf(M)}catch(W){try{await L.rimraf(M)}catch($){}throw new f.ExtensionManagementError((0,o.localize)(0,null,M,u.id),l)}await this.extractAtLocation(u,P,B,_);let j=await this.scanExtension(d.URI.file(B),1);if(!j)throw new Error((0,o.localize)(1,null,B));await this.storeMetadata(j,{installedTimestamp:Date.now()});try{await this.rename(u,B,M,Date.now()+2*60*1e3),this.logService.info("Renamed to",M)}catch(W){try{await L.rimraf(B)}catch($){}if(W.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",u.id);else throw this.logService.info(`Rename failed because of ${(0,i.getErrorMessage)(W)}. Deleted from extracted location`,B),W}try{j=await this.scanExtension(d.URI.file(M),1)}catch(W){}if(j)return j;throw new Error((0,o.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(u,P){return this.setMetadata(u,P),await this.storeMetadata(u,Object.assign(Object.assign({},P),{installedTimestamp:u.installedTimestamp})),u}async storeMetadata(u,P){P.isMachineScoped=P.isMachineScoped||void 0,P.isBuiltin=P.isBuiltin||void 0,P.installedTimestamp=P.installedTimestamp||void 0;const _=U.join(u.location.fsPath,"package.json"),z=await S.promises.readFile(_,"utf8"),{manifest:B}=await this.parseManifest(z);return B.__metadata=P,await L.writeFile(_,JSON.stringify(B,null,"	")),u}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...u){const P=u.map(_=>new v.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version));await this.withUninstalledExtensions(_=>{P.forEach(z=>_[z.key()]=!0)})}async setInstalled(u){await this.withUninstalledExtensions(z=>delete z[u.key()]);const _=(await this.scanExtensions(1)).find(z=>new v.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).equals(u))||null;return _?(await this.storeMetadata(_,{installedTimestamp:Date.now()}),this.scanExtension(_.location,1)):null}async withUninstalledExtensions(u){return this.uninstalledFileLimiter.queue(async()=>{let P;try{P=await S.promises.readFile(this.uninstalledPath,"utf8")}catch(z){if(z.code!=="ENOENT")throw z}let _={};if(P)try{_=JSON.parse(P)}catch(z){}return u&&(u(_),Object.keys(_).length?await L.writeFile(this.uninstalledPath,JSON.stringify(_)):await L.rimraf(this.uninstalledPath)),_})}async removeExtension(u,P){this.logService.trace(`Deleting ${P} extension from disk`,u.identifier.id,u.location.fsPath),await L.rimraf(u.location.fsPath),this.logService.info("Deleted from disk",u.identifier.id,u.location.fsPath)}async removeUninstalledExtension(u){await this.removeExtension(u,"uninstalled"),await this.withUninstalledExtensions(P=>delete P[new v.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).key()])}async extractAtLocation(u,P,_,z){this.logService.trace(`Started extracting the extension from ${P} to ${_}`);try{await L.rimraf(_)}catch(B){throw new f.ExtensionManagementError(this.joinErrors(B).message,l)}try{await(0,b.extract)(P,_,{sourcePath:"extension",overwrite:!0},z),this.logService.info(`Extracted extension to ${_}:`,u.id)}catch(B){try{await L.rimraf(_)}catch(M){}throw new f.ExtensionManagementError(B.message,B instanceof b.ExtractError&&B.type?B.type:a)}}async rename(u,P,_,z){try{await S.promises.rename(P,_)}catch(B){if(E.isWindows&&B&&B.code==="EPERM"&&Date.now()<z)return this.logService.info(`Failed renaming ${P} to ${_} with 'EPERM' error. Trying again...`,u.id),this.rename(u,P,_,z);throw new f.ExtensionManagementError(B.message||(0,o.localize)(3,null,P,_),B.code||h)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const u=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return u;const P=this.scanDevSystemExtensions(),[_,z]=await Promise.all([u,P]);return[..._,...z]}async scanExtensionsInDir(u,P){const _=new R.Limiter(10),z=await this.fileService.resolve(d.URI.file(u));return z.children?(await Promise.all(z.children.filter(M=>M.isDirectory).map(M=>_.queue(async()=>P===1&&(0,n.basename)(M.resource).indexOf(".")===0?null:this.scanExtension(M.resource,P))))).filter(M=>M&&M.identifier):[]}async scanExtension(u,P){var _,z;try{const B=await this.fileService.resolve(u);if(B.children){const{manifest:M,metadata:j}=await this.readManifest(u.fsPath),W=(_=B.children.find(({name:D})=>/^readme(\.txt|\.md|)$/i.test(D)))===null||_===void 0?void 0:_.resource,$=(z=B.children.find(({name:D})=>/^changelog(\.txt|\.md|)$/i.test(D)))===null||z===void 0?void 0:z.resource,H={id:(0,v.getGalleryExtensionId)(M.publisher,M.name)},q={type:P,identifier:H,manifest:M,location:u,readmeUrl:W,changelogUrl:$,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:P===0};return j&&(this.setMetadata(q,j),q.installedTimestamp=j.installedTimestamp),q}}catch(B){P!==0&&this.logService.trace(B)}return null}async scanDefaultSystemExtensions(){const u=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",u.length),u}async scanDevSystemExtensions(){const u=this.getDevSystemExtensionsList();if(u.length){const P=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",P.length),P.filter(_=>u.some(z=>(0,v.areSameExtensions)(_.identifier,{id:z})))}else return[]}setMetadata(u,P){u.publisherDisplayName=P.publisherDisplayName||null,u.publisherId=P.publisherId||null,u.identifier.uuid=P.id,u.isMachineScoped=!!P.isMachineScoped,u.isBuiltin=u.type===0||!!P.isBuiltin}async removeUninstalledExtensions(){const u=await this.getUninstalledExtensions(),P=await this.scanAllUserExtensions(),_=new Set;for(const M of P)u[new v.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version).key()]||_.add(M.identifier.id.toLowerCase());const z=(0,v.groupByExtension)(P,M=>M.identifier);await R.Promises.settled(z.map(async M=>{const j=M.sort((W,$)=>k.rcompare(W.manifest.version,$.manifest.version))[0];_.has(j.identifier.id.toLowerCase())||await this.beforeRemovingExtension(j)}));const B=P.filter(M=>u[new v.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version).key()]);await R.Promises.settled(B.map(M=>this.removeUninstalledExtension(M)))}async removeOutdatedExtensions(){const u=await this.scanAllUserExtensions(),P=[],_=(0,v.groupByExtension)(u,z=>z.identifier);P.push(...(0,p.flatten)(_.map(z=>z.sort((B,M)=>k.rcompare(B.manifest.version,M.manifest.version)).slice(1)))),await R.Promises.settled(P.map(z=>this.removeExtension(z,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(u=>u.name)}joinErrors(u){const P=Array.isArray(u)?u:[u];return P.length===1?P[0]instanceof Error?P[0]:new Error(P[0]):P.reduce((_,z)=>new Error(`${_.message}${_.message?",":""}${z instanceof Error?z.message:z}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=U.normalize(U.join(m.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(u){const P=[S.promises.readFile(U.join(u,"package.json"),"utf8").then(M=>this.parseManifest(M)),S.promises.readFile(U.join(u,"package.nls.json"),"utf8").then(void 0,M=>M.code!=="ENOENT"?Promise.reject(M):"{}").then(M=>JSON.parse(M))],[{manifest:_,metadata:z},B]=await Promise.all(P);return{manifest:(0,I.localizeManifest)(_,B),metadata:z}}parseManifest(u){return new Promise((P,_)=>{try{const z=JSON.parse(u),B=z.__metadata||null;P({manifest:z,metadata:B})}catch(z){_(new Error((0,o.localize)(4,null)))}})}};g=he([Y(1,r.IFileService),Y(2,T.ILogService),Y(3,y.INativeEnvironmentService),Y(4,C.IProductService)],g),e.ExtensionsScanner=g}),define(Z[198],ee([0,1,27,109,8,23,2,18,61,29,33,9,6,3,55,4,57,7,17,143,43,25,68,12,31,70,5,16,30,196,151,197,152,153,10]),function(K,e,S,k,A,L,U,T,f,v,R,d,y,I,o,C,b,E,p,m,r,n,t,i,s,c,a,l,h,g,w,u,P,_,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const B="unsetUninstalled",M="downloading",j="validating",W="local",$="unknown";let H=class extends U.Disposable{constructor(D,O,F,N,V,G,J){super();this.environmentService=D,this.galleryService=O,this.logService=F,this.downloadService=N,this.telemetryService=V,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new I.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new I.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new I.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new I.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const Q=this._register(G.createInstance(P.ExtensionsLifecycle));this.extensionsScanner=this._register(G.createInstance(u.ExtensionsScanner,ie=>Q.postUninstall(ie))),this.manifestCache=this._register(new m.ExtensionsManifestCache(D,this)),this.extensionsDownloader=this._register(G.createInstance(w.ExtensionsDownloader));const ne=this._register(new _.ExtensionsWatcher(this,J,D,F));this._register(ne.onDidChangeExtensionsByAnotherSource(({added:ie,removed:ce})=>{ie.forEach(ue=>this._onDidInstallExtension.fire({identifier:ue.identifier,operation:0,local:ue})),ce.forEach(ue=>this._onDidUninstallExtension.fire({identifier:ue}))})),this._register((0,U.toDisposable)(()=>{this.installingExtensions.forEach(ie=>ie.cancel()),this.uninstallingExtensions.forEach(ie=>ie.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(D){this.logService.trace("ExtensionManagementService#zip",D.identifier.id);const O=await this.collectFiles(D),F=await(0,f.zip)((0,i.joinPath)(this.environmentService.tmpDir,(0,s.generateUuid)()).fsPath,O);return C.URI.file(F)}async unzip(D){return this.logService.trace("ExtensionManagementService#unzip",D.toString()),(await this.install(D)).identifier}async getManifest(D){const O=await this.downloadVsix(D),F=A.resolve(O.fsPath);return(0,g.getManifest)(F)}async collectFiles(D){const O=async N=>{let V=await L.readdir(N);V=V.map(Q=>A.join(N,Q));const G=await Promise.all(V.map(Q=>S.promises.stat(Q)));let J=Promise.resolve([]);return G.forEach((Q,ne)=>{const ie=V[ne];Q.isFile()&&(J=J.then(ce=>[...ce,ie])),Q.isDirectory()&&(J=J.then(ce=>O(ie).then(ue=>[...ce,...ue])))}),J};return(await O(D.location.fsPath)).map(N=>({path:`extension/${A.relative(D.location.fsPath,N)}`,localPath:N}))}async install(D,O={}){return this.logService.trace("ExtensionManagementService#install",D.toString()),(0,y.createCancelablePromise)(async F=>{const N=await this.downloadVsix(D),V=A.resolve(N.fsPath),G=await(0,g.getManifest)(V),J={id:(0,R.getGalleryExtensionId)(G.publisher,G.name)};let Q=1;if(G.engines&&G.engines.vscode&&!(0,t.isEngineValid)(G.engines.vscode,b.default.version))throw new Error(k.localize(0,null,J.id,b.default.version));const ne=new R.ExtensionIdentifierWithVersion(J,G.version),ce=(await this.getInstalled(1)).find(ge=>(0,R.areSameExtensions)(J,ge.identifier));if(ce)if(O.isMachineScoped=O.isMachineScoped||ce.isMachineScoped,O.isBuiltin=O.isBuiltin||ce.isBuiltin,Q=2,ne.equals(new R.ExtensionIdentifierWithVersion(ce.identifier,ce.manifest.version)))try{await this.extensionsScanner.removeExtension(ce,"existing")}catch(ge){throw new Error(k.localize(1,null,G.displayName||G.name))}else o.gt(ce.manifest.version,G.version)&&await this.uninstallExtension(ce);else{const ge=await this.unsetUninstalledAndGetLocal(ne);if(ge)try{await this.extensionsScanner.removeExtension(ge,"existing")}catch(Ee){throw new Error(k.localize(2,null,G.displayName||G.name))}}this.logService.info("Installing the extension:",J.id),this._onInstallExtension.fire({identifier:J,zipPath:V});let ue;try{ue=await this.getGalleryMetadata((0,R.getGalleryExtensionId)(G.publisher,G.name))}catch(ge){}try{const ge=await this.installFromZipPath(ne,V,Object.assign(Object.assign({},ue||{}),O),O,Q,F);return this.logService.info("Successfully installed the extension:",J.id),ge}catch(ge){throw this.logService.error("Failed to install the extension:",J.id,ge.message),ge}})}async downloadVsix(D){if(D.scheme===l.Schemas.file)return D;if(!this.downloadService)throw new Error("Download service is not available");const O=(0,i.joinPath)(this.environmentService.tmpDir,(0,s.generateUuid)());return await this.downloadService.download(D,O),O}async installFromZipPath(D,O,F,N,V,G){try{const J=await this.installExtension({zipPath:O,identifierWithVersion:D,metadata:F},G);try{await this.installDependenciesAndPackExtensions(J,void 0,N)}catch(Q){(0,T.isNonEmptyArray)(J.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",J.identifier.id,Q.message),(0,T.isNonEmptyArray)(J.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",J.identifier.id,Q.message)}return this._onDidInstallExtension.fire({identifier:D,zipPath:O,local:J,operation:V}),J}catch(J){throw this._onDidInstallExtension.fire({identifier:D,zipPath:O,operation:V,error:J}),J}}async canInstall(D){return!0}async installFromGallery(D,O={}){if(!this.galleryService.isEnabled())throw new Error(k.localize(3,null));try{D=await this.checkAndGetCompatibleVersion(D)}catch(V){const G=V&&V.code?V.code:$;throw this.logService.error("Failed to install extension:",D.identifier.id,V?V.message:G),this.reportTelemetry(this.getTelemetryEvent(1),(0,R.getGalleryExtensionTelemetryData)(D),void 0,V),V instanceof Error&&(V.name=G),V}const F=new R.ExtensionIdentifierWithVersion(D.identifier,D.version).key();let N=this.installingExtensions.get(F);return N||(N=(0,y.createCancelablePromise)(V=>this.doInstallFromGallery(D,O,V)),this.installingExtensions.set(F,N),N.finally(()=>this.installingExtensions.delete(F))),N}async doInstallFromGallery(D,O,F){const N=new Date().getTime();let V=1;this.logService.info("Installing extension:",D.identifier.id),this._onInstallExtension.fire({identifier:D.identifier,gallery:D});try{const J=(await this.getInstalled(1)).find(ie=>(0,R.areSameExtensions)(ie.identifier,D.identifier));J&&(V=2);const Q=await this.downloadInstallableExtension(D,V);Q.metadata.isMachineScoped=O.isMachineScoped||(J==null?void 0:J.isMachineScoped),Q.metadata.isBuiltin=O.isBuiltin||(J==null?void 0:J.isBuiltin);const ne=await this.installExtension(Q,F);try{await this.extensionsDownloader.delete(C.URI.file(Q.zipPath))}catch(ie){}if(!O.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(ne,J,O)}catch(ie){try{await this.uninstall(ne)}catch(ce){}throw ie}return J&&o.neq(J.manifest.version,D.version)&&await this.extensionsScanner.setUninstalled(J),this.logService.info("Extensions installed successfully:",D.identifier.id),this._onDidInstallExtension.fire({identifier:D.identifier,gallery:D,local:ne,operation:V}),this.reportTelemetry(this.getTelemetryEvent(V),(0,R.getGalleryExtensionTelemetryData)(D),new Date().getTime()-N,void 0),ne}catch(G){const J=G&&G.code?G.code:$;throw this.logService.error("Failed to install extension:",D.identifier.id,G?G.message:J),this._onDidInstallExtension.fire({identifier:D.identifier,gallery:D,operation:V,error:J}),this.reportTelemetry(this.getTelemetryEvent(V),(0,R.getGalleryExtensionTelemetryData)(D),new Date().getTime()-N,G),G instanceof Error&&(G.name=J),G}}async checkAndGetCompatibleVersion(D){if(await this.isMalicious(D))throw new v.ExtensionManagementError(k.localize(4,null),v.INSTALL_ERROR_MALICIOUS);const O=await this.galleryService.getCompatibleExtension(D);if(!O)throw new v.ExtensionManagementError(k.localize(5,null,D.identifier.id,b.default.version),v.INSTALL_ERROR_INCOMPATIBLE);return O}async reinstallFromGallery(D){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",D.identifier.id),!this.galleryService.isEnabled())throw new Error(k.localize(6,null));const O=await this.findGalleryExtension(D);if(!O)throw new Error(k.localize(7,null));await this.extensionsScanner.setUninstalled(D);try{await this.extensionsScanner.removeUninstalledExtension(D)}catch(F){throw new Error(k.localize(8,null,(0,r.toErrorMessage)(F)))}await this.installFromGallery(O)}getTelemetryEvent(D){return D===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(D){const O=await this.getExtensionsReport();return(0,R.getMaliciousExtensionsSet)(O).has(D.identifier.id)}async downloadInstallableExtension(D,O){const F={id:D.identifier.uuid,publisherId:D.publisherId,publisherDisplayName:D.publisherDisplayName};let N;try{this.logService.trace("Started downloading extension:",D.identifier.id),N=(await this.extensionsDownloader.downloadExtension(D,O)).fsPath,this.logService.info("Downloaded extension:",D.identifier.id,N)}catch(V){throw new v.ExtensionManagementError(this.joinErrors(V).message,M)}try{const V=await(0,g.getManifest)(N);return{zipPath:N,identifierWithVersion:new R.ExtensionIdentifierWithVersion(D.identifier,V.version),metadata:F}}catch(V){throw new v.ExtensionManagementError(this.joinErrors(V).message,j)}}async installExtension(D,O){try{const F=await this.unsetUninstalledAndGetLocal(D.identifierWithVersion);if(F)return D.metadata?this.extensionsScanner.saveMetadataForLocalExtension(F,D.metadata):F}catch(F){throw E.isMacintosh?new v.ExtensionManagementError(k.localize(9,null),B):new v.ExtensionManagementError(k.localize(10,null),B)}return this.extractAndInstall(D,O)}async unsetUninstalledAndGetLocal(D){if(!await this.isUninstalled(D))return null;this.logService.trace("Removing the extension from uninstalled list:",D.id);const F=await this.extensionsScanner.setInstalled(D);return this.logService.info("Removed the extension from uninstalled list:",D.id),F}async extractAndInstall({zipPath:D,identifierWithVersion:O,metadata:F},N){let V=await this.extensionsScanner.extractUserExtension(O,D,N);return this.logService.info("Installation completed.",O.id),F&&(V=await this.extensionsScanner.saveMetadataForLocalExtension(V,F)),V}async installDependenciesAndPackExtensions(D,O,F){if(!!this.galleryService.isEnabled()){const N=D.manifest.extensionDependencies||[];if(D.manifest.extensionPack)for(const V of D.manifest.extensionPack)O&&O.manifest.extensionPack&&O.manifest.extensionPack.some(G=>(0,R.areSameExtensions)({id:G},{id:V}))||N.every(G=>!(0,R.areSameExtensions)({id:G},{id:V}))&&N.push(V);if(N.length){const V=await this.getInstalled(),G=N.filter(J=>V.every(({identifier:Q})=>!(0,R.areSameExtensions)(Q,{id:J})));if(G.length){const Q=(await this.galleryService.query({names:G,pageSize:N.length},h.CancellationToken.None)).firstPage;try{await y.Promises.settled(Q.map(ne=>this.installFromGallery(ne,F)))}catch(ne){try{await this.rollback(Q)}catch(ie){}throw ne}}}}}async rollback(D){const F=(await this.getInstalled(1)).filter(N=>D.some(V=>new R.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version).equals(new R.ExtensionIdentifierWithVersion(V.identifier,V.version))));await y.Promises.settled(F.map(N=>this.uninstall(N)))}async uninstall(D,O={}){this.logService.trace("ExtensionManagementService#uninstall",D.identifier.id);const F=await this.getInstalled(1),N=F.find(V=>(0,R.areSameExtensions)(V.identifier,D.identifier));if(!N)throw new Error(k.localize(11,null,D.manifest.displayName||D.manifest.name));try{await this.checkForDependenciesAndUninstall(N,F,O)}catch(V){throw this.joinErrors(V)}}async updateMetadata(D,O){return this.logService.trace("ExtensionManagementService#updateMetadata",D.identifier.id),D=await this.extensionsScanner.saveMetadataForLocalExtension(D,Object.assign(Object.assign({},D.manifest.__metadata||{}),O)),this.manifestCache.invalidate(),D}async updateExtensionScope(D,O){return this.logService.trace("ExtensionManagementService#updateExtensionScope",D.identifier.id),D=await this.extensionsScanner.saveMetadataForLocalExtension(D,Object.assign(Object.assign({},D.manifest.__metadata||{}),{isMachineScoped:O})),this.manifestCache.invalidate(),D}async getGalleryMetadata(D){const O=await this.findGalleryExtensionByName(D);return O?{id:O.identifier.uuid,publisherDisplayName:O.publisherDisplayName,publisherId:O.publisherId}:void 0}async findGalleryExtension(D){if(D.identifier.uuid){const O=await this.findGalleryExtensionById(D.identifier.uuid);return O||this.findGalleryExtensionByName(D.identifier.id)}return this.findGalleryExtensionByName(D.identifier.id)}async findGalleryExtensionById(D){return(await this.galleryService.query({ids:[D],pageSize:1},h.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(D){return(await this.galleryService.query({names:[D],pageSize:1},h.CancellationToken.None)).firstPage[0]}joinErrors(D){const O=Array.isArray(D)?D:[D];return O.length===1?O[0]instanceof Error?O[0]:new Error(O[0]):O.reduce((F,N)=>new Error(`${F.message}${F.message?",":""}${N instanceof Error?N.message:N}`),new Error(""))}async checkForDependenciesAndUninstall(D,O,F){try{await this.preUninstallExtension(D);const N=F.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(D,O);await this.uninstallExtensions(D,N,O,F)}catch(N){throw await this.postUninstallExtension(D,new v.ExtensionManagementError(N instanceof Error?N.message:N,W)),N}await this.postUninstallExtension(D)}async uninstallExtensions(D,O,F,N){const V=[D,...O];if(!N.donotCheckDependents)for(const G of V)this.checkForDependents(G,V,F,D);await y.Promises.settled([this.uninstallExtension(D),...O.map(G=>this.doUninstall(G))])}checkForDependents(D,O,F,N){const V=this.getDependents(D,F);if(V.length){const G=V.filter(J=>O.indexOf(J)===-1);if(G.length)throw new Error(this.getDependentsErrorMessage(D,G,N))}}getDependentsErrorMessage(D,O,F){return F===D?O.length===1?k.localize(12,null,F.manifest.displayName||F.manifest.name,O[0].manifest.displayName||O[0].manifest.name):O.length===2?k.localize(13,null,F.manifest.displayName||F.manifest.name,O[0].manifest.displayName||O[0].manifest.name,O[1].manifest.displayName||O[1].manifest.name):k.localize(14,null,F.manifest.displayName||F.manifest.name,O[0].manifest.displayName||O[0].manifest.name,O[1].manifest.displayName||O[1].manifest.name):O.length===1?k.localize(15,null,F.manifest.displayName||F.manifest.name,D.manifest.displayName||D.manifest.name,O[0].manifest.displayName||O[0].manifest.name):O.length===2?k.localize(16,null,F.manifest.displayName||F.manifest.name,D.manifest.displayName||D.manifest.name,O[0].manifest.displayName||O[0].manifest.name,O[1].manifest.displayName||O[1].manifest.name):k.localize(17,null,F.manifest.displayName||F.manifest.name,D.manifest.displayName||D.manifest.name,O[0].manifest.displayName||O[0].manifest.name,O[1].manifest.displayName||O[1].manifest.name)}getAllPackExtensionsToUninstall(D,O,F=[]){if(F.indexOf(D)!==-1)return[];F.push(D);const N=D.manifest.extensionPack?D.manifest.extensionPack:[];if(N.length){const V=O.filter(J=>!J.isBuiltin&&N.some(Q=>(0,R.areSameExtensions)({id:Q},J.identifier))),G=[];for(const J of V)G.push(...this.getAllPackExtensionsToUninstall(J,O,F));return[...V,...G]}return[]}getDependents(D,O){return O.filter(F=>F.manifest.extensionDependencies&&F.manifest.extensionDependencies.some(N=>(0,R.areSameExtensions)({id:N},D.identifier)))}async doUninstall(D){try{await this.preUninstallExtension(D),await this.uninstallExtension(D)}catch(O){throw await this.postUninstallExtension(D,new v.ExtensionManagementError(O instanceof Error?O.message:O,W)),O}await this.postUninstallExtension(D)}async preUninstallExtension(D){if(!await L.exists(D.location.fsPath))throw new Error(k.localize(18,null));this.logService.info("Uninstalling extension:",D.identifier.id),this._onUninstallExtension.fire(D.identifier)}async uninstallExtension(D){let O=this.uninstallingExtensions.get(D.identifier.id);return O||(O=(0,y.createCancelablePromise)(async()=>{const F=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...F.filter(N=>(0,R.areSameExtensions)(N.identifier,D.identifier)))}),this.uninstallingExtensions.set(D.identifier.id,O),O.finally(()=>this.uninstallingExtensions.delete(D.identifier.id))),O}async postUninstallExtension(D,O){if(O)this.logService.error("Failed to uninstall extension:",D.identifier.id,O.message);else if(this.logService.info("Successfully uninstalled extension:",D.identifier.id),D.identifier.uuid)try{await this.galleryService.reportStatistic(D.manifest.publisher,D.manifest.name,D.manifest.version,"uninstall")}catch(N){}this.reportTelemetry("extensionGallery:uninstall",(0,R.getLocalExtensionTelemetryData)(D),void 0,O);const F=O?O instanceof v.ExtensionManagementError?O.code:$:void 0;this._onDidUninstallExtension.fire({identifier:D.identifier,error:F})}getInstalled(D=null){return this.extensionsScanner.scanExtensions(D)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(D){return(await this.filterUninstalled(D)).length===1}async filterUninstalled(...D){const O=[],F=await this.extensionsScanner.getUninstalledExtensions();for(const N of D)F[N.key()]&&O.push(N.key());return O}getExtensionsReport(){const D=new Date().getTime();return(!this.reportedExtensions||D-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=D),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const D=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${D.length} reported extensions from service`),D}catch(D){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(D,O,F,N){const V=N?N instanceof v.ExtensionManagementError?N.code:$:void 0;this.telemetryService.publicLogError(D,Object.assign(Object.assign({},O),{success:!N,duration:F,errorcode:V}))}};H=he([Y(0,d.INativeEnvironmentService),Y(1,v.IExtensionGalleryService),Y(2,p.ILogService),Y(3,(0,a.optional)(c.IDownloadService)),Y(4,n.ITelemetryService),Y(5,a.IInstantiationService),Y(6,z.IFileService)],H),e.ExtensionManagementService=H}),define(Z[203],ee([0,1,27,38,204,99,57,98,34,75,50,147,9,127,129,29,198,170,24,161,40,162,25,58,168,78,79,173,17,76,157,54,2,163,70,159,158,141,140,149,148,169,69,154,10,156,16,28,20,191,193,188,56,189,194,167,19,165,190,59,187,171,60,71,131,195,172,83,82,81,5,150,142,11,43,80,176,175,192,138,144,174,4,12]),function(K,e,S,k,A,L,U,T,f,v,R,d,y,I,o,C,b,E,p,m,r,n,t,i,s,c,a,l,h,g,w,u,P,_,z,B,M,j,W,$,H,q,D,O,F,N,V,G,J,Q,ne,ie,ce,ue,ge,Ee,Ie,Te,Ae,Ue,ke,Me,De,Oe,He,Ge,je,$e,X,se,re,me,x,te,oe,ae,le,fe,ve,Se,we,be,Pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class pe extends P.Disposable{constructor(de){super();this.configuration=de,this.server=this._register(new T.Server),(0,A.gracefulify)(S),this.registerListeners()}registerListeners(){const de=()=>this.dispose();process.once("exit",de),L.ipcRenderer.once("vscode:electron-main->shared-process=exit",de)}async open(){const de=await this.initServices();(0,J.registerConfiguration)(),de.invokeFunction(Le=>{const _e=Le.get(h.ILogService);_e.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Le),this.registerErrorHandler(_e)}),this._register((0,P.combinedDisposable)(de.createInstance(B.NodeCachedDataCleaner,this.configuration.nodeCachedDataDir),de.createInstance(M.LanguagePackCachedDataCleaner),de.createInstance(j.StorageDataCleaner,this.configuration.backupWorkspacesPath),de.createInstance(W.LogsDataCleaner),de.createInstance(me.LocalizationsUpdater),de.createInstance(x.DeprecatedExtensionsCleaner)))}async initServices(){const de=new v.ServiceCollection,Le=Object.assign({_serviceBrand:void 0},U.default);de.set(G.IProductService,Le);const _e=new f.StaticRouter(ze=>ze==="main"),Fe=new H.MessagePortMainProcessService(this.server,_e);de.set($.IMainProcessService,Fe);const Ne=new I.NativeEnvironmentService(this.configuration.args,Le);de.set(y.INativeEnvironmentService,Ne);const Xe=new g.LogLevelChannelClient(this.server.getChannel("logLevel",_e)),Ke=new g.LoggerChannelClient(this.configuration.logLevel,Xe.onDidChangeLogLevel,Fe.getChannel("logger"));de.set(h.ILoggerService,Ke);const et=this._register(new h.MultiplexLogService([this._register(new h.ConsoleLogger(this.configuration.logLevel)),this._register(Ke.createLogger((0,ye.joinPath)(Pe.URI.file(Ne.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),qe=this._register(new g.FollowerLogService(Xe,et));de.set(h.ILogService,qe);const Be=this._register(new O.FileService(qe));de.set(F.IFileService,Be);const tt=this._register(new N.DiskFileSystemProvider(qe));Be.registerProvider(V.Schemas.file,tt);const We=this._register(new m.ConfigurationService(Ne.settingsResource,Be));de.set(p.IConfigurationService,We),await We.initialize();const Ye=new Ee.NativeStorageService(void 0,Fe,Ne);de.set(Ie.IStorageService,Ye),await Ye.initialize(),this._register((0,P.toDisposable)(()=>Ye.flush())),de.set(r.IRequestService,new R.SyncDescriptor(n.RequestService)),de.set(Se.IChecksumService,new R.SyncDescriptor(we.ChecksumService));const Qe=f.ProxyChannel.toService(Fe.getChannel("nativeHost"),{context:this.configuration.windowId});de.set(ce.INativeHostService,Qe),de.set(z.IDownloadService,new R.SyncDescriptor(_.DownloadService));const it=this._register(new Ge.ActiveWindowManager(Qe)),ot=new f.StaticRouter(ze=>it.getActiveClientId().then(ft=>ze===ft));de.set(Oe.IExtensionRecommendationNotificationService,new He.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ot)));const{appRoot:at,extensionsPath:ct,extensionDevelopmentLocationURI:lt,isBuilt:ut,installSourcePath:ht}=Ne;let Ze,xe;if(!lt&&!Ne.disableTelemetry&&Le.enableTelemetry){if(xe=new je.TelemetryLogAppender(Ke,Ne),Le.aiConfig&&Le.aiConfig.asimovKey&&ut){const ze=new l.AppInsightsAppender("monacoworkbench",null,Le.aiConfig.asimovKey);this._register((0,P.toDisposable)(()=>ze.flush())),xe=(0,i.combinedAppender)(ze,xe)}Ze=new a.TelemetryService({appender:xe,commonProperties:(0,s.resolveCommonProperties)(Be,(0,k.release)(),process.arch,Le.commit,Le.version,this.configuration.machineId,Le.msftInternalDomains,ht),sendErrorTelemetry:!0,piiPaths:[at,ct]},We)}else Ze=i.NullTelemetryService,xe=i.NullAppender;this.server.registerChannel("telemetryAppender",new c.TelemetryAppenderChannel(xe)),de.set(t.ITelemetryService,Ze);const dt=new be.CustomEndpointTelemetryService(We,Ze);return de.set(t.ICustomEndpointTelemetryService,dt),de.set(C.IExtensionManagementService,new R.SyncDescriptor(b.ExtensionManagementService)),de.set(C.IExtensionGalleryService,new R.SyncDescriptor(E.ExtensionGalleryService)),de.set(C.IExtensionTipsService,new R.SyncDescriptor(Me.ExtensionTipsService)),de.set(u.ILocalizationsService,new R.SyncDescriptor(w.LocalizationsService)),de.set(D.IDiagnosticsService,new R.SyncDescriptor(q.DiagnosticsService)),de.set(Ue.IUserDataSyncAccountService,new R.SyncDescriptor(Ue.UserDataSyncAccountService)),de.set(J.IUserDataSyncLogService,new R.SyncDescriptor(ue.UserDataSyncLogService)),de.set(J.IUserDataSyncUtilService,new ie.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",ze=>ze.ctx!=="main"))),de.set(C.IGlobalExtensionEnablementService,new R.SyncDescriptor(Te.GlobalExtensionEnablementService)),de.set(X.IIgnoredExtensionsManagementService,new R.SyncDescriptor(X.IgnoredExtensionsManagementService)),de.set(se.IExtensionsStorageSyncService,new R.SyncDescriptor(se.ExtensionsStorageSyncService)),de.set(J.IUserDataSyncStoreManagementService,new R.SyncDescriptor(ne.UserDataSyncStoreManagementService)),de.set(J.IUserDataSyncStoreService,new R.SyncDescriptor(ne.UserDataSyncStoreService)),de.set(De.IUserDataSyncMachinesService,new R.SyncDescriptor(De.UserDataSyncMachinesService)),de.set(J.IUserDataSyncBackupStoreService,new R.SyncDescriptor(ke.UserDataSyncBackupStoreService)),de.set(J.IUserDataAutoSyncEnablementService,new R.SyncDescriptor($e.UserDataAutoSyncEnablementService)),de.set(J.IUserDataSyncResourceEnablementService,new R.SyncDescriptor(Ae.UserDataSyncResourceEnablementService)),de.set(J.IUserDataSyncService,new R.SyncDescriptor(Q.UserDataSyncService)),de.set(fe.ILocalPtyService,this._register(new le.PtyHostService(qe))),new d.InstantiationService(de)}initChannels(de){const Le=new o.ExtensionManagementChannel(de.get(C.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Le);const _e=f.ProxyChannel.fromService(de.get(u.ILocalizationsService));this.server.registerChannel("localizations",_e);const Fe=f.ProxyChannel.fromService(de.get(D.IDiagnosticsService));this.server.registerChannel("diagnostics",Fe);const Ne=new o.ExtensionTipsChannel(de.get(C.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ne);const Xe=f.ProxyChannel.fromService(de.get(Se.IChecksumService));this.server.registerChannel("checksum",Xe);const Ke=new ie.UserDataSyncMachinesServiceChannel(de.get(De.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Ke);const et=f.ProxyChannel.fromService(de.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",et);const qe=new ie.UserDataSyncAccountServiceChannel(de.get(Ue.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",qe);const Be=new ie.UserDataSyncStoreManagementServiceChannel(de.get(J.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Be);const tt=new ve.UserDataSyncChannel(de.get(J.IUserDataSyncService),de.get(h.ILogService));this.server.registerChannel("userDataSync",tt);const We=this._register(de.get(re.IInstantiationService).createInstance(ge.UserDataAutoSyncService)),Ye=new ie.UserDataAutoSyncChannel(We);this.server.registerChannel("userDataAutoSync",Ye);const Qe=de.get(fe.ILocalPtyService),it=f.ProxyChannel.fromService(Qe);this.server.registerChannel(ae.TerminalIpcChannels.LocalPty,it)}registerErrorHandler(de){window.addEventListener("unhandledrejection",Le=>{(0,te.onUnexpectedError)(Le.reason),Le.preventDefault()}),(0,te.setUnexpectedErrorHandler)(Le=>{const _e=(0,oe.toErrorMessage)(Le,!0);!_e||de.error(`[uncaught exception in sharedProcess]: ${_e}`)})}}async function Ce(Re){const de=new pe(Re);L.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await de.open(),L.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Ce})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/25785b97e533b15ae3b12e48aaf4187416437e62/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
