/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var X=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/base/common/types","electron","vs/nls","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/errors","fs","vs/base/node/pfs","vs/platform/product/common/productService","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","os","vs/base/common/uuid","vs/platform/workspaces/common/workspaces","vs/base/common/extpath","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/arrays","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/node/state","vs/base/common/labels","vs/platform/update/common/update","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/functional","vs/base/common/json","vs/base/common/objects","child_process","vs/platform/environment/common/environment","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/node/argvHelper","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/environment/node/shellEnv","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/tunnel","vs/platform/sign/common/sign","vs/platform/theme/electron-main/themeMainService","vs/platform/webview/common/webviewManagerService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","vs/base/node/extpath","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.snap","vs/platform/update/electron-main/updateService.win32","vs/platform/issue/electron-main/issueMainService","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],J=function(q){for(var e=[],m=0,L=q.length;m<L;m++)e[m]=X[q[m]];return e};define(X[100],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(L,k){if(!L)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=m}),define(X[52],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function m(p){return(i,D,g)=>{let S=null,v=null;if(typeof g.value=="function"?(S="value",v=g.value):typeof g.get=="function"&&(S="get",v=g.get),!v)throw new Error("not supported");g[S]=p(v,D)}}e.createDecorator=m;let L=0;function k(){const p=`$memoize${L++}`;let i;const D=function(S,v,d){let w=null,I=null;if(typeof d.value=="function"?(w="value",I=d.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(w="get",I=d.get),!I)throw new Error("not supported");const b=`${p}:${v}`;d[w]=function(...a){return i=this,this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!0,enumerable:!1,writable:!0,value:I.apply(this,a)}),this[b]}};return D.clear=()=>{typeof i!="undefined"&&Object.getOwnPropertyNames(i).forEach(g=>{g.indexOf(p)===0&&delete i[g]})},D}e.createMemoizer=k;function y(p,i,D){return k()(p,i,D)}e.memoize=y;function P(p,i,D){return m((g,S)=>{const v=`$debounce$${S}`,d=`$debounce$result$${S}`;return function(...w){this[d]||(this[d]=D?D():void 0),clearTimeout(this[v]),i&&(this[d]=i(this[d],...w),w=[this[d]]),this[v]=setTimeout(()=>{g.apply(this,w),this[d]=D?D():void 0},p)}})}e.debounce=P;function r(p,i,D){return m((g,S)=>{const v=`$throttle$timer$${S}`,d=`$throttle$result$${S}`,w=`$throttle$lastRun$${S}`,I=`$throttle$pending$${S}`;return function(...b){if(this[d]||(this[d]=D?D():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),i&&(this[d]=i(this[d],...b)),!this[I]){const a=this[w]+p;a<=Date.now()?(this[w]=Date.now(),g.apply(this,[this[d]]),this[d]=D?D():void 0):(this[I]=!0,this[v]=setTimeout(()=>{this[I]=!1,this[w]=Date.now(),g.apply(this,[this[d]]),this[d]=D?D():void 0},a-Date.now()))}}})}e.throttle=r}),define(X[17],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function L(s){e.errorHandler.setUnexpectedErrorHandler(s)}e.setUnexpectedErrorHandler=L;function k(s){p(s)||e.errorHandler.onUnexpectedError(s)}e.onUnexpectedError=k;function y(s){p(s)||e.errorHandler.onUnexpectedExternalError(s)}e.onUnexpectedExternalError=y;function P(s){if(s instanceof Error){let{name:t,message:n}=s;const o=s.stacktrace||s.stack;return{$isError:!0,name:t,message:n,stack:o}}return s}e.transformErrorForSerialization=P;const r="Canceled";function p(s){return s instanceof Error&&s.name===r&&s.message===r}e.isPromiseCanceledError=p;class i extends Error{constructor(){super(r);this.name=this.message}}e.CancellationError=i;function D(){const s=new Error(r);return s.name=s.message,s}e.canceled=D;function g(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}e.illegalArgument=g;function S(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}e.illegalState=S;function v(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function d(s){const t=new Error(`${s} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function w(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}e.getErrorMessage=w;class I extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=I;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class a extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=a;function c(s){const t=s;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=c;function l(s,t=Object.create(null)){const n=new Error(s);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=l}),define(X[35],J([0,1,17]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(C,j=0){return C[C.length-(1+j)]}e.tail=L;function k(C){if(C.length===0)throw new Error("Invalid tail call");return[C.slice(0,C.length-1),C[C.length-1]]}e.tail2=k;function y(C,j,N=(T,R)=>T===R){if(C===j)return!0;if(!C||!j||C.length!==j.length)return!1;for(let T=0,R=C.length;T<R;T++)if(!N(C[T],j[T]))return!1;return!0}e.equals=y;function P(C,j,N){let T=0,R=C.length-1;for(;T<=R;){const W=(T+R)/2|0,M=N(C[W],j);if(M<0)T=W+1;else if(M>0)R=W-1;else return W}return-(T+1)}e.binarySearch=P;function r(C,j){let N=0,T=C.length;if(T===0)return 0;for(;N<T;){const R=Math.floor((N+T)/2);j(C[R])?T=R:N=R+1}return N}e.findFirstInSorted=r;function p(C,j,N){if(C=C|0,C>=j.length)throw new TypeError("invalid index");let T=j[Math.floor(j.length*Math.random())],R=[],W=[],M=[];for(let F of j){const B=N(F,T);B<0?R.push(F):B>0?W.push(F):M.push(F)}return C<R.length?p(C,R,N):C<R.length+M.length?M[0]:p(C-(R.length+M.length),W,N)}e.quickSelect=p;function i(C,j){const N=[];let T;for(const R of C.slice(0).sort(j))!T||j(T[0],R)!==0?(T=[R],N.push(T)):T.push(R);return N}e.groupBy=i;function D(C,j,N){const T=[];function R(F,B,V){if(!(B===0&&V.length===0)){const G=T[T.length-1];G&&G.start+G.deleteCount===F?(G.deleteCount+=B,G.toInsert.push(...V)):T.push({start:F,deleteCount:B,toInsert:V})}}let W=0,M=0;for(;;){if(W===C.length){R(W,0,j.slice(M));break}if(M===j.length){R(W,C.length-W,[]);break}const F=C[W],B=j[M],V=N(F,B);V===0?(W+=1,M+=1):V<0?(R(W,1,[]),W+=1):V>0&&(R(W,0,[B]),M+=1)}return T}e.sortedDiff=D;function g(C,j,N){const T=D(C,j,N),R=[],W=[];for(const M of T)R.push(...C.slice(M.start,M.start+M.deleteCount)),W.push(...M.toInsert);return{removed:R,added:W}}e.delta=g;function S(C,j,N){if(N===0)return[];const T=C.slice(0,N).sort(j);return d(C,j,T,N,C.length),T}e.top=S;function v(C,j,N,T,R){return N===0?Promise.resolve([]):new Promise((W,M)=>{(async()=>{const F=C.length,B=C.slice(0,N).sort(j);for(let V=N,G=Math.min(N+T,F);V<F;V=G,G=Math.min(G+T,F)){if(V>N&&await new Promise(Y=>setTimeout(Y)),R&&R.isCancellationRequested)throw(0,m.canceled)();d(C,j,B,V,G)}return B})().then(W,M)})}e.topAsync=v;function d(C,j,N,T,R){for(const W=N.length;T<R;T++){const M=C[T];if(j(M,N[W-1])<0){N.pop();const F=r(N,B=>j(M,B)<0);N.splice(F,0,M)}}}function w(C){return C.filter(j=>!!j)}e.coalesce=w;function I(C){let j=0;for(let N=0;N<C.length;N++)C[N]&&(C[j]=C[N],j+=1);C.length=j}e.coalesceInPlace=I;function b(C,j,N){C.splice(N,0,C.splice(j,1)[0])}e.move=b;function a(C){return!Array.isArray(C)||C.length===0}e.isFalsyOrEmpty=a;function c(C){return Array.isArray(C)&&C.length>0}e.isNonEmptyArray=c;function l(C,j){if(!j)return C.filter((T,R)=>C.indexOf(T)===R);const N=Object.create(null);return C.filter(T=>{const R=j(T);return N[R]?!1:(N[R]=!0,!0)})}e.distinct=l;function s(C){const j=new Set;return C.filter(N=>j.has(N)?!1:(j.add(N),!0))}e.distinctES6=s;function t(C){const j=Object.create(null);return N=>{const T=C(N);return j[T]?!1:(j[T]=!0,!0)}}e.uniqueFilter=t;function n(C,j){for(let N=C.length-1;N>=0;N--){const T=C[N];if(j(T))return N}return-1}e.lastIndex=n;function o(C,j){return C.length>0?C[0]:j}e.firstOrDefault=o;function u(C,j,N=(T,R)=>T===R){let T=0;for(let R=0,W=Math.min(C.length,j.length);R<W&&N(C[R],j[R]);R++)T++;return T}e.commonPrefixLength=u;function h(C){return[].concat(...C)}e.flatten=h;function f(C,j){let N=typeof j=="number"?C:0;typeof j=="number"?N=C:(N=0,j=C);const T=[];if(N<=j)for(let R=N;R<j;R++)T.push(R);else for(let R=N;R>j;R--)T.push(R);return T}e.range=f;function E(C,j,N){return C.reduce((T,R)=>(T[j(R)]=N?N(R):R,T),Object.create(null))}e.index=E;function A(C,j){return C.push(j),()=>_(C,j)}e.insert=A;function _(C,j){const N=C.indexOf(j);if(N>-1)return C.splice(N,1),j}e.remove=_;function U(C,j,N){const T=C.slice(0,j),R=C.slice(j);return T.concat(N,R)}e.arrayInsert=U;function H(C,j){let N;if(typeof j=="number"){let T=j;N=()=>{const R=Math.sin(T++)*179426549;return R-Math.floor(R)}}else N=Math.random;for(let T=C.length-1;T>0;T-=1){const R=Math.floor(N()*(T+1)),W=C[T];C[T]=C[R],C[R]=W}}e.shuffle=H;function Q(C,j){const N=C.indexOf(j);N>-1&&(C.splice(N,1),C.unshift(j))}e.pushToStart=Q;function ne(C,j){const N=C.indexOf(j);N>-1&&(C.splice(N,1),C.push(j))}e.pushToEnd=ne;function ae(C,j){return Array.isArray(C)?C.map(j):j(C)}e.mapArrayOrNot=ae;function O(C){return Array.isArray(C)?C:[C]}e.asArray=O;function $(C){return C[Math.floor(Math.random()*C.length)]}e.getRandomElement=$;function z(C,j){for(const N of C){const T=j(N);if(T!==void 0)return T}}e.mapFind=z}),define(X[42],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(L){const k=this;let y=!1,P;return function(){return y||(y=!0,P=L.apply(k,arguments)),P}}e.once=m}),define(X[62],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(L){function k(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}L.is=k;const y=Object.freeze([]);function P(){return y}L.empty=P;function*r(s){yield s}L.single=r;function p(s){return s||y}L.from=p;function i(s){return!s||s[Symbol.iterator]().next().done===!0}L.isEmpty=i;function D(s){return s[Symbol.iterator]().next().value}L.first=D;function g(s,t){for(const n of s)if(t(n))return!0;return!1}L.some=g;function S(s,t){for(const n of s)if(t(n))return n}L.find=S;function*v(s,t){for(const n of s)t(n)&&(yield n)}L.filter=v;function*d(s,t){for(const n of s)yield t(n)}L.map=d;function*w(...s){for(const t of s)for(const n of t)yield n}L.concat=w;function*I(s){for(const t of s)for(const n of t)yield n}L.concatNested=I;function b(s,t,n){let o=n;for(const u of s)o=t(o,u);return o}L.reduce=b;function*a(s,t,n=s.length){for(t<0&&(t+=s.length),n<0?n+=s.length:n>s.length&&(n=s.length);t<n;t++)yield s[t]}L.slice=a;function c(s,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,s];const o=s[Symbol.iterator]();for(let u=0;u<t;u++){const h=o.next();if(h.done)return[n,L.empty()];n.push(h.value)}return[n,{[Symbol.iterator](){return o}}]}L.consume=c;function l(s,t,n=(o,u)=>o===u){const o=s[Symbol.iterator](),u=t[Symbol.iterator]();for(;;){const h=o.next(),f=u.next();if(h.done!==f.done)return!1;if(h.done)return!0;if(!n(h.value,f.value))return!1}}L.equals=l})(m=e.Iterable||(e.Iterable={}))}),define(X[43],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function P(t,n=!1){let o=0,u=t.length,h="",f=0,E=16,A=0;function _($){let z=0,C=0;for(;z<$;){const j=t.charCodeAt(o);if(j>=48&&j<=57)C=C*16+j-48;else if(j>=65&&j<=70)C=C*16+j-65+10;else if(j>=97&&j<=102)C=C*16+j-97+10;else break;o++,z++}return z<$&&(C=-1),C}function U($){o=$,h="",f=0,E=16,A=0}function H(){const $=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&i(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&i(t.charCodeAt(o)))for(o++;o<t.length&&i(t.charCodeAt(o));)o++;else return A=3,t.substring($,o);let z=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&i(t.charCodeAt(o))){for(o++;o<t.length&&i(t.charCodeAt(o));)o++;z=o}else A=3;return t.substring($,z)}function Q(){let $="",z=o;for(;;){if(o>=u){$+=t.substring(z,o),A=2;break}const C=t.charCodeAt(o);if(C===34){$+=t.substring(z,o),o++;break}if(C===92){if($+=t.substring(z,o),o++,o>=u){A=2;break}switch(t.charCodeAt(o++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const N=_(4);N>=0?$+=String.fromCharCode(N):A=4;break;default:A=5}z=o;continue}if(C>=0&&C<=31)if(p(C)){$+=t.substring(z,o),A=2;break}else A=6;o++}return $}function ne(){if(h="",A=0,f=o,o>=u)return f=u,E=17;let $=t.charCodeAt(o);if(r($)){do o++,h+=String.fromCharCode($),$=t.charCodeAt(o);while(r($));return E=15}if(p($))return o++,h+=String.fromCharCode($),$===13&&t.charCodeAt(o)===10&&(o++,h+=`
`),E=14;switch($){case 123:return o++,E=1;case 125:return o++,E=2;case 91:return o++,E=3;case 93:return o++,E=4;case 58:return o++,E=6;case 44:return o++,E=5;case 34:return o++,h=Q(),E=10;case 47:const z=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<u&&!p(t.charCodeAt(o));)o++;return h=t.substring(z,o),E=12}if(t.charCodeAt(o+1)===42){o+=2;const C=u-1;let j=!1;for(;o<C;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,j=!0;break}o++}return j||(o++,A=1),h=t.substring(z,o),E=13}return h+=String.fromCharCode($),o++,E=16;case 45:if(h+=String.fromCharCode($),o++,o===u||!i(t.charCodeAt(o)))return E=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=H(),E=11;default:for(;o<u&&ae($);)o++,$=t.charCodeAt(o);if(f!==o){switch(h=t.substring(f,o),h){case"true":return E=8;case"false":return E=9;case"null":return E=7}return E=16}return h+=String.fromCharCode($),o++,E=16}}function ae($){if(r($)||p($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function O(){let $;do $=ne();while($>=12&&$<=15);return $}return{setPosition:U,getPosition:()=>o,scan:n?O:ne,getToken:()=>E,getTokenValue:()=>h,getTokenOffset:()=>f,getTokenLength:()=>o-f,getTokenError:()=>A}}e.createScanner=P;function r(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function i(t){return t>=48&&t<=57}var D;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(D||(D={}));function g(t,n){const o=[],u=new Object;let h;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function A(_,U,H,Q){f.value=_,f.offset=U,f.length=H,f.type=Q,f.colonOffset=void 0,h=f}try{c(t,{onObjectBegin:(_,U)=>{if(n<=_)throw u;h=void 0,E=n>_,o.push("")},onObjectProperty:(_,U,H)=>{if(n<U||(A(_,U,H,"property"),o[o.length-1]=_,n<=U+H))throw u},onObjectEnd:(_,U)=>{if(n<=_)throw u;h=void 0,o.pop()},onArrayBegin:(_,U)=>{if(n<=_)throw u;h=void 0,o.push(0)},onArrayEnd:(_,U)=>{if(n<=_)throw u;h=void 0,o.pop()},onLiteralValue:(_,U,H)=>{if(n<U||(A(_,U,H,s(_)),n<=U+H))throw u},onSeparator:(_,U,H)=>{if(n<=U)throw u;if(_===":"&&h&&h.type==="property")h.colonOffset=U,E=!1,h=void 0;else if(_===","){const Q=o[o.length-1];typeof Q=="number"?o[o.length-1]=Q+1:(E=!0,o[o.length-1]=""),h=void 0}}})}catch(_){if(_!==u)throw _}return{path:o,previousNode:h,isAtPropertyKey:E,matches:_=>{let U=0;for(let H=0;U<_.length&&H<o.length;H++)if(_[U]===o[H]||_[U]==="*")U++;else if(_[U]!=="**")return!1;return U===_.length}}}e.getLocation=g;function S(t,n=[],o=y.DEFAULT){let u=null,h=[];const f=[];function E(_){Array.isArray(h)?h.push(_):u!==null&&(h[u]=_)}return c(t,{onObjectBegin:()=>{const _={};E(_),f.push(h),h=_,u=null},onObjectProperty:_=>{u=_},onObjectEnd:()=>{h=f.pop()},onArrayBegin:()=>{const _=[];E(_),f.push(h),h=_,u=null},onArrayEnd:()=>{h=f.pop()},onLiteralValue:E,onError:(_,U,H)=>{n.push({error:_,offset:U,length:H})}},o),h[0]}e.parse=S;function v(t,n=[],o=y.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(_){u.type==="property"&&(u.length=_-u.offset,u=u.parent)}function f(_){return u.children.push(_),_}c(t,{onObjectBegin:_=>{u=f({type:"object",offset:_,length:-1,parent:u,children:[]})},onObjectProperty:(_,U,H)=>{u=f({type:"property",offset:U,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:_,offset:U,length:H,parent:u})},onObjectEnd:(_,U)=>{u.length=_+U-u.offset,u=u.parent,h(_+U)},onArrayBegin:(_,U)=>{u=f({type:"array",offset:_,length:-1,parent:u,children:[]})},onArrayEnd:(_,U)=>{u.length=_+U-u.offset,u=u.parent,h(_+U)},onLiteralValue:(_,U,H)=>{f({type:s(_),offset:U,length:H,parent:u,value:_}),h(U+H)},onSeparator:(_,U,H)=>{u.type==="property"&&(_===":"?u.colonOffset=U:_===","&&h(U))},onError:(_,U,H)=>{n.push({error:_,offset:U,length:H})}},o);const A=u.children[0];return A&&delete A.parent,A}e.parseTree=v;function d(t,n){if(!!t){let o=t;for(let u of n)if(typeof u=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let h=!1;for(const f of o.children)if(Array.isArray(f.children)&&f.children[0].value===u){o=f.children[1],h=!0;break}if(!h)return}else{const h=u;if(o.type!=="array"||h<0||!Array.isArray(o.children)||h>=o.children.length)return;o=o.children[h]}return o}}e.findNodeAtLocation=d;function w(t){if(!t.parent||!t.parent.children)return[];const n=w(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;n.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&n.push(o)}return n}e.getNodePath=w;function I(t){switch(t.type){case"array":return t.children.map(I);case"object":const n=Object.create(null);for(let o of t.children){const u=o.children[1];u&&(n[o.children[0].value]=I(u))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=I;function b(t,n,o=!1){return n>=t.offset&&n<t.offset+t.length||o&&n===t.offset+t.length}e.contains=b;function a(t,n,o=!1){if(b(t,n,o)){const u=t.children;if(Array.isArray(u))for(let h=0;h<u.length&&u[h].offset<=n;h++){const f=a(u[h],n,o);if(f)return f}return t}}e.findNodeAtOffset=a;function c(t,n,o=y.DEFAULT){const u=P(t,!1);function h(B){return B?()=>B(u.getTokenOffset(),u.getTokenLength()):()=>!0}function f(B){return B?V=>B(V,u.getTokenOffset(),u.getTokenLength()):()=>!0}const E=h(n.onObjectBegin),A=f(n.onObjectProperty),_=h(n.onObjectEnd),U=h(n.onArrayBegin),H=h(n.onArrayEnd),Q=f(n.onLiteralValue),ne=f(n.onSeparator),ae=h(n.onComment),O=f(n.onError),$=o&&o.disallowComments,z=o&&o.allowTrailingComma;function C(){for(;;){const B=u.scan();switch(u.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:$||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(B){case 12:case 13:$?j(10):ae();break;case 16:j(1);break;case 15:case 14:break;default:return B}}}function j(B,V=[],G=[]){if(O(B),V.length+G.length>0){let Y=u.getToken();for(;Y!==17;){if(V.indexOf(Y)!==-1){C();break}else if(G.indexOf(Y)!==-1)break;Y=C()}}}function N(B){const V=u.getTokenValue();return B?Q(V):A(V),C(),!0}function T(){switch(u.getToken()){case 11:let B=0;try{B=JSON.parse(u.getTokenValue()),typeof B!="number"&&(j(2),B=0)}catch(V){j(2)}Q(B);break;case 7:Q(null);break;case 8:Q(!0);break;case 9:Q(!1);break;default:return!1}return C(),!0}function R(){return u.getToken()!==10?(j(3,[],[2,5]),!1):(N(!1),u.getToken()===6?(ne(":"),C(),F()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function W(){E(),C();let B=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(B||j(4,[],[]),ne(","),C(),u.getToken()===2&&z)break}else B&&j(6,[],[]);R()||j(4,[],[2,5]),B=!0}return _(),u.getToken()!==2?j(7,[2],[]):C(),!0}function M(){U(),C();let B=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(B||j(4,[],[]),ne(","),C(),u.getToken()===4&&z)break}else B&&j(6,[],[]);F()||j(4,[],[4,5]),B=!0}return H(),u.getToken()!==4?j(8,[4],[]):C(),!0}function F(){switch(u.getToken()){case 3:return M();case 1:return W();case 10:return N(!0);default:return T()}}return C(),u.getToken()===17?o.allowEmptyContent?!0:(j(4,[],[]),!1):F()?(u.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=c;function l(t,n){let o=P(t),u=[],h,f=0,E;do switch(E=o.getPosition(),h=o.scan(),h){case 12:case 13:case 17:f!==E&&u.push(t.substring(f,E)),n!==void 0&&u.push(o.getTokenValue().replace(/[^\r\n]/g,n)),f=o.getPosition();break}while(h!==17);return u.join("")}e.stripComments=l;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),define(X[101],J([0,1,43]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(p,i,D){let g,S,v,d,w;if(i){for(d=i.offset,w=d+i.length,v=d;v>0&&!r(p,v-1);)v--;let f=w;for(;f<p.length&&!r(p,f);)f++;S=p.substring(v,f),g=y(S,D)}else S=p,g=0,v=0,d=0,w=p.length;const I=P(D,p);let b=!1,a=0,c;D.insertSpaces?c=k(" ",D.tabSize||4):c="	";const l=(0,m.createScanner)(S,!1);let s=!1;function t(){return I+k(c,g+a)}function n(){let f=l.scan();for(b=!1;f===15||f===14;)b=b||f===14,f=l.scan();return s=f===16||l.getTokenError()!==0,f}const o=[];function u(f,E,A){!s&&E<w&&A>d&&p.substring(E,A)!==f&&o.push({offset:E,length:A-E,content:f})}let h=n();if(h!==17){const f=l.getTokenOffset()+v,E=k(c,g);u(E,v,f)}for(;h!==17;){let f=l.getTokenOffset()+l.getTokenLength()+v,E=n(),A="";for(;!b&&(E===12||E===13);){const U=l.getTokenOffset()+v;u(" ",f,U),f=l.getTokenOffset()+l.getTokenLength()+v,A=E===12?t():"",E=n()}if(E===2)h!==1&&(a--,A=t());else if(E===4)h!==3&&(a--,A=t());else{switch(h){case 3:case 1:a++,A=t();break;case 5:case 12:A=t();break;case 13:b?A=t():A=" ";break;case 6:A=" ";break;case 10:if(E===6){A="";break}case 7:case 8:case 9:case 11:case 2:case 4:E===12||E===13?A=" ":E!==5&&E!==17&&(s=!0);break;case 16:s=!0;break}b&&(E===12||E===13)&&(A=t())}const _=l.getTokenOffset()+v;u(A,f,_),h=E}return o}e.format=L;function k(p,i){let D="";for(let g=0;g<i;g++)D+=p;return D}function y(p,i){let D=0,g=0;const S=i.tabSize||4;for(;D<p.length;){const v=p.charAt(D);if(v===" ")g++;else if(v==="	")g+=S;else break;D++}return Math.floor(g/S)}function P(p,i){for(let D=0;D<i.length;D++){const g=i.charAt(D);if(g==="\r")return D+1<i.length&&i.charAt(D+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return p&&p.eol||`
`}e.getEOL=P;function r(p,i){return`\r
`.indexOf(p.charAt(i))!==-1}e.isEOL=r}),define(X[102],J([0,1,43,101]),function(q,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(i,D,g){return y(i,D,void 0,g)}e.removeProperty=k;function y(i,D,g,S,v){const d=D.slice(),w=[],I=(0,m.parseTree)(i,w);let b,a;for(;d.length>0&&(a=d.pop(),b=(0,m.findNodeAtLocation)(I,d),b===void 0&&g!==void 0);)typeof a=="string"?g={[a]:g}:g=[g];if(b)if(b.type==="object"&&typeof a=="string"&&Array.isArray(b.children)){const c=(0,m.findNodeAtLocation)(b,[a]);if(c!==void 0)if(g===void 0){if(!c.parent)throw new Error("Malformed AST");const l=b.children.indexOf(c.parent);let s,t=c.parent.offset+c.parent.length;if(l>0){const n=b.children[l-1];s=n.offset+n.length}else s=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return P(i,{offset:s,length:t-s,content:""},S)}else return P(i,{offset:c.offset,length:c.length,content:JSON.stringify(g)},S);else{if(g===void 0)return[];const l=`${JSON.stringify(a)}: ${JSON.stringify(g)}`,s=v?v(b.children.map(n=>n.children[0].value)):b.children.length;let t;if(s>0){const n=b.children[s-1];t={offset:n.offset+n.length,length:0,content:","+l}}else b.children.length===0?t={offset:b.offset+1,length:0,content:l}:t={offset:b.offset+1,length:0,content:l+","};return P(i,t,S)}}else if(b.type==="array"&&typeof a=="number"&&Array.isArray(b.children))if(g!==void 0){const c=`${JSON.stringify(g)}`;let l;if(b.children.length===0||a===0)l={offset:b.offset+1,length:0,content:b.children.length===0?c:c+","};else{const s=a===-1||a>b.children.length?b.children.length:a,t=b.children[s-1];l={offset:t.offset+t.length,length:0,content:","+c}}return P(i,l,S)}else{const c=a,l=b.children[c];let s;if(b.children.length===1)s={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===c){const t=b.children[c-1],n=t.offset+t.length,o=b.offset+b.length;s={offset:n,length:o-2-n,content:""}}else s={offset:l.offset,length:b.children[c+1].offset-l.offset,content:""};return P(i,s,S)}else throw new Error(`Can not add ${typeof a!="number"?"index":"property"} to parent of type ${b.type}`);else{if(g===void 0)throw new Error("Can not delete in empty document");return P(i,{offset:I?I.offset:0,length:I?I.length:0,content:JSON.stringify(g)},S)}}e.setProperty=y;function P(i,D,g){let S=r(i,D),v=D.offset,d=D.offset+D.content.length;if(D.length===0||D.content.length===0){for(;v>0&&!(0,L.isEOL)(S,v-1);)v--;for(;d<S.length&&!(0,L.isEOL)(S,d);)d++}const w=(0,L.format)(S,{offset:v,length:d-v},g);for(let b=w.length-1;b>=0;b--){const a=w[b];S=r(S,a),v=Math.min(v,a.offset),d=Math.max(d,a.offset+a.length),d+=a.content.length-a.length}const I=i.length-(S.length-d)-v;return[{offset:v,length:I,content:S.substring(v,d)}]}e.withFormatting=P;function r(i,D){return i.substring(0,D.offset)+D.content+i.substring(D.offset+D.length)}e.applyEdit=r;function p(i,D){let g=D.slice(0).sort((v,d)=>{const w=v.offset-d.offset;return w===0?v.length-d.length:w}),S=i.length;for(let v=g.length-1;v>=0;v--){let d=g[v];if(d.offset+d.length<=S)i=r(i,d);else throw new Error("Overlapping edit");S=d.offset}return i}e.applyEdits=p}),define(X[57],J([0,1,17]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var L;(function(a){a[a.DependsOnKbLayout=-1]="DependsOnKbLayout",a[a.Unknown=0]="Unknown",a[a.Backspace=1]="Backspace",a[a.Tab=2]="Tab",a[a.Enter=3]="Enter",a[a.Shift=4]="Shift",a[a.Ctrl=5]="Ctrl",a[a.Alt=6]="Alt",a[a.PauseBreak=7]="PauseBreak",a[a.CapsLock=8]="CapsLock",a[a.Escape=9]="Escape",a[a.Space=10]="Space",a[a.PageUp=11]="PageUp",a[a.PageDown=12]="PageDown",a[a.End=13]="End",a[a.Home=14]="Home",a[a.LeftArrow=15]="LeftArrow",a[a.UpArrow=16]="UpArrow",a[a.RightArrow=17]="RightArrow",a[a.DownArrow=18]="DownArrow",a[a.Insert=19]="Insert",a[a.Delete=20]="Delete",a[a.KEY_0=21]="KEY_0",a[a.KEY_1=22]="KEY_1",a[a.KEY_2=23]="KEY_2",a[a.KEY_3=24]="KEY_3",a[a.KEY_4=25]="KEY_4",a[a.KEY_5=26]="KEY_5",a[a.KEY_6=27]="KEY_6",a[a.KEY_7=28]="KEY_7",a[a.KEY_8=29]="KEY_8",a[a.KEY_9=30]="KEY_9",a[a.KEY_A=31]="KEY_A",a[a.KEY_B=32]="KEY_B",a[a.KEY_C=33]="KEY_C",a[a.KEY_D=34]="KEY_D",a[a.KEY_E=35]="KEY_E",a[a.KEY_F=36]="KEY_F",a[a.KEY_G=37]="KEY_G",a[a.KEY_H=38]="KEY_H",a[a.KEY_I=39]="KEY_I",a[a.KEY_J=40]="KEY_J",a[a.KEY_K=41]="KEY_K",a[a.KEY_L=42]="KEY_L",a[a.KEY_M=43]="KEY_M",a[a.KEY_N=44]="KEY_N",a[a.KEY_O=45]="KEY_O",a[a.KEY_P=46]="KEY_P",a[a.KEY_Q=47]="KEY_Q",a[a.KEY_R=48]="KEY_R",a[a.KEY_S=49]="KEY_S",a[a.KEY_T=50]="KEY_T",a[a.KEY_U=51]="KEY_U",a[a.KEY_V=52]="KEY_V",a[a.KEY_W=53]="KEY_W",a[a.KEY_X=54]="KEY_X",a[a.KEY_Y=55]="KEY_Y",a[a.KEY_Z=56]="KEY_Z",a[a.Meta=57]="Meta",a[a.ContextMenu=58]="ContextMenu",a[a.F1=59]="F1",a[a.F2=60]="F2",a[a.F3=61]="F3",a[a.F4=62]="F4",a[a.F5=63]="F5",a[a.F6=64]="F6",a[a.F7=65]="F7",a[a.F8=66]="F8",a[a.F9=67]="F9",a[a.F10=68]="F10",a[a.F11=69]="F11",a[a.F12=70]="F12",a[a.F13=71]="F13",a[a.F14=72]="F14",a[a.F15=73]="F15",a[a.F16=74]="F16",a[a.F17=75]="F17",a[a.F18=76]="F18",a[a.F19=77]="F19",a[a.NumLock=78]="NumLock",a[a.ScrollLock=79]="ScrollLock",a[a.US_SEMICOLON=80]="US_SEMICOLON",a[a.US_EQUAL=81]="US_EQUAL",a[a.US_COMMA=82]="US_COMMA",a[a.US_MINUS=83]="US_MINUS",a[a.US_DOT=84]="US_DOT",a[a.US_SLASH=85]="US_SLASH",a[a.US_BACKTICK=86]="US_BACKTICK",a[a.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",a[a.US_BACKSLASH=88]="US_BACKSLASH",a[a.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",a[a.US_QUOTE=90]="US_QUOTE",a[a.OEM_8=91]="OEM_8",a[a.OEM_102=92]="OEM_102",a[a.NUMPAD_0=93]="NUMPAD_0",a[a.NUMPAD_1=94]="NUMPAD_1",a[a.NUMPAD_2=95]="NUMPAD_2",a[a.NUMPAD_3=96]="NUMPAD_3",a[a.NUMPAD_4=97]="NUMPAD_4",a[a.NUMPAD_5=98]="NUMPAD_5",a[a.NUMPAD_6=99]="NUMPAD_6",a[a.NUMPAD_7=100]="NUMPAD_7",a[a.NUMPAD_8=101]="NUMPAD_8",a[a.NUMPAD_9=102]="NUMPAD_9",a[a.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",a[a.NUMPAD_ADD=104]="NUMPAD_ADD",a[a.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",a[a.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",a[a.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",a[a.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",a[a.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",a[a.ABNT_C1=110]="ABNT_C1",a[a.ABNT_C2=111]="ABNT_C2",a[a.MAX_VALUE=112]="MAX_VALUE"})(L=e.KeyCode||(e.KeyCode={}));class k{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(c,l){this._keyCodeToStr[c]=l,this._strToKeyCode[l.toLowerCase()]=c}keyCodeToStr(c){return this._keyCodeToStr[c]}strToKeyCode(c){return this._strToKeyCode[c.toLowerCase()]||0}}const y=new k,P=new k,r=new k;(function(){function a(c,l,s=l,t=s){y.define(c,l),P.define(c,s),r.define(c,t)}a(0,"unknown"),a(1,"Backspace"),a(2,"Tab"),a(3,"Enter"),a(4,"Shift"),a(5,"Ctrl"),a(6,"Alt"),a(7,"PauseBreak"),a(8,"CapsLock"),a(9,"Escape"),a(10,"Space"),a(11,"PageUp"),a(12,"PageDown"),a(13,"End"),a(14,"Home"),a(15,"LeftArrow","Left"),a(16,"UpArrow","Up"),a(17,"RightArrow","Right"),a(18,"DownArrow","Down"),a(19,"Insert"),a(20,"Delete"),a(21,"0"),a(22,"1"),a(23,"2"),a(24,"3"),a(25,"4"),a(26,"5"),a(27,"6"),a(28,"7"),a(29,"8"),a(30,"9"),a(31,"A"),a(32,"B"),a(33,"C"),a(34,"D"),a(35,"E"),a(36,"F"),a(37,"G"),a(38,"H"),a(39,"I"),a(40,"J"),a(41,"K"),a(42,"L"),a(43,"M"),a(44,"N"),a(45,"O"),a(46,"P"),a(47,"Q"),a(48,"R"),a(49,"S"),a(50,"T"),a(51,"U"),a(52,"V"),a(53,"W"),a(54,"X"),a(55,"Y"),a(56,"Z"),a(57,"Meta"),a(58,"ContextMenu"),a(59,"F1"),a(60,"F2"),a(61,"F3"),a(62,"F4"),a(63,"F5"),a(64,"F6"),a(65,"F7"),a(66,"F8"),a(67,"F9"),a(68,"F10"),a(69,"F11"),a(70,"F12"),a(71,"F13"),a(72,"F14"),a(73,"F15"),a(74,"F16"),a(75,"F17"),a(76,"F18"),a(77,"F19"),a(78,"NumLock"),a(79,"ScrollLock"),a(80,";",";","OEM_1"),a(81,"=","=","OEM_PLUS"),a(82,",",",","OEM_COMMA"),a(83,"-","-","OEM_MINUS"),a(84,".",".","OEM_PERIOD"),a(85,"/","/","OEM_2"),a(86,"`","`","OEM_3"),a(110,"ABNT_C1"),a(111,"ABNT_C2"),a(87,"[","[","OEM_4"),a(88,"\\","\\","OEM_5"),a(89,"]","]","OEM_6"),a(90,"'","'","OEM_7"),a(91,"OEM_8"),a(92,"OEM_102"),a(93,"NumPad0"),a(94,"NumPad1"),a(95,"NumPad2"),a(96,"NumPad3"),a(97,"NumPad4"),a(98,"NumPad5"),a(99,"NumPad6"),a(100,"NumPad7"),a(101,"NumPad8"),a(102,"NumPad9"),a(103,"NumPad_Multiply"),a(104,"NumPad_Add"),a(105,"NumPad_Separator"),a(106,"NumPad_Subtract"),a(107,"NumPad_Decimal"),a(108,"NumPad_Divide")})();var p;(function(a){function c(o){return y.keyCodeToStr(o)}a.toString=c;function l(o){return y.strToKeyCode(o)}a.fromString=l;function s(o){return P.keyCodeToStr(o)}a.toUserSettingsUS=s;function t(o){return r.keyCodeToStr(o)}a.toUserSettingsGeneral=t;function n(o){return P.strToKeyCode(o)||r.strToKeyCode(o)}a.fromUserSettings=n})(p=e.KeyCodeUtils||(e.KeyCodeUtils={}));var i;(function(a){a[a.CtrlCmd=2048]="CtrlCmd",a[a.Shift=1024]="Shift",a[a.Alt=512]="Alt",a[a.WinCtrl=256]="WinCtrl",a[a.KeyCode=255]="KeyCode"})(i||(i={}));var D;(function(a){a[a.CtrlCmd=2048]="CtrlCmd",a[a.Shift=1024]="Shift",a[a.Alt=512]="Alt",a[a.WinCtrl=256]="WinCtrl"})(D=e.KeyMod||(e.KeyMod={}));function g(a,c){const l=(c&65535)<<16>>>0;return(a|l)>>>0}e.KeyChord=g;function S(a,c){if(a===0)return null;const l=(a&65535)>>>0,s=(a&4294901760)>>>16;return s!==0?new w([v(l,c),v(s,c)]):new w([v(l,c)])}e.createKeybinding=S;function v(a,c){const l=!!(a&2048),s=!!(a&256),t=c===2?s:l,n=!!(a&1024),o=!!(a&512),u=c===2?l:s,h=a&255;return new d(t,n,o,u,h)}e.createSimpleKeybinding=v;class d{constructor(c,l,s,t,n){this.ctrlKey=c,this.shiftKey=l,this.altKey=s,this.metaKey=t,this.keyCode=n}equals(c){return this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.keyCode===c.keyCode}getHashCode(){const c=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",s=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${c}${l}${s}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new w([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class w{constructor(c){if(c.length===0)throw(0,m.illegalArgument)("parts");this.parts=c}getHashCode(){let c="";for(let l=0,s=this.parts.length;l<s;l++)l!==0&&(c+=";"),c+=this.parts[l].getHashCode();return c}equals(c){if(c===null||this.parts.length!==c.parts.length)return!1;for(let l=0;l<this.parts.length;l++)if(!this.parts[l].equals(c.parts[l]))return!1;return!0}}e.ChordKeybinding=w;class I{constructor(c,l,s,t,n,o){this.ctrlKey=c,this.shiftKey=l,this.altKey=s,this.metaKey=t,this.keyLabel=n,this.keyAriaLabel=o}}e.ResolvedKeybindingPart=I;class b{}e.ResolvedKeybinding=b}),define(X[2],J([0,1,42,62]),function(q,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const k=!1;let y=null;function P(c){y=c}if(e.setDisposableTracker=P,k){const c="__is_disposable_tracked__";y=new class{trackDisposable(l){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[c]||console.log(s)},3e3)}markTracked(l){if(l&&l!==w.None)try{l[c]=!0}catch(s){}}}}function r(c){!y||y.markTracked(c)}function p(c){return y&&y.trackDisposable(c),c}e.trackDisposable=p;class i extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=i;function D(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=D;function g(c){if(L.Iterable.is(c)){let l=[];for(const s of c)if(s){r(s);try{s.dispose()}catch(t){l.push(t)}}if(l.length===1)throw l[0];if(l.length>1)throw new i(l);return Array.isArray(c)?[]:c}else if(c)return r(c),c.dispose(),c}e.dispose=g;function S(...c){return c.forEach(r),v(()=>g(c))}e.combinedDisposable=S;function v(c){const l=p({dispose:()=>{r(l),c()}});return l}e.toDisposable=v;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(r(this),this._isDisposed=!0,this.clear())}clear(){try{g(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return r(l),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new d,p(this)}dispose(){r(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class I{constructor(){this._isDisposed=!1,p(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var s;this._isDisposed||l===this._value||((s=this._value)===null||s===void 0||s.dispose(),l&&r(l),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,r(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}e.MutableDisposable=I;class b{constructor(){this.references=new Map}acquire(l,...s){let t=this.references.get(l);t||(t={counter:0,object:this.createReferencedObject(l,...s)},this.references.set(l,t));const{object:n}=t,o=(0,m.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(l,t.object),this.references.delete(l))});return t.counter++,{object:n,dispose:o}}}e.ReferenceCollection=b;class a{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=a}),define(X[78],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(y){this.element=y,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class L{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,P){const r=new m(y);if(this._first===m.Undefined)this._first=r,this._last=r;else if(P){const i=this._last;this._last=r,r.prev=i,i.next=r}else{const i=this._first;this._first=r,r.next=i,i.prev=r}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(r))}}shift(){if(this._first!==m.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==m.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==m.Undefined&&y.next!==m.Undefined){const P=y.prev;P.next=y.next,y.next.prev=P}else y.prev===m.Undefined&&y.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):y.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):y.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==m.Undefined;)yield y.element,y=y.next}}e.LinkedList=L});"use strict";(function(){function q(k){const y=[];typeof k=="number"&&y.push("code/timeOrigin",k);function P(p){y.push(p,Date.now())}function r(){const p=[];for(let i=0;i<y.length;i+=2)p.push({name:y[i],startTime:y[i+1]});return p}return{mark:P,getMarks:r}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const P of performance.getEntriesByType("mark"))y.push({name:P.name,startTime:Math.round(k+P.startTime)});return y}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function m(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=m(L))})(),define(X[3],J([0,1]),function(q,e){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const L="en";let k=!1,y=!1,P=!1,r=!1,p=!1,i=!1,D=!1,g,S=L,v,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let w;typeof e.globals.vscode!="undefined"?w=e.globals.vscode.process:typeof process!="undefined"&&(w=process);const I=typeof((m=w==null?void 0:w.versions)===null||m===void 0?void 0:m.electron)=="string"&&w.type==="renderer";if(e.isElectronSandboxed=I&&(w==null?void 0:w.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const u=w==null?void 0:w.env.VSCODE_BROWSER_CODE_LOADING;if(typeof u=="string")return u==="none"||u==="code"||u==="bypassHeatCheck"||u==="bypassHeatCheckAndEagerCompile"?u:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!I)d=navigator.userAgent,k=d.indexOf("Windows")>=0,y=d.indexOf("Macintosh")>=0,D=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=d.indexOf("Linux")>=0,i=!0,g=navigator.language,S=g;else if(typeof w=="object"){k=w.platform==="win32",y=w.platform==="darwin",P=w.platform==="linux",r=P&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,g=L,S=L;const u=w.env.VSCODE_NLS_CONFIG;if(u)try{const h=JSON.parse(u),f=h.availableLanguages["*"];g=h.locale,S=f||L,v=h._translationsConfigFile}catch(h){}p=!0}else console.error("Unable to resolve platform.");var b;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function a(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=a;let c=0;y?c=1:k?c=3:P&&(c=2),e.isWindows=k,e.isMacintosh=y,e.isLinux=P,e.isLinuxSnap=r,e.isNative=p,e.isWeb=i,e.isIOS=D,e.platform=c,e.userAgent=d,e.language=S;var l;(function(u){function h(){return e.language}u.value=h;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}u.isDefaultVariant=f;function E(){return e.language==="en"}u.isDefault=E})(l=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=v,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let f=[];e.globals.addEventListener("message",A=>{if(A.data&&A.data.vscodeSetImmediateId)for(let _=0,U=f.length;_<U;_++){const H=f[_];if(H.id===A.data.vscodeSetImmediateId){f.splice(_,1),H.callback();return}}});let E=0;return A=>{const _=++E;f.push({id:_,callback:A}),e.globals.postMessage({vscodeSetImmediateId:_},"*")}}if(typeof(w==null?void 0:w.nextTick)=="function")return w.nextTick.bind(w);const h=Promise.resolve();return f=>h.then(f)}();var s;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||D?2:k?1:3;let t=!0,n=!1;function o(){if(!n){n=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,t=new Uint16Array(u.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=o}),define(X[32],J([0,1,3]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof m.globals.vscode!="undefined"){const k=m.globals.vscode.process;L={get platform(){return k.platform},get env(){return k.env},cwd(){return k.cwd()},nextTick(y){return(0,m.setImmediate)(y)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:L={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},nextTick(k){return(0,m.setImmediate)(k)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(X[8],J([0,1,32]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,k=97,y=90,P=122,r=46,p=47,i=92,D=58,g=63;class S extends Error{constructor(l,s,t){let n;typeof s=="string"&&s.indexOf("not ")===0?(n="must not be",s=s.replace(/^not /,"")):n="must be";const o=l.indexOf(".")!==-1?"property":"argument";let u=`The "${l}" ${o} ${n} of type ${s}`;u+=`. Received type ${typeof t}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function v(c,l){if(typeof c!="string")throw new S(l,"string",c)}function d(c){return c===p||c===i}function w(c){return c===p}function I(c){return c>=L&&c<=y||c>=k&&c<=P}function b(c,l,s,t){let n="",o=0,u=-1,h=0,f=0;for(let E=0;E<=c.length;++E){if(E<c.length)f=c.charCodeAt(E);else{if(t(f))break;f=p}if(t(f)){if(!(u===E-1||h===1))if(h===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==r||n.charCodeAt(n.length-2)!==r){if(n.length>2){const A=n.lastIndexOf(s);A===-1?(n="",o=0):(n=n.slice(0,A),o=n.length-1-n.lastIndexOf(s)),u=E,h=0;continue}else if(n.length!==0){n="",o=0,u=E,h=0;continue}}l&&(n+=n.length>0?`${s}..`:"..",o=2)}else n.length>0?n+=`${s}${c.slice(u+1,E)}`:n=c.slice(u+1,E),o=E-u-1;u=E,h=0}else f===r&&h!==-1?++h:h=-1}return n}function a(c,l){if(l===null||typeof l!="object")throw new S("pathObject","Object",l);const s=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return s?s===l.root?`${s}${t}`:`${s}${c}${t}`:t}e.win32={resolve(...c){let l="",s="",t=!1;for(let n=c.length-1;n>=-1;n--){let o;if(n>=0){if(o=c[n],v(o,"path"),o.length===0)continue}else l.length===0?o=m.cwd():(o=m.env[`=${l}`]||m.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==l.toLowerCase()&&o.charCodeAt(2)===i)&&(o=`${l}\\`));const u=o.length;let h=0,f="",E=!1;const A=o.charCodeAt(0);if(u===1)d(A)&&(h=1,E=!0);else if(d(A))if(E=!0,d(o.charCodeAt(1))){let _=2,U=_;for(;_<u&&!d(o.charCodeAt(_));)_++;if(_<u&&_!==U){const H=o.slice(U,_);for(U=_;_<u&&d(o.charCodeAt(_));)_++;if(_<u&&_!==U){for(U=_;_<u&&!d(o.charCodeAt(_));)_++;(_===u||_!==U)&&(f=`\\\\${H}\\${o.slice(U,_)}`,h=_)}}}else h=1;else I(A)&&o.charCodeAt(1)===D&&(f=o.slice(0,2),h=2,u>2&&d(o.charCodeAt(2))&&(E=!0,h=3));if(f.length>0)if(l.length>0){if(f.toLowerCase()!==l.toLowerCase())continue}else l=f;if(t){if(l.length>0)break}else if(s=`${o.slice(h)}\\${s}`,t=E,E&&l.length>0)break}return s=b(s,!t,"\\",d),t?`${l}\\${s}`:`${l}${s}`||"."},normalize(c){v(c,"path");const l=c.length;if(l===0)return".";let s=0,t,n=!1;const o=c.charCodeAt(0);if(l===1)return w(o)?"\\":c;if(d(o))if(n=!0,d(c.charCodeAt(1))){let h=2,f=h;for(;h<l&&!d(c.charCodeAt(h));)h++;if(h<l&&h!==f){const E=c.slice(f,h);for(f=h;h<l&&d(c.charCodeAt(h));)h++;if(h<l&&h!==f){for(f=h;h<l&&!d(c.charCodeAt(h));)h++;if(h===l)return`\\\\${E}\\${c.slice(f)}\\`;h!==f&&(t=`\\\\${E}\\${c.slice(f,h)}`,s=h)}}}else s=1;else I(o)&&c.charCodeAt(1)===D&&(t=c.slice(0,2),s=2,l>2&&d(c.charCodeAt(2))&&(n=!0,s=3));let u=s<l?b(c.slice(s),!n,"\\",d):"";return u.length===0&&!n&&(u="."),u.length>0&&d(c.charCodeAt(l-1))&&(u+="\\"),t===void 0?n?`\\${u}`:u:n?`${t}\\${u}`:`${t}${u}`},isAbsolute(c){v(c,"path");const l=c.length;if(l===0)return!1;const s=c.charCodeAt(0);return d(s)||l>2&&I(s)&&c.charCodeAt(1)===D&&d(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let l,s;for(let o=0;o<c.length;++o){const u=c[o];v(u,"path"),u.length>0&&(l===void 0?l=s=u:l+=`\\${u}`)}if(l===void 0)return".";let t=!0,n=0;if(typeof s=="string"&&d(s.charCodeAt(0))){++n;const o=s.length;o>1&&d(s.charCodeAt(1))&&(++n,o>2&&(d(s.charCodeAt(2))?++n:t=!1))}if(t){for(;n<l.length&&d(l.charCodeAt(n));)n++;n>=2&&(l=`\\${l.slice(n)}`)}return e.win32.normalize(l)},relative(c,l){if(v(c,"from"),v(l,"to"),c===l)return"";const s=e.win32.resolve(c),t=e.win32.resolve(l);if(s===t||(c=s.toLowerCase(),l=t.toLowerCase(),c===l))return"";let n=0;for(;n<c.length&&c.charCodeAt(n)===i;)n++;let o=c.length;for(;o-1>n&&c.charCodeAt(o-1)===i;)o--;const u=o-n;let h=0;for(;h<l.length&&l.charCodeAt(h)===i;)h++;let f=l.length;for(;f-1>h&&l.charCodeAt(f-1)===i;)f--;const E=f-h,A=u<E?u:E;let _=-1,U=0;for(;U<A;U++){const Q=c.charCodeAt(n+U);if(Q!==l.charCodeAt(h+U))break;Q===i&&(_=U)}if(U!==A){if(_===-1)return t}else{if(E>A){if(l.charCodeAt(h+U)===i)return t.slice(h+U+1);if(U===2)return t.slice(h+U)}u>A&&(c.charCodeAt(n+U)===i?_=U:U===2&&(_=3)),_===-1&&(_=0)}let H="";for(U=n+_+1;U<=o;++U)(U===o||c.charCodeAt(U)===i)&&(H+=H.length===0?"..":"\\..");return h+=_,H.length>0?`${H}${t.slice(h,f)}`:(t.charCodeAt(h)===i&&++h,t.slice(h,f))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const l=e.win32.resolve(c);if(l.length<=2)return c;if(l.charCodeAt(0)===i){if(l.charCodeAt(1)===i){const s=l.charCodeAt(2);if(s!==g&&s!==r)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(I(l.charCodeAt(0))&&l.charCodeAt(1)===D&&l.charCodeAt(2)===i)return`\\\\?\\${l}`;return c},dirname(c){v(c,"path");const l=c.length;if(l===0)return".";let s=-1,t=0;const n=c.charCodeAt(0);if(l===1)return d(n)?c:".";if(d(n)){if(s=t=1,d(c.charCodeAt(1))){let h=2,f=h;for(;h<l&&!d(c.charCodeAt(h));)h++;if(h<l&&h!==f){for(f=h;h<l&&d(c.charCodeAt(h));)h++;if(h<l&&h!==f){for(f=h;h<l&&!d(c.charCodeAt(h));)h++;if(h===l)return c;h!==f&&(s=t=h+1)}}}}else I(n)&&c.charCodeAt(1)===D&&(s=l>2&&d(c.charCodeAt(2))?3:2,t=s);let o=-1,u=!0;for(let h=l-1;h>=t;--h)if(d(c.charCodeAt(h))){if(!u){o=h;break}}else u=!1;if(o===-1){if(s===-1)return".";o=s}return c.slice(0,o)},basename(c,l){l!==void 0&&v(l,"ext"),v(c,"path");let s=0,t=-1,n=!0,o;if(c.length>=2&&I(c.charCodeAt(0))&&c.charCodeAt(1)===D&&(s=2),l!==void 0&&l.length>0&&l.length<=c.length){if(l===c)return"";let u=l.length-1,h=-1;for(o=c.length-1;o>=s;--o){const f=c.charCodeAt(o);if(d(f)){if(!n){s=o+1;break}}else h===-1&&(n=!1,h=o+1),u>=0&&(f===l.charCodeAt(u)?--u==-1&&(t=o):(u=-1,t=h))}return s===t?t=h:t===-1&&(t=c.length),c.slice(s,t)}for(o=c.length-1;o>=s;--o)if(d(c.charCodeAt(o))){if(!n){s=o+1;break}}else t===-1&&(n=!1,t=o+1);return t===-1?"":c.slice(s,t)},extname(c){v(c,"path");let l=0,s=-1,t=0,n=-1,o=!0,u=0;c.length>=2&&c.charCodeAt(1)===D&&I(c.charCodeAt(0))&&(l=t=2);for(let h=c.length-1;h>=l;--h){const f=c.charCodeAt(h);if(d(f)){if(!o){t=h+1;break}continue}n===-1&&(o=!1,n=h+1),f===r?s===-1?s=h:u!==1&&(u=1):s!==-1&&(u=-1)}return s===-1||n===-1||u===0||u===1&&s===n-1&&s===t+1?"":c.slice(s,n)},format:a.bind(null,"\\"),parse(c){v(c,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return l;const s=c.length;let t=0,n=c.charCodeAt(0);if(s===1)return d(n)?(l.root=l.dir=c,l):(l.base=l.name=c,l);if(d(n)){if(t=1,d(c.charCodeAt(1))){let _=2,U=_;for(;_<s&&!d(c.charCodeAt(_));)_++;if(_<s&&_!==U){for(U=_;_<s&&d(c.charCodeAt(_));)_++;if(_<s&&_!==U){for(U=_;_<s&&!d(c.charCodeAt(_));)_++;_===s?t=_:_!==U&&(t=_+1)}}}}else if(I(n)&&c.charCodeAt(1)===D){if(s<=2)return l.root=l.dir=c,l;if(t=2,d(c.charCodeAt(2))){if(s===3)return l.root=l.dir=c,l;t=3}}t>0&&(l.root=c.slice(0,t));let o=-1,u=t,h=-1,f=!0,E=c.length-1,A=0;for(;E>=t;--E){if(n=c.charCodeAt(E),d(n)){if(!f){u=E+1;break}continue}h===-1&&(f=!1,h=E+1),n===r?o===-1?o=E:A!==1&&(A=1):o!==-1&&(A=-1)}return h!==-1&&(o===-1||A===0||A===1&&o===h-1&&o===u+1?l.base=l.name=c.slice(u,h):(l.name=c.slice(u,o),l.base=c.slice(u,h),l.ext=c.slice(o,h))),u>0&&u!==t?l.dir=c.slice(0,u-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let l="",s=!1;for(let t=c.length-1;t>=-1&&!s;t--){const n=t>=0?c[t]:m.cwd();v(n,"path"),n.length!==0&&(l=`${n}/${l}`,s=n.charCodeAt(0)===p)}return l=b(l,!s,"/",w),s?`/${l}`:l.length>0?l:"."},normalize(c){if(v(c,"path"),c.length===0)return".";const l=c.charCodeAt(0)===p,s=c.charCodeAt(c.length-1)===p;return c=b(c,!l,"/",w),c.length===0?l?"/":s?"./":".":(s&&(c+="/"),l?`/${c}`:c)},isAbsolute(c){return v(c,"path"),c.length>0&&c.charCodeAt(0)===p},join(...c){if(c.length===0)return".";let l;for(let s=0;s<c.length;++s){const t=c[s];v(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(c,l){if(v(c,"from"),v(l,"to"),c===l||(c=e.posix.resolve(c),l=e.posix.resolve(l),c===l))return"";const s=1,t=c.length,n=t-s,o=1,u=l.length-o,h=n<u?n:u;let f=-1,E=0;for(;E<h;E++){const _=c.charCodeAt(s+E);if(_!==l.charCodeAt(o+E))break;_===p&&(f=E)}if(E===h)if(u>h){if(l.charCodeAt(o+E)===p)return l.slice(o+E+1);if(E===0)return l.slice(o+E)}else n>h&&(c.charCodeAt(s+E)===p?f=E:E===0&&(f=0));let A="";for(E=s+f+1;E<=t;++E)(E===t||c.charCodeAt(E)===p)&&(A+=A.length===0?"..":"/..");return`${A}${l.slice(o+f)}`},toNamespacedPath(c){return c},dirname(c){if(v(c,"path"),c.length===0)return".";const l=c.charCodeAt(0)===p;let s=-1,t=!0;for(let n=c.length-1;n>=1;--n)if(c.charCodeAt(n)===p){if(!t){s=n;break}}else t=!1;return s===-1?l?"/":".":l&&s===1?"//":c.slice(0,s)},basename(c,l){l!==void 0&&v(l,"ext"),v(c,"path");let s=0,t=-1,n=!0,o;if(l!==void 0&&l.length>0&&l.length<=c.length){if(l===c)return"";let u=l.length-1,h=-1;for(o=c.length-1;o>=0;--o){const f=c.charCodeAt(o);if(f===p){if(!n){s=o+1;break}}else h===-1&&(n=!1,h=o+1),u>=0&&(f===l.charCodeAt(u)?--u==-1&&(t=o):(u=-1,t=h))}return s===t?t=h:t===-1&&(t=c.length),c.slice(s,t)}for(o=c.length-1;o>=0;--o)if(c.charCodeAt(o)===p){if(!n){s=o+1;break}}else t===-1&&(n=!1,t=o+1);return t===-1?"":c.slice(s,t)},extname(c){v(c,"path");let l=-1,s=0,t=-1,n=!0,o=0;for(let u=c.length-1;u>=0;--u){const h=c.charCodeAt(u);if(h===p){if(!n){s=u+1;break}continue}t===-1&&(n=!1,t=u+1),h===r?l===-1?l=u:o!==1&&(o=1):l!==-1&&(o=-1)}return l===-1||t===-1||o===0||o===1&&l===t-1&&l===s+1?"":c.slice(l,t)},format:a.bind(null,"/"),parse(c){v(c,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return l;const s=c.charCodeAt(0)===p;let t;s?(l.root="/",t=1):t=0;let n=-1,o=0,u=-1,h=!0,f=c.length-1,E=0;for(;f>=t;--f){const A=c.charCodeAt(f);if(A===p){if(!h){o=f+1;break}continue}u===-1&&(h=!1,u=f+1),A===r?n===-1?n=f:E!==1&&(E=1):n!==-1&&(E=-1)}if(u!==-1){const A=o===0&&s?1:o;n===-1||E===0||E===1&&n===u-1&&n===o+1?l.base=l.name=c.slice(A,u):(l.name=c.slice(A,n),l.base=c.slice(A,u),l.ext=c.slice(n,u))}return o>0?l.dir=c.slice(0,o-1):s&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(X[79],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var m;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.None=0]="None",r[r.Hyper=1]="Hyper",r[r.Super=2]="Super",r[r.Fn=3]="Fn",r[r.FnLock=4]="FnLock",r[r.Suspend=5]="Suspend",r[r.Resume=6]="Resume",r[r.Turbo=7]="Turbo",r[r.Sleep=8]="Sleep",r[r.WakeUp=9]="WakeUp",r[r.KeyA=10]="KeyA",r[r.KeyB=11]="KeyB",r[r.KeyC=12]="KeyC",r[r.KeyD=13]="KeyD",r[r.KeyE=14]="KeyE",r[r.KeyF=15]="KeyF",r[r.KeyG=16]="KeyG",r[r.KeyH=17]="KeyH",r[r.KeyI=18]="KeyI",r[r.KeyJ=19]="KeyJ",r[r.KeyK=20]="KeyK",r[r.KeyL=21]="KeyL",r[r.KeyM=22]="KeyM",r[r.KeyN=23]="KeyN",r[r.KeyO=24]="KeyO",r[r.KeyP=25]="KeyP",r[r.KeyQ=26]="KeyQ",r[r.KeyR=27]="KeyR",r[r.KeyS=28]="KeyS",r[r.KeyT=29]="KeyT",r[r.KeyU=30]="KeyU",r[r.KeyV=31]="KeyV",r[r.KeyW=32]="KeyW",r[r.KeyX=33]="KeyX",r[r.KeyY=34]="KeyY",r[r.KeyZ=35]="KeyZ",r[r.Digit1=36]="Digit1",r[r.Digit2=37]="Digit2",r[r.Digit3=38]="Digit3",r[r.Digit4=39]="Digit4",r[r.Digit5=40]="Digit5",r[r.Digit6=41]="Digit6",r[r.Digit7=42]="Digit7",r[r.Digit8=43]="Digit8",r[r.Digit9=44]="Digit9",r[r.Digit0=45]="Digit0",r[r.Enter=46]="Enter",r[r.Escape=47]="Escape",r[r.Backspace=48]="Backspace",r[r.Tab=49]="Tab",r[r.Space=50]="Space",r[r.Minus=51]="Minus",r[r.Equal=52]="Equal",r[r.BracketLeft=53]="BracketLeft",r[r.BracketRight=54]="BracketRight",r[r.Backslash=55]="Backslash",r[r.IntlHash=56]="IntlHash",r[r.Semicolon=57]="Semicolon",r[r.Quote=58]="Quote",r[r.Backquote=59]="Backquote",r[r.Comma=60]="Comma",r[r.Period=61]="Period",r[r.Slash=62]="Slash",r[r.CapsLock=63]="CapsLock",r[r.F1=64]="F1",r[r.F2=65]="F2",r[r.F3=66]="F3",r[r.F4=67]="F4",r[r.F5=68]="F5",r[r.F6=69]="F6",r[r.F7=70]="F7",r[r.F8=71]="F8",r[r.F9=72]="F9",r[r.F10=73]="F10",r[r.F11=74]="F11",r[r.F12=75]="F12",r[r.PrintScreen=76]="PrintScreen",r[r.ScrollLock=77]="ScrollLock",r[r.Pause=78]="Pause",r[r.Insert=79]="Insert",r[r.Home=80]="Home",r[r.PageUp=81]="PageUp",r[r.Delete=82]="Delete",r[r.End=83]="End",r[r.PageDown=84]="PageDown",r[r.ArrowRight=85]="ArrowRight",r[r.ArrowLeft=86]="ArrowLeft",r[r.ArrowDown=87]="ArrowDown",r[r.ArrowUp=88]="ArrowUp",r[r.NumLock=89]="NumLock",r[r.NumpadDivide=90]="NumpadDivide",r[r.NumpadMultiply=91]="NumpadMultiply",r[r.NumpadSubtract=92]="NumpadSubtract",r[r.NumpadAdd=93]="NumpadAdd",r[r.NumpadEnter=94]="NumpadEnter",r[r.Numpad1=95]="Numpad1",r[r.Numpad2=96]="Numpad2",r[r.Numpad3=97]="Numpad3",r[r.Numpad4=98]="Numpad4",r[r.Numpad5=99]="Numpad5",r[r.Numpad6=100]="Numpad6",r[r.Numpad7=101]="Numpad7",r[r.Numpad8=102]="Numpad8",r[r.Numpad9=103]="Numpad9",r[r.Numpad0=104]="Numpad0",r[r.NumpadDecimal=105]="NumpadDecimal",r[r.IntlBackslash=106]="IntlBackslash",r[r.ContextMenu=107]="ContextMenu",r[r.Power=108]="Power",r[r.NumpadEqual=109]="NumpadEqual",r[r.F13=110]="F13",r[r.F14=111]="F14",r[r.F15=112]="F15",r[r.F16=113]="F16",r[r.F17=114]="F17",r[r.F18=115]="F18",r[r.F19=116]="F19",r[r.F20=117]="F20",r[r.F21=118]="F21",r[r.F22=119]="F22",r[r.F23=120]="F23",r[r.F24=121]="F24",r[r.Open=122]="Open",r[r.Help=123]="Help",r[r.Select=124]="Select",r[r.Again=125]="Again",r[r.Undo=126]="Undo",r[r.Cut=127]="Cut",r[r.Copy=128]="Copy",r[r.Paste=129]="Paste",r[r.Find=130]="Find",r[r.AudioVolumeMute=131]="AudioVolumeMute",r[r.AudioVolumeUp=132]="AudioVolumeUp",r[r.AudioVolumeDown=133]="AudioVolumeDown",r[r.NumpadComma=134]="NumpadComma",r[r.IntlRo=135]="IntlRo",r[r.KanaMode=136]="KanaMode",r[r.IntlYen=137]="IntlYen",r[r.Convert=138]="Convert",r[r.NonConvert=139]="NonConvert",r[r.Lang1=140]="Lang1",r[r.Lang2=141]="Lang2",r[r.Lang3=142]="Lang3",r[r.Lang4=143]="Lang4",r[r.Lang5=144]="Lang5",r[r.Abort=145]="Abort",r[r.Props=146]="Props",r[r.NumpadParenLeft=147]="NumpadParenLeft",r[r.NumpadParenRight=148]="NumpadParenRight",r[r.NumpadBackspace=149]="NumpadBackspace",r[r.NumpadMemoryStore=150]="NumpadMemoryStore",r[r.NumpadMemoryRecall=151]="NumpadMemoryRecall",r[r.NumpadMemoryClear=152]="NumpadMemoryClear",r[r.NumpadMemoryAdd=153]="NumpadMemoryAdd",r[r.NumpadMemorySubtract=154]="NumpadMemorySubtract",r[r.NumpadClear=155]="NumpadClear",r[r.NumpadClearEntry=156]="NumpadClearEntry",r[r.ControlLeft=157]="ControlLeft",r[r.ShiftLeft=158]="ShiftLeft",r[r.AltLeft=159]="AltLeft",r[r.MetaLeft=160]="MetaLeft",r[r.ControlRight=161]="ControlRight",r[r.ShiftRight=162]="ShiftRight",r[r.AltRight=163]="AltRight",r[r.MetaRight=164]="MetaRight",r[r.BrightnessUp=165]="BrightnessUp",r[r.BrightnessDown=166]="BrightnessDown",r[r.MediaPlay=167]="MediaPlay",r[r.MediaRecord=168]="MediaRecord",r[r.MediaFastForward=169]="MediaFastForward",r[r.MediaRewind=170]="MediaRewind",r[r.MediaTrackNext=171]="MediaTrackNext",r[r.MediaTrackPrevious=172]="MediaTrackPrevious",r[r.MediaStop=173]="MediaStop",r[r.Eject=174]="Eject",r[r.MediaPlayPause=175]="MediaPlayPause",r[r.MediaSelect=176]="MediaSelect",r[r.LaunchMail=177]="LaunchMail",r[r.LaunchApp2=178]="LaunchApp2",r[r.LaunchApp1=179]="LaunchApp1",r[r.SelectTask=180]="SelectTask",r[r.LaunchScreenSaver=181]="LaunchScreenSaver",r[r.BrowserSearch=182]="BrowserSearch",r[r.BrowserHome=183]="BrowserHome",r[r.BrowserBack=184]="BrowserBack",r[r.BrowserForward=185]="BrowserForward",r[r.BrowserStop=186]="BrowserStop",r[r.BrowserRefresh=187]="BrowserRefresh",r[r.BrowserFavorites=188]="BrowserFavorites",r[r.ZoomToggle=189]="ZoomToggle",r[r.MailReply=190]="MailReply",r[r.MailForward=191]="MailForward",r[r.MailSend=192]="MailSend",r[r.MAX_VALUE=193]="MAX_VALUE"})(m=e.ScanCode||(e.ScanCode={}));const L=[],k=Object.create(null),y=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:r=>y[r]||0,toEnum:r=>k[r]||0,toString:r=>L[r]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class P{constructor(p,i,D,g,S){this.ctrlKey=p,this.shiftKey=i,this.altKey=D,this.metaKey=g,this.scanCode=S}equals(p){return this.ctrlKey===p.ctrlKey&&this.shiftKey===p.shiftKey&&this.altKey===p.altKey&&this.metaKey===p.metaKey&&this.scanCode===p.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=P,function(){function r(p,i){L[p]=i,k[i]=p,y[i.toLowerCase()]=p}r(0,"None"),r(1,"Hyper"),r(2,"Super"),r(3,"Fn"),r(4,"FnLock"),r(5,"Suspend"),r(6,"Resume"),r(7,"Turbo"),r(8,"Sleep"),r(9,"WakeUp"),r(10,"KeyA"),r(11,"KeyB"),r(12,"KeyC"),r(13,"KeyD"),r(14,"KeyE"),r(15,"KeyF"),r(16,"KeyG"),r(17,"KeyH"),r(18,"KeyI"),r(19,"KeyJ"),r(20,"KeyK"),r(21,"KeyL"),r(22,"KeyM"),r(23,"KeyN"),r(24,"KeyO"),r(25,"KeyP"),r(26,"KeyQ"),r(27,"KeyR"),r(28,"KeyS"),r(29,"KeyT"),r(30,"KeyU"),r(31,"KeyV"),r(32,"KeyW"),r(33,"KeyX"),r(34,"KeyY"),r(35,"KeyZ"),r(36,"Digit1"),r(37,"Digit2"),r(38,"Digit3"),r(39,"Digit4"),r(40,"Digit5"),r(41,"Digit6"),r(42,"Digit7"),r(43,"Digit8"),r(44,"Digit9"),r(45,"Digit0"),r(46,"Enter"),r(47,"Escape"),r(48,"Backspace"),r(49,"Tab"),r(50,"Space"),r(51,"Minus"),r(52,"Equal"),r(53,"BracketLeft"),r(54,"BracketRight"),r(55,"Backslash"),r(56,"IntlHash"),r(57,"Semicolon"),r(58,"Quote"),r(59,"Backquote"),r(60,"Comma"),r(61,"Period"),r(62,"Slash"),r(63,"CapsLock"),r(64,"F1"),r(65,"F2"),r(66,"F3"),r(67,"F4"),r(68,"F5"),r(69,"F6"),r(70,"F7"),r(71,"F8"),r(72,"F9"),r(73,"F10"),r(74,"F11"),r(75,"F12"),r(76,"PrintScreen"),r(77,"ScrollLock"),r(78,"Pause"),r(79,"Insert"),r(80,"Home"),r(81,"PageUp"),r(82,"Delete"),r(83,"End"),r(84,"PageDown"),r(85,"ArrowRight"),r(86,"ArrowLeft"),r(87,"ArrowDown"),r(88,"ArrowUp"),r(89,"NumLock"),r(90,"NumpadDivide"),r(91,"NumpadMultiply"),r(92,"NumpadSubtract"),r(93,"NumpadAdd"),r(94,"NumpadEnter"),r(95,"Numpad1"),r(96,"Numpad2"),r(97,"Numpad3"),r(98,"Numpad4"),r(99,"Numpad5"),r(100,"Numpad6"),r(101,"Numpad7"),r(102,"Numpad8"),r(103,"Numpad9"),r(104,"Numpad0"),r(105,"NumpadDecimal"),r(106,"IntlBackslash"),r(107,"ContextMenu"),r(108,"Power"),r(109,"NumpadEqual"),r(110,"F13"),r(111,"F14"),r(112,"F15"),r(113,"F16"),r(114,"F17"),r(115,"F18"),r(116,"F19"),r(117,"F20"),r(118,"F21"),r(119,"F22"),r(120,"F23"),r(121,"F24"),r(122,"Open"),r(123,"Help"),r(124,"Select"),r(125,"Again"),r(126,"Undo"),r(127,"Cut"),r(128,"Copy"),r(129,"Paste"),r(130,"Find"),r(131,"AudioVolumeMute"),r(132,"AudioVolumeUp"),r(133,"AudioVolumeDown"),r(134,"NumpadComma"),r(135,"IntlRo"),r(136,"KanaMode"),r(137,"IntlYen"),r(138,"Convert"),r(139,"NonConvert"),r(140,"Lang1"),r(141,"Lang2"),r(142,"Lang3"),r(143,"Lang4"),r(144,"Lang5"),r(145,"Abort"),r(146,"Props"),r(147,"NumpadParenLeft"),r(148,"NumpadParenRight"),r(149,"NumpadBackspace"),r(150,"NumpadMemoryStore"),r(151,"NumpadMemoryRecall"),r(152,"NumpadMemoryClear"),r(153,"NumpadMemoryAdd"),r(154,"NumpadMemorySubtract"),r(155,"NumpadClear"),r(156,"NumpadClearEntry"),r(157,"ControlLeft"),r(158,"ShiftLeft"),r(159,"AltLeft"),r(160,"MetaLeft"),r(161,"ControlRight"),r(162,"ShiftRight"),r(163,"AltRight"),r(164,"MetaRight"),r(165,"BrightnessUp"),r(166,"BrightnessDown"),r(167,"MediaPlay"),r(168,"MediaRecord"),r(169,"MediaFastForward"),r(170,"MediaRewind"),r(171,"MediaTrackNext"),r(172,"MediaTrackPrevious"),r(173,"MediaStop"),r(174,"Eject"),r(175,"MediaPlayPause"),r(176,"MediaSelect"),r(177,"LaunchMail"),r(178,"LaunchApp2"),r(179,"LaunchApp1"),r(180,"SelectTask"),r(181,"LaunchScreenSaver"),r(182,"BrowserSearch"),r(183,"BrowserHome"),r(184,"BrowserBack"),r(185,"BrowserForward"),r(186,"BrowserStop"),r(187,"BrowserRefresh"),r(188,"BrowserFavorites"),r(189,"ZoomToggle"),r(190,"MailReply"),r(191,"MailForward"),r(192,"MailSend")}(),function(){for(let p=0;p<=193;p++)e.IMMUTABLE_CODE_TO_KEY_CODE[p]=-1;for(let p=0;p<=112;p++)e.IMMUTABLE_KEY_CODE_TO_CODE[p]=-1;function r(p,i){e.IMMUTABLE_CODE_TO_KEY_CODE[p]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[i]=p)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,r(0,0),r(1,0),r(2,0),r(3,0),r(4,0),r(5,0),r(6,0),r(7,0),r(8,0),r(9,0),r(46,3),r(47,9),r(48,1),r(49,2),r(50,10),r(63,8),r(64,59),r(65,60),r(66,61),r(67,62),r(68,63),r(69,64),r(70,65),r(71,66),r(72,67),r(73,68),r(74,69),r(75,70),r(76,0),r(77,79),r(78,7),r(79,19),r(80,14),r(81,11),r(82,20),r(83,13),r(84,12),r(85,17),r(86,15),r(87,18),r(88,16),r(89,78),r(90,108),r(91,103),r(92,106),r(93,104),r(94,3),r(95,94),r(96,95),r(97,96),r(98,97),r(99,98),r(100,99),r(101,100),r(102,101),r(103,102),r(104,93),r(105,107),r(107,58),r(108,0),r(109,0),r(110,71),r(111,72),r(112,73),r(113,74),r(114,75),r(115,76),r(116,77),r(117,0),r(118,0),r(119,0),r(120,0),r(121,0),r(122,0),r(123,0),r(124,0),r(125,0),r(126,0),r(127,0),r(128,0),r(129,0),r(130,0),r(131,0),r(132,0),r(133,0),r(134,105),r(136,0),r(138,0),r(139,0),r(140,0),r(141,0),r(142,0),r(143,0),r(144,0),r(145,0),r(146,0),r(147,0),r(148,0),r(149,0),r(150,0),r(151,0),r(152,0),r(153,0),r(154,0),r(155,0),r(156,0),r(157,5),r(158,4),r(159,6),r(160,57),r(161,5),r(162,4),r(163,6),r(164,57),r(165,0),r(166,0),r(167,0),r(168,0),r(169,0),r(170,0),r(171,0),r(172,0),r(173,0),r(174,0),r(175,0),r(176,0),r(177,0),r(178,0),r(179,0),r(180,0),r(181,0),r(182,0),r(183,0),r(184,0),r(185,0),r(186,0),r(187,0),r(188,0),r(189,0),r(190,0),r(191,0),r(192,0)}()}),define(X[103],J([0,1,57,79]),function(q,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class k{static _readModifiers(P){P=P.toLowerCase().trim();let r=!1,p=!1,i=!1,D=!1,g;do g=!1,/^ctrl(\+|\-)/.test(P)&&(r=!0,P=P.substr("ctrl-".length),g=!0),/^shift(\+|\-)/.test(P)&&(p=!0,P=P.substr("shift-".length),g=!0),/^alt(\+|\-)/.test(P)&&(i=!0,P=P.substr("alt-".length),g=!0),/^meta(\+|\-)/.test(P)&&(D=!0,P=P.substr("meta-".length),g=!0),/^win(\+|\-)/.test(P)&&(D=!0,P=P.substr("win-".length),g=!0),/^cmd(\+|\-)/.test(P)&&(D=!0,P=P.substr("cmd-".length),g=!0);while(g);let S;const v=P.indexOf(" ");return v>0?(S=P.substring(0,v),P=P.substring(v)):(S=P,P=""),{remains:P,ctrl:r,shift:p,alt:i,meta:D,key:S}}static parseSimpleKeybinding(P){const r=this._readModifiers(P),p=m.KeyCodeUtils.fromUserSettings(r.key);return[new m.SimpleKeybinding(r.ctrl,r.shift,r.alt,r.meta,p),r.remains]}static parseKeybinding(P,r){if(!P)return null;const p=[];let i;do[i,P]=this.parseSimpleKeybinding(P),p.push(i);while(P.length>0);return new m.ChordKeybinding(p)}static parseSimpleUserBinding(P){const r=this._readModifiers(P),p=r.key.match(/^\[([^\]]+)\]$/);if(p){const D=p[1],g=L.ScanCodeUtils.lowerCaseToEnum(D);return[new L.ScanCodeBinding(r.ctrl,r.shift,r.alt,r.meta,g),r.remains]}const i=m.KeyCodeUtils.fromUserSettings(r.key);return[new m.SimpleKeybinding(r.ctrl,r.shift,r.alt,r.meta,i),r.remains]}static parseUserBinding(P){if(!P)return[];const r=[];let p;for(;P.length>0;)[p,P]=this.parseSimpleUserBinding(P),r.push(p);return r}}e.KeybindingParser=k}),define(X[104],J([0,1,3]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=m.globals.performance&&typeof m.globals.performance.now=="function";class k{constructor(P){this._highResolution=L&&P,this._startTime=this._now(),this._stopTime=-1}static create(P=!0){return new k(P)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=k}),define(X[5],J([0,1,17,42,2,78,104]),function(q,e,m,L,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var r;(function(b){b.None=()=>k.Disposable.None;function a(O){return($,z=null,C)=>{let j=!1,N;return N=O(T=>{if(!j)return N?N.dispose():j=!0,$.call(z,T)},null,C),j&&N.dispose(),N}}b.once=a;function c(O,$){return u((z,C=null,j)=>O(N=>z.call(C,$(N)),null,j))}b.map=c;function l(O,$){return u((z,C=null,j)=>O(N=>{$(N),z.call(C,N)},null,j))}b.forEach=l;function s(O,$){return u((z,C=null,j)=>O(N=>$(N)&&z.call(C,N),null,j))}b.filter=s;function t(O){return O}b.signal=t;function n(...O){return($,z=null,C)=>(0,k.combinedDisposable)(...O.map(j=>j(N=>$.call(z,N),null,C)))}b.any=n;function o(O,$,z){let C=z;return c(O,j=>(C=$(C,j),C))}b.reduce=o;function u(O){let $;const z=new S({onFirstListenerAdd(){$=O(z.fire,z)},onLastListenerRemove(){$.dispose()}});return z.event}b.snapshot=u;function h(O,$,z=100,C=!1,j){let N,T,R,W=0;const M=new S({leakWarningThreshold:j,onFirstListenerAdd(){N=O(F=>{W++,T=$(T,F),C&&!R&&(M.fire(T),T=void 0),clearTimeout(R),R=setTimeout(()=>{const B=T;T=void 0,R=void 0,(!C||W>1)&&M.fire(B),W=0},z)})},onLastListenerRemove(){N.dispose()}});return M.event}b.debounce=h;function f(O){const $=new Date().getTime();return c(a(O),z=>new Date().getTime()-$)}b.stopwatch=f;function E(O){let $=!0,z;return s(O,C=>{const j=$||C!==z;return $=!1,z=C,j})}b.latch=E;function A(O,$=!1,z=[]){let C=z.slice(),j=O(R=>{C?C.push(R):T.fire(R)});const N=()=>{C&&C.forEach(R=>T.fire(R)),C=null},T=new S({onFirstListenerAdd(){j||(j=O(R=>T.fire(R)))},onFirstListenerDidAdd(){C&&($?setTimeout(N):N())},onLastListenerRemove(){j&&j.dispose(),j=null}});return T.event}b.buffer=A;class _{constructor($){this.event=$}map($){return new _(c(this.event,$))}forEach($){return new _(l(this.event,$))}filter($){return new _(s(this.event,$))}reduce($,z){return new _(o(this.event,$,z))}latch(){return new _(E(this.event))}debounce($,z=100,C=!1,j){return new _(h(this.event,$,z,C,j))}on($,z,C){return this.event($,z,C)}once($,z,C){return a(this.event)($,z,C)}}function U(O){return new _(O)}b.chain=U;function H(O,$,z=C=>C){const C=(...R)=>T.fire(z(...R)),j=()=>O.on($,C),N=()=>O.removeListener($,C),T=new S({onFirstListenerAdd:j,onLastListenerRemove:N});return T.event}b.fromNodeEventEmitter=H;function Q(O,$,z=C=>C){const C=(...R)=>T.fire(z(...R)),j=()=>O.addEventListener($,C),N=()=>O.removeEventListener($,C),T=new S({onFirstListenerAdd:j,onLastListenerRemove:N});return T.event}b.fromDOMEventEmitter=Q;function ne(O){const $=new S;let z=!1;return O.then(void 0,()=>null).then(()=>{z?$.fire(void 0):setTimeout(()=>$.fire(void 0),0)}),z=!0,$.event}b.fromPromise=ne;function ae(O){return new Promise($=>a(O)($))}b.toPromise=ae})(r=e.Event||(e.Event={}));class p{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${p._idPool++}`}start(a){this._stopWatch=new P.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}p._idPool=0;let i=-1;function D(b){const a=i;return i=b,{dispose(){i=a}}}e.setGlobalLeakWarningThreshold=D;class g{constructor(a,c=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let c=i;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),!(c<=0||a<c)){this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(l)||0;if(this._stacks.set(l,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let t,n=0;for(const[o,u]of this._stacks)(!t||n<u)&&(t=o,n=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(l)||0;this._stacks.set(l,t-1)}}}}class S{constructor(a){var c;this._disposed=!1,this._options=a,this._leakageMon=i>0?new g(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((c=this._options)===null||c===void 0?void 0:c._profName)?new p(this._options._profName):void 0}get event(){return this._event||(this._event=(a,c,l)=>{var s;this._listeners||(this._listeners=new y.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(c?[a,c]:a);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,c);const o=(s=this._leakageMon)===null||s===void 0?void 0:s.check(this._listeners.size);let u;return u={dispose:()=>{o&&o(),u.dispose=S._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},l instanceof k.DisposableStore?l.add(u):Array.isArray(l)&&l.push(u),u}),this._event}fire(a){var c,l;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,a]);for((c=this._perfMon)===null||c===void 0||c.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,t]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,t):s[0].call(s[1],t)}catch(n){(0,m.onUnexpectedError)(n)}}(l=this._perfMon)===null||l===void 0||l.stop()}}dispose(){var a,c,l;(a=this._listeners)===null||a===void 0||a.clear(),(c=this._deliveryQueue)===null||c===void 0||c.clear(),(l=this._leakageMon)===null||l===void 0||l.dispose(),this._disposed=!0}}e.Emitter=S,S._noop=function(){};class v extends S{constructor(a){super(a);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=a==null?void 0:a.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=v;class d{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new S({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const c={event:a,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const l=()=>{this.hasListeners&&this.unhook(c);const s=this.events.indexOf(c);this.events.splice(s,1)};return(0,k.toDisposable)((0,L.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(c=>this.emitter.fire(c))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=d;class w{constructor(){this.buffers=[]}wrapEvent(a){return(c,l,s)=>a(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>c.call(l,t)):c.call(l,t)},void 0,s)}bufferEvents(a){const c=[];this.buffers.push(c);const l=a();return this.buffers.pop(),c.forEach(s=>s()),l}}e.EventBufferer=w;class I{constructor(){this.listening=!1,this.inputEvent=r.None,this.inputEventListener=k.Disposable.None,this.emitter=new S({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=I}),define(X[25],J([0,1,5]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(r,p){const i=setTimeout(r.bind(p),0);return{dispose(){clearTimeout(i)}}});var k;(function(r){function p(i){return i===r.None||i===r.Cancelled||i instanceof y?!0:!i||typeof i!="object"?!1:typeof i.isCancellationRequested=="boolean"&&typeof i.onCancellationRequested=="function"}r.isCancellationToken=p,r.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),r.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(k=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=k.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=P}),define(X[105],J([0,1,5]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(D){const g=this._icons.get(D.id);g?D.description?g.description=D.description:console.error(`Duplicate registration of codicon ${D.id}`):(this._icons.set(D.id,D),this._onDidRegister.fire(D))}get(D){return this._icons.get(D)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new L;e.iconRegistry=k;function y(i,D){return new P(i,D)}e.registerCodicon=y;class P{constructor(D,g,S){this.id=D,this.definition=g,this.description=S,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function r(i,D){const g=["codicon","codicon-"+i];return D&&g.push("codicon-modifier-"+D),g}e.getClassNamesArray=r;var p;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const D=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function g(d){if(d instanceof P)return["codicon","codicon-"+d.id];const w=D.exec(d.id);if(!w)return g(P.error);let[,I,b]=w;const a=["codicon","codicon-"+I];return b&&a.push("codicon-modifier-"+b.substr(1)),a}i.asClassNameArray=g;function S(d){return g(d).join(" ")}i.asClassName=S;function v(d){return"."+g(d).join(".")}i.asCSSSelector=v})(p=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personAdd=new i("person-add",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(X[63],J([0,1,17,2]),function(q,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(b){const a=b;return a&&[a.on,a.pause,a.resume,a.destroy].every(c=>typeof c=="function")}e.isReadableStream=k;function y(b){const a=b;return a&&k(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean"}e.isReadableBufferedStream=y;function P(b,a){return new r(b,a)}e.newWriteableStream=P;class r{constructor(a,c){this.reducer=a,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){var c;if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof((c=this.options)===null||c===void 0?void 0:c.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(c=>c(a))}emitError(a){this.listeners.error.length===0?(0,m.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(c=>c(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,c){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(a,c){if(!this.state.destroyed){let l;switch(a){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const s=l.indexOf(c);s>=0&&l.splice(s,1)}}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function p(b,a){const c=[];let l;for(;(l=b.read())!==null;)c.push(l);return a(c)}e.consumeReadable=p;function i(b,a,c){const l=[];let s;for(;(s=b.read())!==null&&l.length<c;)l.push(s);return s===null&&l.length>0?a(l):{read:()=>{if(l.length>0)return l.shift();if(typeof s!="undefined"){const t=s;return s=void 0,t}return b.read()}}}e.peekReadable=i;function D(b,a){return new Promise((c,l)=>{const s=[];g(b,{onData:t=>{a&&s.push(t)},onError:t=>{a?l(t):c(void 0)},onEnd:()=>{c(a?a(s):void 0)}})})}e.consumeStream=D;function g(b,a){b.on("error",c=>a.onError(c)),b.on("end",()=>a.onEnd()),b.on("data",c=>a.onData(c))}e.listenStream=g;function S(b,a){return new Promise((c,l)=>{const s=new L.DisposableStore,t=[],n=h=>{if(t.push(h),t.length>a)return s.dispose(),b.pause(),c({stream:b,buffer:t,ended:!1})},o=h=>l(h),u=()=>c({stream:b,buffer:t,ended:!0});s.add((0,L.toDisposable)(()=>b.removeListener("error",o))),b.on("error",o),s.add((0,L.toDisposable)(()=>b.removeListener("end",u))),b.on("end",u),s.add((0,L.toDisposable)(()=>b.removeListener("data",n))),b.on("data",n)})}e.peekStream=S;function v(b,a){const c=P(a);return c.end(b),c}e.toStream=v;function d(){const b=P(()=>{throw new Error("not supported")});return b.end(),b}e.emptyStream=d;function w(b){let a=!1;return{read:()=>a?null:(a=!0,b)}}e.toReadable=w;function I(b,a,c){const l=P(c);return g(b,{onData:s=>l.write(a.data(s)),onError:s=>l.error(a.error?a.error(s):s),onEnd:()=>l.end()}),l}e.transform=I}),define(X[22],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function m(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=m;const L=/{(\d+)}/g;function k(K,...te){return te.length===0?K:K.replace(L,function(oe,le){const de=parseInt(le,10);return isNaN(de)||de<0||de>=te.length?oe:te[de]})}e.format=k;function y(K){return K.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=y;function P(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function r(K,te){let oe=0;const le=te.charCodeAt(0);for(let de=K.length-1;de>=0;de--)K.charCodeAt(de)===le&&oe++;return oe}e.count=r;function p(K,te,oe="\u2026"){return K.length<=te?K:`${K.substr(0,te)}${oe}`}e.truncate=p;function i(K,te=" "){const oe=D(K,te);return g(oe,te)}e.trim=i;function D(K,te){if(!K||!te)return K;const oe=te.length;if(oe===0||K.length===0)return K;let le=0;for(;K.indexOf(te,le)===le;)le=le+oe;return K.substring(le)}e.ltrim=D;function g(K,te){if(!K||!te)return K;const oe=te.length,le=K.length;if(oe===0||le===0)return K;let de=le,pe=-1;for(;pe=K.lastIndexOf(te,de-1),!(pe===-1||pe+oe!==de);){if(pe===0)return"";de=pe}return K.substring(0,de)}e.rtrim=g;function S(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=S;function v(K){return K.replace(/\*/g,"")}e.stripWildcards=v;function d(K,te,oe={}){if(!K)throw new Error("Cannot create regex from empty string");te||(K=P(K)),oe.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let le="";return oe.global&&(le+="g"),oe.matchCase||(le+="i"),oe.multiline&&(le+="m"),oe.unicode&&(le+="u"),new RegExp(K,le)}e.createRegExp=d;function w(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function I(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=I;function b(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=b;function a(K){return K.split(/\r\n|\r|\n/)}e.splitLines=a;function c(K){for(let te=0,oe=K.length;te<oe;te++){const le=K.charCodeAt(te);if(le!==32&&le!==9)return te}return-1}e.firstNonWhitespaceIndex=c;function l(K,te=0,oe=K.length){for(let le=te;le<oe;le++){const de=K.charCodeAt(le);if(de!==32&&de!==9)return K.substring(te,le)}return K.substring(te,oe)}e.getLeadingWhitespace=l;function s(K,te=K.length-1){for(let oe=te;oe>=0;oe--){const le=K.charCodeAt(oe);if(le!==32&&le!==9)return oe}return-1}e.lastNonWhitespaceIndex=s;function t(K,te){return K<te?-1:K>te?1:0}e.compare=t;function n(K,te,oe=0,le=K.length,de=0,pe=te.length){for(;oe<le&&de<pe;oe++,de++){let Ce=K.charCodeAt(oe),Ne=te.charCodeAt(de);if(Ce<Ne)return-1;if(Ce>Ne)return 1}const Ie=le-oe,Oe=pe-de;return Ie<Oe?-1:Ie>Oe?1:0}e.compareSubstring=n;function o(K,te){return u(K,te,0,K.length,0,te.length)}e.compareIgnoreCase=o;function u(K,te,oe=0,le=K.length,de=0,pe=te.length){for(;oe<le&&de<pe;oe++,de++){let Ce=K.charCodeAt(oe),Ne=te.charCodeAt(de);if(Ce!==Ne){const qe=Ce-Ne;if(!(qe===32&&f(Ne))&&!(qe===-32&&f(Ce)))return h(Ce)&&h(Ne)?qe:n(K.toLowerCase(),te.toLowerCase(),oe,le,de,pe)}}const Ie=le-oe,Oe=pe-de;return Ie<Oe?-1:Ie>Oe?1:0}e.compareSubstringIgnoreCase=u;function h(K){return K>=97&&K<=122}e.isLowerAsciiLetter=h;function f(K){return K>=65&&K<=90}e.isUpperAsciiLetter=f;function E(K){return h(K)||f(K)}function A(K,te){return K.length===te.length&&_(K,te)}e.equalsIgnoreCase=A;function _(K,te,oe=K.length){for(let le=0;le<oe;le++){const de=K.charCodeAt(le),pe=te.charCodeAt(le);if(de!==pe){if(E(de)&&E(pe)){const Ie=Math.abs(de-pe);if(Ie!==0&&Ie!==32)return!1}else if(String.fromCharCode(de).toLowerCase()!==String.fromCharCode(pe).toLowerCase())return!1}}return!0}function U(K,te){const oe=te.length;return te.length>K.length?!1:_(K,te,oe)}e.startsWithIgnoreCase=U;function H(K,te){let oe,le=Math.min(K.length,te.length);for(oe=0;oe<le;oe++)if(K.charCodeAt(oe)!==te.charCodeAt(oe))return oe;return le}e.commonPrefixLength=H;function Q(K,te){let oe,le=Math.min(K.length,te.length);const de=K.length-1,pe=te.length-1;for(oe=0;oe<le;oe++)if(K.charCodeAt(de-oe)!==te.charCodeAt(pe-oe))return oe;return le}e.commonSuffixLength=Q;function ne(K){return 55296<=K&&K<=56319}e.isHighSurrogate=ne;function ae(K){return 56320<=K&&K<=57343}e.isLowSurrogate=ae;function O(K,te){return(K-55296<<10)+(te-56320)+65536}e.computeCodePoint=O;function $(K,te,oe){const le=K.charCodeAt(oe);if(ne(le)&&oe+1<te){const de=K.charCodeAt(oe+1);if(ae(de))return O(le,de)}return le}e.getNextCodePoint=$;function z(K,te){const oe=K.charCodeAt(te-1);if(ae(oe)&&te>1){const le=K.charCodeAt(te-2);if(ne(le))return O(le,oe)}return oe}function C(K,te){const oe=ze.getInstance(),le=te,de=K.length,pe=$(K,de,te);te+=pe>=65536?2:1;let Ie=oe.getGraphemeBreakType(pe);for(;te<de;){const Oe=$(K,de,te),Ce=oe.getGraphemeBreakType(Oe);if(Ke(Ie,Ce))break;te+=Oe>=65536?2:1,Ie=Ce}return te-le}e.nextCharLength=C;function j(K,te){const oe=ze.getInstance(),le=te,de=z(K,te);te-=de>=65536?2:1;let pe=oe.getGraphemeBreakType(de);for(;te>0;){const Ie=z(K,te),Oe=oe.getGraphemeBreakType(Ie);if(Ke(Oe,pe))break;te-=Ie>=65536?2:1,pe=Oe}return le-te}e.prevCharLength=j;function N(K,te){const oe=ze.getInstance(),le=K.length,de=te,pe=$(K,le,te),Ie=oe.getGraphemeBreakType(pe);te+=pe>=65536?2:1;let Oe=Ie;for(;te<le;){const Ne=$(K,le,te),qe=oe.getGraphemeBreakType(Ne);if(Ke(Oe,qe))break;te+=Ne>=65536?2:1,Oe=qe}const Ce=te;for(te=de,Oe=Ie;te>0;){const Ne=z(K,te),qe=oe.getGraphemeBreakType(Ne);if(Ke(qe,Oe))break;te-=Ne>=65536?2:1,Oe=qe}return[te,Ce]}function T(K,te){return te>0&&ae(K.charCodeAt(te))?N(K,te-1):N(K,te)}e.getCharContainingOffset=T;function R(K){const te=K.length;let oe=0,le=0;for(;le<te;){const Ie=$(K,te,le);le+=Ie>=65536?2:1,Ie<128?oe+=1:Ie<2048?oe+=2:Ie<65536?oe+=3:oe+=4}const de=new Uint8Array(oe);le=0;let pe=0;for(;le<te;){const Ie=$(K,te,le);le+=Ie>=65536?2:1,Ie<128?de[pe++]=Ie:Ie<2048?(de[pe++]=192|(Ie&1984)>>>6,de[pe++]=128|(Ie&63)>>>0):Ie<65536?(de[pe++]=224|(Ie&61440)>>>12,de[pe++]=128|(Ie&4032)>>>6,de[pe++]=128|(Ie&63)>>>0):(de[pe++]=240|(Ie&1835008)>>>18,de[pe++]=128|(Ie&258048)>>>12,de[pe++]=128|(Ie&4032)>>>6,de[pe++]=128|(Ie&63)>>>0)}return de}e.encodeUTF8=R;function W(K){const te=K.byteLength,oe=[];let le=0;for(;le<te;){const de=K[le];let pe;if(de>=240&&le+3<te?pe=(K[le++]&7)<<18>>>0|(K[le++]&63)<<12>>>0|(K[le++]&63)<<6>>>0|(K[le++]&63)<<0>>>0:de>=224&&le+2<te?pe=(K[le++]&15)<<12>>>0|(K[le++]&63)<<6>>>0|(K[le++]&63)<<0>>>0:de>=192&&le+1<te?pe=(K[le++]&31)<<6>>>0|(K[le++]&63)<<0>>>0:pe=K[le++],pe>=0&&pe<=55295||pe>=57344&&pe<=65535)oe.push(String.fromCharCode(pe));else if(pe>=65536&&pe<=1114111){const Ie=pe-65536,Oe=55296+((Ie&1047552)>>>10),Ce=56320+((Ie&1023)>>>0);oe.push(String.fromCharCode(Oe)),oe.push(String.fromCharCode(Ce))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=W;const M=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function F(K){return M.test(K)}e.containsRTL=F;const B=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function V(K){return B.test(K)}e.containsEmoji=V;const G=/^[\t\n\r\x20-\x7E]*$/;function Y(K){return G.test(K)}e.isBasicASCII=Y,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=Z;function re(K){for(let te=0,oe=K.length;te<oe;te++)if(se(K.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=re;function se(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=se;function x(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=x;function ie(K,te){if(K.length<te)return K;const oe=/\b/g;let le=0;for(;oe.test(K)&&!(K.length-oe.lastIndex<te);)le=oe.lastIndex,oe.lastIndex+=1;return K.substring(le).replace(/^\s/,"")}e.lcut=ie;const ue=/\x1B\x5B[12]?K/g,ye=/\x1b\[\d+m/g,ge=/\x1b\[0?m/g;function Ee(K){return K&&(K=K.replace(ue,""),K=K.replace(ye,""),K=K.replace(ge,"")),K}e.removeAnsiEscapeCodes=Ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ae(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ae;function ve(K){return Ae(K)?K.substr(1):K}e.stripUTF8BOM=ve;function me(K,te){if(!K||!te||K.length<te.length)return!1;const oe=te.length,le=K.toLowerCase();let de=0,pe=-1;for(;de<oe;){const Ie=le.indexOf(te[de],pe+1);if(Ie<0)return!1;pe=Ie,de++}return!0}e.fuzzyContains=me;function be(K,te=!1){return K?(te&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=be;function Te(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Te;function _e(K,te=1){if(te===0)return"";let oe=-1;do oe=K.indexOf(`
`,oe+1),te--;while(te>0&&oe>=0);return oe===-1?K:(K[oe-1]==="\r"&&oe--,K.substr(0,oe))}e.getNLines=_e;function Ge(K){const te=90-65+1;return K=K%(2*te),K<te?String.fromCharCode(97+K):String.fromCharCode(65+K-te)}e.singleLetterHash=Ge;function Ze(K){return ze.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=Ze;function Ke(K,te){return K===0?te!==5&&te!==7:K===2&&te===3?!1:K===4||K===2||K===3||te===4||te===2||te===3?!0:!(K===8&&(te===8||te===9||te===11||te===12)||(K===11||K===9)&&(te===9||te===10)||(K===12||K===10)&&te===10||te===5||te===13||te===7||K===1||K===13&&te===14||K===6&&te===6)}e.breakBetweenGraphemeBreakType=Ke;var st;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(st=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=it()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const oe=this._data,le=oe.length/3;let de=1;for(;de<=le;)if(te<oe[3*de])de=2*de;else if(te>oe[3*de+1])de=2*de+1;else return oe[3*de+2];return 0}}ze._INSTANCE=null;function it(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(X[23],J([0,1,22,63]),function(q,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer!="undefined",y=typeof TextEncoder!="undefined",P=typeof TextDecoder!="undefined";let r,p;class i{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return k?new i(Buffer.allocUnsafe(h)):new i(new Uint8Array(h))}static wrap(h){return k&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new i(h)}static fromString(h,f){return!((f==null?void 0:f.dontUseNodeBuffer)||!1)&&k?new i(Buffer.from(h)):y?(r||(r=new TextEncoder),new i(r.encode(h))):new i(m.encodeUTF8(h))}static concat(h,f){if(typeof f=="undefined"){f=0;for(let _=0,U=h.length;_<U;_++)f+=h[_].byteLength}const E=i.alloc(f);let A=0;for(let _=0,U=h.length;_<U;_++){const H=h[_];E.set(H,A),A+=H.byteLength}return E}toString(){return k?this.buffer.toString():P?(p||(p=new TextDecoder),p.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(h,f){return new i(this.buffer.subarray(h,f))}set(h,f){h instanceof i?this.buffer.set(h.buffer,f):this.buffer.set(h,f)}readUInt32BE(h){return S(this.buffer,h)}writeUInt32BE(h,f){v(this.buffer,h,f)}readUInt32LE(h){return d(this.buffer,h)}writeUInt32LE(h,f){w(this.buffer,h,f)}readUInt8(h){return I(this.buffer,h)}writeUInt8(h,f){b(this.buffer,h,f)}}e.VSBuffer=i;function D(u,h){return u[h+0]<<0>>>0|u[h+1]<<8>>>0}e.readUInt16LE=D;function g(u,h,f){u[f+0]=h&255,h=h>>>8,u[f+1]=h&255}e.writeUInt16LE=g;function S(u,h){return u[h]*2**24+u[h+1]*2**16+u[h+2]*2**8+u[h+3]}e.readUInt32BE=S;function v(u,h,f){u[f+3]=h,h=h>>>8,u[f+2]=h,h=h>>>8,u[f+1]=h,h=h>>>8,u[f]=h}e.writeUInt32BE=v;function d(u,h){return u[h+0]<<0>>>0|u[h+1]<<8>>>0|u[h+2]<<16>>>0|u[h+3]<<24>>>0}e.readUInt32LE=d;function w(u,h,f){u[f+0]=h&255,h=h>>>8,u[f+1]=h&255,h=h>>>8,u[f+2]=h&255,h=h>>>8,u[f+3]=h&255}e.writeUInt32LE=w;function I(u,h){return u[h]}e.readUInt8=I;function b(u,h,f){u[f]=h}e.writeUInt8=b;function a(u){return L.consumeReadable(u,h=>i.concat(h))}e.readableToBuffer=a;function c(u){return L.toReadable(u)}e.bufferToReadable=c;function l(u){return L.consumeStream(u,h=>i.concat(h))}e.streamToBuffer=l;async function s(u){return u.ended?i.concat(u.buffer):i.concat([...u.buffer,await l(u.stream)])}e.bufferedStreamToBuffer=s;function t(u){return L.toStream(u,h=>i.concat(h))}e.bufferToStream=t;function n(u){return L.transform(u,{data:h=>typeof h=="string"?i.fromString(h):i.wrap(h)},h=>i.concat(h))}e.streamToBufferReadableStream=n;function o(u){return L.newWriteableStream(h=>i.concat(h),u)}e.newWriteableBufferStream=o}),define(X[80],J([0,1,22]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(b){return k(b,0)}e.hash=L;function k(b,a){switch(typeof b){case"object":return b===null?y(349,a):Array.isArray(b)?p(b,a):i(b,a);case"string":return r(b,a);case"boolean":return P(b,a);case"number":return y(b,a);case"undefined":return y(937,a);default:return y(617,a)}}e.doHash=k;function y(b,a){return(a<<5)-a+b|0}function P(b,a){return y(b?433:863,a)}function r(b,a){a=y(149417,a);for(let c=0,l=b.length;c<l;c++)a=y(b.charCodeAt(c),a);return a}e.stringHash=r;function p(b,a){return a=y(104579,a),b.reduce((c,l)=>k(l,c),a)}function i(b,a){return a=y(181387,a),Object.keys(b).sort().reduce((c,l)=>(c=r(l,c),k(b[l],c)),a)}class D{constructor(){this._value=0}get value(){return this._value}hash(a){return this._value=k(a,this._value),this._value}}e.Hasher=D;var g;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(g||(g={}));function S(b,a,c=32){const l=c-a,s=~((1<<l)-1);return(b<<a|(s&b)>>>l)>>>0}function v(b,a=0,c=b.byteLength,l=0){for(let s=0;s<c;s++)b[a+s]=l}function d(b,a,c="0"){for(;b.length<a;)b=c+b;return b}function w(b,a=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(c=>c.toString(16).padStart(2,"0")).join(""):d((b>>>0).toString(16),a/4)}e.toHexString=w;class I{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(a){const c=a.length;if(c!==0){const l=this._buff;let s=this._buffLen,t=this._leftoverHighSurrogate,n,o;for(t!==0?(n=t,o=-1,t=0):(n=a.charCodeAt(0),o=0);;){let u=n;if(m.isHighSurrogate(n))if(o+1<c){const h=a.charCodeAt(o+1);m.isLowSurrogate(h)?(o++,u=m.computeCodePoint(n,h)):u=65533}else{t=n;break}else m.isLowSurrogate(n)&&(u=65533);if(s=this._push(l,s,u),o++,o<c)n=a.charCodeAt(o);else break}this._buffLen=s,this._leftoverHighSurrogate=t}}_push(a,c,l){return l<128?a[c++]=l:l<2048?(a[c++]=192|(l&1984)>>>6,a[c++]=128|(l&63)>>>0):l<65536?(a[c++]=224|(l&61440)>>>12,a[c++]=128|(l&4032)>>>6,a[c++]=128|(l&63)>>>0):(a[c++]=240|(l&1835008)>>>18,a[c++]=128|(l&258048)>>>12,a[c++]=128|(l&4032)>>>6,a[c++]=128|(l&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,a[0]=a[64+0],a[1]=a[64+1],a[2]=a[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const a=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(a/4294967296),!1),this._buffDV.setUint32(60,a%4294967296,!1),this._step()}_step(){const a=I._bigBlock32,c=this._buffDV;for(let E=0;E<64;E+=4)a.setUint32(E,c.getUint32(E,!1),!1);for(let E=64;E<320;E+=4)a.setUint32(E,S(a.getUint32(E-12,!1)^a.getUint32(E-32,!1)^a.getUint32(E-56,!1)^a.getUint32(E-64,!1),1),!1);let l=this._h0,s=this._h1,t=this._h2,n=this._h3,o=this._h4,u,h,f;for(let E=0;E<80;E++)E<20?(u=s&t|~s&n,h=1518500249):E<40?(u=s^t^n,h=1859775393):E<60?(u=s&t|s&n|t&n,h=2400959708):(u=s^t^n,h=3395469782),f=S(l,5)+u+o+h+a.getUint32(E*4,!1)&4294967295,o=n,n=t,t=S(s,30),s=l,l=f;this._h0=this._h0+l&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=I,I._bigBlock32=new DataView(new ArrayBuffer(320))}),define(X[12],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(f){return Array.isArray(f)}e.isArray=m;function L(f){return typeof f=="string"}e.isString=L;function k(f){return Array.isArray(f)&&f.every(E=>L(E))}e.isStringArray=k;function y(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=y;function P(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=P;function r(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=r;function p(f){return f===!0||f===!1}e.isBoolean=p;function i(f){return typeof f=="undefined"}e.isUndefined=i;function D(f){return!g(f)}e.isDefined=D;function g(f){return i(f)||f===null}e.isUndefinedOrNull=g;function S(f,E){if(!f)throw new Error(E?`Unexpected type, expected '${E}'`:"Unexpected type")}e.assertType=S;function v(f){if(g(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=v;function d(...f){const E=[];for(let A=0;A<f.length;A++){const _=f[A];if(g(_))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);E.push(_)}return E}e.assertAllDefined=d;const w=Object.prototype.hasOwnProperty;function I(f){if(!y(f))return!1;for(let E in f)if(w.call(f,E))return!1;return!0}e.isEmptyObject=I;function b(f){return typeof f=="function"}e.isFunction=b;function a(...f){return f.length>0&&f.every(b)}e.areFunctions=a;function c(f,E){const A=Math.min(f.length,E.length);for(let _=0;_<A;_++)l(f[_],E[_])}e.validateConstraints=c;function l(f,E){if(L(E)){if(typeof f!==E)throw new Error(`argument does not match constraint: typeof ${E}`)}else if(b(E)){try{if(f instanceof E)return}catch(A){}if(!g(f)&&f.constructor===E||E.length===1&&E.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function s(f){let E=[],A=Object.getPrototypeOf(f);for(;Object.prototype!==A;)E=E.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return E}e.getAllPropertyNames=s;function t(f){const E=[];for(const A of s(f))typeof f[A]=="function"&&E.push(A);return E}e.getAllMethodNames=t;function n(f,E){const A=U=>function(){const H=Array.prototype.slice.call(arguments,0);return E(U,H)};let _={};for(const U of f)_[U]=A(U);return _}e.createProxyObject=n;function o(f){return f===null?void 0:f}e.withNullAsUndefined=o;function u(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=u;function h(f){return class{constructor(){return new Proxy({},{get(E,A){if(E[A])return E[A];throw new Error(`Not Implemented: ${f}->${String(A)}`)}})}}}e.NotImplementedProxy=h}),define(X[30],J([0,1,3,22,8,12]),function(q,e,m,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function P(n){return n===47||n===92}e.isPathSeparator=P;function r(n){return n.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=r;function p(n,o=k.posix.sep){if(!n)return"";const u=n.length,h=n.charCodeAt(0);if(P(h)){if(P(n.charCodeAt(1))&&!P(n.charCodeAt(2))){let E=3;const A=E;for(;E<u&&!P(n.charCodeAt(E));E++);if(A!==E&&!P(n.charCodeAt(E+1))){for(E+=1;E<u;E++)if(P(n.charCodeAt(E)))return n.slice(0,E+1).replace(/[\\/]/g,o)}}return o}else if(I(h)&&n.charCodeAt(1)===58)return P(n.charCodeAt(2))?n.slice(0,2)+o:n.slice(0,2);let f=n.indexOf("://");if(f!==-1){for(f+=3;f<u;f++)if(P(n.charCodeAt(f)))return n.slice(0,f+1)}return""}e.getRoot=p;function i(n){if(!m.isWindows||!n||n.length<5)return!1;let o=n.charCodeAt(0);if(o!==92||(o=n.charCodeAt(1),o!==92))return!1;let u=2;const h=u;for(;u<n.length&&(o=n.charCodeAt(u),o!==92);u++);return!(h===u||(o=n.charCodeAt(u+1),isNaN(o)||o===92))}e.isUNC=i;const D=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(n,o=m.isWindows){const u=o?D:g;return!(!n||n.length===0||/^\s+$/.test(n)||(u.lastIndex=0,u.test(n))||o&&S.test(n)||n==="."||n===".."||o&&n[n.length-1]==="."||o&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=v;function d(n,o,u){const h=n===o;return!u||h?h:!n||!o?!1:(0,L.equalsIgnoreCase)(n,o)}e.isEqual=d;function w(n,o,u,h=k.sep){if(n===o)return!0;if(!n||!o||o.length>n.length)return!1;if(u){if(!(0,L.startsWithIgnoreCase)(n,o))return!1;if(o.length===n.length)return!0;let E=o.length;return o.charAt(o.length-1)===h&&E--,n.charAt(E)===h}return o.charAt(o.length-1)!==h&&(o+=h),n.indexOf(o)===0}e.isEqualOrParent=w;function I(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=I;function b(n,o){return m.isWindows&&n.endsWith(":")&&(n+=k.sep),(0,k.isAbsolute)(n)||(n=(0,k.join)(o,n)),n=(0,k.normalize)(n),m.isWindows?(n=(0,L.rtrim)(n,k.sep),n.endsWith(":")&&(n+=k.sep)):(n=(0,L.rtrim)(n,k.sep),n||(n=k.sep)),n}e.sanitizeFilePath=b;function a(n){const o=(0,k.normalize)(n);return m.isWindows?n.length>3?!1:c(o)&&(n.length===2||o.charCodeAt(2)===92):o===k.posix.sep}e.isRootOrDriveLetter=a;function c(n){return m.isWindows?I(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function l(n){return c(n)?n[0]:void 0}e.getDriveLetter=l;function s(n,o,u){return o.length>n.length?-1:n===o?0:(u&&(n=n.toLowerCase(),o=o.toLowerCase()),n.indexOf(o))}e.indexOfPath=s;function t(n){const o=n.split(":");let u,h,f;if(o.forEach(E=>{const A=Number(E);(0,y.isNumber)(A)?h===void 0?h=A:f===void 0&&(f=A):u=u?[u,E].join(":"):E}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:h!==void 0?h:void 0,column:f!==void 0?f:h!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(X[44],J([0,1,12]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const w=Array.isArray(d)?[]:{};return Object.keys(d).forEach(I=>{d[I]&&typeof d[I]=="object"?w[I]=L(d[I]):w[I]=d[I]}),w}e.deepClone=L;function k(d){if(!d||typeof d!="object")return d;const w=[d];for(;w.length>0;){const I=w.shift();Object.freeze(I);for(const b in I)if(y.call(I,b)){const a=I[b];typeof a=="object"&&!Object.isFrozen(a)&&w.push(a)}}return d}e.deepFreeze=k;const y=Object.prototype.hasOwnProperty;function P(d,w){return r(d,w,new Set)}e.cloneAndChange=P;function r(d,w,I){if((0,m.isUndefinedOrNull)(d))return d;const b=w(d);if(typeof b!="undefined")return b;if((0,m.isArray)(d)){const a=[];for(const c of d)a.push(r(c,w,I));return a}if((0,m.isObject)(d)){if(I.has(d))throw new Error("Cannot clone recursive data-structure");I.add(d);const a={};for(let c in d)y.call(d,c)&&(a[c]=r(d[c],w,I));return I.delete(d),a}return d}function p(d,w,I=!0){return(0,m.isObject)(d)?((0,m.isObject)(w)&&Object.keys(w).forEach(b=>{b in d?I&&((0,m.isObject)(d[b])&&(0,m.isObject)(w[b])?p(d[b],w[b],I):d[b]=w[b]):d[b]=w[b]}),d):w}e.mixin=p;function i(d,w){if(d===w)return!0;if(d==null||w===null||w===void 0||typeof d!=typeof w||typeof d!="object"||Array.isArray(d)!==Array.isArray(w))return!1;let I,b;if(Array.isArray(d)){if(d.length!==w.length)return!1;for(I=0;I<d.length;I++)if(!i(d[I],w[I]))return!1}else{const a=[];for(b in d)a.push(b);a.sort();const c=[];for(b in w)c.push(b);if(c.sort(),!i(a,c))return!1;for(I=0;I<a.length;I++)if(!i(d[a[I]],w[a[I]]))return!1}return!0}e.equals=i;function D(d){const w=new Set;return JSON.stringify(d,(I,b)=>{if((0,m.isObject)(b)||Array.isArray(b)){if(w.has(b))return"[Circular]";w.add(b)}return b})}e.safeStringify=D;function g(d,w,I){const b=w(d);return typeof b=="undefined"?I:b}e.getOrDefault=g;function S(d,w){const I=Object.create(null);return!d||!w||Object.keys(w).forEach(a=>{const c=d[a],l=w[a];i(c,l)||(I[a]=l)}),I}e.distinct=S;function v(d,w){const I=w.toLowerCase(),b=Object.keys(d).find(a=>a.toLowerCase()===I);return b?d[b]:d[w]}e.getCaseInsensitive=v}),define(X[7],J([0,1,3,8]),function(q,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,y=/^\//,P=/^\/\//;function r(o,u){if(!o.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!k.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!y.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(o,u){return!o&&!u?"file":o}function i(o,u){switch(o){case"https":case"http":case"file":u?u[0]!==g&&(u=g+u):u=g;break}return u}const D="",g="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(u,h,f,E,A,_=!1){typeof u=="object"?(this.scheme=u.scheme||D,this.authority=u.authority||D,this.path=u.path||D,this.query=u.query||D,this.fragment=u.fragment||D):(this.scheme=p(u,_),this.authority=h||D,this.path=i(this.scheme,f||D),this.query=E||D,this.fragment=A||D,r(this,_))}static isUri(u){return u instanceof v?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}get fsPath(){return c(this,!1)}with(u){if(!u)return this;let{scheme:h,authority:f,path:E,query:A,fragment:_}=u;return h===void 0?h=this.scheme:h===null&&(h=D),f===void 0?f=this.authority:f===null&&(f=D),E===void 0?E=this.path:E===null&&(E=D),A===void 0?A=this.query:A===null&&(A=D),_===void 0?_=this.fragment:_===null&&(_=D),h===this.scheme&&f===this.authority&&E===this.path&&A===this.query&&_===this.fragment?this:new w(h,f,E,A,_)}static parse(u,h=!1){const f=S.exec(u);return f?new w(f[2]||D,n(f[4]||D),n(f[5]||D),n(f[7]||D),n(f[9]||D),h):new w(D,D,D,D,D)}static file(u){let h=D;if(m.isWindows&&(u=u.replace(/\\/g,g)),u[0]===g&&u[1]===g){const f=u.indexOf(g,2);f===-1?(h=u.substring(2),u=g):(h=u.substring(2,f),u=u.substring(f)||g)}return new w("file",h,u,D,D)}static from(u){return new w(u.scheme,u.authority,u.path,u.query,u.fragment)}static joinPath(u,...h){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return m.isWindows&&u.scheme==="file"?f=v.file(L.win32.join(c(u,!0),...h)).path:f=L.posix.join(u.path,...h),u.with({path:f})}toString(u=!1){return l(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof v)return u;{const h=new w(u);return h._formatted=u.external,h._fsPath=u._sep===d?u.fsPath:null,h}}else return u}}e.URI=v;const d=m.isWindows?1:void 0;class w extends v{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(u=!1){return u?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=d),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const I={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(o,u){let h,f=-1;for(let E=0;E<o.length;E++){const A=o.charCodeAt(E);if(A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57||A===45||A===46||A===95||A===126||u&&A===47)f!==-1&&(h+=encodeURIComponent(o.substring(f,E)),f=-1),h!==void 0&&(h+=o.charAt(E));else{h===void 0&&(h=o.substr(0,E));const _=I[A];_!==void 0?(f!==-1&&(h+=encodeURIComponent(o.substring(f,E)),f=-1),h+=_):f===-1&&(f=E)}}return f!==-1&&(h+=encodeURIComponent(o.substring(f))),h!==void 0?h:o}function a(o){let u;for(let h=0;h<o.length;h++){const f=o.charCodeAt(h);f===35||f===63?(u===void 0&&(u=o.substr(0,h)),u+=I[f]):u!==void 0&&(u+=o[h])}return u!==void 0?u:o}function c(o,u){let h;return o.authority&&o.path.length>1&&o.scheme==="file"?h=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?u?h=o.path.substr(1):h=o.path[1].toLowerCase()+o.path.substr(2):h=o.path,m.isWindows&&(h=h.replace(/\//g,"\\")),h}e.uriToFsPath=c;function l(o,u){const h=u?a:b;let f="",{scheme:E,authority:A,path:_,query:U,fragment:H}=o;if(E&&(f+=E,f+=":"),(A||E==="file")&&(f+=g,f+=g),A){let Q=A.indexOf("@");if(Q!==-1){const ne=A.substr(0,Q);A=A.substr(Q+1),Q=ne.indexOf(":"),Q===-1?f+=h(ne,!1):(f+=h(ne.substr(0,Q),!1),f+=":",f+=h(ne.substr(Q+1),!1)),f+="@"}A=A.toLowerCase(),Q=A.indexOf(":"),Q===-1?f+=h(A,!1):(f+=h(A.substr(0,Q),!1),f+=A.substr(Q))}if(_){if(_.length>=3&&_.charCodeAt(0)===47&&_.charCodeAt(2)===58){const Q=_.charCodeAt(1);Q>=65&&Q<=90&&(_=`/${String.fromCharCode(Q+32)}:${_.substr(3)}`)}else if(_.length>=2&&_.charCodeAt(1)===58){const Q=_.charCodeAt(0);Q>=65&&Q<=90&&(_=`${String.fromCharCode(Q+32)}:${_.substr(2)}`)}f+=h(_,!0)}return U&&(f+="?",f+=h(U,!1)),H&&(f+="#",f+=u?H:b(H,!1)),f}function s(o){try{return decodeURIComponent(o)}catch(u){return o.length>3?o.substr(0,3)+s(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(o){return o.match(t)?o.replace(t,u=>s(u)):o}}),define(X[106],J([0,1,7]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(i){const D=i;return D&&typeof D.type=="string"&&typeof D.severity=="string"}e.isRemoteConsoleLog=L;function k(i){const D=[];let g;try{const S=JSON.parse(i.arguments),v=S[S.length-1];v&&v.__$stack&&(S.pop(),g=v.__$stack),D.push(...S)}catch(S){D.push("Unable to log remote console arguments",i.arguments)}return{args:D,stack:g}}e.parse=k;function y(i){if(typeof i!="string")return y(k(i).stack);const D=i;if(D){const g=P(D),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(g||"");if(S&&S.length===4)return{uri:m.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=y;function P(i){if(!i)return i;const D=i.indexOf(`
`);return D===-1?i:i.substring(0,D)}function r(i,D){const{args:g,stack:S}=k(i),v=typeof g[0]=="string"&&g.length===1;let d=P(S);d&&(d=`(${d.trim()})`);let w=[];if(typeof g[0]=="string"?d&&v?w=[`%c[${D}] %c${g[0]} %c${d}`,p("blue"),p(""),p("grey")]:w=[`%c[${D}] %c${g[0]}`,p("blue"),p(""),...g.slice(1)]:w=[`%c[${D}]%`,p("blue"),...g],d&&!v&&w.push(d),typeof console[i.severity]!="function")throw new Error("Unknown console method");console[i.severity].apply(console,w)}e.log=r;function p(i){return`color: ${i}`}}),define(X[36],J([0,1,7,22]),function(q,e,m,L){"use strict";var k,y;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(l,s,t){let n=l.get(s);return n===void 0&&(n=t,l.set(s,n)),n}e.getOrSet=P;function r(l){const s=[];return l.forEach((t,n)=>{s.push(`${n} => ${t}`)}),`Map(${l.size}) {${s.join(", ")}}`}e.mapToString=r;function p(l){const s=[];return l.forEach(t=>{s.push(t)}),`Set(${l.size}) {${s.join(", ")}}`}e.setToString=p;class i{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const t=s.charCodeAt(0),n=this._value.charCodeAt(this._pos);return t-n}value(){return this._value[this._pos]}}e.StringIterator=i;class D{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,L.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=D;class g{constructor(s=!0,t=!0){this._splitOnBackslash=s,this._caseSensitive=t}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,L.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=g;var S;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(S||(S={}));class v{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new g(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,L.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=v;class d{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class w{constructor(s){this._iter=s}static forUris(s=()=>!1){return new w(new v(s))}static forPaths(){return new w(new g)}static forStrings(){return new w(new i)}static forConfigKeys(){return new w(new D)}clear(){this._root=void 0}set(s,t){const n=this._iter.reset(s);let o;for(this._root||(this._root=new d,this._root.segment=n.value()),o=this._root;;){const h=n.cmp(o.segment);if(h>0)o.left||(o.left=new d,o.left.segment=n.value()),o=o.left;else if(h<0)o.right||(o.right=new d,o.right.segment=n.value()),o=o.right;else if(n.hasNext())n.next(),o.mid||(o.mid=new d,o.mid.segment=n.value()),o=o.mid;else break}const u=o.value;return o.value=t,o.key=s,u}get(s){var t;return(t=this._getNode(s))===null||t===void 0?void 0:t.value}_getNode(s){const t=this._iter.reset(s);let n=this._root;for(;n;){const o=t.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(t.hasNext())t.next(),n=n.mid;else break}return n}has(s){const t=this._getNode(s);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,t){const n=this._iter.reset(s),o=[];let u=this._root;for(;u;){const h=n.cmp(u.segment);if(h>0)o.push([1,u]),u=u.left;else if(h<0)o.push([-1,u]),u=u.right;else if(n.hasNext())n.next(),o.push([0,u]),u=u.mid;else{for(t?(u.left=void 0,u.mid=void 0,u.right=void 0):u.value=void 0;o.length>0&&u.isEmpty();){let[f,E]=o.pop();switch(f){case 1:E.left=void 0;break;case 0:E.mid=void 0;break;case-1:E.right=void 0;break}u=E}break}}}findSubstr(s){const t=this._iter.reset(s);let n=this._root,o;for(;n;){const u=t.cmp(n.segment);if(u>0)n=n.left;else if(u<0)n=n.right;else if(t.hasNext())t.next(),o=n.value||o,n=n.mid;else break}return n&&n.value||o}findSuperstr(s){const t=this._iter.reset(s);let n=this._root;for(;n;){const o=t.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(t.hasNext())t.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(s){for(const[t,n]of this)s(n,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){s&&(yield*this._entries(s.left),s.value&&(yield[s.key,s.value]),yield*this._entries(s.mid),yield*this._entries(s.right))}}e.TernarySearchTree=w;class I{constructor(s,t){this[k]="ResourceMap",s instanceof I?(this.map=new Map(s.map),this.toKey=t!=null?t:I.defaultToKey):(this.map=new Map,this.toKey=s!=null?s:I.defaultToKey)}set(s,t){return this.map.set(this.toKey(s),t),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,t){typeof t!="undefined"&&(s=s.bind(t));for(let[n,o]of this.map)s(o,m.URI.parse(n),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield m.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[m.URI.parse(s[0]),s[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[m.URI.parse(s[0]),s[1]]}}e.ResourceMap=I,I.defaultToKey=l=>l.toString();var b;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class a{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var s;return(s=this._head)===null||s===void 0?void 0:s.value}get last(){var s;return(s=this._tail)===null||s===void 0?void 0:s.value}has(s){return this._map.has(s)}get(s,t=0){const n=this._map.get(s);if(!!n)return t!==0&&this.touch(n,t),n.value}set(s,t,n=0){let o=this._map.get(s);if(o)o.value=t,n!==0&&this.touch(o,n);else{switch(o={key:s,value:t,next:void 0,previous:void 0},n){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(s,o),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const t=this._map.get(s);if(!!t)return this._map.delete(s),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}}forEach(s,t){const n=this._state;let o=this._head;for(;o;){if(t?s.bind(t)(o.value,o.key,this):s(o.value,o.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const s=this,t=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const u={value:n.key,done:!1};return n=n.next,u}else return{value:void 0,done:!0}}};return o}values(){const s=this,t=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const u={value:n.value,done:!1};return n=n.next,u}else return{value:void 0,done:!0}}};return o}entries(){const s=this,t=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const u={value:[n.key,n.value],done:!1};return n=n.next,u}else return{value:void 0,done:!0}}};return o}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(!(s>=this.size)){if(s===0){this.clear();return}let t=this._head,n=this.size;for(;t&&n>s;)this._map.delete(t.key),t=t.next,n--;this._head=t,this._size=n,t&&(t.previous=void 0),this._state++}}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const t=s.next,n=s.previous;if(!t||!n)throw new Error("Invalid list");t.previous=n,n.next=t}s.next=void 0,s.previous=void 0,this._state++}touch(s,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(s===this._head)return;const n=s.next,o=s.previous;s===this._tail?(o.next=void 0,this._tail=o):(n.previous=o,o.next=n),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(t===2){if(s===this._tail)return;const n=s.next,o=s.previous;s===this._head?(n.previous=void 0,this._head=n):(n.previous=o,o.next=n),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((t,n)=>{s.push([n,t])}),s}fromJSON(s){this.clear();for(const[t,n]of s)this.set(t,n)}}e.LinkedMap=a;class c extends a{constructor(s,t=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,t=2){return super.get(s,t)}peek(s){return super.get(s,0)}set(s,t){return super.set(s,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c}),define(X[107],J([0,1,23,22,7]),function(q,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function y(i){return JSON.stringify(i,r)}e.stringify=y;function P(i){let D=JSON.parse(i);return D=p(D),D}e.parse=P;function r(i,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,L.regExpFlags)(D)}:D}function p(i,D=0){if(!i||D>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return k.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof m.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let g=0;g<i.length;++g)i[g]=p(i[g],D+1);else for(const g in i)Object.hasOwnProperty.call(i,g)&&(i[g]=p(i[g],D+1))}return i}e.revive=p}),define(X[10],J([0,1,7,3]),function(q,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(r){r.inMemory="inmemory",r.vscode="vscode",r.internal="private",r.walkThrough="walkThrough",r.walkThroughSnippet="walkThroughSnippet",r.http="http",r.https="https",r.file="file",r.mailto="mailto",r.untitled="untitled",r.data="data",r.command="command",r.vscodeRemote="vscode-remote",r.vscodeRemoteResource="vscode-remote-resource",r.userData="vscode-userdata",r.vscodeCustomEditor="vscode-custom-editor",r.vscodeNotebook="vscode-notebook",r.vscodeNotebookCell="vscode-notebook-cell",r.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",r.vscodeSettings="vscode-settings",r.vscodeWorkspaceTrust="vscode-workspace-trust",r.webviewPanel="webview-panel",r.vscodeWebview="vscode-webview",r.extension="extension",r.vscodeFileResource="vscode-file"})(k=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}set(p,i,D){this._hosts[p]=i,this._ports[p]=D}setConnectionToken(p,i){this._connectionTokens[p]=i}rewrite(p){if(this._delegate)return this._delegate(p);const i=p.authority;let D=this._hosts[i];D&&D.indexOf(":")!==-1&&(D=`[${D}]`);const g=this._ports[i],S=this._connectionTokens[i];let v=`path=${encodeURIComponent(p.path)}`;return typeof S=="string"&&(v+=`&tkn=${encodeURIComponent(S)}`),m.URI.from({scheme:L.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${D}:${g}`,path:"/vscode-remote-resource",query:v})}}e.RemoteAuthorities=new y;class P{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(p,i,D){const g=this.toUri(p,i);return g.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(g):L.isNative&&(D||L.isPreferringBrowserCodeLoad)&&g.scheme===k.file?g.with({scheme:k.vscodeFileResource,authority:g.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):g}asFileUri(p,i){const D=this.toUri(p,i);return D.scheme===k.vscodeFileResource?D.with({scheme:k.file,authority:D.authority!==this.FALLBACK_AUTHORITY?D.authority:null,query:null,fragment:null}):D}toUri(p,i){return m.URI.isUri(p)?p:m.URI.parse(i.toUrl(p))}}e.FileAccess=new P}),define(X[64],J([0,1,36]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const L=new m.LRUCache(1e4);function k(i){return p(i,"NFC",L)}e.normalizeNFC=k;const y=new m.LRUCache(1e4);function P(i){return p(i,"NFD",y)}e.normalizeNFD=P;const r=/[^\u0000-\u0080]/;function p(i,D,g){if(!e.canNormalize||!i)return i;const S=g.get(i);if(S)return S;let v;return r.test(i)?v=i.normalize(D):v=i,g.set(i,v),v}e.removeAccents=function(){if(e.canNormalize){const i=/[\u0300-\u036f]/g;return function(D){return P(D).replace(i,"")}}else return function(i){return i}}()}),define(X[15],J([0,1,30,8,7,22,10,3]),function(q,e,m,L,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(v){return(0,k.uriToFsPath)(v,!0)}e.originalFSPath=p;class i{constructor(d){this._ignorePathCasing=d}compare(d,w,I=!1){return d===w?0:(0,y.compare)(this.getComparisonKey(d,I),this.getComparisonKey(w,I))}isEqual(d,w,I=!1){return d===w?!0:!d||!w?!1:this.getComparisonKey(d,I)===this.getComparisonKey(w,I)}getComparisonKey(d,w=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,w,I=!1){if(d.scheme===w.scheme){if(d.scheme===P.Schemas.file)return m.isEqualOrParent(p(d),p(w),this._ignorePathCasing(d))&&d.query===w.query&&(I||d.fragment===w.fragment);if((0,e.isEqualAuthority)(d.authority,w.authority))return m.isEqualOrParent(d.path,w.path,this._ignorePathCasing(d),"/")&&d.query===w.query&&(I||d.fragment===w.fragment)}return!1}joinPath(d,...w){return k.URI.joinPath(d,...w)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return L.posix.basename(d.path)}extname(d){return L.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let w;return d.scheme===P.Schemas.file?w=k.URI.file(L.dirname(p(d))).path:(w=L.posix.dirname(d.path),d.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),w="/")),d.with({path:w})}normalizePath(d){if(!d.path.length)return d;let w;return d.scheme===P.Schemas.file?w=k.URI.file(L.normalize(p(d))).path:w=L.posix.normalize(d.path),d.with({path:w})}relativePath(d,w){if(!(d.scheme!==w.scheme||!(0,e.isEqualAuthority)(d.authority,w.authority))){if(d.scheme===P.Schemas.file){const a=L.relative(p(d),p(w));return r.isWindows?m.toSlashes(a):a}let I=d.path||"/",b=w.path||"/";if(this._ignorePathCasing(d)){let a=0;for(const c=Math.min(I.length,b.length);a<c&&!(I.charCodeAt(a)!==b.charCodeAt(a)&&I.charAt(a).toLowerCase()!==b.charAt(a).toLowerCase());a++);I=b.substr(0,a)+I.substr(a)}return L.posix.relative(I,b)}}resolvePath(d,w){if(d.scheme===P.Schemas.file){const I=k.URI.file(L.resolve(p(d),w));return d.with({authority:I.authority,path:I.path})}return w.indexOf("/")===-1&&(w=m.toSlashes(w),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w)),d.with({path:L.posix.resolve(d.path,w)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,w){return d===w||(0,y.equalsIgnoreCase)(d,w)}hasTrailingPathSeparator(d,w=L.sep){if(d.scheme===P.Schemas.file){const I=p(d);return I.length>m.getRoot(I).length&&I[I.length-1]===w}else{const I=d.path;return I.length>1&&I.charCodeAt(I.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,w=L.sep){return(0,e.hasTrailingPathSeparator)(d,w)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,w=L.sep){let I=!1;if(d.scheme===P.Schemas.file){const b=p(d);I=b!==void 0&&b.length===m.getRoot(b).length&&b[b.length-1]===w}else{w="/";const b=d.path;I=b.length===1&&b.charCodeAt(b.length-1)===47}return!I&&!(0,e.hasTrailingPathSeparator)(d,w)?d.with({path:d.path+"/"}):d}}e.ExtUri=i,e.extUri=new i(()=>!1),e.extUriBiasedIgnorePathCase=new i(v=>v.scheme===P.Schemas.file?!r.isLinux:!0),e.extUriIgnorePathCase=new i(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function D(v,d){const w=[];for(let I=0;I<v.length;I++){const b=d(v[I]);v.some((a,c)=>c===I?!1:(0,e.isEqualOrParent)(b,d(a)))||w.push(v[I])}return w}e.distinctParents=D;var g;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function d(w){const I=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(c=>{const[l,s]=c.split(":");l&&s&&I.set(l,s)});const a=w.path.substring(0,w.path.indexOf(";"));return a&&I.set(v.META_DATA_MIME,a),I}v.parseMetaData=d})(g=e.DataUri||(e.DataUri={}));function S(v,d,w){if(d){let I=v.path;return I&&I[0]!==L.posix.sep&&(I=L.posix.sep+I),v.with({scheme:w,authority:d,path:I})}return v.with({scheme:w})}e.toLocalResource=S}),define(X[9],J([0,1,25,17,5,2,78,15]),function(q,e,m,L,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function p(N){return!!N&&typeof N.then=="function"}e.isThenable=p;function i(N){const T=new m.CancellationTokenSource,R=N(T.token),W=new Promise((M,F)=>{T.token.onCancellationRequested(()=>{F((0,L.canceled)())}),Promise.resolve(R).then(B=>{T.dispose(),M(B)},B=>{T.dispose(),F(B)})});return new class{cancel(){T.cancel()}then(M,F){return W.then(M,F)}catch(M){return this.then(void 0,M)}finally(M){return W.finally(M)}}}e.createCancelablePromise=i;function D(N,T,R){return Promise.race([N,new Promise(W=>T.onCancellationRequested(()=>W(R)))])}e.raceCancellation=D;async function g(N){let T=-1;const R=N.map((M,F)=>M.then(B=>(T=F,B))),W=await Promise.race(R);return N.forEach((M,F)=>{F!==T&&M.cancel()}),W}e.raceCancellablePromises=g;function S(N,T,R){let W;const M=setTimeout(()=>{W==null||W(void 0),R==null||R()},T);return Promise.race([N.finally(()=>clearTimeout(M)),new Promise(F=>W=F)])}e.raceTimeout=S;function v(N){return new Promise((T,R)=>{const W=N();p(W)?W.then(T,R):T(W)})}e.asPromise=v;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(T){if(this.activePromise){if(this.queuedPromiseFactory=T,!this.queuedPromise){const R=()=>{this.queuedPromise=null;const W=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,W};this.queuedPromise=new Promise(W=>{this.activePromise.then(R,R).then(W)})}return new Promise((R,W)=>{this.queuedPromise.then(R,W)})}return this.activePromise=T(),new Promise((R,W)=>{this.activePromise.then(M=>{this.activePromise=null,R(M)},M=>{this.activePromise=null,W(M)})})}}e.Throttler=d;class w{constructor(){this.current=Promise.resolve(null)}queue(T){return this.current=this.current.then(()=>T(),()=>T())}}e.Sequencer=w;class I{constructor(){this.promiseMap=new Map}queue(T,R){var W;const F=((W=this.promiseMap.get(T))!==null&&W!==void 0?W:Promise.resolve()).catch(()=>{}).then(R).finally(()=>{this.promiseMap.get(T)===F&&this.promiseMap.delete(T)});return this.promiseMap.set(T,F),F}}e.SequencerByKey=I;class b{constructor(T){this.defaultDelay=T,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(T,R=this.defaultDelay){return this.task=T,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((W,M)=>{this.doResolve=W,this.doReject=M}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const W=this.task;return this.task=null,W()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},R),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=b;class a{constructor(T){this.delayer=new b(T),this.throttler=new d}trigger(T,R){return this.delayer.trigger(()=>this.throttler.queue(T),R)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=a;class c{constructor(){this._isOpen=!1,this._promise=new Promise((T,R)=>{this._completePromise=T})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class l extends c{constructor(T){super();this._timeout=setTimeout(()=>this.open(),T)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function s(N,T){return T?new Promise((R,W)=>{const M=setTimeout(R,N);T.onCancellationRequested(()=>{clearTimeout(M),W((0,L.canceled)())})}):i(R=>s(N,R))}e.timeout=s;function t(N,T=0){const R=setTimeout(N,T);return(0,y.toDisposable)(()=>clearTimeout(R))}e.disposableTimeout=t;function n(N){return N.then(void 0,T=>{})}e.ignoreErrors=n;function o(N){const T=[];let R=0;const W=N.length;function M(){return R<W?N[R++]():null}function F(B){B!=null&&T.push(B);const V=M();return V?V.then(F):Promise.resolve(T)}return Promise.resolve(null).then(F)}e.sequence=o;function u(N,T=W=>!!W,R=null){let W=0;const M=N.length,F=()=>{if(W>=M)return Promise.resolve(R);const B=N[W++];return Promise.resolve(B()).then(G=>T(G)?Promise.resolve(G):F())};return F()}e.first=u;function h(N,T=W=>!!W,R=null){if(N.length===0)return Promise.resolve(R);let W=N.length;const M=()=>{var F,B;W=-1;for(const V of N)(B=(F=V).cancel)===null||B===void 0||B.call(F)};return new Promise((F,B)=>{for(const V of N)V.then(G=>{--W>=0&&T(G)?(M(),F(G)):W===0&&F(R)}).catch(G=>{--W>=0&&(M(),B(G))})})}e.firstParallel=h;class f{constructor(T){this._size=0,this.maxDegreeOfParalellism=T,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(T){return this._size++,new Promise((R,W)=>{this.outstandingPromises.push({factory:T,c:R,e:W}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const T=this.outstandingPromises.shift();this.runningPromises++;const R=T.factory();R.then(T.c,T.e),R.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class E extends f{constructor(){super(1)}}e.Queue=E;class A{constructor(){this.queues=new Map}queueFor(T,R=r.extUri){const W=R.getComparisonKey(T);let M=this.queues.get(W);return M||(M=new E,k.Event.once(M.onFinished)(()=>{M==null||M.dispose(),this.queues.delete(W)}),this.queues.set(W,M)),M}dispose(){this.queues.forEach(T=>T.dispose()),this.queues.clear()}}e.ResourceQueue=A;class _{constructor(T,R){this._token=-1,typeof T=="function"&&typeof R=="number"&&this.setIfNotSet(T,R)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(T,R){this.cancel(),this._token=setTimeout(()=>{this._token=-1,T()},R)}setIfNotSet(T,R){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,T()},R))}}e.TimeoutTimer=_;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(T,R){this.cancel(),this._token=setInterval(()=>{T()},R)}}e.IntervalTimer=U;class H{constructor(T,R){this.timeoutToken=-1,this.runner=T,this.timeout=R,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(T=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,T)}get delay(){return this.timeout}set delay(T){this.timeout=T}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=H;class Q extends H{constructor(T,R){super(T,R);this.units=[]}work(T){this.units.push(T),this.isScheduled()||this.schedule()}doRun(){const T=this.units;this.units=[],this.runner&&this.runner(T)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Q,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=T=>{const R=setTimeout(()=>T(N));let W=!1;return{dispose(){W||(W=!0,clearTimeout(R))}}}}else e.runWhenIdle=(N,T)=>{const R=requestIdleCallback(N,typeof T=="number"?{timeout:T}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(R))}}}}();class ne{constructor(T){this._didRun=!1,this._executor=()=>{try{this._value=T()}catch(R){this._error=R}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=ne;async function ae(N,T,R){let W;for(let M=0;M<R;M++)try{return await N()}catch(F){W=F,await s(T)}throw W}e.retry=ae;class O{hasPending(T){return this._pending?typeof T=="number"?this._pending.taskId===T:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var T;(T=this._pending)===null||T===void 0||T.cancel()}setPending(T,R,W){return this._pending={taskId:T,cancel:()=>W==null?void 0:W(),promise:R},R.then(()=>this.donePending(T),()=>this.donePending(T)),R}donePending(T){this._pending&&T===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const T=this._next;this._next=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}setNext(T){if(this._next)this._next.run=T;else{let R,W;const M=new Promise((F,B)=>{R=F,W=B});this._next={run:T,promise:M,promiseResolve:R,promiseReject:W}}return this._next.promise}}e.TaskSequentializer=O;class ${constructor(T){this.interval=T,this.lastIncrementTime=0,this.value=0}increment(){const T=Date.now();return T-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=T,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((T,R)=>{this.completeCallback=T,this.errorCallback=R})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(T){return new Promise(R=>{this.completeCallback(T),this.resolved=!0,R()})}error(T){return new Promise(R=>{this.errorCallback(T),this.rejected=!0,R()})}cancel(){new Promise(T=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,T()})}}e.DeferredPromise=z;class C extends k.Emitter{async fireAsync(T,R,W){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const M of this._listeners)this._asyncDeliveryQueue.push([M,T]);for(;this._asyncDeliveryQueue.size>0&&!R.isCancellationRequested;){const[M,F]=this._asyncDeliveryQueue.shift(),B=[],V=Object.assign(Object.assign({},F),{waitUntil:G=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");W&&(G=W(G,typeof M=="function"?M:M[0])),B.push(G)}});try{typeof M=="function"?M.call(void 0,V):M[0].call(M[1],V)}catch(G){(0,L.onUnexpectedError)(G);continue}Object.freeze(B),await j.settled(B).catch(G=>(0,L.onUnexpectedError)(G))}}}}e.AsyncEmitter=C;var j;(function(N){async function T(F){return typeof Promise.allSettled=="function"?R(F):W(F)}N.allSettled=T;async function R(F){return Promise.allSettled(F)}async function W(F){return Promise.all(F.map(B=>B.then(V=>({status:"fulfilled",value:V}),V=>({status:"rejected",reason:V}))))}async function M(F){let B;const V=await Promise.all(F.map(G=>G.then(Y=>Y,Y=>{B||(B=Y)})));if(typeof B!="undefined")throw B;return V}N.settled=M})(j=e.Promises||(e.Promises={}))}),define(X[108],J([0,1,22,30,8,36,9]),function(q,e,m,L,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function r(){return Object.create(null)}e.getEmptyExpression=r;const p="**",i="/",D="[/\\\\]",g="[^/\\\\]",S=/\//g;function v(R){switch(R){case 0:return"";case 1:return`${g}*?`;default:return`(?:${D}|${g}+${D}|${D}${g}+)*?`}}function d(R,W){if(!R)return[];const M=[];let F=!1,B=!1,V="";for(const G of R){switch(G){case W:if(!F&&!B){M.push(V),V="";continue}break;case"{":F=!0;break;case"}":F=!1;break;case"[":B=!0;break;case"]":B=!1;break}V+=G}return V&&M.push(V),M}e.splitGlobAware=d;function w(R){if(!R)return"";let W="";const M=d(R,i);if(M.every(F=>F===p))W=".*";else{let F=!1;M.forEach((B,V)=>{if(B===p){F||(W+=v(2),F=!0);return}let G=!1,Y="",Z=!1,re="";for(const se of B){if(se!=="}"&&G){Y+=se;continue}if(Z&&(se!=="]"||!re)){let x;se==="-"?x=se:(se==="^"||se==="!")&&!re?x="^":se===i?x="":x=m.escapeRegExpCharacters(se),re+=x;continue}switch(se){case"{":G=!0;continue;case"[":Z=!0;continue;case"}":W+=`(?:${d(Y,",").map(ue=>w(ue)).join("|")})`,G=!1,Y="";break;case"]":W+="["+re+"]",Z=!1,re="";break;case"?":W+=g;continue;case"*":W+=v(1);continue;default:W+=m.escapeRegExpCharacters(se)}}V<M.length-1&&(M[V+1]!==p||V+2<M.length)&&(W+=D),F=!1})}return W}const I=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new y.LRUCache(1e4),n=function(){return!1},o=function(){return null};function u(R,W){if(!R)return o;let M;typeof R!="string"?M=R.pattern:M=R,M=M.trim();const F=`${M}_${!!W.trimForExclusions}`;let B=t.get(F);if(B)return h(B,R);let V;if(I.test(M)){const G=M.substr(4);B=function(Y,Z){return typeof Y=="string"&&Y.endsWith(G)?M:null}}else(V=b.exec(f(M,W)))?B=E(V[1],M):(W.trimForExclusions?c:a).test(M)?B=A(M,W):(V=l.exec(f(M,W)))?B=_(V[1].substr(1),M,!0):(V=s.exec(f(M,W)))?B=_(V[1],M,!1):B=U(M);return t.set(F,B),h(B,R)}function h(R,W){return typeof W=="string"?R:function(M,F){return L.isEqualOrParent(M,W.base)?R(k.relative(W.base,M),F):null}}function f(R,W){return W.trimForExclusions&&R.endsWith("/**")?R.substr(0,R.length-2):R}function E(R,W){const M=`/${R}`,F=`\\${R}`,B=function(G,Y){return typeof G!="string"?null:Y?Y===R?W:null:G===R||G.endsWith(M)||G.endsWith(F)?W:null},V=[R];return B.basenames=V,B.patterns=[W],B.allBasenames=V,B}function A(R,W){const M=T(R.slice(1,-1).split(",").map(Y=>u(Y,W)).filter(Y=>Y!==o),R),F=M.length;if(!F)return o;if(F===1)return M[0];const B=function(Y,Z){for(let re=0,se=M.length;re<se;re++)if(M[re](Y,Z))return R;return null},V=M.find(Y=>!!Y.allBasenames);V&&(B.allBasenames=V.allBasenames);const G=M.reduce((Y,Z)=>Z.allPaths?Y.concat(Z.allPaths):Y,[]);return G.length&&(B.allPaths=G),B}function _(R,W,M){const F=k.sep===k.posix.sep,B=F?R:R.replace(S,k.sep),V=k.sep+B,G=k.posix.sep+R,Y=M?function(Z,re){return typeof Z=="string"&&(Z===B||Z.endsWith(V)||!F&&(Z===R||Z.endsWith(G)))?W:null}:function(Z,re){return typeof Z=="string"&&(Z===B||!F&&Z===R)?W:null};return Y.allPaths=[(M?"*/":"./")+R],Y}function U(R){try{const W=new RegExp(`^${w(R)}$`);return function(M){return W.lastIndex=0,typeof M=="string"&&W.test(M)?R:null}}catch(W){return o}}function H(R,W,M){return!R||typeof W!="string"?!1:Q(R)(W,void 0,M)}e.match=H;function Q(R,W={}){if(!R)return n;if(typeof R=="string"||$(R)){const M=u(R,W);if(M===o)return n;const F=function(B,V){return!!M(B,V)};return M.allBasenames&&(F.allBasenames=M.allBasenames),M.allPaths&&(F.allPaths=M.allPaths),F}return j(R,W)}e.parse=Q;function ne(R){if(!!R){let W;return M=>(W||(W=(R()||Promise.resolve([])).then(F=>F?O(F):{})),W.then(F=>!!F[M]))}}e.hasSiblingPromiseFn=ne;function ae(R){if(!!R){let W;return M=>{if(!W){const F=R();W=F?O(F):{}}return!!W[M]}}}e.hasSiblingFn=ae;function O(R){const W={};for(const M of R)W[M]=!0;return W}function $(R){const W=R;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=$;function z(R){return R.allBasenames||[]}e.getBasenameTerms=z;function C(R){return R.allPaths||[]}e.getPathTerms=C;function j(R,W){const M=T(Object.getOwnPropertyNames(R).map(Y=>N(Y,R[Y],W)).filter(Y=>Y!==o)),F=M.length;if(!F)return o;if(!M.some(Y=>!!Y.requiresSiblings)){if(F===1)return M[0];const Y=function(se,x){for(let ie=0,ue=M.length;ie<ue;ie++){const ye=M[ie](se,x);if(ye)return ye}return null},Z=M.find(se=>!!se.allBasenames);Z&&(Y.allBasenames=Z.allBasenames);const re=M.reduce((se,x)=>x.allPaths?se.concat(x.allPaths):se,[]);return re.length&&(Y.allPaths=re),Y}const B=function(Y,Z,re){let se;for(let x=0,ie=M.length;x<ie;x++){const ue=M[x];ue.requiresSiblings&&re&&(Z||(Z=k.basename(Y)),se||(se=Z.substr(0,Z.length-k.extname(Y).length)));const ye=ue(Y,Z,se,re);if(ye)return ye}return null},V=M.find(Y=>!!Y.allBasenames);V&&(B.allBasenames=V.allBasenames);const G=M.reduce((Y,Z)=>Z.allPaths?Y.concat(Z.allPaths):Y,[]);return G.length&&(B.allPaths=G),B}function N(R,W,M){if(W===!1)return o;const F=u(R,M);if(F===o)return o;if(typeof W=="boolean")return F;if(W){const B=W.when;if(typeof B=="string"){const V=(G,Y,Z,re)=>{if(!re||!F(G,Y))return null;const se=B.replace("$(basename)",Z),x=re(se);return(0,P.isThenable)(x)?x.then(ie=>ie?R:null):x?R:null};return V.requiresSiblings=!0,V}}return F}function T(R,W){const M=R.filter(Y=>!!Y.basenames);if(M.length<2)return R;const F=M.reduce((Y,Z)=>{const re=Z.basenames;return re?Y.concat(re):Y},[]);let B;if(W){B=[];for(let Y=0,Z=F.length;Y<Z;Y++)B.push(W)}else B=M.reduce((Y,Z)=>{const re=Z.patterns;return re?Y.concat(re):Y},[]);const V=function(Y,Z){if(typeof Y!="string")return null;if(!Z){let se;for(se=Y.length;se>0;se--){const x=Y.charCodeAt(se-1);if(x===47||x===92)break}Z=Y.substr(se)}const re=F.indexOf(Z);return re!==-1?B[re]:null};V.basenames=F,V.patterns=B,V.allBasenames=F;const G=R.filter(Y=>!Y.basenames);return G.push(V),G}}),define(X[39],J([0,1,7,8,22,10,3,15,30]),function(q,e,m,L,k,y,P,r,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function i(u,h,f){if(typeof u=="string"&&(u=m.URI.file(u)),f){const A=f.getWorkspaceFolder(u);if(A){const _=f.getWorkspace().folders.length>1;let U;if((0,r.isEqual)(A.uri,u)?U="":U=(0,r.relativePath)(A.uri,u),_){const H=A.name?A.name:(0,r.basename)(A.uri);U=U?H+" \u2022 "+U:H}return U}}if(u.scheme!==y.Schemas.file&&u.scheme!==y.Schemas.untitled)return u.with({query:null,fragment:null}).toString(!0);if((0,p.hasDriveLetter)(u.fsPath))return(0,L.normalize)(g(u.fsPath));let E=(0,L.normalize)(u.fsPath);return!P.isWindows&&(h==null?void 0:h.userHome)&&(E=v(E,h.userHome.fsPath)),E}e.getPathLabel=i;function D(u){if(!!u){typeof u=="string"&&(u=m.URI.file(u));const h=(0,r.basename)(u)||(u.scheme===y.Schemas.file?u.fsPath:u.path);return P.isWindows&&(0,p.isRootOrDriveLetter)(h)?g(h):h}}e.getBaseLabel=D;function g(u){return(0,p.hasDriveLetter)(u)?u.charAt(0).toUpperCase()+u.slice(1):u}e.normalizeDriveLetter=g;let S=Object.create(null);function v(u,h){if(P.isWindows||!u||!h)return u;let f=S.original===h?S.normalized:void 0;return f||(f=`${(0,k.rtrim)(h,L.posix.sep)}${L.posix.sep}`,S={original:h,normalized:f}),(P.isLinux?u.startsWith(f):(0,k.startsWithIgnoreCase)(u,f))&&(u=`~/${u.substr(f.length)}`),u}e.tildify=v;function d(u,h){return u.replace(/^~($|\/|\\)/,`${h}$1`)}e.untildify=d;const w="\u2026",I="\\\\",b="~";function a(u,h=L.sep){const f=new Array(u.length);let E=!1;for(let A=0;A<u.length;A++){let _=u[A];if(_===""){f[A]=`.${h}`;continue}if(!_){f[A]=_;continue}E=!0;let U="";_.indexOf(I)===0?(U=_.substr(0,_.indexOf(I)+I.length),_=_.substr(_.indexOf(I)+I.length)):_.indexOf(h)===0?(U=_.substr(0,_.indexOf(h)+h.length),_=_.substr(_.indexOf(h)+h.length)):_.indexOf(b)===0&&(U=_.substr(0,_.indexOf(b)+b.length),_=_.substr(_.indexOf(b)+b.length));const H=_.split(h);for(let Q=1;E&&Q<=H.length;Q++)for(let ne=H.length-Q;E&&ne>=0;ne--){E=!1;let ae=H.slice(ne,ne+Q).join(h);for(let O=0;!E&&O<u.length;O++)if(O!==A&&u[O]&&u[O].indexOf(ae)>-1){const $=ne+Q===H.length,z=ne>0&&u[O].indexOf(h)>-1?h+ae:ae,C=u[O].endsWith(z);E=!$||C}if(!E){let O="";(H[0].endsWith(":")||U!=="")&&(ne===1&&(ne=0,Q++,ae=H[0]+h+ae),ne>0&&(O=H[0]+h),O=U+O),ne>0&&(O=O+w+h),O=O+ae,ne+Q<H.length&&(O=O+h+w),f[A]=O}}E&&(f[A]=_)}return f}e.shorten=a;var c;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function l(u,h=Object.create(null)){const f=[];let E=!1,A="";for(const _ of u)if(_==="$"||E&&_==="{")A&&f.push({value:A,type:c.TEXT}),A="",E=!0;else if(_==="}"&&E){const U=h[A];if(typeof U=="string")U.length&&f.push({value:U,type:c.VARIABLE});else if(U){const H=f[f.length-1];(!H||H.type!==c.SEPARATOR)&&f.push({value:U.label,type:c.SEPARATOR})}A="",E=!1}else A+=_;return A&&!E&&f.push({value:A,type:c.TEXT}),f.filter((_,U)=>{if(_.type===c.SEPARATOR){const H=f[U-1],Q=f[U+1];return[H,Q].every(ne=>ne&&(ne.type===c.VARIABLE||ne.type===c.TEXT)&&ne.value.length>0)}return!0}).map(_=>_.value).join("")}e.template=l;function s(u,h){return P.isMacintosh||h?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):u.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=s;function t(u,h){return P.isMacintosh||h?u.replace(/\(&&\w\)|&&/g,""):P.isWindows?u.replace(/&&|&/g,f=>f==="&"?"&&":"&"):u.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(u){return u.replace(/&/g,"&&")}e.unmnemonicLabel=n;function o(u){const h=u.indexOf("/")!==-1?L.posix:L.win32,f=h.basename(u),E=h.dirname(u);return f.length?{name:f,parentPath:E}:{name:E,parentPath:""}}e.splitName=o}),define(X[28],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(p){return m.test(p)}e.isUUID=L;const k=new Uint8Array(16),y=[];for(let p=0;p<256;p++)y.push(p.toString(16).padStart(2,"0"));let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(p){for(let i=0;i<p.length;i++)p[i]=Math.floor(Math.random()*256);return p};function r(){P(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let p=0,i="";return i+=y[k[p++]],i+=y[k[p++]],i+=y[k[p++]],i+=y[k[p++]],i+="-",i+=y[k[p++]],i+=y[k[p++]],i+="-",i+=y[k[p++]],i+=y[k[p++]],i+="-",i+=y[k[p++]],i+=y[k[p++]],i+="-",i+=y[k[p++]],i+=y[k[p++]],i+=y[k[p++]],i+=y[k[p++]],i+=y[k[p++]],i+=y[k[p++]],i}e.generateUuid=r}),define(X[109],J([0,1,18,58,42]),function(q,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function y(P,r){if(await new Promise((D,g)=>{const S=m.createReadStream(P),v=L.createHash("sha1");S.pipe(v);const d=(0,k.once)((w,I)=>{S.removeAllListeners(),v.removeAllListeners(),w?g(w):D(I)});S.once("error",d),S.once("end",d),v.once("error",d),v.once("data",w=>d(void 0,w.toString("hex")))})!==r)throw new Error("Hash mismatch")}e.checksum=y}),define(X[81],J([0,1,231]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(y="utf8"){this.stringDecoder=new m.StringDecoder(y),this.remaining=null}write(y){const P=[],r=this.remaining?this.remaining+this.stringDecoder.write(y):this.stringDecoder.write(y);if(r.length<1)return P;let p=0,i,D=p;for(;D<r.length;)if(i=r.charCodeAt(D),i===13||i===10){if(P.push(r.substring(p,D)),D++,D<r.length){const g=i;i=r.charCodeAt(D),(g===13&&i===10||g===10&&i===13)&&D++}p=D}else D++;return this.remaining=p<r.length?r.substr(p):null,P}end(){return this.remaining}}e.LineDecoder=L}),define(X[110],J([0,1,27]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(r){const p=r.replace(/\-/g,":").toLowerCase();return!L.has(p)}function y(){return new Promise(async(r,p)=>{const i=setTimeout(()=>p("Unable to retrieve mac address (timeout after 10s)"),1e4);try{r(await P())}catch(D){p(D)}finally{clearTimeout(i)}})}e.getMac=y;function P(){return new Promise((r,p)=>{try{const i=(0,m.networkInterfaces)();for(const[,D]of Object.entries(i))for(const g of D)if(k(g.mac))return r(g.mac);p("Unable to retrieve mac address (unexpected format)")}catch(i){p(i)}})}}),define(X[65],J([0,1,17,28,27,36,110]),function(q,e,m,L,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(D){return this._virtualMachineOUIs||(this._virtualMachineOUIs=y.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(D)}value(){if(this._value===void 0){let D=0,g=0;const S=(0,k.networkInterfaces)();for(let v in S)if(Object.prototype.hasOwnProperty.call(S,v))for(const{mac:d,internal:w}of S[v])w||(g+=1,this._isVirtualMachineMacAdress(d.toUpperCase())&&(D+=1));this._value=g>0?D/g:0}return this._value}};let r;async function p(){return r||(r=(async()=>await i()||L.generateUuid())()),r}e.getMachineId=p;async function i(){try{const D=await new Promise((S,v)=>{q(["crypto"],S,v)}),g=await(0,P.getMac)();return D.createHash("sha256").update(g,"utf8").digest("hex")}catch(D){m.onUnexpectedError(D);return}}}),define(X[19],J([0,1,18,27,8,9,3,30,28,64,15,7]),function(q,e,m,L,k,y,P,r,p,i,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var S;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function v(z,C=S.UNLINK){if((0,r.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return C===S.UNLINK?w(z):d(z)}e.rimraf=v;async function d(z){try{const C=(0,k.join)((0,L.tmpdir)(),(0,p.generateUuid)());try{await m.promises.rename(z,C)}catch(j){return w(z)}w(C).catch(j=>{})}catch(C){if(C.code!=="ENOENT")throw C}}async function w(z){return m.promises.rmdir(z,{recursive:!0,maxRetries:3})}function I(z){if((0,r.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(z,{recursive:!0})}e.rimrafSync=I;async function b(z,C){return l(await(C?a(z):m.promises.readdir(z)))}e.readdir=b;async function a(z){try{return await m.promises.readdir(z,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const C=[],j=await b(z);for(const N of j){let T=!1,R=!1,W=!1;try{const M=await m.promises.lstat((0,k.join)(z,N));T=M.isFile(),R=M.isDirectory(),W=M.isSymbolicLink()}catch(M){console.warn("[node.js fs] unexpected error from lstat after readdir: ",M)}C.push({name:N,isFile:()=>T,isDirectory:()=>R,isSymbolicLink:()=>W})}return C}function c(z){return l(m.readdirSync(z))}e.readdirSync=c;function l(z){return z.map(C=>typeof C=="string"?P.isMacintosh?(0,i.normalizeNFC)(C):C:(C.name=P.isMacintosh?(0,i.normalizeNFC)(C.name):C.name,C))}async function s(z){const C=await b(z),j=[];for(const N of C)await n.existsDirectory((0,k.join)(z,N))&&j.push(N);return j}e.readDirsInDir=s;function t(z,C=1e3){return new Promise(j=>{let N=!1;const T=setInterval(()=>{N||(N=!0,m.access(z,R=>{N=!1,R&&(clearInterval(T),j(void 0))}))},C)})}e.whenDeleted=t;var n;(function(z){async function C(T){let R;try{if(R=await m.promises.lstat(T),!R.isSymbolicLink())return{stat:R}}catch(W){}try{return{stat:await m.promises.stat(T),symbolicLink:(R==null?void 0:R.isSymbolicLink())?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&R)return{stat:R,symbolicLink:{dangling:!0}};if(P.isWindows&&W.code==="EACCES")try{return{stat:await m.promises.stat(await m.promises.readlink(T)),symbolicLink:{dangling:!1}}}catch(M){if(M.code==="ENOENT"&&R)return{stat:R,symbolicLink:{dangling:!0}};throw M}throw W}}z.stat=C;async function j(T){try{const{stat:R,symbolicLink:W}=await z.stat(T);return R.isFile()&&(W==null?void 0:W.dangling)!==!0}catch(R){}return!1}z.existsFile=j;async function N(T){try{const{stat:R,symbolicLink:W}=await z.stat(T);return R.isDirectory()&&(W==null?void 0:W.dangling)!==!0}catch(R){}return!1}z.existsDirectory=N})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new y.ResourceQueue;function u(z,C,j){return o.queueFor(g.URI.file(z),D.extUriBiasedIgnorePathCase).queue(()=>{const N=A(j);return new Promise((T,R)=>f(z,C,N,W=>W?R(W):T()))})}e.writeFile=u;let h=!0;function f(z,C,j,N){if(!h)return m.writeFile(z,C,{mode:j.mode,flag:j.flag},N);m.open(z,j.flag,j.mode,(T,R)=>{if(T)return N(T);m.writeFile(R,C,W=>{if(W)return m.close(R,()=>N(W));m.fdatasync(R,M=>(M&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",M),h=!1),m.close(R,F=>N(F))))})})}function E(z,C,j){const N=A(j);if(!h)return m.writeFileSync(z,C,{mode:N.mode,flag:N.flag});const T=m.openSync(z,N.flag,N.mode);try{m.writeFileSync(T,C);try{m.fdatasyncSync(T)}catch(R){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",R),h=!1}}finally{m.closeSync(T)}}e.writeFileSync=E;function A(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function _(z,C){if(z!==C){async function j(N){try{const T=await m.promises.lstat(N);if(T.isDirectory()||T.isSymbolicLink())return;const R=await m.promises.open(N,"a");try{await R.utimes(T.atime,new Date)}finally{await R.close()}}catch(T){}}try{await m.promises.rename(z,C),await j(C)}catch(N){if(z.toLowerCase()!==C.toLowerCase()&&N.code==="EXDEV"||z.endsWith("."))await U(z,C,{preserveSymlinks:!1}),await v(z,S.MOVE),await j(C);else throw N}}}e.move=_;async function U(z,C,j){return Q(z,C,{root:{source:z,target:C},options:j,handledSourcePaths:new Set})}e.copy=U;const H=511;async function Q(z,C,j){if(!j.handledSourcePaths.has(z)){j.handledSourcePaths.add(z);const{stat:N,symbolicLink:T}=await n.stat(z);if(T){if(j.options.preserveSymlinks)try{return await O(z,C,j)}catch(R){console.warn("[node.js fs] copy of symlink failed: ",R)}if(T.dangling)return}return N.isDirectory()?ne(z,C,N.mode&H,j):ae(z,C,N.mode&H)}}async function ne(z,C,j,N){await m.promises.mkdir(C,{recursive:!0,mode:j});const T=await b(z);for(const R of T)await Q((0,k.join)(z,R),(0,k.join)(C,R),N)}async function ae(z,C,j){await m.promises.copyFile(z,C),await m.promises.chmod(C,j)}async function O(z,C,j){let N=await m.promises.readlink(z);(0,r.isEqualOrParent)(N,j.root.source,!P.isLinux)&&(N=(0,k.join)(j.root.target,N.substr(j.root.source.length+1))),await m.promises.symlink(N,C)}async function $(z){try{return await m.promises.access(z),!0}catch(C){return!1}}e.exists=$}),define(X[111],J([0,1,18,112,22,8,19]),function(q,e,m,L,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function r(g){const S=(0,y.dirname)(g);if(g===S)return g;const v=((0,y.basename)(g)||g).toLowerCase();try{const w=(0,P.readdirSync)(S).filter(I=>I.toLowerCase()===v);if(w.length===1){const I=r(S);if(I)return(0,y.join)(I,w[0])}else if(w.length>1){const I=w.indexOf(v);if(I>=0){const b=r(S);if(b)return(0,y.join)(b,w[I])}}}catch(d){}return null}e.realcaseSync=r;async function p(g){try{return await(0,L.promisify)(m.realpath)(g)}catch(S){const v=D(g);return await m.promises.access(v,m.constants.R_OK),v}}e.realpath=p;function i(g){try{return m.realpathSync(g)}catch(S){const v=D(g);return m.accessSync(v,m.constants.R_OK),v}}e.realpathSync=i;function D(g){return(0,k.rtrim)((0,y.normalize)(g),y.sep)}}),define(X[113],J([0,1,59]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=e.randomPort=void 0;function L(){const p=1025;return p+Math.floor((65535-p)*Math.random())}e.randomPort=L;function k(p,i,D){let g=!1;return new Promise(S=>{const v=setTimeout(()=>{if(!g)return g=!0,S(0)},D);y(p,i,d=>{if(!g)return g=!0,clearTimeout(v),S(d)})})}e.findFreePort=k;function y(p,i,D){if(i===0)return D(0);const g=new m.Socket;g.once("connect",()=>(r(g),y(p+1,i-1,D))),g.once("data",()=>{}),g.once("error",S=>(r(g),S.code!=="ECONNREFUSED"?y(p+1,i-1,D):D(p))),g.connect(p,"127.0.0.1")}function P(p,i,D){let g=!1,S,v=1;const d=m.createServer({pauseOnConnect:!0});function w(I,b){g||(g=!0,d.removeAllListeners(),d.close(),S&&clearTimeout(S),b(I))}return new Promise(I=>{S=setTimeout(()=>{w(0,I)},D),d.on("listening",()=>{w(p,I)}),d.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&v<i?(p++,v++,d.listen(p,"127.0.0.1")):w(0,I)}),d.on("close",()=>{w(0,I)}),d.listen(p,"127.0.0.1")})}e.findFreePortFaster=P;function r(p){try{p.removeAllListeners("connect"),p.removeAllListeners("error"),p.end(),p.destroy(),p.unref()}catch(i){console.error(i)}}});var Fe=this&&this.__await||function(q){return this instanceof Fe?(this.v=q,this):new Fe(q)},dt=this&&this.__asyncGenerator||function(q,e,m){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var L=m.apply(q,e||[]),k,y=[];return k={},P("next"),P("throw"),P("return"),k[Symbol.asyncIterator]=function(){return this},k;function P(S){L[S]&&(k[S]=function(v){return new Promise(function(d,w){y.push([S,v,d,w])>1||r(S,v)})})}function r(S,v){try{p(L[S](v))}catch(d){g(y[0][3],d)}}function p(S){S.value instanceof Fe?Promise.resolve(S.value.v).then(i,D):g(y[0][2],S)}function i(S){r("next",S)}function D(S){r("throw",S)}function g(S,v){S(v),y.shift(),y.length&&r(y[0][0],y[0][1])}},ft=this&&this.__asyncValues||function(q){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=q[Symbol.asyncIterator],m;return e?e.call(q):(q=typeof __values=="function"?__values(q):q[Symbol.iterator](),m={},L("next"),L("throw"),L("return"),m[Symbol.asyncIterator]=function(){return this},m);function L(y){m[y]=q[y]&&function(P){return new Promise(function(r,p){P=q[y](P),k(r,p,P.done,P.value)})}}function k(y,P,r,p){Promise.resolve(p).then(function(i){y({value:i,done:r})},P)}};define(X[114],J([0,1,19,27,8]),function(q,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const y=/^\d+$/,P=/^Microsoft.PowerShell_.*/,r=/^Microsoft.PowerShellPreview_.*/;var p;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(p||(p={}));let i;switch(process.arch){case"ia32":case"x32":i=1;break;case"arm":case"arm64":i=2;break;default:i=0;break}let D;process.env.PROCESSOR_ARCHITEW6432?D=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?D=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?D=1:D=0;class g{constructor(s,t,n){this.exePath=s,this.displayName=t,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await m.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:l=!1}={}){return l?i===0?process.env["ProgramFiles(x86)"]||null:D===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:l=!1,findPreview:s=!1}={}){const t=S({useAlternateBitness:l});if(!t)return null;const n=k.join(t,"PowerShell");if(!await m.SymlinkSupport.existsDirectory(n))return null;let o=-1,u=null;for(const E of await m.readdir(n)){let A=-1;if(s){const U=E.indexOf("-");if(U<0)continue;const H=E.substring(0,U);if(!y.test(H)||E.substring(U+1)!=="preview")continue;A=parseInt(H,10)}else{if(!y.test(E))continue;A=parseInt(E,10)}if(!(A<=o)){const _=k.join(n,E,"pwsh.exe");!await m.SymlinkSupport.existsFile(_)||(u=_,o=A)}}if(!u)return null;const h=t.includes("x86")?" (x86)":"",f=s?" Preview":"";return new g(u,`PowerShell${f}${h}`,!0)}async function d({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const s=k.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await m.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=l?{pwshMsixDirRegex:r,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:P,pwshMsixName:"PowerShell (Store)"};for(const o of await m.readdir(s))if(t.test(o)){const u=k.join(s,o,"pwsh.exe");return new g(u,n)}return null}function w(){const l=k.join(L.homedir(),".dotnet","tools","pwsh.exe");return new g(l,".NET Core PowerShell Global Tool")}function I(){const l=k.join(process.env.windir,i===1&&D!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new g(l,"Windows PowerShell",!0)}function b(){return dt(this,arguments,function*(){let s=yield Fe(v());s&&(yield yield Fe(s)),s=yield Fe(v({useAlternateBitness:!0})),s&&(yield yield Fe(s)),s=yield Fe(d()),s&&(yield yield Fe(s)),s=w(),s&&(yield yield Fe(s)),s=yield Fe(v({findPreview:!0})),s&&(yield yield Fe(s)),s=yield Fe(d({findPreview:!0})),s&&(yield yield Fe(s)),s=yield Fe(v({useAlternateBitness:!0,findPreview:!0})),s&&(yield yield Fe(s)),s=I(),s&&(yield yield Fe(s))})}function a(){return dt(this,arguments,function*(){var s,t;try{for(var n=ft(b()),o;o=yield Fe(n.next()),!o.done;){const u=o.value;(yield Fe(u.exists()))&&(yield yield Fe(u))}}catch(u){s={error:u}}finally{try{o&&!o.done&&(t=n.return)&&(yield Fe(t.call(n)))}finally{if(s)throw s.error}}})}e.enumeratePowerShellInstallations=a;async function c(){var l,s;try{for(var t=ft(a()),n;n=await t.next(),!n.done;)return n.value}catch(o){l={error:o}}finally{try{n&&!n.done&&(s=t.return)&&await s.call(t)}finally{if(l)throw l.error}}return null}e.getFirstAvailablePowerShellInstallation=c}),define(X[82],J([0,1,45,10]),function(q,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(P){return new Promise((r,p)=>{let i;const D=new Map;function g(d,w,I,b,a){const c=D.get(w);if(d===P||c){const l={name:S(I),cmd:I,pid:d,ppid:w,load:b,mem:a};D.set(d,l),d===P&&(i=l),c&&(c.children||(c.children=[]),c.children.push(l),c.children.length>1&&(c.children=c.children.sort((s,t)=>s.pid-t.pid)))}}function S(d){const w=/--disable-blink-features=Auxclick/,I=/\\watcher\\win32\\CodeHelper\.exe/,b=/--crashes-directory/,a=/\\pipe\\winpty-control/,c=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(I.exec(d))return"watcherService ";if(b.exec(d))return"electron-crash-reporter";if(a.exec(d))return"winpty-process";if(c.exec(d))return"console-window-host (Windows internal process)";let s=l.exec(d);if(s&&s.length===2)return s[1]==="renderer"?w.exec(d)?"shared-process":"window":s[1];const t=/[a-zA-Z-]+\.js/g;let n="";do s=t.exec(d),s&&(n+=s+" ");while(s);return n&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron_node ${n}`:d}if(process.platform==="win32"){const d=w=>w.indexOf("\\\\?\\")===0||w.indexOf("\\??\\")===0?w.substr(4):w.indexOf('"\\\\?\\')===0||w.indexOf('"\\??\\')===0?'"'+w.substr(5):w;new Promise((w,I)=>{q(["windows-process-tree"],w,I)}).then(w=>{w.getProcessList(P,I=>{w.getProcessCpuUsage(I,b=>{const a=new Map;b.forEach(c=>{const l=d(c.commandLine||"");a.set(c.pid,{name:S(l),cmd:l,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),i=a.get(P),i?(a.forEach(c=>{const l=a.get(c.ppid);l&&(l.children||(l.children=[]),l.children.push(c))}),a.forEach(c=>{c.children&&(c.children=c.children.sort((l,s)=>l.pid-s.pid))}),r(i)):p(new Error(`Root process ${P} not found`))})},w.ProcessDataFlag.CommandLine|w.ProcessDataFlag.Memory)})}else{function v(){let d=[i];const w=[];for(;d.length;){const b=d.shift();b&&(w.push(b.pid),b.children&&(d=d.concat(b.children)))}let I=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",q).fsPath);I+=" "+w.join(" "),(0,m.exec)(I,{},(b,a,c)=>{if(b||c)p(b||new Error(c.toString()));else{const l=a.toString().split(`
`);for(let s=0;s<w.length;s++){const t=D.get(w[s]);t.load=parseFloat(l[s])}if(!i){p(new Error(`Root process ${P} not found`));return}r(i)}})}(0,m.exec)("which ps",{},(d,w,I)=>{if(d||I)if(process.platform!=="linux")p(d||new Error(I.toString()));else{const b=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",q).fsPath);(0,m.exec)(b,{},(a,c,l)=>{a||l?p(a||new Error(l.toString())):(y(c,g),v())})}else{const b=w.toString().trim(),a="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,m.exec)(`${b} ${a}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,l,s)=>{c||s&&!s.includes("screen size is bogus")?p(c||new Error(s.toString())):(y(l,g),process.platform==="linux"?v():i?r(i):p(new Error(`Root process ${P} not found`)))})}})}})}e.listProcesses=k;function y(P,r){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,i=P.toString().split(`
`);for(const D of i){const g=p.exec(D.trim());g&&g.length===6&&r(parseInt(g[1]),parseInt(g[2]),g[5],parseFloat(g[3]),parseFloat(g[4]))}}}),define(X[115],J([0,1,8,18,3,64,2,19]),function(q,e,m,L,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function p(g,S,v){return D({path:g,isDirectory:!1},S,v)}e.watchFile=p;function i(g,S,v){return D({path:g,isDirectory:!0},S,v)}e.watchFolder=i,e.CHANGE_BUFFER_DELAY=100;function D(g,S,v){const d=(0,m.basename)(g.path),w=new Map;let I=!1,b=[(0,P.toDisposable)(()=>{w.forEach(a=>(0,P.dispose)(a)),w.clear()})];try{const a=(0,L.watch)(g.path);b.push((0,P.toDisposable)(()=>{a.removeAllListeners(),a.close()}));const c=new Set;g.isDirectory&&(0,r.readdir)(g.path).then(l=>l.forEach(s=>c.add(s))),a.on("error",(l,s)=>{I||v(`Failed to watch ${g.path} for changes using fs.watch() (${l}, ${s})`)}),a.on("change",(l,s)=>{if(!I){let t="";if(s&&(t=s.toString(),k.isMacintosh&&(t=(0,y.normalizeNFC)(t))),!(!t||l!=="change"&&l!=="rename")){const n=g.isDirectory?(0,m.join)(g.path,t):g.path;if(g.isDirectory)if(l==="rename"){const o=w.get(n);o&&(0,P.dispose)(o);const u=setTimeout(async()=>{w.delete(n);const h=await(0,r.exists)(n);if(!I){let f;h?c.has(t)?f="changed":(f="added",c.add(t)):(c.delete(t),f="deleted"),S(f,n)}},e.CHANGE_BUFFER_DELAY);w.set(n,(0,P.toDisposable)(()=>clearTimeout(u)))}else{let o;c.has(t)?o="changed":(o="added",c.add(t)),S(o,n)}else if(l==="rename"||t!==d){const o=setTimeout(async()=>{const u=await(0,r.exists)(n);I||(u?(S("changed",n),b=[D(g,S,v)]):S("deleted",n))},e.CHANGE_BUFFER_DELAY);(0,P.dispose)(b),b=[(0,P.toDisposable)(()=>clearTimeout(o))]}else S("changed",n)}}})}catch(a){(0,r.exists)(g.path).then(c=>{c&&!I&&v(`Failed to watch ${g.path} for changes using fs.watch() (${a.toString()})`)})}return(0,P.toDisposable)(()=>{I=!0,b=(0,P.dispose)(b)})}}),define(X[116],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(X[117],J([0,1,13,116,12]),function(q,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function y(){m.ipcMain.on(L.CONTEXT_MENU_CHANNEL,(r,p,i,D,g)=>{const S=P(r,D,i);S.popup({window:(0,k.withNullAsUndefined)(m.BrowserWindow.fromWebContents(r.sender)),x:g?g.x:void 0,y:g?g.y:void 0,positioningItem:g?g.positioningItem:void 0,callback:()=>{S&&r.sender.send(L.CONTEXT_MENU_CLOSE_CHANNEL,p)}})})}e.registerContextMenuListener=y;function P(r,p,i){const D=new m.Menu;return i.forEach(g=>{let S;g.type==="separator"?S=new m.MenuItem({type:g.type}):Array.isArray(g.submenu)?S=new m.MenuItem({submenu:P(r,p,g.submenu),label:g.label}):S=new m.MenuItem({label:g.label,type:g.type,accelerator:g.accelerator,checked:g.checked,enabled:g.enabled,visible:g.visible,click:(v,d,w)=>r.sender.send(p,g.id,w)}),D.append(S)}),D}}),define(X[33],J([0,1,5,2,9,25,17,23,35,12,107,22]),function(q,e,m,L,k,y,P,r,p,i,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var S;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(S=e.RequestType||(e.RequestType={}));function v(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function w(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var I;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(I||(I={}));class b{constructor(T){this.buffer=T,this.pos=0}read(T){const R=this.buffer.slice(this.pos,this.pos+T);return this.pos+=R.byteLength,R}}class a{constructor(){this.buffers=[]}get buffer(){return r.VSBuffer.concat(this.buffers)}write(T){this.buffers.push(T)}}var c;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object"})(c||(c={}));function l(N){const T=r.VSBuffer.alloc(4);return T.writeUInt32BE(N,0),T}function s(N){return N.read(4).readUInt32BE(0)}function t(N){const T=r.VSBuffer.alloc(1);return T.writeUInt8(N,0),T}const n={Undefined:t(c.Undefined),String:t(c.String),Buffer:t(c.Buffer),VSBuffer:t(c.VSBuffer),Array:t(c.Array),Object:t(c.Object)},o=typeof Buffer!="undefined";function u(N,T){if(typeof T=="undefined")N.write(n.Undefined);else if(typeof T=="string"){const R=r.VSBuffer.fromString(T);N.write(n.String),N.write(l(R.byteLength)),N.write(R)}else if(o&&Buffer.isBuffer(T)){const R=r.VSBuffer.wrap(T);N.write(n.Buffer),N.write(l(R.byteLength)),N.write(R)}else if(T instanceof r.VSBuffer)N.write(n.VSBuffer),N.write(l(T.byteLength)),N.write(T);else if(Array.isArray(T)){N.write(n.Array),N.write(l(T.length));for(const R of T)u(N,R)}else{const R=r.VSBuffer.fromString(JSON.stringify(T));N.write(n.Object),N.write(l(R.byteLength)),N.write(R)}}function h(N){switch(N.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return N.read(s(N)).toString();case c.Buffer:return N.read(s(N)).buffer;case c.VSBuffer:return N.read(s(N));case c.Array:{const R=s(N),W=[];for(let M=0;M<R;M++)W.push(h(N));return W}case c.Object:return JSON.parse(N.read(s(N)).toString())}}class f{constructor(T,R,W=null,M=1e3){this.protocol=T,this.ctx=R,this.logger=W,this.timeoutDelay=M,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(F=>this.onRawMessage(F)),this.sendResponse({type:200})}registerChannel(T,R){this.channels.set(T,R),setTimeout(()=>this.flushPendingRequests(T),0)}sendResponse(T){switch(T.type){case 200:{const R=this.send([T.type]);this.logger&&this.logger.logOutgoing(R,0,1,w(T.type));return}case 201:case 202:case 204:case 203:{const R=this.send([T.type,T.id],T.data);this.logger&&this.logger.logOutgoing(R,T.id,1,w(T.type),T.data);return}}}send(T,R=void 0){const W=new a;return u(W,T),u(W,R),this.sendBuffer(W.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch(R){return 0}}onRawMessage(T){const R=new b(T),W=h(R),M=h(R),F=W[0];switch(F){case 100:return this.logger&&this.logger.logIncoming(T.byteLength,W[1],1,`${v(F)}: ${W[2]}.${W[3]}`,M),this.onPromise({type:F,id:W[1],channelName:W[2],name:W[3],arg:M});case 102:return this.logger&&this.logger.logIncoming(T.byteLength,W[1],1,`${v(F)}: ${W[2]}.${W[3]}`,M),this.onEventListen({type:F,id:W[1],channelName:W[2],name:W[3],arg:M});case 101:return this.logger&&this.logger.logIncoming(T.byteLength,W[1],1,`${v(F)}`),this.disposeActiveRequest({type:F,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(T.byteLength,W[1],1,`${v(F)}`),this.disposeActiveRequest({type:F,id:W[1]})}}onPromise(T){const R=this.channels.get(T.channelName);if(!R){this.collectPendingRequest(T);return}const W=new y.CancellationTokenSource;let M;try{M=R.call(this.ctx,T.name,T.arg,W.token)}catch(V){M=Promise.reject(V)}const F=T.id;M.then(V=>{this.sendResponse({id:F,data:V,type:201}),this.activeRequests.delete(T.id)},V=>{V instanceof Error?this.sendResponse({id:F,data:{message:V.message,name:V.name,stack:V.stack?V.stack.split?V.stack.split(`
`):V.stack:void 0},type:202}):this.sendResponse({id:F,data:V,type:203}),this.activeRequests.delete(T.id)});const B=(0,L.toDisposable)(()=>W.cancel());this.activeRequests.set(T.id,B)}onEventListen(T){const R=this.channels.get(T.channelName);if(!R){this.collectPendingRequest(T);return}const W=T.id,F=R.listen(this.ctx,T.name,T.arg)(B=>this.sendResponse({id:W,data:B,type:204}));this.activeRequests.set(T.id,F)}disposeActiveRequest(T){const R=this.activeRequests.get(T.id);R&&(R.dispose(),this.activeRequests.delete(T.id))}collectPendingRequest(T){let R=this.pendingRequests.get(T.channelName);R||(R=[],this.pendingRequests.set(T.channelName,R));const W=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.sendResponse({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);R.push({request:T,timeoutTimer:W})}flushPendingRequests(T){const R=this.pendingRequests.get(T);if(R){for(const W of R)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(T)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(T=>T.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var E;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(E=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(T,R=null){this.protocol=T,this.isDisposed=!1,this.state=I.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=R}getChannel(T){const R=this;return{call(W,M,F){return R.isDisposed?Promise.reject(P.canceled()):R.requestPromise(T,W,M,F)},listen(W,M){return R.isDisposed?Promise.reject(P.canceled()):R.requestEvent(T,W,M)}}}requestPromise(T,R,W,M=y.CancellationToken.None){const F=this.lastRequestId++,V={id:F,type:100,channelName:T,name:R,arg:W};if(M.isCancellationRequested)return Promise.reject(P.canceled());let G;return new Promise((Z,re)=>{if(M.isCancellationRequested)return re(P.canceled());const se=()=>{const ye=ge=>{switch(ge.type){case 201:this.handlers.delete(F),Z(ge.data);break;case 202:this.handlers.delete(F);const Ee=new Error(ge.data.message);Ee.stack=ge.data.stack,Ee.name=ge.data.name,re(Ee);break;case 203:this.handlers.delete(F),re(ge.data);break}};this.handlers.set(F,ye),this.sendRequest(V)};let x=null;this.state===I.Idle?se():(x=(0,k.createCancelablePromise)(ye=>this.whenInitialized()),x.then(()=>{x=null,se()}));const ie=()=>{x?(x.cancel(),x=null):this.sendRequest({id:F,type:101}),re(P.canceled())},ue=M.onCancellationRequested(ie);G=(0,L.combinedDisposable)((0,L.toDisposable)(ie),ue),this.activeRequests.add(G)}).finally(()=>{this.activeRequests.delete(G)})}requestEvent(T,R,W){const M=this.lastRequestId++,B={id:M,type:102,channelName:T,name:R,arg:W};let V=null;const G=new m.Emitter({onFirstListenerAdd:()=>{V=(0,k.createCancelablePromise)(Z=>this.whenInitialized()),V.then(()=>{V=null,this.activeRequests.add(G),this.sendRequest(B)})},onLastListenerRemove:()=>{V?(V.cancel(),V=null):(this.activeRequests.delete(G),this.sendRequest({id:M,type:103}))}}),Y=Z=>G.fire(Z.data);return this.handlers.set(M,Y),G.event}sendRequest(T){switch(T.type){case 100:case 102:{const R=this.send([T.type,T.id,T.channelName,T.name],T.arg);this.logger&&this.logger.logOutgoing(R,T.id,0,`${v(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const R=this.send([T.type,T.id]);this.logger&&this.logger.logOutgoing(R,T.id,0,v(T.type));return}}}send(T,R=void 0){const W=new a;return u(W,T),u(W,R),this.sendBuffer(W.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch(R){return 0}}onBuffer(T){const R=new b(T),W=h(R),M=h(R),F=W[0];switch(F){case 200:return this.logger&&this.logger.logIncoming(T.byteLength,0,0,w(F)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(T.byteLength,W[1],0,w(F),M),this.onResponse({type:W[0],id:W[1],data:M})}}onResponse(T){if(T.type===200){this.state=I.Idle,this._onDidInitialize.fire();return}const R=this.handlers.get(T.id);R&&R(T)}whenInitialized(){return this.state===I.Idle?Promise.resolve():m.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(T=>T.dispose()),this.activeRequests.clear()}}e.ChannelClient=A;class _{constructor(T){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,T(({protocol:R,onDidClientDisconnect:W})=>{m.Event.once(R.onMessage)(F=>{const B=new b(F),V=h(B),G=new f(R,V),Y=new A(R);this.channels.forEach((re,se)=>G.registerChannel(se,re));const Z={channelServer:G,channelClient:Y,ctx:V};this._connections.add(Z),this._onDidAddConnection.fire(Z),W(()=>{G.dispose(),Y.dispose(),this._connections.delete(Z),this._onDidRemoveConnection.fire(Z)})})})}get connections(){const T=[];return this._connections.forEach(R=>T.push(R)),T}getChannel(T,R){const W=this;return{call(M,F,B){let V;if((0,i.isFunction)(R)){let Y=(0,p.getRandomElement)(W.connections.filter(R));V=Y?Promise.resolve(Y):m.Event.toPromise(m.Event.filter(W.onDidAddConnection,R))}else V=R.routeCall(W,M,F);const G=V.then(Y=>Y.channelClient.getChannel(T));return H(G).call(M,F,B)},listen(M,F){if((0,i.isFunction)(R))return W.getMulticastEvent(T,R,M,F);const B=R.routeEvent(W,M,F).then(V=>V.channelClient.getChannel(T));return H(B).listen(M,F)}}}getMulticastEvent(T,R,W,M){const F=this;let B=new L.DisposableStore;const V=new m.Emitter({onFirstListenerAdd:()=>{B=new L.DisposableStore;const G=new m.EventMultiplexer,Y=new Map,Z=se=>{const ie=se.channelClient.getChannel(T).listen(W,M),ue=G.add(ie);Y.set(se,ue)},re=se=>{const x=Y.get(se);!x||(x.dispose(),Y.delete(se))};F.connections.filter(R).forEach(Z),m.Event.filter(F.onDidAddConnection,R)(Z,void 0,B),F.onDidRemoveConnection(re,void 0,B),G.event(V.fire,V,B),B.add(G)},onLastListenerRemove:()=>{B.dispose()}});return V.event}registerChannel(T,R){this.channels.set(T,R),this._connections.forEach(W=>{W.channelServer.registerChannel(T,R)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class U{constructor(T,R,W=null){const M=new a;u(M,R),T.send(M.buffer),this.channelClient=new A(T,W),this.channelServer=new f(T,R,W)}getChannel(T){return this.channelClient.getChannel(T)}registerChannel(T,R){this.channelServer.registerChannel(T,R)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function H(N){return{call(T,R,W){return N.then(M=>M.call(T,R,W))},listen(T,R){const W=new m.Relay;return N.then(M=>W.input=M.listen(T,R)),W.event}}}e.getDelayedChannel=H;function Q(N){let T=!1;return{call(R,W,M){return T?N.call(R,W,M):(0,k.timeout)(0).then(()=>T=!0).then(()=>N.call(R,W,M))},listen(R,W){if(T)return N.listen(R,W);const M=new m.Relay;return(0,k.timeout)(0).then(()=>T=!0).then(()=>M.input=N.listen(R,W)),M.event}}}e.getNextTickChannel=Q;class ne{constructor(T){this.fn=T}routeCall(T){return this.route(T)}routeEvent(T){return this.route(T)}async route(T){for(const R of T.connections)if(await Promise.resolve(this.fn(R.ctx)))return Promise.resolve(R);return await m.Event.toPromise(T.onDidAddConnection),await this.route(T)}}e.StaticRouter=ne;var ae;(function(N){function T(M,F){const B=M,V=F&&F.disableMarshalling,G=new Map;for(const Y in B)W(Y)&&G.set(Y,m.Event.buffer(B[Y],!0));return new class{listen(Y,Z){const re=G.get(Z);if(re)return re;throw new Error(`Event not found: ${Z}`)}call(Y,Z,re){const se=B[Z];if(typeof se=="function"){if(!V&&Array.isArray(re))for(let x=0;x<re.length;x++)re[x]=(0,D.revive)(re[x]);return se.apply(B,re)}throw new Error(`Method not found: ${Z}`)}}}N.fromService=T;function R(M,F){const B=F&&F.disableMarshalling;return new Proxy({},{get(V,G){var Y;if(typeof G=="string")return((Y=F==null?void 0:F.properties)===null||Y===void 0?void 0:Y.has(G))?F.properties.get(G):W(G)?M.listen(G):async function(...Z){let re;F&&!(0,i.isUndefinedOrNull)(F.context)?re=[F.context,...Z]:re=Z;const se=await M.call(G,re);return B?se:(0,D.revive)(se)};throw new Error(`Property not found: ${String(G)}`)}})}N.toService=R;function W(M){return M[0]==="o"&&M[1]==="n"&&g.isUpperAsciiLetter(M.charCodeAt(2))}})(ae=e.ProxyChannel||(e.ProxyChannel={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){let T=N.toString();if(T!=="[object Object]")return T}return N}function z(N){return Array.isArray(N)?N.map($):$(N)}function C(N,T,R,W,M,F,B){B=z(B);const V=O[M],G=V[W%V.length];let Y=[`%c[${N}]%c[${String(T).padStart(7," ")}]%c[len: ${String(R).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${F}`,"color: darkgreen","color: grey","color: grey",`color: ${G}`];/\($/.test(F)?(Y=Y.concat(B),Y.push(")")):Y.push(B),console.log.apply(console,Y)}e.logWithColors=C;class j{constructor(T,R){this._outgoingPrefix=T,this._incomingPrefix=R,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(T,R,W,M,F){this._totalOutgoing+=T,C(this._outgoingPrefix,this._totalOutgoing,T,R,W,M,F)}logIncoming(T,R,W,M,F){this._totalIncoming+=T,C(this._incomingPrefix,this._totalIncoming,T,R,W,M,F)}}e.IPCLogger=j}),define(X[118],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class m{constructor(k,y){this.sender=k,this.onMessage=y}send(k){try{this.sender.send("vscode:message",k.buffer)}catch(y){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=m}),define(X[119],J([0,1,5,33,23]),function(q,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class y{constructor(p){this.port=p,this.onMessage=m.Event.fromDOMEventEmitter(this.port,"message",i=>k.VSBuffer.wrap(i.data)),p.start()}send(p){this.port.postMessage(p.buffer)}disconnect(){this.port.close()}}e.Protocol=y;class P extends L.IPCClient{constructor(p,i){const D=new y(p);super(D,i);this.protocol=D}dispose(){this.protocol.disconnect()}}e.Client=P}),define(X[83],J([0,1,5,33,2,23,3,32]),function(q,e,m,L,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let p=null;function i(){return p||(p=y.VSBuffer.alloc(0)),p}class D{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,u){if(o===0)return i();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const A=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=o),A}if(this._chunks[0].byteLength>o){const A=this._chunks[0].slice(0,o);return u&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),A}let h=y.VSBuffer.alloc(o),f=0,E=0;for(;o>0;){const A=this._chunks[E];if(A.byteLength>o){const _=A.slice(0,o);h.set(_,f),f+=o,u&&(this._chunks[E]=A.slice(o),this._totalLength-=o),o-=o}else h.set(A,f),f+=A.byteLength,u?(this._chunks.shift(),this._totalLength-=A.byteLength):E++,o-=A.byteLength}return h}}e.ChunkStream=D;var g;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(g||(g={}));var S;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(S=e.ProtocolConstants||(e.ProtocolConstants={}));class v{constructor(o,u,h,f){this.type=o,this.id=u,this.ack=h,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends k.Disposable{constructor(o){super();this._onMessage=this._register(new m.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new D,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5);else{const h=this._state.messageType,f=this._state.id,E=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new v(h,f,E,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class w{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(!this._isDisposed){o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=y.VSBuffer.alloc(13);u.writeUInt8(o.type,0),u.writeUInt32BE(o.id,1),u.writeUInt32BE(o.ack,5),u.writeUInt32BE(o.data.byteLength,9),this._writeSoon(u,o.data)}}_bufferAdd(o,u){const h=this._totalLength===0;return this._data.push(o,u),this._totalLength+=o.byteLength+u.byteLength,h}_bufferTake(){const o=y.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,u){this._bufferAdd(o,u)&&P.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class I extends k.Disposable{constructor(o){super();this._onMessage=new m.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new m.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new w(this._socket)),this._socketReader=this._register(new d(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new v(1,0,0,o))}}e.Protocol=I;class b extends L.IPCClient{constructor(o,u,h=null){super(o,u,h);this.protocol=o}static fromSocket(o,u){return new b(new I(o),u)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=b;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new m.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,r.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class c{constructor(o){this.data=o,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],u=0,h=this._first;for(;h;)o[u++]=h.data,h=h.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const u=new c(o);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class s{constructor(){this.lastRuns=[];const o=Date.now();for(let u=0;u<s._HISTORY_LENGTH;u++)this.lastRuns[u]=o-1e3*u;setInterval(()=>{for(let u=s._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}load(){const o=Date.now(),u=(1+s._HISTORY_LENGTH)*1e3;let h=0;for(let f=0;f<s._HISTORY_LENGTH;f++)o-this.lastRuns[f]<=u&&h++;return 1-h/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class t{constructor(o,u=null){this._loadEstimator=s.getInstance(),this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),u&&this._socketReader.acceptChunk(u),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new v(5,0,0,i());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const u=new v(4,0,0,i());this._socketWriter.write(u),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,u){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let u=0,h=o.length;u<h;u++)this._socketWriter.write(o[u]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new v(6,0,0,i())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const u=this._outgoingUnackMsg.toArray();for(let h=0,f=u.length;h<f;h++)this._socketWriter.write(u[h]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const h=new v(1,u,this._incomingAckId,o);this._outgoingUnackMsg.push(h),this._isReconnecting||(this._socketWriter.write(h),this._recvAckCheck())}sendControl(o){const u=new v(2,0,0,o);this._socketWriter.write(u)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const o=this._outgoingUnackMsg.peek(),u=Date.now()-o.writtenTime;if(u>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-u,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const o=new v(3,0,this._incomingAckId,i());this._socketWriter.write(o)}}}e.PersistentProtocol=t}),define(X[120],J([0,1,13,5,33,118,2,23]),function(q,e,m,L,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function p(D,g){const S=L.Event.fromNodeEventEmitter(m.ipcMain,g,(d,w)=>({event:d,message:w})),v=L.Event.filter(S,({event:d})=>d.sender.id===D);return L.Event.map(v,({message:d})=>d&&r.VSBuffer.wrap(d))}class i extends k.IPCServer{constructor(){super(i.getOnDidClientConnect())}static getOnDidClientConnect(){const g=L.Event.fromNodeEventEmitter(m.ipcMain,"vscode:hello",({sender:S})=>S);return L.Event.map(g,S=>{const v=S.id,d=i.Clients.get(v);d&&d.dispose();const w=new L.Emitter;i.Clients.set(v,(0,P.toDisposable)(()=>w.fire()));const I=p(v,"vscode:message"),b=L.Event.any(L.Event.signal(p(v,"vscode:disconnect")),w.event);return{protocol:new y.Protocol(S,I),onDidClientDisconnect:b}})}}e.Server=i,i.Clients=new Map}),define(X[84],J([0,1,13,5,28,119]),function(q,e,m,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class P extends y.Client{constructor(i,D){super({addEventListener:(g,S)=>i.addListener(g,S),removeEventListener:(g,S)=>i.removeListener(g,S),postMessage:g=>i.postMessage(g),start:()=>i.start(),close:()=>i.close()},D)}}e.Client=P;async function r(p){if(p.isDestroyed()||p.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const i=(0,k.generateUuid)();p.webContents.send("vscode:createMessageChannel",i);const D=L.Event.fromNodeEventEmitter(m.ipcMain,"vscode:createMessageChannelResult",(S,v)=>({nonce:v,port:S.ports[0]})),{port:g}=await L.Event.toPromise(L.Event.once(L.Event.filter(D,S=>S.nonce===i)));return g}e.connect=r}),define(X[85],J([0,1,2,5,9,12]),function(q,e,m,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var P;(function(D){D[D.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(P=e.StorageHint||(e.StorageHint={}));var r;(function(D){D[D.None=0]="None",D[D.Initialized=1]="Initialized",D[D.Closed=2]="Closed"})(r||(r={}));class p extends m.Disposable{constructor(g,S=Object.create(null)){super();this.database=g,this.options=S,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=r.None,this.cache=new Map,this.flushDelayer=new k.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){var S,v;(S=g.changed)===null||S===void 0||S.forEach((d,w)=>this.accept(w,d)),(v=g.deleted)===null||v===void 0||v.forEach(d=>this.accept(d,void 0))}accept(g,S){if(this.state!==r.Closed){let v=!1;(0,y.isUndefinedOrNull)(S)?v=this.cache.delete(g):this.cache.get(g)!==S&&(this.cache.set(g,S),v=!0),v&&this._onDidChangeStorage.fire(g)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===r.None&&(this.state=r.Initialized,this.options.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,S){const v=this.cache.get(g);return(0,y.isUndefinedOrNull)(v)?S:v}getBoolean(g,S){const v=this.get(g);return(0,y.isUndefinedOrNull)(v)?S:v==="true"}getNumber(g,S){const v=this.get(g);return(0,y.isUndefinedOrNull)(v)?S:parseInt(v,10)}async set(g,S){if(this.state!==r.Closed){if((0,y.isUndefinedOrNull)(S))return this.delete(g);const v=String(S);if(this.cache.get(g)!==v)return this.cache.set(g,v),this.pendingInserts.set(g,v),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(g){if(this.state!==r.Closed&&!!this.cache.delete(g))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=r.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(g){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{var S;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(S=this.whenFlushedCallbacks.pop())===null||S===void 0||S()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=p,p.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((S,v)=>this.items.set(v,S)),g.delete&&g.delete.forEach(S=>this.items.delete(S))}async close(){}}e.InMemoryStorageDatabase=i}),define(X[121],J([0,1,18,5,9,36,8,19]),function(q,e,m,L,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class p{constructor(g,S=Object.create(null)){this.path=g,this.options=S,this.name=(0,P.basename)(this.path),this.logger=new i(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return L.Event.None}async getItems(){const g=await this.whenConnected,S=new Map;return(await this.all(g,"SELECT * FROM ItemTable")).forEach(d=>S.set(d.key,d.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${S.size} rows`),S}async updateItems(g){const S=await this.whenConnected;return this.doUpdateItems(S,g)}doUpdateItems(g,S){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${S.insert?(0,y.mapToString)(S.insert):"0"}), delete(${S.delete?(0,y.setToString)(S.delete):"0"})`),this.transaction(g,()=>{const v=S.insert,d=S.delete;if(v&&v.size>0){const w=[];w.push([]);let I=0;v.forEach((b,a)=>{let c=w[I];c.length>p.MAX_HOST_PARAMETERS&&(I++,c=[],w.push(c)),c.push(a,b)}),w.forEach(b=>{this.prepare(g,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,a=>a.run(b),()=>{const a=[];let c=0;return v.forEach((l,s)=>{a.push(s),c+=l.length}),`Keys: ${a.join(", ")} Length: ${c}`})})}if(d&&d.size){const w=[];w.push([]);let I=0;d.forEach(b=>{let a=w[I];a.length>p.MAX_HOST_PARAMETERS&&(I++,a=[],w.push(a)),a.push(b)}),w.forEach(b=>{this.prepare(g,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,a=>a.run(b),()=>{const a=[];return d.forEach(c=>{a.push(c)}),`Keys: ${a.join(", ")}`})})}})}async close(g){this.logger.trace(`[storage ${this.name}] close()`);const S=await this.whenConnected;return this.doClose(S,g)}doClose(g,S){return new Promise((v,d)=>{g.db.close(w=>(w&&this.handleSQLiteError(g,`[storage ${this.name}] close(): ${w}`),this.path===p.IN_MEMORY_PATH?v():!g.isErroneous&&!g.isInMemory?this.backup().then(v,I=>(this.logger.error(`[storage ${this.name}] backup(): ${I}`),v())):typeof S=="function"?m.promises.unlink(this.path).then(()=>this.doConnect(this.path).then(I=>{const b=()=>this.doClose(I,void 0);return this.doUpdateItems(I,{insert:S()}).then(()=>b(),a=>(b(),Promise.reject(a)))})).then(v,d):d(w||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const g=this.toBackupPath(this.path);return(0,r.copy)(this.path,g,{preserveSymlinks:!1})}toBackupPath(g){return`${g}.backup`}async checkIntegrity(g){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${g})`);const S=await this.whenConnected,v=await this.get(S,g?"PRAGMA integrity_check":"PRAGMA quick_check"),d=g?v.integrity_check:v.quick_check;return S.isErroneous?`${d} (last error: ${S.lastError})`:S.isInMemory?`${d} (in-memory!)`:d}async connect(g,S=!0){this.logger.trace(`[storage ${this.name}] open(${g}, retryOnBusy: ${S})`);try{return await this.doConnect(g)}catch(v){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${v}`),v.code==="SQLITE_BUSY"&&S)return await(0,k.timeout)(p.BUSY_OPEN_TIMEOUT),this.connect(g,!1);try{await m.promises.unlink(g);try{await m.promises.rename(this.toBackupPath(g),g)}catch(d){}return await this.doConnect(g)}catch(d){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${d}`),this.doConnect(p.IN_MEMORY_PATH)}}}handleSQLiteError(g,S){g.isErroneous=!0,g.lastError=S,this.logger.error(S)}doConnect(g){return new Promise((S,v)=>{new Promise((d,w)=>{q(["vscode-sqlite3"],d,w)}).then(d=>{const w={db:new(this.logger.isTracing?d.verbose().Database:d.Database)(g,I=>I?w.db?w.db.close(()=>v(I)):v(I):this.exec(w,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>S(w),b=>w.db.close(()=>v(b)))),isInMemory:g===p.IN_MEMORY_PATH};w.db.on("error",I=>this.handleSQLiteError(w,`[storage ${this.name}] Error (event): ${I}`)),this.logger.isTracing&&w.db.on("trace",I=>this.logger.trace(`[storage ${this.name}] Trace (event): ${I}`))},v)})}exec(g,S){return new Promise((v,d)=>{g.db.exec(S,w=>w?(this.handleSQLiteError(g,`[storage ${this.name}] exec(): ${w}`),d(w)):v())})}get(g,S){return new Promise((v,d)=>{g.db.get(S,(w,I)=>w?(this.handleSQLiteError(g,`[storage ${this.name}] get(): ${w}`),d(w)):v(I))})}all(g,S){return new Promise((v,d)=>{g.db.all(S,(w,I)=>w?(this.handleSQLiteError(g,`[storage ${this.name}] all(): ${w}`),d(w)):v(I))})}transaction(g,S){return new Promise((v,d)=>{g.db.serialize(()=>{g.db.run("BEGIN TRANSACTION"),S(),g.db.run("END TRANSACTION",w=>w?(this.handleSQLiteError(g,`[storage ${this.name}] transaction(): ${w}`),d(w)):v())})})}prepare(g,S,v,d){const w=g.db.prepare(S),I=b=>{this.handleSQLiteError(g,`[storage ${this.name}] prepare(): ${b} (${S}). Details: ${d()}`)};w.on("error",I),v(w),w.finalize(b=>{b&&I(b),w.removeListener("error",I)})}}e.SQLiteStorageDatabase=p,p.IN_MEMORY_PATH=":memory:",p.BUSY_OPEN_TIMEOUT=2e3,p.MAX_HOST_PARAMETERS=256;class i{constructor(g){g&&typeof g.logTrace=="function"&&process.env[i.VSCODE_TRACE_STORAGE]&&(this.logTrace=g.logTrace),g&&typeof g.logError=="function"&&(this.logError=g.logError)}get isTracing(){return!!this.logTrace}trace(g){this.logTrace&&this.logTrace(g)}error(g){this.logError&&this.logError(g)}}i.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(X[122],J([14,11]),function(q,e){return q.create("vs/base/common/date",e)}),define(X[123],J([0,1,122]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,k=L*60,y=k*24,P=y*7,r=y*30,p=y*365;function i(g,S){typeof g!="number"&&(g=g.getTime());const v=Math.round((new Date().getTime()-g)/1e3);if(v<-30)return(0,m.localize)(0,null,i(new Date().getTime()+v*1e3,!1));if(v<30)return(0,m.localize)(1,null);let d;return v<L?(d=v,S?d===1?(0,m.localize)(2,null,d):(0,m.localize)(3,null,d):d===1?(0,m.localize)(4,null,d):(0,m.localize)(5,null,d)):v<k?(d=Math.floor(v/L),S?d===1?(0,m.localize)(6,null,d):(0,m.localize)(7,null,d):d===1?(0,m.localize)(8,null,d):(0,m.localize)(9,null,d)):v<y?(d=Math.floor(v/k),S?d===1?(0,m.localize)(10,null,d):(0,m.localize)(11,null,d):d===1?(0,m.localize)(12,null,d):(0,m.localize)(13,null,d)):v<P?(d=Math.floor(v/y),S?d===1?(0,m.localize)(14,null,d):(0,m.localize)(15,null,d):d===1?(0,m.localize)(16,null,d):(0,m.localize)(17,null,d)):v<r?(d=Math.floor(v/P),S?d===1?(0,m.localize)(18,null,d):(0,m.localize)(19,null,d):d===1?(0,m.localize)(20,null,d):(0,m.localize)(21,null,d)):v<p?(d=Math.floor(v/r),S?d===1?(0,m.localize)(22,null,d):(0,m.localize)(23,null,d):d===1?(0,m.localize)(24,null,d):(0,m.localize)(25,null,d)):(d=Math.floor(v/p),S?d===1?(0,m.localize)(26,null,d):(0,m.localize)(27,null,d):d===1?(0,m.localize)(28,null,d):(0,m.localize)(29,null,d))}e.fromNow=i;function D(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=D}),define(X[124],J([14,11]),function(q,e){return q.create("vs/base/common/errorMessage",e)}),define(X[66],J([0,1,124,12,35]),function(q,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(i,D){return D&&(i.stack||i.stacktrace)?m.localize(0,null,r(i),P(i.stack)||P(i.stacktrace)):r(i)}function P(i){return Array.isArray(i)?i.join(`
`):i}function r(i){return typeof i.code=="string"&&typeof i.errno=="number"&&typeof i.syscall=="string"?m.localize(1,null,i.message):i.message||m.localize(2,null)}function p(i=null,D=!1){if(!i)return m.localize(3,null);if(Array.isArray(i)){const g=k.coalesce(i),S=p(g[0],D);return g.length>1?m.localize(4,null,S,g.length):S}if(L.isString(i))return i;if(i.detail){const g=i.detail;if(g.error)return y(g.error,D);if(g.exception)return y(g.exception,D)}return i.stack?y(i,D):i.message?i.message:m.localize(5,null)}e.toErrorMessage=p}),define(X[125],J([14,11]),function(q,e){return q.create("vs/base/common/keybindingLabels",e)}),define(X[126],J([0,1,125]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(P,r,p=r){this.modifierLabels=[null],this.modifierLabels[2]=P,this.modifierLabels[1]=r,this.modifierLabels[3]=p}toLabel(P,r,p){if(r.length===0)return null;const i=[];for(let D=0,g=r.length;D<g;D++){const S=r[D],v=p(S);if(v===null)return null;i[D]=k(S,v,this.modifierLabels[P])}return i.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:m.localize(0,null),shiftKey:m.localize(1,null),altKey:m.localize(2,null),metaKey:m.localize(3,null),separator:"+"},{ctrlKey:m.localize(4,null),shiftKey:m.localize(5,null),altKey:m.localize(6,null),metaKey:m.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:m.localize(8,null),shiftKey:m.localize(9,null),altKey:m.localize(10,null),metaKey:m.localize(11,null),separator:"+"},{ctrlKey:m.localize(12,null),shiftKey:m.localize(13,null),altKey:m.localize(14,null),metaKey:m.localize(15,null),separator:"+"},{ctrlKey:m.localize(16,null),shiftKey:m.localize(17,null),altKey:m.localize(18,null),metaKey:m.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function k(y,P,r){if(P===null)return"";const p=[];return y.ctrlKey&&p.push(r.ctrlKey),y.shiftKey&&p.push(r.shiftKey),y.altKey&&p.push(r.altKey),y.metaKey&&p.push(r.metaKey),P!==""&&p.push(P),p.join(r.separator)}}),define(X[127],J([14,11]),function(q,e){return q.create("vs/base/node/processes",e)}),define(X[86],J([0,1,8,18,19,45,127,32,12,44,30,3,81,10]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function d(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(s,t){if(g.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};t&&(n.cwd=t);const o=y.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],n);return new Promise(u=>{o.once("error",h=>{u({success:!1,error:h})}),o.once("exit",(h,f)=>{u(h===0?{success:!0}:{success:!1,code:h!==null?h:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?d(n.status):1})}else if(g.isLinux||g.isMacintosh)try{const n=v.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",q).fsPath;return new Promise(o=>{y.execFile(n,[s.pid.toString()],{encoding:"utf8",shell:!0},(u,h,f)=>{o(u?{success:!1,error:u}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function I(s=r.env){return s.comspec||"cmd.exe"}e.getWindowsShell=I;class b{constructor(t,n,o,u){if(n!==void 0&&o!==void 0&&u!==void 0)this.cmd=t,this.args=n,this.shell=o,this.options=u;else{const h=t;this.cmd=h.command,this.shell=h.isShellCommand,this.args=h.args.slice(0),this.options=h.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const h=Object.create(null);Object.keys(r.env).forEach(f=>{h[f]=r.env[f]}),Object.keys(this.options.env).forEach(f=>{h[f]=this.options.env[f]}),this.options.env=h}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const n=t.lastIndexOf(m.sep);return n!==-1&&(t=t.substring(n+1)),b.WellKnowCommands[t]?t:"other"}start(t){return g.isWindows&&(this.options&&this.options.cwd&&D.isUNC(this.options.cwd)||!this.options&&D.isUNC(r.cwd()))?Promise.reject(new Error(P.localize(0,null))):this.useExec().then(n=>{let o,u;const h=new Promise((f,E)=>{o=f,u=E});if(n){let f=this.cmd;this.args&&(f=f+" "+this.args.join(" ")),this.childProcess=y.exec(f,this.options,(E,A,_)=>{this.childProcess=null;const U=E;U&&U.killed?u({killed:this.terminateRequested,stdout:A.toString(),stderr:_.toString()}):this.handleExec(o,t,E,A,_)})}else{let f=null;const E=A=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(A,o,t,u);const _={terminated:this.terminateRequested};p.isNumber(A)&&(_.cmdCode=A),o(_)};if(this.shell&&g.isWindows){const A=i.deepClone(this.options);A.windowsVerbatimArguments=!0,A.detached=!1;let _=!1,U=!1;const H=[];let Q=this.ensureQuotes(this.cmd);H.push(Q.value),_=Q.quoted,this.args&&this.args.forEach(ae=>{Q=this.ensureQuotes(ae),H.push(Q.value),U=U&&Q.quoted});const ne=["/s","/c"];_?U?ne.push('"'+H.join(" ")+'"'):H.length>1?ne.push('"'+H[0]+'" '+H.slice(1).join(" ")):ne.push('"'+H[0]+'"'):ne.push(H.join(" ")),f=y.spawn(I(),ne,A)}else this.cmd&&(f=y.spawn(this.cmd,this.args,this.options));f&&(this.childProcess=f,this.childProcessPromise=Promise.resolve(f),this.pidResolve&&(this.pidResolve(p.isNumber(f.pid)?f.pid:-1),this.pidResolve=void 0),f.on("error",A=>{this.childProcess=null,u({terminated:this.terminateRequested,error:A})}),f.pid&&(this.childProcess.on("close",E),this.handleSpawn(f,o,t,u,!0)))}return h})}handleClose(t,n,o,u){}ensureQuotes(t){return b.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,w(t,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!g.isWindows)return t(!1);const n=y.spawn(I(),["/s","/c"]);n.on("error",o=>t(!0)),n.on("exit",o=>t(!1))})}}e.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class a extends b{constructor(t,n,o,u){super(t,n,o,u);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,n,o,u,h){[u,h].forEach((f,E)=>{const A=new S.LineDecoder;A.write(f).forEach(H=>{n({line:H,source:E===0?0:1})});const U=A.end();U&&n({line:U,source:E===0?0:1})}),t({terminated:this.terminateRequested,error:o})}handleSpawn(t,n,o,u,h){const f=new S.LineDecoder,E=new S.LineDecoder;t.stdout.on("data",A=>{f.write(A).forEach(U=>o({line:U,source:0}))}),t.stderr.on("data",A=>{E.write(A).forEach(U=>o({line:U,source:1}))}),this.stdoutLineDecoder=f,this.stderrLineDecoder=E}handleClose(t,n,o,u){const h=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;h&&o({line:h,source:0});const f=this.stderrLineDecoder?this.stderrLineDecoder.end():null;f&&o({line:f,source:1})}}e.LineProcess=a;function c(s){let t=[],n=!1;const o=function(u){if(n){t.push(u);return}(!s.send(u,f=>{if(f&&console.error(f),n=!1,t.length>0){const E=t.slice(0);t=[],E.forEach(A=>o(A))}})||g.isWindows)&&(n=!0)};return{send:o}}e.createQueuedSender=c;var l;(function(s){async function t(n,o,u){if(m.isAbsolute(n))return n;if(o===void 0&&(o=r.cwd()),m.dirname(n)!=="."||(u===void 0&&p.isString(r.env.PATH)&&(u=r.env.PATH.split(m.delimiter)),u===void 0||u.length===0))return m.join(o,n);async function f(E){return await k.exists(E)?!(await L.promises.stat(E)).isDirectory():!1}for(let E of u){let A;if(m.isAbsolute(E)?A=m.join(E,n):A=m.join(o,E,n),await f(A))return A;let _=A+".com";if(await f(_)||(_=A+".exe",await f(_)))return _}return m.join(o,n)}s.findExecutable=t})(l=e.win32||(e.win32={}))}),define(X[128],J([0,1,27,3,114,86]),function(q,e,m,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function P(v,d){return v===3?L.isWindows?g():y.getWindowsShell(d):i(v,d)}e.getSystemShell=P;function r(v,d){return v===3?L.isWindows?S(d):y.getWindowsShell(d):i(v,d)}e.getSystemShellSync=r;let p=null;function i(v,d){if(L.isLinux&&v===1||L.isMacintosh&&v===2)return"/bin/bash";if(!p){let w;if(L.isWindows)w="/bin/bash";else{if(w=d.SHELL,!w)try{w=m.userInfo().shell}catch(I){}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}p=w}return p}let D=null;async function g(){return D||(D=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),D}function S(v){if(D)return D;const d=L.isWindows&&parseFloat(m.release())>=10,w=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),I=`${v.windir}\\${w?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?I:y.getWindowsShell(v)}}),define(X[87],J([0,1,45,2,9,44,5,86,33,106,25,17,23,3]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends p.ChannelServer{constructor(b){super({send:a=>{try{process.send&&process.send(a.buffer.toString("base64"))}catch(c){}},onMessage:P.Event.fromNodeEventEmitter(process,"message",a=>S.VSBuffer.wrap(Buffer.from(a,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=d;class w{constructor(b,a){this.modulePath=b,this.options=a,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new P.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=a&&a.timeout?a.timeout:6e4;this.disposeDelayer=new k.Delayer(c),this.child=null,this._client=null}getChannel(b){const a=this;return{call(c,l,s){return a.requestPromise(b,c,l,s)},listen(c,l){return a.requestEvent(b,c,l)}}}requestPromise(b,a,c,l=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(g.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(b),t=(0,k.createCancelablePromise)(u=>s.call(a,c,u)),n=l.onCancellationRequested(()=>t.cancel()),o=(0,L.toDisposable)(()=>t.cancel());return this.activeRequests.add(o),t.finally(()=>{n.dispose(),this.activeRequests.delete(o),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(b,a,c){if(!this.disposeDelayer)return P.Event.None;this.disposeDelayer.cancel();let l;const s=new P.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(b).listen(a,c)(s.fire,s),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],a=Object.create(null);a.env=Object.assign(Object.assign({},(0,y.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(a.env=Object.assign(Object.assign({},a.env),this.options.env)),this.options&&this.options.freshExecArgv&&(a.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(a.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(a.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),a.execArgv===void 0&&(a.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h))),v.isMacintosh&&a.env&&delete a.env.DYLD_LIBRARY_PATH,this.child=(0,m.fork)(this.modulePath,b,a);const c=new P.Emitter;P.Event.fromNodeEventEmitter(this.child,"message",h=>h)(h=>{if((0,i.isRemoteConsoleLog)(h)){(0,i.log)(h,`IPC Library: ${this.options.serverName}`);return}c.fire(S.VSBuffer.wrap(Buffer.from(h,"base64")))});const s=this.options.useQueue?(0,r.createQueuedSender)(this.child):this.child,t=h=>this.child&&this.child.connected&&s.send(h.buffer.toString("base64")),n=c.event,o={send:t,onMessage:n};this._client=new p.ChannelClient(o);const u=()=>this.disposeClient();process.once("exit",u),this.child.on("error",h=>console.warn('IPC "'+this.options.serverName+'" errored with '+h)),this.child.on("exit",(h,f)=>{process.removeListener("exit",u),this.activeRequests.forEach(E=>(0,L.dispose)(E)),this.activeRequests.clear(),h!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+h+" and signal "+f),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:h,signal:f})})}return this._client}getCachedChannel(b){let a=this.channels.get(b);return a||(a=this.client.getChannel(b),this.channels.set(b,a)),a}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=w}),define(X[129],J([14,11]),function(q,e){return q.create("vs/code/electron-main/app",e)}),define(X[130],J([14,11]),function(q,e){return q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(X[131],J([14,11]),function(q,e){return q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(X[132],J([14,11]),function(q,e){return q.create("vs/platform/environment/node/argv",e)}),define(X[133],J([14,11]),function(q,e){return q.create("vs/platform/environment/node/argvHelper",e)}),define(X[134],J([14,11]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(X[135],J([14,11]),function(q,e){return q.create("vs/platform/extensions/common/extensionValidator",e)}),define(X[136],J([14,11]),function(q,e){return q.create("vs/platform/files/common/fileService",e)}),define(X[137],J([14,11]),function(q,e){return q.create("vs/platform/files/common/files",e)}),define(X[138],J([14,11]),function(q,e){return q.create("vs/platform/files/common/io",e)}),define(X[139],J([14,11]),function(q,e){return q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(X[140],J([14,11]),function(q,e){return q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(X[141],J([14,11]),function(q,e){return q.create("vs/platform/menubar/electron-main/menubar",e)}),define(X[142],J([14,11]),function(q,e){return q.create("vs/platform/request/common/request",e)}),define(X[143],J([14,11]),function(q,e){return q.create("vs/platform/telemetry/common/telemetryService",e)}),define(X[144],J([14,11]),function(q,e){return q.create("vs/platform/update/common/update.config.contribution",e)}),define(X[145],J([14,11]),function(q,e){return q.create("vs/platform/windows/electron-main/window",e)}),define(X[146],J([14,11]),function(q,e){return q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(X[147],J([14,11]),function(q,e){return q.create("vs/platform/workspaces/common/workspaces",e)}),define(X[148],J([14,11]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(X[149],J([14,11]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(X[150],J([0,1,5,2]),function(q,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new m.Emitter,this._onReloadEmitter=new m.Emitter,this._onTerminateEmitter=new m.Emitter,this._onAttachEmitter=new m.Emitter}call(r,p,i){switch(p){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:i[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:i[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:i[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:i[0],port:i[1],subId:i[2]}))}throw new Error("Method not implemented.")}listen(r,p,i){switch(p){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class y extends L.Disposable{constructor(r){super();this.channel=r}reload(r){this.channel.call("reload",[r])}get onReload(){return this.channel.listen("reload")}close(r){this.channel.call("close",[r])}get onClose(){return this.channel.listen("close")}attachSession(r,p,i){this.channel.call("attach",[r,p,i])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(r,p){this.channel.call("terminate",[r,p])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(r,p,i){return this.channel.call("openExtensionDevelopmentHostWindow",[r,p||{},i])}}e.ExtensionHostDebugChannelClient=y});var ce=this&&this.__decorate||function(q,e,m,L){var k=arguments.length,y=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,m):L,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(q,e,m,L);else for(var r=q.length-1;r>=0;r--)(P=q[r])&&(y=(k<3?P(y):k>3?P(e,m,y):P(e,m))||y);return k>3&&y&&Object.defineProperty(e,m,y),y};define(X[151],J([0,1,8,15,52,123,10,7,32]),function(q,e,m,L,k,y,P,r,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class i{constructor(d,w,I){this._args=d,this.paths=w,this.productService=I}get appRoot(){return(0,m.dirname)(P.FileAccess.asFileUri("",q).fsPath)}get userHome(){return r.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return r.URI.file((0,m.join)(this.userDataPath,"User"))}get tmpDir(){return r.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,L.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,m.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return r.URI.file((0,m.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,L.joinPath)(r.URI.file((0,m.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return r.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return r.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=p.env.VSCODE_PORTABLE;return d?r.URI.file((0,m.join)(d,"argv.json")):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,L.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return r.URI.file((0,m.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,m.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,m.resolve)(d):(0,m.normalize)((0,m.join)(P.FileAccess.asFileUri("",q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,m.resolve)(d):(0,m.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,m.resolve)(d);const w=p.env.VSCODE_EXTENSIONS;if(w)return w;const I=p.env.VSCODE_PORTABLE;return I?(0,m.join)(I,"extensions"):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(w=>/^[^:/?#]+?:\/\//.test(w)?r.URI.parse(w):r.URI.file((0,m.normalize)(w)))}get extensionDevelopmentKind(){var d;return(d=this.args.extensionDevelopmentKind)===null||d===void 0?void 0:d.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?r.URI.parse(d):r.URI.file((0,m.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!p.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,L.joinPath)(r.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return r.URI.file((0,m.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}ce([k.memoize],i.prototype,"appRoot",null),ce([k.memoize],i.prototype,"userHome",null),ce([k.memoize],i.prototype,"userDataPath",null),ce([k.memoize],i.prototype,"appSettingsHome",null),ce([k.memoize],i.prototype,"tmpDir",null),ce([k.memoize],i.prototype,"userRoamingDataHome",null),ce([k.memoize],i.prototype,"settingsResource",null),ce([k.memoize],i.prototype,"userDataSyncHome",null),ce([k.memoize],i.prototype,"userDataSyncLogResource",null),ce([k.memoize],i.prototype,"sync",null),ce([k.memoize],i.prototype,"machineSettingsResource",null),ce([k.memoize],i.prototype,"globalStorageHome",null),ce([k.memoize],i.prototype,"workspaceStorageHome",null),ce([k.memoize],i.prototype,"keybindingsResource",null),ce([k.memoize],i.prototype,"keyboardLayoutResource",null),ce([k.memoize],i.prototype,"argvResource",null),ce([k.memoize],i.prototype,"snippetsHome",null),ce([k.memoize],i.prototype,"isExtensionDevelopment",null),ce([k.memoize],i.prototype,"untitledWorkspacesHome",null),ce([k.memoize],i.prototype,"installSourcePath",null),ce([k.memoize],i.prototype,"builtinExtensionsPath",null),ce([k.memoize],i.prototype,"extensionsPath",null),ce([k.memoize],i.prototype,"extensionDevelopmentLocationURI",null),ce([k.memoize],i.prototype,"extensionDevelopmentKind",null),ce([k.memoize],i.prototype,"extensionTestsLocationURI",null),ce([k.memoize],i.prototype,"debugExtensionHost",null),ce([k.memoize],i.prototype,"serviceMachineIdResource",null),ce([k.memoize],i.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=i;function D(v,d){return S(v["inspect-extensions"],v["inspect-brk-extensions"],5870,d,v.debugId)}e.parseExtensionHostPort=D;function g(v,d){return S(v["inspect-search"],v["inspect-brk-search"],5876,d)}e.parseSearchPort=g;function S(v,d,w,I,b){const c=Number(d||v)||(I?null:w),l=c?Boolean(!!d):!1;return{port:c,break:l,debugId:b}}}),define(X[88],J([0,1,232,132,3]),function(q,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const y={o:(0,L.localize)(0,null),e:(0,L.localize)(1,null),t:(0,L.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,L.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,L.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,L.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,L.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,L.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,L.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,L.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,L.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,L.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,L.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,L.localize)(14,null)},category:{type:"string",cat:"e",description:(0,L.localize)(15,null)},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,L.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,L.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,L.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,L.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,L.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,L.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,L.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,L.localize)(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,L.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,L.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,L.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,L.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,L.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,L.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,L.localize)(30,null)},telemetry:{type:"boolean",cat:"t",description:(0,L.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const P={onUnknownOption:()=>{},onMultipleValues:()=>{}};function r(d,w,I=P){const b={},a=[],c=[];for(let n in w){const o=w[n];o.alias&&(b[n]=o.alias),o.type==="string"||o.type==="string[]"?(a.push(n),o.deprecates&&a.push(o.deprecates)):o.type==="boolean"&&(c.push(n),o.deprecates&&c.push(o.deprecates))}const l=m(d,{string:a,boolean:c,alias:b}),s={},t=l;s._=l._.map(n=>String(n)).filter(n=>n.length>0),delete t._;for(let n in w){const o=w[n];o.alias&&delete t[o.alias];let u=t[n];o.deprecates&&t.hasOwnProperty(o.deprecates)&&(u||(u=t[o.deprecates]),delete t[o.deprecates]),typeof u!="undefined"&&(o.type==="string[]"?u&&!Array.isArray(u)&&(u=[u]):o.type==="string"&&Array.isArray(u)&&(u=u.pop(),I.onMultipleValues(n,u)),s[n]=u),delete t[n]}for(let n in t)I.onUnknownOption(n);return s}e.parseArgs=r;function p(d,w){let I="";return w.args&&(Array.isArray(w.args)?I=` <${w.args.join("> <")}>`:I=` <${w.args}>`),w.alias?`-${w.alias} --${d}${I}`:`--${d}${I}`}function i(d,w){let I=0,b=[];for(const s in d){const t=d[s],n=p(s,t);I=Math.max(I,n.length),b.push([n,t.description])}let a=I+2+1;if(w-a<25)return b.reduce((s,t)=>s.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let c=w-a-1,l=[];for(const s of b){let t=s[0],n=g(s[1],c),o=D(a-t.length-2);l.push("  "+t+o+n[0]);for(let u=1;u<n.length;u++)l.push(D(a)+n[u])}return l}e.formatOptions=i;function D(d){return" ".repeat(d)}function g(d,w){let I=[];for(;d.length;){let b=d.length<w?d.length:d.lastIndexOf(" ",w),a=d.slice(0,b).trim();d=d.slice(b),I.push(a)}return I}function S(d,w,I,b,a=!0){const c=process.stdout.isTTY&&process.stdout.columns||80;let l=[`${d} ${I}`];l.push(""),l.push(`${(0,L.localize)(32,null)}: ${w} [${(0,L.localize)(33,null)}][${(0,L.localize)(34,null)}...]`),l.push(""),a&&(k.isWindows?l.push((0,L.localize)(35,null,w)):l.push((0,L.localize)(36,null,w)),l.push(""));const s={};for(const t in b){const n=b[t];if(n.description&&n.cat){let o=s[n.cat];o||(s[n.cat]=o={}),o[t]=n}}for(let t in s){const n=t;let o=s[n];o&&(l.push(y[n]),l.push(...i(o,c)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=S;function v(d,w){return`${d||(0,L.localize)(37,null)}
${w||(0,L.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=v}),define(X[152],J([0,1,88,59,150]),function(q,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class y extends k.ExtensionHostDebugBroadcastChannel{constructor(r){super();this.windowsMainService=r}call(r,p,i){return p==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(i[0],i[1],i[2]):super.call(r,p,i)}async openExtensionDevelopmentHostWindow(r,p,i){const D=(0,m.parseArgs)(r,m.OPTIONS);D.debugRenderer=i;const g=D.extensionDevelopmentPath;if(!g)return{};let S;const v=Object.keys(p);for(let c of v){let l=p[c];l===null||(S||(S=Object.create(null)),S[c]=l)}const[d]=this.windowsMainService.openExtensionDevelopmentHostWindow(g,{context:5,cli:D,userEnv:S});if(!i)return{};const w=d.win;if(!w)return{};const I=w.webContents.debugger;let b=I.isAttached()?Infinity:0;const a=(0,L.createServer)(c=>{b++==0&&I.attach();let l=!1;const s=o=>{l||c.write(JSON.stringify(o)+"\0")},t=(o,u,h,f)=>s({method:u,params:h,sessionId:f});w.on("close",()=>{I.removeListener("message",t),c.end(),l=!0}),I.addListener("message",t);let n=Buffer.alloc(0);c.on("data",o=>{n=Buffer.concat([n,o]);for(let u=n.indexOf(0);u!==-1;u=n.indexOf(0)){let h;try{const f=n.slice(0,u).toString("utf8");n=n.slice(u+1),h=JSON.parse(f)}catch(f){console.error("error reading cdp line",f)}I.sendCommand(h.method,h.params,h.sessionId).then(f=>s({id:h.id,sessionId:h.sessionId,result:f})).catch(f=>s({id:h.id,sessionId:h.sessionId,error:{code:0,message:f.message}}))}}),c.on("error",o=>{console.error("error on cdp pipe:",o)}),c.on("close",()=>{l=!0,--b==0&&I.detach()})});return await new Promise(c=>a.listen(0,c)),w.on("close",()=>a.close()),{rendererDebugPort:a.address().port}}}e.ElectronExtensionHostDebugBroadcastChannel=y}),function(){"use strict";function q(e,m,L,k){function y(r){const p=P(r),i=[p];return e.isAbsolute(p)||i.unshift(k),e.resolve(...i)}function P(r){const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");const i=r["user-data-dir"];if(i)return i;let D=process.env.VSCODE_APPDATA;if(!D)switch(process.platform){case"win32":if(D=process.env.APPDATA,!D){const g=process.env.USERPROFILE;if(typeof g!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");D=e.join(g,"AppData","Roaming")}break;case"darwin":D=e.join(m.homedir(),"Library","Application Support");break;case"linux":D=process.env.XDG_CONFIG_HOME||e.join(m.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(D,L)}return{getUserDataPath:y}}if(typeof define=="function")define(X[153],J([0,154,27,10,15,32]),function(e,m,L,k,y,P){const r=y.dirname(k.FileAccess.asFileUri("",e)),p=e.__$__nodeRequire(y.joinPath(r,"package.json").fsPath);return q(m,L,p.name,P.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),m=require("path"),L=require("os");module.exports=q(m,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(X[155],J([0,1,27,153,151]),function(q,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class y extends k.AbstractNativeEnvironmentService{constructor(r,p){super(r,{homeDir:(0,m.homedir)(),tmpDir:(0,m.tmpdir)(),userDataDir:(0,L.getUserDataPath)(r)},p)}}e.NativeEnvironmentService=y}),define(X[156],J([0,1,18,27,8]),function(q,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function y(P){const r=(0,k.join)((0,L.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return m.writeFileSync(r,""),P&&console.log(`Marker file for --wait created: ${r}`),r}catch(p){P&&console.error(`Failed to create marker file for --wait: ${p}`);return}}e.createWaitMarkerFile=y}),define(X[157],J([0,1,135]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function k(g){return g=g.trim(),g==="*"||L.test(g)}e.isValidVersionStr=k;function y(g){if(!k(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=g.match(L);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=y;function P(g){if(!g)return null;let S=g.majorBase,v=g.majorMustEqual,d=g.minorBase,w=g.minorMustEqual,I=g.patchBase,b=g.patchMustEqual;return g.hasCaret&&(S===0||(w=!1),b=!1),{majorBase:S,majorMustEqual:v,minorBase:d,minorMustEqual:w,patchBase:I,patchMustEqual:b,isMinimum:g.hasGreaterEquals}}e.normalizeVersion=P;function r(g,S){let v;typeof g=="string"?v=P(y(g)):v=g;let d;if(typeof S=="string"?d=P(y(S)):d=S,!v||!d)return!1;let w=v.majorBase,I=v.minorBase,b=v.patchBase,a=d.majorBase,c=d.minorBase,l=d.patchBase,s=d.majorMustEqual,t=d.minorMustEqual,n=d.patchMustEqual;return d.isMinimum?w>a?!0:w<a?!1:I>c?!0:I<c?!1:b>=l:(w===1&&a===0&&(!s||!t||!n)&&(a=1,c=0,l=0,s=!0,t=!1,n=!1),w<a?!1:w>a?!s:I<c?!1:I>c?!t:b<l?!1:b>l?!n:!0)}e.isValidVersion=r;function p(g,S,v){return S.isBuiltin||typeof S.main=="undefined"?!0:D(g,S.engines.vscode,v)}e.isValidExtensionVersion=p;function i(g,S){return g==="*"||D(S,g)}e.isEngineValid=i;function D(g,S,v=[]){let d=P(y(S));if(!d)return v.push(m.localize(0,null,S)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return v.push(m.localize(1,null,S)),!1}else if(!d.majorMustEqual)return v.push(m.localize(2,null,S)),!1;return r(g,d)?!0:(v.push(m.localize(3,null,g,S)),!1)}e.isVersionValid=D}),define(X[158],J([0,1,33,87,2,10]),function(q,e,m,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends k.Disposable{constructor(p,i,D,g){super();this.folders=p,this.onDidFilesChange=i,this.onLogMessage=D,this.verboseLogging=g,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new L.Client(y.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=P.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(p.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(i=>!this.isDisposed&&this.onDidFilesChange(i))),this._register(this.service.onDidLogMessage(i=>this.onLogMessage(i))),this.setFolders(this.folders)}setVerboseLogging(p){this.verboseLogging=p,!this.isDisposed&&this.service&&this.service.setVerboseLogging(p)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${p}`})}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P,P.MAX_RESTARTS=5}),define(X[159],J([0,1,33,87,2,10]),function(q,e,m,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends k.Disposable{constructor(p,i,D,g,S={}){super();this.folders=p,this.onDidFilesChange=i,this.onLogMessage=D,this.verboseLogging=g,this.watcherOptions=S,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new L.Client(y.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=P.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(p.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(i=>!this.isDisposed&&this.onDidFilesChange(i))),this._register(this.service.onDidLogMessage(i=>this.onLogMessage(i))),this.service.setRoots(this.folders)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${p}`})}setVerboseLogging(p){this.verboseLogging=p,this.service&&this.service.setVerboseLogging(p)}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P,P.MAX_RESTARTS=5}),define(X[160],J([0,1,45,81,108,10]),function(q,e,m,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class P{constructor(p,i,D,g,S){this.watchedFolder=p,this.eventCallback=D,this.logCallback=g,this.verboseLogging=S,this.restartCounter=0,Array.isArray(i)?this.ignored=i.map(v=>k.parse(v)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${p}`),this.startWatcher()}startWatcher(){const p=[this.watchedFolder];this.verboseLogging&&p.push("-verbose"),this.handle=m.spawn(y.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",q).fsPath,p);const i=new L.LineDecoder;this.handle.stdout.on("data",D=>{const g=[];i.write(D).forEach(S=>{const v=S.split("|");if(v.length===2){const d=Number(v[0]),w=v[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(I=>I(w))){this.verboseLogging&&this.log(w);return}g.push({type:P.changeTypeMap[d],path:w})}else this.log(v[1])}}),g.length>0&&this.eventCallback(g)}),this.handle.on("error",D=>this.onError(D)),this.handle.stderr.on("data",D=>this.onError(D)),this.handle.on("exit",(D,g)=>this.onExit(D,g))}onError(p){this.error("process error: "+p.toString())}onExit(p,i){this.handle&&(this.error(`terminated unexpectedly (code: ${p}, signal: ${i})`),this.restartCounter<=P.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(p){this.logCallback({type:"error",message:`[File Watcher (C#)] ${p}`})}log(p){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${p}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=P,P.MAX_RESTARTS=5,P.changeTypeMap=[0,1,2]}),define(X[161],J([0,1,160,8,22]),function(q,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class y{constructor(r,p,i,D){this.onDidFilesChange=p,this.onLogMessage=i,this.verboseLogging=D,this.service=void 0,this.folder=r[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(L.posix.sep)&&(this.folder.path=(0,k.rtrim)(this.folder.path,L.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new m.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,r=>this.onFileEvents(r),r=>this.onLogMessage(r),this.verboseLogging)}setVerboseLogging(r){this.verboseLogging=r,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(r){this.isDisposed||r.length>0&&this.onDidFilesChange(r)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=y}),define(X[67],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class m{constructor(y,P=[],r=!1){this.ctor=y,this.staticArguments=P,this.supportsDelayedInstantiation=r}}e.SyncDescriptor=m;const L=(k,...y)=>new m(k,y);e.createSyncDescriptor=L}),define(X[162],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=m;class L{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let P of this._nodes.values())P.outgoing.size===0&&y.push(P);return y}insertEdge(y,P){const r=this.lookupOrInsertNode(y),p=this.lookupOrInsertNode(P);r.outgoing.set(this._hashFn(P),p),p.incoming.set(this._hashFn(y),r)}removeNode(y){const P=this._hashFn(y);this._nodes.delete(P);for(let r of this._nodes.values())r.outgoing.delete(P),r.incoming.delete(P)}lookupOrInsertNode(y){const P=this._hashFn(y);let r=this._nodes.get(P);return r||(r=new m(y),this._nodes.set(P,r)),r}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[P,r]of this._nodes)y.push(`${P}, (incoming)[${[...r.incoming.keys()].join(", ")}], (outgoing)[${[...r.outgoing.keys()].join(",")}]`);return y.join(`
`)}}e.Graph=L}),define(X[4],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(r){r.serviceIds=new Map,r.DI_TARGET="$di$target",r.DI_DEPENDENCIES="$di$dependencies";function p(i){return i[r.DI_DEPENDENCIES]||[]}r.getServiceDependencies=p})(m=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function L(r,p,i,D){p[m.DI_TARGET]===p?p[m.DI_DEPENDENCIES].push({id:r,index:i,optional:D}):(p[m.DI_DEPENDENCIES]=[{id:r,index:i,optional:D}],p[m.DI_TARGET]=p)}function k(r){if(m.serviceIds.has(r))return m.serviceIds.get(r);const p=function(i,D,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(p,i,g,!1)};return p.toString=()=>r,m.serviceIds.set(r,p),p}e.createDecorator=k;function y(r){return r}e.refineServiceDecorator=y;function P(r){return function(p,i,D){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(r,p,D,!0)}}e.optional=P}),define(X[68],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,m.createDecorator)(e.ID);function L(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=L}),define(X[89],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,m.createDecorator)("encryptionMainService");class L{constructor(y){this.machineId=y}encryption(){return new Promise((y,P)=>q(["vscode-encrypt"],y,P))}async encrypt(y){try{return(await this.encryption()).encrypt(this.machineId,y)}catch(P){return y}}async decrypt(y){try{return(await this.encryption()).decrypt(this.machineId,y)}catch(P){return y}}}e.EncryptionMainService=L}),define(X[46],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(X[163],J([0,1,134,4,10]),function(q,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function y(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=y;var P;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=5]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var r;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(r=e.SortOrder||(e.SortOrder={}));var p;(function(g){g.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var i;(function(g){g[g.None=0]="None",g[g.Install=1]="Install",g[g.Update=2]="Update"})(i=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class D extends Error{constructor(S,v){super(S);this.code=v}}e.ExtensionManagementError=D,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=k.FileAccess.asBrowserUri("./media/defaultIcon.png",q).toString(!0),e.ExtensionsLabel=(0,m.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,m.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,L.createDecorator)("IExtensionManagementCLIService")}),define(X[164],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,m.createDecorator)("extensionUrlTrustService")}),define(X[165],J([0,1,22,4]),function(q,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function k(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var y;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(y=e.ExtensionType||(e.ExtensionType={}));class P{constructor(D){this.value=D,this._lower=D.toLowerCase()}static equals(D,g){if(typeof D=="undefined"||D===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof D=="string"||typeof g=="string"){let S=typeof D=="string"?D:D.value,v=typeof g=="string"?g:g.value;return m.equalsIgnoreCase(S,v)}return D._lower===g._lower}static toKey(D){return typeof D=="string"?D.toLowerCase():D._lower}}e.ExtensionIdentifier=P;function r(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=r;function p(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=p,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(X[166],J([0,1,22,165]),function(q,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(v,d){return v.uuid&&d.uuid?v.uuid===d.uuid:v.id===d.id?!0:(0,m.compareIgnoreCase)(v.id,d.id)===0}e.areSameExtensions=k;class y{constructor(d,w){this.version=w,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof y?k(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=y;function P(v,d){return`${v}.${d}`}e.getExtensionId=P;function r(v){return v.toLocaleLowerCase()}e.adoptToGalleryExtensionId=r;function p(v,d){return r(P(v,d))}e.getGalleryExtensionId=p;function i(v,d){const w=[],I=b=>{for(const a of w)if(a.some(c=>k(d(c),d(b))))return a;return null};for(const b of v){const a=I(b);a?a.push(b):w.push([b])}return w}e.groupByExtension=i;function D(v){return{id:v.identifier.id,name:v.manifest.name,galleryId:null,publisherId:v.publisherId,publisherName:v.manifest.publisher,publisherDisplayName:v.publisherDisplayName,dependencies:v.manifest.extensionDependencies&&v.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=D;function g(v){return Object.assign({id:v.identifier.id,name:v.name,galleryId:v.identifier.uuid,publisherId:v.publisherId,publisherName:v.publisher,publisherDisplayName:v.publisherDisplayName,dependencies:!!(v.properties.dependencies&&v.properties.dependencies.length>0)},v.telemetryData)}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function S(v){const d=new Set;for(const w of v)w.malicious&&d.add(w.id.id);return d}e.getMaliciousExtensionsSet=S}),define(X[24],J([0,1,137,8,7,4,22,12,36]),function(q,e,m,L,k,y,P,r,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function i(O){return O.create===!0}e.isFileOpenForWriteOptions=i;var D;(function(O){O[O.Unknown=0]="Unknown",O[O.File=1]="File",O[O.Directory=2]="Directory",O[O.SymbolicLink=64]="SymbolicLink"})(D=e.FileType||(e.FileType={}));var g;(function(O){O[O.FileReadWrite=2]="FileReadWrite",O[O.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",O[O.FileReadStream=16]="FileReadStream",O[O.FileFolderCopy=8]="FileFolderCopy",O[O.PathCaseSensitive=1024]="PathCaseSensitive",O[O.Readonly=2048]="Readonly",O[O.Trash=4096]="Trash",O[O.FileWriteUnlock=8192]="FileWriteUnlock"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function S(O){return!!(O.capabilities&2)}e.hasReadWriteCapability=S;function v(O){return!!(O.capabilities&8)}e.hasFileFolderCopyCapability=v;function d(O){return!!(O.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function w(O){return!!(O.capabilities&16)}e.hasFileReadStreamCapability=w;var I;(function(O){O.FileExists="EntryExists",O.FileNotFound="EntryNotFound",O.FileNotADirectory="EntryNotADirectory",O.FileIsADirectory="EntryIsADirectory",O.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",O.FileTooLarge="EntryTooLarge",O.FileWriteLocked="EntryWriteLocked",O.NoPermissions="NoPermissions",O.Unavailable="Unavailable",O.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor($,z){super($);this.code=z}}e.FileSystemProviderError=b;function a(O,$){const z=new b(O.toString(),$);return l(z,$),z}e.createFileSystemProviderError=a;function c(O){return O||a((0,m.localize)(0,null),I.Unknown)}e.ensureFileSystemProviderError=c;function l(O,$){return O.name=$?`${$} (FileSystemError)`:"FileSystemError",O}e.markAsFileSystemProviderError=l;function s(O){if(!O)return I.Unknown;if(O instanceof b)return O.code;const $=/^(.+) \(FileSystemError\)$/.exec(O.name);if(!$)return I.Unknown;switch($[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=s;function t(O){if(O instanceof E)return O.fileOperationResult;switch(s(O)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(O){O[O.CREATE=0]="CREATE",O[O.DELETE=1]="DELETE",O[O.MOVE=2]="MOVE",O[O.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class o{constructor($,z,C){this.resource=$,this.operation=z,this.target=C}isOperation($){return this.operation===$}}e.FileOperationEvent=o;var u;(function(O){O[O.UPDATED=0]="UPDATED",O[O.ADDED=1]="ADDED",O[O.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class h{constructor($,z){this.ignorePathCasing=z,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=$;for(const C of $)switch(C.type){case 1:this.added||(this.added=p.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(C.resource,C);break;case 0:this.updated||(this.updated=p.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(C.resource,C);break;case 2:this.deleted||(this.deleted=p.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(C.resource,C);break}}contains($,...z){return this.doContains($,{includeChildren:!1},...z)}affects($,...z){return this.doContains($,{includeChildren:!0},...z)}doContains($,z,...C){var j,N,T,R,W,M;if(!$)return!1;const F=C.length>0;return!!((!F||C.includes(1))&&(((j=this.added)===null||j===void 0?void 0:j.get($))||z.includeChildren&&((N=this.added)===null||N===void 0?void 0:N.findSuperstr($)))||(!F||C.includes(0))&&(((T=this.updated)===null||T===void 0?void 0:T.get($))||z.includeChildren&&((R=this.updated)===null||R===void 0?void 0:R.findSuperstr($)))||(!F||C.includes(2))&&(((W=this.deleted)===null||W===void 0?void 0:W.findSubstr($))||z.includeChildren&&((M=this.deleted)===null||M===void 0?void 0:M.findSuperstr($))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType($){const z=[],C=$===1?this.added:$===0?this.updated:this.deleted;if(C)for(const[,j]of C)z.push(j);return z}filter($){return new h(this.changes.filter(z=>$(z)),this.ignorePathCasing)}}e.FileChangesEvent=h;function f(O,$,z){return!O||!$||O===$||$.length>O.length?!1:($.charAt($.length-1)!==L.sep&&($+=L.sep),z?(0,P.startsWithIgnoreCase)(O,$):O.indexOf($)===0)}e.isParent=f;class E extends Error{constructor($,z,C){super($);this.fileOperationResult=z,this.options=C}static isFileOperationError($){return $ instanceof Error&&!(0,r.isUndefinedOrNull)($.fileOperationResult)}}e.FileOperationError=E;var A;(function(O){O[O.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",O[O.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",O[O.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",O[O.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",O[O.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",O[O.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",O[O.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",O[O.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",O[O.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",O[O.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",O[O.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",O[O.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(O){O[O.FILE=0]="FILE",O[O.FOLDER=1]="FOLDER",O[O.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(O){if(!(typeof O.size!="number"||typeof O.mtime!="number"))return O.mtime.toString(29)+O.size.toString(31)}e.etag=U;async function H(O,$){if(!$.canHandleResource(k.URI.from({scheme:O.scheme})))return new Promise(z=>{const C=$.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===O.scheme&&j.added&&(C.dispose(),z())})})}e.whenProviderRegistered=H,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Q{static formatSize($){return(0,r.isNumber)($)||($=0),$<Q.KB?(0,m.localize)(1,null,$.toFixed(0)):$<Q.MB?(0,m.localize)(2,null,($/Q.KB).toFixed(2)):$<Q.GB?(0,m.localize)(3,null,($/Q.MB).toFixed(2)):$<Q.TB?(0,m.localize)(4,null,($/Q.GB).toFixed(2)):(0,m.localize)(5,null,($/Q.TB).toFixed(2))}}e.ByteSize=Q,Q.KB=1024,Q.MB=Q.KB*Q.KB,Q.GB=Q.MB*Q.KB,Q.TB=Q.GB*Q.KB;var ne;(function(O){O[O.IA32=0]="IA32",O[O.OTHER=1]="OTHER"})(ne=e.Arch||(e.Arch={}));function ae(O){return{maxFileSize:O===0?300*Q.MB:16*Q.GB,maxHeapSize:O===0?700*Q.MB:2*700*Q.MB}}e.getPlatformLimits=ae}),define(X[53],J([0,1,233,133,24,88]),function(q,e,m,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function P(S,v){const d={onUnknownOption:I=>{console.warn((0,L.localize)(0,null,I))},onMultipleValues:(I,b)=>{console.warn((0,L.localize)(1,null,I,b))}},w=(0,y.parseArgs)(S,y.OPTIONS,v?d:void 0);return w.goto&&w._.forEach(I=>m(/^(\w:)?[^:]+(:\d*){0,2}$/.test(I),(0,L.localize)(2,null))),w["max-memory"]&&m(parseInt(w["max-memory"])>=k.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${k.MIN_MAX_MEMORY_SIZE_MB} MB.`),w}function r(S){const v=S.findIndex(d=>!/^-/.test(d));if(v>-1)return[...S.slice(0,v),...S.slice(v+1)]}function p(S){let[,...v]=S;process.env.VSCODE_DEV&&(v=r(v)||[]);const d=!g(process.env);return P(v,d)}e.parseMainProcessArgv=p;function i(S){const[,,...v]=S;return P(v,!0)}e.parseCLIProcessArgv=i;function D(S,...v){const d=S.indexOf("--");return d===-1?S.push(...v):S.splice(d,0,...v),S}e.addArg=D;function g(S){return S.VSCODE_CLI==="1"}e.isLaunchedFromCli=g}),define(X[69],J([0,1,154,45,28,3,53,66,128]),function(q,e,m,L,k,y,P,r,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function i(S,v,d){return v["force-disable-user-env"]?(S.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):y.isWindows?(S.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,P.isLaunchedFromCli)(d)&&!v["force-user-env"]?(S.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,P.isLaunchedFromCli)(d)?S.trace("resolveShellEnv(): running (--force-user-env)"):S.trace("resolveShellEnv(): running (macOS/Linux)"),D||(D=g(S)),D)}e.resolveShellEnv=i;let D;async function g(S){const v=new Promise(async(d,w)=>{const I=process.env.ELECTRON_RUN_AS_NODE;S.trace("getUnixShellEnvironment#runAsNode",I);const b=process.env.ELECTRON_NO_ATTACH_CONSOLE;S.trace("getUnixShellEnvironment#noAttach",b);const a=(0,k.generateUuid)().replace(/-/g,"").substr(0,12),c=new RegExp(a+"(.*)"+a),l=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});S.trace("getUnixShellEnvironment#env",l);const s=await(0,p.getSystemShell)(y.platform,l);S.trace("getUnixShellEnvironment#shell",s);let t=`'${process.execPath}' -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,n=["-ilc"];const o=m.basename(s);/^pwsh(-preview)?$/.test(o)&&(t=`& ${t}`,n=["-Login","-Command"]),S.trace("getUnixShellEnvironment#spawn",JSON.stringify(n),t);const u=(0,L.spawn)(s,[...n,t],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});u.on("error",E=>{S.error("getUnixShellEnvironment#errorChildProcess",(0,r.toErrorMessage)(E)),d({})});const h=[];u.stdout.on("data",E=>h.push(E));const f=[];u.stderr.on("data",E=>f.push(E)),u.on("close",(E,A)=>{const _=Buffer.concat(h).toString("utf8");S.trace("getUnixShellEnvironment#raw",_);const U=Buffer.concat(f).toString("utf8");if(U.trim()&&S.trace("getUnixShellEnvironment#stderr",U),E||A)return w(new Error(`Failed to get environment (code ${E}, signal ${A})`));const H=c.exec(_),Q=H?H[1]:"{}";try{const ne=JSON.parse(Q);I?ne.ELECTRON_RUN_AS_NODE=I:delete ne.ELECTRON_RUN_AS_NODE,b?ne.ELECTRON_NO_ATTACH_CONSOLE=b:delete ne.ELECTRON_NO_ATTACH_CONSOLE,delete ne.XDG_RUNTIME_DIR,S.trace("getUnixShellEnvironment#result",ne),d(ne)}catch(ne){S.error("getUnixShellEnvironment#errorCaught",(0,r.toErrorMessage)(ne)),w(ne)}})});try{return await v}catch(d){return S.error("getUnixShellEnvironment#error",(0,r.toErrorMessage)(d)),{}}}}),define(X[90],J([0,1,138,23,24,17]),function(q,e,m,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(D,g,S,v,d,w){let I;try{await r(D,g,S,v,d,w)}catch(b){I=b}finally{I&&d.errorTransformer&&(I=d.errorTransformer(I)),typeof I!="undefined"&&S.error(I),S.end()}}e.readFileIntoStream=P;async function r(D,g,S,v,d,w){p(w);const I=await D.open(g,{create:!1});try{p(w);let b=0,a=0,c=d&&typeof d.length=="number"?d.length:void 0,l=L.VSBuffer.alloc(Math.min(d.bufferSize,typeof c=="number"?c:d.bufferSize)),s=d&&typeof d.position=="number"?d.position:0,t=0;do a=await D.read(I,s,l.buffer,t,l.byteLength-t),s+=a,t+=a,b+=a,typeof c=="number"&&(c-=a),t===l.byteLength&&(await S.write(v(l)),l=L.VSBuffer.alloc(Math.min(d.bufferSize,typeof c=="number"?c:d.bufferSize)),t=0);while(a>0&&(typeof c!="number"||c>0)&&p(w)&&i(b,d));if(t>0){let n=t;typeof c=="number"&&(n=Math.min(t,c)),S.write(v(l.slice(0,n)))}}catch(b){throw(0,k.ensureFileSystemProviderError)(b)}finally{await D.close(I)}}function p(D){if(D.isCancellationRequested)throw(0,y.canceled)();return!0}function i(D,g){if(g==null?void 0:g.limits){if(typeof g.limits.memory=="number"&&D>g.limits.memory)throw(0,k.createFileSystemProviderError)((0,m.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof g.limits.size=="number"&&D>g.limits.size)throw(0,k.createFileSystemProviderError)((0,m.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(X[91],J([0,1,7,24,3]),function(q,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function y(p){return p.map(i=>({type:i.type,resource:m.URI.file(i.path)}))}e.toFileChanges=y;function P(p){const i=new r;for(const D of p)i.processEvent(D);return i.normalize()}e.normalizeFileChanges=P;class r{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(i){const D=this.mapPathToChange.get(i.path);if(D){const g=D.type,S=i.type;g===1&&S===2?(this.mapPathToChange.delete(i.path),this.normalized.splice(this.normalized.indexOf(D),1)):g===2&&S===1?D.type=0:g===1&&S===0||(D.type=S)}else this.normalized.push(i),this.mapPathToChange.set(i.path,i)}normalize(){const i=[],D=[];return this.normalized.filter(g=>g.type!==2?(i.push(g),!1):!0).sort((g,S)=>g.path.length-S.path.length).filter(g=>D.some(S=>(0,L.isParent)(g.path,S,!k.isLinux))?!1:(D.push(g.path),!0)).concat(i)}}}),define(X[167],J([0,1,91,2,19,111,115,9,8]),function(q,e,m,L,k,y,P,r,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class i extends L.Disposable{constructor(g,S,v,d){super();this.path=g,this.onDidFilesChange=S,this.onLogMessage=v,this.verboseLogging=d,this.fileChangesDelayer=this._register(new r.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(g){this.verboseLogging=g}async startWatching(){try{const{stat:g,symbolicLink:S}=await k.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let v=this.path;if(S)try{v=await(0,y.realpath)(v)}catch(d){if(this.onError(d),S.dangling)return}g.isDirectory()?this._register((0,P.watchFolder)(v,(d,w)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:(0,p.join)(this.path,(0,p.basename)(w))})},d=>this.onError(d))):this._register((0,P.watchFile)(v,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(g){g.code!=="ENOENT"&&this.onError(g)}}onFileChange(g){this.fileChangesBuffer.push(g),this.verboseLogging&&this.onVerbose(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`),this.fileChangesDelayer.trigger(async()=>{const S=this.fileChangesBuffer;this.fileChangesBuffer=[];const v=(0,m.normalizeFileChanges)(S);this.verboseLogging&&v.forEach(d=>{this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`)}),v.length>0&&this.onDidFilesChange(v)})}onError(g){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${g}`})}onVerbose(g){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=i}),define(X[70],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...k){this._entries=new Map;for(let[y,P]of k)this.set(y,P)}set(k,y){const P=this._entries.get(k);return this._entries.set(k,y),P}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=m}),define(X[168],J([0,1,17,162,67,4,70,9]),function(q,e,m,L,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const p=!1;class i extends Error{constructor(d){super("cyclic dependency between services");this.message=d.toString()}}class D{constructor(d=new P.ServiceCollection,w=!1,I){this._activeInstantiations=new Set,this._services=d,this._strict=w,this._parent=I,this._services.set(y.IInstantiationService,this)}createChild(d){return new D(d,this._strict,this)}invokeFunction(d,...w){let I=S.traceInvocation(d),b=!1;try{return d({get:(c,l)=>{if(b)throw(0,m.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(c,I);if(!s&&l!==y.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return s}},...w)}finally{b=!0,I.stop()}}createInstance(d,...w){let I,b;return d instanceof k.SyncDescriptor?(I=S.traceCreation(d.ctor),b=this._createInstance(d.ctor,d.staticArguments.concat(w),I)):(I=S.traceCreation(d),b=this._createInstance(d,w,I)),I.stop(),b}_createInstance(d,w=[],I){let b=y._util.getServiceDependencies(d).sort((l,s)=>l.index-s.index),a=[];for(const l of b){let s=this._getOrCreateServiceInstance(l.id,I);if(!s&&this._strict&&!l.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${l.id}.`);a.push(s)}let c=b.length>0?b[0].index:w.length;if(w.length!==c){console.warn(`[createInstance] First service dependency of ${d.name} at position ${c+1} conflicts with ${w.length} static arguments`);let l=c-w.length;l>0?w=w.concat(new Array(l)):w=w.slice(0,c)}return new d(...[...w,...a])}_setServiceInstance(d,w){if(this._services.get(d)instanceof k.SyncDescriptor)this._services.set(d,w);else if(this._parent)this._parent._setServiceInstance(d,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let w=this._services.get(d);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):w}_getOrCreateServiceInstance(d,w){let I=this._getServiceInstanceOrDescriptor(d);return I instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,I,w.branch(d,!0)):(w.branch(d,!1),I)}_safeCreateAndCacheServiceInstance(d,w,I){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,w,I)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,w,I){const b=new L.Graph(l=>l.id.toString());let a=0;const c=[{id:d,desc:w,_trace:I}];for(;c.length;){const l=c.pop();if(b.lookupOrInsertNode(l),a++>1e3)throw new i(b);for(let s of y._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(s.id);if(!t&&!s.optional&&console.warn(`[createInstance] ${d} depends on ${s.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const n={id:s.id,desc:t,_trace:l._trace.branch(s.id,!0)};b.insertEdge(l,n),c.push(n)}}}for(;;){const l=b.roots();if(l.length===0){if(!b.isEmpty())throw new i(b);break}for(const{data:s}of l){if(this._getServiceInstanceOrDescriptor(s.id)instanceof k.SyncDescriptor){const n=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,n)}b.removeNode(s)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,w,I=[],b,a){if(this._services.get(d)instanceof k.SyncDescriptor)return this._createServiceInstance(w,I,b,a);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,w,I,b,a);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(d,w=[],I,b){if(I){const a=new r.IdleValue(()=>this._createInstance(d,w,b));return new Proxy(Object.create(null),{get(c,l){if(l in c)return c[l];let s=a.value,t=s[l];return typeof t!="function"||(t=t.bind(s),c[l]=t),t},set(c,l,s){return a.value[l]=s,!0}})}else return this._createInstance(d,w,b)}}e.InstantiationService=D;var g;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(g||(g={}));class S{constructor(d,w){this.type=d,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return p?new S(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):S._None}static traceCreation(d){return p?new S(0,d.name):S._None}branch(d,w){let I=new S(2,d.toString());return this._dep.push([d,w,I]),I}stop(){let d=Date.now()-this._start;S._totals+=d;let w=!1;function I(a,c){let l=[],s=new Array(a+1).join("	");for(const[t,n,o]of c._dep)if(n&&o){w=!0,l.push(`${s}CREATES -> ${t}`);let u=I(a+1,o);u&&l.push(u)}else l.push(`${s}uses -> ${t}`);return l.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${I(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(d>2||w)&&console.log(b.join(`
`))}}S._None=new class extends S{constructor(){super(-1,null)}stop(){}branch(){return this}},S._totals=0}),define(X[169],J([0,1,17,126,57]),function(q,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class y extends k.ResolvedKeybinding{constructor(r,p){super();if(p.length===0)throw(0,m.illegalArgument)("parts");this._os=r,this._parts=p}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,r=>this._getLabel(r))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,r=>this._getAriaLabel(r))}getElectronAccelerator(){return this._parts.length>1?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,r=>this._getElectronAccelerator(r))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,r=>this._getUserSettingsLabel(r))}isWYSIWYG(){return this._parts.every(r=>this._isWYSIWYG(r))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(r=>this._getPart(r))}_getPart(r){return new k.ResolvedKeybindingPart(r.ctrlKey,r.shiftKey,r.altKey,r.metaKey,this._getLabel(r),this._getAriaLabel(r))}getDispatchParts(){return this._parts.map(r=>this._getDispatchPart(r))}getSingleModifierDispatchParts(){return this._parts.map(r=>this._getSingleModifierDispatchPart(r))}}e.BaseResolvedKeybinding=y}),define(X[170],J([0,1,57,169]),function(q,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class k extends L.BaseResolvedKeybinding{constructor(P,r){super(r,P.parts)}_keyCodeToUILabel(P){if(this._os===2)switch(P){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return m.KeyCodeUtils.toString(P)}_getLabel(P){return P.isDuplicateModifierCase()?"":this._keyCodeToUILabel(P.keyCode)}_getAriaLabel(P){return P.isDuplicateModifierCase()?"":m.KeyCodeUtils.toString(P.keyCode)}_keyCodeToElectronAccelerator(P){if(P>=93&&P<=108)return null;switch(P){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return m.KeyCodeUtils.toString(P)}_getElectronAccelerator(P){return P.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(P.keyCode)}_getUserSettingsLabel(P){if(P.isDuplicateModifierCase())return"";const r=m.KeyCodeUtils.toUserSettingsUS(P.keyCode);return r&&r.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(P){return k.getDispatchStr(P)}static getDispatchStr(P){if(P.isModifierKey())return null;let r="";return P.ctrlKey&&(r+="ctrl+"),P.shiftKey&&(r+="shift+"),P.altKey&&(r+="alt+"),P.metaKey&&(r+="meta+"),r+=m.KeyCodeUtils.toString(P.keyCode),r}_getSingleModifierDispatchPart(P){return P.keyCode===5&&!P.shiftKey&&!P.altKey&&!P.metaKey?"ctrl":P.keyCode===4&&!P.ctrlKey&&!P.altKey&&!P.metaKey?"shift":P.keyCode===6&&!P.ctrlKey&&!P.shiftKey&&!P.metaKey?"alt":P.keyCode===57&&!P.ctrlKey&&!P.shiftKey&&!P.altKey?"meta":null}}e.USLayoutResolvedKeybinding=k}),define(X[171],J([0,1,9]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(k,y){if(k.length===0)return Promise.resolve(!1);const P=[];let r=!1;for(let p of k){if(p===!0)return Promise.resolve(!0);(0,m.isThenable)(p)&&P.push(p.then(i=>{i&&(r=!0)},i=>{y(i),r=!0}))}return m.Promises.settled(P).then(()=>r)}e.handleVetos=L}),define(X[6],J([0,1,4,2,3,5,66]),function(q,e,m,L,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function r(){return new Date().toISOString()}var p;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;class i extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=i;class D extends i{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(p.Trace)&&this.log(p.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(p.Debug)&&this.log(p.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(p.Info)&&this.log(p.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(p.Warning)&&this.log(p.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(p.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(p.Error,this.format(o))}else this.log(p.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(p.Critical)&&this.log(p.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let o=0;o<t.length;o++){let u=t[o];if(typeof u=="object")try{u=JSON.stringify(u)}catch(h){}n+=(o>0?" ":"")+u}return n}}e.AbstractMessageLogger=D;class g extends i{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!k.isWindows}trace(t,...n){this.getLevel()<=p.Trace&&(this.useColors?console.log(`[90m[main ${r()}][0m`,t,...n):console.log(`[main ${r()}]`,t,...n))}debug(t,...n){this.getLevel()<=p.Debug&&(this.useColors?console.log(`[90m[main ${r()}][0m`,t,...n):console.log(`[main ${r()}]`,t,...n))}info(t,...n){this.getLevel()<=p.Info&&(this.useColors?console.log(`[90m[main ${r()}][0m`,t,...n):console.log(`[main ${r()}]`,t,...n))}warn(t,...n){this.getLevel()<=p.Warning&&(this.useColors?console.warn(`[93m[main ${r()}][0m`,t,...n):console.warn(`[main ${r()}]`,t,...n))}error(t,...n){this.getLevel()<=p.Error&&(this.useColors?console.error(`[91m[main ${r()}][0m`,t,...n):console.error(`[main ${r()}]`,t,...n))}critical(t,...n){this.getLevel()<=p.Critical&&(this.useColors?console.error(`[90m[main ${r()}][0m`,t,...n):console.error(`[main ${r()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class S extends i{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=p.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=p.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=p.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=p.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=p.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=p.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=S;class v extends i{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=p.Trace&&this.adapter.log(p.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=p.Debug&&this.adapter.log(p.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=p.Info&&this.adapter.log(p.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=p.Warning&&this.adapter.log(p.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=p.Error&&this.adapter.log(p.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=p.Critical&&this.adapter.log(p.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,P.toErrorMessage)(t,this.getLevel()<=p.Trace)}dispose(){}flush(){}}e.AdapterLogger=v;class d extends i{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const o of this.logServices)o.trace(t,...n)}debug(t,...n){for(const o of this.logServices)o.debug(t,...n)}info(t,...n){for(const o of this.logServices)o.info(t,...n)}warn(t,...n){for(const o of this.logServices)o.warn(t,...n)}error(t,...n){for(const o of this.logServices)o.error(t,...n)}critical(t,...n){for(const o of this.logServices)o.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class w extends L.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=w;class I extends L.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(o))}))}createLogger(t,n){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,(n==null?void 0:n.always)?p.Trace:this.logLevel,n),this.loggers.set(t.toString(),o),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=I;class b{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(t){}getLevel(){return p.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=b;function a(s){if(s.verbose)return p.Trace;if(typeof s.logLevel=="string"){const t=c(s.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function c(s){switch(s){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Critical;case"off":return p.Off}}e.parseLogLevel=c;function l(s){switch(s){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Critical:return"critical";case p.Off:return"off"}}e.LogLevelToString=l});var ee=this&&this.__param||function(q,e){return function(m,L){e(m,L,q)}};define(X[172],J([0,1,136,71,2,24,5,15,36,35,6,23,63,9,25,10,90,62]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v,d,w,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let a=class extends k.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new P.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new P.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new P.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new P.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new P.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new v.ResourceQueue)}registerProvider(l,s){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,L.mark)(`code/registerFilesystem/${l}`),this.provider.set(l,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:s});const t=new k.DisposableStore;return t.add(s.onDidChangeFile(n=>this._onDidFilesChange.fire(new y.FileChangesEvent(n,!this.isPathCaseSensitive(s))))),t.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:l}))),typeof s.onDidErrorOccur=="function"&&t.add(s.onDidErrorOccur(n=>this._onError.fire(new Error(n)))),(0,k.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:s}),this.provider.delete(l),(0,k.dispose)(t)})}async activateProvider(l){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(t){s.push(t)}}),!this.provider.has(l)&&await v.Promises.settled(s)}canHandleResource(l){return this.provider.has(l.scheme)}hasCapability(l,s){const t=this.provider.get(l.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return b.Iterable.map(this.provider,([l,s])=>({scheme:l,capabilities:s.capabilities}))}async withProvider(l){if(!(0,r.isAbsolutePath)(l))throw new y.FileOperationError((0,m.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const s=this.provider.get(l.scheme);if(!s){const t=new Error;throw t.name="ENOPRO",t.message=(0,m.localize)(1,null,l.toString()),t}return s}async withReadProvider(l){const s=await this.withProvider(l);if((0,y.hasOpenReadWriteCloseCapability)(s)||(0,y.hasReadWriteCapability)(s)||(0,y.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const s=await this.withProvider(l);if((0,y.hasOpenReadWriteCloseCapability)(s)||(0,y.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,s){try{return await this.doResolveFile(l,s)}catch(t){throw(0,y.toFileSystemProviderErrorCode)(t)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,m.localize)(2,null,this.resourceForError(l)),1):(0,y.ensureFileSystemProviderError)(t)}}async doResolveFile(l,s){const t=await this.withProvider(l),n=this.isPathCaseSensitive(t),o=s==null?void 0:s.resolveTo,u=s==null?void 0:s.resolveSingleChildDescendants,h=s==null?void 0:s.resolveMetadata,f=await t.stat(l);let E;return this.toFileStat(t,l,f,void 0,!!h,(A,_)=>(E||(E=p.TernarySearchTree.forUris(()=>!n),E.set(l,!0),(0,i.isNonEmptyArray)(o)&&o.forEach(U=>E.set(U,!0))),Boolean(E.findSuperstr(A.resource)||E.get(A.resource))?!0:A.isDirectory&&u?_===1:!1))}async toFileStat(l,s,t,n,o,u){const{providerExtUri:h}=this.getExtUri(l),f={resource:s,name:h.basename(s),isFile:(t.type&y.FileType.File)!=0,isDirectory:(t.type&y.FileType.Directory)!=0,isSymbolicLink:(t.type&y.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:(0,y.etag)({mtime:t.mtime,size:t.size})};if(f.isDirectory&&u(f,n)){try{const E=await l.readdir(s),A=await v.Promises.settled(E.map(async([_,U])=>{try{const H=h.joinPath(s,_),Q=o?await l.stat(H):{type:U};return await this.toFileStat(l,H,Q,E.length,o,u)}catch(H){return this.logService.trace(H),null}}));f.children=(0,i.coalesce)(A)}catch(E){this.logService.trace(E),f.children=[]}return f}return f}async resolveAll(l){return v.Promises.settled(l.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(l){const s=await this.withProvider(l);try{return!!await s.stat(l)}catch(t){return!1}}async canCreateFile(l,s){try{await this.doValidateCreateFile(l,s)}catch(t){return t}return!0}async doValidateCreateFile(l,s){if(!(s==null?void 0:s.overwrite)&&await this.exists(l))throw new y.FileOperationError((0,m.localize)(3,null,this.resourceForError(l)),3,s)}async createFile(l,s=g.VSBuffer.fromString(""),t){await this.doValidateCreateFile(l,t);const n=await this.writeFile(l,s);return this._onDidRunOperation.fire(new y.FileOperationEvent(l,0,n)),n}async writeFile(l,s,t){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:o}=this.getExtUri(n);try{await this.validateWriteFile(n,l,t)||await this.mkdirp(n,o.dirname(l));let h;if((0,y.hasReadWriteCapability)(n)&&!(s instanceof g.VSBuffer))if((0,S.isReadableStream)(s)){const f=await(0,S.peekStream)(s,3);f.ended?h=g.VSBuffer.concat(f.buffer):h=f}else h=(0,S.peekReadable)(s,f=>g.VSBuffer.concat(f),3);else h=s;!(0,y.hasOpenReadWriteCloseCapability)(n)||(0,y.hasReadWriteCapability)(n)&&h instanceof g.VSBuffer?await this.doWriteUnbuffered(n,l,t,h):await this.doWriteBuffered(n,l,t,h instanceof g.VSBuffer?(0,g.bufferToReadable)(h):h)}catch(u){throw new y.FileOperationError((0,m.localize)(4,null,this.resourceForError(l),(0,y.ensureFileSystemProviderError)(u).toString()),(0,y.toFileOperationResult)(u),t)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,s,t){if(!!(t==null?void 0:t.unlock)&&!(l.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(s)));let o;try{o=await l.stat(s)}catch(u){return}if((o.type&y.FileType.Directory)!=0)throw new y.FileOperationError((0,m.localize)(6,null,this.resourceForError(s)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==y.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&t.mtime<o.mtime&&t.etag!==(0,y.etag)({mtime:t.mtime,size:o.size}))throw new y.FileOperationError((0,m.localize)(7,null),3,t);return o}async readFile(l,s){const t=await this.withReadProvider(l);return(s==null?void 0:s.atomic)?this.doReadFileAtomic(t,l,s):this.doReadFile(t,l,s)}async doReadFileAtomic(l,s,t){return new Promise((n,o)=>{this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(async()=>{try{const u=await this.doReadFile(l,s,t);n(u)}catch(u){o(u)}})})}async doReadFile(l,s,t){const n=await this.doReadFileStream(l,s,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},n),{value:await(0,g.streamToBuffer)(n.value)})}async readFileStream(l,s){const t=await this.withReadProvider(l);return this.doReadFileStream(t,l,s)}async doReadFileStream(l,s,t){const n=new d.CancellationTokenSource,o=this.validateReadFile(s,t).then(h=>h,h=>{throw n.cancel(),h});let u;try{t&&typeof t.etag=="string"&&t.etag!==y.ETAG_DISABLED&&await o,!((0,y.hasOpenReadWriteCloseCapability)(l)||(0,y.hasFileReadStreamCapability)(l))||(0,y.hasReadWriteCapability)(l)&&(t==null?void 0:t.preferUnbuffered)?u=this.readFileUnbuffered(l,s,t):(0,y.hasFileReadStreamCapability)(l)?u=this.readFileStreamed(l,s,n.token,t):u=this.readFileBuffered(l,s,n.token,t);const h=await o;return Object.assign(Object.assign({},h),{value:u})}catch(h){throw u&&await(0,S.consumeStream)(u),new y.FileOperationError((0,m.localize)(8,null,this.resourceForError(s),(0,y.ensureFileSystemProviderError)(h).toString()),(0,y.toFileOperationResult)(h),t)}}readFileStreamed(l,s,t,n=Object.create(null)){const o=l.readFileStream(s,n,t);return(0,S.transform)(o,{data:u=>u instanceof g.VSBuffer?u:g.VSBuffer.wrap(u),error:u=>new y.FileOperationError((0,m.localize)(9,null,this.resourceForError(s),(0,y.ensureFileSystemProviderError)(u).toString()),(0,y.toFileOperationResult)(u),n)},u=>g.VSBuffer.concat(u))}readFileBuffered(l,s,t,n=Object.create(null)){const o=(0,g.newWriteableBufferStream)();return(0,I.readFileIntoStream)(l,s,o,u=>u,Object.assign(Object.assign({},n),{bufferSize:this.BUFFER_SIZE,errorTransformer:u=>new y.FileOperationError((0,m.localize)(10,null,this.resourceForError(s),(0,y.ensureFileSystemProviderError)(u).toString()),(0,y.toFileOperationResult)(u),n)}),t),o}readFileUnbuffered(l,s,t){const n=(0,S.newWriteableStream)(o=>g.VSBuffer.concat(o));return(async()=>{try{let o=await l.readFile(s);t&&typeof t.position=="number"&&(o=o.slice(t.position)),t&&typeof t.length=="number"&&(o=o.slice(0,t.length)),this.validateReadFileLimits(s,o.byteLength,t),n.end(g.VSBuffer.wrap(o))}catch(o){n.error(o),n.end()}})(),n}async validateReadFile(l,s){const t=await this.resolve(l,{resolveMetadata:!0});if(t.isDirectory)throw new y.FileOperationError((0,m.localize)(11,null,this.resourceForError(l)),0,s);if(s&&typeof s.etag=="string"&&s.etag!==y.ETAG_DISABLED&&s.etag===t.etag)throw new y.FileOperationError((0,m.localize)(12,null),2,s);return this.validateReadFileLimits(l,t.size,s),t}validateReadFileLimits(l,s,t){if(t==null?void 0:t.limits){let n;if(typeof t.limits.memory=="number"&&s>t.limits.memory&&(n=9),typeof t.limits.size=="number"&&s>t.limits.size&&(n=7),typeof n=="number")throw new y.FileOperationError((0,m.localize)(13,null,this.resourceForError(l)),n)}}async canMove(l,s,t){return this.doCanMoveCopy(l,s,"move",t)}async canCopy(l,s,t){return this.doCanMoveCopy(l,s,"copy",t)}async doCanMoveCopy(l,s,t,n){if(l.toString()!==s.toString())try{const o=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(o,l,u,s,t,n)}catch(o){return o}return!0}async move(l,s,t){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),u=await this.doMoveCopy(n,l,o,s,"move",!!t),h=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,u==="move"?2:3,h)),h}async copy(l,s,t){const n=await this.withReadProvider(l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),u=await this.doMoveCopy(n,l,o,s,"copy",!!t),h=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,u==="copy"?3:2,h)),h}async doMoveCopy(l,s,t,n,o,u){if(s.toString()===n.toString())return o;const{exists:h,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(l,s,t,n,o,u);if(h&&!f&&u&&await this.del(n,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(n)),o==="copy"){if(l===t&&(0,y.hasFileFolderCopyCapability)(l))await l.copy(s,n,{overwrite:u});else{const E=await this.resolve(s);E.isDirectory?await this.doCopyFolder(l,E,t,n):await this.doCopyFile(l,s,t,n)}return o}else return l===t?(await l.rename(s,n,{overwrite:u}),o):(await this.doMoveCopy(l,s,t,n,"copy",u),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(l,s,t,n){if((0,y.hasOpenReadWriteCloseCapability)(l)&&(0,y.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(l,s,t,n);if((0,y.hasOpenReadWriteCloseCapability)(l)&&(0,y.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(l,s,t,n);if((0,y.hasReadWriteCapability)(l)&&(0,y.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(l,s,t,n);if((0,y.hasReadWriteCapability)(l)&&(0,y.hasReadWriteCapability)(t))return this.doPipeUnbuffered(l,s,t,n)}async doCopyFolder(l,s,t,n){await t.mkdir(n),Array.isArray(s.children)&&await v.Promises.settled(s.children.map(async o=>{const u=this.getExtUri(t).providerExtUri.joinPath(n,o.name);return o.isDirectory?this.doCopyFolder(l,await this.resolve(o.resource),t,u):this.doCopyFile(l,o.resource,t,u)}))}async doValidateMoveCopy(l,s,t,n,o,u){let h=!1;if(l===t){const{providerExtUri:E,isPathCaseSensitive:A}=this.getExtUri(l);if(A||(h=E.isEqual(s,n)),h&&o==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(s),this.resourceForError(n)));if(!h&&E.isEqualOrParent(n,s))throw new Error((0,m.localize)(15,null,this.resourceForError(s),this.resourceForError(n)))}const f=await this.exists(n);if(f&&!h){if(!u)throw new y.FileOperationError((0,m.localize)(16,null,this.resourceForError(s),this.resourceForError(n)),4);if(l===t){const{providerExtUri:E}=this.getExtUri(l);if(E.isEqualOrParent(s,n))throw new Error((0,m.localize)(17,null,this.resourceForError(s),this.resourceForError(n)))}}return{exists:f,isSameResourceWithDifferentPathCase:h}}getExtUri(l){const s=this.isPathCaseSensitive(l);return{providerExtUri:s?r.extUri:r.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(s,l);const t=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,0,t)),t}async mkdirp(l,s){const t=[],{providerExtUri:n}=this.getExtUri(l);for(;!n.isEqual(s,n.dirname(s));)try{if(((await l.stat(s)).type&y.FileType.Directory)==0)throw new Error((0,m.localize)(18,null,this.resourceForError(s)));break}catch(o){if((0,y.toFileSystemProviderErrorCode)(o)!==y.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(n.basename(s)),s=n.dirname(s)}for(let o=t.length-1;o>=0;o--){s=n.joinPath(s,t[o]);try{await l.mkdir(s)}catch(u){if((0,y.toFileSystemProviderErrorCode)(u)!==y.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(l,s){try{await this.doValidateDelete(l,s)}catch(t){return t}return!0}async doValidateDelete(l,s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!(s==null?void 0:s.useTrash)&&!(t.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(l)));const o=await this.exists(l);if(!o)throw new y.FileOperationError((0,m.localize)(20,null,this.resourceForError(l)),1);if(!!!(s==null?void 0:s.recursive)&&o){const h=await this.resolve(l);if(h.isDirectory&&Array.isArray(h.children)&&h.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(l)))}return t}async del(l,s){const t=await this.doValidateDelete(l,s),n=!!(s==null?void 0:s.useTrash),o=!!(s==null?void 0:s.recursive);await t.delete(l,{recursive:o,useTrash:n}),this._onDidRunOperation.fire(new y.FileOperationEvent(l,1))}watch(l,s={recursive:!1,excludes:[]}){let t=!1,n=()=>{t=!0};return this.doWatch(l,s).then(o=>{t?(0,k.dispose)(o):n=()=>(0,k.dispose)(o)},o=>this.logService.error(o)),(0,k.toDisposable)(()=>n())}async doWatch(l,s){const t=await this.withProvider(l),n=this.toWatchKey(t,l,s),o=this.activeWatchers.get(n)||{count:0,disposable:t.watch(l,s)};return this.activeWatchers.has(n)||this.activeWatchers.set(n,o),o.count+=1,(0,k.toDisposable)(()=>{o.count--,o.count===0&&((0,k.dispose)(o.disposable),this.activeWatchers.delete(n))})}toWatchKey(l,s,t){const{providerExtUri:n}=this.getExtUri(l);return[n.getComparisonKey(s),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(l=>(0,k.dispose)(l.disposable)),this.activeWatchers.clear()}async doWriteBuffered(l,s,t,n){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(async()=>{var o;const u=await l.open(s,{create:!0,unlock:(o=t==null?void 0:t.unlock)!==null&&o!==void 0?o:!1});try{(0,S.isReadableStream)(n)||(0,S.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(l,u,n):await this.doWriteReadableBufferedQueued(l,u,n)}catch(h){throw(0,y.ensureFileSystemProviderError)(h)}finally{await l.close(u)}})}async doWriteStreamBufferedQueued(l,s,t){let n=0,o;if((0,S.isReadableBufferedStream)(t)){if(t.buffer.length>0){const u=g.VSBuffer.concat(t.buffer);await this.doWriteBuffer(l,s,u,u.byteLength,n,0),n+=u.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise(async(u,h)=>{(0,S.listenStream)(o,{onData:async f=>{o.pause();try{await this.doWriteBuffer(l,s,f,f.byteLength,n,0)}catch(E){return h(E)}n+=f.byteLength,setTimeout(()=>o.resume())},onError:f=>h(f),onEnd:()=>u()})})}async doWriteReadableBufferedQueued(l,s,t){let n=0,o;for(;(o=t.read())!==null;)await this.doWriteBuffer(l,s,o,o.byteLength,n,0),n+=o.byteLength}async doWriteBuffer(l,s,t,n,o,u){let h=0;for(;h<n;)h+=await l.write(s,o+h,t.buffer,u+h,n-h)}async doWriteUnbuffered(l,s,t,n){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,s,t,n))}async doWriteUnbufferedQueued(l,s,t,n){var o;let u;n instanceof g.VSBuffer?u=n:(0,S.isReadableStream)(n)?u=await(0,g.streamToBuffer)(n):(0,S.isReadableBufferedStream)(n)?u=await(0,g.bufferedStreamToBuffer)(n):u=(0,g.readableToBuffer)(n),await l.writeFile(s,u.buffer,{create:!0,overwrite:!0,unlock:(o=t==null?void 0:t.unlock)!==null&&o!==void 0?o:!1})}async doPipeBuffered(l,s,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,s,t,n))}async doPipeBufferedQueued(l,s,t,n){let o,u;try{o=await l.open(s,{create:!1}),u=await t.open(n,{create:!0,unlock:!1});const h=g.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,E=0,A=0;do A=await l.read(o,f,h.buffer,E,h.byteLength-E),await this.doWriteBuffer(t,u,h,A,f,E),f+=A,E+=A,E===h.byteLength&&(E=0);while(A>0)}catch(h){throw(0,y.ensureFileSystemProviderError)(h)}finally{await v.Promises.settled([typeof o=="number"?l.close(o):Promise.resolve(),typeof u=="number"?t.close(u):Promise.resolve()])}}async doPipeUnbuffered(l,s,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,s,t,n))}async doPipeUnbufferedQueued(l,s,t,n){return t.writeFile(n,await l.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,s,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,s,t,n))}async doPipeUnbufferedToBufferedQueued(l,s,t,n){const o=await t.open(n,{create:!0,unlock:!1});try{const u=await l.readFile(s);await this.doWriteBuffer(t,o,g.VSBuffer.wrap(u),u.byteLength,0,0)}catch(u){throw(0,y.ensureFileSystemProviderError)(u)}finally{await t.close(o)}}async doPipeBufferedToUnbuffered(l,s,t,n){const o=await(0,g.streamToBuffer)(this.readFileBuffered(l,s,d.CancellationToken.None));await this.doWriteUnbuffered(t,n,void 0,o)}throwIfFileSystemIsReadonly(l,s){if(l.capabilities&2048)throw new y.FileOperationError((0,m.localize)(22,null,this.resourceForError(s)),6);return l}resourceForError(l){return l.scheme===w.Schemas.file?l.fsPath:l.toString(!0)}};a=ce([ee(0,D.ILogService)],a),e.FileService=a}),define(X[173],J([0,1,18,112,2,24,5,3,19,8,15,30,9,6,139,91,159,161,158,167,63,90,35,23]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v,d,w,I,b,a,c,l,s,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class o extends k.Disposable{constructor(h,f){var E;super();this.logService=h,this.options=f,this.BUFFER_SIZE=((E=this.options)===null||E===void 0?void 0:E.bufferSize)||64*1024,this.onDidChangeCapabilities=P.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new P.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new S.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,r.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(h){try{const{stat:f,symbolicLink:E}=await p.SymlinkSupport.stat(this.toFilePath(h));return{type:this.toType(f,E),ctime:f.birthtime.getTime(),mtime:f.mtime.getTime(),size:f.size}}catch(f){throw this.toFileSystemProviderError(f)}}async readdir(h){try{const f=await(0,p.readdir)(this.toFilePath(h),{withFileTypes:!0}),E=[];return await Promise.all(f.map(async A=>{try{let _;A.isSymbolicLink()?_=(await this.stat((0,D.joinPath)(h,A.name))).type:_=this.toType(A),E.push([A.name,_])}catch(_){this.logService.trace(_)}})),E}catch(f){throw this.toFileSystemProviderError(f)}}toType(h,f){let E;return(f==null?void 0:f.dangling)?E=y.FileType.Unknown:h.isFile()?E=y.FileType.File:h.isDirectory()?E=y.FileType.Directory:E=y.FileType.Unknown,f&&(E|=y.FileType.SymbolicLink),E}async readFile(h){try{const f=this.toFilePath(h);return await m.promises.readFile(f)}catch(f){throw this.toFileSystemProviderError(f)}}readFileStream(h,f,E){const A=(0,l.newWriteableStream)(_=>n.VSBuffer.concat(_.map(U=>n.VSBuffer.wrap(U))).buffer);return(0,s.readFileIntoStream)(this,h,A,_=>_.buffer,Object.assign(Object.assign({},f),{bufferSize:this.BUFFER_SIZE}),E),A}async writeFile(h,f,E){let A;try{const _=this.toFilePath(h);if(!E.create||!E.overwrite){if(await(0,p.exists)(_)){if(!E.overwrite)throw(0,y.createFileSystemProviderError)((0,d.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!E.create)throw(0,y.createFileSystemProviderError)((0,d.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}A=await this.open(h,{create:!0,unlock:E.unlock}),await this.write(A,0,f,0,f.byteLength)}catch(_){throw await this.toFileSystemProviderWriteError(h,_)}finally{typeof A=="number"&&await this.close(A)}}async open(h,f){try{const E=this.toFilePath(h);if((0,y.isFileOpenForWriteOptions)(f)&&f.unlock)try{const{stat:U}=await p.SymlinkSupport.stat(E);U.mode&128||await m.promises.chmod(E,U.mode|128)}catch(U){this.logService.trace(U)}let A;if((0,y.isFileOpenForWriteOptions)(f)){if(r.isWindows)try{await m.promises.truncate(E,0),A="r+"}catch(U){U.code!=="ENOENT"&&this.logService.trace(U)}A||(A="w")}else A="r";const _=await(0,L.promisify)(m.open)(E,A);return this.mapHandleToPos.set(_,0),(0,y.isFileOpenForWriteOptions)(f)&&this.writeHandles.set(_,h),_}catch(E){throw(0,y.isFileOpenForWriteOptions)(f)?await this.toFileSystemProviderWriteError(h,E):this.toFileSystemProviderError(E)}}async close(h){try{if(this.mapHandleToPos.delete(h),this.writeHandles.delete(h)&&this.canFlush)try{await(0,L.promisify)(m.fdatasync)(h)}catch(f){this.canFlush=!1,this.logService.error(f)}return await(0,L.promisify)(m.close)(h)}catch(f){throw this.toFileSystemProviderError(f)}}async read(h,f,E,A,_){const U=this.normalizePos(h,f);let H=null;try{const Q=await(0,L.promisify)(m.read)(h,E,A,_,U);return typeof Q=="number"?H=Q:H=Q.bytesRead,H}catch(Q){throw this.toFileSystemProviderError(Q)}finally{this.updatePos(h,U,H)}}normalizePos(h,f){return f===this.mapHandleToPos.get(h)?null:f}updatePos(h,f,E){const A=this.mapHandleToPos.get(h);typeof A=="number"&&(typeof f=="number"||(typeof E=="number"?this.mapHandleToPos.set(h,A+E):this.mapHandleToPos.delete(h)))}async write(h,f,E,A,_){return(0,S.retry)(()=>this.doWrite(h,f,E,A,_),100,3)}async doWrite(h,f,E,A,_){const U=this.normalizePos(h,f);let H=null;try{const Q=await(0,L.promisify)(m.write)(h,E,A,_,U);return typeof Q=="number"?H=Q:H=Q.bytesWritten,H}catch(Q){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(h),Q)}finally{this.updatePos(h,U,H)}}async mkdir(h){try{await m.promises.mkdir(this.toFilePath(h))}catch(f){throw this.toFileSystemProviderError(f)}}async delete(h,f){try{const E=this.toFilePath(h);await this.doDelete(E,f)}catch(E){throw this.toFileSystemProviderError(E)}}async doDelete(h,f){f.recursive?await(0,p.rimraf)(h,p.RimRafMode.MOVE):await m.promises.unlink(h)}async rename(h,f,E){const A=this.toFilePath(h),_=this.toFilePath(f);if(A!==_)try{await this.validateTargetDeleted(h,f,"move",E.overwrite),await(0,p.move)(A,_)}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error((0,d.localize)(2,null,(0,i.basename)(A),(0,i.basename)((0,i.dirname)(_)),U.toString()))),this.toFileSystemProviderError(U)}}async copy(h,f,E){const A=this.toFilePath(h),_=this.toFilePath(f);if(A!==_)try{await this.validateTargetDeleted(h,f,"copy",E.overwrite),await(0,p.copy)(A,_,{preserveSymlinks:!0})}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error((0,d.localize)(3,null,(0,i.basename)(A),(0,i.basename)((0,i.dirname)(_)),U.toString()))),this.toFileSystemProviderError(U)}}async validateTargetDeleted(h,f,E,A){const _=this.toFilePath(h),U=this.toFilePath(f);let H=!1;if(!!(this.capabilities&1024)||(H=(0,g.isEqual)(_,U,!0)),H&&E==="copy")throw(0,y.createFileSystemProviderError)((0,d.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!H&&await(0,p.exists)(U)){if(!A)throw(0,y.createFileSystemProviderError)((0,d.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(f,{recursive:!0,useTrash:!1})}}watch(h,f){return f.recursive?this.watchRecursive(h,f.excludes):this.watchNonRecursive(h)}watchRecursive(h,f){const E={path:this.toFilePath(h),excludes:f},A=(0,t.insert)(this.recursiveFoldersToWatch,E);return this.refreshRecursiveWatchers(),(0,k.toDisposable)(()=>{A(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var h,f,E;if(this.recursiveWatcher instanceof a.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,k.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let A,_;((f=(h=this.options)===null||h===void 0?void 0:h.watcher)===null||f===void 0?void 0:f.usePolling)?(A=I.FileWatcher,_=(E=this.options)===null||E===void 0?void 0:E.watcher):this.recursiveFoldersToWatch.length===1?r.isWindows?A=b.FileWatcher:A=I.FileWatcher:A=a.FileWatcher,this.recursiveWatcher=new A(this.recursiveFoldersToWatch,U=>this._onDidChangeFile.fire((0,w.toFileChanges)(U)),U=>{U.type==="error"&&this._onDidWatchErrorOccur.fire(U.message),this.logService[U.type](U.message)},this.logService.getLevel()===v.LogLevel.Trace,_),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)}))}}watchNonRecursive(h){const f=new c.FileWatcher(this.toFilePath(h),A=>this._onDidChangeFile.fire((0,w.toFileChanges)(A)),A=>{A.type==="error"&&this._onDidWatchErrorOccur.fire(A.message),this.logService[A.type](A.message)},this.logService.getLevel()===v.LogLevel.Trace),E=this.logService.onDidChangeLogLevel(()=>{f.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)});return(0,k.combinedDisposable)(f,E)}toFilePath(h){return(0,i.normalize)(h.fsPath)}toFileSystemProviderError(h){if(h instanceof y.FileSystemProviderError)return h;let f;switch(h.code){case"ENOENT":f=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":f=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":f=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":f=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":f=y.FileSystemProviderErrorCode.NoPermissions;break;default:f=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(h,f)}async toFileSystemProviderWriteError(h,f){let E=this.toFileSystemProviderError(f);if(h&&E.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:A}=await p.SymlinkSupport.stat(this.toFilePath(h));A.mode&128||(E=(0,y.createFileSystemProviderError)(f,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(A){this.logService.trace(A)}return E}dispose(){super.dispose(),(0,k.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,k.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=o}),define(X[92],J([0,1,6]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(y,P){switch(P){case m.LogLevel.Trace:return y.trace;case m.LogLevel.Debug:return y.debug;case m.LogLevel.Info:return y.info;case m.LogLevel.Warning:return y.warn;case m.LogLevel.Error:return y.error;case m.LogLevel.Critical:return y.critical;default:throw new Error("Invalid log level")}}class k extends m.AbstractLogger{constructor(P=m.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(P),this._register(this.onDidChangeLogLevel(r=>{this._logger&&this._logger.setLevel(r)}))}set logger(P){this._logger=P;for(const{level:r,args:p}of this.buffer)L(P,r).apply(P,p);this.buffer=[]}_log(P,...r){this._logger?L(this._logger,P).apply(this._logger,r):this.getLevel()<=P&&this.buffer.push({level:P,args:r})}trace(P,...r){this._log(m.LogLevel.Trace,P,...r)}debug(P,...r){this._log(m.LogLevel.Debug,P,...r)}info(P,...r){this._log(m.LogLevel.Info,P,...r)}warn(P,...r){this._log(m.LogLevel.Warning,P,...r)}error(P,...r){this._log(m.LogLevel.Error,P,...r)}critical(P,...r){this._log(m.LogLevel.Critical,P,...r)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=k}),define(X[174],J([0,1,6,24,9,23,15,4,92]),function(q,e,m,L,k,y,P,r,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const i=5*L.ByteSize.MB;let D=class extends m.AbstractLogger{constructor(v,d,w,I){super();this.name=v,this.resource=d,this.fileService=I,this.backupIndex=1,this.setLevel(w),this.queue=this._register(new k.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=m.LogLevel.Trace&&this._log(m.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=m.LogLevel.Debug&&this._log(m.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=m.LogLevel.Info&&this._log(m.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=m.LogLevel.Warning&&this._log(m.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=m.LogLevel.Error){const v=arguments[0];if(v instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=v.stack,this._log(m.LogLevel.Error,this.format(d))}else this._log(m.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=m.LogLevel.Critical&&this._log(m.LogLevel.Critical,this.format(arguments))}flush(){}log(v,d){this._log(v,this.format(d))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(v){if(v.fileOperationResult!==3)throw v}}_log(v,d){this.queue.queue(async()=>{await this.initializePromise;let w=await this.loadContent();w.length>i&&(await this.fileService.writeFile(this.getBackupResource(),y.VSBuffer.fromString(w)),w=""),w+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(v)}] ${d}
`,await this.fileService.writeFile(this.resource,y.VSBuffer.fromString(w))})}getCurrentTimestamp(){const v=I=>I<10?`0${I}`:I,d=I=>I<10?`00${I}`:I<100?`0${I}`:I,w=new Date;return`${w.getFullYear()}-${v(w.getMonth()+1)}-${v(w.getDate())} ${v(w.getHours())}:${v(w.getMinutes())}:${v(w.getSeconds())}.${d(w.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,P.joinPath)((0,P.dirname)(this.resource),`${(0,P.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(v){return""}}stringifyLogLevel(v){switch(v){case m.LogLevel.Critical:return"critical";case m.LogLevel.Debug:return"debug";case m.LogLevel.Error:return"error";case m.LogLevel.Info:return"info";case m.LogLevel.Trace:return"trace";case m.LogLevel.Warning:return"warning"}return""}format(v){let d="";for(let w=0;w<v.length;w++){let I=v[w];if(typeof I=="object")try{I=JSON.stringify(I)}catch(b){}d+=(w>0?" ":"")+I}return d}};D=ce([ee(3,L.IFileService)],D),e.FileLogger=D;let g=class extends m.AbstractLoggerService{constructor(v,d,w){super(v.getLevel(),v.onDidChangeLogLevel);this.instantiationService=d,this.fileService=w}doCreateLogger(v,d){const w=new p.BufferLogService(d);return(0,L.whenProviderRegistered)(v,this.fileService).then(()=>w.logger=this.instantiationService.createInstance(D,(0,P.basename)(v),v,w.getLevel())),w}};g=ce([ee(0,m.ILogService),ee(1,r.IInstantiationService),ee(2,L.IFileService)],g),e.FileLoggerService=g}),define(X[175],J([0,1,6,5,7]),function(q,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class y{constructor(S){this.service=S,this.onDidChangeLogLevel=L.Event.buffer(S.onDidChangeLogLevel,!0)}listen(S,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(S,v,d){switch(v){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=y;class P{constructor(S){this.channel=S}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(S){P.setLevel(this.channel,S)}static setLevel(S,v){return S.call("setLevel",v)}}e.LogLevelChannelClient=P;class r{constructor(S){this.loggerService=S,this.loggers=new Map}listen(S,v){throw new Error(`Event not found: ${v}`)}async call(S,v,d){switch(v){case"createLogger":this.createLogger(k.URI.revive(d[0]),d[1]);return;case"log":return this.log(k.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${v}`)}createLogger(S,v){this.loggers.set(S.toString(),this.loggerService.createLogger(S,v))}consoleLog(S,v){let d=console.log;switch(S){case m.LogLevel.Error:d=console.error;break;case m.LogLevel.Warning:d=console.warn;break;case m.LogLevel.Info:d=console.info;break}d.call(console,...v)}log(S,v){const d=this.loggers.get(S.toString());if(!d)throw new Error("Create the logger before logging");for(const[w,I]of v)switch(w){case m.LogLevel.Trace:d.trace(I);break;case m.LogLevel.Debug:d.debug(I);break;case m.LogLevel.Info:d.info(I);break;case m.LogLevel.Warning:d.warn(I);break;case m.LogLevel.Error:d.error(I);break;case m.LogLevel.Critical:d.critical(I);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=r;class p extends m.AbstractLoggerService{constructor(S,v,d){super(S,v);this.channel=d}createConsoleMainLogger(){return new m.AdapterLogger({log:(S,v)=>{this.channel.call("consoleLog",[S,v])}})}doCreateLogger(S,v,d){return new i(this.channel,S,v,d)}}e.LoggerChannelClient=p;class i extends m.AbstractMessageLogger{constructor(S,v,d,w){super(w==null?void 0:w.always);this.channel=S,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[v,w]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,v){const d=[[S,v]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(S){this.channel.call("log",[this.file,S])}}class D extends m.LogService{constructor(S,v){super(v);this.parent=S,this._register(S.onDidChangeLogLevel(d=>v.setLevel(d)))}setLevel(S){super.setLevel(S),this.parent.setLevel(S)}}e.FollowerLogService=D}),define(X[93],J([0,1,6,24]),function(q,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(p,i,D,g){try{const S=await new Promise((v,d)=>{q(["spdlog"],v,d)});return S.setAsyncMode(8192,500),S.createRotatingLoggerAsync(p,i,D,g)}catch(S){console.error(S)}return null}function y(p,i,D,g){return q.__$__nodeRequire("spdlog").createRotatingLogger(p,i,D,g)}e.createRotatingLogger=y;function P(p,i,D){switch(i){case m.LogLevel.Trace:p.trace(D);break;case m.LogLevel.Debug:p.debug(D);break;case m.LogLevel.Info:p.info(D);break;case m.LogLevel.Warning:p.warn(D);break;case m.LogLevel.Error:p.error(D);break;case m.LogLevel.Critical:p.critical(D);break;default:throw new Error("Invalid log level")}}class r extends m.AbstractMessageLogger{constructor(i,D,g,S){super();this.name=i,this.filepath=D,this.rotating=g,this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(v=>{this._logger&&this._logger.setLevel(v)}))}_createSpdLogLogger(){const i=this.rotating?6:1,D=30/i*L.ByteSize.MB;return k(this.name,this.filepath,D,i).then(g=>{if(g){this._logger=g,this._logger.setLevel(this.getLevel());for(const{level:S,message:v}of this.buffer)P(this._logger,S,v);this.buffer=[]}})}log(i,D){this._logger?P(this._logger,i,D):this.getLevel()<=i&&this.buffer.push({level:i,message:D})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=r}),define(X[176],J([0,1,6,15,10,174,93,24,28]),function(q,e,m,L,k,y,P,r,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let i=class extends m.AbstractLoggerService{constructor(g,S){super(g.getLevel(),g.onDidChangeLogLevel);this.fileService=S}doCreateLogger(g,S,v){var d;if(g.scheme===k.Schemas.file){const w=new P.SpdLogLogger((v==null?void 0:v.name)||(0,p.generateUuid)(),g.fsPath,!(v==null?void 0:v.donotRotate),S);return(v==null?void 0:v.donotUseFormatters)&&w.clearFormatters(),w}else return new y.FileLogger((d=v==null?void 0:v.name)!==null&&d!==void 0?d:(0,L.basename)(g),g,S,this.fileService)}};i=ce([ee(0,m.ILogService),ee(1,r.IFileService)],i),e.LoggerService=i}),define(X[177],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function m(P){return P.submenu!==void 0}e.isMenubarMenuItemSubmenu=m;function L(P){return P.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function k(P){return P.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function y(P){return!m(P)&&!L(P)&&!k(P)}e.isMenubarMenuItemAction=y}),define(X[54],J([0,1,10,3,32,15]),function(q,e,m,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof L.globals.vscode!="undefined"){const r=L.globals.vscode.context.configuration();if(r)P=r.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(q==null?void 0:q.__$__nodeRequire)=="function"){const r=(0,y.dirname)(m.FileAccess.asFileUri("",q));P=q.__$__nodeRequire((0,y.joinPath)(r,"product.json").fsPath);const p=q.__$__nodeRequire((0,y.joinPath)(r,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`}),Object.assign(P,{version:p.version})}else P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.56.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=P}),define(X[20],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,m.createDecorator)("productService")}),define(X[178],J([0,1,58,6,20]),function(q,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let y=class{constructor(r,p){this.productService=r,this.logService=p,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(r,p){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const i=/^(.*)#([^#]+)$/.exec(p);if(!i)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",p),!1;const[,D,g]=i;let S=this.trustedExtensionUrlPublicKeys.get(r);if(!S){if(S=this.productService.trustedExtensionUrlPublicKeys[r],!S||S.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",r),!1;this.trustedExtensionUrlPublicKeys.set(r,[...S])}const v=Buffer.from(decodeURIComponent(g),"base64");if(v.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",p),!1;const d=v.slice(0,6),w=v.readUIntBE(0,6),I=Date.now()-w;if(I<0||I>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",p),!1;const b=v.slice(6),a=m.createVerify("SHA256");a.write(d),a.write(Buffer.from(D)),a.end();for(let c=0;c<S.length;c++){let l=S[c];if(l!==null){if(typeof l=="string")try{l=m.createPublicKey({key:Buffer.from(l,"base64"),format:"der",type:"spki"}),S[c]=l}catch(s){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${c+1} for ${r}:`,s),S[c]=null;continue}if(a.verify(l,b))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",p),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",p),!1}};y=ce([ee(0,k.IProductService),ee(1,L.ILogService)],y),e.ExtensionUrlTrustService=y}),define(X[55],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,m.createDecorator)("protocolMainService")}),define(X[179],J([0,1,2,10,7,46,13,6,36,3,15,28]),function(q,e,m,L,k,y,P,r,p,i,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let S=class extends m.Disposable{constructor(d,w){super();this.logService=w,this.validRoots=p.TernarySearchTree.forUris(()=>!i.isLinux),this.validExtensions=new Set([".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(k.URI.file(d.appRoot)),this.addValidFileRoot(k.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=P.session;d.protocol.registerFileProtocol(L.Schemas.vscodeFileResource,(w,I)=>this.handleResourceRequest(w,I)),d.protocol.interceptFileProtocol(L.Schemas.file,(w,I)=>this.handleFileRequest(w,I)),this._register((0,m.toDisposable)(()=>{d.protocol.unregisterProtocol(L.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(L.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?m.Disposable.None:(this.validRoots.set(d,!0),(0,m.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(d,w){const I=k.URI.parse(d.url);return i.isPreferringBrowserCodeLoad?(this.logService.error(`Refused to load resource ${I.fsPath} from ${L.Schemas.file}: protocol (original URL: ${d.url})`),w({error:-3})):this.validRoots.findSubstr(I)?w({path:I.fsPath}):this.validExtensions.has((0,D.extname)(I))?w({path:I.fsPath}):(this.logService.error(`${L.Schemas.file}: Refused to load resource ${I.fsPath} from ${L.Schemas.file}: protocol (original URL: ${d.url})`),w({error:-3}))}handleResourceRequest(d,w){const I=k.URI.parse(d.url),b=L.FileAccess.asFileUri(I);return this.validRoots.findSubstr(b)?w({path:b.fsPath}):this.validExtensions.has((0,D.extname)(b))?w({path:b.fsPath}):(this.logService.error(`${L.Schemas.vscodeFileResource}: Refused to load resource ${b.fsPath} from ${L.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),w({error:-3}))}createIPCObjectUrl(d){const w=k.URI.from({scheme:"vscode",path:(0,g.generateUuid)()}),I=w.toString(),b=async()=>d;return P.ipcMain.handle(I,b),this.logService.trace(`IPC Object URL: Registered new channel ${I}.`),{resource:w,update:a=>d=a,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${I}.`),P.ipcMain.removeHandler(I)}}}};S=ce([ee(0,y.INativeEnvironmentService),ee(1,r.ILogService)],S),e.ProtocolMainService=S}),define(X[37],J([0,1,12,100]),function(q,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(P,r){L.ok(m.isString(P)),L.ok(m.isObject(r)),L.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,r)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new k}),define(X[180],J([0,1,37,5]),function(q,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(r){return r.length>0&&r.charAt(r.length-1)==="#"?r.substring(0,r.length-1):r}class y{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,i){this.schemasById[k(p)]=i,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new y;m.Registry.add(e.Extensions.JSONContribution,P)}),define(X[47],J([0,1,130,5,37,12,180]),function(q,e,m,L,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var r;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(r=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const p=k.Registry.as(P.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,a=!0){this.registerConfigurations([b],a)}registerConfigurations(b,a=!0){const c=[];b.forEach(l=>{c.push(...this.validateAndRegisterProperties(l,a,l.extensionInfo)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(b){const a=[],c=l=>{if(l.properties)for(const s in l.properties)a.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,l.properties[s]);l.allOf&&l.allOf.forEach(s=>c(s))};for(const l of b){c(l);const s=this.configurationContributors.indexOf(l);s!==-1&&this.configurationContributors.splice(s,1)}p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}registerDefaultConfigurations(b){const a=[],c=[];for(const l of b)for(const s in l)if(a.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]=Object.assign(Object.assign({},this.defaultValues[s]||{}),l[s]);const t={type:"object",default:this.defaultValues[s],description:m.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};c.push(g(s)),this.configurationProperties[s]=t,this.defaultLanguageConfigurationOverridesNode.properties[s]=t}else{this.defaultValues[s]=l[s];const t=this.configurationProperties[s];t&&(this.updatePropertyDefaultValue(s,t),this.updateSchema(s,t))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterDefaultConfigurations(b){const a=[];for(const c of b)for(const l in c)if(a.push(l),delete this.defaultValues[l],e.OVERRIDE_PROPERTY_PATTERN.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const s=this.configurationProperties[l];s&&(this.updatePropertyDefaultValue(l,s),this.updateSchema(l,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const a of b)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,a=!0,c,l=3){var s;l=y.isUndefinedOrNull(b.scope)?l:b.scope;let t=[],n=b.properties;if(n)for(let u in n){if(a&&d(u)){delete n[u];continue}const h=n[u];if(this.updatePropertyDefaultValue(u,h),e.OVERRIDE_PROPERTY_PATTERN.test(u)?h.scope=void 0:(h.scope=y.isUndefinedOrNull(h.scope)?l:h.scope,h.requireTrust=y.isUndefinedOrNull(h.requireTrust)?!!((s=c==null?void 0:c.requireTrustForConfigurations)===null||s===void 0?void 0:s.includes(u)):h.requireTrust),n[u].hasOwnProperty("included")&&!n[u].included){this.excludedConfigurationProperties[u]=n[u],delete n[u];continue}else this.configurationProperties[u]=n[u];!n[u].deprecationMessage&&n[u].markdownDeprecationMessage&&(n[u].deprecationMessage=n[u].markdownDeprecationMessage),t.push(u)}let o=b.allOf;if(o)for(let u of o)t.push(...this.validateAndRegisterProperties(u,a,c,l));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const a=c=>{let l=c.properties;if(l)for(const t in l)this.updateSchema(t,l[t]);let s=c.allOf;s&&s.forEach(a)};a(b)}updateSchema(b,a){switch(e.allSettings.properties[b]=a,a.scope){case 1:e.applicationSettings.properties[b]=a;break;case 2:e.machineSettings.properties[b]=a;break;case 6:e.machineOverridableSettings.properties[b]=a;break;case 3:e.windowSettings.properties[b]=a;break;case 4:e.resourceSettings.properties[b]=a;break;case 5:e.resourceSettings.properties[b]=a,this.resourceLanguageSettingsSchema.properties[b]=a;break}}removeFromSchema(b,a){switch(delete e.allSettings.properties[b],a.scope){case 1:delete e.applicationSettings.properties[b];break;case 2:delete e.machineSettings.properties[b];break;case 6:delete e.machineOverridableSettings.properties[b];break;case 3:delete e.windowSettings.properties[b];break;case 4:case 5:delete e.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const a=`[${b}]`,c={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,c),e.allSettings.properties[a]=c,e.applicationSettings.properties[a]=c,e.machineSettings.properties[a]=c,e.machineOverridableSettings.properties[a]=c,e.windowSettings.properties[a]=c,e.resourceSettings.properties[a]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,a){let c=this.defaultValues[b];y.isUndefined(c)&&(c=a.default),y.isUndefined(c)&&(c=S(a.type)),a.default=c}}const D="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(D);function g(I){return I.substring(1,I.length-1)}e.overrideIdentifierFromKey=g;function S(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=S;const v=new i;k.Registry.add(e.Extensions.Configuration,v);function d(I){return I.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(I)?m.localize(5,null,I):v.getConfigurationProperties()[I]!==void 0?m.localize(6,null,I):null:m.localize(4,null)}e.validateProperty=d;function w(){const I=[],b=v.getConfigurationProperties();for(const a of Object.keys(b))I.push([a,b[a].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.getScopes=w}),define(X[21],J([0,1,44,12,7,37,4,47]),function(q,e,m,L,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function p(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof k.URI)}e.isConfigurationOverrides=p;var i;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(i=e.ConfigurationTarget||(e.ConfigurationTarget={}));function D(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=D;function g(n,o){const u=o?n?o.keys.filter(H=>n.keys.indexOf(H)===-1):[...o.keys]:[],h=n?o?n.keys.filter(H=>o.keys.indexOf(H)===-1):[...n.keys]:[],f=[];if(o&&n){for(const H of n.keys)if(o.keys.indexOf(H)!==-1){const Q=b(n.contents,H),ne=b(o.contents,H);m.equals(Q,ne)||f.push(H)}}const E=[],A=H=>{const Q={};for(const ne of H)for(const ae of ne.identifiers)Q[s(ae)]=ne;return Q},_=o?A(o.overrides):{},U=n?A(n.overrides):{};if(Object.keys(_).length)for(const H of u){const Q=_[H];Q&&E.push([(0,r.overrideIdentifierFromKey)(H),Q.keys])}if(Object.keys(U).length)for(const H of h){const Q=U[H];Q&&E.push([(0,r.overrideIdentifierFromKey)(H),Q.keys])}if(Object.keys(_).length&&Object.keys(U).length)for(const H of f){const Q=U[H],ne=_[H];if(Q&&ne){const ae=g({contents:Q.contents,keys:Q.keys,overrides:[]},{contents:ne.contents,keys:ne.keys,overrides:[]});E.push([(0,r.overrideIdentifierFromKey)(H),[...ae.added,...ae.removed,...ae.updated]])}}return{added:u,removed:h,updated:f,overrides:E}}e.compare=g;function S(n,o){const u=[];for(const h of Object.keys(n))if(r.OVERRIDE_PROPERTY_PATTERN.test(h)){const f={};for(const E in n[h])f[E]=n[h][E];u.push({identifiers:[(0,r.overrideIdentifierFromKey)(h).trim()],keys:Object.keys(f),contents:v(f,o)})}return u}e.toOverrides=S;function v(n,o){const u=Object.create(null);for(let h in n)d(u,h,n[h],o);return u}e.toValuesTree=v;function d(n,o,u,h){const f=o.split("."),E=f.pop();let A=n;for(let _=0;_<f.length;_++){let U=f[_],H=A[U];switch(typeof H){case"undefined":H=A[U]=Object.create(null);break;case"object":break;default:h(`Ignoring ${o} as ${f.slice(0,_+1).join(".")} is ${JSON.stringify(H)}`);return}A=H}if(typeof A=="object"&&A!==null)try{A[E]=u}catch(_){h(`Ignoring ${o} as ${f.join(".")} is ${JSON.stringify(A)}`)}else h(`Ignoring ${o} as ${f.join(".")} is ${JSON.stringify(A)}`)}e.addToValueTree=d;function w(n,o){const u=o.split(".");I(n,u)}e.removeFromValueTree=w;function I(n,o){const u=o.shift();if(o.length===0){delete n[u];return}if(Object.keys(n).indexOf(u)!==-1){const h=n[u];typeof h=="object"&&!Array.isArray(h)&&(I(h,o),Object.keys(h).length===0&&delete n[u])}}function b(n,o,u){function h(A,_){let U=A;for(const H of _){if(typeof U!="object"||U===null)return;U=U[H]}return U}const f=o.split("."),E=h(n,f);return typeof E=="undefined"?u:E}e.getConfigurationValue=b;function a(n,o,u){Object.keys(o).forEach(h=>{h!=="__proto__"&&(h in n?L.isObject(n[h])&&L.isObject(o[h])?a(n[h],o[h],u):u&&(n[h]=o[h]):n[h]=o[h])})}e.merge=a;function c(){const n=y.Registry.as(r.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=c;function l(){const n=Object.create(null),o=y.Registry.as(r.Extensions.Configuration).getConfigurationProperties();for(let u in o){let h=o[u].default;d(n,u,h,f=>console.error(`Conflict in default settings: ${f}`))}return n}e.getDefaultValues=l;function s(n){return`[${n}]`}e.keyFromOverrideIdentifier=s;function t(n,o,u){const h=n.inspect(o),f=n.inspect(u);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:h.defaultValue}e.getMigratedSettingValue=t}),define(X[181],J([0,1,43,36,35,12,44,7,47,21,37,2,5]),function(q,e,m,L,k,y,P,r,p,i,D,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class v{constructor(t={},n=[],o=[]){this._contents=t,this._keys=n,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const o=this.getContentsForOverrideIdentifer(n);return o?t?(0,i.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let o={};for(const u of k.distinct([...Object.keys(this.contents),...Object.keys(n)])){let h=this.contents[u],f=n[u];f&&(typeof h=="object"&&typeof f=="object"?(h=P.deepClone(h),this.mergeContents(h,f)):h=f),o[u]=h}return new v(o,this.keys,this.overrides)}merge(...t){const n=P.deepClone(this.contents),o=P.deepClone(this.overrides),u=[...this.keys];for(const h of t){this.mergeContents(n,h.contents);for(const f of h.overrides){const[E]=o.filter(A=>k.equals(A.identifiers,f.identifiers));E?this.mergeContents(E.contents,f.contents):o.push(P.deepClone(f))}for(const f of h.keys)u.indexOf(f)===-1&&u.push(f)}return new v(n,u,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const o of Object.keys(n)){if(o in t&&y.isObject(t[o])&&y.isObject(n[o])){this.mergeContents(t[o],n[o]);continue}t[o]=P.deepClone(n[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,i.addToValueTree)(this.contents,t,n,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let o=0;o<n;o++)t.indexOf(this.keys[o])===0&&(n=o);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=v;class d extends v{constructor(){const t=(0,i.getDefaultValues)(),n=(0,i.getConfigurationKeys)(),o=[];for(const u of Object.keys(t))p.OVERRIDE_PROPERTY_PATTERN.test(u)&&o.push({identifiers:[(0,p.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(t[u]),contents:(0,i.toValuesTree)(t[u],h=>console.error(`Conflict in default settings file: ${h}`))});super(t,n,o)}}e.DefaultConfigurationModel=d;class w{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!y.isUndefinedOrNull(t)){const o=this.doParseContent(t);this.parseRaw(o,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:o,keys:u,overrides:h,untrusted:f}=this.doParseRaw(t,n);this._configurationModel=new v(o,u,h),this._untrustedConfigurations=f||[]}doParseContent(t){let n={},o=null,u=[],h=[],f=[];function E(_){Array.isArray(u)?u.push(_):o&&(u[o]=_)}let A={onObjectBegin:()=>{let _={};E(_),h.push(u),u=_,o=null},onObjectProperty:_=>{o=_},onObjectEnd:()=>{u=h.pop()},onArrayBegin:()=>{let _=[];E(_),h.push(u),u=_,o=null},onArrayEnd:()=>{u=h.pop()},onLiteralValue:E,onError:(_,U,H)=>{f.push({error:_,offset:U,length:H})}};if(t)try{m.visit(t,A),n=u[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return n}doParseRaw(t,n){const o=D.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),u=this.filter(t,o,!0,n);t=u.raw;const h=(0,i.toValuesTree)(t,A=>console.error(`Conflict in settings file ${this._name}: ${A}`)),f=Object.keys(t),E=(0,i.toOverrides)(t,A=>console.error(`Conflict in settings file ${this._name}: ${A}`));return{contents:h,keys:f,overrides:E,untrusted:u.untrusted}}filter(t,n,o,u){if(!(u==null?void 0:u.scopes)&&!(u==null?void 0:u.isUntrusted))return{raw:t,untrusted:[]};const h={},f=[];for(let E in t)if(p.OVERRIDE_PROPERTY_PATTERN.test(E)&&o){const A=this.filter(t[E],n,!1,u);h[E]=A.raw,f.push(...A.untrusted)}else{const A=n[E],_=A?typeof A.scope!="undefined"?A.scope:3:void 0;(_===void 0||u.scopes===void 0||u.scopes.includes(_))&&(u.isUntrusted&&(A==null?void 0:A.requireTrust)?f.push(E):h[E]=t[E])}return{raw:h,untrusted:f}}}e.ConfigurationModelParser=w;class I extends g.Disposable{constructor(t,n,o,u){super();this.userSettingsResource=t,this.scopes=n,this.fileService=u,this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(S.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=I;class b{constructor(t,n,o=new v,u=new v,h=new L.ResourceMap,f=new v,E=new L.ResourceMap,A=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=u,this._folderConfigurations=h,this._memoryConfiguration=f,this._memoryConfigurationByResource=E,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,n,o){return this.getConsolidateConfigurationModel(n,o).getValue(t)}updateValue(t,n,o={}){let u;o.resource?(u=this._memoryConfigurationByResource.get(o.resource),u||(u=new v,this._memoryConfigurationByResource.set(o.resource,u))):u=this._memoryConfiguration,n===void 0?u.removeValue(t):u.setValue(t,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,o){const u=this.getConsolidateConfigurationModel(n,o),h=this.getFolderConfigurationModelForResource(n.resource,o),f=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,E=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),A=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),_=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),U=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),H=o?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,Q=h?n.overrideIdentifier?h.freeze().override(n.overrideIdentifier).getValue(t):h.freeze().getValue(t):void 0,ne=n.overrideIdentifier?f.override(n.overrideIdentifier).getValue(t):f.getValue(t),ae=u.getValue(t),O=k.distinct(k.flatten(u.overrides.map($=>$.identifiers))).filter($=>u.getOverrideValue(t,$)!==void 0);return{defaultValue:E,userValue:A,userLocalValue:_,userRemoteValue:U,workspaceValue:H,workspaceFolderValue:Q,memoryValue:ne,value:ae,default:E!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:H!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:Q!==void 0?{value:h==null?void 0:h.freeze().getValue(t),override:n.overrideIdentifier?h==null?void 0:h.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:ne!==void 0?{value:f.getValue(t),override:n.overrideIdentifier?f.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:O.length?O:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const o=n.filter(u=>p.OVERRIDE_PROPERTY_PATTERN.test(u)).map(u=>{const h=(0,p.overrideIdentifierFromKey)(u),f=this._defaultConfiguration.getKeysForOverrideIdentifier(h),E=t.getKeysForOverrideIdentifier(h),A=[...E.filter(_=>f.indexOf(_)===-1),...f.filter(_=>E.indexOf(_)===-1),...f.filter(_=>!P.equals(this._defaultConfiguration.override(h).getValue(_),t.override(h).getValue(_)))];return[h,A]});return this.updateDefaultConfiguration(t),{keys:n,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:o,removed:u,overrides:h}=(0,i.compare)(this.localUserConfiguration,t),f=[...n,...o,...u];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:o,removed:u,overrides:h}=(0,i.compare)(this.remoteUserConfiguration,t);let f=[...n,...o,...u];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:o,removed:u,overrides:h}=(0,i.compare)(this.workspaceConfiguration,t);let f=[...n,...o,...u];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:h}}compareAndUpdateFolderConfiguration(t,n){const o=this.folderConfigurations.get(t),{added:u,updated:h,removed:f,overrides:E}=(0,i.compare)(o,n);let A=[...u,...h,...f];return(A.length||!o)&&this.updateFolderConfiguration(t,n),{keys:A,overrides:E}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:u,removed:h,overrides:f}=(0,i.compare)(n,void 0);return{keys:[...o,...u,...h],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let o=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const u=n.getFolder(t);u&&(o=this.getFolderConsolidatedConfiguration(u.uri)||o);const h=this._memoryConfigurationByResource.get(t);h&&(o=o.merge(h))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(t);u?(n=o.merge(u),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=o}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const o=n.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:o,overrides:u,keys:h}=this._folderConfigurations.get(n);return t.push([n,{contents:o,overrides:u,keys:h}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(u=>n.add(u))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),u=this.parseConfigurationModel(t.workspace),h=t.folders.reduce((f,E)=>(f.set(r.URI.revive(E[0]),this.parseConfigurationModel(E[1])),f),new L.ResourceMap);return new b(n,o,new v,u,h,new v,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new v(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function a(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,n=new Map;for(const u of s)u.keys.forEach(h=>t.add(h)),u.overrides.forEach(([h,f])=>{const E=(0,L.getOrSet)(n,h,new Set);f.forEach(A=>E.add(A))});const o=[];return n.forEach((u,h)=>o.push([h,[...u.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=a;class c{constructor(t,n,o,u){this.change=t,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=u,this._previousConfiguration=void 0;const h=new Set;t.keys.forEach(E=>h.add(E)),t.overrides.forEach(([,E])=>E.forEach(A=>h.add(A))),this.affectedKeys=[...h.values()];const f=new v;this.affectedKeys.forEach(E=>f.setValue(E,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var o;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const u=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(o=this.previous)===null||o===void 0?void 0:o.workspace):void 0,h=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!P.equals(u,h)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let o=(0,i.toValuesTree)({[n]:!0},()=>{}),u;for(;typeof o=="object"&&(u=Object.keys(o)[0]);){if(t=t[u],!t)return!1;o=o[u]}return!0}}e.ConfigurationChangeEvent=c;class l extends c{constructor(t,n,o,u){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=o,this.sourceConfig=u}}e.AllKeysConfigurationChangeEvent=l}),define(X[182],J([0,1,37,47,2,21,181,5,9,15]),function(q,e,m,L,k,y,P,r,p,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class D extends k.Disposable{constructor(S,v){super();this.settingsResource=S,this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,i.extUriBiasedIgnorePathCase,v)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(L.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const S=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,S)}getConfigurationData(){return this.configuration.toData()}getValue(S,v){const d=typeof S=="string"?S:void 0,w=(0,y.isConfigurationOverrides)(S)?S:(0,y.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(d,w,void 0)}updateValue(S,v,d,w){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const v=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(d,v,1)}onDidDefaultConfigurationChange(S){const v=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,S);this.trigger(d,v,6)}trigger(S,v,d){const w=new P.ConfigurationChangeEvent(S,{data:v},this.configuration);w.source=d,w.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(w)}getTargetConfiguration(S){switch(S){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=D}),define(X[183],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var L;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(P,r=L.Unknown,p){super(P);this._message=P,this._code=r,this._detail=p,this.isHandled=r===L.NotAvailable&&p===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(P){return P instanceof k&&P._code===L.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof k&&P._code===L.NoResolverFound}static isHandled(P){return P instanceof k&&P.isHandled}}e.RemoteAuthorityResolverError=k}),define(X[184],J([0,1,83,28,2,23,5,183,17,9,25]),function(q,e,m,L,k,y,P,r,p,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const g=30*1e3;var S;(function(M){M[M.Management=1]="Management",M[M.ExtensionHost=2]="ExtensionHost",M[M.Tunnel=3]="Tunnel"})(S=e.ConnectionType||(e.ConnectionType={}));function v(M){switch(M){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(M){const F=new D.CancellationTokenSource;return setTimeout(()=>F.cancel(),M),F.token}function w(M,F){if(M.isCancellationRequested||F.isCancellationRequested)return D.CancellationToken.Cancelled;const B=new D.CancellationTokenSource;return M.onCancellationRequested(()=>B.cancel()),F.onCancellationRequested(()=>B.cancel()),B.token}class I{constructor(F){this._state="pending",this._disposables=new k.DisposableStore,this.promise=new Promise((B,V)=>{this._resolvePromise=B,this._rejectPromise=V}),F.isCancellationRequested?this._timeout():this._disposables.add(F.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(F){this._state==="pending"?this._disposables.add(F):F.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const F=new Error("Time limit reached");return F.code="ETIMEDOUT",F.syscall="connect",F}resolve(F){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(F))}reject(F){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(F))}}function b(M,F){const B=new I(F);return B.registerDisposable(M.onControlMessage(V=>{const G=JSON.parse(V.toString()),Y=j(G);Y?B.reject(Y):B.resolve(G)})),B.promise}function a(M,F,B,V,G,Y){const Z=new I(Y);return F.connect(B,V,G,(re,se)=>{Z.didTimeout?(re&&M.error(re),se==null||se.dispose()):re||!se?Z.reject(re):Z.resolve(se)}),Z.promise}function c(M,F){const B=new I(F);return M.then(V=>{B.didTimeout||B.resolve(V)},V=>{B.didTimeout||B.reject(V)}),B.promise}async function l(M,F,B,V){const G=R(M,F);M.logService.trace(`${G} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await a(M.logService,M.socketFactory,M.host,M.port,`reconnectionToken=${M.reconnectionToken}&reconnection=${M.reconnectionProtocol?"true":"false"}`,V)}catch(x){throw M.logService.error(`${G} socketFactory.connect() failed or timed out. Error:`),M.logService.error(x),x}M.logService.trace(`${G} 2/6. socketFactory.connect() was successful.`);let Z,re;M.reconnectionProtocol?(M.reconnectionProtocol.beginAcceptReconnection(Y,null),Z=M.reconnectionProtocol,re=!1):(Z=new m.PersistentProtocol(Y,null),re=!0),M.logService.trace(`${G} 3/6. sending AuthRequest control message.`);const se={type:"auth",auth:M.connectionToken||"00000000000000000000"};Z.sendControl(y.VSBuffer.fromString(JSON.stringify(se)));try{const x=await b(Z,w(V,d(1e4)));if(x.type!=="sign"||typeof x.data!="string"){const ye=new Error("Unexpected handshake message");throw ye.code="VSCODE_CONNECTION_ERROR",ye}M.logService.trace(`${G} 4/6. received SignRequest control message.`);const ie=await c(M.signService.sign(x.data),V),ue={type:"connectionType",commit:M.commit,signedData:ie,desiredConnectionType:F};return B&&(ue.args=B),M.logService.trace(`${G} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(y.VSBuffer.fromString(JSON.stringify(ue))),{protocol:Z,ownsProtocol:re}}catch(x){throw x&&x.code==="ETIMEDOUT"&&(M.logService.error(`${G} the handshake timed out. Error:`),M.logService.error(x)),x&&x.code==="VSCODE_CONNECTION_ERROR"&&(M.logService.error(`${G} received error control message when negotiating connection. Error:`),M.logService.error(x)),re&&C(Z),x}}async function s(M,F,B,V){const G=Date.now(),Y=R(M,F),{protocol:Z,ownsProtocol:re}=await l(M,F,B,V),se=new I(V);return se.registerDisposable(Z.onControlMessage(x=>{const ie=JSON.parse(x.toString()),ue=j(ie);ue?(M.logService.error(`${Y} received error control message when negotiating connection. Error:`),M.logService.error(ue),re&&C(Z),se.reject(ue)):(M.reconnectionProtocol&&M.reconnectionProtocol.endAcceptReconnection(),M.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${W(G)}!`),se.resolve({protocol:Z,firstMessage:ie}))})),se.promise}async function t(M,F){const{protocol:B}=await s(M,1,void 0,F);return{protocol:B}}async function n(M,F,B){const{protocol:V,firstMessage:G}=await s(M,2,F,B),Y=G&&G.debugPort;return{protocol:V,debugPort:Y}}async function o(M,F,B){const V=Date.now(),G=R(M,3),{protocol:Y}=await l(M,3,F,B);return M.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${W(V)}!`),Y}async function u(M,F,B){const{host:V,port:G,connectionToken:Y}=await M.addressProvider.getAddress();return{commit:M.commit,host:V,port:G,connectionToken:Y,reconnectionToken:F,reconnectionProtocol:B,socketFactory:M.socketFactory,signService:M.signService,logService:M.logService}}async function h(M,F,B){try{const V=(0,L.generateUuid)(),G=await u(M,V,null),{protocol:Y}=await t(G,D.CancellationToken.None);return new $(M,F,B,V,Y)}catch(V){throw M.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),M.logService.error(V),O.triggerPermanentFailure(0,0,r.RemoteAuthorityResolverError.isHandled(V)),V}}e.connectRemoteAgentManagement=h;async function f(M,F){try{const B=(0,L.generateUuid)(),V=await u(M,B,null),{protocol:G,debugPort:Y}=await n(V,F,D.CancellationToken.None);return new z(M,F,B,G,Y)}catch(B){throw M.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),M.logService.error(B),O.triggerPermanentFailure(0,0,r.RemoteAuthorityResolverError.isHandled(B)),B}}e.connectRemoteAgentExtensionHost=f;async function E(M,F){const B=await u(M,(0,L.generateUuid)(),null);return await o(B,{port:F},D.CancellationToken.None)}e.connectRemoteAgentTunnel=E;function A(M){return(0,i.createCancelablePromise)(F=>new Promise((B,V)=>{const G=setTimeout(B,M*1e3);F.onCancellationRequested(()=>{clearTimeout(G),B()})}))}var _;(function(M){M[M.ConnectionLost=0]="ConnectionLost",M[M.ReconnectionWait=1]="ReconnectionWait",M[M.ReconnectionRunning=2]="ReconnectionRunning",M[M.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",M[M.ConnectionGain=4]="ConnectionGain"})(_=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(F,B){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.type=0}}e.ConnectionLostEvent=U;class H{constructor(F,B,V,G){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.durationSeconds=V,this.cancellableTimer=G,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=H;class Q{constructor(F,B,V){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.attempt=V,this.type=2}}e.ReconnectionRunningEvent=Q;class ne{constructor(F,B,V){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.attempt=V,this.type=4}}e.ConnectionGainEvent=ne;class ae{constructor(F,B,V,G){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.attempt=V,this.handled=G,this.type=3}}e.ReconnectionPermanentFailureEvent=ae;class O extends k.Disposable{constructor(F,B,V,G){super();this._connectionType=F,this._onDidStateChange=this._register(new P.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=B,this.reconnectionToken=V,this.protocol=G,this._isReconnecting=!1,this._onDidStateChange.fire(new ne(this.reconnectionToken,0,0)),this._register(G.onSocketClose(()=>this._beginReconnecting())),this._register(G.onSocketTimeout(()=>this._beginReconnecting())),O._instances.push(this),O._permanentFailure&&this._gotoPermanentFailure(O._permanentFailureMillisSinceLastIncomingData,O._permanentFailureAttempt,O._permanentFailureHandled)}static triggerPermanentFailure(F,B,V){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=F,this._permanentFailureAttempt=B,this._permanentFailureHandled=V,this._instances.forEach(G=>G._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(!O._permanentFailure){const F=T(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${F} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const B=[0,5,5,10,10,10,10,10,30],V=Date.now();let G=-1;do{G++;const Y=G<B.length?B[G]:B[B.length-1];try{if(Y>0){const re=A(Y);this._onDidStateChange.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,re)),this._options.logService.info(`${F} waiting for ${Y} seconds before reconnecting...`);try{await re}catch(se){}}if(O._permanentFailure){this._options.logService.error(`${F} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this._options.logService.info(`${F} resolving connection...`);const Z=await u(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${F} connecting to ${Z.host}:${Z.port}...`),await this._reconnect(Z,d(g)),this._options.logService.info(`${F} reconnected!`),this._onDidStateChange.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${F} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(Z),O.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(Date.now()-V>108e5){this._options.logService.error(`${F} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(Z),O.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(r.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Z)){this._options.logService.info(`${F} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this._options.logService.info(`${F} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if((0,p.isPromiseCanceledError)(Z)){this._options.logService.info(`${F} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if(Z instanceof r.RemoteAuthorityResolverError){this._options.logService.error(`${F} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(Z),O.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,r.RemoteAuthorityResolverError.isHandled(Z));break}this._options.logService.error(`${F} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(Z),O.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!O._permanentFailure)}}_gotoPermanentFailure(F,B,V){this._onDidStateChange.fire(new ae(this.reconnectionToken,F,B,V)),C(this.protocol)}}O._permanentFailure=!1,O._permanentFailureMillisSinceLastIncomingData=0,O._permanentFailureAttempt=0,O._permanentFailureHandled=!1,O._instances=[];class $ extends O{constructor(F,B,V,G,Y){super(1,F,G,Y);this.client=this._register(new m.Client(Y,{remoteAuthority:B,clientId:V},F.ipcLogger))}async _reconnect(F,B){await t(F,B)}}e.ManagementPersistentConnection=$;class z extends O{constructor(F,B,V,G,Y){super(2,F,V,G);this._startArguments=B,this.debugPort=Y}async _reconnect(F,B){await n(F,this._startArguments,B)}}e.ExtensionHostPersistentConnection=z;function C(M){try{M.acceptDisconnect();const F=M.getSocket();M.dispose(),F.dispose()}catch(F){(0,p.onUnexpectedError)(F)}}function j(M){if(M&&M.type==="error"){const F=new Error(`Connection error: ${M.reason}`);return F.code="VSCODE_CONNECTION_ERROR",F}return null}function N(M,F){for(;M.length<F;)M+=" ";return M}function T(M,F,B){return`[remote-connection][${N(v(M),13)}][${F.substr(0,5)}\u2026][${B?"reconnect":"initial"}]`}function R(M,F){return`${T(F,M.reconnectionToken,!!M.reconnectionProtocol)}[${M.host}:${M.port}]`}function W(M){return`${Date.now()-M} ms`}}),define(X[72],J([0,1,10]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function L(p){return p.scheme===m.Schemas.vscodeRemote?p.authority:void 0}e.getRemoteAuthority=L;function k(p){if(!!p){const i=p.indexOf("+");return i<0?p:p.substr(0,i)}}e.getRemoteName=k;function y(p){return p.scheme!==m.Schemas.file&&p.scheme!==m.Schemas.vscodeRemote}function P(p){const i=p.configuration;if(i&&y(i))return i;if(p.folders.length){const D=p.folders[0].uri;if(y(D))return D}}e.getVirtualWorkspaceLocation=P;function r(p){var i;return(i=P(p))===null||i===void 0?void 0:i.scheme}e.getVirtualWorkspaceScheme=r}),define(X[73],J([0,1,5,3,4,6]),function(q,e,m,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService");var P;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore"})(P=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function r(S){if(!(S.scheme!=="http"&&S.scheme!=="https")){const v=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(!!v)return{address:v[1],port:+v[2]}}}e.extractLocalHostUriMetaDataForPortMapping=r,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function p(S){return e.LOCALHOST_ADDRESSES.indexOf(S)>=0}e.isLocalhost=p,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function i(S){return e.ALL_INTERFACES_ADDRESSES.indexOf(S)>=0}e.isAllInterfaces=i;function D(S,v){return v?v!==1&&S<1024:!L.isWindows&&S<1024}e.isPortPrivileged=D;let g=class{constructor(v){this.logService=v,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}setTunnelProvider(v,d){return this._tunnelProvider=v,v?(this._canElevate=d.elevation,this._canMakePublic=d.public,{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async v=>{const d=[],w=Array.from(this._tunnels.values());for(let I of w){const b=Array.from(I.values());for(let a of b){const c=await a.value;c&&d.push(c)}}v(d)})}async dispose(){for(const v of this._tunnels.values()){for(const{value:d}of v.values())await d.then(w=>w==null?void 0:w.dispose());v.clear()}this._tunnels.clear()}openTunnel(v,d,w,I,b=!1,a=!1){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${w} on local port ${I}.`),!!v){d||(d="localhost");const c=this.retainOrCreateTunnel(v,d,w,I,b,a);return c?c.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,w);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(l);return(l.tunnelRemoteHost!==d||l.tunnelRemotePort!==w)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}}makeTunnel(v){return{tunnelRemotePort:v.tunnelRemotePort,tunnelRemoteHost:v.tunnelRemoteHost,tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress,public:v.public,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${v.tunnelRemotePort} `);const d=this._tunnels.get(v.tunnelRemoteHost);if(d){const w=d.get(v.tunnelRemotePort);w&&(w.refcount--,await this.tryDisposeTunnel(v.tunnelRemoteHost,v.tunnelRemotePort,w))}}}}async tryDisposeTunnel(v,d,w){if(w.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${v}:${d}.`);const I=w.value.then(async b=>{b&&(await b.dispose(!0),this._onTunnelClosed.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this._tunnels.has(v)&&this._tunnels.get(v).delete(d),I}}async closeTunnel(v,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d} `);const w=this._tunnels.get(v);if(w&&w.has(d)){const I=w.get(d);I.refcount=0,await this.tryDisposeTunnel(v,d,I)}}addTunnelToMap(v,d,w){this._tunnels.has(v)||this._tunnels.set(v,new Map),this._tunnels.get(v).set(d,{refcount:1,value:w})}async removeEmptyTunnelFromMap(v,d){const w=this._tunnels.get(v);w&&(await w.get(d)||w.delete(d),w.size===0&&this._tunnels.delete(v))}getTunnelFromMap(v,d){let w=[v];p(v)?(w.push(...e.LOCALHOST_ADDRESSES),w.push(...e.ALL_INTERFACES_ADDRESSES)):i(v)&&w.push(...e.ALL_INTERFACES_ADDRESSES);const I=w.map(b=>this._tunnels.get(b));for(const b of I){const a=b==null?void 0:b.get(d);if(a)return a}}canTunnel(v){return!!r(v)}createWithProvider(v,d,w,I,b,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${w} on local port ${I}.`);const l={elevationRequired:b?D(I===void 0?w:I):!1},s={remoteAddress:{host:d,port:w},localAddressPort:I,public:a},t=v.forwardPort(s,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(d,w,t),t}};g=ce([ee(0,y.ILogService)],g),e.AbstractTunnelService=g}),define(X[48],J([0,1,142,4,47,37,23]),function(q,e,m,L,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function r(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=r;function p(d){return d.res.statusCode===204}async function i(d){if(!r(d))throw new Error("Server returned "+d.res.statusCode);return p(d)?null:(await(0,P.streamToBuffer)(d.stream)).toString()}e.asText=i;async function D(d){if(!r(d))throw new Error("Server returned "+d.res.statusCode);if(p(d))return null;const I=(await(0,P.streamToBuffer)(d.stream)).toString();try{return JSON.parse(I)}catch(b){throw b.message+=`:
`+I,b}}e.asJson=D;function g(d){v(d)}e.updateProxyConfigurationsScope=g;let S;function v(d){const w=y.Registry.as(k.Extensions.Configuration);S&&w.deregisterConfigurations([S]),S={id:"http",order:15,title:(0,m.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,m.localize)(1,null),requireTrust:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,m.localize)(2,null),requireTrust:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,m.localize)(3,null),requireTrust:!0},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[(0,m.localize)(4,null),(0,m.localize)(5,null),(0,m.localize)(6,null)],default:"override",description:(0,m.localize)(7,null),requireTrust:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,m.localize)(8,null),requireTrust:!0}}},w.registerConfiguration(S)}v(2)}),define(X[185],J([0,1,186,12]),function(q,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(P,r){return P.protocol==="http:"?r.HTTP_PROXY||r.http_proxy||null:P.protocol==="https:"&&(r.HTTPS_PROXY||r.https_proxy||r.HTTP_PROXY||r.http_proxy)||null}async function y(P,r,p={}){const i=(0,m.parse)(P),D=p.proxyUrl||k(i,r);if(!D)return null;const g=(0,m.parse)(D);if(!/^https?:$/.test(g.protocol||""))return null;const S={host:g.hostname||"",port:g.port||(g.protocol==="https"?"443":"80"),auth:g.auth,rejectUnauthorized:(0,L.isBoolean)(p.strictSSL)?p.strictSSL:!0};return i.protocol==="http:"?new(await new Promise((v,d)=>{q(["http-proxy-agent"],v,d)}))(S):new(await new Promise((v,d)=>{q(["https-proxy-agent"],v,d)}))(S)}e.getProxyAgent=y}),define(X[187],J([0,1,28,23]),function(q,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(y,P,r){let p=r&&r.get("storage.serviceMachineId",0)||null;if(p)return p;try{const D=(await P.readFile(y.serviceMachineIdResource)).value.toString();p=(0,m.isUUID)(D)?D:null}catch(i){p=null}if(!p){p=(0,m.generateUuid)();try{await P.writeFile(y.serviceMachineIdResource,L.VSBuffer.fromString(p))}catch(i){}}return r&&r.store("storage.serviceMachineId",p,0,1),p}e.getServiceMachineId=k}),define(X[74],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,m.createDecorator)(e.SIGN_SERVICE_ID)}),define(X[188],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{vsda(){return new Promise((k,y)=>q(["vsda"],k,y))}async sign(k){try{const y=await this.vsda(),P=new y.signer;if(P)return P.sign(k)}catch(y){}return k}}e.SignService=m}),define(X[38],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,m.createDecorator)("stateService")}),define(X[16],J([0,1,13,6,38,5,4,171,3,2,9,12,32]),function(q,e,m,L,k,y,P,r,p,i,D,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.UnloadReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,P.createDecorator)("lifecycleMainService");var v;(function(I){I[I.CLOSE=1]="CLOSE",I[I.QUIT=2]="QUIT",I[I.RELOAD=3]="RELOAD",I[I.LOAD=4]="LOAD"})(v=e.UnloadReason||(e.UnloadReason={}));var d;(function(I){I[I.Starting=1]="Starting",I[I.Ready=2]="Ready",I[I.AfterWindowOpen=3]="AfterWindowOpen"})(d=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let w=class tt extends i.Disposable{constructor(b,a){super();this.logService=b,this.stateService=a,this._onBeforeShutdown=this._register(new y.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new y.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new y.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new y.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new y.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=null,this.pendingQuitPromiseResolve=null,this.pendingWillShutdownPromise=null,this.phaseWhen=new Map,this.handleRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}handleRestarted(){this._wasRestarted=!!this.stateService.getItem(tt.QUIT_FROM_RESTART_MARKER),this._wasRestarted&&this.stateService.removeItem(tt.QUIT_FROM_RESTART_MARKER)}registerListeners(){const b=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),p.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};m.app.addListener("before-quit",b);const a=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!p.isMacintosh)&&m.app.quit()};m.app.addListener("window-all-closed",a),m.app.once("will-quit",c=>{this.logService.trace("Lifecycle#app.on(will-quit)"),c.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),m.app.removeListener("before-quit",b),m.app.removeListener("window-all-closed",a),m.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const b=[];return this._onWillShutdown.fire({join(a){b.push(a)}}),this.pendingWillShutdownPromise=D.Promises.settled(b).then(()=>{},a=>this.logService.error(a)),this.pendingWillShutdownPromise}set phase(b){if(b<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase!==b){this.logService.trace(`lifecycle (main): phase changed (value: ${b})`),this._phase=b;const a=this.phaseWhen.get(this._phase);a&&(a.open(),this.phaseWhen.delete(this._phase))}}async when(b){if(!(b<=this._phase)){let a=this.phaseWhen.get(b);a||(a=new D.Barrier,this.phaseWhen.set(b,a)),await a.wait()}}registerWindow(b){const a=new i.DisposableStore;this.windowCounter++,a.add(b.onWillLoad(l=>this._onWillLoadWindow.fire({window:b,workspace:l.workspace})));const c=(0,g.assertIsDefined)(b.win);c.on("close",l=>{const s=b.id;if(this.windowToCloseRequest.has(s)){this.windowToCloseRequest.delete(s);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${b.id}`),l.preventDefault(),this.unload(b,1).then(t=>{if(t){this.windowToCloseRequest.delete(s);return}this.windowToCloseRequest.add(s),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${s}`),this._onBeforeCloseWindow.fire(b),b.close()})}),c.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${b.id}`),this.windowCounter--,a.dispose(),this.windowCounter===0&&(!p.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(b,a){await this.unload(b,3)||b.reload(a)}async unload(b,a){if(!b.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${b.id}`);const c=this._quitRequested?2:a;let l=await this.onBeforeUnloadWindowInRenderer(b,c);return l?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${b.id})`),this.handleWindowUnloadVeto(l)):(l=await this.onBeforeUnloadWindowInMain(b,c),l?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${b.id})`),this.handleWindowUnloadVeto(l)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${b.id})`),await this.onWillUnloadWindowInRenderer(b,c),!1))}handleWindowUnloadVeto(b){return b?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(b){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(b),this.pendingQuitPromiseResolve=null,this.pendingQuitPromise=null)}onBeforeUnloadWindowInRenderer(b,a){return new Promise(c=>{const l=this.oneTimeListenerTokenGenerator++,s=`vscode:ok${l}`,t=`vscode:cancel${l}`;m.ipcMain.once(s,()=>{c(!1)}),m.ipcMain.once(t,()=>{c(!0)}),b.send("vscode:onBeforeUnload",{okChannel:s,cancelChannel:t,reason:a})})}onBeforeUnloadWindowInMain(b,a){const c=[];return this._onBeforeUnloadWindow.fire({reason:a,window:b,veto(l){c.push(l)}}),(0,r.handleVetos)(c,l=>this.logService.error(l))}onWillUnloadWindowInRenderer(b,a){return new Promise(c=>{const s=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;m.ipcMain.once(s,()=>c()),b.send("vscode:onWillUnload",{replyChannel:s,reason:a})})}quit(b){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - from update: ${b}`),b&&this.stateService.setItem(tt.QUIT_FROM_RESTART_MARKER,!0),this.pendingQuitPromise=new Promise(a=>{this.pendingQuitPromiseResolve=a,this.logService.trace("Lifecycle#quit() - calling app.quit()"),m.app.quit()}),this.pendingQuitPromise)}relaunch(b){this.logService.trace("Lifecycle#relaunch()");const a=process.argv.slice(1);if((b==null?void 0:b.addArgs)&&a.push(...b.addArgs),b==null?void 0:b.removeArgs)for(const l of b.removeArgs){const s=a.indexOf(l);s>=0&&a.splice(s,1)}let c=!1;m.app.once("quit",()=>{if(!c){this.stateService.setItem(tt.QUIT_FROM_RESTART_MARKER,!0);try{if(p.isWindows){const l=(0,S.cwd)();l!==process.cwd()&&process.chdir(l)}}catch(l){this.logService.error(l)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),m.app.relaunch({args:a})}}),this.quit().then(l=>c=l)}async kill(b){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,D.timeout)(1e3),(async()=>{for(const a of m.BrowserWindow.getAllWindows())if(a&&!a.isDestroyed()){let c;a.webContents&&!a.webContents.isDestroyed()?c=new Promise(l=>a.once("closed",l)):c=Promise.resolve(),a.destroy(),await c}})()]),m.app.exit(b)}};w.QUIT_FROM_RESTART_MARKER="quit.from.restart",w=ce([ee(0,L.ILogService),ee(1,k.IStateService)],w),e.LifecycleMainService=w}),define(X[189],J([0,1,4,5,2,16]),function(q,e,m,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,m.createDecorator)("keyboardLayoutMainService");let P=class extends k.Disposable{constructor(i){super();this._onDidChangeKeyboardLayout=this._register(new L.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,i.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const i=await new Promise((D,g)=>{q(["native-keymap"],D,g)});this._keyboardLayoutData=r(i),i.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=r(i),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};P=ce([ee(0,y.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function r(p){const i=p.getKeyMap(),D=p.getCurrentKeyboardLayout();return{keyboardMapping:i,keyboardLayoutInfo:D}}}),define(X[190],J([0,1,8,18,46,19,12,6]),function(q,e,m,L,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class p{constructor(g,S){this.dbPath=g,this.onError=S,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(!this._database){const g=await this.loadAsync();this._database||(this._database=g)}}loadSync(){try{return this.lastFlushedSerializedDatabase=L.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(g){return g.code!=="ENOENT"&&this.onError(g),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await L.promises.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(g){return g.code!=="ENOENT"&&this.onError(g),{}}}getItem(g,S){const v=this.database[g];return(0,P.isUndefinedOrNull)(v)?S:v}setItem(g,S){if((0,P.isUndefinedOrNull)(S))return this.removeItem(g);(typeof S=="string"||typeof S=="number"||typeof S=="boolean")&&this.database[g]===S||(this.database[g]=S,this.saveSync())}removeItem(g){(0,P.isUndefined)(this.database[g])||(this.database[g]=void 0,this.saveSync())}saveSync(){const g=JSON.stringify(this.database,null,4);if(g!==this.lastFlushedSerializedDatabase)try{(0,y.writeFileSync)(this.dbPath,g),this.lastFlushedSerializedDatabase=g}catch(S){this.onError(S)}}}e.FileStorage=p;let i=class vt{constructor(g,S){this.fileStorage=new p(m.join(g.userDataPath,vt.STATE_FILE),v=>S.error(v))}init(){return this.fileStorage.init()}getItem(g,S){return this.fileStorage.getItem(g,S)}setItem(g,S){this.fileStorage.setItem(g,S)}removeItem(g){this.fileStorage.removeItem(g)}};i.STATE_FILE="storage.json",i=ce([ee(0,k.INativeEnvironmentService),ee(1,r.ILogService)],i),e.StateService=i}),define(X[94],J([0,1,4,5,2,12,85,9]),function(q,e,m,L,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const p="__$__targetStorageMarker";e.IStorageService=(0,m.createDecorator)("storageService");var i;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(i=e.WillSaveStateReason||(e.WillSaveStateReason={}));var D;(function(w){w[w.GLOBAL=0]="GLOBAL",w[w.WORKSPACE=1]="WORKSPACE"})(D=e.StorageScope||(e.StorageScope={}));var g;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));class S extends k.Disposable{constructor(I={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super();this.options=I,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new r.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,r.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(I,b){b===p?(I===0?this._globalKeyTargets=void 0:I===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:I})):this._onDidChangeValue.fire({scope:I,key:b,target:this.getKeyTargets(I)[b]})}emitWillSaveState(I){this._onWillSaveState.fire({reason:I})}get(I,b,a){var c;return(c=this.getStorage(b))===null||c===void 0?void 0:c.get(I,a)}getBoolean(I,b,a){var c;return(c=this.getStorage(b))===null||c===void 0?void 0:c.getBoolean(I,a)}getNumber(I,b,a){var c;return(c=this.getStorage(b))===null||c===void 0?void 0:c.getNumber(I,a)}store(I,b,a,c){if((0,y.isUndefinedOrNull)(b)){this.remove(I,a);return}this.withPausedEmitters(()=>{var l;this.updateKeyTarget(I,a,c),(l=this.getStorage(a))===null||l===void 0||l.set(I,b)})}remove(I,b){this.withPausedEmitters(()=>{var a;this.updateKeyTarget(I,b,void 0),(a=this.getStorage(b))===null||a===void 0||a.delete(I)})}withPausedEmitters(I){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{I()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(I,b){const a=[],c=this.getKeyTargets(I);for(const l of Object.keys(c))c[l]===b&&a.push(l);return a}updateKeyTarget(I,b,a){var c,l;const s=this.getKeyTargets(b);typeof a=="number"?s[I]!==a&&(s[I]=a,(c=this.getStorage(b))===null||c===void 0||c.set(p,JSON.stringify(s))):typeof s[I]=="number"&&(delete s[I],(l=this.getStorage(b))===null||l===void 0||l.set(p,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(I){return I===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(I){const b=this.get(p,I);if(b)try{return JSON.parse(b)}catch(a){}return Object.create(null)}isNew(I){return this.getBoolean(e.IS_NEW_KEY,I)===!0}async flush(){var I,b,a,c;this._onWillSaveState.fire({reason:i.NONE}),await r.Promises.settled([(b=(I=this.getStorage(0))===null||I===void 0?void 0:I.whenFlushed())!==null&&b!==void 0?b:Promise.resolve(),(c=(a=this.getStorage(1))===null||a===void 0?void 0:a.whenFlushed())!==null&&c!==void 0?c:Promise.resolve()])}async logStorage(){var I,b,a,c,l,s;const t=(b=(I=this.getStorage(0))===null||I===void 0?void 0:I.items)!==null&&b!==void 0?b:new Map,n=(c=(a=this.getStorage(1))===null||a===void 0?void 0:a.items)!==null&&c!==void 0?c:new Map;return d(t,n,(l=this.getLogDetails(0))!==null&&l!==void 0?l:"",(s=this.getLogDetails(1))!==null&&s!==void 0?s:"")}}e.AbstractStorageService=S,S.DEFAULT_FLUSH_INTERVAL=60*1e3;class v extends S{constructor(){super();this.globalStorage=new P.Storage(new P.InMemoryStorageDatabase),this.workspaceStorage=new P.Storage(new P.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(I=>this.emitDidChangeValue(1,I))),this._register(this.globalStorage.onDidChangeStorage(I=>this.emitDidChangeValue(0,I)))}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(I){}}e.InMemoryStorageService=v;async function d(w,I,b,a){const c=h=>{try{return JSON.parse(h)}catch(f){return h}},l=new Map,s=new Map;w.forEach((h,f)=>{l.set(f,h),s.set(f,c(h))});const t=new Map,n=new Map;I.forEach((h,f)=>{t.set(f,h),n.set(f,c(h))}),console.group(`Storage: Global (path: ${b})`);let o=[];l.forEach((h,f)=>{o.push({key:f,value:h})}),console.table(o),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${a})`);let u=[];t.forEach((h,f)=>{u.push({key:f,value:h})}),console.table(u),console.groupEnd(),console.log(n)}e.logStorage=d}),define(X[191],J([0,1,3,32,28,7]),function(q,e,m,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;async function P(p,i,D,g,S,v,d,w,I){const b=Object.create(null);b["common.machineId"]=v,b.sessionID=(0,k.generateUuid)()+Date.now(),b.commitHash=g,b.version=S,b["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,m.PlatformToString)(m.platform),b["common.nodePlatform"]=L.platform,b["common.nodeArch"]=D,b["common.product"]=I||"desktop";const a=r(d||[]);a&&(b["common.msftInternal"]=a);let c=0;const l=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),m.isLinuxSnap&&(b["common.snap"]="true");try{const s=await p.readFile(y.URI.file(w));b["common.source"]=s.value.toString().slice(0,30)}catch(s){}return b}e.resolveCommonProperties=P;function r(p){const i=L.env.USERDNSDOMAIN;if(!i)return!1;const D=i.toLowerCase();return p.some(g=>D===g)}}),define(X[31],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,m.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,m.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(X[192],J([0,1,27,65,68,18,8,43,82,20,3,7,31,62,10,24,19]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v,d,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function b(t,n){const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],u=new Map,h=new Map,f=2e4;function E(U,H,Q,ne){const ae=H.substring(U.length+1);return new Promise(async O=>{var $,z,C;let j;try{j=await(0,I.readdir)(H,{withFileTypes:!0})}catch(R){O();return}if(ne.count>=f){ne.count+=j.length,ne.maxReached=!0,O();return}let N=j.length;if(N===0){O();return}let T=j;ne.count+j.length>f&&(ne.maxReached=!0,N=f-ne.count,T=j.slice(0,N)),ne.count+=j.length;for(const R of T)if(R.isDirectory()){if(Q.includes(R.name)||await E(U,(0,P.join)(H,R.name),Q,ne),--N==0){O();return}}else{const W=R.name.lastIndexOf(".");if(W>=0){const M=R.name.substring(W+1);M&&u.set(M,(($=u.get(M))!==null&&$!==void 0?$:0)+1)}for(const M of o)((z=M.relativePathPattern)===null||z===void 0?void 0:z.test(ae))!==!1&&M.filePattern.test(R.name)&&h.set(M.tag,((C=h.get(M.tag))!==null&&C!==void 0?C:0)+1);if(--N==0){O();return}}})}const A={count:0,maxReached:!1};await E(t,t,n,A);const _=await l(t);return{configFiles:a(h),fileTypes:a(u),fileCount:A.count,maxFilesReached:A.maxReached,launchConfigFiles:_}}e.collectWorkspaceStats=b;function a(t){return[...v.Iterable.map(t.entries(),([n,o])=>({name:n,count:o}))].sort((n,o)=>o.count-n.count)}function c(){const t={os:`${m.type()} ${m.arch()} ${m.release()}`,memory:`${(m.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(L.virtualMachineHint.value()*100)}%`},n=m.cpus();return n&&n.length>0&&(t.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),t}e.getMachineInfo=c;function l(t){let n=new Map,o=(0,P.join)(t,".vscode","launch.json");return new Promise((u,h)=>{(0,y.exists)(o,f=>{if(f)(0,y.readFile)(o,(E,A)=>{if(E)return u([]);const _=[],U=(0,r.parse)(A.toString(),_);if(_.length)return console.log(`Unable to parse ${o}`),u([]);if((0,r.getNodeType)(U)==="object"&&U.configurations)for(const H of U.configurations){const Q=H.type;Q&&(n.has(Q)?n.set(Q,n.get(Q)+1):n.set(Q,1))}return u(a(n))});else return u([])})})}e.collectLaunchConfigs=l;let s=class{constructor(n,o){this.telemetryService=n,this.productService=o}formatMachineInfo(n){const o=[];return o.push(`OS Version:       ${n.os}`),o.push(`CPUs:             ${n.cpus}`),o.push(`Memory (System):  ${n.memory}`),o.push(`VM:               ${n.vmHint}`),o.join(`
`)}formatEnvironment(n){const o=[];o.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),o.push(`OS Version:       ${m.type()} ${m.arch()} ${m.release()}`);const u=m.cpus();return u&&u.length>0&&o.push(`CPUs:             ${u[0].model} (${u.length} x ${u[0].speed})`),o.push(`Memory (System):  ${(m.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`),D.isWindows||o.push(`Load (avg):       ${m.loadavg().map(h=>Math.round(h)).join(", ")}`),o.push(`VM:               ${Math.round(L.virtualMachineHint.value()*100)}%`),o.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${n.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.expandGPUFeatures(n.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(n,o){return Promise.all([(0,p.listProcesses)(n.mainPID),this.formatWorkspaceMetadata(n)]).then(async u=>{let[h,f]=u,E=this.formatProcessList(n,h);return o.forEach(A=>{if((0,k.isRemoteDiagnosticError)(A))E+=`
${A.errorMessage}`,f+=`
${A.errorMessage}`;else if(E+=`

Remote: ${A.hostName}`,A.processes&&(E+=`
${this.formatProcessList(n,A.processes)}`),A.workspaceMetadata){f+=`
|  Remote: ${A.hostName}`;for(const _ of Object.keys(A.workspaceMetadata)){const U=A.workspaceMetadata[_];let H=`${U.fileCount} files`;U.maxFilesReached&&(H=`more than ${H}`),f+=`|    Folder (${_}): ${H}`,f+=this.formatWorkspaceStats(U)}}}),{processInfo:E,workspaceInfo:f}})}async getSystemInfo(n,o){const{memory:u,vmHint:h,os:f,cpus:E}=c(),A={os:f,memory:u,cpus:E,vmHint:h,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:o};return D.isWindows||(A.load=`${m.loadavg().map(_=>Math.round(_)).join(", ")}`),D.isLinux&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(n,o){const u=[];return(0,p.listProcesses)(n.mainPID).then(async h=>(u.push(""),u.push(this.formatEnvironment(n)),u.push(""),u.push(this.formatProcessList(n,h)),n.windows.some(f=>f.folderURIs&&f.folderURIs.length>0&&!f.remoteAuthority)&&(u.push(""),u.push("Workspace Stats: "),u.push(await this.formatWorkspaceMetadata(n))),o.forEach(f=>{if((0,k.isRemoteDiagnosticError)(f))u.push(`
${f.errorMessage}`);else if(u.push(`

`),u.push(`Remote:           ${f.hostName}`),u.push(this.formatMachineInfo(f.machineInfo)),f.processes&&u.push(this.formatProcessList(n,f.processes)),f.workspaceMetadata)for(const E of Object.keys(f.workspaceMetadata)){const A=f.workspaceMetadata[E];let _=`${A.fileCount} files`;A.maxFilesReached&&(_=`more than ${_}`),u.push(`Folder (${E}): ${_}`),u.push(this.formatWorkspaceStats(A))}}),u.push(""),u.push(""),u.join(`
`)))}formatWorkspaceStats(n){const o=[],u=60;let h=0;const f=(U,H)=>{const Q=` ${U}(${H})`;h+Q.length>u?(o.push(E),E="|                 ",h=E.length):h+=Q.length,E+=Q};let E="|      File types:";const A=10;let _=n.fileTypes.length>A?A:n.fileTypes.length;for(let U=0;U<_;U++){const H=n.fileTypes[U];f(H.name,H.count)}if(o.push(E),n.configFiles.length>=0&&(E="|      Conf files:",h=0,n.configFiles.forEach(U=>{f(U.name,U.count)}),o.push(E)),n.launchConfigFiles.length>0){let U="|      Launch Configs:";n.launchConfigFiles.forEach(H=>{U+=H.count>1?` ${H.name}(${H.count})`:` ${H.name}`}),o.push(U)}return o.join(`
`)}expandGPUFeatures(n){const o=Math.max(...Object.keys(n).map(u=>u.length));return Object.keys(n).map(u=>`${u}:  ${" ".repeat(o-u.length)}  ${n[u]}`).join(`
                  `)}formatWorkspaceMetadata(n){const o=[],u=[];return n.windows.forEach(h=>{h.folderURIs.length===0||!!h.remoteAuthority||(o.push(`|  Window (${h.title})`),h.folderURIs.forEach(f=>{const E=g.URI.revive(f);if(E.scheme===d.Schemas.file){const A=E.fsPath;u.push(b(A,["node_modules",".git"]).then(_=>{let U=`${_.fileCount} files`;_.maxFilesReached&&(U=`more than ${U}`),o.push(`|    Folder (${(0,P.basename)(A)}): ${U}`),o.push(this.formatWorkspaceStats(_))}).catch(_=>{o.push(`|      Error: Unable to collect workspace stats for folder ${A} (${_.toString()})`)}))}else o.push(`|    Folder (${E.toString()}): Workspace stats not available.`)}))}),Promise.all(u).then(h=>o.join(`
`)).catch(h=>`Unable to collect workspace stats: ${h}`)}formatProcessList(n,o){const u=new Map;n.windows.forEach(f=>u.set(f.pid,f.title));const h=[];return h.push("CPU %	Mem MB	   PID	Process"),o&&this.formatProcessItem(n.mainPID,u,h,o,0),h.join(`
`)}formatProcessItem(n,o,u,h,f){const E=f===0;let A;E?A=h.pid===n?`${this.productService.applicationName} main`:"remote agent":(A=`${"  ".repeat(f)} ${h.name}`,h.name==="window"&&(A=`${A} (${o.get(h.pid)})`));const _=process.platform==="win32"?h.mem:m.totalmem()*(h.mem/100);u.push(`${h.load.toFixed(0).padStart(5," ")}	${(_/w.ByteSize.MB).toFixed(0).padStart(6," ")}	${h.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(h.children)&&h.children.forEach(U=>this.formatProcessItem(n,o,u,U,f+1))}async reportWorkspaceStats(n){for(const{uri:o}of n.folders){const u=g.URI.revive(o);if(u.scheme===d.Schemas.file){const h=u.fsPath;try{const f=await b(h,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),f.fileTypes.forEach(E=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:E.name,count:E.count})}),f.launchConfigFiles.forEach(E=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:E.name,count:E.count})}),f.configFiles.forEach(E=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:E.name,count:E.count})})}catch(f){}}}}};s=ce([ee(0,S.ITelemetryService),ee(1,i.IProductService)],s),e.DiagnosticsService=s}),define(X[193],J([0,1,17,163,166,44,31,48,157,46,25,6,24,7,20,94,187,4,15]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v,d,w,I,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var c;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished"})(c||(c={}));function l(...T){return String(T.reduce((R,W)=>R|W,0))}var s;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},n={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},u={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:c.None,criteria:[],assetTypes:[]};class h{constructor(R=u){this.state=R}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(R,W=this.state.pageSize){return new h(Object.assign(Object.assign({},this.state),{pageNumber:R,pageSize:W}))}withFilter(R,...W){const M=[...this.state.criteria,...W.length?W.map(F=>({filterType:R,value:F})):[{filterType:R}]];return new h(Object.assign(Object.assign({},this.state),{criteria:M}))}withSortBy(R){return new h(Object.assign(Object.assign({},this.state),{sortBy:R}))}withSortOrder(R){return new h(Object.assign(Object.assign({},this.state),{sortOrder:R}))}withFlags(...R){return new h(Object.assign(Object.assign({},this.state),{flags:R.reduce((W,M)=>W|M,0)}))}withAssetTypes(...R){return new h(Object.assign(Object.assign({},this.state),{assetTypes:R}))}get raw(){const{criteria:R,pageNumber:W,pageSize:M,sortBy:F,sortOrder:B,flags:V,assetTypes:G}=this.state;return{filters:[{criteria:R,pageNumber:W,pageSize:M,sortBy:F,sortOrder:B}],assetTypes:G,flags:V}}get searchText(){const R=this.state.criteria.filter(W=>W.filterType===s.SearchText)[0];return R&&R.value?R.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(R=>String(R.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function f(T,R){const W=(T||[]).filter(M=>M.statisticName===R)[0];return W?W.value:0}function E(T){const R="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(M=>M.assetType.indexOf(R)===0).reduce((M,F)=>{const B=H(T,F.assetType);return B&&M.push([F.assetType.substring(R.length),B]),M},[])}function A(T){if(T.properties){const R=T.properties.filter(F=>F.key===t.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),M=R.filter(F=>W.test(F.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return H(T,t.Repository)}function _(T){return{uri:`${T.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${T.fallbackAssetUri}/${t.VSIX}`}}function U(T){const R=H(T,t.Icon);if(R)return R;const W=L.DefaultIconPath;return{uri:W,fallbackUri:W}}function H(T,R){return T.files.filter(M=>M.assetType===R)[0]?{uri:`${T.assetUri}/${R}`,fallbackUri:`${T.fallbackAssetUri}/${R}`}:null}function Q(T,R){const W=T.properties?T.properties.filter(F=>F.key===R):[],M=W.length>0&&W[0].value;return M?M.split(",").map(F=>(0,k.adoptToGalleryExtensionId)(F)):[]}function ne(T){const R=T.properties?T.properties.filter(W=>W.key===n.Engine):[];return R.length>0&&R[0].value||""}function ae(T){const R=T.properties?T.properties.filter(M=>M.key===n.LocalizedLanguages):[],W=R.length>0&&R[0].value||"";return W?W.split(","):[]}function O(T){return T.indexOf("preview")!==-1}function $(T){const R=T.properties?T.properties.find(W=>W.key===n.WebExtension):void 0;return!!R&&R.value==="true"}function z(T){return T.files.some(R=>R.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,a.joinPath)(v.URI.parse(T.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function C(T,R,W,M,F){const B={manifest:H(R,t.Manifest),readme:H(R,t.Details),changelog:H(R,t.Changelog),license:H(R,t.License),repository:A(R),download:_(R),icon:U(R),coreTranslations:E(R)};return{identifier:{id:(0,k.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:R.version,date:R.lastUpdated,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,description:T.shortDescription||"",installCount:f(T.statistics,"install"),rating:f(T.statistics,"averagerating"),ratingCount:f(T.statistics,"ratingcount"),assetUri:v.URI.parse(R.assetUri),webResource:z(R),assetTypes:R.files.map(({assetType:V})=>V),assets:B,properties:{dependencies:Q(R,n.Dependency),extensionPack:Q(R,n.ExtensionPack),engine:ne(R),localizedLanguages:ae(R),webExtension:$(R)},telemetryData:{index:(M.pageNumber-1)*M.pageSize+W,searchText:M.searchText,querySource:F},preview:O(T.flags)}}let j=class{constructor(R,W,M,F,B,V,G){this.requestService=R,this.logService=W,this.environmentService=M,this.telemetryService=F,this.fileService=B,this.productService=V;const Y=V.extensionsGallery;this.extensionsGalleryUrl=Y&&Y.serviceUrl,this.extensionsControlUrl=Y&&Y.controlUrl,this.commonHeadersPromise=N(V.version,this.environmentService,this.fileService,G)}api(R=""){return`${this.extensionsGalleryUrl}${R}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(R,W){const M=[];let{total:F,firstPage:B,getPage:V}=await this.query({names:R,pageSize:R.length},W);M.push(...B);for(let G=1;M.length<F&&(B=await V(G,W),B.length);G++)M.push(...B);return M}async getCompatibleExtension(R,W){const M=await this.getCompatibleExtensionByEngine(R,W);return(M==null?void 0:M.properties.webExtension)?M.webResource?M:null:M}async getCompatibleExtensionByEngine(R,W){const M=(0,L.isIExtensionIdentifier)(R)?null:R;if(M&&M.properties.engine&&(0,p.isEngineValid)(M.properties.engine,this.productService.version))return M;const{id:F,uuid:B}=M?M.identifier:R;let V=new h().withFlags(c.IncludeAssetUri,c.IncludeStatistics,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");B?V=V.withFilter(s.ExtensionId,B):V=V.withFilter(s.ExtensionName,F);const{galleryExtensions:G}=await this.queryGallery(V,D.CancellationToken.None),[Y]=G;if(!Y||!Y.versions.length)return null;if(W){const re=Y.versions.filter(se=>se.version===W)[0];if(re){const se=C(Y,re,0,V);if(se.properties.engine&&(0,p.isEngineValid)(se.properties.engine,this.productService.version))return se}return null}const Z=await this.getLastValidExtensionVersion(Y,Y.versions);return Z?C(Y,Z,0,V):null}async query(R,W){const M=D.CancellationToken.isCancellationToken(R)?{}:R,F=D.CancellationToken.isCancellationToken(R)?R:W;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let B=M.text||"";const V=(0,y.getOrDefault)(M,x=>x.pageSize,50);let G=new h().withFlags(c.IncludeLatestVersionOnly,c.IncludeAssetUri,c.IncludeStatistics,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,V).withFilter(s.Target,"Microsoft.VisualStudio.Code");B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(x,ie,ue)=>(G=G.withFilter(s.Category,ue||ie),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(x,ie,ue)=>(G=G.withFilter(s.Tag,ue||ie),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(s.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),G=G.withFilter(s.SearchText,B)),G=G.withSortBy(0)):M.ids?G=G.withFilter(s.ExtensionId,...M.ids):M.names?G=G.withFilter(s.ExtensionName,...M.names):G=G.withSortBy(4),typeof M.sortBy=="number"&&(G=G.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(G=G.withSortOrder(M.sortOrder));const{galleryExtensions:Y,total:Z}=await this.queryGallery(G,F),re=Y.map((x,ie)=>C(x,x.versions[0],ie,G,M.source)),se=async(x,ie)=>{if(ie.isCancellationRequested)throw(0,m.canceled)();const ue=G.withPage(x+1),{galleryExtensions:ye}=await this.queryGallery(ue,ie);return ye.map((ge,Ee)=>C(ge,ge.versions[0],Ee,ue,M.source))};return{firstPage:re,total:Z,pageSize:G.pageSize,getPage:se}}async queryGallery(R,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");R=R.withFlags(R.flags,c.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,l(c.Unpublished));const M=await this.commonHeadersPromise,F=JSON.stringify(R.raw),B=Object.assign(Object.assign({},M),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(F.length)}),V=new Date().getTime();let G,Y,Z=0;try{if(G=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:F,headers:B},W),G.res.statusCode&&G.res.statusCode>=400&&G.res.statusCode<500)return{galleryExtensions:[],total:Z};const re=await(0,r.asJson)(G);if(re){const se=re.results[0],x=se.extensions,ie=se.resultMetadata&&se.resultMetadata.filter(ue=>ue.metadataType==="ResultCount")[0];return Z=ie&&ie.metadataItems.filter(ue=>ue.name==="TotalCount")[0].count||0,{galleryExtensions:x,total:Z}}return{galleryExtensions:[],total:Z}}catch(re){throw Y=re,re}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},R.telemetryData),{requestBodySize:String(F.length),duration:new Date().getTime()-V,success:!!G&&(0,r.isSuccess)(G),responseBodySize:G==null?void 0:G.res.headers["Content-Length"],statusCode:G?String(G.res.statusCode):void 0,errorCode:Y?(0,m.isPromiseCanceledError)(Y)?"canceled":(0,m.getErrorMessage)(Y).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Z)}))}}async reportStatistic(R,W,M,F){if(!!this.isEnabled()){const B=await this.commonHeadersPromise,V=Object.assign(Object.assign({},B),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${R}/extensions/${W}/${M}/stats?statType=${F}`),headers:V},D.CancellationToken.None)}catch(G){}}}async download(R,W,M){this.logService.trace("ExtensionGalleryService#download",R.identifier.id);const F=(0,k.getGalleryExtensionTelemetryData)(R),B=new Date().getTime(),V=re=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},F),{duration:re})),G=M===1?"install":M===2?"update":"",Y=G?{uri:`${R.assets.download.uri}&${G}=true`,fallbackUri:`${R.assets.download.fallbackUri}?${G}=true`}:R.assets.download,Z=await this.getAsset(Y);await this.fileService.writeFile(W,Z.stream),V(new Date().getTime()-B)}async getReadme(R,W){if(R.assets.readme){const M=await this.getAsset(R.assets.readme,{},W);return await(0,r.asText)(M)||""}return""}async getManifest(R,W){if(R.assets.manifest){const M=await this.getAsset(R.assets.manifest,{},W),F=await(0,r.asText)(M);return F?JSON.parse(F):null}return null}async getCoreTranslation(R,W){const M=R.assets.coreTranslations.filter(F=>F[0]===W.toUpperCase())[0];if(M){const F=await this.getAsset(M[1]),B=await(0,r.asText)(F);return B?JSON.parse(B):null}return null}async getChangelog(R,W){if(R.assets.changelog){const M=await this.getAsset(R.assets.changelog,{},W);return await(0,r.asText)(M)||""}return""}async getAllVersions(R,W){let M=new h().withFlags(c.IncludeVersions,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");R.identifier.uuid?M=M.withFilter(s.ExtensionId,R.identifier.uuid):M=M.withFilter(s.ExtensionName,R.identifier.id);const F=[],{galleryExtensions:B}=await this.queryGallery(M,D.CancellationToken.None);return B.length&&(W?await Promise.all(B[0].versions.map(async V=>{let G;try{G=await this.getEngine(V)}catch(Y){}G&&(0,p.isEngineValid)(G,this.productService.version)&&F.push({version:V.version,date:V.lastUpdated})})):F.push(...B[0].versions.map(V=>({version:V.version,date:V.lastUpdated})))),F}async getAsset(R,W={},M=D.CancellationToken.None){const F=await this.commonHeadersPromise,B={type:"GET"},V=Object.assign(Object.assign({},F),W.headers||{});W=Object.assign(Object.assign(Object.assign({},W),B),{headers:V});const G=R.uri,Y=R.fallbackUri,Z=Object.assign(Object.assign({},W),{url:G});try{const re=await this.requestService.request(Z,M);if(re.res.statusCode===200)return re;const se=await(0,r.asText)(re);throw new Error(`Expected 200, got back ${re.res.statusCode} instead.

${se}`)}catch(re){if((0,m.isPromiseCanceledError)(re))throw re;const se=(0,m.getErrorMessage)(re);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:G,message:se});const x=Object.assign(Object.assign({},W),{url:Y});return this.requestService.request(x,M)}}async getLastValidExtensionVersion(R,W){const M=this.getLastValidExtensionVersionFromProperties(R,W);return M||this.getLastValidExtensionVersionRecursively(R,W)}getLastValidExtensionVersionFromProperties(R,W){for(const M of W){const F=ne(M);if(!F)return null;if((0,p.isEngineValid)(F,this.productService.version))return M}return null}async getEngine(R){const W=ne(R);if(W)return W;const M=H(R,t.Manifest);if(!M)throw new Error("Manifest was not found");const F={"Accept-Encoding":"gzip"},B=await this.getAsset(M,{headers:F}),V=await(0,r.asJson)(B);if(V)return V.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(R,W){if(!W.length)return null;const M=W[0],F=await this.getEngine(M);return(0,p.isEngineValid)(F,this.productService.version)?(M.properties=M.properties||[],M.properties.push({key:n.Engine,value:F}),M):this.getLastValidExtensionVersionRecursively(R,W.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const R=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},D.CancellationToken.None);if(R.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,r.asJson)(R),M=new Map;if(W)for(const F of W.malicious){const B=M.get(F)||{id:{id:F},malicious:!0,slow:!1};B.malicious=!0,M.set(F,B)}return[...M.values()]}};j=ce([ee(0,r.IRequestService),ee(1,g.ILogService),ee(2,i.IEnvironmentService),ee(3,P.ITelemetryService),ee(4,S.IFileService),ee(5,d.IProductService),ee(6,(0,b.optional)(w.IStorageService))],j),e.ExtensionGalleryService=j;async function N(T,R,W,M){const F={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T}`},B=await(0,I.getServiceMachineId)(R,W,M);return F["X-Market-User-Id"]=B,F}e.resolveMarketplaceHeaders=N}),define(X[194],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class m{constructor(y){this.appender=y}listen(y,P){throw new Error(`Event not found: ${P}`)}call(y,P,{eventName:r,data:p}){return this.appender.log(r,p),Promise.resolve(null)}}e.TelemetryAppenderChannel=m;class L{constructor(y){this.channel=y}log(y,P){return this.channel.call("log",{eventName:y,data:P}).then(void 0,r=>`Failed to log telemetry: ${console.warn(r)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(X[195],J([0,1,54,143,22,4,21,47,2,44,37]),function(q,e,m,L,k,y,P,r,p,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=class{constructor(d,w){this._configurationService=w,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appender=d.appender,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let I of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(I),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(I=>{const b=/^[a-f0-9]+$/i.test(I["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!b})}))}setExperimentProperty(d,w){this._experimentProperties[d]=w}setEnabled(d){this._enabled=d}_updateUserOptIn(){var d;const w=(d=this._configurationService)===null||d===void 0?void 0:d.getValue(S);this._userOptIn=w?w.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const d=await this._commonProperties;let w=d.sessionID,I=d["common.instanceId"],b=d["common.machineId"],a=d["common.firstSessionDate"],c=d["common.msftInternal"];return{sessionId:w,instanceId:I,machineId:b,firstSessionDate:a,msftInternal:c}}dispose(){this._disposables.dispose()}publicLog(d,w,I){return this.isOptedIn?this._commonProperties.then(b=>{w=(0,i.mixin)(w,b),w=(0,i.mixin)(w,this._experimentProperties),w=(0,i.cloneAndChange)(w,a=>{if(typeof a=="string")return this._cleanupInfo(a,I)}),this._appender.log(d,w)},b=>{console.error(b)}):Promise.resolve(void 0)}publicLog2(d,w,I){return this.publicLog(d,w,I)}publicLogError(d,w){return this.sendErrorTelemetry?this.publicLog(d,w,!0):Promise.resolve(void 0)}publicLogError2(d,w){return this.publicLogError(d,w)}_cleanupInfo(d,w){let I=d;if(w){const b=[];for(let s of this._cleanupPatterns)for(;;){const t=s.exec(d);if(!t)break;b.push([t.index,s.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(I="";;){const s=c.exec(d);if(!s)break;!a.test(s[0])&&b.every(([t,n])=>s.index<t||s.index>=n)&&(I+=d.substring(l,s.index)+"<REDACTED: user-file-path>",l=c.lastIndex)}l<d.length&&(I+=d.substr(l))}for(let b of this._cleanupPatterns)I=I.replace(b,"");return I}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",g=ce([ee(1,(0,y.optional)(P.IConfigurationService))],g),e.TelemetryService=g;const S="telemetry";D.Registry.as(r.Extensions.Configuration).registerConfiguration({id:S,order:110,type:"object",title:(0,L.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,L.localize)(2,null,m.default.privacyStatementUrl):(0,L.localize)(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(X[95],J([0,1,21,44,12,9]),function(q,e,m,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(d,w){return Promise.resolve(void 0)}publicLog2(d,w){return this.publicLog(d,w)}publicLogError(d,w){return Promise.resolve(void 0)}publicLogError2(d,w){return this.publicLogError(d,w)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class P{async publicLog(w,I,b){}async publicLogError(w,I,b){}}e.NullEndpointTelemetryService=P;function r(...d){return{log:(w,I)=>d.forEach(b=>b.log(w,I)),flush:()=>y.Promises.settled(d.map(w=>w.flush()))}}e.combinedAppender=r,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function p(d,w){return w.onDidChangeConfiguration(I=>{I.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,m.ConfigurationTargetToString)(I.source),configurationKeys:S(I.sourceConfig)})})}e.configurationTelemetry=p;function i(d){const w=Object.create(null),I=Object.create(null),b=Object.create(null);g(d,b);for(let a in b){a=a.length>150?a.substr(a.length-149):a;const c=b[a];typeof c=="number"?I[a]=c:typeof c=="boolean"?I[a]=c?1:0:typeof c=="string"?w[a]=c.substring(0,1023):typeof c!="undefined"&&c!==null&&(w[a]=c)}return{properties:w,measurements:I}}e.validateTelemetryData=i;function D(d){if(!d)return"none";let w="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(b=>{d.indexOf(`${b}+`)===0&&(w=b)}),w}e.cleanRemoteAuthority=D;function g(d,w,I=0,b){if(!!d)for(let a of Object.getOwnPropertyNames(d)){const c=d[a],l=b?b+a:a;Array.isArray(c)?w[l]=(0,L.safeStringify)(c):c instanceof Date?w[l]=c.toISOString():(0,k.isObject)(c)?I<2?g(c,w,I+1,l+"."):w[l]=(0,L.safeStringify)(c):w[l]=c}}function S(d){if(!d)return[];const w=[];return v(w,"",d),w}function v(d,w,I){I&&typeof I=="object"&&!Array.isArray(I)?Object.keys(I).forEach(b=>v(d,w?`${w}.${b}`:b,I[b])):d.push(w)}}),define(X[196],J([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(X[197],J([0,1,4,2,37,5,196,105]),function(q,e,m,L,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,m.createDecorator)("themeService");var p;(function(I){function b(a){return a&&typeof a=="object"&&typeof a.id=="string"}I.isThemeColor=b})(p=e.ThemeColor||(e.ThemeColor={}));function i(I){return{id:I}}e.themeColorFromId=i;var D;(function(I){function b(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||p.isThemeColor(t.color))}I.isThemeIcon=b;const a=new RegExp(`^\\$\\((${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?)\\)$`);function c(t){const n=a.exec(t);if(!!n){let[,o]=n;return{id:o}}}I.fromString=c;function l(t,n){let o=t.id;const u=o.lastIndexOf("~");return u!==-1&&(o=o.substring(0,u)),n&&(o=`${o}~${n}`),{id:o}}I.modify=l;function s(t,n){var o,u;return t.id===n.id&&((o=t.color)===null||o===void 0?void 0:o.id)===((u=n.color)===null||u===void 0?void 0:u.id)}I.isEqual=s,I.asClassNameArray=r.CSSIcon.asClassNameArray,I.asClassName=r.CSSIcon.asClassName,I.asCSSSelector=r.CSSIcon.asCSSSelector})(D=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=r.Codicon.file,e.FolderThemeIcon=r.Codicon.folder;function g(I){switch(I){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=g,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new y.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,L.toDisposable)(()=>{const a=this.themingParticipants.indexOf(b);this.themingParticipants.splice(a,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let v=new S;k.Registry.add(e.Extensions.ThemingContribution,v);function d(I){return v.onColorThemeChange(I)}e.registerThemingParticipant=d;class w extends L.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(a=>this.onThemeChange(a)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,a){let c=this.theme.getColor(b);return c&&a&&(c=a(c,this.theme)),c?c.toString():null}}e.Themable=w}),define(X[75],J([0,1,3,13,38,4]),function(q,e,m,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const P="#FFFFFF",r="#1E1E1E",p="#000000",i="theme",D="themeBackground";e.IThemeMainService=(0,y.createDecorator)("themeMainService");let g=class{constructor(v){this.stateService=v,L.ipcMain.on("vscode:changeColorTheme",(d,w,I)=>{typeof I=="string"&&this.storeBackgroundColor(JSON.parse(I))})}storeBackgroundColor(v){this.stateService.setItem(i,v.baseTheme),this.stateService.setItem(D,v.background)}getBackgroundColor(){if((m.isWindows||m.isMacintosh)&&L.nativeTheme.shouldUseInvertedColorScheme)return p;let v=this.stateService.getItem(D,null);if(!v){let d;(m.isWindows||m.isMacintosh)&&L.nativeTheme.shouldUseInvertedColorScheme?d="hc-black":d=this.stateService.getItem(i,"vs-dark").split(" ")[0],v=d==="hc-black"?p:d==="vs"?P:r}return m.isMacintosh&&v.toUpperCase()===r&&(v="#171717"),v}};g=ce([ee(0,k.IStateService)],g),e.ThemeMainService=g}),define(X[40],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(y){y.Uninitialized="uninitialized",y.Idle="idle",y.CheckingForUpdates="checking for updates",y.AvailableForDownload="available for download",y.Downloading="downloading",y.Downloaded="downloaded",y.Updating="updating",y.Ready="ready"})(L=e.StateType||(e.StateType={}));var k;(function(y){y[y.Setup=0]="Setup",y[y.Archive=1]="Archive",y[y.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(y,P)=>({type:"idle",updateType:y,error:P}),CheckingForUpdates:y=>({type:"checking for updates",context:y}),AvailableForDownload:y=>({type:"available for download",update:y}),Downloading:y=>({type:"downloading",update:y}),Downloaded:y=>({type:"downloaded",update:y}),Updating:y=>({type:"updating",update:y}),Ready:y=>({type:"ready",update:y})},e.IUpdateService=(0,m.createDecorator)("updateService")}),define(X[198],J([0,1,37,47,144,3]),function(q,e,m,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),m.Registry.as(L.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,k.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,k.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,k.localize)(2,null),(0,k.localize)(3,null),(0,k.localize)(4,null),(0,k.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,k.localize)(6,null),deprecationMessage:(0,k.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,k.localize)(8,null),description:(0,k.localize)(9,null),included:y.isWindows&&!y.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,k.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(X[199],J([0,1,5,40]),function(q,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(r){this.service=r}listen(r,p){switch(p){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${p}`)}call(r,p,i){switch(p){case"checkForUpdates":return this.service.checkForUpdates(i);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${p}`)}}e.UpdateChannel=k;class y{constructor(r){this.channel=r,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(p=>this.state=p),this.channel.call("_getInitialState").then(p=>this.state=p)}get state(){return this._state}set state(r){this._state=r,this._onStateChange.fire(r)}checkForUpdates(r){return this.channel.call("checkForUpdates",r)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=y}),define(X[96],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,m.createDecorator)("urlService")}),define(X[200],J([0,1,7]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(r){this.handler=r}listen(r,p){throw new Error(`Event not found: ${p}`)}call(r,p,i){switch(p){case"handleURL":return this.handler.handleURL(m.URI.revive(i[0]),i[1])}throw new Error(`Call not found: ${p}`)}}e.URLHandlerChannel=L;class k{constructor(r){this.channel=r}handleURL(r,p){return this.channel.call("handleURL",[r.toJSON(),p])}}e.URLHandlerChannelClient=k;class y{constructor(r){this.next=r}async routeCall(r,p,i,D){if(p!=="handleURL")throw new Error(`Call not found: ${p}`);if(i){const g=m.URI.revive(i);if(g&&g.query){const S=/\bwindowId=(\d+)/.exec(g.query);if(S){const v=S[1],d=new RegExp(`window:${v}`),w=r.connections.find(I=>d.test(I.ctx));if(w)return w}}}return this.next.routeCall(r,p,i,D)}routeEvent(r,p){throw new Error(`Event not found: ${p}`)}}e.URLHandlerRouter=y}),define(X[201],J([0,1,7,9,2,20]),function(q,e,m,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class P extends k.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(i,D){const g=[...this.handlers.values()];return(0,L.first)(g.map(S=>()=>S.handleURL(i,D)),void 0,!1).then(S=>S||!1)}registerHandler(i){return this.handlers.add(i),(0,k.toDisposable)(()=>this.handlers.delete(i))}}e.AbstractURLService=P;let r=class extends P{constructor(i){super();this.productService=i}create(i){let{authority:D,path:g,query:S,fragment:v}=i||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return D&&g&&g.indexOf("/")!==0&&(g=`/${g}`),m.URI.from({scheme:this.productService.urlProtocol,authority:D,path:g,query:S,fragment:v})}};r=ce([ee(0,y.IProductService)],r),e.NativeURLService=r}),define(X[202],J([0,1,5,13,7,2,3,9]),function(q,e,m,L,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function p(D){try{return k.URI.parse(D)}catch(g){return null}}class i{constructor(g,S,v,d,w){if(this.urlService=S,this.uris=[],this.retryCount=0,this.flushDisposable=y.Disposable.None,this.disposables=new y.DisposableStore,this.uris=g,P.isWindows){const a=d.isBuilt?[]:[`"${d.appRoot}"`];a.push("--open-url","--"),L.app.setAsDefaultProtocolClient(w.urlProtocol,process.execPath,a)}const I=m.Event.map(m.Event.fromNodeEventEmitter(L.app,"open-url",(a,c)=>({event:a,url:c})),({event:a,url:c})=>(a.preventDefault(),c));this.disposables.add(I(a=>{const c=p(a);!c||this.urlService.open(c,{originalUrl:a})})),v.getWindows().filter(a=>a.isReady).length>0?this.flush():m.Event.once(v.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(!(this.retryCount++>10)){const g=[];for(const S of this.uris)await this.urlService.open(S.uri,{originalUrl:S.url})||g.push(S);g.length!==0&&(this.uris=g,this.flushDisposable=(0,r.disposableTimeout)(()=>this.flush(),500))}}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=i}),define(X[76],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewPartitionId=e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,m.createDecorator)("webviewManagerService"),e.webviewPartitionId="webview"}),define(X[203],J([0,1,13,2,10,7,76]),function(q,e,m,L,k,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class r extends L.Disposable{constructor(){super();const i=m.session.fromPartition(P.webviewPartitionId),D=this.handleWebviewRequest.bind(this);m.protocol.registerFileProtocol(k.Schemas.vscodeWebview,D),i.protocol.registerFileProtocol(k.Schemas.vscodeWebview,D)}async handleWebviewRequest(i,D){try{const g=y.URI.parse(i.url),S=r.validWebviewFilePaths.get(g.path);if(typeof S=="string"){const v=g.path.startsWith("/electron-browser")?`vs/workbench/contrib/webview/electron-browser/pre/${S}`:`vs/workbench/contrib/webview/browser/pre/${S}`,d=k.FileAccess.asFileUri(v,q);return D(decodeURIComponent(d.fsPath))}}catch(g){}D({error:-10})}}e.WebviewProtocolProvider=r,r.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/electron-browser-index.html","index.html"],["/main.js","main.js"],["/host.js","host.js"],["/service-worker.js","service-worker.js"]])}),define(X[60],J([0,1,3]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(i){return!!i.workspaceUri}e.isWorkspaceToOpen=L;function k(i){return!!i.folderUri}e.isFolderToOpen=k;function y(i){return!!i.fileUri}e.isFileToOpen=y;function P(i){const D=r(i),g=i.getValue("window.menuBarVisibility");return g==="default"||D==="native"&&g==="compact"||m.isMacintosh&&m.isNative?"classic":g}e.getMenuBarVisibility=P;function r(i){if(m.isWeb)return"custom";const D=i.getValue("window");if(D){if(m.isMacintosh&&D.nativeTabs===!0||m.isMacintosh&&D.nativeFullScreen===!1)return"native";const v=D.titleBarStyle;if(v==="native"||v==="custom")return v}return m.isLinux?"native":"custom"}e.getTitleBarStyle=r;function p(i=0){return Math.pow(1.2,i)}e.zoomLevelToZoomFactor=p}),define(X[34],J([0,1,4]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=void 0;var L;(function(r){r[r.CLI=0]="CLI",r[r.DOCK=1]="DOCK",r[r.MENU=2]="MENU",r[r.DIALOG=3]="DIALOG",r[r.DESKTOP=4]="DESKTOP",r[r.API=5]="API"})(L=e.OpenContext||(e.OpenContext={}));const k=function(r=1){return{width:1024,height:768,mode:r}};e.defaultWindowState=k;var y;(function(r){r[r.Maximized=0]="Maximized",r[r.Normal=1]="Normal",r[r.Minimized=2]="Minimized",r[r.Fullscreen=3]="Fullscreen"})(y=e.WindowMode||(e.WindowMode={}));var P;(function(r){r[r.UNRESPONSIVE=1]="UNRESPONSIVE",r[r.CRASHED=2]="CRASHED",r[r.LOAD=3]="LOAD"})(P=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,m.createDecorator)("windowsMainService")}),define(X[204],J([0,1,13,2,73,76,203,34]),function(q,e,m,L,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let p=class extends L.Disposable{constructor(D,g){super();this.windowsMainService=g,this._register(new P.WebviewProtocolProvider);const S=m.session.fromPartition(y.webviewPartitionId);S.setPermissionRequestHandler((v,d,w)=>w(d==="clipboard-read")),S.setPermissionCheckHandler((v,d)=>d==="clipboard-read")}async setIgnoreMenuShortcuts(D,g){let S;if(typeof D.windowId=="number"){const{windowId:v}=D,d=this.windowsMainService.getWindowById(v);if(!(d==null?void 0:d.win))throw new Error(`Invalid windowId: ${v}`);S=d.win.webContents}else{const{webContentsId:v}=D;if(S=m.webContents.fromId(v),!S)throw new Error(`Invalid webContentsId: ${v}`)}S.isDestroyed()||S.setIgnoreMenuShortcuts(g)}};p=ce([ee(0,k.ITunnelService),ee(1,r.IWindowsMainService)],p),e.WebviewMainService=p}),define(X[205],J([0,1,5,2,9]),function(q,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class y extends L.Disposable{constructor({onDidOpenWindow:r,onDidFocusWindow:p,getActiveWindowId:i}){super();this.disposables=this._register(new L.DisposableStore),m.Event.latch(m.Event.any(r,p))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,k.createCancelablePromise)(()=>i()),(async()=>{try{const g=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:g}catch(g){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(r){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=r}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=y}),define(X[206],J([0,1,7,15,4,36]),function(q,e,m,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");var P;(function(S){S[S.EMPTY=1]="EMPTY",S[S.FOLDER=2]="FOLDER",S[S.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function r(S){const v=S;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.isWorkspace=r;function p(S){const v=S;return!!(v&&typeof v=="object"&&m.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.isWorkspaceFolder=p;class i{constructor(v,d,w,I){this._id=v,this._configuration=w,this._ignorePathCasing=I,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(v){this._id=v.id,this._configuration=v.configuration,this._ignorePathCasing=v._ignorePathCasing,this.folders=v.folders}get folders(){return this._folders}set folders(v){this._folders=v,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(v){this._configuration=v}getFolder(v){return v&&this._foldersMap.findSubstr(v.with({scheme:v.scheme,authority:v.authority,path:v.path}))||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing);for(const v of this.folders)this._foldersMap.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=i;class D{constructor(v,d){this.raw=d,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,L.joinPath)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=D;function g(S){return new D({uri:S,index:0,name:(0,L.basenameOrAuthority)(S)},{uri:S.toString()})}e.toWorkspaceFolder=g}),define(X[29],J([0,1,4,147,206,7,3,8,15,102,43,10,39,30,72]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,L.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function I(z){return(typeof z=="string"?(0,r.extname)(z):(0,p.extname)(z))===w}e.hasWorkspaceFileExtension=I,e.IWorkspacesService=(0,m.createDecorator)("workspacesService");function b(z){return z.hasOwnProperty("workspace")}e.isRecentWorkspace=b;function a(z){return z.hasOwnProperty("folderUri")}e.isRecentFolder=a;function c(z){return z.hasOwnProperty("fileUri")}e.isRecentFile=c;function l(z){const C=z;return typeof(C==null?void 0:C.id)=="string"&&y.URI.isUri(C.uri)}e.isSingleFolderWorkspaceIdentifier=l;function s(z){if(z.configuration)return{id:z.id,configPath:z.configuration};if(z.folders.length===1)return{id:z.id,uri:z.folders[0].uri}}e.toWorkspaceIdentifier=s;function t(z){const C=z;return typeof(C==null?void 0:C.id)=="string"&&y.URI.isUri(C.configPath)}e.isWorkspaceIdentifier=t;function n(z){const C=z;if(C==null?void 0:C.uri)return{id:C.id,uri:y.URI.revive(C.uri)};const j=z;if(j==null?void 0:j.configPath)return{id:j.id,configPath:y.URI.revive(j.configPath)};if(z==null?void 0:z.id)return{id:z.id}}e.reviveIdentifier=n;function o(z,C){return p.extUriBiasedIgnorePathCase.isEqualOrParent(z,C.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function u(z){return h(z)||f(z)}e.isStoredWorkspaceFolder=u;function h(z){const C=z;return typeof(C==null?void 0:C.path)=="string"&&(!C.name||typeof C.name=="string")}e.isRawFileWorkspaceFolder=h;function f(z){const C=z;return typeof(C==null?void 0:C.uri)=="string"&&(!C.name||typeof C.name=="string")}e.isRawUriWorkspaceFolder=f;function E(z,C,j,N,T=!P.isWindows,R){if(z.scheme!==N.scheme)return{name:j,uri:z.toString(!0)};let W=C?void 0:R.relativePath(N,z);if(W!==void 0)W.length===0?W=".":P.isWindows&&z.scheme===g.Schemas.file&&!T&&(W=W.replace(/\//g,"\\"));else if(z.scheme===g.Schemas.file)W=z.fsPath,P.isWindows&&(W=(0,S.normalizeDriveLetter)(W),T&&(W=(0,v.toSlashes)(W)));else{if(!R.isEqualAuthority(z.authority,N.authority))return{name:j,uri:z.toString(!0)};W=z.path}return{name:j,path:W}}e.getStoredWorkspaceFolder=E;function A(z,C,j){let N=[],T=new Set;const R=j.dirname(C);for(let W of z){let M=null;if(h(W))W.path&&(M=j.resolvePath(R,W.path));else if(f(W))try{M=y.URI.parse(W.uri),M.path[0]!=="/"&&(M=M.with({path:"/"+M.path}))}catch(F){console.warn(F)}if(M){let F=j.getComparisonKey(M);if(!T.has(F)){T.add(F);const B=W.name||j.basenameOrAuthority(M);N.push(new k.WorkspaceFolder({uri:M,name:B,index:N.length},W))}}}return N}e.toWorkspaceFolders=A;function _(z,C,j,N,T){let R=U(C,z);const W=T.dirname(C),M=T.dirname(N),F=[],B=H(R.folders);for(const Z of R.folders){const re=h(Z)?T.resolvePath(W,Z.path):y.URI.parse(Z.uri);let se;j?se=!1:se=!h(Z)||(0,r.isAbsolute)(Z.path),F.push(E(re,se,Z.name,M,B,T))}const V={insertSpaces:!1,tabSize:4,eol:P.isLinux||P.isMacintosh?`
`:`\r
`},G=i.setProperty(z,["folders"],F,V);let Y=i.applyEdits(z,G);return R.remoteAuthority===(0,d.getRemoteAuthority)(N)&&(Y=i.applyEdits(Y,i.removeProperty(Y,["remoteAuthority"],V))),Y}e.rewriteWorkspaceFileForNewLocation=_;function U(z,C){let j=D.parse(C);if(j&&Array.isArray(j.folders))j.folders=j.folders.filter(N=>u(N));else throw new Error(`${z} looks like an invalid workspace file.`);return j}function H(z){return P.isWindows?z.some(C=>h(C)&&C.path.indexOf("/")>=0):!0}e.useSlashForPath=H;function Q(z){return z.workspace&&typeof z.workspace=="object"&&typeof z.workspace.id=="string"&&typeof z.workspace.configPath=="string"}function ne(z){return typeof z.folderUri=="string"}function ae(z){return typeof z.fileUri=="string"}function O(z,C){const j={workspaces:[],files:[]};if(z){const N=function(R,W){for(let M=0;M<R.length;M++)try{W(R[M],M)}catch(F){C.warn(`Error restoring recent entry ${JSON.stringify(R[M])}: ${F.toString()}. Skip entry.`)}},T=z;if(Array.isArray(T.entries))N(T.entries,R=>{const W=R.label,M=R.remoteAuthority;Q(R)?j.workspaces.push({label:W,remoteAuthority:M,workspace:{id:R.workspace.id,configPath:y.URI.parse(R.workspace.configPath)}}):ne(R)?j.workspaces.push({label:W,remoteAuthority:M,folderUri:y.URI.parse(R.folderUri)}):ae(R)&&j.files.push({label:W,remoteAuthority:M,fileUri:y.URI.parse(R.fileUri)})});else{const R=z;Array.isArray(R.workspaces3)&&N(R.workspaces3,(W,M)=>{const F=Array.isArray(R.workspaceLabels)&&R.workspaceLabels[M]||void 0;typeof W=="object"&&typeof W.id=="string"&&typeof W.configURIPath=="string"?j.workspaces.push({label:F,workspace:{id:W.id,configPath:y.URI.parse(W.configURIPath)}}):typeof W=="string"&&j.workspaces.push({label:F,folderUri:y.URI.parse(W)})}),Array.isArray(R.files2)&&N(R.files2,(W,M)=>{const F=Array.isArray(R.fileLabels)&&R.fileLabels[M]||void 0;typeof W=="string"&&j.files.push({label:F,fileUri:y.URI.parse(W)})})}}return j}e.restoreRecentlyOpened=O;function $(z){const C={entries:[]};for(const j of z.workspaces)a(j)?C.entries.push({folderUri:j.folderUri.toString(),label:j.label,remoteAuthority:j.remoteAuthority}):C.entries.push({workspace:{id:j.workspace.id,configPath:j.workspace.configPath.toString()},label:j.label,remoteAuthority:j.remoteAuthority});for(const j of z.files)C.entries.push({fileUri:j.fileUri.toString(),label:j.label,remoteAuthority:j.remoteAuthority});return C}e.toStoreData=$}),define(X[49],J([0,1,4,29]),function(q,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,m.createDecorator)("backupMainService");function k(y){const P=y;return P&&(0,L.isWorkspaceIdentifier)(P.workspace)}e.isWorkspaceBackupInfo=k}),define(X[50],J([0,1,4,13,9,38,3,8,64,19,12,131,29,39,2,80]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,m.createDecorator)("dialogMainService");let I=class ct{constructor(a){this.stateService=a,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new k.Queue}pickFileFolder(a,c){return this.doPick(Object.assign(Object.assign({},a),{pickFolders:!0,pickFiles:!0,title:(0,g.localize)(0,null)}),c)}pickFolder(a,c){return this.doPick(Object.assign(Object.assign({},a),{pickFolders:!0,title:(0,g.localize)(1,null)}),c)}pickFile(a,c){return this.doPick(Object.assign(Object.assign({},a),{pickFiles:!0,title:(0,g.localize)(2,null)}),c)}pickWorkspace(a,c){const l=(0,g.localize)(3,null),s=(0,v.mnemonicButtonLabel)((0,g.localize)(4,null)),t=S.WORKSPACE_FILTER;return this.doPick(Object.assign(Object.assign({},a),{pickFiles:!0,title:l,filters:t,buttonLabel:s}),c)}async doPick(a,c){const l={title:a.title,buttonLabel:a.buttonLabel,filters:a.filters};l.defaultPath=a.defaultPath||this.stateService.getItem(ct.workingDirPickerStorageKey),(typeof a.pickFiles=="boolean"||typeof a.pickFolders=="boolean")&&(l.properties=void 0,a.pickFiles&&a.pickFolders&&(l.properties=["multiSelections","openDirectory","openFile","createDirectory"])),l.properties||(l.properties=["multiSelections",a.pickFolders?"openDirectory":"openFile","createDirectory"]),P.isMacintosh&&l.properties.push("treatPackageAsDirectory");const s=c||L.BrowserWindow.getFocusedWindow(),t=await this.showOpenDialog(l,(0,D.withNullAsUndefined)(s));if(t&&t.filePaths&&t.filePaths.length>0)return this.stateService.setItem(ct.workingDirPickerStorageKey,(0,r.dirname)(t.filePaths[0])),t.filePaths}getWindowDialogQueue(a){if(a){let c=this.windowDialogQueues.get(a.id);return c||(c=new k.Queue,this.windowDialogQueues.set(a.id,c)),c}else return this.noWindowDialogueQueue}showMessageBox(a,c){return this.getWindowDialogQueue(c).queue(async()=>c?L.dialog.showMessageBox(c,a):L.dialog.showMessageBox(a))}async showSaveDialog(a,c){const l=this.acquireFileDialogLock(a,c);if(!l)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(c).queue(async()=>{let s;return c?s=await L.dialog.showSaveDialog(c,a):s=await L.dialog.showSaveDialog(a),s.filePath=this.normalizePath(s.filePath),s})}finally{(0,d.dispose)(l)}}normalizePath(a){return a&&P.isMacintosh&&(a=(0,p.normalizeNFC)(a)),a}normalizePaths(a){return a.map(c=>this.normalizePath(c))}async showOpenDialog(a,c){a.defaultPath&&(await(0,i.exists)(a.defaultPath)||(a.defaultPath=void 0));const l=this.acquireFileDialogLock(a,c);if(!l)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(c).queue(async()=>{let s;return c?s=await L.dialog.showOpenDialog(c,a):s=await L.dialog.showOpenDialog(a),s.filePaths=this.normalizePaths(s.filePaths),s})}finally{(0,d.dispose)(l)}}acquireFileDialogLock(a,c){if(!c)return d.Disposable.None;let l=this.windowFileDialogLocks.get(c.id);l||(l=new Set,this.windowFileDialogLocks.set(c.id,l));const s=(0,w.hash)(a);if(!l.has(s))return l.add(s),(0,d.toDisposable)(()=>{l==null||l.delete(s),(l==null?void 0:l.size)===0&&this.windowFileDialogLocks.delete(c.id)})}};I.workingDirPickerStorageKey="pickerWorkingDir",I=ce([ee(0,y.IStateService)],I),e.DialogMainService=I}),define(X[207],J([0,1,5,2,29]),function(q,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class y extends L.Disposable{constructor(r,p){super();this.logService=r,this.storageMainService=p,this._onDidChangeGlobalStorage=this._register(new m.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(m.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(r,p)=>(r?r.push(p):r=[p],r),y.STORAGE_CHANGE_DEBOUNCE_TIME)(r=>{r.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(r))}))}serializeGlobalStorageEvents(r){const p=new Map,i=new Set;return r.forEach(D=>{const g=this.storageMainService.globalStorage.get(D.key);typeof g=="string"?p.set(D.key,g):i.add(D.key)}),{changed:Array.from(p.entries()),deleted:Array.from(i.values())}}listen(r,p){switch(p){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${p}`)}async call(r,p,i){const D=(0,k.reviveIdentifier)(i.workspace),g=await this.withStorageInitialized(D);switch(p){case"getItems":return Array.from(g.items.entries());case"updateItems":{const S=i;if(S.insert)for(const[v,d]of S.insert)g.set(v,d);S.delete&&S.delete.forEach(v=>g.delete(v));break}case"close":{if(D)return g.close();break}default:throw new Error(`Call not found: ${p}`)}}async withStorageInitialized(r){const p=r?this.storageMainService.workspaceStorage(r):this.storageMainService.globalStorage;try{await p.init()}catch(i){this.logService.error(`StorageIPC#init: Unable to init ${r?"workspace":"global"} storage due to ${i}`)}return p}}e.StorageDatabaseChannel=y,y.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(X[208],J([0,1,18,19,5,2,6,121,85,8,94,31,28,29]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class d extends y.Disposable{constructor(a){super();this.logService=a,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new k.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new p.Storage(new p.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const a=await this.doCreate();this.storage.dispose(),this.storage=a,this._register(a.onDidChangeStorage(l=>this._onDidChangeStorage.fire({key:l}))),await this.doInit(a);const c=a.getBoolean(D.IS_NEW_KEY);c===void 0?a.set(D.IS_NEW_KEY,!0):c&&a.set(D.IS_NEW_KEY,!1)}catch(a){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${a}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===P.LogLevel.Trace?a=>this.logService.trace(a):void 0,logError:a=>this.logService.error(a)}}doInit(a){return a.init()}get items(){return this.storage.items}get(a,c){return this.storage.get(a,c)}set(a,c){return this.storage.set(a,c)}delete(a){return this.storage.delete(a)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class w extends d{constructor(a,c,l){super(c);this.options=a,this.environmentService=l}async doCreate(){let a;return this.options.useInMemoryStorage?a=r.SQLiteStorageDatabase.IN_MEMORY_PATH:a=(0,i.join)(this.environmentService.globalStorageHome.fsPath,w.STORAGE_NAME),new p.Storage(new r.SQLiteStorageDatabase(a,{logging:this.createLogginOptions()}))}async doInit(a){await super.doInit(a),this.updateTelemetryState(a)}updateTelemetryState(a){a.get(g.instanceStorageKey,void 0)===void 0&&a.set(g.instanceStorageKey,(0,S.generateUuid)()),a.get(g.firstSessionDateStorageKey,void 0)===void 0&&a.set(g.firstSessionDateStorageKey,new Date().toUTCString());const s=a.get(g.currentSessionDateStorageKey,void 0),t=new Date().toUTCString();a.set(g.lastSessionDateStorageKey,typeof s=="undefined"?null:s),a.set(g.currentSessionDateStorageKey,t)}}e.GlobalStorageMain=w,w.STORAGE_NAME="state.vscdb";class I extends d{constructor(a,c,l,s){super(l);this.workspace=a,this.options=c,this.environmentService=s}async doCreate(){const{storageFilePath:a,wasCreated:c}=await this.prepareWorkspaceStorageFolder();return new p.Storage(new r.SQLiteStorageDatabase(a,{logging:this.createLogginOptions()}),{hint:c?p.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:r.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const a=(0,i.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),c=(0,i.join)(a,I.WORKSPACE_STORAGE_NAME);return await(0,L.exists)(a)?{storageFilePath:c,wasCreated:!1}:(await m.promises.mkdir(a,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(a),{storageFilePath:c,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(a){let c;if((0,v.isSingleFolderWorkspaceIdentifier)(this.workspace)?c={folder:this.workspace.uri.toString()}:(0,v.isWorkspaceIdentifier)(this.workspace)&&(c={workspace:this.workspace.configPath.toString()}),c)try{const l=(0,i.join)(a,I.WORKSPACE_META_NAME);await(0,L.exists)(l)||await(0,L.writeFile)(l,JSON.stringify(c,void 0,2))}catch(l){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.WorkspaceStorageMain=I,I.WORKSPACE_STORAGE_NAME="state.vscdb",I.WORKSPACE_META_NAME="workspace.json"}),define(X[97],J([0,1,42,2,46,4,16,6,208]),function(q,e,m,L,k,y,P,r,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,y.createDecorator)("storageMainService");let i=class extends L.Disposable{constructor(g,S,v){super();this.logService=g,this.environmentService=S,this.lifecycleMainService=v,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async g=>{g.workspace&&this.workspaceStorage(g.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(g=>{g.join(this.globalStorage.close());for(const[,S]of this.mapWorkspaceToStorage)g.join(S.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const g=new p.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,m.once)(g.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),g}createWorkspaceStorage(g){return new p.WorkspaceStorageMain(g,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(g){let S=this.mapWorkspaceToStorage.get(g.id);return S||(this.logService.trace(`StorageMainService: creating workspace storage (${g.id})`),S=this.createWorkspaceStorage(g),this.mapWorkspaceToStorage.set(g.id,S),(0,m.once)(S.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${g.id})`),this.mapWorkspaceToStorage.delete(g.id)})),S}};i=ce([ee(0,r.ILogService),ee(1,k.IEnvironmentService),ee(2,P.ILifecycleMainService)],i),e.StorageMainService=i}),define(X[98],J([0,1,7,29,15]),function(q,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function y(p,i,D){for(const S of p){const v=S.openedWorkspace;if((0,L.isWorkspaceIdentifier)(v)){const d=D(v);if(d){if(d.folders.some(w=>k.extUriBiasedIgnorePathCase.isEqualOrParent(i,w.uri)))return S}else if(k.extUriBiasedIgnorePathCase.isEqualOrParent(i,v.configPath))return S}}const g=p.filter(S=>(0,L.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&k.extUriBiasedIgnorePathCase.isEqualOrParent(i,S.openedWorkspace.uri));if(g.length)return g.sort((S,v)=>-(S.openedWorkspace.uri.path.length-v.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=y;function P(p,i){for(const D of p)if((0,L.isWorkspaceIdentifier)(D.openedWorkspace)&&k.extUriBiasedIgnorePathCase.isEqual(D.openedWorkspace.configPath,i)||(0,L.isSingleFolderWorkspaceIdentifier)(D.openedWorkspace)&&k.extUriBiasedIgnorePathCase.isEqual(D.openedWorkspace.uri,i))return D}e.findWindowOnWorkspaceOrFolder=P;function r(p,i){var D,g;const S=v=>i.some(d=>k.extUriBiasedIgnorePathCase.isEqual(m.URI.file(d),m.URI.file(v)));for(const v of p)if((g=(D=v.config)===null||D===void 0?void 0:D.extensionDevelopmentPath)===null||g===void 0?void 0:g.some(d=>S(d)))return v}e.findWindowOnExtensionDevelopmentPath=r}),define(X[209],J([0,1,13,2,3,15,7,21,16,6,38,34,29]),function(q,e,m,L,k,y,P,r,p,i,D,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let v=class ut extends L.Disposable{constructor(c,l,s,t,n){super();this.windowsMainService=c,this.stateService=l,this.lifecycleMainService=s,this.logService=t,this.configurationService=n,this._state=d(this.stateService.getItem(ut.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){m.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(c=>this.onBeforeCloseWindow(c)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(c=>this.onBeforeCloseWindow(c))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(n=>!n.isExtensionDevelopmentHost)),t&&(c.lastActiveWindow=this.toWindowState(t))}const l=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);l&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(l)),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const s=I(c);this.stateService.setItem(ut.windowsStateStorageKey,s),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",s)}onBeforeCloseWindow(c){if(!this.lifecycleMainService.quitRequested){const l=this.toWindowState(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=l:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this._state.openedWindows.forEach(s=>{var t;const n=(0,S.isWorkspaceIdentifier)(c.openedWorkspace)&&((t=s.workspace)===null||t===void 0?void 0:t.id)===c.openedWorkspace.id,o=(0,S.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)&&s.folderUri&&y.extUriBiasedIgnorePathCase.isEqual(s.folderUri,c.openedWorkspace.uri);(n||o)&&(s.uiState=l.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=l)}}toWindowState(c){return{workspace:(0,S.isWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,S.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const l=this.doGetNewWindowState(c),s=this.configurationService.getValue("window");let t;return l.hasDefaultState?t=!!((s==null?void 0:s.newWindowDimensions)&&["fullscreen","inherit","offset"].indexOf(s.newWindowDimensions)>=0):(t=!!(this.lifecycleMainService.wasRestarted||(s==null?void 0:s.restoreFullscreen)),t&&k.isMacintosh&&this.windowsMainService.getWindows().some(n=>n.isFullScreen)&&(t=!1)),l.mode===3&&!t&&(l.mode=1),l}doGetNewWindowState(c){const l=this.windowsMainService.getLastActiveWindow();if(!c.extensionTestsPath){if(!!c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const h=c.workspace;if((0,S.isWorkspaceIdentifier)(h)){const E=this.state.openedWindows.filter(A=>A.workspace&&A.workspace.id===h.id).map(A=>A.uiState);if(E.length)return E[0]}if((0,S.isSingleFolderWorkspaceIdentifier)(h)){const E=this.state.openedWindows.filter(A=>A.folderUri&&y.extUriBiasedIgnorePathCase.isEqual(A.folderUri,h.uri)).map(A=>A.uiState);if(E.length)return E[0]}else if(c.backupPath){const E=this.state.openedWindows.filter(A=>A.backupPath===c.backupPath).map(A=>A.uiState);if(E.length)return E[0]}const f=this.lastClosedState||this.state.lastActiveWindow;if(!l&&f)return f.uiState}let s;const t=m.screen.getAllDisplays();if(t.length===1)s=t[0];else{if(k.isMacintosh){const h=m.screen.getCursorScreenPoint();s=m.screen.getDisplayNearestPoint(h)}!s&&l&&(s=m.screen.getDisplayMatching(l.getBounds())),s||(s=m.screen.getPrimaryDisplay()||t[0])}let n=(0,g.defaultWindowState)();n.x=Math.round(s.bounds.x+s.bounds.width/2-n.width/2),n.y=Math.round(s.bounds.y+s.bounds.height/2-n.height/2);const o=this.configurationService.getValue("window");let u=!0;if(o==null?void 0:o.newWindowDimensions){if(o.newWindowDimensions==="maximized")n.mode=0,u=!1;else if(o.newWindowDimensions==="fullscreen")n.mode=3,u=!1;else if((o.newWindowDimensions==="inherit"||o.newWindowDimensions==="offset")&&l){const h=l.serializeWindowState();h.mode===3?n.mode=3:n=h,u=n.mode!==3&&o.newWindowDimensions==="offset"}}return u&&(n=this.ensureNoOverlap(n)),n.hasDefaultState=!0,n}ensureNoOverlap(c){if(this.windowsMainService.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const l=this.windowsMainService.getWindows().map(s=>s.getBounds());for(;l.some(s=>s.x===c.x||s.y===c.y);)c.x+=30,c.y+=30;return c}};v.windowsStateStorageKey="windowsState",v=ce([ee(0,g.IWindowsMainService),ee(1,D.IStateService),ee(2,p.ILifecycleMainService),ee(3,i.ILogService),ee(4,r.IConfigurationService)],v),e.WindowsStateHandler=v;function d(a){const c={openedWindows:[]},l=a||{openedWindows:[]};return l.lastActiveWindow&&(c.lastActiveWindow=w(l.lastActiveWindow)),l.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=w(l.lastPluginDevelopmentHostWindow)),Array.isArray(l.openedWindows)&&(c.openedWindows=l.openedWindows.map(s=>w(s))),c}e.restoreWindowsState=d;function w(a){const c={uiState:a.uiState};return a.backupPath&&(c.backupPath=a.backupPath),a.remoteAuthority&&(c.remoteAuthority=a.remoteAuthority),a.folder&&(c.folderUri=P.URI.parse(a.folder)),a.workspaceIdentifier&&(c.workspace={id:a.workspaceIdentifier.id,configPath:P.URI.parse(a.workspaceIdentifier.configURIPath)}),c}function I(a){return{lastActiveWindow:a.lastActiveWindow&&b(a.lastActiveWindow),lastPluginDevelopmentHostWindow:a.lastPluginDevelopmentHostWindow&&b(a.lastPluginDevelopmentHostWindow),openedWindows:a.openedWindows.map(c=>b(c))}}e.getWindowsStateStoreData=I;function b(a){return{workspaceIdentifier:a.workspace&&{id:a.workspace.id,configURIPath:a.workspace.configPath.toString()},folder:a.folderUri&&a.folderUri.toString(),backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.uiState}}}),define(X[56],J([0,1,58,59,210,5,33,8,27,28,2,23,83,17,3]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(E){this.socket=E,this._errorListener=A=>{if(A){if(A.code==="EPIPE")return;(0,v.onUnexpectedError)(A)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(E){const A=_=>E(g.VSBuffer.wrap(_));return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(E){return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(E){return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(E){if(!this.socket.destroyed)try{this.socket.write(E.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,v.onUnexpectedError)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,v.onUnexpectedError)(A)}}end(){this.socket.end()}drain(){return new Promise((E,A)=>{if(this.socket.bufferSize===0){E();return}const _=()=>{this.socket.off("close",_),this.socket.off("end",_),this.socket.off("error",_),this.socket.off("timeout",_),this.socket.off("drain",_),E()};this.socket.on("close",_),this.socket.on("end",_),this.socket.on("error",_),this.socket.on("timeout",_),this.socket.on("drain",_)})}}e.NodeSocket=w;var I;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(I||(I={}));var b;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(b||(b={}));class a extends D.Disposable{constructor(E,A,_,U){super();this._onDidZlibFlush=this._register(new y.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=E,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=A,this._recordInflateBytes=U,A?(this._zlibInflate=k.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",H=>{console.error(H),(0,v.onUnexpectedError)(H),this._onClose.fire()}),this._zlibInflate.on("data",H=>{this._pendingInflateData.push(H)}),_&&(this._zlibInflate.write(_.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=k.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",H=>{console.error(H),(0,v.onUnexpectedError)(H),this._onClose.fire()}),this._zlibDeflate.on("data",H=>{this._pendingDeflateData.push(H)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new S.ChunkStream,this._register(this.socket.onData(H=>this._acceptChunk(H))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?g.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):g.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this._onData.event(E)}onClose(E){return this._onClose.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){this._totalOutgoingDataBytes+=E.byteLength,this._zlibDeflate?(this._zlibDeflate.write(E.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let A=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,A=A.slice(0,A.length-4),this._isEnded||this._write(g.VSBuffer.wrap(A),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(E,!1)}_write(E,A){let _=2;E.byteLength<126?_+=0:E.byteLength<2**16?_+=2:_+=8;const U=g.VSBuffer.alloc(_);if(A?U.writeUInt8(194,0):U.writeUInt8(130,0),E.byteLength<126)U.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){U.writeUInt8(126,1);let H=1;U.writeUInt8(E.byteLength>>>8&255,++H),U.writeUInt8(E.byteLength>>>0&255,++H)}else{U.writeUInt8(127,1);let H=1;U.writeUInt8(0,++H),U.writeUInt8(0,++H),U.writeUInt8(0,++H),U.writeUInt8(0,++H),U.writeUInt8(E.byteLength>>>24&255,++H),U.writeUInt8(E.byteLength>>>16&255,++H),U.writeUInt8(E.byteLength>>>8&255,++H),U.writeUInt8(E.byteLength>>>0&255,++H)}this._totalOutgoingWireBytes+=U.byteLength+E.byteLength,this.socket.write(g.VSBuffer.concat([U,E]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(E){if(E.byteLength!==0){for(this._totalIncomingWireBytes+=E.byteLength,this._incomingData.acceptChunk(E);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const A=this._incomingData.peek(this._state.readLen),U=(A.readUInt8(0)&128)>>>7,H=A.readUInt8(1),Q=(H&128)>>>7,ne=H&127;this._state.state=2,this._state.readLen=2+(Q?4:0)+(ne===126?2:0)+(ne===127?8:0),this._state.fin=U,this._state.mask=0}else if(this._state.state===2){const A=this._incomingData.read(this._state.readLen),_=A.readUInt8(1),U=(_&128)>>>7;let H=_&127,Q=1;H===126?H=A.readUInt8(++Q)*2**8+A.readUInt8(++Q):H===127&&(H=A.readUInt8(++Q)*0+A.readUInt8(++Q)*0+A.readUInt8(++Q)*0+A.readUInt8(++Q)*0+A.readUInt8(++Q)*2**24+A.readUInt8(++Q)*2**16+A.readUInt8(++Q)*2**8+A.readUInt8(++Q));let ne=0;U&&(ne=A.readUInt8(++Q)*2**24+A.readUInt8(++Q)*2**16+A.readUInt8(++Q)*2**8+A.readUInt8(++Q)),this._state.state=3,this._state.readLen=H,this._state.mask=ne}else if(this._state.state===3){const A=this._incomingData.read(this._state.readLen);c(A,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(A.buffer)),this._zlibInflate.write(A.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const _=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=_.length,this._onData.fire(g.VSBuffer.wrap(_))})):(this._totalIncomingDataBytes+=A.byteLength,this._onData.fire(A))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await y.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=a;function c(f,E){if(E!==0){let A=f.byteLength>>>2;for(let ae=0;ae<A;ae++){const O=f.readUInt32BE(ae*4);f.writeUInt32BE(O^E,ae*4)}let _=A*4,U=f.byteLength-_;const H=E>>>24&255,Q=E>>>16&255,ne=E>>>8&255;U>=1&&f.writeUInt8(f.readUInt8(_)^H,_),U>=2&&f.writeUInt8(f.readUInt8(_+1)^Q,_+1),U>=3&&f.writeUInt8(f.readUInt8(_+2)^ne,_+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function s(){const f=(0,i.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let E;return e.XDG_RUNTIME_DIR?E=(0,r.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):E=(0,r.join)((0,p.tmpdir)(),`vscode-ipc-${f}.sock`),n(E),E}e.createRandomIPCHandle=s;function t(f,E,A){const _=(0,m.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${_}-${A}-${E}-sock`;let U;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?U=(0,r.join)(e.XDG_RUNTIME_DIR,`vscode-${_.substr(0,8)}-${A}-${E}.sock`):U=(0,r.join)(f,`${A}-${E}.sock`),n(U),U}e.createStaticIPCHandle=t;function n(f){const E=l[d.platform];typeof E=="number"&&f.length>=E&&console.warn(`WARNING: IPC handle "${f}" is longer than ${E} chars, try a shorter --user-data-dir`)}class o extends P.IPCServer{constructor(E){super(o.toClientConnectionEvent(E));this.server=E}static toClientConnectionEvent(E){const A=y.Event.fromNodeEventEmitter(E,"connection");return y.Event.map(A,_=>({protocol:new S.Protocol(new w(_)),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(_,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function u(f){return new Promise((E,A)=>{const _=(0,L.createServer)();_.on("error",A),_.listen(f,()=>{_.removeListener("error",A),E(new o(_))})})}e.serve=u;function h(f,E){return new Promise((A,_)=>{const U=(0,L.createConnection)(f,()=>{U.removeListener("error",_),A(S.Client.fromSocket(new w(U),E))});U.once("error",_)})}e.connect=h}),define(X[211],J([0,1,56]),function(q,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverChannelClient=e.WindowDriverChannel=e.WindowDriverRegistryChannelClient=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(g){this.driver=g}listen(g,S){throw new Error("No event found")}call(g,S,v){switch(S){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(v);case"reloadWindow":return this.driver.reloadWindow(v);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(v[0],v[1]);case"click":return this.driver.click(v[0],v[1],v[2],v[3]);case"doubleClick":return this.driver.doubleClick(v[0],v[1]);case"setValue":return this.driver.setValue(v[0],v[1],v[2]);case"getTitle":return this.driver.getTitle(v[0]);case"isActiveElement":return this.driver.isActiveElement(v[0],v[1]);case"getElements":return this.driver.getElements(v[0],v[1],v[2]);case"getElementXY":return this.driver.getElementXY(v[0],v[1],v[2]);case"typeInEditor":return this.driver.typeInEditor(v[0],v[1],v[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(v[0],v[1]);case"writeInTerminal":return this.driver.writeInTerminal(v[0],v[1],v[2])}throw new Error(`Call not found: ${S}`)}}e.DriverChannel=L;class k{constructor(g){this.channel=g}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(g){return this.channel.call("capturePage",g)}reloadWindow(g){return this.channel.call("reloadWindow",g)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(g,S){return this.channel.call("dispatchKeybinding",[g,S])}click(g,S,v,d){return this.channel.call("click",[g,S,v,d])}doubleClick(g,S){return this.channel.call("doubleClick",[g,S])}setValue(g,S,v){return this.channel.call("setValue",[g,S,v])}getTitle(g){return this.channel.call("getTitle",[g])}isActiveElement(g,S){return this.channel.call("isActiveElement",[g,S])}getElements(g,S,v){return this.channel.call("getElements",[g,S,v])}getElementXY(g,S,v,d){return this.channel.call("getElementXY",[g,S,v,d])}typeInEditor(g,S,v){return this.channel.call("typeInEditor",[g,S,v])}getTerminalBuffer(g,S){return this.channel.call("getTerminalBuffer",[g,S])}writeInTerminal(g,S,v){return this.channel.call("writeInTerminal",[g,S,v])}}e.DriverChannelClient=k;class y{constructor(g){this.registry=g}listen(g,S){throw new Error(`Event not found: ${S}`)}call(g,S,v){switch(S){case"registerWindowDriver":return this.registry.registerWindowDriver(v);case"reloadWindowDriver":return this.registry.reloadWindowDriver(v)}throw new Error(`Call not found: ${S}`)}}e.WindowDriverRegistryChannel=y;class P{constructor(g){this.channel=g}registerWindowDriver(g){return this.channel.call("registerWindowDriver",g)}reloadWindowDriver(g){return this.channel.call("reloadWindowDriver",g)}}e.WindowDriverRegistryChannelClient=P;class r{constructor(g){this.driver=g}listen(g,S){throw new Error(`No event found: ${S}`)}call(g,S,v){switch(S){case"click":return this.driver.click(v[0],v[1],v[2]);case"doubleClick":return this.driver.doubleClick(v);case"setValue":return this.driver.setValue(v[0],v[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(v);case"getElements":return this.driver.getElements(v[0],v[1]);case"getElementXY":return this.driver.getElementXY(v[0],v[1],v[2]);case"typeInEditor":return this.driver.typeInEditor(v[0],v[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(v);case"writeInTerminal":return this.driver.writeInTerminal(v[0],v[1])}throw new Error(`Call not found: ${S}`)}}e.WindowDriverChannel=r;class p{constructor(g){this.channel=g}click(g,S,v){return this.channel.call("click",[g,S,v])}doubleClick(g){return this.channel.call("doubleClick",g)}setValue(g,S){return this.channel.call("setValue",[g,S])}getTitle(){return this.channel.call("getTitle")}isActiveElement(g){return this.channel.call("isActiveElement",g)}getElements(g,S){return this.channel.call("getElements",[g,S])}getElementXY(g,S,v){return this.channel.call("getElementXY",[g,S,v])}typeInEditor(g,S){return this.channel.call("typeInEditor",[g,S])}getTerminalBuffer(g){return this.channel.call("getTerminalBuffer",g)}writeInTerminal(g,S){return this.channel.call("writeInTerminal",[g,S])}}e.WindowDriverChannelClient=p;async function i(D){const g=await(0,m.connect)(D,"driverClient"),S=g.getChannel("driver"),v=new k(S);return{client:g,driver:v}}e.connect=i}),define(X[26],J([0,1,8,52,4,46,155,56]),function(q,e,m,L,k,y,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,k.refineServiceDecorator)(y.IEnvironmentService);class p extends P.NativeEnvironmentService{get cachedLanguagesPath(){return(0,m.join)(this.userDataPath,"clp")}get backupHome(){return(0,m.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,m.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,r.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get nodeCachedDataDir(){return process.env.VSCODE_NODE_CACHED_DATA_DIR||void 0}get chromeCachedDataDir(){return(0,m.join)(this.userDataPath,"Code Cache")}}ce([L.memoize],p.prototype,"cachedLanguagesPath",null),ce([L.memoize],p.prototype,"backupHome",null),ce([L.memoize],p.prototype,"backupWorkspacesPath",null),ce([L.memoize],p.prototype,"mainIPCHandle",null),ce([L.memoize],p.prototype,"sandbox",null),ce([L.memoize],p.prototype,"driverVerbose",null),ce([L.memoize],p.prototype,"disableUpdates",null),ce([L.memoize],p.prototype,"disableKeytar",null),ce([L.memoize],p.prototype,"nodeCachedDataDir",null),ce([L.memoize],p.prototype,"chromeCachedDataDir",null),e.EnvironmentMainService=p}),define(X[212],J([0,1,18,58,8,3,19,49,26,21,24,6,29,7,30,10,15]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v,d,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let b=class{constructor(c,l,s){this.configurationService=l,this.logService=s,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=I.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,n)=>(0,d.isEqual)(t,n,!y.isLinux)},this.backupHome=c.backupHome,this.workspacesJsonPath=c.backupWorkspacesPath}async initialize(){let c;try{c=JSON.parse(await m.promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){c=Object.create(null)}c.emptyWorkspaceInfos&&(this.emptyWindows=await this.validateEmptyWorkspaces(c.emptyWorkspaceInfos));let l=[];try{Array.isArray(c.rootURIWorkspaces)&&(l=c.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:v.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(l);let s=[];try{Array.isArray(c.folderURIWorkspaces)&&(s=c.folderURIWorkspaces.map(t=>v.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(s),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==D.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===D.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){var c;const l=this.configurationService.getValue();return((c=l==null?void 0:l.files)===null||c===void 0?void 0:c.hotExit)||D.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(c,l){this.workspaces.some(t=>c.workspace.id===t.workspace.id)||(this.workspaces.push(c),this.saveSync());const s=this.getBackupPath(c.workspace.id);return l&&this.moveBackupFolderSync(s,l),s}moveBackupFolderSync(c,l){if(m.existsSync(c)&&this.convertToEmptyWindowBackupSync(c),m.existsSync(l))try{m.renameSync(l,c)}catch(s){this.logService.error(`Backup: Could not move backup folder to new location: ${s.toString()}`)}}unregisterWorkspaceBackupSync(c){const l=c.id,s=this.workspaces.findIndex(t=>t.workspace.id===l);s!==-1&&(this.workspaces.splice(s,1),this.saveSync())}registerFolderBackupSync(c){return this.folders.some(l=>this.backupUriComparer.isEqual(c,l))||(this.folders.push(c),this.saveSync()),this.getBackupPath(this.getFolderHash(c))}unregisterFolderBackupSync(c){const l=this.folders.findIndex(s=>this.backupUriComparer.isEqual(c,s));l!==-1&&(this.folders.splice(l,1),this.saveSync())}registerEmptyWindowBackupSync(c,l){const s=c||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,s))||(this.emptyWindows.push({backupFolder:s,remoteAuthority:l}),this.saveSync()),this.getBackupPath(s)}unregisterEmptyWindowBackupSync(c){const l=this.emptyWindows.findIndex(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,c));l!==-1&&(this.emptyWindows.splice(l,1),this.saveSync())}getBackupPath(c){return(0,k.join)(this.backupHome,c)}async validateWorkspaces(c){if(!Array.isArray(c))return[];const l=new Set,s=[];for(let t of c){const n=t.workspace;if(!(0,S.isWorkspaceIdentifier)(n))return[];if(!l.has(n.id)){l.add(n.id);const o=this.getBackupPath(n.id);await this.doHasBackups(o)?n.configPath.scheme!==w.Schemas.file||await(0,P.exists)(n.configPath.fsPath)?s.push(t):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return s}async validateFolders(c){if(!Array.isArray(c))return[];const l=[],s=new Set;for(let t of c){const n=this.backupUriComparer.getComparisonKey(t);if(!s.has(n)){s.add(n);const o=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(o)?t.scheme!==w.Schemas.file||await(0,P.exists)(t.fsPath)?l.push(t):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return l}async validateEmptyWorkspaces(c){if(!Array.isArray(c))return[];const l=[],s=new Set;for(let t of c){const n=t.backupFolder;if(typeof n!="string")return[];if(!s.has(n)){s.add(n);const o=this.getBackupPath(n);await this.doHasBackups(o)?l.push(t):await this.deleteStaleBackup(o)}}return l}async deleteStaleBackup(c){try{await(0,P.exists)(c)&&await(0,P.rimraf)(c,P.RimRafMode.MOVE)}catch(l){this.logService.error(`Backup: Could not delete stale backup: ${l.toString()}`)}}async convertToEmptyWindowBackup(c){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,l));)l=this.getRandomEmptyWindowId();const s=this.getBackupPath(l);try{await m.promises.rename(c,s)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}convertToEmptyWindowBackupSync(c){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,l));)l=this.getRandomEmptyWindowId();const s=this.getBackupPath(l);try{m.renameSync(c,s)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}async getDirtyWorkspaces(){const c=[];for(const l of this.workspaces)await this.hasBackups(l)&&c.push(l.workspace);for(const l of this.folders)await this.hasBackups(l)&&c.push(l);return c}hasBackups(c){let l;return v.URI.isUri(c)?l=this.getBackupPath(this.getFolderHash(c)):(0,r.isWorkspaceBackupInfo)(c)?l=this.getBackupPath(c.workspace.id):l=c.backupFolder,this.doHasBackups(l)}async doHasBackups(c){try{const l=await(0,P.readdir)(c);for(const s of l)try{if((await(0,P.readdir)((0,k.join)(c,s))).length>0)return!0}catch(t){}}catch(l){}return!1}saveSync(){try{(0,P.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}async save(){try{await(0,P.writeFile)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(c=>({id:c.workspace.id,configURIPath:c.workspace.configPath.toString(),remoteAuthority:c.remoteAuthority})),folderURIWorkspaces:this.folders.map(c=>c.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(c){let l;return c.scheme===w.Schemas.file?l=y.isLinux?c.fsPath:c.fsPath.toLowerCase():l=c.toString().toLowerCase(),(0,L.createHash)("md5").update(l).digest("hex")}};b=ce([ee(0,p.IEnvironmentMainService),ee(1,i.IConfigurationService),ee(2,g.ILogService)],b),e.BackupMainService=b}),define(X[41],J([0,1,5,34,13,16,3,26,50,19,7,31,4,27,65,6,8,20,52,2]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v,d,w,I,b,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,S.createDecorator)("nativeHostMainService");let l=class rt extends c.Disposable{constructor(t,n,o,u,h,f,E,A){super();this.sharedProcess=t,this.windowsMainService=n,this.dialogMainService=o,this.lifecycleMainService=u,this.environmentMainService=h,this.telemetryService=f,this.logService=E,this.productService=A,this.onDidOpenWindow=m.Event.map(this.windowsMainService.onDidOpenWindow,_=>_.id),this.onDidMaximizeWindow=m.Event.filter(m.Event.fromNodeEventEmitter(k.app,"browser-window-maximize",(_,U)=>U.id),_=>!!this.windowsMainService.getWindowById(_)),this.onDidUnmaximizeWindow=m.Event.filter(m.Event.fromNodeEventEmitter(k.app,"browser-window-unmaximize",(_,U)=>U.id),_=>!!this.windowsMainService.getWindowById(_)),this.onDidBlurWindow=m.Event.filter(m.Event.fromNodeEventEmitter(k.app,"browser-window-blur",(_,U)=>U.id),_=>!!this.windowsMainService.getWindowById(_)),this.onDidFocusWindow=m.Event.any(m.Event.map(m.Event.filter(m.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),_=>!!_),_=>_.id),m.Event.filter(m.Event.fromNodeEventEmitter(k.app,"browser-window-focus",(_,U)=>U.id),_=>!!this.windowsMainService.getWindowById(_))),this.onDidResumeOS=m.Event.fromNodeEventEmitter(k.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new m.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new m.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=m.Event.debounce(m.Event.any(m.Event.filter(m.Event.fromNodeEventEmitter(k.screen,"display-metrics-changed",(_,U,H)=>H),_=>!(Array.isArray(_)&&_.length===1&&_[0]==="workArea")),m.Event.fromNodeEventEmitter(k.screen,"display-added"),m.Event.fromNodeEventEmitter(k.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){k.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:k.nativeTheme.shouldUseInvertedColorScheme||k.nativeTheme.shouldUseHighContrastColors,dark:k.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(n=>{var o,u;return{id:n.id,workspace:n.openedWorkspace,title:(u=(o=n.win)===null||o===void 0?void 0:o.getTitle())!==null&&u!==void 0?u:"",filename:n.getRepresentedFilename(),dirty:n.isDocumentEdited()}})}async getWindowCount(t){return this.windowsMainService.getWindowCount()}async getActiveWindowId(t){const n=k.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(n)return n.id}openWindow(t,n,o){return Array.isArray(n)?this.doOpenWindow(t,n,o):this.doOpenEmptyWindow(t,n)}async doOpenWindow(t,n,o=Object.create(null)){n.length>0&&this.windowsMainService.open({context:5,contextWindowId:t,urisToOpen:n,cli:this.environmentMainService.args,forceNewWindow:o.forceNewWindow,forceReuseWindow:o.forceReuseWindow,preferNewWindow:o.preferNewWindow,diffMode:o.diffMode,addMode:o.addMode,gotoLineMode:o.gotoLineMode,noRecentEntry:o.noRecentEntry,waitMarkerFileURI:o.waitMarkerFileURI,remoteAuthority:o.remoteAuthority||void 0})}async doOpenEmptyWindow(t,n){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:t},n)}async toggleFullScreen(t){const n=this.windowById(t);n&&n.toggleFullScreen()}async handleTitleDoubleClick(t){const n=this.windowById(t);n&&n.handleTitleDoubleClick()}async isMaximized(t){const n=this.windowById(t);return(n==null?void 0:n.win)?n.win.isMaximized():!1}async maximizeWindow(t){const n=this.windowById(t);(n==null?void 0:n.win)&&n.win.maximize()}async unmaximizeWindow(t){const n=this.windowById(t);(n==null?void 0:n.win)&&n.win.unmaximize()}async minimizeWindow(t){const n=this.windowById(t);(n==null?void 0:n.win)&&n.win.minimize()}async focusWindow(t,n){var o;n&&typeof n.windowId=="number"&&(t=n.windowId);const u=this.windowById(t);u&&u.focus({force:(o=n==null?void 0:n.force)!==null&&o!==void 0?o:!1})}async setMinimumSize(t,n,o){const u=this.windowById(t);if(u==null?void 0:u.win){const[h,f]=u.win.getSize(),[E,A]=u.win.getMinimumSize(),[_,U]=[n!=null?n:E,o!=null?o:A],[H,Q]=[Math.max(h,_),Math.max(f,U)];(E!==_||A!==U)&&u.win.setMinimumSize(_,U),(h!==H||f!==Q)&&u.win.setSize(H,Q)}}async showMessageBox(t,n){return this.dialogMainService.showMessageBox(n,this.toBrowserWindow(t))}async showSaveDialog(t,n){return this.dialogMainService.showSaveDialog(n,this.toBrowserWindow(t))}async showOpenDialog(t,n){return this.dialogMainService.showOpenDialog(n,this.toBrowserWindow(t))}toBrowserWindow(t){const n=this.windowById(t);if(n==null?void 0:n.win)return n.win}async pickFileFolderAndOpen(t,n){const o=await this.dialogMainService.pickFileFolder(n);o&&(this.sendPickerTelemetry(o,n.telemetryEventName||"openFileFolder",n.telemetryExtraData),this.doOpenPicked(await Promise.all(o.map(async u=>await i.SymlinkSupport.existsDirectory(u)?{folderUri:D.URI.file(u)}:{fileUri:D.URI.file(u)})),n,t))}async pickFolderAndOpen(t,n){const o=await this.dialogMainService.pickFolder(n);o&&(this.sendPickerTelemetry(o,n.telemetryEventName||"openFolder",n.telemetryExtraData),this.doOpenPicked(o.map(u=>({folderUri:D.URI.file(u)})),n,t))}async pickFileAndOpen(t,n){const o=await this.dialogMainService.pickFile(n);o&&(this.sendPickerTelemetry(o,n.telemetryEventName||"openFile",n.telemetryExtraData),this.doOpenPicked(o.map(u=>({fileUri:D.URI.file(u)})),n,t))}async pickWorkspaceAndOpen(t,n){const o=await this.dialogMainService.pickWorkspace(n);o&&(this.sendPickerTelemetry(o,n.telemetryEventName||"openWorkspace",n.telemetryExtraData),this.doOpenPicked(o.map(u=>({workspaceUri:D.URI.file(u)})),n,t))}doOpenPicked(t,n,o){this.windowsMainService.open({context:3,contextWindowId:o,cli:this.environmentMainService.args,urisToOpen:t,forceNewWindow:n.forceNewWindow})}sendPickerTelemetry(t,n,o){const u=t?t.length:0;this.telemetryService.publicLog(n,Object.assign(Object.assign({},o),{outcome:u?"success":"canceled",numberOfPaths:u}))}async showItemInFolder(t,n){k.shell.showItemInFolder(n)}async setRepresentedFilename(t,n){const o=this.windowById(t);o&&o.setRepresentedFilename(n)}async setDocumentEdited(t,n){const o=this.windowById(t);o&&o.setDocumentEdited(n)}async openExternal(t,n){return P.isLinuxSnap?this.safeSnapOpenExternal(n):k.shell.openExternal(n),!0}safeSnapOpenExternal(t){const n=process.env.GDK_PIXBUF_MODULE_FILE,o=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,k.shell.openExternal(t),process.env.GDK_PIXBUF_MODULE_FILE=n,process.env.GDK_PIXBUF_MODULEDIR=o}async moveItemToTrash(t,n){return k.shell.moveItemToTrash(n)}async isAdmin(){let t;return P.isWindows?t=(await new Promise((n,o)=>{q(["native-is-elevated"],n,o)}))():t=process.getuid()===0,t}async writeElevated(t,n,o,u){const h=await new Promise((f,E)=>{q(["sudo-prompt"],f,E)});return new Promise((f,E)=>{const A=[`"${this.cliPath}"`];(u==null?void 0:u.unlock)&&A.push("--file-chmod"),A.push("--file-write",`"${n.fsPath}"`,`"${o.fsPath}"`);const _={name:this.productService.nameLong.replace("-",""),icns:P.isMacintosh&&this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};h.exec(A.join(" "),_,(U,H,Q)=>{H&&this.logService.trace(`[sudo-prompt] received stdout: ${H}`),Q&&this.logService.trace(`[sudo-prompt] received stderr: ${Q}`),U?E(U):f(void 0)})})}get cliPath(){return P.isWindows?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):P.isLinux?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,I.join)(this.environmentMainService.appRoot,"bin","code"):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,v.totalmem)(),freemem:(0,v.freemem)(),loadavg:(0,v.loadavg)()}}async getOSProperties(){return{arch:(0,v.arch)(),platform:(0,v.platform)(),release:(0,v.release)(),type:(0,v.type)(),cpus:(0,v.cpus)()}}async getOSVirtualMachineHint(){return d.virtualMachineHint.value()}async killProcess(t,n,o){process.kill(n,o)}async readClipboardText(t,n){return k.clipboard.readText(n)}async writeClipboardText(t,n,o){return k.clipboard.writeText(n,o)}async readClipboardFindText(t){return k.clipboard.readFindText()}async writeClipboardFindText(t,n){return k.clipboard.writeFindText(n)}async writeClipboardBuffer(t,n,o,u){return k.clipboard.writeBuffer(n,Buffer.from(o),u)}async readClipboardBuffer(t,n){return k.clipboard.readBuffer(n)}async hasClipboard(t,n,o){return k.clipboard.has(n,o)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){k.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){k.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){k.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){k.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){k.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(t,n){const o=this.windowById(t);o&&o.updateTouchBar(n)}async notifyReady(t){const n=this.windowById(t);n&&n.setReady()}async relaunch(t,n){return this.lifecycleMainService.relaunch(n)}async reload(t,n){const o=this.windowById(t);if(o)return this.lifecycleMainService.reload(o,(n==null?void 0:n.disableExtensions)!==void 0?{_:[],"disable-extensions":n==null?void 0:n.disableExtensions}:void 0)}async closeWindow(t){this.closeWindowById(t,t)}async closeWindowById(t,n){const o=this.windowById(n);if(o==null?void 0:o.win)return o.win.close()}async quit(t){const n=this.windowsMainService.getLastActiveWindow();(n==null?void 0:n.isExtensionDevelopmentHost)&&this.windowsMainService.getWindowCount()>1&&n.win?n.win.close():setTimeout(()=>{this.lifecycleMainService.quit()},10)}async exit(t,n){await this.lifecycleMainService.kill(n)}async resolveProxy(t,n){var o,u;const h=this.windowById(t),f=(u=(o=h==null?void 0:h.win)===null||o===void 0?void 0:o.webContents)===null||u===void 0?void 0:u.session;if(f)return f.resolveProxy(n)}async openDevTools(t,n){const o=this.windowById(t);(o==null?void 0:o.win)&&o.win.webContents.openDevTools(n)}async toggleDevTools(t){const n=this.windowById(t);(n==null?void 0:n.win)&&n.win.webContents.toggleDevTools()}async sendInputEvent(t,n){const o=this.windowById(t);(o==null?void 0:o.win)&&(n.type==="mouseDown"||n.type==="mouseUp")&&o.win.webContents.sendInputEvent(n)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(t,n,o,u){if(!!P.isWindows){const h=await new Promise((f,E)=>{q(["vscode-windows-registry"],f,E)});try{return h.GetStringRegKey(n,o,u)}catch(f){return}}}async getPassword(t,n,o){const u=await this.withKeytar(),h=await u.getPassword(n,o);if(h)try{let{content:f,hasNextChunk:E}=JSON.parse(h);if(!f||!E)return h;let A=1;for(;E;){const _=await u.getPassword(n,`${o}-${A}`),U=JSON.parse(_);f+=U.content,E=U.hasNextChunk}return f}catch(f){return h}return h}async setPassword(t,n,o,u){const h=await this.withKeytar();if(P.isWindows&&u.length>rt.MAX_PASSWORD_LENGTH){let f=0,E=0,A=!0;for(;A;){const _=u.substring(f,f+rt.PASSWORD_CHUNK_SIZE);f+=rt.PASSWORD_CHUNK_SIZE,A=u.length-f>0;const U={content:_,hasNextChunk:A};await h.setPassword(n,E?`${o}-${E}`:o,JSON.stringify(U)),E++}}else await h.setPassword(n,o,u);this._onDidChangePassword.fire({service:n,account:o})}async deletePassword(t,n,o){const h=await(await this.withKeytar()).deletePassword(n,o);return h&&this._onDidChangePassword.fire({service:n,account:o}),h}async findPassword(t,n){return(await this.withKeytar()).findPassword(n)}async findCredentials(t,n){return(await this.withKeytar()).findCredentials(n)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((t,n)=>{q(["keytar"],t,n)})}windowById(t){if(typeof t=="number")return this.windowsMainService.getWindowById(t)}};l.MAX_PASSWORD_LENGTH=2500,l.PASSWORD_CHUNK_SIZE=l.MAX_PASSWORD_LENGTH-100,ce([a.memoize],l.prototype,"cliPath",null),l=ce([ee(1,L.IWindowsMainService),ee(2,p.IDialogMainService),ee(3,y.ILifecycleMainService),ee(4,r.IEnvironmentMainService),ee(5,g.ITelemetryService),ee(6,w.ILogService),ee(7,b.IProductService)],l),e.NativeHostMainService=l}),define(X[213],J([0,1,2,5,80,13,6,34,41,89,28,20,25]),function(q,e,m,L,k,y,P,r,p,i,D,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var v;(function(w){w[w.Initial=1]="Initial",w[w.StoredCredentialsUsed=2]="StoredCredentialsUsed",w[w.LoginDialogShown=3]="LoginDialogShown"})(v||(v={}));let d=class extends m.Disposable{constructor(I,b,a,c,l){super();this.logService=I,this.windowsMainService=b,this.nativeHostMainService=a,this.encryptionMainService=c,this.productService=l,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=v.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const I=L.Event.fromNodeEventEmitter(y.app,"login",(b,a,c,l,s)=>({event:b,webContents:a,req:c,authInfo:l,callback:s}));this._register(I(this.onLogin,this))}async onLogin({event:I,authInfo:b,req:a,callback:c}){if(!!b.isProxy){if(!this.pendingProxyResolve&&this.state===v.LoginDialogShown&&a.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}I.preventDefault();let l;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),l=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(b);try{l=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}c(l==null?void 0:l.username,l==null?void 0:l.password)}}async resolveProxyCredentials(I){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const b=await this.doResolveProxyCredentials(I);if(b)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),b;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(I){var b,a,c,l;this.logService.trace("auth#doResolveProxyCredentials - enter",I);const s=String((0,k.hash)({scheme:I.scheme,host:I.host,port:I.port}));let t,n;try{const f=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,s);if(f){const E=JSON.parse(await this.encryptionMainService.decrypt(f));t=E.username,n=E.password}}catch(f){this.logService.error(f)}if(this.state!==v.StoredCredentialsUsed&&typeof t=="string"&&typeof n=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=v.StoredCredentialsUsed,{username:t,password:n};const o=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!o){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${o.id} to handle proxy login`);const u={authInfo:I,username:(a=(b=this.sessionCredentials)===null||b===void 0?void 0:b.username)!==null&&a!==void 0?a:t,password:(l=(c=this.sessionCredentials)===null||c===void 0?void 0:c.password)!==null&&l!==void 0?l:n,replyChannel:`vscode:proxyAuthResponse:${(0,D.generateUuid)()}`};o.sendWhenReady("vscode:openProxyAuthenticationDialog",S.CancellationToken.None,u),this.state=v.LoginDialogShown;const h=await new Promise(f=>{var E;const A=async(_,U,H)=>{var Q;if(U===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${o.id}`),(Q=o.win)===null||Q===void 0||Q.webContents.off("ipc-message",A),H){const ne={username:H.username,password:H.password};try{if(H.remember){const ae=await this.encryptionMainService.encrypt(JSON.stringify(ne));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,s,ae)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,s)}catch(ae){this.logService.error(ae)}f({username:ne.username,password:ne.password})}else f(void 0)};(E=o.win)===null||E===void 0||E.webContents.on("ipc-message",A)});return this.sessionCredentials=h,h}};d=ce([ee(0,P.ILogService),ee(1,r.IWindowsMainService),ee(2,p.INativeHostMainService),ee(3,i.IEncryptionMainService),ee(4,g.IProductService)],d),e.ProxyAuthHandler=d}),define(X[214],J([0,1,211,34,56,2,33,57,170,3,5,79,103,9,16,41]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function I(c){return c<21}let b=class{constructor(l,s,t,n,o){this.windowServer=l,this.options=s,this.windowsMainService=t,this.lifecycleMainService=n,this.nativeHostMainService=o,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new D.Emitter}async registerWindowDriver(l){return this.registeredWindowIds.add(l),this.reloadingWindowIds.delete(l),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(l){this.reloadingWindowIds.add(l)}async getWindowIds(){return this.windowsMainService.getWindows().map(l=>l.id).filter(l=>this.registeredWindowIds.has(l)&&!this.reloadingWindowIds.has(l))}async capturePage(l){await this.whenUnfrozen(l);const s=this.windowsMainService.getWindowById(l);if(!(s==null?void 0:s.win))throw new Error("Invalid window");return(await s.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(l){await this.whenUnfrozen(l);const s=this.windowsMainService.getWindowById(l);if(!s)throw new Error("Invalid window");this.reloadingWindowIds.add(l),this.lifecycleMainService.reload(s)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(l,s){await this.whenUnfrozen(l);const t=S.KeybindingParser.parseUserBinding(s);for(let n of t)await this._dispatchKeybinding(l,n)}async _dispatchKeybinding(l,s){if(s instanceof g.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const t=this.windowsMainService.getWindowById(l);if(!(t==null?void 0:t.win))throw new Error("Invalid window");const n=t.win.webContents,o=new r.SimpleKeybinding(!1,!1,!1,!1,s.keyCode),h=new p.USLayoutResolvedKeybinding(o.toChord(),i.OS).getElectronAccelerator(),f=[];s.ctrlKey&&f.push("ctrl"),s.metaKey&&f.push("meta"),s.shiftKey&&f.push("shift"),s.altKey&&f.push("alt"),n.sendInputEvent({type:"keyDown",keyCode:h,modifiers:f}),I(s.keyCode)||n.sendInputEvent({type:"char",keyCode:h,modifiers:f}),n.sendInputEvent({type:"keyUp",keyCode:h,modifiers:f}),await(0,v.timeout)(100)}async click(l,s,t,n){await(await this.getWindowDriver(l)).click(s,t,n)}async doubleClick(l,s){await(await this.getWindowDriver(l)).doubleClick(s)}async setValue(l,s,t){await(await this.getWindowDriver(l)).setValue(s,t)}async getTitle(l){return await(await this.getWindowDriver(l)).getTitle()}async isActiveElement(l,s){return await(await this.getWindowDriver(l)).isActiveElement(s)}async getElements(l,s,t){return await(await this.getWindowDriver(l)).getElements(s,t)}async getElementXY(l,s,t,n){return await(await this.getWindowDriver(l)).getElementXY(s,t,n)}async typeInEditor(l,s,t){await(await this.getWindowDriver(l)).typeInEditor(s,t)}async getTerminalBuffer(l,s){return await(await this.getWindowDriver(l)).getTerminalBuffer(s)}async writeInTerminal(l,s,t){await(await this.getWindowDriver(l)).writeInTerminal(s,t)}async getWindowDriver(l){await this.whenUnfrozen(l);const s=`window:${l}`,t=new P.StaticRouter(o=>o===s),n=this.windowServer.getChannel("windowDriver",t);return new m.WindowDriverChannelClient(n)}async whenUnfrozen(l){for(;this.reloadingWindowIds.has(l);)await D.Event.toPromise(this.onDidReloadingChange.event)}};b=ce([ee(2,L.IWindowsMainService),ee(3,d.ILifecycleMainService),ee(4,w.INativeHostMainService)],b),e.Driver=b;async function a(c,l,s,t){const n=s.driverVerbose,o=t.createInstance(b,c,{verbose:n}),u=new m.WindowDriverRegistryChannel(o);c.registerChannel("windowDriverRegistry",u);const h=await(0,k.serve)(l),f=new m.DriverChannel(o);return h.registerChannel("driver",f),(0,y.combinedDisposable)(h,c)}e.serve=a}),define(X[215],J([0,1,59,56]),function(q,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,y,P,r){const p=D=>r(D,void 0),i=m.createConnection({host:k,port:y},()=>{i.removeListener("error",p);const D=Buffer.alloc(16);for(let d=0;d<16;d++)D[d]=Math.round(Math.random()*256);const g=D.toString("base64");let S=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${y}/?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];i.write(S.join(`\r
`)+`\r
\r
`);const v=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(i.off("data",v),r(void 0,new L.NodeSocket(i)))};i.on("data",v)});i.once("error",p)}}}),define(X[216],J([0,1,59,9,2,113,6,20,184,73,215,74]),function(q,e,m,L,k,y,P,r,p,i,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function S(I,b,a,c){return new v(I,b,a,c).waitForReady()}class v extends k.Disposable{constructor(b,a,c,l){super();this.suggestedLocalPort=l,this.public=!1,this._socketsDispose=new Map,this._options=b,this._server=m.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(a=>{a()})}async waitForReady(){var b;let a=await(0,y.findFreePortFaster)((b=this.suggestedLocalPort)!==null&&b!==void 0?b:this.tunnelRemotePort,2,1e3),c=null;return c=this._server.listen(a).address(),c||(a=0,c=this._server.listen(a).address()),this.tunnelLocalPort=c.port,await this._barrier.wait(),this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(b){b.pause();const a=await(0,p.connectRemoteAgentTunnel)(this._options,this.tunnelRemotePort),c=a.getSocket().socket,l=a.readEntireBuffer();a.dispose(),l.byteLength>0&&b.write(l.buffer),b.on("end",()=>{this._socketsDispose.delete(b.localAddress),c.end()}),b.on("close",()=>c.end()),b.on("error",()=>{this._socketsDispose.delete(b.localAddress),c.destroy()}),c.on("end",()=>b.end()),c.on("close",()=>b.end()),c.on("error",()=>{b.destroy()}),b.pipe(c),c.pipe(b),this._socketsDispose.set(b.localAddress,()=>{b.end(),c.end()})}}let d=class extends i.AbstractTunnelService{constructor(b,a,c,l){super(a);this.socketFactory=b,this.signService=c,this.productService=l}retainOrCreateTunnel(b,a,c,l,s,t){const n=this.getTunnelFromMap(a,c);if(n)return++n.refcount,n.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,a,c,l,s,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${c} on local port ${l}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:b,signService:this.signService,logService:this.logService,ipcLogger:null},u=S(o,a,c,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(a,c,u),u}}};d=ce([ee(1,P.ILogService),ee(2,g.ISignService),ee(3,r.IProductService)],d),e.BaseTunnelService=d;let w=class extends d{constructor(b,a,c){super(D.nodeSocketFactory,b,a,c)}};w=ce([ee(0,P.ILogService),ee(1,g.ISignService),ee(2,r.IProductService)],w),e.TunnelService=w}),define(X[217],J([0,1,210,186,2,12,17,185,21,6,23,46,69]),function(q,e,m,L,k,y,P,r,p,i,D,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let v=class extends k.Disposable{constructor(w,I,b){super();this.environmentService=I,this.logService=b,this.configure(w.getValue()),this._register(w.onDidChangeConfiguration(()=>this.configure(w.getValue()),this))}configure(w){this.proxyUrl=w.http&&w.http.proxy,this.strictSSL=!!(w.http&&w.http.proxyStrictSSL),this.authorization=w.http&&w.http.proxyAuthorization}async request(w,I){this.logService.trace("RequestService#request",w.url);const{proxyUrl:b,strictSSL:a}=this,c=Object.assign(Object.assign({},process.env),await(0,S.resolveShellEnv)(this.logService,this.environmentService.args,process.env)),l=w.agent?w.agent:await(0,r.getProxyAgent)(w.url||"",c,{proxyUrl:b,strictSSL:a});return w.agent=l,w.strictSSL=a,this.authorization&&(w.headers=Object.assign(Object.assign({},w.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(w,I)}async getNodeRequest(w){return((0,L.parse)(w.url).protocol==="https:"?await new Promise((a,c)=>{q(["https"],a,c)}):await new Promise((a,c)=>{q(["http"],a,c)})).request}_request(w,I){return new Promise(async(b,a)=>{let c;const l=(0,L.parse)(w.url),s=w.getRawRequest?w.getRawRequest(w):await this.getNodeRequest(w),t={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:w.type||"GET",headers:w.headers,agent:w.agent,rejectUnauthorized:(0,y.isBoolean)(w.strictSSL)?w.strictSSL:!0};w.user&&w.password&&(t.auth=w.user+":"+w.password),c=s(t,n=>{const o=(0,y.isNumber)(w.followRedirects)?w.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&o>0&&n.headers.location)this._request(Object.assign(Object.assign({},w),{url:n.headers.location,followRedirects:o-1}),I).then(b,a);else{let u=n;n.headers["content-encoding"]==="gzip"&&(u=n.pipe((0,m.createGunzip)())),b({res:n,stream:(0,D.streamToBufferReadableStream)(u)})}}),c.on("error",a),w.timeout&&c.setTimeout(w.timeout),w.data&&typeof w.data=="string"&&c.write(w.data),c.end(),I.onCancellationRequested(()=>{c.abort(),a((0,P.canceled)())})})}async resolveProxy(w){}};v=ce([ee(0,p.IConfigurationService),ee(1,g.INativeEnvironmentService),ee(2,i.ILogService)],v),e.RequestService=v}),define(X[218],J([0,1,217,13]),function(q,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(P){return L.net.request}class y extends m.RequestService{request(r,p){return super.request(Object.assign(Object.assign({},r||{}),{getRawRequest:k}),p)}}e.RequestMainService=y}),define(X[219],J([0,1,54,13,26,9,6,16,75,10,3,2,84,12,5,69,55]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v,d,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let b=class extends g.Disposable{constructor(c,l,s,t,n,o,u){super();this.machineId=c,this.userEnv=l,this.environmentMainService=s,this.lifecycleMainService=t,this.logService=n,this.themeMainService=o,this.protocolMainService=u,this.firstWindowConnectionBarrier=new y.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new d.Emitter),this.onDidError=d.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),L.ipcMain.on("vscode:createSharedProcessMessageChannel",async(c,l)=>this.onWindowConnection(c,l))}async onWindowConnection(c,l){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const s=await this.connect();if(c.sender.isDestroyed())return s.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",l,[s])}onWillShutdown(){const c=this.window;!c||(!c.isDestroyed()&&!c.webContents.isDestroyed()&&c.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(c.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{c.close()}catch(l){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(c=>L.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),c()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.userEnv=Object.assign(Object.assign({},this.userEnv),await(0,w.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env)),this.createWindow(),this.registerWindowListeners(),await new Promise(c=>L.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),c()}))})()),this._whenIpcReady}createWindow(){const c=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new L.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:i.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`],v8CacheOptions:D.browserCodeLoadingCacheStrategy,nodeIntegration:!0,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),c.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:m.default}),this.window.loadURL(i.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",q).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=c=>{var l;this.logService.trace("SharedProcess#close prevented"),c.preventDefault(),((l=this.window)===null||l===void 0?void 0:l.isVisible())&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(c,l)=>this._onDidError.fire({type:2,details:l})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1,details:"SharedProcess: detected unresponsive window"})),this.window.webContents.on("did-fail-load",(c,l,s)=>this._onDidError.fire({type:3,details:`SharedProcess: failed to load: ${s}`})))}async connect(){await this.whenIpcReady;const c=(0,v.assertIsDefined)(this.window);return(0,S.connect)(c)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){var c,l;return(l=(c=this.window)===null||c===void 0?void 0:c.isVisible())!==null&&l!==void 0?l:!1}};b=ce([ee(2,k.IEnvironmentMainService),ee(3,r.ILifecycleMainService),ee(4,P.ILogService),ee(5,p.IThemeMainService),ee(6,I.IProtocolMainService)],b),e.SharedProcess=b}),define(X[77],J([0,1,5,9,21,16,20,40,26,6,48,25]),function(q,e,m,L,k,y,P,r,p,i,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function S(d,w,I){return`${I.updateUrl}/api/update/${d}/${w}/${I.commit}`}e.createUpdateURL=S;let v=class{constructor(w,I,b,a,c,l){this.lifecycleMainService=w,this.configurationService=I,this.environmentMainService=b,this.requestService=a,this.logService=c,this.productService=l,this._state=r.State.Uninitialized,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(w){this.logService.info("update#setState",w.type),this._state=w,this._onStateChange.fire(w)}initialize(){if(!!this.environmentMainService.isBuilt){if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const w=(0,k.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),I=this.getProductQuality(w);if(!I){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(I),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(r.State.Idle(this.getUpdateType())),w==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(null),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,b=>this.logService.error(b))}}getProductQuality(w){return w==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(w=60*60*1e3){return(0,L.timeout)(w).then(()=>this.checkForUpdates(null)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(w){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(w)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(w){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(w=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},g.CancellationToken.None).then(w=>w.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};v=ce([ee(0,y.ILifecycleMainService),ee(1,k.IConfigurationService),ee(2,p.IEnvironmentMainService),ee(3,D.IRequestService),ee(4,i.ILogService),ee(5,P.IProductService)],v),e.AbstractUpdateService=v}),define(X[220],J([0,1,13,2,5,52,21,16,40,31,26,6,77,48,20]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let w=class extends S.AbstractUpdateService{constructor(b,a,c,l,s,t,n){super(b,a,l,s,t,n);this.telemetryService=c,this.disposables=new L.DisposableStore}get onRawError(){return k.Event.fromNodeEventEmitter(m.autoUpdater,"error",(b,a)=>a)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(m.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(m.autoUpdater,"update-available",(b,a,c)=>({url:a,version:c,productVersion:c}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(m.autoUpdater,"update-downloaded",(b,a,c,l)=>({releaseNotes:a,version:c,productVersion:c,date:l}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(b){this.logService.error("UpdateService error:",b);const c=(this.state.type==="checking for updates"?!!this.state.context:!0)?b:void 0;this.setState(p.State.Idle(1,c))}buildUpdateFeedUrl(b){let a;this.productService.darwinUniversalAssetId?a=this.productService.darwinUniversalAssetId:a=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,S.createUpdateURL)(a,b,this.productService);try{m.autoUpdater.setFeedURL({url:c})}catch(l){this.logService.error("Failed to set update feed URL",l);return}return c}doCheckForUpdates(b){this.setState(p.State.CheckingForUpdates(b)),m.autoUpdater.checkForUpdates()}onUpdateAvailable(b){this.state.type==="checking for updates"&&this.setState(p.State.Downloading(b))}onUpdateDownloaded(b){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:b.version}),this.setState(p.State.Ready(b)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!this.state.context}),this.setState(p.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),m.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ce([y.memoize],w.prototype,"onRawError",null),ce([y.memoize],w.prototype,"onRawUpdateNotAvailable",null),ce([y.memoize],w.prototype,"onRawUpdateAvailable",null),ce([y.memoize],w.prototype,"onRawUpdateDownloaded",null),w=ce([ee(0,r.ILifecycleMainService),ee(1,P.IConfigurationService),ee(2,i.ITelemetryService),ee(3,D.IEnvironmentMainService),ee(4,v.IRequestService),ee(5,g.ILogService),ee(6,d.IProductService)],w),e.DarwinUpdateService=w}),define(X[221],J([0,1,20,21,16,40,31,26,6,77,48,25,41]),function(q,e,m,L,k,y,P,r,p,i,D,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let v=class extends i.AbstractUpdateService{constructor(w,I,b,a,c,l,s,t){super(w,I,a,c,l,t);this.telemetryService=b,this.nativeHostMainService=s}buildUpdateFeedUrl(w){return(0,i.createUpdateURL)(`linux-${process.arch}`,w,this.productService)}doCheckForUpdates(w){!this.url||(this.setState(y.State.CheckingForUpdates(w)),this.requestService.request({url:this.url},g.CancellationToken.None).then(D.asJson).then(I=>{!I||!I.url||!I.version||!I.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(y.State.Idle(1))):this.setState(y.State.AvailableForDownload(I))}).then(void 0,I=>{this.logService.error(I),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w});const b=w?I.message||I:void 0;this.setState(y.State.Idle(1,b))}))}async doDownloadUpdate(w){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):w.update.url&&this.nativeHostMainService.openExternal(void 0,w.update.url),this.setState(y.State.Idle(1))}};v=ce([ee(0,k.ILifecycleMainService),ee(1,L.IConfigurationService),ee(2,P.ITelemetryService),ee(3,r.IEnvironmentMainService),ee(4,D.IRequestService),ee(5,p.ILogService),ee(6,S.INativeHostMainService),ee(7,m.IProductService)],v),e.LinuxUpdateService=v}),define(X[222],J([0,1,5,9,16,40,26,6,8,18,45,31]),function(q,e,m,L,k,y,P,r,p,i,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let S=class{constructor(w,I,b){if(this.lifecycleMainService=w,this.logService=b,this._state=y.State.Uninitialized,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,I.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(y.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,a=>this.logService.error(a))}get state(){return this._state}setState(w){this.logService.info("update#setState",w.type),this._state=w,this._onStateChange.fire(w)}scheduleCheckForUpdates(w=60*60*1e3){return(0,L.timeout)(w).then(()=>this.checkForUpdates(null)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(w){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(w)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(w){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(w=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};S=ce([ee(0,k.ILifecycleMainService),ee(1,P.IEnvironmentMainService),ee(2,r.ILogService)],S);let v=class extends S{constructor(w,I,b,a,c,l){super(b,a,c);this.snap=w,this.snapRevision=I,this.telemetryService=l;const s=(0,i.watch)(p.dirname(this.snap)),t=m.Event.fromNodeEventEmitter(s,"change",(h,f)=>f),n=m.Event.filter(t,h=>h==="current"),u=m.Event.debounce(n,(h,f)=>f,2e3)(this.checkForUpdates,this);b.onWillShutdown(()=>{u.dispose(),s.close()})}doCheckForUpdates(w){this.setState(y.State.CheckingForUpdates(w)),this.isUpdateAvailable().then(I=>{I?this.setState(y.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(y.State.Idle(2)))},I=>{this.logService.error(I),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(y.State.Idle(2,I.message||I))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,D.spawn)("sleep 3 && "+p.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const w=await new Promise((b,a)=>(0,i.realpath)(`${p.dirname(this.snap)}/current`,(c,l)=>c?a(c):b(l))),I=p.basename(w);return this.snapRevision!==I}isLatestVersion(){return this.isUpdateAvailable().then(void 0,w=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};v=ce([ee(2,k.ILifecycleMainService),ee(3,P.IEnvironmentMainService),ee(4,r.ILogService),ee(5,g.ITelemetryService)],v),e.SnapUpdateService=v}),define(X[223],J([0,1,18,8,19,52,21,16,20,40,31,26,6,77,48,109,27,45,25,9,24,7,41]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v,d,w,I,b,a,c,l,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function n(f,E=1e3){for(;!f();)await(0,c.timeout)(E)}let o;function u(){return typeof o=="undefined"&&(o=m.existsSync(L.join(L.dirname(process.execPath),"unins000.exe"))?0:1),o}let h=class extends v.AbstractUpdateService{constructor(E,A,_,U,H,Q,ne,ae,O){super(E,A,U,H,Q,O);this.telemetryService=_,this.fileService=ne,this.nativeHostMainService=ae}get cachePath(){const E=L.join((0,I.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return m.promises.mkdir(E,{recursive:!0}).then(()=>E)}initialize(){super.initialize(),u()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(E){let A="win32";return process.arch!=="ia32"&&(A+=`-${process.arch}`),u()===1?A+="-archive":this.productService.target==="user"&&(A+="-user"),(0,v.createUpdateURL)(A,E,this.productService)}doCheckForUpdates(E){!this.url||(this.setState(i.State.CheckingForUpdates(E)),this.requestService.request({url:this.url},a.CancellationToken.None).then(d.asJson).then(A=>{const _=u();return!A||!A.url||!A.version||!A.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!E}),this.setState(i.State.Idle(_)),Promise.resolve(null)):_===1?(this.setState(i.State.AvailableForDownload(A)),Promise.resolve(null)):(this.setState(i.State.Downloading(A)),this.cleanup(A.version).then(()=>this.getUpdatePackagePath(A.version).then(U=>k.exists(U).then(H=>{if(H)return Promise.resolve(U);const Q=A.url,ne=A.hash,ae=`${U}.tmp`;return this.requestService.request({url:Q},a.CancellationToken.None).then(O=>this.fileService.writeFile(s.URI.file(ae),O.stream)).then(ne?()=>(0,w.checksum)(ae,A.hash):()=>{}).then(()=>m.promises.rename(ae,U)).then(()=>U)})).then(U=>{const H=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:U},H&&A.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(i.State.Downloaded(A)):this.setState(i.State.Ready(A))})))}).then(void 0,A=>{this.logService.error(A),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!E});const _=E?A.message||A:void 0;this.setState(i.State.Idle(u(),_))}))}async doDownloadUpdate(E){E.update.url&&this.nativeHostMainService.openExternal(void 0,E.update.url),this.setState(i.State.Idle(u()))}async getUpdatePackagePath(E){const A=await this.cachePath;return L.join(A,`CodeSetup-${this.productService.quality}-${E}.exe`)}async cleanup(E=null){const A=E?Q=>!new RegExp(`${this.productService.quality}-${E}\\.exe$`).test(Q):()=>!0,_=await this.cachePath,H=(await k.readdir(_)).filter(A).map(async Q=>{try{await m.promises.unlink(L.join(_,Q))}catch(ne){}});await Promise.all(H)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const E=this.state.update;this.setState(i.State.Updating(E));const A=await this.cachePath;this.availableUpdate.updateFilePath=L.join(A,`CodeSetup-${this.productService.quality}-${E.version}.flag`),await k.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,b.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(i.State.Idle(u()))});const U=`${this.productService.win32MutexName}-ready`,H=await new Promise((Q,ne)=>{q(["windows-mutex"],Q,ne)});n(()=>H.isActive(U)).then(()=>this.setState(i.State.Ready(E)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?m.unlinkSync(this.availableUpdate.updateFilePath):(0,b.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return u()}};ce([y.memoize],h.prototype,"cachePath",null),h=ce([ee(0,r.ILifecycleMainService),ee(1,P.IConfigurationService),ee(2,D.ITelemetryService),ee(3,g.IEnvironmentMainService),ee(4,d.IRequestService),ee(5,S.ILogService),ee(6,l.IFileService),ee(7,t.INativeHostMainService),ee(8,p.IProductService)],h),e.Win32UpdateService=h}),define(X[51],J([0,1,29,26,8,19,18,3,5,6,58,43,10,2,15,4,149,20,13,12,49,50,98]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v,d,w,I,b,a,c,l,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,w.createDecorator)("workspacesManagementMainService");let n=class extends v.Disposable{constructor(f,E,A,_,U){super();this.environmentMainService=f,this.logService=E,this.backupMainService=A,this.dialogMainService=_,this.productService=U,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new p.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new p.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(f){if(!this.isWorkspacePath(f)||f.scheme!==S.Schemas.file)return null;let E;try{E=(0,P.readFileSync)(f.fsPath,"utf8")}catch(A){return null}return this.doResolveWorkspace(f,E)}isWorkspacePath(f){return(0,m.isUntitledWorkspace)(f,this.environmentMainService)||(0,m.hasWorkspaceFileExtension)(f)}doResolveWorkspace(f,E){try{const A=this.doParseStoredWorkspace(f,E),_=o(f);return{id:_.id,configPath:_.configPath,folders:(0,m.toWorkspaceFolders)(A.folders,_.configPath,d.extUriBiasedIgnorePathCase),remoteAuthority:A.remoteAuthority}}catch(A){this.logService.warn(A.toString())}return null}doParseStoredWorkspace(f,E){const A=(0,g.parse)(E);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(_=>(0,m.isStoredWorkspaceFolder)(_));else throw new Error(`${f.toString(!0)} looks like an invalid workspace file.`);return A}async createUntitledWorkspace(f,E){const{workspace:A,storedWorkspace:_}=this.newUntitledWorkspace(f,E),U=A.configPath.fsPath;return await P.promises.mkdir((0,k.dirname)(U),{recursive:!0}),await(0,y.writeFile)(U,JSON.stringify(_,null,"	")),A}createUntitledWorkspaceSync(f,E){const{workspace:A,storedWorkspace:_}=this.newUntitledWorkspace(f,E),U=A.configPath.fsPath;return(0,P.mkdirSync)((0,k.dirname)(U),{recursive:!0}),(0,y.writeFileSync)(U,JSON.stringify(_,null,"	")),A}newUntitledWorkspace(f=[],E){const A=(Date.now()+Math.round(Math.random()*1e3)).toString(),_=(0,d.joinPath)(this.untitledWorkspacesHome,A),U=(0,d.joinPath)(_,m.UNTITLED_WORKSPACE_NAME),H=[];for(const Q of f)H.push((0,m.getStoredWorkspaceFolder)(Q.uri,!0,Q.name,_,!r.isWindows,d.extUriBiasedIgnorePathCase));return{workspace:o(U),storedWorkspace:{folders:H,remoteAuthority:E}}}async getWorkspaceIdentifier(f){return o(f)}isUntitledWorkspace(f){return(0,m.isUntitledWorkspace)(f.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(f){!this.isUntitledWorkspace(f)||(this.doDeleteUntitledWorkspaceSync(f),this._onDidDeleteUntitledWorkspace.fire(f))}async deleteUntitledWorkspace(f){this.deleteUntitledWorkspaceSync(f)}doDeleteUntitledWorkspaceSync(f){const E=(0,d.originalFSPath)(f.configPath);try{(0,y.rimrafSync)((0,k.dirname)(E));const A=(0,k.join)(this.environmentMainService.workspaceStorageHome.fsPath,f.id);(0,P.existsSync)(A)&&(0,y.writeFileSync)((0,k.join)(A,"obsolete"),"")}catch(A){this.logService.warn(`Unable to delete untitled workspace ${E} (${A}).`)}}getUntitledWorkspacesSync(){const f=[];try{const E=(0,y.readdirSync)(this.untitledWorkspacesHome.fsPath).map(A=>(0,d.joinPath)(this.untitledWorkspacesHome,A,m.UNTITLED_WORKSPACE_NAME));for(const A of E){const _=o(A),U=this.resolveLocalWorkspaceSync(A);U?f.push({workspace:_,remoteAuthority:U.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(_)}}catch(E){E.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${E}).`)}return f}async enterWorkspace(f,E,A){if(!f||!f.win||!f.isReady||!await this.isValidTargetWorkspacePath(f,E,A))return null;const U=this.doEnterWorkspace(f,o(A));return U?(this._onDidEnterWorkspace.fire({window:f,workspace:U.workspace}),U):null}async isValidTargetWorkspacePath(f,E,A){if(!A)return!0;if((0,m.isWorkspaceIdentifier)(f.openedWorkspace)&&d.extUriBiasedIgnorePathCase.isEqual(f.openedWorkspace.configPath,A))return!1;if((0,t.findWindowOnWorkspaceOrFolder)(E,A)){const _={title:this.productService.nameLong,type:"info",buttons:[(0,I.localize)(0,null)],message:(0,I.localize)(1,null,(0,d.basename)(A)),detail:(0,I.localize)(2,null),noLink:!0};return await this.dialogMainService.showMessageBox(_,(0,c.withNullAsUndefined)(a.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(f,E){if(!f.config)return null;f.focus();let A;return f.config.extensionDevelopmentPath||(A=this.backupMainService.registerWorkspaceBackupSync({workspace:E,remoteAuthority:f.remoteAuthority},f.config.backupPath)),(0,m.isWorkspaceIdentifier)(f.openedWorkspace)&&this.isUntitledWorkspace(f.openedWorkspace)&&this.deleteUntitledWorkspaceSync(f.openedWorkspace),f.config.workspace=E,f.config.backupPath=A,{workspace:E,backupPath:A}}};n=ce([ee(0,L.IEnvironmentMainService),ee(1,i.ILogService),ee(2,l.IBackupMainService),ee(3,s.IDialogMainService),ee(4,b.IProductService)],n),e.WorkspacesManagementMainService=n;function o(h){function f(){let E=h.scheme===S.Schemas.file?(0,d.originalFSPath)(h):h.toString();return r.isLinux||(E=E.toLowerCase()),(0,D.createHash)("md5").update(E).digest("hex")}return{id:f(),configPath:h}}e.getWorkspaceIdentifier=o;function u(h,f){function E(){if(h.scheme!==S.Schemas.file)return(0,D.createHash)("md5").update(h.toString()).digest("hex");if(!f)try{f=(0,P.statSync)(h.fsPath)}catch(U){return}let _;return r.isLinux?_=f.ino:r.isMacintosh?_=f.birthtime.getTime():r.isWindows&&(typeof f.birthtimeMs=="number"?_=Math.floor(f.birthtimeMs):_=f.birthtime.getTime()),(0,D.createHash)("md5").update(h.fsPath).update(_?String(_):"").digest("hex")}const A=E();if(typeof A=="string")return{id:A,uri:h}}e.getSingleFolderWorkspaceIdentifier=u}),define(X[99],J([0,1,6,96,3,4,34,19,51,21,7,13,35,53,25,29,12]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v,d,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,y.createDecorator)(e.ID);let b=class{constructor(c,l,s,t,n){this.logService=c,this.windowsMainService=l,this.urlService=s,this.workspacesManagementMainService=t,this.configurationService=n}async start(c,l){this.logService.trace("Received data from other instance: ",c,l),k.isMacintosh&&g.app.focus({steal:!0});const s=this.parseOpenUrl(c);if(s.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:n,url:o}of s)this.urlService.open(n,{originalUrl:o})})}else return this.startOpenWindow(c,l)}parseOpenUrl(c){return c["open-url"]&&c._urls&&c._urls.length>0?(0,S.coalesce)(c._urls.map(l=>{try{return{uri:D.URI.parse(l),url:l}}catch(s){return null}})):[]}async startOpenWindow(c,l){const s=(0,v.isLaunchedFromCli)(l)?0:4;let t=[];const n=c.wait&&c.waitMarkerFilePath?D.URI.file(c.waitMarkerFilePath):void 0,o=c.remote||void 0;if(c.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(c.extensionDevelopmentPath,{context:s,cli:c,userEnv:l,waitMarkerFileURI:n,remoteAuthority:o});else if(!c._.length&&!c["folder-uri"]&&!c["file-uri"]){let u=!1;if(c["new-window"]||c["unity-launch"])u=!0;else if(c["reuse-window"])u=!1;else{const h=this.configurationService.getValue("window");switch((h==null?void 0:h.openWithoutArgumentsInNewWindow)||"default"){case"on":u=!0;break;case"off":u=!1;break;default:u=!k.isMacintosh}}if(u)t=this.windowsMainService.open({context:s,cli:c,userEnv:l,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:n,remoteAuthority:o});else{const h=this.windowsMainService.getLastActiveWindow();h?(h.focus(),t=[h]):t=this.windowsMainService.open({context:s,cli:c,forceEmpty:!0,remoteAuthority:o})}}else t=this.windowsMainService.open({context:s,cli:c,userEnv:l,forceNewWindow:c["new-window"],preferNewWindow:!c["reuse-window"]&&!c.wait,forceReuseWindow:c["reuse-window"],diffMode:c.diff,addMode:c.add,noRecentEntry:!!c["skip-add-to-recently-opened"],waitMarkerFileURI:n,gotoLineMode:c.goto,remoteAuthority:o});if(n&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,(0,r.whenDeleted)(n.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const c=[];return g.BrowserWindow.getAllWindows().forEach(l=>{const s=this.windowsMainService.getWindowById(l.id);s?c.push(this.codeWindowToInfo(s)):c.push(this.browserWindowToInfo(l))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:c,screenReader:!!g.app.accessibilitySupportEnabled,gpuFeatureStatus:g.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(c){const l=this.windowsMainService.getWindows();return(await Promise.all(l.map(t=>new Promise(n=>{const o=t.remoteAuthority;if(o){const u=`vscode:getDiagnosticInfoResponse${t.id}`,h={includeProcesses:c.includeProcesses,folders:c.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",d.CancellationToken.None,{replyChannel:u,args:h}),g.ipcMain.once(u,(f,E)=>{E||n({hostName:o,errorMessage:`Unable to resolve connection to '${o}'.`}),n(E)}),setTimeout(()=>{n({hostName:o,errorMessage:`Fetching remote diagnostics for '${o}' timed out.`})},5e3)}else n(void 0)})))).filter(t=>!!t)}getFolderURIs(c){const l=[],s=c.openedWorkspace;if((0,w.isSingleFolderWorkspaceIdentifier)(s))l.push(s.uri);else if((0,w.isWorkspaceIdentifier)(s)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(s.configPath);t&&t.folders.forEach(o=>{l.push(o.uri)})}return l}codeWindowToInfo(c){const l=this.getFolderURIs(c),s=(0,I.assertIsDefined)(c.win);return this.browserWindowToInfo(s,l,c.remoteAuthority)}browserWindowToInfo(c,l=[],s){return{pid:c.webContents.getOSProcessId(),title:c.getTitle(),folderURIs:l,remoteAuthority:s}}};b=ce([ee(0,m.ILogService),ee(1,P.IWindowsMainService),ee(2,L.IURLService),ee(3,p.IWorkspacesManagementMainService),ee(4,i.IConfigurationService)],b),e.LaunchMainService=b}),define(X[224],J([0,1,140,27,54,13,99,68,26,3,6,82,50,4,60,10,41,55,2]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v,d,w,I,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,v.createDecorator)("issueMainService");let c=class wt{constructor(s,t,n,o,u,h,f,E){this.userEnv=s,this.environmentMainService=t,this.launchMainService=n,this.logService=o,this.diagnosticsService=u,this.dialogMainService=h,this.nativeHostMainService=f,this.protocolMainService=E,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){y.ipcMain.on("vscode:issueSystemInfoRequest",async s=>{const[t,n]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),o=await this.diagnosticsService.getSystemInfo(t,n);this.safeSend(s,"vscode:issueSystemInfoResponse",o)}),y.ipcMain.on("vscode:listProcesses",async s=>{const t=[];try{const n=await this.launchMainService.getMainProcessId();t.push({name:(0,m.localize)(0,null),rootProcess:await(0,g.listProcesses)(n)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(u=>{(0,r.isRemoteDiagnosticError)(u)?t.push({name:u.hostName,rootProcess:u}):u.processes&&t.push({name:u.hostName,rootProcess:u.processes})})}catch(n){this.logService.error(`Listing processes failed: ${n}`)}this.safeSend(s,"vscode:listProcessesResponse",t)}),y.ipcMain.on("vscode:issueReporterClipboard",async s=>{const t={message:(0,m.localize)(1,null),type:"warning",buttons:[(0,m.localize)(2,null),(0,m.localize)(3,null)]};if(this.issueReporterWindow){const n=await this.dialogMainService.showMessageBox(t,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",n.response===0)}}),y.ipcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const t=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",t)}),y.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={message:(0,m.localize)(4,null),type:"warning",buttons:[(0,m.localize)(5,null),(0,m.localize)(6,null)]};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),y.ipcMain.on("vscode:workbenchCommand",(s,t)=>{const{id:n,from:o,args:u}=t;let h;switch(o){case"issueReporter":h=this.issueReporterParentWindow;break;case"processExplorer":h=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${o}`)}h&&h.webContents.send("vscode:runAction",{id:n,from:o,args:u})}),y.ipcMain.on("vscode:openExternal",(s,t)=>{this.nativeHostMainService.openExternal(void 0,t)}),y.ipcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),y.ipcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),y.ipcMain.on("vscode:windowsInfoRequest",async s=>{const t=await this.launchMainService.getMainProcessInfo();this.safeSend(s,"vscode:windowsInfoResponse",t.windows)})}safeSend(s,t,...n){s.sender.isDestroyed()||s.sender.send(t,...n)}async openReporter(s){var t;if(!this.issueReporterWindow&&(this.issueReporterParentWindow=y.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const n=new a.DisposableStore,o=n.add(this.protocolMainService.createIPCObjectUrl()),u=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(u,o,s.styles.backgroundColor,(0,m.localize)(7,null),s.zoomLevel),o.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:k.default}),this.issueReporterWindow.loadURL(w.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",q,!0).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,n.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,n.dispose())})}(t=this.issueReporterWindow)===null||t===void 0||t.focus()}async openProcessExplorer(s){var t;if(!this.processExplorerWindow&&(this.processExplorerParentWindow=y.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const n=new a.DisposableStore,o=n.add(this.protocolMainService.createIPCObjectUrl()),u=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(u,o,s.styles.backgroundColor,(0,m.localize)(8,null),s.zoomLevel),o.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:k.default}),this.processExplorerWindow.loadURL(w.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",q,!0).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,n.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,n.dispose())})}(t=this.processExplorerWindow)===null||t===void 0||t.focus()}createBrowserWindow(s,t,n,o,u){const h=new y.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:o,backgroundColor:n||wt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:w.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`],v8CacheOptions:i.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,d.zoomLevelToZoomFactor)(u),sandbox:!0,contextIsolation:!0}});return h.setMenuBarVisibility(!1),h}async getSystemStatus(){const[s,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,t)}getWindowPosition(s,t,n){let o;const u=y.screen.getAllDisplays();if(u.length===1)o=u[0];else{if(i.isMacintosh){const E=y.screen.getCursorScreenPoint();o=y.screen.getDisplayNearestPoint(E)}!o&&s&&(o=y.screen.getDisplayMatching(s.getBounds())),o||(o=y.screen.getPrimaryDisplay()||u[0])}const h={width:t,height:n},f=o.bounds;return h.x=f.x+f.width/2-h.width/2,h.y=f.y+f.height/2-h.height/2,f.width>0&&f.height>0&&(h.x<f.x&&(h.x=f.x),h.y<f.y&&(h.y=f.y),h.x>f.x+f.width&&(h.x=f.x),h.y>f.y+f.height&&(h.y=f.y),h.width>f.width&&(h.width=f.width),h.height>f.height&&(h.height=f.height)),h}async getPerformanceInfo(){try{const[s,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,t)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}};c.DEFAULT_BACKGROUND_COLOR="#1E1E1E",c=ce([ee(1,p.IEnvironmentMainService),ee(2,P.ILaunchMainService),ee(3,D.ILogService),ee(4,r.IDiagnosticsService),ee(5,S.IDialogMainService),ee(6,I.INativeHostMainService),ee(7,b.IProtocolMainService)],c),e.IssueMainService=c}),define(X[225],J([0,1,8,145,71,5,7,13,26,6,21,20,60,2,3,34,29,51,49,193,75,31,50,39,197,16,97,24,10,53,25,41,55]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v,d,w,I,b,a,c,l,s,t,n,o,u,h,f,E,A,_,U,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Q;(function(ae){ae[ae.NONE=0]="NONE",ae[ae.LOADING=1]="LOADING",ae[ae.NAVIGATING=2]="NAVIGATING",ae[ae.READY=3]="READY"})(Q||(Q={}));let ne=class extends v.Disposable{constructor(O,$,z,C,j,N,T,R,W,M,F,B,V,G,Y){super();this.logService=$,this.environmentMainService=z,this.fileService=C,this.configurationService=N,this.themeMainService=T,this.workspacesManagementMainService=R,this.backupMainService=W,this.telemetryService=M,this.dialogMainService=F,this.lifecycleMainService=B,this.nativeHostMainService=V,this.productService=G,this.protocolMainService=Y,this._onWillLoad=this._register(new y.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new y.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new y.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new y.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this._lastFocusTime=-1,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.readyState=0;{const[Z,re]=this.restoreWindowState(O.state);this.windowState=Z,this.logService.trace("window#ctor: using window state",Z);const se=this.windowState.mode===0||this.windowState.mode===3,x=this.configurationService.getValue("window"),ie={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:S.WindowMinimumSize.WIDTH,minHeight:S.WindowMinimumSize.HEIGHT,show:!se,title:this.productService.nameLong,webPreferences:Object.assign({preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:d.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,webviewTag:!0,zoomFactor:(0,S.zoomLevelToZoomFactor)(x==null?void 0:x.zoomLevel)},this.environmentMainService.sandbox?{sandbox:!0,contextIsolation:!0}:{nodeIntegration:!0})};d.browserCodeLoadingCacheStrategy?this.logService.info(`window#ctor: using vscode-file:// protocol and V8 cache options: ${d.browserCodeLoadingCacheStrategy}`):this.logService.trace("window#ctor: vscode-file:// protocol is explicitly disabled"),d.isLinux?ie.icon=(0,m.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):d.isWindows&&!this.environmentMainService.isBuilt&&(ie.icon=(0,m.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),d.isMacintosh&&!this.useNativeFullScreen()&&(ie.fullscreenable=!1),d.isMacintosh&&(ie.acceptFirstMouse=!0,(x==null?void 0:x.clickThroughInactive)===!1&&(ie.acceptFirstMouse=!1));const ue=d.isMacintosh&&(x==null?void 0:x.nativeTabs)===!0;ue&&(ie.tabbingIdentifier=this.productService.nameShort);const ye=(0,S.getTitleBarStyle)(this.configurationService)==="custom";if(ye&&(ie.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,d.isMacintosh||(ie.frame=!1)),(0,k.mark)("code/willCreateCodeBrowserWindow"),this._win=new r.BrowserWindow(ie),(0,k.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),d.isMacintosh&&ye&&this._win.setSheetOffset(22),d.isMacintosh&&re&&(!ue||r.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(ge=>typeof ge=="number")){const ge=this.windowState;this._win.setBounds({width:ge.width,height:ge.height,x:ge.x,y:ge.y})}se&&((0,k.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,k.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,c.resolveMarketplaceHeaders)(this.productService.version,this.environmentMainService,this.fileService,{get:Z=>j.globalStorage.get(Z),store:(Z,re)=>j.globalStorage.set(Z,re)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){var O;return(O=this.currentConfig)===null||O===void 0?void 0:O.backupPath}get openedWorkspace(){var O;return(O=this.currentConfig)===null||O===void 0?void 0:O.workspace}get remoteAuthority(){var O;return(O=this.currentConfig)===null||O===void 0?void 0:O.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){var O;return!!((O=this.currentConfig)===null||O===void 0?void 0:O.extensionDevelopmentPath)}get isExtensionTestHost(){var O;return!!((O=this.currentConfig)===null||O===void 0?void 0:O.extensionTestsPath)}get isExtensionDevelopmentTestFromCli(){var O;return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!((O=this.currentConfig)===null||O===void 0?void 0:O.debugId)}setRepresentedFilename(O){d.isMacintosh?this._win.setRepresentedFilename(O):this.representedFilename=O}getRepresentedFilename(){return d.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(O){d.isMacintosh&&this._win.setDocumentEdited(O),this.documentEdited=O}isDocumentEdited(){return d.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(O){d.isMacintosh&&(O==null?void 0:O.force)&&r.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(O=>{if(this.isReady)return O(this);this.whenReadyCallbacks.push(O)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(O=>{function $(){z.dispose(),C.dispose(),O()}const z=this.onDidClose(()=>$()),C=this.onWillLoad(()=>$())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(z,C)=>this.onWindowError(2,C)),this._win.webContents.on("did-fail-load",(z,C,j)=>this.onWindowError(3,j)),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const O=new Set([E.Schemas.file,E.Schemas.vscodeFileResource,E.Schemas.vscodeRemoteResource,"devtools"]);this._win.webContents.session.webRequest.onBeforeRequest((z,C)=>{const j=P.URI.parse(z.url);return j.path.endsWith(".svg")&&!(O.has(j.scheme)||j.path.includes(E.Schemas.vscodeRemoteResource))?C({cancel:!0}):C({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((z,C)=>{const j=z.responseHeaders,N=j["content-type"]||j["Content-Type"];if(N&&Array.isArray(N)){const T=P.URI.parse(z.url);if(T.path.endsWith(".svg")&&O.has(T.scheme))return j["Content-Type"]=["image/svg+xml"],C({cancel:!1,responseHeaders:j});if(!T.path.includes(E.Schemas.vscodeRemoteResource)&&N.some(R=>R.toLowerCase().includes("image/svg")))return C({cancel:!0})}return C({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),d.isMacintosh&&this._register(this.nativeHostMainService.onDidChangeDisplay(()=>{!this._win||!this.useNativeFullScreen()&&this.isFullScreen&&(this.setFullScreen(!1),this.setFullScreen(!0))})),this._win.on("maximize",z=>{this.currentConfig&&(this.currentConfig.maximized=!0),r.app.emit("browser-window-maximize",z,this._win)}),this._win.on("unmaximize",z=>{this.currentConfig&&(this.currentConfig.maximized=!1),r.app.emit("browser-window-unmaximize",z,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",_.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",_.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(z=>this.onDidDeleteUntitledWorkspace(z)));const $=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:$},async(z,C)=>{const j=await this.marketplaceHeadersPromise;C({cancel:!1,requestHeaders:Object.assign(z.requestHeaders,j)})})}async onWindowError(O,$){switch(O){case 2:this.logService.error(`CodeWindow: renderer process crashed (detail: ${typeof $=="string"?$:$==null?void 0:$.reason})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load workbench window: ${typeof $=="string"?$:$==null?void 0:$.reason}`);break}if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.telemetryService.publicLog2("windowerror",{type:O,reason:typeof $!="string"?$==null?void 0:$.reason:void 0}),O===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,n.mnemonicButtonLabel)((0,L.localize)(0,null)),(0,n.mnemonicButtonLabel)((0,L.localize)(1,null)),(0,n.mnemonicButtonLabel)((0,L.localize)(2,null))],message:(0,L.localize)(3,null),detail:(0,L.localize)(4,null),noLink:!0},this._win);if(!this._win)return;z.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):z.response===2&&this.destroyWindow()}else if(O===2){let z;typeof $=="string"||!$?z=(0,L.localize)(5,null):z=(0,L.localize)(6,null,$.reason);const C=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,n.mnemonicButtonLabel)((0,L.localize)(7,null)),(0,n.mnemonicButtonLabel)((0,L.localize)(8,null))],message:z,detail:(0,L.localize)(9,null),noLink:!0},this._win);if(!this._win)return;C.response===0?this.reload():C.response===1&&this.destroyWindow()}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(O){var $;(($=this.openedWorkspace)===null||$===void 0?void 0:$.id)===O.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const O=this.getMenuBarVisibility();O!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=O,this.setMenuBarVisibility(O));let $=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;($==null?void 0:$.endsWith("/"))&&($=$.substr(0,$.length-1));const z=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if(($||"").indexOf("@")===-1&&($!==this.currentHttpProxy||z!==this.currentNoProxy)){this.currentHttpProxy=$,this.currentNoProxy=z;const C=$||"",j=z?`${z},<local>`:"<local>";this.logService.trace(`Setting proxy to '${C}', bypassing '${j}'`),this._win.webContents.session.setProxy({proxyRules:C,proxyBypassRules:j,pacScript:""})}}addTabbedWindow(O){d.isMacintosh&&O.win&&this._win.addTabbedWindow(O.win)}load(O,$=Object.create(null)){this.isDocumentEdited()&&(!$.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),$.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(O,$),this.readyState===0?this.currentConfig=O:(this.pendingLoadConfig=O,this.readyState=2),this._win.loadURL(E.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",q).toString(!0)),!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&(this.showTimeoutHandle=setTimeout(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)),this._onWillLoad.fire({workspace:O.workspace})}updateConfiguration(O,$){var z,C;const j=(C=(z=this.currentConfig)!==null&&z!==void 0?z:this.pendingLoadConfig)===null||C===void 0?void 0:C.userEnv;j&&(0,A.isLaunchedFromCli)(j)&&!(0,A.isLaunchedFromCli)(O.userEnv)&&(O.userEnv=Object.assign(Object.assign({},j),O.userEnv)),process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(O.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),$.disableExtensions!==void 0&&(O["disable-extensions"]=$.disableExtensions),O.fullscreen=this.isFullScreen,O.maximized=this._win.isMaximized(),(0,k.mark)("code/willOpenNewWindow"),O.perfMarks=(0,k.getMarks)(),this.configObjectUrl.update(O)}async reload(O){const $=Object.assign({},this.currentConfig);$.workspace=await this.validateWorkspace($),delete $.filesToOpenOrCreate,delete $.filesToDiff,delete $.filesToWait,this.isExtensionDevelopmentHost&&O&&($.verbose=O.verbose,$.debugId=O.debugId,$["inspect-extensions"]=O["inspect-extensions"],$["inspect-brk-extensions"]=O["inspect-brk-extensions"],$["extensions-dir"]=O["extensions-dir"]),$.isInitialStartup=!1,this.load($,{isReload:!0,disableExtensions:O==null?void 0:O["disable-extensions"]})}async validateWorkspace(O){if((0,I.isWorkspaceIdentifier)(O.workspace)){const $=O.workspace.configPath;if($.scheme===E.Schemas.file&&!await this.fileService.exists($))return}else if((0,I.isSingleFolderWorkspaceIdentifier)(O.workspace)){const $=O.workspace.uri;if($.scheme===E.Schemas.file&&!await this.fileService.exists($))return}return O.workspace}serializeWindowState(){if(!this._win)return(0,w.defaultWindowState)();if(this.isFullScreen){let z;try{z=r.screen.getDisplayMatching(this.getBounds())}catch(N){}const C=(0,w.defaultWindowState)();return{mode:3,display:z?z.id:void 0,width:this.windowState.width||C.width,height:this.windowState.height||C.height,x:this.windowState.x||0,y:this.windowState.y||0}}const O=Object.create(null);let $;if(!d.isMacintosh&&this._win.isMaximized()?$=0:$=1,$===0?O.mode=0:O.mode=1,$===1||$===0){let z;$===1?z=this.getBounds():z=this._win.getNormalBounds(),O.x=z.x,O.y=z.y,O.width=z.width,O.height=z.height}return O}restoreWindowState(O){(0,k.mark)("code/willRestoreCodeWindowState");let $=!1;if(O)try{const z=r.screen.getAllDisplays();$=z.length>1,O=this.validateWindowState(O,z)}catch(z){this.logService.warn(`Unexpected error validating window state: ${z}
${z.stack}`)}return(0,k.mark)("code/didRestoreCodeWindowState"),[O||(0,w.defaultWindowState)(),$]}validateWindowState(O,$){var z,C;if(this.logService.trace(`window#validateWindowState: validating window state on ${$.length} display(s)`,O),typeof O.x!="number"||typeof O.y!="number"||typeof O.width!="number"||typeof O.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(O.width<=0||O.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if($.length===1){const R=this.getWorkingArea($[0]);if(R){this.logService.trace("window#validateWindowState: 1 monitor working area",R);function j(){!O||typeof O.x!="number"||typeof O.y!="number"||!R||(O.x<R.x&&(O.x=R.x),O.y<R.y&&(O.y=R.y))}j(),O.width>R.width&&(O.width=R.width),O.height>R.height&&(O.height=R.height),O.x>R.x+R.width-128&&(O.x=R.x+R.width-O.width),O.y>R.y+R.height-128&&(O.y=R.y+R.height-O.height),j()}return O}if(O.display&&O.mode===3){const R=$.find(W=>W.id===O.display);if(R&&typeof((z=R.bounds)===null||z===void 0?void 0:z.x)=="number"&&typeof((C=R.bounds)===null||C===void 0?void 0:C.y)=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const W=(0,w.defaultWindowState)(3);return W.x=R.bounds.x,W.y=R.bounds.y,W}}let N,T;try{N=r.screen.getDisplayMatching({x:O.x,y:O.y,width:O.width,height:O.height}),T=this.getWorkingArea(N)}catch(R){}if(N&&T&&O.x+O.width>T.x&&O.y+O.height>T.y&&O.x<T.x+T.width&&O.y<T.y+T.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",T),O}getWorkingArea(O){if(O.workArea.width>0&&O.workArea.height>0)return O.workArea;if(O.bounds.width>0&&O.bounds.height>0)return O.bounds}getBounds(){const[O,$]=this._win.getPosition(),[z,C]=this._win.getSize();return{x:O,y:$,width:z,height:C}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(O){this.useNativeFullScreen()?this.setNativeFullScreen(O):this.setSimpleFullScreen(O),this.sendWhenReady(O?"vscode:enterFullScreen":"vscode:leaveFullScreen",_.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(O){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(O)}setSimpleFullScreen(O){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(O),this._win.webContents.focus()}useNativeFullScreen(){const O=this.configurationService.getValue("window");return!O||typeof O.nativeFullScreen!="boolean"||O.nativeTabs?!0:O.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let O=(0,S.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(O)<0&&(O="classic"),O}setMenuBarVisibility(O,$=!0){d.isMacintosh||(O==="toggle"&&$&&this.send("vscode:showInfoMessage",(0,L.localize)(10,null)),O==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(O)}):this.doSetMenuBarVisibility(O))}doSetMenuBarVisibility(O){const $=this.isFullScreen;switch(O){case"classic":this._win.setMenuBarVisibility(!$),this._win.autoHideMenuBar=$;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(d.isMacintosh)switch(r.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(O,$,...z){this.isReady?this.send(O,...z):this.ready().then(()=>{$.isCancellationRequested||this.send(O,...z)})}send(O,...$){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${O} for window that is destroyed`);return}this._win.webContents.send(O,...$)}}updateTouchBar(O){!d.isMacintosh||this.touchBarGroups.forEach(($,z)=>{const C=O[z];$.segments=this.createTouchBarGroupSegments(C)})}createTouchBar(){if(!!d.isMacintosh){for(let O=0;O<10;O++){const $=this.createTouchBarGroup();this.touchBarGroups.push($)}this._win.setTouchBar(new r.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(O=[]){const $=this.createTouchBarGroupSegments(O),z=new r.TouchBar.TouchBarSegmentedControl({segments:$,mode:"buttons",segmentStyle:"automatic",change:C=>{this.sendWhenReady("vscode:runAction",_.CancellationToken.None,{id:z.segments[C].id,from:"touchbar"})}});return z}createTouchBarGroupSegments(O=[]){return O.map(z=>{var C,j;let N;z.icon&&!o.ThemeIcon.isThemeIcon(z.icon)&&((j=(C=z.icon)===null||C===void 0?void 0:C.dark)===null||j===void 0?void 0:j.scheme)===E.Schemas.file&&(N=r.nativeImage.createFromPath(P.URI.revive(z.icon.dark).fsPath),N.isEmpty()&&(N=void 0));let T;return typeof z.title=="string"?T=z.title:T=z.title.value,{id:z.id,label:N?void 0:T,icon:N}})}dispose(){super.dispose(),this.showTimeoutHandle&&clearTimeout(this.showTimeoutHandle),this._win=null}};ne=ce([ee(1,i.ILogService),ee(2,p.IEnvironmentMainService),ee(3,f.IFileService),ee(4,h.IStorageMainService),ee(5,D.IConfigurationService),ee(6,l.IThemeMainService),ee(7,b.IWorkspacesManagementMainService),ee(8,a.IBackupMainService),ee(9,s.ITelemetryService),ee(10,t.IDialogMainService),ee(11,u.ILifecycleMainService),ee(12,U.INativeHostMainService),ee(13,g.IProductService),ee(14,H.IProtocolMainService)],ne),e.CodeWindow=ne}),define(X[61],J([0,1,148,35,38,13,6,39,5,3,29,51,9,15,7,10,19,16,4,2]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v,d,w,I,b,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,a.createDecorator)("workspacesHistoryMainService");let l=class Ve extends c.Disposable{constructor(f,E,A,_){super();this.stateService=f,this.logService=E,this.workspacesManagementMainService=A,this.lifecycleMainService=_,this._onDidChangeRecentlyOpened=this._register(new p.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new S.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(f=>this.addRecentlyOpened([{workspace:f.workspace}])))}handleWindowsJumpList(){!i.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(f){const E=[],A=[];for(let _ of f)if((0,D.isRecentWorkspace)(_))!this.workspacesManagementMainService.isUntitledWorkspace(_.workspace)&&n(E,_.workspace)===-1&&E.push(_);else if((0,D.isRecentFolder)(_))o(E,_.folderUri)===-1&&E.push(_);else{const U=u(A,_.fileUri)>=0,H=_.fileUri.scheme===w.Schemas.file&&Ve.COMMON_FILES_FILTER.indexOf((0,v.basename)(_.fileUri))>=0;!U&&!H&&(A.push(_),i.isWindows&&_.fileUri.scheme===w.Schemas.file&&y.app.addRecentDocument(_.fileUri.fsPath))}this.addEntriesFromStorage(E,A),E.length>Ve.MAX_TOTAL_RECENT_ENTRIES&&(E.length=Ve.MAX_TOTAL_RECENT_ENTRIES),A.length>Ve.MAX_TOTAL_RECENT_ENTRIES&&(A.length=Ve.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:E,files:A}),this._onDidChangeRecentlyOpened.fire(),i.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(f){const E=H=>{const Q=t(H);for(const ne of f)if(v.extUriBiasedIgnorePathCase.isEqual(ne,Q))return!1;return!0},A=this.getRecentlyOpened(),_=A.workspaces.filter(E),U=A.files.filter(E);(_.length!==A.workspaces.length||U.length!==A.files.length)&&(this.saveRecentlyOpened({files:U,workspaces:_}),this._onDidChangeRecentlyOpened.fire(),i.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!!i.isMacintosh){y.app.clearRecentDocuments();const f=this.getRecentlyOpened(),E=[];let A=0;for(let U=0;U<f.workspaces.length&&A<Ve.MAX_MACOS_DOCK_RECENT_WORKSPACES;U++){const H=t(f.workspaces[U]);if(H.scheme===w.Schemas.file){const Q=(0,v.originalFSPath)(H);await(0,I.exists)(Q)&&(E.push(Q),A++)}}const _=[];for(let U=0;U<f.files.length&&A<Ve.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;U++){const H=t(f.files[U]);if(H.scheme===w.Schemas.file){const Q=(0,v.originalFSPath)(H);if(Ve.COMMON_FILES_FILTER.includes((0,v.basename)(H))||E.includes(Q))continue;await(0,I.exists)(Q)&&(_.push(Q),A++)}}_.reverse().forEach(U=>y.app.addRecentDocument(U)),E.reverse().forEach(U=>y.app.addRecentDocument(U))}}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),y.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(f){var E,A;const _=[],U=[],H=(E=f==null?void 0:f.config)===null||E===void 0?void 0:E.workspace;(0,D.isWorkspaceIdentifier)(H)&&!this.workspacesManagementMainService.isUntitledWorkspace(H)?_.push({workspace:H}):(0,D.isSingleFolderWorkspaceIdentifier)(H)&&_.push({folderUri:H.uri});const Q=(A=f==null?void 0:f.config)===null||A===void 0?void 0:A.filesToOpenOrCreate;if(Q)for(let ne of Q){const ae=ne.fileUri;ae&&u(U,ae)===-1&&U.push({fileUri:ae})}return this.addEntriesFromStorage(_,U),{workspaces:_,files:U}}addEntriesFromStorage(f,E){let A=this.getRecentlyOpenedFromStorage();for(let _ of A.workspaces){let U=(0,D.isRecentFolder)(_)?o(f,_.folderUri):n(f,_.workspace);U>=0?f[U].label=f[U].label||_.label:f.push(_)}for(let _ of A.files){let U=u(E,_.fileUri);U>=0?E[U].label=E[U].label||_.label:E.push(_)}}getRecentlyOpenedFromStorage(){const f=this.stateService.getItem(Ve.recentlyOpenedStorageKey);return(0,D.restoreRecentlyOpened)(f,this.logService)}saveRecentlyOpened(f){const E=(0,D.toStoreData)(f);this.stateService.setItem(Ve.recentlyOpenedStorageKey,E)}updateWindowsJumpList(){if(!!i.isWindows){const f=[];if(f.push({type:"tasks",items:[{type:"task",title:(0,m.localize)(0,null),description:(0,m.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let E=[];for(let U of y.app.getJumpListSettings().removedItems){const H=U.args;if(H){const Q=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(H);Q&&E.push(d.URI.parse(Q[2]))}}this.removeRecentlyOpened(E);let A=!1;const _=(0,L.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(U=>{const H=(0,D.isRecentWorkspace)(U)?U.workspace:U.folderUri,{title:Q,description:ne}=this.getWindowsJumpListLabel(H,U.label);let ae;return d.URI.isUri(H)?ae=`--folder-uri "${H.toString()}"`:(A=!0,ae=`--file-uri "${H.configPath.toString()}"`),{type:"task",title:Q.substr(0,255),description:ne.substr(0,255),program:process.execPath,args:ae,iconPath:"explorer.exe",iconIndex:0}}));_.length>0&&f.push({type:"custom",name:A?(0,m.localize)(2,null):(0,m.localize)(3,null),items:_})}f.push({type:"recent"});try{y.app.setJumpList(f)}catch(E){this.logService.warn("updateWindowsJumpList#setJumpList",E)}}}getWindowsJumpListLabel(f,E){if(E)return{title:(0,r.splitName)(E).name,description:E};if(d.URI.isUri(f))return{title:(0,v.basename)(f),description:s(f)};if(this.workspacesManagementMainService.isUntitledWorkspace(f))return{title:(0,m.localize)(4,null),description:""};let A=(0,v.basename)(f.configPath);return A.endsWith(D.WORKSPACE_EXTENSION)&&(A=A.substr(0,A.length-D.WORKSPACE_EXTENSION.length-1)),{title:(0,m.localize)(5,null,A),description:s(f.configPath)}}};l.MAX_TOTAL_RECENT_ENTRIES=100,l.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,l.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,l.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],l.recentlyOpenedStorageKey="openedPathsList",l=ce([ee(0,k.IStateService),ee(1,P.ILogService),ee(2,g.IWorkspacesManagementMainService),ee(3,b.ILifecycleMainService)],l),e.WorkspacesHistoryMainService=l;function s(h){return h.scheme==="file"?(0,r.normalizeDriveLetter)(h.fsPath):h.toString()}function t(h){return(0,D.isRecentFolder)(h)?h.folderUri:(0,D.isRecentFile)(h)?h.fileUri:h.workspace.configPath}function n(h,f){return h.findIndex(E=>(0,D.isRecentWorkspace)(E)&&E.workspace.id===f.id)}function o(h,f){return h.findIndex(E=>(0,D.isRecentFolder)(E)&&v.extUriBiasedIgnorePathCase.isEqual(E.folderUri,f))}function u(h,f){return h.findIndex(E=>v.extUriBiasedIgnorePathCase.isEqual(E.fileUri,f))}}),define(X[226],J([0,1,141,3,26,13,60,21,31,40,20,9,6,39,34,61,177,7,38,16,41,25]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v,d,w,I,b,a,c,l,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let n=class ht{constructor(h,f,E,A,_,U,H,Q,ne,ae,O){this.updateService=h,this.configurationService=f,this.windowsMainService=E,this.environmentMainService=A,this.telemetryService=_,this.workspacesHistoryMainService=U,this.stateService=H,this.lifecycleMainService=Q,this.logService=ne,this.nativeHostMainService=ae,this.productService=O,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new g.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new g.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(L.isMacintosh||(0,P.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const h=this.stateService.getItem(ht.lastKnownMenubarStorageKey);h&&(h.menus&&(this.menubarMenus=h.menus),h.keybindings&&(this.keybindings=h.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(U,H,Q)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:H==null?void 0:H.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(U,H,Q)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:H==null?void 0:H.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(U,H,Q)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(Q),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(U,H,Q)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(Q),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const h=this.productService.twitterUrl;h&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(h,"openTwitterUrl"));const f=this.productService.requestFeatureUrl;f&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(f,"openUserVoiceUrl"));const E=this.productService.reportIssueUrl;E&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(E,"openReportIssues"));const A=this.productService.licenseUrl;A&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(L.language){const U=A.indexOf("?")>0?"&":"?";this.openUrl(`${A}${U}lang=${L.language}`,"openLicenseUrl")}else this.openUrl(A,"openLicenseUrl")});const _=this.productService.privacyStatementUrl;_&&A&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(L.language){const U=A.indexOf("?")>0?"&":"?";this.openUrl(`${_}${U}lang=${L.language}`,"openPrivacyStatement")}else this.openUrl(_,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(h=>this.onDidChangeWindowsCount(h)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let h=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof h!="boolean"&&(h=!0),h}get currentEnableNativeTabs(){if(!L.isMacintosh)return!1;let h=this.configurationService.getValue("window.nativeTabs");return typeof h!="boolean"&&(h=!1),h}updateMenu(h,f){this.menubarMenus=h.menus,this.keybindings=h.keybindings,this.stateService.setItem(ht.lastKnownMenubarStorageKey,h),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(h){!L.isMacintosh||(h.oldCount===0&&h.newCount>0||h.oldCount>0&&h.newCount===0)&&(this.closedLastWindow=h.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!L.isMacintosh||(this.noActiveWindow=!y.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const h=y.Menu.getApplicationMenu();if(h&&this.oldMenus.push(h),Object.keys(this.menubarMenus).length===0){y.Menu.setApplicationMenu(L.isMacintosh?new y.Menu:null);return}const f=new y.Menu;let E;if(L.isMacintosh){const F=new y.Menu;E=new y.MenuItem({label:this.productService.nameShort,submenu:F}),this.setMacApplicationMenu(F),f.append(E)}if(L.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const F=new y.Menu;F.append(new y.MenuItem({label:this.mnemonicLabel(m.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),y.app.dock.setMenu(F)}const A=new y.Menu,_=new y.MenuItem({label:this.mnemonicLabel(m.localize(1,null)),submenu:A});this.setMenuById(A,"File"),f.append(_);const U=new y.Menu,H=new y.MenuItem({label:this.mnemonicLabel(m.localize(2,null)),submenu:U});this.setMenuById(U,"Edit"),f.append(H);const Q=new y.Menu,ne=new y.MenuItem({label:this.mnemonicLabel(m.localize(3,null)),submenu:Q});this.setMenuById(Q,"Selection"),f.append(ne);const ae=new y.Menu,O=new y.MenuItem({label:this.mnemonicLabel(m.localize(4,null)),submenu:ae});this.setMenuById(ae,"View"),f.append(O);const $=new y.Menu,z=new y.MenuItem({label:this.mnemonicLabel(m.localize(5,null)),submenu:$});this.setMenuById($,"Go"),f.append(z);const C=new y.Menu,j=new y.MenuItem({label:this.mnemonicLabel(m.localize(6,null)),submenu:C});this.setMenuById(C,"Run"),f.append(j);const N=new y.Menu,T=new y.MenuItem({label:this.mnemonicLabel(m.localize(7,null)),submenu:N});this.setMenuById(N,"Terminal"),f.append(T);let R;if(this.shouldDrawMenu("Window")){const F=new y.Menu;R=new y.MenuItem({label:this.mnemonicLabel(m.localize(8,null)),submenu:F,role:"window"}),this.setMacWindowMenu(F)}R&&f.append(R);const W=new y.Menu,M=new y.MenuItem({label:this.mnemonicLabel(m.localize(9,null)),submenu:W,role:"help"});this.setMenuById(W,"Help"),f.append(M),f.items&&f.items.length>0?y.Menu.setApplicationMenu(f):y.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(h){const f=this.createMenuItem(m.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),E=this.getUpdateMenuItems();let A;if(this.shouldDrawMenu("Preferences")){const $=new y.Menu;this.setMenuById($,"Preferences"),A=new y.MenuItem({label:this.mnemonicLabel(m.localize(11,null)),submenu:$})}const _=new y.Menu,U=new y.MenuItem({label:m.localize(12,null),role:"services",submenu:_}),H=new y.MenuItem({label:m.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),Q=new y.MenuItem({label:m.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ne=new y.MenuItem({label:m.localize(15,null),role:"unhide"}),ae=new y.MenuItem(this.likeAction("workbench.action.quit",{label:m.localize(16,null,this.productService.nameLong),click:()=>{const $=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!y.BrowserWindow.getFocusedWindow()||($==null?void 0:$.isMinimized()))&&this.nativeHostMainService.quit(void 0)}})),O=[f];O.push(...E),A&&O.push(o(),A),O.push(o(),U,o(),H,Q,ne,o(),ae),O.forEach($=>h.append($))}shouldDrawMenu(h){if(!L.isMacintosh&&(0,P.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(h){case"File":case"Help":if(L.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[h];case"Window":if(L.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[h]}}setMenu(h,f){f.forEach(E=>{if((0,I.isMenubarMenuItemSeparator)(E))h.append(o());else if((0,I.isMenubarMenuItemSubmenu)(E)){const A=new y.Menu,_=new y.MenuItem({label:this.mnemonicLabel(E.label),submenu:A});this.setMenu(A,E.submenu.items),h.append(_)}else(0,I.isMenubarMenuItemRecentAction)(E)?h.append(this.createOpenRecentMenuItem(E)):(0,I.isMenubarMenuItemAction)(E)&&(E.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(h),L.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[E.id]?h.append(new y.MenuItem(this.likeAction(E.id,{label:this.mnemonicLabel(E.label),click:this.fallbackMenuHandlers[E.id]}))):h.append(this.createMenuItem(E.label,E.id,!1,E.checked)):h.append(this.createMenuItem(E.label,E.id,E.enabled!==!1,!!E.checked)):h.append(this.createMenuItem(E.label,E.id,E.enabled!==!1,!!E.checked)))})}setMenuById(h,f){this.menubarMenus&&this.menubarMenus[f]&&this.setMenu(h,this.menubarMenus[f].items)}insertCheckForUpdatesItems(h){const f=this.getUpdateMenuItems();f.length&&(f.forEach(E=>h.append(E)),h.append(o()))}createOpenRecentMenuItem(h){const f=b.URI.revive(h.uri),E=h.id,A=E==="openRecentFile"?{fileUri:f}:E==="openRecentWorkspace"?{workspaceUri:f}:{folderUri:f};return new y.MenuItem(this.likeAction(E,{label:h.label,click:(_,U,H)=>{const Q=this.isOptionClick(H);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[A],forceNewWindow:Q,gotoLineMode:!1,remoteAuthority:h.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([f])}},!1))}isOptionClick(h){return!!(h&&(!L.isMacintosh&&(h.ctrlKey||h.shiftKey)||L.isMacintosh&&(h.metaKey||h.altKey)))}createRoleMenuItem(h,f,E){const A={label:this.mnemonicLabel(h),role:E,enabled:!0};return new y.MenuItem(this.withKeybinding(f,A))}setMacWindowMenu(h){const f=new y.MenuItem({label:m.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),E=new y.MenuItem({label:m.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),A=new y.MenuItem({label:m.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),_=this.createMenuItem(m.localize(20,null),"workbench.action.switchWindow"),U=[];this.currentEnableNativeTabs&&(U.push(o()),U.push(this.createMenuItem(m.localize(21,null),"workbench.action.newWindowTab")),U.push(this.createRoleMenuItem(m.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),U.push(this.createRoleMenuItem(m.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),U.push(this.createRoleMenuItem(m.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),U.push(this.createRoleMenuItem(m.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[f,E,o(),_,...U,o(),A].forEach(H=>h.append(H))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new y.MenuItem({label:this.mnemonicLabel(m.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate");const f=this.windowsMainService.getLastActiveWindow(),E=f&&`window:${f.id}`;this.updateService.checkForUpdates(E)},0)})];case"checking for updates":return[new y.MenuItem({label:m.localize(27,null),enabled:!1})];case"available for download":return[new y.MenuItem({label:this.mnemonicLabel(m.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new y.MenuItem({label:m.localize(29,null),enabled:!1})];case"downloaded":return[new y.MenuItem({label:this.mnemonicLabel(m.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new y.MenuItem({label:m.localize(31,null),enabled:!1})];case"ready":return[new y.MenuItem({label:this.mnemonicLabel(m.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(h,f,E,A){const _=this.mnemonicLabel(h),U=typeof f=="function"?f:(O,$,z)=>{const C=O?O.userSettingsLabel:null;let j=f;Array.isArray(f)&&(j=this.isOptionClick(z)?f[1]:f[0]),C&&z.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:C}):this.runActionInRenderer({type:"commandId",commandId:j})},H=typeof E=="boolean"?E:this.windowsMainService.getWindowCount()>0,Q=typeof A=="boolean"?A:!1,ne={label:_,click:U,enabled:H};Q&&(ne.type="checkbox",ne.checked=Q);let ae;return typeof f=="string"?ae=f:Array.isArray(f)&&(ae=f[0]),L.isMacintosh&&(ae==="editor.action.clipboardCutAction"?ne.role="cut":ae==="editor.action.clipboardCopyAction"?ne.role="copy":ae==="editor.action.clipboardPasteAction"&&(ne.role="paste"),ae==="undo"?ne.click=this.makeContextAwareClickHandler(U,{inDevTools:O=>O.undo(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("undo:")}):ae==="redo"?ne.click=this.makeContextAwareClickHandler(U,{inDevTools:O=>O.redo(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("redo:")}):ae==="editor.action.selectAll"&&(ne.click=this.makeContextAwareClickHandler(U,{inDevTools:O=>O.selectAll(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("selectAll:")}))),new y.MenuItem(this.withKeybinding(ae,ne))}makeContextAwareClickHandler(h,f){return(E,A,_)=>{const U=y.BrowserWindow.getFocusedWindow();if(!U)return f.inNoWindow();if(U.webContents.isDevToolsFocused()&&U.webContents.devToolsWebContents)return f.inDevTools(U.webContents.devToolsWebContents);h(E,A||U,_)}}runActionInRenderer(h){let f=y.BrowserWindow.getFocusedWindow();if(!f){const A=this.windowsMainService.getLastActiveWindow();(A==null?void 0:A.isMinimized())&&(f=A.win)}const E=f?this.windowsMainService.getWindowById(f.id):void 0;if(E){if(this.logService.trace("menubar#runActionInRenderer",h),L.isMacintosh&&!this.environmentMainService.isBuilt&&!E.isReady&&(h.type==="commandId"&&h.commandId==="workbench.action.toggleDevTools"||h.type!=="commandId"&&h.userSettingsLabel==="alt+cmd+i"))return;if(h.type==="commandId"){const A={id:h.commandId,from:"menu"};E.sendWhenReady("vscode:runAction",s.CancellationToken.None,A)}else{const A={userSettingsLabel:h.userSettingsLabel};E.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,A)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",h)}withKeybinding(h,f){const E=typeof h=="string"?this.keybindings[h]:void 0;if(E==null?void 0:E.label){if(E.isNative!==!1)f.accelerator=E.label,f.userSettingsLabel=E.userSettingsLabel;else if(typeof f.label=="string"){const A=f.label.indexOf("[");A>=0?f.label=`${f.label.substr(0,A)} [${E.label}]`:f.label=`${f.label} [${E.label}]`}}else f.accelerator=void 0;return f}likeAction(h,f,E=!f.accelerator){E&&(f=this.withKeybinding(h,f));const A=f.click;return f.click=(_,U,H)=>{this.reportMenuActionTelemetry(h),A&&A(_,U,H)},f}openUrl(h,f){this.nativeHostMainService.openExternal(void 0,h),this.reportMenuActionTelemetry(f)}reportMenuActionTelemetry(h){this.telemetryService.publicLog2("workbenchActionExecuted",{id:h,from:t})}mnemonicLabel(h){return(0,v.mnemonicMenuLabel)(h,!this.currentEnableMenuBarMnemonics)}};n.lastKnownMenubarStorageKey="lastKnownMenubarData",n=ce([ee(0,i.IUpdateService),ee(1,r.IConfigurationService),ee(2,d.IWindowsMainService),ee(3,k.IEnvironmentMainService),ee(4,p.ITelemetryService),ee(5,w.IWorkspacesHistoryMainService),ee(6,a.IStateService),ee(7,c.ILifecycleMainService),ee(8,S.ILogService),ee(9,l.INativeHostMainService),ee(10,D.IProductService)],n),e.Menubar=n;function o(){return new y.MenuItem({type:"separator"})}}),define(X[227],J([0,1,226,6,4,16]),function(q,e,m,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,k.createDecorator)("menubarMainService");let P=class{constructor(p,i,D){this.instantiationService=p,this.lifecycleMainService=i,this.logService=D,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(m.Menubar)}async updateMenubar(p,i){this.logService.trace("menubarService#updateMenubar",p),(await this.menubar).updateMenu(i,p)}};P=ce([ee(0,k.IInstantiationService),ee(1,y.ILifecycleMainService),ee(2,L.ILogService)],P),e.MenubarMainService=P}),define(X[228],J([0,1,18,27,54,71,8,146,35,49,26,38,225,13,16,21,6,60,98,5,20,61,3,29,4,10,7,15,72,209,51,42,2,50,12,30,39,25,24,32,55]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v,d,w,I,b,a,c,l,s,t,n,o,u,h,f,E,A,_,U,H,Q,ne,ae,O,$,z,C,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function N(W){return(0,n.isWorkspaceIdentifier)(W==null?void 0:W.workspace)}function T(W){return(0,n.isSingleFolderWorkspaceIdentifier)(W==null?void 0:W.workspace)}let R=class xe extends H.Disposable{constructor(M,F,B,V,G,Y,Z,re,se,x,ie,ue,ye,ge,Ee){super();this.machineId=M,this.initialUserEnv=F,this.logService=B,this.stateService=V,this.environmentMainService=G,this.lifecycleMainService=Y,this.backupMainService=Z,this.configurationService=re,this.workspacesHistoryMainService=se,this.workspacesManagementMainService=x,this.instantiationService=ie,this.dialogMainService=ue,this.fileService=ye,this.productService=ge,this.protocolMainService=Ee,this._onDidOpenWindow=this._register(new c.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new c.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new c.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new c.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new A.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(M=>this._onDidSignalReadyWindow.fire(M.window))),this._register(this.onDidSignalReadyWindow(M=>{var F,B;if(((F=M.config)===null||F===void 0?void 0:F.extensionDevelopmentPath)||((B=M.config)===null||B===void 0?void 0:B.extensionTestsPath)){const V=new H.DisposableStore;if(V.add(c.Event.any(M.onDidClose,M.onDidDestroy)(()=>V.dispose())),M.config.extensionDevelopmentPath)for(const G of M.config.extensionDevelopmentPath)V.add(this.protocolMainService.addValidFileRoot(h.URI.file(G)));M.config.extensionTestsPath&&V.add(this.protocolMainService.addValidFileRoot(h.URI.file(M.config.extensionTestsPath)))}}))}openEmptyWindow(M,F){let B=this.environmentMainService.args;const V=(F==null?void 0:F.remoteAuthority)||void 0,G=!0,Y=F==null?void 0:F.forceReuseWindow,Z=!Y;return this.open(Object.assign(Object.assign({},M),{cli:B,forceEmpty:G,forceNewWindow:Z,forceReuseWindow:Y,remoteAuthority:V}))}open(M){this.logService.trace("windowsManager#open"),M.addMode&&(M.initialStartup||!this.getLastActiveWindow())&&(M.addMode=!1);const F=[],B=[],V=[],G=[],Y=[];let Z,re=0;const se=this.getPathsToOpen(M);this.logService.trace("windowsManager#open pathsToOpen",se);for(const ge of se)T(ge)?M.addMode?F.push(ge):B.push(ge):N(ge)?V.push(ge):ge.fileUri?(Z||(Z={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ge.remoteAuthority}),Z.filesToOpenOrCreate.push(ge)):ge.backupPath?Y.push({backupFolder:(0,P.basename)(ge.backupPath),remoteAuthority:ge.remoteAuthority}):re++;M.diffMode&&(Z==null?void 0:Z.filesToOpenOrCreate.length)===2&&(Z.filesToDiff=Z.filesToOpenOrCreate,Z.filesToOpenOrCreate=[]),Z&&M.waitMarkerFileURI&&(Z.filesToWait={paths:[...Z.filesToDiff,...Z.filesToOpenOrCreate],waitMarkerFileUri:M.waitMarkerFileURI}),M.initialStartup?(G.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),V.push(...G),Y.push(...this.backupMainService.getEmptyWindowBackupPaths())):Y.length=0;const{windows:x,filesOpenedInWindow:ie}=this.doOpen(M,V,B,Y,re,Z,F);if(this.logService.trace(`windowsManager#open used window count ${x.length} (workspacesToOpen: ${V.length}, foldersToOpen: ${B.length}, emptyToRestore: ${Y.length}, emptyToOpen: ${re})`),x.length>1)if(ie)ie.focus();else{const ge=this.windowsStateHandler.state.lastActiveWindow&&!M.forceEmpty&&!M.cli._.length&&!M.cli["file-uri"]&&!M.cli["folder-uri"]&&!(M.urisToOpen&&M.urisToOpen.length);let Ee=!0,Ae=!0;if(ge){const ve=x.filter(me=>this.windowsStateHandler.state.lastActiveWindow&&me.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ve.length&&(ve[0].focus(),Ee=!1,Ae=!1)}if(Ee)for(let ve=x.length-1;ve>=0;ve--){const me=x[ve];if(!(me.openedWorkspace&&G.some(be=>me.openedWorkspace&&be.workspace.id===me.openedWorkspace.id)||me.backupPath&&Y.some(be=>me.backupPath&&be.backupFolder===(0,P.basename)(me.backupPath)))){me.focus(),Ae=!1;break}}Ae&&x[x.length-1].focus()}const ue=Z&&Z.filesToDiff.length>0;if(!x.some(ge=>ge.isExtensionDevelopmentHost)&&!ue&&!M.noRecentEntry){const ge=[];for(const Ee of se)N(Ee)?ge.push({label:Ee.label,workspace:Ee.workspace,remoteAuthority:Ee.remoteAuthority}):T(Ee)?ge.push({label:Ee.label,folderUri:Ee.workspace.uri,remoteAuthority:Ee.remoteAuthority}):Ee.fileUri&&ge.push({label:Ee.label,fileUri:Ee.fileUri,remoteAuthority:Ee.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ge)}const ye=M.waitMarkerFileURI;return M.context===0&&ye&&x.length===1&&x[0]&&x[0].whenClosedOrLoaded.then(()=>this.fileService.del(ye),()=>{}),x}doOpen(M,F,B,V,G,Y,Z){const re=[];let se;function x(ve,me){re.push(ve),me&&(se=ve,Y=void 0)}let{openFolderInNewWindow:ie,openFilesInNewWindow:ue}=this.shouldOpenNewWindow(M);if(!M.initialStartup&&Z.length>0){const ve=Z[0].remoteAuthority,me=this.getLastActiveWindowForAuthority(ve);me&&x(this.doAddFoldersToExistingWindow(me,Z.map(be=>be.workspace.uri)))}const ye=B.length+F.length+V.length;if(Y&&ye===0){const ve=Y.filesToOpenOrCreate[0]||Y.filesToDiff[0],me=this.getWindows().filter(Te=>Y&&Te.remoteAuthority===Y.remoteAuthority);let be;(ve==null?void 0:ve.fileUri)&&!ue&&((M.context===4||M.context===0||M.context===1)&&(be=(0,a.findWindowOnFile)(me,ve.fileUri,Te=>Te.configPath.scheme===u.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Te.configPath):null)),be||(be=this.doGetLastActiveWindow(me))),be?(0,n.isWorkspaceIdentifier)(be.openedWorkspace)?F.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,n.isSingleFolderWorkspaceIdentifier)(be.openedWorkspace)?B.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):x(this.doOpenFilesInExistingWindow(M,be,Y),!0):x(this.openInBrowserWindow({userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,filesToOpen:Y,forceNewWindow:!0,remoteAuthority:Y.remoteAuthority,forceNewTabbedWindow:M.forceNewTabbedWindow}),!0)}const ge=(0,p.distinct)(F,ve=>ve.workspace.id);if(ge.length>0){const ve=(0,p.coalesce)(ge.map(me=>(0,a.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.configPath)));if(ve.length>0){const me=ve[0],be=(Y==null?void 0:Y.remoteAuthority)===me.remoteAuthority?Y:void 0;x(this.doOpenFilesInExistingWindow(M,me,be),!!be),ie=!0}ge.forEach(me=>{if(!ve.some(_e=>_e.openedWorkspace&&_e.openedWorkspace.id===me.workspace.id)){const be=me.remoteAuthority,Te=(Y==null?void 0:Y.remoteAuthority)===be?Y:void 0;x(this.doOpenFolderOrWorkspace(M,me,ie,Te),!!Te),ie=!0}})}const Ee=(0,p.distinct)(B,ve=>f.extUriBiasedIgnorePathCase.getComparisonKey(ve.workspace.uri));if(Ee.length>0){const ve=(0,p.coalesce)(Ee.map(me=>(0,a.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.uri)));if(ve.length>0){const me=ve[0],be=(Y==null?void 0:Y.remoteAuthority)===me.remoteAuthority?Y:void 0;x(this.doOpenFilesInExistingWindow(M,me,be),!!be),ie=!0}Ee.forEach(me=>{if(!ve.some(_e=>(0,n.isSingleFolderWorkspaceIdentifier)(_e.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(_e.openedWorkspace.uri,me.workspace.uri))){const be=me.remoteAuthority,Te=(Y==null?void 0:Y.remoteAuthority)===be?Y:void 0;x(this.doOpenFolderOrWorkspace(M,me,ie,Te),!!Te),ie=!0}})}const Ae=(0,p.distinct)(V,ve=>ve.backupFolder);if(Ae.length>0&&Ae.forEach(ve=>{const me=ve.remoteAuthority,be=(Y==null?void 0:Y.remoteAuthority)===me?Y:void 0;x(this.openInBrowserWindow({userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,filesToOpen:be,remoteAuthority:me,forceNewWindow:!0,forceNewTabbedWindow:M.forceNewTabbedWindow,emptyWindowBackupInfo:ve}),!!be),ie=!0}),re.length===0||Y){Y&&!G&&G++;const ve=Y?Y.remoteAuthority:M.remoteAuthority;for(let me=0;me<G;me++)x(this.doOpenEmpty(M,ie,ve,Y),!!Y),ie=!0}return{windows:(0,p.distinct)(re),filesOpenedInWindow:se}}doOpenFilesInExistingWindow(M,F,B){var V;this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),F.focus();const G={filesToOpenOrCreate:B==null?void 0:B.filesToOpenOrCreate,filesToDiff:B==null?void 0:B.filesToDiff,filesToWait:B==null?void 0:B.filesToWait,termProgram:(V=M==null?void 0:M.userEnv)===null||V===void 0?void 0:V.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",$.CancellationToken.None,G),F}doAddFoldersToExistingWindow(M,F){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),M.focus();const B={foldersToAdd:F};return M.sendWhenReady("vscode:addFolders",$.CancellationToken.None,B),M}doOpenEmpty(M,F,B,V,G){return!F&&!G&&typeof M.contextWindowId=="number"&&(G=this.getWindowById(M.contextWindowId)),this.openInBrowserWindow({userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,remoteAuthority:B,forceNewWindow:F,forceNewTabbedWindow:M.forceNewTabbedWindow,filesToOpen:V,windowToUse:G})}doOpenFolderOrWorkspace(M,F,B,V,G){return!B&&!G&&typeof M.contextWindowId=="number"&&(G=this.getWindowById(M.contextWindowId)),this.openInBrowserWindow({workspace:F.workspace,userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:B,forceNewTabbedWindow:M.forceNewTabbedWindow,filesToOpen:V,windowToUse:G})}getPathsToOpen(M){var F;let B,V=!1,G=!1;if(M.urisToOpen&&M.urisToOpen.length>0?(B=this.doExtractPathsFromAPI(M),V=!0):M.forceEmpty?B=[Object.create(null)]:M.cli._.length||M.cli["folder-uri"]||M.cli["file-uri"]?(B=this.doExtractPathsFromCLI(M.cli),B.length===0&&B.push(Object.create(null)),V=!0):(B=this.doGetPathsFromLastSession(),B.length===0&&B.push(Object.create(null)),G=!0),!M.addMode&&V){const Y=B.filter(Z=>T(Z));if(Y.length>1){const Z=Y[0].remoteAuthority;if(Y.every(re=>re.remoteAuthority===Z)){const re=this.workspacesManagementMainService.createUntitledWorkspaceSync(Y.map(se=>({uri:se.workspace.uri})));B.push({workspace:re,remoteAuthority:Z}),B=B.filter(se=>!T(se))}}}return M.initialStartup&&!G&&((F=this.configurationService.getValue("window"))===null||F===void 0?void 0:F.restoreWindows)==="preserve"&&B.unshift(...this.doGetPathsFromLastSession().filter(Y=>N(Y)||T(Y)||Y.backupPath)),B}doExtractPathsFromAPI(M){const F=[],B={gotoLineMode:M.gotoLineMode,remoteAuthority:M.remoteAuthority};for(const V of(0,p.coalesce)(M.urisToOpen||[])){const G=this.resolveOpenable(V,B);if(G)G.label=V.label,F.push(G);else{const Y=this.resourceFromOpenable(V),Z={title:this.productService.nameLong,type:"info",buttons:[(0,r.localize)(0,null)],message:Y.scheme===u.Schemas.file?(0,r.localize)(1,null):(0,r.localize)(2,null),detail:Y.scheme===u.Schemas.file?(0,r.localize)(3,null,(0,O.getPathLabel)(Y.fsPath,this.environmentMainService)):(0,r.localize)(4,null,Y.toString()),noLink:!0};this.dialogMainService.showMessageBox(Z,(0,ne.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}}return F}doExtractPathsFromCLI(M){const F=[],B={ignoreFileNotFound:!0,gotoLineMode:M.goto,remoteAuthority:M.remote||void 0,forceOpenWorkspaceAsFile:!1},V=M["folder-uri"];if(V)for(const Z of V){const re=this.cliArgToUri(Z);if(re){const se=this.resolveOpenable({folderUri:re},B);se&&F.push(se)}}const G=M["file-uri"];if(G)for(const Z of G){const re=this.cliArgToUri(Z);if(re){const se=this.resolveOpenable((0,n.hasWorkspaceFileExtension)(Z)?{workspaceUri:re}:{fileUri:re},B);se&&F.push(se)}}const Y=M._;for(const Z of Y){const re=B.remoteAuthority?this.doResolvePathRemote(Z,B):this.doResolveFilePath(Z,B);re&&F.push(re)}return F}cliArgToUri(M){try{const F=h.URI.parse(M);if(!F.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${M}`);return}return F}catch(F){this.logService.error(`Invalid URI input string: ${M}, ${F.message}`)}}doGetPathsFromLastSession(){const M=this.getRestoreWindowsSetting();switch(M){case"none":return[];case"one":case"all":case"preserve":case"folders":const F=[];M!=="one"&&F.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&F.push(this.windowsStateHandler.state.lastActiveWindow);const B=[];for(const V of F)if(V.workspace){const G=this.resolveOpenable({workspaceUri:V.workspace.configPath},{remoteAuthority:V.remoteAuthority});N(G)&&B.push(G)}else if(V.folderUri){const G=this.resolveOpenable({folderUri:V.folderUri},{remoteAuthority:V.remoteAuthority});T(G)&&B.push(G)}else M!=="folders"&&V.backupPath&&B.push({backupPath:V.backupPath,remoteAuthority:V.remoteAuthority});return B}}getRestoreWindowsSetting(){let M;if(this.lifecycleMainService.wasRestarted)M="all";else{const F=this.configurationService.getValue("window");M=(F==null?void 0:F.restoreWindows)||"all",["preserve","all","folders","one","none"].includes(M)||(M="all")}return M}resolveOpenable(M,F={}){let B=this.resourceFromOpenable(M);return B.scheme===u.Schemas.file?((0,b.isFileToOpen)(M)&&(F=Object.assign(Object.assign({},F),{forceOpenWorkspaceAsFile:!0})),this.doResolveFilePath(B.fsPath,F)):this.doResolveRemoteOpenable(M,F)}doResolveRemoteOpenable(M,F){let B=this.resourceFromOpenable(M);const V=(0,E.getRemoteAuthority)(B)||F.remoteAuthority;if(B=(0,f.removeTrailingPathSeparator)((0,f.normalizePath)(B)),(0,b.isFileToOpen)(M)){if(F.gotoLineMode){const{path:G,line:Y,column:Z}=(0,ae.parseLineAndColumnAware)(B.path);return{fileUri:B.with({path:G}),lineNumber:Y,columnNumber:Z,remoteAuthority:V}}return{fileUri:B,remoteAuthority:V}}else if((0,b.isWorkspaceToOpen)(M))return{workspace:(0,_.getWorkspaceIdentifier)(B),remoteAuthority:V};return{workspace:(0,_.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:V}}resourceFromOpenable(M){return(0,b.isWorkspaceToOpen)(M)?M.workspaceUri:(0,b.isFolderToOpen)(M)?M.folderUri:M.fileUri}doResolveFilePath(M,F){let B,V;F.gotoLineMode&&({path:M,line:B,column:V}=(0,ae.parseLineAndColumnAware)(M)),M=(0,ae.sanitizeFilePath)((0,P.normalize)(M),(0,C.cwd)());try{const G=(0,m.statSync)(M);if(G.isFile()){if(!F.forceOpenWorkspaceAsFile){const Y=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(M));if(Y)return{workspace:{id:Y.id,configPath:Y.configPath},remoteAuthority:Y.remoteAuthority,exists:!0}}return{fileUri:h.URI.file(M),lineNumber:B,columnNumber:V,exists:!0}}else if(G.isDirectory())return{workspace:(0,_.getSingleFolderWorkspaceIdentifier)(h.URI.file(M),G),exists:!0}}catch(G){const Y=h.URI.file(M);if(this.workspacesHistoryMainService.removeRecentlyOpened([Y]),F.ignoreFileNotFound)return{fileUri:Y,exists:!1}}}doResolvePathRemote(M,F){const B=M.charCodeAt(0),V=F.remoteAuthority;let G,Y;F.gotoLineMode&&({path:M,line:G,column:Y}=(0,ae.parseLineAndColumnAware)(M)),B!==47&&((0,ae.isWindowsDriveLetter)(B)&&M.charCodeAt(M.charCodeAt(1))===58&&(M=(0,ae.toSlashes)(M)),M=`/${M}`);const Z=h.URI.from({scheme:u.Schemas.vscodeRemote,authority:V,path:M});if(M.charCodeAt(M.length-1)!==47){if((0,n.hasWorkspaceFileExtension)(M))return F.forceOpenWorkspaceAsFile?{fileUri:Z,lineNumber:G,columnNumber:Y,remoteAuthority:F.remoteAuthority}:{workspace:(0,_.getWorkspaceIdentifier)(Z),remoteAuthority:V};if(F.gotoLineMode||P.posix.basename(M).indexOf(".")!==-1)return{fileUri:Z,lineNumber:G,columnNumber:Y,remoteAuthority:V}}return{workspace:(0,_.getSingleFolderWorkspaceIdentifier)(Z),remoteAuthority:V}}shouldOpenNewWindow(M){const F=this.configurationService.getValue("window"),B=(F==null?void 0:F.openFoldersInNewWindow)||"default",V=(F==null?void 0:F.openFilesInNewWindow)||"off";let G=(M.preferNewWindow||M.forceNewWindow)&&!M.forceReuseWindow;!M.forceNewWindow&&!M.forceReuseWindow&&(B==="on"||B==="off")&&(G=B==="on");let Y=!1;return M.forceNewWindow||M.forceReuseWindow?Y=!!M.forceNewWindow&&!M.forceReuseWindow:(t.isMacintosh?M.context===1&&(Y=!0):M.context!==3&&M.context!==2&&!(M.userEnv&&M.userEnv.TERM_PROGRAM==="vscode")&&(Y=!0),!M.cli.extensionDevelopmentPath&&(V==="on"||V==="off")&&(Y=V==="on")),{openFolderInNewWindow:!!G,openFilesInNewWindow:Y}}openExtensionDevelopmentHostWindow(M,F){const B=(0,a.findWindowOnExtensionDevelopmentPath)(this.getWindows(),M);if(B)return this.lifecycleMainService.reload(B,F.cli),B.focus(),[B];let V=F.cli["folder-uri"]||[],G=F.cli["file-uri"]||[],Y=F.cli._;if(!Y.length&&!V.length&&!G.length&&!F.cli.extensionTestsPath){const x=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ie=x&&(x.workspace||x.folderUri);ie&&(h.URI.isUri(ie)?ie.scheme===u.Schemas.file?Y=[ie.fsPath]:V=[ie.toString()]:ie.configPath.scheme===u.Schemas.file?Y=[(0,f.originalFSPath)(ie.configPath)]:G=[ie.configPath.toString()])}let Z=F.remoteAuthority;for(const x of M)if(x.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ie=h.URI.parse(x),ue=(0,E.getRemoteAuthority)(ie);ue&&(Z?ue!==Z&&this.logService.error("more than one extension development path authority"):Z=ue)}Y=Y.filter(x=>{const ie=h.URI.file(x);return(0,a.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:(0,E.getRemoteAuthority)(ie)===Z}),V=V.filter(x=>{const ie=this.cliArgToUri(x);return ie&&!!(0,a.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:ie?(0,E.getRemoteAuthority)(ie)===Z:!1}),G=G.filter(x=>{const ie=this.cliArgToUri(x);return ie&&!!(0,a.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:ie?(0,E.getRemoteAuthority)(ie)===Z:!1}),F.cli._=Y,F.cli["folder-uri"]=V,F.cli["file-uri"]=G;const re=!Y.length&&!V.length&&!G.length,se={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:re,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:Z};return this.open(se)}openInBrowserWindow(M){var F,B,V,G,Y;const Z=this.configurationService.getValue("window"),re=Object.assign(Object.assign(Object.assign({},this.environmentMainService.args),M.cli),{machineId:this.machineId,sessionId:"",windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,partsSplashPath:(0,P.join)(this.environmentMainService.userDataPath,"rapid_render.json"),backupPath:M.emptyWindowBackupInfo?(0,P.join)(this.environmentMainService.backupHome,M.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:M.remoteAuthority,workspace:M.workspace,userEnv:Object.assign(Object.assign({},this.initialUserEnv),M.userEnv),filesToOpenOrCreate:(F=M.filesToOpen)===null||F===void 0?void 0:F.filesToOpenOrCreate,filesToDiff:(B=M.filesToOpen)===null||B===void 0?void 0:B.filesToDiff,filesToWait:(V=M.filesToOpen)===null||V===void 0?void 0:V.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:k.default,isInitialStartup:M.initialStartup,perfMarks:(0,y.getMarks)(),os:{release:(0,L.release)()},zoomLevel:typeof(Z==null?void 0:Z.zoomLevel)=="number"?Z.zoomLevel:void 0,autoDetectHighContrast:(G=Z==null?void 0:Z.autoDetectHighContrast)!==null&&G!==void 0?G:!0,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:{dark:v.nativeTheme.shouldUseDarkColors,highContrast:v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors}});let se;if(!M.forceNewWindow&&!M.forceNewTabbedWindow&&(se=M.windowToUse||this.getLastActiveWindow(),se&&se.focus()),se){const x=se.config;!re.extensionDevelopmentPath&&x&&!!x.extensionDevelopmentPath&&(re.extensionDevelopmentPath=x.extensionDevelopmentPath,re.verbose=x.verbose,re["inspect-brk-extensions"]=x["inspect-brk-extensions"],re.debugId=x.debugId,re["inspect-extensions"]=x["inspect-extensions"],re["extensions-dir"]=x["extensions-dir"])}else{const x=this.windowsStateHandler.getNewWindowState(re);(0,y.mark)("code/willCreateCodeWindow");const ie=se=this.instantiationService.createInstance(S.CodeWindow,{state:x,extensionDevelopmentPath:re.extensionDevelopmentPath,isExtensionTestHost:!!re.extensionTestsPath});if((0,y.mark)("code/didCreateCodeWindow"),M.forceNewTabbedWindow){const ye=this.getLastActiveWindow();ye&&ye.addTabbedWindow(ie)}xe.WINDOWS.push(ie),this._onDidOpenWindow.fire(ie),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,U.once)(ie.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(ie)),(0,U.once)(ie.onDidClose)(()=>this.onWindowClosed(ie)),(0,U.once)(ie.onDidDestroy)(()=>this._onDidDestroyWindow.fire(ie));const ue=(0,ne.assertIsDefined)((Y=ie.win)===null||Y===void 0?void 0:Y.webContents);ue.removeAllListeners("devtools-reload-page"),ue.on("devtools-reload-page",()=>this.lifecycleMainService.reload(ie)),this.lifecycleMainService.registerWindow(ie)}return re.windowId=se.id,re.sessionId=`window:${se.id}`,se.isReady?this.lifecycleMainService.unload(se,4).then(x=>{x||this.doOpenInBrowserWindow(se,re,M)}):this.doOpenInBrowserWindow(se,re,M),se}doOpenInBrowserWindow(M,F,B){if(!F.extensionDevelopmentPath)if((0,n.isWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:F.workspace,remoteAuthority:F.remoteAuthority});else if((0,n.isSingleFolderWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerFolderBackupSync(F.workspace.uri);else{const V=B.emptyWindowBackupInfo&&B.emptyWindowBackupInfo.backupFolder;F.backupPath=this.backupMainService.registerEmptyWindowBackupSync(V,F.remoteAuthority)}M.load(F)}onWindowClosed(M){const F=xe.WINDOWS.indexOf(M);xe.WINDOWS.splice(F,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const M=v.BrowserWindow.getFocusedWindow();if(M)return this.getWindowById(M.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(M){return this.doGetLastActiveWindow(this.getWindows().filter(F=>F.remoteAuthority===M))}doGetLastActiveWindow(M){const F=Math.max.apply(Math,M.map(B=>B.lastFocusTime));return M.find(B=>B.lastFocusTime===F)}sendToFocused(M,...F){const B=this.getFocusedWindow()||this.getLastActiveWindow();B&&B.sendWhenReady(M,$.CancellationToken.None,...F)}sendToAll(M,F,B){for(const V of this.getWindows())B&&B.indexOf(V.id)>=0||V.sendWhenReady(M,$.CancellationToken.None,F)}getWindows(){return xe.WINDOWS}getWindowCount(){return xe.WINDOWS.length}getWindowById(M){const F=this.getWindows().filter(B=>B.id===M);return(0,p.firstOrDefault)(F)}getWindowByWebContents(M){const F=v.BrowserWindow.fromWebContents(M);if(!!F)return this.getWindowById(F.id)}};R.WINDOWS=[],R=ce([ee(2,I.ILogService),ee(3,g.IStateService),ee(4,D.IEnvironmentMainService),ee(5,d.ILifecycleMainService),ee(6,i.IBackupMainService),ee(7,w.IConfigurationService),ee(8,s.IWorkspacesHistoryMainService),ee(9,_.IWorkspacesManagementMainService),ee(10,o.IInstantiationService),ee(11,Q.IDialogMainService),ee(12,z.IFileService),ee(13,l.IProductService),ee(14,j.IProtocolMainService)],R),e.WindowsMainService=R}),define(X[229],J([0,1,51,34,61,49]),function(q,e,m,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let P=class{constructor(p,i,D,g){this.workspacesManagementMainService=p,this.windowsMainService=i,this.workspacesHistoryMainService=D,this.backupMainService=g,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(p,i){const D=this.windowsMainService.getWindowById(p);return D?this.workspacesManagementMainService.enterWorkspace(D,this.windowsMainService.getWindows(),i):null}createUntitledWorkspace(p,i,D){return this.workspacesManagementMainService.createUntitledWorkspace(i,D)}deleteUntitledWorkspace(p,i){return this.workspacesManagementMainService.deleteUntitledWorkspace(i)}getWorkspaceIdentifier(p,i){return this.workspacesManagementMainService.getWorkspaceIdentifier(i)}async getRecentlyOpened(p){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(p))}async addRecentlyOpened(p,i){return this.workspacesHistoryMainService.addRecentlyOpened(i)}async removeRecentlyOpened(p,i){return this.workspacesHistoryMainService.removeRecentlyOpened(i)}async clearRecentlyOpened(p){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};P=ce([ee(0,m.IWorkspacesManagementMainService),ee(1,L.IWindowsMainService),ee(2,k.IWorkspacesHistoryMainService),ee(3,y.IBackupMainService)],P),e.WorkspacesMainService=P}),define(X[230],J([0,1,27,18,13,3,228,16,69,40,199,33,120,84,219,99,4,70,67,6,38,26,21,96,200,31,95,194,195,191,20,213,2,34,7,29,229,65,223,221,220,224,175,17,202,214,227,117,8,15,129,10,222,97,207,212,49,61,201,51,68,152,41,50,12,39,204,76,24,43,28,23,89,205,189,53,30,25,164,178,42,72,74]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v,d,w,I,b,a,c,l,s,t,n,o,u,h,f,E,A,_,U,H,Q,ne,ae,O,$,z,C,j,N,T,R,W,M,F,B,V,G,Y,Z,re,se,x,ie,ue,ye,ge,Ee,Ae,ve,me,be,Te,_e,Ge,Ze,Ke,st,ze,it,K,te,oe,le,de,pe,Ie,Oe,Ce,Ne,qe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let ot=class extends H.Disposable{constructor(fe,we,Le,he,ke,Se,Pe,De,Me,We){super();this.mainProcessNodeIpcServer=fe,this.userEnv=we,this.mainInstantiationService=Le,this.logService=he,this.environmentMainService=ke,this.lifecycleMainService=Se,this.configurationService=Pe,this.stateService=De,this.fileService=Me,this.productService=We,this.registerListeners()}registerListeners(){(0,R.setUnexpectedErrorHandler)(he=>this.onUnexpectedError(he)),process.on("uncaughtException",he=>this.onUnexpectedError(he)),process.on("unhandledRejection",he=>(0,R.onUnexpectedError)(he)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,B.registerContextMenuListener)(),k.app.on("accessibility-support-changed",(he,ke)=>{var Se;(Se=this.windowsMainService)===null||Se===void 0||Se.sendToAll("vscode:accessibilitySupportChanged",ke)}),k.app.on("activate",(he,ke)=>{var Se;this.logService.trace("app#activate"),ke||(Se=this.windowsMainService)===null||Se===void 0||Se.openEmptyWindow({context:1})}),k.app.on("remote-require",(he,ke,Se)=>{this.logService.trace("app#on(remote-require): prevented"),he.preventDefault()}),k.app.on("remote-get-global",(he,ke,Se)=>{this.logService.trace(`app#on(remote-get-global): prevented on ${Se}`),he.preventDefault()}),k.app.on("remote-get-builtin",(he,ke,Se)=>{this.logService.trace(`app#on(remote-get-builtin): prevented on ${Se}`),Se!=="clipboard"&&he.preventDefault()}),k.app.on("remote-get-current-window",he=>{this.logService.trace("app#on(remote-get-current-window): prevented"),he.preventDefault()}),k.app.on("remote-get-current-web-contents",he=>{this.environmentMainService.args.driver||(this.logService.trace("app#on(remote-get-current-web-contents): prevented"),he.preventDefault())}),k.app.on("web-contents-created",(he,ke)=>{ke.on("will-attach-webview",(Pe,De,Me)=>{const We=$e=>{if(!$e)return!1;const Ue=ne.URI.parse($e);if(Ue.scheme===Z.Schemas.vscodeWebview)return Ue.path==="/index.html"||Ue.path==="/electron-browser-index.html";const Xe=Ue.fsPath.toLowerCase(),Re=ne.URI.file(this.environmentMainService.appRoot).fsPath.toLowerCase();return Xe.startsWith(Re+V.sep)};delete De.preload,De.nodeIntegration=!1,!(We(Me.src)&&We(De.preloadURL))&&(delete De.preloadURL,this.logService.error("webContents#web-contents-created: Prevented webview attach"),Pe.preventDefault())}),ke.on("will-navigate",Pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),ke.on("new-window",(Pe,De)=>{var Me;Pe.preventDefault(),(Me=this.nativeHostMainService)===null||Me===void 0||Me.openExternal(void 0,De)});const Se=Pe=>Pe.startsWith(`${Z.Schemas.vscodeWebview}://`);k.session.defaultSession.setPermissionRequestHandler((Pe,De,Me,We)=>Se(We.requestingUrl)?Me(De==="clipboard-read"):Me(!1)),k.session.defaultSession.setPermissionCheckHandler((Pe,De,Me,We)=>Se(We.requestingUrl)?De==="clipboard-read":!1)});let fe=[],we=null;k.app.on("open-file",(he,ke)=>{this.logService.trace("app#open-file: ",ke),he.preventDefault(),fe.push(this.getWindowOpenableFromPathSync(ke)),we!==null&&(clearTimeout(we),we=null),we=setTimeout(()=>{var Se;(Se=this.windowsMainService)===null||Se===void 0||Se.open({context:1,cli:this.environmentMainService.args,urisToOpen:fe,gotoLineMode:!1,preferNewWindow:!0}),fe=[],we=null},100)}),k.app.on("new-window-for-tab",()=>{var he;(he=this.windowsMainService)===null||he===void 0||he.openEmptyWindow({context:4})});let Le=!1;k.ipcMain.handle("vscode:fetchShellEnv",he=>new Promise(async ke=>{var Se;const Pe=he.sender;let De=!1;function Me(je){clearTimeout($e),clearTimeout(Xe),De||(De=!0,Pe.isDestroyed()||ke(je))}const We=new pe.CancellationTokenSource,$e=setTimeout(()=>{var je;Le||((je=this.windowsMainService)===null||je===void 0||je.sendToFocused("vscode:showShellEnvSlowWarning",We.token),Le=!0)},3e3),Ue=(Se=this.windowsMainService)===null||Se===void 0?void 0:Se.getWindowByWebContents(he.sender),Xe=setTimeout(()=>{We.dispose(!0),Ue==null||Ue.sendWhenReady("vscode:showShellEnvTimeoutError",pe.CancellationToken.None),Me({})},1e4);let Re,Ye;(Ue==null?void 0:Ue.config)?(Re=Ue.config,Ye=Object.assign(Object.assign({},process.env),Ue.config.userEnv)):(Re=this.environmentMainService.args,Ye=process.env);const Qe=await(0,p.resolveShellEnv)(this.logService,Re,Ye);Me(Qe)})),k.ipcMain.handle("vscode:writeNlsFile",(he,ke,Se)=>{const Pe=this.validateNlsPath([ke]);if(!Pe||typeof Se!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Pe,it.VSBuffer.fromString(Se))}),k.ipcMain.handle("vscode:readNlsFile",async(he,...ke)=>{const Se=this.validateNlsPath(ke);if(!Se)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Se)).value.toString()}),k.ipcMain.on("vscode:toggleDevTools",he=>he.sender.toggleDevTools()),k.ipcMain.on("vscode:openDevTools",he=>he.sender.openDevTools()),k.ipcMain.on("vscode:reloadWindow",he=>he.sender.reload())}validateNlsPath(fe){let we;for(const Le of fe)typeof Le=="string"&&(typeof we!="string"?we=Le:we=(0,V.join)(we,Le));if(!(typeof we!="string"||!(0,V.isAbsolute)(we)||!(0,de.isEqualOrParent)(we,this.environmentMainService.cachedLanguagesPath,!y.isLinux)))return ne.URI.file(we)}onUnexpectedError(fe){var we;if(fe){const Le={message:`[uncaught exception in main]: ${fe.message}`,stack:fe.stack};(we=this.windowsMainService)===null||we===void 0||we.sendToFocused("vscode:reportError",JSON.stringify(Le))}this.logService.error(`[uncaught exception in main]: ${fe}`),fe.stack&&this.logService.error(fe.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);try{const Me=ne.URI.file(this.environmentMainService.chromeCachedDataDir);this.logService.trace(`Deleting Chrome cached data path: ${Me.fsPath}`),await this.fileService.del(Me,{recursive:!0})}catch(Me){Me.fileOperationResult!==1&&this.logService.error(Me)}const fe=this.productService.win32AppUserModelId;y.isWindows&&fe&&k.app.setAppUserModelId(fe);try{y.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!k.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&k.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Me){this.logService.error(Me)}const we=new S.Server;this.logService.trace("Resolving machine identifier...");const Le=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Le}`);const{sharedProcess:he,sharedProcessReady:ke,sharedProcessClient:Se}=this.setupSharedProcess(Le),Pe=await this.initServices(Le,he,ke);if(this.environmentMainService.driverHandle){const Me=await(0,M.serve)(we,this.environmentMainService.driverHandle,this.environmentMainService,Pe);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Me)}this._register(Pe.createInstance(U.ProxyAuthHandler)),Pe.invokeFunction(Me=>this.initChannels(Me,we,Se));const De=Pe.invokeFunction(Me=>this.openFirstWindow(Me,we));Pe.invokeFunction(Me=>this.afterWindowOpen(Me,he)),this.environmentMainService.args.trace&&Pe.invokeFunction(Me=>this.stopTracingEventually(Me,De))}async resolveMachineId(){let fe=this.stateService.getItem(u.machineIdKey);return(!fe||y.isMacintosh&&fe==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(fe=await(0,$.getMachineId)(),this.stateService.setItem(u.machineIdKey,fe)),fe}setupSharedProcess(fe){const we=this._register(this.mainInstantiationService.createInstance(d.SharedProcess,fe,this.userEnv)),Le=(async()=>{this.logService.trace("Main->SharedProcess#connect");const ke=await we.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new v.Client(ke,"main")})(),he=(async()=>(await we.whenReady(),Le))();return{sharedProcess:we,sharedProcessReady:he,sharedProcessClient:Le}}async initServices(fe,we,Le){const he=new b.ServiceCollection;switch(process.platform){case"win32":he.set(i.IUpdateService,new a.SyncDescriptor(z.Win32UpdateService));break;case"linux":y.isLinuxSnap?he.set(i.IUpdateService,new a.SyncDescriptor(re.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):he.set(i.IUpdateService,new a.SyncDescriptor(C.LinuxUpdateService));break;case"darwin":he.set(i.IUpdateService,new a.SyncDescriptor(j.DarwinUpdateService));break}he.set(Q.IWindowsMainService,new a.SyncDescriptor(P.WindowsMainService,[fe,this.userEnv])),he.set(be.IDialogMainService,new a.SyncDescriptor(be.DialogMainService)),he.set(w.ILaunchMainService,new a.SyncDescriptor(w.LaunchMainService)),he.set(Ae.IDiagnosticsService,g.ProxyChannel.toService((0,g.getDelayedChannel)(Le.then(Se=>Se.getChannel("diagnostics"))))),he.set(N.IIssueMainService,new a.SyncDescriptor(N.IssueMainService,[this.userEnv])),he.set(K.IEncryptionMainService,new a.SyncDescriptor(K.EncryptionMainService,[fe])),he.set(oe.IKeyboardLayoutMainService,new a.SyncDescriptor(oe.KeyboardLayoutMainService)),he.set(me.INativeHostMainService,new a.SyncDescriptor(me.NativeHostMainService,[we])),he.set(Ze.IWebviewManagerService,new a.SyncDescriptor(Ge.WebviewMainService)),he.set(ae.IWorkspacesService,new a.SyncDescriptor(O.WorkspacesMainService)),he.set(Ee.IWorkspacesManagementMainService,new a.SyncDescriptor(Ee.WorkspacesManagementMainService)),he.set(ye.IWorkspacesHistoryMainService,new a.SyncDescriptor(ye.WorkspacesHistoryMainService)),he.set(F.IMenubarMainService,new a.SyncDescriptor(F.MenubarMainService)),he.set(Ie.IExtensionUrlTrustService,new a.SyncDescriptor(Oe.ExtensionUrlTrustService)),he.set(se.IStorageMainService,new a.SyncDescriptor(se.StorageMainService));const ke=new ie.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(he.set(ue.IBackupMainService,ke),he.set(n.IURLService,new a.SyncDescriptor(ge.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const Se=(0,g.getDelayedChannel)(Le.then($e=>$e.getChannel("telemetryAppender"))),Pe=new f.TelemetryAppenderClient(Se),De=(0,A.resolveCommonProperties)(this.fileService,(0,m.release)(),process.arch,this.productService.commit,this.productService.version,fe,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Me=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],We={appender:Pe,commonProperties:De,piiPaths:Me,sendErrorTelemetry:!0};he.set(u.ITelemetryService,new a.SyncDescriptor(E.TelemetryService,[We]))}else he.set(u.ITelemetryService,h.NullTelemetryService);return await ke.initialize(),this.mainInstantiationService.createChild(he)}initChannels(fe,we,Le){const he=g.ProxyChannel.fromService(fe.get(w.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",he);const ke=new D.UpdateChannel(fe.get(i.IUpdateService));we.registerChannel("update",ke);const Se=g.ProxyChannel.fromService(fe.get(N.IIssueMainService));we.registerChannel("issue",Se);const Pe=g.ProxyChannel.fromService(fe.get(K.IEncryptionMainService));we.registerChannel("encryption",Pe);const De=g.ProxyChannel.fromService(fe.get(qe.ISignService));we.registerChannel("sign",De);const Me=g.ProxyChannel.fromService(fe.get(oe.IKeyboardLayoutMainService));we.registerChannel("keyboardLayout",Me),this.nativeHostMainService=fe.get(me.INativeHostMainService);const We=g.ProxyChannel.fromService(this.nativeHostMainService);we.registerChannel("nativeHost",We),Le.then(He=>He.registerChannel("nativeHost",We));const $e=g.ProxyChannel.fromService(fe.get(ae.IWorkspacesService));we.registerChannel("workspaces",$e);const Ue=g.ProxyChannel.fromService(fe.get(F.IMenubarMainService));we.registerChannel("menubar",Ue);const Xe=g.ProxyChannel.fromService(fe.get(n.IURLService));we.registerChannel("url",Xe);const Re=g.ProxyChannel.fromService(fe.get(Ie.IExtensionUrlTrustService));we.registerChannel("extensionUrlTrust",Re);const Ye=g.ProxyChannel.fromService(fe.get(Ze.IWebviewManagerService));we.registerChannel("webview",Ye);const Qe=this._register(new x.StorageDatabaseChannel(this.logService,fe.get(se.IStorageMainService)));we.registerChannel("storage",Qe),Le.then(He=>He.registerChannel("storage",Qe));const je=new T.LogLevelChannel(fe.get(c.ILogService));we.registerChannel("logLevel",je),Le.then(He=>He.registerChannel("logLevel",je));const et=new T.LoggerChannel(fe.get(c.ILoggerService));we.registerChannel("logger",et),Le.then(He=>He.registerChannel("logger",et));const nt=new ve.ElectronExtensionHostDebugBroadcastChannel(fe.get(Q.IWindowsMainService));we.registerChannel("extensionhostdebugservice",nt)}openFirstWindow(fe,we){const Le=this.windowsMainService=fe.get(Q.IWindowsMainService),he=fe.get(n.IURLService),ke=fe.get(me.INativeHostMainService);this.lifecycleMainService.phase=2;const Se=[],Pe=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Be=>{try{return{uri:ne.URI.parse(Be),url:Be}}catch(Je){return null}}).filter(Be=>{if(!Be||this.shouldBlockURI(Be.uri))return!1;const Je=this.getWindowOpenableFromProtocolLink(Be.uri);return Je?(Se.push(Je),!1):!0}),De=this,Me=this.environmentMainService;he.registerHandler({async handleURL(Be,Je){if(De.shouldBlockURI(Be))return!0;const mt=De.getWindowOpenableFromProtocolLink(Be);if(mt){const[lt]=Le.open({context:5,cli:Object.assign({},Me.args),urisToOpen:[mt],gotoLineMode:!0});return lt.focus(),!0}if(y.isMacintosh&&Le.getWindowCount()===0){const[lt]=Le.open({context:5,cli:Object.assign({},Me.args),forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Ne.getRemoteAuthority)(Be)});return await lt.ready(),he.open(Be,Je)}return!1}});const We=this._register(new te.ActiveWindowManager({onDidOpenWindow:ke.onDidOpenWindow,onDidFocusWindow:ke.onDidFocusWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),$e=new g.StaticRouter(Be=>We.getActiveClientId().then(Je=>Be===Je)),Ue=new o.URLHandlerRouter($e),Xe=we.getChannel("urlHandler",Ue);he.registerHandler(new o.URLHandlerChannelClient(Xe)),this._register(new W.ElectronURLListener(Pe,he,Le,this.environmentMainService,this.productService));const Re=this.environmentMainService.args,Ye=global.macOpenFiles,Qe=(0,le.isLaunchedFromCli)(process.env)?0:4,je=Re._.length,et=!!Re["folder-uri"],nt=!!Re["file-uri"],He=Re["skip-add-to-recently-opened"]===!0,at=Re.wait&&Re.waitMarkerFilePath?ne.URI.file(Re.waitMarkerFilePath):void 0,gt=Re.remote||void 0;return Se.length>0?Le.open({context:Qe,cli:Re,urisToOpen:Se,gotoLineMode:!0,initialStartup:!0}):Re["new-window"]&&!je&&!et&&!nt?Le.open({context:Qe,cli:Re,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:He,waitMarkerFileURI:at,initialStartup:!0,remoteAuthority:gt}):Ye.length&&!je&&!et&&!nt?Le.open({context:1,cli:Re,urisToOpen:Ye.map(Be=>this.getWindowOpenableFromPathSync(Be)),noRecentEntry:He,waitMarkerFileURI:at,initialStartup:!0}):Le.open({context:Qe,cli:Re,forceNewWindow:Re["new-window"]||!je&&Re["unity-launch"],diffMode:Re.diff,noRecentEntry:He,waitMarkerFileURI:at,gotoLineMode:Re.goto,initialStartup:!0,remoteAuthority:gt})}shouldBlockURI(fe){return!!(fe.authority===Z.Schemas.file&&y.isWindows&&k.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,_e.mnemonicButtonLabel)((0,Y.localize)(0,null)),(0,_e.mnemonicButtonLabel)((0,Y.localize)(1,null))],cancelId:1,message:(0,Y.localize)(2,null,(0,_e.getPathLabel)(fe.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,Y.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(fe){if(!!fe.path){if(fe.authority===Z.Schemas.file)return{fileUri:ne.URI.file(fe.fsPath)};if(fe.authority===Z.Schemas.vscodeRemote){const we=fe.path.indexOf(V.posix.sep,1);if(we!==-1){const Le=fe.path.substring(1,we),he=fe.path.substring(we),ke=ne.URI.from({scheme:Z.Schemas.vscodeRemote,authority:Le,path:he,query:fe.query,fragment:fe.fragment});return(0,ae.hasWorkspaceFileExtension)(he)?{workspaceUri:ke}:{folderUri:ke}}}}}getWindowOpenableFromPathSync(fe){try{if((0,L.statSync)(fe).isDirectory())return{folderUri:ne.URI.file(fe)};if((0,ae.hasWorkspaceFileExtension)(fe))return{workspaceUri:ne.URI.file(fe)}}catch(we){}return{fileUri:ne.URI.file(fe)}}async afterWindowOpen(fe,we){var Le;this.lifecycleMainService.phase=3;const he=fe.get(u.ITelemetryService);this._register(we.onDidError(({type:Pe,details:De})=>{let Me;typeof De=="string"?Me=De:Me=`SharedProcess: crashed (detail: ${De.reason})`,(0,R.onUnexpectedError)(new Error(Me)),he.publicLog2("sharedprocesserror",{type:Pe,reason:typeof De!="string"?De==null?void 0:De.reason:void 0,visible:we.isVisible()})}));const ke=this.productService.win32MutexName;if(y.isWindows&&ke)try{const Pe=q.__$__nodeRequire("windows-mutex").Mutex,De=new Pe(ke);(0,Ce.once)(this.lifecycleMainService.onWillShutdown)(()=>De.release())}catch(Pe){this.logService.error(Pe)}k.protocol.registerHttpProtocol(Z.Schemas.vscodeRemoteResource,(Pe,De)=>{De({url:Pe.url.replace(/^vscode-remote-resource:/,"http:"),method:Pe.method})});const Se=fe.get(i.IUpdateService);(Se instanceof z.Win32UpdateService||Se instanceof C.LinuxUpdateService||Se instanceof j.DarwinUpdateService)&&Se.initialize(),(0,p.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env);try{const De=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,st.stripComments)(De))["enable-crash-reporter"]===void 0){const We=(Le=this.configurationService.getValue("telemetry.enableCrashReporter"))!==null&&Le!==void 0?Le:!0,$e=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${We},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,ze.generateUuid)()}"`,"}"],Ue=De.substring(0,De.length-2).concat(`,
`,$e.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,it.VSBuffer.fromString(Ue))}}catch(Pe){this.logService.error(Pe)}}stopTracingEventually(fe,we){this.logService.info("Tracing: waiting for windows to get ready...");const Le=fe.get(be.IDialogMainService);let he=!1;const ke=async Pe=>{if(!he){he=!0;const De=await k.contentTracing.stopRecording((0,G.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Pe?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${De}`):Le.showMessageBox({type:"info",message:(0,Y.localize)(4,null),detail:(0,Y.localize)(5,null,De),buttons:[(0,Y.localize)(6,null)]},(0,Te.withNullAsUndefined)(k.BrowserWindow.getFocusedWindow()))}},Se=setTimeout(()=>ke(!0),3e4);Promise.all(we.map(Pe=>Pe.ready())).then(()=>{clearTimeout(Se),ke(!1)})}};ot=ce([ee(2,I.IInstantiationService),ee(3,c.ILogService),ee(4,s.IEnvironmentMainService),ee(5,r.ILifecycleMainService),ee(6,t.IConfigurationService),ee(7,l.IStateService),ee(8,Ke.IFileService),ee(9,_.IProductService)],ot),e.CodeApplication=ot}),define(X[234],J([0,1,13,18,11,3,71,54,53,156,16,33,56,168,70,67,6,190,38,21,182,48,218,230,39,93,92,17,75,42,74,188,192,172,173,10,24,73,216,20,30,22,8,35,26,66,95,176,32,55,179,198]),function(q,e,m,L,k,y,P,r,p,i,D,g,S,v,d,w,I,b,a,c,l,s,t,n,o,u,h,f,E,A,_,U,H,Q,ne,ae,O,$,z,C,j,N,T,R,W,M,F,B,V,G,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Z{main(){try{this.startup()}catch(x){console.error(x.message),m.app.exit(1)}}async startup(){(0,f.setUnexpectedErrorHandler)(ve=>console.error(ve));const[x,ie,ue,ye,ge,Ee,Ae]=this.createServices();try{try{await this.initServices(ue,ye,ge)}catch(ve){throw this.handleStartupDataDirError(ue,Ae.nameLong,ve),ve}await x.invokeFunction(async ve=>{const me=ve.get(I.ILogService),be=ve.get(D.ILifecycleMainService),Te=ve.get(O.IFileService),_e=await this.claimInstance(me,ue,be,x,Ae,!0);return Ee.logger=new u.SpdLogLogger("main",(0,T.join)(ue.logsPath,"main.log"),!0,Ee.getLevel()),(0,A.once)(be.onWillShutdown)(()=>{Te.dispose(),ye.dispose()}),x.createInstance(n.CodeApplication,_e,ie).startup()})}catch(ve){x.invokeFunction(this.quit,ve)}}createServices(){const x=new d.ServiceCollection,ie=Object.assign({_serviceBrand:void 0},r.default);x.set(C.IProductService,ie);const ue=new W.EnvironmentMainService(this.resolveArgs(),ie),ye=this.patchEnvironment(ue);x.set(W.IEnvironmentMainService,ue);const ge=new h.BufferLogService,Ee=new I.MultiplexLogService([new I.ConsoleMainLogger((0,I.getLogLevel)(ue)),ge]);process.once("exit",()=>Ee.dispose()),x.set(I.ILogService,Ee);const Ae=new Q.FileService(Ee);x.set(O.IFileService,Ae);const ve=new ne.DiskFileSystemProvider(Ee);Ae.registerProvider(ae.Schemas.file,ve),x.set(I.ILoggerService,new B.LoggerService(Ee,Ae));const me=new l.ConfigurationService(ue.settingsResource,Ae);x.set(c.IConfigurationService,me),x.set(D.ILifecycleMainService,new w.SyncDescriptor(D.LifecycleMainService));const be=new b.StateService(ue,Ee);return x.set(a.IStateService,be),x.set(s.IRequestService,new w.SyncDescriptor(t.RequestMainService)),x.set(E.IThemeMainService,new w.SyncDescriptor(E.ThemeMainService)),x.set(_.ISignService,new w.SyncDescriptor(U.SignService)),x.set($.ITunnelService,new w.SyncDescriptor(z.TunnelService)),x.set(G.IProtocolMainService,new w.SyncDescriptor(Y.ProtocolMainService)),[new v.InstantiationService(x,!0),ye,ue,me,be,ge,ie]}patchEnvironment(x){const ie={VSCODE_IPC_HOOK:x.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const ye=process.env[ue];typeof ye=="string"&&(ie[ue]=ye)}),Object.assign(process.env,ie),ie}initServices(x,ie,ue){const ye=Promise.all([x.extensionsPath,x.nodeCachedDataDir,x.logsPath,x.globalStorageHome.fsPath,x.workspaceStorageHome.fsPath,x.backupHome].map(Ae=>Ae?L.promises.mkdir(Ae,{recursive:!0}):void 0)),ge=ie.initialize(),Ee=ue.init();return Promise.all([ye,ge,Ee])}async claimInstance(x,ie,ue,ye,ge,Ee){let Ae;try{(0,P.mark)("code/willStartMainServer"),Ae=await(0,S.serve)(ie.mainIPCHandle),(0,P.mark)("code/didStartMainServer"),(0,A.once)(ue.onWillShutdown)(()=>Ae.dispose())}catch(ve){if(ve.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ie,ge.nameLong,ve),ve;let me;try{me=await(0,S.connect)(ie.mainIPCHandle,"main")}catch(_e){if(!Ee||y.isWindows||_e.code!=="ECONNREFUSED")throw _e.code==="EPERM"&&this.showStartupWarningDialog((0,k.localize)(0,null,ge.nameShort),(0,k.localize)(1,null),ge.nameLong),_e;try{(0,L.unlinkSync)(ie.mainIPCHandle)}catch(Ge){throw x.warn("Could not delete obsolete instance handle",Ge),Ge}return this.claimInstance(x,ie,ue,ye,ge,!1)}if(ie.extensionTestsLocationURI&&!ie.debugExtensionHost.break){const _e="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw x.error(_e),me.dispose(),new Error(_e)}let be;!ie.args.wait&&!ie.args.status&&(be=setTimeout(()=>{this.showStartupWarningDialog((0,k.localize)(2,null,ge.nameShort),(0,k.localize)(3,null),ge.nameLong)},1e4));const Te=g.ProxyChannel.toService(me.getChannel("launch"),{disableMarshalling:!0});if(ie.args.status)return ye.invokeFunction(async()=>{const _e=new H.DiagnosticsService(F.NullTelemetryService,ge),Ge=await Te.getMainProcessInfo(),Ze=await Te.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ke=await _e.getDiagnostics(Ge,Ze);throw console.log(Ke),new f.ExpectedError});throw y.isWindows&&await this.windowsAllowSetForegroundWindow(Te,x),x.trace("Sending env to running instance..."),await Te.start(ie.args,process.env),me.dispose(),be&&clearTimeout(be),new f.ExpectedError("Sent env to running instance. Terminating...")}if(ie.args.status)throw x.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ae}handleStartupDataDirError(x,ie,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const ye=(0,R.coalesce)([x.userDataPath,x.extensionsPath,S.XDG_RUNTIME_DIR]).map(ge=>(0,o.getPathLabel)(ge,x));this.showStartupWarningDialog((0,k.localize)(4,null),(0,k.localize)(5,null,(0,M.toErrorMessage)(ue),ye.join(`
`)),ie)}}showStartupWarningDialog(x,ie,ue){m.dialog.showMessageBoxSync({title:ue,type:"warning",buttons:[(0,o.mnemonicButtonLabel)((0,k.localize)(6,null))],message:x,detail:ie,noLink:!0})}async windowsAllowSetForegroundWindow(x,ie){if(y.isWindows){const ue=await x.getMainProcessId();ie.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((ye,ge)=>{q(["windows-foreground-love"],ye,ge)})).allowSetForegroundWindow(ue)}catch(ye){ie.error(ye)}}}quit(x,ie){const ue=x.get(I.ILogService),ye=x.get(D.ILifecycleMainService);let ge=0;ie&&(ie.isExpected?ie.message&&ue.trace(ie.message):(ge=1,ie.stack?ue.error(ie.stack):ue.error(`Startup error: ${ie.toString()}`))),ye.kill(ge)}resolveArgs(){const x=this.validatePaths((0,p.parseMainProcessArgv)(process.argv));if(x.wait&&!x.waitMarkerFilePath){const ie=(0,i.createWaitMarkerFile)(x.verbose);ie&&((0,p.addArg)(process.argv,"--waitMarkerFilePath",ie),x.waitMarkerFilePath=ie)}return x}validatePaths(x){if(x["open-url"]&&(x._urls=x._,x._=[]),!x.remote){const ie=this.doValidatePaths(x._,x.goto);x._=ie}return x}doValidatePaths(x,ie){const ue=(0,V.cwd)(),ye=x.map(Ae=>{let ve=String(Ae),me;ie&&(me=(0,j.parseLineAndColumnAware)(ve),ve=me.path),ve&&(ve=this.preparePath(ue,ve));const be=(0,j.sanitizeFilePath)(ve,ue),Te=(0,T.basename)(be);return Te&&!(0,j.isValidBasename)(Te)?null:ie&&me?(me.path=be,this.toPath(me)):be}),ge=y.isWindows||y.isMacintosh,Ee=(0,R.distinct)(ye,Ae=>Ae&&ge?Ae.toLowerCase():Ae||"");return(0,R.coalesce)(Ee)}preparePath(x,ie){return y.isWindows&&(ie=(0,N.rtrim)(ie,'"')),ie=(0,N.trim)((0,N.trim)(ie," "),"	"),y.isWindows&&(ie=(0,T.resolve)(x,ie),ie=(0,N.rtrim)(ie,".")),ie}toPath(x){const ie=[x.path];return typeof x.line=="number"&&ie.push(String(x.line)),typeof x.column=="number"&&ie.push(String(x.column)),ie.join(":")}}new Z().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/25785b97e533b15ae3b12e48aaf4187416437e62/core/vs/code/electron-main/main.js.map
