/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/base/common/uri","vs/base/common/network","vs/base/common/event","vs/base/node/pfs","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/platform","fs","vs/base/common/buffer","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/objects","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","os","child_process","vs/base/common/process","vs/base/common/stream","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/node/zip","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/request/common/request","vs/platform/product/common/product","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","util","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","vs/base/common/performance","vs/base/common/iterator","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],Z=function($){for(var t=[],v=0,C=$.length;v<C;v++)t[v]=Q[$[v]];return t};define(Q[56],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function v(C,I){if(!C)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}t.ok=v}),define(Q[57],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createMemoizer=t.createDecorator=void 0;function v(h){return(f,O,d)=>{let y=null,D=null;if(typeof d.value=="function"?(y="value",D=d.value):typeof d.get=="function"&&(y="get",D=d.get),!D)throw new Error("not supported");d[y]=h(D,O)}}t.createDecorator=v;let C=0;function I(){const h=`$memoize${C++}`;let f;const O=function(y,D,a){let m=null,S=null;if(typeof a.value=="function"?(m="value",S=a.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(m="get",S=a.get),!S)throw new Error("not supported");const E=`${h}:${D}`;a[m]=function(...b){return f=this,this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!0,enumerable:!1,writable:!0,value:S.apply(this,b)}),this[E]}};return O.clear=()=>{typeof f!="undefined"&&Object.getOwnPropertyNames(f).forEach(d=>{d.indexOf(h)===0&&delete f[d]})},O}t.createMemoizer=I;function w(h,f,O){return I()(h,f,O)}t.memoize=w;function T(h,f,O){return v((d,y)=>{const D=`$debounce$${y}`,a=`$debounce$result$${y}`;return function(...m){this[a]||(this[a]=O?O():void 0),clearTimeout(this[D]),f&&(this[a]=f(this[a],...m),m=[this[a]]),this[D]=setTimeout(()=>{d.apply(this,m),this[a]=O?O():void 0},h)}})}t.debounce=T;function R(h,f,O){return v((d,y)=>{const D=`$throttle$timer$${y}`,a=`$throttle$result$${y}`,m=`$throttle$lastRun$${y}`,S=`$throttle$pending$${y}`;return function(...E){if(this[a]||(this[a]=O?O():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),f&&(this[a]=f(this[a],...E)),!this[S]){const b=this[m]+h;b<=Date.now()?(this[m]=Date.now(),d.apply(this,[this[a]]),this[a]=O?O():void 0):(this[S]=!0,this[D]=setTimeout(()=>{this[S]=!1,this[m]=Date.now(),d.apply(this,[this[a]]),this[a]=O?O():void 0},b-Date.now()))}}})}t.throttle=R}),define(Q[23],Z([0,1,14]),function($,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function C(W,G=0){return W[W.length-(1+G)]}t.tail=C;function I(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}t.tail2=I;function w(W,G,_=(c,u)=>c===u){if(W===G)return!0;if(!W||!G||W.length!==G.length)return!1;for(let c=0,u=W.length;c<u;c++)if(!_(W[c],G[c]))return!1;return!0}t.equals=w;function T(W,G,_){let c=0,u=W.length-1;for(;c<=u;){const P=(c+u)/2|0,L=_(W[P],G);if(L<0)c=P+1;else if(L>0)u=P-1;else return P}return-(c+1)}t.binarySearch=T;function R(W,G){let _=0,c=W.length;if(c===0)return 0;for(;_<c;){const u=Math.floor((_+c)/2);G(W[u])?c=u:_=u+1}return _}t.findFirstInSorted=R;function h(W,G,_){if(W=W|0,W>=G.length)throw new TypeError("invalid index");let c=G[Math.floor(G.length*Math.random())],u=[],P=[],L=[];for(let k of G){const M=_(k,c);M<0?u.push(k):M>0?P.push(k):L.push(k)}return W<u.length?h(W,u,_):W<u.length+L.length?L[0]:h(W-(u.length+L.length),P,_)}t.quickSelect=h;function f(W,G){const _=[];let c;for(const u of W.slice(0).sort(G))!c||G(c[0],u)!==0?(c=[u],_.push(c)):c.push(u);return _}t.groupBy=f;function O(W,G,_){const c=[];function u(k,M,z){if(!(M===0&&z.length===0)){const B=c[c.length-1];B&&B.start+B.deleteCount===k?(B.deleteCount+=M,B.toInsert.push(...z)):c.push({start:k,deleteCount:M,toInsert:z})}}let P=0,L=0;for(;;){if(P===W.length){u(P,0,G.slice(L));break}if(L===G.length){u(P,W.length-P,[]);break}const k=W[P],M=G[L],z=_(k,M);z===0?(P+=1,L+=1):z<0?(u(P,1,[]),P+=1):z>0&&(u(P,0,[M]),L+=1)}return c}t.sortedDiff=O;function d(W,G,_){const c=O(W,G,_),u=[],P=[];for(const L of c)u.push(...W.slice(L.start,L.start+L.deleteCount)),P.push(...L.toInsert);return{removed:u,added:P}}t.delta=d;function y(W,G,_){if(_===0)return[];const c=W.slice(0,_).sort(G);return a(W,G,c,_,W.length),c}t.top=y;function D(W,G,_,c,u){return _===0?Promise.resolve([]):new Promise((P,L)=>{(async()=>{const k=W.length,M=W.slice(0,_).sort(G);for(let z=_,B=Math.min(_+c,k);z<k;z=B,B=Math.min(B+c,k)){if(z>_&&await new Promise(q=>setTimeout(q)),u&&u.isCancellationRequested)throw(0,v.canceled)();a(W,G,M,z,B)}return M})().then(P,L)})}t.topAsync=D;function a(W,G,_,c,u){for(const P=_.length;c<u;c++){const L=W[c];if(G(L,_[P-1])<0){_.pop();const k=R(_,M=>G(L,M)<0);_.splice(k,0,L)}}}function m(W){return W.filter(G=>!!G)}t.coalesce=m;function S(W){let G=0;for(let _=0;_<W.length;_++)W[_]&&(W[G]=W[_],G+=1);W.length=G}t.coalesceInPlace=S;function E(W,G,_){W.splice(_,0,W.splice(G,1)[0])}t.move=E;function b(W){return!Array.isArray(W)||W.length===0}t.isFalsyOrEmpty=b;function p(W){return Array.isArray(W)&&W.length>0}t.isNonEmptyArray=p;function l(W,G){if(!G)return W.filter((c,u)=>W.indexOf(c)===u);const _=Object.create(null);return W.filter(c=>{const u=G(c);return _[u]?!1:(_[u]=!0,!0)})}t.distinct=l;function r(W){const G=new Set;return W.filter(_=>G.has(_)?!1:(G.add(_),!0))}t.distinctES6=r;function e(W){const G=Object.create(null);return _=>{const c=W(_);return G[c]?!1:(G[c]=!0,!0)}}t.uniqueFilter=e;function i(W,G){for(let _=W.length-1;_>=0;_--){const c=W[_];if(G(c))return _}return-1}t.lastIndex=i;function n(W,G){return W.length>0?W[0]:G}t.firstOrDefault=n;function s(W,G,_=(c,u)=>c===u){let c=0;for(let u=0,P=Math.min(W.length,G.length);u<P&&_(W[u],G[u]);u++)c++;return c}t.commonPrefixLength=s;function o(W){return[].concat(...W)}t.flatten=o;function g(W,G){let _=typeof G=="number"?W:0;typeof G=="number"?_=W:(_=0,G=W);const c=[];if(_<=G)for(let u=_;u<G;u++)c.push(u);else for(let u=_;u>G;u--)c.push(u);return c}t.range=g;function F(W,G,_){return W.reduce((c,u)=>(c[G(u)]=_?_(u):u,c),Object.create(null))}t.index=F;function j(W,G){return W.push(G),()=>N(W,G)}t.insert=j;function N(W,G){const _=W.indexOf(G);if(_>-1)return W.splice(_,1),G}t.remove=N;function A(W,G,_){const c=W.slice(0,G),u=W.slice(G);return c.concat(_,u)}t.arrayInsert=A;function U(W,G){let _;if(typeof G=="number"){let c=G;_=()=>{const u=Math.sin(c++)*179426549;return u-Math.floor(u)}}else _=Math.random;for(let c=W.length-1;c>0;c-=1){const u=Math.floor(_()*(c+1)),P=W[c];W[c]=W[u],W[u]=P}}t.shuffle=U;function x(W,G){const _=W.indexOf(G);_>-1&&(W.splice(_,1),W.unshift(G))}t.pushToStart=x;function X(W,G){const _=W.indexOf(G);_>-1&&(W.splice(_,1),W.push(G))}t.pushToEnd=X;function ne(W,G){return Array.isArray(W)?W.map(G):G(W)}t.mapArrayOrNot=ne;function ee(W){return Array.isArray(W)?W:[W]}t.asArray=ee;function te(W){return W[Math.floor(Math.random()*W.length)]}t.getRandomElement=te;function ae(W,G){for(const _ of W){const c=G(_);if(c!==void 0)return c}}t.mapFind=ae}),define(Q[58],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var v;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(v=t.ScanError||(t.ScanError={}));var C;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(C=t.SyntaxKind||(t.SyntaxKind={}));var I;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(I=t.ParseErrorCode||(t.ParseErrorCode={}));var w;(function(e){e.DEFAULT={allowTrailingComma:!0}})(w=t.ParseOptions||(t.ParseOptions={}));function T(e,i=!1){let n=0,s=e.length,o="",g=0,F=16,j=0;function N(te){let ae=0,W=0;for(;ae<te;){const G=e.charCodeAt(n);if(G>=48&&G<=57)W=W*16+G-48;else if(G>=65&&G<=70)W=W*16+G-65+10;else if(G>=97&&G<=102)W=W*16+G-97+10;else break;n++,ae++}return ae<te&&(W=-1),W}function A(te){n=te,o="",g=0,F=16,j=0}function U(){const te=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&f(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&f(e.charCodeAt(n)))for(n++;n<e.length&&f(e.charCodeAt(n));)n++;else return j=3,e.substring(te,n);let ae=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&f(e.charCodeAt(n))){for(n++;n<e.length&&f(e.charCodeAt(n));)n++;ae=n}else j=3;return e.substring(te,ae)}function x(){let te="",ae=n;for(;;){if(n>=s){te+=e.substring(ae,n),j=2;break}const W=e.charCodeAt(n);if(W===34){te+=e.substring(ae,n),n++;break}if(W===92){if(te+=e.substring(ae,n),n++,n>=s){j=2;break}switch(e.charCodeAt(n++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:const _=N(4);_>=0?te+=String.fromCharCode(_):j=4;break;default:j=5}ae=n;continue}if(W>=0&&W<=31)if(h(W)){te+=e.substring(ae,n),j=2;break}else j=6;n++}return te}function X(){if(o="",j=0,g=n,n>=s)return g=s,F=17;let te=e.charCodeAt(n);if(R(te)){do n++,o+=String.fromCharCode(te),te=e.charCodeAt(n);while(R(te));return F=15}if(h(te))return n++,o+=String.fromCharCode(te),te===13&&e.charCodeAt(n)===10&&(n++,o+=`
`),F=14;switch(te){case 123:return n++,F=1;case 125:return n++,F=2;case 91:return n++,F=3;case 93:return n++,F=4;case 58:return n++,F=6;case 44:return n++,F=5;case 34:return n++,o=x(),F=10;case 47:const ae=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<s&&!h(e.charCodeAt(n));)n++;return o=e.substring(ae,n),F=12}if(e.charCodeAt(n+1)===42){n+=2;const W=s-1;let G=!1;for(;n<W;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,G=!0;break}n++}return G||(n++,j=1),o=e.substring(ae,n),F=13}return o+=String.fromCharCode(te),n++,F=16;case 45:if(o+=String.fromCharCode(te),n++,n===s||!f(e.charCodeAt(n)))return F=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=U(),F=11;default:for(;n<s&&ne(te);)n++,te=e.charCodeAt(n);if(g!==n){switch(o=e.substring(g,n),o){case"true":return F=8;case"false":return F=9;case"null":return F=7}return F=16}return o+=String.fromCharCode(te),n++,F=16}}function ne(te){if(R(te)||h(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ee(){let te;do te=X();while(te>=12&&te<=15);return te}return{setPosition:A,getPosition:()=>n,scan:i?ee:X,getToken:()=>F,getTokenValue:()=>o,getTokenOffset:()=>g,getTokenLength:()=>n-g,getTokenError:()=>j}}t.createScanner=T;function R(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function h(e){return e===10||e===13||e===8232||e===8233}function f(e){return e>=48&&e<=57}var O;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(O||(O={}));function d(e,i){const n=[],s=new Object;let o;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let F=!1;function j(N,A,U,x){g.value=N,g.offset=A,g.length=U,g.type=x,g.colonOffset=void 0,o=g}try{p(e,{onObjectBegin:(N,A)=>{if(i<=N)throw s;o=void 0,F=i>N,n.push("")},onObjectProperty:(N,A,U)=>{if(i<A||(j(N,A,U,"property"),n[n.length-1]=N,i<=A+U))throw s},onObjectEnd:(N,A)=>{if(i<=N)throw s;o=void 0,n.pop()},onArrayBegin:(N,A)=>{if(i<=N)throw s;o=void 0,n.push(0)},onArrayEnd:(N,A)=>{if(i<=N)throw s;o=void 0,n.pop()},onLiteralValue:(N,A,U)=>{if(i<A||(j(N,A,U,r(N)),i<=A+U))throw s},onSeparator:(N,A,U)=>{if(i<=A)throw s;if(N===":"&&o&&o.type==="property")o.colonOffset=A,F=!1,o=void 0;else if(N===","){const x=n[n.length-1];typeof x=="number"?n[n.length-1]=x+1:(F=!0,n[n.length-1]=""),o=void 0}}})}catch(N){if(N!==s)throw N}return{path:n,previousNode:o,isAtPropertyKey:F,matches:N=>{let A=0;for(let U=0;A<N.length&&U<n.length;U++)if(N[A]===n[U]||N[A]==="*")A++;else if(N[A]!=="**")return!1;return A===N.length}}}t.getLocation=d;function y(e,i=[],n=w.DEFAULT){let s=null,o=[];const g=[];function F(N){Array.isArray(o)?o.push(N):s!==null&&(o[s]=N)}return p(e,{onObjectBegin:()=>{const N={};F(N),g.push(o),o=N,s=null},onObjectProperty:N=>{s=N},onObjectEnd:()=>{o=g.pop()},onArrayBegin:()=>{const N=[];F(N),g.push(o),o=N,s=null},onArrayEnd:()=>{o=g.pop()},onLiteralValue:F,onError:(N,A,U)=>{i.push({error:N,offset:A,length:U})}},n),o[0]}t.parse=y;function D(e,i=[],n=w.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(N){s.type==="property"&&(s.length=N-s.offset,s=s.parent)}function g(N){return s.children.push(N),N}p(e,{onObjectBegin:N=>{s=g({type:"object",offset:N,length:-1,parent:s,children:[]})},onObjectProperty:(N,A,U)=>{s=g({type:"property",offset:A,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:N,offset:A,length:U,parent:s})},onObjectEnd:(N,A)=>{s.length=N+A-s.offset,s=s.parent,o(N+A)},onArrayBegin:(N,A)=>{s=g({type:"array",offset:N,length:-1,parent:s,children:[]})},onArrayEnd:(N,A)=>{s.length=N+A-s.offset,s=s.parent,o(N+A)},onLiteralValue:(N,A,U)=>{g({type:r(N),offset:A,length:U,parent:s,value:N}),o(A+U)},onSeparator:(N,A,U)=>{s.type==="property"&&(N===":"?s.colonOffset=A:N===","&&o(A))},onError:(N,A,U)=>{i.push({error:N,offset:A,length:U})}},n);const j=s.children[0];return j&&delete j.parent,j}t.parseTree=D;function a(e,i){if(!!e){let n=e;for(let s of i)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let o=!1;for(const g of n.children)if(Array.isArray(g.children)&&g.children[0].value===s){n=g.children[1],o=!0;break}if(!o)return}else{const o=s;if(n.type!=="array"||o<0||!Array.isArray(n.children)||o>=n.children.length)return;n=n.children[o]}return n}}t.findNodeAtLocation=a;function m(e){if(!e.parent||!e.parent.children)return[];const i=m(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=m;function S(e){switch(e.type){case"array":return e.children.map(S);case"object":const i=Object.create(null);for(let n of e.children){const s=n.children[1];s&&(i[n.children[0].value]=S(s))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=S;function E(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=E;function b(e,i,n=!1){if(E(e,i,n)){const s=e.children;if(Array.isArray(s))for(let o=0;o<s.length&&s[o].offset<=i;o++){const g=b(s[o],i,n);if(g)return g}return e}}t.findNodeAtOffset=b;function p(e,i,n=w.DEFAULT){const s=T(e,!1);function o(M){return M?()=>M(s.getTokenOffset(),s.getTokenLength()):()=>!0}function g(M){return M?z=>M(z,s.getTokenOffset(),s.getTokenLength()):()=>!0}const F=o(i.onObjectBegin),j=g(i.onObjectProperty),N=o(i.onObjectEnd),A=o(i.onArrayBegin),U=o(i.onArrayEnd),x=g(i.onLiteralValue),X=g(i.onSeparator),ne=o(i.onComment),ee=g(i.onError),te=n&&n.disallowComments,ae=n&&n.allowTrailingComma;function W(){for(;;){const M=s.scan();switch(s.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:te||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(M){case 12:case 13:te?G(10):ne();break;case 16:G(1);break;case 15:case 14:break;default:return M}}}function G(M,z=[],B=[]){if(ee(M),z.length+B.length>0){let q=s.getToken();for(;q!==17;){if(z.indexOf(q)!==-1){W();break}else if(B.indexOf(q)!==-1)break;q=W()}}}function _(M){const z=s.getTokenValue();return M?x(z):j(z),W(),!0}function c(){switch(s.getToken()){case 11:let M=0;try{M=JSON.parse(s.getTokenValue()),typeof M!="number"&&(G(2),M=0)}catch(z){G(2)}x(M);break;case 7:x(null);break;case 8:x(!0);break;case 9:x(!1);break;default:return!1}return W(),!0}function u(){return s.getToken()!==10?(G(3,[],[2,5]),!1):(_(!1),s.getToken()===6?(X(":"),W(),k()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function P(){F(),W();let M=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(M||G(4,[],[]),X(","),W(),s.getToken()===2&&ae)break}else M&&G(6,[],[]);u()||G(4,[],[2,5]),M=!0}return N(),s.getToken()!==2?G(7,[2],[]):W(),!0}function L(){A(),W();let M=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(M||G(4,[],[]),X(","),W(),s.getToken()===4&&ae)break}else M&&G(6,[],[]);k()||G(4,[],[4,5]),M=!0}return U(),s.getToken()!==4?G(8,[4],[]):W(),!0}function k(){switch(s.getToken()){case 3:return L();case 1:return P();case 10:return _(!0);default:return c()}}return W(),s.getToken()===17?n.allowEmptyContent?!0:(G(4,[],[]),!1):k()?(s.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}t.visit=p;function l(e,i){let n=T(e),s=[],o,g=0,F;do switch(F=n.getPosition(),o=n.scan(),o){case 12:case 13:case 17:g!==F&&s.push(e.substring(g,F)),i!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,i)),g=n.getPosition();break}while(o!==17);return s.join("")}t.stripComments=l;function r(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=r});"use strict";(function(){function $(I){const w=[];typeof I=="number"&&w.push("code/timeOrigin",I);function T(h){w.push(h,Date.now())}function R(){const h=[];for(let f=0;f<w.length;f+=2)h.push({name:w[f],startTime:w[f+1]});return h}return{mark:T,getMarks:R}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const w=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const T of performance.getEntriesByType("mark"))w.push({name:T.name,startTime:Math.round(I+T.startTime)});return w}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function v(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=t()),I.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=v(C))})(),function($,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var v=t();for(var C in v)(typeof exports=="object"?exports:$)[C]=v[C]}}(typeof self!="undefined"?self:this,function(){return function($){var t={};function v(C){if(t[C])return t[C].exports;var I=t[C]={i:C,l:!1,exports:{}};return $[C].call(I.exports,I,I.exports,v),I.l=!0,I.exports}return v.m=$,v.c=t,v.d=function(C,I,w){v.o(C,I)||Object.defineProperty(C,I,{enumerable:!0,get:w})},v.r=function(C){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},v.t=function(C,I){if(1&I&&(C=v(C)),8&I||4&I&&typeof C=="object"&&C&&C.__esModule)return C;var w=Object.create(null);if(v.r(w),Object.defineProperty(w,"default",{enumerable:!0,value:C}),2&I&&typeof C!="string")for(var T in C)v.d(w,T,function(R){return C[R]}.bind(null,T));return w},v.n=function(C){var I=C&&C.__esModule?function(){return C.default}:function(){return C};return v.d(I,"a",I),I},v.o=function(C,I){return Object.prototype.hasOwnProperty.call(C,I)},v.p="",v(v.s=0)}([function($,t,v){(function(C){var I;t=$.exports=B,I=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var w=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,R=t.re=[],h=t.src=[],f=0,O=f++;h[O]="0|[1-9]\\d*";var d=f++;h[d]="[0-9]+";var y=f++;h[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var D=f++;h[D]="("+h[O]+")\\.("+h[O]+")\\.("+h[O]+")";var a=f++;h[a]="("+h[d]+")\\.("+h[d]+")\\.("+h[d]+")";var m=f++;h[m]="(?:"+h[O]+"|"+h[y]+")";var S=f++;h[S]="(?:"+h[d]+"|"+h[y]+")";var E=f++;h[E]="(?:-("+h[m]+"(?:\\."+h[m]+")*))";var b=f++;h[b]="(?:-?("+h[S]+"(?:\\."+h[S]+")*))";var p=f++;h[p]="[0-9A-Za-z-]+";var l=f++;h[l]="(?:\\+("+h[p]+"(?:\\."+h[p]+")*))";var r=f++,e="v?"+h[D]+h[E]+"?"+h[l]+"?";h[r]="^"+e+"$";var i="[v=\\s]*"+h[a]+h[b]+"?"+h[l]+"?",n=f++;h[n]="^"+i+"$";var s=f++;h[s]="((?:<|>)?=?)";var o=f++;h[o]=h[d]+"|x|X|\\*";var g=f++;h[g]=h[O]+"|x|X|\\*";var F=f++;h[F]="[v=\\s]*("+h[g]+")(?:\\.("+h[g]+")(?:\\.("+h[g]+")(?:"+h[E]+")?"+h[l]+"?)?)?";var j=f++;h[j]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[b]+")?"+h[l]+"?)?)?";var N=f++;h[N]="^"+h[s]+"\\s*"+h[F]+"$";var A=f++;h[A]="^"+h[s]+"\\s*"+h[j]+"$";var U=f++;h[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var x=f++;h[x]="(?:~>?)";var X=f++;h[X]="(\\s*)"+h[x]+"\\s+",R[X]=new RegExp(h[X],"g");var ne=f++;h[ne]="^"+h[x]+h[F]+"$";var ee=f++;h[ee]="^"+h[x]+h[j]+"$";var te=f++;h[te]="(?:\\^)";var ae=f++;h[ae]="(\\s*)"+h[te]+"\\s+",R[ae]=new RegExp(h[ae],"g");var W=f++;h[W]="^"+h[te]+h[F]+"$";var G=f++;h[G]="^"+h[te]+h[j]+"$";var _=f++;h[_]="^"+h[s]+"\\s*("+i+")$|^$";var c=f++;h[c]="^"+h[s]+"\\s*("+e+")$|^$";var u=f++;h[u]="(\\s*)"+h[s]+"\\s*("+i+"|"+h[F]+")",R[u]=new RegExp(h[u],"g");var P=f++;h[P]="^\\s*("+h[F]+")\\s+-\\s+("+h[F]+")\\s*$";var L=f++;h[L]="^\\s*("+h[j]+")\\s+-\\s+("+h[j]+")\\s*$";var k=f++;h[k]="(<|>)?=?\\s*\\*";for(var M=0;M<35;M++)I(M,h[M]),R[M]||(R[M]=new RegExp(h[M]));function z(V,H){if(V instanceof B)return V;if(typeof V!="string"||V.length>w||!(H?R[n]:R[r]).test(V))return null;try{return new B(V,H)}catch(K){return null}}function B(V,H){if(V instanceof B){if(V.loose===H)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>w)throw new TypeError("version is longer than "+w+" characters");if(!(this instanceof B))return new B(V,H);I("SemVer",V,H),this.loose=H;var K=V.trim().match(H?R[n]:R[r]);if(!K)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(se){if(/^[0-9]+$/.test(se)){var oe=+se;if(oe>=0&&oe<T)return oe}return se}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}t.parse=z,t.valid=function(V,H){var K=z(V,H);return K?K.version:null},t.clean=function(V,H){var K=z(V.trim().replace(/^[=v]+/,""),H);return K?K.version:null},t.SemVer=B,B.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},B.prototype.toString=function(){return this.version},B.prototype.compare=function(V){return I("SemVer.compare",this.version,this.loose,V),V instanceof B||(V=new B(V,this.loose)),this.compareMain(V)||this.comparePre(V)},B.prototype.compareMain=function(V){return V instanceof B||(V=new B(V,this.loose)),J(this.major,V.major)||J(this.minor,V.minor)||J(this.patch,V.patch)},B.prototype.comparePre=function(V){if(V instanceof B||(V=new B(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var H=0;do{var K=this.prerelease[H],se=V.prerelease[H];if(I("prerelease compare",H,K,se),K===void 0&&se===void 0)return 0;if(se===void 0)return 1;if(K===void 0)return-1;if(K!==se)return J(K,se)}while(++H)},B.prototype.inc=function(V,H){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},t.inc=function(V,H,K,se){typeof K=="string"&&(se=K,K=void 0);try{return new B(V,K).inc(H,se).version}catch(oe){return null}},t.diff=function(V,H){if(he(V,H))return null;var K=z(V),se=z(H);if(K.prerelease.length||se.prerelease.length){for(var oe in K)if((oe==="major"||oe==="minor"||oe==="patch")&&K[oe]!==se[oe])return"pre"+oe;return"prerelease"}for(var oe in K)if((oe==="major"||oe==="minor"||oe==="patch")&&K[oe]!==se[oe])return oe},t.compareIdentifiers=J;var q=/^[0-9]+$/;function J(V,H){var K=q.test(V),se=q.test(H);return K&&se&&(V=+V,H=+H),K&&!se?-1:se&&!K?1:V<H?-1:V>H?1:0}function Y(V,H,K){return new B(V,K).compare(new B(H,K))}function ie(V,H,K){return Y(V,H,K)>0}function re(V,H,K){return Y(V,H,K)<0}function he(V,H,K){return Y(V,H,K)===0}function ge(V,H,K){return Y(V,H,K)!==0}function De(V,H,K){return Y(V,H,K)>=0}function Oe(V,H,K){return Y(V,H,K)<=0}function Fe(V,H,K,se){var oe;switch(H){case"===":typeof V=="object"&&(V=V.version),typeof K=="object"&&(K=K.version),oe=V===K;break;case"!==":typeof V=="object"&&(V=V.version),typeof K=="object"&&(K=K.version),oe=V!==K;break;case"":case"=":case"==":oe=he(V,K,se);break;case"!=":oe=ge(V,K,se);break;case">":oe=ie(V,K,se);break;case">=":oe=De(V,K,se);break;case"<":oe=re(V,K,se);break;case"<=":oe=Oe(V,K,se);break;default:throw new TypeError("Invalid operator: "+H)}return oe}function Re(V,H){if(V instanceof Re){if(V.loose===H)return V;V=V.value}if(!(this instanceof Re))return new Re(V,H);I("comparator",V,H),this.loose=H,this.parse(V),this.semver===Me?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}t.rcompareIdentifiers=function(V,H){return J(H,V)},t.major=function(V,H){return new B(V,H).major},t.minor=function(V,H){return new B(V,H).minor},t.patch=function(V,H){return new B(V,H).patch},t.compare=Y,t.compareLoose=function(V,H){return Y(V,H,!0)},t.rcompare=function(V,H,K){return Y(H,V,K)},t.sort=function(V,H){return V.sort(function(K,se){return t.compare(K,se,H)})},t.rsort=function(V,H){return V.sort(function(K,se){return t.rcompare(K,se,H)})},t.gt=ie,t.lt=re,t.eq=he,t.neq=ge,t.gte=De,t.lte=Oe,t.cmp=Fe,t.Comparator=Re;var Me={};function ve(V,H){if(V instanceof ve)return V.loose===H?V:new ve(V.raw,H);if(V instanceof Re)return new ve(V.value,H);if(!(this instanceof ve))return new ve(V,H);if(this.loose=H,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function Se(V){return!V||V.toLowerCase()==="x"||V==="*"}function xe(V,H,K,se,oe,be,de,Ce,Ee,Le,ke,we,Ie){return((H=Se(K)?"":Se(se)?">="+K+".0.0":Se(oe)?">="+K+"."+se+".0":">="+H)+" "+(Ce=Se(Ee)?"":Se(Le)?"<"+(+Ee+1)+".0.0":Se(ke)?"<"+Ee+"."+(+Le+1)+".0":we?"<="+Ee+"."+Le+"."+ke+"-"+we:"<="+Ce)).trim()}function $e(V,H){for(var K=0;K<V.length;K++)if(!V[K].test(H))return!1;if(H.prerelease.length){for(K=0;K<V.length;K++)if(I(V[K].semver),V[K].semver!==Me&&V[K].semver.prerelease.length>0){var se=V[K].semver;if(se.major===H.major&&se.minor===H.minor&&se.patch===H.patch)return!0}return!1}return!0}function Ue(V,H,K){try{H=new ve(H,K)}catch(se){return!1}return H.test(V)}function ze(V,H,K,se){var oe,be,de,Ce,Ee;switch(V=new B(V,se),H=new ve(H,se),K){case">":oe=ie,be=Oe,de=re,Ce=">",Ee=">=";break;case"<":oe=re,be=De,de=ie,Ce="<",Ee="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(V,H,se))return!1;for(var Le=0;Le<H.set.length;++Le){var ke=H.set[Le],we=null,Ie=null;if(ke.forEach(function(Te){Te.semver===Me&&(Te=new Re(">=0.0.0")),we=we||Te,Ie=Ie||Te,oe(Te.semver,we.semver,se)?we=Te:de(Te.semver,Ie.semver,se)&&(Ie=Te)}),we.operator===Ce||we.operator===Ee||(!Ie.operator||Ie.operator===Ce)&&be(V,Ie.semver)||Ie.operator===Ee&&de(V,Ie.semver))return!1}return!0}Re.prototype.parse=function(V){var H=this.loose?R[_]:R[c],K=V.match(H);if(!K)throw new TypeError("Invalid comparator: "+V);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new B(K[2],this.loose):this.semver=Me},Re.prototype.toString=function(){return this.value},Re.prototype.test=function(V){return I("Comparator.test",V,this.loose),this.semver===Me||(typeof V=="string"&&(V=new B(V,this.loose)),Fe(V,this.operator,this.semver,this.loose))},Re.prototype.intersects=function(V,H){if(!(V instanceof Re))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new ve(V.value,H),Ue(this.value,K,H);if(V.operator==="")return K=new ve(this.value,H),Ue(V.semver,K,H);var se=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),oe=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),be=this.semver.version===V.semver.version,de=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Ce=Fe(this.semver,"<",V.semver,H)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ee=Fe(this.semver,">",V.semver,H)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return se||oe||be&&de||Ce||Ee},t.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(V){var H=this.loose;V=V.trim(),I("range",V,H);var K=H?R[L]:R[P];V=V.replace(K,xe),I("hyphen replace",V),V=V.replace(R[u],"$1$2$3"),I("comparator trim",V,R[u]),V=(V=(V=V.replace(R[X],"$1~")).replace(R[ae],"$1^")).split(/\s+/).join(" ");var se=H?R[_]:R[c],oe=V.split(" ").map(function(be){return function(de,Ce){return I("comp",de),de=function(Ee,Le){return Ee.trim().split(/\s+/).map(function(ke){return function(we,Ie){I("caret",we,Ie);var Te=Ie?R[G]:R[W];return we.replace(Te,function(Ae,le,fe,me,pe){var Pe;return I("caret",we,Ae,le,fe,me,pe),Se(le)?Pe="":Se(fe)?Pe=">="+le+".0.0 <"+(+le+1)+".0.0":Se(me)?Pe=le==="0"?">="+le+"."+fe+".0 <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+".0 <"+(+le+1)+".0.0":pe?(I("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Pe=le==="0"?fe==="0"?">="+le+"."+fe+"."+me+pe+" <"+le+"."+fe+"."+(+me+1):">="+le+"."+fe+"."+me+pe+" <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+"."+me+pe+" <"+(+le+1)+".0.0"):(I("no pr"),Pe=le==="0"?fe==="0"?">="+le+"."+fe+"."+me+" <"+le+"."+fe+"."+(+me+1):">="+le+"."+fe+"."+me+" <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+"."+me+" <"+(+le+1)+".0.0"),I("caret return",Pe),Pe})}(ke,Le)}).join(" ")}(de,Ce),I("caret",de),de=function(Ee,Le){return Ee.trim().split(/\s+/).map(function(ke){return function(we,Ie){var Te=Ie?R[ee]:R[ne];return we.replace(Te,function(Ae,le,fe,me,pe){var Pe;return I("tilde",we,Ae,le,fe,me,pe),Se(le)?Pe="":Se(fe)?Pe=">="+le+".0.0 <"+(+le+1)+".0.0":Se(me)?Pe=">="+le+"."+fe+".0 <"+le+"."+(+fe+1)+".0":pe?(I("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Pe=">="+le+"."+fe+"."+me+pe+" <"+le+"."+(+fe+1)+".0"):Pe=">="+le+"."+fe+"."+me+" <"+le+"."+(+fe+1)+".0",I("tilde return",Pe),Pe})}(ke,Le)}).join(" ")}(de,Ce),I("tildes",de),de=function(Ee,Le){return I("replaceXRanges",Ee,Le),Ee.split(/\s+/).map(function(ke){return function(we,Ie){we=we.trim();var Te=Ie?R[A]:R[N];return we.replace(Te,function(Ae,le,fe,me,pe,Pe){I("xRange",we,Ae,le,fe,me,pe,Pe);var Be=Se(fe),Ne=Be||Se(me),je=Ne||Se(pe);return le==="="&&je&&(le=""),Be?Ae=le===">"||le==="<"?"<0.0.0":"*":le&&je?(Ne&&(me=0),je&&(pe=0),le===">"?(le=">=",Ne?(fe=+fe+1,me=0,pe=0):je&&(me=+me+1,pe=0)):le==="<="&&(le="<",Ne?fe=+fe+1:me=+me+1),Ae=le+fe+"."+me+"."+pe):Ne?Ae=">="+fe+".0.0 <"+(+fe+1)+".0.0":je&&(Ae=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0"),I("xRange return",Ae),Ae})}(ke,Le)}).join(" ")}(de,Ce),I("xrange",de),de=function(Ee,Le){return I("replaceStars",Ee,Le),Ee.trim().replace(R[k],"")}(de,Ce),I("stars",de),de}(be,H)}).join(" ").split(/\s+/);return this.loose&&(oe=oe.filter(function(be){return!!be.match(se)})),oe=oe.map(function(be){return new Re(be,H)})},ve.prototype.intersects=function(V,H){if(!(V instanceof ve))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(se){return V.set.some(function(oe){return oe.every(function(be){return se.intersects(be,H)})})})})},t.toComparators=function(V,H){return new ve(V,H).set.map(function(K){return K.map(function(se){return se.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new B(V,this.loose));for(var H=0;H<this.set.length;H++)if($e(this.set[H],V))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(V,H,K){var se=null,oe=null;try{var be=new ve(H,K)}catch(de){return null}return V.forEach(function(de){be.test(de)&&(se&&oe.compare(de)!==-1||(oe=new B(se=de,K)))}),se},t.minSatisfying=function(V,H,K){var se=null,oe=null;try{var be=new ve(H,K)}catch(de){return null}return V.forEach(function(de){be.test(de)&&(se&&oe.compare(de)!==1||(oe=new B(se=de,K)))}),se},t.validRange=function(V,H){try{return new ve(V,H).range||"*"}catch(K){return null}},t.ltr=function(V,H,K){return ze(V,H,"<",K)},t.gtr=function(V,H,K){return ze(V,H,">",K)},t.outside=ze,t.prerelease=function(V,H){var K=z(V,H);return K&&K.prerelease.length?K.prerelease:null},t.intersects=function(V,H,K){return V=new ve(V,K),H=new ve(H,K),V.intersects(H)},t.coerce=function(V){if(V instanceof B)return V;if(typeof V!="string")return null;var H=V.match(R[U]);return H==null?null:z((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,v(1))},function($,t){var v,C,I=$.exports={};function w(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function R(S){if(v===setTimeout)return setTimeout(S,0);if((v===w||!v)&&setTimeout)return v=setTimeout,setTimeout(S,0);try{return v(S,0)}catch(E){try{return v.call(null,S,0)}catch(b){return v.call(this,S,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:w}catch(S){v=w}try{C=typeof clearTimeout=="function"?clearTimeout:T}catch(S){C=T}})();var h,f=[],O=!1,d=-1;function y(){O&&h&&(O=!1,h.length?f=h.concat(f):d=-1,f.length&&D())}function D(){if(!O){var S=R(y);O=!0;for(var E=f.length;E;){for(h=f,f=[];++d<E;)h&&h[d].run();d=-1,E=f.length}h=null,O=!1,function(b){if(C===clearTimeout)return clearTimeout(b);if((C===T||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(b);try{C(b)}catch(p){try{return C.call(null,b)}catch(l){return C.call(this,b)}}}(S)}}function a(S,E){this.fun=S,this.array=E}function m(){}I.nextTick=function(S){var E=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)E[b-1]=arguments[b];f.push(new a(S,E)),f.length!==1||O||R(D)},a.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=m,I.addListener=m,I.once=m,I.off=m,I.removeListener=m,I.removeAllListeners=m,I.emit=m,I.prependListener=m,I.prependOnceListener=m,I.listeners=function(S){return[]},I.binding=function(S){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(S){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Q[35],Z([0,1,14,2]),function($,t,v,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function I(E){const b=E;return b&&[b.on,b.pause,b.resume,b.destroy].every(p=>typeof p=="function")}t.isReadableStream=I;function w(E){const b=E;return b&&I(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean"}t.isReadableBufferedStream=w;function T(E,b){return new R(E,b)}t.newWriteableStream=T;class R{constructor(b,p){this.reducer=b,this.options=p,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(b){var p;if(!this.state.destroyed){if(this.state.flowing)this.emitData(b);else if(this.buffer.data.push(b),typeof((p=this.options)===null||p===void 0?void 0:p.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(b){this.state.destroyed||(this.state.flowing?this.emitError(b):this.buffer.error.push(b))}end(b){this.state.destroyed||(typeof b!="undefined"&&this.write(b),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(b){this.listeners.data.slice(0).forEach(p=>p(b))}emitError(b){this.listeners.error.length===0?(0,v.onUnexpectedError)(b):this.listeners.error.slice(0).forEach(p=>p(b))}emitEnd(){this.listeners.end.slice(0).forEach(b=>b())}on(b,p){if(!this.state.destroyed)switch(b){case"data":this.listeners.data.push(p),this.resume();break;case"end":this.listeners.end.push(p),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(p),this.state.flowing&&this.flowErrors();break}}removeListener(b,p){if(!this.state.destroyed){let l;switch(b){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const r=l.indexOf(p);r>=0&&l.splice(r,1)}}}flowData(){if(this.buffer.data.length>0){const b=this.reducer(this.buffer.data);this.emitData(b),this.buffer.data.length=0;const p=[...this.pendingWritePromises];this.pendingWritePromises.length=0,p.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const b of this.buffer.error)this.emitError(b);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function h(E,b){const p=[];let l;for(;(l=E.read())!==null;)p.push(l);return b(p)}t.consumeReadable=h;function f(E,b,p){const l=[];let r;for(;(r=E.read())!==null&&l.length<p;)l.push(r);return r===null&&l.length>0?b(l):{read:()=>{if(l.length>0)return l.shift();if(typeof r!="undefined"){const e=r;return r=void 0,e}return E.read()}}}t.peekReadable=f;function O(E,b){return new Promise((p,l)=>{const r=[];d(E,{onData:e=>{b&&r.push(e)},onError:e=>{b?l(e):p(void 0)},onEnd:()=>{p(b?b(r):void 0)}})})}t.consumeStream=O;function d(E,b){E.on("error",p=>b.onError(p)),E.on("end",()=>b.onEnd()),E.on("data",p=>b.onData(p))}t.listenStream=d;function y(E,b){return new Promise((p,l)=>{const r=new C.DisposableStore,e=[],i=o=>{if(e.push(o),e.length>b)return r.dispose(),E.pause(),p({stream:E,buffer:e,ended:!1})},n=o=>l(o),s=()=>p({stream:E,buffer:e,ended:!0});r.add((0,C.toDisposable)(()=>E.removeListener("error",n))),E.on("error",n),r.add((0,C.toDisposable)(()=>E.removeListener("end",s))),E.on("end",s),r.add((0,C.toDisposable)(()=>E.removeListener("data",i))),E.on("data",i)})}t.peekStream=y;function D(E,b){const p=T(b);return p.end(E),p}t.toStream=D;function a(){const E=T(()=>{throw new Error("not supported")});return E.end(),E}t.emptyStream=a;function m(E){let b=!1;return{read:()=>b?null:(b=!0,E)}}t.toReadable=m;function S(E,b,p){const l=T(p);return d(E,{onData:r=>l.write(b.data(r)),onError:r=>l.error(b.error?b.error(r):r),onEnd:()=>l.end()}),l}t.transform=S}),define(Q[17],Z([0,1,21,35]),function($,t,v,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const I=typeof Buffer!="undefined",w=typeof TextEncoder!="undefined",T=typeof TextDecoder!="undefined";let R,h;class f{constructor(o){this.buffer=o,this.byteLength=this.buffer.byteLength}static alloc(o){return I?new f(Buffer.allocUnsafe(o)):new f(new Uint8Array(o))}static wrap(o){return I&&!Buffer.isBuffer(o)&&(o=Buffer.from(o.buffer,o.byteOffset,o.byteLength)),new f(o)}static fromString(o,g){return!((g==null?void 0:g.dontUseNodeBuffer)||!1)&&I?new f(Buffer.from(o)):w?(R||(R=new TextEncoder),new f(R.encode(o))):new f(v.encodeUTF8(o))}static concat(o,g){if(typeof g=="undefined"){g=0;for(let N=0,A=o.length;N<A;N++)g+=o[N].byteLength}const F=f.alloc(g);let j=0;for(let N=0,A=o.length;N<A;N++){const U=o[N];F.set(U,j),j+=U.byteLength}return F}toString(){return I?this.buffer.toString():T?(h||(h=new TextDecoder),h.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(o,g){return new f(this.buffer.subarray(o,g))}set(o,g){o instanceof f?this.buffer.set(o.buffer,g):this.buffer.set(o,g)}readUInt32BE(o){return y(this.buffer,o)}writeUInt32BE(o,g){D(this.buffer,o,g)}readUInt32LE(o){return a(this.buffer,o)}writeUInt32LE(o,g){m(this.buffer,o,g)}readUInt8(o){return S(this.buffer,o)}writeUInt8(o,g){E(this.buffer,o,g)}}t.VSBuffer=f;function O(s,o){return s[o+0]<<0>>>0|s[o+1]<<8>>>0}t.readUInt16LE=O;function d(s,o,g){s[g+0]=o&255,o=o>>>8,s[g+1]=o&255}t.writeUInt16LE=d;function y(s,o){return s[o]*2**24+s[o+1]*2**16+s[o+2]*2**8+s[o+3]}t.readUInt32BE=y;function D(s,o,g){s[g+3]=o,o=o>>>8,s[g+2]=o,o=o>>>8,s[g+1]=o,o=o>>>8,s[g]=o}t.writeUInt32BE=D;function a(s,o){return s[o+0]<<0>>>0|s[o+1]<<8>>>0|s[o+2]<<16>>>0|s[o+3]<<24>>>0}t.readUInt32LE=a;function m(s,o,g){s[g+0]=o&255,o=o>>>8,s[g+1]=o&255,o=o>>>8,s[g+2]=o&255,o=o>>>8,s[g+3]=o&255}t.writeUInt32LE=m;function S(s,o){return s[o]}t.readUInt8=S;function E(s,o,g){s[g]=o}t.writeUInt8=E;function b(s){return C.consumeReadable(s,o=>f.concat(o))}t.readableToBuffer=b;function p(s){return C.toReadable(s)}t.bufferToReadable=p;function l(s){return C.consumeStream(s,o=>f.concat(o))}t.streamToBuffer=l;async function r(s){return s.ended?f.concat(s.buffer):f.concat([...s.buffer,await l(s.stream)])}t.bufferedStreamToBuffer=r;function e(s){return C.toStream(s,o=>f.concat(o))}t.bufferToStream=e;function i(s){return C.transform(s,{data:o=>typeof o=="string"?f.fromString(o):f.wrap(o)},o=>f.concat(o))}t.streamToBufferReadableStream=i;function n(s){return C.newWriteableStream(o=>f.concat(o),s)}t.newWriteableBufferStream=n}),define(Q[22],Z([0,1,8]),function($,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function C(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const m=Array.isArray(a)?[]:{};return Object.keys(a).forEach(S=>{a[S]&&typeof a[S]=="object"?m[S]=C(a[S]):m[S]=a[S]}),m}t.deepClone=C;function I(a){if(!a||typeof a!="object")return a;const m=[a];for(;m.length>0;){const S=m.shift();Object.freeze(S);for(const E in S)if(w.call(S,E)){const b=S[E];typeof b=="object"&&!Object.isFrozen(b)&&m.push(b)}}return a}t.deepFreeze=I;const w=Object.prototype.hasOwnProperty;function T(a,m){return R(a,m,new Set)}t.cloneAndChange=T;function R(a,m,S){if((0,v.isUndefinedOrNull)(a))return a;const E=m(a);if(typeof E!="undefined")return E;if((0,v.isArray)(a)){const b=[];for(const p of a)b.push(R(p,m,S));return b}if((0,v.isObject)(a)){if(S.has(a))throw new Error("Cannot clone recursive data-structure");S.add(a);const b={};for(let p in a)w.call(a,p)&&(b[p]=R(a[p],m,S));return S.delete(a),b}return a}function h(a,m,S=!0){return(0,v.isObject)(a)?((0,v.isObject)(m)&&Object.keys(m).forEach(E=>{E in a?S&&((0,v.isObject)(a[E])&&(0,v.isObject)(m[E])?h(a[E],m[E],S):a[E]=m[E]):a[E]=m[E]}),a):m}t.mixin=h;function f(a,m){if(a===m)return!0;if(a==null||m===null||m===void 0||typeof a!=typeof m||typeof a!="object"||Array.isArray(a)!==Array.isArray(m))return!1;let S,E;if(Array.isArray(a)){if(a.length!==m.length)return!1;for(S=0;S<a.length;S++)if(!f(a[S],m[S]))return!1}else{const b=[];for(E in a)b.push(E);b.sort();const p=[];for(E in m)p.push(E);if(p.sort(),!f(b,p))return!1;for(S=0;S<b.length;S++)if(!f(a[b[S]],m[b[S]]))return!1}return!0}t.equals=f;function O(a){const m=new Set;return JSON.stringify(a,(S,E)=>{if((0,v.isObject)(E)||Array.isArray(E)){if(m.has(E))return"[Circular]";m.add(E)}return E})}t.safeStringify=O;function d(a,m,S){const E=m(a);return typeof E=="undefined"?S:E}t.getOrDefault=d;function y(a,m){const S=Object.create(null);return!a||!m||Object.keys(m).forEach(b=>{const p=a[b],l=m[b];f(p,l)||(S[b]=l)}),S}t.distinct=y;function D(a,m){const S=m.toLowerCase(),E=Object.keys(a).find(b=>b.toLowerCase()===S);return E?a[E]:a[m]}t.getCaseInsensitive=D}),define(Q[59],Z([0,1,9]),function($,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function C(f){const O=f;return O&&typeof O.type=="string"&&typeof O.severity=="string"}t.isRemoteConsoleLog=C;function I(f){const O=[];let d;try{const y=JSON.parse(f.arguments),D=y[y.length-1];D&&D.__$stack&&(y.pop(),d=D.__$stack),O.push(...y)}catch(y){O.push("Unable to log remote console arguments",f.arguments)}return{args:O,stack:d}}t.parse=I;function w(f){if(typeof f!="string")return w(I(f).stack);const O=f;if(O){const d=T(O),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(d||"");if(y&&y.length===4)return{uri:v.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}t.getFirstFrame=w;function T(f){if(!f)return f;const O=f.indexOf(`
`);return O===-1?f:f.substring(0,O)}function R(f,O){const{args:d,stack:y}=I(f),D=typeof d[0]=="string"&&d.length===1;let a=T(y);a&&(a=`(${a.trim()})`);let m=[];if(typeof d[0]=="string"?a&&D?m=[`%c[${O}] %c${d[0]} %c${a}`,h("blue"),h(""),h("grey")]:m=[`%c[${O}] %c${d[0]}`,h("blue"),h(""),...d.slice(1)]:m=[`%c[${O}]%`,h("blue"),...d],a&&!D&&m.push(a),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,m)}t.log=R;function h(f){return`color: ${f}`}}),define(Q[60],Z([0,1,17,21,9]),function($,t,v,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function w(f){return JSON.stringify(f,R)}t.stringify=w;function T(f){let O=JSON.parse(f);return O=h(O),O}t.parse=T;function R(f,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,C.regExpFlags)(O)}:O}function h(f,O=0){if(!f||O>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return I.URI.revive(f);case 2:return new RegExp(f.source,f.flags)}if(f instanceof v.VSBuffer||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let d=0;d<f.length;++d)f[d]=h(f[d],O+1);else for(const d in f)Object.hasOwnProperty.call(f,d)&&(f[d]=h(f[d],O+1))}return f}t.revive=h}),define(Q[61],Z([0,1,21,36,3,43,4]),function($,t,v,C,I,w,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function R(){return Object.create(null)}t.getEmptyExpression=R;const h="**",f="/",O="[/\\\\]",d="[^/\\\\]",y=/\//g;function D(u){switch(u){case 0:return"";case 1:return`${d}*?`;default:return`(?:${O}|${d}+${O}|${O}${d}+)*?`}}function a(u,P){if(!u)return[];const L=[];let k=!1,M=!1,z="";for(const B of u){switch(B){case P:if(!k&&!M){L.push(z),z="";continue}break;case"{":k=!0;break;case"}":k=!1;break;case"[":M=!0;break;case"]":M=!1;break}z+=B}return z&&L.push(z),L}t.splitGlobAware=a;function m(u){if(!u)return"";let P="";const L=a(u,f);if(L.every(k=>k===h))P=".*";else{let k=!1;L.forEach((M,z)=>{if(M===h){k||(P+=D(2),k=!0);return}let B=!1,q="",J=!1,Y="";for(const ie of M){if(ie!=="}"&&B){q+=ie;continue}if(J&&(ie!=="]"||!Y)){let re;ie==="-"?re=ie:(ie==="^"||ie==="!")&&!Y?re="^":ie===f?re="":re=v.escapeRegExpCharacters(ie),Y+=re;continue}switch(ie){case"{":B=!0;continue;case"[":J=!0;continue;case"}":P+=`(?:${a(q,",").map(ge=>m(ge)).join("|")})`,B=!1,q="";break;case"]":P+="["+Y+"]",J=!1,Y="";break;case"?":P+=d;continue;case"*":P+=D(1);continue;default:P+=v.escapeRegExpCharacters(ie)}}z<L.length-1&&(L[z+1]!==h||z+2<L.length)&&(P+=O),k=!1})}return P}const S=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,p=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new w.LRUCache(1e4),i=function(){return!1},n=function(){return null};function s(u,P){if(!u)return n;let L;typeof u!="string"?L=u.pattern:L=u,L=L.trim();const k=`${L}_${!!P.trimForExclusions}`;let M=e.get(k);if(M)return o(M,u);let z;if(S.test(L)){const B=L.substr(4);M=function(q,J){return typeof q=="string"&&q.endsWith(B)?L:null}}else(z=E.exec(g(L,P)))?M=F(z[1],L):(P.trimForExclusions?p:b).test(L)?M=j(L,P):(z=l.exec(g(L,P)))?M=N(z[1].substr(1),L,!0):(z=r.exec(g(L,P)))?M=N(z[1],L,!1):M=A(L);return e.set(k,M),o(M,u)}function o(u,P){return typeof P=="string"?u:function(L,k){return C.isEqualOrParent(L,P.base)?u(I.relative(P.base,L),k):null}}function g(u,P){return P.trimForExclusions&&u.endsWith("/**")?u.substr(0,u.length-2):u}function F(u,P){const L=`/${u}`,k=`\\${u}`,M=function(B,q){return typeof B!="string"?null:q?q===u?P:null:B===u||B.endsWith(L)||B.endsWith(k)?P:null},z=[u];return M.basenames=z,M.patterns=[P],M.allBasenames=z,M}function j(u,P){const L=c(u.slice(1,-1).split(",").map(q=>s(q,P)).filter(q=>q!==n),u),k=L.length;if(!k)return n;if(k===1)return L[0];const M=function(q,J){for(let Y=0,ie=L.length;Y<ie;Y++)if(L[Y](q,J))return u;return null},z=L.find(q=>!!q.allBasenames);z&&(M.allBasenames=z.allBasenames);const B=L.reduce((q,J)=>J.allPaths?q.concat(J.allPaths):q,[]);return B.length&&(M.allPaths=B),M}function N(u,P,L){const k=I.sep===I.posix.sep,M=k?u:u.replace(y,I.sep),z=I.sep+M,B=I.posix.sep+u,q=L?function(J,Y){return typeof J=="string"&&(J===M||J.endsWith(z)||!k&&(J===u||J.endsWith(B)))?P:null}:function(J,Y){return typeof J=="string"&&(J===M||!k&&J===u)?P:null};return q.allPaths=[(L?"*/":"./")+u],q}function A(u){try{const P=new RegExp(`^${m(u)}$`);return function(L){return P.lastIndex=0,typeof L=="string"&&P.test(L)?u:null}}catch(P){return n}}function U(u,P,L){return!u||typeof P!="string"?!1:x(u)(P,void 0,L)}t.match=U;function x(u,P={}){if(!u)return i;if(typeof u=="string"||te(u)){const L=s(u,P);if(L===n)return i;const k=function(M,z){return!!L(M,z)};return L.allBasenames&&(k.allBasenames=L.allBasenames),L.allPaths&&(k.allPaths=L.allPaths),k}return G(u,P)}t.parse=x;function X(u){if(!!u){let P;return L=>(P||(P=(u()||Promise.resolve([])).then(k=>k?ee(k):{})),P.then(k=>!!k[L]))}}t.hasSiblingPromiseFn=X;function ne(u){if(!!u){let P;return L=>{if(!P){const k=u();P=k?ee(k):{}}return!!P[L]}}}t.hasSiblingFn=ne;function ee(u){const P={};for(const L of u)P[L]=!0;return P}function te(u){const P=u;return P&&typeof P.base=="string"&&typeof P.pattern=="string"}t.isRelativePattern=te;function ae(u){return u.allBasenames||[]}t.getBasenameTerms=ae;function W(u){return u.allPaths||[]}t.getPathTerms=W;function G(u,P){const L=c(Object.getOwnPropertyNames(u).map(q=>_(q,u[q],P)).filter(q=>q!==n)),k=L.length;if(!k)return n;if(!L.some(q=>!!q.requiresSiblings)){if(k===1)return L[0];const q=function(ie,re){for(let he=0,ge=L.length;he<ge;he++){const De=L[he](ie,re);if(De)return De}return null},J=L.find(ie=>!!ie.allBasenames);J&&(q.allBasenames=J.allBasenames);const Y=L.reduce((ie,re)=>re.allPaths?ie.concat(re.allPaths):ie,[]);return Y.length&&(q.allPaths=Y),q}const M=function(q,J,Y){let ie;for(let re=0,he=L.length;re<he;re++){const ge=L[re];ge.requiresSiblings&&Y&&(J||(J=I.basename(q)),ie||(ie=J.substr(0,J.length-I.extname(q).length)));const De=ge(q,J,ie,Y);if(De)return De}return null},z=L.find(q=>!!q.allBasenames);z&&(M.allBasenames=z.allBasenames);const B=L.reduce((q,J)=>J.allPaths?q.concat(J.allPaths):q,[]);return B.length&&(M.allPaths=B),M}function _(u,P,L){if(P===!1)return n;const k=s(u,L);if(k===n)return n;if(typeof P=="boolean")return k;if(P){const M=P.when;if(typeof M=="string"){const z=(B,q,J,Y)=>{if(!Y||!k(B,q))return null;const ie=M.replace("$(basename)",J),re=Y(ie);return(0,T.isThenable)(re)?re.then(he=>he?u:null):re?u:null};return z.requiresSiblings=!0,z}}return k}function c(u,P){const L=u.filter(q=>!!q.basenames);if(L.length<2)return u;const k=L.reduce((q,J)=>{const Y=J.basenames;return Y?q.concat(Y):q},[]);let M;if(P){M=[];for(let q=0,J=k.length;q<J;q++)M.push(P)}else M=L.reduce((q,J)=>{const Y=J.patterns;return Y?q.concat(Y):q},[]);const z=function(q,J){if(typeof q!="string")return null;if(!J){let ie;for(ie=q.length;ie>0;ie--){const re=q.charCodeAt(ie-1);if(re===47||re===92)break}J=q.substr(ie)}const Y=k.indexOf(J);return Y!==-1?M[Y]:null};z.basenames=k,z.patterns=M,z.allBasenames=k;const B=u.filter(q=>!q.basenames);return B.push(z),B}}),define(Q[62],Z([0,1,9,3,21,10,15,18,36]),function($,t,v,C,I,w,T,R,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function f(s,o,g){if(typeof s=="string"&&(s=v.URI.file(s)),g){const j=g.getWorkspaceFolder(s);if(j){const N=g.getWorkspace().folders.length>1;let A;if((0,R.isEqual)(j.uri,s)?A="":A=(0,R.relativePath)(j.uri,s),N){const U=j.name?j.name:(0,R.basename)(j.uri);A=A?U+" \u2022 "+A:U}return A}}if(s.scheme!==w.Schemas.file&&s.scheme!==w.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,h.hasDriveLetter)(s.fsPath))return(0,C.normalize)(d(s.fsPath));let F=(0,C.normalize)(s.fsPath);return!T.isWindows&&(o==null?void 0:o.userHome)&&(F=D(F,o.userHome.fsPath)),F}t.getPathLabel=f;function O(s){if(!!s){typeof s=="string"&&(s=v.URI.file(s));const o=(0,R.basename)(s)||(s.scheme===w.Schemas.file?s.fsPath:s.path);return T.isWindows&&(0,h.isRootOrDriveLetter)(o)?d(o):o}}t.getBaseLabel=O;function d(s){return(0,h.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}t.normalizeDriveLetter=d;let y=Object.create(null);function D(s,o){if(T.isWindows||!s||!o)return s;let g=y.original===o?y.normalized:void 0;return g||(g=`${(0,I.rtrim)(o,C.posix.sep)}${C.posix.sep}`,y={original:o,normalized:g}),(T.isLinux?s.startsWith(g):(0,I.startsWithIgnoreCase)(s,g))&&(s=`~/${s.substr(g.length)}`),s}t.tildify=D;function a(s,o){return s.replace(/^~($|\/|\\)/,`${o}$1`)}t.untildify=a;const m="\u2026",S="\\\\",E="~";function b(s,o=C.sep){const g=new Array(s.length);let F=!1;for(let j=0;j<s.length;j++){let N=s[j];if(N===""){g[j]=`.${o}`;continue}if(!N){g[j]=N;continue}F=!0;let A="";N.indexOf(S)===0?(A=N.substr(0,N.indexOf(S)+S.length),N=N.substr(N.indexOf(S)+S.length)):N.indexOf(o)===0?(A=N.substr(0,N.indexOf(o)+o.length),N=N.substr(N.indexOf(o)+o.length)):N.indexOf(E)===0&&(A=N.substr(0,N.indexOf(E)+E.length),N=N.substr(N.indexOf(E)+E.length));const U=N.split(o);for(let x=1;F&&x<=U.length;x++)for(let X=U.length-x;F&&X>=0;X--){F=!1;let ne=U.slice(X,X+x).join(o);for(let ee=0;!F&&ee<s.length;ee++)if(ee!==j&&s[ee]&&s[ee].indexOf(ne)>-1){const te=X+x===U.length,ae=X>0&&s[ee].indexOf(o)>-1?o+ne:ne,W=s[ee].endsWith(ae);F=!te||W}if(!F){let ee="";(U[0].endsWith(":")||A!=="")&&(X===1&&(X=0,x++,ne=U[0]+o+ne),X>0&&(ee=U[0]+o),ee=A+ee),X>0&&(ee=ee+m+o),ee=ee+ne,X+x<U.length&&(ee=ee+o+m),g[j]=ee}}F&&(g[j]=N)}return g}t.shorten=b;var p;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function l(s,o=Object.create(null)){const g=[];let F=!1,j="";for(const N of s)if(N==="$"||F&&N==="{")j&&g.push({value:j,type:p.TEXT}),j="",F=!0;else if(N==="}"&&F){const A=o[j];if(typeof A=="string")A.length&&g.push({value:A,type:p.VARIABLE});else if(A){const U=g[g.length-1];(!U||U.type!==p.SEPARATOR)&&g.push({value:A.label,type:p.SEPARATOR})}j="",F=!1}else j+=N;return j&&!F&&g.push({value:j,type:p.TEXT}),g.filter((N,A)=>{if(N.type===p.SEPARATOR){const U=g[A-1],x=g[A+1];return[U,x].every(X=>X&&(X.type===p.VARIABLE||X.type===p.TEXT)&&X.value.length>0)}return!0}).map(N=>N.value).join("")}t.template=l;function r(s,o){return T.isMacintosh||o?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):s.replace(/&&|&/g,g=>g==="&"?"&&":"&")}t.mnemonicMenuLabel=r;function e(s,o){return T.isMacintosh||o?s.replace(/\(&&\w\)|&&/g,""):T.isWindows?s.replace(/&&|&/g,g=>g==="&"?"&&":"&"):s.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(s){return s.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(s){const o=s.indexOf("/")!==-1?C.posix:C.win32,g=o.basename(s),F=o.dirname(s);return g.length?{name:g,parentPath:F}:{name:F,parentPath:""}}t.splitName=n}),define(Q[44],Z([0,1,127]),function($,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class C{constructor(w="utf8"){this.stringDecoder=new v.StringDecoder(w),this.remaining=null}write(w){const T=[],R=this.remaining?this.remaining+this.stringDecoder.write(w):this.stringDecoder.write(w);if(R.length<1)return T;let h=0,f,O=h;for(;O<R.length;)if(f=R.charCodeAt(O),f===13||f===10){if(T.push(R.substring(h,O)),O++,O<R.length){const d=f;f=R.charCodeAt(O),(d===13&&f===10||d===10&&f===13)&&O++}h=O}else O++;return this.remaining=h<R.length?R.substr(h):null,T}end(){return this.remaining}}t.LineDecoder=C}),define(Q[63],Z([0,1,16,64,21,3,12]),function($,t,v,C,I,w,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function R(d){const y=(0,w.dirname)(d);if(d===y)return d;const D=((0,w.basename)(d)||d).toLowerCase();try{const m=(0,T.readdirSync)(y).filter(S=>S.toLowerCase()===D);if(m.length===1){const S=R(y);if(S)return(0,w.join)(S,m[0])}else if(m.length>1){const S=m.indexOf(D);if(S>=0){const E=R(y);if(E)return(0,w.join)(E,m[S])}}}catch(a){}return null}t.realcaseSync=R;async function h(d){try{return await(0,C.promisify)(v.realpath)(d)}catch(y){const D=O(d);return await v.promises.access(D,v.constants.R_OK),D}}t.realpath=h;function f(d){try{return v.realpathSync(d)}catch(y){const D=O(d);return v.accessSync(D,v.constants.R_OK),D}}t.realpathSync=f;function O(d){return(0,I.rtrim)((0,w.normalize)(d),w.sep)}});var ye=this&&this.__await||function($){return this instanceof ye?(this.v=$,this):new ye($)},Ve=this&&this.__asyncGenerator||function($,t,v){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var C=v.apply($,t||[]),I,w=[];return I={},T("next"),T("throw"),T("return"),I[Symbol.asyncIterator]=function(){return this},I;function T(y){C[y]&&(I[y]=function(D){return new Promise(function(a,m){w.push([y,D,a,m])>1||R(y,D)})})}function R(y,D){try{h(C[y](D))}catch(a){d(w[0][3],a)}}function h(y){y.value instanceof ye?Promise.resolve(y.value.v).then(f,O):d(w[0][2],y)}function f(y){R("next",y)}function O(y){R("throw",y)}function d(y,D){y(D),w.shift(),w.length&&R(w[0][0],w[0][1])}},_e=this&&this.__asyncValues||function($){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var t=$[Symbol.asyncIterator],v;return t?t.call($):($=typeof __values=="function"?__values($):$[Symbol.iterator](),v={},C("next"),C("throw"),C("return"),v[Symbol.asyncIterator]=function(){return this},v);function C(w){v[w]=$[w]&&function(T){return new Promise(function(R,h){T=$[w](T),I(R,h,T.done,T.value)})}}function I(w,T,R,h){Promise.resolve(h).then(function(f){w({value:f,done:R})},T)}};define(Q[65],Z([0,1,12,32,3]),function($,t,v,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const w=/^\d+$/,T=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var h;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(h||(h={}));let f;switch(process.arch){case"ia32":case"x32":f=1;break;case"arm":case"arm64":f=2;break;default:f=0;break}let O;process.env.PROCESSOR_ARCHITEW6432?O=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?O=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?O=1:O=0;class d{constructor(r,e,i){this.exePath=r,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await v.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function y({useAlternateBitness:l=!1}={}){return l?f===0?process.env["ProgramFiles(x86)"]||null:O===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function D({useAlternateBitness:l=!1,findPreview:r=!1}={}){const e=y({useAlternateBitness:l});if(!e)return null;const i=I.join(e,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(i))return null;let n=-1,s=null;for(const F of await v.readdir(i)){let j=-1;if(r){const A=F.indexOf("-");if(A<0)continue;const U=F.substring(0,A);if(!w.test(U)||F.substring(A+1)!=="preview")continue;j=parseInt(U,10)}else{if(!w.test(F))continue;j=parseInt(F,10)}if(!(j<=n)){const N=I.join(i,F,"pwsh.exe");!await v.SymlinkSupport.existsFile(N)||(s=N,n=j)}}if(!s)return null;const o=e.includes("x86")?" (x86)":"",g=r?" Preview":"";return new d(s,`PowerShell${g}${o}`,!0)}async function a({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const r=I.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(r))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=l?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const n of await v.readdir(r))if(e.test(n)){const s=I.join(r,n,"pwsh.exe");return new d(s,i)}return null}function m(){const l=I.join(C.homedir(),".dotnet","tools","pwsh.exe");return new d(l,".NET Core PowerShell Global Tool")}function S(){const l=I.join(process.env.windir,f===1&&O!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new d(l,"Windows PowerShell",!0)}function E(){return Ve(this,arguments,function*(){let r=yield ye(D());r&&(yield yield ye(r)),r=yield ye(D({useAlternateBitness:!0})),r&&(yield yield ye(r)),r=yield ye(a()),r&&(yield yield ye(r)),r=m(),r&&(yield yield ye(r)),r=yield ye(D({findPreview:!0})),r&&(yield yield ye(r)),r=yield ye(a({findPreview:!0})),r&&(yield yield ye(r)),r=yield ye(D({useAlternateBitness:!0,findPreview:!0})),r&&(yield yield ye(r)),r=S(),r&&(yield yield ye(r))})}function b(){return Ve(this,arguments,function*(){var r,e;try{for(var i=_e(E()),n;n=yield ye(i.next()),!n.done;){const s=n.value;(yield ye(s.exists()))&&(yield yield ye(s))}}catch(s){r={error:s}}finally{try{n&&!n.done&&(e=i.return)&&(yield ye(e.call(i)))}finally{if(r)throw r.error}}})}t.enumeratePowerShellInstallations=b;async function p(){var l,r;try{for(var e=_e(b()),i;i=await e.next(),!i.done;)return i.value}catch(n){l={error:n}}finally{try{i&&!i.done&&(r=e.return)&&await r.call(e)}finally{if(l)throw l.error}}return null}t.getFirstAvailablePowerShellInstallation=p}),define(Q[66],Z([0,1,3,16,15,128,2,12]),function($,t,v,C,I,w,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function h(d,y,D){return O({path:d,isDirectory:!1},y,D)}t.watchFile=h;function f(d,y,D){return O({path:d,isDirectory:!0},y,D)}t.watchFolder=f,t.CHANGE_BUFFER_DELAY=100;function O(d,y,D){const a=(0,v.basename)(d.path),m=new Map;let S=!1,E=[(0,T.toDisposable)(()=>{m.forEach(b=>(0,T.dispose)(b)),m.clear()})];try{const b=(0,C.watch)(d.path);E.push((0,T.toDisposable)(()=>{b.removeAllListeners(),b.close()}));const p=new Set;d.isDirectory&&(0,R.readdir)(d.path).then(l=>l.forEach(r=>p.add(r))),b.on("error",(l,r)=>{S||D(`Failed to watch ${d.path} for changes using fs.watch() (${l}, ${r})`)}),b.on("change",(l,r)=>{if(!S){let e="";if(r&&(e=r.toString(),I.isMacintosh&&(e=(0,w.normalizeNFC)(e))),!(!e||l!=="change"&&l!=="rename")){const i=d.isDirectory?(0,v.join)(d.path,e):d.path;if(d.isDirectory)if(l==="rename"){const n=m.get(i);n&&(0,T.dispose)(n);const s=setTimeout(async()=>{m.delete(i);const o=await(0,R.exists)(i);if(!S){let g;o?p.has(e)?g="changed":(g="added",p.add(e)):(p.delete(e),g="deleted"),y(g,i)}},t.CHANGE_BUFFER_DELAY);m.set(i,(0,T.toDisposable)(()=>clearTimeout(s)))}else{let n;p.has(e)?n="changed":(n="added",p.add(e)),y(n,i)}else if(l==="rename"||e!==a){const n=setTimeout(async()=>{const s=await(0,R.exists)(i);S||(s?(y("changed",i),E=[O(d,y,D)]):y("deleted",i))},t.CHANGE_BUFFER_DELAY);(0,T.dispose)(E),E=[(0,T.toDisposable)(()=>clearTimeout(n))]}else y("changed",i)}}})}catch(b){(0,R.exists)(d.path).then(p=>{p&&!S&&D(`Failed to watch ${d.path} for changes using fs.watch() (${b.toString()})`)})}return(0,T.toDisposable)(()=>{S=!0,E=(0,T.dispose)(E)})}}),define(Q[37],Z([0,1,11,2,4,28,14,17,23,8,60,21]),function($,t,v,C,I,w,T,R,h,f,O,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var y;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(y=t.RequestType||(t.RequestType={}));function D(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(a=t.ResponseType||(t.ResponseType={}));function m(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(S||(S={}));class E{constructor(c){this.buffer=c,this.pos=0}read(c){const u=this.buffer.slice(this.pos,this.pos+c);return this.pos+=u.byteLength,u}}class b{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(c){this.buffers.push(c)}}var p;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object"})(p||(p={}));function l(_){const c=R.VSBuffer.alloc(4);return c.writeUInt32BE(_,0),c}function r(_){return _.read(4).readUInt32BE(0)}function e(_){const c=R.VSBuffer.alloc(1);return c.writeUInt8(_,0),c}const i={Undefined:e(p.Undefined),String:e(p.String),Buffer:e(p.Buffer),VSBuffer:e(p.VSBuffer),Array:e(p.Array),Object:e(p.Object)},n=typeof Buffer!="undefined";function s(_,c){if(typeof c=="undefined")_.write(i.Undefined);else if(typeof c=="string"){const u=R.VSBuffer.fromString(c);_.write(i.String),_.write(l(u.byteLength)),_.write(u)}else if(n&&Buffer.isBuffer(c)){const u=R.VSBuffer.wrap(c);_.write(i.Buffer),_.write(l(u.byteLength)),_.write(u)}else if(c instanceof R.VSBuffer)_.write(i.VSBuffer),_.write(l(c.byteLength)),_.write(c);else if(Array.isArray(c)){_.write(i.Array),_.write(l(c.length));for(const u of c)s(_,u)}else{const u=R.VSBuffer.fromString(JSON.stringify(c));_.write(i.Object),_.write(l(u.byteLength)),_.write(u)}}function o(_){switch(_.read(1).readUInt8(0)){case p.Undefined:return;case p.String:return _.read(r(_)).toString();case p.Buffer:return _.read(r(_)).buffer;case p.VSBuffer:return _.read(r(_));case p.Array:{const u=r(_),P=[];for(let L=0;L<u;L++)P.push(o(_));return P}case p.Object:return JSON.parse(_.read(r(_)).toString())}}class g{constructor(c,u,P=null,L=1e3){this.protocol=c,this.ctx=u,this.logger=P,this.timeoutDelay=L,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(k=>this.onRawMessage(k)),this.sendResponse({type:200})}registerChannel(c,u){this.channels.set(c,u),setTimeout(()=>this.flushPendingRequests(c),0)}sendResponse(c){switch(c.type){case 200:{const u=this.send([c.type]);this.logger&&this.logger.logOutgoing(u,0,1,m(c.type));return}case 201:case 202:case 204:case 203:{const u=this.send([c.type,c.id],c.data);this.logger&&this.logger.logOutgoing(u,c.id,1,m(c.type),c.data);return}}}send(c,u=void 0){const P=new b;return s(P,c),s(P,u),this.sendBuffer(P.buffer)}sendBuffer(c){try{return this.protocol.send(c),c.byteLength}catch(u){return 0}}onRawMessage(c){const u=new E(c),P=o(u),L=o(u),k=P[0];switch(k){case 100:return this.logger&&this.logger.logIncoming(c.byteLength,P[1],1,`${D(k)}: ${P[2]}.${P[3]}`,L),this.onPromise({type:k,id:P[1],channelName:P[2],name:P[3],arg:L});case 102:return this.logger&&this.logger.logIncoming(c.byteLength,P[1],1,`${D(k)}: ${P[2]}.${P[3]}`,L),this.onEventListen({type:k,id:P[1],channelName:P[2],name:P[3],arg:L});case 101:return this.logger&&this.logger.logIncoming(c.byteLength,P[1],1,`${D(k)}`),this.disposeActiveRequest({type:k,id:P[1]});case 103:return this.logger&&this.logger.logIncoming(c.byteLength,P[1],1,`${D(k)}`),this.disposeActiveRequest({type:k,id:P[1]})}}onPromise(c){const u=this.channels.get(c.channelName);if(!u){this.collectPendingRequest(c);return}const P=new w.CancellationTokenSource;let L;try{L=u.call(this.ctx,c.name,c.arg,P.token)}catch(z){L=Promise.reject(z)}const k=c.id;L.then(z=>{this.sendResponse({id:k,data:z,type:201}),this.activeRequests.delete(c.id)},z=>{z instanceof Error?this.sendResponse({id:k,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.sendResponse({id:k,data:z,type:203}),this.activeRequests.delete(c.id)});const M=(0,C.toDisposable)(()=>P.cancel());this.activeRequests.set(c.id,M)}onEventListen(c){const u=this.channels.get(c.channelName);if(!u){this.collectPendingRequest(c);return}const P=c.id,k=u.listen(this.ctx,c.name,c.arg)(M=>this.sendResponse({id:P,data:M,type:204}));this.activeRequests.set(c.id,k)}disposeActiveRequest(c){const u=this.activeRequests.get(c.id);u&&(u.dispose(),this.activeRequests.delete(c.id))}collectPendingRequest(c){let u=this.pendingRequests.get(c.channelName);u||(u=[],this.pendingRequests.set(c.channelName,u));const P=setTimeout(()=>{console.error(`Unknown channel: ${c.channelName}`),c.type===100&&this.sendResponse({id:c.id,data:{name:"Unknown channel",message:`Channel name '${c.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);u.push({request:c,timeoutTimer:P})}flushPendingRequests(c){const u=this.pendingRequests.get(c);if(u){for(const P of u)switch(clearTimeout(P.timeoutTimer),P.request.type){case 100:this.onPromise(P.request);break;case 102:this.onEventListen(P.request);break}this.pendingRequests.delete(c)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(c=>c.dispose()),this.activeRequests.clear()}}t.ChannelServer=g;var F;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(F=t.RequestInitiator||(t.RequestInitiator={}));class j{constructor(c,u=null){this.protocol=c,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(P=>this.onBuffer(P)),this.logger=u}getChannel(c){const u=this;return{call(P,L,k){return u.isDisposed?Promise.reject(T.canceled()):u.requestPromise(c,P,L,k)},listen(P,L){return u.isDisposed?Promise.reject(T.canceled()):u.requestEvent(c,P,L)}}}requestPromise(c,u,P,L=w.CancellationToken.None){const k=this.lastRequestId++,z={id:k,type:100,channelName:c,name:u,arg:P};if(L.isCancellationRequested)return Promise.reject(T.canceled());let B;return new Promise((J,Y)=>{if(L.isCancellationRequested)return Y(T.canceled());const ie=()=>{const De=Oe=>{switch(Oe.type){case 201:this.handlers.delete(k),J(Oe.data);break;case 202:this.handlers.delete(k);const Fe=new Error(Oe.data.message);Fe.stack=Oe.data.stack,Fe.name=Oe.data.name,Y(Fe);break;case 203:this.handlers.delete(k),Y(Oe.data);break}};this.handlers.set(k,De),this.sendRequest(z)};let re=null;this.state===S.Idle?ie():(re=(0,I.createCancelablePromise)(De=>this.whenInitialized()),re.then(()=>{re=null,ie()}));const he=()=>{re?(re.cancel(),re=null):this.sendRequest({id:k,type:101}),Y(T.canceled())},ge=L.onCancellationRequested(he);B=(0,C.combinedDisposable)((0,C.toDisposable)(he),ge),this.activeRequests.add(B)}).finally(()=>{this.activeRequests.delete(B)})}requestEvent(c,u,P){const L=this.lastRequestId++,M={id:L,type:102,channelName:c,name:u,arg:P};let z=null;const B=new v.Emitter({onFirstListenerAdd:()=>{z=(0,I.createCancelablePromise)(J=>this.whenInitialized()),z.then(()=>{z=null,this.activeRequests.add(B),this.sendRequest(M)})},onLastListenerRemove:()=>{z?(z.cancel(),z=null):(this.activeRequests.delete(B),this.sendRequest({id:L,type:103}))}}),q=J=>B.fire(J.data);return this.handlers.set(L,q),B.event}sendRequest(c){switch(c.type){case 100:case 102:{const u=this.send([c.type,c.id,c.channelName,c.name],c.arg);this.logger&&this.logger.logOutgoing(u,c.id,0,`${D(c.type)}: ${c.channelName}.${c.name}`,c.arg);return}case 101:case 103:{const u=this.send([c.type,c.id]);this.logger&&this.logger.logOutgoing(u,c.id,0,D(c.type));return}}}send(c,u=void 0){const P=new b;return s(P,c),s(P,u),this.sendBuffer(P.buffer)}sendBuffer(c){try{return this.protocol.send(c),c.byteLength}catch(u){return 0}}onBuffer(c){const u=new E(c),P=o(u),L=o(u),k=P[0];switch(k){case 200:return this.logger&&this.logger.logIncoming(c.byteLength,0,0,m(k)),this.onResponse({type:P[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(c.byteLength,P[1],0,m(k),L),this.onResponse({type:P[0],id:P[1],data:L})}}onResponse(c){if(c.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const u=this.handlers.get(c.id);u&&u(c)}whenInitialized(){return this.state===S.Idle?Promise.resolve():v.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(c=>c.dispose()),this.activeRequests.clear()}}t.ChannelClient=j;class N{constructor(c){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,c(({protocol:u,onDidClientDisconnect:P})=>{v.Event.once(u.onMessage)(k=>{const M=new E(k),z=o(M),B=new g(u,z),q=new j(u);this.channels.forEach((Y,ie)=>B.registerChannel(ie,Y));const J={channelServer:B,channelClient:q,ctx:z};this._connections.add(J),this._onDidAddConnection.fire(J),P(()=>{B.dispose(),q.dispose(),this._connections.delete(J),this._onDidRemoveConnection.fire(J)})})})}get connections(){const c=[];return this._connections.forEach(u=>c.push(u)),c}getChannel(c,u){const P=this;return{call(L,k,M){let z;if((0,f.isFunction)(u)){let q=(0,h.getRandomElement)(P.connections.filter(u));z=q?Promise.resolve(q):v.Event.toPromise(v.Event.filter(P.onDidAddConnection,u))}else z=u.routeCall(P,L,k);const B=z.then(q=>q.channelClient.getChannel(c));return U(B).call(L,k,M)},listen(L,k){if((0,f.isFunction)(u))return P.getMulticastEvent(c,u,L,k);const M=u.routeEvent(P,L,k).then(z=>z.channelClient.getChannel(c));return U(M).listen(L,k)}}}getMulticastEvent(c,u,P,L){const k=this;let M=new C.DisposableStore;const z=new v.Emitter({onFirstListenerAdd:()=>{M=new C.DisposableStore;const B=new v.EventMultiplexer,q=new Map,J=ie=>{const he=ie.channelClient.getChannel(c).listen(P,L),ge=B.add(he);q.set(ie,ge)},Y=ie=>{const re=q.get(ie);!re||(re.dispose(),q.delete(ie))};k.connections.filter(u).forEach(J),v.Event.filter(k.onDidAddConnection,u)(J,void 0,M),k.onDidRemoveConnection(Y,void 0,M),B.event(z.fire,z,M),M.add(B)},onLastListenerRemove:()=>{M.dispose()}});return z.event}registerChannel(c,u){this.channels.set(c,u),this._connections.forEach(P=>{P.channelServer.registerChannel(c,u)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=N;class A{constructor(c,u,P=null){const L=new b;s(L,u),c.send(L.buffer),this.channelClient=new j(c,P),this.channelServer=new g(c,u,P)}getChannel(c){return this.channelClient.getChannel(c)}registerChannel(c,u){this.channelServer.registerChannel(c,u)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=A;function U(_){return{call(c,u,P){return _.then(L=>L.call(c,u,P))},listen(c,u){const P=new v.Relay;return _.then(L=>P.input=L.listen(c,u)),P.event}}}t.getDelayedChannel=U;function x(_){let c=!1;return{call(u,P,L){return c?_.call(u,P,L):(0,I.timeout)(0).then(()=>c=!0).then(()=>_.call(u,P,L))},listen(u,P){if(c)return _.listen(u,P);const L=new v.Relay;return(0,I.timeout)(0).then(()=>c=!0).then(()=>L.input=_.listen(u,P)),L.event}}}t.getNextTickChannel=x;class X{constructor(c){this.fn=c}routeCall(c){return this.route(c)}routeEvent(c){return this.route(c)}async route(c){for(const u of c.connections)if(await Promise.resolve(this.fn(u.ctx)))return Promise.resolve(u);return await v.Event.toPromise(c.onDidAddConnection),await this.route(c)}}t.StaticRouter=X;var ne;(function(_){function c(L,k){const M=L,z=k&&k.disableMarshalling,B=new Map;for(const q in M)P(q)&&B.set(q,v.Event.buffer(M[q],!0));return new class{listen(q,J){const Y=B.get(J);if(Y)return Y;throw new Error(`Event not found: ${J}`)}call(q,J,Y){const ie=M[J];if(typeof ie=="function"){if(!z&&Array.isArray(Y))for(let re=0;re<Y.length;re++)Y[re]=(0,O.revive)(Y[re]);return ie.apply(M,Y)}throw new Error(`Method not found: ${J}`)}}}_.fromService=c;function u(L,k){const M=k&&k.disableMarshalling;return new Proxy({},{get(z,B){var q;if(typeof B=="string")return((q=k==null?void 0:k.properties)===null||q===void 0?void 0:q.has(B))?k.properties.get(B):P(B)?L.listen(B):async function(...J){let Y;k&&!(0,f.isUndefinedOrNull)(k.context)?Y=[k.context,...J]:Y=J;const ie=await L.call(B,Y);return M?ie:(0,O.revive)(ie)};throw new Error(`Property not found: ${String(B)}`)}})}_.toService=u;function P(L){return L[0]==="o"&&L[1]==="n"&&d.isUpperAsciiLetter(L.charCodeAt(2))}})(ne=t.ProxyChannel||(t.ProxyChannel={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function te(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){let c=_.toString();if(c!=="[object Object]")return c}return _}function ae(_){return Array.isArray(_)?_.map(te):te(_)}function W(_,c,u,P,L,k,M){M=ae(M);const z=ee[L],B=z[P%z.length];let q=[`%c[${_}]%c[${String(c).padStart(7," ")}]%c[len: ${String(u).padStart(5," ")}]%c${String(P).padStart(5," ")} - ${k}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(k)?(q=q.concat(M),q.push(")")):q.push(M),console.log.apply(console,q)}t.logWithColors=W;class G{constructor(c,u){this._outgoingPrefix=c,this._incomingPrefix=u,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(c,u,P,L,k){this._totalOutgoing+=c,W(this._outgoingPrefix,this._totalOutgoing,c,u,P,L,k)}logIncoming(c,u,P,L,k){this._totalIncoming+=c,W(this._incomingPrefix,this._totalIncoming,c,u,P,L,k)}}t.IPCLogger=G}),define(Q[67],Z([0,1,2,11,4,8]),function($,t,v,C,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var T;(function(O){O[O.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=t.StorageHint||(t.StorageHint={}));var R;(function(O){O[O.None=0]="None",O[O.Initialized=1]="Initialized",O[O.Closed=2]="Closed"})(R||(R={}));class h extends v.Disposable{constructor(d,y=Object.create(null)){super();this.database=d,this.options=y,this._onDidChangeStorage=this._register(new C.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=R.None,this.cache=new Map,this.flushDelayer=new I.ThrottledDelayer(h.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){var y,D;(y=d.changed)===null||y===void 0||y.forEach((a,m)=>this.accept(m,a)),(D=d.deleted)===null||D===void 0||D.forEach(a=>this.accept(a,void 0))}accept(d,y){if(this.state!==R.Closed){let D=!1;(0,w.isUndefinedOrNull)(y)?D=this.cache.delete(d):this.cache.get(d)!==y&&(this.cache.set(d,y),D=!0),D&&this._onDidChangeStorage.fire(d)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===R.None&&(this.state=R.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,y){const D=this.cache.get(d);return(0,w.isUndefinedOrNull)(D)?y:D}getBoolean(d,y){const D=this.get(d);return(0,w.isUndefinedOrNull)(D)?y:D==="true"}getNumber(d,y){const D=this.get(d);return(0,w.isUndefinedOrNull)(D)?y:parseInt(D,10)}async set(d,y){if(this.state!==R.Closed){if((0,w.isUndefinedOrNull)(y))return this.delete(d);const D=String(y);if(this.cache.get(d)!==D)return this.cache.set(d,D),this.pendingInserts.set(d,D),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(d){if(this.state!==R.Closed&&!!this.cache.delete(d))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=R.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(d){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{var y;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(y=this.whenFlushedCallbacks.pop())===null||y===void 0||y()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}t.Storage=h,h.DEFAULT_FLUSH_DELAY=100;class f{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((y,D)=>this.items.set(D,y)),d.delete&&d.delete.forEach(y=>this.items.delete(y))}async close(){}}t.InMemoryStorageDatabase=f}),define(Q[68],Z([5,6]),function($,t){return $.create("vs/base/common/date",t)}),define(Q[69],Z([0,1,68]),function($,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const C=60,I=C*60,w=I*24,T=w*7,R=w*30,h=w*365;function f(d,y){typeof d!="number"&&(d=d.getTime());const D=Math.round((new Date().getTime()-d)/1e3);if(D<-30)return(0,v.localize)(0,null,f(new Date().getTime()+D*1e3,!1));if(D<30)return(0,v.localize)(1,null);let a;return D<C?(a=D,y?a===1?(0,v.localize)(2,null,a):(0,v.localize)(3,null,a):a===1?(0,v.localize)(4,null,a):(0,v.localize)(5,null,a)):D<I?(a=Math.floor(D/C),y?a===1?(0,v.localize)(6,null,a):(0,v.localize)(7,null,a):a===1?(0,v.localize)(8,null,a):(0,v.localize)(9,null,a)):D<w?(a=Math.floor(D/I),y?a===1?(0,v.localize)(10,null,a):(0,v.localize)(11,null,a):a===1?(0,v.localize)(12,null,a):(0,v.localize)(13,null,a)):D<T?(a=Math.floor(D/w),y?a===1?(0,v.localize)(14,null,a):(0,v.localize)(15,null,a):a===1?(0,v.localize)(16,null,a):(0,v.localize)(17,null,a)):D<R?(a=Math.floor(D/T),y?a===1?(0,v.localize)(18,null,a):(0,v.localize)(19,null,a):a===1?(0,v.localize)(20,null,a):(0,v.localize)(21,null,a)):D<h?(a=Math.floor(D/R),y?a===1?(0,v.localize)(22,null,a):(0,v.localize)(23,null,a):a===1?(0,v.localize)(24,null,a):(0,v.localize)(25,null,a)):(a=Math.floor(D/h),y?a===1?(0,v.localize)(26,null,a):(0,v.localize)(27,null,a):a===1?(0,v.localize)(28,null,a):(0,v.localize)(29,null,a))}t.fromNow=f;function O(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=O}),define(Q[70],Z([5,6]),function($,t){return $.create("vs/base/common/errorMessage",t)}),define(Q[29],Z([0,1,70,8,23]),function($,t,v,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function w(f,O){return O&&(f.stack||f.stacktrace)?v.localize(0,null,R(f),T(f.stack)||T(f.stacktrace)):R(f)}function T(f){return Array.isArray(f)?f.join(`
`):f}function R(f){return typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?v.localize(1,null,f.message):f.message||v.localize(2,null)}function h(f=null,O=!1){if(!f)return v.localize(3,null);if(Array.isArray(f)){const d=I.coalesce(f),y=h(d[0],O);return d.length>1?v.localize(4,null,y,d.length):y}if(C.isString(f))return f;if(f.detail){const d=f.detail;if(d.error)return w(d.error,O);if(d.exception)return w(d.exception,O)}return f.stack?w(f,O):f.message?f.message:v.localize(5,null)}t.toErrorMessage=h}),define(Q[71],Z([5,6]),function($,t){return $.create("vs/base/node/processes",t)}),define(Q[45],Z([0,1,3,16,12,33,71,34,8,22,36,15,44,10]),function($,t,v,C,I,w,T,R,h,f,O,d,y,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function a(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function m(r,e){if(d.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};e&&(i.cwd=e);const n=w.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],i);return new Promise(s=>{n.once("error",o=>{s({success:!1,error:o})}),n.once("exit",(o,g)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?a(i.status):1})}else if(d.isLinux||d.isMacintosh)try{const i=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(n=>{w.execFile(i,[r.pid.toString()],{encoding:"utf8",shell:!0},(s,o,g)=>{n(s?{success:!1,error:s}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function S(r=R.env){return r.comspec||"cmd.exe"}t.getWindowsShell=S;class E{constructor(e,i,n,s){if(i!==void 0&&n!==void 0&&s!==void 0)this.cmd=e,this.args=i,this.shell=n,this.options=s;else{const o=e;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(R.env).forEach(g=>{o[g]=R.env[g]}),Object.keys(this.options.env).forEach(g=>{o[g]=this.options.env[g]}),this.options.env=o}}getSanitizedCommand(){let e=this.cmd.toLowerCase();const i=e.lastIndexOf(v.sep);return i!==-1&&(e=e.substring(i+1)),E.WellKnowCommands[e]?e:"other"}start(e){return d.isWindows&&(this.options&&this.options.cwd&&O.isUNC(this.options.cwd)||!this.options&&O.isUNC(R.cwd()))?Promise.reject(new Error(T.localize(0,null))):this.useExec().then(i=>{let n,s;const o=new Promise((g,F)=>{n=g,s=F});if(i){let g=this.cmd;this.args&&(g=g+" "+this.args.join(" ")),this.childProcess=w.exec(g,this.options,(F,j,N)=>{this.childProcess=null;const A=F;A&&A.killed?s({killed:this.terminateRequested,stdout:j.toString(),stderr:N.toString()}):this.handleExec(n,e,F,j,N)})}else{let g=null;const F=j=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(j,n,e,s);const N={terminated:this.terminateRequested};h.isNumber(j)&&(N.cmdCode=j),n(N)};if(this.shell&&d.isWindows){const j=f.deepClone(this.options);j.windowsVerbatimArguments=!0,j.detached=!1;let N=!1,A=!1;const U=[];let x=this.ensureQuotes(this.cmd);U.push(x.value),N=x.quoted,this.args&&this.args.forEach(ne=>{x=this.ensureQuotes(ne),U.push(x.value),A=A&&x.quoted});const X=["/s","/c"];N?A?X.push('"'+U.join(" ")+'"'):U.length>1?X.push('"'+U[0]+'" '+U.slice(1).join(" ")):X.push('"'+U[0]+'"'):X.push(U.join(" ")),g=w.spawn(S(),X,j)}else this.cmd&&(g=w.spawn(this.cmd,this.args,this.options));g&&(this.childProcess=g,this.childProcessPromise=Promise.resolve(g),this.pidResolve&&(this.pidResolve(h.isNumber(g.pid)?g.pid:-1),this.pidResolve=void 0),g.on("error",j=>{this.childProcess=null,s({terminated:this.terminateRequested,error:j})}),g.pid&&(this.childProcess.on("close",F),this.handleSpawn(g,n,e,s,!0)))}return o})}handleClose(e,i,n,s){}ensureQuotes(e){return E.regexp.test(e)?{value:'"'+e+'"',quoted:!0}:{value:e,quoted:e.length>0&&e[0]==='"'&&e[e.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(e=>e.pid,e=>-1):new Promise(e=>{this.pidResolve=e})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(e=>(this.terminateRequested=!0,m(e,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),e=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(e=>{if(!this.shell||!d.isWindows)return e(!1);const i=w.spawn(S(),["/s","/c"]);i.on("error",n=>e(!0)),i.on("exit",n=>e(!1))})}}t.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class b extends E{constructor(e,i,n,s){super(e,i,n,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(e,i,n,s,o){[s,o].forEach((g,F)=>{const j=new y.LineDecoder;j.write(g).forEach(U=>{i({line:U,source:F===0?0:1})});const A=j.end();A&&i({line:A,source:F===0?0:1})}),e({terminated:this.terminateRequested,error:n})}handleSpawn(e,i,n,s,o){const g=new y.LineDecoder,F=new y.LineDecoder;e.stdout.on("data",j=>{g.write(j).forEach(A=>n({line:A,source:0}))}),e.stderr.on("data",j=>{F.write(j).forEach(A=>n({line:A,source:1}))}),this.stdoutLineDecoder=g,this.stderrLineDecoder=F}handleClose(e,i,n,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&n({line:o,source:0});const g=this.stderrLineDecoder?this.stderrLineDecoder.end():null;g&&n({line:g,source:1})}}t.LineProcess=b;function p(r){let e=[],i=!1;const n=function(s){if(i){e.push(s);return}(!r.send(s,g=>{if(g&&console.error(g),i=!1,e.length>0){const F=e.slice(0);e=[],F.forEach(j=>n(j))}})||d.isWindows)&&(i=!0)};return{send:n}}t.createQueuedSender=p;var l;(function(r){async function e(i,n,s){if(v.isAbsolute(i))return i;if(n===void 0&&(n=R.cwd()),v.dirname(i)!=="."||(s===void 0&&h.isString(R.env.PATH)&&(s=R.env.PATH.split(v.delimiter)),s===void 0||s.length===0))return v.join(n,i);async function g(F){return await I.exists(F)?!(await C.promises.stat(F)).isDirectory():!1}for(let F of s){let j;if(v.isAbsolute(F)?j=v.join(F,i):j=v.join(n,F,i),await g(j))return j;let N=j+".com";if(await g(N)||(N=j+".exe",await g(N)))return N}return v.join(n,i)}r.findExecutable=e})(l=t.win32||(t.win32={}))}),define(Q[72],Z([0,1,32,15,65,45]),function($,t,v,C,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function T(D,a){return D===3?C.isWindows?d():w.getWindowsShell(a):f(D,a)}t.getSystemShell=T;function R(D,a){return D===3?C.isWindows?y(a):w.getWindowsShell(a):f(D,a)}t.getSystemShellSync=R;let h=null;function f(D,a){if(C.isLinux&&D===1||C.isMacintosh&&D===2)return"/bin/bash";if(!h){let m;if(C.isWindows)m="/bin/bash";else{if(m=a.SHELL,!m)try{m=v.userInfo().shell}catch(S){}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}h=m}return h}let O=null;async function d(){return O||(O=(await(0,I.getFirstAvailablePowerShellInstallation)()).exePath),O}function y(D){if(O)return O;const a=C.isWindows&&parseFloat(v.release())>=10,m=D.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${D.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return a?S:w.getWindowsShell(D)}}),define(Q[46],Z([0,1,33,2,4,22,11,45,37,59,28,14,17,15]),function($,t,v,C,I,w,T,R,h,f,O,d,y,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class a extends h.ChannelServer{constructor(E){super({send:b=>{try{process.send&&process.send(b.buffer.toString("base64"))}catch(p){}},onMessage:T.Event.fromNodeEventEmitter(process,"message",b=>y.VSBuffer.wrap(Buffer.from(b,"base64")))},E);process.once("disconnect",()=>this.dispose())}}t.Server=a;class m{constructor(E,b){this.modulePath=E,this.options=b,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new T.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const p=b&&b.timeout?b.timeout:6e4;this.disposeDelayer=new I.Delayer(p),this.child=null,this._client=null}getChannel(E){const b=this;return{call(p,l,r){return b.requestPromise(E,p,l,r)},listen(p,l){return b.requestEvent(E,p,l)}}}requestPromise(E,b,p,l=O.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(d.canceled());this.disposeDelayer.cancel();const r=this.getCachedChannel(E),e=(0,I.createCancelablePromise)(s=>r.call(b,p,s)),i=l.onCancellationRequested(()=>e.cancel()),n=(0,C.toDisposable)(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(E,b,p){if(!this.disposeDelayer)return T.Event.None;this.disposeDelayer.cancel();let l;const r=new T.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(E).listen(b,p)(r.fire,r),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return r.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],b=Object.create(null);b.env=Object.assign(Object.assign({},(0,w.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(b.env=Object.assign(Object.assign({},b.env),this.options.env)),this.options&&this.options.freshExecArgv&&(b.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(b.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(b.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),b.execArgv===void 0&&(b.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),D.isMacintosh&&b.env&&delete b.env.DYLD_LIBRARY_PATH,this.child=(0,v.fork)(this.modulePath,E,b);const p=new T.Emitter;T.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,f.isRemoteConsoleLog)(o)){(0,f.log)(o,`IPC Library: ${this.options.serverName}`);return}p.fire(y.VSBuffer.wrap(Buffer.from(o,"base64")))});const r=this.options.useQueue?(0,R.createQueuedSender)(this.child):this.child,e=o=>this.child&&this.child.connected&&r.send(o.buffer.toString("base64")),i=p.event,n={send:e,onMessage:i};this._client=new h.ChannelClient(n);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,g)=>{process.removeListener("exit",s),this.activeRequests.forEach(F=>(0,C.dispose)(F)),this.activeRequests.clear(),o!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+g),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:g})})}return this._client}getCachedChannel(E){let b=this.channels.get(E);return b||(b=this.client.getChannel(E),this.channels.set(E,b)),b}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=m}),define(Q[73],Z([5,6]),function($,t){return $.create("vs/base/node/zip",t)}),define(Q[74],Z([5,6]),function($,t){return $.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Q[75],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Q[76],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Q[77],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Q[78],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Q[79],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Q[80],Z([5,6]),function($,t){return $.create("vs/platform/extensions/common/extensionValidator",t)}),define(Q[81],Z([5,6]),function($,t){return $.create("vs/platform/files/common/fileService",t)}),define(Q[82],Z([5,6]),function($,t){return $.create("vs/platform/files/common/io",t)}),define(Q[83],Z([5,6]),function($,t){return $.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Q[84],Z([5,6]),function($,t){return $.create("vs/platform/request/common/request",t)}),define(Q[85],Z([5,6]),function($,t){return $.create("vs/platform/telemetry/common/telemetryService",t)});var ce=this&&this.__decorate||function($,t,v,C){var I=arguments.length,w=I<3?t:C===null?C=Object.getOwnPropertyDescriptor(t,v):C,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")w=Reflect.decorate($,t,v,C);else for(var R=$.length-1;R>=0;R--)(T=$[R])&&(w=(I<3?T(w):I>3?T(t,v,w):T(t,v))||w);return I>3&&w&&Object.defineProperty(t,v,w),w};define(Q[86],Z([0,1,3,18,57,69,10,9,34]),function($,t,v,C,I,w,T,R,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class f{constructor(a,m,S){this._args=a,this.paths=m,this.productService=S}get appRoot(){return(0,v.dirname)(T.FileAccess.asFileUri("",$).fsPath)}get userHome(){return R.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return R.URI.file((0,v.join)(this.userDataPath,"User"))}get tmpDir(){return R.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,C.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const a=(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,v.join)(this.userDataPath,"logs",a)}return this.args.logsPath}get userDataSyncLogResource(){return R.URI.file((0,v.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(R.URI.file((0,v.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return R.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return R.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const a=h.env.VSCODE_PORTABLE;return a?R.URI.file((0,v.join)(a,"argv.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,C.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return R.URI.file((0,v.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,v.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const a=this.args["builtin-extensions-dir"];return a?(0,v.resolve)(a):(0,v.normalize)((0,v.join)(T.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const a=this.args["extensions-download-dir"];return a?(0,v.resolve)(a):(0,v.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const a=this.args["extensions-dir"];if(a)return(0,v.resolve)(a);const m=h.env.VSCODE_EXTENSIONS;if(m)return m;const S=h.env.VSCODE_PORTABLE;return S?(0,v.join)(S,"extensions"):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const a=this.args.extensionDevelopmentPath;if(Array.isArray(a))return a.map(m=>/^[^:/?#]+?:\/\//.test(m)?R.URI.parse(m):R.URI.file((0,v.normalize)(m)))}get extensionDevelopmentKind(){var a;return(a=this.args.extensionDevelopmentKind)===null||a===void 0?void 0:a.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const a=this.args.extensionTestsPath;if(a)return/^[^:/?#]+?:\/\//.test(a)?R.URI.parse(a):R.URI.file((0,v.normalize)(a))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const a=this.args["disable-extension"];if(a){if(typeof a=="string")return[a];if(Array.isArray(a)&&a.length>0)return a}return!1}get debugExtensionHost(){return O(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!h.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,C.joinPath)(R.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return R.URI.file((0,v.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}ce([I.memoize],f.prototype,"appRoot",null),ce([I.memoize],f.prototype,"userHome",null),ce([I.memoize],f.prototype,"userDataPath",null),ce([I.memoize],f.prototype,"appSettingsHome",null),ce([I.memoize],f.prototype,"tmpDir",null),ce([I.memoize],f.prototype,"userRoamingDataHome",null),ce([I.memoize],f.prototype,"settingsResource",null),ce([I.memoize],f.prototype,"userDataSyncHome",null),ce([I.memoize],f.prototype,"userDataSyncLogResource",null),ce([I.memoize],f.prototype,"sync",null),ce([I.memoize],f.prototype,"machineSettingsResource",null),ce([I.memoize],f.prototype,"globalStorageHome",null),ce([I.memoize],f.prototype,"workspaceStorageHome",null),ce([I.memoize],f.prototype,"keybindingsResource",null),ce([I.memoize],f.prototype,"keyboardLayoutResource",null),ce([I.memoize],f.prototype,"argvResource",null),ce([I.memoize],f.prototype,"snippetsHome",null),ce([I.memoize],f.prototype,"isExtensionDevelopment",null),ce([I.memoize],f.prototype,"untitledWorkspacesHome",null),ce([I.memoize],f.prototype,"installSourcePath",null),ce([I.memoize],f.prototype,"builtinExtensionsPath",null),ce([I.memoize],f.prototype,"extensionsPath",null),ce([I.memoize],f.prototype,"extensionDevelopmentLocationURI",null),ce([I.memoize],f.prototype,"extensionDevelopmentKind",null),ce([I.memoize],f.prototype,"extensionTestsLocationURI",null),ce([I.memoize],f.prototype,"debugExtensionHost",null),ce([I.memoize],f.prototype,"serviceMachineIdResource",null),ce([I.memoize],f.prototype,"telemetryLogResource",null),t.AbstractNativeEnvironmentService=f;function O(D,a){return y(D["inspect-extensions"],D["inspect-brk-extensions"],5870,a,D.debugId)}t.parseExtensionHostPort=O;function d(D,a){return y(D["inspect-search"],D["inspect-brk-search"],5876,a)}t.parseSearchPort=d;function y(D,a,m,S,E){const p=Number(a||D)||(S?null:m),l=p?Boolean(!!a):!1;return{port:p,break:l,debugId:E}}}),function(){"use strict";function $(t,v,C,I){function w(R){const h=T(R),f=[h];return t.isAbsolute(h)||f.unshift(I),t.resolve(...f)}function T(R){const h=process.env.VSCODE_PORTABLE;if(h)return t.join(h,"user-data");const f=R["user-data-dir"];if(f)return f;let O=process.env.VSCODE_APPDATA;if(!O)switch(process.platform){case"win32":if(O=process.env.APPDATA,!O){const d=process.env.USERPROFILE;if(typeof d!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");O=t.join(d,"AppData","Roaming")}break;case"darwin":O=t.join(v.homedir(),"Library","Application Support");break;case"linux":O=process.env.XDG_CONFIG_HOME||t.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(O,C)}return{getUserDataPath:w}}if(typeof define=="function")define(Q[87],Z([0,88,32,10,18,34]),function(t,v,C,I,w,T){const R=w.dirname(I.FileAccess.asFileUri("",t)),h=t.__$__nodeRequire(w.joinPath(R,"package.json").fsPath);return $(v,C,h.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),v=require("path"),C=require("os");module.exports=$(v,C,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[89],Z([0,1,32,87,86]),function($,t,v,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class w extends I.AbstractNativeEnvironmentService{constructor(R,h){super(R,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,C.getUserDataPath)(R)},h)}}t.NativeEnvironmentService=w}),define(Q[90],Z([0,1,22]),function($,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const C=/^%([\w\d.-]+)%$/i;function I(w,T){const R=h=>{if(typeof h=="string"){const f=C.exec(h);if(!!f)return T[f[1]]||h}};return(0,v.cloneAndChange)(w,R)}t.localizeManifest=I}),define(Q[47],Z([0,1,80]),function($,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVersionValid=t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function I(d){return d=d.trim(),d==="*"||C.test(d)}t.isValidVersionStr=I;function w(d){if(!I(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=d.match(C);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}t.parseVersion=w;function T(d){if(!d)return null;let y=d.majorBase,D=d.majorMustEqual,a=d.minorBase,m=d.minorMustEqual,S=d.patchBase,E=d.patchMustEqual;return d.hasCaret&&(y===0||(m=!1),E=!1),{majorBase:y,majorMustEqual:D,minorBase:a,minorMustEqual:m,patchBase:S,patchMustEqual:E,isMinimum:d.hasGreaterEquals}}t.normalizeVersion=T;function R(d,y){let D;typeof d=="string"?D=T(w(d)):D=d;let a;if(typeof y=="string"?a=T(w(y)):a=y,!D||!a)return!1;let m=D.majorBase,S=D.minorBase,E=D.patchBase,b=a.majorBase,p=a.minorBase,l=a.patchBase,r=a.majorMustEqual,e=a.minorMustEqual,i=a.patchMustEqual;return a.isMinimum?m>b?!0:m<b?!1:S>p?!0:S<p?!1:E>=l:(m===1&&b===0&&(!r||!e||!i)&&(b=1,p=0,l=0,r=!0,e=!1,i=!1),m<b?!1:m>b?!r:S<p?!1:S>p?!e:E<l?!1:E>l?!i:!0)}t.isValidVersion=R;function h(d,y,D){return y.isBuiltin||typeof y.main=="undefined"?!0:O(d,y.engines.vscode,D)}t.isValidExtensionVersion=h;function f(d,y){return d==="*"||O(y,d)}t.isEngineValid=f;function O(d,y,D=[]){let a=T(w(y));if(!a)return D.push(v.localize(0,null,y)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return D.push(v.localize(1,null,y)),!1}else if(!a.majorMustEqual)return D.push(v.localize(2,null,y)),!1;return R(d,a)?!0:(D.push(v.localize(3,null,d,y)),!1)}t.isVersionValid=O}),define(Q[91],Z([0,1,37,46,2,10]),function($,t,v,C,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends I.Disposable{constructor(h,f,O,d){super();this.folders=h,this.onDidFilesChange=f,this.onLogMessage=O,this.verboseLogging=d,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const h=this._register(new C.Client(w.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(h.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService((0,v.getNextTickChannel)(h.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(f=>!this.isDisposed&&this.onDidFilesChange(f))),this._register(this.service.onDidLogMessage(f=>this.onLogMessage(f))),this.setFolders(this.folders)}setVerboseLogging(h){this.verboseLogging=h,!this.isDisposed&&this.service&&this.service.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${h}`})}setFolders(h){this.folders=h,this.service&&this.service.setRoots(h)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=T,T.MAX_RESTARTS=5}),define(Q[92],Z([0,1,37,46,2,10]),function($,t,v,C,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends I.Disposable{constructor(h,f,O,d,y={}){super();this.folders=h,this.onDidFilesChange=f,this.onLogMessage=O,this.verboseLogging=d,this.watcherOptions=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const h=this._register(new C.Client(w.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(h.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService((0,v.getNextTickChannel)(h.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(f=>!this.isDisposed&&this.onDidFilesChange(f))),this._register(this.service.onDidLogMessage(f=>this.onLogMessage(f))),this.service.setRoots(this.folders)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${h}`})}setVerboseLogging(h){this.verboseLogging=h,this.service&&this.service.setVerboseLogging(h)}setFolders(h){this.folders=h,this.service&&this.service.setRoots(h)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=T,T.MAX_RESTARTS=5}),define(Q[93],Z([0,1,33,44,61,10]),function($,t,v,C,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class T{constructor(h,f,O,d,y){this.watchedFolder=h,this.eventCallback=O,this.logCallback=d,this.verboseLogging=y,this.restartCounter=0,Array.isArray(f)?this.ignored=f.map(D=>I.parse(D)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${h}`),this.startWatcher()}startWatcher(){const h=[this.watchedFolder];this.verboseLogging&&h.push("-verbose"),this.handle=v.spawn(w.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",$).fsPath,h);const f=new C.LineDecoder;this.handle.stdout.on("data",O=>{const d=[];f.write(O).forEach(y=>{const D=y.split("|");if(D.length===2){const a=Number(D[0]),m=D[1];if(a>=0&&a<3){if(this.ignored&&this.ignored.some(S=>S(m))){this.verboseLogging&&this.log(m);return}d.push({type:T.changeTypeMap[a],path:m})}else this.log(D[1])}}),d.length>0&&this.eventCallback(d)}),this.handle.on("error",O=>this.onError(O)),this.handle.stderr.on("data",O=>this.onError(O)),this.handle.on("exit",(O,d)=>this.onExit(O,d))}onError(h){this.error("process error: "+h.toString())}onExit(h,f){this.handle&&(this.error(`terminated unexpectedly (code: ${h}, signal: ${f})`),this.restartCounter<=T.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(h){this.logCallback({type:"error",message:`[File Watcher (C#)] ${h}`})}log(h){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${h}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=T,T.MAX_RESTARTS=5,T.changeTypeMap=[0,1,2]}),define(Q[94],Z([0,1,93,3,21]),function($,t,v,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class w{constructor(R,h,f,O){this.onDidFilesChange=h,this.onLogMessage=f,this.verboseLogging=O,this.service=void 0,this.folder=R[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(C.posix.sep)&&(this.folder.path=(0,I.rtrim)(this.folder.path,C.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new v.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,R=>this.onFileEvents(R),R=>this.onLogMessage(R),this.verboseLogging)}setVerboseLogging(R){this.verboseLogging=R,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(R){this.isDisposed||R.length>0&&this.onDidFilesChange(R)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=w}),define(Q[48],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class v{constructor(w,T=[],R=!1){this.ctor=w,this.staticArguments=T,this.supportsDelayedInstantiation=R}}t.SyncDescriptor=v;const C=(I,...w)=>new v(I,w);t.createSyncDescriptor=C}),define(Q[95],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class v{constructor(w){this.incoming=new Map,this.outgoing=new Map,this.data=w}}t.Node=v;class C{constructor(w){this._hashFn=w,this._nodes=new Map}roots(){const w=[];for(let T of this._nodes.values())T.outgoing.size===0&&w.push(T);return w}insertEdge(w,T){const R=this.lookupOrInsertNode(w),h=this.lookupOrInsertNode(T);R.outgoing.set(this._hashFn(T),h),h.incoming.set(this._hashFn(w),R)}removeNode(w){const T=this._hashFn(w);this._nodes.delete(T);for(let R of this._nodes.values())R.outgoing.delete(T),R.incoming.delete(T)}lookupOrInsertNode(w){const T=this._hashFn(w);let R=this._nodes.get(T);return R||(R=new v(w),this._nodes.set(T,R)),R}lookup(w){return this._nodes.get(this._hashFn(w))}isEmpty(){return this._nodes.size===0}toString(){let w=[];for(let[T,R]of this._nodes)w.push(`${T}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return w.join(`
`)}}t.Graph=C}),define(Q[96],Z([0,1,7]),function($,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,v.createDecorator)("downloadService")}),define(Q[19],Z([0,1,7]),function($,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,v.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,v.refineServiceDecorator)(t.IEnvironmentService)}),define(Q[24],Z([0,1,75,7,10]),function($,t,v,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN);function w(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}t.isIExtensionIdentifier=w;var T;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=5]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(T=t.SortBy||(t.SortBy={}));var R;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(R=t.SortOrder||(t.SortOrder={}));var h;(function(d){d.Uninstall="uninstall"})(h=t.StatisticType||(t.StatisticType={}));var f;(function(d){d[d.None=0]="None",d[d.Install=1]="Install",d[d.Update=2]="Update"})(f=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class O extends Error{constructor(y,D){super(y);this.code=D}}t.ExtensionManagementError=O,t.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=I.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),t.ExtensionsLabel=(0,v.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,v.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService")}),define(Q[38],Z([0,1,21,7]),function($,t,v,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin";function I(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}t.isIExtensionIdentifier=I,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var w;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(w=t.ExtensionType||(t.ExtensionType={}));class T{constructor(O){this.value=O,this._lower=O.toLowerCase()}static equals(O,d){if(typeof O=="undefined"||O===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof O=="string"||typeof d=="string"){let y=typeof O=="string"?O:O.value,D=typeof d=="string"?d:d.value;return v.equalsIgnoreCase(y,D)}return O._lower===d._lower}static toKey(O){return typeof O=="string"?O.toLowerCase():O._lower}}t.ExtensionIdentifier=T;function R(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}t.isLanguagePackExtension=R;function h(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=h,t.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[25],Z([0,1,21,38]),function($,t,v,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function I(D,a){return D.uuid&&a.uuid?D.uuid===a.uuid:D.id===a.id?!0:(0,v.compareIgnoreCase)(D.id,a.id)===0}t.areSameExtensions=I;class w{constructor(a,m){this.version=m,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof w?I(this,a)&&this.version===a.version:!1}}t.ExtensionIdentifierWithVersion=w;function T(D,a){return`${D}.${a}`}t.getExtensionId=T;function R(D){return D.toLocaleLowerCase()}t.adoptToGalleryExtensionId=R;function h(D,a){return R(T(D,a))}t.getGalleryExtensionId=h;function f(D,a){const m=[],S=E=>{for(const b of m)if(b.some(p=>I(a(p),a(E))))return b;return null};for(const E of D){const b=S(E);b?b.push(E):m.push([E])}return m}t.groupByExtension=f;function O(D){return{id:D.identifier.id,name:D.manifest.name,galleryId:null,publisherId:D.publisherId,publisherName:D.manifest.publisher,publisherDisplayName:D.publisherDisplayName,dependencies:D.manifest.extensionDependencies&&D.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=O;function d(D){return Object.assign({id:D.identifier.id,name:D.name,galleryId:D.identifier.uuid,publisherId:D.publisherId,publisherName:D.publisher,publisherDisplayName:D.publisherDisplayName,dependencies:!!(D.properties.dependencies&&D.properties.dependencies.length>0)},D.telemetryData)}t.getGalleryExtensionTelemetryData=d,t.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function y(D){const a=new Set;for(const m of D)m.malicious&&a.add(m.id.id);return a}t.getMaliciousExtensionsSet=y});var ue=this&&this.__param||function($,t){return function(v,C){t(v,C,$)}};define(Q[97],Z([0,1,76,14,9,39,24,25,38,62,28,10]),function($,t,v,C,I,w,T,R,h,f,O,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const y=b=>(0,v.localize)(0,null,b),D=(0,v.localize)(1,null,"ms-dotnettools.csharp");function a(b,p){return p?`${b.publisher}.${b.name}@${b.version}`:`${b.publisher}.${b.name}`}const m=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function S(b){const p=m.exec(b);return p&&p[1]?[(0,R.adoptToGalleryExtensionId)(p[1]),p[2]]:[(0,R.adoptToGalleryExtensionId)(b),void 0]}t.getIdAndVersion=S;let E=class{constructor(p,l){this.extensionManagementService=p,this.extensionGalleryService=l}get location(){}async listExtensions(p,l,r=console){let e=await this.extensionManagementService.getInstalled(1);const i=h.EXTENSION_CATEGORIES.map(s=>s.toLowerCase());if(l&&l!==""){if(i.indexOf(l.toLowerCase())<0){r.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(s=>s.manifest.categories?s.manifest.categories.map(g=>g.toLowerCase()).indexOf(l.toLowerCase())>-1:!1)}else if(l===""){r.log("Possible Categories: "),i.forEach(s=>{r.log(s)});return}this.location&&r.log((0,v.localize)(2,null,this.location)),e=e.sort((s,o)=>s.identifier.id.localeCompare(o.identifier.id));let n;for(let s of e)n!==s.identifier.id&&(n=s.identifier.id,r.log(a(s.manifest,p)))}async installExtensions(p,l,r,e,i=console){const n=[],s=[];p.length&&i.log(this.location?(0,v.localize)(3,null,this.location):(0,v.localize)(4,null));const o=await this.extensionManagementService.getInstalled(1),g=(N,A)=>{const U=o.find(x=>(0,R.areSameExtensions)(x.identifier,{id:N}));if(U){if(!A&&!e)return i.log((0,v.localize)(5,null,N,U.manifest.version,N)),!1;if(A&&U.manifest.version===A)return i.log((0,v.localize)(6,null,`${N}@${A}`)),!1}return!0},F=[],j=[];for(const N of p)if(N instanceof I.URI)F.push(N);else{const[A,U]=S(N);g(A,U)&&j.push({id:A,version:U,installOptions:{isBuiltin:!1,isMachineScoped:r}})}for(const N of l){const[A,U]=S(N);g(A,U)&&j.push({id:A,version:U,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(F.length&&await Promise.all(F.map(async N=>{try{const A=await this.installVSIX(N,{isBuiltin:!1,isMachineScoped:r},e,i);A&&s.push(A)}catch(A){i.error(A.message||A.stack||A),n.push(N.toString())}})),j.length){const N=await this.getGalleryExtensions(j);await Promise.all(j.map(async A=>{const U=N.get(A.id.toLowerCase());if(U)try{const x=await this.installFromGallery(A,U,o,e,i);x&&s.push(x)}catch(x){i.error(x.message||x.stack||x),n.push(A.id)}else i.error(`${y(A.version?`${A.id}@${A.version}`:A.id)}
${D}`),n.push(A.id)}))}if(n.length)throw new Error((0,v.localize)(7,null,n.join(", ")))}async installVSIX(p,l,r,e){const i=await this.extensionManagementService.getManifest(p);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,r,e))try{return await this.extensionManagementService.install(p,l),e.log((0,v.localize)(8,null,(0,f.getBaseLabel)(p))),i}catch(s){if((0,C.isPromiseCanceledError)(s))return e.log((0,v.localize)(9,null,(0,f.getBaseLabel)(p))),null;throw s}return null}async getGalleryExtensions(p){const l=p.filter(({version:i})=>i===void 0).map(({id:i})=>i),r=p.filter(({version:i})=>i!==void 0),e=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(l,O.CancellationToken.None)).forEach(n=>e.set(n.identifier.id.toLowerCase(),n))})(),Promise.all(r.map(async({id:i,version:n})=>{const s=await this.extensionGalleryService.getCompatibleExtension({id:i},n);s&&e.set(s.identifier.id.toLowerCase(),s)}))]),e}async installFromGallery({id:p,version:l,installOptions:r},e,i,n,s){const o=await this.extensionGalleryService.getManifest(e,O.CancellationToken.None);if(o&&!this.validateExtensionKind(o,s))return null;const g=i.find(F=>(0,R.areSameExtensions)(F.identifier,e.identifier));if(g){if(e.version===g.manifest.version)return s.log((0,v.localize)(10,null,l?`${p}@${l}`:p)),null;s.log((0,v.localize)(11,null,p,e.version))}try{return r.isBuiltin?s.log((0,v.localize)(12,null,p,e.version)):s.log((0,v.localize)(13,null,p,e.version)),await this.extensionManagementService.installFromGallery(e,r),s.log((0,v.localize)(14,null,p,e.version)),o}catch(F){if((0,C.isPromiseCanceledError)(F))return s.log((0,v.localize)(15,null,p)),null;throw F}}validateExtensionKind(p,l){return!0}async validateVSIX(p,l,r){const e={id:(0,R.getGalleryExtensionId)(p.publisher,p.name)},n=(await this.extensionManagementService.getInstalled(1)).find(s=>(0,R.areSameExtensions)(e,s.identifier)&&(0,w.gt)(s.manifest.version,p.version));return n&&!l?(r.log((0,v.localize)(16,null,n.identifier.id,n.manifest.version,p.version)),!1):this.validateExtensionKind(p,r)}async uninstallExtensions(p,l,r=console){const e=async n=>{if(n instanceof I.URI){const s=await this.extensionManagementService.getManifest(n);return a(s)}return n},i=[];for(const n of p){const s=await e(n),g=(await this.extensionManagementService.getInstalled()).filter(F=>(0,R.areSameExtensions)(F.identifier,{id:s}));if(!g.length)throw new Error(`${this.notInstalled(s)}
${D}`);if(g.some(F=>F.type===0)){r.log((0,v.localize)(17,null,s));return}if(!l&&g.some(F=>F.isBuiltin)){r.log((0,v.localize)(18,null,s));return}r.log((0,v.localize)(19,null,s));for(const F of g)await this.extensionManagementService.uninstall(F),i.push(F);this.location?r.log((0,v.localize)(20,null,s,this.location)):r.log((0,v.localize)(21,null,s))}}async locateExtension(p,l=console){const r=await this.extensionManagementService.getInstalled();p.forEach(e=>{r.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===d.Schemas.file){l.log(i.location.fsPath);return}})})}notInstalled(p){return this.location?(0,v.localize)(22,null,p,this.location):(0,v.localize)(23,null,p)}};E=ce([ue(0,T.IExtensionManagementService),ue(1,T.IExtensionGalleryService)],E),t.ExtensionManagementCLIService=E}),define(Q[98],Z([0,1,2,3,38,12]),function($,t,v,C,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class T extends v.Disposable{constructor(h,f){super();this.environmentService=h,this.extensionsManifestCache=(0,C.join)(this.environmentService.userDataPath,I.MANIFEST_CACHE_FOLDER,I.USER_MANIFEST_CACHE_FILE),this._register(f.onDidInstallExtension(O=>this.onDidInstallExtension(O))),this._register(f.onDidUninstallExtension(O=>this.onDidUnInstallExtension(O)))}onDidInstallExtension(h){h.error||this.invalidate()}onDidUnInstallExtension(h){h.error||this.invalidate()}invalidate(){w.rimraf(this.extensionsManifestCache,w.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=T}),define(Q[99],Z([0,1,88,33,30,15,129,29,72]),function($,t,v,C,I,w,T,R,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function f(y,D,a){return D["force-disable-user-env"]?(y.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.isWindows?(y.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,T.isLaunchedFromCli)(a)&&!D["force-user-env"]?(y.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,T.isLaunchedFromCli)(a)?y.trace("resolveShellEnv(): running (--force-user-env)"):y.trace("resolveShellEnv(): running (macOS/Linux)"),O||(O=d(y)),O)}t.resolveShellEnv=f;let O;async function d(y){const D=new Promise(async(a,m)=>{const S=process.env.ELECTRON_RUN_AS_NODE;y.trace("getUnixShellEnvironment#runAsNode",S);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;y.trace("getUnixShellEnvironment#noAttach",E);const b=(0,I.generateUuid)().replace(/-/g,"").substr(0,12),p=new RegExp(b+"(.*)"+b),l=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});y.trace("getUnixShellEnvironment#env",l);const r=await(0,h.getSystemShell)(w.platform,l);y.trace("getUnixShellEnvironment#shell",r);let e=`'${process.execPath}' -p '"${b}" + JSON.stringify(process.env) + "${b}"'`,i=["-ilc"];const n=v.basename(r);/^pwsh(-preview)?$/.test(n)&&(e=`& ${e}`,i=["-Login","-Command"]),y.trace("getUnixShellEnvironment#spawn",JSON.stringify(i),e);const s=(0,C.spawn)(r,[...i,e],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});s.on("error",F=>{y.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)(F)),a({})});const o=[];s.stdout.on("data",F=>o.push(F));const g=[];s.stderr.on("data",F=>g.push(F)),s.on("close",(F,j)=>{const N=Buffer.concat(o).toString("utf8");y.trace("getUnixShellEnvironment#raw",N);const A=Buffer.concat(g).toString("utf8");if(A.trim()&&y.trace("getUnixShellEnvironment#stderr",A),F||j)return m(new Error(`Failed to get environment (code ${F}, signal ${j})`));const U=p.exec(N),x=U?U[1]:"{}";try{const X=JSON.parse(x);S?X.ELECTRON_RUN_AS_NODE=S:delete X.ELECTRON_RUN_AS_NODE,E?X.ELECTRON_NO_ATTACH_CONSOLE=E:delete X.ELECTRON_NO_ATTACH_CONSOLE,delete X.XDG_RUNTIME_DIR,y.trace("getUnixShellEnvironment#result",X),a(X)}catch(X){y.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)(X)),m(X)}})});try{return await D}catch(a){return y.error("getUnixShellEnvironment#error",(0,R.toErrorMessage)(a)),{}}}}),define(Q[49],Z([0,1,82,17,20,14]),function($,t,v,C,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function T(O,d,y,D,a,m){let S;try{await R(O,d,y,D,a,m)}catch(E){S=E}finally{S&&a.errorTransformer&&(S=a.errorTransformer(S)),typeof S!="undefined"&&y.error(S),y.end()}}t.readFileIntoStream=T;async function R(O,d,y,D,a,m){h(m);const S=await O.open(d,{create:!1});try{h(m);let E=0,b=0,p=a&&typeof a.length=="number"?a.length:void 0,l=C.VSBuffer.alloc(Math.min(a.bufferSize,typeof p=="number"?p:a.bufferSize)),r=a&&typeof a.position=="number"?a.position:0,e=0;do b=await O.read(S,r,l.buffer,e,l.byteLength-e),r+=b,e+=b,E+=b,typeof p=="number"&&(p-=b),e===l.byteLength&&(await y.write(D(l)),l=C.VSBuffer.alloc(Math.min(a.bufferSize,typeof p=="number"?p:a.bufferSize)),e=0);while(b>0&&(typeof p!="number"||p>0)&&h(m)&&f(E,a));if(e>0){let i=e;typeof p=="number"&&(i=Math.min(e,p)),y.write(D(l.slice(0,i)))}}catch(E){throw(0,I.ensureFileSystemProviderError)(E)}finally{await O.close(S)}}function h(O){if(O.isCancellationRequested)throw(0,w.canceled)();return!0}function f(O,d){if(d==null?void 0:d.limits){if(typeof d.limits.memory=="number"&&O>d.limits.memory)throw(0,I.createFileSystemProviderError)((0,v.localize)(0,null),I.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof d.limits.size=="number"&&O>d.limits.size)throw(0,I.createFileSystemProviderError)((0,v.localize)(1,null),I.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[50],Z([0,1,9,20,15]),function($,t,v,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function w(h){return h.map(f=>({type:f.type,resource:v.URI.file(f.path)}))}t.toFileChanges=w;function T(h){const f=new R;for(const O of h)f.processEvent(O);return f.normalize()}t.normalizeFileChanges=T;class R{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(f){const O=this.mapPathToChange.get(f.path);if(O){const d=O.type,y=f.type;d===1&&y===2?(this.mapPathToChange.delete(f.path),this.normalized.splice(this.normalized.indexOf(O),1)):d===2&&y===1?O.type=0:d===1&&y===0||(O.type=y)}else this.normalized.push(f),this.mapPathToChange.set(f.path,f)}normalize(){const f=[],O=[];return this.normalized.filter(d=>d.type!==2?(f.push(d),!1):!0).sort((d,y)=>d.path.length-y.path.length).filter(d=>O.some(y=>(0,C.isParent)(d.path,y,!I.isLinux))?!1:(O.push(d.path),!0)).concat(f)}}}),define(Q[100],Z([0,1,50,2,12,63,66,4,3]),function($,t,v,C,I,w,T,R,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class f extends C.Disposable{constructor(d,y,D,a){super();this.path=d,this.onDidFilesChange=y,this.onLogMessage=D,this.verboseLogging=a,this.fileChangesDelayer=this._register(new R.ThrottledDelayer(T.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(d){this.verboseLogging=d}async startWatching(){try{const{stat:d,symbolicLink:y}=await I.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let D=this.path;if(y)try{D=await(0,w.realpath)(D)}catch(a){if(this.onError(a),y.dangling)return}d.isDirectory()?this._register((0,T.watchFolder)(D,(a,m)=>{this.onFileChange({type:a==="changed"?0:a==="added"?1:2,path:(0,h.join)(this.path,(0,h.basename)(m))})},a=>this.onError(a))):this._register((0,T.watchFile)(D,a=>{this.onFileChange({type:a==="changed"?0:2,path:this.path})},a=>this.onError(a)))}catch(d){d.code!=="ENOENT"&&this.onError(d)}}onFileChange(d){this.fileChangesBuffer.push(d),this.verboseLogging&&this.onVerbose(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`),this.fileChangesDelayer.trigger(async()=>{const y=this.fileChangesBuffer;this.fileChangesBuffer=[];const D=(0,v.normalizeFileChanges)(y);this.verboseLogging&&D.forEach(a=>{this.onVerbose(`>> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`)}),D.length>0&&this.onDidFilesChange(D)})}onError(d){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${d}`})}onVerbose(d){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=f}),define(Q[51],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class v{constructor(...I){this._entries=new Map;for(let[w,T]of I)this.set(w,T)}set(I,w){const T=this._entries.get(I);return this._entries.set(I,w),T}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}t.ServiceCollection=v}),define(Q[101],Z([0,1,14,95,48,7,51,4]),function($,t,v,C,I,w,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const h=!1;class f extends Error{constructor(a){super("cyclic dependency between services");this.message=a.toString()}}class O{constructor(a=new T.ServiceCollection,m=!1,S){this._activeInstantiations=new Set,this._services=a,this._strict=m,this._parent=S,this._services.set(w.IInstantiationService,this)}createChild(a){return new O(a,this._strict,this)}invokeFunction(a,...m){let S=y.traceInvocation(a),E=!1;try{return a({get:(p,l)=>{if(E)throw(0,v.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(p,S);if(!r&&l!==w.optional)throw new Error(`[invokeFunction] unknown service '${p}'`);return r}},...m)}finally{E=!0,S.stop()}}createInstance(a,...m){let S,E;return a instanceof I.SyncDescriptor?(S=y.traceCreation(a.ctor),E=this._createInstance(a.ctor,a.staticArguments.concat(m),S)):(S=y.traceCreation(a),E=this._createInstance(a,m,S)),S.stop(),E}_createInstance(a,m=[],S){let E=w._util.getServiceDependencies(a).sort((l,r)=>l.index-r.index),b=[];for(const l of E){let r=this._getOrCreateServiceInstance(l.id,S);if(!r&&this._strict&&!l.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${l.id}.`);b.push(r)}let p=E.length>0?E[0].index:m.length;if(m.length!==p){console.warn(`[createInstance] First service dependency of ${a.name} at position ${p+1} conflicts with ${m.length} static arguments`);let l=p-m.length;l>0?m=m.concat(new Array(l)):m=m.slice(0,p)}return new a(...[...m,...b])}_setServiceInstance(a,m){if(this._services.get(a)instanceof I.SyncDescriptor)this._services.set(a,m);else if(this._parent)this._parent._setServiceInstance(a,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let m=this._services.get(a);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):m}_getOrCreateServiceInstance(a,m){let S=this._getServiceInstanceOrDescriptor(a);return S instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,S,m.branch(a,!0)):(m.branch(a,!1),S)}_safeCreateAndCacheServiceInstance(a,m,S){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,m,S)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,m,S){const E=new C.Graph(l=>l.id.toString());let b=0;const p=[{id:a,desc:m,_trace:S}];for(;p.length;){const l=p.pop();if(E.lookupOrInsertNode(l),b++>1e3)throw new f(E);for(let r of w._util.getServiceDependencies(l.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(r.id);if(!e&&!r.optional&&console.warn(`[createInstance] ${a} depends on ${r.id} which is NOT registered.`),e instanceof I.SyncDescriptor){const i={id:r.id,desc:e,_trace:l._trace.branch(r.id,!0)};E.insertEdge(l,i),p.push(i)}}}for(;;){const l=E.roots();if(l.length===0){if(!E.isEmpty())throw new f(E);break}for(const{data:r}of l){if(this._getServiceInstanceOrDescriptor(r.id)instanceof I.SyncDescriptor){const i=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,i)}E.removeNode(r)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,m,S=[],E,b){if(this._services.get(a)instanceof I.SyncDescriptor)return this._createServiceInstance(m,S,E,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,m,S,E,b);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(a,m=[],S,E){if(S){const b=new R.IdleValue(()=>this._createInstance(a,m,E));return new Proxy(Object.create(null),{get(p,l){if(l in p)return p[l];let r=b.value,e=r[l];return typeof e!="function"||(e=e.bind(r),p[l]=e),e},set(p,l,r){return b.value[l]=r,!0}})}else return this._createInstance(a,m,E)}}t.InstantiationService=O;var d;(function(D){D[D.Creation=0]="Creation",D[D.Invocation=1]="Invocation",D[D.Branch=2]="Branch"})(d||(d={}));class y{constructor(a,m){this.type=a,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return h?new y(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):y._None}static traceCreation(a){return h?new y(0,a.name):y._None}branch(a,m){let S=new y(2,a.toString());return this._dep.push([a,m,S]),S}stop(){let a=Date.now()-this._start;y._totals+=a;let m=!1;function S(b,p){let l=[],r=new Array(b+1).join("	");for(const[e,i,n]of p._dep)if(i&&n){m=!0,l.push(`${r}CREATES -> ${e}`);let s=S(b+1,n);s&&l.push(s)}else l.push(`${r}uses -> ${e}`);return l.join(`
`)}let E=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(a>2||m)&&console.log(E.join(`
`))}}y._None=new class extends y{constructor(){super(-1,null)}stop(){}branch(){return this}},y._totals=0}),define(Q[52],Z([0,1,7]),function($,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,v.createDecorator)("localizationsService");function C(I){if(typeof I.languageId!="string"||!Array.isArray(I.translations)||I.translations.length===0)return!1;for(const w of I.translations)if(typeof w.id!="string"||typeof w.path!="string")return!1;return!(I.languageName&&typeof I.languageName!="string"||I.localizedLanguageName&&typeof I.localizedLanguageName!="string")}t.isValidLocalization=C}),define(Q[13],Z([0,1,7,2,15,11,29]),function($,t,v,C,I,w,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,v.createDecorator)("logService"),t.ILoggerService=(0,v.createDecorator)("loggerService");function R(){return new Date().toISOString()}var h;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(h=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=h.Info;class f extends C.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new w.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=f;class O extends f{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(h.Trace)&&this.log(h.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(h.Debug)&&this.log(h.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(h.Info)&&this.log(h.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(h.Warning)&&this.log(h.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(h.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(h.Error,this.format(n))}else this.log(h.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(h.Critical)&&this.log(h.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let s=e[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch(o){}i+=(n>0?" ":"")+s}return i}}t.AbstractMessageLogger=O;class d extends f{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!I.isWindows}trace(e,...i){this.getLevel()<=h.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,e,...i):console.log(`[main ${R()}]`,e,...i))}debug(e,...i){this.getLevel()<=h.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,e,...i):console.log(`[main ${R()}]`,e,...i))}info(e,...i){this.getLevel()<=h.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,e,...i):console.log(`[main ${R()}]`,e,...i))}warn(e,...i){this.getLevel()<=h.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,e,...i):console.warn(`[main ${R()}]`,e,...i))}error(e,...i){this.getLevel()<=h.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,e,...i):console.error(`[main ${R()}]`,e,...i))}critical(e,...i){this.getLevel()<=h.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,e,...i):console.error(`[main ${R()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=d;class y extends f{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=h.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=h.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=h.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=h.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=h.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=h.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=y;class D extends f{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=h.Trace&&this.adapter.log(h.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=h.Debug&&this.adapter.log(h.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=h.Info&&this.adapter.log(h.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=h.Warning&&this.adapter.log(h.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=h.Error&&this.adapter.log(h.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=h.Critical&&this.adapter.log(h.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,T.toErrorMessage)(e,this.getLevel()<=h.Trace)}dispose(){}flush(){}}t.AdapterLogger=D;class a extends f{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=a;class m extends C.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=m;class S extends C.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(n))}))}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,(i==null?void 0:i.always)?h.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=S;class E{constructor(){this.onDidChangeLogLevel=new w.Emitter().event}setLevel(e){}getLevel(){return h.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=E;function b(r){if(r.verbose)return h.Trace;if(typeof r.logLevel=="string"){const e=p(r.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=b;function p(r){switch(r){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Critical;case"off":return h.Off}}t.parseLogLevel=p;function l(r){switch(r){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Critical:return"critical";case h.Off:return"off"}}t.LogLevelToString=l}),define(Q[102],Z([0,1,16,2,20,24,19,9,18,25,13,30,39,15,4,14]),function($,t,v,C,I,w,T,R,h,f,O,d,y,D,a,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let E=class extends C.Disposable{constructor(p,l,r,e){super();this.fileService=l,this.extensionGalleryService=r,this.logService=e,this.extensionsDownloadDir=R.URI.file(p.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(p,l){await this.cleanUpPromise;const r=this.getName(p),e=(0,h.joinPath)(this.extensionsDownloadDir,r);if(!await this.fileService.exists(e)){const i=(0,h.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(p,i,l);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(s){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",p.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,m.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(p){}async rename(p,l,r){try{await v.promises.rename(p.fsPath,l.fsPath)}catch(e){if(D.isWindows&&e&&e.code==="EPERM"&&Date.now()<r)return this.logService.info(`Failed renaming ${p} to ${l} with 'EPERM' error. Trying again...`),this.rename(p,l,r);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const p=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(p.children){const l=[],r=[];for(const n of p.children){const s=this.parse(n.name);s&&r.push([s,n])}const e=(0,f.groupByExtension)(r,([n])=>n),i=[];for(const n of e)n.sort((s,o)=>y.rcompare(s[0].version,o[0].version)),l.push(...n.slice(1).map(s=>s[1].resource)),i.push(n[0][1]);i.sort((n,s)=>n.mtime-s.mtime),l.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await a.Promises.settled(l.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(p){this.logService.error(p)}}getName(p){return this.cache?new f.ExtensionIdentifierWithVersion(p.identifier,p.version).key().toLowerCase():(0,d.generateUuid)()}parse(p){const l=S.exec(p);return l&&l[1]&&l[2]?new f.ExtensionIdentifierWithVersion({id:l[1]},l[2]):null}};E=ce([ue(0,T.INativeEnvironmentService),ue(1,I.IFileService),ue(2,w.IExtensionGalleryService),ue(3,O.ILogService)],E),t.ExtensionsDownloader=E}),define(Q[103],Z([0,1,2,13,33,29,3,4,11,10,12,19]),function($,t,v,C,I,w,T,R,h,f,O,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let y=class extends v.Disposable{constructor(a,m){super();this.environmentService=a,this.logService=m,this.processesLimiter=new R.Limiter(5)}async postUninstall(a){const m=this.parseScript(a,"uninstall");return m&&(this.logService.info(a.identifier.id,a.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(m.script,"uninstall",m.args,!0,a).then(()=>this.logService.info(a.identifier.id,a.manifest.version,"Finished running post uninstall script"),S=>this.logService.error(a.identifier.id,a.manifest.version,`Failed to run post uninstall script: ${S}`)))),(0,O.rimraf)(this.getExtensionStoragePath(a)).then(void 0,S=>this.logService.error("Error while removing extension storage path",S))}parseScript(a,m){const S=`vscode:${m}`;if(a.location.scheme===f.Schemas.file&&a.manifest&&a.manifest.scripts&&typeof a.manifest.scripts[S]=="string"){const E=a.manifest.scripts[S].split(" ");return E.length<2||E[0]!=="node"||!E[1]?(this.logService.warn(a.identifier.id,a.manifest.version,`${S} should be a node script`),null):{script:(0,T.join)(a.location.fsPath,E[1]),args:E.slice(2)||[]}}return null}runLifecycleHook(a,m,S,E,b){return new Promise((p,l)=>{const r=this.start(a,m,S,b);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?l(n):p(void 0)};r.on("error",n=>{i((0,w.toErrorMessage)(n)||"Unknown")}),r.on("exit",(n,s)=>{i(n?`post-${m} process exited with code ${n}`:void 0)}),E&&(e=setTimeout(()=>{e=null,r.kill(),l("timed out")},5e3))})}start(a,m,S,E){const b={silent:!0,execArgv:void 0},p=(0,I.fork)(a,[`--type=extension-post-${m}`,...S],b);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const l=h.Event.fromNodeEventEmitter(p.stdout,"data"),r=h.Event.fromNodeEventEmitter(p.stderr,"data");l(n=>this.logService.info(E.identifier.id,E.manifest.version,`post-${m}`,n)),r(n=>this.logService.error(E.identifier.id,E.manifest.version,`post-${m}`,n));const e=h.Event.any(h.Event.map(l,n=>({data:`%c${n}`,format:[""]})),h.Event.map(r,n=>({data:`%c${n}`,format:["color: red"]})));return h.Event.debounce(e,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(E.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),p}getExtensionStoragePath(a){return(0,T.join)(this.environmentService.globalStorageHome.fsPath,a.identifier.id.toLowerCase())}};y=ce([ue(0,d.IEnvironmentService),ue(1,C.ILogService)],y),t.ExtensionsLifecycle=y}),define(Q[104],Z([0,1,2,19,11,20,9,25,18,13]),function($,t,v,C,I,w,T,R,h,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let O=class extends v.Disposable{constructor(y,D,a,m){super();this.extensionsManagementService=y,this.logService=m,this._onDidChangeExtensionsByAnotherSource=this._register(new I.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(b=>{this.installedExtensions=b.map(p=>p.identifier),this.startTimestamp=Date.now()}),this._register(y.onInstallExtension(b=>this.onInstallExtension(b))),this._register(y.onDidInstallExtension(b=>this.onDidInstallExtension(b))),this._register(y.onDidUninstallExtension(b=>this.onDidUninstallExtension(b)));const S=T.URI.file(a.extensionsPath),E=new h.ExtUri(b=>!D.hasCapability(b,1024));this._register(D.watch(S)),this._register(I.Event.filter(D.onDidFilesChange,b=>b.changes.some(p=>this.doesChangeAffects(p,S,E)))(()=>this.onDidChange()))}doesChangeAffects(y,D,a){return a.isEqual(a.dirname(y.resource),D)?a.isEqual(y.resource,a.joinPath(D,".obsolete"))?!0:!(y.type!==1&&y.type!==2||a.basename(y.resource).startsWith(".")):!1}onInstallExtension(y){this.addInstallingExtension(y.identifier)}onDidInstallExtension(y){this.removeInstallingExtension(y.identifier),y.error||this.addInstalledExtension(y.identifier)}onDidUninstallExtension(y){y.error||this.removeInstalledExtension(y.identifier)}addInstallingExtension(y){this.removeInstallingExtension(y),this.installingExtensions.push(y)}removeInstallingExtension(y){this.installingExtensions=this.installingExtensions.filter(D=>!(0,R.areSameExtensions)(D,y))}addInstalledExtension(y){this.installedExtensions&&(this.removeInstalledExtension(y),this.installedExtensions.push(y))}removeInstalledExtension(y){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(D=>!(0,R.areSameExtensions)(D,y)))}async onDidChange(){if(this.installedExtensions){const y=await this.extensionsManagementService.getInstalled(1),D=y.filter(m=>[...this.installingExtensions,...this.installedExtensions].some(S=>(0,R.areSameExtensions)(S,m.identifier))?!1:m.installedTimestamp&&m.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",m.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",m.identifier.id),!1)),a=this.installedExtensions.filter(m=>this.installingExtensions.some(S=>(0,R.areSameExtensions)(S,m))?!1:y.every(S=>!(0,R.areSameExtensions)(S.identifier,m))?(this.logService.info("Detected extension removed from another source",m.id),!0):!1);this.installedExtensions=y.map(m=>m.identifier),(D.length||a.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:D,removed:a})}}};O=ce([ue(1,w.IFileService),ue(2,C.INativeEnvironmentService),ue(3,f.ILogService)],O),t.ExtensionsWatcher=O}),define(Q[105],Z([0,1,81,130,2,20,11,18,43,23,13,17,35,4,28,10,49,131]),function($,t,v,C,I,w,T,R,h,f,O,d,y,D,a,m,S,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let b=class extends I.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(l,r){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${l}`),this.provider.set(l,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:r});const e=new I.DisposableStore;return e.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new w.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),e.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:l}))),typeof r.onDidErrorOccur=="function"&&e.add(r.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,I.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:r}),this.provider.delete(l),(0,I.dispose)(e)})}async activateProvider(l){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(e){r.push(e)}}),!this.provider.has(l)&&await D.Promises.settled(r)}canHandleResource(l){return this.provider.has(l.scheme)}hasCapability(l,r){const e=this.provider.get(l.scheme);return!!(e&&e.capabilities&r)}listCapabilities(){return E.Iterable.map(this.provider,([l,r])=>({scheme:l,capabilities:r.capabilities}))}async withProvider(l){if(!(0,R.isAbsolutePath)(l))throw new w.FileOperationError((0,v.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const r=this.provider.get(l.scheme);if(!r){const e=new Error;throw e.name="ENOPRO",e.message=(0,v.localize)(1,null,l.toString()),e}return r}async withReadProvider(l){const r=await this.withProvider(l);if((0,w.hasOpenReadWriteCloseCapability)(r)||(0,w.hasReadWriteCapability)(r)||(0,w.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const r=await this.withProvider(l);if((0,w.hasOpenReadWriteCloseCapability)(r)||(0,w.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,r){try{return await this.doResolveFile(l,r)}catch(e){throw(0,w.toFileSystemProviderErrorCode)(e)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,v.localize)(2,null,this.resourceForError(l)),1):(0,w.ensureFileSystemProviderError)(e)}}async doResolveFile(l,r){const e=await this.withProvider(l),i=this.isPathCaseSensitive(e),n=r==null?void 0:r.resolveTo,s=r==null?void 0:r.resolveSingleChildDescendants,o=r==null?void 0:r.resolveMetadata,g=await e.stat(l);let F;return this.toFileStat(e,l,g,void 0,!!o,(j,N)=>(F||(F=h.TernarySearchTree.forUris(()=>!i),F.set(l,!0),(0,f.isNonEmptyArray)(n)&&n.forEach(A=>F.set(A,!0))),Boolean(F.findSuperstr(j.resource)||F.get(j.resource))?!0:j.isDirectory&&s?N===1:!1))}async toFileStat(l,r,e,i,n,s){const{providerExtUri:o}=this.getExtUri(l),g={resource:r,name:o.basename(r),isFile:(e.type&w.FileType.File)!=0,isDirectory:(e.type&w.FileType.Directory)!=0,isSymbolicLink:(e.type&w.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,etag:(0,w.etag)({mtime:e.mtime,size:e.size})};if(g.isDirectory&&s(g,i)){try{const F=await l.readdir(r),j=await D.Promises.settled(F.map(async([N,A])=>{try{const U=o.joinPath(r,N),x=n?await l.stat(U):{type:A};return await this.toFileStat(l,U,x,F.length,n,s)}catch(U){return this.logService.trace(U),null}}));g.children=(0,f.coalesce)(j)}catch(F){this.logService.trace(F),g.children=[]}return g}return g}async resolveAll(l){return D.Promises.settled(l.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(l){const r=await this.withProvider(l);try{return!!await r.stat(l)}catch(e){return!1}}async canCreateFile(l,r){try{await this.doValidateCreateFile(l,r)}catch(e){return e}return!0}async doValidateCreateFile(l,r){if(!(r==null?void 0:r.overwrite)&&await this.exists(l))throw new w.FileOperationError((0,v.localize)(3,null,this.resourceForError(l)),3,r)}async createFile(l,r=d.VSBuffer.fromString(""),e){await this.doValidateCreateFile(l,e);const i=await this.writeFile(l,r);return this._onDidRunOperation.fire(new w.FileOperationEvent(l,0,i)),i}async writeFile(l,r,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,l,e)||await this.mkdirp(i,n.dirname(l));let o;if((0,w.hasReadWriteCapability)(i)&&!(r instanceof d.VSBuffer))if((0,y.isReadableStream)(r)){const g=await(0,y.peekStream)(r,3);g.ended?o=d.VSBuffer.concat(g.buffer):o=g}else o=(0,y.peekReadable)(r,g=>d.VSBuffer.concat(g),3);else o=r;!(0,w.hasOpenReadWriteCloseCapability)(i)||(0,w.hasReadWriteCapability)(i)&&o instanceof d.VSBuffer?await this.doWriteUnbuffered(i,l,e,o):await this.doWriteBuffered(i,l,e,o instanceof d.VSBuffer?(0,d.bufferToReadable)(o):o)}catch(s){throw new w.FileOperationError((0,v.localize)(4,null,this.resourceForError(l),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),e)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,r,e){if(!!(e==null?void 0:e.unlock)&&!(l.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(r)));let n;try{n=await l.stat(r)}catch(s){return}if((n.type&w.FileType.Directory)!=0)throw new w.FileOperationError((0,v.localize)(6,null,this.resourceForError(r)),0,e);if(e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==w.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,w.etag)({mtime:e.mtime,size:n.size}))throw new w.FileOperationError((0,v.localize)(7,null),3,e);return n}async readFile(l,r){const e=await this.withReadProvider(l);return(r==null?void 0:r.atomic)?this.doReadFileAtomic(e,l,r):this.doReadFile(e,l,r)}async doReadFileAtomic(l,r,e){return new Promise((i,n)=>{this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(l,r,e);i(s)}catch(s){n(s)}})})}async doReadFile(l,r,e){const i=await this.doReadFileStream(l,r,Object.assign(Object.assign({},e),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await(0,d.streamToBuffer)(i.value)})}async readFileStream(l,r){const e=await this.withReadProvider(l);return this.doReadFileStream(e,l,r)}async doReadFileStream(l,r,e){const i=new a.CancellationTokenSource,n=this.validateReadFile(r,e).then(o=>o,o=>{throw i.cancel(),o});let s;try{e&&typeof e.etag=="string"&&e.etag!==w.ETAG_DISABLED&&await n,!((0,w.hasOpenReadWriteCloseCapability)(l)||(0,w.hasFileReadStreamCapability)(l))||(0,w.hasReadWriteCapability)(l)&&(e==null?void 0:e.preferUnbuffered)?s=this.readFileUnbuffered(l,r,e):(0,w.hasFileReadStreamCapability)(l)?s=this.readFileStreamed(l,r,i.token,e):s=this.readFileBuffered(l,r,i.token,e);const o=await n;return Object.assign(Object.assign({},o),{value:s})}catch(o){throw s&&await(0,y.consumeStream)(s),new w.FileOperationError((0,v.localize)(8,null,this.resourceForError(r),(0,w.ensureFileSystemProviderError)(o).toString()),(0,w.toFileOperationResult)(o),e)}}readFileStreamed(l,r,e,i=Object.create(null)){const n=l.readFileStream(r,i,e);return(0,y.transform)(n,{data:s=>s instanceof d.VSBuffer?s:d.VSBuffer.wrap(s),error:s=>new w.FileOperationError((0,v.localize)(9,null,this.resourceForError(r),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),i)},s=>d.VSBuffer.concat(s))}readFileBuffered(l,r,e,i=Object.create(null)){const n=(0,d.newWriteableBufferStream)();return(0,S.readFileIntoStream)(l,r,n,s=>s,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new w.FileOperationError((0,v.localize)(10,null,this.resourceForError(r),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),i)}),e),n}readFileUnbuffered(l,r,e){const i=(0,y.newWriteableStream)(n=>d.VSBuffer.concat(n));return(async()=>{try{let n=await l.readFile(r);e&&typeof e.position=="number"&&(n=n.slice(e.position)),e&&typeof e.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(r,n.byteLength,e),i.end(d.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(l,r){const e=await this.resolve(l,{resolveMetadata:!0});if(e.isDirectory)throw new w.FileOperationError((0,v.localize)(11,null,this.resourceForError(l)),0,r);if(r&&typeof r.etag=="string"&&r.etag!==w.ETAG_DISABLED&&r.etag===e.etag)throw new w.FileOperationError((0,v.localize)(12,null),2,r);return this.validateReadFileLimits(l,e.size,r),e}validateReadFileLimits(l,r,e){if(e==null?void 0:e.limits){let i;if(typeof e.limits.memory=="number"&&r>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&r>e.limits.size&&(i=7),typeof i=="number")throw new w.FileOperationError((0,v.localize)(13,null,this.resourceForError(l)),i)}}async canMove(l,r,e){return this.doCanMoveCopy(l,r,"move",e)}async canCopy(l,r,e){return this.doCanMoveCopy(l,r,"copy",e)}async doCanMoveCopy(l,r,e,i){if(l.toString()!==r.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(n,l,s,r,e,i)}catch(n){return n}return!0}async move(l,r,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(i,l,n,r,"move",!!e),o=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(l,s==="move"?2:3,o)),o}async copy(l,r,e){const i=await this.withReadProvider(l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(i,l,n,r,"copy",!!e),o=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(l,s==="copy"?3:2,o)),o}async doMoveCopy(l,r,e,i,n,s){if(r.toString()===i.toString())return n;const{exists:o,isSameResourceWithDifferentPathCase:g}=await this.doValidateMoveCopy(l,r,e,i,n,s);if(o&&!g&&s&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(l===e&&(0,w.hasFileFolderCopyCapability)(l))await l.copy(r,i,{overwrite:s});else{const F=await this.resolve(r);F.isDirectory?await this.doCopyFolder(l,F,e,i):await this.doCopyFile(l,r,e,i)}return n}else return l===e?(await l.rename(r,i,{overwrite:s}),n):(await this.doMoveCopy(l,r,e,i,"copy",s),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(l,r,e,i){if((0,w.hasOpenReadWriteCloseCapability)(l)&&(0,w.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(l,r,e,i);if((0,w.hasOpenReadWriteCloseCapability)(l)&&(0,w.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(l,r,e,i);if((0,w.hasReadWriteCapability)(l)&&(0,w.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(l,r,e,i);if((0,w.hasReadWriteCapability)(l)&&(0,w.hasReadWriteCapability)(e))return this.doPipeUnbuffered(l,r,e,i)}async doCopyFolder(l,r,e,i){await e.mkdir(i),Array.isArray(r.children)&&await D.Promises.settled(r.children.map(async n=>{const s=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(l,await this.resolve(n.resource),e,s):this.doCopyFile(l,n.resource,e,s)}))}async doValidateMoveCopy(l,r,e,i,n,s){let o=!1;if(l===e){const{providerExtUri:F,isPathCaseSensitive:j}=this.getExtUri(l);if(j||(o=F.isEqual(r,i)),o&&n==="copy")throw new Error((0,v.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!o&&F.isEqualOrParent(i,r))throw new Error((0,v.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const g=await this.exists(i);if(g&&!o){if(!s)throw new w.FileOperationError((0,v.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(l===e){const{providerExtUri:F}=this.getExtUri(l);if(F.isEqualOrParent(r,i))throw new Error((0,v.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:g,isSameResourceWithDifferentPathCase:o}}getExtUri(l){const r=this.isPathCaseSensitive(l);return{providerExtUri:r?R.extUri:R.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(r,l);const e=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(l,0,e)),e}async mkdirp(l,r){const e=[],{providerExtUri:i}=this.getExtUri(l);for(;!i.isEqual(r,i.dirname(r));)try{if(((await l.stat(r)).type&w.FileType.Directory)==0)throw new Error((0,v.localize)(18,null,this.resourceForError(r)));break}catch(n){if((0,w.toFileSystemProviderErrorCode)(n)!==w.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(r)),r=i.dirname(r)}for(let n=e.length-1;n>=0;n--){r=i.joinPath(r,e[n]);try{await l.mkdir(r)}catch(s){if((0,w.toFileSystemProviderErrorCode)(s)!==w.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(l,r){try{await this.doValidateDelete(l,r)}catch(e){return e}return!0}async doValidateDelete(l,r){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!(r==null?void 0:r.useTrash)&&!(e.capabilities&4096))throw new Error((0,v.localize)(19,null,this.resourceForError(l)));const n=await this.exists(l);if(!n)throw new w.FileOperationError((0,v.localize)(20,null,this.resourceForError(l)),1);if(!!!(r==null?void 0:r.recursive)&&n){const o=await this.resolve(l);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,v.localize)(21,null,this.resourceForError(l)))}return e}async del(l,r){const e=await this.doValidateDelete(l,r),i=!!(r==null?void 0:r.useTrash),n=!!(r==null?void 0:r.recursive);await e.delete(l,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new w.FileOperationEvent(l,1))}watch(l,r={recursive:!1,excludes:[]}){let e=!1,i=()=>{e=!0};return this.doWatch(l,r).then(n=>{e?(0,I.dispose)(n):i=()=>(0,I.dispose)(n)},n=>this.logService.error(n)),(0,I.toDisposable)(()=>i())}async doWatch(l,r){const e=await this.withProvider(l),i=this.toWatchKey(e,l,r),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(l,r)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,I.toDisposable)(()=>{n.count--,n.count===0&&((0,I.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(l,r,e){const{providerExtUri:i}=this.getExtUri(l);return[i.getComparisonKey(r),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(l=>(0,I.dispose)(l.disposable)),this.activeWatchers.clear()}async doWriteBuffered(l,r,e,i){return this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(async()=>{var n;const s=await l.open(r,{create:!0,unlock:(n=e==null?void 0:e.unlock)!==null&&n!==void 0?n:!1});try{(0,y.isReadableStream)(i)||(0,y.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(l,s,i):await this.doWriteReadableBufferedQueued(l,s,i)}catch(o){throw(0,w.ensureFileSystemProviderError)(o)}finally{await l.close(s)}})}async doWriteStreamBufferedQueued(l,r,e){let i=0,n;if((0,y.isReadableBufferedStream)(e)){if(e.buffer.length>0){const s=d.VSBuffer.concat(e.buffer);await this.doWriteBuffer(l,r,s,s.byteLength,i,0),i+=s.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(s,o)=>{(0,y.listenStream)(n,{onData:async g=>{n.pause();try{await this.doWriteBuffer(l,r,g,g.byteLength,i,0)}catch(F){return o(F)}i+=g.byteLength,setTimeout(()=>n.resume())},onError:g=>o(g),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(l,r,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(l,r,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(l,r,e,i,n,s){let o=0;for(;o<i;)o+=await l.write(r,n+o,e.buffer,s+o,i-o)}async doWriteUnbuffered(l,r,e,i){return this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,r,e,i))}async doWriteUnbufferedQueued(l,r,e,i){var n;let s;i instanceof d.VSBuffer?s=i:(0,y.isReadableStream)(i)?s=await(0,d.streamToBuffer)(i):(0,y.isReadableBufferedStream)(i)?s=await(0,d.bufferedStreamToBuffer)(i):s=(0,d.readableToBuffer)(i),await l.writeFile(r,s.buffer,{create:!0,overwrite:!0,unlock:(n=e==null?void 0:e.unlock)!==null&&n!==void 0?n:!1})}async doPipeBuffered(l,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,r,e,i))}async doPipeBufferedQueued(l,r,e,i){let n,s;try{n=await l.open(r,{create:!1}),s=await e.open(i,{create:!0,unlock:!1});const o=d.VSBuffer.alloc(this.BUFFER_SIZE);let g=0,F=0,j=0;do j=await l.read(n,g,o.buffer,F,o.byteLength-F),await this.doWriteBuffer(e,s,o,j,g,F),g+=j,F+=j,F===o.byteLength&&(F=0);while(j>0)}catch(o){throw(0,w.ensureFileSystemProviderError)(o)}finally{await D.Promises.settled([typeof n=="number"?l.close(n):Promise.resolve(),typeof s=="number"?e.close(s):Promise.resolve()])}}async doPipeUnbuffered(l,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,r,e,i))}async doPipeUnbufferedQueued(l,r,e,i){return e.writeFile(i,await l.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,r,e,i))}async doPipeUnbufferedToBufferedQueued(l,r,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const s=await l.readFile(r);await this.doWriteBuffer(e,n,d.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,w.ensureFileSystemProviderError)(s)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(l,r,e,i){const n=await(0,d.streamToBuffer)(this.readFileBuffered(l,r,a.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(l,r){if(l.capabilities&2048)throw new w.FileOperationError((0,v.localize)(22,null,this.resourceForError(r)),6);return l}resourceForError(l){return l.scheme===m.Schemas.file?l.fsPath:l.toString(!0)}};b=ce([ue(0,O.ILogService)],b),t.FileService=b}),define(Q[106],Z([0,1,16,64,2,20,11,15,12,3,18,36,4,13,83,50,92,94,91,100,35,49,23,17]),function($,t,v,C,I,w,T,R,h,f,O,d,y,D,a,m,S,E,b,p,l,r,e,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class n extends I.Disposable{constructor(o,g){var F;super();this.logService=o,this.options=g,this.BUFFER_SIZE=((F=this.options)===null||F===void 0?void 0:F.bufferSize)||64*1024,this.onDidChangeCapabilities=T.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new T.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new y.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,R.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(o){try{const{stat:g,symbolicLink:F}=await h.SymlinkSupport.stat(this.toFilePath(o));return{type:this.toType(g,F),ctime:g.birthtime.getTime(),mtime:g.mtime.getTime(),size:g.size}}catch(g){throw this.toFileSystemProviderError(g)}}async readdir(o){try{const g=await(0,h.readdir)(this.toFilePath(o),{withFileTypes:!0}),F=[];return await Promise.all(g.map(async j=>{try{let N;j.isSymbolicLink()?N=(await this.stat((0,O.joinPath)(o,j.name))).type:N=this.toType(j),F.push([j.name,N])}catch(N){this.logService.trace(N)}})),F}catch(g){throw this.toFileSystemProviderError(g)}}toType(o,g){let F;return(g==null?void 0:g.dangling)?F=w.FileType.Unknown:o.isFile()?F=w.FileType.File:o.isDirectory()?F=w.FileType.Directory:F=w.FileType.Unknown,g&&(F|=w.FileType.SymbolicLink),F}async readFile(o){try{const g=this.toFilePath(o);return await v.promises.readFile(g)}catch(g){throw this.toFileSystemProviderError(g)}}readFileStream(o,g,F){const j=(0,l.newWriteableStream)(N=>i.VSBuffer.concat(N.map(A=>i.VSBuffer.wrap(A))).buffer);return(0,r.readFileIntoStream)(this,o,j,N=>N.buffer,Object.assign(Object.assign({},g),{bufferSize:this.BUFFER_SIZE}),F),j}async writeFile(o,g,F){let j;try{const N=this.toFilePath(o);if(!F.create||!F.overwrite){if(await(0,h.exists)(N)){if(!F.overwrite)throw(0,w.createFileSystemProviderError)((0,a.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!F.create)throw(0,w.createFileSystemProviderError)((0,a.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}j=await this.open(o,{create:!0,unlock:F.unlock}),await this.write(j,0,g,0,g.byteLength)}catch(N){throw await this.toFileSystemProviderWriteError(o,N)}finally{typeof j=="number"&&await this.close(j)}}async open(o,g){try{const F=this.toFilePath(o);if((0,w.isFileOpenForWriteOptions)(g)&&g.unlock)try{const{stat:A}=await h.SymlinkSupport.stat(F);A.mode&128||await v.promises.chmod(F,A.mode|128)}catch(A){this.logService.trace(A)}let j;if((0,w.isFileOpenForWriteOptions)(g)){if(R.isWindows)try{await v.promises.truncate(F,0),j="r+"}catch(A){A.code!=="ENOENT"&&this.logService.trace(A)}j||(j="w")}else j="r";const N=await(0,C.promisify)(v.open)(F,j);return this.mapHandleToPos.set(N,0),(0,w.isFileOpenForWriteOptions)(g)&&this.writeHandles.set(N,o),N}catch(F){throw(0,w.isFileOpenForWriteOptions)(g)?await this.toFileSystemProviderWriteError(o,F):this.toFileSystemProviderError(F)}}async close(o){try{if(this.mapHandleToPos.delete(o),this.writeHandles.delete(o)&&this.canFlush)try{await(0,C.promisify)(v.fdatasync)(o)}catch(g){this.canFlush=!1,this.logService.error(g)}return await(0,C.promisify)(v.close)(o)}catch(g){throw this.toFileSystemProviderError(g)}}async read(o,g,F,j,N){const A=this.normalizePos(o,g);let U=null;try{const x=await(0,C.promisify)(v.read)(o,F,j,N,A);return typeof x=="number"?U=x:U=x.bytesRead,U}catch(x){throw this.toFileSystemProviderError(x)}finally{this.updatePos(o,A,U)}}normalizePos(o,g){return g===this.mapHandleToPos.get(o)?null:g}updatePos(o,g,F){const j=this.mapHandleToPos.get(o);typeof j=="number"&&(typeof g=="number"||(typeof F=="number"?this.mapHandleToPos.set(o,j+F):this.mapHandleToPos.delete(o)))}async write(o,g,F,j,N){return(0,y.retry)(()=>this.doWrite(o,g,F,j,N),100,3)}async doWrite(o,g,F,j,N){const A=this.normalizePos(o,g);let U=null;try{const x=await(0,C.promisify)(v.write)(o,F,j,N,A);return typeof x=="number"?U=x:U=x.bytesWritten,U}catch(x){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(o),x)}finally{this.updatePos(o,A,U)}}async mkdir(o){try{await v.promises.mkdir(this.toFilePath(o))}catch(g){throw this.toFileSystemProviderError(g)}}async delete(o,g){try{const F=this.toFilePath(o);await this.doDelete(F,g)}catch(F){throw this.toFileSystemProviderError(F)}}async doDelete(o,g){g.recursive?await(0,h.rimraf)(o,h.RimRafMode.MOVE):await v.promises.unlink(o)}async rename(o,g,F){const j=this.toFilePath(o),N=this.toFilePath(g);if(j!==N)try{await this.validateTargetDeleted(o,g,"move",F.overwrite),await(0,h.move)(j,N)}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,a.localize)(2,null,(0,f.basename)(j),(0,f.basename)((0,f.dirname)(N)),A.toString()))),this.toFileSystemProviderError(A)}}async copy(o,g,F){const j=this.toFilePath(o),N=this.toFilePath(g);if(j!==N)try{await this.validateTargetDeleted(o,g,"copy",F.overwrite),await(0,h.copy)(j,N,{preserveSymlinks:!0})}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,a.localize)(3,null,(0,f.basename)(j),(0,f.basename)((0,f.dirname)(N)),A.toString()))),this.toFileSystemProviderError(A)}}async validateTargetDeleted(o,g,F,j){const N=this.toFilePath(o),A=this.toFilePath(g);let U=!1;if(!!(this.capabilities&1024)||(U=(0,d.isEqual)(N,A,!0)),U&&F==="copy")throw(0,w.createFileSystemProviderError)((0,a.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(!U&&await(0,h.exists)(A)){if(!j)throw(0,w.createFileSystemProviderError)((0,a.localize)(5,null),w.FileSystemProviderErrorCode.FileExists);await this.delete(g,{recursive:!0,useTrash:!1})}}watch(o,g){return g.recursive?this.watchRecursive(o,g.excludes):this.watchNonRecursive(o)}watchRecursive(o,g){const F={path:this.toFilePath(o),excludes:g},j=(0,e.insert)(this.recursiveFoldersToWatch,F);return this.refreshRecursiveWatchers(),(0,I.toDisposable)(()=>{j(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var o,g,F;if(this.recursiveWatcher instanceof b.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,I.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let j,N;((g=(o=this.options)===null||o===void 0?void 0:o.watcher)===null||g===void 0?void 0:g.usePolling)?(j=S.FileWatcher,N=(F=this.options)===null||F===void 0?void 0:F.watcher):this.recursiveFoldersToWatch.length===1?R.isWindows?j=E.FileWatcher:j=S.FileWatcher:j=b.FileWatcher,this.recursiveWatcher=new j(this.recursiveFoldersToWatch,A=>this._onDidChangeFile.fire((0,m.toFileChanges)(A)),A=>{A.type==="error"&&this._onDidWatchErrorOccur.fire(A.message),this.logService[A.type](A.message)},this.logService.getLevel()===D.LogLevel.Trace,N),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===D.LogLevel.Trace)}))}}watchNonRecursive(o){const g=new p.FileWatcher(this.toFilePath(o),j=>this._onDidChangeFile.fire((0,m.toFileChanges)(j)),j=>{j.type==="error"&&this._onDidWatchErrorOccur.fire(j.message),this.logService[j.type](j.message)},this.logService.getLevel()===D.LogLevel.Trace),F=this.logService.onDidChangeLogLevel(()=>{g.setVerboseLogging(this.logService.getLevel()===D.LogLevel.Trace)});return(0,I.combinedDisposable)(g,F)}toFilePath(o){return(0,f.normalize)(o.fsPath)}toFileSystemProviderError(o){if(o instanceof w.FileSystemProviderError)return o;let g;switch(o.code){case"ENOENT":g=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":g=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":g=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":g=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":g=w.FileSystemProviderErrorCode.NoPermissions;break;default:g=w.FileSystemProviderErrorCode.Unknown}return(0,w.createFileSystemProviderError)(o,g)}async toFileSystemProviderWriteError(o,g){let F=this.toFileSystemProviderError(g);if(o&&F.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:j}=await h.SymlinkSupport.stat(this.toFilePath(o));j.mode&128||(F=(0,w.createFileSystemProviderError)(g,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(j){this.logService.trace(j)}return F}dispose(){super.dispose(),(0,I.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,I.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=n}),define(Q[107],Z([0,1,12,16,132,24,2,19,4,25,13,52,23,11,10,3]),function($,t,v,C,I,w,T,R,h,f,O,d,y,D,a,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let S=class extends T.Disposable{constructor(p,l,r){super();this.extensionManagementService=p,this.logService=r,this._onDidLanguagesChange=this._register(new D.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new E(l,r)),this._register(p.onDidInstallExtension(({local:e})=>this.onDidInstallExtension(e))),this._register(p.onDidUninstallExtension(({identifier:e})=>this.onDidUninstallExtension(e)))}getLanguageIds(){return this.cache.getLanguagePacks().then(p=>{const l=["en",...Object.keys(p)];return(0,y.distinct)(l)})}onDidInstallExtension(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",p.identifier.id),this.update().then(l=>{l&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(p){this.cache.getLanguagePacks().then(l=>{Object.keys(l).some(r=>l[r]&&l[r].extensions.some(e=>(0,f.areSameExtensions)(e.extensionIdentifier,p)))&&(this.logService.debug("Removing language packs from the extension",p.id),this.update().then(r=>{r&&this._onDidLanguagesChange.fire()}))})}async update(){const[p,l]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),r=await this.cache.update(l);return!(0,y.equals)(Object.keys(p),Object.keys(r))}};S=ce([ue(0,w.IExtensionManagementService),ue(1,R.INativeEnvironmentService),ue(2,O.ILogService)],S),t.LocalizationsService=S;let E=class extends T.Disposable{constructor(p,l){super();this.logService=l,this.languagePacks={},this.languagePacksFilePath=(0,m.join)(p.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new h.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(p){return this.withLanguagePacks(l=>{Object.keys(l).forEach(r=>delete l[r]),this.createLanguagePacksFromExtensions(l,...p)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(p,...l){for(const r of l)r&&r.manifest&&r.manifest.contributes&&r.manifest.contributes.localizations&&r.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(p,r);Object.keys(p).forEach(r=>this.updateHash(p[r]))}createLanguagePacksFromExtension(p,l){const r=l.identifier,e=l.manifest.contributes&&l.manifest.contributes.localizations?l.manifest.contributes.localizations:[];for(const i of e)if(l.location.scheme===a.Schemas.file&&(0,d.isValidLocalization)(i)){let n=p[i.languageId];n||(n={hash:"",extensions:[],translations:{}},p[i.languageId]=n);let s=n.extensions.filter(o=>(0,f.areSameExtensions)(o.extensionIdentifier,r))[0];s?s.version=l.manifest.version:n.extensions.push({extensionIdentifier:r,version:l.manifest.version});for(const o of i.translations)n.translations[o.id]=(0,m.join)(l.location.fsPath,o.path)}}updateHash(p){if(p){const l=(0,I.createHash)("md5");for(const r of p.extensions)l.update(r.extensionIdentifier.uuid||r.extensionIdentifier.id).update(r.version);p.hash=l.digest("hex")}}withLanguagePacks(p=()=>null){return this.languagePacksFileLimiter.queue(()=>{let l=null;return C.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,r=>r.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(r)).then(r=>{try{return JSON.parse(r)}catch(e){return{}}}).then(r=>(l=p(r),r)).then(r=>{for(const i of Object.keys(r))r[i]||delete r[i];this.languagePacks=r,this.initializedCache=!0;const e=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",e),(0,v.writeFile)(this.languagePacksFilePath,e)}).then(()=>l,r=>this.logService.error(r))})}};E=ce([ue(0,R.INativeEnvironmentService),ue(1,O.ILogService)],E)}),define(Q[108],Z([0,1,13,20]),function($,t,v,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function I(h,f,O,d){try{const y=await new Promise((D,a)=>{$(["spdlog"],D,a)});return y.setAsyncMode(8192,500),y.createRotatingLoggerAsync(h,f,O,d)}catch(y){console.error(y)}return null}function w(h,f,O,d){return $.__$__nodeRequire("spdlog").createRotatingLogger(h,f,O,d)}t.createRotatingLogger=w;function T(h,f,O){switch(f){case v.LogLevel.Trace:h.trace(O);break;case v.LogLevel.Debug:h.debug(O);break;case v.LogLevel.Info:h.info(O);break;case v.LogLevel.Warning:h.warn(O);break;case v.LogLevel.Error:h.error(O);break;case v.LogLevel.Critical:h.critical(O);break;default:throw new Error("Invalid log level")}}class R extends v.AbstractMessageLogger{constructor(f,O,d,y){super();this.name=f,this.filepath=O,this.rotating=d,this.buffer=[],this.setLevel(y),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(D=>{this._logger&&this._logger.setLevel(D)}))}_createSpdLogLogger(){const f=this.rotating?6:1,O=30/f*C.ByteSize.MB;return I(this.name,this.filepath,O,f).then(d=>{if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:y,message:D}of this.buffer)T(this._logger,y,D);this.buffer=[]}})}log(f,O){this._logger?T(this._logger,f,O):this.getLevel()<=f&&this.buffer.push({level:f,message:O})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=R}),define(Q[40],Z([0,1,7]),function($,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,v.createDecorator)("productService")}),define(Q[26],Z([0,1,8,56]),function($,t,v,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class I{constructor(){this.data=new Map}add(T,R){C.ok(v.isString(T)),C.ok(v.isObject(R)),C.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,R)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}t.Registry=new I}),define(Q[109],Z([0,1,26,11]),function($,t,v,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function I(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class w{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,f){this.schemasById[I(h)]=f,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new w;v.Registry.add(t.Extensions.JSONContribution,T)}),define(Q[31],Z([0,1,74,11,26,8,109]),function($,t,v,C,I,w,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"};var R;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const h=I.Registry.as(T.Extensions.JSONContribution);class f{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},h.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,b=!0){this.registerConfigurations([E],b)}registerConfigurations(E,b=!0){const p=[];E.forEach(l=>{p.push(...this.validateAndRegisterProperties(l,b,l.extensionInfo)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),h.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterConfigurations(E){const b=[],p=l=>{if(l.properties)for(const r in l.properties)b.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,l.properties[r]);l.allOf&&l.allOf.forEach(r=>p(r))};for(const l of E){p(l);const r=this.configurationContributors.indexOf(l);r!==-1&&this.configurationContributors.splice(r,1)}h.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}registerDefaultConfigurations(E){const b=[],p=[];for(const l of E)for(const r in l)if(b.push(r),t.OVERRIDE_PROPERTY_PATTERN.test(r)){this.defaultValues[r]=Object.assign(Object.assign({},this.defaultValues[r]||{}),l[r]);const e={type:"object",default:this.defaultValues[r],description:v.localize(1,null,r),$ref:t.resourceLanguageSettingsSchemaId};p.push(d(r)),this.configurationProperties[r]=e,this.defaultLanguageConfigurationOverridesNode.properties[r]=e}else{this.defaultValues[r]=l[r];const e=this.configurationProperties[r];e&&(this.updatePropertyDefaultValue(r,e),this.updateSchema(r,e))}this.registerOverrideIdentifiers(p),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}deregisterDefaultConfigurations(E){const b=[];for(const p of E)for(const l in p)if(b.push(l),delete this.defaultValues[l],t.OVERRIDE_PROPERTY_PATTERN.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const r=this.configurationProperties[l];r&&(this.updatePropertyDefaultValue(l,r),this.updateSchema(l,r))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const b of E)this.overrideIdentifiers.add(b);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(E,b=!0,p,l=3){var r;l=w.isUndefinedOrNull(E.scope)?l:E.scope;let e=[],i=E.properties;if(i)for(let s in i){if(b&&a(s)){delete i[s];continue}const o=i[s];if(this.updatePropertyDefaultValue(s,o),t.OVERRIDE_PROPERTY_PATTERN.test(s)?o.scope=void 0:(o.scope=w.isUndefinedOrNull(o.scope)?l:o.scope,o.requireTrust=w.isUndefinedOrNull(o.requireTrust)?!!((r=p==null?void 0:p.requireTrustForConfigurations)===null||r===void 0?void 0:r.includes(s)):o.requireTrust),i[s].hasOwnProperty("included")&&!i[s].included){this.excludedConfigurationProperties[s]=i[s],delete i[s];continue}else this.configurationProperties[s]=i[s];!i[s].deprecationMessage&&i[s].markdownDeprecationMessage&&(i[s].deprecationMessage=i[s].markdownDeprecationMessage),e.push(s)}let n=E.allOf;if(n)for(let s of n)e.push(...this.validateAndRegisterProperties(s,b,p,l));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const b=p=>{let l=p.properties;if(l)for(const e in l)this.updateSchema(e,l[e]);let r=p.allOf;r&&r.forEach(b)};b(E)}updateSchema(E,b){switch(t.allSettings.properties[E]=b,b.scope){case 1:t.applicationSettings.properties[E]=b;break;case 2:t.machineSettings.properties[E]=b;break;case 6:t.machineOverridableSettings.properties[E]=b;break;case 3:t.windowSettings.properties[E]=b;break;case 4:t.resourceSettings.properties[E]=b;break;case 5:t.resourceSettings.properties[E]=b,this.resourceLanguageSettingsSchema.properties[E]=b;break}}removeFromSchema(E,b){switch(delete t.allSettings.properties[E],b.scope){case 1:delete t.applicationSettings.properties[E];break;case 2:delete t.machineSettings.properties[E];break;case 6:delete t.machineOverridableSettings.properties[E];break;case 3:delete t.windowSettings.properties[E];break;case 4:case 5:delete t.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const b=`[${E}]`,p={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(b,p),t.allSettings.properties[b]=p,t.applicationSettings.properties[b]=p,t.machineSettings.properties[b]=p,t.machineOverridableSettings.properties[b]=p,t.windowSettings.properties[b]=p,t.resourceSettings.properties[b]=p}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,b){let p=this.defaultValues[E];w.isUndefined(p)&&(p=b.default),w.isUndefined(p)&&(p=y(b.type)),b.default=p}}const O="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(O);function d(S){return S.substring(1,S.length-1)}t.overrideIdentifierFromKey=d;function y(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=y;const D=new f;I.Registry.add(t.Extensions.Configuration,D);function a(S){return S.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(S)?v.localize(5,null,S):D.getConfigurationProperties()[S]!==void 0?v.localize(6,null,S):null:v.localize(4,null)}t.validateProperty=a;function m(){const S=[],E=D.getConfigurationProperties();for(const b of Object.keys(E))S.push([b,E[b].scope]);return S.push(["launch",4]),S.push(["task",4]),S}t.getScopes=m}),define(Q[27],Z([0,1,22,8,9,26,7,31]),function($,t,v,C,I,w,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,T.createDecorator)("configurationService");function h(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof I.URI)}t.isConfigurationOverrides=h;var f;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(f=t.ConfigurationTarget||(t.ConfigurationTarget={}));function O(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=O;function d(i,n){const s=n?i?n.keys.filter(U=>i.keys.indexOf(U)===-1):[...n.keys]:[],o=i?n?i.keys.filter(U=>n.keys.indexOf(U)===-1):[...i.keys]:[],g=[];if(n&&i){for(const U of i.keys)if(n.keys.indexOf(U)!==-1){const x=E(i.contents,U),X=E(n.contents,U);v.equals(x,X)||g.push(U)}}const F=[],j=U=>{const x={};for(const X of U)for(const ne of X.identifiers)x[r(ne)]=X;return x},N=n?j(n.overrides):{},A=i?j(i.overrides):{};if(Object.keys(N).length)for(const U of s){const x=N[U];x&&F.push([(0,R.overrideIdentifierFromKey)(U),x.keys])}if(Object.keys(A).length)for(const U of o){const x=A[U];x&&F.push([(0,R.overrideIdentifierFromKey)(U),x.keys])}if(Object.keys(N).length&&Object.keys(A).length)for(const U of g){const x=A[U],X=N[U];if(x&&X){const ne=d({contents:x.contents,keys:x.keys,overrides:[]},{contents:X.contents,keys:X.keys,overrides:[]});F.push([(0,R.overrideIdentifierFromKey)(U),[...ne.added,...ne.removed,...ne.updated]])}}return{added:s,removed:o,updated:g,overrides:F}}t.compare=d;function y(i,n){const s=[];for(const o of Object.keys(i))if(R.OVERRIDE_PROPERTY_PATTERN.test(o)){const g={};for(const F in i[o])g[F]=i[o][F];s.push({identifiers:[(0,R.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(g),contents:D(g,n)})}return s}t.toOverrides=y;function D(i,n){const s=Object.create(null);for(let o in i)a(s,o,i[o],n);return s}t.toValuesTree=D;function a(i,n,s,o){const g=n.split("."),F=g.pop();let j=i;for(let N=0;N<g.length;N++){let A=g[N],U=j[A];switch(typeof U){case"undefined":U=j[A]=Object.create(null);break;case"object":break;default:o(`Ignoring ${n} as ${g.slice(0,N+1).join(".")} is ${JSON.stringify(U)}`);return}j=U}if(typeof j=="object"&&j!==null)try{j[F]=s}catch(N){o(`Ignoring ${n} as ${g.join(".")} is ${JSON.stringify(j)}`)}else o(`Ignoring ${n} as ${g.join(".")} is ${JSON.stringify(j)}`)}t.addToValueTree=a;function m(i,n){const s=n.split(".");S(i,s)}t.removeFromValueTree=m;function S(i,n){const s=n.shift();if(n.length===0){delete i[s];return}if(Object.keys(i).indexOf(s)!==-1){const o=i[s];typeof o=="object"&&!Array.isArray(o)&&(S(o,n),Object.keys(o).length===0&&delete i[s])}}function E(i,n,s){function o(j,N){let A=j;for(const U of N){if(typeof A!="object"||A===null)return;A=A[U]}return A}const g=n.split("."),F=o(i,g);return typeof F=="undefined"?s:F}t.getConfigurationValue=E;function b(i,n,s){Object.keys(n).forEach(o=>{o!=="__proto__"&&(o in i?C.isObject(i[o])&&C.isObject(n[o])?b(i[o],n[o],s):s&&(i[o]=n[o]):i[o]=n[o])})}t.merge=b;function p(){const i=w.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=p;function l(){const i=Object.create(null),n=w.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(let s in n){let o=n[s].default;a(i,s,o,g=>console.error(`Conflict in default settings: ${g}`))}return i}t.getDefaultValues=l;function r(i){return`[${i}]`}t.keyFromOverrideIdentifier=r;function e(i,n,s){const o=i.inspect(n),g=i.inspect(s);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:o.defaultValue}t.getMigratedSettingValue=e}),define(Q[110],Z([0,1,58,43,23,8,22,9,31,27,26,2,11]),function($,t,v,C,I,w,T,R,h,f,O,d,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class D{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,f.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,f.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const s of I.distinct([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[s],g=i[s];g&&(typeof o=="object"&&typeof g=="object"?(o=T.deepClone(o),this.mergeContents(o,g)):o=g),n[s]=o}return new D(n,this.keys,this.overrides)}merge(...e){const i=T.deepClone(this.contents),n=T.deepClone(this.overrides),s=[...this.keys];for(const o of e){this.mergeContents(i,o.contents);for(const g of o.overrides){const[F]=n.filter(j=>I.equals(j.identifiers,g.identifiers));F?this.mergeContents(F.contents,g.contents):n.push(T.deepClone(g))}for(const g of o.keys)s.indexOf(g)===-1&&s.push(g)}return new D(i,s,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&w.isObject(e[n])&&w.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=T.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?T.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,f.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,f.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=D;class a extends D{constructor(){const e=(0,f.getDefaultValues)(),i=(0,f.getConfigurationKeys)(),n=[];for(const s of Object.keys(e))h.OVERRIDE_PROPERTY_PATTERN.test(s)&&n.push({identifiers:[(0,h.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(e[s]),contents:(0,f.toValuesTree)(e[s],o=>console.error(`Conflict in default settings file: ${o}`))});super(e,i,n)}}t.DefaultConfigurationModel=a;class m{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new D}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!w.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:s,overrides:o,untrusted:g}=this.doParseRaw(e,i);this._configurationModel=new D(n,s,o),this._untrustedConfigurations=g||[]}doParseContent(e){let i={},n=null,s=[],o=[],g=[];function F(N){Array.isArray(s)?s.push(N):n&&(s[n]=N)}let j={onObjectBegin:()=>{let N={};F(N),o.push(s),s=N,n=null},onObjectProperty:N=>{n=N},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{let N=[];F(N),o.push(s),s=N,n=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:F,onError:(N,A,U)=>{g.push({error:N,offset:A,length:U})}};if(e)try{v.visit(e,j),i=s[0]||{}}catch(N){console.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return i}doParseRaw(e,i){const n=O.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),s=this.filter(e,n,!0,i);e=s.raw;const o=(0,f.toValuesTree)(e,j=>console.error(`Conflict in settings file ${this._name}: ${j}`)),g=Object.keys(e),F=(0,f.toOverrides)(e,j=>console.error(`Conflict in settings file ${this._name}: ${j}`));return{contents:o,keys:g,overrides:F,untrusted:s.untrusted}}filter(e,i,n,s){if(!(s==null?void 0:s.scopes)&&!(s==null?void 0:s.isUntrusted))return{raw:e,untrusted:[]};const o={},g=[];for(let F in e)if(h.OVERRIDE_PROPERTY_PATTERN.test(F)&&n){const j=this.filter(e[F],i,!1,s);o[F]=j.raw,g.push(...j.untrusted)}else{const j=i[F],N=j?typeof j.scope!="undefined"?j.scope:3:void 0;(N===void 0||s.scopes===void 0||s.scopes.includes(N))&&(s.isUntrusted&&(j==null?void 0:j.requireTrust)?g.push(F):o[F]=e[F])}return{raw:o,untrusted:g}}}t.ConfigurationModelParser=m;class S extends d.Disposable{constructor(e,i,n,s){super();this.userSettingsResource=e,this.scopes=i,this.fileService=s,this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(y.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new D}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}t.UserSettings=S;class E{constructor(e,i,n=new D,s=new D,o=new C.ResourceMap,g=new D,F=new C.ResourceMap,j=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=s,this._folderConfigurations=o,this._memoryConfiguration=g,this._memoryConfigurationByResource=F,this._freeze=j,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let s;n.resource?(s=this._memoryConfigurationByResource.get(n.resource),s||(s=new D,this._memoryConfigurationByResource.set(n.resource,s))):s=this._memoryConfiguration,i===void 0?s.removeValue(e):s.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const s=this.getConsolidateConfigurationModel(i,n),o=this.getFolderConfigurationModelForResource(i.resource,n),g=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,F=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),j=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),N=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),A=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),U=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,x=o?i.overrideIdentifier?o.freeze().override(i.overrideIdentifier).getValue(e):o.freeze().getValue(e):void 0,X=i.overrideIdentifier?g.override(i.overrideIdentifier).getValue(e):g.getValue(e),ne=s.getValue(e),ee=I.distinct(I.flatten(s.overrides.map(te=>te.identifiers))).filter(te=>s.getOverrideValue(e,te)!==void 0);return{defaultValue:F,userValue:j,userLocalValue:N,userRemoteValue:A,workspaceValue:U,workspaceFolderValue:x,memoryValue:X,value:ne,default:F!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:j!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:x!==void 0?{value:o==null?void 0:o.freeze().getValue(e),override:i.overrideIdentifier?o==null?void 0:o.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:X!==void 0?{value:g.getValue(e),override:i.overrideIdentifier?g.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ee.length?ee:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(s=>h.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const o=(0,h.overrideIdentifierFromKey)(s),g=this._defaultConfiguration.getKeysForOverrideIdentifier(o),F=e.getKeysForOverrideIdentifier(o),j=[...F.filter(N=>g.indexOf(N)===-1),...g.filter(N=>F.indexOf(N)===-1),...g.filter(N=>!T.equals(this._defaultConfiguration.override(o).getValue(N),e.override(o).getValue(N)))];return[o,j]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:s,overrides:o}=(0,f.compare)(this.localUserConfiguration,e),g=[...i,...n,...s];return g.length&&this.updateLocalUserConfiguration(e),{keys:g,overrides:o}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:s,overrides:o}=(0,f.compare)(this.remoteUserConfiguration,e);let g=[...i,...n,...s];return g.length&&this.updateRemoteUserConfiguration(e),{keys:g,overrides:o}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:s,overrides:o}=(0,f.compare)(this.workspaceConfiguration,e);let g=[...i,...n,...s];return g.length&&this.updateWorkspaceConfiguration(e),{keys:g,overrides:o}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:s,updated:o,removed:g,overrides:F}=(0,f.compare)(n,i);let j=[...s,...o,...g];return(j.length||!n)&&this.updateFolderConfiguration(e,i),{keys:j,overrides:F}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:s,removed:o,overrides:g}=(0,f.compare)(i,void 0);return{keys:[...n,...s,...o],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const s=i.getFolder(e);s&&(n=this.getFolderConsolidatedConfiguration(s.uri)||n);const o=this._memoryConfigurationByResource.get(e);o&&(n=n.merge(o))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(e);s?(i=n.merge(s),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:s,keys:o}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:s,keys:o}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(s=>i.add(s))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),s=this.parseConfigurationModel(e.workspace),o=e.folders.reduce((g,F)=>(g.set(R.URI.revive(F[0]),this.parseConfigurationModel(F[1])),g),new C.ResourceMap);return new E(i,n,new D,s,o,new D,new C.ResourceMap,!1)}static parseConfigurationModel(e){return new D(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=E;function b(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,i=new Map;for(const s of r)s.keys.forEach(o=>e.add(o)),s.overrides.forEach(([o,g])=>{const F=(0,C.getOrSet)(i,o,new Set);g.forEach(j=>F.add(j))});const n=[];return i.forEach((s,o)=>n.push([o,[...s.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=b;class p{constructor(e,i,n,s){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=s,this._previousConfiguration=void 0;const o=new Set;e.keys.forEach(F=>o.add(F)),e.overrides.forEach(([,F])=>F.forEach(j=>o.add(j))),this.affectedKeys=[...o.values()];const g=new D;this.affectedKeys.forEach(F=>g.setValue(F,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){var n;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(e,i,(n=this.previous)===null||n===void 0?void 0:n.workspace):void 0,o=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!T.equals(s,o)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,f.toValuesTree)({[i]:!0},()=>{}),s;for(;typeof n=="object"&&(s=Object.keys(n)[0]);){if(e=e[s],!e)return!1;n=n[s]}return!0}}t.ConfigurationChangeEvent=p;class l extends p{constructor(e,i,n,s){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=s}}t.AllKeysConfigurationChangeEvent=l}),define(Q[111],Z([0,1,26,31,2,27,110,11,4,18]),function($,t,v,C,I,w,T,R,h,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class O extends I.Disposable{constructor(y,D){super();this.settingsResource=y,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new T.UserSettings(this.settingsResource,void 0,f.extUriBiasedIgnorePathCase,D)),this.configuration=new T.Configuration(new T.DefaultConfigurationModel,new T.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new h.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(v.Registry.as(C.Extensions.Configuration).onDidUpdateConfiguration(a=>this.onDidDefaultConfigurationChange(a))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const y=await this.userConfiguration.loadConfiguration();this.configuration=new T.Configuration(new T.DefaultConfigurationModel,y)}getConfigurationData(){return this.configuration.toData()}getValue(y,D){const a=typeof y=="string"?y:void 0,m=(0,w.isConfigurationOverrides)(y)?y:(0,w.isConfigurationOverrides)(D)?D:{};return this.configuration.getValue(a,m,void 0)}updateValue(y,D,a,m){return Promise.reject(new Error("not supported"))}inspect(y){return this.configuration.inspect(y,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const y=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(y)}onDidChangeUserConfiguration(y){const D=this.configuration.toData(),a=this.configuration.compareAndUpdateLocalUserConfiguration(y);this.trigger(a,D,1)}onDidDefaultConfigurationChange(y){const D=this.configuration.toData(),a=this.configuration.compareAndUpdateDefaultConfiguration(new T.DefaultConfigurationModel,y);this.trigger(a,D,6)}trigger(y,D,a){const m=new T.ConfigurationChangeEvent(y,{data:D},this.configuration);m.source=a,m.sourceConfig=this.getTargetConfiguration(a),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(y){switch(y){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=O}),define(Q[53],Z([0,1,84,7,31,26,17]),function($,t,v,C,I,w,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,C.createDecorator)("requestService");function R(a){return a.res.statusCode&&a.res.statusCode>=200&&a.res.statusCode<300||a.res.statusCode===1223}t.isSuccess=R;function h(a){return a.res.statusCode===204}async function f(a){if(!R(a))throw new Error("Server returned "+a.res.statusCode);return h(a)?null:(await(0,T.streamToBuffer)(a.stream)).toString()}t.asText=f;async function O(a){if(!R(a))throw new Error("Server returned "+a.res.statusCode);if(h(a))return null;const S=(await(0,T.streamToBuffer)(a.stream)).toString();try{return JSON.parse(S)}catch(E){throw E.message+=`:
`+S,E}}t.asJson=O;function d(a){D(a)}t.updateProxyConfigurationsScope=d;let y;function D(a){const m=w.Registry.as(I.Extensions.Configuration);y&&m.deregisterConfigurations([y]),y={id:"http",order:15,title:(0,v.localize)(0,null),type:"object",scope:a,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,v.localize)(1,null),requireTrust:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,v.localize)(2,null),requireTrust:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,v.localize)(3,null),requireTrust:!0},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[(0,v.localize)(4,null),(0,v.localize)(5,null),(0,v.localize)(6,null)],default:"override",description:(0,v.localize)(7,null),requireTrust:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,v.localize)(8,null),requireTrust:!0}}},m.registerConfiguration(y)}D(2)}),define(Q[112],Z([0,1,113,8]),function($,t,v,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function I(T,R){return T.protocol==="http:"?R.HTTP_PROXY||R.http_proxy||null:T.protocol==="https:"&&(R.HTTPS_PROXY||R.https_proxy||R.HTTP_PROXY||R.http_proxy)||null}async function w(T,R,h={}){const f=(0,v.parse)(T),O=h.proxyUrl||I(f,R);if(!O)return null;const d=(0,v.parse)(O);if(!/^https?:$/.test(d.protocol||""))return null;const y={host:d.hostname||"",port:d.port||(d.protocol==="https"?"443":"80"),auth:d.auth,rejectUnauthorized:(0,C.isBoolean)(h.strictSSL)?h.strictSSL:!0};return f.protocol==="http:"?new(await new Promise((D,a)=>{$(["http-proxy-agent"],D,a)}))(y):new(await new Promise((D,a)=>{$(["https-proxy-agent"],D,a)}))(y)}t.getProxyAgent=w}),define(Q[114],Z([0,1,30,17]),function($,t,v,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function I(w,T,R){let h=R&&R.get("storage.serviceMachineId",0)||null;if(h)return h;try{const O=(await T.readFile(w.serviceMachineIdResource)).value.toString();h=(0,v.isUUID)(O)?O:null}catch(f){h=null}if(!h){h=(0,v.generateUuid)();try{await T.writeFile(w.serviceMachineIdResource,C.VSBuffer.fromString(h))}catch(f){}}return R&&R.store("storage.serviceMachineId",h,0,1),h}t.getServiceMachineId=I}),define(Q[115],Z([0,1,7]),function($,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IStateService=void 0,t.IStateService=(0,v.createDecorator)("stateService")}),define(Q[116],Z([0,1,3,16,19,12,8,13]),function($,t,v,C,I,w,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StateService=t.FileStorage=void 0;class h{constructor(d,y){this.dbPath=d,this.onError=y,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(!this._database){const d=await this.loadAsync();this._database||(this._database=d)}}loadSync(){try{return this.lastFlushedSerializedDatabase=C.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(d){return d.code!=="ENOENT"&&this.onError(d),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await C.promises.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(d){return d.code!=="ENOENT"&&this.onError(d),{}}}getItem(d,y){const D=this.database[d];return(0,T.isUndefinedOrNull)(D)?y:D}setItem(d,y){if((0,T.isUndefinedOrNull)(y))return this.removeItem(d);(typeof y=="string"||typeof y=="number"||typeof y=="boolean")&&this.database[d]===y||(this.database[d]=y,this.saveSync())}removeItem(d){(0,T.isUndefined)(this.database[d])||(this.database[d]=void 0,this.saveSync())}saveSync(){const d=JSON.stringify(this.database,null,4);if(d!==this.lastFlushedSerializedDatabase)try{(0,w.writeFileSync)(this.dbPath,d),this.lastFlushedSerializedDatabase=d}catch(y){this.onError(y)}}}t.FileStorage=h;let f=class We{constructor(d,y){this.fileStorage=new h(v.join(d.userDataPath,We.STATE_FILE),D=>y.error(D))}init(){return this.fileStorage.init()}getItem(d,y){return this.fileStorage.getItem(d,y)}setItem(d,y){this.fileStorage.setItem(d,y)}removeItem(d){this.fileStorage.removeItem(d)}};f.STATE_FILE="storage.json",f=ce([ue(0,I.INativeEnvironmentService),ue(1,R.ILogService)],f),t.StateService=f}),define(Q[117],Z([0,1,7,11,2,8,67,4]),function($,t,v,C,I,w,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const h="__$__targetStorageMarker";t.IStorageService=(0,v.createDecorator)("storageService");var f;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(f=t.WillSaveStateReason||(t.WillSaveStateReason={}));var O;(function(m){m[m.GLOBAL=0]="GLOBAL",m[m.WORKSPACE=1]="WORKSPACE"})(O=t.StorageScope||(t.StorageScope={}));var d;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(d=t.StorageTarget||(t.StorageTarget={}));class y extends I.Disposable{constructor(S={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=S,this._onDidChangeValue=this._register(new C.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new C.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new C.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new I.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,I.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(S,E){E===h?(S===0?this._globalKeyTargets=void 0:S===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:S})):this._onDidChangeValue.fire({scope:S,key:E,target:this.getKeyTargets(S)[E]})}emitWillSaveState(S){this._onWillSaveState.fire({reason:S})}get(S,E,b){var p;return(p=this.getStorage(E))===null||p===void 0?void 0:p.get(S,b)}getBoolean(S,E,b){var p;return(p=this.getStorage(E))===null||p===void 0?void 0:p.getBoolean(S,b)}getNumber(S,E,b){var p;return(p=this.getStorage(E))===null||p===void 0?void 0:p.getNumber(S,b)}store(S,E,b,p){if((0,w.isUndefinedOrNull)(E)){this.remove(S,b);return}this.withPausedEmitters(()=>{var l;this.updateKeyTarget(S,b,p),(l=this.getStorage(b))===null||l===void 0||l.set(S,E)})}remove(S,E){this.withPausedEmitters(()=>{var b;this.updateKeyTarget(S,E,void 0),(b=this.getStorage(E))===null||b===void 0||b.delete(S)})}withPausedEmitters(S){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{S()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(S,E){const b=[],p=this.getKeyTargets(S);for(const l of Object.keys(p))p[l]===E&&b.push(l);return b}updateKeyTarget(S,E,b){var p,l;const r=this.getKeyTargets(E);typeof b=="number"?r[S]!==b&&(r[S]=b,(p=this.getStorage(E))===null||p===void 0||p.set(h,JSON.stringify(r))):typeof r[S]=="number"&&(delete r[S],(l=this.getStorage(E))===null||l===void 0||l.set(h,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(S){return S===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(S){const E=this.get(h,S);if(E)try{return JSON.parse(E)}catch(b){}return Object.create(null)}isNew(S){return this.getBoolean(t.IS_NEW_KEY,S)===!0}async flush(){var S,E,b,p;this._onWillSaveState.fire({reason:f.NONE}),await R.Promises.settled([(E=(S=this.getStorage(0))===null||S===void 0?void 0:S.whenFlushed())!==null&&E!==void 0?E:Promise.resolve(),(p=(b=this.getStorage(1))===null||b===void 0?void 0:b.whenFlushed())!==null&&p!==void 0?p:Promise.resolve()])}async logStorage(){var S,E,b,p,l,r;const e=(E=(S=this.getStorage(0))===null||S===void 0?void 0:S.items)!==null&&E!==void 0?E:new Map,i=(p=(b=this.getStorage(1))===null||b===void 0?void 0:b.items)!==null&&p!==void 0?p:new Map;return a(e,i,(l=this.getLogDetails(0))!==null&&l!==void 0?l:"",(r=this.getLogDetails(1))!==null&&r!==void 0?r:"")}}t.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class D extends y{constructor(){super();this.globalStorage=new T.Storage(new T.InMemoryStorageDatabase),this.workspaceStorage=new T.Storage(new T.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(S=>this.emitDidChangeValue(1,S))),this._register(this.globalStorage.onDidChangeStorage(S=>this.emitDidChangeValue(0,S)))}getStorage(S){return S===0?this.globalStorage:this.workspaceStorage}getLogDetails(S){return S===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(S){}}t.InMemoryStorageService=D;async function a(m,S,E,b){const p=o=>{try{return JSON.parse(o)}catch(g){return o}},l=new Map,r=new Map;m.forEach((o,g)=>{l.set(g,o),r.set(g,p(o))});const e=new Map,i=new Map;S.forEach((o,g)=>{e.set(g,o),i.set(g,p(o))}),console.group(`Storage: Global (path: ${E})`);let n=[];l.forEach((o,g)=>{n.push({key:g,value:o})}),console.table(n),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${b})`);let s=[];e.forEach((o,g)=>{s.push({key:g,value:o})}),console.table(s),console.groupEnd(),console.log(i)}t.logStorage=a}),define(Q[118],Z([0,1,15,34,30,9]),function($,t,v,C,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveCommonProperties=void 0;async function T(h,f,O,d,y,D,a,m,S){const E=Object.create(null);E["common.machineId"]=D,E.sessionID=(0,I.generateUuid)()+Date.now(),E.commitHash=d,E.version=y,E["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,v.PlatformToString)(v.platform),E["common.nodePlatform"]=C.platform,E["common.nodeArch"]=O,E["common.product"]=S||"desktop";const b=R(a||[]);b&&(E["common.msftInternal"]=b);let p=0;const l=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),v.isLinuxSnap&&(E["common.snap"]="true");try{const r=await h.readFile(w.URI.file(m));E["common.source"]=r.value.toString().slice(0,30)}catch(r){}return E}t.resolveCommonProperties=T;function R(h){const f=C.env.USERDNSDOMAIN;if(!f)return!1;const O=f.toLowerCase();return h.some(d=>O===d)}}),define(Q[41],Z([0,1,7]),function($,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,v.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(Q[119],Z([0,1,14,24,25,22,41,53,47,19,28,13,20,9,40,117,114,7,18]),function($,t,v,C,I,w,T,R,h,f,O,d,y,D,a,m,S,E,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var p;(function(c){c[c.None=0]="None",c[c.IncludeVersions=1]="IncludeVersions",c[c.IncludeFiles=2]="IncludeFiles",c[c.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",c[c.IncludeSharedAccounts=8]="IncludeSharedAccounts",c[c.IncludeVersionProperties=16]="IncludeVersionProperties",c[c.ExcludeNonValidated=32]="ExcludeNonValidated",c[c.IncludeInstallationTargets=64]="IncludeInstallationTargets",c[c.IncludeAssetUri=128]="IncludeAssetUri",c[c.IncludeStatistics=256]="IncludeStatistics",c[c.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",c[c.Unpublished=4096]="Unpublished"})(p||(p={}));function l(...c){return String(c.reduce((u,P)=>u|P,0))}var r;(function(c){c[c.Tag=1]="Tag",c[c.ExtensionId=4]="ExtensionId",c[c.Category=5]="Category",c[c.ExtensionName=7]="ExtensionName",c[c.Target=8]="Target",c[c.Featured=9]="Featured",c[c.SearchText=10]="SearchText",c[c.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const e={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},s={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:p.None,criteria:[],assetTypes:[]};class o{constructor(u=s){this.state=u}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(u,P=this.state.pageSize){return new o(Object.assign(Object.assign({},this.state),{pageNumber:u,pageSize:P}))}withFilter(u,...P){const L=[...this.state.criteria,...P.length?P.map(k=>({filterType:u,value:k})):[{filterType:u}]];return new o(Object.assign(Object.assign({},this.state),{criteria:L}))}withSortBy(u){return new o(Object.assign(Object.assign({},this.state),{sortBy:u}))}withSortOrder(u){return new o(Object.assign(Object.assign({},this.state),{sortOrder:u}))}withFlags(...u){return new o(Object.assign(Object.assign({},this.state),{flags:u.reduce((P,L)=>P|L,0)}))}withAssetTypes(...u){return new o(Object.assign(Object.assign({},this.state),{assetTypes:u}))}get raw(){const{criteria:u,pageNumber:P,pageSize:L,sortBy:k,sortOrder:M,flags:z,assetTypes:B}=this.state;return{filters:[{criteria:u,pageNumber:P,pageSize:L,sortBy:k,sortOrder:M}],assetTypes:B,flags:z}}get searchText(){const u=this.state.criteria.filter(P=>P.filterType===r.SearchText)[0];return u&&u.value?u.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(u=>String(u.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function g(c,u){const P=(c||[]).filter(L=>L.statisticName===u)[0];return P?P.value:0}function F(c){const u="Microsoft.VisualStudio.Code.Translation.";return c.files.filter(L=>L.assetType.indexOf(u)===0).reduce((L,k)=>{const M=U(c,k.assetType);return M&&L.push([k.assetType.substring(u.length),M]),L},[])}function j(c){if(c.properties){const u=c.properties.filter(k=>k.key===e.Repository),P=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),L=u.filter(k=>P.test(k.value))[0];return L?{uri:L.value,fallbackUri:L.value}:null}return U(c,e.Repository)}function N(c){return{uri:`${c.fallbackAssetUri}/${e.VSIX}?redirect=true`,fallbackUri:`${c.fallbackAssetUri}/${e.VSIX}`}}function A(c){const u=U(c,e.Icon);if(u)return u;const P=C.DefaultIconPath;return{uri:P,fallbackUri:P}}function U(c,u){return c.files.filter(L=>L.assetType===u)[0]?{uri:`${c.assetUri}/${u}`,fallbackUri:`${c.fallbackAssetUri}/${u}`}:null}function x(c,u){const P=c.properties?c.properties.filter(k=>k.key===u):[],L=P.length>0&&P[0].value;return L?L.split(",").map(k=>(0,I.adoptToGalleryExtensionId)(k)):[]}function X(c){const u=c.properties?c.properties.filter(P=>P.key===i.Engine):[];return u.length>0&&u[0].value||""}function ne(c){const u=c.properties?c.properties.filter(L=>L.key===i.LocalizedLanguages):[],P=u.length>0&&u[0].value||"";return P?P.split(","):[]}function ee(c){return c.indexOf("preview")!==-1}function te(c){const u=c.properties?c.properties.find(P=>P.key===i.WebExtension):void 0;return!!u&&u.value==="true"}function ae(c){return c.files.some(u=>u.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,b.joinPath)(D.URI.parse(c.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function W(c,u,P,L,k){const M={manifest:U(u,e.Manifest),readme:U(u,e.Details),changelog:U(u,e.Changelog),license:U(u,e.License),repository:j(u),download:N(u),icon:A(u),coreTranslations:F(u)};return{identifier:{id:(0,I.getGalleryExtensionId)(c.publisher.publisherName,c.extensionName),uuid:c.extensionId},name:c.extensionName,version:u.version,date:u.lastUpdated,displayName:c.displayName,publisherId:c.publisher.publisherId,publisher:c.publisher.publisherName,publisherDisplayName:c.publisher.displayName,description:c.shortDescription||"",installCount:g(c.statistics,"install"),rating:g(c.statistics,"averagerating"),ratingCount:g(c.statistics,"ratingcount"),assetUri:D.URI.parse(u.assetUri),webResource:ae(u),assetTypes:u.files.map(({assetType:z})=>z),assets:M,properties:{dependencies:x(u,i.Dependency),extensionPack:x(u,i.ExtensionPack),engine:X(u),localizedLanguages:ne(u),webExtension:te(u)},telemetryData:{index:(L.pageNumber-1)*L.pageSize+P,searchText:L.searchText,querySource:k},preview:ee(c.flags)}}let G=class{constructor(u,P,L,k,M,z,B){this.requestService=u,this.logService=P,this.environmentService=L,this.telemetryService=k,this.fileService=M,this.productService=z;const q=z.extensionsGallery;this.extensionsGalleryUrl=q&&q.serviceUrl,this.extensionsControlUrl=q&&q.controlUrl,this.commonHeadersPromise=_(z.version,this.environmentService,this.fileService,B)}api(u=""){return`${this.extensionsGalleryUrl}${u}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(u,P){const L=[];let{total:k,firstPage:M,getPage:z}=await this.query({names:u,pageSize:u.length},P);L.push(...M);for(let B=1;L.length<k&&(M=await z(B,P),M.length);B++)L.push(...M);return L}async getCompatibleExtension(u,P){const L=await this.getCompatibleExtensionByEngine(u,P);return(L==null?void 0:L.properties.webExtension)?L.webResource?L:null:L}async getCompatibleExtensionByEngine(u,P){const L=(0,C.isIExtensionIdentifier)(u)?null:u;if(L&&L.properties.engine&&(0,h.isEngineValid)(L.properties.engine,this.productService.version))return L;const{id:k,uuid:M}=L?L.identifier:u;let z=new o().withFlags(p.IncludeAssetUri,p.IncludeStatistics,p.IncludeFiles,p.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");M?z=z.withFilter(r.ExtensionId,M):z=z.withFilter(r.ExtensionName,k);const{galleryExtensions:B}=await this.queryGallery(z,O.CancellationToken.None),[q]=B;if(!q||!q.versions.length)return null;if(P){const Y=q.versions.filter(ie=>ie.version===P)[0];if(Y){const ie=W(q,Y,0,z);if(ie.properties.engine&&(0,h.isEngineValid)(ie.properties.engine,this.productService.version))return ie}return null}const J=await this.getLastValidExtensionVersion(q,q.versions);return J?W(q,J,0,z):null}async query(u,P){const L=O.CancellationToken.isCancellationToken(u)?{}:u,k=O.CancellationToken.isCancellationToken(u)?u:P;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let M=L.text||"";const z=(0,w.getOrDefault)(L,re=>re.pageSize,50);let B=new o().withFlags(p.IncludeLatestVersionOnly,p.IncludeAssetUri,p.IncludeStatistics,p.IncludeFiles,p.IncludeVersionProperties).withPage(1,z).withFilter(r.Target,"Microsoft.VisualStudio.Code");M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,he,ge)=>(B=B.withFilter(r.Category,ge||he),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,he,ge)=>(B=B.withFilter(r.Tag,ge||he),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(B=B.withFilter(r.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),B=B.withFilter(r.SearchText,M)),B=B.withSortBy(0)):L.ids?B=B.withFilter(r.ExtensionId,...L.ids):L.names?B=B.withFilter(r.ExtensionName,...L.names):B=B.withSortBy(4),typeof L.sortBy=="number"&&(B=B.withSortBy(L.sortBy)),typeof L.sortOrder=="number"&&(B=B.withSortOrder(L.sortOrder));const{galleryExtensions:q,total:J}=await this.queryGallery(B,k),Y=q.map((re,he)=>W(re,re.versions[0],he,B,L.source)),ie=async(re,he)=>{if(he.isCancellationRequested)throw(0,v.canceled)();const ge=B.withPage(re+1),{galleryExtensions:De}=await this.queryGallery(ge,he);return De.map((Oe,Fe)=>W(Oe,Oe.versions[0],Fe,ge,L.source))};return{firstPage:Y,total:J,pageSize:B.pageSize,getPage:ie}}async queryGallery(u,P){if(!this.isEnabled())throw new Error("No extension gallery service configured.");u=u.withFlags(u.flags,p.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,l(p.Unpublished));const L=await this.commonHeadersPromise,k=JSON.stringify(u.raw),M=Object.assign(Object.assign({},L),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(k.length)}),z=new Date().getTime();let B,q,J=0;try{if(B=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:k,headers:M},P),B.res.statusCode&&B.res.statusCode>=400&&B.res.statusCode<500)return{galleryExtensions:[],total:J};const Y=await(0,R.asJson)(B);if(Y){const ie=Y.results[0],re=ie.extensions,he=ie.resultMetadata&&ie.resultMetadata.filter(ge=>ge.metadataType==="ResultCount")[0];return J=he&&he.metadataItems.filter(ge=>ge.name==="TotalCount")[0].count||0,{galleryExtensions:re,total:J}}return{galleryExtensions:[],total:J}}catch(Y){throw q=Y,Y}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},u.telemetryData),{requestBodySize:String(k.length),duration:new Date().getTime()-z,success:!!B&&(0,R.isSuccess)(B),responseBodySize:B==null?void 0:B.res.headers["Content-Length"],statusCode:B?String(B.res.statusCode):void 0,errorCode:q?(0,v.isPromiseCanceledError)(q)?"canceled":(0,v.getErrorMessage)(q).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(J)}))}}async reportStatistic(u,P,L,k){if(!!this.isEnabled()){const M=await this.commonHeadersPromise,z=Object.assign(Object.assign({},M),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${u}/extensions/${P}/${L}/stats?statType=${k}`),headers:z},O.CancellationToken.None)}catch(B){}}}async download(u,P,L){this.logService.trace("ExtensionGalleryService#download",u.identifier.id);const k=(0,I.getGalleryExtensionTelemetryData)(u),M=new Date().getTime(),z=Y=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},k),{duration:Y})),B=L===1?"install":L===2?"update":"",q=B?{uri:`${u.assets.download.uri}&${B}=true`,fallbackUri:`${u.assets.download.fallbackUri}?${B}=true`}:u.assets.download,J=await this.getAsset(q);await this.fileService.writeFile(P,J.stream),z(new Date().getTime()-M)}async getReadme(u,P){if(u.assets.readme){const L=await this.getAsset(u.assets.readme,{},P);return await(0,R.asText)(L)||""}return""}async getManifest(u,P){if(u.assets.manifest){const L=await this.getAsset(u.assets.manifest,{},P),k=await(0,R.asText)(L);return k?JSON.parse(k):null}return null}async getCoreTranslation(u,P){const L=u.assets.coreTranslations.filter(k=>k[0]===P.toUpperCase())[0];if(L){const k=await this.getAsset(L[1]),M=await(0,R.asText)(k);return M?JSON.parse(M):null}return null}async getChangelog(u,P){if(u.assets.changelog){const L=await this.getAsset(u.assets.changelog,{},P);return await(0,R.asText)(L)||""}return""}async getAllVersions(u,P){let L=new o().withFlags(p.IncludeVersions,p.IncludeFiles,p.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");u.identifier.uuid?L=L.withFilter(r.ExtensionId,u.identifier.uuid):L=L.withFilter(r.ExtensionName,u.identifier.id);const k=[],{galleryExtensions:M}=await this.queryGallery(L,O.CancellationToken.None);return M.length&&(P?await Promise.all(M[0].versions.map(async z=>{let B;try{B=await this.getEngine(z)}catch(q){}B&&(0,h.isEngineValid)(B,this.productService.version)&&k.push({version:z.version,date:z.lastUpdated})})):k.push(...M[0].versions.map(z=>({version:z.version,date:z.lastUpdated})))),k}async getAsset(u,P={},L=O.CancellationToken.None){const k=await this.commonHeadersPromise,M={type:"GET"},z=Object.assign(Object.assign({},k),P.headers||{});P=Object.assign(Object.assign(Object.assign({},P),M),{headers:z});const B=u.uri,q=u.fallbackUri,J=Object.assign(Object.assign({},P),{url:B});try{const Y=await this.requestService.request(J,L);if(Y.res.statusCode===200)return Y;const ie=await(0,R.asText)(Y);throw new Error(`Expected 200, got back ${Y.res.statusCode} instead.

${ie}`)}catch(Y){if((0,v.isPromiseCanceledError)(Y))throw Y;const ie=(0,v.getErrorMessage)(Y);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:B,message:ie});const re=Object.assign(Object.assign({},P),{url:q});return this.requestService.request(re,L)}}async getLastValidExtensionVersion(u,P){const L=this.getLastValidExtensionVersionFromProperties(u,P);return L||this.getLastValidExtensionVersionRecursively(u,P)}getLastValidExtensionVersionFromProperties(u,P){for(const L of P){const k=X(L);if(!k)return null;if((0,h.isEngineValid)(k,this.productService.version))return L}return null}async getEngine(u){const P=X(u);if(P)return P;const L=U(u,e.Manifest);if(!L)throw new Error("Manifest was not found");const k={"Accept-Encoding":"gzip"},M=await this.getAsset(L,{headers:k}),z=await(0,R.asJson)(M);if(z)return z.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(u,P){if(!P.length)return null;const L=P[0],k=await this.getEngine(L);return(0,h.isEngineValid)(k,this.productService.version)?(L.properties=L.properties||[],L.properties.push({key:i.Engine,value:k}),L):this.getLastValidExtensionVersionRecursively(u,P.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const u=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},O.CancellationToken.None);if(u.res.statusCode!==200)throw new Error("Could not get extensions report.");const P=await(0,R.asJson)(u),L=new Map;if(P)for(const k of P.malicious){const M=L.get(k)||{id:{id:k},malicious:!0,slow:!1};M.malicious=!0,L.set(k,M)}return[...L.values()]}};G=ce([ue(0,R.IRequestService),ue(1,d.ILogService),ue(2,f.IEnvironmentService),ue(3,T.ITelemetryService),ue(4,y.IFileService),ue(5,a.IProductService),ue(6,(0,E.optional)(m.IStorageService))],G),t.ExtensionGalleryService=G;async function _(c,u,P,L){const k={"X-Market-Client-Id":`VSCode ${c}`,"User-Agent":`VSCode ${c}`},M=await(0,S.getServiceMachineId)(u,P,L);return k["X-Market-User-Id"]=M,k}t.resolveMarketplaceHeaders=_}),define(Q[120],Z([0,1,54,85,21,7,27,31,2,22,26]),function($,t,v,C,I,w,T,R,h,f,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let d=class{constructor(a,m){this._configurationService=m,this._experimentProperties={},this._disposables=new h.DisposableStore,this._cleanupPatterns=[],this._appender=a.appender,this._commonProperties=a.commonProperties||Promise.resolve({}),this._piiPaths=a.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!a.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,I.escapeRegExpCharacters)(S),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(S=>{const E=/^[a-f0-9]+$/i.test(S["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!E})}))}setExperimentProperty(a,m){this._experimentProperties[a]=m}setEnabled(a){this._enabled=a}_updateUserOptIn(){var a;const m=(a=this._configurationService)===null||a===void 0?void 0:a.getValue(y);this._userOptIn=m?m.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const a=await this._commonProperties;let m=a.sessionID,S=a["common.instanceId"],E=a["common.machineId"],b=a["common.firstSessionDate"],p=a["common.msftInternal"];return{sessionId:m,instanceId:S,machineId:E,firstSessionDate:b,msftInternal:p}}dispose(){this._disposables.dispose()}publicLog(a,m,S){return this.isOptedIn?this._commonProperties.then(E=>{m=(0,f.mixin)(m,E),m=(0,f.mixin)(m,this._experimentProperties),m=(0,f.cloneAndChange)(m,b=>{if(typeof b=="string")return this._cleanupInfo(b,S)}),this._appender.log(a,m)},E=>{console.error(E)}):Promise.resolve(void 0)}publicLog2(a,m,S){return this.publicLog(a,m,S)}publicLogError(a,m){return this.sendErrorTelemetry?this.publicLog(a,m,!0):Promise.resolve(void 0)}publicLogError2(a,m){return this.publicLogError(a,m)}_cleanupInfo(a,m){let S=a;if(m){const E=[];for(let r of this._cleanupPatterns)for(;;){const e=r.exec(a);if(!e)break;E.push([e.index,r.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(S="";;){const r=p.exec(a);if(!r)break;!b.test(r[0])&&E.every(([e,i])=>r.index<e||r.index>=i)&&(S+=a.substring(l,r.index)+"<REDACTED: user-file-path>",l=p.lastIndex)}l<a.length&&(S+=a.substr(l))}for(let E of this._cleanupPatterns)S=S.replace(E,"");return S}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=ce([ue(1,(0,w.optional)(T.IConfigurationService))],d),t.TelemetryService=d;const y="telemetry";O.Registry.as(R.Extensions.Configuration).registerConfiguration({id:y,order:110,type:"object",title:(0,C.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,C.localize)(2,null,v.default.privacyStatementUrl):(0,C.localize)(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(Q[55],Z([0,1,27,22,8,4]),function($,t,v,C,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(a,m){return Promise.resolve(void 0)}publicLog2(a,m){return this.publicLog(a,m)}publicLogError(a,m){return Promise.resolve(void 0)}publicLogError2(a,m){return this.publicLogError(a,m)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class T{async publicLog(m,S,E){}async publicLogError(m,S,E){}}t.NullEndpointTelemetryService=T;function R(...a){return{log:(m,S)=>a.forEach(E=>E.log(m,S)),flush:()=>w.Promises.settled(a.map(m=>m.flush()))}}t.combinedAppender=R,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(a,m){return m.onDidChangeConfiguration(S=>{S.source!==6&&a.publicLog2("updateConfiguration",{configurationSource:(0,v.ConfigurationTargetToString)(S.source),configurationKeys:y(S.sourceConfig)})})}t.configurationTelemetry=h;function f(a){const m=Object.create(null),S=Object.create(null),E=Object.create(null);d(a,E);for(let b in E){b=b.length>150?b.substr(b.length-149):b;const p=E[b];typeof p=="number"?S[b]=p:typeof p=="boolean"?S[b]=p?1:0:typeof p=="string"?m[b]=p.substring(0,1023):typeof p!="undefined"&&p!==null&&(m[b]=p)}return{properties:m,measurements:S}}t.validateTelemetryData=f;function O(a){if(!a)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(E=>{a.indexOf(`${E}+`)===0&&(m=E)}),m}t.cleanRemoteAuthority=O;function d(a,m,S=0,E){if(!!a)for(let b of Object.getOwnPropertyNames(a)){const p=a[b],l=E?E+b:b;Array.isArray(p)?m[l]=(0,C.safeStringify)(p):p instanceof Date?m[l]=p.toISOString():(0,I.isObject)(p)?S<2?d(p,m,S+1,l+"."):m[l]=(0,C.safeStringify)(p):m[l]=p}}function y(a){if(!a)return[];const m=[];return D(m,"",a),m}function D(a,m,S){S&&typeof S=="object"&&!Array.isArray(S)?Object.keys(S).forEach(E=>D(a,m?`${m}.${E}`:E,S[E])):a.push(m)}}),define(Q[121],Z([0,1,14,22,55]),function($,t,v,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function w(R){const h=await new Promise((O,d)=>{$(["applicationinsights"],O,d)});let f;return h.defaultClient?(f=new h.TelemetryClient(R),f.channel.setUseDiskRetryCaching(!0)):(h.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),f=h.defaultClient),R.indexOf("AIF-")===0&&(f.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),f}class T{constructor(h,f,O){this._eventPrefix=h,this._defaultData=f,this._defaultData||(this._defaultData=Object.create(null)),typeof O=="function"?this._aiClient=O():this._aiClient=O,this._asyncAIClient=null}_withAIClient(h){if(!!this._aiClient){if(typeof this._aiClient!="string"){h(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=w(this._aiClient)),this._asyncAIClient.then(f=>{h(f)},f=>{(0,v.onUnexpectedError)(f),console.error(f)})}}log(h,f){!this._aiClient||(f=(0,C.mixin)(f,this._defaultData),f=(0,I.validateTelemetryData)(f),this._withAIClient(O=>O.trackEvent({name:this._eventPrefix+"/"+h,properties:f.properties,measurements:f.measurements})))}flush(){return this._aiClient?new Promise(h=>{this._withAIClient(f=>{f.flush({callback:()=>{this._aiClient=void 0,h(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=T}),define(Q[122],Z([0,1,12,16,3]),function($,t,v,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;function w(T,R){const h=Object.create(null),f=(d,y)=>{const D=JSON.parse(d);h[y]=D};if(R){const d=(0,v.readdirSync)(R).filter(D=>{try{return(0,C.statSync)((0,I.join)(R,D)).isDirectory()}catch(a){return!1}}),y=[];d.forEach(D=>{(0,v.readdirSync)((0,I.join)(R,D)).filter(m=>m==="telemetry.json").length===1&&y.push(D)}),y.forEach(D=>{const a=(0,C.readFileSync)((0,I.join)(R,D,"telemetry.json")).toString();f(a,D)})}let O=(0,C.readFileSync)((0,I.join)(T,"telemetry-core.json")).toString();return f(O,"vscode-core"),O=(0,C.readFileSync)((0,I.join)(T,"telemetry-extensions.json")).toString(),f(O,"vscode-extensions"),JSON.stringify(h,null,4)}t.buildTelemetryMessage=w}),define(Q[42],Z([0,1,73,3,16,4,12,133,134,8]),function($,t,v,C,I,w,T,R,h,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class O extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=O;function d(r){const e=r.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function y(r){if(r instanceof O)return r;let e;return/end of central directory record signature not found/.test(r.message)&&(e="CorruptZip"),new O(e,r)}function D(r,e,i,n,s,o){const g=C.dirname(e),F=C.join(n,g);if(!F.startsWith(n))return Promise.reject(new Error(v.localize(0,null,e)));const j=C.join(n,e);let N;return o.onCancellationRequested(()=>{N&&N.destroy()}),Promise.resolve(I.promises.mkdir(F,{recursive:!0})).then(()=>new Promise((A,U)=>{if(!o.isCancellationRequested)try{N=(0,I.createWriteStream)(j,{mode:i}),N.once("close",()=>A()),N.once("error",U),r.once("error",U),r.pipe(N)}catch(x){U(x)}}))}function a(r,e,i,n){let s=(0,w.createCancelablePromise)(()=>Promise.resolve()),o=0;return n.onCancellationRequested(()=>{s.cancel(),r.close()}),new Promise((g,F)=>{const j=new w.Sequencer,N=A=>{A.isCancellationRequested||(o++,r.readEntry())};r.once("error",F),r.once("close",()=>s.then(()=>{n.isCancellationRequested||r.entryCount===o?g():F(new O("Incomplete",new Error(v.localize(1,null,o,r.entryCount))))},F)),r.readEntry(),r.on("entry",A=>{if(!n.isCancellationRequested){if(!i.sourcePathRegex.test(A.fileName)){N(n);return}const U=A.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(U)){const ne=C.join(e,U);s=(0,w.createCancelablePromise)(ee=>I.promises.mkdir(ne,{recursive:!0}).then(()=>N(ee)).then(void 0,F));return}const x=S(r,A),X=d(A);s=(0,w.createCancelablePromise)(ne=>j.queue(()=>x.then(ee=>D(ee,U,X,e,i,ne).then(()=>N(ne)))).then(null,F))}})})}function m(r,e=!1){return new Promise((i,n)=>{(0,R.open)(r,e?{lazyEntries:!0}:void 0,(s,o)=>{s?n(y(s)):i((0,f.assertIsDefined)(o))})})}function S(r,e){return new Promise((i,n)=>{r.openReadStream(e,(s,o)=>{s?n(y(s)):i((0,f.assertIsDefined)(o))})})}function E(r,e){return new Promise((i,n)=>{const s=new h.ZipFile;e.forEach(g=>{g.contents?s.addBuffer(typeof g.contents=="string"?Buffer.from(g.contents,"utf8"):g.contents,g.path):g.localPath&&s.addFile(g.localPath,g.path)}),s.end();const o=(0,I.createWriteStream)(r);s.outputStream.pipe(o),s.outputStream.once("error",n),o.once("error",n),o.once("finish",()=>i(r))})}t.zip=E;function b(r,e,i={},n){const s=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let o=m(r,!0);return i.overwrite&&(o=o.then(g=>(0,T.rimraf)(e).then(()=>g))),o.then(g=>a(g,e,{sourcePathRegex:s},n))}t.extract=b;function p(r,e){return m(r).then(i=>new Promise((n,s)=>{i.on("entry",o=>{o.fileName===e&&S(i,o).then(g=>n(g),g=>s(g))}),i.once("close",()=>s(new Error(v.localize(2,null,e))))}))}function l(r,e){return p(r,e).then(i=>new Promise((n,s)=>{const o=[];i.once("error",s),i.on("data",g=>o.push(g)),i.on("end",()=>n(Buffer.concat(o)))}))}t.buffer=l}),define(Q[123],Z([0,1,42,78]),function($,t,v,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function I(w){return(0,v.buffer)(w,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch(R){throw new Error((0,C.localize)(0,null))}})}t.getManifest=I}),define(Q[124],Z([0,1,16,39,2,12,3,13,24,25,4,9,19,90,79,40,42,15,23,10,20,18,30,14]),function($,t,v,C,I,w,T,R,h,f,O,d,y,D,a,m,S,E,b,p,l,r,e,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const n="scanningSystem",s="scanningUser",o="extracting",g="deleting",F="renaming";let j=class extends I.Disposable{constructor(A,U,x,X,ne){super();this.beforeRemovingExtension=A,this.fileService=U,this.logService=x,this.environmentService=X,this.productService=ne,this._devSystemExtensionsPath=null,this.systemExtensionsPath=X.builtinExtensionsPath,this.extensionsPath=X.extensionsPath,this.uninstalledPath=T.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new O.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(A){const U=[];(A===null||A===0)&&U.push(this.scanSystemExtensions().then(null,x=>Promise.reject(new h.ExtensionManagementError(this.joinErrors(x).message,n)))),(A===null||A===1)&&U.push(this.scanUserExtensions(!0).then(null,x=>Promise.reject(new h.ExtensionManagementError(this.joinErrors(x).message,s))));try{const x=await Promise.all(U);return(0,b.flatten)(x)}catch(x){throw this.joinErrors(x)}}async scanUserExtensions(A){this.logService.trace("Started scanning user extensions");let[U,x]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return x=x.filter(X=>!U[new f.ExtensionIdentifierWithVersion(X.identifier,X.manifest.version).key()]),A&&(x=(0,f.groupByExtension)(x,ne=>ne.identifier).map(ne=>ne.sort((ee,te)=>C.rcompare(ee.manifest.version,te.manifest.version))[0])),this.logService.trace("Scanned user extensions:",x.length),x}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(A,U,x){const X=A.key(),ne=T.join(this.extensionsPath,`.${(0,e.generateUuid)()}`),ee=T.join(this.extensionsPath,X);try{await w.rimraf(ee)}catch(ae){try{await w.rimraf(ee)}catch(W){}throw new h.ExtensionManagementError((0,a.localize)(0,null,ee,A.id),g)}await this.extractAtLocation(A,U,ne,x);let te=await this.scanExtension(d.URI.file(ne),1);if(!te)throw new Error((0,a.localize)(1,null,ne));await this.storeMetadata(te,{installedTimestamp:Date.now()});try{await this.rename(A,ne,ee,Date.now()+2*60*1e3),this.logService.info("Renamed to",ee)}catch(ae){try{await w.rimraf(ne)}catch(W){}if(ae.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",A.id);else throw this.logService.info(`Rename failed because of ${(0,i.getErrorMessage)(ae)}. Deleted from extracted location`,ne),ae}try{te=await this.scanExtension(d.URI.file(ee),1)}catch(ae){}if(te)return te;throw new Error((0,a.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(A,U){return this.setMetadata(A,U),await this.storeMetadata(A,Object.assign(Object.assign({},U),{installedTimestamp:A.installedTimestamp})),A}async storeMetadata(A,U){U.isMachineScoped=U.isMachineScoped||void 0,U.isBuiltin=U.isBuiltin||void 0,U.installedTimestamp=U.installedTimestamp||void 0;const x=T.join(A.location.fsPath,"package.json"),X=await v.promises.readFile(x,"utf8"),{manifest:ne}=await this.parseManifest(X);return ne.__metadata=U,await w.writeFile(x,JSON.stringify(ne,null,"	")),A}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...A){const U=A.map(x=>new f.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version));await this.withUninstalledExtensions(x=>{U.forEach(X=>x[X.key()]=!0)})}async setInstalled(A){await this.withUninstalledExtensions(X=>delete X[A.key()]);const x=(await this.scanExtensions(1)).find(X=>new f.ExtensionIdentifierWithVersion(X.identifier,X.manifest.version).equals(A))||null;return x?(await this.storeMetadata(x,{installedTimestamp:Date.now()}),this.scanExtension(x.location,1)):null}async withUninstalledExtensions(A){return this.uninstalledFileLimiter.queue(async()=>{let U;try{U=await v.promises.readFile(this.uninstalledPath,"utf8")}catch(X){if(X.code!=="ENOENT")throw X}let x={};if(U)try{x=JSON.parse(U)}catch(X){}return A&&(A(x),Object.keys(x).length?await w.writeFile(this.uninstalledPath,JSON.stringify(x)):await w.rimraf(this.uninstalledPath)),x})}async removeExtension(A,U){this.logService.trace(`Deleting ${U} extension from disk`,A.identifier.id,A.location.fsPath),await w.rimraf(A.location.fsPath),this.logService.info("Deleted from disk",A.identifier.id,A.location.fsPath)}async removeUninstalledExtension(A){await this.removeExtension(A,"uninstalled"),await this.withUninstalledExtensions(U=>delete U[new f.ExtensionIdentifierWithVersion(A.identifier,A.manifest.version).key()])}async extractAtLocation(A,U,x,X){this.logService.trace(`Started extracting the extension from ${U} to ${x}`);try{await w.rimraf(x)}catch(ne){throw new h.ExtensionManagementError(this.joinErrors(ne).message,g)}try{await(0,S.extract)(U,x,{sourcePath:"extension",overwrite:!0},X),this.logService.info(`Extracted extension to ${x}:`,A.id)}catch(ne){try{await w.rimraf(x)}catch(ee){}throw new h.ExtensionManagementError(ne.message,ne instanceof S.ExtractError&&ne.type?ne.type:o)}}async rename(A,U,x,X){try{await v.promises.rename(U,x)}catch(ne){if(E.isWindows&&ne&&ne.code==="EPERM"&&Date.now()<X)return this.logService.info(`Failed renaming ${U} to ${x} with 'EPERM' error. Trying again...`,A.id),this.rename(A,U,x,X);throw new h.ExtensionManagementError(ne.message||(0,a.localize)(3,null,U,x),ne.code||F)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const A=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return A;const U=this.scanDevSystemExtensions(),[x,X]=await Promise.all([A,U]);return[...x,...X]}async scanExtensionsInDir(A,U){const x=new O.Limiter(10),X=await this.fileService.resolve(d.URI.file(A));return X.children?(await Promise.all(X.children.filter(ee=>ee.isDirectory).map(ee=>x.queue(async()=>U===1&&(0,r.basename)(ee.resource).indexOf(".")===0?null:this.scanExtension(ee.resource,U))))).filter(ee=>ee&&ee.identifier):[]}async scanExtension(A,U){var x,X;try{const ne=await this.fileService.resolve(A);if(ne.children){const{manifest:ee,metadata:te}=await this.readManifest(A.fsPath),ae=(x=ne.children.find(({name:c})=>/^readme(\.txt|\.md|)$/i.test(c)))===null||x===void 0?void 0:x.resource,W=(X=ne.children.find(({name:c})=>/^changelog(\.txt|\.md|)$/i.test(c)))===null||X===void 0?void 0:X.resource,G={id:(0,f.getGalleryExtensionId)(ee.publisher,ee.name)},_={type:U,identifier:G,manifest:ee,location:A,readmeUrl:ae,changelogUrl:W,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:U===0};return te&&(this.setMetadata(_,te),_.installedTimestamp=te.installedTimestamp),_}}catch(ne){U!==0&&this.logService.trace(ne)}return null}async scanDefaultSystemExtensions(){const A=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",A.length),A}async scanDevSystemExtensions(){const A=this.getDevSystemExtensionsList();if(A.length){const U=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",U.length),U.filter(x=>A.some(X=>(0,f.areSameExtensions)(x.identifier,{id:X})))}else return[]}setMetadata(A,U){A.publisherDisplayName=U.publisherDisplayName||null,A.publisherId=U.publisherId||null,A.identifier.uuid=U.id,A.isMachineScoped=!!U.isMachineScoped,A.isBuiltin=A.type===0||!!U.isBuiltin}async removeUninstalledExtensions(){const A=await this.getUninstalledExtensions(),U=await this.scanAllUserExtensions(),x=new Set;for(const ee of U)A[new f.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]||x.add(ee.identifier.id.toLowerCase());const X=(0,f.groupByExtension)(U,ee=>ee.identifier);await O.Promises.settled(X.map(async ee=>{const te=ee.sort((ae,W)=>C.rcompare(ae.manifest.version,W.manifest.version))[0];x.has(te.identifier.id.toLowerCase())||await this.beforeRemovingExtension(te)}));const ne=U.filter(ee=>A[new f.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]);await O.Promises.settled(ne.map(ee=>this.removeUninstalledExtension(ee)))}async removeOutdatedExtensions(){const A=await this.scanAllUserExtensions(),U=[],x=(0,f.groupByExtension)(A,X=>X.identifier);U.push(...(0,b.flatten)(x.map(X=>X.sort((ne,ee)=>C.rcompare(ne.manifest.version,ee.manifest.version)).slice(1)))),await O.Promises.settled(U.map(X=>this.removeExtension(X,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(A=>A.name)}joinErrors(A){const U=Array.isArray(A)?A:[A];return U.length===1?U[0]instanceof Error?U[0]:new Error(U[0]):U.reduce((x,X)=>new Error(`${x.message}${x.message?",":""}${X instanceof Error?X.message:X}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=T.normalize(T.join(p.FileAccess.asFileUri("",$).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(A){const U=[v.promises.readFile(T.join(A,"package.json"),"utf8").then(ee=>this.parseManifest(ee)),v.promises.readFile(T.join(A,"package.nls.json"),"utf8").then(void 0,ee=>ee.code!=="ENOENT"?Promise.reject(ee):"{}").then(ee=>JSON.parse(ee))],[{manifest:x,metadata:X},ne]=await Promise.all(U);return{manifest:(0,D.localizeManifest)(x,ne),metadata:X}}parseManifest(A){return new Promise((U,x)=>{try{const X=JSON.parse(A),ne=X.__metadata||null;U({manifest:X,metadata:ne})}catch(X){x(new Error((0,a.localize)(4,null)))}})}};j=ce([ue(1,l.IFileService),ue(2,R.ILogService),ue(3,y.INativeEnvironmentService),ue(4,m.IProductService)],j),t.ExtensionsScanner=j}),define(Q[125],Z([0,1,16,77,3,12,2,23,42,24,25,19,4,11,39,9,54,15,13,98,29,41,47,18,30,96,7,10,28,123,102,124,103,104,20]),function($,t,v,C,I,w,T,R,h,f,O,d,y,D,a,m,S,E,b,p,l,r,e,i,n,s,o,g,F,j,N,A,U,x,X){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const ne="unsetUninstalled",ee="downloading",te="validating",ae="local",W="unknown";let G=class extends T.Disposable{constructor(c,u,P,L,k,M,z){super();this.environmentService=c,this.galleryService=u,this.logService=P,this.downloadService=L,this.telemetryService=k,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new D.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const B=this._register(M.createInstance(U.ExtensionsLifecycle));this.extensionsScanner=this._register(M.createInstance(A.ExtensionsScanner,J=>B.postUninstall(J))),this.manifestCache=this._register(new p.ExtensionsManifestCache(c,this)),this.extensionsDownloader=this._register(M.createInstance(N.ExtensionsDownloader));const q=this._register(new x.ExtensionsWatcher(this,z,c,P));this._register(q.onDidChangeExtensionsByAnotherSource(({added:J,removed:Y})=>{J.forEach(ie=>this._onDidInstallExtension.fire({identifier:ie.identifier,operation:0,local:ie})),Y.forEach(ie=>this._onDidUninstallExtension.fire({identifier:ie}))})),this._register((0,T.toDisposable)(()=>{this.installingExtensions.forEach(J=>J.cancel()),this.uninstallingExtensions.forEach(J=>J.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(c){this.logService.trace("ExtensionManagementService#zip",c.identifier.id);const u=await this.collectFiles(c),P=await(0,h.zip)((0,i.joinPath)(this.environmentService.tmpDir,(0,n.generateUuid)()).fsPath,u);return m.URI.file(P)}async unzip(c){return this.logService.trace("ExtensionManagementService#unzip",c.toString()),(await this.install(c)).identifier}async getManifest(c){const u=await this.downloadVsix(c),P=I.resolve(u.fsPath);return(0,j.getManifest)(P)}async collectFiles(c){const u=async L=>{let k=await w.readdir(L);k=k.map(B=>I.join(L,B));const M=await Promise.all(k.map(B=>v.promises.stat(B)));let z=Promise.resolve([]);return M.forEach((B,q)=>{const J=k[q];B.isFile()&&(z=z.then(Y=>[...Y,J])),B.isDirectory()&&(z=z.then(Y=>u(J).then(ie=>[...Y,...ie])))}),z};return(await u(c.location.fsPath)).map(L=>({path:`extension/${I.relative(c.location.fsPath,L)}`,localPath:L}))}async install(c,u={}){return this.logService.trace("ExtensionManagementService#install",c.toString()),(0,y.createCancelablePromise)(async P=>{const L=await this.downloadVsix(c),k=I.resolve(L.fsPath),M=await(0,j.getManifest)(k),z={id:(0,O.getGalleryExtensionId)(M.publisher,M.name)};let B=1;if(M.engines&&M.engines.vscode&&!(0,e.isEngineValid)(M.engines.vscode,S.default.version))throw new Error(C.localize(0,null,z.id,S.default.version));const q=new O.ExtensionIdentifierWithVersion(z,M.version),Y=(await this.getInstalled(1)).find(re=>(0,O.areSameExtensions)(z,re.identifier));if(Y)if(u.isMachineScoped=u.isMachineScoped||Y.isMachineScoped,u.isBuiltin=u.isBuiltin||Y.isBuiltin,B=2,q.equals(new O.ExtensionIdentifierWithVersion(Y.identifier,Y.manifest.version)))try{await this.extensionsScanner.removeExtension(Y,"existing")}catch(re){throw new Error(C.localize(1,null,M.displayName||M.name))}else a.gt(Y.manifest.version,M.version)&&await this.uninstallExtension(Y);else{const re=await this.unsetUninstalledAndGetLocal(q);if(re)try{await this.extensionsScanner.removeExtension(re,"existing")}catch(he){throw new Error(C.localize(2,null,M.displayName||M.name))}}this.logService.info("Installing the extension:",z.id),this._onInstallExtension.fire({identifier:z,zipPath:k});let ie;try{ie=await this.getGalleryMetadata((0,O.getGalleryExtensionId)(M.publisher,M.name))}catch(re){}try{const re=await this.installFromZipPath(q,k,Object.assign(Object.assign({},ie||{}),u),u,B,P);return this.logService.info("Successfully installed the extension:",z.id),re}catch(re){throw this.logService.error("Failed to install the extension:",z.id,re.message),re}})}async downloadVsix(c){if(c.scheme===g.Schemas.file)return c;if(!this.downloadService)throw new Error("Download service is not available");const u=(0,i.joinPath)(this.environmentService.tmpDir,(0,n.generateUuid)());return await this.downloadService.download(c,u),u}async installFromZipPath(c,u,P,L,k,M){try{const z=await this.installExtension({zipPath:u,identifierWithVersion:c,metadata:P},M);try{await this.installDependenciesAndPackExtensions(z,void 0,L)}catch(B){(0,R.isNonEmptyArray)(z.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",z.identifier.id,B.message),(0,R.isNonEmptyArray)(z.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",z.identifier.id,B.message)}return this._onDidInstallExtension.fire({identifier:c,zipPath:u,local:z,operation:k}),z}catch(z){throw this._onDidInstallExtension.fire({identifier:c,zipPath:u,operation:k,error:z}),z}}async canInstall(c){return!0}async installFromGallery(c,u={}){if(!this.galleryService.isEnabled())throw new Error(C.localize(3,null));try{c=await this.checkAndGetCompatibleVersion(c)}catch(k){const M=k&&k.code?k.code:W;throw this.logService.error("Failed to install extension:",c.identifier.id,k?k.message:M),this.reportTelemetry(this.getTelemetryEvent(1),(0,O.getGalleryExtensionTelemetryData)(c),void 0,k),k instanceof Error&&(k.name=M),k}const P=new O.ExtensionIdentifierWithVersion(c.identifier,c.version).key();let L=this.installingExtensions.get(P);return L||(L=(0,y.createCancelablePromise)(k=>this.doInstallFromGallery(c,u,k)),this.installingExtensions.set(P,L),L.finally(()=>this.installingExtensions.delete(P))),L}async doInstallFromGallery(c,u,P){const L=new Date().getTime();let k=1;this.logService.info("Installing extension:",c.identifier.id),this._onInstallExtension.fire({identifier:c.identifier,gallery:c});try{const z=(await this.getInstalled(1)).find(J=>(0,O.areSameExtensions)(J.identifier,c.identifier));z&&(k=2);const B=await this.downloadInstallableExtension(c,k);B.metadata.isMachineScoped=u.isMachineScoped||(z==null?void 0:z.isMachineScoped),B.metadata.isBuiltin=u.isBuiltin||(z==null?void 0:z.isBuiltin);const q=await this.installExtension(B,P);try{await this.extensionsDownloader.delete(m.URI.file(B.zipPath))}catch(J){}if(!u.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(q,z,u)}catch(J){try{await this.uninstall(q)}catch(Y){}throw J}return z&&a.neq(z.manifest.version,c.version)&&await this.extensionsScanner.setUninstalled(z),this.logService.info("Extensions installed successfully:",c.identifier.id),this._onDidInstallExtension.fire({identifier:c.identifier,gallery:c,local:q,operation:k}),this.reportTelemetry(this.getTelemetryEvent(k),(0,O.getGalleryExtensionTelemetryData)(c),new Date().getTime()-L,void 0),q}catch(M){const z=M&&M.code?M.code:W;throw this.logService.error("Failed to install extension:",c.identifier.id,M?M.message:z),this._onDidInstallExtension.fire({identifier:c.identifier,gallery:c,operation:k,error:z}),this.reportTelemetry(this.getTelemetryEvent(k),(0,O.getGalleryExtensionTelemetryData)(c),new Date().getTime()-L,M),M instanceof Error&&(M.name=z),M}}async checkAndGetCompatibleVersion(c){if(await this.isMalicious(c))throw new f.ExtensionManagementError(C.localize(4,null),f.INSTALL_ERROR_MALICIOUS);const u=await this.galleryService.getCompatibleExtension(c);if(!u)throw new f.ExtensionManagementError(C.localize(5,null,c.identifier.id,S.default.version),f.INSTALL_ERROR_INCOMPATIBLE);return u}async reinstallFromGallery(c){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",c.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(6,null));const u=await this.findGalleryExtension(c);if(!u)throw new Error(C.localize(7,null));await this.extensionsScanner.setUninstalled(c);try{await this.extensionsScanner.removeUninstalledExtension(c)}catch(P){throw new Error(C.localize(8,null,(0,l.toErrorMessage)(P)))}await this.installFromGallery(u)}getTelemetryEvent(c){return c===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(c){const u=await this.getExtensionsReport();return(0,O.getMaliciousExtensionsSet)(u).has(c.identifier.id)}async downloadInstallableExtension(c,u){const P={id:c.identifier.uuid,publisherId:c.publisherId,publisherDisplayName:c.publisherDisplayName};let L;try{this.logService.trace("Started downloading extension:",c.identifier.id),L=(await this.extensionsDownloader.downloadExtension(c,u)).fsPath,this.logService.info("Downloaded extension:",c.identifier.id,L)}catch(k){throw new f.ExtensionManagementError(this.joinErrors(k).message,ee)}try{const k=await(0,j.getManifest)(L);return{zipPath:L,identifierWithVersion:new O.ExtensionIdentifierWithVersion(c.identifier,k.version),metadata:P}}catch(k){throw new f.ExtensionManagementError(this.joinErrors(k).message,te)}}async installExtension(c,u){try{const P=await this.unsetUninstalledAndGetLocal(c.identifierWithVersion);if(P)return c.metadata?this.extensionsScanner.saveMetadataForLocalExtension(P,c.metadata):P}catch(P){throw E.isMacintosh?new f.ExtensionManagementError(C.localize(9,null),ne):new f.ExtensionManagementError(C.localize(10,null),ne)}return this.extractAndInstall(c,u)}async unsetUninstalledAndGetLocal(c){if(!await this.isUninstalled(c))return null;this.logService.trace("Removing the extension from uninstalled list:",c.id);const P=await this.extensionsScanner.setInstalled(c);return this.logService.info("Removed the extension from uninstalled list:",c.id),P}async extractAndInstall({zipPath:c,identifierWithVersion:u,metadata:P},L){let k=await this.extensionsScanner.extractUserExtension(u,c,L);return this.logService.info("Installation completed.",u.id),P&&(k=await this.extensionsScanner.saveMetadataForLocalExtension(k,P)),k}async installDependenciesAndPackExtensions(c,u,P){if(!!this.galleryService.isEnabled()){const L=c.manifest.extensionDependencies||[];if(c.manifest.extensionPack)for(const k of c.manifest.extensionPack)u&&u.manifest.extensionPack&&u.manifest.extensionPack.some(M=>(0,O.areSameExtensions)({id:M},{id:k}))||L.every(M=>!(0,O.areSameExtensions)({id:M},{id:k}))&&L.push(k);if(L.length){const k=await this.getInstalled(),M=L.filter(z=>k.every(({identifier:B})=>!(0,O.areSameExtensions)(B,{id:z})));if(M.length){const B=(await this.galleryService.query({names:M,pageSize:L.length},F.CancellationToken.None)).firstPage;try{await y.Promises.settled(B.map(q=>this.installFromGallery(q,P)))}catch(q){try{await this.rollback(B)}catch(J){}throw q}}}}}async rollback(c){const P=(await this.getInstalled(1)).filter(L=>c.some(k=>new O.ExtensionIdentifierWithVersion(L.identifier,L.manifest.version).equals(new O.ExtensionIdentifierWithVersion(k.identifier,k.version))));await y.Promises.settled(P.map(L=>this.uninstall(L)))}async uninstall(c,u={}){this.logService.trace("ExtensionManagementService#uninstall",c.identifier.id);const P=await this.getInstalled(1),L=P.find(k=>(0,O.areSameExtensions)(k.identifier,c.identifier));if(!L)throw new Error(C.localize(11,null,c.manifest.displayName||c.manifest.name));try{await this.checkForDependenciesAndUninstall(L,P,u)}catch(k){throw this.joinErrors(k)}}async updateMetadata(c,u){return this.logService.trace("ExtensionManagementService#updateMetadata",c.identifier.id),c=await this.extensionsScanner.saveMetadataForLocalExtension(c,Object.assign(Object.assign({},c.manifest.__metadata||{}),u)),this.manifestCache.invalidate(),c}async updateExtensionScope(c,u){return this.logService.trace("ExtensionManagementService#updateExtensionScope",c.identifier.id),c=await this.extensionsScanner.saveMetadataForLocalExtension(c,Object.assign(Object.assign({},c.manifest.__metadata||{}),{isMachineScoped:u})),this.manifestCache.invalidate(),c}async getGalleryMetadata(c){const u=await this.findGalleryExtensionByName(c);return u?{id:u.identifier.uuid,publisherDisplayName:u.publisherDisplayName,publisherId:u.publisherId}:void 0}async findGalleryExtension(c){if(c.identifier.uuid){const u=await this.findGalleryExtensionById(c.identifier.uuid);return u||this.findGalleryExtensionByName(c.identifier.id)}return this.findGalleryExtensionByName(c.identifier.id)}async findGalleryExtensionById(c){return(await this.galleryService.query({ids:[c],pageSize:1},F.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(c){return(await this.galleryService.query({names:[c],pageSize:1},F.CancellationToken.None)).firstPage[0]}joinErrors(c){const u=Array.isArray(c)?c:[c];return u.length===1?u[0]instanceof Error?u[0]:new Error(u[0]):u.reduce((P,L)=>new Error(`${P.message}${P.message?",":""}${L instanceof Error?L.message:L}`),new Error(""))}async checkForDependenciesAndUninstall(c,u,P){try{await this.preUninstallExtension(c);const L=P.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(c,u);await this.uninstallExtensions(c,L,u,P)}catch(L){throw await this.postUninstallExtension(c,new f.ExtensionManagementError(L instanceof Error?L.message:L,ae)),L}await this.postUninstallExtension(c)}async uninstallExtensions(c,u,P,L){const k=[c,...u];if(!L.donotCheckDependents)for(const M of k)this.checkForDependents(M,k,P,c);await y.Promises.settled([this.uninstallExtension(c),...u.map(M=>this.doUninstall(M))])}checkForDependents(c,u,P,L){const k=this.getDependents(c,P);if(k.length){const M=k.filter(z=>u.indexOf(z)===-1);if(M.length)throw new Error(this.getDependentsErrorMessage(c,M,L))}}getDependentsErrorMessage(c,u,P){return P===c?u.length===1?C.localize(12,null,P.manifest.displayName||P.manifest.name,u[0].manifest.displayName||u[0].manifest.name):u.length===2?C.localize(13,null,P.manifest.displayName||P.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):C.localize(14,null,P.manifest.displayName||P.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):u.length===1?C.localize(15,null,P.manifest.displayName||P.manifest.name,c.manifest.displayName||c.manifest.name,u[0].manifest.displayName||u[0].manifest.name):u.length===2?C.localize(16,null,P.manifest.displayName||P.manifest.name,c.manifest.displayName||c.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):C.localize(17,null,P.manifest.displayName||P.manifest.name,c.manifest.displayName||c.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name)}getAllPackExtensionsToUninstall(c,u,P=[]){if(P.indexOf(c)!==-1)return[];P.push(c);const L=c.manifest.extensionPack?c.manifest.extensionPack:[];if(L.length){const k=u.filter(z=>!z.isBuiltin&&L.some(B=>(0,O.areSameExtensions)({id:B},z.identifier))),M=[];for(const z of k)M.push(...this.getAllPackExtensionsToUninstall(z,u,P));return[...k,...M]}return[]}getDependents(c,u){return u.filter(P=>P.manifest.extensionDependencies&&P.manifest.extensionDependencies.some(L=>(0,O.areSameExtensions)({id:L},c.identifier)))}async doUninstall(c){try{await this.preUninstallExtension(c),await this.uninstallExtension(c)}catch(u){throw await this.postUninstallExtension(c,new f.ExtensionManagementError(u instanceof Error?u.message:u,ae)),u}await this.postUninstallExtension(c)}async preUninstallExtension(c){if(!await w.exists(c.location.fsPath))throw new Error(C.localize(18,null));this.logService.info("Uninstalling extension:",c.identifier.id),this._onUninstallExtension.fire(c.identifier)}async uninstallExtension(c){let u=this.uninstallingExtensions.get(c.identifier.id);return u||(u=(0,y.createCancelablePromise)(async()=>{const P=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...P.filter(L=>(0,O.areSameExtensions)(L.identifier,c.identifier)))}),this.uninstallingExtensions.set(c.identifier.id,u),u.finally(()=>this.uninstallingExtensions.delete(c.identifier.id))),u}async postUninstallExtension(c,u){if(u)this.logService.error("Failed to uninstall extension:",c.identifier.id,u.message);else if(this.logService.info("Successfully uninstalled extension:",c.identifier.id),c.identifier.uuid)try{await this.galleryService.reportStatistic(c.manifest.publisher,c.manifest.name,c.manifest.version,"uninstall")}catch(L){}this.reportTelemetry("extensionGallery:uninstall",(0,O.getLocalExtensionTelemetryData)(c),void 0,u);const P=u?u instanceof f.ExtensionManagementError?u.code:W:void 0;this._onDidUninstallExtension.fire({identifier:c.identifier,error:P})}getInstalled(c=null){return this.extensionsScanner.scanExtensions(c)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(c){return(await this.filterUninstalled(c)).length===1}async filterUninstalled(...c){const u=[],P=await this.extensionsScanner.getUninstalledExtensions();for(const L of c)P[L.key()]&&u.push(L.key());return u}getExtensionsReport(){const c=new Date().getTime();return(!this.reportedExtensions||c-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=c),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const c=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${c.length} reported extensions from service`),c}catch(c){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(c,u,P,L){const k=L?L instanceof f.ExtensionManagementError?L.code:W:void 0;this.telemetryService.publicLogError(c,Object.assign(Object.assign({},u),{success:!L,duration:P,errorcode:k}))}};G=ce([ue(0,d.INativeEnvironmentService),ue(1,f.IExtensionGalleryService),ue(2,b.ILogService),ue(3,(0,o.optional)(s.IDownloadService)),ue(4,r.ITelemetryService),ue(5,o.IInstantiationService),ue(6,X.IFileService)],G),t.ExtensionManagementService=G}),define(Q[126],Z([0,1,135,113,2,8,14,112,27,13,17,19,99]),function($,t,v,C,I,w,T,R,h,f,O,d,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let D=class extends I.Disposable{constructor(m,S,E){super();this.environmentService=S,this.logService=E,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,S){this.logService.trace("RequestService#request",m.url);const{proxyUrl:E,strictSSL:b}=this,p=Object.assign(Object.assign({},process.env),await(0,y.resolveShellEnv)(this.logService,this.environmentService.args,process.env)),l=m.agent?m.agent:await(0,R.getProxyAgent)(m.url||"",p,{proxyUrl:E,strictSSL:b});return m.agent=l,m.strictSSL=b,this.authorization&&(m.headers=Object.assign(Object.assign({},m.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(m,S)}async getNodeRequest(m){return((0,C.parse)(m.url).protocol==="https:"?await new Promise((b,p)=>{$(["https"],b,p)}):await new Promise((b,p)=>{$(["http"],b,p)})).request}_request(m,S){return new Promise(async(E,b)=>{let p;const l=(0,C.parse)(m.url),r=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),e={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,w.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(e.auth=m.user+":"+m.password),p=r(e,i=>{const n=(0,w.isNumber)(m.followRedirects)?m.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request(Object.assign(Object.assign({},m),{url:i.headers.location,followRedirects:n-1}),S).then(E,b);else{let s=i;i.headers["content-encoding"]==="gzip"&&(s=i.pipe((0,v.createGunzip)())),E({res:i,stream:(0,O.streamToBufferReadableStream)(s)})}}),p.on("error",b),m.timeout&&p.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&p.write(m.data),p.end(),S.onCancellationRequested(()=>{p.abort(),b((0,T.canceled)())})})}async resolveProxy(m){}};D=ce([ue(0,h.IConfigurationService),ue(1,d.INativeEnvironmentService),ue(2,f.ILogService)],D),t.RequestService=D}),define(Q[136],Z([0,1,32,16,137,3,4,54,51,48,101,19,89,24,125,119,41,55,120,118,53,126,27,111,121,115,116,13,10,108,122,105,20,106,2,40,97,9,107,52,14,29,17,34]),function($,t,v,C,I,w,T,R,h,f,O,d,y,D,a,m,S,E,b,p,l,r,e,i,n,s,o,g,F,j,N,A,U,x,X,ne,ee,te,ae,W,G,_,c,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class P extends X.Disposable{constructor(M){super();this.argv=M,(0,I.gracefulify)(C),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[M,z]=await this.initServices();return M.invokeFunction(async B=>{const q=B.get(g.ILogService),J=B.get(U.IFileService),Y=B.get(d.INativeEnvironmentService),ie=B.get(D.IExtensionManagementCLIService);return q.info("CLI main",this.argv),this.registerErrorHandler(q),await this.doRun(Y,ie,J),(0,T.raceTimeout)((0,E.combinedAppender)(...z).flush(),1e3)})}async initServices(){const M=new h.ServiceCollection,z=Object.assign({_serviceBrand:void 0},R.default);M.set(ne.IProductService,z);const B=new y.NativeEnvironmentService(this.argv,z);M.set(d.INativeEnvironmentService,B),await Promise.all([B.appSettingsHome.fsPath,B.extensionsPath].map(Se=>Se?C.promises.mkdir(Se,{recursive:!0}):void 0));const q=(0,g.getLogLevel)(B),J=[];J.push(new j.SpdLogLogger("cli",(0,w.join)(B.logsPath,"cli.log"),!0,q)),q===g.LogLevel.Trace&&J.push(new g.ConsoleLogger(q));const Y=this._register(new g.MultiplexLogService(J));M.set(g.ILogService,Y);const ie=this._register(new A.FileService(Y));M.set(U.IFileService,ie);const re=this._register(new x.DiskFileSystemProvider(Y));ie.registerProvider(F.Schemas.file,re);const he=this._register(new i.ConfigurationService(B.settingsResource,ie));M.set(e.IConfigurationService,he),await he.initialize();const ge=new o.StateService(B,Y);M.set(s.IStateService,ge);const{appRoot:De,extensionsPath:Oe,extensionDevelopmentLocationURI:Fe,isBuilt:Re,installSourcePath:Me}=B;M.set(l.IRequestService,new f.SyncDescriptor(r.RequestService)),M.set(D.IExtensionManagementService,new f.SyncDescriptor(a.ExtensionManagementService)),M.set(D.IExtensionGalleryService,new f.SyncDescriptor(m.ExtensionGalleryService)),M.set(D.IExtensionManagementCLIService,new f.SyncDescriptor(ee.ExtensionManagementCLIService)),M.set(W.ILocalizationsService,new f.SyncDescriptor(ae.LocalizationsService));const ve=[];if(Re&&!Fe&&!B.disableTelemetry&&z.enableTelemetry){z.aiConfig&&z.aiConfig.asimovKey&&ve.push(new n.AppInsightsAppender("monacoworkbench",null,z.aiConfig.asimovKey));const Se={appender:(0,E.combinedAppender)(...ve),sendErrorTelemetry:!1,commonProperties:(0,p.resolveCommonProperties)(ie,(0,v.release)(),process.arch,z.commit,z.version,ge.getItem("telemetry.machineId"),z.msftInternalDomains,Me),piiPaths:[De,Oe]};M.set(S.ITelemetryService,new f.SyncDescriptor(b.TelemetryService,[Se]))}else M.set(S.ITelemetryService,E.NullTelemetryService);return[new O.InstantiationService(M),ve]}registerErrorHandler(M){(0,G.setUnexpectedErrorHandler)(z=>{const B=(0,_.toErrorMessage)(z,!0);!B||M.error(`[uncaught exception in CLI]: ${B}`)})}async doRun(M,z,B){if(this.argv["install-source"])return this.setInstallSource(M,B,this.argv["install-source"]);if(this.argv["list-extensions"])return z.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return z.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return z.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return z.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log((0,N.buildTelemetryMessage)(M.appRoot,M.extensionsPath))}asExtensionIdOrVSIX(M){return M.map(z=>/\.vsix$/i.test(z)?te.URI.file((0,w.isAbsolute)(z)?z:(0,w.join)((0,u.cwd)(),z)):z)}async setInstallSource(M,z,B){await z.writeFile(te.URI.file(M.installSourcePath),c.VSBuffer.fromString(B.slice(0,30)))}}async function L(k){const M=new P(k);try{await M.run()}finally{M.dispose()}}t.main=L})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/25785b97e533b15ae3b12e48aaf4187416437e62/core/vs/code/node/cliProcessMain.js.map
