/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/platform","vs/base/common/strings","vs/base/common/network","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/types","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/errors","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/base/common/resources","vs/base/node/pfs","vs/workbench/api/common/extHostInitDataService","vs/base/common/uuid","vs/platform/extensions/common/extensions","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/glob","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","fs","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostDebugService","vs/base/common/stopwatch","os","vs/editor/common/core/position","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/base/common/assert","vs/base/common/collections","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/node/processes","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/externalTerminal/node/externalTerminal","vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalProfiles","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],pe=function(Q){for(var e=[],_=0,P=Q.length;_<P;_++)e[_]=ge[Q[_]];return e};define(ge[52],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function _(P,T){if(!P)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=_}),define(ge[53],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const _=Object.prototype.hasOwnProperty;function P(R){const C=[];for(let w in R)_.call(R,w)&&C.push(R[w]);return C}e.values=P;function T(R,C){for(let w in R)if(_.call(R,w)&&C({key:w,value:R[w]},function(){delete R[w]})===!1)return}e.forEach=T;function I(R,C){const w=Object.create(null);for(const m of R){const s=C(m);let d=w[s];d||(d=w[s]=[]),d.push(m)}return w}e.groupBy=I;function D(R){const C=Object.create(null);return R&&R.forEach((w,m)=>{C[m]=w}),C}e.fromMap=D;function k(R,C){const w=[],m=[];for(let s of R)C.has(s)||w.push(s);for(let s of C)R.has(s)||m.push(s);return{removed:w,added:m}}e.diffSets=k;function y(R,C){const w=[],m=[];for(let[s,d]of R)C.has(s)||w.push(d);for(let[s,d]of C)R.has(s)||m.push(d);return{removed:w,added:m}}e.diffMaps=y;class i{constructor(){this.map=new Map}add(C,w){let m=this.map.get(C);m||(m=new Set,this.map.set(C,m)),m.add(w)}delete(C,w){const m=this.map.get(C);!m||(m.delete(w),m.size===0&&this.map.delete(C))}forEach(C,w){const m=this.map.get(C);!m||m.forEach(w)}}e.SetMap=i}),define(ge[68],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function _(y){return(i,R,C)=>{let w=null,m=null;if(typeof C.value=="function"?(w="value",m=C.value):typeof C.get=="function"&&(w="get",m=C.get),!m)throw new Error("not supported");C[w]=y(m,R)}}e.createDecorator=_;let P=0;function T(){const y=`$memoize${P++}`;let i;const R=function(w,m,s){let d=null,S=null;if(typeof s.value=="function"?(d="value",S=s.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof s.get=="function"&&(d="get",S=s.get),!S)throw new Error("not supported");const v=`${y}:${m}`;s[d]=function(...b){return i=this,this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!0,enumerable:!1,writable:!0,value:S.apply(this,b)}),this[v]}};return R.clear=()=>{typeof i!="undefined"&&Object.getOwnPropertyNames(i).forEach(C=>{C.indexOf(y)===0&&delete i[C]})},R}e.createMemoizer=T;function I(y,i,R){return T()(y,i,R)}e.memoize=I;function D(y,i,R){return _((C,w)=>{const m=`$debounce$${w}`,s=`$debounce$result$${w}`;return function(...d){this[s]||(this[s]=R?R():void 0),clearTimeout(this[m]),i&&(this[s]=i(this[s],...d),d=[this[s]]),this[m]=setTimeout(()=>{C.apply(this,d),this[s]=R?R():void 0},y)}})}e.debounce=D;function k(y,i,R){return _((C,w)=>{const m=`$throttle$timer$${w}`,s=`$throttle$result$${w}`,d=`$throttle$lastRun$${w}`,S=`$throttle$pending$${w}`;return function(...v){if(this[s]||(this[s]=R?R():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),i&&(this[s]=i(this[s],...v)),!this[S]){const b=this[d]+y;b<=Date.now()?(this[d]=Date.now(),C.apply(this,[this[s]]),this[s]=R?R():void 0):(this[S]=!0,this[m]=setTimeout(()=>{this[S]=!1,this[d]=Date.now(),C.apply(this,[this[s]]),this[s]=R?R():void 0},b-Date.now()))}}})}e.throttle=k}),define(ge[18],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class _{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=_,e.errorHandler=new _;function P(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=P;function T(c){y(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=T;function I(c){y(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=I;function D(c){if(c instanceof Error){let{name:t,message:n}=c;const o=c.stacktrace||c.stack;return{$isError:!0,name:t,message:n,stack:o}}return c}e.transformErrorForSerialization=D;const k="Canceled";function y(c){return c instanceof Error&&c.name===k&&c.message===k}e.isPromiseCanceledError=y;class i extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=i;function R(){const c=new Error(k);return c.name=c.message,c}e.canceled=R;function C(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=C;function w(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=w;function m(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function s(c){const t=new Error(`${c} has been disposed`);return t.name="DISPOSED",t}e.disposed=s;function d(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=d;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class v extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=v;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function p(c){const t=c;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=p;function u(c,t=Object.create(null)){const n=new Error(c);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=u}),define(ge[14],pe([0,1,18]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function P(F,U=0){return F[F.length-(1+U)]}e.tail=P;function T(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=T;function I(F,U,M=(N,O)=>N===O){if(F===U)return!0;if(!F||!U||F.length!==U.length)return!1;for(let N=0,O=F.length;N<O;N++)if(!M(F[N],U[N]))return!1;return!0}e.equals=I;function D(F,U,M){let N=0,O=F.length-1;for(;N<=O;){const V=(N+O)/2|0,q=M(F[V],U);if(q<0)N=V+1;else if(q>0)O=V-1;else return V}return-(N+1)}e.binarySearch=D;function k(F,U){let M=0,N=F.length;if(N===0)return 0;for(;M<N;){const O=Math.floor((M+N)/2);U(F[O])?N=O:M=O+1}return M}e.findFirstInSorted=k;function y(F,U,M){if(F=F|0,F>=U.length)throw new TypeError("invalid index");let N=U[Math.floor(U.length*Math.random())],O=[],V=[],q=[];for(let J of U){const me=M(J,N);me<0?O.push(J):me>0?V.push(J):q.push(J)}return F<O.length?y(F,O,M):F<O.length+q.length?q[0]:y(F-(O.length+q.length),V,M)}e.quickSelect=y;function i(F,U){const M=[];let N;for(const O of F.slice(0).sort(U))!N||U(N[0],O)!==0?(N=[O],M.push(N)):N.push(O);return M}e.groupBy=i;function R(F,U,M){const N=[];function O(J,me,we){if(!(me===0&&we.length===0)){const Ae=N[N.length-1];Ae&&Ae.start+Ae.deleteCount===J?(Ae.deleteCount+=me,Ae.toInsert.push(...we)):N.push({start:J,deleteCount:me,toInsert:we})}}let V=0,q=0;for(;;){if(V===F.length){O(V,0,U.slice(q));break}if(q===U.length){O(V,F.length-V,[]);break}const J=F[V],me=U[q],we=M(J,me);we===0?(V+=1,q+=1):we<0?(O(V,1,[]),V+=1):we>0&&(O(V,0,[me]),q+=1)}return N}e.sortedDiff=R;function C(F,U,M){const N=R(F,U,M),O=[],V=[];for(const q of N)O.push(...F.slice(q.start,q.start+q.deleteCount)),V.push(...q.toInsert);return{removed:O,added:V}}e.delta=C;function w(F,U,M){if(M===0)return[];const N=F.slice(0,M).sort(U);return s(F,U,N,M,F.length),N}e.top=w;function m(F,U,M,N,O){return M===0?Promise.resolve([]):new Promise((V,q)=>{(async()=>{const J=F.length,me=F.slice(0,M).sort(U);for(let we=M,Ae=Math.min(M+N,J);we<J;we=Ae,Ae=Math.min(Ae+N,J)){if(we>M&&await new Promise(Pe=>setTimeout(Pe)),O&&O.isCancellationRequested)throw(0,_.canceled)();s(F,U,me,we,Ae)}return me})().then(V,q)})}e.topAsync=m;function s(F,U,M,N,O){for(const V=M.length;N<O;N++){const q=F[N];if(U(q,M[V-1])<0){M.pop();const J=k(M,me=>U(q,me)<0);M.splice(J,0,q)}}}function d(F){return F.filter(U=>!!U)}e.coalesce=d;function S(F){let U=0;for(let M=0;M<F.length;M++)F[M]&&(F[U]=F[M],U+=1);F.length=U}e.coalesceInPlace=S;function v(F,U,M){F.splice(M,0,F.splice(U,1)[0])}e.move=v;function b(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=b;function p(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=p;function u(F,U){if(!U)return F.filter((N,O)=>F.indexOf(N)===O);const M=Object.create(null);return F.filter(N=>{const O=U(N);return M[O]?!1:(M[O]=!0,!0)})}e.distinct=u;function c(F){const U=new Set;return F.filter(M=>U.has(M)?!1:(U.add(M),!0))}e.distinctES6=c;function t(F){const U=Object.create(null);return M=>{const N=F(M);return U[N]?!1:(U[N]=!0,!0)}}e.uniqueFilter=t;function n(F,U){for(let M=F.length-1;M>=0;M--){const N=F[M];if(U(N))return M}return-1}e.lastIndex=n;function o(F,U){return F.length>0?F[0]:U}e.firstOrDefault=o;function r(F,U,M=(N,O)=>N===O){let N=0;for(let O=0,V=Math.min(F.length,U.length);O<V&&M(F[O],U[O]);O++)N++;return N}e.commonPrefixLength=r;function l(F){return[].concat(...F)}e.flatten=l;function a(F,U){let M=typeof U=="number"?F:0;typeof U=="number"?M=F:(M=0,U=F);const N=[];if(M<=U)for(let O=M;O<U;O++)N.push(O);else for(let O=M;O>U;O--)N.push(O);return N}e.range=a;function g(F,U,M){return F.reduce((N,O)=>(N[U(O)]=M?M(O):O,N),Object.create(null))}e.index=g;function E(F,U){return F.push(U),()=>f(F,U)}e.insert=E;function f(F,U){const M=F.indexOf(U);if(M>-1)return F.splice(M,1),U}e.remove=f;function h(F,U,M){const N=F.slice(0,U),O=F.slice(U);return N.concat(M,O)}e.arrayInsert=h;function A(F,U){let M;if(typeof U=="number"){let N=U;M=()=>{const O=Math.sin(N++)*179426549;return O-Math.floor(O)}}else M=Math.random;for(let N=F.length-1;N>0;N-=1){const O=Math.floor(M()*(N+1)),V=F[N];F[N]=F[O],F[O]=V}}e.shuffle=A;function L(F,U){const M=F.indexOf(U);M>-1&&(F.splice(M,1),F.unshift(U))}e.pushToStart=L;function B(F,U){const M=F.indexOf(U);M>-1&&(F.splice(M,1),F.push(U))}e.pushToEnd=B;function ee(F,U){return Array.isArray(F)?F.map(U):U(F)}e.mapArrayOrNot=ee;function j(F){return Array.isArray(F)?F:[F]}e.asArray=j;function x(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=x;function $(F,U){for(const M of F){const N=U(M);if(N!==void 0)return N}}e.mapFind=$}),define(ge[69],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function _(P){const T=this;let I=!1,D;return function(){return I||(I=!0,D=P.apply(T,arguments)),D}}e.once=_}),define(ge[70],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class _{constructor(T){this._prefix=T,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=_,e.defaultGenerator=new _("id#")}),define(ge[71],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var _;(function(P){function T(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}P.is=T;const I=Object.freeze([]);function D(){return I}P.empty=D;function*k(c){yield c}P.single=k;function y(c){return c||I}P.from=y;function i(c){return!c||c[Symbol.iterator]().next().done===!0}P.isEmpty=i;function R(c){return c[Symbol.iterator]().next().value}P.first=R;function C(c,t){for(const n of c)if(t(n))return!0;return!1}P.some=C;function w(c,t){for(const n of c)if(t(n))return n}P.find=w;function*m(c,t){for(const n of c)t(n)&&(yield n)}P.filter=m;function*s(c,t){for(const n of c)yield t(n)}P.map=s;function*d(...c){for(const t of c)for(const n of t)yield n}P.concat=d;function*S(c){for(const t of c)for(const n of t)yield n}P.concatNested=S;function v(c,t,n){let o=n;for(const r of c)o=t(o,r);return o}P.reduce=v;function*b(c,t,n=c.length){for(t<0&&(t+=c.length),n<0?n+=c.length:n>c.length&&(n=c.length);t<n;t++)yield c[t]}P.slice=b;function p(c,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,c];const o=c[Symbol.iterator]();for(let r=0;r<t;r++){const l=o.next();if(l.done)return[n,P.empty()];n.push(l.value)}return[n,{[Symbol.iterator](){return o}}]}P.consume=p;function u(c,t,n=(o,r)=>o===r){const o=c[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const l=o.next(),a=r.next();if(l.done!==a.done)return!1;if(l.done)return!0;if(!n(l.value,a.value))return!1}}P.equals=u})(_=e.Iterable||(e.Iterable={}))}),define(ge[54],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var _;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(_=e.ScanError||(e.ScanError={}));var P;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(P=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var I;(function(t){t.DEFAULT={allowTrailingComma:!0}})(I=e.ParseOptions||(e.ParseOptions={}));function D(t,n=!1){let o=0,r=t.length,l="",a=0,g=16,E=0;function f(x){let $=0,F=0;for(;$<x;){const U=t.charCodeAt(o);if(U>=48&&U<=57)F=F*16+U-48;else if(U>=65&&U<=70)F=F*16+U-65+10;else if(U>=97&&U<=102)F=F*16+U-97+10;else break;o++,$++}return $<x&&(F=-1),F}function h(x){o=x,l="",a=0,g=16,E=0}function A(){const x=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&i(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&i(t.charCodeAt(o)))for(o++;o<t.length&&i(t.charCodeAt(o));)o++;else return E=3,t.substring(x,o);let $=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&i(t.charCodeAt(o))){for(o++;o<t.length&&i(t.charCodeAt(o));)o++;$=o}else E=3;return t.substring(x,$)}function L(){let x="",$=o;for(;;){if(o>=r){x+=t.substring($,o),E=2;break}const F=t.charCodeAt(o);if(F===34){x+=t.substring($,o),o++;break}if(F===92){if(x+=t.substring($,o),o++,o>=r){E=2;break}switch(t.charCodeAt(o++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const M=f(4);M>=0?x+=String.fromCharCode(M):E=4;break;default:E=5}$=o;continue}if(F>=0&&F<=31)if(y(F)){x+=t.substring($,o),E=2;break}else E=6;o++}return x}function B(){if(l="",E=0,a=o,o>=r)return a=r,g=17;let x=t.charCodeAt(o);if(k(x)){do o++,l+=String.fromCharCode(x),x=t.charCodeAt(o);while(k(x));return g=15}if(y(x))return o++,l+=String.fromCharCode(x),x===13&&t.charCodeAt(o)===10&&(o++,l+=`
`),g=14;switch(x){case 123:return o++,g=1;case 125:return o++,g=2;case 91:return o++,g=3;case 93:return o++,g=4;case 58:return o++,g=6;case 44:return o++,g=5;case 34:return o++,l=L(),g=10;case 47:const $=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<r&&!y(t.charCodeAt(o));)o++;return l=t.substring($,o),g=12}if(t.charCodeAt(o+1)===42){o+=2;const F=r-1;let U=!1;for(;o<F;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,U=!0;break}o++}return U||(o++,E=1),l=t.substring($,o),g=13}return l+=String.fromCharCode(x),o++,g=16;case 45:if(l+=String.fromCharCode(x),o++,o===r||!i(t.charCodeAt(o)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=A(),g=11;default:for(;o<r&&ee(x);)o++,x=t.charCodeAt(o);if(a!==o){switch(l=t.substring(a,o),l){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return l+=String.fromCharCode(x),o++,g=16}}function ee(x){if(k(x)||y(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let x;do x=B();while(x>=12&&x<=15);return x}return{setPosition:h,getPosition:()=>o,scan:n?j:B,getToken:()=>g,getTokenValue:()=>l,getTokenOffset:()=>a,getTokenLength:()=>o-a,getTokenError:()=>E}}e.createScanner=D;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function i(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function C(t,n){const o=[],r=new Object;let l;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function E(f,h,A,L){a.value=f,a.offset=h,a.length=A,a.type=L,a.colonOffset=void 0,l=a}try{p(t,{onObjectBegin:(f,h)=>{if(n<=f)throw r;l=void 0,g=n>f,o.push("")},onObjectProperty:(f,h,A)=>{if(n<h||(E(f,h,A,"property"),o[o.length-1]=f,n<=h+A))throw r},onObjectEnd:(f,h)=>{if(n<=f)throw r;l=void 0,o.pop()},onArrayBegin:(f,h)=>{if(n<=f)throw r;l=void 0,o.push(0)},onArrayEnd:(f,h)=>{if(n<=f)throw r;l=void 0,o.pop()},onLiteralValue:(f,h,A)=>{if(n<h||(E(f,h,A,c(f)),n<=h+A))throw r},onSeparator:(f,h,A)=>{if(n<=h)throw r;if(f===":"&&l&&l.type==="property")l.colonOffset=h,g=!1,l=void 0;else if(f===","){const L=o[o.length-1];typeof L=="number"?o[o.length-1]=L+1:(g=!0,o[o.length-1]=""),l=void 0}}})}catch(f){if(f!==r)throw f}return{path:o,previousNode:l,isAtPropertyKey:g,matches:f=>{let h=0;for(let A=0;h<f.length&&A<o.length;A++)if(f[h]===o[A]||f[h]==="*")h++;else if(f[h]!=="**")return!1;return h===f.length}}}e.getLocation=C;function w(t,n=[],o=I.DEFAULT){let r=null,l=[];const a=[];function g(f){Array.isArray(l)?l.push(f):r!==null&&(l[r]=f)}return p(t,{onObjectBegin:()=>{const f={};g(f),a.push(l),l=f,r=null},onObjectProperty:f=>{r=f},onObjectEnd:()=>{l=a.pop()},onArrayBegin:()=>{const f=[];g(f),a.push(l),l=f,r=null},onArrayEnd:()=>{l=a.pop()},onLiteralValue:g,onError:(f,h,A)=>{n.push({error:f,offset:h,length:A})}},o),l[0]}e.parse=w;function m(t,n=[],o=I.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(f){r.type==="property"&&(r.length=f-r.offset,r=r.parent)}function a(f){return r.children.push(f),f}p(t,{onObjectBegin:f=>{r=a({type:"object",offset:f,length:-1,parent:r,children:[]})},onObjectProperty:(f,h,A)=>{r=a({type:"property",offset:h,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:f,offset:h,length:A,parent:r})},onObjectEnd:(f,h)=>{r.length=f+h-r.offset,r=r.parent,l(f+h)},onArrayBegin:(f,h)=>{r=a({type:"array",offset:f,length:-1,parent:r,children:[]})},onArrayEnd:(f,h)=>{r.length=f+h-r.offset,r=r.parent,l(f+h)},onLiteralValue:(f,h,A)=>{a({type:c(f),offset:h,length:A,parent:r,value:f}),l(h+A)},onSeparator:(f,h,A)=>{r.type==="property"&&(f===":"?r.colonOffset=h:f===","&&l(h))},onError:(f,h,A)=>{n.push({error:f,offset:h,length:A})}},o);const E=r.children[0];return E&&delete E.parent,E}e.parseTree=m;function s(t,n){if(!!t){let o=t;for(let r of n)if(typeof r=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let l=!1;for(const a of o.children)if(Array.isArray(a.children)&&a.children[0].value===r){o=a.children[1],l=!0;break}if(!l)return}else{const l=r;if(o.type!=="array"||l<0||!Array.isArray(o.children)||l>=o.children.length)return;o=o.children[l]}return o}}e.findNodeAtLocation=s;function d(t){if(!t.parent||!t.parent.children)return[];const n=d(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;n.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&n.push(o)}return n}e.getNodePath=d;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const n=Object.create(null);for(let o of t.children){const r=o.children[1];r&&(n[o.children[0].value]=S(r))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function v(t,n,o=!1){return n>=t.offset&&n<t.offset+t.length||o&&n===t.offset+t.length}e.contains=v;function b(t,n,o=!1){if(v(t,n,o)){const r=t.children;if(Array.isArray(r))for(let l=0;l<r.length&&r[l].offset<=n;l++){const a=b(r[l],n,o);if(a)return a}return t}}e.findNodeAtOffset=b;function p(t,n,o=I.DEFAULT){const r=D(t,!1);function l(me){return me?()=>me(r.getTokenOffset(),r.getTokenLength()):()=>!0}function a(me){return me?we=>me(we,r.getTokenOffset(),r.getTokenLength()):()=>!0}const g=l(n.onObjectBegin),E=a(n.onObjectProperty),f=l(n.onObjectEnd),h=l(n.onArrayBegin),A=l(n.onArrayEnd),L=a(n.onLiteralValue),B=a(n.onSeparator),ee=l(n.onComment),j=a(n.onError),x=o&&o.disallowComments,$=o&&o.allowTrailingComma;function F(){for(;;){const me=r.scan();switch(r.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:x||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(me){case 12:case 13:x?U(10):ee();break;case 16:U(1);break;case 15:case 14:break;default:return me}}}function U(me,we=[],Ae=[]){if(j(me),we.length+Ae.length>0){let Pe=r.getToken();for(;Pe!==17;){if(we.indexOf(Pe)!==-1){F();break}else if(Ae.indexOf(Pe)!==-1)break;Pe=F()}}}function M(me){const we=r.getTokenValue();return me?L(we):E(we),F(),!0}function N(){switch(r.getToken()){case 11:let me=0;try{me=JSON.parse(r.getTokenValue()),typeof me!="number"&&(U(2),me=0)}catch(we){U(2)}L(me);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return F(),!0}function O(){return r.getToken()!==10?(U(3,[],[2,5]),!1):(M(!1),r.getToken()===6?(B(":"),F(),J()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function V(){g(),F();let me=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(me||U(4,[],[]),B(","),F(),r.getToken()===2&&$)break}else me&&U(6,[],[]);O()||U(4,[],[2,5]),me=!0}return f(),r.getToken()!==2?U(7,[2],[]):F(),!0}function q(){h(),F();let me=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(me||U(4,[],[]),B(","),F(),r.getToken()===4&&$)break}else me&&U(6,[],[]);J()||U(4,[],[4,5]),me=!0}return A(),r.getToken()!==4?U(8,[4],[]):F(),!0}function J(){switch(r.getToken()){case 3:return q();case 1:return V();case 10:return M(!0);default:return N()}}return F(),r.getToken()===17?o.allowEmptyContent?!0:(U(4,[],[]),!1):J()?(r.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=p;function u(t,n){let o=D(t),r=[],l,a=0,g;do switch(g=o.getPosition(),l=o.scan(),l){case 12:case 13:case 17:a!==g&&r.push(t.substring(a,g)),n!==void 0&&r.push(o.getTokenValue().replace(/[^\r\n]/g,n)),a=o.getPosition();break}while(l!==17);return r.join("")}e.stripComments=u;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(ge[131],pe([0,1,54]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function P(y,i,R){let C,w,m,s,d;if(i){for(s=i.offset,d=s+i.length,m=s;m>0&&!k(y,m-1);)m--;let a=d;for(;a<y.length&&!k(y,a);)a++;w=y.substring(m,a),C=I(w,R)}else w=y,C=0,m=0,s=0,d=y.length;const S=D(R,y);let v=!1,b=0,p;R.insertSpaces?p=T(" ",R.tabSize||4):p="	";const u=(0,_.createScanner)(w,!1);let c=!1;function t(){return S+T(p,C+b)}function n(){let a=u.scan();for(v=!1;a===15||a===14;)v=v||a===14,a=u.scan();return c=a===16||u.getTokenError()!==0,a}const o=[];function r(a,g,E){!c&&g<d&&E>s&&y.substring(g,E)!==a&&o.push({offset:g,length:E-g,content:a})}let l=n();if(l!==17){const a=u.getTokenOffset()+m,g=T(p,C);r(g,m,a)}for(;l!==17;){let a=u.getTokenOffset()+u.getTokenLength()+m,g=n(),E="";for(;!v&&(g===12||g===13);){const h=u.getTokenOffset()+m;r(" ",a,h),a=u.getTokenOffset()+u.getTokenLength()+m,E=g===12?t():"",g=n()}if(g===2)l!==1&&(b--,E=t());else if(g===4)l!==3&&(b--,E=t());else{switch(l){case 3:case 1:b++,E=t();break;case 5:case 12:E=t();break;case 13:v?E=t():E=" ";break;case 6:E=" ";break;case 10:if(g===6){E="";break}case 7:case 8:case 9:case 11:case 2:case 4:g===12||g===13?E=" ":g!==5&&g!==17&&(c=!0);break;case 16:c=!0;break}v&&(g===12||g===13)&&(E=t())}const f=u.getTokenOffset()+m;r(E,a,f),l=g}return o}e.format=P;function T(y,i){let R="";for(let C=0;C<i;C++)R+=y;return R}function I(y,i){let R=0,C=0;const w=i.tabSize||4;for(;R<y.length;){const m=y.charAt(R);if(m===" ")C++;else if(m==="	")C+=w;else break;R++}return Math.floor(C/w)}function D(y,i){for(let R=0;R<i.length;R++){const C=i.charAt(R);if(C==="\r")return R+1<i.length&&i.charAt(R+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=D;function k(y,i){return`\r
`.indexOf(y.charAt(i))!==-1}e.isEOL=k}),define(ge[132],pe([0,1,54,131]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(i,R,C){return I(i,R,void 0,C)}e.removeProperty=T;function I(i,R,C,w,m){const s=R.slice(),d=[],S=(0,_.parseTree)(i,d);let v,b;for(;s.length>0&&(b=s.pop(),v=(0,_.findNodeAtLocation)(S,s),v===void 0&&C!==void 0);)typeof b=="string"?C={[b]:C}:C=[C];if(v)if(v.type==="object"&&typeof b=="string"&&Array.isArray(v.children)){const p=(0,_.findNodeAtLocation)(v,[b]);if(p!==void 0)if(C===void 0){if(!p.parent)throw new Error("Malformed AST");const u=v.children.indexOf(p.parent);let c,t=p.parent.offset+p.parent.length;if(u>0){const n=v.children[u-1];c=n.offset+n.length}else c=v.offset+1,v.children.length>1&&(t=v.children[1].offset);return D(i,{offset:c,length:t-c,content:""},w)}else return D(i,{offset:p.offset,length:p.length,content:JSON.stringify(C)},w);else{if(C===void 0)return[];const u=`${JSON.stringify(b)}: ${JSON.stringify(C)}`,c=m?m(v.children.map(n=>n.children[0].value)):v.children.length;let t;if(c>0){const n=v.children[c-1];t={offset:n.offset+n.length,length:0,content:","+u}}else v.children.length===0?t={offset:v.offset+1,length:0,content:u}:t={offset:v.offset+1,length:0,content:u+","};return D(i,t,w)}}else if(v.type==="array"&&typeof b=="number"&&Array.isArray(v.children))if(C!==void 0){const p=`${JSON.stringify(C)}`;let u;if(v.children.length===0||b===0)u={offset:v.offset+1,length:0,content:v.children.length===0?p:p+","};else{const c=b===-1||b>v.children.length?v.children.length:b,t=v.children[c-1];u={offset:t.offset+t.length,length:0,content:","+p}}return D(i,u,w)}else{const p=b,u=v.children[p];let c;if(v.children.length===1)c={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===p){const t=v.children[p-1],n=t.offset+t.length,o=v.offset+v.length;c={offset:n,length:o-2-n,content:""}}else c={offset:u.offset,length:v.children[p+1].offset-u.offset,content:""};return D(i,c,w)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${v.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return D(i,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(C)},w)}}e.setProperty=I;function D(i,R,C){let w=k(i,R),m=R.offset,s=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;m>0&&!(0,P.isEOL)(w,m-1);)m--;for(;s<w.length&&!(0,P.isEOL)(w,s);)s++}const d=(0,P.format)(w,{offset:m,length:s-m},C);for(let v=d.length-1;v>=0;v--){const b=d[v];w=k(w,b),m=Math.min(m,b.offset),s=Math.max(s,b.offset+b.length),s+=b.content.length-b.length}const S=i.length-(w.length-s)-m;return[{offset:m,length:S,content:w.substring(m,s)}]}e.withFormatting=D;function k(i,R){return i.substring(0,R.offset)+R.content+i.substring(R.offset+R.length)}e.applyEdit=k;function y(i,R){let C=R.slice(0).sort((m,s)=>{const d=m.offset-s.offset;return d===0?m.length-s.length:d}),w=i.length;for(let m=C.length-1;m>=0;m--){let s=C[m];if(s.offset+s.length<=w)i=k(i,s);else throw new Error("Overlapping edit");w=s.offset}return i}e.applyEdits=y}),define(ge[133],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class _{constructor(T){this.executor=T,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(T){return new _(()=>T(this.getValue()))}}e.Lazy=_}),define(ge[6],pe([0,1,69,71]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const T=!1;let I=null;function D(p){I=p}if(e.setDisposableTracker=D,T){const p="__is_disposable_tracked__";I=new class{trackDisposable(u){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[p]||console.log(c)},3e3)}markTracked(u){if(u&&u!==d.None)try{u[p]=!0}catch(c){}}}}function k(p){!I||I.markTracked(p)}function y(p){return I&&I.trackDisposable(p),p}e.trackDisposable=y;class i extends Error{constructor(u){super(`Encountered errors while disposing of store. Errors: [${u.join(", ")}]`);this.errors=u}}e.MultiDisposeError=i;function R(p){return typeof p.dispose=="function"&&p.dispose.length===0}e.isDisposable=R;function C(p){if(P.Iterable.is(p)){let u=[];for(const c of p)if(c){k(c);try{c.dispose()}catch(t){u.push(t)}}if(u.length===1)throw u[0];if(u.length>1)throw new i(u);return Array.isArray(p)?[]:p}else if(p)return k(p),p.dispose(),p}e.dispose=C;function w(...p){return p.forEach(k),m(()=>C(p))}e.combinedDisposable=w;function m(p){const u=y({dispose:()=>{k(u),p()}});return u}e.toDisposable=m;class s{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(k(this),this._isDisposed=!0,this.clear())}clear(){try{C(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return k(u),this._isDisposed?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=s,s.DISABLE_DISPOSED_WARNING=!1;class d{constructor(){this._store=new s,y(this)}dispose(){k(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=d,d.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){var c;this._isDisposed||u===this._value||((c=this._value)===null||c===void 0||c.dispose(),u&&k(u),this._value=u)}clear(){this.value=void 0}dispose(){var u;this._isDisposed=!0,k(this),(u=this._value)===null||u===void 0||u.dispose(),this._value=void 0}}e.MutableDisposable=S;class v{constructor(){this.references=new Map}acquire(u,...c){let t=this.references.get(u);t||(t={counter:0,object:this.createReferencedObject(u,...c)},this.references.set(u,t));const{object:n}=t,o=(0,_.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(u,t.object),this.references.delete(u))});return t.counter++,{object:n,dispose:o}}}e.ReferenceCollection=v;class b{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=b}),define(ge[55],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class _{constructor(I){this.element=I,this.next=_.Undefined,this.prev=_.Undefined}}_.Undefined=new _(void 0);class P{constructor(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===_.Undefined}clear(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}unshift(I){return this._insert(I,!1)}push(I){return this._insert(I,!0)}_insert(I,D){const k=new _(I);if(this._first===_.Undefined)this._first=k,this._last=k;else if(D){const i=this._last;this._last=k,k.prev=i,i.next=k}else{const i=this._first;this._first=k,k.next=i,i.prev=k}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(k))}}shift(){if(this._first!==_.Undefined){const I=this._first.element;return this._remove(this._first),I}}pop(){if(this._last!==_.Undefined){const I=this._last.element;return this._remove(this._last),I}}_remove(I){if(I.prev!==_.Undefined&&I.next!==_.Undefined){const D=I.prev;D.next=I.next,I.next.prev=D}else I.prev===_.Undefined&&I.next===_.Undefined?(this._first=_.Undefined,this._last=_.Undefined):I.next===_.Undefined?(this._last=this._last.prev,this._last.next=_.Undefined):I.prev===_.Undefined&&(this._first=this._first.next,this._first.prev=_.Undefined);this._size-=1}*[Symbol.iterator](){let I=this._first;for(;I!==_.Undefined;)yield I.element,I=I.next}}e.LinkedList=P}),function(Q,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Q=typeof globalThis!="undefined"?globalThis:Q||self,Q.marked=e())}(this,function(){"use strict";function Q(K,oe){for(var he=0;he<oe.length;he++){var Z=oe[he];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(K,Z.key,Z)}}function e(K,oe,he){return oe&&Q(K.prototype,oe),he&&Q(K,he),K}function _(K,oe){if(!!K){if(typeof K=="string")return P(K,oe);var he=Object.prototype.toString.call(K).slice(8,-1);if(he==="Object"&&K.constructor&&(he=K.constructor.name),he==="Map"||he==="Set")return Array.from(K);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return P(K,oe)}}function P(K,oe){(oe==null||oe>K.length)&&(oe=K.length);for(var he=0,Z=new Array(oe);he<oe;he++)Z[he]=K[he];return Z}function T(K,oe){var he;if(typeof Symbol=="undefined"||K[Symbol.iterator]==null){if(Array.isArray(K)||(he=_(K))||oe&&K&&typeof K.length=="number"){he&&(K=he);var Z=0;return function(){return Z>=K.length?{done:!0}:{done:!1,value:K[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return he=K[Symbol.iterator](),he.next.bind(he)}function I(K){var oe={exports:{}};return K(oe,oe.exports),oe.exports}var D=I(function(K){function oe(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function he(Z){K.exports.defaults=Z}K.exports={defaults:oe(),getDefaults:oe,changeDefaults:he}}),k=/[&<>"']/,y=/[&<>"']/g,i=/[<>"']|&(?!#?\w+;)/,R=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(oe){return C[oe]};function m(K,oe){if(oe){if(k.test(K))return K.replace(y,w)}else if(i.test(K))return K.replace(R,w);return K}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(K){return K.replace(s,function(oe,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var S=/(^|[^\[])\^/g;function v(K,oe){K=K.source||K,oe=oe||"";var he={replace:function(ie,le){return le=le.source||le,le=le.replace(S,"$1"),K=K.replace(ie,le),he},getRegex:function(){return new RegExp(K,oe)}};return he}var b=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(K,oe,he){if(K){var Z;try{Z=decodeURIComponent(d(he)).replace(b,"").toLowerCase()}catch(ie){return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}oe&&!p.test(he)&&(he=r(oe,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch(ie){return null}return he}var c={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(K,oe){c[" "+K]||(t.test(K)?c[" "+K]=K+"/":c[" "+K]=E(K,"/",!0)),K=c[" "+K];var he=K.indexOf(":")===-1;return oe.substring(0,2)==="//"?he?oe:K.replace(n,"$1")+oe:oe.charAt(0)==="/"?he?oe:K.replace(o,"$1")+oe:K+oe}var l={exec:function(){}};function a(K){for(var oe=1,he,Z;oe<arguments.length;oe++){he=arguments[oe];for(Z in he)Object.prototype.hasOwnProperty.call(he,Z)&&(K[Z]=he[Z])}return K}function g(K,oe){var he=K.replace(/\|/g,function(le,ve,ye){for(var We=!1,Oe=ve;--Oe>=0&&ye[Oe]==="\\";)We=!We;return We?"|":" |"}),Z=he.split(/ \|/),ie=0;if(Z.length>oe)Z.splice(oe);else for(;Z.length<oe;)Z.push("");for(;ie<Z.length;ie++)Z[ie]=Z[ie].trim().replace(/\\\|/g,"|");return Z}function E(K,oe,he){var Z=K.length;if(Z===0)return"";for(var ie=0;ie<Z;){var le=K.charAt(Z-ie-1);if(le===oe&&!he)ie++;else if(le!==oe&&he)ie++;else break}return K.substr(0,Z-ie)}function f(K,oe){if(K.indexOf(oe[1])===-1)return-1;for(var he=K.length,Z=0,ie=0;ie<he;ie++)if(K[ie]==="\\")ie++;else if(K[ie]===oe[0])Z++;else if(K[ie]===oe[1]&&(Z--,Z<0))return ie;return-1}function h(K){K&&K.sanitize&&!K.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(K,oe){if(oe<1)return"";for(var he="";oe>1;)oe&1&&(he+=K),oe>>=1,K+=K;return he+K}var L={escape:m,unescape:d,edit:v,cleanUrl:u,resolveUrl:r,noopTest:l,merge:a,splitCells:g,rtrim:E,findClosingBracket:f,checkSanitizeDeprecation:h,repeatString:A},B=D.defaults,ee=L.rtrim,j=L.splitCells,x=L.escape,$=L.findClosingBracket;function F(K,oe,he){var Z=oe.href,ie=oe.title?x(oe.title):null,le=K[1].replace(/\\([\[\]])/g,"$1");return K[0].charAt(0)!=="!"?{type:"link",raw:he,href:Z,title:ie,text:le}:{type:"image",raw:he,href:Z,title:ie,text:x(le)}}function U(K,oe){var he=K.match(/^(\s+)(?:```)/);if(he===null)return oe;var Z=he[1];return oe.split(`
`).map(function(ie){var le=ie.match(/^\s+/);if(le===null)return ie;var ve=le[0];return ve.length>=Z.length?ie.slice(Z.length):ie}).join(`
`)}var M=function(){function K(he){this.options=he||B}var oe=K.prototype;return oe.space=function(Z){var ie=this.rules.block.newline.exec(Z);if(ie)return ie[0].length>1?{type:"space",raw:ie[0]}:{raw:`
`}},oe.code=function(Z){var ie=this.rules.block.code.exec(Z);if(ie){var le=ie[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ie[0],codeBlockStyle:"indented",text:this.options.pedantic?le:ee(le,`
`)}}},oe.fences=function(Z){var ie=this.rules.block.fences.exec(Z);if(ie){var le=ie[0],ve=U(le,ie[3]||"");return{type:"code",raw:le,lang:ie[2]?ie[2].trim():ie[2],text:ve}}},oe.heading=function(Z){var ie=this.rules.block.heading.exec(Z);if(ie){var le=ie[2].trim();if(/#$/.test(le)){var ve=ee(le,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(le=ve.trim())}return{type:"heading",raw:ie[0],depth:ie[1].length,text:le}}},oe.nptable=function(Z){var ie=this.rules.block.nptable.exec(Z);if(ie){var le={type:"table",header:j(ie[1].replace(/^ *| *\| *$/g,"")),align:ie[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ie[3]?ie[3].replace(/\n$/,"").split(`
`):[],raw:ie[0]};if(le.header.length===le.align.length){var ve=le.align.length,ye;for(ye=0;ye<ve;ye++)/^ *-+: *$/.test(le.align[ye])?le.align[ye]="right":/^ *:-+: *$/.test(le.align[ye])?le.align[ye]="center":/^ *:-+ *$/.test(le.align[ye])?le.align[ye]="left":le.align[ye]=null;for(ve=le.cells.length,ye=0;ye<ve;ye++)le.cells[ye]=j(le.cells[ye],le.header.length);return le}}},oe.hr=function(Z){var ie=this.rules.block.hr.exec(Z);if(ie)return{type:"hr",raw:ie[0]}},oe.blockquote=function(Z){var ie=this.rules.block.blockquote.exec(Z);if(ie){var le=ie[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ie[0],text:le}}},oe.list=function(Z){var ie=this.rules.block.list.exec(Z);if(ie){var le=ie[0],ve=ie[2],ye=ve.length>1,We={type:"list",raw:le,ordered:ye,start:ye?+ve.slice(0,-1):"",loose:!1,items:[]},Oe=ie[0].match(this.rules.block.item),qe=!1,Ye,tt,nt,rt,it,gt,ue,Ce,ce=Oe.length;nt=this.rules.block.listItemStart.exec(Oe[0]);for(var G=0;G<ce;G++){if(Ye=Oe[G],le=Ye,G!==ce-1){if(rt=this.rules.block.listItemStart.exec(Oe[G+1]),this.options.pedantic?rt[1].length>nt[1].length:rt[1].length>nt[0].length||rt[1].length>3){Oe.splice(G,2,Oe[G]+`
`+Oe[G+1]),G--,ce--;continue}else(!this.options.pedantic||this.options.smartLists?rt[2][rt[2].length-1]!==ve[ve.length-1]:ye===(rt[2].length===1))&&(it=Oe.slice(G+1).join(`
`),We.raw=We.raw.substring(0,We.raw.length-it.length),G=ce-1);nt=rt}tt=Ye.length,Ye=Ye.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ye.indexOf(`
 `)&&(tt-=Ye.length,Ye=this.options.pedantic?Ye.replace(/^ {1,4}/gm,""):Ye.replace(new RegExp("^ {1,"+tt+"}","gm"),"")),gt=qe||/\n\n(?!\s*$)/.test(Ye),G!==ce-1&&(qe=Ye.charAt(Ye.length-1)===`
`,gt||(gt=qe)),gt&&(We.loose=!0),this.options.gfm&&(ue=/^\[[ xX]\] /.test(Ye),Ce=void 0,ue&&(Ce=Ye[1]!==" ",Ye=Ye.replace(/^\[[ xX]\] +/,""))),We.items.push({type:"list_item",raw:le,task:ue,checked:Ce,loose:gt,text:Ye})}return We}},oe.html=function(Z){var ie=this.rules.block.html.exec(Z);if(ie)return{type:this.options.sanitize?"paragraph":"html",raw:ie[0],pre:!this.options.sanitizer&&(ie[1]==="pre"||ie[1]==="script"||ie[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):x(ie[0]):ie[0]}},oe.def=function(Z){var ie=this.rules.block.def.exec(Z);if(ie){ie[3]&&(ie[3]=ie[3].substring(1,ie[3].length-1));var le=ie[1].toLowerCase().replace(/\s+/g," ");return{tag:le,raw:ie[0],href:ie[2],title:ie[3]}}},oe.table=function(Z){var ie=this.rules.block.table.exec(Z);if(ie){var le={type:"table",header:j(ie[1].replace(/^ *| *\| *$/g,"")),align:ie[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ie[3]?ie[3].replace(/\n$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=ie[0];var ve=le.align.length,ye;for(ye=0;ye<ve;ye++)/^ *-+: *$/.test(le.align[ye])?le.align[ye]="right":/^ *:-+: *$/.test(le.align[ye])?le.align[ye]="center":/^ *:-+ *$/.test(le.align[ye])?le.align[ye]="left":le.align[ye]=null;for(ve=le.cells.length,ye=0;ye<ve;ye++)le.cells[ye]=j(le.cells[ye].replace(/^ *\| *| *\| *$/g,""),le.header.length);return le}}},oe.lheading=function(Z){var ie=this.rules.block.lheading.exec(Z);if(ie)return{type:"heading",raw:ie[0],depth:ie[2].charAt(0)==="="?1:2,text:ie[1]}},oe.paragraph=function(Z){var ie=this.rules.block.paragraph.exec(Z);if(ie)return{type:"paragraph",raw:ie[0],text:ie[1].charAt(ie[1].length-1)===`
`?ie[1].slice(0,-1):ie[1]}},oe.text=function(Z){var ie=this.rules.block.text.exec(Z);if(ie)return{type:"text",raw:ie[0],text:ie[0]}},oe.escape=function(Z){var ie=this.rules.inline.escape.exec(Z);if(ie)return{type:"escape",raw:ie[0],text:x(ie[1])}},oe.tag=function(Z,ie,le){var ve=this.rules.inline.tag.exec(Z);if(ve)return!ie&&/^<a /i.test(ve[0])?ie=!0:ie&&/^<\/a>/i.test(ve[0])&&(ie=!1),!le&&/^<(pre|code|kbd|script)(\s|>)/i.test(ve[0])?le=!0:le&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ve[0])&&(le=!1),{type:this.options.sanitize?"text":"html",raw:ve[0],inLink:ie,inRawBlock:le,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ve[0]):x(ve[0]):ve[0]}},oe.link=function(Z){var ie=this.rules.inline.link.exec(Z);if(ie){var le=ie[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var ve=ee(le.slice(0,-1),"\\");if((le.length-ve.length)%2==0)return}else{var ye=$(ie[2],"()");if(ye>-1){var We=ie[0].indexOf("!")===0?5:4,Oe=We+ie[1].length+ye;ie[2]=ie[2].substring(0,ye),ie[0]=ie[0].substring(0,Oe).trim(),ie[3]=""}}var qe=ie[2],Ye="";if(this.options.pedantic){var tt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(qe);tt&&(qe=tt[1],Ye=tt[3])}else Ye=ie[3]?ie[3].slice(1,-1):"";return qe=qe.trim(),/^</.test(qe)&&(this.options.pedantic&&!/>$/.test(le)?qe=qe.slice(1):qe=qe.slice(1,-1)),F(ie,{href:qe&&qe.replace(this.rules.inline._escapes,"$1"),title:Ye&&Ye.replace(this.rules.inline._escapes,"$1")},ie[0])}},oe.reflink=function(Z,ie){var le;if((le=this.rules.inline.reflink.exec(Z))||(le=this.rules.inline.nolink.exec(Z))){var ve=(le[2]||le[1]).replace(/\s+/g," ");if(ve=ie[ve.toLowerCase()],!ve||!ve.href){var ye=le[0].charAt(0);return{type:"text",raw:ye,text:ye}}return F(le,ve,le[0])}},oe.emStrong=function(Z,ie,le){le===void 0&&(le="");var ve=this.rules.inline.emStrong.lDelim.exec(Z);if(!!ve&&!(ve[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ye=ve[1]||ve[2]||"";if(!ye||ye&&(le===""||this.rules.inline.punctuation.exec(le))){var We=ve[0].length-1,Oe,qe,Ye=We,tt=0,nt=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(nt.lastIndex=0,ie=ie.slice(-1*Z.length+We);(ve=nt.exec(ie))!=null;)if(Oe=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!Oe){if(qe=Oe.length,ve[3]||ve[4]){Ye+=qe;continue}else if((ve[5]||ve[6])&&We%3&&!((We+qe)%3)){tt+=qe;continue}if(Ye-=qe,!(Ye>0)){if(Ye+tt-qe<=0&&!ie.slice(nt.lastIndex).match(nt)&&(qe=Math.min(qe,qe+Ye+tt)),Math.min(We,qe)%2)return{type:"em",raw:Z.slice(0,We+ve.index+qe+1),text:Z.slice(1,We+ve.index+qe)};if(Math.min(We,qe)%2==0)return{type:"strong",raw:Z.slice(0,We+ve.index+qe+1),text:Z.slice(2,We+ve.index+qe-1)}}}}}},oe.codespan=function(Z){var ie=this.rules.inline.code.exec(Z);if(ie){var le=ie[2].replace(/\n/g," "),ve=/[^ ]/.test(le),ye=/^ /.test(le)&&/ $/.test(le);return ve&&ye&&(le=le.substring(1,le.length-1)),le=x(le,!0),{type:"codespan",raw:ie[0],text:le}}},oe.br=function(Z){var ie=this.rules.inline.br.exec(Z);if(ie)return{type:"br",raw:ie[0]}},oe.del=function(Z){var ie=this.rules.inline.del.exec(Z);if(ie)return{type:"del",raw:ie[0],text:ie[2]}},oe.autolink=function(Z,ie){var le=this.rules.inline.autolink.exec(Z);if(le){var ve,ye;return le[2]==="@"?(ve=x(this.options.mangle?ie(le[1]):le[1]),ye="mailto:"+ve):(ve=x(le[1]),ye=ve),{type:"link",raw:le[0],text:ve,href:ye,tokens:[{type:"text",raw:ve,text:ve}]}}},oe.url=function(Z,ie){var le;if(le=this.rules.inline.url.exec(Z)){var ve,ye;if(le[2]==="@")ve=x(this.options.mangle?ie(le[0]):le[0]),ye="mailto:"+ve;else{var We;do We=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(We!==le[0]);ve=x(le[0]),le[1]==="www."?ye="http://"+ve:ye=ve}return{type:"link",raw:le[0],text:ve,href:ye,tokens:[{type:"text",raw:ve,text:ve}]}}},oe.inlineText=function(Z,ie,le){var ve=this.rules.inline.text.exec(Z);if(ve){var ye;return ie?ye=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ve[0]):x(ve[0]):ve[0]:ye=x(this.options.smartypants?le(ve[0]):ve[0]),{type:"text",raw:ve[0],text:ye}}},K}(),N=L.noopTest,O=L.edit,V=L.merge,q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:N,table:N,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=O(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,q.item=O(q.item,"gm").replace(/bull/g,q.bullet).getRegex(),q.listItemStart=O(/^( *)(bull)/).replace("bull",q.bullet).getRegex(),q.list=O(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=O(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=O(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.blockquote=O(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=V({},q),q.gfm=V({},q.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.nptable=O(q.gfm.nptable).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.gfm.table=O(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.pedantic=V({},q.normal,{html:O(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:N,paragraph:O(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var J={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:N,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:N,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};J._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",J.punctuation=O(J.punctuation).replace(/punctuation/g,J._punctuation).getRegex(),J.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,J.escapedEmSt=/\\\*|\\_/g,J._comment=O(q._comment).replace("(?:-->|$)","-->").getRegex(),J.emStrong.lDelim=O(J.emStrong.lDelim).replace(/punct/g,J._punctuation).getRegex(),J.emStrong.rDelimAst=O(J.emStrong.rDelimAst,"g").replace(/punct/g,J._punctuation).getRegex(),J.emStrong.rDelimUnd=O(J.emStrong.rDelimUnd,"g").replace(/punct/g,J._punctuation).getRegex(),J._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,J._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,J._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,J.autolink=O(J.autolink).replace("scheme",J._scheme).replace("email",J._email).getRegex(),J._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,J.tag=O(J.tag).replace("comment",J._comment).replace("attribute",J._attribute).getRegex(),J._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,J._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,J._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,J.link=O(J.link).replace("label",J._label).replace("href",J._href).replace("title",J._title).getRegex(),J.reflink=O(J.reflink).replace("label",J._label).getRegex(),J.reflinkSearch=O(J.reflinkSearch,"g").replace("reflink",J.reflink).replace("nolink",J.nolink).getRegex(),J.normal=V({},J),J.pedantic=V({},J.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:O(/^!?\[(label)\]\((.*?)\)/).replace("label",J._label).getRegex(),reflink:O(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",J._label).getRegex()}),J.gfm=V({},J.normal,{escape:O(J.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),J.gfm.url=O(J.gfm.url,"i").replace("email",J.gfm._extended_email).getRegex(),J.breaks=V({},J.gfm,{br:O(J.br).replace("{2,}","*").getRegex(),text:O(J.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var me={block:q,inline:J},we=D.defaults,Ae=me.block,Pe=me.inline,Fe=L.repeatString;function z(K){return K.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Y(K){var oe="",he,Z,ie=K.length;for(he=0;he<ie;he++)Z=K.charCodeAt(he),Math.random()>.5&&(Z="x"+Z.toString(16)),oe+="&#"+Z+";";return oe}var te=function(){function K(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||we,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var Z={block:Ae.normal,inline:Pe.normal};this.options.pedantic?(Z.block=Ae.pedantic,Z.inline=Pe.pedantic):this.options.gfm&&(Z.block=Ae.gfm,this.options.breaks?Z.inline=Pe.breaks:Z.inline=Pe.gfm),this.tokenizer.rules=Z}K.lex=function(Z,ie){var le=new K(ie);return le.lex(Z)},K.lexInline=function(Z,ie){var le=new K(ie);return le.inlineTokens(Z)};var oe=K.prototype;return oe.lex=function(Z){return Z=Z.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Z,this.tokens,!0),this.inline(this.tokens),this.tokens},oe.blockTokens=function(Z,ie,le){ie===void 0&&(ie=[]),le===void 0&&(le=!0),this.options.pedantic&&(Z=Z.replace(/^ +$/gm,""));for(var ve,ye,We,Oe;Z;){if(ve=this.tokenizer.space(Z)){Z=Z.substring(ve.raw.length),ve.type&&ie.push(ve);continue}if(ve=this.tokenizer.code(Z)){Z=Z.substring(ve.raw.length),Oe=ie[ie.length-1],Oe&&Oe.type==="paragraph"?(Oe.raw+=`
`+ve.raw,Oe.text+=`
`+ve.text):ie.push(ve);continue}if(ve=this.tokenizer.fences(Z)){Z=Z.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.heading(Z)){Z=Z.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.nptable(Z)){Z=Z.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.hr(Z)){Z=Z.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.blockquote(Z)){Z=Z.substring(ve.raw.length),ve.tokens=this.blockTokens(ve.text,[],le),ie.push(ve);continue}if(ve=this.tokenizer.list(Z)){for(Z=Z.substring(ve.raw.length),We=ve.items.length,ye=0;ye<We;ye++)ve.items[ye].tokens=this.blockTokens(ve.items[ye].text,[],!1);ie.push(ve);continue}if(ve=this.tokenizer.html(Z)){Z=Z.substring(ve.raw.length),ie.push(ve);continue}if(le&&(ve=this.tokenizer.def(Z))){Z=Z.substring(ve.raw.length),this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(Z)){Z=Z.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.lheading(Z)){Z=Z.substring(ve.raw.length),ie.push(ve);continue}if(le&&(ve=this.tokenizer.paragraph(Z))){Z=Z.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.text(Z)){Z=Z.substring(ve.raw.length),Oe=ie[ie.length-1],Oe&&Oe.type==="text"?(Oe.raw+=`
`+ve.raw,Oe.text+=`
`+ve.text):ie.push(ve);continue}if(Z){var qe="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(qe);break}else throw new Error(qe)}}return ie},oe.inline=function(Z){var ie,le,ve,ye,We,Oe,qe=Z.length;for(ie=0;ie<qe;ie++)switch(Oe=Z[ie],Oe.type){case"paragraph":case"text":case"heading":{Oe.tokens=[],this.inlineTokens(Oe.text,Oe.tokens);break}case"table":{for(Oe.tokens={header:[],cells:[]},ye=Oe.header.length,le=0;le<ye;le++)Oe.tokens.header[le]=[],this.inlineTokens(Oe.header[le],Oe.tokens.header[le]);for(ye=Oe.cells.length,le=0;le<ye;le++)for(We=Oe.cells[le],Oe.tokens.cells[le]=[],ve=0;ve<We.length;ve++)Oe.tokens.cells[le][ve]=[],this.inlineTokens(We[ve],Oe.tokens.cells[le][ve]);break}case"blockquote":{this.inline(Oe.tokens);break}case"list":{for(ye=Oe.items.length,le=0;le<ye;le++)this.inline(Oe.items[le].tokens);break}}return Z},oe.inlineTokens=function(Z,ie,le,ve){ie===void 0&&(ie=[]),le===void 0&&(le=!1),ve===void 0&&(ve=!1);var ye,We,Oe=Z,qe,Ye,tt;if(this.tokens.links){var nt=Object.keys(this.tokens.links);if(nt.length>0)for(;(qe=this.tokenizer.rules.inline.reflinkSearch.exec(Oe))!=null;)nt.includes(qe[0].slice(qe[0].lastIndexOf("[")+1,-1))&&(Oe=Oe.slice(0,qe.index)+"["+Fe("a",qe[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(qe=this.tokenizer.rules.inline.blockSkip.exec(Oe))!=null;)Oe=Oe.slice(0,qe.index)+"["+Fe("a",qe[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(qe=this.tokenizer.rules.inline.escapedEmSt.exec(Oe))!=null;)Oe=Oe.slice(0,qe.index)+"++"+Oe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;){if(Ye||(tt=""),Ye=!1,ye=this.tokenizer.escape(Z)){Z=Z.substring(ye.raw.length),ie.push(ye);continue}if(ye=this.tokenizer.tag(Z,le,ve)){Z=Z.substring(ye.raw.length),le=ye.inLink,ve=ye.inRawBlock;var rt=ie[ie.length-1];rt&&ye.type==="text"&&rt.type==="text"?(rt.raw+=ye.raw,rt.text+=ye.text):ie.push(ye);continue}if(ye=this.tokenizer.link(Z)){Z=Z.substring(ye.raw.length),ye.type==="link"&&(ye.tokens=this.inlineTokens(ye.text,[],!0,ve)),ie.push(ye);continue}if(ye=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(ye.raw.length);var it=ie[ie.length-1];ye.type==="link"?(ye.tokens=this.inlineTokens(ye.text,[],!0,ve),ie.push(ye)):it&&ye.type==="text"&&it.type==="text"?(it.raw+=ye.raw,it.text+=ye.text):ie.push(ye);continue}if(ye=this.tokenizer.emStrong(Z,Oe,tt)){Z=Z.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],le,ve),ie.push(ye);continue}if(ye=this.tokenizer.codespan(Z)){Z=Z.substring(ye.raw.length),ie.push(ye);continue}if(ye=this.tokenizer.br(Z)){Z=Z.substring(ye.raw.length),ie.push(ye);continue}if(ye=this.tokenizer.del(Z)){Z=Z.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],le,ve),ie.push(ye);continue}if(ye=this.tokenizer.autolink(Z,Y)){Z=Z.substring(ye.raw.length),ie.push(ye);continue}if(!le&&(ye=this.tokenizer.url(Z,Y))){Z=Z.substring(ye.raw.length),ie.push(ye);continue}if(ye=this.tokenizer.inlineText(Z,ve,z)){Z=Z.substring(ye.raw.length),ye.raw.slice(-1)!=="_"&&(tt=ye.raw.slice(-1)),Ye=!0,We=ie[ie.length-1],We&&We.type==="text"?(We.raw+=ye.raw,We.text+=ye.text):ie.push(ye);continue}if(Z){var gt="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(gt);break}else throw new Error(gt)}}return ie},e(K,null,[{key:"rules",get:function(){return{block:Ae,inline:Pe}}}]),K}(),ae=D.defaults,fe=L.cleanUrl,De=L.escape,Me=function(){function K(he){this.options=he||ae}var oe=K.prototype;return oe.code=function(Z,ie,le){var ve=(ie||"").match(/\S*/)[0];if(this.options.highlight){var ye=this.options.highlight(Z,ve);ye!=null&&ye!==Z&&(le=!0,Z=ye)}return Z=Z.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+De(ve,!0)+'">'+(le?Z:De(Z,!0))+`</code></pre>
`:"<pre><code>"+(le?Z:De(Z,!0))+`</code></pre>
`},oe.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},oe.html=function(Z){return Z},oe.heading=function(Z,ie,le,ve){return this.options.headerIds?"<h"+ie+' id="'+this.options.headerPrefix+ve.slug(le)+'">'+Z+"</h"+ie+`>
`:"<h"+ie+">"+Z+"</h"+ie+`>
`},oe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},oe.list=function(Z,ie,le){var ve=ie?"ol":"ul",ye=ie&&le!==1?' start="'+le+'"':"";return"<"+ve+ye+`>
`+Z+"</"+ve+`>
`},oe.listitem=function(Z){return"<li>"+Z+`</li>
`},oe.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},oe.paragraph=function(Z){return"<p>"+Z+`</p>
`},oe.table=function(Z,ie){return ie&&(ie="<tbody>"+ie+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ie+`</table>
`},oe.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},oe.tablecell=function(Z,ie){var le=ie.header?"th":"td",ve=ie.align?"<"+le+' align="'+ie.align+'">':"<"+le+">";return ve+Z+"</"+le+`>
`},oe.strong=function(Z){return"<strong>"+Z+"</strong>"},oe.em=function(Z){return"<em>"+Z+"</em>"},oe.codespan=function(Z){return"<code>"+Z+"</code>"},oe.br=function(){return this.options.xhtml?"<br/>":"<br>"},oe.del=function(Z){return"<del>"+Z+"</del>"},oe.link=function(Z,ie,le){if(Z=fe(this.options.sanitize,this.options.baseUrl,Z),Z===null)return le;var ve='<a href="'+De(Z)+'"';return ie&&(ve+=' title="'+ie+'"'),ve+=">"+le+"</a>",ve},oe.image=function(Z,ie,le){if(Z=fe(this.options.sanitize,this.options.baseUrl,Z),Z===null)return le;var ve='<img src="'+Z+'" alt="'+le+'"';return ie&&(ve+=' title="'+ie+'"'),ve+=this.options.xhtml?"/>":">",ve},oe.text=function(Z){return Z},K}(),be=function(){function K(){}var oe=K.prototype;return oe.strong=function(Z){return Z},oe.em=function(Z){return Z},oe.codespan=function(Z){return Z},oe.del=function(Z){return Z},oe.html=function(Z){return Z},oe.text=function(Z){return Z},oe.link=function(Z,ie,le){return""+le},oe.image=function(Z,ie,le){return""+le},oe.br=function(){return""},K}(),ke=function(){function K(){this.seen={}}var oe=K.prototype;return oe.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},oe.getNextSafeSlug=function(Z,ie){var le=Z,ve=0;if(this.seen.hasOwnProperty(le)){ve=this.seen[Z];do ve++,le=Z+"-"+ve;while(this.seen.hasOwnProperty(le))}return ie||(this.seen[Z]=ve,this.seen[le]=0),le},oe.slug=function(Z,ie){ie===void 0&&(ie={});var le=this.serialize(Z);return this.getNextSafeSlug(le,ie.dryrun)},K}(),Re=D.defaults,Be=L.unescape,Ee=function(){function K(he){this.options=he||Re,this.options.renderer=this.options.renderer||new Me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new be,this.slugger=new ke}K.parse=function(Z,ie){var le=new K(ie);return le.parse(Z)},K.parseInline=function(Z,ie){var le=new K(ie);return le.parseInline(Z)};var oe=K.prototype;return oe.parse=function(Z,ie){ie===void 0&&(ie=!0);var le="",ve,ye,We,Oe,qe,Ye,tt,nt,rt,it,gt,ue,Ce,ce,G,Ue,Te,Xe,Ge=Z.length;for(ve=0;ve<Ge;ve++)switch(it=Z[ve],it.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(it.tokens),it.depth,Be(this.parseInline(it.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(it.text,it.lang,it.escaped);continue}case"table":{for(nt="",tt="",Oe=it.header.length,ye=0;ye<Oe;ye++)tt+=this.renderer.tablecell(this.parseInline(it.tokens.header[ye]),{header:!0,align:it.align[ye]});for(nt+=this.renderer.tablerow(tt),rt="",Oe=it.cells.length,ye=0;ye<Oe;ye++){for(Ye=it.tokens.cells[ye],tt="",qe=Ye.length,We=0;We<qe;We++)tt+=this.renderer.tablecell(this.parseInline(Ye[We]),{header:!1,align:it.align[We]});rt+=this.renderer.tablerow(tt)}le+=this.renderer.table(nt,rt);continue}case"blockquote":{rt=this.parse(it.tokens),le+=this.renderer.blockquote(rt);continue}case"list":{for(gt=it.ordered,ue=it.start,Ce=it.loose,Oe=it.items.length,rt="",ye=0;ye<Oe;ye++)G=it.items[ye],Ue=G.checked,Te=G.task,ce="",G.task&&(Xe=this.renderer.checkbox(Ue),Ce?G.tokens.length>0&&G.tokens[0].type==="text"?(G.tokens[0].text=Xe+" "+G.tokens[0].text,G.tokens[0].tokens&&G.tokens[0].tokens.length>0&&G.tokens[0].tokens[0].type==="text"&&(G.tokens[0].tokens[0].text=Xe+" "+G.tokens[0].tokens[0].text)):G.tokens.unshift({type:"text",text:Xe}):ce+=Xe),ce+=this.parse(G.tokens,Ce),rt+=this.renderer.listitem(ce,Te,Ue);le+=this.renderer.list(rt,gt,ue);continue}case"html":{le+=this.renderer.html(it.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(it.tokens));continue}case"text":{for(rt=it.tokens?this.parseInline(it.tokens):it.text;ve+1<Ge&&Z[ve+1].type==="text";)it=Z[++ve],rt+=`
`+(it.tokens?this.parseInline(it.tokens):it.text);le+=ie?this.renderer.paragraph(rt):rt;continue}default:{var lt='Token with "'+it.type+'" type was not found.';if(this.options.silent){console.error(lt);return}else throw new Error(lt)}}return le},oe.parseInline=function(Z,ie){ie=ie||this.renderer;var le="",ve,ye,We=Z.length;for(ve=0;ve<We;ve++)switch(ye=Z[ve],ye.type){case"escape":{le+=ie.text(ye.text);break}case"html":{le+=ie.html(ye.text);break}case"link":{le+=ie.link(ye.href,ye.title,this.parseInline(ye.tokens,ie));break}case"image":{le+=ie.image(ye.href,ye.title,ye.text);break}case"strong":{le+=ie.strong(this.parseInline(ye.tokens,ie));break}case"em":{le+=ie.em(this.parseInline(ye.tokens,ie));break}case"codespan":{le+=ie.codespan(ye.text);break}case"br":{le+=ie.br();break}case"del":{le+=ie.del(this.parseInline(ye.tokens,ie));break}case"text":{le+=ie.text(ye.text);break}default:{var Oe='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Oe);return}else throw new Error(Oe)}}return le},K}(),Ke=L.merge,X=L.checkSanitizeDeprecation,re=L.escape,_e=D.getDefaults,Ne=D.changeDefaults,Ve=D.defaults;function $e(K,oe,he){if(typeof K=="undefined"||K===null)throw new Error("marked(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");if(typeof oe=="function"&&(he=oe,oe=null),oe=Ke({},$e.defaults,oe||{}),X(oe),he){var Z=oe.highlight,ie;try{ie=te.lex(K,oe)}catch(We){return he(We)}var le=function(Oe){var qe;if(!Oe)try{qe=Ee.parse(ie,oe)}catch(Ye){Oe=Ye}return oe.highlight=Z,Oe?he(Oe):he(null,qe)};if(!Z||Z.length<3||(delete oe.highlight,!ie.length))return le();var ve=0;$e.walkTokens(ie,function(We){We.type==="code"&&(ve++,setTimeout(function(){Z(We.text,We.lang,function(Oe,qe){if(Oe)return le(Oe);qe!=null&&qe!==We.text&&(We.text=qe,We.escaped=!0),ve--,ve===0&&le()})},0))}),ve===0&&le();return}try{var ye=te.lex(K,oe);return oe.walkTokens&&$e.walkTokens(ye,oe.walkTokens),Ee.parse(ye,oe)}catch(We){if(We.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+re(We.message+"",!0)+"</pre>";throw We}}$e.options=$e.setOptions=function(K){return Ke($e.defaults,K),Ne($e.defaults),$e},$e.getDefaults=_e,$e.defaults=Ve,$e.use=function(K){var oe=Ke({},K);if(K.renderer&&function(){var Z=$e.defaults.renderer||new Me,ie=function(ye){var We=Z[ye];Z[ye]=function(){for(var Oe=arguments.length,qe=new Array(Oe),Ye=0;Ye<Oe;Ye++)qe[Ye]=arguments[Ye];var tt=K.renderer[ye].apply(Z,qe);return tt===!1&&(tt=We.apply(Z,qe)),tt}};for(var le in K.renderer)ie(le);oe.renderer=Z}(),K.tokenizer&&function(){var Z=$e.defaults.tokenizer||new M,ie=function(ye){var We=Z[ye];Z[ye]=function(){for(var Oe=arguments.length,qe=new Array(Oe),Ye=0;Ye<Oe;Ye++)qe[Ye]=arguments[Ye];var tt=K.tokenizer[ye].apply(Z,qe);return tt===!1&&(tt=We.apply(Z,qe)),tt}};for(var le in K.tokenizer)ie(le);oe.tokenizer=Z}(),K.walkTokens){var he=$e.defaults.walkTokens;oe.walkTokens=function(Z){K.walkTokens(Z),he&&he(Z)}}$e.setOptions(oe)},$e.walkTokens=function(K,oe){for(var he=T(K),Z;!(Z=he()).done;){var ie=Z.value;switch(oe(ie),ie.type){case"table":{for(var le=T(ie.tokens.header),ve;!(ve=le()).done;){var ye=ve.value;$e.walkTokens(ye,oe)}for(var We=T(ie.tokens.cells),Oe;!(Oe=We()).done;)for(var qe=Oe.value,Ye=T(qe),tt;!(tt=Ye()).done;){var nt=tt.value;$e.walkTokens(nt,oe)}break}case"list":{$e.walkTokens(ie.items,oe);break}default:ie.tokens&&$e.walkTokens(ie.tokens,oe)}}},$e.parseInline=function(K,oe){if(typeof K=="undefined"||K===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");oe=Ke({},$e.defaults,oe||{}),X(oe);try{var he=te.lexInline(K,oe);return oe.walkTokens&&$e.walkTokens(he,oe.walkTokens),Ee.parseInline(he,oe)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+re(Z.message+"",!0)+"</pre>";throw Z}},$e.Parser=Ee,$e.parser=Ee.parse,$e.Renderer=Me,$e.TextRenderer=be,$e.Lexer=te,$e.lexer=te.lex,$e.Tokenizer=M,$e.Slugger=ke,$e.parse=$e;var Ze=$e;return Ze}),define(ge[72],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function _(D,k,y){return Math.min(Math.max(D,k),y)}e.clamp=_;function P(D,k){return(k+D%k)%k}e.rot=P;class T{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=T;class I{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=I});"use strict";(function(){function Q(T){const I=[];typeof T=="number"&&I.push("code/timeOrigin",T);function D(y){I.push(y,Date.now())}function k(){const y=[];for(let i=0;i<I.length;i+=2)y.push({name:I[i],startTime:I[i+1]});return y}return{mark:D,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const D of performance.getEntriesByType("mark"))I.push({name:D.name,startTime:Math.round(T+D.startTime)});return I}};if(typeof process=="object"){const T=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function _(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return _(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=_(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=_(P))})(),define(ge[9],pe([0,1]),function(Q,e){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const P="en";let T=!1,I=!1,D=!1,k=!1,y=!1,i=!1,R=!1,C,w=P,m,s;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const S=typeof((_=d==null?void 0:d.versions)===null||_===void 0?void 0:_.electron)=="string"&&d.type==="renderer";if(e.isElectronSandboxed=S&&(d==null?void 0:d.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=d==null?void 0:d.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!S)s=navigator.userAgent,T=s.indexOf("Windows")>=0,I=s.indexOf("Macintosh")>=0,R=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=s.indexOf("Linux")>=0,i=!0,C=navigator.language,w=C;else if(typeof d=="object"){T=d.platform==="win32",I=d.platform==="darwin",D=d.platform==="linux",k=D&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,C=P,w=P;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const l=JSON.parse(r),a=l.availableLanguages["*"];C=l.locale,w=a||P,m=l._translationsConfigFile}catch(l){}y=!0}else console.error("Unable to resolve platform.");var v;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function b(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let p=0;I?p=1:T?p=3:D&&(p=2),e.isWindows=T,e.isMacintosh=I,e.isLinux=D,e.isLinuxSnap=k,e.isNative=y,e.isWeb=i,e.isIOS=R,e.platform=p,e.userAgent=s,e.language=w;var u;(function(r){function l(){return e.language}r.value=l;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=a;function g(){return e.language==="en"}r.isDefault=g})(u=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeSetImmediateId)for(let f=0,h=a.length;f<h;f++){const A=a[f];if(A.id===E.data.vscodeSetImmediateId){a.splice(f,1),A.callback();return}}});let g=0;return E=>{const f=++g;a.push({id:f,callback:E}),e.globals.postMessage({vscodeSetImmediateId:f},"*")}}if(typeof(d==null?void 0:d.nextTick)=="function")return d.nextTick.bind(d);const l=Promise.resolve();return a=>l.then(a)}();var c;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||R?2:T?1:3;let t=!0,n=!1;function o(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=o}),define(ge[36],pe([0,1,9]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let P;if(typeof _.globals.vscode!="undefined"){const T=_.globals.vscode.process;P={get platform(){return T.platform},get env(){return T.env},cwd(){return T.cwd()},nextTick(I){return(0,_.setImmediate)(I)}}}else typeof process!="undefined"?P={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(T){return process.nextTick(T)}}:P={get platform(){return _.isWindows?"win32":_.isMacintosh?"darwin":"linux"},nextTick(T){return(0,_.setImmediate)(T)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=P.cwd,e.env=P.env,e.platform=P.platform,e.nextTick=P.nextTick}),define(ge[8],pe([0,1,36]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const P=65,T=97,I=90,D=122,k=46,y=47,i=92,R=58,C=63;class w extends Error{constructor(u,c,t){let n;typeof c=="string"&&c.indexOf("not ")===0?(n="must not be",c=c.replace(/^not /,"")):n="must be";const o=u.indexOf(".")!==-1?"property":"argument";let r=`The "${u}" ${o} ${n} of type ${c}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function m(p,u){if(typeof p!="string")throw new w(u,"string",p)}function s(p){return p===y||p===i}function d(p){return p===y}function S(p){return p>=P&&p<=I||p>=T&&p<=D}function v(p,u,c,t){let n="",o=0,r=-1,l=0,a=0;for(let g=0;g<=p.length;++g){if(g<p.length)a=p.charCodeAt(g);else{if(t(a))break;a=y}if(t(a)){if(!(r===g-1||l===1))if(l===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==k||n.charCodeAt(n.length-2)!==k){if(n.length>2){const E=n.lastIndexOf(c);E===-1?(n="",o=0):(n=n.slice(0,E),o=n.length-1-n.lastIndexOf(c)),r=g,l=0;continue}else if(n.length!==0){n="",o=0,r=g,l=0;continue}}u&&(n+=n.length>0?`${c}..`:"..",o=2)}else n.length>0?n+=`${c}${p.slice(r+1,g)}`:n=p.slice(r+1,g),o=g-r-1;r=g,l=0}else a===k&&l!==-1?++l:l=-1}return n}function b(p,u){if(u===null||typeof u!="object")throw new w("pathObject","Object",u);const c=u.dir||u.root,t=u.base||`${u.name||""}${u.ext||""}`;return c?c===u.root?`${c}${t}`:`${c}${p}${t}`:t}e.win32={resolve(...p){let u="",c="",t=!1;for(let n=p.length-1;n>=-1;n--){let o;if(n>=0){if(o=p[n],m(o,"path"),o.length===0)continue}else u.length===0?o=_.cwd():(o=_.env[`=${u}`]||_.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==u.toLowerCase()&&o.charCodeAt(2)===i)&&(o=`${u}\\`));const r=o.length;let l=0,a="",g=!1;const E=o.charCodeAt(0);if(r===1)s(E)&&(l=1,g=!0);else if(s(E))if(g=!0,s(o.charCodeAt(1))){let f=2,h=f;for(;f<r&&!s(o.charCodeAt(f));)f++;if(f<r&&f!==h){const A=o.slice(h,f);for(h=f;f<r&&s(o.charCodeAt(f));)f++;if(f<r&&f!==h){for(h=f;f<r&&!s(o.charCodeAt(f));)f++;(f===r||f!==h)&&(a=`\\\\${A}\\${o.slice(h,f)}`,l=f)}}}else l=1;else S(E)&&o.charCodeAt(1)===R&&(a=o.slice(0,2),l=2,r>2&&s(o.charCodeAt(2))&&(g=!0,l=3));if(a.length>0)if(u.length>0){if(a.toLowerCase()!==u.toLowerCase())continue}else u=a;if(t){if(u.length>0)break}else if(c=`${o.slice(l)}\\${c}`,t=g,g&&u.length>0)break}return c=v(c,!t,"\\",s),t?`${u}\\${c}`:`${u}${c}`||"."},normalize(p){m(p,"path");const u=p.length;if(u===0)return".";let c=0,t,n=!1;const o=p.charCodeAt(0);if(u===1)return d(o)?"\\":p;if(s(o))if(n=!0,s(p.charCodeAt(1))){let l=2,a=l;for(;l<u&&!s(p.charCodeAt(l));)l++;if(l<u&&l!==a){const g=p.slice(a,l);for(a=l;l<u&&s(p.charCodeAt(l));)l++;if(l<u&&l!==a){for(a=l;l<u&&!s(p.charCodeAt(l));)l++;if(l===u)return`\\\\${g}\\${p.slice(a)}\\`;l!==a&&(t=`\\\\${g}\\${p.slice(a,l)}`,c=l)}}}else c=1;else S(o)&&p.charCodeAt(1)===R&&(t=p.slice(0,2),c=2,u>2&&s(p.charCodeAt(2))&&(n=!0,c=3));let r=c<u?v(p.slice(c),!n,"\\",s):"";return r.length===0&&!n&&(r="."),r.length>0&&s(p.charCodeAt(u-1))&&(r+="\\"),t===void 0?n?`\\${r}`:r:n?`${t}\\${r}`:`${t}${r}`},isAbsolute(p){m(p,"path");const u=p.length;if(u===0)return!1;const c=p.charCodeAt(0);return s(c)||u>2&&S(c)&&p.charCodeAt(1)===R&&s(p.charCodeAt(2))},join(...p){if(p.length===0)return".";let u,c;for(let o=0;o<p.length;++o){const r=p[o];m(r,"path"),r.length>0&&(u===void 0?u=c=r:u+=`\\${r}`)}if(u===void 0)return".";let t=!0,n=0;if(typeof c=="string"&&s(c.charCodeAt(0))){++n;const o=c.length;o>1&&s(c.charCodeAt(1))&&(++n,o>2&&(s(c.charCodeAt(2))?++n:t=!1))}if(t){for(;n<u.length&&s(u.charCodeAt(n));)n++;n>=2&&(u=`\\${u.slice(n)}`)}return e.win32.normalize(u)},relative(p,u){if(m(p,"from"),m(u,"to"),p===u)return"";const c=e.win32.resolve(p),t=e.win32.resolve(u);if(c===t||(p=c.toLowerCase(),u=t.toLowerCase(),p===u))return"";let n=0;for(;n<p.length&&p.charCodeAt(n)===i;)n++;let o=p.length;for(;o-1>n&&p.charCodeAt(o-1)===i;)o--;const r=o-n;let l=0;for(;l<u.length&&u.charCodeAt(l)===i;)l++;let a=u.length;for(;a-1>l&&u.charCodeAt(a-1)===i;)a--;const g=a-l,E=r<g?r:g;let f=-1,h=0;for(;h<E;h++){const L=p.charCodeAt(n+h);if(L!==u.charCodeAt(l+h))break;L===i&&(f=h)}if(h!==E){if(f===-1)return t}else{if(g>E){if(u.charCodeAt(l+h)===i)return t.slice(l+h+1);if(h===2)return t.slice(l+h)}r>E&&(p.charCodeAt(n+h)===i?f=h:h===2&&(f=3)),f===-1&&(f=0)}let A="";for(h=n+f+1;h<=o;++h)(h===o||p.charCodeAt(h)===i)&&(A+=A.length===0?"..":"\\..");return l+=f,A.length>0?`${A}${t.slice(l,a)}`:(t.charCodeAt(l)===i&&++l,t.slice(l,a))},toNamespacedPath(p){if(typeof p!="string")return p;if(p.length===0)return"";const u=e.win32.resolve(p);if(u.length<=2)return p;if(u.charCodeAt(0)===i){if(u.charCodeAt(1)===i){const c=u.charCodeAt(2);if(c!==C&&c!==k)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(S(u.charCodeAt(0))&&u.charCodeAt(1)===R&&u.charCodeAt(2)===i)return`\\\\?\\${u}`;return p},dirname(p){m(p,"path");const u=p.length;if(u===0)return".";let c=-1,t=0;const n=p.charCodeAt(0);if(u===1)return s(n)?p:".";if(s(n)){if(c=t=1,s(p.charCodeAt(1))){let l=2,a=l;for(;l<u&&!s(p.charCodeAt(l));)l++;if(l<u&&l!==a){for(a=l;l<u&&s(p.charCodeAt(l));)l++;if(l<u&&l!==a){for(a=l;l<u&&!s(p.charCodeAt(l));)l++;if(l===u)return p;l!==a&&(c=t=l+1)}}}}else S(n)&&p.charCodeAt(1)===R&&(c=u>2&&s(p.charCodeAt(2))?3:2,t=c);let o=-1,r=!0;for(let l=u-1;l>=t;--l)if(s(p.charCodeAt(l))){if(!r){o=l;break}}else r=!1;if(o===-1){if(c===-1)return".";o=c}return p.slice(0,o)},basename(p,u){u!==void 0&&m(u,"ext"),m(p,"path");let c=0,t=-1,n=!0,o;if(p.length>=2&&S(p.charCodeAt(0))&&p.charCodeAt(1)===R&&(c=2),u!==void 0&&u.length>0&&u.length<=p.length){if(u===p)return"";let r=u.length-1,l=-1;for(o=p.length-1;o>=c;--o){const a=p.charCodeAt(o);if(s(a)){if(!n){c=o+1;break}}else l===-1&&(n=!1,l=o+1),r>=0&&(a===u.charCodeAt(r)?--r==-1&&(t=o):(r=-1,t=l))}return c===t?t=l:t===-1&&(t=p.length),p.slice(c,t)}for(o=p.length-1;o>=c;--o)if(s(p.charCodeAt(o))){if(!n){c=o+1;break}}else t===-1&&(n=!1,t=o+1);return t===-1?"":p.slice(c,t)},extname(p){m(p,"path");let u=0,c=-1,t=0,n=-1,o=!0,r=0;p.length>=2&&p.charCodeAt(1)===R&&S(p.charCodeAt(0))&&(u=t=2);for(let l=p.length-1;l>=u;--l){const a=p.charCodeAt(l);if(s(a)){if(!o){t=l+1;break}continue}n===-1&&(o=!1,n=l+1),a===k?c===-1?c=l:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||n===-1||r===0||r===1&&c===n-1&&c===t+1?"":p.slice(c,n)},format:b.bind(null,"\\"),parse(p){m(p,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return u;const c=p.length;let t=0,n=p.charCodeAt(0);if(c===1)return s(n)?(u.root=u.dir=p,u):(u.base=u.name=p,u);if(s(n)){if(t=1,s(p.charCodeAt(1))){let f=2,h=f;for(;f<c&&!s(p.charCodeAt(f));)f++;if(f<c&&f!==h){for(h=f;f<c&&s(p.charCodeAt(f));)f++;if(f<c&&f!==h){for(h=f;f<c&&!s(p.charCodeAt(f));)f++;f===c?t=f:f!==h&&(t=f+1)}}}}else if(S(n)&&p.charCodeAt(1)===R){if(c<=2)return u.root=u.dir=p,u;if(t=2,s(p.charCodeAt(2))){if(c===3)return u.root=u.dir=p,u;t=3}}t>0&&(u.root=p.slice(0,t));let o=-1,r=t,l=-1,a=!0,g=p.length-1,E=0;for(;g>=t;--g){if(n=p.charCodeAt(g),s(n)){if(!a){r=g+1;break}continue}l===-1&&(a=!1,l=g+1),n===k?o===-1?o=g:E!==1&&(E=1):o!==-1&&(E=-1)}return l!==-1&&(o===-1||E===0||E===1&&o===l-1&&o===r+1?u.base=u.name=p.slice(r,l):(u.name=p.slice(r,o),u.base=p.slice(r,l),u.ext=p.slice(o,l))),r>0&&r!==t?u.dir=p.slice(0,r-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...p){let u="",c=!1;for(let t=p.length-1;t>=-1&&!c;t--){const n=t>=0?p[t]:_.cwd();m(n,"path"),n.length!==0&&(u=`${n}/${u}`,c=n.charCodeAt(0)===y)}return u=v(u,!c,"/",d),c?`/${u}`:u.length>0?u:"."},normalize(p){if(m(p,"path"),p.length===0)return".";const u=p.charCodeAt(0)===y,c=p.charCodeAt(p.length-1)===y;return p=v(p,!u,"/",d),p.length===0?u?"/":c?"./":".":(c&&(p+="/"),u?`/${p}`:p)},isAbsolute(p){return m(p,"path"),p.length>0&&p.charCodeAt(0)===y},join(...p){if(p.length===0)return".";let u;for(let c=0;c<p.length;++c){const t=p[c];m(t,"path"),t.length>0&&(u===void 0?u=t:u+=`/${t}`)}return u===void 0?".":e.posix.normalize(u)},relative(p,u){if(m(p,"from"),m(u,"to"),p===u||(p=e.posix.resolve(p),u=e.posix.resolve(u),p===u))return"";const c=1,t=p.length,n=t-c,o=1,r=u.length-o,l=n<r?n:r;let a=-1,g=0;for(;g<l;g++){const f=p.charCodeAt(c+g);if(f!==u.charCodeAt(o+g))break;f===y&&(a=g)}if(g===l)if(r>l){if(u.charCodeAt(o+g)===y)return u.slice(o+g+1);if(g===0)return u.slice(o+g)}else n>l&&(p.charCodeAt(c+g)===y?a=g:g===0&&(a=0));let E="";for(g=c+a+1;g<=t;++g)(g===t||p.charCodeAt(g)===y)&&(E+=E.length===0?"..":"/..");return`${E}${u.slice(o+a)}`},toNamespacedPath(p){return p},dirname(p){if(m(p,"path"),p.length===0)return".";const u=p.charCodeAt(0)===y;let c=-1,t=!0;for(let n=p.length-1;n>=1;--n)if(p.charCodeAt(n)===y){if(!t){c=n;break}}else t=!1;return c===-1?u?"/":".":u&&c===1?"//":p.slice(0,c)},basename(p,u){u!==void 0&&m(u,"ext"),m(p,"path");let c=0,t=-1,n=!0,o;if(u!==void 0&&u.length>0&&u.length<=p.length){if(u===p)return"";let r=u.length-1,l=-1;for(o=p.length-1;o>=0;--o){const a=p.charCodeAt(o);if(a===y){if(!n){c=o+1;break}}else l===-1&&(n=!1,l=o+1),r>=0&&(a===u.charCodeAt(r)?--r==-1&&(t=o):(r=-1,t=l))}return c===t?t=l:t===-1&&(t=p.length),p.slice(c,t)}for(o=p.length-1;o>=0;--o)if(p.charCodeAt(o)===y){if(!n){c=o+1;break}}else t===-1&&(n=!1,t=o+1);return t===-1?"":p.slice(c,t)},extname(p){m(p,"path");let u=-1,c=0,t=-1,n=!0,o=0;for(let r=p.length-1;r>=0;--r){const l=p.charCodeAt(r);if(l===y){if(!n){c=r+1;break}continue}t===-1&&(n=!1,t=r+1),l===k?u===-1?u=r:o!==1&&(o=1):u!==-1&&(o=-1)}return u===-1||t===-1||o===0||o===1&&u===t-1&&u===c+1?"":p.slice(u,t)},format:b.bind(null,"/"),parse(p){m(p,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return u;const c=p.charCodeAt(0)===y;let t;c?(u.root="/",t=1):t=0;let n=-1,o=0,r=-1,l=!0,a=p.length-1,g=0;for(;a>=t;--a){const E=p.charCodeAt(a);if(E===y){if(!l){o=a+1;break}continue}r===-1&&(l=!1,r=a+1),E===k?n===-1?n=a:g!==1&&(g=1):n!==-1&&(g=-1)}if(r!==-1){const E=o===0&&c?1:o;n===-1||g===0||g===1&&n===r-1&&n===o+1?u.base=u.name=p.slice(E,r):(u.name=p.slice(E,n),u.base=p.slice(E,r),u.ext=p.slice(n,r))}return o>0?u.dir=p.slice(0,o-1):c&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=_.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=_.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=_.platform==="win32"?e.win32.join:e.posix.join,e.resolve=_.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=_.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=_.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=_.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=_.platform==="win32"?e.win32.extname:e.posix.extname,e.format=_.platform==="win32"?e.win32.format:e.posix.format,e.parse=_.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=_.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=_.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=_.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ge[134],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var _;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(_=e.Source||(e.Source={}));var P;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(P=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(I,...D){const k=D.reduce((R,C)=>(R[C]=!0,R),{}),y=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(R=>!k[R]).forEach(R=>{for(let C=0;C<y.length;C++)if(R.search(y[C])!==-1){delete I[R];break}})}e.sanitizeProcessEnvironment=T}),define(ge[47],pe([0,1,9]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const P=_.globals.performance&&typeof _.globals.performance.now=="function";class T{constructor(D){this._highResolution=P&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new T(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?_.globals.performance.now():Date.now()}}e.StopWatch=T}),define(ge[3],pe([0,1,18,69,6,55,47]),function(Q,e,_,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(v){v.None=()=>T.Disposable.None;function b(j){return(x,$=null,F)=>{let U=!1,M;return M=j(N=>{if(!U)return M?M.dispose():U=!0,x.call($,N)},null,F),U&&M.dispose(),M}}v.once=b;function p(j,x){return r(($,F=null,U)=>j(M=>$.call(F,x(M)),null,U))}v.map=p;function u(j,x){return r(($,F=null,U)=>j(M=>{x(M),$.call(F,M)},null,U))}v.forEach=u;function c(j,x){return r(($,F=null,U)=>j(M=>x(M)&&$.call(F,M),null,U))}v.filter=c;function t(j){return j}v.signal=t;function n(...j){return(x,$=null,F)=>(0,T.combinedDisposable)(...j.map(U=>U(M=>x.call($,M),null,F)))}v.any=n;function o(j,x,$){let F=$;return p(j,U=>(F=x(F,U),F))}v.reduce=o;function r(j){let x;const $=new w({onFirstListenerAdd(){x=j($.fire,$)},onLastListenerRemove(){x.dispose()}});return $.event}v.snapshot=r;function l(j,x,$=100,F=!1,U){let M,N,O,V=0;const q=new w({leakWarningThreshold:U,onFirstListenerAdd(){M=j(J=>{V++,N=x(N,J),F&&!O&&(q.fire(N),N=void 0),clearTimeout(O),O=setTimeout(()=>{const me=N;N=void 0,O=void 0,(!F||V>1)&&q.fire(me),V=0},$)})},onLastListenerRemove(){M.dispose()}});return q.event}v.debounce=l;function a(j){const x=new Date().getTime();return p(b(j),$=>new Date().getTime()-x)}v.stopwatch=a;function g(j){let x=!0,$;return c(j,F=>{const U=x||F!==$;return x=!1,$=F,U})}v.latch=g;function E(j,x=!1,$=[]){let F=$.slice(),U=j(O=>{F?F.push(O):N.fire(O)});const M=()=>{F&&F.forEach(O=>N.fire(O)),F=null},N=new w({onFirstListenerAdd(){U||(U=j(O=>N.fire(O)))},onFirstListenerDidAdd(){F&&(x?setTimeout(M):M())},onLastListenerRemove(){U&&U.dispose(),U=null}});return N.event}v.buffer=E;class f{constructor(x){this.event=x}map(x){return new f(p(this.event,x))}forEach(x){return new f(u(this.event,x))}filter(x){return new f(c(this.event,x))}reduce(x,$){return new f(o(this.event,x,$))}latch(){return new f(g(this.event))}debounce(x,$=100,F=!1,U){return new f(l(this.event,x,$,F,U))}on(x,$,F){return this.event(x,$,F)}once(x,$,F){return b(this.event)(x,$,F)}}function h(j){return new f(j)}v.chain=h;function A(j,x,$=F=>F){const F=(...O)=>N.fire($(...O)),U=()=>j.on(x,F),M=()=>j.removeListener(x,F),N=new w({onFirstListenerAdd:U,onLastListenerRemove:M});return N.event}v.fromNodeEventEmitter=A;function L(j,x,$=F=>F){const F=(...O)=>N.fire($(...O)),U=()=>j.addEventListener(x,F),M=()=>j.removeEventListener(x,F),N=new w({onFirstListenerAdd:U,onLastListenerRemove:M});return N.event}v.fromDOMEventEmitter=L;function B(j){const x=new w;let $=!1;return j.then(void 0,()=>null).then(()=>{$?x.fire(void 0):setTimeout(()=>x.fire(void 0),0)}),$=!0,x.event}v.fromPromise=B;function ee(j){return new Promise(x=>b(j)(x))}v.toPromise=ee})(k=e.Event||(e.Event={}));class y{constructor(b){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${b}_${y._idPool++}`}start(b){this._stopWatch=new D.StopWatch(!0),this._listenerCount=b}stop(){if(this._stopWatch){const b=this._stopWatch.elapsed();this._elapsedOverall+=b,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${b.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let i=-1;function R(v){const b=i;return i=v,{dispose(){i=b}}}e.setGlobalLeakWarningThreshold=R;class C{constructor(b,p=Math.random().toString(18).slice(2,5)){this.customThreshold=b,this.name=p,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(b){let p=i;if(typeof this.customThreshold=="number"&&(p=this.customThreshold),!(p<=0||b<p)){this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),c=this._stacks.get(u)||0;if(this._stacks.set(u,c+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let t,n=0;for(const[o,r]of this._stacks)(!t||n<r)&&(t=o,n=r);console.warn(`[${this.name}] potential listener LEAK detected, having ${b} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(u)||0;this._stacks.set(u,t-1)}}}}class w{constructor(b){var p;this._disposed=!1,this._options=b,this._leakageMon=i>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((p=this._options)===null||p===void 0?void 0:p._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(b,p,u)=>{var c;this._listeners||(this._listeners=new I.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(p?[b,p]:b);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,b,p);const o=(c=this._leakageMon)===null||c===void 0?void 0:c.check(this._listeners.size);let r;return r={dispose:()=>{o&&o(),r.dispose=w._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},u instanceof T.DisposableStore?u.add(r):Array.isArray(u)&&u.push(r),r}),this._event}fire(b){var p,u;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new I.LinkedList);for(let c of this._listeners)this._deliveryQueue.push([c,b]);for((p=this._perfMon)===null||p===void 0||p.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[c,t]=this._deliveryQueue.shift();try{typeof c=="function"?c.call(void 0,t):c[0].call(c[1],t)}catch(n){(0,_.onUnexpectedError)(n)}}(u=this._perfMon)===null||u===void 0||u.stop()}}dispose(){var b,p,u;(b=this._listeners)===null||b===void 0||b.clear(),(p=this._deliveryQueue)===null||p===void 0||p.clear(),(u=this._leakageMon)===null||u===void 0||u.dispose(),this._disposed=!0}}e.Emitter=w,w._noop=function(){};class m extends w{constructor(b){super(b);this._isPaused=0,this._eventQueue=new I.LinkedList,this._mergeFn=b==null?void 0:b.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const b=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(b))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(b){this._listeners&&(this._isPaused!==0?this._eventQueue.push(b):super.fire(b))}}e.PauseableEmitter=m;class s{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new w({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(b){const p={event:b,listener:null};this.events.push(p),this.hasListeners&&this.hook(p);const u=()=>{this.hasListeners&&this.unhook(p);const c=this.events.indexOf(p);this.events.splice(c,1)};return(0,T.toDisposable)((0,P.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(b=>this.hook(b))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(b=>this.unhook(b))}hook(b){b.listener=b.event(p=>this.emitter.fire(p))}unhook(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=s;class d{constructor(){this.buffers=[]}wrapEvent(b){return(p,u,c)=>b(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>p.call(u,t)):p.call(u,t)},void 0,c)}bufferEvents(b){const p=[];this.buffers.push(p);const u=b();return this.buffers.pop(),p.forEach(c=>c()),u}}e.EventBufferer=d;class S{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=T.Disposable.None,this.emitter=new w({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(b){this.inputEvent=b,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=b(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=S}),define(ge[21],pe([0,1,3]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const P=Object.freeze(function(k,y){const i=setTimeout(k.bind(y),0);return{dispose(){clearTimeout(i)}}});var T;(function(k){function y(i){return i===k.None||i===k.Cancelled||i instanceof I?!0:!i||typeof i!="object"?!1:typeof i.isCancellationRequested=="boolean"&&typeof i.onCancellationRequested=="function"}k.isCancellationToken=y,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:P})})(T=e.CancellationToken||(e.CancellationToken={}));class I{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?P:(this._emitter||(this._emitter=new _.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new I),this._token}cancel(){this._token?this._token instanceof I&&this._token.cancel():this._token=T.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof I&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=D}),define(ge[43],pe([0,1,3]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class P{constructor(){this._icons=new Map,this._onDidRegister=new _.Emitter}add(R){const C=this._icons.get(R.id);C?R.description?C.description=R.description:console.error(`Duplicate registration of codicon ${R.id}`):(this._icons.set(R.id,R),this._onDidRegister.fire(R))}get(R){return this._icons.get(R)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const T=new P;e.iconRegistry=T;function I(i,R){return new D(i,R)}e.registerCodicon=I;class D{constructor(R,C,w){this.id=R,this.definition=C,this.description=w,T.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function k(i,R){const C=["codicon","codicon-"+i];return R&&C.push("codicon-modifier-"+R),C}e.getClassNamesArray=k;var y;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const R=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function C(s){if(s instanceof D)return["codicon","codicon-"+s.id];const d=R.exec(s.id);if(!d)return C(D.error);let[,S,v]=d;const b=["codicon","codicon-"+S];return v&&b.push("codicon-modifier-"+v.substr(1)),b}i.asClassNameArray=C;function w(s){return C(s).join(" ")}i.asClassName=w;function m(s){return"."+C(s).join(".")}i.asCSSSelector=m})(y=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personAdd=new i("person-add",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(ge[92],pe([0,1,18,6]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function T(v){const b=v;return b&&[b.on,b.pause,b.resume,b.destroy].every(p=>typeof p=="function")}e.isReadableStream=T;function I(v){const b=v;return b&&T(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean"}e.isReadableBufferedStream=I;function D(v,b){return new k(v,b)}e.newWriteableStream=D;class k{constructor(b,p){this.reducer=b,this.options=p,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(b){var p;if(!this.state.destroyed){if(this.state.flowing)this.emitData(b);else if(this.buffer.data.push(b),typeof((p=this.options)===null||p===void 0?void 0:p.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(b){this.state.destroyed||(this.state.flowing?this.emitError(b):this.buffer.error.push(b))}end(b){this.state.destroyed||(typeof b!="undefined"&&this.write(b),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(b){this.listeners.data.slice(0).forEach(p=>p(b))}emitError(b){this.listeners.error.length===0?(0,_.onUnexpectedError)(b):this.listeners.error.slice(0).forEach(p=>p(b))}emitEnd(){this.listeners.end.slice(0).forEach(b=>b())}on(b,p){if(!this.state.destroyed)switch(b){case"data":this.listeners.data.push(p),this.resume();break;case"end":this.listeners.end.push(p),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(p),this.state.flowing&&this.flowErrors();break}}removeListener(b,p){if(!this.state.destroyed){let u;switch(b){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const c=u.indexOf(p);c>=0&&u.splice(c,1)}}}flowData(){if(this.buffer.data.length>0){const b=this.reducer(this.buffer.data);this.emitData(b),this.buffer.data.length=0;const p=[...this.pendingWritePromises];this.pendingWritePromises.length=0,p.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const b of this.buffer.error)this.emitError(b);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(v,b){const p=[];let u;for(;(u=v.read())!==null;)p.push(u);return b(p)}e.consumeReadable=y;function i(v,b,p){const u=[];let c;for(;(c=v.read())!==null&&u.length<p;)u.push(c);return c===null&&u.length>0?b(u):{read:()=>{if(u.length>0)return u.shift();if(typeof c!="undefined"){const t=c;return c=void 0,t}return v.read()}}}e.peekReadable=i;function R(v,b){return new Promise((p,u)=>{const c=[];C(v,{onData:t=>{b&&c.push(t)},onError:t=>{b?u(t):p(void 0)},onEnd:()=>{p(b?b(c):void 0)}})})}e.consumeStream=R;function C(v,b){v.on("error",p=>b.onError(p)),v.on("end",()=>b.onEnd()),v.on("data",p=>b.onData(p))}e.listenStream=C;function w(v,b){return new Promise((p,u)=>{const c=new P.DisposableStore,t=[],n=l=>{if(t.push(l),t.length>b)return c.dispose(),v.pause(),p({stream:v,buffer:t,ended:!1})},o=l=>u(l),r=()=>p({stream:v,buffer:t,ended:!0});c.add((0,P.toDisposable)(()=>v.removeListener("error",o))),v.on("error",o),c.add((0,P.toDisposable)(()=>v.removeListener("end",r))),v.on("end",r),c.add((0,P.toDisposable)(()=>v.removeListener("data",n))),v.on("data",n)})}e.peekStream=w;function m(v,b){const p=D(b);return p.end(v),p}e.toStream=m;function s(){const v=D(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=s;function d(v){let b=!1;return{read:()=>b?null:(b=!0,v)}}e.toReadable=d;function S(v,b,p){const u=D(p);return C(v,{onData:c=>u.write(b.data(c)),onError:c=>u.error(b.error?b.error(c):c),onEnd:()=>u.end()}),u}e.transform=S}),define(ge[10],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function _(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=_;const P=/{(\d+)}/g;function T(K,...oe){return oe.length===0?K:K.replace(P,function(he,Z){const ie=parseInt(Z,10);return isNaN(ie)||ie<0||ie>=oe.length?he:oe[ie]})}e.format=T;function I(K){return K.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=I;function D(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function k(K,oe){let he=0;const Z=oe.charCodeAt(0);for(let ie=K.length-1;ie>=0;ie--)K.charCodeAt(ie)===Z&&he++;return he}e.count=k;function y(K,oe,he="\u2026"){return K.length<=oe?K:`${K.substr(0,oe)}${he}`}e.truncate=y;function i(K,oe=" "){const he=R(K,oe);return C(he,oe)}e.trim=i;function R(K,oe){if(!K||!oe)return K;const he=oe.length;if(he===0||K.length===0)return K;let Z=0;for(;K.indexOf(oe,Z)===Z;)Z=Z+he;return K.substring(Z)}e.ltrim=R;function C(K,oe){if(!K||!oe)return K;const he=oe.length,Z=K.length;if(he===0||Z===0)return K;let ie=Z,le=-1;for(;le=K.lastIndexOf(oe,ie-1),!(le===-1||le+he!==ie);){if(le===0)return"";ie=le}return K.substring(0,ie)}e.rtrim=C;function w(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=w;function m(K){return K.replace(/\*/g,"")}e.stripWildcards=m;function s(K,oe,he={}){if(!K)throw new Error("Cannot create regex from empty string");oe||(K=D(K)),he.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let Z="";return he.global&&(Z+="g"),he.matchCase||(Z+="i"),he.multiline&&(Z+="m"),he.unicode&&(Z+="u"),new RegExp(K,Z)}e.createRegExp=s;function d(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function S(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=S;function v(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=v;function b(K){return K.split(/\r\n|\r|\n/)}e.splitLines=b;function p(K){for(let oe=0,he=K.length;oe<he;oe++){const Z=K.charCodeAt(oe);if(Z!==32&&Z!==9)return oe}return-1}e.firstNonWhitespaceIndex=p;function u(K,oe=0,he=K.length){for(let Z=oe;Z<he;Z++){const ie=K.charCodeAt(Z);if(ie!==32&&ie!==9)return K.substring(oe,Z)}return K.substring(oe,he)}e.getLeadingWhitespace=u;function c(K,oe=K.length-1){for(let he=oe;he>=0;he--){const Z=K.charCodeAt(he);if(Z!==32&&Z!==9)return he}return-1}e.lastNonWhitespaceIndex=c;function t(K,oe){return K<oe?-1:K>oe?1:0}e.compare=t;function n(K,oe,he=0,Z=K.length,ie=0,le=oe.length){for(;he<Z&&ie<le;he++,ie++){let We=K.charCodeAt(he),Oe=oe.charCodeAt(ie);if(We<Oe)return-1;if(We>Oe)return 1}const ve=Z-he,ye=le-ie;return ve<ye?-1:ve>ye?1:0}e.compareSubstring=n;function o(K,oe){return r(K,oe,0,K.length,0,oe.length)}e.compareIgnoreCase=o;function r(K,oe,he=0,Z=K.length,ie=0,le=oe.length){for(;he<Z&&ie<le;he++,ie++){let We=K.charCodeAt(he),Oe=oe.charCodeAt(ie);if(We!==Oe){const qe=We-Oe;if(!(qe===32&&a(Oe))&&!(qe===-32&&a(We)))return l(We)&&l(Oe)?qe:n(K.toLowerCase(),oe.toLowerCase(),he,Z,ie,le)}}const ve=Z-he,ye=le-ie;return ve<ye?-1:ve>ye?1:0}e.compareSubstringIgnoreCase=r;function l(K){return K>=97&&K<=122}e.isLowerAsciiLetter=l;function a(K){return K>=65&&K<=90}e.isUpperAsciiLetter=a;function g(K){return l(K)||a(K)}function E(K,oe){return K.length===oe.length&&f(K,oe)}e.equalsIgnoreCase=E;function f(K,oe,he=K.length){for(let Z=0;Z<he;Z++){const ie=K.charCodeAt(Z),le=oe.charCodeAt(Z);if(ie!==le){if(g(ie)&&g(le)){const ve=Math.abs(ie-le);if(ve!==0&&ve!==32)return!1}else if(String.fromCharCode(ie).toLowerCase()!==String.fromCharCode(le).toLowerCase())return!1}}return!0}function h(K,oe){const he=oe.length;return oe.length>K.length?!1:f(K,oe,he)}e.startsWithIgnoreCase=h;function A(K,oe){let he,Z=Math.min(K.length,oe.length);for(he=0;he<Z;he++)if(K.charCodeAt(he)!==oe.charCodeAt(he))return he;return Z}e.commonPrefixLength=A;function L(K,oe){let he,Z=Math.min(K.length,oe.length);const ie=K.length-1,le=oe.length-1;for(he=0;he<Z;he++)if(K.charCodeAt(ie-he)!==oe.charCodeAt(le-he))return he;return Z}e.commonSuffixLength=L;function B(K){return 55296<=K&&K<=56319}e.isHighSurrogate=B;function ee(K){return 56320<=K&&K<=57343}e.isLowSurrogate=ee;function j(K,oe){return(K-55296<<10)+(oe-56320)+65536}e.computeCodePoint=j;function x(K,oe,he){const Z=K.charCodeAt(he);if(B(Z)&&he+1<oe){const ie=K.charCodeAt(he+1);if(ee(ie))return j(Z,ie)}return Z}e.getNextCodePoint=x;function $(K,oe){const he=K.charCodeAt(oe-1);if(ee(he)&&oe>1){const Z=K.charCodeAt(oe-2);if(B(Z))return j(Z,he)}return he}function F(K,oe){const he=$e.getInstance(),Z=oe,ie=K.length,le=x(K,ie,oe);oe+=le>=65536?2:1;let ve=he.getGraphemeBreakType(le);for(;oe<ie;){const ye=x(K,ie,oe),We=he.getGraphemeBreakType(ye);if(Ne(ve,We))break;oe+=ye>=65536?2:1,ve=We}return oe-Z}e.nextCharLength=F;function U(K,oe){const he=$e.getInstance(),Z=oe,ie=$(K,oe);oe-=ie>=65536?2:1;let le=he.getGraphemeBreakType(ie);for(;oe>0;){const ve=$(K,oe),ye=he.getGraphemeBreakType(ve);if(Ne(ye,le))break;oe-=ve>=65536?2:1,le=ye}return Z-oe}e.prevCharLength=U;function M(K,oe){const he=$e.getInstance(),Z=K.length,ie=oe,le=x(K,Z,oe),ve=he.getGraphemeBreakType(le);oe+=le>=65536?2:1;let ye=ve;for(;oe<Z;){const Oe=x(K,Z,oe),qe=he.getGraphemeBreakType(Oe);if(Ne(ye,qe))break;oe+=Oe>=65536?2:1,ye=qe}const We=oe;for(oe=ie,ye=ve;oe>0;){const Oe=$(K,oe),qe=he.getGraphemeBreakType(Oe);if(Ne(qe,ye))break;oe-=Oe>=65536?2:1,ye=qe}return[oe,We]}function N(K,oe){return oe>0&&ee(K.charCodeAt(oe))?M(K,oe-1):M(K,oe)}e.getCharContainingOffset=N;function O(K){const oe=K.length;let he=0,Z=0;for(;Z<oe;){const ve=x(K,oe,Z);Z+=ve>=65536?2:1,ve<128?he+=1:ve<2048?he+=2:ve<65536?he+=3:he+=4}const ie=new Uint8Array(he);Z=0;let le=0;for(;Z<oe;){const ve=x(K,oe,Z);Z+=ve>=65536?2:1,ve<128?ie[le++]=ve:ve<2048?(ie[le++]=192|(ve&1984)>>>6,ie[le++]=128|(ve&63)>>>0):ve<65536?(ie[le++]=224|(ve&61440)>>>12,ie[le++]=128|(ve&4032)>>>6,ie[le++]=128|(ve&63)>>>0):(ie[le++]=240|(ve&1835008)>>>18,ie[le++]=128|(ve&258048)>>>12,ie[le++]=128|(ve&4032)>>>6,ie[le++]=128|(ve&63)>>>0)}return ie}e.encodeUTF8=O;function V(K){const oe=K.byteLength,he=[];let Z=0;for(;Z<oe;){const ie=K[Z];let le;if(ie>=240&&Z+3<oe?le=(K[Z++]&7)<<18>>>0|(K[Z++]&63)<<12>>>0|(K[Z++]&63)<<6>>>0|(K[Z++]&63)<<0>>>0:ie>=224&&Z+2<oe?le=(K[Z++]&15)<<12>>>0|(K[Z++]&63)<<6>>>0|(K[Z++]&63)<<0>>>0:ie>=192&&Z+1<oe?le=(K[Z++]&31)<<6>>>0|(K[Z++]&63)<<0>>>0:le=K[Z++],le>=0&&le<=55295||le>=57344&&le<=65535)he.push(String.fromCharCode(le));else if(le>=65536&&le<=1114111){const ve=le-65536,ye=55296+((ve&1047552)>>>10),We=56320+((ve&1023)>>>0);he.push(String.fromCharCode(ye)),he.push(String.fromCharCode(We))}else he.push(String.fromCharCode(65533))}return he.join("")}e.decodeUTF8=V;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function J(K){return q.test(K)}e.containsRTL=J;const me=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function we(K){return me.test(K)}e.containsEmoji=we;const Ae=/^[\t\n\r\x20-\x7E]*$/;function Pe(K){return Ae.test(K)}e.isBasicASCII=Pe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Fe(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=Fe;function z(K){for(let oe=0,he=K.length;oe<he;oe++)if(Y(K.charCodeAt(oe)))return!0;return!1}e.containsFullWidthCharacter=z;function Y(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=Y;function te(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=te;function ae(K,oe){if(K.length<oe)return K;const he=/\b/g;let Z=0;for(;he.test(K)&&!(K.length-he.lastIndex<oe);)Z=he.lastIndex,he.lastIndex+=1;return K.substring(Z).replace(/^\s/,"")}e.lcut=ae;const fe=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Me=/\x1b\[0?m/g;function be(K){return K&&(K=K.replace(fe,""),K=K.replace(De,""),K=K.replace(Me,"")),K}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Re(K){return ke(K)?K.substr(1):K}e.stripUTF8BOM=Re;function Be(K,oe){if(!K||!oe||K.length<oe.length)return!1;const he=oe.length,Z=K.toLowerCase();let ie=0,le=-1;for(;ie<he;){const ve=Z.indexOf(oe[ie],le+1);if(ve<0)return!1;le=ve,ie++}return!0}e.fuzzyContains=Be;function Ee(K,oe=!1){return K?(oe&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Ee;function Ke(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Ke;function X(K,oe=1){if(oe===0)return"";let he=-1;do he=K.indexOf(`
`,he+1),oe--;while(oe>0&&he>=0);return he===-1?K:(K[he-1]==="\r"&&he--,K.substr(0,he))}e.getNLines=X;function re(K){const oe=90-65+1;return K=K%(2*oe),K<oe?String.fromCharCode(97+K):String.fromCharCode(65+K-oe)}e.singleLetterHash=re;function _e(K){return $e.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=_e;function Ne(K,oe){return K===0?oe!==5&&oe!==7:K===2&&oe===3?!1:K===4||K===2||K===3||oe===4||oe===2||oe===3?!0:!(K===8&&(oe===8||oe===9||oe===11||oe===12)||(K===11||K===9)&&(oe===9||oe===10)||(K===12||K===10)&&oe===10||oe===5||oe===13||oe===7||K===1||K===13&&oe===14||K===6&&oe===6)}e.breakBetweenGraphemeBreakType=Ne;var Ve;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Ve=e.GraphemeBreakType||(e.GraphemeBreakType={}));class $e{constructor(){this._data=Ze()}static getInstance(){return $e._INSTANCE||($e._INSTANCE=new $e),$e._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const he=this._data,Z=he.length/3;let ie=1;for(;ie<=Z;)if(oe<he[3*ie])ie=2*ie;else if(oe>he[3*ie+1])ie=2*ie+1;else return he[3*ie+2];return 0}}$e._INSTANCE=null;function Ze(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(ge[22],pe([0,1,10,92]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined",I=typeof TextEncoder!="undefined",D=typeof TextDecoder!="undefined";let k,y;class i{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return T?new i(Buffer.allocUnsafe(l)):new i(new Uint8Array(l))}static wrap(l){return T&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new i(l)}static fromString(l,a){return!((a==null?void 0:a.dontUseNodeBuffer)||!1)&&T?new i(Buffer.from(l)):I?(k||(k=new TextEncoder),new i(k.encode(l))):new i(_.encodeUTF8(l))}static concat(l,a){if(typeof a=="undefined"){a=0;for(let f=0,h=l.length;f<h;f++)a+=l[f].byteLength}const g=i.alloc(a);let E=0;for(let f=0,h=l.length;f<h;f++){const A=l[f];g.set(A,E),E+=A.byteLength}return g}toString(){return T?this.buffer.toString():D?(y||(y=new TextDecoder),y.decode(this.buffer)):_.decodeUTF8(this.buffer)}slice(l,a){return new i(this.buffer.subarray(l,a))}set(l,a){l instanceof i?this.buffer.set(l.buffer,a):this.buffer.set(l,a)}readUInt32BE(l){return w(this.buffer,l)}writeUInt32BE(l,a){m(this.buffer,l,a)}readUInt32LE(l){return s(this.buffer,l)}writeUInt32LE(l,a){d(this.buffer,l,a)}readUInt8(l){return S(this.buffer,l)}writeUInt8(l,a){v(this.buffer,l,a)}}e.VSBuffer=i;function R(r,l){return r[l+0]<<0>>>0|r[l+1]<<8>>>0}e.readUInt16LE=R;function C(r,l,a){r[a+0]=l&255,l=l>>>8,r[a+1]=l&255}e.writeUInt16LE=C;function w(r,l){return r[l]*2**24+r[l+1]*2**16+r[l+2]*2**8+r[l+3]}e.readUInt32BE=w;function m(r,l,a){r[a+3]=l,l=l>>>8,r[a+2]=l,l=l>>>8,r[a+1]=l,l=l>>>8,r[a]=l}e.writeUInt32BE=m;function s(r,l){return r[l+0]<<0>>>0|r[l+1]<<8>>>0|r[l+2]<<16>>>0|r[l+3]<<24>>>0}e.readUInt32LE=s;function d(r,l,a){r[a+0]=l&255,l=l>>>8,r[a+1]=l&255,l=l>>>8,r[a+2]=l&255,l=l>>>8,r[a+3]=l&255}e.writeUInt32LE=d;function S(r,l){return r[l]}e.readUInt8=S;function v(r,l,a){r[a]=l}e.writeUInt8=v;function b(r){return P.consumeReadable(r,l=>i.concat(l))}e.readableToBuffer=b;function p(r){return P.toReadable(r)}e.bufferToReadable=p;function u(r){return P.consumeStream(r,l=>i.concat(l))}e.streamToBuffer=u;async function c(r){return r.ended?i.concat(r.buffer):i.concat([...r.buffer,await u(r.stream)])}e.bufferedStreamToBuffer=c;function t(r){return P.toStream(r,l=>i.concat(l))}e.bufferToStream=t;function n(r){return P.transform(r,{data:l=>typeof l=="string"?i.fromString(l):i.wrap(l)},l=>i.concat(l))}e.streamToBufferReadableStream=n;function o(r){return P.newWriteableStream(l=>i.concat(l),r)}e.newWriteableBufferStream=o}),define(ge[73],pe([0,1,10]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function P(v){return T(v,0)}e.hash=P;function T(v,b){switch(typeof v){case"object":return v===null?I(349,b):Array.isArray(v)?y(v,b):i(v,b);case"string":return k(v,b);case"boolean":return D(v,b);case"number":return I(v,b);case"undefined":return I(937,b);default:return I(617,b)}}e.doHash=T;function I(v,b){return(b<<5)-b+v|0}function D(v,b){return I(v?433:863,b)}function k(v,b){b=I(149417,b);for(let p=0,u=v.length;p<u;p++)b=I(v.charCodeAt(p),b);return b}e.stringHash=k;function y(v,b){return b=I(104579,b),v.reduce((p,u)=>T(u,p),b)}function i(v,b){return b=I(181387,b),Object.keys(v).sort().reduce((p,u)=>(p=k(u,p),T(v[u],p)),b)}class R{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=T(b,this._value),this._value}}e.Hasher=R;var C;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function w(v,b,p=32){const u=p-b,c=~((1<<u)-1);return(v<<b|(c&v)>>>u)>>>0}function m(v,b=0,p=v.byteLength,u=0){for(let c=0;c<p;c++)v[b+c]=u}function s(v,b,p="0"){for(;v.length<b;)v=p+v;return v}function d(v,b=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(p=>p.toString(16).padStart(2,"0")).join(""):s((v>>>0).toString(16),b/4)}e.toHexString=d;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const p=b.length;if(p!==0){const u=this._buff;let c=this._buffLen,t=this._leftoverHighSurrogate,n,o;for(t!==0?(n=t,o=-1,t=0):(n=b.charCodeAt(0),o=0);;){let r=n;if(_.isHighSurrogate(n))if(o+1<p){const l=b.charCodeAt(o+1);_.isLowSurrogate(l)?(o++,r=_.computeCodePoint(n,l)):r=65533}else{t=n;break}else _.isLowSurrogate(n)&&(r=65533);if(c=this._push(u,c,r),o++,o<p)n=b.charCodeAt(o);else break}this._buffLen=c,this._leftoverHighSurrogate=t}}_push(b,p,u){return u<128?b[p++]=u:u<2048?(b[p++]=192|(u&1984)>>>6,b[p++]=128|(u&63)>>>0):u<65536?(b[p++]=224|(u&61440)>>>12,b[p++]=128|(u&4032)>>>6,b[p++]=128|(u&63)>>>0):(b[p++]=240|(u&1835008)>>>18,b[p++]=128|(u&258048)>>>12,b[p++]=128|(u&4032)>>>6,b[p++]=128|(u&63)>>>0),p>=64&&(this._step(),p-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),p}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=S._bigBlock32,p=this._buffDV;for(let g=0;g<64;g+=4)b.setUint32(g,p.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)b.setUint32(g,w(b.getUint32(g-12,!1)^b.getUint32(g-32,!1)^b.getUint32(g-56,!1)^b.getUint32(g-64,!1),1),!1);let u=this._h0,c=this._h1,t=this._h2,n=this._h3,o=this._h4,r,l,a;for(let g=0;g<80;g++)g<20?(r=c&t|~c&n,l=1518500249):g<40?(r=c^t^n,l=1859775393):g<60?(r=c&t|c&n|t&n,l=2400959708):(r=c^t^n,l=3395469782),a=w(u,5)+r+o+l+b.getUint32(g*4,!1)&4294967295,o=n,n=t,t=w(c,30),c=u,u=a;this._h0=this._h0+u&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ge[56],pe([0,1,10]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var P;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(P||(P={})),function(T){const I="error",D="warning",k="warn",y="info";function i(R){return R?_.equalsIgnoreCase(I,R)?T.Error:_.equalsIgnoreCase(D,R)||_.equalsIgnoreCase(k,R)?T.Warning:_.equalsIgnoreCase(y,R)?T.Info:T.Ignore:T.Ignore}T.fromValue=i}(P||(P={})),e.default=P}),define(ge[15],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function _(a){return Array.isArray(a)}e.isArray=_;function P(a){return typeof a=="string"}e.isString=P;function T(a){return Array.isArray(a)&&a.every(g=>P(g))}e.isStringArray=T;function I(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=I;function D(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=D;function k(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=k;function y(a){return a===!0||a===!1}e.isBoolean=y;function i(a){return typeof a=="undefined"}e.isUndefined=i;function R(a){return!C(a)}e.isDefined=R;function C(a){return i(a)||a===null}e.isUndefinedOrNull=C;function w(a,g){if(!a)throw new Error(g?`Unexpected type, expected '${g}'`:"Unexpected type")}e.assertType=w;function m(a){if(C(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=m;function s(...a){const g=[];for(let E=0;E<a.length;E++){const f=a[E];if(C(f))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);g.push(f)}return g}e.assertAllDefined=s;const d=Object.prototype.hasOwnProperty;function S(a){if(!I(a))return!1;for(let g in a)if(d.call(a,g))return!1;return!0}e.isEmptyObject=S;function v(a){return typeof a=="function"}e.isFunction=v;function b(...a){return a.length>0&&a.every(v)}e.areFunctions=b;function p(a,g){const E=Math.min(a.length,g.length);for(let f=0;f<E;f++)u(a[f],g[f])}e.validateConstraints=p;function u(a,g){if(P(g)){if(typeof a!==g)throw new Error(`argument does not match constraint: typeof ${g}`)}else if(v(g)){try{if(a instanceof g)return}catch(E){}if(!C(a)&&a.constructor===g||g.length===1&&g.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function c(a){let g=[],E=Object.getPrototypeOf(a);for(;Object.prototype!==E;)g=g.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return g}e.getAllPropertyNames=c;function t(a){const g=[];for(const E of c(a))typeof a[E]=="function"&&g.push(E);return g}e.getAllMethodNames=t;function n(a,g){const E=h=>function(){const A=Array.prototype.slice.call(arguments,0);return g(h,A)};let f={};for(const h of a)f[h]=E(h);return f}e.createProxyObject=n;function o(a){return a===null?void 0:a}e.withNullAsUndefined=o;function r(a){return typeof a=="undefined"?null:a}e.withUndefinedAsNull=r;function l(a){return class{constructor(){return new Proxy({},{get(g,E){if(g[E])return g[E];throw new Error(`Not Implemented: ${a}->${String(E)}`)}})}}}e.NotImplementedProxy=l}),define(ge[30],pe([0,1,9,10,8,15]),function(Q,e,_,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function D(n){return n===47||n===92}e.isPathSeparator=D;function k(n){return n.replace(/[\\/]/g,T.posix.sep)}e.toSlashes=k;function y(n,o=T.posix.sep){if(!n)return"";const r=n.length,l=n.charCodeAt(0);if(D(l)){if(D(n.charCodeAt(1))&&!D(n.charCodeAt(2))){let g=3;const E=g;for(;g<r&&!D(n.charCodeAt(g));g++);if(E!==g&&!D(n.charCodeAt(g+1))){for(g+=1;g<r;g++)if(D(n.charCodeAt(g)))return n.slice(0,g+1).replace(/[\\/]/g,o)}}return o}else if(S(l)&&n.charCodeAt(1)===58)return D(n.charCodeAt(2))?n.slice(0,2)+o:n.slice(0,2);let a=n.indexOf("://");if(a!==-1){for(a+=3;a<r;a++)if(D(n.charCodeAt(a)))return n.slice(0,a+1)}return""}e.getRoot=y;function i(n){if(!_.isWindows||!n||n.length<5)return!1;let o=n.charCodeAt(0);if(o!==92||(o=n.charCodeAt(1),o!==92))return!1;let r=2;const l=r;for(;r<n.length&&(o=n.charCodeAt(r),o!==92);r++);return!(l===r||(o=n.charCodeAt(r+1),isNaN(o)||o===92))}e.isUNC=i;const R=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(n,o=_.isWindows){const r=o?R:C;return!(!n||n.length===0||/^\s+$/.test(n)||(r.lastIndex=0,r.test(n))||o&&w.test(n)||n==="."||n===".."||o&&n[n.length-1]==="."||o&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=m;function s(n,o,r){const l=n===o;return!r||l?l:!n||!o?!1:(0,P.equalsIgnoreCase)(n,o)}e.isEqual=s;function d(n,o,r,l=T.sep){if(n===o)return!0;if(!n||!o||o.length>n.length)return!1;if(r){if(!(0,P.startsWithIgnoreCase)(n,o))return!1;if(o.length===n.length)return!0;let g=o.length;return o.charAt(o.length-1)===l&&g--,n.charAt(g)===l}return o.charAt(o.length-1)!==l&&(o+=l),n.indexOf(o)===0}e.isEqualOrParent=d;function S(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=S;function v(n,o){return _.isWindows&&n.endsWith(":")&&(n+=T.sep),(0,T.isAbsolute)(n)||(n=(0,T.join)(o,n)),n=(0,T.normalize)(n),_.isWindows?(n=(0,P.rtrim)(n,T.sep),n.endsWith(":")&&(n+=T.sep)):(n=(0,P.rtrim)(n,T.sep),n||(n=T.sep)),n}e.sanitizeFilePath=v;function b(n){const o=(0,T.normalize)(n);return _.isWindows?n.length>3?!1:p(o)&&(n.length===2||o.charCodeAt(2)===92):o===T.posix.sep}e.isRootOrDriveLetter=b;function p(n){return _.isWindows?S(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function u(n){return p(n)?n[0]:void 0}e.getDriveLetter=u;function c(n,o,r){return o.length>n.length?-1:n===o?0:(r&&(n=n.toLowerCase(),o=o.toLowerCase()),n.indexOf(o))}e.indexOfPath=c;function t(n){const o=n.split(":");let r,l,a;if(o.forEach(g=>{const E=Number(g);(0,I.isNumber)(E)?l===void 0?l=E:a===void 0&&(a=E):r=r?[r,g].join(":"):g}),!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:l!==void 0?l:void 0,column:a!==void 0?a:l!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(ge[23],pe([0,1,15]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function P(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const d=Array.isArray(s)?[]:{};return Object.keys(s).forEach(S=>{s[S]&&typeof s[S]=="object"?d[S]=P(s[S]):d[S]=s[S]}),d}e.deepClone=P;function T(s){if(!s||typeof s!="object")return s;const d=[s];for(;d.length>0;){const S=d.shift();Object.freeze(S);for(const v in S)if(I.call(S,v)){const b=S[v];typeof b=="object"&&!Object.isFrozen(b)&&d.push(b)}}return s}e.deepFreeze=T;const I=Object.prototype.hasOwnProperty;function D(s,d){return k(s,d,new Set)}e.cloneAndChange=D;function k(s,d,S){if((0,_.isUndefinedOrNull)(s))return s;const v=d(s);if(typeof v!="undefined")return v;if((0,_.isArray)(s)){const b=[];for(const p of s)b.push(k(p,d,S));return b}if((0,_.isObject)(s)){if(S.has(s))throw new Error("Cannot clone recursive data-structure");S.add(s);const b={};for(let p in s)I.call(s,p)&&(b[p]=k(s[p],d,S));return S.delete(s),b}return s}function y(s,d,S=!0){return(0,_.isObject)(s)?((0,_.isObject)(d)&&Object.keys(d).forEach(v=>{v in s?S&&((0,_.isObject)(s[v])&&(0,_.isObject)(d[v])?y(s[v],d[v],S):s[v]=d[v]):s[v]=d[v]}),s):d}e.mixin=y;function i(s,d){if(s===d)return!0;if(s==null||d===null||d===void 0||typeof s!=typeof d||typeof s!="object"||Array.isArray(s)!==Array.isArray(d))return!1;let S,v;if(Array.isArray(s)){if(s.length!==d.length)return!1;for(S=0;S<s.length;S++)if(!i(s[S],d[S]))return!1}else{const b=[];for(v in s)b.push(v);b.sort();const p=[];for(v in d)p.push(v);if(p.sort(),!i(b,p))return!1;for(S=0;S<b.length;S++)if(!i(s[b[S]],d[b[S]]))return!1}return!0}e.equals=i;function R(s){const d=new Set;return JSON.stringify(s,(S,v)=>{if((0,_.isObject)(v)||Array.isArray(v)){if(d.has(v))return"[Circular]";d.add(v)}return v})}e.safeStringify=R;function C(s,d,S){const v=d(s);return typeof v=="undefined"?S:v}e.getOrDefault=C;function w(s,d){const S=Object.create(null);return!s||!d||Object.keys(d).forEach(b=>{const p=s[b],u=d[b];i(p,u)||(S[b]=u)}),S}e.distinct=w;function m(s,d){const S=d.toLowerCase(),v=Object.keys(s).find(b=>b.toLowerCase()===S);return v?s[v]:s[d]}e.getCaseInsensitive=m}),define(ge[93],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var _;(function(I){I[I.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",I[I.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",I[I.MAX_UINT_8=255]="MAX_UINT_8",I[I.MAX_UINT_16=65535]="MAX_UINT_16",I[I.MAX_UINT_32=4294967295]="MAX_UINT_32",I[I.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_=e.Constants||(e.Constants={}));function P(I){return I<0?0:I>255?255:I|0}e.toUint8=P;function T(I){return I<0?0:I>4294967295?4294967295:I|0}e.toUint32=T}),define(ge[2],pe([0,1,9,8]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,I=/^\//,D=/^\/\//;function k(o,r){if(!o.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!T.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!I.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(o,r){return!o&&!r?"file":o}function i(o,r){switch(o){case"https":case"http":case"file":r?r[0]!==C&&(r=C+r):r=C;break}return r}const R="",C="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(r,l,a,g,E,f=!1){typeof r=="object"?(this.scheme=r.scheme||R,this.authority=r.authority||R,this.path=r.path||R,this.query=r.query||R,this.fragment=r.fragment||R):(this.scheme=y(r,f),this.authority=l||R,this.path=i(this.scheme,a||R),this.query=g||R,this.fragment=E||R,k(this,f))}static isUri(r){return r instanceof m?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return p(this,!1)}with(r){if(!r)return this;let{scheme:l,authority:a,path:g,query:E,fragment:f}=r;return l===void 0?l=this.scheme:l===null&&(l=R),a===void 0?a=this.authority:a===null&&(a=R),g===void 0?g=this.path:g===null&&(g=R),E===void 0?E=this.query:E===null&&(E=R),f===void 0?f=this.fragment:f===null&&(f=R),l===this.scheme&&a===this.authority&&g===this.path&&E===this.query&&f===this.fragment?this:new d(l,a,g,E,f)}static parse(r,l=!1){const a=w.exec(r);return a?new d(a[2]||R,n(a[4]||R),n(a[5]||R),n(a[7]||R),n(a[9]||R),l):new d(R,R,R,R,R)}static file(r){let l=R;if(_.isWindows&&(r=r.replace(/\\/g,C)),r[0]===C&&r[1]===C){const a=r.indexOf(C,2);a===-1?(l=r.substring(2),r=C):(l=r.substring(2,a),r=r.substring(a)||C)}return new d("file",l,r,R,R)}static from(r){return new d(r.scheme,r.authority,r.path,r.query,r.fragment)}static joinPath(r,...l){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return _.isWindows&&r.scheme==="file"?a=m.file(P.win32.join(p(r,!0),...l)).path:a=P.posix.join(r.path,...l),r.with({path:a})}toString(r=!1){return u(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof m)return r;{const l=new d(r);return l._formatted=r.external,l._fsPath=r._sep===s?r.fsPath:null,l}}else return r}}e.URI=m;const s=_.isWindows?1:void 0;class d extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(r=!1){return r?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=s),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(o,r){let l,a=-1;for(let g=0;g<o.length;g++){const E=o.charCodeAt(g);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||r&&E===47)a!==-1&&(l+=encodeURIComponent(o.substring(a,g)),a=-1),l!==void 0&&(l+=o.charAt(g));else{l===void 0&&(l=o.substr(0,g));const f=S[E];f!==void 0?(a!==-1&&(l+=encodeURIComponent(o.substring(a,g)),a=-1),l+=f):a===-1&&(a=g)}}return a!==-1&&(l+=encodeURIComponent(o.substring(a))),l!==void 0?l:o}function b(o){let r;for(let l=0;l<o.length;l++){const a=o.charCodeAt(l);a===35||a===63?(r===void 0&&(r=o.substr(0,l)),r+=S[a]):r!==void 0&&(r+=o[l])}return r!==void 0?r:o}function p(o,r){let l;return o.authority&&o.path.length>1&&o.scheme==="file"?l=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?r?l=o.path.substr(1):l=o.path[1].toLowerCase()+o.path.substr(2):l=o.path,_.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=p;function u(o,r){const l=r?b:v;let a="",{scheme:g,authority:E,path:f,query:h,fragment:A}=o;if(g&&(a+=g,a+=":"),(E||g==="file")&&(a+=C,a+=C),E){let L=E.indexOf("@");if(L!==-1){const B=E.substr(0,L);E=E.substr(L+1),L=B.indexOf(":"),L===-1?a+=l(B,!1):(a+=l(B.substr(0,L),!1),a+=":",a+=l(B.substr(L+1),!1)),a+="@"}E=E.toLowerCase(),L=E.indexOf(":"),L===-1?a+=l(E,!1):(a+=l(E.substr(0,L),!1),a+=E.substr(L))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const L=f.charCodeAt(1);L>=65&&L<=90&&(f=`/${String.fromCharCode(L+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const L=f.charCodeAt(0);L>=65&&L<=90&&(f=`${String.fromCharCode(L+32)}:${f.substr(2)}`)}a+=l(f,!0)}return h&&(a+="?",a+=l(h,!1)),A&&(a+="#",a+=r?A:v(A,!1)),a}function c(o){try{return decodeURIComponent(o)}catch(r){return o.length>3?o.substr(0,3)+c(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(o){return o.match(t)?o.replace(t,r=>c(r)):o}}),define(ge[24],pe([0,1,2,10]),function(Q,e,_,P){"use strict";var T,I;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(u,c,t){let n=u.get(c);return n===void 0&&(n=t,u.set(c,n)),n}e.getOrSet=D;function k(u){const c=[];return u.forEach((t,n)=>{c.push(`${n} => ${t}`)}),`Map(${u.size}) {${c.join(", ")}}`}e.mapToString=k;function y(u){const c=[];return u.forEach(t=>{c.push(t)}),`Set(${u.size}) {${c.join(", ")}}`}e.setToString=y;class i{constructor(){this._value="",this._pos=0}reset(c){return this._value=c,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(c){const t=c.charCodeAt(0),n=this._value.charCodeAt(this._pos);return t-n}value(){return this._value[this._pos]}}e.StringIterator=i;class R{constructor(c=!0){this._caseSensitive=c}reset(c){return this._value=c,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let c=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(c)this._from++;else break;else c=!1;return this}cmp(c){return this._caseSensitive?(0,P.compareSubstring)(c,this._value,0,c.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(c,this._value,0,c.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class C{constructor(c=!0,t=!0){this._splitOnBackslash=c,this._caseSensitive=t}reset(c){return this._value=c.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let c=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(c)this._from++;else break;else c=!1}return this}cmp(c){return this._caseSensitive?(0,P.compareSubstring)(c,this._value,0,c.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(c,this._value,0,c.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=C;var w;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(w||(w={}));class m{constructor(c){this._ignorePathCasing=c,this._states=[],this._stateIdx=0}reset(c){return this._value=c,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new C(!1,!this._ignorePathCasing(c)),this._pathIterator.reset(c.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(c){if(this._states[this._stateIdx]===1)return(0,P.compareIgnoreCase)(c,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,P.compareIgnoreCase)(c,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(c);if(this._states[this._stateIdx]===4)return(0,P.compare)(c,this._value.query);if(this._states[this._stateIdx]===5)return(0,P.compare)(c,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=m;class s{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class d{constructor(c){this._iter=c}static forUris(c=()=>!1){return new d(new m(c))}static forPaths(){return new d(new C)}static forStrings(){return new d(new i)}static forConfigKeys(){return new d(new R)}clear(){this._root=void 0}set(c,t){const n=this._iter.reset(c);let o;for(this._root||(this._root=new s,this._root.segment=n.value()),o=this._root;;){const l=n.cmp(o.segment);if(l>0)o.left||(o.left=new s,o.left.segment=n.value()),o=o.left;else if(l<0)o.right||(o.right=new s,o.right.segment=n.value()),o=o.right;else if(n.hasNext())n.next(),o.mid||(o.mid=new s,o.mid.segment=n.value()),o=o.mid;else break}const r=o.value;return o.value=t,o.key=c,r}get(c){var t;return(t=this._getNode(c))===null||t===void 0?void 0:t.value}_getNode(c){const t=this._iter.reset(c);let n=this._root;for(;n;){const o=t.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(t.hasNext())t.next(),n=n.mid;else break}return n}has(c){const t=this._getNode(c);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(c){return this._delete(c,!1)}deleteSuperstr(c){return this._delete(c,!0)}_delete(c,t){const n=this._iter.reset(c),o=[];let r=this._root;for(;r;){const l=n.cmp(r.segment);if(l>0)o.push([1,r]),r=r.left;else if(l<0)o.push([-1,r]),r=r.right;else if(n.hasNext())n.next(),o.push([0,r]),r=r.mid;else{for(t?(r.left=void 0,r.mid=void 0,r.right=void 0):r.value=void 0;o.length>0&&r.isEmpty();){let[a,g]=o.pop();switch(a){case 1:g.left=void 0;break;case 0:g.mid=void 0;break;case-1:g.right=void 0;break}r=g}break}}}findSubstr(c){const t=this._iter.reset(c);let n=this._root,o;for(;n;){const r=t.cmp(n.segment);if(r>0)n=n.left;else if(r<0)n=n.right;else if(t.hasNext())t.next(),o=n.value||o,n=n.mid;else break}return n&&n.value||o}findSuperstr(c){const t=this._iter.reset(c);let n=this._root;for(;n;){const o=t.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(t.hasNext())t.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(c){for(const[t,n]of this)c(n,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(c){c&&(yield*this._entries(c.left),c.value&&(yield[c.key,c.value]),yield*this._entries(c.mid),yield*this._entries(c.right))}}e.TernarySearchTree=d;class S{constructor(c,t){this[T]="ResourceMap",c instanceof S?(this.map=new Map(c.map),this.toKey=t!=null?t:S.defaultToKey):(this.map=new Map,this.toKey=c!=null?c:S.defaultToKey)}set(c,t){return this.map.set(this.toKey(c),t),this}get(c){return this.map.get(this.toKey(c))}has(c){return this.map.has(this.toKey(c))}get size(){return this.map.size}clear(){this.map.clear()}delete(c){return this.map.delete(this.toKey(c))}forEach(c,t){typeof t!="undefined"&&(c=c.bind(t));for(let[n,o]of this.map)c(o,_.URI.parse(n),this)}values(){return this.map.values()}*keys(){for(let c of this.map.keys())yield _.URI.parse(c)}*entries(){for(let c of this.map.entries())yield[_.URI.parse(c[0]),c[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let c of this.map)yield[_.URI.parse(c[0]),c[1]]}}e.ResourceMap=S,S.defaultToKey=u=>u.toString();var v;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class b{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var c;return(c=this._head)===null||c===void 0?void 0:c.value}get last(){var c;return(c=this._tail)===null||c===void 0?void 0:c.value}has(c){return this._map.has(c)}get(c,t=0){const n=this._map.get(c);if(!!n)return t!==0&&this.touch(n,t),n.value}set(c,t,n=0){let o=this._map.get(c);if(o)o.value=t,n!==0&&this.touch(o,n);else{switch(o={key:c,value:t,next:void 0,previous:void 0},n){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(c,o),this._size++}return this}delete(c){return!!this.remove(c)}remove(c){const t=this._map.get(c);if(!!t)return this._map.delete(c),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const c=this._head;return this._map.delete(c.key),this.removeItem(c),this._size--,c.value}}forEach(c,t){const n=this._state;let o=this._head;for(;o;){if(t?c.bind(t)(o.value,o.key,this):c(o.value,o.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const c=this,t=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(c._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const r={value:n.key,done:!1};return n=n.next,r}else return{value:void 0,done:!0}}};return o}values(){const c=this,t=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(c._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const r={value:n.value,done:!1};return n=n.next,r}else return{value:void 0,done:!0}}};return o}entries(){const c=this,t=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(c._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const r={value:[n.key,n.value],done:!1};return n=n.next,r}else return{value:void 0,done:!0}}};return o}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(c){if(!(c>=this.size)){if(c===0){this.clear();return}let t=this._head,n=this.size;for(;t&&n>c;)this._map.delete(t.key),t=t.next,n--;this._head=t,this._size=n,t&&(t.previous=void 0),this._state++}}addItemFirst(c){if(!this._head&&!this._tail)this._tail=c;else if(this._head)c.next=this._head,this._head.previous=c;else throw new Error("Invalid list");this._head=c,this._state++}addItemLast(c){if(!this._head&&!this._tail)this._head=c;else if(this._tail)c.previous=this._tail,this._tail.next=c;else throw new Error("Invalid list");this._tail=c,this._state++}removeItem(c){if(c===this._head&&c===this._tail)this._head=void 0,this._tail=void 0;else if(c===this._head){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this._head=c.next}else if(c===this._tail){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this._tail=c.previous}else{const t=c.next,n=c.previous;if(!t||!n)throw new Error("Invalid list");t.previous=n,n.next=t}c.next=void 0,c.previous=void 0,this._state++}touch(c,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(c===this._head)return;const n=c.next,o=c.previous;c===this._tail?(o.next=void 0,this._tail=o):(n.previous=o,o.next=n),c.previous=void 0,c.next=this._head,this._head.previous=c,this._head=c,this._state++}else if(t===2){if(c===this._tail)return;const n=c.next,o=c.previous;c===this._head?(n.previous=void 0,this._head=n):(n.previous=o,o.next=n),c.next=void 0,c.previous=this._tail,this._tail.next=c,this._tail=c,this._state++}}}toJSON(){const c=[];return this.forEach((t,n)=>{c.push([n,t])}),c}fromJSON(c){this.clear();for(const[t,n]of c)this.set(t,n)}}e.LinkedMap=b;class p extends b{constructor(c,t=1){super();this._limit=c,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(c){this._limit=c,this.checkTrim()}get ratio(){return this._ratio}set ratio(c){this._ratio=Math.min(Math.max(0,c),1),this.checkTrim()}get(c,t=2){return super.get(c,t)}peek(c){return super.get(c,0)}set(c,t){return super.set(c,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=p}),define(ge[94],pe([0,1,24,10]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function T(...be){return function(ke,Re){for(let Be=0,Ee=be.length;Be<Ee;Be++){const Ke=be[Be](ke,Re);if(Ke)return Ke}return null}}e.or=T,e.matchesStrictPrefix=I.bind(void 0,!1),e.matchesPrefix=I.bind(void 0,!0);function I(be,ke,Re){if(!Re||Re.length<ke.length)return null;let Be;return be?Be=P.startsWithIgnoreCase(Re,ke):Be=Re.indexOf(ke)===0,Be?ke.length>0?[{start:0,end:ke.length}]:[]:null}function D(be,ke){const Re=ke.toLowerCase().indexOf(be.toLowerCase());return Re===-1?null:[{start:Re,end:Re+be.length}]}e.matchesContiguousSubString=D;function k(be,ke){return y(be.toLowerCase(),ke.toLowerCase(),0,0)}e.matchesSubString=k;function y(be,ke,Re,Be){if(Re===be.length)return[];if(Be===ke.length)return null;if(be[Re]===ke[Be]){let Ee=null;return(Ee=y(be,ke,Re+1,Be+1))?v({start:Be,end:Be+1},Ee):null}return y(be,ke,Re,Be+1)}function i(be){return 97<=be&&be<=122}function R(be){return 65<=be&&be<=90}e.isUpper=R;function C(be){return 48<=be&&be<=57}function w(be){return be===32||be===9||be===10||be===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(be=>m.add(be.charCodeAt(0)));function s(be){return w(be)||m.has(be)}function d(be,ke){return be===ke||s(be)&&s(ke)}function S(be){return i(be)||R(be)||C(be)}function v(be,ke){return ke.length===0?ke=[be]:be.end===ke[0].start?ke[0].start=be.start:ke.unshift(be),ke}function b(be,ke){for(let Re=ke;Re<be.length;Re++){const Be=be.charCodeAt(Re);if(R(Be)||C(Be)||Re>0&&!S(be.charCodeAt(Re-1)))return Re}return be.length}function p(be,ke,Re,Be){if(Re===be.length)return[];if(Be===ke.length)return null;if(be[Re]!==ke[Be].toLowerCase())return null;{let Ee=null,Ke=Be+1;for(Ee=p(be,ke,Re+1,Be+1);!Ee&&(Ke=b(ke,Ke))<ke.length;)Ee=p(be,ke,Re+1,Ke),Ke++;return Ee===null?null:v({start:Be,end:Be+1},Ee)}}function u(be){let ke=0,Re=0,Be=0,Ee=0,Ke=0;for(let Ve=0;Ve<be.length;Ve++)Ke=be.charCodeAt(Ve),R(Ke)&&ke++,i(Ke)&&Re++,S(Ke)&&Be++,C(Ke)&&Ee++;const X=ke/be.length,re=Re/be.length,_e=Be/be.length,Ne=Ee/be.length;return{upperPercent:X,lowerPercent:re,alphaPercent:_e,numericPercent:Ne}}function c(be){const{upperPercent:ke,lowerPercent:Re}=be;return Re===0&&ke>.6}function t(be){const{upperPercent:ke,lowerPercent:Re,alphaPercent:Be,numericPercent:Ee}=be;return Re>.2&&ke<.8&&Be>.6&&Ee<.2}function n(be){let ke=0,Re=0,Be=0,Ee=0;for(let Ke=0;Ke<be.length;Ke++)Be=be.charCodeAt(Ke),R(Be)&&ke++,i(Be)&&Re++,w(Be)&&Ee++;return(ke===0||Re===0)&&Ee===0?be.length<=30:ke<=5}function o(be,ke){if(!ke||(ke=ke.trim(),ke.length===0)||!n(be)||ke.length>60)return null;const Re=u(ke);if(!t(Re)){if(!c(Re))return null;ke=ke.toLowerCase()}let Be=null,Ee=0;for(be=be.toLowerCase();Ee<ke.length&&(Be=p(be,ke,0,Ee))===null;)Ee=b(ke,Ee+1);return Be}e.matchesCamelCase=o;function r(be,ke,Re=!1){if(!ke||ke.length===0)return null;let Be=null,Ee=0;for(be=be.toLowerCase(),ke=ke.toLowerCase();Ee<ke.length&&(Be=l(be,ke,0,Ee,Re))===null;)Ee=a(ke,Ee+1);return Be}e.matchesWords=r;function l(be,ke,Re,Be,Ee){if(Re===be.length)return[];if(Be===ke.length)return null;if(d(be.charCodeAt(Re),ke.charCodeAt(Be))){let Ke=null,X=Be+1;if(Ke=l(be,ke,Re+1,Be+1,Ee),!Ee)for(;!Ke&&(X=a(ke,X))<ke.length;)Ke=l(be,ke,Re+1,X,Ee),X++;return Ke===null?null:v({start:Be,end:Be+1},Ke)}else return null}function a(be,ke){for(let Re=ke;Re<be.length;Re++)if(s(be.charCodeAt(Re))||Re>0&&s(be.charCodeAt(Re-1)))return Re;return be.length}const g=T(e.matchesPrefix,o,D),E=T(e.matchesPrefix,o,k),f=new _.LRUCache(1e4);function h(be,ke,Re=!1){if(typeof be!="string"||typeof ke!="string")return null;let Be=f.get(be);Be||(Be=new RegExp(P.convertSimple2RegExpPattern(be),"i"),f.set(be,Be));const Ee=Be.exec(ke);return Ee?[{start:Ee.index,end:Ee.index+Ee[0].length}]:Re?E(be,ke):g(be,ke)}e.matchesFuzzy=h;function A(be,ke){const Re=z(be,be.toLowerCase(),0,ke,ke.toLowerCase(),0,!0);return Re?B(Re):null}e.matchesFuzzy2=A;function L(be,ke,Re,Be,Ee,Ke){const X=Math.min(13,be.length);for(;Re<X;Re++){const re=z(be,ke,Re,Be,Ee,Ke,!1);if(re)return re}return[0,Ke]}e.anyScore=L;function B(be){if(typeof be=="undefined")return[];const ke=[],Re=be[1];for(let Be=be.length-1;Be>1;Be--){const Ee=be[Be]+Re,Ke=ke[ke.length-1];Ke&&Ke.end===Ee?Ke.end=Ee+1:ke.push({start:Ee,end:Ee+1})}return ke}e.createMatches=B;const ee=128;function j(){const be=[],ke=[];for(let Re=0;Re<=ee;Re++)ke[Re]=0;for(let Re=0;Re<=ee;Re++)be.push(ke.slice(0));return be}function x(be){const ke=[];for(let Re=0;Re<=be;Re++)ke[Re]=0;return ke}const $=x(2*ee),F=x(2*ee),U=j(),M=j(),N=j(),O=!1;function V(be,ke,Re,Be,Ee){function Ke(re,_e,Ne=" "){for(;re.length<_e;)re=Ne+re;return re}let X=` |   |${Be.split("").map(re=>Ke(re,3)).join("|")}
`;for(let re=0;re<=Re;re++)re===0?X+=" |":X+=`${ke[re-1]}|`,X+=be[re].slice(0,Ee+1).map(_e=>Ke(_e.toString(),3)).join("|")+`
`;return X}function q(be,ke,Re,Be){be=be.substr(ke),Re=Re.substr(Be),console.log(V(M,be,be.length,Re,Re.length)),console.log(V(N,be,be.length,Re,Re.length)),console.log(V(U,be,be.length,Re,Re.length))}function J(be,ke){if(ke<0||ke>=be.length)return!1;const Re=be.codePointAt(ke);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!P.isEmojiImprecise(Re)}}function me(be,ke){if(ke<0||ke>=be.length)return!1;switch(be.charCodeAt(ke)){case 32:case 9:return!0;default:return!1}}function we(be,ke,Re){return ke[be]!==Re[be]}function Ae(be,ke,Re,Be,Ee,Ke,X=!1){for(;ke<Re&&Ee<Ke;)be[ke]===Be[Ee]&&(X&&($[ke]=Ee),ke+=1),Ee+=1;return ke===Re}e.isPatternInWord=Ae;var Pe;(function(be){be[be.Diag=1]="Diag",be[be.Left=2]="Left",be[be.LeftLeft=3]="LeftLeft"})(Pe||(Pe={}));var Fe;(function(be){be.Default=[-100,0];function ke(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}be.isDefault=ke})(Fe=e.FuzzyScore||(e.FuzzyScore={}));function z(be,ke,Re,Be,Ee,Ke,X){const re=be.length>ee?ee:be.length,_e=Be.length>ee?ee:Be.length;if(!(Re>=re||Ke>=_e||re-Re>_e-Ke)&&!!Ae(ke,Re,re,Ee,Ke,_e,!0)){Y(re,_e,Re,Ke,ke,Ee);let Ne=1,Ve=1,$e=Re,Ze=Ke;const K=[!1];for(Ne=1,$e=Re;$e<re;Ne++,$e++){const le=$[$e],ve=F[$e],ye=$e+1<re?F[$e+1]:_e;for(Ve=le-Ke+1,Ze=le;Ze<ye;Ve++,Ze++){let We=Number.MIN_SAFE_INTEGER,Oe=!1;Ze<=ve&&(We=te(be,ke,$e,Re,Be,Ee,Ze,_e,Ke,U[Ne-1][Ve-1]===0,K));let qe=0;We!==Number.MAX_SAFE_INTEGER&&(Oe=!0,qe=We+M[Ne-1][Ve-1]);const Ye=Ze>le,tt=Ye?M[Ne][Ve-1]+(U[Ne][Ve-1]>0?-5:0):0,nt=Ze>le+1&&U[Ne][Ve-1]>0,rt=nt?M[Ne][Ve-2]+(U[Ne][Ve-2]>0?-5:0):0;if(nt&&(!Ye||rt>=tt)&&(!Oe||rt>=qe))M[Ne][Ve]=rt,N[Ne][Ve]=3,U[Ne][Ve]=0;else if(Ye&&(!Oe||tt>=qe))M[Ne][Ve]=tt,N[Ne][Ve]=2,U[Ne][Ve]=0;else if(Oe)M[Ne][Ve]=qe,N[Ne][Ve]=1,U[Ne][Ve]=U[Ne-1][Ve-1]+1;else throw new Error("not possible")}}if(O&&q(be,Re,Be,Ke),!(!K[0]&&!X)){Ne--,Ve--;const oe=[M[Ne][Ve],Ke];let he=0,Z=0;for(;Ne>=1;){let le=Ve;do{const ve=N[Ne][le];if(ve===3)le=le-2;else if(ve===2)le=le-1;else break}while(le>=1);he>1&&ke[Re+Ne-1]===Ee[Ke+Ve-1]&&!we(le+Ke-1,Be,Ee)&&he+1>U[Ne][le]&&(le=Ve),le===Ve?he++:he=1,Z||(Z=le),Ne--,Ve=le-1,oe.push(Ve)}_e===re&&(oe[0]+=2);const ie=Z-re;return oe[0]-=ie,oe}}}e.fuzzyScore=z;function Y(be,ke,Re,Be,Ee,Ke){let X=be-1,re=ke-1;for(;X>=Re&&re>=Be;)Ee[X]===Ke[re]&&(F[X]=re,X--),re--}function te(be,ke,Re,Be,Ee,Ke,X,re,_e,Ne,Ve){if(ke[Re]!==Ke[X])return Number.MIN_SAFE_INTEGER;let $e=1,Ze=!1;return X===Re-Be?$e=be[Re]===Ee[X]?7:5:we(X,Ee,Ke)&&(X===0||!we(X-1,Ee,Ke))?($e=be[Re]===Ee[X]?7:5,Ze=!0):J(Ke,X)&&(X===0||!J(Ke,X-1))?$e=5:(J(Ke,X-1)||me(Ke,X-1))&&($e=5,Ze=!0),$e>1&&Re===Be&&(Ve[0]=!0),Ze||(Ze=we(X,Ee,Ke)||J(Ke,X-1)||me(Ke,X-1)),Re===Be?X>_e&&($e-=Ze?3:5):Ne?$e+=Ze?2:0:$e+=Ze?0:1,X+1===re&&($e-=Ze?3:5),$e}function ae(be,ke,Re,Be,Ee,Ke,X){return De(be,ke,Re,Be,Ee,Ke,!0,X)}e.fuzzyScoreGracefulAggressive=ae;function fe(be,ke,Re,Be,Ee,Ke,X){return De(be,ke,Re,Be,Ee,Ke,!1,X)}e.fuzzyScoreGraceful=fe;function De(be,ke,Re,Be,Ee,Ke,X,re){let _e=z(be,ke,Re,Be,Ee,Ke,re);if(_e&&!X)return _e;if(be.length>=3){const Ne=Math.min(7,be.length-1);for(let Ve=Re+1;Ve<Ne;Ve++){const $e=Me(be,Ve);if($e){const Ze=z($e,$e.toLowerCase(),Re,Be,Ee,Ke,re);Ze&&(Ze[0]-=3,(!_e||Ze[0]>_e[0])&&(_e=Ze))}}}return _e}function Me(be,ke){if(!(ke+1>=be.length)){const Re=be[ke],Be=be[ke+1];if(Re!==Be)return be.slice(0,ke)+Be+Re+be.slice(ke+2)}}}),define(ge[135],pe([0,1,43,94,10]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const I=new RegExp(`\\$\\(${_.CSSIcon.iconNameExpression}(?:${_.CSSIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(`(\\\\)?${I.source}`,"g");function k(d){return d.replace(D,(S,v)=>v?S:`\\${S}`)}e.escapeIcons=k;const y=new RegExp(`\\\\${I.source}`,"g");function i(d){return d.replace(y,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=i;const R=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function C(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(R,(S,v,b,p)=>b?S:v||p||"")}e.stripIcons=C;function w(d){const S=d.indexOf(e.iconStartMarker);return S===-1?{text:d}:m(d,S)}e.parseLabelWithIcons=w;function m(d,S){const v=[];let b="";function p(a){if(a){b+=a;for(const g of a)v.push(t)}}let u=-1,c="",t=0,n,o,r=S;const l=d.length;for(p(d.substr(0,S));r<l;)n=d[r],o=d[r+1],n===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(u=r,p(c),c=e.iconStartMarker,r++):n===")"&&u!==-1?(t+=r-u+1,u=-1,c=""):u!==-1?/^[a-z0-9\-]$/i.test(n)?c+=n:(p(c),u=-1,c=""):p(n),r++;return p(c),{text:b,iconOffsets:v}}function s(d,S,v=!1){const{text:b,iconOffsets:p}=S;if(!p||p.length===0)return(0,P.matchesFuzzy)(d,b,v);const u=(0,T.ltrim)(b," "),c=b.length-u.length,t=(0,P.matchesFuzzy)(d,u,v);if(t)for(const n of t){const o=p[n.start+c]+c;n.start+=o,n.end+=o}return t}e.matchesFuzzyIconAware=s}),define(ge[95],pe([0,1,14,135,18]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(d="",S=!1){var v,b;if(this.value=d,typeof this.value!="string")throw(0,T.illegalArgument)("value");typeof S=="boolean"?(this.isTrusted=S,this.supportThemeIcons=!1):(this.isTrusted=(v=S.isTrusted)!==null&&v!==void 0?v:void 0,this.supportThemeIcons=(b=S.supportThemeIcons)!==null&&b!==void 0?b:!1)}appendText(d,S=0){return this.value+=C(this.supportThemeIcons?(0,P.escapeIcons)(d):d).replace(/([ \t]+)/g,(v,b)=>"&nbsp;".repeat(b.length)).replace(/^>/gm,"\\>").replace(/\n/g,S===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,S){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=S,this.value+="\n```\n",this}}e.MarkdownString=D;function k(s){return y(s)?!s.value:Array.isArray(s)?s.every(k):!0}e.isEmptyMarkdownString=k;function y(s){return s instanceof D?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function i(s,d){return!s&&!d?!0:!s||!d?!1:Array.isArray(s)&&Array.isArray(d)?(0,_.equals)(s,d,R):y(s)&&y(d)?R(s,d):!1}e.markedStringsEquals=i;function R(s,d){return s===d?!0:!s||!d?!1:s.value===d.value&&s.isTrusted===d.isTrusted&&s.supportThemeIcons===d.supportThemeIcons}function C(s){return s.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function w(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=w;function m(s){const d=[],S=s.split("|").map(b=>b.trim());s=S[0];const v=S[1];if(v){const b=/height=(\d+)/.exec(v),p=/width=(\d+)/.exec(v),u=b?b[1]:"",c=p?p[1]:"",t=isFinite(parseInt(c)),n=isFinite(parseInt(u));t&&d.push(`width="${c}"`),n&&d.push(`height="${u}"`)}return{href:s,dimensions:d}}e.parseHrefAndDimensions=m}),define(ge[57],pe([0,1,22,10,2]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function I(i){return JSON.stringify(i,k)}e.stringify=I;function D(i){let R=JSON.parse(i);return R=y(R),R}e.parse=D;function k(i,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,P.regExpFlags)(R)}:R}function y(i,R=0){if(!i||R>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return T.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof _.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let C=0;C<i.length;++C)i[C]=y(i[C],R+1);else for(const C in i)Object.hasOwnProperty.call(i,C)&&(i[C]=y(i[C],R+1))}return i}e.revive=y}),define(ge[11],pe([0,1,2,9]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var T;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file"})(T=e.Schemas||(e.Schemas={}));class I{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,i,R){this._hosts[y]=i,this._ports[y]=R}setConnectionToken(y,i){this._connectionTokens[y]=i}rewrite(y){if(this._delegate)return this._delegate(y);const i=y.authority;let R=this._hosts[i];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const C=this._ports[i],w=this._connectionTokens[i];let m=`path=${encodeURIComponent(y.path)}`;return typeof w=="string"&&(m+=`&tkn=${encodeURIComponent(w)}`),_.URI.from({scheme:P.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${R}:${C}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new I;class D{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,i,R){const C=this.toUri(y,i);return C.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(C):P.isNative&&(R||P.isPreferringBrowserCodeLoad)&&C.scheme===T.file?C.with({scheme:T.vscodeFileResource,authority:C.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(y,i){const R=this.toUri(y,i);return R.scheme===T.vscodeFileResource?R.with({scheme:T.file,authority:R.authority!==this.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(y,i){return _.URI.isUri(y)?y:_.URI.parse(i.toUrl(y))}}e.FileAccess=new D}),define(ge[74],pe([0,1,24]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const P=new _.LRUCache(1e4);function T(i){return y(i,"NFC",P)}e.normalizeNFC=T;const I=new _.LRUCache(1e4);function D(i){return y(i,"NFD",I)}e.normalizeNFD=D;const k=/[^\u0000-\u0080]/;function y(i,R,C){if(!e.canNormalize||!i)return i;const w=C.get(i);if(w)return w;let m;return k.test(i)?m=i.normalize(R):m=i,C.set(i,m),m}e.removeAccents=function(){if(e.canNormalize){const i=/[\u0300-\u036f]/g;return function(R){return D(R).replace(i,"")}}else return function(i){return i}}()}),define(ge[25],pe([0,1,30,8,2,10,11,9]),function(Q,e,_,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(m){return(0,T.uriToFsPath)(m,!0)}e.originalFSPath=y;class i{constructor(s){this._ignorePathCasing=s}compare(s,d,S=!1){return s===d?0:(0,I.compare)(this.getComparisonKey(s,S),this.getComparisonKey(d,S))}isEqual(s,d,S=!1){return s===d?!0:!s||!d?!1:this.getComparisonKey(s,S)===this.getComparisonKey(d,S)}getComparisonKey(s,d=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,d,S=!1){if(s.scheme===d.scheme){if(s.scheme===D.Schemas.file)return _.isEqualOrParent(y(s),y(d),this._ignorePathCasing(s))&&s.query===d.query&&(S||s.fragment===d.fragment);if((0,e.isEqualAuthority)(s.authority,d.authority))return _.isEqualOrParent(s.path,d.path,this._ignorePathCasing(s),"/")&&s.query===d.query&&(S||s.fragment===d.fragment)}return!1}joinPath(s,...d){return T.URI.joinPath(s,...d)}basenameOrAuthority(s){return(0,e.basename)(s)||s.authority}basename(s){return P.posix.basename(s.path)}extname(s){return P.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let d;return s.scheme===D.Schemas.file?d=T.URI.file(P.dirname(y(s))).path:(d=P.posix.dirname(s.path),s.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${s.toString})) resulted in a relative path`),d="/")),s.with({path:d})}normalizePath(s){if(!s.path.length)return s;let d;return s.scheme===D.Schemas.file?d=T.URI.file(P.normalize(y(s))).path:d=P.posix.normalize(s.path),s.with({path:d})}relativePath(s,d){if(!(s.scheme!==d.scheme||!(0,e.isEqualAuthority)(s.authority,d.authority))){if(s.scheme===D.Schemas.file){const b=P.relative(y(s),y(d));return k.isWindows?_.toSlashes(b):b}let S=s.path||"/",v=d.path||"/";if(this._ignorePathCasing(s)){let b=0;for(const p=Math.min(S.length,v.length);b<p&&!(S.charCodeAt(b)!==v.charCodeAt(b)&&S.charAt(b).toLowerCase()!==v.charAt(b).toLowerCase());b++);S=v.substr(0,b)+S.substr(b)}return P.posix.relative(S,v)}}resolvePath(s,d){if(s.scheme===D.Schemas.file){const S=T.URI.file(P.resolve(y(s),d));return s.with({authority:S.authority,path:S.path})}return d.indexOf("/")===-1&&(d=_.toSlashes(d),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d)),s.with({path:P.posix.resolve(s.path,d)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,d){return s===d||(0,I.equalsIgnoreCase)(s,d)}hasTrailingPathSeparator(s,d=P.sep){if(s.scheme===D.Schemas.file){const S=y(s);return S.length>_.getRoot(S).length&&S[S.length-1]===d}else{const S=s.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,d=P.sep){return(0,e.hasTrailingPathSeparator)(s,d)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,d=P.sep){let S=!1;if(s.scheme===D.Schemas.file){const v=y(s);S=v!==void 0&&v.length===_.getRoot(v).length&&v[v.length-1]===d}else{d="/";const v=s.path;S=v.length===1&&v.charCodeAt(v.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(s,d)?s.with({path:s.path+"/"}):s}}e.ExtUri=i,e.extUri=new i(()=>!1),e.extUriBiasedIgnorePathCase=new i(m=>m.scheme===D.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new i(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(m,s){const d=[];for(let S=0;S<m.length;S++){const v=s(m[S]);m.some((b,p)=>p===S?!1:(0,e.isEqualOrParent)(v,s(b)))||d.push(m[S])}return d}e.distinctParents=R;var C;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function s(d){const S=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(p=>{const[u,c]=p.split(":");u&&c&&S.set(u,c)});const b=d.path.substring(0,d.path.indexOf(";"));return b&&S.set(m.META_DATA_MIME,b),S}m.parseMetaData=s})(C=e.DataUri||(e.DataUri={}));function w(m,s,d){if(s){let S=m.path;return S&&S[0]!==P.posix.sep&&(S=P.posix.sep+S),m.with({scheme:d,authority:s,path:S})}return m.with({scheme:d})}e.toLocalResource=w}),define(ge[19],pe([0,1,21,18,3,6,55,25]),function(Q,e,_,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(M){return!!M&&typeof M.then=="function"}e.isThenable=y;function i(M){const N=new _.CancellationTokenSource,O=M(N.token),V=new Promise((q,J)=>{N.token.onCancellationRequested(()=>{J((0,P.canceled)())}),Promise.resolve(O).then(me=>{N.dispose(),q(me)},me=>{N.dispose(),J(me)})});return new class{cancel(){N.cancel()}then(q,J){return V.then(q,J)}catch(q){return this.then(void 0,q)}finally(q){return V.finally(q)}}}e.createCancelablePromise=i;function R(M,N,O){return Promise.race([M,new Promise(V=>N.onCancellationRequested(()=>V(O)))])}e.raceCancellation=R;async function C(M){let N=-1;const O=M.map((q,J)=>q.then(me=>(N=J,me))),V=await Promise.race(O);return M.forEach((q,J)=>{J!==N&&q.cancel()}),V}e.raceCancellablePromises=C;function w(M,N,O){let V;const q=setTimeout(()=>{V==null||V(void 0),O==null||O()},N);return Promise.race([M.finally(()=>clearTimeout(q)),new Promise(J=>V=J)])}e.raceTimeout=w;function m(M){return new Promise((N,O)=>{const V=M();y(V)?V.then(N,O):N(V)})}e.asPromise=m;class s{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(O,O).then(V)})}return new Promise((O,V)=>{this.queuedPromise.then(O,V)})}return this.activePromise=N(),new Promise((O,V)=>{this.activePromise.then(q=>{this.activePromise=null,O(q)},q=>{this.activePromise=null,V(q)})})}}e.Throttler=s;class d{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=d;class S{constructor(){this.promiseMap=new Map}queue(N,O){var V;const J=((V=this.promiseMap.get(N))!==null&&V!==void 0?V:Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(N)===J&&this.promiseMap.delete(N)});return this.promiseMap.set(N,J),J}}e.SequencerByKey=S;class v{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,O=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,q)=>{this.doResolve=V,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},O),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,P.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=v;class b{constructor(N){this.delayer=new v(N),this.throttler=new s}trigger(N,O){return this.delayer.trigger(()=>this.throttler.queue(N),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class p{constructor(){this._isOpen=!1,this._promise=new Promise((N,O)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=p;class u extends p{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function c(M,N){return N?new Promise((O,V)=>{const q=setTimeout(O,M);N.onCancellationRequested(()=>{clearTimeout(q),V((0,P.canceled)())})}):i(O=>c(M,O))}e.timeout=c;function t(M,N=0){const O=setTimeout(M,N);return(0,I.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=t;function n(M){return M.then(void 0,N=>{})}e.ignoreErrors=n;function o(M){const N=[];let O=0;const V=M.length;function q(){return O<V?M[O++]():null}function J(me){me!=null&&N.push(me);const we=q();return we?we.then(J):Promise.resolve(N)}return Promise.resolve(null).then(J)}e.sequence=o;function r(M,N=V=>!!V,O=null){let V=0;const q=M.length,J=()=>{if(V>=q)return Promise.resolve(O);const me=M[V++];return Promise.resolve(me()).then(Ae=>N(Ae)?Promise.resolve(Ae):J())};return J()}e.first=r;function l(M,N=V=>!!V,O=null){if(M.length===0)return Promise.resolve(O);let V=M.length;const q=()=>{var J,me;V=-1;for(const we of M)(me=(J=we).cancel)===null||me===void 0||me.call(J)};return new Promise((J,me)=>{for(const we of M)we.then(Ae=>{--V>=0&&N(Ae)?(q(),J(Ae)):V===0&&J(O)}).catch(Ae=>{--V>=0&&(q(),me(Ae))})})}e.firstParallel=l;class a{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new T.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((O,V)=>{this.outstandingPromises.push({factory:N,c:O,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const O=N.factory();O.then(N.c,N.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=a;class g extends a{constructor(){super(1)}}e.Queue=g;class E{constructor(){this.queues=new Map}queueFor(N,O=k.extUri){const V=O.getComparisonKey(N);let q=this.queues.get(V);return q||(q=new g,T.Event.once(q.onFinished)(()=>{q==null||q.dispose(),this.queues.delete(V)}),this.queues.set(V,q)),q}dispose(){this.queues.forEach(N=>N.dispose()),this.queues.clear()}}e.ResourceQueue=E;class f{constructor(N,O){this._token=-1,typeof N=="function"&&typeof O=="number"&&this.setIfNotSet(N,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},O)}setIfNotSet(N,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},O))}}e.TimeoutTimer=f;class h{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,O){this.cancel(),this._token=setInterval(()=>{N()},O)}}e.IntervalTimer=h;class A{constructor(N,O){this.timeoutToken=-1,this.runner=N,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=A;class L extends A{constructor(N,O){super(N,O);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const M=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=N=>{const O=setTimeout(()=>N(M));let V=!1;return{dispose(){V||(V=!0,clearTimeout(O))}}}}else e.runWhenIdle=(M,N)=>{const O=requestIdleCallback(M,typeof N=="number"?{timeout:N}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(O))}}}}();class B{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=B;async function ee(M,N,O){let V;for(let q=0;q<O;q++)try{return await M()}catch(J){V=J,await c(N)}throw V}e.retry=ee;class j{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var N;(N=this._pending)===null||N===void 0||N.cancel()}setPending(N,O,V){return this._pending={taskId:N,cancel:()=>V==null?void 0:V(),promise:O},O.then(()=>this.donePending(N),()=>this.donePending(N)),O}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let O,V;const q=new Promise((J,me)=>{O=J,V=me});this._next={run:N,promise:q,promiseResolve:O,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=j;class x{constructor(N){this.interval=N,this.lastIncrementTime=0,this.value=0}increment(){const N=Date.now();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,O)=>{this.completeCallback=N,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(O=>{this.completeCallback(N),this.resolved=!0,O()})}error(N){return new Promise(O=>{this.errorCallback(N),this.rejected=!0,O()})}cancel(){new Promise(N=>{this.errorCallback((0,P.canceled)()),this.rejected=!0,N()})}}e.DeferredPromise=$;class F extends T.Emitter{async fireAsync(N,O,V){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new D.LinkedList);for(const q of this._listeners)this._asyncDeliveryQueue.push([q,N]);for(;this._asyncDeliveryQueue.size>0&&!O.isCancellationRequested;){const[q,J]=this._asyncDeliveryQueue.shift(),me=[],we=Object.assign(Object.assign({},J),{waitUntil:Ae=>{if(Object.isFrozen(me))throw new Error("waitUntil can NOT be called asynchronous");V&&(Ae=V(Ae,typeof q=="function"?q:q[0])),me.push(Ae)}});try{typeof q=="function"?q.call(void 0,we):q[0].call(q[1],we)}catch(Ae){(0,P.onUnexpectedError)(Ae);continue}Object.freeze(me),await U.settled(me).catch(Ae=>(0,P.onUnexpectedError)(Ae))}}}}e.AsyncEmitter=F;var U;(function(M){async function N(J){return typeof Promise.allSettled=="function"?O(J):V(J)}M.allSettled=N;async function O(J){return Promise.allSettled(J)}async function V(J){return Promise.all(J.map(me=>me.then(we=>({status:"fulfilled",value:we}),we=>({status:"rejected",reason:we}))))}async function q(J){let me;const we=await Promise.all(J.map(Ae=>Ae.then(Pe=>Pe,Pe=>{me||(me=Pe)})));if(typeof me!="undefined")throw me;return we}M.settled=q})(U=e.Promises||(e.Promises={}))}),define(ge[96],pe([0,1,8,19]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const T=new P.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),I=new P.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new P.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(u,c,t=!1){const n=u||"",o=c||"",r=T.value.collator.compare(n,o);return T.value.collatorIsNumeric&&r===0&&n!==o?n<o?-1:1:r}e.compareFileNames=k;function y(u,c){const t=I.value.collator;return u=u||"",c=c||"",d(t,u,c)}e.compareFileNamesDefault=y;function i(u,c,t=!1){t||(u=u&&u.toLowerCase(),c=c&&c.toLowerCase());const[n,o]=m(u),[r,l]=m(c);return n!==r?n<r?-1:1:o===l?0:o<l?-1:1}e.noIntlCompareFileNames=i;function R(u,c){const[t,n]=m(u),[o,r]=m(c);let l=T.value.collator.compare(n,r);if(l===0){if(T.value.collatorIsNumeric&&n!==r)return n<r?-1:1;if(l=T.value.collator.compare(t,o),T.value.collatorIsNumeric&&l===0&&t!==o)return t<o?-1:1}return l}e.compareFileExtensions=R;function C(u,c){u=u||"",c=c||"";const t=s(u),n=s(c),o=I.value.collator,r=D.value.collator;let l;return l=d(r,t,n),l!==0?l:d(o,u,c)}e.compareFileExtensionsDefault=C;const w=/^(.*?)(\.([^.]*))?$/;function m(u,c=!1){const t=u?w.exec(u):[];let n=[t&&t[1]||"",t&&t[3]||""];return c&&(!n[0]&&n[1]||n[0]&&n[0].charAt(0)===".")&&(n=[n[0]+"."+n[1],""]),n}function s(u){const c=u?w.exec(u):[];return c&&c[1]&&c[1].charAt(0)!=="."&&c[3]||""}function d(u,c,t){let n=u.compare(c,t);return n!==0?n:c.length!==t.length?c.length<t.length?-1:1:0}function S(u,c,t=!1){return t||(u=u&&u.toLowerCase(),c=c&&c.toLowerCase()),u===c?0:u<c?-1:1}function v(u,c,t=!1){const n=u.split(_.sep),o=c.split(_.sep),r=n.length-1,l=o.length-1;let a,g;for(let E=0;;E++){if(a=r===E,g=l===E,a&&g)return k(n[E],o[E],t);if(a)return-1;if(g)return 1;const f=S(n[E],o[E],t);if(f!==0)return f}}e.comparePaths=v;function b(u,c,t){const n=u.toLowerCase(),o=c.toLowerCase(),r=p(u,c,t);if(r)return r;const l=n.endsWith(t),a=o.endsWith(t);if(l!==a)return l?-1:1;const g=k(n,o);return g!==0?g:n.localeCompare(o)}e.compareAnything=b;function p(u,c,t){const n=u.toLowerCase(),o=c.toLowerCase(),r=n.startsWith(t),l=o.startsWith(t);if(r!==l)return r?-1:1;if(r&&l){if(n.length<o.length)return-1;if(n.length>o.length)return 1}return 0}e.compareByPrefix=p}),define(ge[97],pe([0,1,96,94,8,9,10]),function(Q,e,_,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const k=0,y=[k,[]];function i(x,$,F,U){if(!x||!$)return y;const M=x.length,N=$.length;if(M<N)return y;const O=x.toLowerCase();return!U&&!O.includes(F)?y:R($,F,N,x,O,M)}e.scoreFuzzy=i;function R(x,$,F,U,M,N){const O=[],V=[];for(let we=0;we<F;we++){const Ae=we*N,Pe=Ae-N,Fe=we>0,z=x[we],Y=$[we];for(let te=0;te<N;te++){const ae=te>0,fe=Ae+te,De=fe-1,Me=Pe+te-1,be=ae?O[De]:0,ke=Fe&&ae?O[Me]:0,Re=Fe&&ae?V[Me]:0;let Be;!ke&&Fe?Be=0:Be=C(z,Y,U,M,te,Re),Be&&ke+Be>=be?(V[fe]=Re+1,O[fe]=ke+Be):(V[fe]=k,O[fe]=be)}}const q=[];let J=F-1,me=N-1;for(;J>=0&&me>=0;){const we=J*N+me;V[we]===k||(q.push(me),J--),me--}return[O[F*N-1],q.reverse()]}function C(x,$,F,U,M,N){let O=0;if(!w($,U[M]))return O;if(O+=1,N>0&&(O+=N*5),x===F[M]&&(O+=1),M===0)O+=8;else{const V=m(F.charCodeAt(M-1));V?O+=V:(0,P.isUpper)(F.charCodeAt(M))&&(O+=2)}return O}function w(x,$){return x===$?!0:x==="/"||x==="\\"?$==="/"||$==="\\":!1}function m(x){switch(x){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const s=[void 0,[]];function d(x,$,F=0,U=0){const M=$;return M.values&&M.values.length>1?S(x,M.values,F,U):v(x,$,F,U)}e.scoreFuzzy2=d;function S(x,$,F,U){let M=0;const N=[];for(const O of $){const[V,q]=v(x,O,F,U);if(typeof V!="number")return s;M+=V,N.push(...q)}return[M,a(N)]}function v(x,$,F,U){const M=(0,P.fuzzyScore)($.original,$.originalLowercase,F,x,x.toLowerCase(),U,!0);return M?[M[0],(0,P.createMatches)(M)]:s}const b=Object.freeze({score:0}),p=1<<18,u=1<<17,c=1<<16;function t(x,$,F,U,M){if(!x||!$.normalized)return b;const N=U.getItemLabel(x);if(!N)return b;const O=U.getItemDescription(x);let V;O?V=`${N}${O}${$.normalized}${Array.isArray($.values)?$.values.length:""}${F}`:V=`${N}${$.normalized}${Array.isArray($.values)?$.values.length:""}${F}`;const q=M[V];if(q)return q;const J=n(N,O,U.getItemPath(x),$,F);return M[V]=J,J}e.scoreItemFuzzy=t;function n(x,$,F,U,M){const N=!F||!U.containsPathSeparator;return F&&(I.isLinux?U.pathNormalized===F:(0,D.equalsIgnoreCase)(U.pathNormalized,F))?{score:p,labelMatch:[{start:0,end:x.length}],descriptionMatch:$?[{start:0,end:$.length}]:void 0}:U.values&&U.values.length>1?o(x,$,F,U.values,N,M):r(x,$,F,U,N,M)}function o(x,$,F,U,M,N){let O=0;const V=[],q=[];for(const J of U){const{score:me,labelMatch:we,descriptionMatch:Ae}=r(x,$,F,J,M,N);if(me===k)return b;O+=me,we&&V.push(...we),Ae&&q.push(...Ae)}return{score:O,labelMatch:a(V),descriptionMatch:a(q)}}function r(x,$,F,U,M,N){if(M||!$){const[O,V]=i(x,U.normalized,U.normalizedLowercase,N);if(O){const q=(0,P.matchesPrefix)(U.normalized,x);let J;return q?(J=u,J+=Math.round(U.normalized.length/x.length*100)):J=c,{score:J+O,labelMatch:q||l(V)}}}if($){let O=$;F&&(O=`${$}${T.sep}`);const V=O.length,q=`${O}${x}`,[J,me]=i(q,U.normalized,U.normalizedLowercase,N);if(J){const we=l(me),Ae=[],Pe=[];return we.forEach(Fe=>{Fe.start<V&&Fe.end>V?(Ae.push({start:0,end:Fe.end-V}),Pe.push({start:Fe.start,end:V})):Fe.start>=V?Ae.push({start:Fe.start-V,end:Fe.end-V}):Pe.push(Fe)}),{score:J,labelMatch:Ae,descriptionMatch:Pe}}}return b}function l(x){const $=[];if(!x)return $;let F;for(const U of x)F&&F.end===U?F.end+=1:(F={start:U,end:U+1},$.push(F));return $}function a(x){const $=x.sort((M,N)=>M.start-N.start),F=[];let U;for(const M of $)!U||!g(U,M)?(U=M,F.push(M)):(U.start=Math.min(U.start,M.start),U.end=Math.max(U.end,M.end));return F}function g(x,$){return!(x.end<$.start||$.end<x.start)}function E(x,$,F,U,M,N){const O=t(x,F,U,M,N),V=t($,F,U,M,N),q=O.score,J=V.score;if((q===p||J===p)&&q!==J)return q===p?-1:1;if(q>c||J>c){if(q!==J)return q>J?-1:1;if(q<u&&J<u){const Y=h(O.labelMatch,V.labelMatch);if(Y!==0)return Y}const Fe=M.getItemLabel(x)||"",z=M.getItemLabel($)||"";if(Fe.length!==z.length)return Fe.length-z.length}if(q!==J)return q>J?-1:1;const me=Array.isArray(O.labelMatch)&&O.labelMatch.length>0,we=Array.isArray(V.labelMatch)&&V.labelMatch.length>0;if(me&&!we)return-1;if(we&&!me)return 1;const Ae=f(x,O,M),Pe=f($,V,M);return Ae&&Pe&&Ae!==Pe?Pe>Ae?-1:1:A(x,$,F,M)}e.compareItemsByFuzzyScore=E;function f(x,$,F){let U=-1,M=-1;if($.descriptionMatch&&$.descriptionMatch.length?U=$.descriptionMatch[0].start:$.labelMatch&&$.labelMatch.length&&(U=$.labelMatch[0].start),$.labelMatch&&$.labelMatch.length){if(M=$.labelMatch[$.labelMatch.length-1].end,$.descriptionMatch&&$.descriptionMatch.length){const N=F.getItemDescription(x);N&&(M+=N.length)}}else $.descriptionMatch&&$.descriptionMatch.length&&(M=$.descriptionMatch[$.descriptionMatch.length-1].end);return M-U}function h(x,$){if(!x&&!$||(!x||!x.length)&&(!$||!$.length))return 0;if(!$||!$.length)return-1;if(!x||!x.length)return 1;const F=x[0].start,M=x[x.length-1].end-F,N=$[0].start,V=$[$.length-1].end-N;return M===V?0:V<M?1:-1}function A(x,$,F,U){const M=U.getItemLabel(x)||"",N=U.getItemLabel($)||"",O=U.getItemDescription(x),V=U.getItemDescription($),q=M.length+(O?O.length:0),J=N.length+(V?V.length:0);if(q!==J)return q-J;const me=U.getItemPath(x),we=U.getItemPath($);return me&&we&&me.length!==we.length?me.length-we.length:M!==N?(0,_.compareAnything)(M,N,F.normalized):O&&V&&O!==V?(0,_.compareAnything)(O,V,F.normalized):me&&we&&me!==we?(0,_.compareAnything)(me,we,F.normalized):0}const L=" ";function B(x){typeof x!="string"&&(x="");const $=x.toLowerCase(),{pathNormalized:F,normalized:U,normalizedLowercase:M}=ee(x),N=F.indexOf(T.sep)>=0;let O;const V=x.split(L);if(V.length>1)for(const q of V){const{pathNormalized:J,normalized:me,normalizedLowercase:we}=ee(q);me&&(O||(O=[]),O.push({original:q,originalLowercase:q.toLowerCase(),pathNormalized:J,normalized:me,normalizedLowercase:we}))}return{original:x,originalLowercase:$,pathNormalized:F,normalized:U,normalizedLowercase:M,values:O,containsPathSeparator:N}}e.prepareQuery=B;function ee(x){let $;I.isWindows?$=x.replace(/\//g,T.sep):$=x.replace(/\\/g,T.sep);const F=(0,D.stripWildcards)($).replace(/\s/g,"");return{pathNormalized:$,normalized:F,normalizedLowercase:F.toLowerCase()}}function j(x){return Array.isArray(x)?B(x.map($=>$.original).join(L)):B(x.original)}e.pieceToQuery=j}),define(ge[33],pe([0,1,10,30,8,24,19]),function(Q,e,_,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const y="**",i="/",R="[/\\\\]",C="[^/\\\\]",w=/\//g;function m(O){switch(O){case 0:return"";case 1:return`${C}*?`;default:return`(?:${R}|${C}+${R}|${R}${C}+)*?`}}function s(O,V){if(!O)return[];const q=[];let J=!1,me=!1,we="";for(const Ae of O){switch(Ae){case V:if(!J&&!me){q.push(we),we="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":me=!0;break;case"]":me=!1;break}we+=Ae}return we&&q.push(we),q}e.splitGlobAware=s;function d(O){if(!O)return"";let V="";const q=s(O,i);if(q.every(J=>J===y))V=".*";else{let J=!1;q.forEach((me,we)=>{if(me===y){J||(V+=m(2),J=!0);return}let Ae=!1,Pe="",Fe=!1,z="";for(const Y of me){if(Y!=="}"&&Ae){Pe+=Y;continue}if(Fe&&(Y!=="]"||!z)){let te;Y==="-"?te=Y:(Y==="^"||Y==="!")&&!z?te="^":Y===i?te="":te=_.escapeRegExpCharacters(Y),z+=te;continue}switch(Y){case"{":Ae=!0;continue;case"[":Fe=!0;continue;case"}":V+=`(?:${s(Pe,",").map(fe=>d(fe)).join("|")})`,Ae=!1,Pe="";break;case"]":V+="["+z+"]",Fe=!1,z="";break;case"?":V+=C;continue;case"*":V+=m(1);continue;default:V+=_.escapeRegExpCharacters(Y)}}we<q.length-1&&(q[we+1]!==y||we+2<q.length)&&(V+=R),J=!1})}return V}const S=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,p=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.LRUCache(1e4),n=function(){return!1},o=function(){return null};function r(O,V){if(!O)return o;let q;typeof O!="string"?q=O.pattern:q=O,q=q.trim();const J=`${q}_${!!V.trimForExclusions}`;let me=t.get(J);if(me)return l(me,O);let we;if(S.test(q)){const Ae=q.substr(4);me=function(Pe,Fe){return typeof Pe=="string"&&Pe.endsWith(Ae)?q:null}}else(we=v.exec(a(q,V)))?me=g(we[1],q):(V.trimForExclusions?p:b).test(q)?me=E(q,V):(we=u.exec(a(q,V)))?me=f(we[1].substr(1),q,!0):(we=c.exec(a(q,V)))?me=f(we[1],q,!1):me=h(q);return t.set(J,me),l(me,O)}function l(O,V){return typeof V=="string"?O:function(q,J){return P.isEqualOrParent(q,V.base)?O(T.relative(V.base,q),J):null}}function a(O,V){return V.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function g(O,V){const q=`/${O}`,J=`\\${O}`,me=function(Ae,Pe){return typeof Ae!="string"?null:Pe?Pe===O?V:null:Ae===O||Ae.endsWith(q)||Ae.endsWith(J)?V:null},we=[O];return me.basenames=we,me.patterns=[V],me.allBasenames=we,me}function E(O,V){const q=N(O.slice(1,-1).split(",").map(Pe=>r(Pe,V)).filter(Pe=>Pe!==o),O),J=q.length;if(!J)return o;if(J===1)return q[0];const me=function(Pe,Fe){for(let z=0,Y=q.length;z<Y;z++)if(q[z](Pe,Fe))return O;return null},we=q.find(Pe=>!!Pe.allBasenames);we&&(me.allBasenames=we.allBasenames);const Ae=q.reduce((Pe,Fe)=>Fe.allPaths?Pe.concat(Fe.allPaths):Pe,[]);return Ae.length&&(me.allPaths=Ae),me}function f(O,V,q){const J=T.sep===T.posix.sep,me=J?O:O.replace(w,T.sep),we=T.sep+me,Ae=T.posix.sep+O,Pe=q?function(Fe,z){return typeof Fe=="string"&&(Fe===me||Fe.endsWith(we)||!J&&(Fe===O||Fe.endsWith(Ae)))?V:null}:function(Fe,z){return typeof Fe=="string"&&(Fe===me||!J&&Fe===O)?V:null};return Pe.allPaths=[(q?"*/":"./")+O],Pe}function h(O){try{const V=new RegExp(`^${d(O)}$`);return function(q){return V.lastIndex=0,typeof q=="string"&&V.test(q)?O:null}}catch(V){return o}}function A(O,V,q){return!O||typeof V!="string"?!1:L(O)(V,void 0,q)}e.match=A;function L(O,V={}){if(!O)return n;if(typeof O=="string"||x(O)){const q=r(O,V);if(q===o)return n;const J=function(me,we){return!!q(me,we)};return q.allBasenames&&(J.allBasenames=q.allBasenames),q.allPaths&&(J.allPaths=q.allPaths),J}return U(O,V)}e.parse=L;function B(O){if(!!O){let V;return q=>(V||(V=(O()||Promise.resolve([])).then(J=>J?j(J):{})),V.then(J=>!!J[q]))}}e.hasSiblingPromiseFn=B;function ee(O){if(!!O){let V;return q=>{if(!V){const J=O();V=J?j(J):{}}return!!V[q]}}}e.hasSiblingFn=ee;function j(O){const V={};for(const q of O)V[q]=!0;return V}function x(O){const V=O;return V&&typeof V.base=="string"&&typeof V.pattern=="string"}e.isRelativePattern=x;function $(O){return O.allBasenames||[]}e.getBasenameTerms=$;function F(O){return O.allPaths||[]}e.getPathTerms=F;function U(O,V){const q=N(Object.getOwnPropertyNames(O).map(Pe=>M(Pe,O[Pe],V)).filter(Pe=>Pe!==o)),J=q.length;if(!J)return o;if(!q.some(Pe=>!!Pe.requiresSiblings)){if(J===1)return q[0];const Pe=function(Y,te){for(let ae=0,fe=q.length;ae<fe;ae++){const De=q[ae](Y,te);if(De)return De}return null},Fe=q.find(Y=>!!Y.allBasenames);Fe&&(Pe.allBasenames=Fe.allBasenames);const z=q.reduce((Y,te)=>te.allPaths?Y.concat(te.allPaths):Y,[]);return z.length&&(Pe.allPaths=z),Pe}const me=function(Pe,Fe,z){let Y;for(let te=0,ae=q.length;te<ae;te++){const fe=q[te];fe.requiresSiblings&&z&&(Fe||(Fe=T.basename(Pe)),Y||(Y=Fe.substr(0,Fe.length-T.extname(Pe).length)));const De=fe(Pe,Fe,Y,z);if(De)return De}return null},we=q.find(Pe=>!!Pe.allBasenames);we&&(me.allBasenames=we.allBasenames);const Ae=q.reduce((Pe,Fe)=>Fe.allPaths?Pe.concat(Fe.allPaths):Pe,[]);return Ae.length&&(me.allPaths=Ae),me}function M(O,V,q){if(V===!1)return o;const J=r(O,q);if(J===o)return o;if(typeof V=="boolean")return J;if(V){const me=V.when;if(typeof me=="string"){const we=(Ae,Pe,Fe,z)=>{if(!z||!J(Ae,Pe))return null;const Y=me.replace("$(basename)",Fe),te=z(Y);return(0,D.isThenable)(te)?te.then(ae=>ae?O:null):te?O:null};return we.requiresSiblings=!0,we}}return J}function N(O,V){const q=O.filter(Pe=>!!Pe.basenames);if(q.length<2)return O;const J=q.reduce((Pe,Fe)=>{const z=Fe.basenames;return z?Pe.concat(z):Pe},[]);let me;if(V){me=[];for(let Pe=0,Fe=J.length;Pe<Fe;Pe++)me.push(V)}else me=q.reduce((Pe,Fe)=>{const z=Fe.patterns;return z?Pe.concat(z):Pe},[]);const we=function(Pe,Fe){if(typeof Pe!="string")return null;if(!Fe){let Y;for(Y=Pe.length;Y>0;Y--){const te=Pe.charCodeAt(Y-1);if(te===47||te===92)break}Fe=Pe.substr(Y)}const z=J.indexOf(Fe);return z!==-1?me[z]:null};we.basenames=J,we.patterns=me,we.allBasenames=J;const Ae=O.filter(Pe=>!Pe.basenames);return Ae.push(we),Ae}}),define(ge[75],pe([0,1,2,8,10,11,9,25,30]),function(Q,e,_,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function i(r,l,a){if(typeof r=="string"&&(r=_.URI.file(r)),a){const E=a.getWorkspaceFolder(r);if(E){const f=a.getWorkspace().folders.length>1;let h;if((0,k.isEqual)(E.uri,r)?h="":h=(0,k.relativePath)(E.uri,r),f){const A=E.name?E.name:(0,k.basename)(E.uri);h=h?A+" \u2022 "+h:A}return h}}if(r.scheme!==I.Schemas.file&&r.scheme!==I.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(r.fsPath))return(0,P.normalize)(C(r.fsPath));let g=(0,P.normalize)(r.fsPath);return!D.isWindows&&(l==null?void 0:l.userHome)&&(g=m(g,l.userHome.fsPath)),g}e.getPathLabel=i;function R(r){if(!!r){typeof r=="string"&&(r=_.URI.file(r));const l=(0,k.basename)(r)||(r.scheme===I.Schemas.file?r.fsPath:r.path);return D.isWindows&&(0,y.isRootOrDriveLetter)(l)?C(l):l}}e.getBaseLabel=R;function C(r){return(0,y.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=C;let w=Object.create(null);function m(r,l){if(D.isWindows||!r||!l)return r;let a=w.original===l?w.normalized:void 0;return a||(a=`${(0,T.rtrim)(l,P.posix.sep)}${P.posix.sep}`,w={original:l,normalized:a}),(D.isLinux?r.startsWith(a):(0,T.startsWithIgnoreCase)(r,a))&&(r=`~/${r.substr(a.length)}`),r}e.tildify=m;function s(r,l){return r.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=s;const d="\u2026",S="\\\\",v="~";function b(r,l=P.sep){const a=new Array(r.length);let g=!1;for(let E=0;E<r.length;E++){let f=r[E];if(f===""){a[E]=`.${l}`;continue}if(!f){a[E]=f;continue}g=!0;let h="";f.indexOf(S)===0?(h=f.substr(0,f.indexOf(S)+S.length),f=f.substr(f.indexOf(S)+S.length)):f.indexOf(l)===0?(h=f.substr(0,f.indexOf(l)+l.length),f=f.substr(f.indexOf(l)+l.length)):f.indexOf(v)===0&&(h=f.substr(0,f.indexOf(v)+v.length),f=f.substr(f.indexOf(v)+v.length));const A=f.split(l);for(let L=1;g&&L<=A.length;L++)for(let B=A.length-L;g&&B>=0;B--){g=!1;let ee=A.slice(B,B+L).join(l);for(let j=0;!g&&j<r.length;j++)if(j!==E&&r[j]&&r[j].indexOf(ee)>-1){const x=B+L===A.length,$=B>0&&r[j].indexOf(l)>-1?l+ee:ee,F=r[j].endsWith($);g=!x||F}if(!g){let j="";(A[0].endsWith(":")||h!=="")&&(B===1&&(B=0,L++,ee=A[0]+l+ee),B>0&&(j=A[0]+l),j=h+j),B>0&&(j=j+d+l),j=j+ee,B+L<A.length&&(j=j+l+d),a[E]=j}}g&&(a[E]=f)}return a}e.shorten=b;var p;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function u(r,l=Object.create(null)){const a=[];let g=!1,E="";for(const f of r)if(f==="$"||g&&f==="{")E&&a.push({value:E,type:p.TEXT}),E="",g=!0;else if(f==="}"&&g){const h=l[E];if(typeof h=="string")h.length&&a.push({value:h,type:p.VARIABLE});else if(h){const A=a[a.length-1];(!A||A.type!==p.SEPARATOR)&&a.push({value:h.label,type:p.SEPARATOR})}E="",g=!1}else E+=f;return E&&!g&&a.push({value:E,type:p.TEXT}),a.filter((f,h)=>{if(f.type===p.SEPARATOR){const A=a[h-1],L=a[h+1];return[A,L].every(B=>B&&(B.type===p.VARIABLE||B.type===p.TEXT)&&B.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=u;function c(r,l){return D.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):r.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function t(r,l){return D.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,""):D.isWindows?r.replace(/&&|&/g,a=>a==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=n;function o(r){const l=r.indexOf("/")!==-1?P.posix:P.win32,a=l.basename(r),g=l.dirname(r);return a.length?{name:a,parentPath:g}:{name:g,parentPath:""}}e.splitName=o}),define(ge[98],pe([0,1,2]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function P(R){return R.toJSON()}class T{constructor(C){this._uriTransformer=C}transformIncoming(C){const w=this._uriTransformer.transformIncoming(C);return w===C?C:P(_.URI.from(w))}transformOutgoing(C){const w=this._uriTransformer.transformOutgoing(C);return w===C?C:P(_.URI.from(w))}transformOutgoingURI(C){const w=this._uriTransformer.transformOutgoing(C);return w===C?C:_.URI.from(w)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function I(R,C,w){if(!R||w>200)return null;if(typeof R=="object"){if(R instanceof _.URI)return C.transformOutgoing(R);for(let m in R)if(Object.hasOwnProperty.call(R,m)){const s=I(R[m],C,w+1);s!==null&&(R[m]=s)}}return null}function D(R,C){const w=I(R,C,0);return w===null?R:w}e.transformOutgoingURIs=D;function k(R,C,w,m){if(!R||m>200)return null;if(typeof R=="object"){if(R.$mid===1)return w?_.URI.revive(C.transformIncoming(R)):C.transformIncoming(R);for(let s in R)if(Object.hasOwnProperty.call(R,s)){const d=k(R[s],C,w,m+1);d!==null&&(R[s]=d)}}return null}function y(R,C){const w=k(R,C,!1,0);return w===null?R:w}e.transformIncomingURIs=y;function i(R,C){const w=k(R,C,!0,0);return w===null?R:w}e.transformAndReviveIncomingURIs=i}),define(ge[28],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const _=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(y){return _.test(y)}e.isUUID=P;const T=new Uint8Array(16),I=[];for(let y=0;y<256;y++)I.push(y.toString(16).padStart(2,"0"));let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(y){for(let i=0;i<y.length;i++)y[i]=Math.floor(Math.random()*256);return y};function k(){D(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let y=0,i="";return i+=I[T[y++]],i+=I[T[y++]],i+=I[T[y++]],i+=I[T[y++]],i+="-",i+=I[T[y++]],i+=I[T[y++]],i+="-",i+=I[T[y++]],i+=I[T[y++]],i+="-",i+=I[T[y++]],i+=I[T[y++]],i+="-",i+=I[T[y++]],i+=I[T[y++]],i+=I[T[y++]],i+=I[T[y++]],i+=I[T[y++]],i+=I[T[y++]],i}e.generateUuid=k}),define(ge[136],pe([0,1,99]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class P{constructor(I="utf8"){this.stringDecoder=new _.StringDecoder(I),this.remaining=null}write(I){const D=[],k=this.remaining?this.remaining+this.stringDecoder.write(I):this.stringDecoder.write(I);if(k.length<1)return D;let y=0,i,R=y;for(;R<k.length;)if(i=k.charCodeAt(R),i===13||i===10){if(D.push(k.substring(y,R)),R++,R<k.length){const C=i;i=k.charCodeAt(R),(C===13&&i===10||C===10&&i===13)&&R++}y=R}else R++;return this.remaining=y<k.length?k.substr(y):null,D}end(){return this.remaining}}e.LineDecoder=P}),define(ge[26],pe([0,1,37,48,8,19,9,30,28,74,25,2]),function(Q,e,_,P,T,I,D,k,y,i,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var w;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function m($,F=w.UNLINK){if((0,k.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return F===w.UNLINK?d($):s($)}e.rimraf=m;async function s($){try{const F=(0,T.join)((0,P.tmpdir)(),(0,y.generateUuid)());try{await _.promises.rename($,F)}catch(U){return d($)}d(F).catch(U=>{})}catch(F){if(F.code!=="ENOENT")throw F}}async function d($){return _.promises.rmdir($,{recursive:!0,maxRetries:3})}function S($){if((0,k.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");_.rmdirSync($,{recursive:!0})}e.rimrafSync=S;async function v($,F){return u(await(F?b($):_.promises.readdir($)))}e.readdir=v;async function b($){try{return await _.promises.readdir($,{withFileTypes:!0})}catch(M){console.warn("[node.js fs] readdir with filetypes failed with error: ",M)}const F=[],U=await v($);for(const M of U){let N=!1,O=!1,V=!1;try{const q=await _.promises.lstat((0,T.join)($,M));N=q.isFile(),O=q.isDirectory(),V=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}F.push({name:M,isFile:()=>N,isDirectory:()=>O,isSymbolicLink:()=>V})}return F}function p($){return u(_.readdirSync($))}e.readdirSync=p;function u($){return $.map(F=>typeof F=="string"?D.isMacintosh?(0,i.normalizeNFC)(F):F:(F.name=D.isMacintosh?(0,i.normalizeNFC)(F.name):F.name,F))}async function c($){const F=await v($),U=[];for(const M of F)await n.existsDirectory((0,T.join)($,M))&&U.push(M);return U}e.readDirsInDir=c;function t($,F=1e3){return new Promise(U=>{let M=!1;const N=setInterval(()=>{M||(M=!0,_.access($,O=>{M=!1,O&&(clearInterval(N),U(void 0))}))},F)})}e.whenDeleted=t;var n;(function($){async function F(N){let O;try{if(O=await _.promises.lstat(N),!O.isSymbolicLink())return{stat:O}}catch(V){}try{return{stat:await _.promises.stat(N),symbolicLink:(O==null?void 0:O.isSymbolicLink())?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(D.isWindows&&V.code==="EACCES")try{return{stat:await _.promises.stat(await _.promises.readlink(N)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw q}throw V}}$.stat=F;async function U(N){try{const{stat:O,symbolicLink:V}=await $.stat(N);return O.isFile()&&(V==null?void 0:V.dangling)!==!0}catch(O){}return!1}$.existsFile=U;async function M(N){try{const{stat:O,symbolicLink:V}=await $.stat(N);return O.isDirectory()&&(V==null?void 0:V.dangling)!==!0}catch(O){}return!1}$.existsDirectory=M})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new I.ResourceQueue;function r($,F,U){return o.queueFor(C.URI.file($),R.extUriBiasedIgnorePathCase).queue(()=>{const M=E(U);return new Promise((N,O)=>a($,F,M,V=>V?O(V):N()))})}e.writeFile=r;let l=!0;function a($,F,U,M){if(!l)return _.writeFile($,F,{mode:U.mode,flag:U.flag},M);_.open($,U.flag,U.mode,(N,O)=>{if(N)return M(N);_.writeFile(O,F,V=>{if(V)return _.close(O,()=>M(V));_.fdatasync(O,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),l=!1),_.close(O,J=>M(J))))})})}function g($,F,U){const M=E(U);if(!l)return _.writeFileSync($,F,{mode:M.mode,flag:M.flag});const N=_.openSync($,M.flag,M.mode);try{_.writeFileSync(N,F);try{_.fdatasyncSync(N)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),l=!1}}finally{_.closeSync(N)}}e.writeFileSync=g;function E($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function f($,F){if($!==F){async function U(M){try{const N=await _.promises.lstat(M);if(N.isDirectory()||N.isSymbolicLink())return;const O=await _.promises.open(M,"a");try{await O.utimes(N.atime,new Date)}finally{await O.close()}}catch(N){}}try{await _.promises.rename($,F),await U(F)}catch(M){if($.toLowerCase()!==F.toLowerCase()&&M.code==="EXDEV"||$.endsWith("."))await h($,F,{preserveSymlinks:!1}),await m($,w.MOVE),await U(F);else throw M}}}e.move=f;async function h($,F,U){return L($,F,{root:{source:$,target:F},options:U,handledSourcePaths:new Set})}e.copy=h;const A=511;async function L($,F,U){if(!U.handledSourcePaths.has($)){U.handledSourcePaths.add($);const{stat:M,symbolicLink:N}=await n.stat($);if(N){if(U.options.preserveSymlinks)try{return await j($,F,U)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(N.dangling)return}return M.isDirectory()?B($,F,M.mode&A,U):ee($,F,M.mode&A)}}async function B($,F,U,M){await _.promises.mkdir(F,{recursive:!0,mode:U});const N=await v($);for(const O of N)await L((0,T.join)($,O),(0,T.join)(F,O),M)}async function ee($,F,U){await _.promises.copyFile($,F),await _.promises.chmod(F,U)}async function j($,F,U){let M=await _.promises.readlink($);(0,k.isEqualOrParent)(M,U.root.source,!D.isLinux)&&(M=(0,T.join)(U.root.target,M.substr(U.root.source.length+1))),await _.promises.symlink(M,F)}async function x($){try{return await _.promises.access($),!0}catch(F){return!1}}e.exists=x}),define(ge[100],pe([0,1,37,284,10,8,26]),function(Q,e,_,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function k(C){const w=(0,I.dirname)(C);if(C===w)return C;const m=((0,I.basename)(C)||C).toLowerCase();try{const d=(0,D.readdirSync)(w).filter(S=>S.toLowerCase()===m);if(d.length===1){const S=k(w);if(S)return(0,I.join)(S,d[0])}else if(d.length>1){const S=d.indexOf(m);if(S>=0){const v=k(w);if(v)return(0,I.join)(v,d[S])}}}catch(s){}return null}e.realcaseSync=k;async function y(C){try{return await(0,P.promisify)(_.realpath)(C)}catch(w){const m=R(C);return await _.promises.access(m,_.constants.R_OK),m}}e.realpath=y;function i(C){try{return _.realpathSync(C)}catch(w){const m=R(C);return _.accessSync(m,_.constants.R_OK),m}}e.realpathSync=i;function R(C){return(0,T.rtrim)((0,I.normalize)(C),I.sep)}});var bt=this&&this.__await||function(Q){return this instanceof bt?(this.v=Q,this):new bt(Q)},Tn=this&&this.__asyncGenerator||function(Q,e,_){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var P=_.apply(Q,e||[]),T,I=[];return T={},D("next"),D("throw"),D("return"),T[Symbol.asyncIterator]=function(){return this},T;function D(w){P[w]&&(T[w]=function(m){return new Promise(function(s,d){I.push([w,m,s,d])>1||k(w,m)})})}function k(w,m){try{y(P[w](m))}catch(s){C(I[0][3],s)}}function y(w){w.value instanceof bt?Promise.resolve(w.value.v).then(i,R):C(I[0][2],w)}function i(w){k("next",w)}function R(w){k("throw",w)}function C(w,m){w(m),I.shift(),I.length&&k(I[0][0],I[0][1])}},rn=this&&this.__asyncValues||function(Q){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=Q[Symbol.asyncIterator],_;return e?e.call(Q):(Q=typeof __values=="function"?__values(Q):Q[Symbol.iterator](),_={},P("next"),P("throw"),P("return"),_[Symbol.asyncIterator]=function(){return this},_);function P(I){_[I]=Q[I]&&function(D){return new Promise(function(k,y){D=Q[I](D),T(k,y,D.done,D.value)})}}function T(I,D,k,y){Promise.resolve(y).then(function(i){I({value:i,done:k})},D)}};define(ge[101],pe([0,1,26,48,8]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const I=/^\d+$/,D=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var y;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(y||(y={}));let i;switch(process.arch){case"ia32":case"x32":i=1;break;case"arm":case"arm64":i=2;break;default:i=0;break}let R;process.env.PROCESSOR_ARCHITEW6432?R=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?R=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?R=1:R=0;class C{constructor(c,t,n){this.exePath=c,this.displayName=t,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await _.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function w({useAlternateBitness:u=!1}={}){return u?i===0?process.env["ProgramFiles(x86)"]||null:R===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:u=!1,findPreview:c=!1}={}){const t=w({useAlternateBitness:u});if(!t)return null;const n=T.join(t,"PowerShell");if(!await _.SymlinkSupport.existsDirectory(n))return null;let o=-1,r=null;for(const g of await _.readdir(n)){let E=-1;if(c){const h=g.indexOf("-");if(h<0)continue;const A=g.substring(0,h);if(!I.test(A)||g.substring(h+1)!=="preview")continue;E=parseInt(A,10)}else{if(!I.test(g))continue;E=parseInt(g,10)}if(!(E<=o)){const f=T.join(n,g,"pwsh.exe");!await _.SymlinkSupport.existsFile(f)||(r=f,o=E)}}if(!r)return null;const l=t.includes("x86")?" (x86)":"",a=c?" Preview":"";return new C(r,`PowerShell${a}${l}`,!0)}async function s({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const c=T.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await _.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=u?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const o of await _.readdir(c))if(t.test(o)){const r=T.join(c,o,"pwsh.exe");return new C(r,n)}return null}function d(){const u=T.join(P.homedir(),".dotnet","tools","pwsh.exe");return new C(u,".NET Core PowerShell Global Tool")}function S(){const u=T.join(process.env.windir,i===1&&R!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(u,"Windows PowerShell",!0)}function v(){return Tn(this,arguments,function*(){let c=yield bt(m());c&&(yield yield bt(c)),c=yield bt(m({useAlternateBitness:!0})),c&&(yield yield bt(c)),c=yield bt(s()),c&&(yield yield bt(c)),c=d(),c&&(yield yield bt(c)),c=yield bt(m({findPreview:!0})),c&&(yield yield bt(c)),c=yield bt(s({findPreview:!0})),c&&(yield yield bt(c)),c=yield bt(m({useAlternateBitness:!0,findPreview:!0})),c&&(yield yield bt(c)),c=S(),c&&(yield yield bt(c))})}function b(){return Tn(this,arguments,function*(){var c,t;try{for(var n=rn(v()),o;o=yield bt(n.next()),!o.done;){const r=o.value;(yield bt(r.exists()))&&(yield yield bt(r))}}catch(r){c={error:r}}finally{try{o&&!o.done&&(t=n.return)&&(yield bt(t.call(n)))}finally{if(c)throw c.error}}})}e.enumeratePowerShellInstallations=b;async function p(){var u,c;try{for(var t=rn(b()),n;n=await t.next(),!n.done;)return n.value}catch(o){u={error:o}}finally{try{n&&!n.done&&(c=t.return)&&await c.call(t)}finally{if(u)throw u.error}}return null}e.getFirstAvailablePowerShellInstallation=p}),define(ge[102],pe([0,1,3,6,19,21,18,22,14,15,57,10]),function(Q,e,_,P,T,I,D,k,y,i,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var w;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(w=e.RequestType||(e.RequestType={}));function m(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(s=e.ResponseType||(e.ResponseType={}));function d(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(S||(S={}));class v{constructor(N){this.buffer=N,this.pos=0}read(N){const O=this.buffer.slice(this.pos,this.pos+N);return this.pos+=O.byteLength,O}}class b{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var p;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(p||(p={}));function u(M){const N=k.VSBuffer.alloc(4);return N.writeUInt32BE(M,0),N}function c(M){return M.read(4).readUInt32BE(0)}function t(M){const N=k.VSBuffer.alloc(1);return N.writeUInt8(M,0),N}const n={Undefined:t(p.Undefined),String:t(p.String),Buffer:t(p.Buffer),VSBuffer:t(p.VSBuffer),Array:t(p.Array),Object:t(p.Object)},o=typeof Buffer!="undefined";function r(M,N){if(typeof N=="undefined")M.write(n.Undefined);else if(typeof N=="string"){const O=k.VSBuffer.fromString(N);M.write(n.String),M.write(u(O.byteLength)),M.write(O)}else if(o&&Buffer.isBuffer(N)){const O=k.VSBuffer.wrap(N);M.write(n.Buffer),M.write(u(O.byteLength)),M.write(O)}else if(N instanceof k.VSBuffer)M.write(n.VSBuffer),M.write(u(N.byteLength)),M.write(N);else if(Array.isArray(N)){M.write(n.Array),M.write(u(N.length));for(const O of N)r(M,O)}else{const O=k.VSBuffer.fromString(JSON.stringify(N));M.write(n.Object),M.write(u(O.byteLength)),M.write(O)}}function l(M){switch(M.read(1).readUInt8(0)){case p.Undefined:return;case p.String:return M.read(c(M)).toString();case p.Buffer:return M.read(c(M)).buffer;case p.VSBuffer:return M.read(c(M));case p.Array:{const O=c(M),V=[];for(let q=0;q<O;q++)V.push(l(M));return V}case p.Object:return JSON.parse(M.read(c(M)).toString())}}class a{constructor(N,O,V=null,q=1e3){this.protocol=N,this.ctx=O,this.logger=V,this.timeoutDelay=q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(J=>this.onRawMessage(J)),this.sendResponse({type:200})}registerChannel(N,O){this.channels.set(N,O),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const O=this.send([N.type]);this.logger&&this.logger.logOutgoing(O,0,1,d(N.type));return}case 201:case 202:case 204:case 203:{const O=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(O,N.id,1,d(N.type),N.data);return}}}send(N,O=void 0){const V=new b;return r(V,N),r(V,O),this.sendBuffer(V.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(O){return 0}}onRawMessage(N){const O=new v(N),V=l(O),q=l(O),J=V[0];switch(J){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${m(J)}: ${V[2]}.${V[3]}`,q),this.onPromise({type:J,id:V[1],channelName:V[2],name:V[3],arg:q});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${m(J)}: ${V[2]}.${V[3]}`,q),this.onEventListen({type:J,id:V[1],channelName:V[2],name:V[3],arg:q});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${m(J)}`),this.disposeActiveRequest({type:J,id:V[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${m(J)}`),this.disposeActiveRequest({type:J,id:V[1]})}}onPromise(N){const O=this.channels.get(N.channelName);if(!O){this.collectPendingRequest(N);return}const V=new I.CancellationTokenSource;let q;try{q=O.call(this.ctx,N.name,N.arg,V.token)}catch(we){q=Promise.reject(we)}const J=N.id;q.then(we=>{this.sendResponse({id:J,data:we,type:201}),this.activeRequests.delete(N.id)},we=>{we instanceof Error?this.sendResponse({id:J,data:{message:we.message,name:we.name,stack:we.stack?we.stack.split?we.stack.split(`
`):we.stack:void 0},type:202}):this.sendResponse({id:J,data:we,type:203}),this.activeRequests.delete(N.id)});const me=(0,P.toDisposable)(()=>V.cancel());this.activeRequests.set(N.id,me)}onEventListen(N){const O=this.channels.get(N.channelName);if(!O){this.collectPendingRequest(N);return}const V=N.id,J=O.listen(this.ctx,N.name,N.arg)(me=>this.sendResponse({id:V,data:me,type:204}));this.activeRequests.set(N.id,J)}disposeActiveRequest(N){const O=this.activeRequests.get(N.id);O&&(O.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let O=this.pendingRequests.get(N.channelName);O||(O=[],this.pendingRequests.set(N.channelName,O));const V=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:N,timeoutTimer:V})}flushPendingRequests(N){const O=this.pendingRequests.get(N);if(O){for(const V of O)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=a;var g;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(N,O=null){this.protocol=N,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=O}getChannel(N){const O=this;return{call(V,q,J){return O.isDisposed?Promise.reject(D.canceled()):O.requestPromise(N,V,q,J)},listen(V,q){return O.isDisposed?Promise.reject(D.canceled()):O.requestEvent(N,V,q)}}}requestPromise(N,O,V,q=I.CancellationToken.None){const J=this.lastRequestId++,we={id:J,type:100,channelName:N,name:O,arg:V};if(q.isCancellationRequested)return Promise.reject(D.canceled());let Ae;return new Promise((Fe,z)=>{if(q.isCancellationRequested)return z(D.canceled());const Y=()=>{const De=Me=>{switch(Me.type){case 201:this.handlers.delete(J),Fe(Me.data);break;case 202:this.handlers.delete(J);const be=new Error(Me.data.message);be.stack=Me.data.stack,be.name=Me.data.name,z(be);break;case 203:this.handlers.delete(J),z(Me.data);break}};this.handlers.set(J,De),this.sendRequest(we)};let te=null;this.state===S.Idle?Y():(te=(0,T.createCancelablePromise)(De=>this.whenInitialized()),te.then(()=>{te=null,Y()}));const ae=()=>{te?(te.cancel(),te=null):this.sendRequest({id:J,type:101}),z(D.canceled())},fe=q.onCancellationRequested(ae);Ae=(0,P.combinedDisposable)((0,P.toDisposable)(ae),fe),this.activeRequests.add(Ae)}).finally(()=>{this.activeRequests.delete(Ae)})}requestEvent(N,O,V){const q=this.lastRequestId++,me={id:q,type:102,channelName:N,name:O,arg:V};let we=null;const Ae=new _.Emitter({onFirstListenerAdd:()=>{we=(0,T.createCancelablePromise)(Fe=>this.whenInitialized()),we.then(()=>{we=null,this.activeRequests.add(Ae),this.sendRequest(me)})},onLastListenerRemove:()=>{we?(we.cancel(),we=null):(this.activeRequests.delete(Ae),this.sendRequest({id:q,type:103}))}}),Pe=Fe=>Ae.fire(Fe.data);return this.handlers.set(q,Pe),Ae.event}sendRequest(N){switch(N.type){case 100:case 102:{const O=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(O,N.id,0,`${m(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const O=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(O,N.id,0,m(N.type));return}}}send(N,O=void 0){const V=new b;return r(V,N),r(V,O),this.sendBuffer(V.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(O){return 0}}onBuffer(N){const O=new v(N),V=l(O),q=l(O),J=V[0];switch(J){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,d(J)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],0,d(J),q),this.onResponse({type:V[0],id:V[1],data:q})}}onResponse(N){if(N.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(N.id);O&&O(N)}whenInitialized(){return this.state===S.Idle?Promise.resolve():_.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelClient=E;class f{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:O,onDidClientDisconnect:V})=>{_.Event.once(O.onMessage)(J=>{const me=new v(J),we=l(me),Ae=new a(O,we),Pe=new E(O);this.channels.forEach((z,Y)=>Ae.registerChannel(Y,z));const Fe={channelServer:Ae,channelClient:Pe,ctx:we};this._connections.add(Fe),this._onDidAddConnection.fire(Fe),V(()=>{Ae.dispose(),Pe.dispose(),this._connections.delete(Fe),this._onDidRemoveConnection.fire(Fe)})})})}get connections(){const N=[];return this._connections.forEach(O=>N.push(O)),N}getChannel(N,O){const V=this;return{call(q,J,me){let we;if((0,i.isFunction)(O)){let Pe=(0,y.getRandomElement)(V.connections.filter(O));we=Pe?Promise.resolve(Pe):_.Event.toPromise(_.Event.filter(V.onDidAddConnection,O))}else we=O.routeCall(V,q,J);const Ae=we.then(Pe=>Pe.channelClient.getChannel(N));return A(Ae).call(q,J,me)},listen(q,J){if((0,i.isFunction)(O))return V.getMulticastEvent(N,O,q,J);const me=O.routeEvent(V,q,J).then(we=>we.channelClient.getChannel(N));return A(me).listen(q,J)}}}getMulticastEvent(N,O,V,q){const J=this;let me=new P.DisposableStore;const we=new _.Emitter({onFirstListenerAdd:()=>{me=new P.DisposableStore;const Ae=new _.EventMultiplexer,Pe=new Map,Fe=Y=>{const ae=Y.channelClient.getChannel(N).listen(V,q),fe=Ae.add(ae);Pe.set(Y,fe)},z=Y=>{const te=Pe.get(Y);!te||(te.dispose(),Pe.delete(Y))};J.connections.filter(O).forEach(Fe),_.Event.filter(J.onDidAddConnection,O)(Fe,void 0,me),J.onDidRemoveConnection(z,void 0,me),Ae.event(we.fire,we,me),me.add(Ae)},onLastListenerRemove:()=>{me.dispose()}});return we.event}registerChannel(N,O){this.channels.set(N,O),this._connections.forEach(V=>{V.channelServer.registerChannel(N,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=f;class h{constructor(N,O,V=null){const q=new b;r(q,O),N.send(q.buffer),this.channelClient=new E(N,V),this.channelServer=new a(N,O,V)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,O){this.channelServer.registerChannel(N,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=h;function A(M){return{call(N,O,V){return M.then(q=>q.call(N,O,V))},listen(N,O){const V=new _.Relay;return M.then(q=>V.input=q.listen(N,O)),V.event}}}e.getDelayedChannel=A;function L(M){let N=!1;return{call(O,V,q){return N?M.call(O,V,q):(0,T.timeout)(0).then(()=>N=!0).then(()=>M.call(O,V,q))},listen(O,V){if(N)return M.listen(O,V);const q=new _.Relay;return(0,T.timeout)(0).then(()=>N=!0).then(()=>q.input=M.listen(O,V)),q.event}}}e.getNextTickChannel=L;class B{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const O of N.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await _.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=B;var ee;(function(M){function N(q,J){const me=q,we=J&&J.disableMarshalling,Ae=new Map;for(const Pe in me)V(Pe)&&Ae.set(Pe,_.Event.buffer(me[Pe],!0));return new class{listen(Pe,Fe){const z=Ae.get(Fe);if(z)return z;throw new Error(`Event not found: ${Fe}`)}call(Pe,Fe,z){const Y=me[Fe];if(typeof Y=="function"){if(!we&&Array.isArray(z))for(let te=0;te<z.length;te++)z[te]=(0,R.revive)(z[te]);return Y.apply(me,z)}throw new Error(`Method not found: ${Fe}`)}}}M.fromService=N;function O(q,J){const me=J&&J.disableMarshalling;return new Proxy({},{get(we,Ae){var Pe;if(typeof Ae=="string")return((Pe=J==null?void 0:J.properties)===null||Pe===void 0?void 0:Pe.has(Ae))?J.properties.get(Ae):V(Ae)?q.listen(Ae):async function(...Fe){let z;J&&!(0,i.isUndefinedOrNull)(J.context)?z=[J.context,...Fe]:z=Fe;const Y=await q.call(Ae,z);return me?Y:(0,R.revive)(Y)};throw new Error(`Property not found: ${String(Ae)}`)}})}M.toService=O;function V(q){return q[0]==="o"&&q[1]==="n"&&C.isUpperAsciiLetter(q.charCodeAt(2))}})(ee=e.ProxyChannel||(e.ProxyChannel={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let N=M.toString();if(N!=="[object Object]")return N}return M}function $(M){return Array.isArray(M)?M.map(x):x(M)}function F(M,N,O,V,q,J,me){me=$(me);const we=j[q],Ae=we[V%we.length];let Pe=[`%c[${M}]%c[${String(N).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${Ae}`];/\($/.test(J)?(Pe=Pe.concat(me),Pe.push(")")):Pe.push(me),console.log.apply(console,Pe)}e.logWithColors=F;class U{constructor(N,O){this._outgoingPrefix=N,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,O,V,q,J){this._totalOutgoing+=N,F(this._outgoingPrefix,this._totalOutgoing,N,O,V,q,J)}logIncoming(N,O,V,q,J){this._totalIncoming+=N,F(this._incomingPrefix,this._totalIncoming,N,O,V,q,J)}}e.IPCLogger=U}),define(ge[103],pe([0,1,3,102,6,22,9,36]),function(Q,e,_,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let y=null;function i(){return y||(y=I.VSBuffer.alloc(0)),y}class R{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,r){if(o===0)return i();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const E=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=o),E}if(this._chunks[0].byteLength>o){const E=this._chunks[0].slice(0,o);return r&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),E}let l=I.VSBuffer.alloc(o),a=0,g=0;for(;o>0;){const E=this._chunks[g];if(E.byteLength>o){const f=E.slice(0,o);l.set(f,a),a+=o,r&&(this._chunks[g]=E.slice(o),this._totalLength-=o),o-=o}else l.set(E,a),a+=E.byteLength,r?(this._chunks.shift(),this._totalLength-=E.byteLength):g++,o-=E.byteLength}return l}}e.ChunkStream=R;var C;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(C||(C={}));var w;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class m{constructor(o,r,l,a){this.type=o,this.id=r,this.ack=l,this.data=a,this.writtenTime=0}get size(){return this.data.byteLength}}class s extends T.Disposable{constructor(o){super();this._onMessage=this._register(new _.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new R,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5);else{const l=this._state.messageType,a=this._state.id,g=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new m(l,a,g,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(!this._isDisposed){o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=I.VSBuffer.alloc(13);r.writeUInt8(o.type,0),r.writeUInt32BE(o.id,1),r.writeUInt32BE(o.ack,5),r.writeUInt32BE(o.data.byteLength,9),this._writeSoon(r,o.data)}}_bufferAdd(o,r){const l=this._totalLength===0;return this._data.push(o,r),this._totalLength+=o.byteLength+r.byteLength,l}_bufferTake(){const o=I.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,r){this._bufferAdd(o,r)&&D.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class S extends T.Disposable{constructor(o){super();this._onMessage=new _.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new s(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new m(1,0,0,o))}}e.Protocol=S;class v extends P.IPCClient{constructor(o,r,l=null){super(o,r,l);this.protocol=o}static fromSocket(o,r){return new v(new S(o),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=v;class b{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new _.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,k.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=b;class p{constructor(o){this.data=o,this.next=null}}class u{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],r=0,l=this._first;for(;l;)o[r++]=l.data,l=l.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const r=new p(o);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class c{constructor(){this.lastRuns=[];const o=Date.now();for(let r=0;r<c._HISTORY_LENGTH;r++)this.lastRuns[r]=o-1e3*r;setInterval(()=>{for(let r=c._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return c._INSTANCE||(c._INSTANCE=new c),c._INSTANCE}load(){const o=Date.now(),r=(1+c._HISTORY_LENGTH)*1e3;let l=0;for(let a=0;a<c._HISTORY_LENGTH;a++)o-this.lastRuns[a]<=r&&l++;return 1-l/c._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}c._HISTORY_LENGTH=10,c._INSTANCE=null;class t{constructor(o,r=null){this._loadEstimator=c.getInstance(),this._onControlMessage=new b,this.onControlMessage=this._onControlMessage.event,this._onMessage=new b,this.onMessage=this._onMessage.event,this._onDidDispose=new b,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new b,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new b,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new s(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),r&&this._socketReader.acceptChunk(r),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,T.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new m(5,0,0,i());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const r=new m(4,0,0,i());this._socketWriter.write(r),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,r){this._isReconnecting=!0,this._socketDisposables=(0,T.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new s(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let r=0,l=o.length;r<l;r++)this._socketWriter.write(o[r]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new m(6,0,0,i())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const r=this._outgoingUnackMsg.toArray();for(let l=0,a=r.length;l<a;l++)this._socketWriter.write(r[l]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new m(1,r,this._incomingAckId,o);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(o){const r=new m(2,0,0,o);this._socketWriter.write(r)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const o=this._outgoingUnackMsg.peek(),r=Date.now()-o.writtenTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-r,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const o=new m(3,0,this._incomingAckId,i());this._socketWriter.write(o)}}}e.PersistentProtocol=t}),define(ge[104],pe([0,1,93]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class P{constructor(k){let y=(0,_.toUint8)(k);this._defaultValue=y,this._asciiMap=P._createAsciiMap(y),this._map=new Map}static _createAsciiMap(k){let y=new Uint8Array(256);for(let i=0;i<256;i++)y[i]=k;return y}set(k,y){let i=(0,_.toUint8)(y);k>=0&&k<256?this._asciiMap[k]=i:this._map.set(k,i)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=P;var T;(function(D){D[D.False=0]="False",D[D.True=1]="True"})(T||(T={}));class I{constructor(){this._actual=new P(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=I}),define(ge[137],pe([0,1,104]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var P;(function(D){D[D.Regular=0]="Regular",D[D.Whitespace=1]="Whitespace",D[D.WordSeparator=2]="WordSeparator"})(P=e.WordCharacterClass||(e.WordCharacterClass={}));class T extends _.CharacterClassifier{constructor(k){super(0);for(let y=0,i=k.length;y<i;y++)this.set(k.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=T;function I(D){let k={};return y=>(k.hasOwnProperty(y)||(k[y]=D(y)),k[y])}e.getMapForWordSeparators=I(D=>new T(D))}),define(ge[49],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class _{constructor(T,I){this.lineNumber=T,this.column=I}with(T=this.lineNumber,I=this.column){return T===this.lineNumber&&I===this.column?this:new _(T,I)}delta(T=0,I=0){return this.with(this.lineNumber+T,this.column+I)}equals(T){return _.equals(this,T)}static equals(T,I){return!T&&!I?!0:!!T&&!!I&&T.lineNumber===I.lineNumber&&T.column===I.column}isBefore(T){return _.isBefore(this,T)}static isBefore(T,I){return T.lineNumber<I.lineNumber?!0:I.lineNumber<T.lineNumber?!1:T.column<I.column}isBeforeOrEqual(T){return _.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,I){return T.lineNumber<I.lineNumber?!0:I.lineNumber<T.lineNumber?!1:T.column<=I.column}static compare(T,I){let D=T.lineNumber|0,k=I.lineNumber|0;if(D===k){let y=T.column|0,i=I.column|0;return y-i}return D-k}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new _(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}}e.Position=_}),define(ge[44],pe([0,1,49]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class P{constructor(I,D,k,y){I>k||I===k&&D>y?(this.startLineNumber=k,this.startColumn=y,this.endLineNumber=I,this.endColumn=D):(this.startLineNumber=I,this.startColumn=D,this.endLineNumber=k,this.endColumn=y)}isEmpty(){return P.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return P.containsPosition(this,I)}static containsPosition(I,D){return!(D.lineNumber<I.startLineNumber||D.lineNumber>I.endLineNumber||D.lineNumber===I.startLineNumber&&D.column<I.startColumn||D.lineNumber===I.endLineNumber&&D.column>I.endColumn)}containsRange(I){return P.containsRange(this,I)}static containsRange(I,D){return!(D.startLineNumber<I.startLineNumber||D.endLineNumber<I.startLineNumber||D.startLineNumber>I.endLineNumber||D.endLineNumber>I.endLineNumber||D.startLineNumber===I.startLineNumber&&D.startColumn<I.startColumn||D.endLineNumber===I.endLineNumber&&D.endColumn>I.endColumn)}strictContainsRange(I){return P.strictContainsRange(this,I)}static strictContainsRange(I,D){return!(D.startLineNumber<I.startLineNumber||D.endLineNumber<I.startLineNumber||D.startLineNumber>I.endLineNumber||D.endLineNumber>I.endLineNumber||D.startLineNumber===I.startLineNumber&&D.startColumn<=I.startColumn||D.endLineNumber===I.endLineNumber&&D.endColumn>=I.endColumn)}plusRange(I){return P.plusRange(this,I)}static plusRange(I,D){let k,y,i,R;return D.startLineNumber<I.startLineNumber?(k=D.startLineNumber,y=D.startColumn):D.startLineNumber===I.startLineNumber?(k=D.startLineNumber,y=Math.min(D.startColumn,I.startColumn)):(k=I.startLineNumber,y=I.startColumn),D.endLineNumber>I.endLineNumber?(i=D.endLineNumber,R=D.endColumn):D.endLineNumber===I.endLineNumber?(i=D.endLineNumber,R=Math.max(D.endColumn,I.endColumn)):(i=I.endLineNumber,R=I.endColumn),new P(k,y,i,R)}intersectRanges(I){return P.intersectRanges(this,I)}static intersectRanges(I,D){let k=I.startLineNumber,y=I.startColumn,i=I.endLineNumber,R=I.endColumn,C=D.startLineNumber,w=D.startColumn,m=D.endLineNumber,s=D.endColumn;return k<C?(k=C,y=w):k===C&&(y=Math.max(y,w)),i>m?(i=m,R=s):i===m&&(R=Math.min(R,s)),k>i||k===i&&y>R?null:new P(k,y,i,R)}equalsRange(I){return P.equalsRange(this,I)}static equalsRange(I,D){return!!I&&!!D&&I.startLineNumber===D.startLineNumber&&I.startColumn===D.startColumn&&I.endLineNumber===D.endLineNumber&&I.endColumn===D.endColumn}getEndPosition(){return P.getEndPosition(this)}static getEndPosition(I){return new _.Position(I.endLineNumber,I.endColumn)}getStartPosition(){return P.getStartPosition(this)}static getStartPosition(I){return new _.Position(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,D){return new P(this.startLineNumber,this.startColumn,I,D)}setStartPosition(I,D){return new P(I,D,this.endLineNumber,this.endColumn)}collapseToStart(){return P.collapseToStart(this)}static collapseToStart(I){return new P(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}static fromPositions(I,D=I){return new P(I.lineNumber,I.column,D.lineNumber,D.column)}static lift(I){return I?new P(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,D){return!(I.endLineNumber<D.startLineNumber||I.endLineNumber===D.startLineNumber&&I.endColumn<D.startColumn||D.endLineNumber<I.startLineNumber||D.endLineNumber===I.startLineNumber&&D.endColumn<I.startColumn)}static areIntersecting(I,D){return!(I.endLineNumber<D.startLineNumber||I.endLineNumber===D.startLineNumber&&I.endColumn<=D.startColumn||D.endLineNumber<I.startLineNumber||D.endLineNumber===I.startLineNumber&&D.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,D){if(I&&D){const i=I.startLineNumber|0,R=D.startLineNumber|0;if(i===R){const C=I.startColumn|0,w=D.startColumn|0;if(C===w){const m=I.endLineNumber|0,s=D.endLineNumber|0;if(m===s){const d=I.endColumn|0,S=D.endColumn|0;return d-S}return m-s}return C-w}return i-R}return(I?1:0)-(D?1:0)}static compareRangesUsingEnds(I,D){return I.endLineNumber===D.endLineNumber?I.endColumn===D.endColumn?I.startLineNumber===D.startLineNumber?I.startColumn-D.startColumn:I.startLineNumber-D.startLineNumber:I.endColumn-D.endColumn:I.endLineNumber-D.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}}e.Range=P}),define(ge[138],pe([0,1,49,44]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var T;(function(D){D[D.LTR=0]="LTR",D[D.RTL=1]="RTL"})(T=e.SelectionDirection||(e.SelectionDirection={}));class I extends P.Range{constructor(k,y,i,R){super(k,y,i,R);this.selectionStartLineNumber=k,this.selectionStartColumn=y,this.positionLineNumber=i,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return I.selectionsEqual(this,k)}static selectionsEqual(k,y){return k.selectionStartLineNumber===y.selectionStartLineNumber&&k.selectionStartColumn===y.selectionStartColumn&&k.positionLineNumber===y.positionLineNumber&&k.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,y){return this.getDirection()===0?new I(this.startLineNumber,this.startColumn,k,y):new I(k,y,this.startLineNumber,this.startColumn)}getPosition(){return new _.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(k,y){return this.getDirection()===0?new I(k,y,this.endLineNumber,this.endColumn):new I(this.endLineNumber,this.endColumn,k,y)}static fromPositions(k,y=k){return new I(k.lineNumber,k.column,y.lineNumber,y.column)}static liftSelection(k){return new I(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,y){if(k&&!y||!k&&y)return!1;if(!k&&!y)return!0;if(k.length!==y.length)return!1;for(let i=0,R=k.length;i<R;i++)if(!this.selectionsEqual(k[i],y[i]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,y,i,R,C){return C===0?new I(k,y,i,R):new I(i,R,k,y)}}e.Selection=I}),define(ge[105],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var _;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(_=e.OverviewRulerLane||(e.OverviewRulerLane={}));var P;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(P=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var I;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(I=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var D;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(D=e.EndOfLineSequence||(e.EndOfLineSequence={}));class k{constructor(s){this.tabSize=Math.max(1,s.tabSize|0),this.indentSize=s.tabSize|0,this.insertSpaces=Boolean(s.insertSpaces),this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=Boolean(s.trimAutoWhitespace)}equals(s){return this.tabSize===s.tabSize&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}e.TextModelResolvedOptions=k;class y{constructor(s,d){this.range=s,this.matches=d}}e.FindMatch=y;var i;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(i=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var R;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(R=e.ModelConstants||(e.ModelConstants={}));class C{constructor(s,d,S,v,b,p){this.identifier=s,this.range=d,this.text=S,this.forceMoveMarkers=v,this.isAutoWhitespaceEdit=b,this._isTracked=p}}e.ValidAnnotatedEditOperation=C;class w{constructor(s,d,S){this.reverseEdits=s,this.changes=d,this.trimAutoWhitespaceLineNumbers=S}}e.ApplyEditsResult=w}),define(ge[139],pe([0,1,10,137,49,44,105]),function(Q,e,_,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class y{constructor(p,u,c,t){this.searchString=p,this.isRegex=u,this.matchCase=c,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let p;this.isRegex?p=i(this.searchString):p=this.searchString.indexOf(`
`)>=0;let u=null;try{u=_.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:p,global:!0,unicode:!0})}catch(t){return null}if(!u)return null;let c=!this.isRegex&&!p;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new R(u,this.wordSeparators?(0,P.getMapForWordSeparators)(this.wordSeparators):null,c?this.searchString:null)}}e.SearchParams=y;function i(b){if(!b||b.length===0)return!1;for(let p=0,u=b.length;p<u;p++)if(b.charCodeAt(p)===92){if(p++,p>=u)break;const t=b.charCodeAt(p);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=i;class R{constructor(p,u,c){this.regex=p,this.wordSeparators=u,this.simpleSearch=c}}e.SearchData=R;function C(b,p,u){if(!u)return new D.FindMatch(b,null);let c=[];for(let t=0,n=p.length;t<n;t++)c[t]=p[t];return new D.FindMatch(b,c)}e.createFindMatch=C;class w{constructor(p){let u=[],c=0;for(let t=0,n=p.length;t<n;t++)p.charCodeAt(t)===10&&(u[c++]=t);this._lineFeedsOffsets=u}findLineFeedCountBeforeOffset(p){const u=this._lineFeedsOffsets;let c=0,t=u.length-1;if(t===-1||p<=u[0])return 0;for(;c<t;){const n=c+((t-c)/2>>0);u[n]>=p?t=n-1:u[n+1]>=p?(c=n,t=n):c=n+1}return c+1}}class m{static findMatches(p,u,c,t,n){const o=u.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(p,c,new v(o.wordSeparators,o.regex),t,n):this._doFindMatchesLineByLine(p,c,o,t,n):[]}static _getMultilineMatchRange(p,u,c,t,n,o){let r,l=0;t?(l=t.findLineFeedCountBeforeOffset(n),r=u+n+l):r=u+n;let a;if(t){let h=t.findLineFeedCountBeforeOffset(n+o.length)-l;a=r+o.length+h}else a=r+o.length;const g=p.getPositionAt(r),E=p.getPositionAt(a);return new I.Range(g.lineNumber,g.column,E.lineNumber,E.column)}static _doFindMatchesMultiline(p,u,c,t,n){const o=p.getOffsetAt(u.getStartPosition()),r=p.getValueInRange(u,1),l=p.getEOL()===`\r
`?new w(r):null,a=[];let g=0,E;for(c.reset(0);E=c.next(r);)if(a[g++]=C(this._getMultilineMatchRange(p,o,r,l,E.index,E[0]),E,t),g>=n)return a;return a}static _doFindMatchesLineByLine(p,u,c,t,n){const o=[];let r=0;if(u.startLineNumber===u.endLineNumber){const a=p.getLineContent(u.startLineNumber).substring(u.startColumn-1,u.endColumn-1);return r=this._findMatchesInLine(c,a,u.startLineNumber,u.startColumn-1,r,o,t,n),o}const l=p.getLineContent(u.startLineNumber).substring(u.startColumn-1);r=this._findMatchesInLine(c,l,u.startLineNumber,u.startColumn-1,r,o,t,n);for(let a=u.startLineNumber+1;a<u.endLineNumber&&r<n;a++)r=this._findMatchesInLine(c,p.getLineContent(a),a,0,r,o,t,n);if(r<n){const a=p.getLineContent(u.endLineNumber).substring(0,u.endColumn-1);r=this._findMatchesInLine(c,a,u.endLineNumber,0,r,o,t,n)}return o}static _findMatchesInLine(p,u,c,t,n,o,r,l){const a=p.wordSeparators;if(!r&&p.simpleSearch){const f=p.simpleSearch,h=f.length,A=u.length;let L=-h;for(;(L=u.indexOf(f,L+h))!==-1;)if((!a||S(a,u,A,L,h))&&(o[n++]=new D.FindMatch(new I.Range(c,L+1+t,c,L+1+h+t),null),n>=l))return n;return n}const g=new v(p.wordSeparators,p.regex);let E;g.reset(0);do if(E=g.next(u),E&&(o[n++]=C(new I.Range(c,E.index+1+t,c,E.index+1+E[0].length+t),E,r),n>=l))return n;while(E);return n}static findNextMatch(p,u,c,t){const n=u.parseSearchRequest();if(!n)return null;const o=new v(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(p,c,o,t):this._doFindNextMatchLineByLine(p,c,o,t)}static _doFindNextMatchMultiline(p,u,c,t){const n=new T.Position(u.lineNumber,1),o=p.getOffsetAt(n),r=p.getLineCount(),l=p.getValueInRange(new I.Range(n.lineNumber,n.column,r,p.getLineMaxColumn(r)),1),a=p.getEOL()===`\r
`?new w(l):null;c.reset(u.column-1);let g=c.next(l);return g?C(this._getMultilineMatchRange(p,o,l,a,g.index,g[0]),g,t):u.lineNumber!==1||u.column!==1?this._doFindNextMatchMultiline(p,new T.Position(1,1),c,t):null}static _doFindNextMatchLineByLine(p,u,c,t){const n=p.getLineCount(),o=u.lineNumber,r=p.getLineContent(o),l=this._findFirstMatchInLine(c,r,o,u.column,t);if(l)return l;for(let a=1;a<=n;a++){const g=(o+a-1)%n,E=p.getLineContent(g+1),f=this._findFirstMatchInLine(c,E,g+1,1,t);if(f)return f}return null}static _findFirstMatchInLine(p,u,c,t,n){p.reset(t-1);const o=p.next(u);return o?C(new I.Range(c,o.index+1,c,o.index+1+o[0].length),o,n):null}static findPreviousMatch(p,u,c,t){const n=u.parseSearchRequest();if(!n)return null;const o=new v(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(p,c,o,t):this._doFindPreviousMatchLineByLine(p,c,o,t)}static _doFindPreviousMatchMultiline(p,u,c,t){const n=this._doFindMatchesMultiline(p,new I.Range(1,1,u.lineNumber,u.column),c,t,10*k);if(n.length>0)return n[n.length-1];const o=p.getLineCount();return u.lineNumber!==o||u.column!==p.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(p,new T.Position(o,p.getLineMaxColumn(o)),c,t):null}static _doFindPreviousMatchLineByLine(p,u,c,t){const n=p.getLineCount(),o=u.lineNumber,r=p.getLineContent(o).substring(0,u.column-1),l=this._findLastMatchInLine(c,r,o,t);if(l)return l;for(let a=1;a<=n;a++){const g=(n+o-a-1)%n,E=p.getLineContent(g+1),f=this._findLastMatchInLine(c,E,g+1,t);if(f)return f}return null}static _findLastMatchInLine(p,u,c,t){let n=null,o;for(p.reset(0);o=p.next(u);)n=C(new I.Range(c,o.index+1,c,o.index+1+o[0].length),o,t);return n}}e.TextModelSearch=m;function s(b,p,u,c,t){if(c===0)return!0;const n=p.charCodeAt(c-1);if(b.get(n)!==0||n===13||n===10)return!0;if(t>0){const o=p.charCodeAt(c);if(b.get(o)!==0)return!0}return!1}function d(b,p,u,c,t){if(c+t===u)return!0;const n=p.charCodeAt(c+t);if(b.get(n)!==0||n===13||n===10)return!0;if(t>0){const o=p.charCodeAt(c+t-1);if(b.get(o)!==0)return!0}return!1}function S(b,p,u,c,t){return s(b,p,u,c,t)&&d(b,p,u,c,t)}e.isValidMatch=S;class v{constructor(p,u){this._wordSeparators=p,this._searchRegex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(p){this._searchRegex.lastIndex=p,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(p){const u=p.length;let c;do{if(this._prevMatchStartIndex+this._prevMatchLength===u||(c=this._searchRegex.exec(p),!c))return null;const t=c.index,n=c[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){_.getNextCodePoint(p,u,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||S(this._wordSeparators,p,u,t,n))return c}while(c);return null}}e.Searcher=v}),define(ge[106],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function _(k=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const i of e.USUAL_WORD_SEPARATORS)k.indexOf(i)>=0||(y+="\\"+i);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=_();function P(k){let y=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)y=k;else{let i="g";k.ignoreCase&&(i+="i"),k.multiline&&(i+="m"),k.unicode&&(i+="u"),y=new RegExp(k.source,i)}return y.lastIndex=0,y}e.ensureValidWordDefinition=P;const T={maxLen:1e3,windowSize:15,timeBudget:150};function I(k,y,i,R,C=T){if(i.length>C.maxLen){let S=k-C.maxLen/2;return S<0?S=0:R+=S,i=i.substring(S,k+C.maxLen/2),I(k,y,i,R,C)}const w=Date.now(),m=k-1-R;let s=-1,d=null;for(let S=1;!(Date.now()-w>=C.timeBudget);S++){const v=m-C.windowSize*S;y.lastIndex=Math.max(0,v);const b=D(y,i,m,s);if(!b&&d||(d=b,v<=0))break;s=v}if(d){let S={word:d[0],startColumn:R+1+d.index,endColumn:R+1+d.index+d[0].length};return y.lastIndex=0,S}return null}e.getWordAtText=I;function D(k,y,i,R){let C;for(;C=k.exec(y);){const w=C.index||0;if(w<=i&&k.lastIndex>=i)return C;if(R>0&&w>R)return null}return null}}),define(ge[140],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var _;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(_=e.IndentAction||(e.IndentAction={}));class P{constructor(k){if(this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let y=0,i=k.notIn.length;y<i;y++)switch(k.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=P;class T{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of k)I(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),I(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),I(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),I(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&I(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=T;function I(D,k,y){D.has(k)?D.get(k).push(y):D.set(k,[y])}}),define(ge[76],pe([0,1,33,8]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function T(I,D,k,y){if(Array.isArray(I)){let i=0;for(const R of I){const C=T(R,D,k,y);if(C===10)return C;C>i&&(i=C)}return i}else{if(typeof I=="string")return y?I==="*"?5:I===k?10:0:0;if(I){const{language:i,pattern:R,scheme:C,hasAccessToAllModels:w}=I;if(!y&&!w)return 0;let m=0;if(C)if(C===D.scheme)m=10;else if(C==="*")m=5;else return 0;if(i)if(i===k)m=10;else if(i==="*")m=Math.max(m,5);else return 0;if(R){let s;if(typeof R=="string"?s=R:s=Object.assign(Object.assign({},R),{base:(0,P.normalize)(R.base)}),s===D.fsPath||(0,_.match)(s,D.fsPath))m=10;else return 0}return m}else return 0}}e.score=T}),define(ge[141],pe([0,1,104]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var P;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(P=e.State||(e.State={}));class T{constructor(s,d,S){const v=new Uint8Array(s*d);for(let b=0,p=s*d;b<p;b++)v[b]=S;this._data=v,this.rows=s,this.cols=d}get(s,d){return this._data[s*this.cols+d]}set(s,d,S){this._data[s*this.cols+d]=S}}e.Uint8Matrix=T;class I{constructor(s){let d=0,S=0;for(let b=0,p=s.length;b<p;b++){let[u,c,t]=s[b];c>d&&(d=c),u>S&&(S=u),t>S&&(S=t)}d++,S++;let v=new T(S,d,0);for(let b=0,p=s.length;b<p;b++){let[u,c,t]=s[b];v.set(u,c,t)}this._states=v,this._maxCharCode=d}nextState(s,d){return d<0||d>=this._maxCharCode?0:this._states.get(s,d)}}e.StateMachine=I;let D=null;function k(){return D===null&&(D=new I([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),D}var y;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let i=null;function R(){if(i===null){i=new _.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<m.length;d++)i.set(m.charCodeAt(d),1);const s=".,;";for(let d=0;d<s.length;d++)i.set(s.charCodeAt(d),2)}return i}class C{static _createLink(s,d,S,v,b){let p=b-1;do{const u=d.charCodeAt(p);if(s.get(u)!==2)break;p--}while(p>v);if(v>0){const u=d.charCodeAt(v-1),c=d.charCodeAt(p);(u===40&&c===41||u===91&&c===93||u===123&&c===125)&&p--}return{range:{startLineNumber:S,startColumn:v+1,endLineNumber:S,endColumn:p+2},url:d.substring(v,p+1)}}static computeLinks(s,d=k()){const S=R();let v=[];for(let b=1,p=s.getLineCount();b<=p;b++){const u=s.getLineContent(b),c=u.length;let t=0,n=0,o=0,r=1,l=!1,a=!1,g=!1,E=!1;for(;t<c;){let f=!1;const h=u.charCodeAt(t);if(r===13){let A;switch(h){case 40:l=!0,A=0;break;case 41:A=l?0:1;break;case 91:g=!0,a=!0,A=0;break;case 93:g=!1,A=a?0:1;break;case 123:E=!0,A=0;break;case 125:A=E?0:1;break;case 39:A=o===34||o===96?0:1;break;case 34:A=o===39||o===96?0:1;break;case 96:A=o===39||o===34?0:1;break;case 42:A=o===42?1:0;break;case 124:A=o===124?1:0;break;case 32:A=g?0:1;break;default:A=S.get(h)}A===1&&(v.push(C._createLink(S,u,b,n,t)),f=!0)}else if(r===12){let A;h===91?(a=!0,A=0):A=S.get(h),A===1?f=!0:r=13}else r=d.nextState(r,h),r===0&&(f=!0);f&&(r=1,l=!1,a=!1,E=!1,n=t+1,o=h),t++}r===13&&v.push(C._createLink(S,u,b,n,c))}return v}}e.LinkComputer=C;function w(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:C.computeLinks(m)}e.computeLinks=w}),define(ge[142],pe([0,1,3,6]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class T{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(D){this._onDidChange.fire({changedLanguages:D,changedColorMap:!1})}register(D,k){return this._map.set(D,k),this.fire([D]),(0,P.toDisposable)(()=>{this._map.get(D)===k&&(this._map.delete(D),this.fire([D]))})}registerPromise(D,k){let y=null,i=!1;return this._promises.set(D,k.then(R=>{this._promises.delete(D),!(i||!R)&&(y=this.register(D,R))})),(0,P.toDisposable)(()=>{i=!0,y&&y.dispose()})}getPromise(D){const k=this.get(D);if(k)return Promise.resolve(k);const y=this._promises.get(D);return y?y.then(i=>this.get(D)):null}get(D){return this._map.get(D)||null}setColorMap(D){this._colorMap=D,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=T}),define(ge[107],pe([0,1,22,9]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var T;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(T||(T={}));function I(C){for(let w=0,m=C.length;w<m;w+=4){const s=C[w+0],d=C[w+1],S=C[w+2],v=C[w+3];C[w+0]=v,C[w+1]=S,C[w+2]=d,C[w+3]=s}}function D(C){const w=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return P.isLittleEndian()||I(w),_.VSBuffer.wrap(w)}function k(C){const w=C.buffer;if(P.isLittleEndian()||I(w),w.byteOffset%4==0)return new Uint32Array(w.buffer,w.byteOffset,w.length/4);{const m=new Uint8Array(w.byteLength);return m.set(w),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function y(C){const w=new Uint32Array(i(C));let m=0;if(w[m++]=C.id,C.type==="full")w[m++]=1,w[m++]=C.data.length,w.set(C.data,m),m+=C.data.length;else{w[m++]=2,w[m++]=C.deltas.length;for(const s of C.deltas)w[m++]=s.start,w[m++]=s.deleteCount,s.data?(w[m++]=s.data.length,w.set(s.data,m),m+=s.data.length):w[m++]=0}return D(w)}e.encodeSemanticTokensDto=y;function i(C){let w=0;if(w+=1+1,C.type==="full")w+=1+C.data.length;else{w+=1,w+=(1+1+1)*C.deltas.length;for(const m of C.deltas)m.data&&(w+=m.data.length)}return w}function R(C){const w=k(C);let m=0;const s=w[m++];if(w[m++]===1){const b=w[m++],p=w.subarray(m,m+b);return m+=b,{id:s,type:"full",data:p}}const S=w[m++];let v=[];for(let b=0;b<S;b++){const p=w[m++],u=w[m++],c=w[m++];let t;c>0&&(t=w.subarray(m,m+c),m+=c),v[b]={start:p,deleteCount:u,data:t}}return{id:s,type:"delta",deltas:v}}e.decodeSemanticTokensDto=R}),define(ge[108],pe([0,1,93]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class P{constructor(D,k){this.index=D,this.remainder=k}}e.PrefixSumIndexOfResult=P;class T{constructor(D){this.values=D,this.prefixSum=new Uint32Array(D.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(D,k){D=(0,_.toUint32)(D);const y=this.values,i=this.prefixSum,R=k.length;return R===0?!1:(this.values=new Uint32Array(y.length+R),this.values.set(y.subarray(0,D),0),this.values.set(y.subarray(D),D+R),this.values.set(k,D),D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(i.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(D,k){return D=(0,_.toUint32)(D),k=(0,_.toUint32)(k),this.values[D]===k?!1:(this.values[D]=k,D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),!0)}removeValues(D,k){D=(0,_.toUint32)(D),k=(0,_.toUint32)(k);const y=this.values,i=this.prefixSum;if(D>=y.length)return!1;let R=y.length-D;return k>=R&&(k=R),k===0?!1:(this.values=new Uint32Array(y.length-k),this.values.set(y.subarray(0,D),0),this.values.set(y.subarray(D+k),D),this.prefixSum=new Uint32Array(this.values.length),D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(i.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(D){return D<0?0:(D=(0,_.toUint32)(D),this._getAccumulatedValue(D))}_getAccumulatedValue(D){if(D<=this.prefixSumValidIndex[0])return this.prefixSum[D];let k=this.prefixSumValidIndex[0]+1;k===0&&(this.prefixSum[0]=this.values[0],k++),D>=this.values.length&&(D=this.values.length-1);for(let y=k;y<=D;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],D),this.prefixSum[D]}getIndexOf(D){D=Math.floor(D),this.getTotalValue();let k=0,y=this.values.length-1,i=0,R=0,C=0;for(;k<=y;)if(i=k+(y-k)/2|0,R=this.prefixSum[i],C=R-this.values[i],D<C)y=i-1;else if(D>=R)k=i+1;else break;return new P(i,D-C)}}e.PrefixSumComputer=T}),define(ge[143],pe([0,1,10,49,108]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class I{constructor(k,y,i,R){this._uri=k,this._lines=y,this._eol=i,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const y=k.changes;for(const i of y)this._acceptDeleteRange(i.range),this._acceptInsertText(new P.Position(i.range.startLineNumber,i.range.startColumn),i.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,y=this._lines.length,i=new Uint32Array(y);for(let R=0;R<y;R++)i[R]=this._lines[R].length+k;this._lineStarts=new T.PrefixSumComputer(i)}}_setLineText(k,y){this._lines[k]=y,this._lineStarts&&this._lineStarts.changeValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,y){if(y.length!==0){let i=(0,_.splitLines)(y);if(i.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+i[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}i[i.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+i[0]);let R=new Uint32Array(i.length-1);for(let C=1;C<i.length;C++)this._lines.splice(k.lineNumber+C-1,0,i[C]),R[C-1]=i[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,R)}}}e.MirrorTextModel=I}),define(ge[144],pe([16,17]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(ge[145],pe([0,1,144]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const P=60,T=P*60,I=T*24,D=I*7,k=I*30,y=I*365;function i(C,w){typeof C!="number"&&(C=C.getTime());const m=Math.round((new Date().getTime()-C)/1e3);if(m<-30)return(0,_.localize)(0,null,i(new Date().getTime()+m*1e3,!1));if(m<30)return(0,_.localize)(1,null);let s;return m<P?(s=m,w?s===1?(0,_.localize)(2,null,s):(0,_.localize)(3,null,s):s===1?(0,_.localize)(4,null,s):(0,_.localize)(5,null,s)):m<T?(s=Math.floor(m/P),w?s===1?(0,_.localize)(6,null,s):(0,_.localize)(7,null,s):s===1?(0,_.localize)(8,null,s):(0,_.localize)(9,null,s)):m<I?(s=Math.floor(m/T),w?s===1?(0,_.localize)(10,null,s):(0,_.localize)(11,null,s):s===1?(0,_.localize)(12,null,s):(0,_.localize)(13,null,s)):m<D?(s=Math.floor(m/I),w?s===1?(0,_.localize)(14,null,s):(0,_.localize)(15,null,s):s===1?(0,_.localize)(16,null,s):(0,_.localize)(17,null,s)):m<k?(s=Math.floor(m/D),w?s===1?(0,_.localize)(18,null,s):(0,_.localize)(19,null,s):s===1?(0,_.localize)(20,null,s):(0,_.localize)(21,null,s)):m<y?(s=Math.floor(m/k),w?s===1?(0,_.localize)(22,null,s):(0,_.localize)(23,null,s):s===1?(0,_.localize)(24,null,s):(0,_.localize)(25,null,s)):(s=Math.floor(m/y),w?s===1?(0,_.localize)(26,null,s):(0,_.localize)(27,null,s):s===1?(0,_.localize)(28,null,s):(0,_.localize)(29,null,s))}e.fromNow=i;function R(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(ge[146],pe([16,17]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(ge[58],pe([0,1,146,15,14]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function I(i,R){return R&&(i.stack||i.stacktrace)?_.localize(0,null,k(i),D(i.stack)||D(i.stacktrace)):k(i)}function D(i){return Array.isArray(i)?i.join(`
`):i}function k(i){return typeof i.code=="string"&&typeof i.errno=="number"&&typeof i.syscall=="string"?_.localize(1,null,i.message):i.message||_.localize(2,null)}function y(i=null,R=!1){if(!i)return _.localize(3,null);if(Array.isArray(i)){const C=T.coalesce(i),w=y(C[0],R);return C.length>1?_.localize(4,null,w,C.length):w}if(P.isString(i))return i;if(i.detail){const C=i.detail;if(C.error)return I(C.error,R);if(C.exception)return I(C.exception,R)}return i.stack?I(i,R):i.message?i.message:_.localize(5,null)}e.toErrorMessage=y}),define(ge[147],pe([16,17]),function(Q,e){return Q.create("vs/base/node/processes",e)}),define(ge[77],pe([0,1,8,37,26,38,147,36,15,23,30,9,136,11]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function s(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(c,t){if(C.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};t&&(n.cwd=t);const o=I.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],n);return new Promise(r=>{o.once("error",l=>{r({success:!1,error:l})}),o.once("exit",(l,a)=>{r(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?s(n.status):1})}else if(C.isLinux||C.isMacintosh)try{const n=m.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Q).fsPath;return new Promise(o=>{I.execFile(n,[c.pid.toString()],{encoding:"utf8",shell:!0},(r,l,a)=>{o(r?{success:!1,error:r}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function S(c=k.env){return c.comspec||"cmd.exe"}e.getWindowsShell=S;class v{constructor(t,n,o,r){if(n!==void 0&&o!==void 0&&r!==void 0)this.cmd=t,this.args=n,this.shell=o,this.options=r;else{const l=t;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(k.env).forEach(a=>{l[a]=k.env[a]}),Object.keys(this.options.env).forEach(a=>{l[a]=this.options.env[a]}),this.options.env=l}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const n=t.lastIndexOf(_.sep);return n!==-1&&(t=t.substring(n+1)),v.WellKnowCommands[t]?t:"other"}start(t){return C.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(k.cwd()))?Promise.reject(new Error(D.localize(0,null))):this.useExec().then(n=>{let o,r;const l=new Promise((a,g)=>{o=a,r=g});if(n){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=I.exec(a,this.options,(g,E,f)=>{this.childProcess=null;const h=g;h&&h.killed?r({killed:this.terminateRequested,stdout:E.toString(),stderr:f.toString()}):this.handleExec(o,t,g,E,f)})}else{let a=null;const g=E=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(E,o,t,r);const f={terminated:this.terminateRequested};y.isNumber(E)&&(f.cmdCode=E),o(f)};if(this.shell&&C.isWindows){const E=i.deepClone(this.options);E.windowsVerbatimArguments=!0,E.detached=!1;let f=!1,h=!1;const A=[];let L=this.ensureQuotes(this.cmd);A.push(L.value),f=L.quoted,this.args&&this.args.forEach(ee=>{L=this.ensureQuotes(ee),A.push(L.value),h=h&&L.quoted});const B=["/s","/c"];f?h?B.push('"'+A.join(" ")+'"'):A.length>1?B.push('"'+A[0]+'" '+A.slice(1).join(" ")):B.push('"'+A[0]+'"'):B.push(A.join(" ")),a=I.spawn(S(),B,E)}else this.cmd&&(a=I.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(y.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",E=>{this.childProcess=null,r({terminated:this.terminateRequested,error:E})}),a.pid&&(this.childProcess.on("close",g),this.handleSpawn(a,o,t,r,!0)))}return l})}handleClose(t,n,o,r){}ensureQuotes(t){return v.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,d(t,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!C.isWindows)return t(!1);const n=I.spawn(S(),["/s","/c"]);n.on("error",o=>t(!0)),n.on("exit",o=>t(!1))})}}e.AbstractProcess=v,v.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},v.regexp=/^[^"].* .*[^"]/;class b extends v{constructor(t,n,o,r){super(t,n,o,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,n,o,r,l){[r,l].forEach((a,g)=>{const E=new w.LineDecoder;E.write(a).forEach(A=>{n({line:A,source:g===0?0:1})});const h=E.end();h&&n({line:h,source:g===0?0:1})}),t({terminated:this.terminateRequested,error:o})}handleSpawn(t,n,o,r,l){const a=new w.LineDecoder,g=new w.LineDecoder;t.stdout.on("data",E=>{a.write(E).forEach(h=>o({line:h,source:0}))}),t.stderr.on("data",E=>{g.write(E).forEach(h=>o({line:h,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=g}handleClose(t,n,o,r){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&o({line:l,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&o({line:a,source:1})}}e.LineProcess=b;function p(c){let t=[],n=!1;const o=function(r){if(n){t.push(r);return}(!c.send(r,a=>{if(a&&console.error(a),n=!1,t.length>0){const g=t.slice(0);t=[],g.forEach(E=>o(E))}})||C.isWindows)&&(n=!0)};return{send:o}}e.createQueuedSender=p;var u;(function(c){async function t(n,o,r){if(_.isAbsolute(n))return n;if(o===void 0&&(o=k.cwd()),_.dirname(n)!=="."||(r===void 0&&y.isString(k.env.PATH)&&(r=k.env.PATH.split(_.delimiter)),r===void 0||r.length===0))return _.join(o,n);async function a(g){return await T.exists(g)?!(await P.promises.stat(g)).isDirectory():!1}for(let g of r){let E;if(_.isAbsolute(g)?E=_.join(g,n):E=_.join(o,g,n),await a(E))return E;let f=E+".com";if(await a(f)||(f=E+".exe",await a(f)))return f}return _.join(o,n)}c.findExecutable=t})(u=e.win32||(e.win32={}))}),define(ge[148],pe([0,1,48,9,101,77]),function(Q,e,_,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(m,s){return m===3?P.isWindows?C():I.getWindowsShell(s):i(m,s)}e.getSystemShell=D;function k(m,s){return m===3?P.isWindows?w(s):I.getWindowsShell(s):i(m,s)}e.getSystemShellSync=k;let y=null;function i(m,s){if(P.isLinux&&m===1||P.isMacintosh&&m===2)return"/bin/bash";if(!y){let d;if(P.isWindows)d="/bin/bash";else{if(d=s.SHELL,!d)try{d=_.userInfo().shell}catch(S){}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}y=d}return y}let R=null;async function C(){return R||(R=(await(0,T.getFirstAvailablePowerShellInstallation)()).exePath),R}function w(m){if(R)return R;const s=P.isWindows&&parseFloat(_.release())>=10,d=m.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${m.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return s?S:I.getWindowsShell(m)}}),define(ge[149],pe([16,17]),function(Q,e){return Q.create("vs/editor/common/config/editorOptions",e)}),define(ge[150],pe([0,1,149,9,106]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var I;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(I=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(re){this._values=re}hasChanged(re){return this._values[re]}}e.ConfigurationChangedEvent=D;class k{constructor(){this._values=[]}_read(re){return this._values[re]}get(re){return this._values[re]}_write(re,_e){this._values[re]=_e}}e.ValidatedEditorOptions=k;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class i{constructor(re,_e,Ne,Ve){this.id=re,this.name=_e,this.defaultValue=Ne,this.schema=Ve}compute(re,_e,Ne){return Ne}}class R{constructor(re,_e=null){this.schema=void 0,this.id=re,this.name="_never_",this.defaultValue=void 0,this.deps=_e}validate(re){return this.defaultValue}}class C{constructor(re,_e,Ne,Ve){this.id=re,this.name=_e,this.defaultValue=Ne,this.schema=Ve}validate(re){return typeof re=="undefined"?this.defaultValue:re}compute(re,_e,Ne){return Ne}}function w(X,re){return typeof X=="undefined"?re:X==="false"?!1:Boolean(X)}e.boolean=w;class m extends C{constructor(re,_e,Ne,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="boolean",Ve.default=Ne),super(re,_e,Ne,Ve)}validate(re){return w(re,this.defaultValue)}}class s extends C{constructor(re,_e,Ne,Ve,$e,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="integer",Ze.default=Ne,Ze.minimum=Ve,Ze.maximum=$e),super(re,_e,Ne,Ze),this.minimum=Ve,this.maximum=$e}static clampedInt(re,_e,Ne,Ve){if(typeof re=="undefined")return _e;let $e=parseInt(re,10);return isNaN($e)?_e:($e=Math.max(Ne,$e),$e=Math.min(Ve,$e),$e|0)}validate(re){return s.clampedInt(re,this.defaultValue,this.minimum,this.maximum)}}class d extends C{constructor(re,_e,Ne,Ve,$e){typeof $e!="undefined"&&($e.type="number",$e.default=Ne),super(re,_e,Ne,$e),this.validationFn=Ve}static clamp(re,_e,Ne){return re<_e?_e:re>Ne?Ne:re}static float(re,_e){if(typeof re=="number")return re;if(typeof re=="undefined")return _e;const Ne=parseFloat(re);return isNaN(Ne)?_e:Ne}validate(re){return this.validationFn(d.float(re,this.defaultValue))}}class S extends C{static string(re,_e){return typeof re!="string"?_e:re}constructor(re,_e,Ne,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.default=Ne),super(re,_e,Ne,Ve)}validate(re){return S.string(re,this.defaultValue)}}function v(X,re,_e){return typeof X!="string"||_e.indexOf(X)===-1?re:X}e.stringSet=v;class b extends C{constructor(re,_e,Ne,Ve,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.enum=Ve,$e.default=Ne),super(re,_e,Ne,$e),this._allowedValues=Ve}validate(re){return v(re,this.defaultValue,this._allowedValues)}}class p extends i{constructor(re,_e,Ne,Ve,$e,Ze,K=void 0){typeof K!="undefined"&&(K.type="string",K.enum=$e,K.default=Ve),super(re,_e,Ne,K),this._allowedValues=$e,this._convert=Ze}validate(re){return typeof re!="string"?this.defaultValue:this._allowedValues.indexOf(re)===-1?this.defaultValue:this._convert(re)}}function u(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends i{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[_.localize(0,null),_.localize(1,null),_.localize(2,null)],default:"auto",description:_.localize(3,null)})}validate(re){switch(re){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(re,_e,Ne){return Ne===0?re.accessibilitySupport:Ne}}class t extends i{constructor(){const re={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",re,{"editor.comments.insertSpace":{type:"boolean",default:re.insertSpace,description:_.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:re.ignoreEmptyLines,description:_.localize(5,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{insertSpace:w(_e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:w(_e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function o(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(X){switch(X){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function a(X){switch(X){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class g extends R{constructor(){super(123,[62,31])}compute(re,_e,Ne){const Ve=["monaco-editor"];return _e.get(31)&&Ve.push(_e.get(31)),re.extraEditorClassName&&Ve.push(re.extraEditorClassName),_e.get(62)==="default"?Ve.push("mouse-default"):_e.get(62)==="copy"&&Ve.push("mouse-copy"),_e.get(97)&&Ve.push("showUnused"),_e.get(121)&&Ve.push("showDeprecated"),Ve.join(" ")}}class E extends m{constructor(){super(30,"emptySelectionClipboard",!0,{description:_.localize(6,null)})}compute(re,_e,Ne){return Ne&&re.emptySelectionClipboard}}class f extends i{constructor(){const re={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",re,{"editor.find.cursorMoveOnType":{type:"boolean",default:re.cursorMoveOnType,description:_.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:re.seedSearchStringFromSelection,description:_.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:re.autoFindInSelection,enumDescriptions:[_.localize(9,null),_.localize(10,null),_.localize(11,null)],description:_.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:re.globalFindClipboard,description:_.localize(13,null),included:P.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:re.addExtraSpaceOnTop,description:_.localize(14,null)},"editor.find.loop":{type:"boolean",default:re.loop,description:_.localize(15,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{cursorMoveOnType:w(_e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:w(_e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof re.autoFindInSelection=="boolean"?re.autoFindInSelection?"always":"never":v(_e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:w(_e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:w(_e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:w(_e.loop,this.defaultValue.loop)}}}class h extends i{constructor(){super(41,"fontLigatures",h.OFF,{anyOf:[{type:"boolean",description:_.localize(16,null)},{type:"string",description:_.localize(17,null)}],description:_.localize(18,null),default:!1})}validate(re){return typeof re=="undefined"?this.defaultValue:typeof re=="string"?re==="false"?h.OFF:re==="true"?h.ON:re:Boolean(re)?h.ON:h.OFF}}e.EditorFontLigatures=h,h.OFF='"liga" off, "calt" off',h.ON='"liga" on, "calt" on';class A extends R{constructor(){super(40)}compute(re,_e,Ne){return re.fontInfo}}class L extends C{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:_.localize(19,null)})}validate(re){let _e=d.float(re,this.defaultValue);return _e===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(_e,6,100)}compute(re,_e,Ne){return re.fontInfo.fontSize}}class B extends i{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.MINIMUM_VALUE,maximum:B.MAXIMUM_VALUE,errorMessage:_.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:_.localize(21,null)})}validate(re){return re==="normal"||re==="bold"?re:String(s.clampedInt(re,e.EDITOR_FONT_DEFAULTS.fontWeight,B.MINIMUM_VALUE,B.MAXIMUM_VALUE))}}B.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],B.MINIMUM_VALUE=1,B.MAXIMUM_VALUE=1e3;class ee extends i{constructor(){const re={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},_e={type:"string",enum:["peek","gotoAndPeek","goto"],default:re.multiple,enumDescriptions:[_.localize(22,null),_.localize(23,null),_.localize(24,null)]};super(47,"gotoLocation",re,{"editor.gotoLocation.multiple":{deprecationMessage:_.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:_.localize(26,null)},_e),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:_.localize(27,null)},_e),"editor.gotoLocation.multipleDeclarations":Object.assign({description:_.localize(28,null)},_e),"editor.gotoLocation.multipleImplementations":Object.assign({description:_.localize(29,null)},_e),"editor.gotoLocation.multipleReferences":Object.assign({description:_.localize(30,null)},_e),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:re.alternativeDefinitionCommand,description:_.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:re.alternativeTypeDefinitionCommand,description:_.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:re.alternativeDeclarationCommand,description:_.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:re.alternativeImplementationCommand,description:_.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:re.alternativeReferenceCommand,description:_.localize(35,null)}})}validate(re){var _e,Ne,Ve,$e,Ze;if(!re||typeof re!="object")return this.defaultValue;const K=re;return{multiple:v(K.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(_e=K.multipleDefinitions)!==null&&_e!==void 0?_e:v(K.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ne=K.multipleTypeDefinitions)!==null&&Ne!==void 0?Ne:v(K.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Ve=K.multipleDeclarations)!==null&&Ve!==void 0?Ve:v(K.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:($e=K.multipleImplementations)!==null&&$e!==void 0?$e:v(K.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ze=K.multipleReferences)!==null&&Ze!==void 0?Ze:v(K.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(K.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(K.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(K.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(K.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(K.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class j extends i{constructor(){const re={enabled:!0,delay:300,sticky:!0};super(50,"hover",re,{"editor.hover.enabled":{type:"boolean",default:re.enabled,description:_.localize(36,null)},"editor.hover.delay":{type:"number",default:re.delay,description:_.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:re.sticky,description:_.localize(38,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{enabled:w(_e.enabled,this.defaultValue.enabled),delay:s.clampedInt(_e.delay,this.defaultValue.delay,0,1e4),sticky:w(_e.sticky,this.defaultValue.sticky)}}}var x;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(x=e.RenderMinimap||(e.RenderMinimap={}));class $ extends R{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(re,_e,Ne){return $.computeLayout(_e,{memory:re.memory,outerWidth:re.outerWidth,outerHeight:re.outerHeight,isDominatedByLongLines:re.isDominatedByLongLines,lineHeight:re.fontInfo.lineHeight,viewLineCount:re.viewLineCount,lineNumbersDigitCount:re.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:re.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:re.fontInfo.maxDigitWidth,pixelRatio:re.pixelRatio})}static computeContainedMinimapLineCount(re){const _e=re.height/re.lineHeight,Ne=re.scrollBeyondLastLine?_e-1:0,Ve=(re.viewLineCount+Ne)/(re.pixelRatio*re.height),$e=Math.floor(re.viewLineCount/Ve);return{typicalViewportLineCount:_e,extraLinesBeyondLastLine:Ne,desiredRatio:Ve,minimapLineCount:$e}}static _computeMinimapLayout(re,_e){const Ne=re.outerWidth,Ve=re.outerHeight,$e=re.pixelRatio;if(!re.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor($e*Ve),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ve};const Ze=_e.stableMinimapLayoutInput,K=Ze&&re.outerHeight===Ze.outerHeight&&re.lineHeight===Ze.lineHeight&&re.typicalHalfwidthCharacterWidth===Ze.typicalHalfwidthCharacterWidth&&re.pixelRatio===Ze.pixelRatio&&re.scrollBeyondLastLine===Ze.scrollBeyondLastLine&&re.minimap.enabled===Ze.minimap.enabled&&re.minimap.side===Ze.minimap.side&&re.minimap.size===Ze.minimap.size&&re.minimap.showSlider===Ze.minimap.showSlider&&re.minimap.renderCharacters===Ze.minimap.renderCharacters&&re.minimap.maxColumn===Ze.minimap.maxColumn&&re.minimap.scale===Ze.minimap.scale&&re.verticalScrollbarWidth===Ze.verticalScrollbarWidth&&re.isViewportWrapping===Ze.isViewportWrapping,oe=re.lineHeight,he=re.typicalHalfwidthCharacterWidth,Z=re.scrollBeyondLastLine,ie=re.minimap.renderCharacters;let le=$e>=2?Math.round(re.minimap.scale*2):re.minimap.scale;const ve=re.minimap.maxColumn,ye=re.minimap.size,We=re.minimap.side,Oe=re.verticalScrollbarWidth,qe=re.viewLineCount,Ye=re.remainingWidth,tt=re.isViewportWrapping,nt=ie?2:3;let rt=Math.floor($e*Ve);const it=rt/$e;let gt=!1,ue=!1,Ce=nt*le,ce=le/$e,G=1;if(ye==="fill"||ye==="fit"){const{typicalViewportLineCount:Qe,extraLinesBeyondLastLine:st,desiredRatio:ut,minimapLineCount:pt}=$.computeContainedMinimapLineCount({viewLineCount:qe,scrollBeyondLastLine:Z,height:Ve,lineHeight:oe,pixelRatio:$e});if(qe/pt>1)gt=!0,ue=!0,le=1,Ce=1,ce=le/$e;else{let wt=!1,Et=le+1;if(ye==="fit"){const yt=Math.ceil((qe+st)*Ce);tt&&K&&Ye<=_e.stableFitRemainingWidth?(wt=!0,Et=_e.stableFitMaxMinimapScale):(wt=yt>rt,tt&&wt?(_e.stableMinimapLayoutInput=re,_e.stableFitRemainingWidth=Ye):(_e.stableMinimapLayoutInput=null,_e.stableFitRemainingWidth=0))}if(ye==="fill"||wt){gt=!0;const yt=le;Ce=Math.min(oe*$e,Math.max(1,Math.floor(1/ut))),le=Math.min(Et,Math.max(1,Math.floor(Ce/nt))),le>yt&&(G=Math.min(2,le/yt)),ce=le/$e/G,rt=Math.ceil(Math.max(Qe,qe+st)*Ce),tt&&wt&&(_e.stableFitMaxMinimapScale=le)}}}const Ue=Math.floor(ve*ce),Te=Math.min(Ue,Math.max(0,Math.floor((Ye-Oe-2)*ce/(he+ce)))+e.MINIMAP_GUTTER_WIDTH);let Xe=Math.floor($e*Te);const Ge=Xe/$e;Xe=Math.floor(Xe*G);const lt=ie?1:2,at=We==="left"?0:Ne-Te-Oe;return{renderMinimap:lt,minimapLeft:at,minimapWidth:Te,minimapHeightIsEditorHeight:gt,minimapIsSampling:ue,minimapScale:le,minimapLineHeight:Ce,minimapCanvasInnerWidth:Xe,minimapCanvasInnerHeight:rt,minimapCanvasOuterWidth:Ge,minimapCanvasOuterHeight:it}}static computeLayout(re,_e){const Ne=_e.outerWidth|0,Ve=_e.outerHeight|0,$e=_e.lineHeight|0,Ze=_e.lineNumbersDigitCount|0,K=_e.typicalHalfwidthCharacterWidth,oe=_e.maxDigitWidth,he=_e.pixelRatio,Z=_e.viewLineCount,ie=re.get(118),le=ie==="inherit"?re.get(117):ie,ve=le==="inherit"?re.get(113):le,ye=re.get(116),We=re.get(2),Oe=_e.isDominatedByLongLines,qe=re.get(46),Ye=re.get(56).renderType!==0,tt=re.get(57),nt=re.get(91),rt=re.get(61),it=re.get(89),gt=it.verticalScrollbarSize,ue=it.verticalHasArrows,Ce=it.arrowSize,ce=it.horizontalScrollbarSize,G=re.get(54),Ue=re.get(35);let Te;if(typeof G=="string"&&/^\d+(\.\d+)?ch$/.test(G)){const Rt=parseFloat(G.substr(0,G.length-2));Te=s.clampedInt(Rt*K,0,0,1e3)}else Te=s.clampedInt(G,0,0,1e3);Ue&&(Te+=16);let Xe=0;if(Ye){const Rt=Math.max(Ze,tt);Xe=Math.round(Rt*oe)}let Ge=0;qe&&(Ge=$e);let lt=0,at=lt+Ge,Qe=at+Xe,st=Qe+Te;const ut=Ne-Ge-Xe-Te;let pt=!1,vt=!1,wt=-1;We!==2&&(le==="inherit"&&Oe?(pt=!0,vt=!0):ve==="on"||ve==="bounded"?vt=!0:ve==="wordWrapColumn"&&(wt=ye));const Et=$._computeMinimapLayout({outerWidth:Ne,outerHeight:Ve,lineHeight:$e,typicalHalfwidthCharacterWidth:K,pixelRatio:he,scrollBeyondLastLine:nt,minimap:rt,verticalScrollbarWidth:gt,viewLineCount:Z,remainingWidth:ut,isViewportWrapping:vt},_e.memory||new y);Et.renderMinimap!==0&&Et.minimapLeft===0&&(lt+=Et.minimapWidth,at+=Et.minimapWidth,Qe+=Et.minimapWidth,st+=Et.minimapWidth);const yt=ut-Et.minimapWidth,_t=Math.max(1,Math.floor((yt-gt-2)/K)),Ot=ue?Ce:0;return vt&&(wt=Math.max(1,_t),ve==="bounded"&&(wt=Math.min(wt,ye))),{width:Ne,height:Ve,glyphMarginLeft:lt,glyphMarginWidth:Ge,lineNumbersLeft:at,lineNumbersWidth:Xe,decorationsLeft:Qe,decorationsWidth:Te,contentLeft:st,contentWidth:yt,minimap:Et,viewportColumn:_t,isWordWrapMinified:pt,isViewportWrapping:vt,wrappingColumn:wt,verticalScrollbarWidth:gt,horizontalScrollbarHeight:ce,overviewRuler:{top:Ot,width:gt,height:Ve-2*Ot,right:0}}}}e.EditorLayoutInfoComputer=$;class F extends i{constructor(){const re={enabled:!0};super(53,"lightbulb",re,{"editor.lightbulb.enabled":{type:"boolean",default:re.enabled,description:_.localize(39,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:w(re.enabled,this.defaultValue.enabled)}}}class U extends i{constructor(){const re={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",re,{"editor.inlineHints.enabled":{type:"boolean",default:re.enabled,description:_.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:re.fontSize,description:_.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:re.fontFamily,description:_.localize(42,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{enabled:w(_e.enabled,this.defaultValue.enabled),fontSize:s.clampedInt(_e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(_e.fontFamily,this.defaultValue.fontFamily)}}}class M extends s{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:_.localize(43,null)})}compute(re,_e,Ne){return re.fontInfo.lineHeight}}class N extends i{constructor(){const re={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",re,{"editor.minimap.enabled":{type:"boolean",default:re.enabled,description:_.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[_.localize(45,null),_.localize(46,null),_.localize(47,null)],default:re.size,description:_.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:re.side,description:_.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:re.showSlider,description:_.localize(50,null)},"editor.minimap.scale":{type:"number",default:re.scale,minimum:1,maximum:3,enum:[1,2,3],description:_.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:re.renderCharacters,description:_.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:re.maxColumn,description:_.localize(53,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{enabled:w(_e.enabled,this.defaultValue.enabled),size:v(_e.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(_e.side,this.defaultValue.side,["right","left"]),showSlider:v(_e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:w(_e.renderCharacters,this.defaultValue.renderCharacters),scale:s.clampedInt(_e.scale,1,1,3),maxColumn:s.clampedInt(_e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function O(X){return X==="ctrlCmd"?P.isMacintosh?"metaKey":"ctrlKey":"altKey"}class V extends i{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(55,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{top:s.clampedInt(_e.top,0,0,1e3),bottom:s.clampedInt(_e.bottom,0,0,1e3)}}}class q extends i{constructor(){const re={enabled:!0,cycle:!1};super(72,"parameterHints",re,{"editor.parameterHints.enabled":{type:"boolean",default:re.enabled,description:_.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:re.cycle,description:_.localize(57,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{enabled:w(_e.enabled,this.defaultValue.enabled),cycle:w(_e.cycle,this.defaultValue.cycle)}}}class J extends R{constructor(){super(124)}compute(re,_e,Ne){return re.pixelRatio}}class me extends i{constructor(){const re={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",re,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:re.strings,description:_.localize(58,null)},comments:{type:"boolean",default:re.comments,description:_.localize(59,null)},other:{type:"boolean",default:re.other,description:_.localize(60,null)}}}],default:re,description:_.localize(61,null)});this.defaultValue=re}validate(re){if(typeof re=="boolean")return re;if(re&&typeof re=="object"){const _e=re,Ne={other:w(_e.other,this.defaultValue.other),comments:w(_e.comments,this.defaultValue.comments),strings:w(_e.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var we;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(we=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ae extends i{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[_.localize(62,null),_.localize(63,null),_.localize(64,null),_.localize(65,null)],default:"on",description:_.localize(66,null)})}validate(re){let _e=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof re!="undefined"&&(typeof re=="function"?(_e=4,Ne=re):re==="interval"?_e=3:re==="relative"?_e=2:re==="on"?_e=1:_e=0),{renderType:_e,renderFn:Ne}}}function Pe(X){const re=X.get(84);return re==="editable"?X.get(77):re!=="on"}e.filterValidationDecorations=Pe;class Fe extends i{constructor(){const re=[],_e={type:"number",description:_.localize(67,null)};super(88,"rulers",re,{type:"array",items:{anyOf:[_e,{type:["object"],properties:{column:_e,color:{type:"string",description:_.localize(68,null),format:"color-hex"}}}]},default:re,description:_.localize(69,null)})}validate(re){if(Array.isArray(re)){let _e=[];for(let Ne of re)if(typeof Ne=="number")_e.push({column:s.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const Ve=Ne;_e.push({column:s.clampedInt(Ve.column,0,0,1e4),color:Ve.color})}return _e.sort((Ne,Ve)=>Ne.column-Ve.column),_e}return this.defaultValue}}function z(X,re){if(typeof X!="string")return re;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Y extends i{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re,Ne=s.clampedInt(_e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ve=s.clampedInt(_e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:s.clampedInt(_e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:z(_e.vertical,this.defaultValue.vertical),horizontal:z(_e.horizontal,this.defaultValue.horizontal),useShadows:w(_e.useShadows,this.defaultValue.useShadows),verticalHasArrows:w(_e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:w(_e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:w(_e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:w(_e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:s.clampedInt(_e.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:Ve,verticalSliderSize:s.clampedInt(_e.verticalSliderSize,Ve,0,1e3),scrollByPage:w(_e.scrollByPage,this.defaultValue.scrollByPage)}}}class te extends i{constructor(){const re={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",re,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[_.localize(70,null),_.localize(71,null)],default:re.insertMode,description:_.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:re.filterGraceful,description:_.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:re.localityBonus,description:_.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:re.shareSuggestSelections,markdownDescription:_.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:re.snippetsPreventQuickSuggestions,description:_.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:re.showIcons,description:_.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:re.showStatusBar,description:_.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:re.showInlineDetails,description:_.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:_.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:_.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:_.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:_.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:_.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:_.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:_.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:_.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:_.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:_.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:_.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:_.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:_.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:_.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:_.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:_.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:_.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:_.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:_.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:_.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:_.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:_.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:_.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:_.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:_.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:_.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:_.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:_.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:_.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:_.localize(109,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{insertMode:v(_e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:w(_e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:w(_e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:w(_e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:w(_e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:w(_e.showIcons,this.defaultValue.showIcons),showStatusBar:w(_e.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:w(_e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:w(_e.showMethods,this.defaultValue.showMethods),showFunctions:w(_e.showFunctions,this.defaultValue.showFunctions),showConstructors:w(_e.showConstructors,this.defaultValue.showConstructors),showFields:w(_e.showFields,this.defaultValue.showFields),showVariables:w(_e.showVariables,this.defaultValue.showVariables),showClasses:w(_e.showClasses,this.defaultValue.showClasses),showStructs:w(_e.showStructs,this.defaultValue.showStructs),showInterfaces:w(_e.showInterfaces,this.defaultValue.showInterfaces),showModules:w(_e.showModules,this.defaultValue.showModules),showProperties:w(_e.showProperties,this.defaultValue.showProperties),showEvents:w(_e.showEvents,this.defaultValue.showEvents),showOperators:w(_e.showOperators,this.defaultValue.showOperators),showUnits:w(_e.showUnits,this.defaultValue.showUnits),showValues:w(_e.showValues,this.defaultValue.showValues),showConstants:w(_e.showConstants,this.defaultValue.showConstants),showEnums:w(_e.showEnums,this.defaultValue.showEnums),showEnumMembers:w(_e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:w(_e.showKeywords,this.defaultValue.showKeywords),showWords:w(_e.showWords,this.defaultValue.showWords),showColors:w(_e.showColors,this.defaultValue.showColors),showFiles:w(_e.showFiles,this.defaultValue.showFiles),showReferences:w(_e.showReferences,this.defaultValue.showReferences),showFolders:w(_e.showFolders,this.defaultValue.showFolders),showTypeParameters:w(_e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:w(_e.showSnippets,this.defaultValue.showSnippets),showUsers:w(_e.showUsers,this.defaultValue.showUsers),showIssues:w(_e.showIssues,this.defaultValue.showIssues)}}}class ae extends i{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:_.localize(110,null),default:!0,type:"boolean"}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:w(re.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class fe extends R{constructor(){super(125,[77])}compute(re,_e,Ne){return _e.get(77)?!0:re.tabFocusMode}}var De;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(De=e.WrappingIndent||(e.WrappingIndent={}));function Me(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class be extends R{constructor(){super(127,[126])}compute(re,_e,Ne){const Ve=_e.get(126);return{isDominatedByLongLines:re.isDominatedByLongLines,isWordWrapMinified:Ve.isWordWrapMinified,isViewportWrapping:Ve.isViewportWrapping,wrappingColumn:Ve.wrappingColumn}}}const ke="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",Be="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:P.isMacintosh?Re:P.isLinux?Be:ke,fontWeight:"normal",fontSize:P.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Ee(X){return e.editorOptionsRegistry[X.id]=X,X}var Ke;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.codeLens=12]="codeLens",X[X.codeLensFontFamily=13]="codeLensFontFamily",X[X.codeLensFontSize=14]="codeLensFontSize",X[X.colorDecorators=15]="colorDecorators",X[X.columnSelection=16]="columnSelection",X[X.comments=17]="comments",X[X.contextmenu=18]="contextmenu",X[X.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",X[X.cursorBlinking=20]="cursorBlinking",X[X.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",X[X.cursorStyle=22]="cursorStyle",X[X.cursorSurroundingLines=23]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",X[X.cursorWidth=25]="cursorWidth",X[X.disableLayerHinting=26]="disableLayerHinting",X[X.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",X[X.domReadOnly=28]="domReadOnly",X[X.dragAndDrop=29]="dragAndDrop",X[X.emptySelectionClipboard=30]="emptySelectionClipboard",X[X.extraEditorClassName=31]="extraEditorClassName",X[X.fastScrollSensitivity=32]="fastScrollSensitivity",X[X.find=33]="find",X[X.fixedOverflowWidgets=34]="fixedOverflowWidgets",X[X.folding=35]="folding",X[X.foldingStrategy=36]="foldingStrategy",X[X.foldingHighlight=37]="foldingHighlight",X[X.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=39]="fontFamily",X[X.fontInfo=40]="fontInfo",X[X.fontLigatures=41]="fontLigatures",X[X.fontSize=42]="fontSize",X[X.fontWeight=43]="fontWeight",X[X.formatOnPaste=44]="formatOnPaste",X[X.formatOnType=45]="formatOnType",X[X.glyphMargin=46]="glyphMargin",X[X.gotoLocation=47]="gotoLocation",X[X.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",X[X.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",X[X.hover=50]="hover",X[X.inDiffEditor=51]="inDiffEditor",X[X.letterSpacing=52]="letterSpacing",X[X.lightbulb=53]="lightbulb",X[X.lineDecorationsWidth=54]="lineDecorationsWidth",X[X.lineHeight=55]="lineHeight",X[X.lineNumbers=56]="lineNumbers",X[X.lineNumbersMinChars=57]="lineNumbersMinChars",X[X.linkedEditing=58]="linkedEditing",X[X.links=59]="links",X[X.matchBrackets=60]="matchBrackets",X[X.minimap=61]="minimap",X[X.mouseStyle=62]="mouseStyle",X[X.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=64]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",X[X.multiCursorModifier=66]="multiCursorModifier",X[X.multiCursorPaste=67]="multiCursorPaste",X[X.occurrencesHighlight=68]="occurrencesHighlight",X[X.overviewRulerBorder=69]="overviewRulerBorder",X[X.overviewRulerLanes=70]="overviewRulerLanes",X[X.padding=71]="padding",X[X.parameterHints=72]="parameterHints",X[X.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",X[X.quickSuggestions=75]="quickSuggestions",X[X.quickSuggestionsDelay=76]="quickSuggestionsDelay",X[X.readOnly=77]="readOnly",X[X.renameOnType=78]="renameOnType",X[X.renderControlCharacters=79]="renderControlCharacters",X[X.renderIndentGuides=80]="renderIndentGuides",X[X.renderFinalNewline=81]="renderFinalNewline",X[X.renderLineHighlight=82]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=84]="renderValidationDecorations",X[X.renderWhitespace=85]="renderWhitespace",X[X.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",X[X.roundedSelection=87]="roundedSelection",X[X.rulers=88]="rulers",X[X.scrollbar=89]="scrollbar",X[X.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=91]="scrollBeyondLastLine",X[X.scrollPredominantAxis=92]="scrollPredominantAxis",X[X.selectionClipboard=93]="selectionClipboard",X[X.selectionHighlight=94]="selectionHighlight",X[X.selectOnLineNumbers=95]="selectOnLineNumbers",X[X.showFoldingControls=96]="showFoldingControls",X[X.showUnused=97]="showUnused",X[X.snippetSuggestions=98]="snippetSuggestions",X[X.smartSelect=99]="smartSelect",X[X.smoothScrolling=100]="smoothScrolling",X[X.stickyTabStops=101]="stickyTabStops",X[X.stopRenderingLineAfter=102]="stopRenderingLineAfter",X[X.suggest=103]="suggest",X[X.suggestFontSize=104]="suggestFontSize",X[X.suggestLineHeight=105]="suggestLineHeight",X[X.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",X[X.suggestSelection=107]="suggestSelection",X[X.tabCompletion=108]="tabCompletion",X[X.tabIndex=109]="tabIndex",X[X.unusualLineTerminators=110]="unusualLineTerminators",X[X.useTabStops=111]="useTabStops",X[X.wordSeparators=112]="wordSeparators",X[X.wordWrap=113]="wordWrap",X[X.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=116]="wordWrapColumn",X[X.wordWrapOverride1=117]="wordWrapOverride1",X[X.wordWrapOverride2=118]="wordWrapOverride2",X[X.wrappingIndent=119]="wrappingIndent",X[X.wrappingStrategy=120]="wrappingStrategy",X[X.showDeprecated=121]="showDeprecated",X[X.inlineHints=122]="inlineHints",X[X.editorClassName=123]="editorClassName",X[X.pixelRatio=124]="pixelRatio",X[X.tabFocusMode=125]="tabFocusMode",X[X.layoutInfo=126]="layoutInfo",X[X.wrappingInfo=127]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ee(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:_.localize(111,null)})),acceptSuggestionOnEnter:Ee(new b(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",_.localize(112,null),""],markdownDescription:_.localize(113,null)})),accessibilitySupport:Ee(new c),accessibilityPageSize:Ee(new s(3,"accessibilityPageSize",10,1,1073741824,{description:_.localize(114,null)})),ariaLabel:Ee(new S(4,"ariaLabel",_.localize(115,null))),autoClosingBrackets:Ee(new b(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(116,null),_.localize(117,null),""],description:_.localize(118,null)})),autoClosingDelete:Ee(new b(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",_.localize(119,null),""],description:_.localize(120,null)})),autoClosingOvertype:Ee(new b(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",_.localize(121,null),""],description:_.localize(122,null)})),autoClosingQuotes:Ee(new b(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(123,null),_.localize(124,null),""],description:_.localize(125,null)})),autoIndent:Ee(new p(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[_.localize(126,null),_.localize(127,null),_.localize(128,null),_.localize(129,null),_.localize(130,null)],description:_.localize(131,null)})),automaticLayout:Ee(new m(10,"automaticLayout",!1)),autoSurround:Ee(new b(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[_.localize(132,null),_.localize(133,null),_.localize(134,null),""],description:_.localize(135,null)})),stickyTabStops:Ee(new m(101,"stickyTabStops",!1,{description:_.localize(136,null)})),codeLens:Ee(new m(12,"codeLens",!0,{description:_.localize(137,null)})),codeLensFontFamily:Ee(new S(13,"codeLensFontFamily","",{description:_.localize(138,null)})),codeLensFontSize:Ee(new s(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:_.localize(139,null)})),colorDecorators:Ee(new m(15,"colorDecorators",!0,{description:_.localize(140,null)})),columnSelection:Ee(new m(16,"columnSelection",!1,{description:_.localize(141,null)})),comments:Ee(new t),contextmenu:Ee(new m(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Ee(new m(19,"copyWithSyntaxHighlighting",!0,{description:_.localize(142,null)})),cursorBlinking:Ee(new p(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:_.localize(143,null)})),cursorSmoothCaretAnimation:Ee(new m(21,"cursorSmoothCaretAnimation",!1,{description:_.localize(144,null)})),cursorStyle:Ee(new p(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],a,{description:_.localize(145,null)})),cursorSurroundingLines:Ee(new s(23,"cursorSurroundingLines",0,0,1073741824,{description:_.localize(146,null)})),cursorSurroundingLinesStyle:Ee(new b(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[_.localize(147,null),_.localize(148,null)],description:_.localize(149,null)})),cursorWidth:Ee(new s(25,"cursorWidth",0,0,1073741824,{markdownDescription:_.localize(150,null)})),disableLayerHinting:Ee(new m(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ee(new m(27,"disableMonospaceOptimizations",!1)),domReadOnly:Ee(new m(28,"domReadOnly",!1)),dragAndDrop:Ee(new m(29,"dragAndDrop",!0,{description:_.localize(151,null)})),emptySelectionClipboard:Ee(new E),extraEditorClassName:Ee(new S(31,"extraEditorClassName","")),fastScrollSensitivity:Ee(new d(32,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:_.localize(152,null)})),find:Ee(new f),fixedOverflowWidgets:Ee(new m(34,"fixedOverflowWidgets",!1)),folding:Ee(new m(35,"folding",!0,{description:_.localize(153,null)})),foldingStrategy:Ee(new b(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[_.localize(154,null),_.localize(155,null)],description:_.localize(156,null)})),foldingHighlight:Ee(new m(37,"foldingHighlight",!0,{description:_.localize(157,null)})),unfoldOnClickAfterEndOfLine:Ee(new m(38,"unfoldOnClickAfterEndOfLine",!1,{description:_.localize(158,null)})),fontFamily:Ee(new S(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:_.localize(159,null)})),fontInfo:Ee(new A),fontLigatures2:Ee(new h),fontSize:Ee(new L),fontWeight:Ee(new B),formatOnPaste:Ee(new m(44,"formatOnPaste",!1,{description:_.localize(160,null)})),formatOnType:Ee(new m(45,"formatOnType",!1,{description:_.localize(161,null)})),glyphMargin:Ee(new m(46,"glyphMargin",!0,{description:_.localize(162,null)})),gotoLocation:Ee(new ee),hideCursorInOverviewRuler:Ee(new m(48,"hideCursorInOverviewRuler",!1,{description:_.localize(163,null)})),highlightActiveIndentGuide:Ee(new m(49,"highlightActiveIndentGuide",!0,{description:_.localize(164,null)})),hover:Ee(new j),inDiffEditor:Ee(new m(51,"inDiffEditor",!1)),letterSpacing:Ee(new d(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>d.clamp(X,-5,20),{description:_.localize(165,null)})),lightbulb:Ee(new F),lineDecorationsWidth:Ee(new C(54,"lineDecorationsWidth",10)),lineHeight:Ee(new M),lineNumbers:Ee(new Ae),lineNumbersMinChars:Ee(new s(57,"lineNumbersMinChars",5,1,300)),linkedEditing:Ee(new m(58,"linkedEditing",!1,{description:_.localize(166,null)})),links:Ee(new m(59,"links",!0,{description:_.localize(167,null)})),matchBrackets:Ee(new b(60,"matchBrackets","always",["always","near","never"],{description:_.localize(168,null)})),minimap:Ee(new N),mouseStyle:Ee(new b(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ee(new d(63,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:_.localize(169,null)})),mouseWheelZoom:Ee(new m(64,"mouseWheelZoom",!1,{markdownDescription:_.localize(170,null)})),multiCursorMergeOverlapping:Ee(new m(65,"multiCursorMergeOverlapping",!0,{description:_.localize(171,null)})),multiCursorModifier:Ee(new p(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],O,{markdownEnumDescriptions:[_.localize(172,null),_.localize(173,null)],markdownDescription:_.localize(174,null)})),multiCursorPaste:Ee(new b(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[_.localize(175,null),_.localize(176,null)],markdownDescription:_.localize(177,null)})),occurrencesHighlight:Ee(new m(68,"occurrencesHighlight",!0,{description:_.localize(178,null)})),overviewRulerBorder:Ee(new m(69,"overviewRulerBorder",!0,{description:_.localize(179,null)})),overviewRulerLanes:Ee(new s(70,"overviewRulerLanes",3,0,3)),padding:Ee(new V),parameterHints:Ee(new q),peekWidgetDefaultFocus:Ee(new b(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[_.localize(180,null),_.localize(181,null)],description:_.localize(182,null)})),definitionLinkOpensInPeek:Ee(new m(74,"definitionLinkOpensInPeek",!1,{description:_.localize(183,null)})),quickSuggestions:Ee(new me),quickSuggestionsDelay:Ee(new s(76,"quickSuggestionsDelay",10,0,1073741824,{description:_.localize(184,null)})),readOnly:Ee(new m(77,"readOnly",!1)),renameOnType:Ee(new m(78,"renameOnType",!1,{description:_.localize(185,null),markdownDeprecationMessage:_.localize(186,null)})),renderControlCharacters:Ee(new m(79,"renderControlCharacters",!1,{description:_.localize(187,null)})),renderIndentGuides:Ee(new m(80,"renderIndentGuides",!0,{description:_.localize(188,null)})),renderFinalNewline:Ee(new m(81,"renderFinalNewline",!0,{description:_.localize(189,null)})),renderLineHighlight:Ee(new b(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",_.localize(190,null)],description:_.localize(191,null)})),renderLineHighlightOnlyWhenFocus:Ee(new m(83,"renderLineHighlightOnlyWhenFocus",!1,{description:_.localize(192,null)})),renderValidationDecorations:Ee(new b(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ee(new b(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",_.localize(193,null),_.localize(194,null),_.localize(195,null),""],description:_.localize(196,null)})),revealHorizontalRightPadding:Ee(new s(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ee(new m(87,"roundedSelection",!0,{description:_.localize(197,null)})),rulers:Ee(new Fe),scrollbar:Ee(new Y),scrollBeyondLastColumn:Ee(new s(90,"scrollBeyondLastColumn",5,0,1073741824,{description:_.localize(198,null)})),scrollBeyondLastLine:Ee(new m(91,"scrollBeyondLastLine",!0,{description:_.localize(199,null)})),scrollPredominantAxis:Ee(new m(92,"scrollPredominantAxis",!0,{description:_.localize(200,null)})),selectionClipboard:Ee(new m(93,"selectionClipboard",!0,{description:_.localize(201,null),included:P.isLinux})),selectionHighlight:Ee(new m(94,"selectionHighlight",!0,{description:_.localize(202,null)})),selectOnLineNumbers:Ee(new m(95,"selectOnLineNumbers",!0)),showFoldingControls:Ee(new b(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[_.localize(203,null),_.localize(204,null)],description:_.localize(205,null)})),showUnused:Ee(new m(97,"showUnused",!0,{description:_.localize(206,null)})),showDeprecated:Ee(new m(121,"showDeprecated",!0,{description:_.localize(207,null)})),inlineHints:Ee(new U),snippetSuggestions:Ee(new b(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[_.localize(208,null),_.localize(209,null),_.localize(210,null),_.localize(211,null)],description:_.localize(212,null)})),smartSelect:Ee(new ae),smoothScrolling:Ee(new m(100,"smoothScrolling",!1,{description:_.localize(213,null)})),stopRenderingLineAfter:Ee(new s(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ee(new te),suggestFontSize:Ee(new s(104,"suggestFontSize",0,0,1e3,{markdownDescription:_.localize(214,null)})),suggestLineHeight:Ee(new s(105,"suggestLineHeight",0,0,1e3,{markdownDescription:_.localize(215,null)})),suggestOnTriggerCharacters:Ee(new m(106,"suggestOnTriggerCharacters",!0,{description:_.localize(216,null)})),suggestSelection:Ee(new b(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[_.localize(217,null),_.localize(218,null),_.localize(219,null)],description:_.localize(220,null)})),tabCompletion:Ee(new b(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[_.localize(221,null),_.localize(222,null),_.localize(223,null)],description:_.localize(224,null)})),tabIndex:Ee(new s(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Ee(new b(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[_.localize(225,null),_.localize(226,null),_.localize(227,null)],description:_.localize(228,null)})),useTabStops:Ee(new m(111,"useTabStops",!0,{description:_.localize(229,null)})),wordSeparators:Ee(new S(112,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:_.localize(230,null)})),wordWrap:Ee(new b(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[_.localize(231,null),_.localize(232,null),_.localize(233,null),_.localize(234,null)],description:_.localize(235,null)})),wordWrapBreakAfterCharacters:Ee(new S(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ee(new S(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ee(new s(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:_.localize(236,null)})),wordWrapOverride1:Ee(new b(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ee(new b(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ee(new p(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Me,{enumDescriptions:[_.localize(237,null),_.localize(238,null),_.localize(239,null),_.localize(240,null)],description:_.localize(241,null)})),wrappingStrategy:Ee(new b(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[_.localize(242,null),_.localize(243,null)],description:_.localize(244,null)})),editorClassName:Ee(new g),pixelRatio:Ee(new J),tabFocusMode:Ee(new fe),layoutInfo:Ee(new $),wrappingInfo:Ee(new be)}}),define(ge[151],pe([16,17]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[152],pe([16,17]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[153],pe([16,17]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ge[154],pe([16,17]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(ge[155],pe([16,17]),function(Q,e){return Q.create("vs/platform/markers/common/markers",e)}),define(ge[156],pe([16,17]),function(Q,e){return Q.create("vs/platform/theme/common/iconRegistry",e)}),define(ge[157],pe([16,17]),function(Q,e){return Q.create("vs/platform/workspaces/common/workspaces",e)}),define(ge[158],pe([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHost.api.impl",e)}),define(ge[159],pe([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ge[160],pe([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(ge[161],pe([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ge[162],pe([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostProgress",e)}),define(ge[163],pe([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ge[164],pe([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ge[165],pe([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ge[166],pe([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ge[167],pe([16,17]),function(Q,e){return Q.create("vs/workbench/api/node/extHostDebugService",e)}),define(ge[168],pe([16,17]),function(Q,e){return Q.create("vs/workbench/common/views",e)}),define(ge[169],pe([16,17]),function(Q,e){return Q.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ge[170],pe([16,17]),function(Q,e){return Q.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ge[171],pe([16,17]),function(Q,e){return Q.create("vs/workbench/contrib/externalTerminal/node/externalTerminalService",e)}),define(ge[172],pe([16,17]),function(Q,e){return Q.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ge[173],pe([16,17]),function(Q,e){return Q.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ge[174],pe([16,17]),function(Q,e){return Q.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[175],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var _;(function(D){D[D.ACTIVATE=0]="ACTIVATE",D[D.RESTORE=1]="RESTORE",D[D.PRESERVE=2]="PRESERVE"})(_=e.EditorActivation||(e.EditorActivation={}));var P;(function(D){D[D.PICK=1]="PICK",D[D.DISABLED=2]="DISABLED"})(P=e.EditorOverride||(e.EditorOverride={}));var T;(function(D){D[D.API=0]="API",D[D.USER=1]="USER"})(T=e.EditorOpenContext||(e.EditorOpenContext={}));var I;(function(D){D[D.Center=0]="Center",D[D.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",D[D.NearTop=2]="NearTop",D[D.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(I=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ge[176],pe([0,1,153]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function T(C){return C=C.trim(),C==="*"||P.test(C)}e.isValidVersionStr=T;function I(C){if(!T(C))return null;if(C=C.trim(),C==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let w=C.match(P);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}e.parseVersion=I;function D(C){if(!C)return null;let w=C.majorBase,m=C.majorMustEqual,s=C.minorBase,d=C.minorMustEqual,S=C.patchBase,v=C.patchMustEqual;return C.hasCaret&&(w===0||(d=!1),v=!1),{majorBase:w,majorMustEqual:m,minorBase:s,minorMustEqual:d,patchBase:S,patchMustEqual:v,isMinimum:C.hasGreaterEquals}}e.normalizeVersion=D;function k(C,w){let m;typeof C=="string"?m=D(I(C)):m=C;let s;if(typeof w=="string"?s=D(I(w)):s=w,!m||!s)return!1;let d=m.majorBase,S=m.minorBase,v=m.patchBase,b=s.majorBase,p=s.minorBase,u=s.patchBase,c=s.majorMustEqual,t=s.minorMustEqual,n=s.patchMustEqual;return s.isMinimum?d>b?!0:d<b?!1:S>p?!0:S<p?!1:v>=u:(d===1&&b===0&&(!c||!t||!n)&&(b=1,p=0,u=0,c=!0,t=!1,n=!1),d<b?!1:d>b?!c:S<p?!1:S>p?!t:v<u?!1:v>u?!n:!0)}e.isValidVersion=k;function y(C,w,m){return w.isBuiltin||typeof w.main=="undefined"?!0:R(C,w.engines.vscode,m)}e.isValidExtensionVersion=y;function i(C,w){return C==="*"||R(w,C)}e.isEngineValid=i;function R(C,w,m=[]){let s=D(I(w));if(!s)return m.push(_.localize(0,null,w)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return m.push(_.localize(1,null,w)),!1}else if(!s.majorMustEqual)return m.push(_.localize(2,null,w)),!1;return k(C,s)?!0:(m.push(_.localize(3,null,C,w)),!1)}e.isVersionValid=R}),define(ge[109],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class _{constructor(I,D=[],k=!1){this.ctor=I,this.staticArguments=D,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=_;const P=(T,...I)=>new _(T,I);e.createSyncDescriptor=P}),define(ge[78],pe([0,1,109]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const P=[];function T(D,k,y){k instanceof _.SyncDescriptor||(k=new _.SyncDescriptor(k,[],y)),P.push([D,k])}e.registerSingleton=T;function I(){return P}e.getSingletonServiceDescriptors=I}),define(ge[177],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class _{constructor(I){this.incoming=new Map,this.outgoing=new Map,this.data=I}}e.Node=_;class P{constructor(I){this._hashFn=I,this._nodes=new Map}roots(){const I=[];for(let D of this._nodes.values())D.outgoing.size===0&&I.push(D);return I}insertEdge(I,D){const k=this.lookupOrInsertNode(I),y=this.lookupOrInsertNode(D);k.outgoing.set(this._hashFn(D),y),y.incoming.set(this._hashFn(I),k)}removeNode(I){const D=this._hashFn(I);this._nodes.delete(D);for(let k of this._nodes.values())k.outgoing.delete(D),k.incoming.delete(D)}lookupOrInsertNode(I){const D=this._hashFn(I);let k=this._nodes.get(D);return k||(k=new _(I),this._nodes.set(D,k)),k}lookup(I){return this._nodes.get(this._hashFn(I))}isEmpty(){return this._nodes.size===0}toString(){let I=[];for(let[D,k]of this._nodes)I.push(`${D}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return I.join(`
`)}}e.Graph=P}),define(ge[4],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var _;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function y(i){return i[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=y})(_=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function P(k,y,i,R){y[_.DI_TARGET]===y?y[_.DI_DEPENDENCIES].push({id:k,index:i,optional:R}):(y[_.DI_DEPENDENCIES]=[{id:k,index:i,optional:R}],y[_.DI_TARGET]=y)}function T(k){if(_.serviceIds.has(k))return _.serviceIds.get(k);const y=function(i,R,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(y,i,C,!1)};return y.toString=()=>k,_.serviceIds.set(k,y),y}e.createDecorator=T;function I(k){return k}e.refineServiceDecorator=I;function D(k){return function(y,i,R){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");P(k,y,R,!0)}}e.optional=D}),define(ge[178],pe([0,1,4]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,_.createDecorator)("modelService");function P(T){return!T.isTooLargeForSyncing()&&!T.isForSimpleWidget}e.shouldSynchronizeModel=P}),define(ge[179],pe([0,1,3,73,6,24,72,76,178]),function(Q,e,_,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function i(w){return typeof w=="string"?!1:Array.isArray(w)?w.every(i):!!w.exclusive}class R{constructor(){this._clock=0,this._entries=[],this._onDidChange=new _.Emitter}get onDidChange(){return this._onDidChange.event}register(m,s){let d={selector:m,provider:s,_score:-1,_time:this._clock++};return this._entries.push(d),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,T.toDisposable)(()=>{if(d){let S=this._entries.indexOf(d);S>=0&&(this._entries.splice(S,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),d=void 0)}})}has(m){return this.all(m).length>0}all(m){if(!m)return[];this._updateScores(m);const s=[];for(let d of this._entries)d._score>0&&s.push(d.provider);return s}ordered(m){const s=[];return this._orderedForEach(m,d=>s.push(d.provider)),s}orderedGroups(m){const s=[];let d,S;return this._orderedForEach(m,v=>{d&&S===v._score?d.push(v.provider):(S=v._score,d=[v.provider],s.push(d))}),s}_orderedForEach(m,s){if(!!m){this._updateScores(m);for(const d of this._entries)d._score>0&&s(d)}}_updateScores(m){let s={uri:m.uri.toString(),language:m.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===s.language&&this._lastCandidate.uri===s.uri)){this._lastCandidate=s;for(let d of this._entries)if(d._score=(0,k.score)(d.selector,m.uri,m.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(m)),i(d.selector)&&d._score>0){for(let S of this._entries)S._score=0;d._score=1e3;break}this._entries.sort(R._compareByScoreAndTime)}}static _compareByScoreAndTime(m,s){return m._score<s._score?1:m._score>s._score?-1:m._time<s._time?1:m._time>s._time?-1:0}}e.LanguageFeatureRegistry=R;class C{constructor(m,s,d=Number.MAX_SAFE_INTEGER){this._registry=m,this.min=s,this.max=d,this._cache=new I.LRUCache(50,.7)}_key(m){return m.id+(0,P.hash)(this._registry.all(m))}_clamp(m){return m===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(m*1.3)))}get(m){const s=this._key(m),d=this._cache.get(s);return this._clamp(d==null?void 0:d.value)}update(m,s){const d=this._key(m);let S=this._cache.get(d);return S||(S=new D.MovingAverage,this._cache.set(d,S)),S.update(s),this.get(m)}}e.LanguageFeatureRequestDelays=C}),define(ge[79],pe([0,1,2,44,179,142,43]),function(Q,e,_,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var k;(function(f){f[f.Null=0]="Null",f[f.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));class y{constructor(h,A){this.language=h,this.id=A}}e.LanguageIdentifier=y;var i;(function(f){f[f.NotSet=-1]="NotSet",f[f.None=0]="None",f[f.Italic=1]="Italic",f[f.Bold=2]="Bold",f[f.Underline=4]="Underline"})(i=e.FontStyle||(e.FontStyle={}));var R;(function(f){f[f.None=0]="None",f[f.DefaultForeground=1]="DefaultForeground",f[f.DefaultBackground=2]="DefaultBackground"})(R=e.ColorId||(e.ColorId={}));var C;(function(f){f[f.Other=0]="Other",f[f.Comment=1]="Comment",f[f.String=2]="String",f[f.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var w;(function(f){f[f.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",f[f.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",f[f.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",f[f.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",f[f.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",f[f.ITALIC_MASK=2048]="ITALIC_MASK",f[f.BOLD_MASK=4096]="BOLD_MASK",f[f.UNDERLINE_MASK=8192]="UNDERLINE_MASK",f[f.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",f[f.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",f[f.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",f[f.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",f[f.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",f[f.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",f[f.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",f[f.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",f[f.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",f[f.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(w=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(h){return(h&255)>>>0}static getTokenType(h){return(h&1792)>>>8}static getFontStyle(h){return(h&14336)>>>11}static getForeground(h){return(h&8372224)>>>14}static getBackground(h){return(h&4286578688)>>>23}static getClassNameFromMetadata(h){let A=this.getForeground(h),L="mtk"+A,B=this.getFontStyle(h);return B&1&&(L+=" mtki"),B&2&&(L+=" mtkb"),B&4&&(L+=" mtku"),L}static getInlineStyleFromMetadata(h,A){const L=this.getForeground(h),B=this.getFontStyle(h);let ee=`color: ${A[L]};`;return B&1&&(ee+="font-style: italic;"),B&2&&(ee+="font-weight: bold;"),B&4&&(ee+="text-decoration: underline;"),ee}}e.TokenMetadata=m;var s;(function(f){f[f.Method=0]="Method",f[f.Function=1]="Function",f[f.Constructor=2]="Constructor",f[f.Field=3]="Field",f[f.Variable=4]="Variable",f[f.Class=5]="Class",f[f.Struct=6]="Struct",f[f.Interface=7]="Interface",f[f.Module=8]="Module",f[f.Property=9]="Property",f[f.Event=10]="Event",f[f.Operator=11]="Operator",f[f.Unit=12]="Unit",f[f.Value=13]="Value",f[f.Constant=14]="Constant",f[f.Enum=15]="Enum",f[f.EnumMember=16]="EnumMember",f[f.Keyword=17]="Keyword",f[f.Text=18]="Text",f[f.Color=19]="Color",f[f.File=20]="File",f[f.Reference=21]="Reference",f[f.Customcolor=22]="Customcolor",f[f.Folder=23]="Folder",f[f.TypeParameter=24]="TypeParameter",f[f.User=25]="User",f[f.Issue=26]="Issue",f[f.Snippet=27]="Snippet"})(s=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let f=Object.create(null);return f[0]="symbol-method",f[1]="symbol-function",f[2]="symbol-constructor",f[3]="symbol-field",f[4]="symbol-variable",f[5]="symbol-class",f[6]="symbol-struct",f[7]="symbol-interface",f[8]="symbol-module",f[9]="symbol-property",f[10]="symbol-event",f[11]="symbol-operator",f[12]="symbol-unit",f[13]="symbol-value",f[14]="symbol-constant",f[15]="symbol-enum",f[16]="symbol-enum-member",f[17]="symbol-keyword",f[27]="symbol-snippet",f[18]="symbol-text",f[19]="symbol-color",f[20]="symbol-file",f[21]="symbol-reference",f[22]="symbol-customcolor",f[23]="symbol-folder",f[24]="symbol-type-parameter",f[25]="account",f[26]="issues",function(h){const A=f[h];let L=A&&D.iconRegistry.get(A);return L||(console.info("No codicon found for CompletionItemKind "+h),L=D.Codicon.symbolProperty),L.classNames}}(),e.completionKindFromString=function(){let f=Object.create(null);return f.method=0,f.function=1,f.constructor=2,f.field=3,f.variable=4,f.class=5,f.struct=6,f.interface=7,f.module=8,f.property=9,f.event=10,f.operator=11,f.unit=12,f.value=13,f.constant=14,f.enum=15,f["enum-member"]=16,f.enumMember=16,f.keyword=17,f.snippet=27,f.text=18,f.color=19,f.file=20,f.reference=21,f.customcolor=22,f.folder=23,f["type-parameter"]=24,f.typeParameter=24,f.account=25,f.issue=26,function(h,A){let L=f[h];return typeof L=="undefined"&&!A&&(L=9),L}}();var d;(function(f){f[f.Deprecated=1]="Deprecated"})(d=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(f){f[f.KeepWhitespace=1]="KeepWhitespace",f[f.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var v;(function(f){f[f.Invoke=0]="Invoke",f[f.TriggerCharacter=1]="TriggerCharacter",f[f.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(f){f[f.Invoke=1]="Invoke",f[f.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var p;(function(f){f[f.Invoke=1]="Invoke",f[f.TriggerCharacter=2]="TriggerCharacter",f[f.ContentChange=3]="ContentChange"})(p=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var u;(function(f){f[f.Text=0]="Text",f[f.Read=1]="Read",f[f.Write=2]="Write"})(u=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function c(f){return f&&_.URI.isUri(f.uri)&&P.Range.isIRange(f.range)&&(P.Range.isIRange(f.originSelectionRange)||P.Range.isIRange(f.targetSelectionRange))}e.isLocationLink=c;var t;(function(f){f[f.File=0]="File",f[f.Module=1]="Module",f[f.Namespace=2]="Namespace",f[f.Package=3]="Package",f[f.Class=4]="Class",f[f.Method=5]="Method",f[f.Property=6]="Property",f[f.Field=7]="Field",f[f.Constructor=8]="Constructor",f[f.Enum=9]="Enum",f[f.Interface=10]="Interface",f[f.Function=11]="Function",f[f.Variable=12]="Variable",f[f.Constant=13]="Constant",f[f.String=14]="String",f[f.Number=15]="Number",f[f.Boolean=16]="Boolean",f[f.Array=17]="Array",f[f.Object=18]="Object",f[f.Key=19]="Key",f[f.Null=20]="Null",f[f.EnumMember=21]="EnumMember",f[f.Struct=22]="Struct",f[f.Event=23]="Event",f[f.Operator=24]="Operator",f[f.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(f){f[f.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var o;(function(f){const h=new Map;h.set("file",0),h.set("module",1),h.set("namespace",2),h.set("package",3),h.set("class",4),h.set("method",5),h.set("property",6),h.set("field",7),h.set("constructor",8),h.set("enum",9),h.set("interface",10),h.set("function",11),h.set("variable",12),h.set("constant",13),h.set("string",14),h.set("number",15),h.set("boolean",16),h.set("array",17),h.set("object",18),h.set("key",19),h.set("null",20),h.set("enum-member",21),h.set("struct",22),h.set("event",23),h.set("operator",24),h.set("type-parameter",25);const A=new Map;A.set(0,"file"),A.set(1,"module"),A.set(2,"namespace"),A.set(3,"package"),A.set(4,"class"),A.set(5,"method"),A.set(6,"property"),A.set(7,"field"),A.set(8,"constructor"),A.set(9,"enum"),A.set(10,"interface"),A.set(11,"function"),A.set(12,"variable"),A.set(13,"constant"),A.set(14,"string"),A.set(15,"number"),A.set(16,"boolean"),A.set(17,"array"),A.set(18,"object"),A.set(19,"key"),A.set(20,"null"),A.set(21,"enum-member"),A.set(22,"struct"),A.set(23,"event"),A.set(24,"operator"),A.set(25,"type-parameter");function L(j){return h.get(j)}f.fromString=L;function B(j){return A.get(j)}f.toString=B;function ee(j,x){const $=A.get(j);let F=$&&D.iconRegistry.get("symbol-"+$);return F||(console.info("No codicon found for SymbolKind "+j),F=D.Codicon.symbolProperty),`${x?"inline":"block"} ${F.classNames}`}f.toCssClassName=ee})(o=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(h){this.value=h}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var l;(function(f){f[f.Collapsed=0]="Collapsed",f[f.Expanded=1]="Expanded"})(l=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var a;(function(f){f[f.Editing=0]="Editing",f[f.Preview=1]="Preview"})(a=e.CommentMode||(e.CommentMode={}));var g;(function(f){f[f.Other=0]="Other",f[f.Type=1]="Type",f[f.Parameter=2]="Parameter"})(g=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new T.LanguageFeatureRegistry,e.RenameProviderRegistry=new T.LanguageFeatureRegistry,e.CompletionProviderRegistry=new T.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new T.LanguageFeatureRegistry,e.HoverProviderRegistry=new T.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new T.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new T.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new T.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new T.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new T.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new T.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.LinkProviderRegistry=new T.LanguageFeatureRegistry,e.ColorProviderRegistry=new T.LanguageFeatureRegistry,e.SelectionRangeRegistry=new T.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.TokenizationRegistry=new I.TokenizationRegistryImpl;var E;(function(f){f[f.None=0]="None",f[f.Option=1]="Option",f[f.Default=2]="Default",f[f.Preferred=3]="Preferred"})(E=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[180],pe([0,1,6,15,4,3,55,71]),function(Q,e,_,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,T.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new I.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(y,i){if(!y)throw new Error("invalid command");if(typeof y=="string"){if(!i)throw new Error("invalid command");return this.registerCommand({id:y,handler:i})}if(y.description){const s=[];for(let S of y.description.args)s.push(S.constraint);const d=y.handler;y.handler=function(S,...v){return(0,P.validateConstraints)(v,s),d(S,...v)}}const{id:R}=y;let C=this._commands.get(R);C||(C=new D.LinkedList,this._commands.set(R,C));let w=C.unshift(y),m=(0,_.toDisposable)(()=>{w();const s=this._commands.get(R);(s==null?void 0:s.isEmpty())&&this._commands.delete(R)});return this._onDidRegisterCommand.fire(R),m}registerCommandAlias(y,i){return e.CommandsRegistry.registerCommand(y,(R,...C)=>R.get(e.ICommandService).executeCommand(i,...C))}getCommand(y){const i=this._commands.get(y);if(!(!i||i.isEmpty()))return k.Iterable.first(i)}getCommands(){const y=new Map;for(const i of this._commands.keys()){const R=this.getCommand(i);R&&y.set(i,R)}return y}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>_.Disposable.None,onDidExecuteCommand:()=>_.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(ge[80],pe([0,1,10,4,9]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let I=T.userAgent||"";const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",T.isMacintosh),D.set("isLinux",T.isLinux),D.set("isWindows",T.isWindows),D.set("isWeb",T.isWeb),D.set("isMacNative",T.isMacintosh&&!T.isWeb),D.set("isEdge",I.indexOf("Edg/")>=0),D.set("isFirefox",I.indexOf("Firefox")>=0),D.set("isChrome",I.indexOf("Chrome")>=0),D.set("isSafari",I.indexOf("Safari")>=0),D.set("isIPad",I.indexOf("iPad")>=0);const k=Object.prototype.hasOwnProperty;var y;(function(f){f[f.False=0]="False",f[f.True=1]="True",f[f.Defined=2]="Defined",f[f.Not=3]="Not",f[f.Equals=4]="Equals",f[f.NotEquals=5]="NotEquals",f[f.And=6]="And",f[f.Regex=7]="Regex",f[f.NotRegex=8]="NotRegex",f[f.Or=9]="Or",f[f.In=10]="In",f[f.NotIn=11]="NotIn",f[f.Greater=12]="Greater",f[f.GreaterEquals=13]="GreaterEquals",f[f.Smaller=14]="Smaller",f[f.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class i{static false(){return C.INSTANCE}static true(){return w.INSTANCE}static has(h){return m.create(h)}static equals(h,A){return s.create(h,A)}static notEquals(h,A){return v.create(h,A)}static regex(h,A){return n.create(h,A)}static in(h,A){return d.create(h,A)}static not(h){return b.create(h)}static and(...h){return r.create(h)}static or(...h){return l.create(h)}static greater(h,A){return p.create(h,A)}static less(h,A){return c.create(h,A)}static deserialize(h,A=!1){if(!!h)return this._deserializeOrExpression(h,A)}static _deserializeOrExpression(h,A){let L=h.split("||");return l.create(L.map(B=>this._deserializeAndExpression(B,A)))}static _deserializeAndExpression(h,A){let L=h.split("&&");return r.create(L.map(B=>this._deserializeOne(B,A)))}static _deserializeOne(h,A){if(h=h.trim(),h.indexOf("!=")>=0){let L=h.split("!=");return v.create(L[0].trim(),this._deserializeValue(L[1],A))}if(h.indexOf("==")>=0){let L=h.split("==");return s.create(L[0].trim(),this._deserializeValue(L[1],A))}if(h.indexOf("=~")>=0){let L=h.split("=~");return n.create(L[0].trim(),this._deserializeRegexValue(L[1],A))}if(h.indexOf(" in ")>=0){let L=h.split(" in ");return d.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(h)){const L=h.split(">=");return u.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(h)){const L=h.split(">");return p.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(h)){const L=h.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(h)){const L=h.split("<");return c.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(h)?b.create(h.substr(1).trim()):m.create(h)}static _deserializeValue(h,A){if(h=h.trim(),h==="true")return!0;if(h==="false")return!1;let L=/^'([^']*)'$/.exec(h);return L?L[1].trim():h}static _deserializeRegexValue(h,A){if((0,_.isFalsyOrWhitespace)(h)){if(A)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=h.indexOf("/"),B=h.lastIndexOf("/");if(L===B||L<0){if(A)throw new Error(`bad regexp-value '${h}', missing /-enclosure`);return console.warn(`bad regexp-value '${h}', missing /-enclosure`),null}let ee=h.slice(L+1,B),j=h[B+1]==="i"?"i":"";try{return new RegExp(ee,j)}catch(x){if(A)throw new Error(`bad regexp-value '${h}', parse error: ${x}`);return console.warn(`bad regexp-value '${h}', parse error: ${x}`),null}}}e.ContextKeyExpr=i;function R(f,h){return f.cmp(h)}class C{constructor(){this.type=0}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}evaluate(h){return!1}serialize(){return"false"}keys(){return[]}map(h){return this}negate(){return w.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class w{constructor(){this.type=1}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}evaluate(h){return!0}serialize(){return"true"}keys(){return[]}map(h){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=w,w.INSTANCE=new w;class m{constructor(h){this.key=h,this.type=2}static create(h){const A=D.get(h);return typeof A=="boolean"?A?w.INSTANCE:C.INSTANCE:new m(h)}cmp(h){return h.type!==this.type?this.type-h.type:g(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}evaluate(h){return!!h.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(h){return h.mapDefined(this.key)}negate(){return b.create(this.key)}}e.ContextKeyDefinedExpr=m;class s{constructor(h,A){this.key=h,this.value=A,this.type=4}static create(h,A){if(typeof A=="boolean")return A?m.create(h):b.create(h);const L=D.get(h);return typeof L=="boolean"?A===(L?"true":"false")?w.INSTANCE:C.INSTANCE:new s(h,A)}cmp(h){return h.type!==this.type?this.type-h.type:E(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return h.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(h){return h.mapEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyEqualsExpr=s;class d{constructor(h,A){this.key=h,this.valueKey=A,this.type=10}static create(h,A){return new d(h,A)}cmp(h){return h.type!==this.type?this.type-h.type:E(this.key,this.valueKey,h.key,h.valueKey)}equals(h){return h.type===this.type?this.key===h.key&&this.valueKey===h.valueKey:!1}evaluate(h){const A=h.getValue(this.valueKey),L=h.getValue(this.key);return Array.isArray(A)?A.indexOf(L)>=0:typeof L=="string"&&typeof A=="object"&&A!==null?k.call(A,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(h){return h.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=d;class S{constructor(h){this._actual=h,this.type=11}static create(h){return new S(h)}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}evaluate(h){return!this._actual.evaluate(h)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(h){return new S(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class v{constructor(h,A){this.key=h,this.value=A,this.type=5}static create(h,A){if(typeof A=="boolean")return A?b.create(h):m.create(h);const L=D.get(h);return typeof L=="boolean"?A===(L?"true":"false")?C.INSTANCE:w.INSTANCE:new v(h,A)}cmp(h){return h.type!==this.type?this.type-h.type:E(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return h.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(h){return h.mapNotEquals(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=v;class b{constructor(h){this.key=h,this.type=3}static create(h){const A=D.get(h);return typeof A=="boolean"?A?C.INSTANCE:w.INSTANCE:new b(h)}cmp(h){return h.type!==this.type?this.type-h.type:g(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}evaluate(h){return!h.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(h){return h.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=b;class p{constructor(h,A){this.key=h,this.value=A,this.type=12}static create(h,A){return new p(h,A)}cmp(h){return h.type!==this.type?this.type-h.type:E(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=p;class u{constructor(h,A){this.key=h,this.value=A,this.type=13}static create(h,A){return new u(h,A)}cmp(h){return h.type!==this.type?this.type-h.type:E(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreaterEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=u;class c{constructor(h,A){this.key=h,this.value=A,this.type=14}static create(h,A){return new c(h,A)}cmp(h){return h.type!==this.type?this.type-h.type:E(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmaller(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerExpr=c;class t{constructor(h,A){this.key=h,this.value=A,this.type=15}static create(h,A){return new t(h,A)}cmp(h){return h.type!==this.type?this.type-h.type:E(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmallerEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(h,A){this.key=h,this.regexp=A,this.type=7}static create(h,A){return new n(h,A)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.key<h.key)return-1;if(this.key>h.key)return 1;const A=this.regexp?this.regexp.source:"",L=h.regexp?h.regexp.source:"";return A<L?-1:A>L?1:0}equals(h){if(h.type===this.type){const A=this.regexp?this.regexp.source:"",L=h.regexp?h.regexp.source:"";return this.key===h.key&&A===L}return!1}evaluate(h){let A=h.getValue(this.key);return this.regexp?this.regexp.test(A):!1}serialize(){const h=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${h}`}keys(){return[this.key]}map(h){return h.mapRegex(this.key,this.regexp)}negate(){return o.create(this)}}e.ContextKeyRegexExpr=n;class o{constructor(h){this._actual=h,this.type=8}static create(h){return new o(h)}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}evaluate(h){return!this._actual.evaluate(h)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(h){return new o(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;class r{constructor(h){this.expr=h,this.type=6}static create(h){return r._normalizeArr(h)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let A=0,L=this.expr.length;A<L;A++){const B=R(this.expr[A],h.expr[A]);if(B!==0)return B}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].equals(h.expr[A]))return!1;return!0}return!1}evaluate(h){for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].evaluate(h))return!1;return!0}static _normalizeArr(h){const A=[];let L=!1;for(const B of h)if(!!B){if(B.type===1){L=!0;continue}if(B.type===0)return C.INSTANCE;if(B.type===6){A.push(...B.expr);continue}A.push(B)}if(A.length===0&&L)return w.INSTANCE;if(A.length!==0){if(A.length===1)return A[0];for(A.sort(R);A.length>1;){const B=A[A.length-1];if(B.type!==9)break;A.pop();const ee=A.pop(),j=l.create(B.expr.map(x=>r.create([x,ee])));j&&(A.push(j),A.sort(R))}return A.length===1?A[0]:new r(A)}}serialize(){return this.expr.map(h=>h.serialize()).join(" && ")}keys(){const h=[];for(let A of this.expr)h.push(...A.keys());return h}map(h){return new r(this.expr.map(A=>A.map(h)))}negate(){let h=[];for(let A of this.expr)h.push(A.negate());return l.create(h)}}e.ContextKeyAndExpr=r;class l{constructor(h){this.expr=h,this.type=9}static create(h){const A=l._normalizeArr(h);if(A.length!==0)return A.length===1?A[0]:new l(A)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let A=0,L=this.expr.length;A<L;A++){const B=R(this.expr[A],h.expr[A]);if(B!==0)return B}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].equals(h.expr[A]))return!1;return!0}return!1}evaluate(h){for(let A=0,L=this.expr.length;A<L;A++)if(this.expr[A].evaluate(h))return!0;return!1}static _normalizeArr(h){let A=[],L=!1;if(h){for(let B=0,ee=h.length;B<ee;B++){const j=h[B];if(!!j){if(j.type===0){L=!0;continue}if(j.type===1)return[w.INSTANCE];if(j.type===9){A=A.concat(j.expr);continue}A.push(j)}}if(A.length===0&&L)return[C.INSTANCE];A.sort(R)}return A}serialize(){return this.expr.map(h=>h.serialize()).join(" || ")}keys(){const h=[];for(let A of this.expr)h.push(...A.keys());return h}map(h){return new l(this.expr.map(A=>A.map(h)))}negate(){let h=[];for(let L of this.expr)h.push(L.negate());const A=L=>L.type===9?L.expr:[L];for(;h.length>1;){const L=h.shift(),B=h.shift(),ee=[];for(const j of A(L))for(const x of A(B))ee.push(i.and(j,x));h.unshift(i.or(...ee))}return h[0]}}e.ContextKeyOrExpr=l;class a extends m{constructor(h,A,L){super(h);this._defaultValue=A,typeof L=="object"?a._info.push(Object.assign(Object.assign({},L),{key:h})):L!==!0&&a._info.push({key:h,description:L,type:A!=null?typeof A:void 0})}static all(){return a._info.values()}bindTo(h){return h.createKey(this.key,this._defaultValue)}getValue(h){return h.getContextKeyValue(this.key)}toNegated(){return i.not(this.key)}isEqualTo(h){return i.equals(this.key,h)}notEqualsTo(h){return i.notEquals(this.key,h)}}e.RawContextKey=a,a._info=[],e.IContextKeyService=(0,P.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function g(f,h){return f<h?-1:f>h?1:0}function E(f,h,A,L){return f<A?-1:f>A?1:h<L?-1:h>L?1:0}}),define(ge[181],pe([0,1,4]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,_.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,_.refineServiceDecorator)(e.IEnvironmentService)}),define(ge[182],pe([0,1,152,4,11]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function I(C){return C&&typeof C=="object"&&typeof C.id=="string"&&(!C.uuid||typeof C.uuid=="string")}e.isIExtensionIdentifier=I;var D;(function(C){C[C.NoneOrRelevance=0]="NoneOrRelevance",C[C.LastUpdatedDate=1]="LastUpdatedDate",C[C.Title=2]="Title",C[C.PublisherName=3]="PublisherName",C[C.InstallCount=4]="InstallCount",C[C.PublishedDate=5]="PublishedDate",C[C.AverageRating=6]="AverageRating",C[C.WeightedRating=12]="WeightedRating"})(D=e.SortBy||(e.SortBy={}));var k;(function(C){C[C.Default=0]="Default",C[C.Ascending=1]="Ascending",C[C.Descending=2]="Descending"})(k=e.SortOrder||(e.SortOrder={}));var y;(function(C){C.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var i;(function(C){C[C.None=0]="None",C[C.Install=1]="Install",C[C.Update=2]="Update"})(i=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,P.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class R extends Error{constructor(w,m){super(w);this.code=m}}e.ExtensionManagementError=R,e.IExtensionManagementService=(0,P.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,P.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,P.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",Q).toString(!0),e.ExtensionsLabel=(0,_.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,_.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,P.createDecorator)("IExtensionManagementCLIService")}),define(ge[29],pe([0,1,10,4]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function T(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class D{constructor(R){this.value=R,this._lower=R.toLowerCase()}static equals(R,C){if(typeof R=="undefined"||R===null)return typeof C=="undefined"||C===null;if(typeof C=="undefined"||C===null)return!1;if(typeof R=="string"||typeof C=="string"){let w=typeof R=="string"?R:R.value,m=typeof C=="string"?C:C.value;return _.equalsIgnoreCase(w,m)}return R._lower===C._lower}static toKey(R){return typeof R=="string"?R.toLowerCase():R._lower}}e.ExtensionIdentifier=D;function k(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function y(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=(0,P.createDecorator)("IBuiltinExtensionsScannerService")}),define(ge[183],pe([0,1,10,29]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function T(m,s){return m.uuid&&s.uuid?m.uuid===s.uuid:m.id===s.id?!0:(0,_.compareIgnoreCase)(m.id,s.id)===0}e.areSameExtensions=T;class I{constructor(s,d){this.version=d,this.id=s.id,this.uuid=s.uuid}key(){return`${this.id}-${this.version}`}equals(s){return s instanceof I?T(this,s)&&this.version===s.version:!1}}e.ExtensionIdentifierWithVersion=I;function D(m,s){return`${m}.${s}`}e.getExtensionId=D;function k(m){return m.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function y(m,s){return k(D(m,s))}e.getGalleryExtensionId=y;function i(m,s){const d=[],S=v=>{for(const b of d)if(b.some(p=>T(s(p),s(v))))return b;return null};for(const v of m){const b=S(v);b?b.push(v):d.push([v])}return d}e.groupByExtension=i;function R(m){return{id:m.identifier.id,name:m.manifest.name,galleryId:null,publisherId:m.publisherId,publisherName:m.manifest.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:m.manifest.extensionDependencies&&m.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function C(m){return Object.assign({id:m.identifier.id,name:m.name,galleryId:m.identifier.uuid,publisherId:m.publisherId,publisherName:m.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:!!(m.properties.dependencies&&m.properties.dependencies.length>0)},m.telemetryData)}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function w(m){const s=new Set;for(const d of m)d.malicious&&s.add(d.id.id);return s}e.getMaliciousExtensionsSet=w}),define(ge[45],pe([0,1,154,8,2,4,10,15,24]),function(Q,e,_,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function i(j){return j.create===!0}e.isFileOpenForWriteOptions=i;var R;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var C;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function w(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=w;function m(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=m;function s(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=s;function d(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=d;var S;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(x,$){super(x);this.code=$}}e.FileSystemProviderError=v;function b(j,x){const $=new v(j.toString(),x);return u($,x),$}e.createFileSystemProviderError=b;function p(j){return j||b((0,_.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=p;function u(j,x){return j.name=x?`${x} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=u;function c(j){if(!j)return S.Unknown;if(j instanceof v)return j.code;const x=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!x)return S.Unknown;switch(x[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=c;function t(j){if(j instanceof g)return j.fileOperationResult;switch(c(j)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class o{constructor(x,$,F){this.resource=x,this.operation=$,this.target=F}isOperation(x){return this.operation===x}}e.FileOperationEvent=o;var r;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(r=e.FileChangeType||(e.FileChangeType={}));class l{constructor(x,$){this.ignorePathCasing=$,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=x;for(const F of x)switch(F.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(F.resource,F);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(F.resource,F);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(F.resource,F);break}}contains(x,...$){return this.doContains(x,{includeChildren:!1},...$)}affects(x,...$){return this.doContains(x,{includeChildren:!0},...$)}doContains(x,$,...F){var U,M,N,O,V,q;if(!x)return!1;const J=F.length>0;return!!((!J||F.includes(1))&&(((U=this.added)===null||U===void 0?void 0:U.get(x))||$.includeChildren&&((M=this.added)===null||M===void 0?void 0:M.findSuperstr(x)))||(!J||F.includes(0))&&(((N=this.updated)===null||N===void 0?void 0:N.get(x))||$.includeChildren&&((O=this.updated)===null||O===void 0?void 0:O.findSuperstr(x)))||(!J||F.includes(2))&&(((V=this.deleted)===null||V===void 0?void 0:V.findSubstr(x))||$.includeChildren&&((q=this.deleted)===null||q===void 0?void 0:q.findSuperstr(x))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(x){const $=[],F=x===1?this.added:x===0?this.updated:this.deleted;if(F)for(const[,U]of F)$.push(U);return $}filter(x){return new l(this.changes.filter($=>x($)),this.ignorePathCasing)}}e.FileChangesEvent=l;function a(j,x,$){return!j||!x||j===x||x.length>j.length?!1:(x.charAt(x.length-1)!==P.sep&&(x+=P.sep),$?(0,D.startsWithIgnoreCase)(j,x):j.indexOf(x)===0)}e.isParent=a;class g extends Error{constructor(x,$,F){super(x);this.fileOperationResult=$,this.options=F}static isFileOperationError(x){return x instanceof Error&&!(0,k.isUndefinedOrNull)(x.fileOperationResult)}}e.FileOperationError=g;var E;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(E=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var f;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(f=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function h(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=h;async function A(j,x){if(!x.canHandleResource(T.URI.from({scheme:j.scheme})))return new Promise($=>{const F=x.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===j.scheme&&U.added&&(F.dispose(),$())})})}e.whenProviderRegistered=A,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(x){return(0,k.isNumber)(x)||(x=0),x<L.KB?(0,_.localize)(1,null,x.toFixed(0)):x<L.MB?(0,_.localize)(2,null,(x/L.KB).toFixed(2)):x<L.GB?(0,_.localize)(3,null,(x/L.MB).toFixed(2)):x<L.TB?(0,_.localize)(4,null,(x/L.GB).toFixed(2)):(0,_.localize)(5,null,(x/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var B;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function ee(j){return{maxFileSize:j===0?300*L.MB:16*L.GB,maxHeapSize:j===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=ee}),define(ge[81],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class _{constructor(...T){this._entries=new Map;for(let[I,D]of T)this.set(I,D)}set(T,I){const D=this._entries.get(T);return this._entries.set(T,I),D}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=_}),define(ge[184],pe([0,1,18,177,109,4,81,19]),function(Q,e,_,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class i extends Error{constructor(s){super("cyclic dependency between services");this.message=s.toString()}}class R{constructor(s=new D.ServiceCollection,d=!1,S){this._activeInstantiations=new Set,this._services=s,this._strict=d,this._parent=S,this._services.set(I.IInstantiationService,this)}createChild(s){return new R(s,this._strict,this)}invokeFunction(s,...d){let S=w.traceInvocation(s),v=!1;try{return s({get:(p,u)=>{if(v)throw(0,_.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(p,S);if(!c&&u!==I.optional)throw new Error(`[invokeFunction] unknown service '${p}'`);return c}},...d)}finally{v=!0,S.stop()}}createInstance(s,...d){let S,v;return s instanceof T.SyncDescriptor?(S=w.traceCreation(s.ctor),v=this._createInstance(s.ctor,s.staticArguments.concat(d),S)):(S=w.traceCreation(s),v=this._createInstance(s,d,S)),S.stop(),v}_createInstance(s,d=[],S){let v=I._util.getServiceDependencies(s).sort((u,c)=>u.index-c.index),b=[];for(const u of v){let c=this._getOrCreateServiceInstance(u.id,S);if(!c&&this._strict&&!u.optional)throw new Error(`[createInstance] ${s.name} depends on UNKNOWN service ${u.id}.`);b.push(c)}let p=v.length>0?v[0].index:d.length;if(d.length!==p){console.warn(`[createInstance] First service dependency of ${s.name} at position ${p+1} conflicts with ${d.length} static arguments`);let u=p-d.length;u>0?d=d.concat(new Array(u)):d=d.slice(0,p)}return new s(...[...d,...b])}_setServiceInstance(s,d){if(this._services.get(s)instanceof T.SyncDescriptor)this._services.set(s,d);else if(this._parent)this._parent._setServiceInstance(s,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){let d=this._services.get(s);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):d}_getOrCreateServiceInstance(s,d){let S=this._getServiceInstanceOrDescriptor(s);return S instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,S,d.branch(s,!0)):(d.branch(s,!1),S)}_safeCreateAndCacheServiceInstance(s,d,S){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,d,S)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,d,S){const v=new P.Graph(u=>u.id.toString());let b=0;const p=[{id:s,desc:d,_trace:S}];for(;p.length;){const u=p.pop();if(v.lookupOrInsertNode(u),b++>1e3)throw new i(v);for(let c of I._util.getServiceDependencies(u.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(c.id);if(!t&&!c.optional&&console.warn(`[createInstance] ${s} depends on ${c.id} which is NOT registered.`),t instanceof T.SyncDescriptor){const n={id:c.id,desc:t,_trace:u._trace.branch(c.id,!0)};v.insertEdge(u,n),p.push(n)}}}for(;;){const u=v.roots();if(u.length===0){if(!v.isEmpty())throw new i(v);break}for(const{data:c}of u){if(this._getServiceInstanceOrDescriptor(c.id)instanceof T.SyncDescriptor){const n=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,n)}v.removeNode(c)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,d,S=[],v,b){if(this._services.get(s)instanceof T.SyncDescriptor)return this._createServiceInstance(d,S,v,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,d,S,v,b);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(s,d=[],S,v){if(S){const b=new k.IdleValue(()=>this._createInstance(s,d,v));return new Proxy(Object.create(null),{get(p,u){if(u in p)return p[u];let c=b.value,t=c[u];return typeof t!="function"||(t=t.bind(c),p[u]=t),t},set(p,u,c){return b.value[u]=c,!0}})}else return this._createInstance(s,d,v)}}e.InstantiationService=R;var C;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(C||(C={}));class w{constructor(s,d){this.type=s,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(s){return y?new w(1,s.name||s.toString().substring(0,42).replace(/\n/g,"")):w._None}static traceCreation(s){return y?new w(0,s.name):w._None}branch(s,d){let S=new w(2,s.toString());return this._dep.push([s,d,S]),S}stop(){let s=Date.now()-this._start;w._totals+=s;let d=!1;function S(b,p){let u=[],c=new Array(b+1).join("	");for(const[t,n,o]of p._dep)if(n&&o){d=!0,u.push(`${c}CREATES -> ${t}`);let r=S(b+1,o);r&&u.push(r)}else u.push(`${c}uses -> ${t}`);return u.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(s>2||d)&&console.log(v.join(`
`))}}w._None=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w._totals=0}),define(ge[12],pe([0,1,4,6,9,3,58]),function(Q,e,_,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function k(){return new Date().toISOString()}var y;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class i extends P.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=i;class R extends i{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(y.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(y.Error,this.format(o))}else this.log(y.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let o=0;o<t.length;o++){let r=t[o];if(typeof r=="object")try{r=JSON.stringify(r)}catch(l){}n+=(o>0?" ":"")+r}return n}}e.AbstractMessageLogger=R;class C extends i{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!T.isWindows}trace(t,...n){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...n):console.log(`[main ${k()}]`,t,...n))}debug(t,...n){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...n):console.log(`[main ${k()}]`,t,...n))}info(t,...n){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...n):console.log(`[main ${k()}]`,t,...n))}warn(t,...n){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,t,...n):console.warn(`[main ${k()}]`,t,...n))}error(t,...n){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,t,...n):console.error(`[main ${k()}]`,t,...n))}critical(t,...n){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,t,...n):console.error(`[main ${k()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class w extends i{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=w;class m extends i{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class s extends i{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const o of this.logServices)o.trace(t,...n)}debug(t,...n){for(const o of this.logServices)o.debug(t,...n)}info(t,...n){for(const o of this.logServices)o.info(t,...n)}warn(t,...n){for(const o of this.logServices)o.warn(t,...n)}error(t,...n){for(const o of this.logServices)o.error(t,...n)}critical(t,...n){for(const o of this.logServices)o.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=s;class d extends P.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=d;class S extends P.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(o))}))}createLogger(t,n){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,(n==null?void 0:n.always)?y.Trace:this.logLevel,n),this.loggers.set(t.toString(),o),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class v{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=v;function b(c){if(c.verbose)return y.Trace;if(typeof c.logLevel=="string"){const t=p(c.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function p(c){switch(c){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=p;function u(c){switch(c){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=u}),define(ge[110],pe([0,1,12,45]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function T(y,i,R,C){try{const w=await new Promise((m,s)=>{Q(["spdlog"],m,s)});return w.setAsyncMode(8192,500),w.createRotatingLoggerAsync(y,i,R,C)}catch(w){console.error(w)}return null}function I(y,i,R,C){return Q.__$__nodeRequire("spdlog").createRotatingLogger(y,i,R,C)}e.createRotatingLogger=I;function D(y,i,R){switch(i){case _.LogLevel.Trace:y.trace(R);break;case _.LogLevel.Debug:y.debug(R);break;case _.LogLevel.Info:y.info(R);break;case _.LogLevel.Warning:y.warn(R);break;case _.LogLevel.Error:y.error(R);break;case _.LogLevel.Critical:y.critical(R);break;default:throw new Error("Invalid log level")}}class k extends _.AbstractMessageLogger{constructor(i,R,C,w){super();this.name=i,this.filepath=R,this.rotating=C,this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const i=this.rotating?6:1,R=30/i*P.ByteSize.MB;return T(this.name,this.filepath,R,i).then(C=>{if(C){this._logger=C,this._logger.setLevel(this.getLevel());for(const{level:w,message:m}of this.buffer)D(this._logger,w,m);this.buffer=[]}})}log(i,R){this._logger?D(this._logger,i,R):this.getLevel()<=i&&this.buffer.push({level:i,message:R})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(ge[111],pe([0,1,4,155,56]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(I=e.MarkerTag||(e.MarkerTag={}));var D;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function i(s,d){return d-s}y.compare=i;const R=Object.create(null);R[y.Error]=(0,P.localize)(0,null),R[y.Warning]=(0,P.localize)(1,null),R[y.Info]=(0,P.localize)(2,null);function C(s){return R[s]||""}y.toString=C;function w(s){switch(s){case T.default.Error:return y.Error;case T.default.Warning:return y.Warning;case T.default.Info:return y.Info;case T.default.Ignore:return y.Hint}}y.fromSeverity=w;function m(s){switch(s){case y.Error:return T.default.Error;case y.Warning:return T.default.Warning;case y.Info:return T.default.Info;case y.Hint:return T.default.Ignore}}y.toSeverity=m}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(y){const i="";function R(w){return C(w,!0)}y.makeKey=R;function C(w,m){let s=[i];return w.source?s.push(w.source.replace("\xA6","\\\xA6")):s.push(i),w.code?typeof w.code=="string"?s.push(w.code.replace("\xA6","\\\xA6")):s.push(w.code.value.replace("\xA6","\\\xA6")):s.push(i),w.severity!==void 0&&w.severity!==null?s.push(D.toString(w.severity)):s.push(i),w.message&&m?s.push(w.message.replace("\xA6","\\\xA6")):s.push(i),w.startLineNumber!==void 0&&w.startLineNumber!==null?s.push(w.startLineNumber.toString()):s.push(i),w.startColumn!==void 0&&w.startColumn!==null?s.push(w.startColumn.toString()):s.push(i),w.endLineNumber!==void 0&&w.endLineNumber!==null?s.push(w.endLineNumber.toString()):s.push(i),w.endColumn!==void 0&&w.endColumn!==null?s.push(w.endColumn.toString()):s.push(i),s.push(i),s.join("\xA6")}y.makeKeyOptionalMessage=C})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(ge[185],pe([0,1,56,4,3]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=_.default,e.INotificationService=(0,P.createDecorator)("notificationService");var I;(function(i){i[i.WORKSPACE=0]="WORKSPACE",i[i.GLOBAL=1]="GLOBAL"})(I=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(i){i[i.OFF=0]="OFF",i[i.SILENT=1]="SILENT",i[i.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new y,this.onDidClose=T.Event.None,this.onDidChangeVisibility=T.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=k;class y{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=y}),define(ge[186],pe([0,1,11,9,36,25]),function(Q,e,_,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof P.globals.vscode!="undefined"){const k=P.globals.vscode.context.configuration();if(k)D=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(Q==null?void 0:Q.__$__nodeRequire)=="function"){const k=(0,I.dirname)(_.FileAccess.asFileUri("",Q));D=Q.__$__nodeRequire((0,I.joinPath)(k,"product.json").fsPath);const y=Q.__$__nodeRequire((0,I.joinPath)(k,"package.json").fsPath);T.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`}),Object.assign(D,{version:y.version})}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.56.0-dev",nameShort:P.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:P.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=D});var je=this&&this.__decorate||function(Q,e,_,P){var T=arguments.length,I=T<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,_):P,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(Q,e,_,P);else for(var k=Q.length-1;k>=0;k--)(D=Q[k])&&(I=(T<3?D(I):T>3?D(e,_,I):D(e,_))||I);return T>3&&I&&Object.defineProperty(e,_,I),I},xe=this&&this.__param||function(Q,e){return function(_,P){e(_,P,Q)}};define(ge[112],pe([0,1,4,21,6,19]),function(Q,e,_,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,_.createDecorator)("progressService");var D;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let y=class extends T.Disposable{constructor(C,w){super();this.deferred=new I.DeferredPromise,w.withProgress(C,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,T.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};y=je([xe(1,e.IProgressService)],y),e.UnmanagedProgress=y;class i extends T.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new T.DisposableStore)}start(C){this.stop();const w=++this.currentOperationId,m=new P.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{w===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,T.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,T.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,T.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:w,token:m.token,stop:()=>this.doStop(w),isCurrent:()=>this.currentOperationId===w}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=i,e.IEditorProgressService=(0,_.createDecorator)("editorProgressService")}),define(ge[40],pe([0,1,15,52]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(D,k){P.ok(_.isString(D)),P.ok(_.isObject(k)),P.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,k)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new T}),define(ge[113],pe([0,1,40,3]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class I{constructor(){this._onDidChangeSchema=new P.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,i){this.schemasById[T(y)]=i,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new I;_.Registry.add(e.Extensions.JSONContribution,D)}),define(ge[82],pe([0,1,151,3,40,15,113]),function(Q,e,_,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=T.Registry.as(D.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new P.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new P.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(v,b=!0){this.registerConfigurations([v],b)}registerConfigurations(v,b=!0){const p=[];v.forEach(u=>{p.push(...this.validateAndRegisterProperties(u,b,u.extensionInfo)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterConfigurations(v){const b=[],p=u=>{if(u.properties)for(const c in u.properties)b.push(c),delete this.configurationProperties[c],this.removeFromSchema(c,u.properties[c]);u.allOf&&u.allOf.forEach(c=>p(c))};for(const u of v){p(u);const c=this.configurationContributors.indexOf(u);c!==-1&&this.configurationContributors.splice(c,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}registerDefaultConfigurations(v){const b=[],p=[];for(const u of v)for(const c in u)if(b.push(c),e.OVERRIDE_PROPERTY_PATTERN.test(c)){this.defaultValues[c]=Object.assign(Object.assign({},this.defaultValues[c]||{}),u[c]);const t={type:"object",default:this.defaultValues[c],description:_.localize(1,null,c),$ref:e.resourceLanguageSettingsSchemaId};p.push(C(c)),this.configurationProperties[c]=t,this.defaultLanguageConfigurationOverridesNode.properties[c]=t}else{this.defaultValues[c]=u[c];const t=this.configurationProperties[c];t&&(this.updatePropertyDefaultValue(c,t),this.updateSchema(c,t))}this.registerOverrideIdentifiers(p),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}deregisterDefaultConfigurations(v){const b=[];for(const p of v)for(const u in p)if(b.push(u),delete this.defaultValues[u],e.OVERRIDE_PROPERTY_PATTERN.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const c=this.configurationProperties[u];c&&(this.updatePropertyDefaultValue(u,c),this.updateSchema(u,c))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}notifyConfigurationSchemaUpdated(...v){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(v){for(const b of v)this.overrideIdentifiers.add(b);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(v,b=!0,p,u=3){var c;u=I.isUndefinedOrNull(v.scope)?u:v.scope;let t=[],n=v.properties;if(n)for(let r in n){if(b&&s(r)){delete n[r];continue}const l=n[r];if(this.updatePropertyDefaultValue(r,l),e.OVERRIDE_PROPERTY_PATTERN.test(r)?l.scope=void 0:(l.scope=I.isUndefinedOrNull(l.scope)?u:l.scope,l.requireTrust=I.isUndefinedOrNull(l.requireTrust)?!!((c=p==null?void 0:p.requireTrustForConfigurations)===null||c===void 0?void 0:c.includes(r)):l.requireTrust),n[r].hasOwnProperty("included")&&!n[r].included){this.excludedConfigurationProperties[r]=n[r],delete n[r];continue}else this.configurationProperties[r]=n[r];!n[r].deprecationMessage&&n[r].markdownDeprecationMessage&&(n[r].deprecationMessage=n[r].markdownDeprecationMessage),t.push(r)}let o=v.allOf;if(o)for(let r of o)t.push(...this.validateAndRegisterProperties(r,b,p,u));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(v){const b=p=>{let u=p.properties;if(u)for(const t in u)this.updateSchema(t,u[t]);let c=p.allOf;c&&c.forEach(b)};b(v)}updateSchema(v,b){switch(e.allSettings.properties[v]=b,b.scope){case 1:e.applicationSettings.properties[v]=b;break;case 2:e.machineSettings.properties[v]=b;break;case 6:e.machineOverridableSettings.properties[v]=b;break;case 3:e.windowSettings.properties[v]=b;break;case 4:e.resourceSettings.properties[v]=b;break;case 5:e.resourceSettings.properties[v]=b,this.resourceLanguageSettingsSchema.properties[v]=b;break}}removeFromSchema(v,b){switch(delete e.allSettings.properties[v],b.scope){case 1:delete e.applicationSettings.properties[v];break;case 2:delete e.machineSettings.properties[v];break;case 6:delete e.machineOverridableSettings.properties[v];break;case 3:delete e.windowSettings.properties[v];break;case 4:case 5:delete e.resourceSettings.properties[v];break}}updateOverridePropertyPatternKey(){for(const v of this.overrideIdentifiers.values()){const b=`[${v}]`,p={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(b,p),e.allSettings.properties[b]=p,e.applicationSettings.properties[b]=p,e.machineSettings.properties[b]=p,e.machineOverridableSettings.properties[b]=p,e.windowSettings.properties[b]=p,e.resourceSettings.properties[b]=p}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(v,b){let p=this.defaultValues[v];I.isUndefined(p)&&(p=b.default),I.isUndefined(p)&&(p=w(b.type)),b.default=p}}const R="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(R);function C(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=C;function w(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=w;const m=new i;T.Registry.add(e.Extensions.Configuration,m);function s(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?_.localize(5,null,S):m.getConfigurationProperties()[S]!==void 0?_.localize(6,null,S):null:_.localize(4,null)}e.validateProperty=s;function d(){const S=[],v=m.getConfigurationProperties();for(const b of Object.keys(v))S.push([b,v[b].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=d}),define(ge[83],pe([0,1,23,15,2,40,4,82]),function(Q,e,_,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function y(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof T.URI)}e.isConfigurationOverrides=y;var i;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(i=e.ConfigurationTarget||(e.ConfigurationTarget={}));function R(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=R;function C(n,o){const r=o?n?o.keys.filter(A=>n.keys.indexOf(A)===-1):[...o.keys]:[],l=n?o?n.keys.filter(A=>o.keys.indexOf(A)===-1):[...n.keys]:[],a=[];if(o&&n){for(const A of n.keys)if(o.keys.indexOf(A)!==-1){const L=v(n.contents,A),B=v(o.contents,A);_.equals(L,B)||a.push(A)}}const g=[],E=A=>{const L={};for(const B of A)for(const ee of B.identifiers)L[c(ee)]=B;return L},f=o?E(o.overrides):{},h=n?E(n.overrides):{};if(Object.keys(f).length)for(const A of r){const L=f[A];L&&g.push([(0,k.overrideIdentifierFromKey)(A),L.keys])}if(Object.keys(h).length)for(const A of l){const L=h[A];L&&g.push([(0,k.overrideIdentifierFromKey)(A),L.keys])}if(Object.keys(f).length&&Object.keys(h).length)for(const A of a){const L=h[A],B=f[A];if(L&&B){const ee=C({contents:L.contents,keys:L.keys,overrides:[]},{contents:B.contents,keys:B.keys,overrides:[]});g.push([(0,k.overrideIdentifierFromKey)(A),[...ee.added,...ee.removed,...ee.updated]])}}return{added:r,removed:l,updated:a,overrides:g}}e.compare=C;function w(n,o){const r=[];for(const l of Object.keys(n))if(k.OVERRIDE_PROPERTY_PATTERN.test(l)){const a={};for(const g in n[l])a[g]=n[l][g];r.push({identifiers:[(0,k.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(a),contents:m(a,o)})}return r}e.toOverrides=w;function m(n,o){const r=Object.create(null);for(let l in n)s(r,l,n[l],o);return r}e.toValuesTree=m;function s(n,o,r,l){const a=o.split("."),g=a.pop();let E=n;for(let f=0;f<a.length;f++){let h=a[f],A=E[h];switch(typeof A){case"undefined":A=E[h]=Object.create(null);break;case"object":break;default:l(`Ignoring ${o} as ${a.slice(0,f+1).join(".")} is ${JSON.stringify(A)}`);return}E=A}if(typeof E=="object"&&E!==null)try{E[g]=r}catch(f){l(`Ignoring ${o} as ${a.join(".")} is ${JSON.stringify(E)}`)}else l(`Ignoring ${o} as ${a.join(".")} is ${JSON.stringify(E)}`)}e.addToValueTree=s;function d(n,o){const r=o.split(".");S(n,r)}e.removeFromValueTree=d;function S(n,o){const r=o.shift();if(o.length===0){delete n[r];return}if(Object.keys(n).indexOf(r)!==-1){const l=n[r];typeof l=="object"&&!Array.isArray(l)&&(S(l,o),Object.keys(l).length===0&&delete n[r])}}function v(n,o,r){function l(E,f){let h=E;for(const A of f){if(typeof h!="object"||h===null)return;h=h[A]}return h}const a=o.split("."),g=l(n,a);return typeof g=="undefined"?r:g}e.getConfigurationValue=v;function b(n,o,r){Object.keys(o).forEach(l=>{l!=="__proto__"&&(l in n?P.isObject(n[l])&&P.isObject(o[l])?b(n[l],o[l],r):r&&(n[l]=o[l]):n[l]=o[l])})}e.merge=b;function p(){const n=I.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=p;function u(){const n=Object.create(null),o=I.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let r in o){let l=o[r].default;s(n,r,l,a=>console.error(`Conflict in default settings: ${a}`))}return n}e.getDefaultValues=u;function c(n){return`[${n}]`}e.keyFromOverrideIdentifier=c;function t(n,o,r){const l=n.inspect(o),a=n.inspect(r);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:l.defaultValue}e.getMigratedSettingValue=t}),define(ge[187],pe([0,1,54,24,14,15,23,2,82,83,40,6,3]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},n=[],o=[]){this._contents=t,this._keys=n,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const o=this.getContentsForOverrideIdentifer(n);return o?t?(0,i.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let o={};for(const r of T.distinct([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[r],a=n[r];a&&(typeof l=="object"&&typeof a=="object"?(l=D.deepClone(l),this.mergeContents(l,a)):l=a),o[r]=l}return new m(o,this.keys,this.overrides)}merge(...t){const n=D.deepClone(this.contents),o=D.deepClone(this.overrides),r=[...this.keys];for(const l of t){this.mergeContents(n,l.contents);for(const a of l.overrides){const[g]=o.filter(E=>T.equals(E.identifiers,a.identifiers));g?this.mergeContents(g.contents,a.contents):o.push(D.deepClone(a))}for(const a of l.keys)r.indexOf(a)===-1&&r.push(a)}return new m(n,r,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const o of Object.keys(n)){if(o in t&&I.isObject(t[o])&&I.isObject(n[o])){this.mergeContents(t[o],n[o]);continue}t[o]=D.deepClone(n[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?D.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,i.addToValueTree)(this.contents,t,n,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let o=0;o<n;o++)t.indexOf(this.keys[o])===0&&(n=o);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=m;class s extends m{constructor(){const t=(0,i.getDefaultValues)(),n=(0,i.getConfigurationKeys)(),o=[];for(const r of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(r)&&o.push({identifiers:[(0,y.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,i.toValuesTree)(t[r],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,n,o)}}e.DefaultConfigurationModel=s;class d{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!I.isUndefinedOrNull(t)){const o=this.doParseContent(t);this.parseRaw(o,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:o,keys:r,overrides:l,untrusted:a}=this.doParseRaw(t,n);this._configurationModel=new m(o,r,l),this._untrustedConfigurations=a||[]}doParseContent(t){let n={},o=null,r=[],l=[],a=[];function g(f){Array.isArray(r)?r.push(f):o&&(r[o]=f)}let E={onObjectBegin:()=>{let f={};g(f),l.push(r),r=f,o=null},onObjectProperty:f=>{o=f},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{let f=[];g(f),l.push(r),r=f,o=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:g,onError:(f,h,A)=>{a.push({error:f,offset:h,length:A})}};if(t)try{_.visit(t,E),n=r[0]||{}}catch(f){console.error(`Error while parsing settings file ${this._name}: ${f}`),this._parseErrors=[f]}return n}doParseRaw(t,n){const o=R.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,o,!0,n);t=r.raw;const l=(0,i.toValuesTree)(t,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),a=Object.keys(t),g=(0,i.toOverrides)(t,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:l,keys:a,overrides:g,untrusted:r.untrusted}}filter(t,n,o,r){if(!(r==null?void 0:r.scopes)&&!(r==null?void 0:r.isUntrusted))return{raw:t,untrusted:[]};const l={},a=[];for(let g in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(g)&&o){const E=this.filter(t[g],n,!1,r);l[g]=E.raw,a.push(...E.untrusted)}else{const E=n[g],f=E?typeof E.scope!="undefined"?E.scope:3:void 0;(f===void 0||r.scopes===void 0||r.scopes.includes(f))&&(r.isUntrusted&&(E==null?void 0:E.requireTrust)?a.push(g):l[g]=t[g])}return{raw:l,untrusted:a}}}e.ConfigurationModelParser=d;class S extends C.Disposable{constructor(t,n,o,r){super();this.userSettingsResource=t,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(w.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=S;class v{constructor(t,n,o=new m,r=new m,l=new P.ResourceMap,a=new m,g=new P.ResourceMap,E=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=r,this._folderConfigurations=l,this._memoryConfiguration=a,this._memoryConfigurationByResource=g,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(t,n,o){return this.getConsolidateConfigurationModel(n,o).getValue(t)}updateValue(t,n,o={}){let r;o.resource?(r=this._memoryConfigurationByResource.get(o.resource),r||(r=new m,this._memoryConfigurationByResource.set(o.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(t):r.setValue(t,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,o){const r=this.getConsolidateConfigurationModel(n,o),l=this.getFolderConfigurationModelForResource(n.resource,o),a=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,g=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),E=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),f=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),h=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),A=o?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=l?n.overrideIdentifier?l.freeze().override(n.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,B=n.overrideIdentifier?a.override(n.overrideIdentifier).getValue(t):a.getValue(t),ee=r.getValue(t),j=T.distinct(T.flatten(r.overrides.map(x=>x.identifiers))).filter(x=>r.getOverrideValue(t,x)!==void 0);return{defaultValue:g,userValue:E,userLocalValue:f,userRemoteValue:h,workspaceValue:A,workspaceFolderValue:L,memoryValue:B,value:ee,default:g!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:f!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:h!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:A!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:l==null?void 0:l.freeze().getValue(t),override:n.overrideIdentifier?l==null?void 0:l.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:B!==void 0?{value:a.getValue(t),override:n.overrideIdentifier?a.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const o=n.filter(r=>y.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const l=(0,y.overrideIdentifierFromKey)(r),a=this._defaultConfiguration.getKeysForOverrideIdentifier(l),g=t.getKeysForOverrideIdentifier(l),E=[...g.filter(f=>a.indexOf(f)===-1),...a.filter(f=>g.indexOf(f)===-1),...a.filter(f=>!D.equals(this._defaultConfiguration.override(l).getValue(f),t.override(l).getValue(f)))];return[l,E]});return this.updateDefaultConfiguration(t),{keys:n,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:o,removed:r,overrides:l}=(0,i.compare)(this.localUserConfiguration,t),a=[...n,...o,...r];return a.length&&this.updateLocalUserConfiguration(t),{keys:a,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:o,removed:r,overrides:l}=(0,i.compare)(this.remoteUserConfiguration,t);let a=[...n,...o,...r];return a.length&&this.updateRemoteUserConfiguration(t),{keys:a,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:o,removed:r,overrides:l}=(0,i.compare)(this.workspaceConfiguration,t);let a=[...n,...o,...r];return a.length&&this.updateWorkspaceConfiguration(t),{keys:a,overrides:l}}compareAndUpdateFolderConfiguration(t,n){const o=this.folderConfigurations.get(t),{added:r,updated:l,removed:a,overrides:g}=(0,i.compare)(o,n);let E=[...r,...l,...a];return(E.length||!o)&&this.updateFolderConfiguration(t,n),{keys:E,overrides:g}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:r,removed:l,overrides:a}=(0,i.compare)(n,void 0);return{keys:[...o,...r,...l],overrides:a}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let o=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const r=n.getFolder(t);r&&(o=this.getFolderConsolidatedConfiguration(r.uri)||o);const l=this._memoryConfigurationByResource.get(t);l&&(o=o.merge(l))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(n=o.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=o}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const o=n.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:o,overrides:r,keys:l}=this._folderConfigurations.get(n);return t.push([n,{contents:o,overrides:r,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((a,g)=>(a.set(k.URI.revive(g[0]),this.parseConfigurationModel(g[1])),a),new P.ResourceMap);return new v(n,o,new m,r,l,new m,new P.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=v;function b(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const t=new Set,n=new Map;for(const r of c)r.keys.forEach(l=>t.add(l)),r.overrides.forEach(([l,a])=>{const g=(0,P.getOrSet)(n,l,new Set);a.forEach(E=>g.add(E))});const o=[];return n.forEach((r,l)=>o.push([l,[...r.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=b;class p{constructor(t,n,o,r){this.change=t,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=r,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(g=>l.add(g)),t.overrides.forEach(([,g])=>g.forEach(E=>l.add(E))),this.affectedKeys=[...l.values()];const a=new m;this.affectedKeys.forEach(g=>a.setValue(g,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var o;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(o=this.previous)===null||o===void 0?void 0:o.workspace):void 0,l=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!D.equals(r,l)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let o=(0,i.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof o=="object"&&(r=Object.keys(o)[0]);){if(t=t[r],!t)return!1;o=o[r]}return!0}}e.ConfigurationChangeEvent=p;class u extends p{constructor(t,n,o,r){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=o,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=u}),define(ge[114],pe([0,1,4]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,_.createDecorator)("remoteAuthorityResolverService");var P;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(P=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(D,k=P.Unknown,y){super(D);this._message=D,this._code=k,this._detail=y,this.isHandled=k===P.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(D){return D instanceof T&&D._code===P.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof T&&D._code===P.NoResolverFound}static isHandled(D){return D instanceof T&&D.isHandled}}e.RemoteAuthorityResolverError=T}),define(ge[115],pe([0,1,11]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function P(y){return y.scheme===_.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=P;function T(y){if(!!y){const i=y.indexOf("+");return i<0?y:y.substr(0,i)}}e.getRemoteName=T;function I(y){return y.scheme!==_.Schemas.file&&y.scheme!==_.Schemas.vscodeRemote}function D(y){const i=y.configuration;if(i&&I(i))return i;if(y.folders.length){const R=y.folders[0].uri;if(I(R))return R}}e.getVirtualWorkspaceLocation=D;function k(y){var i;return(i=D(y))===null||i===void 0?void 0:i.scheme}e.getVirtualWorkspaceScheme=k}),define(ge[188],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class _{vsda(){return new Promise((T,I)=>Q(["vsda"],T,I))}async sign(T){try{const I=await this.vsda(),D=new I.signer;if(D)return D.sign(T)}catch(I){}return T}}e.SignService=_}),define(ge[189],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class _{constructor(T){this._callback=T,this._terminalBufferMap=new Map}dispose(){for(const T of this._terminalBufferMap.values())T.dispose()}startBuffering(T,I,D=5){let k;return k=I(y=>{const i=typeof y=="string"?y:y.data;let R=this._terminalBufferMap.get(T);if(R){R.data.push(i);return}const C=setTimeout(()=>this.flushBuffer(T),D);R={data:[i],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(T),k.dispose()}},this._terminalBufferMap.set(T,R)}),k}stopBuffering(T){const I=this._terminalBufferMap.get(T);I&&I.dispose()}flushBuffer(T){const I=this._terminalBufferMap.get(T);I&&(this._terminalBufferMap.delete(T),this._callback(T,I.data.join("")))}}e.TerminalDataBufferer=_}),define(ge[190],pe([0,1,48,8,36,26,15,23,9]),function(Q,e,_,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function i(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(_.release());let w=0;return C&&C.length===4&&(w=parseInt(C[3])),w}e.getWindowsBuildNumber=i;async function R(C,w,m,s=T.env,d=I.exists){if(P.isAbsolute(C))return await d(C)?C:void 0;if(w===void 0&&(w=T.cwd()),P.dirname(C)!=="."){const p=P.join(w,C);return await d(p)?p:void 0}const v=(0,k.getCaseInsensitive)(s,"PATH");if(m===void 0&&(0,D.isString)(v)&&(m=v.split(P.delimiter)),m===void 0||m.length===0){const p=P.join(w,C);return await d(p)?p:void 0}for(let p of m){let u;if(P.isAbsolute(p)?u=P.join(p,C):u=P.join(w,p,C),await d(u))return u;if(y.isWindows){let c=u+".com";if(await d(c)||(c=u+".exe",await d(c)))return c}}const b=P.join(w,C);return await d(b)?b:void 0}e.findExecutable=R}),define(ge[191],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var _;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST="hc"})(_=e.ColorScheme||(e.ColorScheme={}))}),define(ge[192],pe([0,1,4,6,40,3,191,43]),function(Q,e,_,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,_.createDecorator)("themeService");var y;(function(S){function v(b){return b&&typeof b=="object"&&typeof b.id=="string"}S.isThemeColor=v})(y=e.ThemeColor||(e.ThemeColor={}));function i(S){return{id:S}}e.themeColorFromId=i;var R;(function(S){function v(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||y.isThemeColor(t.color))}S.isThemeIcon=v;const b=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function p(t){const n=b.exec(t);if(!!n){let[,o]=n;return{id:o}}}S.fromString=p;function u(t,n){let o=t.id;const r=o.lastIndexOf("~");return r!==-1&&(o=o.substring(0,r)),n&&(o=`${o}~${n}`),{id:o}}S.modify=u;function c(t,n){var o,r;return t.id===n.id&&((o=t.color)===null||o===void 0?void 0:o.id)===((r=n.color)===null||r===void 0?void 0:r.id)}S.isEqual=c,S.asClassNameArray=k.CSSIcon.asClassNameArray,S.asClassName=k.CSSIcon.asClassName,S.asCSSSelector=k.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function C(S){switch(S){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class w{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new I.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,P.toDisposable)(()=>{const b=this.themingParticipants.indexOf(v);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new w;T.Registry.add(e.Extensions.ThemingContribution,m);function s(S){return m.onColorThemeChange(S)}e.registerThemingParticipant=s;class d extends P.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,b){let p=this.theme.getColor(v);return p&&b&&(p=b(p,this.theme)),p?p.toString():null}}e.Themable=d}),define(ge[193],pe([0,1,40,192,3,156,113,19,43]),function(Q,e,_,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class i{constructor(){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,I.localize)(0,null)},fontCharacter:{type:"string",description:(0,I.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(v,b,p,u){const c=this.iconsById[v];if(c){if(p&&!c.description){c.description=p,this.iconSchema.properties[v].markdownDescription=`${p} $(${v})`;const o=this.iconReferenceSchema.enum.indexOf(v);o!==-1&&(this.iconReferenceSchema.enumDescriptions[o]=p),this._onDidChange.fire()}return c}let t={id:v,description:p,defaults:b,deprecationMessage:u};this.iconsById[v]=t;let n={$ref:"#/definitions/icons"};return u&&(n.deprecationMessage=u),p&&(n.markdownDescription=`${p}: $(${v})`),this.iconSchema.properties[v]=n,this.iconReferenceSchema.enum.push(v),this.iconReferenceSchema.enumDescriptions.push(p||""),this._onDidChange.fire(),{id:v}}deregisterIcon(v){delete this.iconsById[v],delete this.iconSchema.properties[v];const b=this.iconReferenceSchema.enum.indexOf(v);b!==-1&&(this.iconReferenceSchema.enum.splice(b,1),this.iconReferenceSchema.enumDescriptions.splice(b,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(v=>this.iconsById[v])}getIcon(v){return this.iconsById[v]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(v,b){const p=this.iconFontsById[v];if(p)return p;let u={id:v,definition:b};return this.iconFontsById[v]=u,this._onDidChange.fire(),u}deregisterIconFont(v){delete this.iconFontsById[v]}getIconFonts(){return Object.keys(this.iconFontsById).map(v=>this.iconFontsById[v])}getIconFont(v){return this.iconFontsById[v]}toString(){const v=(c,t)=>c.id.localeCompare(t.id),b=c=>{for(;P.ThemeIcon.isThemeIcon(c.defaults);)c=this.iconsById[c.defaults.id];return`codicon codicon-${c?c.id:""}`};let p=[];p.push("| preview     | identifier                        | default codicon ID                | description"),p.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.iconsById).map(c=>this.iconsById[c]);for(const c of u.filter(t=>!!t.description).sort(v))p.push(`|<i class="${b(c)}"></i>|${c.id}|${P.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);p.push("| preview     | identifier                        "),p.push("| ----------- | --------------------------------- |");for(const c of u.filter(t=>!P.ThemeIcon.isThemeIcon(t.defaults)).sort(v))p.push(`|<i class="${b(c)}"></i>|${c.id}|`);return p.join(`
`)}}const R=new i;_.Registry.add(e.Extensions.IconContribution,R);function C(S,v,b,p){return R.registerIcon(S,v,b,p)}e.registerIcon=C;function w(){return R}e.getIconRegistry=w;function m(){for(const S of y.iconRegistry.all)R.registerIcon(S.id,S.definition,S.description);y.iconRegistry.onDidRegister(S=>R.registerIcon(S.id,S.definition,S.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let s=_.Registry.as(D.Extensions.JSONContribution);s.registerSchema(e.iconsSchemaId,R.getIconSchema());const d=new k.RunOnceScheduler(()=>s.notifySchemaChanged(e.iconsSchemaId),200);R.onDidChange(()=>{d.isScheduled()||d.schedule()}),e.widgetClose=C("widget-close",y.Codicon.close,(0,I.localize)(2,null)),e.gotoPreviousLocation=C("goto-previous-location",y.Codicon.arrowUp,(0,I.localize)(3,null)),e.gotoNextLocation=C("goto-next-location",y.Codicon.arrowDown,(0,I.localize)(4,null)),e.syncing=P.ThemeIcon.modify(y.Codicon.sync,"spin")}),define(ge[59],pe([0,1,2,25,4,24]),function(Q,e,_,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var D;(function(w){w[w.EMPTY=1]="EMPTY",w[w.FOLDER=2]="FOLDER",w[w.WORKSPACE=3]="WORKSPACE"})(D=e.WorkbenchState||(e.WorkbenchState={}));function k(w){const m=w;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=k;function y(w){const m=w;return!!(m&&typeof m=="object"&&_.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=y;class i{constructor(m,s,d,S){this._id=m,this._configuration=d,this._ignorePathCasing=S,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=i;class R{constructor(m,s){this.raw=s,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,P.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function C(w){return new R({uri:w,index:0,name:(0,P.basenameOrAuthority)(w)},{uri:w.toString()})}e.toWorkspaceFolder=C}),define(ge[116],pe([0,1,4,157,59,2,9,8,25,132,54,11,75,30,115]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S($){return(typeof $=="string"?(0,k.extname)($):(0,y.extname)($))===d}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=(0,_.createDecorator)("workspacesService");function v($){return $.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function b($){return $.hasOwnProperty("folderUri")}e.isRecentFolder=b;function p($){return $.hasOwnProperty("fileUri")}e.isRecentFile=p;function u($){const F=$;return typeof(F==null?void 0:F.id)=="string"&&I.URI.isUri(F.uri)}e.isSingleFolderWorkspaceIdentifier=u;function c($){if($.configuration)return{id:$.id,configPath:$.configuration};if($.folders.length===1)return{id:$.id,uri:$.folders[0].uri}}e.toWorkspaceIdentifier=c;function t($){const F=$;return typeof(F==null?void 0:F.id)=="string"&&I.URI.isUri(F.configPath)}e.isWorkspaceIdentifier=t;function n($){const F=$;if(F==null?void 0:F.uri)return{id:F.id,uri:I.URI.revive(F.uri)};const U=$;if(U==null?void 0:U.configPath)return{id:U.id,configPath:I.URI.revive(U.configPath)};if($==null?void 0:$.id)return{id:$.id}}e.reviveIdentifier=n;function o($,F){return y.extUriBiasedIgnorePathCase.isEqualOrParent($,F.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function r($){return l($)||a($)}e.isStoredWorkspaceFolder=r;function l($){const F=$;return typeof(F==null?void 0:F.path)=="string"&&(!F.name||typeof F.name=="string")}e.isRawFileWorkspaceFolder=l;function a($){const F=$;return typeof(F==null?void 0:F.uri)=="string"&&(!F.name||typeof F.name=="string")}e.isRawUriWorkspaceFolder=a;function g($,F,U,M,N=!D.isWindows,O){if($.scheme!==M.scheme)return{name:U,uri:$.toString(!0)};let V=F?void 0:O.relativePath(M,$);if(V!==void 0)V.length===0?V=".":D.isWindows&&$.scheme===C.Schemas.file&&!N&&(V=V.replace(/\//g,"\\"));else if($.scheme===C.Schemas.file)V=$.fsPath,D.isWindows&&(V=(0,w.normalizeDriveLetter)(V),N&&(V=(0,m.toSlashes)(V)));else{if(!O.isEqualAuthority($.authority,M.authority))return{name:U,uri:$.toString(!0)};V=$.path}return{name:U,path:V}}e.getStoredWorkspaceFolder=g;function E($,F,U){let M=[],N=new Set;const O=U.dirname(F);for(let V of $){let q=null;if(l(V))V.path&&(q=U.resolvePath(O,V.path));else if(a(V))try{q=I.URI.parse(V.uri),q.path[0]!=="/"&&(q=q.with({path:"/"+q.path}))}catch(J){console.warn(J)}if(q){let J=U.getComparisonKey(q);if(!N.has(J)){N.add(J);const me=V.name||U.basenameOrAuthority(q);M.push(new T.WorkspaceFolder({uri:q,name:me,index:M.length},V))}}}return M}e.toWorkspaceFolders=E;function f($,F,U,M,N){let O=h(F,$);const V=N.dirname(F),q=N.dirname(M),J=[],me=A(O.folders);for(const Fe of O.folders){const z=l(Fe)?N.resolvePath(V,Fe.path):I.URI.parse(Fe.uri);let Y;U?Y=!1:Y=!l(Fe)||(0,k.isAbsolute)(Fe.path),J.push(g(z,Y,Fe.name,q,me,N))}const we={insertSpaces:!1,tabSize:4,eol:D.isLinux||D.isMacintosh?`
`:`\r
`},Ae=i.setProperty($,["folders"],J,we);let Pe=i.applyEdits($,Ae);return O.remoteAuthority===(0,s.getRemoteAuthority)(M)&&(Pe=i.applyEdits(Pe,i.removeProperty(Pe,["remoteAuthority"],we))),Pe}e.rewriteWorkspaceFileForNewLocation=f;function h($,F){let U=R.parse(F);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(M=>r(M));else throw new Error(`${$} looks like an invalid workspace file.`);return U}function A($){return D.isWindows?$.some(F=>l(F)&&F.path.indexOf("/")>=0):!0}e.useSlashForPath=A;function L($){return $.workspace&&typeof $.workspace=="object"&&typeof $.workspace.id=="string"&&typeof $.workspace.configPath=="string"}function B($){return typeof $.folderUri=="string"}function ee($){return typeof $.fileUri=="string"}function j($,F){const U={workspaces:[],files:[]};if($){const M=function(O,V){for(let q=0;q<O.length;q++)try{V(O[q],q)}catch(J){F.warn(`Error restoring recent entry ${JSON.stringify(O[q])}: ${J.toString()}. Skip entry.`)}},N=$;if(Array.isArray(N.entries))M(N.entries,O=>{const V=O.label,q=O.remoteAuthority;L(O)?U.workspaces.push({label:V,remoteAuthority:q,workspace:{id:O.workspace.id,configPath:I.URI.parse(O.workspace.configPath)}}):B(O)?U.workspaces.push({label:V,remoteAuthority:q,folderUri:I.URI.parse(O.folderUri)}):ee(O)&&U.files.push({label:V,remoteAuthority:q,fileUri:I.URI.parse(O.fileUri)})});else{const O=$;Array.isArray(O.workspaces3)&&M(O.workspaces3,(V,q)=>{const J=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[q]||void 0;typeof V=="object"&&typeof V.id=="string"&&typeof V.configURIPath=="string"?U.workspaces.push({label:J,workspace:{id:V.id,configPath:I.URI.parse(V.configURIPath)}}):typeof V=="string"&&U.workspaces.push({label:J,folderUri:I.URI.parse(V)})}),Array.isArray(O.files2)&&M(O.files2,(V,q)=>{const J=Array.isArray(O.fileLabels)&&O.fileLabels[q]||void 0;typeof V=="string"&&U.files.push({label:J,fileUri:I.URI.parse(V)})})}}return U}e.restoreRecentlyOpened=j;function x($){const F={entries:[]};for(const U of $.workspaces)b(U)?F.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):F.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of $.files)F.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return F}e.toStoreData=x}),define(ge[84],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class _{constructor(T){this.id=T,this._data=new Map,this._idPool=1}add(T){const I=this._idPool++;return this._data.set(I,T),this.logDebugInfo(),I}get(T,I){return this._data.has(T)?this._data.get(T)[I]:void 0}delete(T){this._data.delete(T),this.logDebugInfo()}logDebugInfo(){!_.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=_,_.enableDebugLogging=!1}),define(ge[194],pe([0,1,2,3]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class T{constructor(){this._onDidChangeTabs=new P.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(D){this._tabs=D.map(k=>({name:k.name,group:k.group,resource:_.URI.revive(k.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(ge[60],pe([0,1,11,4]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(_.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(D,k){k===null?this._providerInfo.delete(D):this._providerInfo.set(D,k)}isFreeScheme(D){return!this._providerInfo.has(D)&&!this._systemSchemes.has(D)}getCapabilities(D){return this._providerInfo.get(D)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,P.createDecorator)("IExtHostFileSystemInfo")}),define(ge[27],pe([0,1,4]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,_.createDecorator)("IExtHostInitDataService")}),define(ge[195],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class _{constructor(I,D,k){this._id=I,this._shared=D,this._storage=k,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)})}get whenReady(){return this._init}get(I,D){let k=this._value[I];return typeof k=="undefined"&&(k=D),k}update(I,D){return this._value[I]=D,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=_;class P extends _{constructor(I,D){super(I.identifier.value,!0,D);this._extension=I}setKeysForSync(I){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},I)}}e.ExtensionGlobalMemento=P}),define(ge[13],pe([0,1,4]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,_.createDecorator)("IExtHostRpcService");class P{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.ExtHostRpcService=P});var et=this&&this.__classPrivateFieldSet||function(Q,e,_,P,T){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?T.call(Q,_):T?T.value=_:e.set(Q,_),_},He=this&&this.__classPrivateFieldGet||function(Q,e,_,P){if(_==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!P:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?P:_==="a"?P.call(Q):P?P.value:e.get(Q)};define(ge[196],pe([0,1,29,3]),function(Q,e,_,P){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class I{constructor(k,y){T.set(this,void 0),this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this._id=_.ExtensionIdentifier.toKey(k.identifier),et(this,T,y,"f"),He(this,T,"f").onDidChangePassword(i=>{i.extensionId===this._id&&this._onDidChange.fire({key:i.key})})}get(k){return He(this,T,"f").get(this._id,k)}store(k,y){return He(this,T,"f").store(this._id,k,y)}delete(k){return He(this,T,"f").delete(this._id,k)}}e.ExtensionSecrets=I,T=new WeakMap}),define(ge[117],pe([0,1,4,3]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class T{constructor(){this._onDidChangeTelemetryEnabled=new P.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(D){this._enabled=D}$onDidChangeTelemetryEnabled(D){this._enabled=D,this._onDidChangeTelemetryEnabled.fire(D)}}e.ExtHostTelemetry=T,e.IExtHostTelemetry=(0,_.createDecorator)("IExtHostTelemetry")}),define(ge[50],pe([0,1,4,3,13]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var I;(function(k){function y(R){return{remoteAddress:R.remoteAddress,localAddress:R.localAddress,public:!!R.public}}k.fromApiTunnel=y;function i(R){return{remoteAddress:{host:R.tunnelRemoteHost,port:R.tunnelRemotePort},localAddress:R.localAddress,public:R.public}}k.fromServiceTunnel=i})(I=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,_.createDecorator)("IExtHostTunnelService");let D=class{constructor(y){this.onDidChangeTunnels=new P.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,i){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,i){return{dispose:()=>{}}}async $providePortAttributes(y,i,R,C,w){return[]}async $forwardPort(y,i){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};D=je([xe(0,T.IExtHostRpcService)],D),e.ExtHostTunnelService=D});var et=this&&this.__classPrivateFieldSet||function(Q,e,_,P,T){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?T.call(Q,_):T?T.value=_:e.set(Q,_),_},He=this&&this.__classPrivateFieldGet||function(Q,e,_,P){if(_==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!P:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?P:_==="a"?P.call(Q):P?P.value:e.get(Q)};define(ge[7],pe([0,1,14,18,95,24,15,2,28,45,114]),function(Q,e,_,P,T,I,D,k,y,i,R){"use strict";var C,w,m,s,d,S,v,b,p,u,c,t,n,o,r,l,a,g;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItem=e.TestChildrenCollection=e.TestItemHookProperty=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function E(H){function W(){return Reflect.construct(H,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor(H,"name")),Object.setPrototypeOf(W,H),Object.setPrototypeOf(W.prototype,H.prototype),W}let f=d=class{constructor(W){C.set(this,void 0),et(this,C,W,"f")}static from(...W){let se=W;return new d(function(){if(se){for(const Se of se)Se&&typeof Se.dispose=="function"&&Se.dispose();se=void 0}})}dispose(){typeof He(this,C,"f")=="function"&&(He(this,C,"f").call(this),et(this,C,void 0,"f"))}};C=new WeakMap,f=d=je([E],f),e.Disposable=f;let h=S=class{constructor(W,se){if(W<0)throw(0,P.illegalArgument)("line must be non-negative");if(se<0)throw(0,P.illegalArgument)("character must be non-negative");this._line=W,this._character=se}static Min(...W){if(W.length===0)throw new TypeError;let se=W[0];for(let Se=1;Se<W.length;Se++){const ze=W[Se];ze.isBefore(se)&&(se=ze)}return se}static Max(...W){if(W.length===0)throw new TypeError;let se=W[0];for(let Se=1;Se<W.length;Se++){const ze=W[Se];ze.isAfter(se)&&(se=ze)}return se}static isPosition(W){if(!W)return!1;if(W instanceof S)return!0;let{line:se,character:Se}=W;return typeof se=="number"&&typeof Se=="number"}get line(){return this._line}get character(){return this._character}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,se=0){if(W===null||se===null)throw(0,P.illegalArgument)();let Se;return typeof W=="undefined"?Se=0:typeof W=="number"?Se=W:(Se=typeof W.lineDelta=="number"?W.lineDelta:0,se=typeof W.characterDelta=="number"?W.characterDelta:0),Se===0&&se===0?this:new S(this.line+Se,this.character+se)}with(W,se=this.character){if(W===null||se===null)throw(0,P.illegalArgument)();let Se;return typeof W=="undefined"?Se=this.line:typeof W=="number"?Se=W:(Se=typeof W.line=="number"?W.line:this.line,se=typeof W.character=="number"?W.character:this.character),Se===this.line&&se===this.character?this:new S(Se,se)}toJSON(){return{line:this.line,character:this.character}}};h=S=je([E],h),e.Position=h;let A=v=class{constructor(W,se,Se,ze){let Je,ot;if(typeof W=="number"&&typeof se=="number"&&typeof Se=="number"&&typeof ze=="number"?(Je=new h(W,se),ot=new h(Se,ze)):W instanceof h&&se instanceof h&&(Je=W,ot=se),!Je||!ot)throw new Error("Invalid arguments");Je.isBefore(ot)?(this._start=Je,this._end=ot):(this._start=ot,this._end=Je)}static isRange(W){return W instanceof v?!0:W?h.isPosition(W.start)&&h.isPosition(W.end):!1}get start(){return this._start}get end(){return this._end}contains(W){return W instanceof v?this.contains(W._start)&&this.contains(W._end):W instanceof h?!(W.isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const se=h.Max(W.start,this._start),Se=h.Min(W.end,this._end);if(!se.isAfter(Se))return new v(se,Se)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const se=h.Min(W.start,this._start),Se=h.Max(W.end,this.end);return new v(se,Se)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,se=this.end){if(W===null||se===null)throw(0,P.illegalArgument)();let Se;return W?h.isPosition(W)?Se=W:(Se=W.start||this.start,se=W.end||this.end):Se=this.start,Se.isEqual(this._start)&&se.isEqual(this.end)?this:new v(Se,se)}toJSON(){return[this.start,this.end]}};A=v=je([E],A),e.Range=A;let L=b=class extends A{constructor(W,se,Se,ze){let Je,ot;if(typeof W=="number"&&typeof se=="number"&&typeof Se=="number"&&typeof ze=="number"?(Je=new h(W,se),ot=new h(Se,ze)):W instanceof h&&se instanceof h&&(Je=W,ot=se),!Je||!ot)throw new Error("Invalid arguments");super(Je,ot);this._anchor=Je,this._active=ot}static isSelection(W){return W instanceof b?!0:W?A.isRange(W)&&h.isPosition(W.anchor)&&h.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};L=b=je([E],L),e.Selection=L;class B{constructor(W,se,Se){if(typeof W!="string"||W.length===0)throw(0,P.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,P.illegalArgument)("port");if(typeof Se!="undefined"&&(typeof Se!="string"||Se.length===0||!/^[0-9A-Za-z\-]+$/.test(Se)))throw(0,P.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(se),this.connectionToken=Se}}e.ResolvedAuthority=B;class ee extends Error{constructor(W,se=R.RemoteAuthorityResolverErrorCode.Unknown,Se){super(W);this._message=W,this._code=se,this._detail=Se,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ee.prototype)}static NotAvailable(W,se){return new ee(W,R.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(W){return new ee(W,R.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=ee;var j;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(j=e.EndOfLine||(e.EndOfLine={}));var x;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let $=p=class{constructor(W,se){this._range=W,this._newText=se}static isTextEdit(W){return W instanceof p?!0:W?A.isRange(W)&&typeof W.newText=="string":!1}static replace(W,se){return new p(W,se)}static insert(W,se){return p.replace(new A(W,W),se)}static delete(W){return p.replace(W,"")}static setEndOfLine(W){const se=new p(new A(new h(0,0),new h(0,0)),"");return se.newEol=W,se}get range(){return this._range}set range(W){if(W&&!A.isRange(W))throw(0,P.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,P.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,P.illegalArgument)("newEol");this._newEol=W}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};$=p=je([E],$),e.TextEdit=$;var F;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellOutput=4]="CellOutput",H[H.CellReplace=5]="CellReplace",H[H.CellOutputItem=6]="CellOutputItem"})(F=e.FileEditType||(e.FileEditType={}));let U=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,se,Se,ze){this._edits.push({_type:1,from:W,to:se,options:Se,metadata:ze})}createFile(W,se,Se){this._edits.push({_type:1,from:void 0,to:W,options:se,metadata:Se})}deleteFile(W,se,Se){this._edits.push({_type:1,from:W,to:void 0,options:se,metadata:Se})}replaceNotebookMetadata(W,se,Se){this._edits.push({_type:3,metadata:Se,uri:W,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(W,se,Se,ze,Je){(se!==Se||ze.length>0)&&this._edits.push({_type:5,uri:W,index:se,count:Se-se,cells:ze,metadata:Je})}replaceNotebookCellOutput(W,se,Se,ze){this._editNotebookCellOutput(W,se,!1,Se,ze)}appendNotebookCellOutput(W,se,Se,ze){this._editNotebookCellOutput(W,se,!0,Se,ze)}replaceNotebookCellOutputItems(W,se,Se,ze,Je){this._editNotebookCellOutputItems(W,se,Se,!1,ze,Je)}appendNotebookCellOutputItems(W,se,Se,ze,Je){this._editNotebookCellOutputItems(W,se,Se,!0,ze,Je)}_editNotebookCellOutputItems(W,se,Se,ze,Je,ot){this._edits.push({_type:6,metadata:ot,uri:W,index:se,outputId:Se,append:ze,newOutputItems:Je})}_editNotebookCellOutput(W,se,Se,ze,Je){this._edits.push({_type:4,metadata:Je,uri:W,index:se,append:Se,newOutputs:ze,newMetadata:void 0})}replaceNotebookCellMetadata(W,se,Se,ze){this._edits.push({_type:3,metadata:ze,uri:W,edit:{editType:11,index:se,metadata:Se}})}replace(W,se,Se,ze){this._edits.push({_type:2,uri:W,edit:new $(se,Se),metadata:ze})}insert(W,se,Se,ze){this.replace(W,new A(se,se),Se,ze)}delete(W,se,Se){this.replace(W,se,"",Se)}has(W){return this._edits.some(se=>se._type===2&&se.uri.toString()===W.toString())}set(W,se){if(se)for(const Se of se)Se&&this._edits.push({_type:2,uri:W,edit:Se});else{for(let Se=0;Se<this._edits.length;Se++){const ze=this._edits[Se];ze._type===2&&ze.uri.toString()===W.toString()&&(this._edits[Se]=void 0)}(0,_.coalesceInPlace)(this._edits)}}get(W){const se=[];for(let Se of this._edits)Se._type===2&&Se.uri.toString()===W.toString()&&se.push(Se.edit);return se}entries(){const W=new I.ResourceMap;for(let se of this._edits)if(se._type===2){let Se=W.get(se.uri);Se||(Se=[se.uri,[]],W.set(se.uri,Se)),Se[1].push(se.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};U=je([E],U),e.WorkspaceEdit=U;let M=u=class{constructor(W){this._tabstop=1,this.value=W||""}static isSnippetString(W){return W instanceof u?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}appendText(W){return this.value+=u._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,se=this._tabstop++){if(typeof W=="function"){const Se=new u;Se._tabstop=this._tabstop,W(Se),this._tabstop=Se._tabstop,W=Se.value}else W=u._escape(W);return this.value+="${",this.value+=se,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,se=this._tabstop++){const Se=W.map(ze=>ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(W,se){if(typeof se=="function"){const Se=new u;Se._tabstop=this._tabstop,se(Se),this._tabstop=Se._tabstop,se=Se.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,se&&(this.value+=":",this.value+=se),this.value+="}",this}};M=u=je([E],M),e.SnippetString=M;var N;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(N=e.DiagnosticTag||(e.DiagnosticTag={}));var O;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(O=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let V=c=class{constructor(W,se){if(this.uri=W,se)if(se instanceof A)this.range=se;else if(se instanceof h)this.range=new A(se,se);else throw new Error("Illegal argument")}static isLocation(W){return W instanceof c?!0:W?A.isRange(W.range)&&k.URI.isUri(W.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};V=c=je([E],V),e.Location=V;let q=class{constructor(W,se){this.location=W,this.message=se}static is(W){return W?typeof W.message=="string"&&W.location&&A.isRange(W.location.range)&&k.URI.isUri(W.location.uri):!1}static isEqual(W,se){return W===se?!0:!W||!se?!1:W.message===se.message&&W.location.range.isEqual(se.location.range)&&W.location.uri.toString()===se.location.uri.toString()}};q=je([E],q),e.DiagnosticRelatedInformation=q;let J=class{constructor(W,se,Se=O.Error){if(!A.isRange(W))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=W,this.message=se,this.severity=Se}toJSON(){return{severity:O[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,se){return W===se?!0:!W||!se?!1:W.message===se.message&&W.severity===se.severity&&W.code===se.code&&W.severity===se.severity&&W.source===se.source&&W.range.isEqual(se.range)&&(0,_.equals)(W.tags,se.tags)&&(0,_.equals)(W.relatedInformation,se.relatedInformation,q.isEqual)}};J=je([E],J),e.Diagnostic=J;let me=class{constructor(W,se){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:(0,T.isMarkdownString)(W)?this.contents=[W]:this.contents=[W],this.range=se}};me=je([E],me),e.Hover=me;var we;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(we=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ae=class{constructor(W,se=we.Text){this.range=W,this.kind=se}toJSON(){return{range:this.range,kind:we[this.kind]}}};Ae=je([E],Ae),e.DocumentHighlight=Ae;var Pe;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(Pe=e.SymbolKind||(e.SymbolKind={}));var Fe;(function(H){H[H.Deprecated=1]="Deprecated"})(Fe=e.SymbolTag||(e.SymbolTag={}));let z=t=class{constructor(W,se,Se,ze,Je){this.name=W,this.kind=se,this.containerName=Je,typeof Se=="string"&&(this.containerName=Se),ze instanceof V?this.location=ze:Se instanceof A&&(this.location=new V(ze,Se)),t.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Pe[this.kind],location:this.location,containerName:this.containerName}}};z=t=je([E],z),e.SymbolInformation=z;let Y=n=class{constructor(W,se,Se,ze,Je){this.name=W,this.detail=se,this.kind=Se,this.range=ze,this.selectionRange=Je,this.children=[],n.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children&&W.children.forEach(n.validate)}};Y=n=je([E],Y),e.DocumentSymbol=Y;var te;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(W,se){this.title=W,this.kind=se}};ae=je([E],ae),e.CodeAction=ae;let fe=o=class{constructor(W){this.value=W}append(W){return new o(this.value?this.value+o.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+o.sep)}};fe.sep=".",fe=o=je([E],fe),e.CodeActionKind=fe,fe.Empty=new fe(""),fe.QuickFix=fe.Empty.append("quickfix"),fe.Refactor=fe.Empty.append("refactor"),fe.RefactorExtract=fe.Refactor.append("extract"),fe.RefactorInline=fe.Refactor.append("inline"),fe.RefactorRewrite=fe.Refactor.append("rewrite"),fe.Source=fe.Empty.append("source"),fe.SourceOrganizeImports=fe.Source.append("organizeImports"),fe.SourceFixAll=fe.Source.append("fixAll");let De=class{constructor(W,se){if(this.range=W,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};De=je([E],De),e.SelectionRange=De;class Me{constructor(W,se,Se,ze,Je,ot){this.kind=W,this.name=se,this.detail=Se,this.uri=ze,this.range=Je,this.selectionRange=ot}}e.CallHierarchyItem=Me;class be{constructor(W,se){this.fromRanges=se,this.from=W}}e.CallHierarchyIncomingCall=be;class ke{constructor(W,se){this.fromRanges=se,this.to=W}}e.CallHierarchyOutgoingCall=ke;let Re=class{constructor(W,se){this.range=W,this.command=se}get isResolved(){return!!this.command}};Re=je([E],Re),e.CodeLens=Re;let Be=r=class{constructor(W,se=!1){w.set(this,void 0),et(this,w,new T.MarkdownString(W,{supportThemeIcons:se}),"f")}static isMarkdownString(W){return W instanceof r?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}get value(){return He(this,w,"f").value}set value(W){He(this,w,"f").value=W}get isTrusted(){return He(this,w,"f").isTrusted}set isTrusted(W){He(this,w,"f").isTrusted=W}get supportThemeIcons(){return He(this,w,"f").supportThemeIcons}appendText(W){return He(this,w,"f").appendText(W),this}appendMarkdown(W){return He(this,w,"f").appendMarkdown(W),this}appendCodeblock(W,se){return He(this,w,"f").appendCodeblock(se!=null?se:"",W),this}};w=new WeakMap,Be=r=je([E],Be),e.MarkdownString=Be;let Ee=class{constructor(W,se){this.label=W,this.documentation=se}};Ee=je([E],Ee),e.ParameterInformation=Ee;let Ke=class{constructor(W,se){this.label=W,this.documentation=se,this.parameters=[]}};Ke=je([E],Ke),e.SignatureInformation=Ke;let X=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};X=je([E],X),e.SignatureHelp=X;var re;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(re=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var _e;(function(H){H[H.Other=0]="Other",H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(_e=e.InlineHintKind||(e.InlineHintKind={}));let Ne=class{constructor(W,se,Se){this.text=W,this.range=se,this.kind=Se}};Ne=je([E],Ne),e.InlineHint=Ne;var Ve;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ve=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $e;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})($e=e.CompletionItemKind||(e.CompletionItemKind={}));var Ze;(function(H){H[H.Deprecated=1]="Deprecated"})(Ze=e.CompletionItemTag||(e.CompletionItemTag={}));let K=class{constructor(W,se){this.label=W,this.kind=se}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&$e[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};K=je([E],K),e.CompletionItem=K;let oe=class{constructor(W=[],se=!1){this.items=W,this.isIncomplete=se}};oe=je([E],oe),e.CompletionList=oe;var he;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(he=e.ViewColumn||(e.ViewColumn={}));var Z;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(Z=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ie;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(ie=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var le;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(le=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ve;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(ve=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ye;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var We;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(We=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(H){function W(se){switch(se){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=W}(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Oe=class{constructor(W,se){if(se&&!k.URI.isUri(se))throw(0,P.illegalArgument)("target");if(!A.isRange(W)||W.isEmpty)throw(0,P.illegalArgument)("range");this.range=W,this.target=se}};Oe=je([E],Oe),e.DocumentLink=Oe;let qe=class{constructor(W,se,Se,ze){this.red=W,this.green=se,this.blue=Se,this.alpha=ze}};qe=je([E],qe),e.Color=qe;let Ye=class{constructor(W,se){if(se&&!(se instanceof qe))throw(0,P.illegalArgument)("color");if(!A.isRange(W)||W.isEmpty)throw(0,P.illegalArgument)("range");this.range=W,this.color=se}};Ye=je([E],Ye),e.ColorInformation=Ye;let tt=class{constructor(W){if(!W||typeof W!="string")throw(0,P.illegalArgument)("label");this.label=W}};tt=je([E],tt),e.ColorPresentation=tt;var nt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(nt=e.ColorFormat||(e.ColorFormat={}));var rt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(rt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var it;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(it=e.TaskRevealKind||(e.TaskRevealKind={}));var gt;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(gt=e.TaskPanelKind||(e.TaskPanelKind={}));let ue=l=class{constructor(W,se){if(typeof W!="string"||typeof se!="string")throw(0,P.illegalArgument)("name");this._id=W}static from(W){switch(W){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}get id(){return this._id}};ue.Clean=new l("clean","Clean"),ue.Build=new l("build","Build"),ue.Rebuild=new l("rebuild","Rebuild"),ue.Test=new l("test","Test"),ue=l=je([E],ue),e.TaskGroup=ue;function Ce(H){let W="";for(let se=0;se<H.length;se++)W+=H[se].replace(/,/g,",,")+",";return W}let ce=class{constructor(W,se,Se){if(typeof W!="string")throw(0,P.illegalArgument)("process");this._args=[],this._process=W,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=Se):this._options=se)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,P.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(let se of this._args)W.push(se);return Ce(W)}};ce=je([E],ce),e.ProcessExecution=ce;let G=class{constructor(W,se,Se){if(this._args=[],Array.isArray(se)){if(!W)throw(0,P.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,P.illegalArgument)("command");this._command=W,this._args=se,this._options=Se}else{if(typeof W!="string")throw(0,P.illegalArgument)("commandLine");this._commandLine=W,this._options=se}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,P.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,P.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)W.push(typeof se=="string"?se:se.value);return Ce(W)}};G=je([E],G),e.ShellExecution=G;var Ue;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Ue=e.ShellQuoting||(e.ShellQuoting={}));var Te;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(Te=e.TaskScope||(e.TaskScope={}));class Xe{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,y.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=Xe;let Ge=a=class{constructor(W,se,Se,ze,Je,ot){this.__deprecated=!1,this._definition=this.definition=W;let ht;typeof se=="string"?(this._name=this.name=se,this._source=this.source=Se,this.execution=ze,ht=Je,this.__deprecated=!0):se===Te.Global||se===Te.Workspace?(this.target=se,this._name=this.name=Se,this._source=this.source=ze,this.execution=Je,ht=ot):(this.target=se,this._name=this.name=Se,this._source=this.source=ze,this.execution=Je,ht=ot),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ce?this._definition={type:a.ProcessType,id:this._execution.computeId()}:this._execution instanceof G?this._definition={type:a.ShellType,id:this._execution.computeId()}:this._execution instanceof Xe?this._definition={type:a.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:a.EmptyType,id:(0,y.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,P.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,P.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const se=this._definition.type;(a.EmptyType===se||a.ProcessType===se||a.ShellType===se||a.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,P.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};Ge.ExtensionCallbackType="customExecution",Ge.ProcessType="process",Ge.ShellType="shell",Ge.EmptyType="$empty",Ge=a=je([E],Ge),e.Task=Ge;var lt;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(lt=e.ProgressLocation||(e.ProgressLocation={}));let at=class{constructor(W,se=Qe.None){this.collapsibleState=se,k.URI.isUri(W)?this.resourceUri=W:this.label=W}};at=je([E],at),e.TreeItem=at;var Qe;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(Qe=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let st=class{constructor(W,se){this.id=W,this.color=se}};st=je([E],st),e.ThemeIcon=st,st.File=new st("file"),st.Folder=new st("folder");let ut=class{constructor(W){this.id=W}};ut=je([E],ut),e.ThemeColor=ut;var pt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(pt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let vt=class{constructor(W,se){if(typeof W!="string"&&(!W||!k.URI.isUri(W)&&!k.URI.isUri(W.uri)))throw(0,P.illegalArgument)("base");if(typeof se!="string")throw(0,P.illegalArgument)("pattern");typeof W=="string"?(this.baseFolder=k.URI.file(W),this.base=W):k.URI.isUri(W)?(this.baseFolder=W,this.base=W.fsPath):(this.baseFolder=W.uri,this.base=W.uri.fsPath),this.pattern=se}};vt=je([E],vt),e.RelativePattern=vt;let wt=class{constructor(W,se,Se,ze){this.enabled=typeof W=="boolean"?W:!0,typeof se=="string"&&(this.condition=se),typeof Se=="string"&&(this.hitCondition=Se),typeof ze=="string"&&(this.logMessage=ze)}get id(){return this._id||(this._id=(0,y.generateUuid)()),this._id}};wt=je([E],wt),e.Breakpoint=wt;let Et=class extends wt{constructor(W,se,Se,ze,Je){super(se,Se,ze,Je);if(W===null)throw(0,P.illegalArgument)("location");this.location=W}};Et=je([E],Et),e.SourceBreakpoint=Et;let yt=class extends wt{constructor(W,se,Se,ze,Je){super(se,Se,ze,Je);this.functionName=W}};yt=je([E],yt),e.FunctionBreakpoint=yt;let _t=class extends wt{constructor(W,se,Se,ze,Je,ot,ht){super(ze,Je,ot,ht);if(!se)throw(0,P.illegalArgument)("dataId");this.label=W,this.dataId=se,this.canPersist=Se}};_t=je([E],_t),e.DataBreakpoint=_t;let Ot=class{constructor(W,se,Se){this.command=W,this.args=se||[],this.options=Se}};Ot=je([E],Ot),e.DebugAdapterExecutable=Ot;let Rt=class{constructor(W,se){this.port=W,this.host=se}};Rt=je([E],Rt),e.DebugAdapterServer=Rt;let ft=class{constructor(W){this.path=W}};ft=je([E],ft),e.DebugAdapterNamedPipeServer=ft;let qt=class{constructor(W){this.implementation=W}};qt=je([E],qt),e.DebugAdapterInlineImplementation=qt;let St=class{constructor(W,se){this.range=W,this.expression=se}};St=je([E],St),e.EvaluatableExpression=St;let zt=class{constructor(W,se){this.range=W,this.text=se}};zt=je([E],zt),e.InlineValueText=zt;let Kt=class{constructor(W,se,Se=!0){this.range=W,this.variableName=se,this.caseSensitiveLookup=Se}};Kt=je([E],Kt),e.InlineValueVariableLookup=Kt;let Nt=class{constructor(W,se){this.range=W,this.expression=se}};Nt=je([E],Nt),e.InlineValueEvaluatableExpression=Nt;let dt=class{constructor(W,se){this.frameId=W,this.stoppedLocation=se}};dt=je([E],dt),e.InlineValueContext=dt;var gn;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(gn=e.FileChangeType||(e.FileChangeType={}));let Pt=g=class extends Error{constructor(W,se=i.FileSystemProviderErrorCode.Unknown,Se){var ze;super(k.URI.isUri(W)?W.toString(!0):W);this.code=(ze=Se==null?void 0:Se.name)!==null&&ze!==void 0?ze:"Unknown",(0,i.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}static FileExists(W){return new g(W,i.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound(W){return new g(W,i.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory(W){return new g(W,i.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory(W){return new g(W,i.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions(W){return new g(W,i.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable(W){return new g(W,i.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}};Pt=g=je([E],Pt),e.FileSystemError=Pt;let Lt=class{constructor(W,se,Se){this.start=W,this.end=se,this.kind=Se}};Lt=je([E],Lt),e.FoldingRange=Lt;var sn;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(sn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var pn;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(pn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var on;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(on=e.CommentMode||(e.CommentMode={}));class vn{constructor(W,se=[]){this.tokenTypes=W,this.tokenModifiers=se}}e.SemanticTokensLegend=vn;function an(H){return typeof H=="undefined"||(0,D.isStringArray)(H)}class At{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let se=0,Se=W.tokenTypes.length;se<Se;se++)this._tokenTypeStrToInt.set(W.tokenTypes[se],se);for(let se=0,Se=W.tokenModifiers.length;se<Se;se++)this._tokenModifierStrToInt.set(W.tokenModifiers[se],se)}}push(W,se,Se,ze,Je){if(typeof W=="number"&&typeof se=="number"&&typeof Se=="number"&&typeof ze=="number"&&(typeof Je=="number"||typeof Je=="undefined"))return typeof Je=="undefined"&&(Je=0),this._pushEncoded(W,se,Se,ze,Je);if(A.isRange(W)&&typeof se=="string"&&an(Se))return this._push(W,se,Se);throw(0,P.illegalArgument)()}_push(W,se,Se){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const ze=W.start.line,Je=W.start.character,ot=W.end.character-W.start.character,ht=this._tokenTypeStrToInt.get(se);let Dt=0;if(Se)for(const kt of Se){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const It=this._tokenModifierStrToInt.get(kt);Dt|=1<<It>>>0}this._pushEncoded(ze,Je,ot,ht,Dt)}_pushEncoded(W,se,Se,ze,Je){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let kt=0,It=0;for(let Tt=0;Tt<Dt;Tt++){let Ft=this._data[5*Tt],tn=this._data[5*Tt+1];Ft===0?(Ft=kt,tn+=It):Ft+=kt,this._data[5*Tt]=Ft,this._data[5*Tt+1]=tn,kt=Ft,It=tn}}let ot=W,ht=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Se,this._data[this._dataLen++]=ze,this._data[this._dataLen++]=Je,this._prevLine=W,this._prevChar=se}static _sortAndDeltaEncode(W){let se=[];const Se=W.length/5|0;for(let ht=0;ht<Se;ht++)se[ht]=ht;se.sort((ht,Dt)=>{const kt=W[5*ht],It=W[5*Dt];if(kt===It){const Tt=W[5*ht+1],Ft=W[5*Dt+1];return Tt-Ft}return kt-It});const ze=new Uint32Array(W.length);let Je=0,ot=0;for(let ht=0;ht<Se;ht++){const Dt=5*se[ht],kt=W[Dt+0],It=W[Dt+1],Tt=W[Dt+2],Ft=W[Dt+3],tn=W[Dt+4],Rn=kt-Je,Nn=Rn===0?It-ot:It,nn=5*ht;ze[nn+0]=Rn,ze[nn+1]=Nn,ze[nn+2]=Tt,ze[nn+3]=Ft,ze[nn+4]=tn,Je=kt,ot=It}return ze}build(W){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),W):new Gt(At._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=At;class Gt{constructor(W,se){this.resultId=se,this.data=W}}e.SemanticTokens=Gt;class Qt{constructor(W,se,Se){this.start=W,this.deleteCount=se,this.data=Se}}e.SemanticTokensEdit=Qt;class Xt{constructor(W,se){this.resultId=se,this.edits=W}}e.SemanticTokensEdits=Xt;var wn;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(wn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var bn;(function(H){H[H.Initial=1]="Initial",H[H.Dynamic=2]="Dynamic"})(bn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Ct=class{constructor(){}};Ct.Back={iconPath:new st("arrow-left")},Ct=je([E],Ct),e.QuickInputButtons=Ct;var _n;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(_n=e.ExtensionKind||(e.ExtensionKind={}));class En{constructor(W,se,Se){this.badge=W,this.tooltip=se,this.color=Se}static validate(W){if(W.badge&&W.badge.length!==1&&W.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=En;let Jt=class{constructor(W){this.kind=W}};Jt=je([E],Jt),e.ColorTheme=Jt;var Sn;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast"})(Sn=e.ColorThemeKind||(e.ColorThemeKind={}));class Ut{constructor(W,se){if(W<0)throw(0,P.illegalArgument)("start must be positive");if(se<W)throw(0,P.illegalArgument)("end cannot be smaller than start");this._start=W,this._end=se}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(W){let se=this._start,Se=this._end;return W.start!==void 0&&(se=W.start),W.end!==void 0&&(Se=W.end),se===this._start&&Se===this._end?this:new Ut(se,Se)}}e.NotebookCellRange=Ut;class Vt{constructor(W,se,Se,ze,Je,ot){this.editable=W,this.breakpointMargin=se,this.statusMessage=Se,this.inputCollapsed=ze,this.outputCollapsed=Je,this.custom=ot}with(W){let{editable:se,breakpointMargin:Se,statusMessage:ze,inputCollapsed:Je,outputCollapsed:ot,custom:ht}=W;return se===void 0?se=this.editable:se===null&&(se=void 0),Se===void 0?Se=this.breakpointMargin:Se===null&&(Se=void 0),ze===void 0?ze=this.statusMessage:ze===null&&(ze=void 0),Je===void 0?Je=this.inputCollapsed:Je===null&&(Je=void 0),ot===void 0?ot=this.outputCollapsed:ot===null&&(ot=void 0),ht===void 0?ht=this.custom:ht===null&&(ht=void 0),se===this.editable&&Se===this.breakpointMargin&&ze===this.statusMessage&&Je===this.inputCollapsed&&ot===this.outputCollapsed&&ht===this.custom?this:new Vt(se,Se,ze,Je,ot,ht)}}e.NotebookCellMetadata=Vt;class xt{constructor(W=!0,se=!0,Se={},ze=!0){this.editable=W,this.cellEditable=se,this.custom=Se,this.trusted=ze}with(W){let{editable:se,cellEditable:Se,custom:ze,trusted:Je}=W;return se===void 0?se=this.editable:se===null&&(se=void 0),Se===void 0?Se=this.cellEditable:Se===null&&(Se=void 0),ze===void 0?ze=this.custom:ze===null&&(ze=void 0),Je===void 0?Je=this.trusted:Je===null&&(Je=void 0),se===this.editable&&Se===this.cellEditable&&ze===this.custom&&Je===this.trusted?this:new xt(se,Se,ze,Je)}}e.NotebookDocumentMetadata=xt;class Yt{constructor(W,se,Se,ze,Je,ot){this.kind=W,this.source=se,this.language=Se,this.outputs=ze!=null?ze:[],this.metadata=Je,this.latestExecutionSummary=ot}}e.NotebookCellData=Yt;class Le{constructor(W,se){this.cells=W,this.metadata=se!=null?se:new xt}}e.NotebookData=Le;class Bt{constructor(W,se,Se){this.mime=W,this.value=se,this.metadata=Se}static isNotebookCellOutputItem(W){return W instanceof Bt}}e.NotebookCellOutputItem=Bt;class Zt{constructor(W,se,Se){this.outputs=W,typeof se=="string"?(this.id=se,this.metadata=Se):(this.id=(0,y.generateUuid)(),this.metadata=se!=null?se:Se)}}e.NotebookCellOutput=Zt;var mt;(function(H){H[H.Markdown=1]="Markdown",H[H.Code=2]="Code"})(mt=e.NotebookCellKind||(e.NotebookCellKind={}));var yn;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(yn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Dn;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(Dn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var ln;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(ln=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class cn{constructor(W,se,Se,ze,Je,ot){this.text=W,this.alignment=se,this.command=Se,this.tooltip=ze,this.priority=Je,this.accessibilityInformation=ot}}e.NotebookCellStatusBarItem=cn;let en=class{constructor(W,se){this.label=W,this.timestamp=se}};en=je([E],en),e.TimelineItem=en;var Cn;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(Cn=e.ExtensionMode||(e.ExtensionMode={}));var kn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(kn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Pn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=4]="RegEx"})(Pn=e.StandardTokenType||(e.StandardTokenType={}));class un{constructor(W,se){this.ranges=W,this.wordPattern=se}}e.LinkedEditingRanges=un;var In;(function(H){H[H.Unset=0]="Unset",H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(In=e.TestResultState||(e.TestResultState={}));var dn;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information",H[H.Hint=3]="Hint"})(dn=e.TestMessageSeverity||(e.TestMessageSeverity={})),e.TestItemHookProperty=Symbol("TestItemHookProperty");const jt=(H,W,se)=>{let Se=se;return{enumerable:!0,configurable:!1,get(){return Se},set(ze){var Je;(Je=H[e.TestItemHookProperty])===null||Je===void 0||Je.setProp(W,ze),Se=ze}}};class hn{constructor(W){m.set(this,new Map),s.set(this,void 0),et(this,s,W,"f")}get size(){return He(this,m,"f").size}add(W){const se=He(this,m,"f"),Se=He(this,s,"f").call(this),ze=se.get(W.id);ze!==W&&(ze&&(Se==null||Se.delete(W.id)),se.set(W.id,W),Se==null||Se.created(W))}get(W){return He(this,m,"f").get(W)}clear(){for(const W of He(this,m,"f").keys())this.delete(W)}delete(W){var se;const Se=typeof W=="string"?W:W.id;He(this,m,"f").has(Se)&&(He(this,m,"f").delete(Se),(se=He(this,s,"f").call(this))===null||se===void 0||se.delete(Se))}toJSON(){return[...He(this,m,"f").values()]}[(m=new WeakMap,s=new WeakMap,Symbol.iterator)](){return He(this,m,"f").values()}}e.TestChildrenCollection=hn;class An{constructor(W,se,Se,ze){this.label=se,this.expandable=ze,Object.defineProperties(this,{id:{value:W,enumerable:!0,writable:!1},uri:{value:Se,enumerable:!0,writable:!1},children:{value:new hn(()=>this[e.TestItemHookProperty]),enumerable:!0,writable:!1},[e.TestItemHookProperty]:{enumerable:!1,writable:!0,configurable:!1},range:jt(this,"range",void 0),description:jt(this,"description",void 0),runnable:jt(this,"runnable",!0),debuggable:jt(this,"debuggable",!0)})}invalidate(){var W;(W=this[e.TestItemHookProperty])===null||W===void 0||W.invalidate(this.id)}discoverChildren(W,se){W.report({busy:!1})}}e.TestItem=An;class ne{constructor(W){this.message=W,this.severity=dn.Error}static diff(W,se,Se){const ze=new ne(W);return ze.expectedOutput=se,ze.actualOutput=Se,ze}}e.TestMessage=ne;var de;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(de=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ie;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(Ie=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ct;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore"})(ct=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ge[118],pe([0,1,52,11,10,143,106,7,14]),function(Q,e,_,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const i=new Map;function R(s,d){d?i.set(s,d):i.delete(s)}e.setWordDefinitionFor=R;function C(s){return i.get(s)}e.getWordDefinitionFor=C;class w extends I.MirrorTextModel{constructor(d,S,v,b,p,u,c,t){super(S,v,b,p);this._proxy=d,this._languageId=u,this._isDirty=c,this._notebook=t,this._isDisposed=!1}dispose(){(0,_.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,y.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===P.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(S){return S?d._getTextInRange(S):d.getText()},get eol(){return d._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(S){return d._lineAt(S)},offsetAt(S){return d._offsetAt(S)},positionAt(S){return d._positionAt(S)},validateRange(S){return d._validateRange(S)},validatePosition(S){return d._validatePosition(S)},getWordRangeAtPosition(S,v){return d._getWordRangeAtPosition(S,v)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,_.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,_.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const S=this._validateRange(d);if(S.isEmpty)return"";if(S.isSingleLine)return this._lines[S.start.line].substring(S.start.character,S.end.character);const v=this._eol,b=S.start.line,p=S.end.line,u=[];u.push(this._lines[b].substring(S.start.character));for(let c=b+1;c<p;c++)u.push(this._lines[c]);return u.push(this._lines[p].substring(0,S.end.character)),u.join(v)}_lineAt(d){let S;if(d instanceof k.Position?S=d.line:typeof d=="number"&&(S=d),typeof S!="number"||S<0||S>=this._lines.length||Math.floor(S)!==S)throw new Error("Illegal value for `line`");return new m(S,this._lines[S],S===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(d),v=this._lines[S.index].length;return new k.Position(S.index,Math.min(S.remainder,v))}_validateRange(d){if(!(d instanceof k.Range))throw new Error("Invalid argument");const S=this._validatePosition(d.start),v=this._validatePosition(d.end);return S===d.start&&v===d.end?d:new k.Range(S.line,S.character,v.line,v.character)}_validatePosition(d){if(!(d instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:S,character:v}=d,b=!1;if(S<0)S=0,v=0,b=!0;else if(S>=this._lines.length)S=this._lines.length-1,v=this._lines[S].length,b=!0;else{const p=this._lines[S].length;v<0?(v=0,b=!0):v>p&&(v=p,b=!0)}return b?new k.Position(S,v):d}_getWordRangeAtPosition(d,S){const v=this._validatePosition(d);if(!S)S=C(this._languageId);else if((0,T.regExpLeadsToEndlessLoop)(S))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${S.source}' because it matches the empty string.`);const b=(0,D.getWordAtText)(v.character+1,(0,D.ensureValidWordDefinition)(S),this._lines[v.line],0);if(b)return new k.Range(v.line,b.startColumn-1,v.line,b.endColumn-1)}}e.ExtHostDocumentData=w;class m{constructor(d,S,v){this._line=d,this._text=S,this._isLastLine=v}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(ge[197],pe([0,1,7,3,108,6,76,24,2,28]),function(Q,e,_,P,T,I,D,k,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(w,m,s,d){this._notebook=s,this._selector=d,this._disposables=new I.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,i.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(v=>{const b=this._cellUris.get(v.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const S=v=>{v===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(w.onDidChangeNotebookCells(v=>S(v.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const w=[],m=[];for(const s of this._notebook.getCells())s.kind===_.NotebookCellKind.Code&&(!this._selector||(0,D.score)(this._selector,s.document.uri,s.document.languageId,!0))&&(this._cellUris.set(s.document.uri,this._cells.length),this._cells.push(s),w.push(s.document.getText().length+1),m.push(s.document.lineCount));this._cellLengths=new T.PrefixSumComputer(new Uint32Array(w)),this._cellLines=new T.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(w){var m,s;if(!w){let p="";for(const u of this._cells)p+=u.document.getText()+`
`;return p=p.slice(0,-1),p}if(w.isEmpty)return"";const d=this.locationAt(w.start),S=this.locationAt(w.end),v=this._cells[(m=this._cellUris.get(d.uri))!==null&&m!==void 0?m:-1],b=this._cells[(s=this._cellUris.get(S.uri))!==null&&s!==void 0?s:-1];if(!v||!b)return"";if(v===b)return v.document.getText(new _.Range(d.range.start,S.range.end));{const p=v.document.getText(new _.Range(d.range.start,new _.Position(v.document.lineCount,0))),u=b.document.getText(new _.Range(new _.Position(0,0),S.range.end));return p+`
`+u}}offsetAt(w){const m=this._cellLines.getIndexOf(w.line),s=this._cellLengths.getAccumulatedValue(m.index-1),d=this._cells[m.index].document.offsetAt(w.with(m.remainder));return s+d}positionAt(w){if(typeof w=="number"){const s=this._cellLengths.getIndexOf(w),d=this._cellLines.getAccumulatedValue(s.index-1);return this._cells[s.index].document.positionAt(s.remainder).translate(d)}const m=this._cellUris.get(w.uri);if(m!==void 0){const s=this._cellLines.getAccumulatedValue(m-1);return new _.Position(s+w.range.start.line,w.range.start.character)}return new _.Position(0,0)}locationAt(w){_.Range.isRange(w)||(w=new _.Range(w,w));const m=this._cellLines.getIndexOf(w.start.line);let s=m;w.isEmpty||(s=this._cellLines.getIndexOf(w.end.line));const d=new _.Position(m.remainder,w.start.character),S=new _.Position(s.remainder,w.end.character),v=new _.Range(d,S),b=this._cells[m.index];return new _.Location(b.document.uri,b.document.validateRange(v))}contains(w){return this._cellUris.has(w)}validateRange(w){const m=this.validatePosition(w.start),s=this.validatePosition(w.end);return w.with(m,s)}validatePosition(w){const m=this._cellLines.getIndexOf(w.line),s=new _.Position(m.remainder,w.character),d=this._cells[m.index].document.validatePosition(s),S=this._cellLines.getAccumulatedValue(m.index-1);return new _.Position(S+d.line,d.character)}}e.ExtHostNotebookConcatDocument=R}),define(ge[198],pe([0,1,7,13,3]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let I=class{constructor(k){this._actual=new _.ColorTheme(_.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new T.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let y=k==="light"?_.ColorThemeKind.Light:k==="dark"?_.ColorThemeKind.Dark:_.ColorThemeKind.HighContrast;this._actual=new _.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};I=je([xe(0,P.IExtHostRpcService)],I),e.ExtHostTheming=I}),define(ge[61],pe([0,1,4]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,_.createDecorator)("IURITransformerService");class P{constructor(I){I?(this.transformIncoming=I.transformIncoming.bind(I),this.transformOutgoing=I.transformOutgoing.bind(I),this.transformOutgoingURI=I.transformOutgoingURI.bind(I),this.transformOutgoingScheme=I.transformOutgoingScheme.bind(I)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=P}),define(ge[199],pe([0,1,22]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class P{constructor(){this.buffers=[]}add(y){let i=this.buffers.indexOf(y);return i<0&&(i=this.buffers.length,this.buffers.push(y)),i}}function T(k,y){if(y){const i=new P,R=(m,s)=>{if(s instanceof ArrayBuffer){const d=i.add(s);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(s)){const d=I(s);if(d){const S=i.add(s.buffer);return{$$vscode_array_buffer_reference$$:!0,index:S,view:{type:d,byteLength:s.byteLength,byteOffset:s.byteOffset}}}}return s},C=JSON.stringify(k,R),w=i.buffers.map(m=>{const s=new Uint8Array(m);return _.VSBuffer.wrap(s)});return{message:C,buffers:w}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=T;function I(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function D(k,y){const i=y.map(w=>{const m=new ArrayBuffer(w.byteLength);return new Uint8Array(m).set(w.buffer),m}),R=y.length?(w,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const s=m,{index:d}=s,S=i[d];if(s.view)switch(s.view.type){case 1:return new Int8Array(S,s.view.byteOffset,s.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(S,s.view.byteOffset,s.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(S,s.view.byteOffset,s.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(S,s.view.byteOffset,s.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(S,s.view.byteOffset,s.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(S,s.view.byteOffset,s.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(S,s.view.byteOffset,s.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(S,s.view.byteOffset,s.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(S,s.view.byteOffset,s.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(S,s.view.byteOffset,s.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(S,s.view.byteOffset,s.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return S}return m}:void 0;return{message:JSON.parse(k,R),arrayBuffers:i}}e.deserializeWebviewMessage=D}),define(ge[85],pe([0,1,2]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function P(I,D,k){const y=I.webviewResourceRoot.replace("{{resource}}",k.scheme+T(k)).replace("{{uuid}}",D);return _.URI.parse(y)}e.asWebviewUri=P;function T(I){return I.toString().replace(/^\S+?:/,"")}}),define(ge[200],pe([0,1,3,6,85,28]),function(Q,e,_,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class D{constructor(y,i,R){this._proxy=y,this._editors=i,this._initData=R,this._handlePool=0,this._disposables=new P.DisposableStore,this._insets=new Map,this._disposables.add(i.onDidChangeVisibleTextEditors(()=>{const C=i.getVisibleTextEditors();for(const w of this._insets.values())C.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,i,R,C,w){let m;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===y){m=u;break}if(!m)throw new Error("not a visible editor");const s=this,d=this._handlePool++,S=new _.Emitter,v=new _.Emitter,b=new class{constructor(){this._uuid=(0,I.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,T.asWebviewUri)(s._initData,this._uuid,u)}get cspSource(){return s._initData.webviewCspSource}set options(u){this._options=u,s._proxy.$setOptions(d,u)}get options(){return this._options}set html(u){this._html=u,s._proxy.$setHtml(d,u)}get html(){return this._html}get onDidReceiveMessage(){return S.event}postMessage(u){return s._proxy.$postMessage(d,u)}},p=new class{constructor(){this.editor=y,this.line=i,this.height=R,this.webview=b,this.onDidDispose=v.event}dispose(){s._insets.has(d)&&(s._insets.delete(d),s._proxy.$disposeEditorInset(d),v.fire(),v.dispose(),S.dispose())}};return this._proxy.$createEditorInset(d,m.id,m.value.document.uri,i+1,R,C||{},w.identifier,w.extensionLocation),this._insets.set(d,{editor:y,inset:p,onDidReceiveMessage:S}),p}$onDidDispose(y){const i=this._insets.get(y);i&&i.inset.dispose()}$onDidReceiveMessage(y,i){const R=this._insets.get(y);R&&R.onDidReceiveMessage.fire(i)}}e.ExtHostEditorInsets=D}),define(ge[201],pe([0,1,3,80,168,4,6,24,40,14,53,23,43,193]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",w.Codicon.window,(0,T.localize)(0,null));var s;(function(l){l.ViewContainersRegistry="workbench.registry.view.containers",l.ViewsRegistry="workbench.registry.view"})(s=e.Extensions||(e.Extensions={}));var d;(function(l){l[l.Sidebar=0]="Sidebar",l[l.Panel=1]="Panel"})(d=e.ViewContainerLocation||(e.ViewContainerLocation={}));function S(l){switch(l){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=S;function v(l){return`viewContainer.${l}.enabled`}e.getEnabledViewContainerContextKey=v;class b extends D.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new _.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new _.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,i.flatten)([...this.viewContainers.values()])}registerViewContainer(a,g,E){var f;const h=this.get(a.id);if(h)return h;const A=a;return A.openCommandActionDescriptor=(E==null?void 0:E.donotRegisterOpenCommand)?void 0:(f=A.openCommandActionDescriptor)!==null&&f!==void 0?f:{id:A.id},(0,k.getOrSet)(this.viewContainers,g,[]).push(A),(E==null?void 0:E.isDefault)&&this.defaultViewContainers.push(A),this._onDidRegister.fire({viewContainer:A,viewContainerLocation:g}),A}deregisterViewContainer(a){for(const g of this.viewContainers.keys()){const E=this.viewContainers.get(g),f=E==null?void 0:E.indexOf(a);if(f!==-1){E==null||E.splice(f,1),E.length===0&&this.viewContainers.delete(g),this._onDidDeregister.fire({viewContainer:a,viewContainerLocation:g});return}}}get(a){return this.all.filter(g=>g.id===a)[0]}getViewContainers(a){return[...this.viewContainers.get(a)||[]]}getViewContainerLocation(a){return[...this.viewContainers.keys()].filter(g=>this.getViewContainers(g).filter(E=>(E==null?void 0:E.id)===a.id).length>0)[0]}getDefaultViewContainer(a){return this.defaultViewContainers.find(g=>this.getViewContainerLocation(g)===a)}}y.Registry.add(s.ViewContainersRegistry,new b);var p;(function(l){l.Open="2_open",l.Debug="4_debug",l.SCM="5_scm",l.More="9_more"})(p=e.ViewContentGroups||(e.ViewContentGroups={}));function u(l,a){var g,E,f,h;const A=(g=l.group)!==null&&g!==void 0?g:p.More,L=(E=a.group)!==null&&E!==void 0?E:p.More;return A!==L?A.localeCompare(L):((f=l.order)!==null&&f!==void 0?f:5)-((h=a.order)!==null&&h!==void 0?h:5)}class c extends D.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new _.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new _.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new _.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new _.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new R.SetMap}registerViews(a,g){this.registerViews2([{views:a,viewContainer:g}])}registerViews2(a){a.forEach(({views:g,viewContainer:E})=>this.addViews(g,E)),this._onViewsRegistered.fire(a)}deregisterViews(a,g){const E=this.removeViews(a,g);E.length&&this._onViewsDeregistered.fire({views:E,viewContainer:g})}moveViews(a,g){for(const E of this._views.keys())if(E!==g){const f=this.removeViews(a,E);f.length&&(this.addViews(f,g),this._onDidChangeContainer.fire({views:f,from:E,to:g}))}}getViews(a){return this._views.get(a)||[]}getView(a){for(const g of this._viewContainers){const E=(this._views.get(g)||[]).filter(f=>f.id===a)[0];if(E)return E}return null}getViewContainer(a){for(const g of this._viewContainers)if((this._views.get(g)||[]).filter(f=>f.id===a)[0])return g;return null}registerViewWelcomeContent(a,g){return this._viewWelcomeContents.add(a,g),this._onDidChangeViewWelcomeContent.fire(a),(0,D.toDisposable)(()=>{this._viewWelcomeContents.delete(a,g),this._onDidChangeViewWelcomeContent.fire(a)})}registerViewWelcomeContent2(a,g){const E=new Map;for(const[f,h]of g)this._viewWelcomeContents.add(a,h),E.set(f,(0,D.toDisposable)(()=>{this._viewWelcomeContents.delete(a,h),this._onDidChangeViewWelcomeContent.fire(a)}));return this._onDidChangeViewWelcomeContent.fire(a),E}getViewWelcomeContent(a){const g=[];return this._viewWelcomeContents.forEach(a,E=>g.push(E)),g.sort(u)}addViews(a,g){let E=this._views.get(g);E||(E=[],this._views.set(g,E),this._viewContainers.push(g));for(const f of a){if(this.getView(f.id)!==null)throw new Error((0,T.localize)(1,null,f.id));E.push(f)}}removeViews(a,g){const E=this._views.get(g);if(!E)return[];const f=[],h=[];for(const A of E)a.includes(A)?f.push(A):h.push(A);return f.length&&(h.length?this._views.set(g,h):(this._views.delete(g),this._viewContainers.splice(this._viewContainers.indexOf(g),1))),f}}y.Registry.add(s.ViewsRegistry,new c),e.IViewsService=(0,I.createDecorator)("viewsService"),e.FocusedViewContext=new P.RawContextKey("focusedView","",(0,T.localize)(2,null));function t(l){return`view.${l}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,I.createDecorator)("viewDescriptorService");var n;(function(l){l[l.Default=0]="Default",l[l.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var o;(function(l){l[l.None=0]="None",l[l.Collapsed=1]="Collapsed",l[l.Expanded=2]="Expanded"})(o=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(a,g){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,a),this._hasResolve=!!g,this.resolve=async E=>{var f,h;if(g&&!this.resolved){const A=await g(E);A&&(this.tooltip=(f=this.tooltip)!==null&&f!==void 0?f:A.tooltip,this.command=(h=this.command)!==null&&h!==void 0?h:A.command)}E.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r}),define(ge[202],pe([0,1,2,180,116,12,181,201]),function(Q,e,_,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function y(d){return(S,...v)=>d(S.get(P.ICommandService),...v)}class i{static execute(S,v){const b={forceReuseWindow:v&&v.reuseWindow,remoteAuthority:v&&v.remoteAuthority};return S.executeCommand("_files.newWindow",b)}}e.NewWindowAPICommand=i,i.ID="vscode.newWindow",P.CommandsRegistry.registerCommand({id:i.ID,handler:y(i.execute),description:{description:"Opens an new window",args:[]}}),P.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(d,S){return d.get(T.IWorkspacesService).removeRecentlyOpened([S])});class R{static execute(S,v){return typeof v=="string"?v=v.match(/^[^:/?#]+:\/\//)?_.URI.parse(v):_.URI.file(v):v=_.URI.revive(v),S.executeCommand("_workbench.removeFromRecentlyOpened",v)}}e.RemoveFromRecentlyOpenedAPICommand=R,R.ID="vscode.removeFromRecentlyOpened",P.CommandsRegistry.registerCommand(R.ID,y(R.execute));class C{static execute(S,v){const b=typeof v=="string"?{extensionId:v}:v;return S.executeCommand("workbench.action.openIssueReporter",b)}}e.OpenIssueReporter=C,C.ID="vscode.openIssueReporter",P.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(d,S){const v=d.get(T.IWorkspacesService);let b;const p=S.uri,u=S.label,c=S.remoteAuthority;return S.type==="workspace"?b={workspace:await v.getWorkspaceIdentifier(p),label:u,remoteAuthority:c}:S.type==="folder"?b={folderUri:p,label:u,remoteAuthority:c}:b={fileUri:p,label:u,remoteAuthority:c},v.addRecentlyOpened([b])}),P.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(d){return d.get(T.IWorkspacesService).getRecentlyOpened()}),P.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(d,S){const v=d.get(I.ILogService),b=d.get(D.IEnvironmentService);b.isExtensionDevelopment&&!!b.extensionTestsLocationURI&&v.setLevel(S)}),P.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(d){return d.get(I.ILogService).getLevel()}),P.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(d,S){const v=d.get(k.IViewDescriptorService),b=v.getViewContainerById(S.destinationId);if(!!b){for(const p of S.viewIds){const u=v.getViewDescriptorById(p);(u==null?void 0:u.canMoveView)&&v.moveViewsToContainer([u],b,k.ViewVisibilityState.Default)}await d.get(k.IViewsService).openViewContainer(b.id,!0)}});class w{static execute(S,v){return!Array.isArray(v==null?void 0:v.viewIds)||typeof(v==null?void 0:v.destinationId)!="string"?Promise.reject("Invalid arguments"):S.executeCommand("_workbench.action.moveViews",v)}}e.MoveViewsAPICommand=w,w.ID="vscode.moveViews",P.CommandsRegistry.registerCommand({id:w.ID,handler:y(w.execute),description:{description:"Move Views",args:[]}});class m{static execute(S,v){return S.executeCommand("_workbench.open",v)}}m.ID="vscode.open",P.CommandsRegistry.registerCommand(m.ID,y(m.execute));class s{static execute(S,v,b,p,u){return S.executeCommand("_workbench.diff",[v,b,p])}}s.ID="vscode.diff",P.CommandsRegistry.registerCommand(s.ID,y(s.execute))}),define(ge[119],pe([0,1,3,19,169]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class I{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new _.Emitter,this._onExit=new _.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,y,i,R){const C={command:k};if(y&&Object.keys(y).length>0&&(C.arguments=y),this.internalSend("request",C),typeof R=="number"){const w=setTimeout(()=>{clearTimeout(w);const m=this.pendingRequests.get(C.seq);if(m){this.pendingRequests.delete(C.seq);const s={type:"response",seq:0,request_seq:C.seq,success:!1,command:k,message:(0,T.localize)(0,null,R,k)};m(s)}},R)}return i&&this.pendingRequests.set(C.seq,i),C.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,y){return k.type!=="event"||y.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,P.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const y=k,i=this.pendingRequests.get(y.request_seq);i&&(this.pendingRequests.delete(y.request_seq),i(y));break}}}internalSend(k,y){y.type=k,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((y,i)=>k.set(i,y)),await(0,P.timeout)(500),k.forEach((y,i)=>{y({type:"response",seq:0,request_seq:i,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(i)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=I}),define(ge[203],pe([0,1,10,2,8,23,11]),function(Q,e,_,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function y(n,o,r){return n.replace(k,function(l,a){return o&&a.length>0&&a[0]!=="_"?l:r&&r.hasOwnProperty(a)?r[a]:l})}e.formatPII=y;function i(n){const o={};for(const r of Object.keys(n))r.startsWith("!")||(o[r]=n[r]);return o}e.filterExceptionsFromTelemetry=i;function R(n){return n.configuration.request==="attach"&&!C(n)}e.isSessionAttach=R;function C(n){let o=n.configuration.type;if(!!o)return o==="vslsShare"&&(o=n.configuration.adapterProxy.configuration.type),(0,_.equalsIgnoreCase)(o,"extensionhost")||(0,_.equalsIgnoreCase)(o,"pwa-extensionhost")?n:n.parentSession?C(n.parentSession):void 0}e.getExtensionHostDebugSession=C;function w(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=w;function m(n,o,r){let l,a=0,g=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,E=null;for(;E=g.exec(n);){let f=E.index+1,h=f+E[0].length;if(f<=o&&h>=r){l=E[0],a=f;break}}if(l){let f=/\w+/g,h=null;for(;(h=f.exec(l))&&!(h.index+1+a+h[0].length>=r););h&&(l=l.substring(0,f.lastIndex))}return l?{start:a,end:a+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(n){return!!(n&&n.match(s))}e.isUri=d;function S(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(d(n.path))return P.URI.parse(n.path);if((0,T.isAbsolute)(n.path))return P.URI.file(n.path)}return n.path}function v(n){if(typeof n.path=="object"){const o=P.URI.revive(n.path);if(o)return o.scheme===D.Schemas.file?o.fsPath:o.toString()}return n.path}function b(n,o){const r=o?S:v,l=(0,I.deepClone)(n);return u(l,(a,g)=>{a&&g&&(g.path=r(g))}),l}e.convertToDAPaths=b;function p(n,o){const r=o?S:v,l=(0,I.deepClone)(n);return u(l,(a,g)=>{!a&&g&&(g.path=r(g))}),l}e.convertToVSCPaths=p;function u(n,o){switch(n.type){case"event":const r=n;switch(r.event){case"output":o(!1,r.body.source);break;case"loadedSource":o(!1,r.body.source);break;case"breakpoint":o(!1,r.body.breakpoint.source);break;default:break}break;case"request":const l=n;switch(l.command){case"setBreakpoints":o(!0,l.arguments.source);break;case"breakpointLocations":o(!0,l.arguments.source);break;case"source":o(!0,l.arguments.source);break;case"gotoTargets":o(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(g=>o(!1,g));break;default:break}break;case"response":const a=n;if(a.success&&a.body)switch(a.command){case"stackTrace":a.body.stackFrames.forEach(g=>o(!1,g.source));break;case"loadedSources":a.body.sources.forEach(g=>o(!1,g));break;case"scopes":a.body.scopes.forEach(g=>o(!1,g.source));break;case"setFunctionBreakpoints":a.body.breakpoints.forEach(g=>o(!1,g.source));break;case"setBreakpoints":a.body.breakpoints.forEach(g=>o(!1,g.source));break;default:break}break}}function c(n){return n.filter(o=>{var r;return!((r=o.presentation)===null||r===void 0?void 0:r.hidden)}).sort((o,r)=>o.presentation?r.presentation?o.presentation.group?r.presentation.group?o.presentation.group!==r.presentation.group?o.presentation.group.localeCompare(r.presentation.group):t(o.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(o.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=c;function t(n,o){return typeof n!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:n-o}}),define(ge[204],pe([0,1,26,38,170,120,8,10,23,9,182,119]),function(Q,e,_,P,T,I,D,k,y,i,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class w extends C.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,p){this.outputStream=p,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",u=>this.handleData(u))}sendMessage(b){if(this.outputStream){const p=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(p,"utf8")}${w.TWO_CRLF}${p}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const p=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,p.length>0)try{this.acceptMessage(JSON.parse(p))}catch(u){this._onError.fire(new Error((u.message||u)+`
`+p))}continue}}else{const p=this.rawData.indexOf(w.TWO_CRLF);if(p!==-1){const c=this.rawData.toString("utf8",0,p).split(w.HEADER_LINESEPARATOR);for(const t of c){const n=t.split(w.HEADER_FIELDSEPARATOR);n[0]==="Content-Length"&&(this.contentLength=Number(n[1]))}this.rawData=this.rawData.slice(p+w.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=w,w.TWO_CRLF=`\r
\r
`,w.HEADER_LINESEPARATOR=/\r?\n/,w.HEADER_FIELDSEPARATOR=/: */;class m extends w{startSession(){return new Promise((b,p)=>{let u=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),u=!0}),this.socket.on("close",()=>{u?this._onError.fire(new Error("connection closed")):p(new Error("connection closed"))}),this.socket.on("error",c=>{u?this._onError.fire(c):p(c)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=m;class s extends m{constructor(b){super();this.adapterServer=b}createConnection(b){return I.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=s;class d extends m{constructor(b){super();this.adapterServer=b}createConnection(b){return I.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=d;class S extends w{constructor(b,p,u){super();this.adapterExecutable=b,this.debugType=p,this.outputService=u}async startSession(){const b=this.adapterExecutable.command,p=this.adapterExecutable.args,u=this.adapterExecutable.options||{};try{if(b)if(D.isAbsolute(b)){if(!await(0,_.exists)(b))throw new Error(T.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(T.localize(1,null,this.debugType));let c=process.env;if(u.env&&Object.keys(u.env).length>0&&(c=y.mixin(y.deepClone(process.env),u.env)),b==="node")if(Array.isArray(p)&&p.length>0){const n=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:c,execArgv:n?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};u.cwd&&(o.cwd=u.cwd);const r=P.fork(p[0],p.slice(1),o);if(!r.pid)throw new Error(T.localize(2,null,p[0]));this.serverProcess=r}else throw new Error(T.localize(3,null));else{const n={env:c};u.cwd&&(n.cwd=u.cwd),this.serverProcess=P.spawn(b,p,n)}this.serverProcess.on("error",n=>{this._onError.fire(n)}),this.serverProcess.on("exit",(n,o)=>{this._onExit.fire(n)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",n=>{this._onError.fire(n)}),this.serverProcess.stdin.on("error",n=>{this._onError.fire(n)});const t=this.outputService;if(t){const n=o=>o.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",o=>{const r=t.getChannel(R.ExtensionsChannelId);r&&r.append(n(o))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(c){this._onError.fire(c)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),i.isWindows?new Promise((b,p)=>{const u=P.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(c,t,n){if(c)return p(c)});u.on("exit",b),u.on("error",p)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,p){if(!!b){const u=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?u.runtime=D.join(p,b.runtime):u.runtime=b.runtime),b.runtimeArgs&&(u.runtimeArgs=b.runtimeArgs),b.program&&(D.isAbsolute(b.program)?u.program=b.program:u.program=D.join(p,b.program)),b.args&&(u.args=b.args);const c=b;return c.win&&(u.win=S.extract(c.win,p)),c.winx86&&(u.winx86=S.extract(c.winx86,p)),c.windows&&(u.windows=S.extract(c.windows,p)),c.osx&&(u.osx=S.extract(c.osx,p)),c.linux&&(u.linux=S.extract(c.linux,p)),u}}static platformAdapterExecutable(b,p){let u=Object.create(null);p=p.toLowerCase();for(const l of b)if(l.contributes){const a=l.contributes.debuggers;a&&a.length>0&&a.filter(g=>typeof g.type=="string"&&k.equalsIgnoreCase(g.type,p)).forEach(g=>{const E=S.extract(g,l.extensionLocation.fsPath);u=y.mixin(u,E,l.isBuiltin)})}let c;i.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?c=u.winx86||u.win||u.windows:i.isWindows?c=u.win||u.windows:i.isMacintosh?c=u.osx:i.isLinux&&(c=u.linux),c=c||u;let t=c.program||u.program;const n=c.args||u.args;let o=c.runtime||u.runtime;const r=c.runtimeArgs||u.runtimeArgs;if(o)return{type:"executable",command:o,args:(r||[]).concat(typeof t=="string"?[t]:[]).concat(n||[])};if(t)return{type:"executable",command:t,args:n||[]}}}e.ExecutableDebugAdapter=S}),define(ge[205],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=void 0,e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(ge[206],pe([0,1,38,8,77,171,26,9,83,4,205,11]),function(Q,e,_,P,T,I,D,k,y,i,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const w=I.localize(0,null);let m=class Wt{constructor(p){this._configurationService=p}openTerminal(p){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(_,u,T.getWindowsShell(),p)}}runInTerminal(p,u,c,t,n){const o=n.windowsExec||Wt.getDefaultTerminalWindows();return new Promise((r,l)=>{const a=`"${u} - ${w}"`,g=`""${c.join('" "')}" & pause"`,E=["/c","start",a,"/wait",o,"/c",g],f=Object.assign({},process.env,t);Object.keys(f).filter(L=>f[L]===null).forEach(L=>delete f[L]);const h={cwd:u,env:f,windowsVerbatimArguments:!0};_.spawn(Wt.CMD,E,h).on("error",L=>{l(S(L))}),r(void 0)})}spawnTerminal(p,u,c,t){const o=u.terminal.external.windowsExec||Wt.getDefaultTerminalWindows();t&&t[1]===":"&&(t=t[0].toUpperCase()+t.substr(1));const r=P.basename(o).toLowerCase();if(r==="cmder"||r==="cmder.exe")return p.spawn(o,t?[t]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return o.indexOf(" ")>=0&&l.push('""'),l.push(o),(r==="wt"||r==="wt.exe")&&l.push("-d ."),new Promise((a,g)=>{const E=t?{cwd:t}:void 0,f=p.spawn(c,l,E);f.on("error",g),f.on("exit",()=>a())})}static getDefaultTerminalWindows(){if(!Wt._DEFAULT_TERMINAL_WINDOWS){const p=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");Wt._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${p?"Sysnative":"System32"}\\cmd.exe`}return Wt._DEFAULT_TERMINAL_WINDOWS}};m.CMD="cmd.exe",m=je([xe(0,(0,i.optional)(y.IConfigurationService))],m),e.WindowsExternalTerminalService=m;let s=class Ln{constructor(p){this._configurationService=p}openTerminal(p){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(_,u,p)}}runInTerminal(p,u,c,t,n){const o=n.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((r,l)=>{if(o===R.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const a=o===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",E=[C.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${a}.scpt`,Q).fsPath,"-t",p||w,"-w",u];for(let A of c)E.push("-a"),E.push(A);if(t)for(let A in t){const L=t[A];L===null?(E.push("-u"),E.push(A)):(E.push("-e"),E.push(`${A}=${L}`))}let f="";const h=_.spawn(Ln.OSASCRIPT,E);h.on("error",A=>{l(S(A))}),h.stderr.on("data",A=>{f+=A.toString()}),h.on("exit",A=>{if(A===0)r(void 0);else if(f){const L=f.split(`
`,1);l(new Error(L[0]))}else l(new Error(I.localize(1,null,a,A)))})}else l(new Error(I.localize(2,null,o)))})}spawnTerminal(p,u,c){const n=u.terminal.external.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((o,r)=>{const l=["-a",n];c&&l.push(c);const a=p.spawn("/usr/bin/open",l);a.on("error",r),a.on("exit",()=>o())})}};s.OSASCRIPT="/usr/bin/osascript",s=je([xe(0,(0,i.optional)(y.IConfigurationService))],s),e.MacExternalTerminalService=s;let d=class $t{constructor(p){this._configurationService=p}openTerminal(p){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(_,u,p)}}runInTerminal(p,u,c,t,n){const o=n.linuxExec?Promise.resolve(n.linuxExec):$t.getDefaultTerminalLinuxReady();return new Promise((r,l)=>{let a=[];o.then(g=>{g.indexOf("gnome-terminal")>=0?a.push("-x"):a.push("-e"),a.push("bash"),a.push("-c");const E=`${v(c)}; echo; read -p "${$t.WAIT_MESSAGE}" -n1;`;a.push(`''${E}''`);const f=Object.assign({},process.env,t);Object.keys(f).filter(B=>f[B]===null).forEach(B=>delete f[B]);const h={cwd:u,env:f};let A="";const L=_.spawn(g,a,h);L.on("error",B=>{l(S(B))}),L.stderr.on("data",B=>{A+=B.toString()}),L.on("exit",B=>{if(B===0)r(void 0);else if(A){const ee=A.split(`
`,1);l(new Error(ee[0]))}else l(new Error(I.localize(4,null,g,B)))})})})}spawnTerminal(p,u,c){const t=u.terminal.external,n=t.linuxExec?Promise.resolve(t.linuxExec):$t.getDefaultTerminalLinuxReady();return new Promise((o,r)=>{n.then(l=>{const a=c?{cwd:c}:void 0,g=p.spawn(l,[],a);g.on("error",r),g.on("exit",()=>o())})})}static async getDefaultTerminalLinuxReady(){return $t._DEFAULT_TERMINAL_LINUX_READY||($t._DEFAULT_TERMINAL_LINUX_READY=new Promise(async p=>{k.isLinux?await D.exists("/etc/debian_version")?p("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?p("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?p("konsole"):process.env.COLORTERM?p(process.env.COLORTERM):process.env.TERM?p(process.env.TERM):p("xterm"):p("xterm")})),$t._DEFAULT_TERMINAL_LINUX_READY}};d.WAIT_MESSAGE=I.localize(3,null),d=je([xe(0,(0,i.optional)(y.IConfigurationService))],d),e.LinuxExternalTerminalService=d;function S(b){return"errno"in b&&b.errno==="ENOENT"&&"path"in b&&typeof b.path=="string"?new Error(I.localize(5,null,b.path)):b}function v(b){let p="";for(let u of b)u.indexOf(" ")>=0?p+='"'+u+'"':p+=u,p+=" ";return p}}),define(ge[207],pe([0,1,38,9,206,30]),function(Q,e,_,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;let D;function k(w,m){if(!D)if(P.isWindows)D=new T.WindowsExternalTerminalService(void 0);else if(P.isMacintosh)D=new T.MacExternalTerminalService(void 0);else if(P.isLinux)D=new T.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const s=m.getConfiguration("terminal");return D.runInTerminal(w.title,w.cwd,w.args,w.env||{},s.external||{})}e.runInExternalTerminal=k;function y(w,m){return new Promise((s,d)=>{let S="";const v=_.spawn(w,m);v.pid&&v.stdout.on("data",b=>{S+=b.toString()}),v.on("error",b=>{d(b)}),v.on("close",b=>{s(S)})})}function i(w){return w?P.isWindows?y("wmic",["process","get","ParentProcessId"]).then(m=>m.split(`\r
`).some(d=>parseInt(d)===w),m=>!0):y("/usr/bin/pgrep",["-lP",String(w)]).then(m=>{const s=m.trim();return!(s.length===0||s.indexOf(" tmux")>=0)},m=>!0):Promise.resolve(!0)}e.hasChildProcesses=i;var R;(function(w){w[w.cmd=0]="cmd",w[w.powershell=1]="powershell",w[w.bash=2]="bash"})(R||(R={}));function C(w,m,s,d){w=w.trim().toLowerCase();let S;w.indexOf("powershell")>=0||w.indexOf("pwsh")>=0?S=1:w.indexOf("cmd.exe")>=0?S=0:w.indexOf("bash")>=0?S=2:P.isWindows?S=0:S=2;let v,b=" ";switch(S){case 1:if(v=u=>(u=u.replace(/\'/g,"''"),u.length>0&&u.charAt(u.length-1)==="\\"?`'${u}\\'`:`'${u}'`),s){const u=(0,I.getDriveLetter)(s);u&&(b+=`${u}:; `),b+=`cd ${v(s)}; `}if(d)for(let u in d){const c=d[u];c===null?b+=`Remove-Item env:${u}; `:b+=`\${env:${u}}='${c}'; `}if(m.length>0){const u=v(m.shift());b+=u[0]==="'"?`& ${u} `:`${u} `;for(let c of m)b+=`${v(c)} `}break;case 0:if(v=u=>(u=u.replace(/\"/g,'""'),u.indexOf(" ")>=0||u.indexOf('"')>=0||u.length===0?`"${u}"`:u),s){const u=(0,I.getDriveLetter)(s);u&&(b+=`${u}: && `),b+=`cd ${v(s)} && `}if(d){b+='cmd /C "';for(let u in d){let c=d[u];c===null?b+=`set "${u}=" && `:(c=c.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),b+=`set "${u}=${c}" && `)}}for(let u of m)b+=`${v(u)} `;d&&(b+='"');break;case 2:v=u=>(u=u.replace(/(["'\\\$])/g,"\\$1"),u.indexOf(" ")>=0||u.indexOf(";")>=0||u.length===0?`"${u}"`:u);const p=u=>/[^\w@%\/+=,.:^-]/.test(u)?`'${u.replace(/'/g,"'\\''")}'`:u;if(s&&(b+=`cd ${v(s)} ; `),d){b+="/usr/bin/env";for(let u in d){const c=d[u];c===null?b+=` -u ${p(u)}`:b+=` ${p(`${u}=${c}`)}`}b+=" "}for(let u of m)b+=`${v(u)} `;break}return b}e.prepareCommand=C}),define(ge[86],pe([0,1,33,11,8,9,80]),function(Q,e,_,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var k;(function(L){L[L.Markdown=1]="Markdown",L[L.Code=2]="Code"})(k=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(L){L[L.Running=1]="Running",L[L.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,cellEditable:!0,custom:{},trusted:!0};var i;(function(L){L[L.Idle=1]="Idle",L[L.Pending=2]="Pending",L[L.Executing=3]="Executing"})(i=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var R;(function(L){L[L.WithHardKernelDependency=0]="WithHardKernelDependency",L[L.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",L[L.Pure=2]="Pure",L[L.Never=3]="Never"})(R=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var C;(function(L){L[L.ModelChange=1]="ModelChange",L[L.Move=2]="Move",L[L.CellClearOutput=3]="CellClearOutput",L[L.CellsClearOutput=4]="CellsClearOutput",L[L.ChangeLanguage=5]="ChangeLanguage",L[L.Initialize=6]="Initialize",L[L.ChangeCellMetadata=7]="ChangeCellMetadata",L[L.Output=8]="Output",L[L.OutputItem=9]="OutputItem",L[L.ChangeCellContent=10]="ChangeCellContent",L[L.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",L[L.Unknown=12]="Unknown"})(C=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var w;(function(L){L[L.Handle=0]="Handle",L[L.Index=1]="Index"})(w=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(L){L[L.Replace=1]="Replace",L[L.Output=2]="Output",L[L.Metadata=3]="Metadata",L[L.CellLanguage=4]="CellLanguage",L[L.DocumentMetadata=5]="DocumentMetadata",L[L.OutputsSplice=6]="OutputsSplice",L[L.Move=7]="Move",L[L.Unknown=8]="Unknown",L[L.CellContent=9]="CellContent",L[L.OutputItems=10]="OutputItems",L[L.PartialMetadata=11]="PartialMetadata"})(m=e.CellEditType||(e.CellEditType={}));function s(L){const B=d.parse(L);return B?B.notebook.toString():L.toString()}e.getCellUndoRedoComparisonKey=s;var d;(function(L){L.scheme=P.Schemas.vscodeNotebookCell;const B=/^ch(\d{7,})/;function ee(F,U){return F.with({scheme:L.scheme,fragment:`ch${U.toString().padStart(7,"0")}${F.scheme!==P.Schemas.file?F.scheme:""}`})}L.generate=ee;function j(F){if(F.scheme===L.scheme){const U=B.exec(F.fragment);if(!!U)return{handle:Number(U[1]),notebook:F.with({scheme:F.fragment.substr(U[0].length)||P.Schemas.file,fragment:null})}}}L.parse=j;function x(F,U){return F.with({scheme:P.Schemas.vscodeNotebookCellMetadata,fragment:`ch${U.toString().padStart(7,"0")}${F.scheme!==P.Schemas.file?F.scheme:""}`})}L.generateCellMetadataUri=x;function $(F){if(F.scheme===P.Schemas.vscodeNotebookCellMetadata){const U=B.exec(F.fragment);if(!!U)return{handle:Number(U[1]),notebook:F.with({scheme:F.fragment.substr(U[0].length)||P.Schemas.file,fragment:null})}}}L.parseCellMetadataUri=$})(d=e.CellUri||(e.CellUri={}));const S=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function v(L){var B,ee;return(ee=(B=S.get(L))===null||B===void 0?void 0:B.alwaysSecure)!==null&&ee!==void 0?ee:!1}e.mimeTypeIsAlwaysSecure=v;function b(L){var B,ee;return(ee=(B=S.get(L))===null||B===void 0?void 0:B.supportedByCore)!==null&&ee!==void 0?ee:!1}e.mimeTypeSupportedByCore=b;function p(L){var B,ee;return(ee=(B=S.get(L))===null||B===void 0?void 0:B.mergeable)!==null&&ee!==void 0?ee:!1}e.mimeTypeIsMergeable=p;function u(L,B){return I.isWindows&&(L=L.replace(/\//g,"\\"),B=B.replace(/\//g,"\\")),_.match(L,B)}function c(L,B,ee){let j=0;for(let x=0;x<B.length;x++){if(u(B[x],L))return j;j++}for(let x=0;x<ee.length;x++){if(u(ee[x],L))return j;j++}return j}function t(L,B,ee){return L.sort((j,x)=>c(j,B,ee)-c(x,B,ee))}e.sortMimeTypes=t;function n(L,B,ee,j=(x,$)=>x===$){const x=[];function $(M,N,O){if(!(N===0&&O.length===0)){const V=x[x.length-1];V&&V.start+V.deleteCount===M?(V.deleteCount+=N,V.toInsert.push(...O)):x.push({start:M,deleteCount:N,toInsert:O})}}let F=0,U=0;for(;;){if(F===L.length){$(F,0,B.slice(U));break}if(U===B.length){$(F,L.length-F,[]);break}const M=L[F],N=B[U];if(j(M,N)){F+=1,U+=1;continue}ee(N)?($(F,1,[]),F+=1):($(F,0,[N]),U+=1)}return x}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var o;(function(L){L.default="default",L.option="option"})(o=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(L){const B=L;return!!((typeof B.include=="string"||_.isRelativePattern(B.include))&&(typeof B.exclude=="string"||_.isRelativePattern(B.exclude)))}e.isDocumentExcludePattern=r;function l(L,B,ee){if(Array.isArray(L.viewType)&&L.viewType.indexOf(B)>=0||L.viewType===B)return!0;if(L.filenamePattern){let j=r(L.filenamePattern)?L.filenamePattern.include:L.filenamePattern,x=r(L.filenamePattern)?L.filenamePattern.exclude:void 0;if(_.match(j,(0,T.basename)(ee.fsPath).toLowerCase()))return!(x&&_.match(x,(0,T.basename)(ee.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class a{constructor(B){this.textModel=B}getElements(){const B=new Int32Array(this.textModel.cells.length);for(let ee=0;ee<this.textModel.cells.length;ee++)B[ee]=this.textModel.cells[ee].getHashValue();return B}}e.CellSequence=a,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var g;(function(L){L[L.Left=1]="Left",L[L.Right=2]="Right"})(g=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function E(L){L.sort((ee,j)=>ee-j);const B=L.shift();return B===void 0?[]:L.reduce(function(ee,j){return j<=ee[0][1]?ee[0][1]=j+1:ee.unshift([j,j+1]),ee},[[B,B+1]]).reverse().map(ee=>({start:ee[0],end:ee[1]}))}e.cellIndexesToRanges=E;function f(L){return L.reduce((ee,j)=>{for(let x=j.start;x<j.end;x++)ee.push(x);return ee},[])}e.cellRangesToIndexes=f;function h(L){const B=L.sort((j,x)=>j.start-x.start),ee=B[0];return ee?B.reduce((j,x)=>{const $=j[j.length-1];return $.end>=x.start?$.end=Math.max($.end,x.end):j.push(x),j},[ee]):[]}e.reduceRanges=h;function A(L,B){return B.start>=L.start&&B.end<=L.end}e.cellRangeContains=A}),define(ge[208],pe([0,1,173,4,80]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new T.RawContextKey("customExecutionSupported",!0,_.localize(0,null)),e.ShellExecutionSupportedContext=new T.RawContextKey("shellExecutionSupported",!1,_.localize(1,null)),e.ProcessExecutionSupportedContext=new T.RawContextKey("processExecutionSupported",!1,_.localize(2,null)),e.ITaskService=(0,P.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ge[209],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function _(T){return[...T.entries()]}e.serializeEnvironmentVariableCollection=_;function P(T){return new Map(T)}e.deserializeEnvironmentVariableCollection=P}),define(ge[210],pe([0,1,8,9,134]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function I(c,t){if(!!t)if(P.isWindows)for(const n in t){let o=n;for(const l in c)if(n.toLowerCase()===l.toLowerCase()){o=l;break}const r=t[n];r!==void 0&&D(c,o,r)}else Object.keys(t).forEach(n=>{const o=t[n];o!==void 0&&D(c,n,o)})}e.mergeEnvironments=I;function D(c,t,n){typeof n=="string"?c[t]=n:delete c[t]}function k(c,t,n,o){c.TERM_PROGRAM="vscode",t&&(c.TERM_PROGRAM_VERSION=t),R(c,o)&&(c.LANG=C(n)),c.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=k;function y(c,t){if(!!t)for(const n of Object.keys(t)){const o=t[n];o&&(c[n]=o)}}function i(c,t){return Object.keys(t).forEach(n=>{const o=t[n];if(typeof o=="string")try{t[n]=c(o)}catch(r){t[n]=o}}),t}function R(c,t){if(t==="on")return!0;if(t==="auto"){const n=c.LANG;return!n||n.search(/\.UTF\-8$/)===-1&&n.search(/\.utf8$/)===-1&&n.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=R;function C(c){const t=c?c.split("-"):[],n=t.length;if(n===0)return"en_US.UTF-8";if(n===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in o&&t.push(o[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.getLangEnvVariable=C;function w(c,t,n,o,r,l){if(c.cwd){const g=typeof c.cwd=="object"?c.cwd.fsPath:c.cwd,E=m(g,n);return s(E||g)}let a;return!c.ignoreConfigurationCwd&&r&&(n&&(r=m(r,n,l)),r&&(_.isAbsolute(r)?a=r:o&&(a=_.join(o.fsPath,r)))),a||(a=o?o.fsPath:t||""),s(a)}e.getCwd=w;function m(c,t,n){if(t)try{return t(c)}catch(o){n==null||n.error("Could not resolve terminal cwd",o);return}return c}function s(c){return P.platform===3&&c&&c[1]===":"?c[0].toUpperCase()+c.substr(1):c}function d(c){let t=c;t.indexOf("\\")!==0&&(t=t.replace(/\\/g,"\\\\"));const n=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return t=t.replace(n,""),`'${t}'`}e.escapeNonWindowsPath=d;function S(c,t){if(!!t)return n=>t.resolve(c,n)}e.createVariableResolver=S;function v(c,t,n,o,r,l,a,g,E=P.platform){let f=null;g&&(f=p(c,t,"automationShell",E)),f||(f=p(c,t,"shell",E));let h=f||n;if(E===3&&!o&&r){const A=_.join(r,"Sysnative").replace(/\//g,"\\").toLowerCase();h&&h.toLowerCase().indexOf(A)===0&&(h=_.join(r,"System32",h.substr(A.length+1)))}if(h&&E===3&&(h=h.replace(/\//g,"\\")),l)try{h=l(h)}catch(A){a.error("Could not resolve shell",A)}return h}e.getDefaultShell=v;function b(c,t,n,o,r,l=P.platform){if(n&&p(c,t,"automationShell",l))return[];const a=l===3?"windows":l===1?"osx":"linux",g=c(`terminal.integrated.shellArgs.${a}`);let E=(t?g.value:g.userValue)||g.defaultValue;if(!E)return[];if(typeof E=="string"&&l===3)return o?o(E):E;if(o){const f=[];for(const h of E)try{f.push(o(h))}catch(A){r.error(`Could not resolve terminal.integrated.shellArgs.${a}`,A),f.push(h)}E=f}return E}e.getDefaultShellArgs=b;function p(c,t,n,o=P.platform){const l=c(`terminal.integrated.${n}.${o===3?"windows":o===1?"osx":"linux"}`);return(t?l.value:l.userValue)||l.defaultValue}function u(c,t,n,o,r,l,a){let g={};if(c.strictEnv)y(g,c.env);else{y(g,a);const E=Object.assign({},o?t.value:t.userValue);n&&(E&&i(n,E),c.env&&i(n,c.env)),(0,T.sanitizeProcessEnvironment)(g,"VSCODE_IPC_HOOK_CLI"),I(g,E),I(g,c.env),k(g,r,P.locale,l)}return g}e.createTerminalEnvironment=u});var rn=this&&this.__asyncValues||function(Q){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=Q[Symbol.asyncIterator],_;return e?e.call(Q):(Q=typeof __values=="function"?__values(Q):Q[Symbol.iterator](),_={},P("next"),P("throw"),P("return"),_[Symbol.asyncIterator]=function(){return this},_);function P(I){_[I]=Q[I]&&function(D){return new Promise(function(k,y){D=Q[I](D),T(k,y,D.done,D.value)})}}function T(I,D,k,y){Promise.resolve(y).then(function(i){I({value:i,done:k})},D)}};define(ge[211],pe([0,1,37,9,8,101,190,38,26,43]),function(Q,e,_,P,T,I,D,k,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let R;function C(u,c,t,n,o,r,l){return c=c||{existsFile:y.SymlinkSupport.existsFile,readFile:_.promises.readFile},P.isWindows?w(u,c,t,n==null?void 0:n.useWslProfiles,n==null?void 0:n.profiles.windows,o,r):v(c,t,u,P.isMacintosh?n==null?void 0:n.profiles.osx:n==null?void 0:n.profiles.linux,l,o,r)}e.detectAvailableProfiles=C;async function w(u,c,t,n,o,r,l){const a=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),g=`${process.env.windir}\\${a?"Sysnative":"System32"}`;let E=!1;(0,D.getWindowsBuildNumber)()>=16299&&(E=!0),await s();const f=new Map;u||(f.set("PowerShell",{source:"PowerShell",icon:i.Codicon.terminalPowershell.id,isAutoDetected:!0}),f.set("Windows PowerShell",{path:`${g}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:i.Codicon.terminalPowershell.id,isAutoDetected:!0}),f.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),f.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),f.set("Command Prompt",{path:`${g}\\cmd.exe`,icon:i.Codicon.terminalCmd.id,isAutoDetected:!0})),b(o,f);const h=await m(f.entries(),c,t,r,l);if(!u||u&&n)try{const A=await S(`${g}\\${E?"wsl.exe":"bash.exe"}`,n);A&&h.push(...A)}catch(A){t==null||t.info("WSL is not installed, so could not detect WSL profiles")}return h}async function m(u,c,t,n,o){const r=[];for(const[l,a]of u)if(a!==null){let g,E,f;if("source"in a){const L=R==null?void 0:R.get(a.source);if(!L)continue;g=L.paths,E=a.args||L.args,f=a.icon||L.icon}else g=Array.isArray(a.path)?a.path:[a.path],E=P.isWindows||Array.isArray(a.args)?a.args:void 0,f=a.icon;const h=g.slice();for(let L=0;L<h.length;L++)h[L]=await(n==null?void 0:n.resolveAsync(o,h[L]))||h[L];const A=await p(l,h,c,E,a.env,a.overrideName,a.isAutoDetected,t);A?(A.isAutoDetected=a.isAutoDetected,A.icon=f,r.push(A)):t==null||t.trace("profile not validated",l,g)}return r}async function s(){R||(R=new Map,R.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`],args:["--login"]}),R.set("PowerShell",{profileName:"PowerShell",paths:await d(),icon:"terminal-powershell"}))}async function d(){var u,c;const t=[];try{for(var n=rn((0,I.enumeratePowerShellInstallations)()),o;o=await n.next(),!o.done;){const r=o.value;t.push(r.exePath)}}catch(r){u={error:r}}finally{try{o&&!o.done&&(c=n.return)&&await c.call(n)}finally{if(u)throw u.error}}return t}async function S(u,c){const t=[];if(c){const n=await new Promise((o,r)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le"},(l,a)=>{if(l)return r("Problem occurred when getting wsl distros");o(a)})});if(n){const o=new RegExp(/[\r?\n]/),r=n.split(o).filter(l=>l.trim().length>0&&l!=="");for(let l of r)if(l!==""&&!l.startsWith("docker-desktop")){const a={profileName:`${l} (WSL)`,path:u,args:["-d",`${l}`]};l.includes("Debian")?a.icon="terminal-debian":a.icon="terminal-linux",t.push(a)}return t}}return[]}async function v(u,c,t,n,o,r,l){const a=new Map;if(!t){const g=await u.readFile("/etc/shells","utf8"),E=o||g.split(`
`).filter(h=>h.trim().indexOf("#")!==0&&h.trim().length>0),f=new Map;for(const h of E){let A=(0,T.basename)(h),L=f.get(A)||0;L++,L>1&&(A=`${A} (${L})`),f.set(A,L),a.set(A,{path:h,isAutoDetected:!0})}}return b(n,a),await m(a.entries(),u,c,r,l)}function b(u,c){if(!!u)for(const[t,n]of Object.entries(u))n===null||!("path"in n)&&!("source"in n)?c.delete(t):c.set(t,n)}async function p(u,c,t,n,o,r,l,a){if(c.length===0)return Promise.resolve(void 0);const g=c.shift();if(g==="")return p(u,c,t,n,o,r,l);const E={profileName:u,path:g,args:n,env:o,overrideName:r,isAutoDetected:l};if((0,T.basename)(g)===g){const h=process.env.PATH?process.env.PATH.split(T.delimiter):void 0;return await(0,D.findExecutable)(g,void 0,h,void 0,t.existsFile)?E:p(u,c,t,n)}return await t.existsFile((0,T.normalize)(g))?E:p(u,c,t,n,o,r,l)}}),define(ge[121],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var _;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(_=e.TestItemExpandState||(e.TestItemExpandState={}));const P=(y,i)=>{i.expand!==void 0&&(y.expand=i.expand),i.item!==void 0&&Object.assign(y.item,i.item)};e.applyTestItemUpdate=P;var T;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.DeltaRootsComplete=3]="DeltaRootsComplete",y[y.Retire=4]="Retire"})(T=e.TestDiffOpType||(e.TestDiffOpType={}));const I=(y,i)=>`${y}:${i.toString()}`;e.getTestSubscriptionKey=I;class D{add(i){}update(i){}remove(i,R){}complete(){}}e.IncrementalChangeCollector=D;class k{constructor(){this.items=new Map,this.roots=new Set,this.busyProviderCount=0,this.pendingRootCount=0}apply(i){const R=this.createChangeCollector();for(const C of i)switch(C[0]){case 0:{const w=C[1];if(w.parent){if(this.items.has(w.parent)){const m=this.items.get(w.parent);m.children.add(w.item.extId);const s=this.createItem(w,m);this.items.set(w.item.extId,s),R.add(s)}}else{this.roots.add(w.item.extId);const m=this.createItem(w);this.items.set(w.item.extId,m),R.add(m)}w.expand===2&&this.updateBusyProviders(1);break}case 1:{const w=C[1],m=this.items.get(w.extId);if(!m)break;(0,e.applyTestItemUpdate)(m,w),R.update(m),w.expand!==void 0&&m.expand===2&&w.expand!==2&&this.updateBusyProviders(-1);break}case 2:{const w=this.items.get(C[1]);if(!w)break;w.parent?this.items.get(w.parent).children.delete(w.item.extId):this.roots.delete(w.item.extId);const m=[[C[1]]];for(;m.length;)for(const s of m.pop()){const d=this.items.get(s);d&&(m.push(d.children),this.items.delete(s),R.remove(d,d!==w),d.expand===2&&this.updateBusyProviders(-1))}break}case 4:this.retireTest(C[1]);break;case 3:this.updatePendingRoots(C[1]);break}R.complete()}retireTest(i){}updateBusyProviders(i){this.busyProviderCount+=i}updatePendingRoots(i){this.pendingRootCount+=i}createChangeCollector(){return new D}}e.AbstractIncrementalTestCollection=k}),define(ge[212],pe([0,1,8,36,15,23,9,75,174]),function(Q,e,_,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class i{constructor(C,w,m,s){if(this._contributedVariables=new Map,this._context=C,this._labelService=w,m)if(D.isWindows){const d=Object.create(null);this._envVariables=d,Object.keys(m).forEach(S=>{d[S.toLowerCase()]=m[S]})}else this._envVariables=m}resolveWithEnvironment(C,w,m){return this.recursiveResolve(C,w?w.uri:void 0,m)}async resolveAsync(C,w){return this.recursiveResolve(this._envVariables,C?C.uri:void 0,w)}resolve(C,w){return this.recursiveResolve(this._envVariables,C?C.uri:void 0,w)}resolveAnyBase(C,w,m,s){const d=I.deepClone(w);return D.isWindows&&d.windows?Object.keys(d.windows).forEach(S=>d[S]=d.windows[S]):D.isMacintosh&&d.osx?Object.keys(d.osx).forEach(S=>d[S]=d.osx[S]):D.isLinux&&d.linux&&Object.keys(d.linux).forEach(S=>d[S]=d.linux[S]),delete d.windows,delete d.osx,delete d.linux,this.recursiveResolve(this._envVariables,C?C.uri:void 0,d,m,s)}resolveAny(C,w,m){return this.resolveAnyBase(C,w,m)}async resolveAnyAsync(C,w,m){return this.resolveAnyBase(C,w,m)}resolveAnyMap(C,w,m){const s=new Map;return{newConfig:this.resolveAnyBase(C,w,m,s),resolvedVariables:s}}resolveWithInteractionReplace(C,w,m,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,w,m,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,w){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,w)}recursiveResolve(C,w,m,s,d){if(T.isString(m))return this.resolveString(C,w,m,s,d);if(T.isArray(m))return m.map(S=>this.recursiveResolve(C,w,S,s,d));if(T.isObject(m)){let S=Object.create(null);return Object.keys(m).forEach(v=>{const b=this.resolveString(C,w,v,s,d);S[b]=this.recursiveResolve(C,w,m[v],s,d)}),S}return m}resolveString(C,w,m,s,d){return m.replace(i.VARIABLE_REGEXP,(v,b)=>{if(b.includes(i.VARIABLE_LHS))return v;let p=this.evaluateSingleVariable(C,v,b,w,s);return d&&d.set(b,p),p})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,w,m,s,d){let S;const v=m.split(":");v.length>1&&(m=v[0],S=v[1]);const b=()=>{const c=this._context.getFilePath();if(c)return c;throw new Error((0,y.localize)(0,null,w))},p=()=>{const c=b();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,w,_.basename(c)))},u=()=>{if(S){const c=this._context.getFolderUri(S);if(c)return c;throw new Error((0,y.localize)(2,null,w,S))}if(s)return s;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,w)):new Error((0,y.localize)(4,null,w))};switch(m){case"env":if(S){if(C){const c=C[D.isWindows?S.toLowerCase():S];if(T.isString(c))return c}return""}throw new Error((0,y.localize)(5,null,w));case"config":if(S){const c=this._context.getConfigurationValue(s,S);if(T.isUndefinedOrNull(c))throw new Error((0,y.localize)(6,null,w,S));if(T.isObject(c))throw new Error((0,y.localize)(7,null,w,S));return c}throw new Error((0,y.localize)(8,null,w));case"command":return this.resolveFromMap(w,S,d,"command");case"input":return this.resolveFromMap(w,S,d,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(u()));case"cwd":return s||S?(0,k.normalizeDriveLetter)(this.fsPath(u())):P.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return _.basename(this.fsPath(u()));case"lineNumber":const c=this._context.getLineNumber();if(c)return c;throw new Error((0,y.localize)(9,null,w));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,w));case"file":return b();case"fileWorkspaceFolder":return p();case"relativeFile":return s||S?_.relative(this.fsPath(u()),b()):b();case"relativeFileDirname":const n=_.dirname(b());if(s||S){const a=_.relative(this.fsPath(u()),n);return a.length===0?".":a}return n;case"fileDirname":return _.dirname(b());case"fileExtname":return _.extname(b());case"fileBasename":return _.basename(b());case"fileBasenameNoExtension":const o=_.basename(b());return o.slice(0,o.length-_.extname(o).length);case"fileDirnameBasename":return _.basename(_.dirname(b()));case"execPath":const r=this._context.getExecPath();return r||w;case"execInstallFolder":const l=this._context.getAppRoot();return l||w;case"pathSeparator":return _.sep;default:try{const a=S?`${m}:${S}`:m;return this.resolveFromMap(w,a,d,void 0)}catch(a){return w}}}}resolveFromMap(C,w,m,s){if(w&&m){const d=s===void 0?m[w]:m[s+":"+w];if(typeof d=="string")return d;throw new Error((0,y.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=i,i.VARIABLE_LHS="${",i.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[213],pe([0,1,4]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,_.createDecorator)("editorGroupsService");var P;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(P=e.GroupDirection||(e.GroupDirection={}));var T;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var D;(function(w){w[w.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var k;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(k=e.MergeGroupMode||(e.MergeGroupMode={}));var y;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y=e.GroupsOrder||(e.GroupsOrder={}));var i;(function(w){w[w.GROUP_ACTIVE=0]="GROUP_ACTIVE",w[w.GROUP_INDEX=1]="GROUP_INDEX",w[w.EDITOR_OPEN=2]="EDITOR_OPEN",w[w.EDITOR_CLOSE=3]="EDITOR_CLOSE",w[w.EDITOR_MOVE=4]="EDITOR_MOVE",w[w.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",w[w.EDITOR_LABEL=6]="EDITOR_LABEL",w[w.EDITOR_PIN=7]="EDITOR_PIN",w[w.EDITOR_STICKY=8]="EDITOR_STICKY",w[w.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(i=e.GroupChangeKind||(e.GroupChangeKind={}));var R;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(R=e.OpenEditorContext||(e.OpenEditorContext={}));function C(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(ge[214],pe([0,1,4]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,_.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ge[20],pe([0,1,14,95,285,57,23,15,2,44,79,175,111,86,214,7]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var S;(function(ue){function Ce(G){const{selectionStartLineNumber:Ue,selectionStartColumn:Te,positionLineNumber:Xe,positionColumn:Ge}=G,lt=new d.Position(Ue-1,Te-1),at=new d.Position(Xe-1,Ge-1);return new d.Selection(lt,at)}ue.to=Ce;function ce(G){const{anchor:Ue,active:Te}=G;return{selectionStartLineNumber:Ue.line+1,selectionStartColumn:Ue.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}ue.from=ce})(S=e.Selection||(e.Selection={}));var v;(function(ue){function Ce(G){if(!!G){const{start:Ue,end:Te}=G;return{startLineNumber:Ue.line+1,startColumn:Ue.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}}ue.from=Ce;function ce(G){if(!!G){const{startLineNumber:Ue,startColumn:Te,endLineNumber:Xe,endColumn:Ge}=G;return new d.Range(Ue-1,Te-1,Xe-1,Ge-1)}}ue.to=ce})(v=e.Range||(e.Range={}));var b;(function(ue){function Ce(ce){switch(ce){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 4:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}ue.to=Ce})(b=e.TokenType||(e.TokenType={}));var p;(function(ue){function Ce(G){return new d.Position(G.lineNumber-1,G.column-1)}ue.to=Ce;function ce(G){return{lineNumber:G.line+1,column:G.character+1}}ue.from=ce})(p=e.Position||(e.Position={}));var u;(function(ue){function Ce(G){switch(G){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}ue.from=Ce;function ce(G){switch(G){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}ue.to=ce})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(ue){function Ce(G){let Ue;return G.code&&((0,k.isString)(G.code)||(0,k.isNumber)(G.code)?Ue=String(G.code):Ue={value:String(G.code.value),target:G.code.target}),Object.assign(Object.assign({},v.from(G.range)),{message:G.message,source:G.source,code:Ue,severity:n.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(t.from),tags:Array.isArray(G.tags)?(0,_.coalesce)(G.tags.map(u.from)):void 0})}ue.from=Ce;function ce(G){var Ue;const Te=new d.Diagnostic(v.to(G),G.message,n.to(G.severity));return Te.source=G.source,Te.code=(0,k.isString)(G.code)?G.code:(Ue=G.code)===null||Ue===void 0?void 0:Ue.value,Te.relatedInformation=G.relatedInformation&&G.relatedInformation.map(t.to),Te.tags=G.tags&&(0,_.coalesce)(G.tags.map(u.to)),Te}ue.to=ce})(c=e.Diagnostic||(e.Diagnostic={}));var t;(function(ue){function Ce(G){return Object.assign(Object.assign({},v.from(G.location.range)),{message:G.message,resource:G.location.uri})}ue.from=Ce;function ce(G){return new d.DiagnosticRelatedInformation(new d.Location(G.resource,v.to(G)),G.message)}ue.to=ce})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(ue){function Ce(G){switch(G){case d.DiagnosticSeverity.Error:return w.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return w.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return w.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return w.MarkerSeverity.Hint}return w.MarkerSeverity.Error}ue.from=Ce;function ce(G){switch(G){case w.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case w.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case w.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case w.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}ue.to=ce})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var o;(function(ue){function Ce(G){return typeof G=="number"&&G>=d.ViewColumn.One?G-1:G===d.ViewColumn.Beside?s.SIDE_GROUP:s.ACTIVE_GROUP}ue.from=Ce;function ce(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}ue.to=ce})(o=e.ViewColumn||(e.ViewColumn={}));function r(ue){return typeof ue.range!="undefined"}function l(ue){return ue.length===0?!0:!!r(ue[0])}e.isDecorationOptionsArr=l;var a;(function(ue){function Ce(Ge){return Ge.map(ue.from)}ue.fromMany=Ce;function ce(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function G(Ge){let lt;if(ce(Ge)){const{language:ut,value:pt}=Ge;lt={value:"```"+ut+`
`+pt+"\n```\n"}}else d.MarkdownString.isMarkdownString(Ge)?lt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons}:typeof Ge=="string"?lt={value:Ge}:lt={value:""};const at=Object.create(null);lt.uris=at;const Qe=ut=>{try{let pt=y.URI.parse(ut,!0);pt=pt.with({query:Ue(pt.query,at)}),at[ut]=pt}catch(pt){}return""},st=new T.Renderer;return st.link=Qe,st.image=ut=>Qe(P.parseHrefAndDimensions(ut).href),T(lt.value,{renderer:st}),lt}ue.from=G;function Ue(Ge,lt){if(!Ge)return Ge;let at;try{at=(0,I.parse)(Ge)}catch(st){}if(!at)return Ge;let Qe=!1;return at=(0,D.cloneAndChange)(at,st=>{if(y.URI.isUri(st)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[ut]=st,Qe=!0,ut}else return}),Qe?JSON.stringify(at):Ge}function Te(Ge){const lt=new d.MarkdownString(Ge.value,Ge.supportThemeIcons);return lt.isTrusted=Ge.isTrusted,lt}ue.to=Te;function Xe(Ge){if(!!Ge)return typeof Ge=="string"?Ge:ue.from(Ge)}ue.fromStrict=Xe})(a=e.MarkdownString||(e.MarkdownString={}));function g(ue){return l(ue)?ue.map(Ce=>({range:v.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?a.fromMany(Ce.hoverMessage):Ce.hoverMessage?a.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):ue.map(Ce=>({range:v.from(Ce)}))}e.fromRangeOrRangeWithMessage=g;function E(ue){return typeof ue=="undefined"?ue:typeof ue=="string"?y.URI.file(ue):ue}e.pathOrURIToURI=E;var f;(function(ue){function Ce(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?E(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}ue.from=Ce})(f=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var h;(function(ue){function Ce(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?E(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?f.from(ce.before):void 0,after:ce.after?f.from(ce.after):void 0}}ue.from=Ce})(h=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var A;(function(ue){function Ce(ce){if(typeof ce=="undefined")return ce;switch(ce){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}ue.from=Ce})(A=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(ue){function Ce(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?A.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?h.from(ce.light):void 0,dark:ce.dark?h.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?E(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?f.from(ce.before):void 0,after:ce.after?f.from(ce.after):void 0}}ue.from=Ce})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var B;(function(ue){function Ce(G){return{text:G.newText,eol:G.newEol&&re.from(G.newEol),range:v.from(G.range)}}ue.from=Ce;function ce(G){const Ue=new d.TextEdit(v.to(G.range),G.text);return Ue.newEol=typeof G.eol=="undefined"?void 0:re.to(G.eol),Ue}ue.to=ce})(B=e.TextEdit||(e.TextEdit={}));var ee;(function(ue){function Ce(G,Ue,Te){var Xe,Ge,lt;const at={edits:[]};if(G instanceof d.WorkspaceEdit)for(let Qe of G._allEntries())if(Qe._type===1)at.edits.push({_type:1,oldUri:Qe.from,newUri:Qe.to,options:Qe.options,metadata:Qe.metadata});else if(Qe._type===2){const st=Ue==null?void 0:Ue.getDocument(Qe.uri);at.edits.push({_type:2,resource:Qe.uri,edit:B.from(Qe.edit),modelVersionId:st==null?void 0:st.version,metadata:Qe.metadata})}else Qe._type===3?at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:(Xe=Te==null?void 0:Te.lookupNotebookDocument(Qe.uri))===null||Xe===void 0?void 0:Xe.notebookDocument.version}):Qe._type===4?(Qe.newOutputs&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:2,index:Qe.index,append:Qe.append,outputs:Qe.newOutputs.map(We.from)}}),Qe.newMetadata&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:11,index:Qe.index,metadata:Qe.newMetadata}})):Qe._type===5?at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:(Ge=Te==null?void 0:Te.lookupNotebookDocument(Qe.uri))===null||Ge===void 0?void 0:Ge.notebookDocument.version,edit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(ve.from)}}):Qe._type===6&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:10,outputId:Qe.outputId,items:((lt=Qe.newOutputItems)===null||lt===void 0?void 0:lt.map(ye.from))||[],append:Qe.append}});return at}ue.from=Ce;function ce(G){const Ue=new d.WorkspaceEdit;for(const Te of G.edits)Te.edit?Ue.replace(y.URI.revive(Te.resource),v.to(Te.edit.range),Te.edit.text):Ue.renameFile(y.URI.revive(Te.oldUri),y.URI.revive(Te.newUri),Te.options);return Ue}ue.to=ce})(ee=e.WorkspaceEdit||(e.WorkspaceEdit={}));var j;(function(ue){const Ce=Object.create(null);Ce[d.SymbolKind.File]=0,Ce[d.SymbolKind.Module]=1,Ce[d.SymbolKind.Namespace]=2,Ce[d.SymbolKind.Package]=3,Ce[d.SymbolKind.Class]=4,Ce[d.SymbolKind.Method]=5,Ce[d.SymbolKind.Property]=6,Ce[d.SymbolKind.Field]=7,Ce[d.SymbolKind.Constructor]=8,Ce[d.SymbolKind.Enum]=9,Ce[d.SymbolKind.Interface]=10,Ce[d.SymbolKind.Function]=11,Ce[d.SymbolKind.Variable]=12,Ce[d.SymbolKind.Constant]=13,Ce[d.SymbolKind.String]=14,Ce[d.SymbolKind.Number]=15,Ce[d.SymbolKind.Boolean]=16,Ce[d.SymbolKind.Array]=17,Ce[d.SymbolKind.Object]=18,Ce[d.SymbolKind.Key]=19,Ce[d.SymbolKind.Null]=20,Ce[d.SymbolKind.EnumMember]=21,Ce[d.SymbolKind.Struct]=22,Ce[d.SymbolKind.Event]=23,Ce[d.SymbolKind.Operator]=24,Ce[d.SymbolKind.TypeParameter]=25;function ce(Ue){return typeof Ce[Ue]=="number"?Ce[Ue]:6}ue.from=ce;function G(Ue){for(const Te in Ce)if(Ce[Te]===Ue)return Number(Te);return d.SymbolKind.Property}ue.to=G})(j=e.SymbolKind||(e.SymbolKind={}));var x;(function(ue){function Ce(G){switch(G){case d.SymbolTag.Deprecated:return 1}}ue.from=Ce;function ce(G){switch(G){case 1:return d.SymbolTag.Deprecated}}ue.to=ce})(x=e.SymbolTag||(e.SymbolTag={}));var $;(function(ue){function Ce(G){return{name:G.name,kind:j.from(G.kind),tags:G.tags&&G.tags.map(x.from),containerName:G.containerName,location:O.from(G.location)}}ue.from=Ce;function ce(G){const Ue=new d.SymbolInformation(G.name,j.to(G.kind),G.containerName,O.to(G.location));return Ue.tags=G.tags&&G.tags.map(x.to),Ue}ue.to=ce})($=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var F;(function(ue){function Ce(G){var Ue,Te;const Xe={name:G.name||"!!MISSING: name!!",detail:G.detail,range:v.from(G.range),selectionRange:v.from(G.selectionRange),kind:j.from(G.kind),tags:(Te=(Ue=G.tags)===null||Ue===void 0?void 0:Ue.map(x.from))!==null&&Te!==void 0?Te:[]};return G.children&&(Xe.children=G.children.map(Ce)),Xe}ue.from=Ce;function ce(G){const Ue=new d.DocumentSymbol(G.name,G.detail,j.to(G.kind),v.to(G.range),v.to(G.selectionRange));return(0,_.isNonEmptyArray)(G.tags)&&(Ue.tags=G.tags.map(x.to)),G.children&&(Ue.children=G.children.map(ce)),Ue}ue.to=ce})(F=e.DocumentSymbol||(e.DocumentSymbol={}));var U;(function(ue){function Ce(ce){const G=new d.CallHierarchyItem(j.to(ce.kind),ce.name,ce.detail||"",y.URI.revive(ce.uri),v.to(ce.range),v.to(ce.selectionRange));return G._sessionId=ce._sessionId,G._itemId=ce._itemId,G}ue.to=Ce})(U=e.CallHierarchyItem||(e.CallHierarchyItem={}));var M;(function(ue){function Ce(ce){return new d.CallHierarchyIncomingCall(U.to(ce.from),ce.fromRanges.map(G=>v.to(G)))}ue.to=Ce})(M=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var N;(function(ue){function Ce(ce){return new d.CallHierarchyOutgoingCall(U.to(ce.to),ce.fromRanges.map(G=>v.to(G)))}ue.to=Ce})(N=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var O;(function(ue){function Ce(G){return{range:G.range&&v.from(G.range),uri:G.uri}}ue.from=Ce;function ce(G){return new d.Location(y.URI.revive(G.uri),v.to(G.range))}ue.to=ce})(O=e.location||(e.location={}));var V;(function(ue){function Ce(G){const Ue=G,Te=G;return{originSelectionRange:Ue.originSelectionRange?v.from(Ue.originSelectionRange):void 0,uri:Ue.targetUri?Ue.targetUri:Te.uri,range:v.from(Ue.targetRange?Ue.targetRange:Te.range),targetSelectionRange:Ue.targetSelectionRange?v.from(Ue.targetSelectionRange):void 0}}ue.from=Ce;function ce(G){return{targetUri:y.URI.revive(G.uri),targetRange:v.to(G.range),targetSelectionRange:G.targetSelectionRange?v.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?v.to(G.originSelectionRange):void 0}}ue.to=ce})(V=e.DefinitionLink||(e.DefinitionLink={}));var q;(function(ue){function Ce(G){return{range:v.from(G.range),contents:a.fromMany(G.contents)}}ue.from=Ce;function ce(G){return new d.Hover(G.contents.map(a.to),v.to(G.range))}ue.to=ce})(q=e.Hover||(e.Hover={}));var J;(function(ue){function Ce(G){return{range:v.from(G.range),expression:G.expression}}ue.from=Ce;function ce(G){return new d.EvaluatableExpression(v.to(G.range),G.expression)}ue.to=ce})(J=e.EvaluatableExpression||(e.EvaluatableExpression={}));var me;(function(ue){function Ce(G){if(G instanceof d.InlineValueText)return{type:"text",range:v.from(G.range),text:G.text};if(G instanceof d.InlineValueVariableLookup)return{type:"variable",range:v.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:v.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}ue.from=Ce;function ce(G){switch(G.type){case"text":return{range:v.to(G.range),text:G.text};case"variable":return{range:v.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:v.to(G.range),expression:G.expression}}}ue.to=ce})(me=e.InlineValue||(e.InlineValue={}));var we;(function(ue){function Ce(G){return{frameId:G.frameId,stoppedLocation:v.from(G.stoppedLocation)}}ue.from=Ce;function ce(G){return new d.InlineValueContext(G.frameId,v.to(G.stoppedLocation))}ue.to=ce})(we=e.InlineValueContext||(e.InlineValueContext={}));var Ae;(function(ue){function Ce(G){return{range:v.from(G.range),kind:G.kind}}ue.from=Ce;function ce(G){return new d.DocumentHighlight(v.to(G.range),G.kind)}ue.to=ce})(Ae=e.DocumentHighlight||(e.DocumentHighlight={}));var Pe;(function(ue){function Ce(ce){switch(ce){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}ue.to=Ce})(Pe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Fe;(function(ue){function Ce(ce){return{triggerKind:Pe.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}ue.to=Ce})(Fe=e.CompletionContext||(e.CompletionContext={}));var z;(function(ue){function Ce(G){switch(G){case d.CompletionItemTag.Deprecated:return 1}}ue.from=Ce;function ce(G){switch(G){case 1:return d.CompletionItemTag.Deprecated}}ue.to=ce})(z=e.CompletionItemTag||(e.CompletionItemTag={}));var Y;(function(ue){const Ce=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function ce(Te){var Xe;return(Xe=Ce.get(Te))!==null&&Xe!==void 0?Xe:9}ue.from=ce;const G=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Ue(Te){var Xe;return(Xe=G.get(Te))!==null&&Xe!==void 0?Xe:d.CompletionItemKind.Property}ue.to=Ue})(Y=e.CompletionItemKind||(e.CompletionItemKind={}));var te;(function(ue){function Ce(ce,G){var Ue;const Te=new d.CompletionItem(typeof ce.label=="string"?ce.label:ce.label.name);return typeof ce.label!="string"&&(Te.label2=ce.label),Te.insertText=ce.insertText,Te.kind=Y.to(ce.kind),Te.tags=(Ue=ce.tags)===null||Ue===void 0?void 0:Ue.map(z.to),Te.detail=ce.detail,Te.documentation=P.isMarkdownString(ce.documentation)?a.to(ce.documentation):ce.documentation,Te.sortText=ce.sortText,Te.filterText=ce.filterText,Te.preselect=ce.preselect,Te.commitCharacters=ce.commitCharacters,i.Range.isIRange(ce.range)?Te.range=v.to(ce.range):typeof ce.range=="object"&&(Te.range={inserting:v.to(ce.range.insert),replacing:v.to(ce.range.replace)}),Te.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?Te.insertText=new d.SnippetString(ce.insertText):(Te.insertText=ce.insertText,Te.textEdit=Te.range instanceof d.Range?new d.TextEdit(Te.range,Te.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Te.additionalTextEdits=ce.additionalTextEdits.map(Xe=>B.to(Xe))),Te.command=G&&ce.command?G.fromInternal(ce.command):void 0,Te}ue.to=Ce})(te=e.CompletionItem||(e.CompletionItem={}));var ae;(function(ue){function Ce(G){return{label:G.label,documentation:G.documentation?a.fromStrict(G.documentation):void 0}}ue.from=Ce;function ce(G){return{label:G.label,documentation:P.isMarkdownString(G.documentation)?a.to(G.documentation):G.documentation}}ue.to=ce})(ae=e.ParameterInformation||(e.ParameterInformation={}));var fe;(function(ue){function Ce(G){return{label:G.label,documentation:G.documentation?a.fromStrict(G.documentation):void 0,parameters:Array.isArray(G.parameters)?G.parameters.map(ae.from):[],activeParameter:G.activeParameter}}ue.from=Ce;function ce(G){return{label:G.label,documentation:P.isMarkdownString(G.documentation)?a.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(ae.to):[],activeParameter:G.activeParameter}}ue.to=ce})(fe=e.SignatureInformation||(e.SignatureInformation={}));var De;(function(ue){function Ce(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(fe.from):[]}}ue.from=Ce;function ce(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(fe.to):[]}}ue.to=ce})(De=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(ue){function Ce(G){var Ue;return{text:G.text,range:v.from(G.range),kind:be.from((Ue=G.kind)!==null&&Ue!==void 0?Ue:d.InlineHintKind.Other),description:G.description&&a.fromStrict(G.description),whitespaceBefore:G.whitespaceBefore,whitespaceAfter:G.whitespaceAfter}}ue.from=Ce;function ce(G){const Ue=new d.InlineHint(G.text,v.to(G.range),be.to(G.kind));return Ue.whitespaceAfter=G.whitespaceAfter,Ue.whitespaceBefore=G.whitespaceBefore,Ue.description=P.isMarkdownString(G.description)?a.to(G.description):G.description,Ue}ue.to=ce})(Me=e.InlineHint||(e.InlineHint={}));var be;(function(ue){function Ce(G){return G}ue.from=Ce;function ce(G){return G}ue.to=ce})(be=e.InlineHintKind||(e.InlineHintKind={}));var ke;(function(ue){function Ce(G){return{range:v.from(G.range),url:G.target,tooltip:G.tooltip}}ue.from=Ce;function ce(G){let Ue;if(G.url)try{Ue=typeof G.url=="string"?y.URI.parse(G.url,!0):y.URI.revive(G.url)}catch(Te){}return new d.DocumentLink(v.to(G.range),Ue)}ue.to=ce})(ke=e.DocumentLink||(e.DocumentLink={}));var Re;(function(ue){function Ce(G){const Ue=new d.ColorPresentation(G.label);return G.textEdit&&(Ue.textEdit=B.to(G.textEdit)),G.additionalTextEdits&&(Ue.additionalTextEdits=G.additionalTextEdits.map(Te=>B.to(Te))),Ue}ue.to=Ce;function ce(G){return{label:G.label,textEdit:G.textEdit?B.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Ue=>B.from(Ue)):void 0}}ue.from=ce})(Re=e.ColorPresentation||(e.ColorPresentation={}));var Be;(function(ue){function Ce(G){return new d.Color(G[0],G[1],G[2],G[3])}ue.to=Ce;function ce(G){return[G.red,G.green,G.blue,G.alpha]}ue.from=ce})(Be=e.Color||(e.Color={}));var Ee;(function(ue){function Ce(G){return{range:v.from(G.range)}}ue.from=Ce;function ce(G){return new d.SelectionRange(v.to(G.range))}ue.to=ce})(Ee=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(ue){function Ce(ce){switch(ce){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}ue.to=Ce})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var X;(function(ue){function Ce(G){switch(G){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}ue.from=Ce;function ce(G){switch(G){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}ue.to=ce})(X=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var re;(function(ue){function Ce(G){if(G===d.EndOfLine.CRLF)return 1;if(G===d.EndOfLine.LF)return 0}ue.from=Ce;function ce(G){if(G===1)return d.EndOfLine.CRLF;if(G===0)return d.EndOfLine.LF}ue.to=ce})(re=e.EndOfLine||(e.EndOfLine={}));var _e;(function(ue){function Ce(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ue.from=Ce})(_e=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(ue){function Ce(ce){const G={start:ce.start+1,end:ce.end+1};return ce.kind&&(G.kind=Ve.from(ce.kind)),G}ue.from=Ce})(Ne=e.FoldingRange||(e.FoldingRange={}));var Ve;(function(ue){function Ce(ce){if(ce)switch(ce){case d.FoldingRangeKind.Comment:return R.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return R.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return R.FoldingRangeKind.Region}}ue.from=Ce})(Ve=e.FoldingRangeKind||(e.FoldingRangeKind={}));var $e;(function(ue){function Ce(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?v.from(ce.selection):void 0,override:typeof ce.override=="boolean"?C.EditorOverride.DISABLED:void 0}}ue.from=Ce})($e=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ze;(function(ue){function Ce(G){return G instanceof d.RelativePattern||typeof G=="string"?G:ce(G)?new d.RelativePattern(G.base,G.pattern):G}ue.from=Ce;function ce(G){const Ue=G;return Ue&&typeof Ue.base=="string"&&typeof Ue.pattern=="string"}})(Ze=e.GlobPattern||(e.GlobPattern={}));var K;(function(ue){function Ce(ce){if(ce){if(Array.isArray(ce))return ce.map(Ce);if(typeof ce=="string")return ce;{const G=ce;return{language:G.language,scheme:G.scheme,pattern:typeof G.pattern=="undefined"?void 0:Ze.from(G.pattern),exclusive:G.exclusive}}}else return}ue.from=Ce})(K=e.LanguageSelector||(e.LanguageSelector={}));var oe;(function(ue){function Ce(G){return{start:G.start,end:G.end}}ue.from=Ce;function ce(G){return new d.NotebookCellRange(G.start,G.end)}ue.to=ce})(oe=e.NotebookCellRange||(e.NotebookCellRange={}));var he;(function(ue){function Ce(ce){return new d.NotebookCellMetadata(ce.editable,ce.breakpointMargin,ce.statusMessage,ce.inputCollapsed,ce.outputCollapsed,ce.custom)}ue.to=Ce})(he=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var Z;(function(ue){function Ce(G){return G}ue.from=Ce;function ce(G){return new d.NotebookDocumentMetadata(G.editable,G.cellEditable,G.custom,G.trusted)}ue.to=ce})(Z=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ie;(function(ue){function Ce(G){return{duration:G.lastRunDuration,executionOrder:G.executionOrder,success:G.lastRunSuccess}}ue.to=Ce;function ce(G){return{lastRunSuccess:G.success,lastRunDuration:G.duration,executionOrder:G.executionOrder}}ue.from=ce})(ie=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var le;(function(ue){function Ce(G){switch(G){case d.NotebookCellKind.Markdown:return m.CellKind.Markdown;case d.NotebookCellKind.Code:default:return m.CellKind.Code}}ue.from=Ce;function ce(G){switch(G){case m.CellKind.Markdown:return d.NotebookCellKind.Markdown;case m.CellKind.Code:default:return d.NotebookCellKind.Code}}ue.to=ce})(le=e.NotebookCellKind||(e.NotebookCellKind={}));var ve;(function(ue){function Ce(G){var Ue;return{cellKind:le.from(G.kind),language:G.language,source:G.source,metadata:Object.assign(Object.assign({},G.metadata),ie.from((Ue=G.latestExecutionSummary)!==null&&Ue!==void 0?Ue:{})),outputs:G.outputs?G.outputs.map(We.from):[]}}ue.from=Ce;function ce(G){return new d.NotebookCellData(le.to(G.cellKind),G.source,G.language,G.outputs?G.outputs.map(We.to):void 0,G.metadata?he.to(G.metadata):void 0)}ue.to=ce})(ve=e.NotebookCellData||(e.NotebookCellData={}));var ye;(function(ue){function Ce(G){return{mime:G.mime,value:G.value,metadata:G.metadata}}ue.from=Ce;function ce(G){return new d.NotebookCellOutputItem(G.mime,G.value,G.metadata)}ue.to=ce})(ye=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var We;(function(ue){function Ce(G){return{outputId:G.id,outputs:G.outputs.map(ye.from),metadata:G.metadata}}ue.from=Ce;function ce(G){const Ue=G.outputs.map(ye.to);return new d.NotebookCellOutput(Ue,G.outputId,G.metadata)}ue.to=ce})(We=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Oe;(function(ue){function Ce(Te){if(Te!=null){if(Te instanceof d.RelativePattern||typeof Te=="string")return Te;if(Ue(Te))return new d.RelativePattern(Te.base,Te.pattern);if(G(Te))return{include:Ze.from(Te.include)||void 0,exclude:Ze.from(Te.exclude)||void 0}}}ue.from=Ce;function ce(Te){return typeof Te=="string"?Te:Ue(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}ue.to=ce;function G(Te){const Xe=Te,Ge=Ze.from(Xe.include);if(!(Ge&&Ge instanceof d.RelativePattern||typeof Ge=="string"))return!1;const lt=Ze.from(Xe.exclude);return!!(lt&&lt instanceof d.RelativePattern||typeof lt=="string")}function Ue(Te){const Xe=Te;return Xe&&typeof Xe.base=="string"&&typeof Xe.pattern=="string"}})(Oe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var qe;(function(ue){function Ce(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?f.from(ce.top):void 0}}ue.from=Ce})(qe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ye;(function(ue){function Ce(ce,G,Ue){const Te=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Te,Ue),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}ue.from=Ce})(Ye=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var tt;(function(ue){function Ce(ce){var G;return{transientOutputs:(G=ce==null?void 0:ce.transientOutputs)!==null&&G!==void 0?G:!1,transientMetadata:Object.assign(Object.assign({},ce==null?void 0:ce.transientMetadata),{executionOrder:!0,lastRunDuration:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,lastRunSuccess:!0})}}ue.from=Ce})(tt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var nt;(function(ue){function Ce(G){return{message:a.fromStrict(G.message)||"",severity:G.severity,expectedOutput:G.expectedOutput,actualOutput:G.actualOutput,location:G.location?O.from(G.location):void 0}}ue.from=Ce;function ce(G){const Ue=new d.TestMessage(typeof G.message=="string"?G.message:a.to(G.message));return Ue.severity=G.severity,Ue.actualOutput=G.actualOutput,Ue.expectedOutput=G.expectedOutput,Ue}ue.to=ce})(nt=e.TestMessage||(e.TestMessage={}));var rt;(function(ue){function Ce(Te){var Xe,Ge;return{extId:Te.id,label:Te.label,uri:Te.uri,range:v.from(Te.range),debuggable:(Xe=Te.debuggable)!==null&&Xe!==void 0?Xe:!1,description:Te.description,runnable:(Ge=Te.runnable)!==null&&Ge!==void 0?Ge:!0,expandable:Te.expandable}}ue.from=Ce;function ce(Te){return{extId:Te.id,label:Te.label,uri:Te.uri,range:v.from(Te.range),debuggable:!1,description:Te.description,runnable:!0,expandable:!0}}ue.fromResultSnapshot=ce;function G(Te){return{id:Te.extId,label:Te.label,uri:y.URI.revive(Te.uri),range:v.to(Te.range),expandable:Te.expandable,debuggable:Te.debuggable,description:Te.description,runnable:Te.runnable}}ue.toPlain=G;function Ue(Te){const Xe=new d.TestItem(Te.extId,Te.label,y.URI.revive(Te.uri),Te.expandable);return Xe.range=v.to(Te.range),Xe.debuggable=Te.debuggable,Xe.description=Te.description,Xe.runnable=Te.runnable,Xe}ue.to=Ue})(rt=e.TestItem||(e.TestItem={}));var it;(function(ue){function Ce(Ue,Te){var Xe,Ge,lt;const at={completedAt:Te.completedAt,id:Ue,output:Te.output,items:[]},Qe=[[null,Te.results]];for(;Qe.length;){const[st,ut]=Qe.pop();for(const pt of ut){const vt={children:(Ge=(Xe=pt.children)===null||Xe===void 0?void 0:Xe.map(wt=>wt.id))!==null&&Ge!==void 0?Ge:[],computedState:pt.state,item:rt.fromResultSnapshot(pt),state:{state:pt.state,duration:pt.duration,messages:pt.messages.map(nt.from)},retired:void 0,expand:3,parent:(lt=st==null?void 0:st.item.extId)!==null&&lt!==void 0?lt:null,src:{provider:"",tree:-1},direct:!st};at.items.push(vt),pt.children&&Qe.push([vt,pt.children])}}return at}ue.from=Ce;const ce=(Ue,Te)=>Object.assign(Object.assign({},rt.toPlain(Ue.item)),{state:Ue.state.state,duration:Ue.state.duration,messages:Ue.state.messages.map(nt.to),children:Ue.children.map(Xe=>Te.get(Xe)).filter(k.isDefined).map(Xe=>ce(Xe,Te))});function G(Ue){const Te=[],Xe=new Map;for(const Ge of Ue.items)Xe.set(Ge.item.extId,Ge),Ge.direct&&Te.push(Ge);return{completedAt:Ue.completedAt,results:Te.map(Ge=>ce(Ge,Xe))}}ue.to=G})(it=e.TestResults||(e.TestResults={}));var gt;(function(ue){function Ce(ce){switch(ce){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}ue.to=Ce})(gt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ge[215],pe([0,1,2,18,7,20,55]),function(Q,e,_,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(i,R,C,w={timeout:1500,errors:3}){this._logService=i,this._documents=R,this._mainThreadBulkEdits=C,this._thresholds=w,this._callbacks=new D.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(i){return(R,C,w)=>{const s={dispose:this._callbacks.push([R,C,i])};return Array.isArray(w)&&w.push(s),s}}async $participateInSave(i,R){const C=_.URI.revive(i);let w=!1;const m=setTimeout(()=>w=!0,this._thresholds.timeout),s=[];try{for(let d of[...this._callbacks]){if(w)break;const S=this._documents.getDocument(C),v=await this._deliverEventAsyncAndBlameBadListeners(d,{document:S,reason:I.TextDocumentSaveReason.to(R)});s.push(v)}}finally{clearTimeout(m)}return s}_deliverEventAsyncAndBlameBadListeners([i,R,C],w){const m=this._badListeners.get(i);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,i,R,w).then(()=>!0,s=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const d=this._badListeners.get(i);this._badListeners.set(i,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(i,R,C,w){const m=[],s=Date.now(),{document:d,reason:S}=w,{version:v}=d,b=Object.freeze({document:d,reason:S,waitUntil(p){if(Object.isFrozen(m))throw(0,P.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(p))}});try{R.apply(C,[b])}catch(p){return Promise.reject(p)}return Object.freeze(m),new Promise((p,u)=>{const c=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${i.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(c),p(t)}).catch(t=>{clearTimeout(c),u(t)})}).then(p=>{const u={edits:[]};for(const c of p)if(Array.isArray(c)&&c.every(t=>t instanceof T.TextEdit))for(const{newText:t,newEol:n,range:o}of c)u.edits.push({_type:2,resource:d.uri,edit:{range:o&&I.Range.from(o),text:t,eol:n&&I.EndOfLine.from(n)}});if(u.edits.length!==0)return v===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(ge[216],pe([0,1,3,19,33,2,20,7]),function(Q,e,_,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(C,w,m,s,d){this._onDidCreate=new _.Emitter,this._onDidChange=new _.Emitter,this._onDidDelete=new _.Emitter,this._config=0,m&&(this._config+=1),s&&(this._config+=2),d&&(this._config+=4);const S=(0,T.parse)(w),v=C(b=>{if(!m)for(let p of b.created){const u=I.URI.revive(p);S(u.fsPath)&&this._onDidCreate.fire(u)}if(!s)for(let p of b.changed){const u=I.URI.revive(p);S(u.fsPath)&&this._onDidChange.fire(u)}if(!d)for(let p of b.deleted){const u=I.URI.revive(p);S(u.fsPath)&&this._onDidDelete.fire(u)}});this._disposable=k.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class i{constructor(C,w,m){this._logService=w,this._extHostDocumentsAndEditors=m,this._onFileSystemEvent=new _.Emitter,this._onDidRenameFile=new _.Emitter,this._onDidCreateFile=new _.Emitter,this._onDidDeleteFile=new _.Emitter,this._onWillRenameFile=new P.AsyncEmitter,this._onWillCreateFile=new P.AsyncEmitter,this._onWillDeleteFile=new P.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,w,m,s){return new y(this._onFileSystemEvent.event,C,w,m,s)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,w){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:w.map(m=>({oldUri:I.URI.revive(m.source),newUri:I.URI.revive(m.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:w.map(m=>I.URI.revive(m.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:w.map(m=>I.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,w){return(m,s,d)=>{const S=function(b){m.call(s,b)};return S.extension=C,w.event(S,void 0,d)}}async $onWillRunFileOperation(C,w,m,s){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:w.map(d=>({oldUri:I.URI.revive(d.source),newUri:I.URI.revive(d.target)}))},m,s);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:w.map(d=>I.URI.revive(d.target))},m,s);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:w.map(d=>I.URI.revive(d.target))},m,s)}}async _fireWillEvent(C,w,m,s){const d=new Set,S=[];if(await C.fireAsync(w,s,async(b,p)=>{var u;const c=Date.now(),t=await Promise.resolve(b);t instanceof k.WorkspaceEdit&&(S.push(t),d.add((u=p.extension.displayName)!==null&&u!==void 0?u:p.extension.identifier.value)),Date.now()-c>m&&this._logService.warn("SLOW file-participant",p.extension.identifier)}),!s.isCancellationRequested&&S.length!==0){const v={edits:[]};for(let b of S){let{edits:p}=D.WorkspaceEdit.from(b,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(p)}return{edit:v,extensionNames:Array.from(d)}}}}e.ExtHostFileSystemEventService=i}),define(ge[217],pe([0,1,3,6,11,23,2,20,7,86]),function(Q,e,_,P,T,I,D,k,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class R{constructor(s,d,S,v){this.start=s,this.deletedCount=d,this.deletedItems=S,this.items=v}static asApiEvents(s){return s.map(d=>({start:d.start,deletedCount:d.deletedCount,deletedItems:d.deletedItems,items:d.items.map(S=>S.cell)}))}}class C{constructor(s,d,S){var v;this._notebook=s,this._extHostDocument=d,this._cellData=S,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this.handle=S.handle,this.uri=D.URI.revive(S.uri),this.cellKind=S.cellKind,this._outputs=S.outputs.map(k.NotebookCellOutput.to),this._internalMetadata=(v=S.metadata)!==null&&v!==void 0?v:{},this._metadata=k.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=k.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(s,d){return{EOL:d.eol,lines:d.source,modeId:d.language,uri:d.uri,isDirty:!1,versionId:1,notebook:s}}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get internalMetadata(){return this._internalMetadata}get cell(){if(!this._cell){const s=this,d=this._extHostDocument.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return s._notebook.getCellIndex(s)},notebook:s._notebook.notebookDocument,kind:k.NotebookCellKind.to(this._cellData.cellKind),document:d.document,get outputs(){return s._outputs.slice(0)},get metadata(){return s._metadata},get latestExecutionSummary(){return s._previousResult}})}return this._cell}setOutputs(s){this._outputs=s.map(k.NotebookCellOutput.to)}setOutputItems(s,d,S){const v=S.map(k.NotebookCellOutputItem.to),b=this._outputs.find(p=>p.id===s);b&&(d||(b.outputs.length=0),b.outputs.push(...v))}setMetadata(s){this._internalMetadata=s,this._metadata=k.NotebookCellMetadata.to(s),this._previousResult=k.NotebookCellPreviousExecutionResult.to(s)}}e.ExtHostCell=C;class w extends P.Disposable{constructor(s,d,S,v,b,p,u){super();this._proxy=s,this._textDocumentsAndEditors=d,this._textDocuments=S,this._emitter=v,this._viewType=b,this._metadata=p,this.uri=u,this.handle=w._handlePool++,this._cells=[],this._cellDisposableMapping=new Map,this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0,super.dispose(),(0,P.dispose)(this._cellDisposableMapping.values())}get notebookDocument(){if(!this._notebook){const s=this;this._notebook=Object.freeze({get uri(){return s.uri},get version(){return s._versionId},get fileName(){return s.uri.fsPath},get viewType(){return s._viewType},get isDirty(){return s._isDirty},get isUntitled(){return s.uri.scheme===T.Schemas.untitled},get isClosed(){return s._disposed},get metadata(){return s._metadata},get cellCount(){return s._cells.length},cellAt(d){return d=s._validateIndex(d),s._cells[d].cell},getCells(d){return(d?s._getCells(d):s._cells).map(v=>v.cell)},save(){return s._save()}})}return this._notebook}updateBackup(s){var d;(d=this._backup)===null||d===void 0||d.delete(),this._backup=s}disposeBackup(){var s;(s=this._backup)===null||s===void 0||s.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(s){s.metadata&&(this._metadata=this._metadata.with(s.metadata))}acceptModelChanged(s,d){this._versionId=s.versionId,this._isDirty=d;for(const S of s.rawEvents)S.kind===i.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(S.changes,!0),S.kind===i.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(S.changes,!1):S.kind===i.NotebookCellsChangeType.Move?this._moveCell(S.index,S.newIdx):S.kind===i.NotebookCellsChangeType.Output?this._setCellOutputs(S.index,S.outputs):S.kind===i.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(S.index,S.outputId,S.append,S.outputItems):S.kind===i.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(S.index,S.language):S.kind===i.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(S.index,S.metadata)}_validateIndex(s){return s<0?0:s>=this._cells.length?this._cells.length-1:s}_validateRange(s){return s.start<0&&(s=s.with({start:0})),s.end>this._cells.length&&(s=s.with({end:this._cells.length})),s}_getCells(s){s=this._validateRange(s);const d=[];for(let S=s.start;S<s.end;S++)d.push(this._cells[S]);return d}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(s,d){if(!this._disposed){const S=[],v=[],b=[];s.reverse().forEach(p=>{var u;const t=p[2].map(r=>{const l=new C(this,this._textDocumentsAndEditors,r);if(d||v.push(C.asModelAddData(this.notebookDocument,r)),!this._cellDisposableMapping.has(l.handle)){const a=new P.DisposableStore;a.add(l),this._cellDisposableMapping.set(l.handle,a)}return l});for(let r=p[0];r<p[0]+p[1];r++)(u=this._cellDisposableMapping.get(this._cells[r].handle))===null||u===void 0||u.dispose(),this._cellDisposableMapping.delete(this._cells[r].handle);const n=new R(p[0],p[1],[],t),o=this._cells.splice(p[0],p[1],...t);for(let r of o)b.push(r.uri),n.deletedItems.push(r.cell);S.push(n)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:b}),d||this._emitter.emitModelChange((0,I.deepFreeze)({document:this.notebookDocument,changes:R.asApiEvents(S)}))}}_moveCell(s,d){const S=this._cells.splice(s,1);this._cells.splice(d,0,...S);const v=[new R(s,1,S.map(b=>b.cell),[]),new R(d,0,[],S)];this._emitter.emitModelChange((0,I.deepFreeze)({document:this.notebookDocument,changes:R.asApiEvents(v)}))}_setCellOutputs(s,d){const S=this._cells[s];S.setOutputs(d),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.notebookDocument,cells:[S.cell]}))}_setCellOutputItems(s,d,S,v){const b=this._cells[s];b.setOutputItems(d,S,v),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.notebookDocument,cells:[b.cell]}))}_changeCellLanguage(s,d){const S=this._cells[s];S.cell.document.languageId!==d&&this._textDocuments.$acceptModelModeChanged(S.uri,d)}_changeCellMetadata(s,d){var S;const v=this._cells[s],b=v.internalMetadata,p=v.cell.metadata;v.setMetadata(d);const u=v.cell.metadata;if((0,I.equals)(p,u)||this._emitter.emitCellMetadataChange((0,I.deepFreeze)({document:this.notebookDocument,cell:v.cell})),b.runState!==d.runState){const c=(S=d.runState)!==null&&S!==void 0?S:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,I.deepFreeze)({document:this.notebookDocument,cell:v.cell,executionState:c}))}}getCellFromIndex(s){return this._cells[s]}getCell(s){return this._cells.find(d=>d.handle===s)}getCellIndex(s){return this._cells.indexOf(s)}}e.ExtHostNotebookDocument=w,w._handlePool=0}),define(ge[218],pe([0,1,7,20]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(k){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=k}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(k){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:k})}replaceCellMetadata(k,y){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:k,metadata:y})}replaceCellOutput(k,y){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:k,outputs:y.map(i=>P.NotebookCellOutput.from(i))})}replaceCells(k,y,i){this._throwIfFinalized(),!(k===y&&i.length===0)&&this._collectedEdits.push({editType:1,index:k,count:y-k,cells:i.map(P.NotebookCellData.from)})}}class I{constructor(k,y,i,R,C,w){this.id=k,this._proxy=y,this.notebookData=i,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=C,this._visibleRanges=R,this._viewColumn=w}get apiEditor(){if(!this._editor){const k=this;this._editor={get document(){return k.notebookData.notebookDocument},get selections(){return k._selections},get visibleRanges(){return k._visibleRanges},revealRange(y,i){k._proxy.$tryRevealRange(k.id,P.NotebookCellRange.from(y),i!=null?i:_.NotebookEditorRevealType.Default)},get viewColumn(){return k._viewColumn},edit(y){const i=new T(this.document.version);return y(i),k._applyEdit(i.finalize())},get kernel(){return k._kernel},setDecorations(y,i){return k.setDecorations(y,i)}}}return this._editor}_acceptKernel(k){this._kernel=k}get visible(){return this._visible}_acceptVisibility(k){this._visible=k}_acceptVisibleRanges(k){this._visibleRanges=k}_acceptSelections(k){this._selections=k}_acceptViewColumn(k){this._viewColumn=k}_applyEdit(k){if(k.cellEdits.length===0)return Promise.resolve(!0);const y=[];let i=-1;for(let R=0;R<k.cellEdits.length;R++){if(i<0){y.push(k.cellEdits[R]),i++;continue}const w=y[i],m=k.cellEdits[R];if(w.editType===1&&m.editType===1&&w.index===m.index){w.cells.push(...k.cellEdits[R].cells),w.count+=k.cellEdits[R].count;continue}y.push(k.cellEdits[R]),i++}return this._proxy.$tryApplyEdits(this.id,k.documentVersionId,y)}setDecorations(k,y){if(!(y.isEmpty&&!this._hasDecorationsForKey.has(k.key)))return y.isEmpty?this._hasDecorationsForKey.delete(k.key):this._hasDecorationsForKey.add(k.key),this._proxy.$trySetDecorations(this.id,P.NotebookCellRange.from(y),k.key)}}e.ExtHostNotebookEditor=I}),define(ge[219],pe([0,1,20,112,162,21,68]),function(Q,e,_,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class k{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}withProgress(C,w,m){const s=this._handles++,{title:d,location:S,cancellable:v}=w,b={label:(0,T.localize)(0,null,C.displayName||C.name),id:C.identifier.value};return this._proxy.$startProgress(s,{location:_.ProgressLocation.from(S),title:d,source:b,cancellable:v},C),this._withProgress(s,m,!!v)}_withProgress(C,w,m){let s;m&&(s=new I.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,s));const d=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),s&&s.dispose()};let S;try{S=w(new i(this._proxy,C),m&&s?s.token:I.CancellationToken.None)}catch(v){throw d(C),v}return S.then(v=>d(C),v=>d(C)),S}$acceptProgressCanceled(C){const w=this._mapHandleToCancellationSource.get(C);w&&(w.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=k;function y(R,C){return R.message=C.message,typeof C.increment=="number"&&(typeof R.increment=="number"?R.increment+=C.increment:R.increment=C.increment),R}class i extends P.Progress{constructor(C,w){super(m=>this.throttledReport(m));this._proxy=C,this._handle=w}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}je([(0,D.throttle)(100,(R,C)=>y(R,C),()=>Object.create(null))],i.prototype,"throttledReport",null)}),define(ge[122],pe([0,1,52,18,70,20,7]),function(Q,e,_,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(w,m){const s=k._Keys.nextId();w.$registerTextEditorDecorationType(s,I.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:s,dispose(){w.$removeTextEditorDecorationType(s)}})}}e.TextEditorDecorationType=k,k._Keys=new T.IdGenerator("TextEditorDecorationType");class y{constructor(w,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=w,this._documentVersionId=w.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(w,m){this._throwIfFinalized();let s=null;if(w instanceof D.Position)s=new D.Range(w,w);else if(w instanceof D.Range)s=w;else throw new Error("Unrecognized location");this._pushEdit(s,m,!1)}insert(w,m){this._throwIfFinalized(),this._pushEdit(new D.Range(w,w),m,!0)}delete(w){this._throwIfFinalized();let m=null;if(w instanceof D.Range)m=w;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(w,m,s){const d=this._document.validateRange(w);this._collectedEdits.push({range:d,text:m,forceMoveMarkers:s})}setEndOfLine(w){if(this._throwIfFinalized(),w!==D.EndOfLine.LF&&w!==D.EndOfLine.CRLF)throw(0,P.illegalArgument)("endOfLine");this._setEndOfLine=w}}e.TextEditorEdit=y;class i{constructor(w,m,s,d){this._proxy=w,this._id=m,this._accept(s),this._logService=d;const S=this;this.value={get tabSize(){return S._tabSize},set tabSize(v){S._setTabSize(v)},get insertSpaces(){return S._insertSpaces},set insertSpaces(v){S._setInsertSpaces(v)},get cursorStyle(){return S._cursorStyle},set cursorStyle(v){S._setCursorStyle(v)},get lineNumbers(){return S._lineNumbers},set lineNumbers(v){S._setLineNumbers(v)}}}_accept(w){this._tabSize=w.tabSize,this._insertSpaces=w.insertSpaces,this._cursorStyle=w.cursorStyle,this._lineNumbers=I.TextEditorLineNumbersStyle.to(w.lineNumbers)}_validateTabSize(w){if(w==="auto")return"auto";if(typeof w=="number"){const m=Math.floor(w);return m>0?m:null}if(typeof w=="string"){const m=parseInt(w,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(w){const m=this._validateTabSize(w);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(w){return w==="auto"?"auto":w==="false"?!1:Boolean(w)}_setInsertSpaces(w){const m=this._validateInsertSpaces(w);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(w){this._cursorStyle!==w&&(this._cursorStyle=w,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:w})))}_setLineNumbers(w){this._lineNumbers!==w&&(this._lineNumbers=w,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:I.TextEditorLineNumbersStyle.from(w)})))}assign(w){const m={};let s=!1;if(typeof w.tabSize!="undefined"){const d=this._validateTabSize(w.tabSize);d==="auto"?(s=!0,m.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,s=!0,m.tabSize=d)}if(typeof w.insertSpaces!="undefined"){const d=this._validateInsertSpaces(w.insertSpaces);d==="auto"?(s=!0,m.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,s=!0,m.insertSpaces=d)}typeof w.cursorStyle!="undefined"&&this._cursorStyle!==w.cursorStyle&&(this._cursorStyle=w.cursorStyle,s=!0,m.cursorStyle=w.cursorStyle),typeof w.lineNumbers!="undefined"&&this._lineNumbers!==w.lineNumbers&&(this._lineNumbers=w.lineNumbers,s=!0,m.lineNumbers=I.TextEditorLineNumbersStyle.from(w.lineNumbers)),s&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(w){w.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=i;class R{constructor(w,m,s,d,S,v,b,p){this.id=w,this._proxy=m,this._logService=s,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._options=new i(this._proxy,this.id,v,s),this._visibleRanges=b,this._viewColumn=p;const u=this;this.value=Object.freeze({get document(){return d.getValue()},set document(c){throw(0,P.readonly)("document")},get selection(){return u._selections&&u._selections[0]},set selection(c){if(!(c instanceof D.Selection))throw(0,P.illegalArgument)("selection");u._selections=[c],u._trySetSelection()},get selections(){return u._selections},set selections(c){if(!Array.isArray(c)||c.some(t=>!(t instanceof D.Selection)))throw(0,P.illegalArgument)("selections");u._selections=c,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(c){throw(0,P.readonly)("visibleRanges")},get options(){return u._options.value},set options(c){u._disposed||u._options.assign(c)},get viewColumn(){return u._viewColumn},set viewColumn(c){throw(0,P.readonly)("viewColumn")},edit(c,t={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new y(d.getValue(),t);return c(n),u._applyEdit(n)},insertSnippet(c,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=u._selections.map(r=>I.Range.from(r));else if(t instanceof D.Position){const{lineNumber:r,column:l}=I.Position.from(t);o=[{startLineNumber:r,startColumn:l,endLineNumber:r,endColumn:l}]}else if(t instanceof D.Range)o=[I.Range.from(t)];else{o=[];for(const r of t)if(r instanceof D.Range)o.push(I.Range.from(r));else{const{lineNumber:l,column:a}=I.Position.from(r);o.push({startLineNumber:l,startColumn:a,endLineNumber:l,endColumn:a})}}return m.$tryInsertSnippet(w,c.value,o,n)},setDecorations(c,t){const n=t.length===0;n&&!u._hasDecorationsForKey.has(c.key)||(n?u._hasDecorationsForKey.delete(c.key):u._hasDecorationsForKey.add(c.key),u._runOnProxy(()=>{if(I.isDecorationOptionsArr(t))return m.$trySetDecorations(w,c.key,I.fromRangeOrRangeWithMessage(t));{const o=new Array(4*t.length);for(let r=0,l=t.length;r<l;r++){const a=t[r];o[4*r]=a.start.line+1,o[4*r+1]=a.start.character+1,o[4*r+2]=a.end.line+1,o[4*r+3]=a.end.character+1}return m.$trySetDecorationsFast(w,c.key,o)}}))},revealRange(c,t){u._runOnProxy(()=>m.$tryRevealRange(w,I.Range.from(c),t||D.TextEditorRevealType.Default))},show(c){m.$tryShowEditor(w,I.ViewColumn.from(c))},hide(){m.$tryHideEditor(w)}})}dispose(){(0,_.ok)(!this._disposed),this._disposed=!0}_acceptOptions(w){(0,_.ok)(!this._disposed),this._options._accept(w)}_acceptVisibleRanges(w){(0,_.ok)(!this._disposed),this._visibleRanges=w}_acceptViewColumn(w){(0,_.ok)(!this._disposed),this._viewColumn=w}_acceptSelections(w){(0,_.ok)(!this._disposed),this._selections=w}async _trySetSelection(){const w=this._selections.map(I.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,w)),this.value}_applyEdit(w){const m=w.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const s=m.edits.map(S=>S.range);s.sort((S,v)=>S.end.line===v.end.line?S.end.character===v.end.character?S.start.line===v.start.line?S.start.character-v.start.character:S.start.line-v.start.line:S.end.character-v.end.character:S.end.line-v.end.line);for(let S=0,v=s.length-1;S<v;S++){const b=s[S].end;if(s[S+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=m.edits.map(S=>({range:I.Range.from(S.range),text:S.text,forceMoveMarkers:S.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,d,{setEndOfLine:typeof m.setEndOfLine=="number"?I.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(w){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):w().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=R}),define(ge[220],pe([0,1,165,25,2,3,6,19,7,15,14,20,21]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function m(S,v){if((0,i.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let b;return Array.isArray(S.highlights)&&(b=S.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),b=b.length?b:void 0),{label:S.label,highlights:b}}}class s{constructor(v,b,p){this._proxy=v,this.commands=b,this.logService=p,this.treeViews=new Map;function u(c){return c&&c.$treeViewId&&c.$treeItemHandle}b.registerArgumentProcessor({processArgument:c=>u(c)?this.convertArgument(c):Array.isArray(c)&&c.length>0?c.map(t=>u(t)?this.convertArgument(t):t):c})}registerTreeDataProvider(v,b,p){const u=this.createTreeView(v,{treeDataProvider:b},p);return{dispose:()=>u.dispose()}}createTreeView(v,b,p){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=this._proxy.$registerTreeViewDataProvider(v,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany}),c=this.createExtHostTreeView(v,b,p);return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get message(){return c.message},set message(t){c.message=t},get title(){return c.title},set title(t){c.title=t},get description(){return c.description},set description(t){c.description=t},reveal:(t,n)=>c.reveal(t,n),dispose:async()=>{await u,this.treeViews.delete(v),c.dispose()}}}$getChildren(v,b){const p=this.treeViews.get(v);return p?p.getChildren(b):Promise.reject(new Error((0,_.localize)(0,null,v)))}async $hasResolve(v){const b=this.treeViews.get(v);if(!b)throw new Error((0,_.localize)(1,null,v));return b.hasResolve}$resolve(v,b,p){const u=this.treeViews.get(v);if(!u)throw new Error((0,_.localize)(2,null,v));return u.resolveTreeItem(b,p)}$setExpanded(v,b,p){const u=this.treeViews.get(v);if(!u)throw new Error((0,_.localize)(3,null,v));u.setExpanded(b,p)}$setSelection(v,b){const p=this.treeViews.get(v);if(!p)throw new Error((0,_.localize)(4,null,v));p.setSelection(b)}$setVisible(v,b){const p=this.treeViews.get(v);if(!p)throw new Error((0,_.localize)(5,null,v));p.setVisible(b)}createExtHostTreeView(v,b,p){const u=new d(v,b,this._proxy,this.commands.converter,this.logService,p);return this.treeViews.set(v,u),u}convertArgument(v){const b=this.treeViews.get(v.$treeViewId);return b?b.getExtensionElement(v.$treeItemHandle):null}}e.ExtHostTreeViews=s;class d extends D.Disposable{constructor(v,b,p,u,c,t){super();if(this.viewId=v,this.proxy=p,this.commands=u,this.logService=c,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new I.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new I.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new I.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new I.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new I.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new w.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const l of t.contributes.views[r])l.id===v&&(this._title=l.name);this.dataProvider=b.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let n,o;this._register(I.Event.debounce(this._onDidChangeData.event,(r,l)=>(r||(r={message:!1,elements:[]}),l.element!==!1&&(n||(n=new Promise(a=>o=a),this.refreshPromise=this.refreshPromise.then(()=>n)),r.elements.push(l.element)),l.message&&(r.message=!0),r),200,!0)(({message:r,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const a=o;return n=null,this.refresh(l).then(()=>a())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(v=>this.getExtensionElement(v)).filter(v=>!(0,i.isUndefinedOrNull)(v))}getChildren(v){const b=v?this.getExtensionElement(v):void 0;if(v&&!b)return this.logService.error(`No tree item with id '${v}' found.`),Promise.resolve([]);const p=this.getChildrenNodes(v);return(p?Promise.resolve(p):this.fetchChildrenNodes(b)).then(u=>u.map(c=>c.item))}getExtensionElement(v){return this.elements.get(v)}reveal(v,b){b=b||{select:!0,focus:!1};const p=(0,i.isUndefinedOrNull)(b.select)?!0:b.select,u=(0,i.isUndefinedOrNull)(b.focus)?!1:b.focus,c=(0,i.isUndefinedOrNull)(b.expand)?!1:b.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.refreshPromise.then(()=>this.resolveUnknownParentChain(v)).then(t=>this.resolveTreeNode(v,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(o=>o.item)},{select:p,focus:u,expand:c})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:p,focus:u,expand:c})}get message(){return this._message}set message(v){this._message=v,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(v){this._title=v,this.proxy.$setTitle(this.viewId,v,this._description)}get description(){return this._description}set description(v){this._description=v,this.proxy.$setTitle(this.viewId,this._title,v)}setExpanded(v,b){const p=this.getExtensionElement(v);p&&(b?this._onDidExpandElement.fire(Object.freeze({element:p})):this._onDidCollapseElement.fire(Object.freeze({element:p})))}setSelection(v){(0,R.equals)(this._selectedHandles,v)||(this._selectedHandles=v,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(v){v!==this._visible&&(this._visible=v,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(v,b){var p;if(!!this.dataProvider.resolveTreeItem){const u=this.elements.get(v);if(u){const c=this.nodes.get(u);if(c){const t=(p=await this.dataProvider.resolveTreeItem(c.extensionItem,u,b))!==null&&p!==void 0?p:c.extensionItem;return c.item.tooltip=this.getTooltip(t.tooltip),c.item.command=this.getCommand(c.disposableStore,t.command),c.item}}}}resolveUnknownParentChain(v){return this.resolveParent(v).then(b=>b?this.resolveUnknownParentChain(b).then(p=>this.resolveTreeNode(b,p[p.length-1]).then(u=>(p.push(u),p))):Promise.resolve([]))}resolveParent(v){const b=this.nodes.get(v);return b?Promise.resolve(b.parent?this.elements.get(b.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(v))}resolveTreeNode(v,b){const p=this.nodes.get(v);return p?Promise.resolve(p):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(u=>this.createHandle(v,u,b,!0)).then(u=>this.getChildren(b?b.item.handle:void 0).then(()=>{const c=this.getExtensionElement(u);if(c){const t=this.nodes.get(c);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(v){if(v){let b;if(typeof v=="string"){const p=this.getExtensionElement(v);b=p?this.nodes.get(p):void 0}else b=v;return b&&b.children||null}return this.roots}async fetchChildrenNodes(v){this.clearChildren(v);const b=new w.CancellationTokenSource(this._refreshCancellationSource.token);try{const p=v?this.nodes.get(v):void 0,u=await this.dataProvider.getChildren(v);if(b.token.isCancellationRequested)return[];const c=await Promise.all((0,R.coalesce)(u||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!b.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,p):null}));return b.token.isCancellationRequested?[]:(0,R.coalesce)(c)}finally{b.dispose()}}refresh(v){if(v.some(p=>!p))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new w.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const p=this.getHandlesToRefresh(v);if(p.length)return this.refreshHandles(p)}return Promise.resolve(void 0)}getHandlesToRefresh(v){const b=new Set,p=v.map(c=>this.nodes.get(c));for(const c of p)if(c&&!b.has(c.item.handle)){let t=c;for(;t&&t.parent&&p.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&b.add(c.item.handle)}const u=[];return b.forEach(c=>{const t=this.elements.get(c);if(t){const n=this.nodes.get(t);n&&(!n.parent||!b.has(n.parent.item.handle))&&u.push(c)}}),u}refreshHandles(v){const b={};return Promise.all(v.map(p=>this.refreshNode(p).then(u=>{u&&(b[p]=u.item)}))).then(()=>Object.keys(b).length?this.proxy.$refresh(this.viewId,b):void 0)}refreshNode(v){const b=this.getExtensionElement(v);if(b){const p=this.nodes.get(b);if(p)return this.clearChildren(b),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(u=>{if(u){const c=this.createTreeNode(b,u,p.parent);return this.updateNodeCache(b,c,p,p.parent),p.dispose(),c}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(v,b,p){const u=this.createTreeNode(v,b,p);if(b.id&&this.elements.has(u.item.handle))throw new Error((0,_.localize)(6,null,b.id));return this.addNodeToCache(v,u),this.addNodeToParentCache(u,p),u}getTooltip(v){return y.MarkdownString.isMarkdownString(v)?C.MarkdownString.from(v):v}getCommand(v,b){return b?this.commands.toInternal(b,v):void 0}createTreeNode(v,b,p){const u=new D.DisposableStore,c=this.createHandle(v,b,p),t=this.getLightIconPath(b);return{item:{handle:c,parentHandle:p?p.item.handle:void 0,label:m(b.label,this.extension),description:b.description,resourceUri:b.resourceUri,tooltip:this.getTooltip(b.tooltip),command:this.getCommand(u,b.command),contextValue:b.contextValue,icon:t,iconDark:this.getDarkIconPath(b)||t,themeIcon:this.getThemeIcon(b),collapsibleState:(0,i.isUndefinedOrNull)(b.collapsibleState)?y.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation},extensionItem:b,parent:p,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(v){return v.iconPath instanceof y.ThemeIcon?v.iconPath:void 0}createHandle(v,{id:b,label:p,resourceUri:u},c,t){if(b)return`${d.ID_HANDLE_PREFIX}/${b}`;const n=m(p,this.extension),o=c?c.item.handle:d.LABEL_HANDLE_PREFIX;let r=n?n.label:u?(0,P.basename)(u):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const l=this.nodes.has(v)?this.nodes.get(v).item.handle:void 0,a=this.getChildrenNodes(c)||[];let g,E=0;do{if(g=`${o}/${E}:${r}`,t||!this.elements.has(g)||l===g)break;E++}while(E<=a.length);return g}getLightIconPath(v){if(v.iconPath&&!(v.iconPath instanceof y.ThemeIcon))return typeof v.iconPath=="string"||T.URI.isUri(v.iconPath)?this.getIconPath(v.iconPath):this.getIconPath(v.iconPath.light)}getDarkIconPath(v){if(v.iconPath&&!(v.iconPath instanceof y.ThemeIcon)&&v.iconPath.dark)return this.getIconPath(v.iconPath.dark)}getIconPath(v){return T.URI.isUri(v)?v:T.URI.file(v)}addNodeToCache(v,b){this.elements.set(b.item.handle,v),this.nodes.set(v,b)}updateNodeCache(v,b,p,u){this.elements.delete(b.item.handle),this.nodes.delete(v),b.item.handle!==p.item.handle&&this.elements.delete(p.item.handle),this.addNodeToCache(v,b);const c=this.getChildrenNodes(u)||[],t=c.filter(n=>n.item.handle===p.item.handle)[0];t&&c.splice(c.indexOf(t),1,b)}addNodeToParentCache(v,b){b?(b.children||(b.children=[]),b.children.push(v)):(this.roots||(this.roots=[]),this.roots.push(v))}clearChildren(v){if(v){const b=this.nodes.get(v);if(b){if(b.children)for(const p of b.children){const u=this.elements.get(p.item.handle);u&&this.clear(u)}b.children=void 0}}else this.clearAll()}clear(v){const b=this.nodes.get(v);if(b){if(b.children)for(const p of b.children){const u=this.elements.get(p.item.handle);u&&this.clear(u)}this.nodes.delete(v),this.elements.delete(b.item.handle),b.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(v=>v.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}d.LABEL_HANDLE_PREFIX="0",d.ID_HANDLE_PREFIX="1"}),define(ge[221],pe([0,1,14,19,21,20,7,121]),function(Q,e,_,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class y{constructor(){this.testIdsToInternal=new Map}getTestById(s,d){if(d!==void 0){const S=this.testIdsToInternal.get(d),v=S==null?void 0:S.get(s);if(v)return[S,v]}return(0,_.mapFind)(this.testIdsToInternal.values(),S=>{const v=S.get(s);return v&&[S,v]})}createForHierarchy(s=()=>{}){return new w(this.createIdMap(R++),s)}createIdMap(s){const d=new C(s);return this.testIdsToInternal.set(d.id,d),{object:d,dispose:()=>this.testIdsToInternal.delete(d.id)}}}e.OwnedTestCollection=y;var i;(function(m){m[m.Disconnected=0]="Disconnected",m[m.IsChild=1]="IsChild",m[m.IsParent=2]="IsParent",m[m.IsSame=3]="IsSame"})(i=e.TestPosition||(e.TestPosition={}));let R=0;class C{constructor(s){this.id=s,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(s){if(this.map.has(s.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${s.item.extId}`);this.map.set(s.item.extId,s),s.parent||this._roots.add(s)}has(s){return this.map.has(s)}delete(s){const d=this.map.get(s);return d?(this.map.delete(s),this._roots.delete(d),!0):!1}get(s){return this.map.get(s)}comparePositions(s,d){const S=typeof s=="string"?this.map.get(s):s,v=typeof d=="string"?this.map.get(d):d;if(!S||!v)return 0;if(S===v)return 3;for(let b=this.map.get(v.parent);b;b=this.map.get(b.parent))if(b===S)return 1;for(let b=this.map.get(S.parent);b;b=this.map.get(b.parent))if(b===v)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=C;class w{constructor(s,d){this.testIdToInternal=s,this.publishDiff=d,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new P.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(s,d){this.addItem(s,d,null)}getTestByReference(s){return this.testItemToInternal.get(s)}collectDiff(){const s=this.diff;return this.diff=[],s}pushDiff(s){const d=this.diff[this.diff.length-1];if(d&&s[0]===1){if(d[0]===1&&d[1].extId===s[1].extId){(0,k.applyTestItemUpdate)(d[1],s[1]);return}if(d[0]===0&&d[1].item.extId===s[1].extId){(0,k.applyTestItemUpdate)(d[1],s[1]);return}}this.diff.push(s),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(s,d){var S;const v=this.testIdToInternal.object.get(s);if(!!v){if((v.expandLevels===void 0||d>v.expandLevels)&&(v.expandLevels=d),v.expand===1){const b=this.refreshChildren(v);return b.isSettled?this.expandChildren(v,d-1):b.p.then(()=>this.expandChildren(v,d-1))}else if(v.expand===3)return((S=v.initialExpand)===null||S===void 0?void 0:S.isSettled)===!1?v.initialExpand.p.then(()=>this.expandChildren(v,d-1)):this.expandChildren(v,d-1)}}dispose(){var s;for(const d of this.testItemToInternal.values())(s=d.discoverCts)===null||s===void 0||s.dispose(!0),d.actual[D.TestItemHookProperty]=void 0;this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}addItem(s,d,S){if(!(s instanceof D.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${s.id} did not`);if(this.testItemToInternal.has(s))throw new Error(`Attempted to add a single TestItem ${s.id} multiple times to the tree`);if(this.testIdToInternal.object.has(s.id))throw new Error(`Attempted to insert a duplicate test item ID ${s.id}`);const v=S?S.item.extId:null,b=s.expandable?1:0,p=S==null?void 0:S.expandLevels,u={provider:d,tree:this.testIdToInternal.object.id},c={actual:s,parent:v,item:I.TestItem.from(s),expandLevels:p&&b===1?p-1:void 0,expand:b,src:u};this.testIdToInternal.object.add(c),this.testItemToInternal.set(s,c),this.pushDiff([0,{parent:v,src:u,expand:b,item:c.item}]),s[D.TestItemHookProperty]={created:t=>this.addItem(t,d,c),delete:t=>this.removeItembyId(t),invalidate:t=>this.pushDiff([4,t]),setProp:(t,n)=>this.pushDiff([1,{extId:s.id,item:{[t]:t==="range"?I.Range.from(n):n}}])};for(const t of s.children)this.addItem(t,d,c)}expandChildren(s,d){if(!(d<0)){const S=[...s.actual.children].map(v=>this.expand(v.id,d-1)).filter(P.isThenable);if(S.length)return Promise.all(S).then(()=>{})}}refreshChildren(s){s.discoverCts&&s.discoverCts.dispose(!0),s.expand=2,s.discoverCts=new T.CancellationTokenSource,this.pushExpandStateUpdate(s);const d=new P.DeferredPromise;return s.initialExpand=d,s.actual.discoverChildren({report:S=>{S.busy?(s.expand=2,this.pushExpandStateUpdate(s)):(s.expand=3,d.isSettled||d.complete(),this.pushExpandStateUpdate(s))}},s.discoverCts.token),d}pushExpandStateUpdate(s){this.pushDiff([1,{extId:s.actual.id,expand:s.expand}])}removeItembyId(s){var d;this.pushDiff([2,s]);const S=[this.testIdToInternal.object.get(s)];for(;S.length;){const v=S.pop();if(!!v){(d=v.discoverCts)===null||d===void 0||d.dispose(!0),this.testIdToInternal.object.delete(v.item.extId),this.testItemToInternal.delete(v.actual);for(const b of v.actual.children)S.push(this.testIdToInternal.object.get(b.id))}}}flushDiff(){const s=this.collectDiff();s.length&&this.publishDiff(s)}}e.SingleUseTestCollection=w}),define(ge[222],pe([0,1,29,3,8]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class I{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=I;class D{constructor(R){this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(_.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(_.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let C of R.activationEvents)C==="onUri"&&(C=`onUri:${_.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(R)}}keepOnly(R){const C=new Set;R.forEach(w=>C.add(_.ExtensionIdentifier.toKey(w))),this._extensionDescriptions=this._extensionDescriptions.filter(w=>C.has(_.ExtensionIdentifier.toKey(w.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,C){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const w=D._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(w.map(m=>m.identifier)),C.length>0){const m=new Set;C.forEach(s=>m.add(_.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>!m.has(_.ExtensionIdentifier.toKey(s.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new I(w)}static _findLoopingExtensions(R){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(S){this._nodesSet.has(S)||(this._nodesSet.add(S),this._nodesArr.push(S))}addArc(S,v){this.addNode(S),this.addNode(v),this._arcs.has(S)?this._arcs.get(S).push(v):this._arcs.set(S,[v])}getArcs(S){return this._arcs.has(S)?this._arcs.get(S):[]}hasOnlyGoodArcs(S,v){const b=C.getArcs(S);for(let p=0;p<b.length;p++)if(!v.has(b[p]))return!1;return!0}getNodes(){return this._nodesArr}};let w=new Map;for(let S of R){const v=_.ExtensionIdentifier.toKey(S.identifier);if(w.set(v,S),S.extensionDependencies)for(let b of S.extensionDependencies){const p=_.ExtensionIdentifier.toKey(b);C.addArc(v,p)}}let m=new Set;C.getNodes().filter(S=>C.getArcs(S).length===0).forEach(S=>m.add(S));let s=C.getNodes().filter(S=>!m.has(S)),d;do{d=!1;for(let S=0;S<s.length;S++){const v=s[S];C.hasOnlyGoodArcs(v,m)&&(s.splice(S,1),S--,m.add(v),d=!0)}}while(d);return s.map(S=>w.get(S))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(_.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const C=this._activationMap.get(R);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const C=this._extensionsMap.get(_.ExtensionIdentifier.toKey(R));return C||void 0}}e.ExtensionDescriptionRegistry=D;var k;(function(i){i[i.Builtin=0]="Builtin",i[i.User=1]="User",i[i.Dev=2]="Dev"})(k||(k={}));function y(i,R){const C=i.isBuiltin?0:i.isUnderDevelopment?2:1,w=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(C!==w)return C-w;const m=T.posix.basename(i.extensionLocation.path),s=T.posix.basename(R.extensionLocation.path);return m<s?-1:m>s?1:0}}),define(ge[223],pe([0,1,22]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var P;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(P=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var T;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(T=e.MessageType||(e.MessageType={}));function I(k){const y=_.VSBuffer.alloc(1);switch(k){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=I;function D(k,y){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=D}),define(ge[41],pe([0,1,3,2,4,29,183]),function(Q,e,_,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new I.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:P.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class k{constructor(b){this.dependency=b}}e.MissingDependencyError=k;var y;(function(v){v[v.LocalProcess=0]="LocalProcess",v[v.LocalWebWorker=1]="LocalWebWorker",v[v.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class i{constructor(b,p,u,c){this.codeLoadingTime=b,this.activateCallTime=p,this.activateResolvedTime=u,this.activationReason=c}}e.ActivationTimes=i;class R{constructor(b,p){this.description=b,this.value=p}}e.ExtensionPointContribution=R,e.ExtensionHostLogFileName="exthost";var C;(function(v){v[v.Normal=0]="Normal",v[v.Immediate=1]="Immediate"})(C=e.ActivationKind||(e.ActivationKind={}));function w(v){v.enableProposedApi||m(v)}e.checkProposedApiEnabled=w;function m(v){throw new Error(`[${v.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`)}e.throwProposedApiError=m;function s(v){return{type:v.isBuiltin?0:1,isBuiltin:v.isBuiltin||v.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(v.publisher,v.name),uuid:v.uuid},manifest:v,location:v.extensionLocation}}e.toExtension=s;function d(v){return Object.assign(Object.assign({identifier:new I.ExtensionIdentifier(v.identifier.id),isBuiltin:v.type===0,isUserBuiltin:v.type===1&&v.isBuiltin,isUnderDevelopment:!1,extensionLocation:v.location},v.manifest),{uuid:v.identifier.uuid})}e.toExtensionDescription=d;class S{constructor(){this.onDidRegisterExtensions=_.Event.None,this.onDidChangeExtensionsStatus=_.Event.None,this.onDidChangeExtensions=_.Event.None,this.onWillActivateByEvent=_.Event.None,this.onDidChangeResponsiveChange=_.Event.None}activateByEvent(b){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(b){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(b){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(b){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(b,p){}_activateById(b,p){return Promise.resolve()}_onWillActivateExtension(b){}_onDidActivateExtension(b,p,u,c,t){}_onExtensionRuntimeError(b,p){}_onExtensionHostExit(b){}}e.NullExtensionService=S}),define(ge[224],pe([0,1,160,29,41,12]),function(Q,e,_,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const D=Promise.resolve(void 0);class k{constructor(d,S,v,b){this.startup=d,this.codeLoadingTime=S,this.activateCallTime=v,this.activateResolvedTime=b}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class y{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,S){return d===-1||S===-1?-1:S-d}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class i{constructor(d,S,v,b,p,u){this.activationFailed=d,this.activationFailedError=S,this.activationTimes=v,this.module=b,this.exports=p,this.subscriptions=u}}e.ActivatedExtension=i;class R extends i{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class C extends i{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=C;class w extends i{constructor(d){super(!0,d,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=w;let m=class{constructor(d,S,v,b,p){this._logService=p,this._registry=d,this._resolvedExtensionsSet=new Set,S.forEach(u=>this._resolvedExtensionsSet.add(P.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,v.forEach(u=>this._hostExtensionsMap.set(P.ExtensionIdentifier.toKey(u),u)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(d){const S=P.ExtensionIdentifier.toKey(d);return this._activatedExtensions.has(S)}getActivatedExtension(d){const S=P.ExtensionIdentifier.toKey(d),v=this._activatedExtensions.get(S);if(!v)throw new Error("Extension `"+d.value+"` is not known or not activated");return v}activateByEvent(d,S){if(this._alreadyActivatedEvents[d])return D;const v=this._registry.getExtensionDescriptionsForActivationEvent(d);return this._activateExtensions(v.map(b=>({id:b.identifier,reason:{startup:S,extensionId:b.identifier,activationEvent:d}}))).then(()=>{this._alreadyActivatedEvents[d]=!0})}activateById(d,S){const v=this._registry.getExtensionDescription(d);if(!v)throw new Error("Extension `"+d+"` is not known");return this._activateExtensions([{id:v.identifier,reason:S}])}_handleActivateRequest(d,S,v){if(this._hostExtensionsMap.has(P.ExtensionIdentifier.toKey(d.id))){S[P.ExtensionIdentifier.toKey(d.id)]=d;return}const b=this._registry.getExtensionDescription(d.id);if(!b){this._host.onExtensionActivationError(d.id,new T.MissingDependencyError(d.id.value));const c=new Error(`Unknown dependency '${d.id.value}'`);this._activatedExtensions.set(P.ExtensionIdentifier.toKey(d.id),new w(c));return}const p=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let u=!0;for(let c=0,t=p.length;c<t;c++){const n=p[c];if(!this._resolvedExtensionsSet.has(P.ExtensionIdentifier.toKey(n))){const o=this._activatedExtensions.get(P.ExtensionIdentifier.toKey(n));if(!(o&&!o.activationFailed)){if(o&&o.activationFailed){this._host.onExtensionActivationError(b.identifier,_.localize(0,null,b.displayName||b.identifier.value,n));const a=new Error(`Dependency ${n} failed to activate`);a.detail=o.activationFailedError,this._activatedExtensions.set(P.ExtensionIdentifier.toKey(b.identifier),new w(a));return}if(this._hostExtensionsMap.has(P.ExtensionIdentifier.toKey(n))){u=!1,S[P.ExtensionIdentifier.toKey(n)]={id:this._hostExtensionsMap.get(P.ExtensionIdentifier.toKey(n)),reason:d.reason};continue}const r=this._registry.getExtensionDescription(n);if(r){u=!1,S[P.ExtensionIdentifier.toKey(n)]={id:r.identifier,reason:d.reason};continue}this._host.onExtensionActivationError(b.identifier,new T.MissingDependencyError(n));const l=new Error(`Unknown dependency '${n}'`);this._activatedExtensions.set(P.ExtensionIdentifier.toKey(b.identifier),new w(l));return}}}u?S[P.ExtensionIdentifier.toKey(b.identifier)]=d:v.push(d)}_activateExtensions(d){if(d.length===0||(d=d.filter(p=>!this._activatedExtensions.has(P.ExtensionIdentifier.toKey(p.id))),d.length===0))return Promise.resolve(void 0);const S=Object.create(null),v=[];for(let p=0,u=d.length;p<u;p++)this._handleActivateRequest(d[p],S,v);for(let p=0,u=v.length;p<u;p++){const c=P.ExtensionIdentifier.toKey(v[p].id);S[c]&&delete S[c]}const b=Object.keys(S).map(p=>S[p]);return v.length===0?Promise.all(b.map(p=>this._activateExtension(p.id,p.reason))).then(p=>{}):this._activateExtensions(b).then(p=>this._activateExtensions(v))}_activateExtension(d,S){const v=P.ExtensionIdentifier.toKey(d);if(this._activatedExtensions.has(v))return Promise.resolve(void 0);const b=this._activatingExtensions.get(v);if(b)return b;const p=this._host.actualActivateExtension(d,S).then(void 0,u=>(this._host.onExtensionActivationError(d,_.localize(1,null,d.value,u.message)),this._logService.error(`Activating extension ${d.value} failed due to an error:`),this._logService.error(u),new w(u))).then(u=>{this._activatedExtensions.set(v,u),this._activatingExtensions.delete(v)});return this._activatingExtensions.set(v,p),p}};m=je([xe(4,I.ILogService)],m),e.ExtensionsActivator=m}),define(ge[225],pe([0,1,12,41,27,11,110]),function(Q,e,_,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let k=class extends _.LogService{constructor(i){if(i.logFile.scheme!==I.Schemas.file)throw new Error("Only file-logging supported");super(new D.SpdLogLogger(P.ExtensionHostLogFileName,i.logFile.fsPath,!0,i.logLevel))}$setLevel(i){this.setLevel(i)}};k=je([xe(0,T.IExtHostInitDataService)],k),e.ExtHostLogService=k}),define(ge[226],pe([0,1,18]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class P{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((I,D)=>{this._actualOk=I,this._actualErr=D,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(I){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=I,this._actual&&this._actualOk(I))}resolveErr(I){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=I,this._actual?this._actualErr(I):(0,_.onUnexpectedError)(I))}then(I,D){return this._ensureActual().then(I,D)}catch(I){return this._ensureActual().then(void 0,I)}finally(I){return this._ensureActual().finally(I)}}e.LazyPromise=P}),define(ge[123],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class _{constructor(y,i){this.isMain=y,this.sid=i,this.nid=++_.count}}e.ProxyIdentifier=_,_.count=0;const P=[];function T(k){const y=new _(!0,k);return P[y.nid]=y,y}e.createMainContextProxyIdentifier=T;function I(k){const y=new _(!1,k);return P[y.nid]=y,y}e.createExtHostContextProxyIdentifier=I;function D(k){return P[k].sid}e.getStringIdentifierForProxy=D}),define(ge[5],pe([0,1,2,123,57]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var I;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(I=e.UIKind||(e.UIKind={}));var D;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(D=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var i;(function(u){u[u.Markdown=1]="Markdown",u[u.Code=2]="Code"})(i=e.CellKind||(e.CellKind={}));var R;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(R=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var w;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(w=e.CandidatePortSource||(e.CandidatePortSource={}));var m;(function(u){u.name="$ident";function c(n,o){return Object.defineProperty(n,u.name,{value:o,enumerable:!0}),n}u.mixin=c;function t(n){return n[u.name]}u.of=t})(m=e.ObjectIdentifier||(e.ObjectIdentifier={}));class s{static mixin(c){return c._id=s._n++,c}}e.IdObject=s,s._n=0;var d;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n",u.label2="o"})(d=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var S;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(S=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function b(u){if(u&&u.edits)for(const c of u.edits)typeof c.resource=="object"?c.resource=_.URI.revive(c.resource):(c.newUri=_.URI.revive(c.newUri),c.oldUri=_.URI.revive(c.oldUri)),c.metadata&&c.metadata.iconPath&&(c.metadata=(0,T.revive)(c.metadata));return u}e.reviveWorkspaceEditDto=b;var p;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,P.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,P.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,P.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,P.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,P.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,P.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,P.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,P.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,P.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,P.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,P.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,P.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,P.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,P.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,P.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,P.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,P.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,P.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,P.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,P.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,P.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,P.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,P.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,P.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,P.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,P.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,P.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,P.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,P.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,P.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,P.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,P.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,P.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,P.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,P.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,P.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,P.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,P.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,P.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,P.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,P.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,P.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,P.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,P.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,P.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,P.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,P.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,P.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,P.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,P.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,P.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,P.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,P.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,P.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,P.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,P.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,P.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,P.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,P.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,P.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,P.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,P.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,P.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,P.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,P.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,P.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,P.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,P.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,P.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,P.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,P.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,P.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,P.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,P.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,P.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,P.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,P.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,P.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,P.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,P.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,P.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,P.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,P.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,P.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,P.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,P.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,P.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,P.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,P.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,P.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,P.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,P.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,P.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,P.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,P.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,P.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,P.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,P.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,P.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,P.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ge[87],pe([0,1,5,3,4]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class I{constructor(k){this._onDidChangePassword=new P.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(_.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,y){return this._proxy.$getPassword(k,y)}store(k,y,i){return this._proxy.$setPassword(k,y,i)}delete(k,y){return this._proxy.$deletePassword(k,y)}}e.ExtHostSecretState=I,e.IExtHostSecretState=(0,T.createDecorator)("IExtHostSecretState")}),define(ge[62],pe([0,1,4,12,5,13]),function(Q,e,_,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,_.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(y,i){this._extHostLogService=i,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(T.MainContext.MainThreadTelemetry)}report(y,i,R){const C=this.getUsageKey(y,i);this._reportedUsages.has(C)||(this._reportedUsages.add(C),i.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:i.identifier.value,apiId:y}))}getUsageKey(y,i){return`${y}-${i.identifier.value}`}};D=je([xe(0,I.IExtHostRpcService),xe(1,P.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(k,y,i){}})}),define(ge[227],pe([0,1,3,5,7,29]),function(Q,e,_,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new _.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new _.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(P.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(y,i,R,C={}){const w=I.ExtensionIdentifier.toKey(y.identifier),m=this._inFlightRequests.get(w)||[],s=R.sort().join(" ");let d=m.find(S=>S.scopes===s);if(d)return d.result;{const S=this._getSession(y,w,i,R,C);d={scopes:s,result:S},m.push(d),this._inFlightRequests.set(w,m);try{await S}finally{const v=m.findIndex(b=>b.scopes===s);v>-1&&(m.splice(v),this._inFlightRequests.set(w,m))}return S}}async _getSession(y,i,R,C,w={}){await this._proxy.$ensureProvider(R);const m=y.displayName||y.name;return this._proxy.$getSession(R,C,i,m,w)}async removeSession(y,i){const R=this._authenticationProviders.get(y);return R?R.provider.removeSession(i):this._proxy.$removeSession(y,i)}registerAuthenticationProvider(y,i,R,C){var w;if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:i,provider:R,options:C!=null?C:{supportsMultipleAccounts:!1}}),this._providers.find(s=>s.id===y)||this._providers.push({id:y,label:i});const m=R.onDidChangeSessions(s=>{var d,S,v;this._proxy.$sendDidChangeSessions(y,{added:(d=s.added)!==null&&d!==void 0?d:[],changed:(S=s.changed)!==null&&S!==void 0?S:[],removed:(v=s.removed)!==null&&v!==void 0?v:[]})});return this._proxy.$registerAuthenticationProvider(y,i,(w=C==null?void 0:C.supportsMultipleAccounts)!==null&&w!==void 0?w:!1),new T.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(y);const s=this._providers.findIndex(d=>d.id===y);s>-1&&this._providers.splice(s),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,i){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.createSession(i));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,i){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.removeSession(i));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,i){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.getSessions(i));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,i){return this._onDidChangeSessions.fire({provider:{id:y,label:i}}),Promise.resolve()}$onDidChangeAuthenticationProviders(y,i){return y.forEach(R=>{this._providers.some(C=>C.id===R.id)||this._providers.push(R)}),i.forEach(R=>{const C=this._providers.findIndex(w=>w.id===R.id);C>-1&&this._providers.splice(C)}),this._onDidChangeAuthenticationProviders.fire({added:y,removed:i}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(ge[228],pe([0,1,5,13,20]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let I=class{constructor(k,y){this._extHostDocumentsAndEditors=y,this._proxy=k.getProxy(_.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const y=T.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};I=je([xe(0,P.IExtHostRpcService)],I),e.ExtHostBulkEdits=I}),define(ge[229],pe([0,1,5]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class P{constructor(I){const D=I.getProxy(_.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(k){return D.$writeText(k)}})}}e.ExtHostClipboard=P}),define(ge[51],pe([0,1,15,7,20,23,5,14,12,57,44,49,2,6,4,13]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(D.MainContext.MainThreadCommands),this._logService=n,this.converter=new v(this,o=>{const r=this._apiCommands.get(o);return(r==null?void 0:r.result)===p.Void?r:void 0},n),this._argumentProcessors=[{processArgument(o){return(0,i.revive)(o)}},{processArgument(o){return(0,I.cloneAndChange)(o,function(r){if(R.Range.isIRange(r))return T.Range.to(r);if(C.Position.isIPosition(r))return T.Position.to(r);if(R.Range.isIRange(r.range)&&w.URI.isUri(r.uri))return T.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...o)=>{const r=t.args.map((a,g)=>{if(!a.validate(o[g]))throw new Error(`Invalid argument '${a.name}' when running '${t.id}', received: ${o[g]}`);return a.convert(o[g])}),l=await this.executeCommand(t.internalId,...r);return t.result.convert(l,o,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new P.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,o,r,l){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:o,thisArg:r,description:l}),t&&this._proxy.$registerCommand(n),new P.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,o){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const r=(0,I.cloneAndChange)(n,function(l){if(l instanceof P.Position)return T.Position.from(l);if(l instanceof P.Range)return T.Range.from(l);if(l instanceof P.Location)return T.location.from(l);if(!Array.isArray(l))return l});try{const l=await this._proxy.$executeCommand(t,r,o);return(0,i.revive)(l)}catch(l){if(l instanceof Error&&l.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw l}}}async _executeContributedCommand(t,n){const o=this._commands.get(t);if(!o)throw new Error("Unknown command");let{callback:r,thisArg:l,description:a}=o;if(a)for(let g=0;g<a.args.length;g++)try{(0,_.validateConstraint)(n[g],a.args[g].constraint)}catch(E){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${a.args[g].name}' - ${a.args[g].description}`)}try{return await r.apply(l,n)}catch(g){if(t===this.converter.delegatingCommandId){const E=this.converter.getActualCommand(...n);E&&(t=E.command)}throw this._logService.error(g,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(o=>this._argumentProcessors.reduce((r,l)=>l.processArgument(r),o)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(o=>o[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,o]of this._commands){let{description:r}=o;r&&(t[n]=r)}return Promise.resolve(t)}};S=je([xe(0,d.IExtHostRpcService),xe(1,y.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=(0,s.createDecorator)("IExtHostCommands");class v{constructor(t,n,o){this._commands=t,this._lookupApiCommand=n,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const o={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return o;const r=this._lookupApiCommand(t.command);if(r)o.id=r.internalId,o.arguments=r.args.map((l,a)=>l.convert(t.arguments&&t.arguments[a]));else if((0,k.isNonEmptyArray)(t.arguments)){const l=++this._cachIdPool;this._cache.set(l,t),n.add((0,m.toDisposable)(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),o.$ident=l,o.id=this.delegatingCommandId,o.arguments=[l],this._logService.trace("CommandsConverter#CREATE",t.command,l)}return o}}fromInternal(t){const n=D.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=v;class b{constructor(t,n,o,r){this.name=t,this.description=n,this.validate=o,this.convert=r}optional(){return new b(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new b(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=b,b.Uri=new b("uri","Uri of a text document",c=>w.URI.isUri(c),c=>c),b.Position=new b("position","A position in a text document",c=>P.Position.isPosition(c),T.Position.from),b.Range=new b("range","A range in a text document",c=>P.Range.isRange(c),T.Range.from),b.Selection=new b("selection","A selection in a text document",c=>P.Selection.isSelection(c),T.Selection.from),b.Number=new b("number","",c=>typeof c=="number",c=>c),b.String=new b("string","",c=>typeof c=="string",c=>c),b.CallHierarchyItem=new b("item","A call hierarchy item",c=>c instanceof P.CallHierarchyItem,T.CallHierarchyItem.to);class p{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=p,p.Void=new p("no result",c=>c);class u{constructor(t,n,o,r,l){this.id=t,this.internalId=n,this.description=o,this.args=r,this.result=l}}e.ApiCommand=u}),define(ge[230],pe([0,1,6,20,7,79,51,202,14,107]),function(Q,e,_,P,T,I,D,k,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const R=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",w(P.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(s,d)=>{if(!(0,y.isFalsyOrEmpty)(s)){class S extends T.SymbolInformation{static to(b){const p=new S(b.name,P.SymbolKind.to(b.kind),b.containerName||"",new T.Location(d[0],P.Range.to(b.range)));return p.detail=b.detail,p.range=p.location.range,p.selectionRange=P.Range.to(b.selectionRange),p.children=b.children?b.children.map(S.to):[],p}}return s.map(S.to)}})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(P.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(P.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",s=>typeof s=="string",s=>s),new D.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(P.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",w(P.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",w(P.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",s=>Array.isArray(s)&&s.every(d=>T.Position.isPosition(d)),s=>s.map(P.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",s=>s.map(d=>{let S;for(const v of d.reverse())S=new T.SelectionRange(P.Range.to(v),S);return S}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",s=>{const d=[];if(Array.isArray(s))for(let S of s)d.push(...S[1].map(P.WorkspaceSymbol.to));return d})),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(P.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(P.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(P.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",s=>{if(!!s){if(s.rejectReason)throw new Error(s.rejectReason);return P.WorkspaceEdit.to(s)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(P.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(!!s)return new T.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!!s){const d=(0,i.decodeSemanticTokensDto)(s);if(d.type==="full")return new T.SemanticTokens(d.data,void 0)}})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(!!s)return new T.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!!s){const d=(0,i.decodeSemanticTokensDto)(s);if(d.type==="full")return new T.SemanticTokens(d.data,void 0)}})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(s,d,S)=>{if(!s)return new T.CompletionList([]);const v=s.suggestions.map(b=>P.CompletionItem.to(b,S));return new T.CompletionList(v,s.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",s=>{if(s)return P.SignatureHelp.to(s)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(s,d,S)=>w(v=>new T.CodeLens(P.Range.to(v.range),v.command&&S.fromInternal(v.command)))(s))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>T.Range.isRange(s),s=>T.Selection.isSelection(s)?P.Selection.from(s):P.Range.from(s)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(s,d,S)=>w(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return S.fromInternal(v.command)}else{const b=new T.CodeAction(v.title,v.kind?new T.CodeActionKind(v.kind):void 0);return v.edit&&(b.edit=P.WorkspaceEdit.to(v.edit)),v.command&&(b.command=S.fromInternal(v.command)),b.isPreferred=v.isPreferred,b}})(s))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(d=>new T.ColorInformation(P.Range.to(d.range),P.Color.to(d.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",s=>s instanceof T.Color,P.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:P.Range.from(s.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(P.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineHint objects",s=>s.map(P.InlineHint.to))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",w(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientMetadata:s.options.transientMetadata},filenamePattern:s.filenamePattern.map(d=>P.NotebookExclusiveDocumentPattern.to(d))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",s=>s.map(P.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[s,void 0]:[P.ViewColumn.from(s.viewColumn),P.TextEditorOpenOptions.from(s)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[s,void 0]:[P.ViewColumn.from(s.viewColumn),P.TextEditorOpenOptions.from(s)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[P.ViewColumn.from(s.viewColumn),P.TextEditorOpenOptions.from(s)]).optional()],D.ApiCommandResult.Void)];class C{constructor(d){this._disposables=new _.DisposableStore,this._commands=d}static register(d){return R.forEach(d.registerApiCommand,d),new C(d).registerCommands()}registerCommands(){const d=S=>(...v)=>S(this._commands,...v);this._register(k.RemoveFromRecentlyOpenedAPICommand.ID,d(k.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:S=>typeof S=="string"}]}),this._register(k.OpenIssueReporter.ID,d(k.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:S=>typeof S=="string"||typeof S=="object"&&typeof S.extensionId=="string"}]})}_register(d,S,v){const b=this._commands.registerCommand(!1,d,S,this,v);this._disposables.add(b)}}e.ExtHostApiCommands=C;function w(s){return d=>{if(Array.isArray(d))return d.map(s)}}function m(s){if(!!Array.isArray(s)){const d=[];for(const S of s)I.isLocationLink(S)?d.push(P.DefinitionLink.to(S)):d.push(P.location.to(S));return d}}}),define(ge[231],pe([0,1,19,68,3,6,2,79,29,20,7,5]),function(Q,e,_,P,T,I,D,k,y,i,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class w{constructor(u,c,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=u.getProxy(C.MainContext.MainThreadComments),c.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const o=this._commentControllers.get(n.handle);return o||n}else if(n&&n.$mid===7){const o=this._commentControllers.get(n.commentControlHandle);if(!o)return n;const r=o.getCommentThread(n.commentThreadHandle);return r||n}else if(n&&n.$mid===8){const o=this._commentControllers.get(n.thread.commentControlHandle);if(!o)return n;const r=o.getCommentThread(n.thread.commentThreadHandle);return r?{thread:r,text:n.text}:n}else if(n&&n.$mid===9){const o=this._commentControllers.get(n.thread.commentControlHandle);if(!o)return n;const r=o.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let l=n.commentUniqueId,a=r.getCommentByUniqueId(l);return a||n}else if(n&&n.$mid===10){const o=this._commentControllers.get(n.thread.commentControlHandle);if(!o)return n;const r=o.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let l=n.text,a=n.commentUniqueId,g=r.getCommentByUniqueId(a);return g?(g.body=l,g):n}return n}})}createCommentController(u,c,t){const n=w.handlePool++,o=new s(u,n,this._proxy,c,t);this._commentControllers.set(o.handle,o);const r=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(u.identifier))||[];return r.push(o),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(u.identifier),r),o}$createCommentThreadTemplate(u,c,t){const n=this._commentControllers.get(u);!n||n.$createCommentThreadTemplate(c,t)}async $updateCommentThreadTemplate(u,c,t){const n=this._commentControllers.get(u);!n||n.$updateCommentThreadTemplate(c,t)}$deleteCommentThread(u,c){const t=this._commentControllers.get(u);t&&t.$deleteCommentThread(c)}$provideCommentingRanges(u,c,t){const n=this._commentControllers.get(u);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const o=this._documents.getDocument(D.URI.revive(c));return(0,_.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(o,t)).then(r=>r?r.map(l=>i.Range.from(l)):void 0)}$toggleReaction(u,c,t,n,o){const r=this._commentControllers.get(u);return!r||!r.reactionHandler?Promise.resolve(void 0):(0,_.asPromise)(()=>{const l=r.getCommentThread(c);if(l){const a=l.getCommentByUniqueId(n.uniqueIdInThread);if(r!==void 0&&a&&r.reactionHandler)return r.reactionHandler(a,v(o))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=w,w.handlePool=0;class m{constructor(u,c,t,n,o,r,l){this._proxy=u,this._commentController=c,this._id=t,this._uri=n,this._range=o,this._comments=r,this.handle=m._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new T.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new I.MutableDisposable,this._acceptInputDisposables.value=new I.DisposableStore,this._id===void 0&&(this._id=`${c.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,i.Range.from(this._range),l),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){u.isEqual(this._range)||(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new I.DisposableStore);const u=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),c={};u("range")&&(c.range=i.Range.from(this._range)),u("label")&&(c.label=this.label),u("contextValue")&&(c.contextValue=this.contextValue),u("comments")&&(c.comments=this._comments.map(t=>d(this,this._commentController,t,this._commentsMap))),u("collapsibleState")&&(c.collapseState=b(this._collapseState)),u("canReply")&&(c.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,c)}}getCommentByUniqueId(u){for(let c of this._commentsMap){let t=c[0],n=c[1];if(u===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}m._handlePool=0,je([(0,P.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=m;class s{constructor(u,c,t,n,o){this._extension=u,this._handle=c,this._proxy=t,this._id=n,this._label=o,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,o)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(u,c,t,n){if(typeof u=="string"){const o=new m(this._proxy,this,u,c,t,n,this._extension.identifier);return this._threads.set(o.handle,o),o}else{const o=new m(this._proxy,this,void 0,u,c,t,this._extension.identifier);return this._threads.set(o.handle,o),o}}$createCommentThreadTemplate(u,c){const t=new m(this._proxy,this,void 0,D.URI.revive(u),i.Range.to(c),[],this._extension.identifier);return t.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(u,c){let t=this._threads.get(u);t&&(t.range=i.Range.to(c))}$deleteCommentThread(u){let c=this._threads.get(u);c&&c.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function d(p,u,c,t){let n=t.get(c);n||(n=++p.commentHandle,t.set(c,n));const o=c.author&&c.author.iconPath?c.author.iconPath.toString():void 0;return{mode:c.mode,contextValue:c.contextValue,uniqueIdInThread:n,body:i.MarkdownString.from(c.body),userName:c.author.name,userIconPath:o,label:c.label,commentReactions:c.reactions?c.reactions.map(r=>S(r)):void 0}}function S(p){return{label:p.label,iconPath:p.iconPath?i.pathOrURIToURI(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted}}function v(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?D.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1}}function b(p){if(p!==void 0)switch(p){case R.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}}),define(ge[124],pe([0,1,2,5,7,4,13,12,14,10,8]),function(Q,e,_,P,T,I,D,k,y,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class fn{constructor(m,s){this._logService=s,this._provider=new Map,this._proxy=m.getProxy(P.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,s){const d=fn._handlePool++;this._provider.set(d,{provider:m,extensionId:s}),this._proxy.$registerDecorationProvider(d,s.value);const S=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(v=>{if(!v){this._proxy.$onDidChange(d,null);return}let b=(0,y.asArray)(v);if(b.length<=fn._maxEventSize){this._proxy.$onDidChange(d,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.value,b.length);const p=b.map(t=>({uri:t,rank:(0,i.count)(t.path,"/")})),u=(0,y.groupBy)(p,(t,n)=>t.rank-n.rank||(0,i.compare)(t.uri.path,n.uri.path));let c=[];e:for(let t of u){let n;for(let o of t){let r=(0,R.dirname)(o.uri.path);if(n!==r&&(n=r,c.push(o.uri)>=fn._maxEventSize))break e}}this._proxy.$onDidChange(d,c)});return new T.Disposable(()=>{S==null||S.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(m,s,d){if(!this._provider.has(m))return Object.create(null);const S=Object.create(null),{provider:v,extensionId:b}=this._provider.get(m);return await Promise.all(s.map(async p=>{try{const{uri:u,id:c}=p,t=await Promise.resolve(v.provideFileDecoration(_.URI.revive(u),d));if(!t)return;try{T.FileDecoration.validate(t),S[c]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${b.value}': ${n}`)}}catch(u){this._logService.error(u)}})),S}};C._handlePool=0,C._maxEventSize=250,C=je([xe(0,D.IExtHostRpcService),xe(1,k.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,I.createDecorator)("IExtHostDecorations")}),define(ge[232],pe([0,1,159,111,2,5,7,20,3,12,24]),function(Q,e,_,P,T,I,D,k,y,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{constructor(s,d,S,v,b){this._name=s,this._owner=d,this._maxDiagnosticsPerFile=S,this._proxy=v,this._onDidChangeDiagnostics=b,this._isDisposed=!1,this._data=new R.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(s,d){if(!s){this.clear();return}this._checkDisposed();let S=[];if(T.URI.isUri(s)){if(!d){this.delete(s);return}this._data.set(s,d.slice()),S=[s]}else if(Array.isArray(s)){S=[];let b;s=[...s].sort(C._compareIndexedTuplesByUri);for(const p of s){const[u,c]=p;if((!b||u.toString()!==b.toString())&&(b&&this._data.get(b).length===0&&this._data.delete(b),b=u,S.push(u),this._data.set(u,[])),c){const t=this._data.get(u);t&&t.push(...c)}else{const t=this._data.get(u);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(S),!!this._proxy){const v=[];for(let b of S){let p=[];const u=this._data.get(b);if(u)if(u.length>this._maxDiagnosticsPerFile){p=[];const c=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of u)if(n.severity===c[t]&&p.push(k.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;p.push({severity:P.MarkerSeverity.Info,message:(0,_.localize)(0,null,u.length-this._maxDiagnosticsPerFile),startLineNumber:p[p.length-1].startLineNumber,startColumn:p[p.length-1].startColumn,endLineNumber:p[p.length-1].endLineNumber,endColumn:p[p.length-1].endColumn})}else p=u.map(c=>k.Diagnostic.from(c));v.push([b,p])}this._proxy.$changeMany(this._owner,v)}}delete(s){this._checkDisposed(),this._onDidChangeDiagnostics.fire([s]),this._data.delete(s),this._proxy&&this._proxy.$changeMany(this._owner,[[s,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(s,d){this._checkDisposed();for(let S of this._data.keys())s.apply(d,[S,this.get(S),this])}get(s){this._checkDisposed();const d=this._data.get(s);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(s){return this._checkDisposed(),Array.isArray(this._data.get(s))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(s,d){return s[0].toString()<d[0].toString()?-1:s[0].toString()>d[0].toString()?1:0}}e.DiagnosticCollection=C;let w=class Ht{constructor(s,d){this._logService=d,this._collections=new Map,this._onDidChangeDiagnostics=new y.Emitter,this.onDidChangeDiagnostics=y.Event.map(y.Event.debounce(this._onDidChangeDiagnostics.event,Ht._debouncer,50),Ht._mapper),this._proxy=s.getProxy(I.MainContext.MainThreadDiagnostics)}static _debouncer(s,d){return s?s.concat(d):d}static _mapper(s){const d=[],S=new Set;for(const v of s)typeof v=="string"?S.has(v)||(S.add(v),d.push(T.URI.parse(v))):S.has(v.toString())||(S.add(v.toString()),d.push(v));return Object.freeze(d),{uris:d}}createDiagnosticCollection(s,d){const{_collections:S,_proxy:v,_onDidChangeDiagnostics:b,_logService:p}=this,u=new class{$changeMany(n,o){v.$changeMany(n,o),p.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,n,o.length===0?"CLEARING":o)}$clear(n){v.$clear(n),p.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,n)}dispose(){v.dispose()}};let c;if(!d)d="_generated_diagnostic_collection_name_#"+Ht._idPool++,c=d;else if(!S.has(d))c=d;else{this._logService.warn(`DiagnosticCollection with name '${d}' does already exist.`);do c=d+Ht._idPool++;while(S.has(c))}return new class extends C{constructor(){super(d,c,Ht._maxDiagnosticsPerFile,u,b);S.set(c,this)}dispose(){super.dispose(),S.delete(c)}}}getDiagnostics(s){if(s)return this._getDiagnostics(s);{const d=new Map,S=[];for(const v of this._collections.values())v.forEach((b,p)=>{let u=d.get(b.toString());typeof u=="undefined"&&(u=S.length,d.set(b.toString(),u),S.push([b,[]])),S[u][1]=S[u][1].concat(...p)});return S}}_getDiagnostics(s){let d=[];for(let S of this._collections.values())S.has(s)&&(d=d.concat(S.get(s)));return d}$acceptMarkersChange(s){if(!this._mirrorCollection){const d="_generated_mirror",S=new C(d,d,Ht._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(d,S),this._mirrorCollection=S}for(const[d,S]of s)this._mirrorCollection.set(T.URI.revive(d),S.map(k.Diagnostic.to))}};w._idPool=0,w._maxDiagnosticsPerFile=1e3,w=je([xe(1,i.ILogService)],w),e.ExtHostDiagnostics=w}),define(ge[233],pe([0,1,2,5]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class T{constructor(D){this._proxy=D.getProxy(P.MainContext.MainThreadDialogs)}showOpenDialog(D){return this._proxy.$showOpenDialog(D).then(k=>k?k.map(y=>_.URI.revive(y)):void 0)}showSaveDialog(D){return this._proxy.$showSaveDialog(D).then(k=>k?_.URI.revive(k):void 0)}}e.ExtHostDialogs=T}),define(ge[234],pe([0,1,18,2,7,5,11,21,10]),function(Q,e,_,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class i{constructor(C,w,m){this._documentsAndEditors=w,this._logService=m,this._documentContentProviders=new Map,this._proxy=C.getProxy(I.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,w){if(Object.keys(D.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const m=i._handlePool++;this._documentContentProviders.set(m,w),this._proxy.$registerTextContentProvider(m,C);let s;return typeof w.onDidChange=="function"&&(s=w.onDidChange(d=>{if(d.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(m,d).then(S=>{if(!(!S&&typeof S!="string")){const v=this._documentsAndEditors.getDocument(d);if(!!v){const b=(0,y.splitLines)(S);if(!v.equalLines(b))return this._proxy.$onVirtualDocumentChange(d,S)}}},_.onUnexpectedError)})),new T.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),s&&(s.dispose(),s=void 0)})}$provideTextDocumentContent(C,w){const m=this._documentContentProviders.get(C);return m?Promise.resolve(m.provideTextDocumentContent(P.URI.revive(w),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${w.scheme}`))}}e.ExtHostDocumentContentProvider=i,i._handlePool=0}),define(ge[235],pe([0,1,3,6,2,5,118,20,15,23]),function(Q,e,_,P,T,I,D,k,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class R{constructor(w,m){this._onDidAddDocument=new _.Emitter,this._onDidRemoveDocument=new _.Emitter,this._onDidChangeDocument=new _.Emitter,this._onDidSaveDocument=new _.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new P.DisposableStore,this._documentLoader=new Map,this._proxy=w.getProxy(I.MainContext.MainThreadDocuments),this._documentsAndEditors=m,this._documentsAndEditors.onDidRemoveDocuments(s=>{for(const d of s)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(s=>{for(const d of s)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(w){if(!!w){const m=this._documentsAndEditors.getDocument(w);if(m)return m}}getDocument(w){const m=this.getDocumentData(w);if(!(m==null?void 0:m.document))throw new Error(`Unable to retrieve document from URI '${w}'`);return m.document}ensureDocumentData(w){const m=this._documentsAndEditors.getDocument(w);if(m)return Promise.resolve(m);let s=this._documentLoader.get(w.toString());return s||(s=this._proxy.$tryOpenDocument(w).then(d=>{this._documentLoader.delete(w.toString());const S=T.URI.revive(d);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(S))},d=>(this._documentLoader.delete(w.toString()),Promise.reject(d))),this._documentLoader.set(w.toString(),s)),s}createDocumentData(w){return this._proxy.$tryCreateDocument(w).then(m=>T.URI.revive(m))}$acceptModelModeChanged(w,m){const s=T.URI.revive(w),d=this._documentsAndEditors.getDocument(s);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(m),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(w){const m=T.URI.revive(w),s=this._documentsAndEditors.getDocument(m);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this._onDidSaveDocument.fire(s.document)}$acceptDirtyStateChanged(w,m){const s=T.URI.revive(w),d=this._documentsAndEditors.getDocument(s);if(!d)throw new Error("unknown document");d._acceptIsDirty(m),this._onDidChangeDocument.fire({document:d.document,contentChanges:[]})}$acceptModelChanged(w,m,s){const d=T.URI.revive(w),S=this._documentsAndEditors.getDocument(d);if(!S)throw new Error("unknown document");S._acceptIsDirty(s),S.onEvents(m),this._onDidChangeDocument.fire((0,i.deepFreeze)({document:S.document,contentChanges:m.changes.map(v=>({range:k.Range.to(v.range),rangeOffset:v.rangeOffset,rangeLength:v.rangeLength,text:v.text}))}))}setWordDefinitionFor(w,m){(0,D.setWordDefinitionFor)(w,m)}}e.ExtHostDocuments=R}),define(ge[39],pe([0,1,52,3,6,2,4,5,118,13,122,20,12,24,11,71,133]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class v{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(u,c){this._extHostRpc=u,this._logService=c,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new P.Emitter,this._onDidRemoveDocuments=new P.Emitter,this._onDidChangeVisibleTextEditors=new P.Emitter,this._onDidChangeActiveTextEditor=new P.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const c=[],t=[],n=[];if(u.removedDocuments)for(const o of u.removedDocuments){const r=I.URI.revive(o),l=this._documents.get(r);(l==null?void 0:l.unref())&&(this._documents.delete(r),c.push(l.value))}if(u.addedDocuments)for(const o of u.addedDocuments){const r=I.URI.revive(o.uri);let l=this._documents.get(r);if(l&&r.scheme!==s.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);l||(l=new v(new y.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),r,o.lines,o.EOL,o.versionId,o.modeId,o.isDirty,o.notebook)),this._documents.set(r,l),t.push(l.value)),l.ref()}if(u.removedEditors)for(const o of u.removedEditors){const r=this._editors.get(o);this._editors.delete(o),r&&n.push(r)}if(u.addedEditors)for(const o of u.addedEditors){const r=I.URI.revive(o.documentUri);_.ok(this._documents.has(r),`document '${r}' does not exist`),_.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const l=this._documents.get(r).value,a=new R.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new S.Lazy(()=>l.document),o.selections.map(C.Selection.to),o.options,o.visibleRanges.map(g=>C.Range.to(g)),typeof o.editorPosition=="number"?C.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,a)}u.newActiveEditor!==void 0&&(_.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),(0,T.dispose)(c),(0,T.dispose)(n),u.removedDocuments&&this._onDidRemoveDocuments.fire(c),u.addedDocuments&&this._onDidAddDocuments.fire(t),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){var c;return(c=this._documents.get(u))===null||c===void 0?void 0:c.value}allDocuments(){return d.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!!this._activeEditorId){const c=this._editors.get(this._activeEditorId);return u?c:c==null?void 0:c.value}}allEditors(){return[...this._editors.values()]}};b=je([xe(0,i.IExtHostRpcService),xe(1,w.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(ge[236],pe([0,1,2,5,6,7,20,141,10,22]),function(Q,e,_,P,T,I,D,k,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class R{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const s=this._schemes.indexOf(m);s>=0&&(this._schemes.splice(s,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),s=[];let d,S,v=14,b=14;for(const p of m){let u=d?(0,y.commonPrefixLength)(d,p):0;for(u===0?S=1:S=b;u<p.length;u++)u+1===p.length?(v=b,b=9):b+=1,s.push([S,p.toUpperCase().charCodeAt(u),b]),s.push([S,p.toLowerCase().charCodeAt(u),b]),S=b;d=p,b=v}s.push([9,58,10]),s.push([10,47,12]),this._stateMachine=new k.StateMachine(s)}}provideDocumentLinks(m){this._initStateMachine();const s=[],d=k.LinkComputer.computeLinks({getLineContent(S){return m.lineAt(S-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const S of d){const v=D.DocumentLink.to(S);v.target&&s.push(v)}return s}}class C{constructor(m,s){this._extHostLanguageFeatures=s,this._linkProvider=new R,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(P.MainContext.MainThreadFileSystem)}dispose(){var m;(m=this._linkProviderRegistration)===null||m===void 0||m.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,s,d,S={}){if(this._registeredSchemes.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const v=this._handlePool++;this._linkProvider.add(s),this._registeredSchemes.add(s),this._fsProvider.set(v,d);let b=2;S.isCaseSensitive&&(b+=1024),S.isReadonly&&(b+=2048),typeof d.copy=="function"&&(b+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&(b+=4),this._proxy.$registerFileSystemProvider(v,s,b).catch(u=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${s}`),console.error(u)});const p=d.onDidChangeFile(u=>{const c=[];for(const t of u){let{uri:n,type:o}=t;if(n.scheme===s){let r;switch(o){case I.FileChangeType.Changed:r=0;break;case I.FileChangeType.Created:r=1;break;case I.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:n,type:r})}}this._proxy.$onFileSystemChange(v,c)});return(0,T.toDisposable)(()=>{p.dispose(),this._linkProvider.delete(s),this._registeredSchemes.delete(s),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(m){const{type:s,ctime:d,mtime:S,size:v}=m;return{type:s,ctime:d,mtime:S,size:v}}$stat(m,s){return Promise.resolve(this._getFsProvider(m).stat(_.URI.revive(s))).then(C._asIStat)}$readdir(m,s){return Promise.resolve(this._getFsProvider(m).readDirectory(_.URI.revive(s)))}$readFile(m,s){return Promise.resolve(this._getFsProvider(m).readFile(_.URI.revive(s))).then(d=>i.VSBuffer.wrap(d))}$writeFile(m,s,d,S){return Promise.resolve(this._getFsProvider(m).writeFile(_.URI.revive(s),d.buffer,S))}$delete(m,s,d){return Promise.resolve(this._getFsProvider(m).delete(_.URI.revive(s),d))}$rename(m,s,d,S){return Promise.resolve(this._getFsProvider(m).rename(_.URI.revive(s),_.URI.revive(d),S))}$copy(m,s,d,S){const v=this._getFsProvider(m);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(_.URI.revive(s),_.URI.revive(d),S))}$mkdir(m,s){return Promise.resolve(this._getFsProvider(m).createDirectory(_.URI.revive(s)))}$watch(m,s,d,S){const v=this._getFsProvider(m).watch(_.URI.revive(d),S);this._watches.set(s,v)}$unwatch(m,s){const d=this._watches.get(s);d&&(d.dispose(),this._watches.delete(s))}$open(m,s,d){const S=this._getFsProvider(m);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(_.URI.revive(s),d))}$close(m,s){const d=this._getFsProvider(m);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(s))}$read(m,s,d,S){const v=this._getFsProvider(m);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const b=i.VSBuffer.alloc(S);return Promise.resolve(v.read(s,d,b.buffer,0,S)).then(p=>b.slice(0,p))}$write(m,s,d,S){const v=this._getFsProvider(m);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(s,d,S.buffer,0,S.byteLength))}_getFsProvider(m){const s=this._fsProvider.get(m);if(!s){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return s}}e.ExtHostFileSystem=C}),define(ge[88],pe([0,1,5,45,7,22,4,13,60]),function(Q,e,_,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let i=class Mt{constructor(C,w){const m=C.getProxy(_.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(s){return m.$stat(s).catch(Mt._handleError)},readDirectory(s){return m.$readdir(s).catch(Mt._handleError)},createDirectory(s){return m.$mkdir(s).catch(Mt._handleError)},async readFile(s){return m.$readFile(s).then(d=>d.buffer).catch(Mt._handleError)},writeFile(s,d){return m.$writeFile(s,I.VSBuffer.wrap(d)).catch(Mt._handleError)},delete(s,d){return m.$delete(s,Object.assign({recursive:!1,useTrash:!1},d)).catch(Mt._handleError)},rename(s,d,S){return m.$rename(s,d,Object.assign({overwrite:!1},S)).catch(Mt._handleError)},copy(s,d,S){return m.$copy(s,d,Object.assign({overwrite:!1},S)).catch(Mt._handleError)},isWritableFileSystem(s){const d=w.getCapabilities(s);if(typeof d=="number")return!(d&2048)}})}static _handleError(C){if(!(C instanceof Error))throw new T.FileSystemError(String(C));if(C.name==="ENOPRO")throw T.FileSystemError.Unavailable(C.message);switch(C.name){case P.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(C.message);case P.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(C.message);case P.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(C.message);case P.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(C.message);case P.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(C.message);case P.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(C.message);default:throw new T.FileSystemError(C.message,C.name)}}};i=je([xe(0,k.IExtHostRpcService),xe(1,y.IExtHostFileSystemInfo)],i),e.ExtHostConsumerFileSystem=i,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(ge[237],pe([0,1,6,5]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class T{constructor(D){this._handlePool=0,this._proxy=D.getProxy(P.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,D),(0,_.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=T}),define(ge[238],pe([0,1,2,23,20,7,19,5,10,44,14,15,138,6,107,70,84,47,18]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class p{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentSymbols(z,Y){const te=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideDocumentSymbols(te,Y)).then(ae=>{if(!(0,R.isFalsyOrEmpty)(ae))return ae[0]instanceof I.DocumentSymbol?ae.map(T.DocumentSymbol.from):p._asDocumentSymbolTree(ae)})}static _asDocumentSymbolTree(z){var Y;z=z.slice(0).sort((fe,De)=>{let Me=fe.location.range.start.compareTo(De.location.range.start);return Me===0&&(Me=De.location.range.end.compareTo(fe.location.range.end)),Me});const te=[],ae=[];for(const fe of z){const De={name:fe.name||"!!MISSING: name!!",kind:T.SymbolKind.from(fe.kind),tags:((Y=fe.tags)===null||Y===void 0?void 0:Y.map(T.SymbolTag.from))||[],detail:"",containerName:fe.containerName,range:T.Range.from(fe.location.range),selectionRange:T.Range.from(fe.location.range),children:[]};for(;;){if(ae.length===0){ae.push(De),te.push(De);break}const Me=ae[ae.length-1];if(i.Range.containsRange(Me.range,De.range)&&!i.Range.equalsRange(Me.range,De.range)){Me.children&&Me.children.push(De),ae.push(De);break}ae.pop()}}return te}}class u{constructor(z,Y,te){this._documents=z,this._commands=Y,this._provider=te,this._cache=new S.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,Y){const te=this._documents.getDocument(z),ae=await this._provider.provideCodeLenses(te,Y);if(!(!ae||Y.isCancellationRequested)){const fe=this._cache.add(ae),De=new m.DisposableStore;this._disposables.set(fe,De);const Me={cacheId:fe,lenses:[]};for(let be=0;be<ae.length;be++)Me.lenses.push({cacheId:[fe,be],range:T.Range.from(ae[be].range),command:this._commands.toInternal(ae[be].command,De)});return Me}}async resolveCodeLens(z,Y){var te;const ae=z.cacheId&&this._cache.get(...z.cacheId);if(!!ae){let fe;if(typeof this._provider.resolveCodeLens!="function"||ae.isResolved?fe=ae:fe=await this._provider.resolveCodeLens(ae,Y),fe||(fe=ae),!Y.isCancellationRequested){const De=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!De)return z.command=this._commands.toInternal((te=fe.command)!==null&&te!==void 0?te:u._badCmd,De),z}}}releaseCodeLenses(z){var Y;(Y=this._disposables.get(z))===null||Y===void 0||Y.dispose(),this._disposables.delete(z),this._cache.delete(z)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function c(Fe){return Array.isArray(Fe)?Fe.map(T.DefinitionLink.from):Fe?[T.DefinitionLink.from(Fe)]:[]}class t{constructor(z,Y){this._documents=z,this._provider=Y}provideDefinition(z,Y,te){const ae=this._documents.getDocument(z),fe=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideDefinition(ae,fe,te)).then(c)}}class n{constructor(z,Y){this._documents=z,this._provider=Y}provideDeclaration(z,Y,te){const ae=this._documents.getDocument(z),fe=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideDeclaration(ae,fe,te)).then(c)}}class o{constructor(z,Y){this._documents=z,this._provider=Y}provideImplementation(z,Y,te){const ae=this._documents.getDocument(z),fe=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideImplementation(ae,fe,te)).then(c)}}class r{constructor(z,Y){this._documents=z,this._provider=Y}provideTypeDefinition(z,Y,te){const ae=this._documents.getDocument(z),fe=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideTypeDefinition(ae,fe,te)).then(c)}}class l{constructor(z,Y){this._documents=z,this._provider=Y}provideHover(z,Y,te){const ae=this._documents.getDocument(z),fe=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideHover(ae,fe,te)).then(De=>{if(!(!De||(0,R.isFalsyOrEmpty)(De.contents)))return De.range||(De.range=ae.getWordRangeAtPosition(fe)),De.range||(De.range=new I.Range(fe,fe)),T.Hover.from(De)})}}class a{constructor(z,Y){this._documents=z,this._provider=Y}provideEvaluatableExpression(z,Y,te){const ae=this._documents.getDocument(z),fe=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideEvaluatableExpression(ae,fe,te)).then(De=>{if(De)return T.EvaluatableExpression.from(De)})}}class g{constructor(z,Y){this._documents=z,this._provider=Y}provideInlineValues(z,Y,te,ae){const fe=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideInlineValues(fe,T.Range.to(Y),T.InlineValueContext.to(te),ae)).then(De=>{if(Array.isArray(De))return De.map(Me=>T.InlineValue.from(Me))})}}class E{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentHighlights(z,Y,te){const ae=this._documents.getDocument(z),fe=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideDocumentHighlights(ae,fe,te)).then(De=>{if(Array.isArray(De))return De.map(T.DocumentHighlight.from)})}}class f{constructor(z,Y){this._documents=z,this._provider=Y}provideLinkedEditingRanges(z,Y,te){const ae=this._documents.getDocument(z),fe=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideLinkedEditingRanges(ae,fe,te)).then(De=>{if(De&&Array.isArray(De.ranges))return{ranges:(0,R.coalesce)(De.ranges.map(T.Range.from)),wordPattern:De.wordPattern}})}}class h{constructor(z,Y){this._documents=z,this._provider=Y}provideReferences(z,Y,te,ae){const fe=this._documents.getDocument(z),De=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideReferences(fe,De,te,ae)).then(Me=>{if(Array.isArray(Me))return Me.map(T.location.from)})}}class A{constructor(z,Y,te,ae,fe,De,Me){this._documents=z,this._commands=Y,this._diagnostics=te,this._provider=ae,this._logService=fe,this._extension=De,this._apiDeprecation=Me,this._cache=new S.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(z,Y,te,ae){const fe=this._documents.getDocument(z),De=w.Selection.isISelection(Y)?T.Selection.to(Y):T.Range.to(Y),Me=[];for(const ke of this._diagnostics.getDiagnostics(z))if(De.intersection(ke.range)&&Me.push(ke)>A._maxCodeActionsPerFile)break;const be={diagnostics:Me,only:te.only?new I.CodeActionKind(te.only):void 0,triggerKind:T.CodeActionTriggerKind.to(te.trigger)};return(0,D.asPromise)(()=>this._provider.provideCodeActions(fe,De,be,ae)).then(ke=>{var Re;if(!(!(0,R.isNonEmptyArray)(ke)||ae.isCancellationRequested)){const Be=this._cache.add(ke),Ee=new m.DisposableStore;this._disposables.set(Be,Ee);const Ke=[];for(let X=0;X<ke.length;X++){const re=ke[X];!re||(A._isCommand(re)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:re.title,command:this._commands.toInternal(re,Ee)})):(be.only&&(re.kind?be.only.contains(re.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action is of kind '${re.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[Be,X],title:re.title,command:re.command&&this._commands.toInternal(re.command,Ee),diagnostics:re.diagnostics&&re.diagnostics.map(T.Diagnostic.from),edit:re.edit&&T.WorkspaceEdit.from(re.edit),kind:re.kind&&re.kind.value,isPreferred:re.isPreferred,disabled:(Re=re.disabled)===null||Re===void 0?void 0:Re.reason})))}return{cacheId:Be,actions:Ke}}})}async resolveCodeAction(z,Y){var te;const[ae,fe]=z,De=this._cache.get(ae,fe);if(!(!De||A._isCommand(De))&&!!this._provider.resolveCodeAction){const Me=(te=await this._provider.resolveCodeAction(De,Y))!==null&&te!==void 0?te:De;return(Me==null?void 0:Me.edit)?T.WorkspaceEdit.from(Me.edit):void 0}}releaseCodeActions(z){var Y;(Y=this._disposables.get(z))===null||Y===void 0||Y.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}A._maxCodeActionsPerFile=1e3;class L{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentFormattingEdits(z,Y,te){const ae=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideDocumentFormattingEdits(ae,Y,te)).then(fe=>{if(Array.isArray(fe))return fe.map(T.TextEdit.from)})}}class B{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentRangeFormattingEdits(z,Y,te,ae){const fe=this._documents.getDocument(z),De=T.Range.to(Y);return(0,D.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(fe,De,te,ae)).then(Me=>{if(Array.isArray(Me))return Me.map(T.TextEdit.from)})}}class ee{constructor(z,Y){this._documents=z,this._provider=Y,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(z,Y,te,ae,fe){const De=this._documents.getDocument(z),Me=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(De,Me,te,ae,fe)).then(be=>{if(Array.isArray(be))return be.map(T.TextEdit.from)})}}class j{constructor(z,Y){this._provider=z,this._logService=Y,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(z,Y){const te=k.IdObject.mixin({symbols:[]});return(0,D.asPromise)(()=>this._provider.provideWorkspaceSymbols(z,Y)).then(ae=>{if((0,R.isNonEmptyArray)(ae)){for(const fe of ae)if(!!fe){if(!fe.name){this._logService.warn("INVALID SymbolInformation, lacks name",fe);continue}const De=k.IdObject.mixin(T.WorkspaceSymbol.from(fe));this._symbolCache.set(De._id,fe),te.symbols.push(De)}}}).then(()=>(te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te))}async resolveWorkspaceSymbol(z,Y){if(typeof this._provider.resolveWorkspaceSymbol!="function")return z;const te=this._symbolCache.get(z._id);if(te){const ae=await(0,D.asPromise)(()=>this._provider.resolveWorkspaceSymbol(te,Y));return ae&&(0,P.mixin)(z,T.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(z){const Y=this._resultCache.get(z);if(Y){for(let[te,ae]=Y;te<=ae;te++)this._symbolCache.delete(te);this._resultCache.delete(z)}}}class x{constructor(z,Y,te){this._documents=z,this._provider=Y,this._logService=te}static supportsResolving(z){return typeof z.prepareRename=="function"}provideRenameEdits(z,Y,te,ae){const fe=this._documents.getDocument(z),De=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.provideRenameEdits(fe,De,te,ae)).then(Me=>{if(!!Me)return T.WorkspaceEdit.from(Me)},Me=>{const be=x._asMessage(Me);return be?{rejectReason:be,edits:void 0}:Promise.reject(Me)})}resolveRenameLocation(z,Y,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(z),fe=T.Position.to(Y);return(0,D.asPromise)(()=>this._provider.prepareRename(ae,fe,te)).then(De=>{let Me,be;if(I.Range.isRange(De)?(Me=De,be=ae.getText(De)):(0,C.isObject)(De)&&(Me=De.range,be=De.placeholder),!!Me){if(Me.start.line>fe.line||Me.end.line<fe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:T.Range.from(Me),text:be}}},De=>{const Me=x._asMessage(De);return Me?{rejectReason:Me,range:void 0,text:void 0}:Promise.reject(De)})}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ${constructor(z,Y){this.resultId=z,this.tokens=Y}}class F{constructor(z,Y){this._documents=z,this._provider=Y,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(z,Y,te){const ae=this._documents.getDocument(z),fe=Y!==0?this._previousResults.get(Y):null;return(0,D.asPromise)(()=>fe&&typeof fe.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ae,fe.resultId,te):this._provider.provideDocumentSemanticTokens(ae,te)).then(De=>(fe&&this._previousResults.delete(Y),De?(De=F._fixProvidedSemanticTokens(De),this._send(F._convertToEdits(fe,De),De)):null))}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return F._isSemanticTokens(z)?F._isCorrectSemanticTokens(z)?z:new I.SemanticTokens(new Uint32Array(z.data),z.resultId):F._isSemanticTokensEdits(z)?F._isCorrectSemanticTokensEdits(z)?z:new I.SemanticTokensEdits(z.edits.map(Y=>new I.SemanticTokensEdit(Y.start,Y.deleteCount,Y.data?new Uint32Array(Y.data):Y.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const Y of z.edits)if(!(Y.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,Y){if(!F._isSemanticTokens(Y)||!z||!z.tokens)return Y;const te=z.tokens,ae=te.length,fe=Y.data,De=fe.length;let Me=0;const be=Math.min(ae,De);for(;Me<be&&te[Me]===fe[Me];)Me++;if(Me===ae&&Me===De)return new I.SemanticTokensEdits([],Y.resultId);let ke=0;const Re=be-Me;for(;ke<Re&&te[ae-ke-1]===fe[De-ke-1];)ke++;return new I.SemanticTokensEdits([{start:Me,deleteCount:ae-Me-ke,data:fe.subarray(Me,De-ke)}],Y.resultId)}_send(z,Y){if(F._isSemanticTokens(z)){const te=this._nextResultId++;return this._previousResults.set(te,new $(z.resultId,z.data)),(0,s.encodeSemanticTokensDto)({id:te,type:"full",data:z.data})}if(F._isSemanticTokensEdits(z)){const te=this._nextResultId++;return F._isSemanticTokens(Y)?this._previousResults.set(te,new $(Y.resultId,Y.data)):this._previousResults.set(te,new $(z.resultId)),(0,s.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(z.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=F;class U{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentRangeSemanticTokens(z,Y,te){const ae=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(ae,T.Range.to(Y),te)).then(fe=>fe?this._send(fe):null)}_send(z){return(0,s.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=U;class M{constructor(z,Y,te,ae,fe){this._documents=z,this._commands=Y,this._provider=te,this._apiDeprecation=ae,this._extension=fe,this._cache=new S.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,Y,te,ae){const fe=this._documents.getDocument(z),De=T.Position.to(Y),Me=fe.getWordRangeAtPosition(De)||new I.Range(De,De),be=Me.with({end:De}),ke=new v.StopWatch(!0),Re=await(0,D.asPromise)(()=>this._provider.provideCompletionItems(fe,De,ae,T.CompletionContext.to(te)));if(!!Re&&!ae.isCancellationRequested){const Be=Array.isArray(Re)?new I.CompletionList(Re):Re,Ee=M.supportsResolving(this._provider)?this._cache.add(Be.items):this._cache.add([]),Ke=new m.DisposableStore;this._disposables.set(Ee,Ke);const X=[],re={x:Ee,b:X,a:{replace:T.Range.from(Me),insert:T.Range.from(be)},c:Be.isIncomplete||void 0,d:ke.elapsed()};for(let _e=0;_e<Be.items.length;_e++){const Ne=Be.items[_e],Ve=this._convertCompletionItem(Ne,[Ee,_e],be,Me);X.push(Ve)}return re}}async resolveCompletionItem(z,Y){if(typeof this._provider.resolveCompletionItem=="function"){const te=this._cache.get(...z);if(!!te){const ae=await(0,D.asPromise)(()=>this._provider.resolveCompletionItem(te,Y));if(!!ae)return this._convertCompletionItem(ae,z)}}}releaseCompletionItems(z){var Y;(Y=this._disposables.get(z))===null||Y===void 0||Y.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,Y,te,ae){var fe;const De=this._disposables.get(Y[0]);if(!De)throw Error("DisposableStore is missing...");const Me={x:Y,a:(fe=z.label)!==null&&fe!==void 0?fe:"",o:z.label2,b:z.kind!==void 0?T.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(T.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:T.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(T.TextEdit.from),m:this._commands.toInternal(z.command,De)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Me.h=z.textEdit.newText):typeof z.insertText=="string"?Me.h=z.insertText:z.insertText instanceof I.SnippetString&&(Me.h=z.insertText.value,Me.i|=4);let be;return z.textEdit?be=z.textEdit.range:z.range&&(be=z.range),I.Range.isRange(be)?Me.j=T.Range.from(be):be&&(!(te==null?void 0:te.isEqual(be.inserting))||!(ae==null?void 0:ae.isEqual(be.replacing)))&&(Me.j={insert:T.Range.from(be.inserting),replace:T.Range.from(be.replacing)}),Me}}class N{constructor(z,Y){this._documents=z,this._provider=Y,this._cache=new S.Cache("SignatureHelp")}provideSignatureHelp(z,Y,te,ae){const fe=this._documents.getDocument(z),De=T.Position.to(Y),Me=this.reviveContext(te);return(0,D.asPromise)(()=>this._provider.provideSignatureHelp(fe,De,ae,Me)).then(be=>{if(be){const ke=this._cache.add([be]);return Object.assign(Object.assign({},T.SignatureHelp.from(be)),{id:ke})}})}reviveContext(z){let Y;if(z.activeSignatureHelp){const te=T.SignatureHelp.to(z.activeSignatureHelp),ae=this._cache.get(z.activeSignatureHelp.id,0);ae?(Y=ae,Y.activeSignature=te.activeSignature,Y.activeParameter=te.activeParameter):Y=te}return Object.assign(Object.assign({},z),{activeSignatureHelp:Y})}releaseSignatureHelp(z){this._cache.delete(z)}}class O{constructor(z,Y){this._documents=z,this._provider=Y}provideInlineHints(z,Y,te){const ae=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideInlineHints(ae,T.Range.to(Y),te)).then(fe=>fe?{hints:fe.map(T.InlineHint.from)}:void 0)}}class V{constructor(z,Y){this._documents=z,this._provider=Y,this._cache=new S.Cache("DocumentLink")}provideLinks(z,Y){const te=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideDocumentLinks(te,Y)).then(ae=>{if(!(!Array.isArray(ae)||ae.length===0)&&!Y.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.map(T.DocumentLink.from)};{const fe=this._cache.add(ae),De={links:[],id:fe};for(let Me=0;Me<ae.length;Me++){const be=T.DocumentLink.from(ae[Me]);be.cacheId=[fe,Me],De.links.push(be)}return De}}})}resolveLink(z,Y){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const te=this._cache.get(...z);return te?(0,D.asPromise)(()=>this._provider.resolveDocumentLink(te,Y)).then(ae=>ae&&T.DocumentLink.from(ae)||void 0):Promise.resolve(void 0)}releaseLinks(z){this._cache.delete(z)}}class q{constructor(z,Y){this._documents=z,this._provider=Y}provideColors(z,Y){const te=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideDocumentColors(te,Y)).then(ae=>Array.isArray(ae)?ae.map(De=>({color:T.Color.from(De.color),range:T.Range.from(De.range)})):[])}provideColorPresentations(z,Y,te){const ae=this._documents.getDocument(z),fe=T.Range.to(Y.range),De=T.Color.to(Y.color);return(0,D.asPromise)(()=>this._provider.provideColorPresentations(De,{document:ae,range:fe},te)).then(Me=>{if(!!Array.isArray(Me))return Me.map(T.ColorPresentation.from)})}}class J{constructor(z,Y){this._documents=z,this._provider=Y}provideFoldingRanges(z,Y,te){const ae=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideFoldingRanges(ae,Y,te)).then(fe=>{if(!!Array.isArray(fe))return fe.map(T.FoldingRange.from)})}}class me{constructor(z,Y,te){this._documents=z,this._provider=Y,this._logService=te}provideSelectionRanges(z,Y,te){const ae=this._documents.getDocument(z),fe=Y.map(T.Position.to);return(0,D.asPromise)(()=>this._provider.provideSelectionRanges(ae,fe,te)).then(De=>{if(!(0,R.isNonEmptyArray)(De))return[];if(De.length!==fe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Me=[];for(let be=0;be<fe.length;be++){const ke=[];Me.push(ke);let Re=fe[be],Be=De[be];for(;;){if(!Be.range.contains(Re))throw new Error("INVALID selection range, must contain the previous range");if(ke.push(T.SelectionRange.from(Be)),!Be.parent)break;Re=Be.range,Be=Be.parent}}return Me})}}class we{constructor(z,Y){this._documents=z,this._provider=Y,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(z,Y,te){const ae=this._documents.getDocument(z),fe=T.Position.to(Y),De=await this._provider.prepareCallHierarchy(ae,fe,te);if(!!De){const Me=this._idPool.nextId();return this._cache.set(Me,new Map),Array.isArray(De)?De.map(be=>this._cacheAndConvertItem(Me,be)):[this._cacheAndConvertItem(Me,De)]}}async provideCallsTo(z,Y,te){const ae=this._itemFromCache(z,Y);if(!ae)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyIncomingCalls(ae,te);if(!!fe)return fe.map(De=>({from:this._cacheAndConvertItem(z,De.from),fromRanges:De.fromRanges.map(Me=>T.Range.from(Me))}))}async provideCallsFrom(z,Y,te){const ae=this._itemFromCache(z,Y);if(!ae)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyOutgoingCalls(ae,te);if(!!fe)return fe.map(De=>({to:this._cacheAndConvertItem(z,De.to),fromRanges:De.fromRanges.map(Me=>T.Range.from(Me))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,Y){var te;const ae=this._cache.get(z),fe={_sessionId:z,_itemId:ae.size.toString(36),name:Y.name,detail:Y.detail,kind:T.SymbolKind.from(Y.kind),uri:Y.uri,range:T.Range.from(Y.range),selectionRange:T.Range.from(Y.selectionRange),tags:(te=Y.tags)===null||te===void 0?void 0:te.map(T.SymbolTag.from)};return ae.set(fe._itemId,Y),fe}_itemFromCache(z,Y){const te=this._cache.get(z);return te==null?void 0:te.get(Y)}}class Ae{constructor(z,Y){this.adapter=z,this.extension=Y}}class Pe{constructor(z,Y,te,ae,fe,De,Me){this._adapter=new Map,this._uriTransformer=Y,this._proxy=z.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=ae,this._diagnostics=fe,this._logService=De,this._apiDeprecation=Me}_transformDocumentSelector(z){return(0,R.coalesce)((0,R.asArray)(z).map(Y=>this._doTransformDocumentSelector(Y)))}_doTransformDocumentSelector(z){if(typeof z=="string")return{$serialized:!0,language:z};if(z)return{$serialized:!0,language:z.language,scheme:this._transformScheme(z.scheme),pattern:typeof z.pattern=="undefined"?void 0:T.GlobPattern.from(z.pattern),exclusive:z.exclusive}}_transformScheme(z){return this._uriTransformer&&typeof z=="string"?this._uriTransformer.transformOutgoingScheme(z):z}_createDisposable(z){return new I.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return Pe._handlePool++}_withAdapter(z,Y,te,ae,fe=!1){const De=this._adapter.get(z);if(!De)return Promise.resolve(ae);if(De.adapter instanceof Y){let Me;De.extension&&(Me=Date.now(),this._logService.trace(`[${De.extension.identifier.value}] INVOKE provider '${Y.name}'`));const be=te(De.adapter,De.extension),ke=De.extension;return ke&&Promise.resolve(be).then(()=>this._logService.trace(`[${ke.identifier.value}] provider DONE after ${Date.now()-Me}ms`),Re=>{fe&&Re instanceof b.CancellationError||(this._logService.error(`[${ke.identifier.value}] provider FAILED`),this._logService.error(Re))}),be}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(z,Y){const te=this._nextHandle();return this._adapter.set(te,new Ae(z,Y)),te}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,Y,te,ae){const fe=this._addNewAdapter(new p(this._documents,te),z),De=ae&&ae.label||Pe._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(fe,this._transformDocumentSelector(Y),De),this._createDisposable(fe)}$provideDocumentSymbols(z,Y,te){return this._withAdapter(z,p,ae=>ae.provideDocumentSymbols(_.URI.revive(Y),te),void 0)}registerCodeLensProvider(z,Y,te){const ae=this._nextHandle(),fe=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ae(new u(this._documents,this._commands.converter,te),z)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Y),fe);let De=this._createDisposable(ae);if(fe!==void 0){const Me=te.onDidChangeCodeLenses(be=>this._proxy.$emitCodeLensEvent(fe));De=I.Disposable.from(De,Me)}return De}$provideCodeLenses(z,Y,te){return this._withAdapter(z,u,ae=>ae.provideCodeLenses(_.URI.revive(Y),te),void 0)}$resolveCodeLens(z,Y,te){return this._withAdapter(z,u,ae=>ae.resolveCodeLens(Y,te),void 0)}$releaseCodeLenses(z,Y){this._withAdapter(z,u,te=>Promise.resolve(te.releaseCodeLenses(Y)),void 0)}registerDefinitionProvider(z,Y,te){const ae=this._addNewAdapter(new t(this._documents,te),z);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDefinition(z,Y,te,ae){return this._withAdapter(z,t,fe=>fe.provideDefinition(_.URI.revive(Y),te,ae),[])}registerDeclarationProvider(z,Y,te){const ae=this._addNewAdapter(new n(this._documents,te),z);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDeclaration(z,Y,te,ae){return this._withAdapter(z,n,fe=>fe.provideDeclaration(_.URI.revive(Y),te,ae),[])}registerImplementationProvider(z,Y,te){const ae=this._addNewAdapter(new o(this._documents,te),z);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideImplementation(z,Y,te,ae){return this._withAdapter(z,o,fe=>fe.provideImplementation(_.URI.revive(Y),te,ae),[])}registerTypeDefinitionProvider(z,Y,te){const ae=this._addNewAdapter(new r(this._documents,te),z);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideTypeDefinition(z,Y,te,ae){return this._withAdapter(z,r,fe=>fe.provideTypeDefinition(_.URI.revive(Y),te,ae),[])}registerHoverProvider(z,Y,te,ae){const fe=this._addNewAdapter(new l(this._documents,te),z);return this._proxy.$registerHoverProvider(fe,this._transformDocumentSelector(Y)),this._createDisposable(fe)}$provideHover(z,Y,te,ae){return this._withAdapter(z,l,fe=>fe.provideHover(_.URI.revive(Y),te,ae),void 0)}registerEvaluatableExpressionProvider(z,Y,te,ae){const fe=this._addNewAdapter(new a(this._documents,te),z);return this._proxy.$registerEvaluatableExpressionProvider(fe,this._transformDocumentSelector(Y)),this._createDisposable(fe)}$provideEvaluatableExpression(z,Y,te,ae){return this._withAdapter(z,a,fe=>fe.provideEvaluatableExpression(_.URI.revive(Y),te,ae),void 0)}registerInlineValuesProvider(z,Y,te,ae){const fe=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,De=this._addNewAdapter(new g(this._documents,te),z);this._proxy.$registerInlineValuesProvider(De,this._transformDocumentSelector(Y),fe);let Me=this._createDisposable(De);if(fe!==void 0){const be=te.onDidChangeInlineValues(ke=>this._proxy.$emitInlineValuesEvent(fe));Me=I.Disposable.from(Me,be)}return Me}$provideInlineValues(z,Y,te,ae,fe){return this._withAdapter(z,g,De=>De.provideInlineValues(_.URI.revive(Y),te,ae,fe),void 0)}registerDocumentHighlightProvider(z,Y,te){const ae=this._addNewAdapter(new E(this._documents,te),z);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDocumentHighlights(z,Y,te,ae){return this._withAdapter(z,E,fe=>fe.provideDocumentHighlights(_.URI.revive(Y),te,ae),void 0)}registerLinkedEditingRangeProvider(z,Y,te){const ae=this._addNewAdapter(new f(this._documents,te),z);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideLinkedEditingRanges(z,Y,te,ae){return this._withAdapter(z,f,async fe=>{const De=await fe.provideLinkedEditingRanges(_.URI.revive(Y),te,ae);if(De)return{ranges:De.ranges,wordPattern:De.wordPattern?Pe._serializeRegExp(De.wordPattern):void 0}},void 0)}registerReferenceProvider(z,Y,te){const ae=this._addNewAdapter(new h(this._documents,te),z);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideReferences(z,Y,te,ae,fe){return this._withAdapter(z,h,De=>De.provideReferences(_.URI.revive(Y),te,ae,fe),void 0)}registerCodeActionProvider(z,Y,te,ae){var fe,De;const Me=new m.DisposableStore,be=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,te,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(be,this._transformDocumentSelector(Y),{providedKinds:(fe=ae==null?void 0:ae.providedCodeActionKinds)===null||fe===void 0?void 0:fe.map(ke=>ke.value),documentation:(De=ae==null?void 0:ae.documentation)===null||De===void 0?void 0:De.map(ke=>({kind:ke.kind.value,command:this._commands.converter.toInternal(ke.command,Me)}))},Pe._extLabel(z),Boolean(te.resolveCodeAction)),Me.add(this._createDisposable(be)),Me}$provideCodeActions(z,Y,te,ae,fe){return this._withAdapter(z,A,De=>De.provideCodeActions(_.URI.revive(Y),te,ae,fe),void 0)}$resolveCodeAction(z,Y,te){return this._withAdapter(z,A,ae=>ae.resolveCodeAction(Y,te),void 0)}$releaseCodeActions(z,Y){this._withAdapter(z,A,te=>Promise.resolve(te.releaseCodeActions(Y)),void 0)}registerDocumentFormattingEditProvider(z,Y,te){const ae=this._addNewAdapter(new L(this._documents,te),z);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Y),z.identifier,z.displayName||z.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(z,Y,te,ae){return this._withAdapter(z,L,fe=>fe.provideDocumentFormattingEdits(_.URI.revive(Y),te,ae),void 0)}registerDocumentRangeFormattingEditProvider(z,Y,te){const ae=this._addNewAdapter(new B(this._documents,te),z);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Y),z.identifier,z.displayName||z.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(z,Y,te,ae,fe){return this._withAdapter(z,B,De=>De.provideDocumentRangeFormattingEdits(_.URI.revive(Y),te,ae,fe),void 0)}registerOnTypeFormattingEditProvider(z,Y,te,ae){const fe=this._addNewAdapter(new ee(this._documents,te),z);return this._proxy.$registerOnTypeFormattingSupport(fe,this._transformDocumentSelector(Y),ae,z.identifier),this._createDisposable(fe)}$provideOnTypeFormattingEdits(z,Y,te,ae,fe,De){return this._withAdapter(z,ee,Me=>Me.provideOnTypeFormattingEdits(_.URI.revive(Y),te,ae,fe,De),void 0)}registerWorkspaceSymbolProvider(z,Y){const te=this._addNewAdapter(new j(Y,this._logService),z);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(z,Y,te){return this._withAdapter(z,j,ae=>ae.provideWorkspaceSymbols(Y,te),{symbols:[]})}$resolveWorkspaceSymbol(z,Y,te){return this._withAdapter(z,j,ae=>ae.resolveWorkspaceSymbol(Y,te),void 0)}$releaseWorkspaceSymbols(z,Y){this._withAdapter(z,j,te=>te.releaseWorkspaceSymbols(Y),void 0)}registerRenameProvider(z,Y,te){const ae=this._addNewAdapter(new x(this._documents,te,this._logService),z);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Y),x.supportsResolving(te)),this._createDisposable(ae)}$provideRenameEdits(z,Y,te,ae,fe){return this._withAdapter(z,x,De=>De.provideRenameEdits(_.URI.revive(Y),te,ae,fe),void 0)}$resolveRenameLocation(z,Y,te,ae){return this._withAdapter(z,x,fe=>fe.resolveRenameLocation(_.URI.revive(Y),te,ae),void 0)}registerDocumentSemanticTokensProvider(z,Y,te,ae){const fe=this._nextHandle(),De=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(fe,new Ae(new F(this._documents,te),z)),this._proxy.$registerDocumentSemanticTokensProvider(fe,this._transformDocumentSelector(Y),ae,De);let Me=this._createDisposable(fe);if(De){const be=te.onDidChangeSemanticTokens(ke=>this._proxy.$emitDocumentSemanticTokensEvent(De));Me=I.Disposable.from(Me,be)}return Me}$provideDocumentSemanticTokens(z,Y,te,ae){return this._withAdapter(z,F,fe=>fe.provideDocumentSemanticTokens(_.URI.revive(Y),te,ae),null,!0)}$releaseDocumentSemanticTokens(z,Y){this._withAdapter(z,F,te=>te.releaseDocumentSemanticColoring(Y),void 0)}registerDocumentRangeSemanticTokensProvider(z,Y,te,ae){const fe=this._addNewAdapter(new U(this._documents,te),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(fe,this._transformDocumentSelector(Y),ae),this._createDisposable(fe)}$provideDocumentRangeSemanticTokens(z,Y,te,ae){return this._withAdapter(z,U,fe=>fe.provideDocumentRangeSemanticTokens(_.URI.revive(Y),te,ae),null,!0)}registerCompletionItemProvider(z,Y,te,ae){const fe=this._addNewAdapter(new M(this._documents,this._commands.converter,te,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(fe,this._transformDocumentSelector(Y),ae,M.supportsResolving(te),`${z.identifier.value}(${ae.join("")})`),this._createDisposable(fe)}$provideCompletionItems(z,Y,te,ae,fe){return this._withAdapter(z,M,De=>De.provideCompletionItems(_.URI.revive(Y),te,ae,fe),void 0)}$resolveCompletionItem(z,Y,te){return this._withAdapter(z,M,ae=>ae.resolveCompletionItem(Y,te),void 0)}$releaseCompletionItems(z,Y){this._withAdapter(z,M,te=>te.releaseCompletionItems(Y),void 0)}registerSignatureHelpProvider(z,Y,te,ae){const fe=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,De=this._addNewAdapter(new N(this._documents,te),z);return this._proxy.$registerSignatureHelpProvider(De,this._transformDocumentSelector(Y),fe),this._createDisposable(De)}$provideSignatureHelp(z,Y,te,ae,fe){return this._withAdapter(z,N,De=>De.provideSignatureHelp(_.URI.revive(Y),te,ae,fe),void 0)}$releaseSignatureHelp(z,Y){this._withAdapter(z,N,te=>te.releaseSignatureHelp(Y),void 0)}registerInlineHintsProvider(z,Y,te){const ae=typeof te.onDidChangeInlineHints=="function"?this._nextHandle():void 0,fe=this._addNewAdapter(new O(this._documents,te),z);this._proxy.$registerInlineHintsProvider(fe,this._transformDocumentSelector(Y),ae);let De=this._createDisposable(fe);if(ae!==void 0){const Me=te.onDidChangeInlineHints(be=>this._proxy.$emitInlineHintsEvent(ae));De=I.Disposable.from(De,Me)}return De}$provideInlineHints(z,Y,te,ae){return this._withAdapter(z,O,fe=>fe.provideInlineHints(_.URI.revive(Y),te,ae),void 0)}registerDocumentLinkProvider(z,Y,te){const ae=this._addNewAdapter(new V(this._documents,te),z);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Y),typeof te.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(z,Y,te){return this._withAdapter(z,V,ae=>ae.provideLinks(_.URI.revive(Y),te),void 0)}$resolveDocumentLink(z,Y,te){return this._withAdapter(z,V,ae=>ae.resolveLink(Y,te),void 0)}$releaseDocumentLinks(z,Y){this._withAdapter(z,V,te=>te.releaseLinks(Y),void 0)}registerColorProvider(z,Y,te){const ae=this._addNewAdapter(new q(this._documents,te),z);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDocumentColors(z,Y,te){return this._withAdapter(z,q,ae=>ae.provideColors(_.URI.revive(Y),te),[])}$provideColorPresentations(z,Y,te,ae){return this._withAdapter(z,q,fe=>fe.provideColorPresentations(_.URI.revive(Y),te,ae),void 0)}registerFoldingRangeProvider(z,Y,te){const ae=this._nextHandle(),fe=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ae(new J(this._documents,te),z)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Y),fe);let De=this._createDisposable(ae);if(fe!==void 0){const Me=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(fe));De=I.Disposable.from(De,Me)}return De}$provideFoldingRanges(z,Y,te,ae){return this._withAdapter(z,J,fe=>fe.provideFoldingRanges(_.URI.revive(Y),te,ae),void 0)}registerSelectionRangeProvider(z,Y,te){const ae=this._addNewAdapter(new me(this._documents,te,this._logService),z);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideSelectionRanges(z,Y,te,ae){return this._withAdapter(z,me,fe=>fe.provideSelectionRanges(_.URI.revive(Y),te,ae),[])}registerCallHierarchyProvider(z,Y,te){const ae=this._addNewAdapter(new we(this._documents,te),z);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$prepareCallHierarchy(z,Y,te,ae){return this._withAdapter(z,we,fe=>Promise.resolve(fe.prepareSession(_.URI.revive(Y),te,ae)),void 0)}$provideCallHierarchyIncomingCalls(z,Y,te,ae){return this._withAdapter(z,we,fe=>fe.provideCallsTo(Y,te,ae),void 0)}$provideCallHierarchyOutgoingCalls(z,Y,te,ae){return this._withAdapter(z,we,fe=>fe.provideCallsFrom(Y,te,ae),void 0)}$releaseCallHierarchy(z,Y){this._withAdapter(z,we,te=>Promise.resolve(te.releaseSession(Y)),void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,y.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:Pe._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:Pe._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Pe._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Pe._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:Pe._serializeRegExp(z.beforeText),afterText:z.afterText?Pe._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?Pe._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(Pe._serializeOnEnterRule)}setLanguageConfiguration(z,Y,te){let{wordPattern:ae}=te;if(ae&&(0,y.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Y,ae):this._documents.setWordDefinitionFor(Y,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const fe=this._nextHandle(),De={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?Pe._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?Pe._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?Pe._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(fe,Y,De),this._createDisposable(fe)}$setWordDefinitions(z){for(const Y of z)this._documents.setWordDefinitionFor(Y.languageId,new RegExp(Y.regexSource,Y.regexFlags))}}e.ExtHostLanguageFeatures=Pe,Pe._handlePool=0}),define(ge[239],pe([0,1,5,20,7]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class I{constructor(k,y){this._proxy=k.getProxy(_.MainContext.MainThreadLanguages),this._documents=y}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(k,y){await this._proxy.$changeLanguage(k,y);const i=this._documents.getDocumentData(k);if(!i)throw new Error(`document '${k.toString}' NOT found`);return i.document}async tokenAtPosition(k,y){var i;const R=k.version,C=P.Position.from(y),w=await this._proxy.$tokensAtPosition(k.uri,C),m={type:T.StandardTokenType.Other,range:(i=k.getWordRangeAtPosition(y))!==null&&i!==void 0?i:new T.Range(y.line,y.character,y.line,y.character)};if(!w)return m;const s={range:P.Range.to(w.range),type:P.TokenType.to(w.type)};return!s.range.contains(y)||R!==k.version?m:s}}e.ExtHostLanguages=I}),define(ge[240],pe([0,1,5,12,41]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function I(k){return k&&k.title}let D=class{constructor(y,i){this._logService=i,this._proxy=y.getProxy(_.MainContext.MainThreadMessageService)}showMessage(y,i,R,C,w){const m={extension:y};let s;typeof C=="string"||I(C)?s=[C,...w]:(m.modal=C&&C.modal,m.useCustom=C&&C.useCustom,s=w),m.useCustom&&(0,T.checkProposedApiEnabled)(y);const d=[];for(let S=0;S<s.length;S++){const v=s[S];if(typeof v=="string")d.push({title:v,handle:S,isCloseAffordance:!1});else if(typeof v=="object"){let{title:b,isCloseAffordance:p}=v;d.push({title:b,isCloseAffordance:!!p,handle:S})}else this._logService.warn("Invalid message item:",v)}return this._proxy.$showMessage(i,R,m,d).then(S=>{if(typeof S=="number")return s[S]})}};D=je([xe(1,P.ILogService)],D),e.ExtHostMessageService=D}),define(ge[241],pe([0,1,21,3,6,2,28,5,20,7,85,86,24,217,218,70,15,22,73,84]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d,S,v,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class u extends T.Disposable{constructor(a,g,E,f,h){super();this._editorId=a,this.uri=g,this._proxy=E,this._webviewInitData=f,this.document=h,this._onDidReceiveDocumentMessage=new P.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:A=>this._proxy.$postMessage(this._editorId,void 0,A),asWebviewUri:A=>this._asWebviewUri(A)}}onDidReceiveMessage(a,g){var E;this._onDidReceiveDocumentMessage.fire(g),a!==void 0&&((E=this._rendererIdToEmitters.get(a))===null||E===void 0||E.fire(g))}getRendererComm(a){const g=new P.Emitter;return this._rendererIdToEmitters.set(a,g),{editorId:this._editorId,onDidReceiveMessage:g.event,postMessage:E=>this._proxy.$postMessage(this._editorId,a,E),asWebviewUri:E=>this._asWebviewUri(E)}}_asWebviewUri(a){return(0,R.asWebviewUri)(this._webviewInitData,this._editorId,a)}}class c extends T.Disposable{constructor(a,g,E,f){super();this._proxy=a,this._handle=g,this._extension=E,this._provider=f,this._kernelToFriendlyId=new w.ResourceMap,this._friendlyIdToKernel=new w.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(h=>{const A=h==null?void 0:h.uri;this._proxy.$onNotebookKernelChange(this._handle,A)}))}async provideKernels(a,g){const E=await this._provider.provideKernels(a.notebookDocument,g)||[],f=new Map;let h=0;const A=new Set,L=this._kernelToFriendlyId.get(a.uri),B=E.map(j=>{var x;let $=L==null?void 0:L.get(j);return $===void 0&&(j.id&&A.has(j.id)?$=`${this._extension.identifier.value}_${j.id}_${h++}`:$=`${this._extension.identifier.value}_${j.id||D.generateUuid()}`),f.set(j,$),{id:j.id,friendlyId:$,label:j.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:j.description,detail:j.detail,isPreferred:j.isPreferred,preloads:(x=j.preloads)===null||x===void 0?void 0:x.map(F=>(I.URI.isUri(F)&&(F={uri:F,provides:[]}),{uri:F.uri,provides:typeof F.provides=="string"?[F.provides]:F.provides===void 0?[]:F.provides})),supportedLanguages:j.supportedLanguages,implementsInterrupt:!!j.interrupt}});this._kernelToFriendlyId.set(a.uri,f);const ee=new Map;return f.forEach((j,x)=>{ee.set(j,x)}),this._friendlyIdToKernel.set(a.uri,ee),B}getKernelByFriendlyId(a,g){var E;return(E=this._friendlyIdToKernel.get(a))===null||E===void 0?void 0:E.get(g)}async resolveNotebook(a,g,E,f){var h;const A=(h=this._friendlyIdToKernel.get(g.uri))===null||h===void 0?void 0:h.get(a);if(A&&this._provider.resolveKernel)return this._provider.resolveKernel(A,g.notebookDocument,E,f)}async executeNotebook(a,g,E){var f;const h=(f=this._friendlyIdToKernel.get(g.uri))===null||f===void 0?void 0:f.get(a);if(!!h){const A=E.map(L=>y.NotebookCellRange.to(L));return h.executeCellsRequest(g.notebookDocument,A)}}async interruptNotebookExecution(a,g){var E;const f=(E=this._friendlyIdToKernel.get(g.uri))===null||E===void 0?void 0:E.get(a);if(!(!f||!f.interrupt))return f.interrupt(g.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=c;class t{constructor(a,g){const E=t._Keys.nextId();a.$registerNotebookEditorDecorationType(E,y.NotebookDecorationRenderOptions.from(g)),this.value={key:E,dispose(){a.$removeNotebookEditorDecorationType(E)}}}}e.NotebookEditorDecorationType=t,t._Keys=new d.IdGenerator("NotebookEditorDecorationType");class n{constructor(a,g,E,f,h,A,L){this._textDocumentsAndEditors=E,this._textDocuments=f,this._webviewInitData=h,this.logService=A,this._extensionStoragePaths=L,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new w.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new P.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new P.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new P.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new P.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new P.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new P.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new P.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new P.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new P.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new P.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new P.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new P.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new P.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new w.ResourceMap,this._statusBarCache=new p.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._rendererIpcEmitters=new Map,this._notebookProxy=a.getProxy(k.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(k.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(k.MainContext.MainThreadNotebookEditors),this._commandsConverter=g.converter,g.registerArgumentProcessor({processArgument:B=>{var ee;if(B&&B.$mid===12){const j=(ee=B.notebookEditor)===null||ee===void 0?void 0:ee.notebookUri,x=B.cell.handle,$=this._documents.get(j),F=$==null?void 0:$.getCell(x);if(F)return F.cell}return B}})}get activeNotebookEditor(){var a;return(a=this._activeNotebookEditor)===null||a===void 0?void 0:a.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(a){return this._documents.get(a)}_getNotebookDocument(a){const g=this._documents.get(a);if(!g)throw new Error(`NO notebook document for '${a}'`);return g}_getProviderData(a){const g=this._notebookContentProviders.get(a);if(!g)throw new Error(`NO provider for '${a}'`);return g}registerNotebookContentProvider(a,g,E,f){var h,A,L;if(this._notebookContentProviders.has(g))throw new Error(`Notebook provider for '${g}' already registered`);this._notebookContentProviders.set(g,{extension:a,provider:E});let B;E.onDidChangeNotebookContentOptions&&(B=E.onDidChangeNotebookContentOptions(()=>{const x=y.NotebookDocumentContentOptions.from(E.options);this._notebookProxy.$updateNotebookProviderOptions(g,x)}));const ee=(h=f==null?void 0:f.viewOptions)===null||h===void 0?void 0:h.filenamePattern.map(x=>y.NotebookExclusiveDocumentPattern.from(x)).filter(x=>x!==void 0);((A=f==null?void 0:f.viewOptions)===null||A===void 0?void 0:A.filenamePattern)&&!ee&&console.warn(`Notebook content provider view options file name pattern is invalid ${(L=f==null?void 0:f.viewOptions)===null||L===void 0?void 0:L.filenamePattern}`);const j=y.NotebookDocumentContentOptions.from(f);return this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation,description:a.description},g,{transientOutputs:j.transientOutputs,transientMetadata:j.transientMetadata,viewOptions:(f==null?void 0:f.viewOptions)&&ee?{displayName:f.viewOptions.displayName,filenamePattern:ee,exclusive:f.viewOptions.exclusive||!1}:void 0}),new i.Disposable(()=>{B==null||B.dispose(),this._notebookContentProviders.delete(g),this._notebookProxy.$unregisterNotebookProvider(g)})}registerNotebookKernelProvider(a,g,E){const f=n._notebookKernelProviderHandlePool++,h=new c(this._notebookProxy,f,a,E);return this._notebookKernelProviders.set(f,h),this._notebookProxy.$registerNotebookKernelProvider({id:a.identifier,location:a.extensionLocation,description:a.description},f,{viewType:g.viewType,filenamePattern:g.filenamePattern?y.NotebookExclusiveDocumentPattern.from(g.filenamePattern):void 0}),new i.Disposable(()=>{h.dispose(),this._notebookKernelProviders.delete(f),this._notebookProxy.$unregisterNotebookKernelProvider(f)})}registerNotebookCellStatusBarItemProvider(a,g,E){const f=n._notebookStatusBarItemProviderHandlePool++,h=typeof E.onDidChangeCellStatusBarItems=="function"?n._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(f,E),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(f,h,{viewType:g.viewType,filenamePattern:g.filenamePattern?y.NotebookExclusiveDocumentPattern.from(g.filenamePattern):void 0});let A;return h!==void 0&&(A=E.onDidChangeCellStatusBarItems(L=>this._notebookProxy.$emitCellStatusBarEvent(h))),new i.Disposable(()=>{this._notebookStatusBarItemProviders.delete(f),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(f,h),A&&A.dispose()})}createNotebookEditorDecorationType(a){return new t(this._notebookEditorsProxy,a).value}async openNotebookDocument(a){const g=this._documents.get(a);if(g)return g.notebookDocument;const E=await this._notebookDocumentsProxy.$tryOpenDocument(a),f=this._documents.get(I.URI.revive(E));return(0,S.assertIsDefined)(f==null?void 0:f.notebookDocument)}_withAdapter(a,g,E){const f=this._documents.get(I.URI.revive(g));if(!f)return[];const h=this._notebookKernelProviders.get(a);return h?E(h,f):[]}async showNotebookDocument(a,g){var E;I.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let f;typeof g=="object"?f={position:y.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selections:g.selections&&g.selections.map(y.NotebookCellRange.from),pinned:typeof g.preview=="boolean"?!g.preview:void 0}:f={preserveFocus:!1};const h=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.viewType,f),A=h&&((E=this._editors.get(h))===null||E===void 0?void 0:E.apiEditor);if(A)return A;throw h?new Error(`Could NOT open editor for "${a.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.toString()}".`)}async $provideNotebookKernels(a,g,E){return this._withAdapter(a,g,(f,h)=>f.provideKernels(h,E))}async $resolveNotebookKernel(a,g,E,f,h){await this._withAdapter(a,E,async(A,L)=>{const B=this._webviewComm.get(g);B&&await A.resolveNotebook(f,L,B.contentProviderComm,h)})}async $provideNotebookCellStatusBarItems(a,g,E,f){var h;const A=this._notebookStatusBarItemProviders.get(a),L=I.URI.revive(g),B=this._documents.get(L);if(!(!B||!A)){const ee=B.getCellFromIndex(E);if(!!ee){const j=await A.provideCellStatusBarItems(ee.cell,f);if(!!j){const x=new T.DisposableStore,$=this._statusBarCache.add([x]),F=(h=j&&j.map(U=>y.NotebookStatusBarItem.from(U,this._commandsConverter,x)))!==null&&h!==void 0?h:void 0;return{cacheId:$,items:F}}}}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}async $resolveNotebookEditor(a,g,E){const f=this._notebookContentProviders.get(a),h=I.URI.revive(g),A=this._documents.get(h);if(!(!A||!f)){let L=this._webviewComm.get(E);L||(L=new u(E,h,this._notebookProxy,this._webviewInitData,A),this._webviewComm.set(E,L))}}async $executeNotebookKernelFromProvider(a,g,E,f){await this._withAdapter(a,g,async(h,A)=>h.executeNotebook(E,A,f))}registerNotebookSerializer(a,g,E,f){const h=this._handlePool++;this._notebookSerializer.set(h,E);const A=y.NotebookDocumentContentOptions.from(f);return this._notebookProxy.$registerNotebookSerializer(h,{id:a.identifier,location:a.extensionLocation,description:a.description},g,A),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(h)})}async $dataToNotebook(a,g){const E=this._notebookSerializer.get(a);if(!E)throw new Error("NO serializer found");const f=await E.dataToNotebook(g.buffer);return{metadata:y.NotebookDocumentMetadata.from(f.metadata),cells:f.cells.map(y.NotebookCellData.from)}}async $notebookToData(a,g){const E=this._notebookSerializer.get(a);if(!E)throw new Error("NO serializer found");const f=await E.notebookToData({metadata:y.NotebookDocumentMetadata.to(g.metadata),cells:g.cells.map(y.NotebookCellData.to)});return v.VSBuffer.wrap(f)}async $cancelNotebookCellExecution(a,g,E,f){await this._withAdapter(a,g,async(A,L)=>A.interruptNotebookExecution(E,L));const h=this._documents.get(I.URI.revive(g));if(!!h)for(let A of f)for(let L=A.start;L<A.end;L++){const B=h.getCellFromIndex(L);B&&this.cancelOneNotebookCellExecution(B)}}cancelOneNotebookCellExecution(a){const g=this._activeExecutions.get(a.uri);g==null||g.cancel()}async $openNotebook(a,g,E,f,h){const{provider:A}=this._getProviderData(a),L=await A.openNotebook(I.URI.revive(g),{backupId:E,untitledDocumentData:f==null?void 0:f.buffer},h);return{metadata:y.NotebookDocumentMetadata.from(L.metadata),cells:L.cells.map(y.NotebookCellData.from)}}async $saveNotebook(a,g,E){const f=this._getNotebookDocument(I.URI.revive(g)),{provider:h}=this._getProviderData(a);return await h.saveNotebook(f.notebookDocument,E),!0}async $saveNotebookAs(a,g,E,f){const h=this._getNotebookDocument(I.URI.revive(g)),{provider:A}=this._getProviderData(a);return await A.saveNotebookAs(I.URI.revive(E),h.notebookDocument,f),!0}async $backupNotebook(a,g,E){var f;const h=this._getNotebookDocument(I.URI.revive(g)),A=this._getProviderData(a),L=(f=this._extensionStoragePaths.workspaceValue(A.extension))!==null&&f!==void 0?f:this._extensionStoragePaths.globalValue(A.extension),B=String((0,b.hash)([h.uri.toString(),this._backupIdPool++])),ee=I.URI.joinPath(L,B),j=await A.provider.backupNotebook(h.notebookDocument,{destination:ee},E);return h.updateBackup(j),j.id}$acceptNotebookActiveKernelChange(a){a.providerHandle!==void 0&&this._withAdapter(a.providerHandle,a.uri,async(g,E)=>{const f=a.kernelFriendlyId?g.getKernelByFriendlyId(I.URI.revive(a.uri),a.kernelFriendlyId):void 0;this._editors.forEach(h=>{h.notebookData===E&&h._acceptKernel(f)}),this._onDidChangeActiveNotebookKernel.fire({document:E.notebookDocument,kernel:f})})}$onDidReceiveMessage(a,g,E){var f;(f=this._webviewComm.get(a))===null||f===void 0||f.onDidReceiveMessage(g,E)}$acceptModelChanged(a,g,E){this._getNotebookDocument(I.URI.revive(a)).acceptModelChanged(g,E)}$acceptDirtyStateChanged(a,g){const E=this._getNotebookDocument(I.URI.revive(a));E.acceptModelChanged({rawEvents:[],versionId:E.notebookDocument.version},g)}$acceptModelSaved(a){const g=this._getNotebookDocument(I.URI.revive(a));this._onDidSaveNotebookDocument.fire(g.notebookDocument)}$acceptEditorPropertiesChanged(a,g){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",a,g);const E=this._editors.get(a);if(!E)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);g.visibleRanges&&E._acceptVisibleRanges(g.visibleRanges.ranges.map(y.NotebookCellRange.to)),g.selections&&E._acceptSelections(g.selections.selections.map(y.NotebookCellRange.to)),g.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),g.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}_editorIdFromApiEditor(a){for(const[g,E]of this._editors)if(E.apiEditor===a)return g}createNotebookCommunication(a){const g=this,E=this._handlePool++,f=new P.Emitter,h=this._notebookEditorsProxy.$addRendererIpc(a,E),A={rendererId:a,onDidReceiveMessage:f.event,dispose(){f.dispose(),g._rendererIpcEmitters.delete(E),g._notebookEditorsProxy.$removeRendererIpc(a,E)},async postMessage(L,B){let ee;return B&&(ee=g._editorIdFromApiEditor(B),!ee)?!1:(await h,g._notebookEditorsProxy.$postRendererIpcMessage(a,E,ee,L))},asWebviewUri(L,B){const ee=g._editorIdFromApiEditor(B);if(!ee)throw new Error("invalid editor");return(0,R.asWebviewUri)(g._webviewInitData,ee,L)}};return this._rendererIpcEmitters.set(E,{emitter:f}),A}$acceptEditorIpcMessage(a,g,E,f){var h;const A=this._editors.get(a);if(!A)throw new Error("sending ipc message for UNKNOWN editor");for(const L of E)(h=this._rendererIpcEmitters.get(L))===null||h===void 0||h.emitter.fire({editor:A.apiEditor,message:f})}$acceptEditorViewColumns(a){for(const g in a){const E=this._editors.get(g);if(!E)throw new Error(`unknown text editor: ${g}. known editors: ${[...this._editors.keys()]} `);E._acceptViewColumn(y.ViewColumn.to(a[g]))}}$acceptDocumentPropertiesChanged(a,g){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",a.path,g);const E=this._getNotebookDocument(I.URI.revive(a));E.acceptDocumentPropertiesChanged(g),g.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:E.notebookDocument})}_createExtHostEditor(a,g,E){if(this._editors.has(g))throw new Error(`editor with id ALREADY EXSIST: ${g}`);const f=a.uri;let h=this._webviewComm.get(g);h||(h=new u(g,f,this._notebookProxy,this._webviewInitData,a),this._webviewComm.set(g,h));const A=new s.ExtHostNotebookEditor(g,this._notebookEditorsProxy,a,E.visibleRanges.map(y.NotebookCellRange.to),E.selections.map(y.NotebookCellRange.to),typeof E.viewColumn=="number"?y.ViewColumn.to(E.viewColumn):void 0);this._editors.set(g,A)}$acceptDocumentAndEditorsDelta(a){var g,E,f;if(a.removedDocuments)for(const A of a.removedDocuments){const L=I.URI.revive(A),B=this._documents.get(L);B&&(B.dispose(),this._documents.delete(L),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:B.notebookDocument.getCells().map(ee=>ee.document.uri)}),this._onDidCloseNotebookDocument.fire(B.notebookDocument));for(const ee of this._editors.values())ee.notebookData.uri.toString()===L.toString()&&this._editors.delete(ee.id)}if(a.addedDocuments){const A=[];for(const L of a.addedDocuments){const B=I.URI.revive(L.uri),ee=L.viewType;if(this._documents.has(B))throw new Error(`adding EXISTING notebook ${B} `);const j=this,x=new m.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange($){j._onDidChangeNotebookCells.fire($)},emitCellOutputsChange($){j._onDidChangeCellOutputs.fire($)},emitCellMetadataChange($){j._onDidChangeCellMetadata.fire($)},emitCellExecutionStateChange($){j._onDidChangeCellExecutionState.fire($)}},ee,L.metadata?y.NotebookDocumentMetadata.to(L.metadata):new i.NotebookDocumentMetadata,B);x.acceptModelChanged({versionId:L.versionId,rawEvents:[{kind:C.NotebookCellsChangeType.Initialize,changes:[[0,0,L.cells]]}]},!1),A.push(...L.cells.map($=>m.ExtHostCell.asModelAddData(x.notebookDocument,$))),(g=this._documents.get(B))===null||g===void 0||g.dispose(),this._documents.set(B,x),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:A}),this._onDidOpenNotebookDocument.fire(x.notebookDocument)}}if(a.addedEditors)for(const A of a.addedEditors){if(this._editors.has(A.id))return;const L=I.URI.revive(A.documentUri),B=this._documents.get(L);B&&this._createExtHostEditor(B,A.id,A)}const h=[];if(a.removedEditors)for(const A of a.removedEditors){const L=this._editors.get(A);L&&(this._editors.delete(A),((E=this._activeNotebookEditor)===null||E===void 0?void 0:E.id)===L.id&&(this._activeNotebookEditor=void 0),h.push(L))}if(a.visibleEditors){this._visibleNotebookEditors=a.visibleEditors.map(L=>this._editors.get(L)).filter(L=>!!L);const A=new Set;this._visibleNotebookEditors.forEach(L=>A.add(L.id));for(const L of this._editors.values()){const B=A.has(L.id);L._acceptVisibility(B)}this._visibleNotebookEditors=[...this._editors.values()].map(L=>L).filter(L=>L.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.newActiveEditor===null?this._activeNotebookEditor=void 0:a.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.newActiveEditor)),a.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((f=this._activeNotebookEditor)===null||f===void 0?void 0:f.apiEditor)}createNotebookCellExecution(a,g,E){const f=this.lookupNotebookDocument(a);if(!f)throw new Error(`Invalid cell uri / index: ${a}, ${g} `);const h=f.getCellFromIndex(g);if(!h)throw new Error(`Invalid cell uri / index: ${a}, ${g} `);if(!this._activeExecutions.has(h.uri)){const A=new r(a,f,h,this._notebookDocumentsProxy);this._activeExecutions.set(h.uri,A);const L=A.onDidChangeState(()=>{A.state===o.Resolved&&(A.dispose(),L.dispose(),this._activeExecutions.delete(h.uri))});return A.asApiObject()}}}e.ExtHostNotebookController=n,n._notebookKernelProviderHandlePool=0,n._notebookStatusBarItemProviderHandlePool=0;var o;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(o||(o={}));class r extends T.Disposable{constructor(a,g,E,f){super();this._uri=a,this._document=g,this._cell=E,this._proxy=f,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new _.CancellationTokenSource),this._executionOrder=E.internalMetadata.executionOrder,this.mixinMetadata({runState:i.NotebookCellExecutionState.Pending,lastRunDuration:null,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEdits(a){return this._proxy.$applyEdits(this._uri,a,!1)}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(a){const g=[{editType:11,handle:this._cell.handle,metadata:a}];this.applyEdits(g)}cellIndexToHandle(a){const g=typeof a=="number"?this._document.getCellFromIndex(a):this._cell;if(!!g)return g.handle}asApiObject(){const a=this;return Object.freeze({get document(){return a._document.notebookDocument},get cell(){return a._cell.cell},get executionOrder(){return a._executionOrder},set executionOrder(g){a._executionOrder=g,a.mixinMetadata({executionOrder:g})},start(g){if(a._state===o.Resolved||a._state===o.Started)throw new Error("Cannot call start again");a._state=o.Started,a._onDidChangeState.fire(),a.mixinMetadata({runState:i.NotebookCellExecutionState.Executing,runStartTime:g==null?void 0:g.startTime})},end(g){var E,f;if(a._state===o.Resolved)throw new Error("Cannot call resolve twice");a._state=o.Resolved,a._onDidChangeState.fire(),a.mixinMetadata({runState:i.NotebookCellExecutionState.Idle,lastRunSuccess:(E=g==null?void 0:g.success)!==null&&E!==void 0?E:null,lastRunDuration:(f=g==null?void 0:g.duration)!==null&&f!==void 0?f:null})},clearOutput(g){return a.verifyStateForOutput(),this.replaceOutput([],g)},async appendOutput(g,E){a.verifyStateForOutput();const f=a.cellIndexToHandle(E);if(typeof f=="number")return g=Array.isArray(g)?g:[g],a.applyEdits([{editType:2,handle:f,append:!0,outputs:g.map(y.NotebookCellOutput.from)}])},async replaceOutput(g,E){a.verifyStateForOutput();const f=a.cellIndexToHandle(E);if(typeof f=="number")return g=Array.isArray(g)?g:[g],a.applyEdits([{editType:2,handle:f,outputs:g.map(y.NotebookCellOutput.from)}])},async appendOutputItems(g,E){return a.verifyStateForOutput(),g=Array.isArray(g)?g:[g],a.applyEdits([{editType:10,append:!0,items:g.map(y.NotebookCellOutputItem.from),outputId:E}])},async replaceOutputItems(g,E){return a.verifyStateForOutput(),g=Array.isArray(g)?g:[g],a.applyEdits([{editType:10,items:g.map(y.NotebookCellOutputItem.from),outputId:E}])},token:a._tokenSource.token})}}}),define(ge[242],pe([0,1,3,6,5,2,20,14]),function(Q,e,_,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class y{constructor(R,C){this._extHostNotebook=C,this._kernelData=new Map,this._handlePool=0,this._proxy=R.getProxy(T.MainContext.MainThreadNotebookKernels)}createKernel(R,C){var w,m;const s=this._handlePool++,d=this;let S=!1;const v=new P.DisposableStore,b=new _.Emitter;this._kernelData.set(s,{id:C.id,executeHandler:C.executeHandler,onDidChangeSelection:b});const p={id:C.id,selector:C.selector,extensionId:R.identifier,extensionLocation:R.extensionLocation,label:C.label,supportedLanguages:[]};this._proxy.$addKernel(s,p);let u=0;const c=()=>{if(!S){const n=++u;Promise.resolve().then(()=>{n===u&&this._proxy.$updateKernel(s,p)})}},t={get id(){return p.id},get selector(){return p.selector},onDidChangeNotebookAssociation:b.event,get label(){return p.label},set label(n){p.label=n,c()},get description(){var n;return(n=p.description)!==null&&n!==void 0?n:""},set description(n){p.description=n,c()},get supportedLanguages(){return p.supportedLanguages},set supportedLanguages(n){p.supportedLanguages=(0,k.isNonEmptyArray)(n)?n:["plaintext"],c()},get hasExecutionOrder(){var n;return(n=p.hasExecutionOrder)!==null&&n!==void 0?n:!1},set hasExecutionOrder(n){p.hasExecutionOrder=n,c()},get executeHandler(){return d._kernelData.get(s).executeHandler},get interruptHandler(){return d._kernelData.get(s).interruptHandler},set interruptHandler(n){d._kernelData.get(s).interruptHandler=n,p.supportsInterrupt=Boolean(n),c()},createNotebookCellExecutionTask(n){if(S)throw new Error("object disposed");return d._extHostNotebook.createNotebookCellExecution(n.document.uri,n.index,p.id)},dispose:()=>{S||(S=!0,this._kernelData.delete(s),v.dispose(),b.dispose(),this._proxy.$removeKernel(s))}};return t.supportedLanguages=(w=C.supportedLanguages)!==null&&w!==void 0?w:[],t.interruptHandler=C.interruptHandler,t.hasExecutionOrder=(m=C.hasExecutionOrder)!==null&&m!==void 0?m:!1,t}$acceptSelection(R,C,w){const m=this._kernelData.get(R);m&&m.onDidChangeSelection.fire({selected:w,notebook:this._extHostNotebook.lookupNotebookDocument(I.URI.revive(C)).notebookDocument})}$executeCells(R,C,w){const m=this._kernelData.get(R);if(!!m){const s=this._extHostNotebook.lookupNotebookDocument(I.URI.revive(C));if(!s)throw new Error("MISSING notebook");const d=[];for(let S of w){const v=s.notebookDocument.getCells(D.NotebookCellRange.to(S));for(let b of v){const p=this._extHostNotebook.createNotebookCellExecution(s.uri,b.index,m.id);p?d.push(p):console.warn("could NOT create notebook cell execution task for: "+b.document.uri)}}try{m.executeHandler(d)}catch(S){console.error(S)}}}$cancelCells(R,C,w){const m=this._kernelData.get(R);if(!!m){const s=this._extHostNotebook.lookupNotebookDocument(I.URI.revive(C));if(!s)throw new Error("MISSING notebook");m.interruptHandler&&m.interruptHandler(s.notebookDocument)}}}e.ExtHostNotebookKernels=y}),define(ge[63],pe([0,1,5,3,6,22,4,13]),function(Q,e,_,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends T.Disposable{constructor(s,d,S,v){super();this._onDidAppend=this._register(new P.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=s,this._proxy=v,this._id=v.$register(this.name,d,S),this._disposed=!1,this._offset=0}get name(){return this._name}append(s){this.validate(),this._offset+=s?I.VSBuffer.fromString(s).byteLength:0}update(){this._id.then(s=>this._proxy.$update(s))}appendLine(s){this.validate(),this.append(s+`
`)}clear(){this.validate();const s=this._offset;this._id.then(d=>this._proxy.$clear(d,s))}show(s,d){this.validate(),this._id.then(S=>this._proxy.$reveal(S,!!(typeof s=="boolean"?s:d)))}hide(){this.validate(),this._id.then(s=>this._proxy.$close(s))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(s=>this._proxy.$dispose(s)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class i extends y{constructor(s,d){super(s,!1,void 0,d)}append(s){super.append(s),this._id.then(d=>this._proxy.$append(d,s)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=i;class R extends y{constructor(s,d,S){super(s,!0,d,S)}append(s){throw new Error("Not supported")}}class C{constructor(s,d){this.name=s,this._channel=d}append(s){this._channel.then(d=>d.append(s))}appendLine(s){this._channel.then(d=>d.appendLine(s))}clear(){this._channel.then(s=>s.clear())}show(s,d){this._channel.then(S=>S.show(s,d))}hide(){this._channel.then(s=>s.hide())}dispose(){this._channel.then(s=>s.dispose())}}e.LazyOutputChannel=C;let w=class{constructor(s){this._proxy=s.getProxy(_.MainContext.MainThreadOutputService)}$setVisibleChannel(s){}createOutputChannel(s){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");return new i(s,this._proxy)}createOutputChannelFromLogFile(s,d){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");if(!d)throw new Error("illegal argument `file`. must not be falsy");return new R(s,d,this._proxy)}};w=je([xe(0,k.IExtHostRpcService)],w),e.ExtHostOutputService=w,e.IExtHostOutputService=(0,D.createDecorator)("IExtHostOutputService")}),define(ge[243],pe([0,1,19,21,3,6,5,2,7,18,14,56]),function(Q,e,_,P,T,I,D,k,y,i,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function w(m,s,d){const S=m.getProxy(D.MainContext.MainThreadQuickOpen);class v{constructor(r,l){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=l}showQuickPick(r,l,a,g=P.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(r),f=++this._instances,h=S.$show(f,{title:a==null?void 0:a.title,placeHolder:a==null?void 0:a.placeHolder,matchOnDescription:a==null?void 0:a.matchOnDescription,matchOnDetail:a==null?void 0:a.matchOnDetail,ignoreFocusLost:a==null?void 0:a.ignoreFocusOut,canPickMany:a==null?void 0:a.canPickMany},g),A={},L=h.then(()=>A);return Promise.race([L,E]).then(B=>{if(B!==A)return E.then(ee=>{const j=[];for(let x=0;x<ee.length;x++){const $=ee[x];let F,U,M,N,O;typeof $=="string"?F=$:(F=$.label,U=$.description,M=$.detail,N=$.picked,O=$.alwaysShow),j.push({label:F,description:U,handle:x,detail:M,picked:N,alwaysShow:O})}return a&&typeof a.onDidSelectItem=="function"&&(this._onDidSelectItem=x=>{a.onDidSelectItem(ee[x])}),S.$setItems(f,j),h.then(x=>{if(typeof x=="number")return ee[x];if(Array.isArray(x))return x.map($=>ee[$])})})}).then(void 0,B=>{if(!(0,i.isPromiseCanceledError)(B))return S.$setError(f,B),Promise.reject(B)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,l=P.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,S.$input(r,typeof this._validateInput=="function",l).then(void 0,a=>{if(!(0,i.isPromiseCanceledError)(a))return Promise.reject(a)})}$validateInput(r){return this._validateInput?(0,_.asPromise)(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,l=P.CancellationToken.None){const a=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!!a){const g=await this._workspace.getWorkspaceFolders2();if(!!g)return g.find(E=>E.uri.toString()===a.uri.toString())}}createQuickPick(r,l){const a=new t(r,l,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}createInputBox(r){const l=new n(r,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(r,l){const a=this._sessions.get(r);a&&a._fireDidChangeValue(l)}$onDidAccept(r){const l=this._sessions.get(r);l&&l._fireDidAccept()}$onDidChangeActive(r,l){const a=this._sessions.get(r);a instanceof t&&a._fireDidChangeActive(l)}$onDidChangeSelection(r,l){const a=this._sessions.get(r);a instanceof t&&a._fireDidChangeSelection(l)}$onDidTriggerButton(r,l){const a=this._sessions.get(r);a&&a._fireDidTriggerButton(l)}$onDidHide(r){const l=this._sessions.get(r);l&&l._fireDidHide()}}class b{constructor(r,l){this._extensionId=r,this._onDidDispose=l,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new T.Emitter,this._onDidChangeValueEmitter=new T.Emitter,this._onDidTriggerButtonEmitter=new T.Emitter,this._onDidHideEmitter=new T.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((l,a)=>{const g=l===y.QuickInputButtons.Back?-1:a;this._handlesToButtons.set(g,l)}),this.update({buttons:r.map((l,a)=>({iconPath:p(l.iconPath),tooltip:l.tooltip,handle:l===y.QuickInputButtons.Back?-1:a}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const l=this._handlesToButtons.get(r);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,I.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(r){if(!this._disposed){for(const l of Object.keys(r)){const a=r[l];this._pendingUpdate[l]=a===void 0?null:a}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}b._nextId=1;function p(o){if(o instanceof y.ThemeIcon)return{id:o.id};const r=c(o),l=u(o);return{dark:typeof r=="string"?k.URI.file(r):r,light:typeof l=="string"?k.URI.file(l):l}}function u(o){return typeof o=="object"&&"light"in o?o.light:o}function c(o){return typeof o=="object"&&"dark"in o?o.dark:o}class t extends b{constructor(r,l,a){super(r,a);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new T.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new T.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((l,a)=>{this._handlesToItems.set(a,l),this._itemsToHandles.set(l,a)}),this.update({items:r.map((l,a)=>({label:l.label,description:l.description,handle:a,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(r){const l=(0,R.coalesce)(r.map(a=>this._handlesToItems.get(a)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(r){const l=(0,R.coalesce)(r.map(a=>this._handlesToItems.get(a)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}}class n extends b{constructor(r,l){super(r,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?C.default.Error:C.default.Ignore})}}return new v(s,d)}e.createExtHostQuickOpen=w}),define(ge[244],pe([0,1,2,3,68,6,19,5,14,96,12,29,41]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function m(r){if(r)return typeof r.iconPath=="string"?_.URI.file(r.iconPath):r.iconPath}function s(r,l){if(!r.iconPath&&!l.iconPath)return 0;if(r.iconPath){if(!l.iconPath)return 1}else return-1;const a=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,g=typeof l.iconPath=="string"?l.iconPath:l.iconPath.fsPath;return(0,i.comparePaths)(a,g)}function d(r,l){let a=0;if(r.strikeThrough!==l.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==l.faded)return r.faded?1:-1;if(r.tooltip!==l.tooltip)return(r.tooltip||"").localeCompare(l.tooltip||"");if(a=s(r,l),a!==0)return a;if(r.light&&l.light)a=s(r.light,l.light);else{if(r.light)return 1;if(l.light)return-1}if(a!==0)return a;if(r.dark&&l.dark)a=s(r.dark,l.dark);else{if(r.dark)return 1;if(l.dark)return-1}return a}function S(r,l){if(r.command!==l.command)return r.command<l.command?-1:1;if(r.title!==l.title)return r.title<l.title?-1:1;if(r.tooltip!==l.tooltip){if(r.tooltip!==void 0&&l.tooltip!==void 0)return r.tooltip<l.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(r.arguments===l.arguments)return 0;if(r.arguments)if(l.arguments){if(r.arguments.length!==l.arguments.length)return r.arguments.length-l.arguments.length}else return 1;else return-1;for(let a=0;a<r.arguments.length;a++){const g=r.arguments[a],E=l.arguments[a];if(g!==E)return g<E?-1:1}return 0}function v(r,l){let a=(0,i.comparePaths)(r.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(a!==0)return a;if(r.command&&l.command)a=S(r.command,l.command);else{if(r.command)return 1;if(l.command)return-1}if(a!==0)return a;if(r.decorations&&l.decorations)a=d(r.decorations,l.decorations);else{if(r.decorations)return 1;if(l.decorations)return-1}return a}function b(r,l){for(let a=0;a<r.length;a++)if(r[a]!==l[a])return!1;return!0}function p(r,l){return r.command===l.command&&r.title===l.title&&r.tooltip===l.tooltip&&(r.arguments&&l.arguments?b(r.arguments,l.arguments):r.arguments===l.arguments)}function u(r,l){return(0,y.equals)(r,l,p)}class c{constructor(l,a,g){this._extension=l,this._proxy=a,this._sourceControlHandle=g,this._value="",this._onDidChange=new P.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(l){this._proxy.$setInputBoxValue(this._sourceControlHandle,l),this.updateValue(l)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(l){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,l),this._placeholder=l}get validateInput(){return(0,w.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(l){if((0,w.checkProposedApiEnabled)(this._extension),l&&typeof l!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=l,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!l)}get visible(){return this._visible}set visible(l){l=!!l,this._visible!==l&&(this._visible=l,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,l))}focus(){(0,w.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(l,a){(0,w.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,l,a)}$onInputBoxValueChange(l){this.updateValue(l)}updateValue(l){this._value=l,this._onDidChange.fire(l)}}e.ExtHostSCMInputBox=c;class t{constructor(l,a,g,E,f){this._proxy=l,this._commands=a,this._sourceControlHandle=g,this._id=E,this._label=f,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new P.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new P.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(l){this._label=l,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,l)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(l){this._hideWhenEmpty=l,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(l){this._resourceStates=[...l],this._onDidUpdateResourceStates.fire()}getResourceState(l){return this._resourceStatesMap.get(l)}$executeResourceCommand(l,a){const g=this._resourceStatesCommandsMap.get(l);return g?(0,D.asPromise)(()=>this._commands.executeCommand(g.command,...g.arguments||[],a)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var l;const a=[...this._resourceStates].sort(v),E=(0,y.sortedDiff)(this._resourceSnapshot,a,v).map(A=>{const L=A.toInsert.map(B=>{const ee=this._resourceHandlePool++;this._resourceStatesMap.set(ee,B);const j=B.resourceUri,x=m(B.decorations),$=B.decorations&&m(B.decorations.light)||x,F=B.decorations&&m(B.decorations.dark)||x,U=[];let M;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const me=new I.DisposableStore;M=this._commands.converter.toInternal(B.command,me),this._resourceStatesDisposablesMap.set(ee,me)}else this._resourceStatesCommandsMap.set(ee,B.command);$&&U.push($),F&&F.toString()!==($==null?void 0:$.toString())&&U.push(F);const N=B.decorations&&B.decorations.tooltip||"",O=B.decorations&&!!B.decorations.strikeThrough,V=B.decorations&&!!B.decorations.faded,q=B.contextValue||"";return{rawResource:[ee,j,U,N,O,V,q,M],handle:ee}});return{start:A.start,deleteCount:A.deleteCount,toInsert:L}}),f=E.map(({start:A,deleteCount:L,toInsert:B})=>[A,L,B.map(ee=>ee.rawResource)]),h=E.reverse();for(const{start:A,deleteCount:L,toInsert:B}of h){const ee=B.map(x=>x.handle),j=this._handlesSnapshot.splice(A,L,...ee);for(const x of j)this._resourceStatesMap.delete(x),this._resourceStatesCommandsMap.delete(x),(l=this._resourceStatesDisposablesMap.get(x))===null||l===void 0||l.dispose(),this._resourceStatesDisposablesMap.delete(x)}return this._resourceSnapshot=a,f}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(l,a,g,E,f,h){this._proxy=a,this._commands=g,this._id=E,this._label=f,this._rootUri=h,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new I.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new I.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new P.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new c(l,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,f,h)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(l){this._count!==l&&(this._count=l,this._proxy.$updateSourceControl(this.handle,{count:l}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(l){this._quickDiffProvider=l,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!l})}get commitTemplate(){return this._commitTemplate}set commitTemplate(l){l!==this._commitTemplate&&(this._commitTemplate=l,this._proxy.$updateSourceControl(this.handle,{commitTemplate:l}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(l){this._acceptInputDisposables.value=new I.DisposableStore,this._acceptInputCommand=l;const a=this._commands.converter.toInternal(l,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:a})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(l){if(!(this._statusBarCommands&&l&&u(this._statusBarCommands,l))){this._statusBarDisposables.value=new I.DisposableStore,this._statusBarCommands=l;const a=(l||[]).map(g=>this._commands.converter.toInternal(g,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:a})}}get selected(){return this._selected}createResourceGroup(l,a){const g=new t(this._proxy,this._commands,this.handle,l,a),E=P.Event.once(g.onDidDispose)(()=>this.createdResourceGroups.delete(g));return this.createdResourceGroups.set(g,E),this.eventuallyAddResourceGroups(),g}eventuallyAddResourceGroups(){const l=[],a=[];for(const[g,E]of this.createdResourceGroups){E.dispose();const f=g.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(g),this.eventuallyUpdateResourceStates()});P.Event.once(g.onDidDispose)(()=>{this.updatedResourceGroups.delete(g),f.dispose(),this._groups.delete(g.handle),this._proxy.$unregisterGroup(this.handle,g.handle)}),l.push([g.handle,g.id,g.label,g.features]);const h=g._takeResourceStateSnapshot();h.length>0&&a.push([g.handle,h]),this._groups.set(g.handle,g)}this._proxy.$registerGroups(this.handle,l,a),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const l=[];this.updatedResourceGroups.forEach(a=>{const g=a._takeResourceStateSnapshot();g.length!==0&&l.push([a.handle,g])}),l.length>0&&this._proxy.$spliceResourceStates(this.handle,l),this.updatedResourceGroups.clear()}getResourceGroup(l){return this._groups.get(l)}setSelectionState(l){this._selected=l,this._onDidChangeSelection.fire(l)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(l=>l.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,je([(0,T.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),je([(0,T.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let o=class Fn{constructor(l,a,g){this._commands=a,this.logService=g,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new P.Emitter,this._proxy=l.getProxy(k.MainContext.MainThreadSCM),this._telemetry=l.getProxy(k.MainContext.MainThreadTelemetry),a.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const f=this._sourceControls.get(E.sourceControlHandle);if(!f)return E;const h=f.getResourceGroup(E.groupHandle);return h?h.getResourceState(E.handle):E}else if(E&&E.$mid===4){const f=this._sourceControls.get(E.sourceControlHandle);return f?f.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const f=this._sourceControls.get(E.handle);return f||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(l,a,g,E){this.logService.trace("ExtHostSCM#createSourceControl",l.identifier.value,a,g,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const f=Fn._handlePool++,h=new n(l,this._proxy,this._commands,a,g,E);this._sourceControls.set(f,h);const A=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(l.identifier))||[];return A.push(h),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(l.identifier),A),h}getLastInputBox(l){this.logService.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const a=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(l.identifier)),g=a&&a[a.length-1];return g&&g.inputBox}$provideOriginalResource(l,a,g){const E=_.URI.revive(a);this.logService.trace("ExtHostSCM#$provideOriginalResource",l,E.toString());const f=this._sourceControls.get(l);return!f||!f.quickDiffProvider||!f.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>f.quickDiffProvider.provideOriginalResource(E,g)).then(h=>h||null)}$onInputBoxValueChange(l,a){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",l);const g=this._sourceControls.get(l);return g&&g.inputBox.$onInputBoxValueChange(a),Promise.resolve(void 0)}$executeResourceCommand(l,a,g,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",l,a,g);const f=this._sourceControls.get(l);if(!f)return Promise.resolve(void 0);const h=f.getResourceGroup(a);return h?h.$executeResourceCommand(g,E):Promise.resolve(void 0)}$validateInput(l,a,g){this.logService.trace("ExtHostSCM#$validateInput",l);const E=this._sourceControls.get(l);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>E.inputBox.validateInput(a,g)).then(f=>f?Promise.resolve([f.message,f.type]):Promise.resolve(void 0))}$setSelectedSourceControl(l){var a,g;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&((a=this._sourceControls.get(l))===null||a===void 0||a.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((g=this._sourceControls.get(this._selectedSourceControlHandle))===null||g===void 0||g.setSelectionState(!1)),this._selectedSourceControlHandle=l,Promise.resolve(void 0)}};o._handlePool=0,o=je([xe(2,R.ILogService)],o),e.ExtHostSCM=o});var et=this&&this.__classPrivateFieldSet||function(Q,e,_,P,T){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?T.call(Q,_):T?T.value=_:e.set(Q,_),_},He=this&&this.__classPrivateFieldGet||function(Q,e,_,P){if(_==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!P:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?P:_==="a"?P.call(Q):P?P.value:e.get(Q)};define(ge[245],pe([0,1,7,5,163,6]),function(Q,e,_,P,T,I){"use strict";var D,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{constructor(w,m,s,d,S=_.StatusBarAlignment.Left,v,b){D.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new I.DisposableStore,et(this,D,w,"f"),et(this,k,m,"f"),this._id=y.ID_GEN++,this._statusId=s,this._statusName=d,this._alignment=S,this._priority=v,this._accessibilityInformation=b}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var w;return(w=this._command)===null||w===void 0?void 0:w.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(w){this._text=w,this.update()}set tooltip(w){this._tooltip=w,this.update()}set color(w){this._color=w,this.update()}set backgroundColor(w){w&&!y.ALLOWED_BACKGROUND_COLORS.has(w.id)&&(w=void 0),this._backgroundColor=w,this.update()}set command(w){var m;((m=this._command)===null||m===void 0?void 0:m.fromApi)!==w&&(this._internalCommandRegistration.clear(),typeof w=="string"?this._command={fromApi:w,internal:He(this,k,"f").toInternal({title:"",command:w},this._internalCommandRegistration)}:w?this._command={fromApi:w,internal:He(this,k,"f").toInternal(w,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(w){this._accessibilityInformation=w,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,He(this,D,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var w;this._timeoutHandle=void 0;let m=this._color;this._backgroundColor&&(m=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),He(this,D,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(w=this._command)===null||w===void 0?void 0:w.internal,m,this._backgroundColor,this._alignment===_.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y,D=new WeakMap,k=new WeakMap,y.ID_GEN=0,y.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new _.ThemeColor("statusBarItem.errorForeground")]]);class i{constructor(w){this._messages=[],this._item=w.createStatusBarEntry("status.extensionMessage",(0,T.localize)(0,null),_.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(w){const m={message:w};return this._messages.unshift(m),this._update(),new _.Disposable(()=>{const s=this._messages.indexOf(m);s>=0&&(this._messages.splice(s,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class R{constructor(w,m){this._proxy=w.getProxy(P.MainContext.MainThreadStatusBar),this._commands=m,this._statusMessage=new i(this)}createStatusBarEntry(w,m,s,d,S){return new y(this._proxy,this._commands,w,m,s,d,S)}setStatusBarMessage(w,m){const s=this._statusMessage.setMessage(w);let d;return typeof m=="number"?d=setTimeout(()=>s.dispose(),m):typeof m!="undefined"&&m.then(()=>s.dispose(),()=>s.dispose()),new _.Disposable(()=>{s.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=R}),define(ge[89],pe([0,1,5,3,4]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class I{constructor(k){this._onDidChangeStorage=new P.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(_.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,y){this._proxy.$registerExtensionStorageKeysToSync(k,y)}getValue(k,y,i){return this._proxy.$getValue(k,y).then(R=>R||i)}setValue(k,y,i){return this._proxy.$setValue(k,y,i)}$acceptValue(k,y,i){this._onDidChangeStorage.fire({shared:k,key:y,value:i})}}e.ExtHostStorage=I,e.IExtHostStorage=(0,T.createDecorator)("IExtHostStorage")}),define(ge[90],pe([0,1,4,27,12,88,2]),function(Q,e,_,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,_.createDecorator)("IExtensionStoragePaths");let k=class{constructor(i,R,C){var w;this._logService=R,this._extHostFileSystem=C,this._workspace=(w=i.workspace)!==null&&w!==void 0?w:void 0,this._environment=i.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getOrCreateWorkspaceStoragePath(){var i;if(!this._workspace)return Promise.resolve(void 0);const R=this._workspace.id,C=D.URI.joinPath(this._environment.workspaceStorageHome,R);try{return await this._extHostFileSystem.value.stat(C),this._logService.trace("[ExtHostStorage] storage dir already exists",C),C}catch(w){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",C),await this._extHostFileSystem.value.createDirectory(C),await this._extHostFileSystem.value.writeFile(D.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(i=D.URI.revive(this._workspace.configuration))===null||i===void 0?void 0:i.toString(),name:this._workspace.name},void 0,2))),C}catch(w){this._logService.error("[ExtHostStorage]",w);return}}workspaceValue(i){if(this._value)return D.URI.joinPath(this._value,i.identifier.value)}globalValue(i){return D.URI.joinPath(this._environment.globalStorageHome,i.identifier.value.toLowerCase())}};k=je([xe(0,P.IExtHostInitDataService),xe(1,T.ILogService),xe(2,I.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(ge[34],pe([0,1,3,5,4,2,13,6,7,164,18,209,21,28,189]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,T.createDecorator)("IExtHostTerminalService");class d{constructor(t,n,o,r){this._proxy=t,this._id=n,this._creationOptions=o,this._name=r,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(a=>this._pidPromiseComplete=a);const l=this;this.value={get name(){return l._name||""},get processId(){return l._pidPromise},get creationOptions(){return l._creationOptions},get exitStatus(){return l._exitStatus},sendText(a,g=!0){l._checkDisposed(),l._proxy.$sendText(l._id,a,g)},show(a){l._checkDisposed(),l._proxy.$show(l._id,a)},hide(){l._checkDisposed(),l._proxy.$hide(l._id)},dispose(){l._disposed||(l._disposed=!0,l._proxy.$dispose(l._id))},get dimensions(){if(!(l._cols===void 0||l._rows===void 0))return{columns:l._cols,rows:l._rows}}}}async create(t,n,o,r,l,a,g,E,f,h,A){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:o,env:r,icon:l,initialText:a,waitOnExit:g,strictEnv:E,hideFromUser:f,isFeatureTerminal:h,isExtensionOwnedTerminal:A})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=d;class S{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new _.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new _.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new _.Emitter,this._onProcessTitleChanged=new _.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new _.Emitter,this._onProcessShellTypeChanged=new _.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=S;let v=1,b=class extends k.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new _.Emitter,this._onDidOpenTerminal=new _.Emitter,this._onDidChangeActiveTerminal=new _.Emitter,this._onDidChangeTerminalDimensions=new _.Emitter,this._proxy=n.getProxy(P.MainContext.MainThreadTerminalService),this._bufferer=new s.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new _.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[o,r]of this._terminalProcesses)r.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const n=new d(this._proxy,(0,m.generateUuid)(),t,t.name),o=new S(t.pty);return n.createExtensionTerminal().then(r=>{const l=this._setupExtHostProcessListeners(r,o);this._terminalProcessDisposables[r]=l}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const r=new S(n),l=this._setupExtHostProcessListeners(t,r);this._terminalProcessDisposables[t]=l}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const o=this._getTerminalById(t);o&&(this._activeTerminal=o,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const o=this._getTerminalById(t);o&&this._onDidWriteTerminalData.fire({terminal:o.value,data:n})}async $acceptTerminalDimensions(t,n,o){const r=this._getTerminalById(t);r&&r.setDimensions(n,o)&&this._onDidChangeTerminalDimensions.fire({terminal:r.value,dimensions:r.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,o){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,o)}async $acceptTerminalTitleChange(t,n){const o=this._getTerminalById(t);o&&(o.name=n)}async $acceptTerminalClosed(t,n){const o=this._getTerminalObjectIndexById(this._terminals,t);if(o!==null){const r=this._terminals.splice(o,1)[0];r.setExitCode(n),this._onDidCloseTerminal.fire(r.value)}}$acceptTerminalOpened(t,n,o,r){if(n){const g=this._getTerminalObjectIndexById(this._terminals,n);if(g!==null){this._terminals[g]._id=t,this._onDidOpenTerminal.fire(this.terminals[g]),this._terminals[g].isOpen=!0;return}}const l={name:r.name,shellPath:r.executable,shellArgs:r.args,cwd:typeof r.cwd=="string"?r.cwd:I.URI.revive(r.cwd),env:r.env,hideFromUser:r.hideFromUser},a=new d(this._proxy,t,l,o);this._terminals.push(a),this._onDidOpenTerminal.fire(a.value),a.isOpen=!0}async $acceptTerminalProcessId(t,n){const o=this._getTerminalById(t);o&&o._setProcessId(n)}async $startExtensionTerminal(t,n){const o=this._getTerminalById(t);if(!o)return{message:(0,i.localize)(0,null,t)};o.isOpen||await new Promise(l=>{const a=this.onDidOpenTerminal(async g=>{g===o.value&&(a.dispose(),l())})});const r=this._terminalProcesses.get(t);r?r.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const o=new k.DisposableStore;o.add(n.onProcessReady(l=>this._proxy.$sendProcessReady(t,l.pid,l.cwd))),o.add(n.onProcessTitleChanged(l=>this._proxy.$sendProcessTitle(t,l))),this._bufferer.startBuffering(t,n.onProcessData),o.add(n.onProcessExit(l=>this._onProcessExit(t,l))),n.onProcessOverrideDimensions&&o.add(n.onProcessOverrideDimensions(l=>this._proxy.$sendOverrideDimensions(t,l))),this._terminalProcesses.set(t,n);const r=this._extensionTerminalAwaitingStart[t];return r&&n instanceof S&&(n.startSendingEvents(r.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),o}$acceptProcessAckDataEvent(t,n){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.input(n)}$acceptProcessResize(t,n,o){var r;try{(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,o)}catch(l){if(l.code!=="EPIPE"&&l.code!=="ERR_IPC_CHANNEL_CLOSED")throw l}}$acceptProcessShutdown(t,n){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(o=>this._proxy.$sendProcessInitialCwd(t,o))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(o=>this._proxy.$sendProcessCwd(t,o))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const o=this._getTerminalById(t);if(!o)return[];this._terminalLinkCache.delete(t);const r=this._terminalLinkCancellationSource.get(t);r&&r.dispose(!0);const l=new w.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,l);const a=[],g={terminal:o.value,line:n},E=[];for(const A of this._linkProviders)E.push(new Promise(async L=>{l.token.onCancellationRequested(()=>L({provider:A,links:[]}));const B=await A.provideTerminalLinks(g,l.token)||[];l.token.isCancellationRequested||L({provider:A,links:B})}));const f=await Promise.all(E);if(l.token.isCancellationRequested)return[];const h=new Map;for(const A of f)A&&A.links.length>0&&a.push(...A.links.map(L=>{const B={id:v++,startIndex:L.startIndex,length:L.length,label:L.tooltip};return h.set(B.id,{provider:A.provider,link:L}),B}));return this._terminalLinkCache.set(t,h),a}$activateLink(t,n){var o;const r=(o=this._terminalLinkCache.get(t))===null||o===void 0?void 0:o.get(n);!r||r.provider.handleTerminalLink(r.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const o=this._terminalProcessDisposables[t];o&&(o.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const o=this._getTerminalObjectIndexById(t,n);return o!==null?t[o]:null}_getTerminalObjectIndexById(t,n){let o=null;return t.some((r,l)=>r._id===n?(o=l,!0):!1),o}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new p,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const o=(0,C.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,o.length===0?void 0:o)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const o=n[0],r=new p(n[1]);this._setEnvironmentVariableCollection(o,r)})}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};b=je([xe(1,D.IExtHostRpcService)],b),e.BaseExtHostTerminalService=b;class p{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new _.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:y.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const o=this.map.get(t);(!o||o.value!==n.value||o.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((o,r)=>t.call(n,r,o,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=p;let u=class extends b{constructor(t){super(!1,t)}createTerminal(t,n,o){throw new R.NotSupportedError}createTerminalFromOptions(t){throw new R.NotSupportedError}getDefaultShell(t,n){throw new R.NotSupportedError}getDefaultShellArgs(t,n){throw new R.NotSupportedError}$getAvailableProfiles(t){throw new R.NotSupportedError}async $getDefaultShellAndArgs(t){throw new R.NotSupportedError}$acceptWorkspacePermissionsChanged(t){throw new R.NotSupportedError}};u=je([xe(0,D.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u}),define(ge[246],pe([0,1,3,14,5,122,20,7]),function(Q,e,_,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(R,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new _.Emitter,this._onDidChangeTextEditorOptions=new _.Emitter,this._onDidChangeTextEditorVisibleRanges=new _.Emitter,this._onDidChangeTextEditorViewColumn=new _.Emitter,this._onDidChangeActiveTextEditor=new _.Emitter,this._onDidChangeVisibleTextEditors=new _.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(T.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(w=>this._onDidChangeVisibleTextEditors.fire(w)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(w=>this._onDidChangeActiveTextEditor.fire(w))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const C=this._extHostDocumentsAndEditors.allEditors();return R?C:C.map(w=>w.value)}async showTextDocument(R,C,w){let m;typeof C=="number"?m={position:D.ViewColumn.from(C),preserveFocus:w}:typeof C=="object"?m={position:D.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?D.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:m={preserveFocus:!1};const s=await this._proxy.$tryShowTextDocument(R.uri,m),d=s&&this._extHostDocumentsAndEditors.getEditor(s);if(d)return d.value;throw s?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R){return new I.TextEditorDecorationType(this._proxy,R).value}$acceptEditorPropertiesChanged(R,C){const w=this._extHostDocumentsAndEditors.getEditor(R);if(!w)throw new Error("unknown text editor");if(C.options&&w._acceptOptions(C.options),C.selections){const m=C.selections.selections.map(D.Selection.to);w._acceptSelections(m)}if(C.visibleRanges){const m=P.coalesce(C.visibleRanges.map(D.Range.to));w._acceptVisibleRanges(m)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:w.value,options:Object.assign(Object.assign({},C.options),{lineNumbers:D.TextEditorLineNumbersStyle.to(C.options.lineNumbers)})}),C.selections){const m=k.TextEditorSelectionChangeKind.fromValue(C.selections.source),s=C.selections.selections.map(D.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:w.value,selections:s,kind:m})}if(C.visibleRanges){const m=P.coalesce(C.visibleRanges.map(D.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:w.value,visibleRanges:m})}}$acceptEditorPositionData(R){for(const C in R){const w=this._extHostDocumentsAndEditors.getEditor(C);if(!w)throw new Error("Unknown text editor");const m=D.ViewColumn.to(R[C]);w.value.viewColumn!==m&&(w._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:w.value,viewColumn:m}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=y});var mn=this&&this.__rest||function(Q,e){var _={};for(var P in Q)Object.prototype.hasOwnProperty.call(Q,P)&&e.indexOf(P)<0&&(_[P]=Q[P]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,P=Object.getOwnPropertySymbols(Q);T<P.length;T++)e.indexOf(P[T])<0&&Object.prototype.propertyIsEnumerable.call(Q,P[T])&&(_[P[T]]=Q[P[T]]);return _};define(ge[247],pe([0,1,2,4,5,6,7]),function(Q,e,_,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,P.createDecorator)("IExtHostTimeline");class k{constructor(R,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(T.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:w=>{var m,s;if(w&&w.$mid===11){const d=w.uri===void 0?void 0:_.URI.revive(w.uri);return(s=(m=this._itemsBySourceAndUriMap.get(w.source))===null||m===void 0?void 0:m.get(y(d)))===null||s===void 0?void 0:s.get(w.handle)}return w}})}async $getTimeline(R,C,w,m,s){const d=this._providers.get(R);return d==null?void 0:d.provideTimeline(_.URI.revive(C),w,m,s)}registerTimelineProvider(R,C,w,m){const s=new I.DisposableStore,d=this.convertTimelineItem(C.id,m,s).bind(this);let S;C.onDidChange&&(S=C.onDidChange(b=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},b),{id:C.id})),this));const v=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},C),{scheme:R,onDidChange:void 0,async provideTimeline(b,p,u,c){var t;(c==null?void 0:c.resetCache)&&(s.clear(),(t=v.get(C.id))===null||t===void 0||t.clear());const n=await C.provideTimeline(b,p,u);if(n!=null){const o=d(b,c);return Object.assign(Object.assign({},n),{source:C.id,items:n.items.map(o)})}},dispose(){var b;for(const p of v.values())(b=p.get(C.id))===null||b===void 0||b.clear();S==null||S.dispose(),s.dispose()}}))}convertTimelineItem(R,C,w){return(m,s)=>{let d;if(s==null?void 0:s.cacheResults){let S=this._itemsBySourceAndUriMap.get(R);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(R,S));const v=y(m);d=S.get(v),d===void 0&&(d=new Map,S.set(v,d))}return S=>{var v,b;const{iconPath:p}=S,u=mn(S,["iconPath"]),c=`${R}|${(v=S.id)!==null&&v!==void 0?v:S.timestamp}`;d==null||d.set(c,S);let t,n,o;return S.iconPath&&(p instanceof D.ThemeIcon?o={id:p.id}:_.URI.isUri(p)?(t=p,n=p):{light:t,dark:n}=p),Object.assign(Object.assign({},u),{id:(b=u.id)!==null&&b!==void 0?b:void 0,handle:c,source:R,command:S.command?C.toInternal(S.command,w):void 0,icon:t,iconDark:n,themeIcon:o,accessibilityInformation:S.accessibilityInformation})}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,I.toDisposable)(()=>{var w;for(const m of this._itemsBySourceAndUriMap.values())(w=m.get(R.id))===null||w===void 0||w.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=k;function y(i){return i==null?void 0:i.toString()}}),define(ge[248],pe([0,1,6,11,2,5]),function(Q,e,_,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(y){this._openers=new Map,this._proxy=y.getProxy(I.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,i,R,C){if(this._openers.has(i))throw new Error(`Opener with id '${i}' already registered`);const w=C.schemes.find(m=>!D.supportedSchemes.has(m));if(w)throw new Error(`Scheme '${w}' is not supported. Only http and https are currently supported.`);return this._openers.set(i,R),this._proxy.$registerUriOpener(i,C.schemes,y,C.label),(0,_.toDisposable)(()=>{this._openers.delete(i),this._proxy.$unregisterUriOpener(i)})}async $canOpenUri(y,i,R){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener with id: ${y}`);const w=T.URI.revive(i);return C.canOpenExternalUri(w,R)}async $openUri(y,i,R){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener id: '${y}'`);return C.openExternalUri(T.URI.revive(i.resolvedUri),{sourceUri:T.URI.revive(i.sourceUri)},R)}}e.ExtHostUriOpeners=D,D.supportedSchemes=new Set([P.Schemas.http,P.Schemas.https])}),define(ge[249],pe([0,1,5,2,6,18,29]),function(Q,e,_,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(i){this.handles=new Set,this.handlers=new Map,this._proxy=i.getProxy(_.MainContext.MainThreadUrls)}registerUriHandler(i,R){if(this.handles.has(D.ExtensionIdentifier.toKey(i)))throw new Error(`Protocol handler already registered for extension ${i}`);const C=k.HandlePool++;return this.handles.add(D.ExtensionIdentifier.toKey(i)),this.handlers.set(C,R),this._proxy.$registerUriHandler(C,i),(0,T.toDisposable)(()=>{this.handles.delete(D.ExtensionIdentifier.toKey(i)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(i,R){const C=this.handlers.get(i);if(!C)return Promise.resolve(void 0);try{C.handleUri(P.URI.revive(R))}catch(w){(0,I.onUnexpectedError)(w)}return Promise.resolve(void 0)}async createAppUri(i){return P.URI.revive(await this._proxy.$createAppUri(i))}}e.ExtHostUrls=k,k.HandlePool=0});var et=this&&this.__classPrivateFieldSet||function(Q,e,_,P,T){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?T.call(Q,_):T?T.value=_:e.set(Q,_),_},He=this&&this.__classPrivateFieldGet||function(Q,e,_,P){if(_==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!P:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?P:_==="a"?P.call(Q):P?P.value:e.get(Q)};define(ge[64],pe([0,1,22,3,2,176,199,85,5]),function(Q,e,_,P,T,I,D,k,y){"use strict";var i,R,C,w,m,s,d,S,v,b,p,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.serializeMessage=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class c{constructor(f,h,A,L,B,ee,j){i.set(this,void 0),R.set(this,void 0),C.set(this,void 0),w.set(this,void 0),m.set(this,void 0),s.set(this,void 0),d.set(this,""),S.set(this,void 0),v.set(this,!1),b.set(this,!1),p.set(this,!1),this._onMessageEmitter=new P.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new P.Emitter),this._onDidDispose=He(this,u,"f").event,et(this,i,f,"f"),et(this,R,h,"f"),et(this,S,A,"f"),et(this,w,L,"f"),et(this,m,B,"f"),et(this,s,ee,"f"),et(this,p,t(ee),"f"),et(this,C,j,"f")}dispose(){et(this,v,!0,"f"),He(this,u,"f").fire(),He(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return et(this,b,!0,"f"),(0,k.asWebviewUri)(He(this,w,"f"),He(this,i,"f"),f)}get cspSource(){return He(this,w,"f").webviewCspSource.replace("{{uuid}}",He(this,i,"f"))}get html(){return this.assertNotDisposed(),He(this,d,"f")}set html(f){this.assertNotDisposed(),He(this,d,"f")!==f&&(et(this,d,f,"f"),!He(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(et(this,b,!0,"f"),He(this,C,"f").report("Webview vscode-resource: uris",He(this,s,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),He(this,R,"f").$setHtml(He(this,i,"f"),f))}get options(){return this.assertNotDisposed(),He(this,S,"f")}set options(f){this.assertNotDisposed(),He(this,R,"f").$setOptions(He(this,i,"f"),l(He(this,s,"f"),He(this,m,"f"),f)),et(this,S,f,"f")}async postMessage(f){if(He(this,v,"f"))return!1;const h=n(f,{serializeBuffersForPostMessage:He(this,p,"f")});return He(this,R,"f").$postMessage(He(this,i,"f"),h.message,...h.buffers)}assertNotDisposed(){if(He(this,v,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=c,i=new WeakMap,R=new WeakMap,C=new WeakMap,w=new WeakMap,m=new WeakMap,s=new WeakMap,d=new WeakMap,S=new WeakMap,v=new WeakMap,b=new WeakMap,p=new WeakMap,u=new WeakMap;function t(E){if(!E.enableProposedApi)return!1;try{const f=(0,I.normalizeVersion)((0,I.parseVersion)(E.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=56}catch(f){return!1}}e.shouldSerializeBuffersForPostMessage=t;function n(E,f){if(f.serializeBuffersForPostMessage){const h=[],A=(B,ee)=>{if(ee&&ee instanceof ArrayBuffer){let j=h.findIndex(x=>x.original===ee);if(j===-1){const x=new Uint8Array(ee),$=_.VSBuffer.wrap(x);j=h.length,h.push({original:ee,vsBuffer:$})}return{$$vscode_array_buffer_reference$$:!0,index:j}}return ee};return{message:JSON.stringify(E,A),buffers:h.map(B=>B.vsBuffer)}}else return{message:JSON.stringify(E),buffers:[]}}e.serializeMessage=n;class o{constructor(f,h,A,L,B){this.initData=h,this.workspace=A,this._logService=L,this._deprecationService=B,this._webviews=new Map,this._webviewProxy=f.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(f,h,...A){const L=this.getWebview(f);if(L){const{message:B}=(0,D.deserializeWebviewMessage)(h,A);L._onMessageEmitter.fire(B)}}$onMissingCsp(f,h){this._logService.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,h,A){const L=new c(f,this._webviewProxy,a(h),this.initData,this.workspace,A,this._deprecationService);return this._webviews.set(f,L),L._onDidDispose(()=>{this._webviews.delete(f)}),L}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=o;function r(E){return{id:E.identifier,location:E.extensionLocation}}e.toExtensionData=r;function l(E,f,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||g(E,f)}}e.serializeWebviewOptions=l;function a(E){var f;return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,portMapping:E.portMapping,localResourceRoots:(f=E.localResourceRoots)===null||f===void 0?void 0:f.map(h=>T.URI.from(h))}}e.reviveOptions=a;function g(E,f){return[...((f==null?void 0:f.getWorkspaceFolders())||[]).map(h=>h.uri),E.extensionLocation]}}),define(ge[250],pe([0,1,21,73,6,11,25,2,20,64,84,5,7]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=u(this.document.uri)+this._backupCounter++;return(0,D.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class s{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,o){const r=this.key(t,n.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const l=new m(n,o);return this._documents.set(r,l),l}delete(t,n){const o=this.key(t,n.uri);this._documents.delete(o)}key(t,n){return`${t}@@@${n}`}}var d;(function(c){c[c.Text=0]="Text",c[c.Custom=1]="Custom"})(d||(d={}));class S{constructor(){this._providers=new Map}addTextProvider(t,n,o){return this.add(0,t,n,o)}addCustomProvider(t,n,o){return this.add(1,t,n,o)}get(t){return this._providers.get(t)}add(t,n,o,r){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:o,provider:r}),new w.Disposable(()=>this._providers.delete(n))}}class v{constructor(t,n,o,r,l){this._extHostDocuments=n,this._extensionStoragePaths=o,this._extHostWebview=r,this._extHostWebviewPanels=l,this._editorProviders=new S,this._documents=new s,this._proxy=t.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,o,r){const l=new T.DisposableStore;return b(o)?(l.add(this._editorProviders.addTextProvider(n,t,o)),this._proxy.$registerTextEditorProvider((0,i.toExtensionData)(t),n,r.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,i.shouldSerializeBuffersForPostMessage)(t))):(l.add(this._editorProviders.addCustomProvider(n,t,o)),this.supportEditing(o)&&l.add(o.onDidChangeCustomDocument(a=>{const g=this.getCustomDocumentEntry(n,a.document.uri);if(p(a)){const E=g.addEdit(a);this._proxy.$onDidEdit(a.document.uri,n,E,a.label)}else this._proxy.$onContentChange(a.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,i.toExtensionData)(t),n,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,i.shouldSerializeBuffersForPostMessage)(t))),w.Disposable.from(l,new w.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,o,r,l){var a;const g=this._editorProviders.get(n);if(!g)throw new Error(`No provider found for '${n}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${n}'`);const E=k.URI.revive(t),f=await g.provider.openCustomDocument(E,{backupId:o,untitledDocumentData:r==null?void 0:r.buffer},l);let h;return this.supportEditing(g.provider)&&this._extensionStoragePaths&&(h=(a=this._extensionStoragePaths.workspaceValue(g.extension))!==null&&a!==void 0?a:this._extensionStoragePaths.globalValue(g.extension)),this._documents.add(n,f,h),{editable:this.supportEditing(g.provider)}}async $disposeCustomDocument(t,n){const o=this._editorProviders.get(n);if(!o)throw new Error(`No provider found for '${n}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${n}'`);const r=k.URI.revive(t),{document:l}=this.getCustomDocumentEntry(n,r);this._documents.delete(n,l),l.dispose()}async $resolveWebviewEditor(t,n,o,r,l,a){const g=this._editorProviders.get(o);if(!g)throw new Error(`No provider found for '${o}'`);const E=y.ViewColumn.to(l),f=this._extHostWebview.createNewWebview(n,r.webviewOptions,g.extension),h=this._extHostWebviewPanels.createNewWebviewPanel(n,o,r.title,E,r.panelOptions,f),A=k.URI.revive(t);switch(g.type){case 1:{const{document:L}=this.getCustomDocumentEntry(o,A);return g.provider.resolveCustomEditor(L,h,a)}case 0:{const L=this._extHostDocuments.getDocument(A);return g.provider.resolveCustomTextEditor(L,h,a)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,o){this.getCustomDocumentEntry(n,t).disposeEdits(o)}async $onMoveCustomEditor(t,n,o){const r=this._editorProviders.get(o);if(!r)throw new Error(`No provider found for '${o}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const l=this._extHostWebviewPanels.getWebviewPanel(t);if(!l)throw new Error("No webview found");const a=k.URI.revive(n),g=this._extHostDocuments.getDocument(a);await r.provider.moveCustomTextEditor(g,l,_.CancellationToken.None)}async $undo(t,n,o,r){return this.getCustomDocumentEntry(n,t).undo(o,r)}async $redo(t,n,o,r){return this.getCustomDocumentEntry(n,t).redo(o,r)}async $revert(t,n,o){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(r.document,o),r.disposeBackup()}async $onSave(t,n,o){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(r.document,o),r.disposeBackup()}async $onSaveAs(t,n,o,r){const l=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(l.document,k.URI.revive(o),r)}async $backup(t,n,o){const r=this.getCustomDocumentEntry(n,t),a=await this.getCustomEditorProvider(n).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},o);return r.updateBackup(a),a.id}getCustomDocumentEntry(t,n){const o=this._documents.get(t,k.URI.revive(n));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(t){const n=this._editorProviders.get(t),o=n==null?void 0:n.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=v;function b(c){return typeof c.resolveCustomTextEditor=="function"}function p(c){return typeof c.undo=="function"&&typeof c.redo=="function"}function u(c){const t=c.scheme===I.Schemas.file||c.scheme===I.Schemas.untitled?c.fsPath:c.toString();return(0,P.hash)(t)+""}});var et=this&&this.__classPrivateFieldSet||function(Q,e,_,P,T){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?T.call(Q,_):T?T.value=_:e.set(Q,_),_},He=this&&this.__classPrivateFieldGet||function(Q,e,_,P){if(_==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!P:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?P:_==="a"?P.call(Q):P?P.value:e.get(Q)};define(ge[251],pe([0,1,3,6,2,28,20,64,5,7]),function(Q,e,_,P,T,I,D,k,y,i){"use strict";var R,C,w,m,s,d,S,v,b,p,u,c,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends P.Disposable{constructor(a,g,E,f,h,A,L){super();R.set(this,void 0),C.set(this,void 0),w.set(this,void 0),m.set(this,void 0),s.set(this,void 0),d.set(this,void 0),S.set(this,void 0),v.set(this,void 0),b.set(this,!0),p.set(this,!0),u.set(this,!1),c.set(this,this._register(new _.Emitter)),this.onDidDispose=He(this,c,"f").event,t.set(this,this._register(new _.Emitter)),this.onDidChangeViewState=He(this,t,"f").event,et(this,R,a,"f"),et(this,C,g,"f"),et(this,w,E,"f"),et(this,s,A,"f"),et(this,v,h,"f"),et(this,d,f,"f"),et(this,m,L,"f")}dispose(){He(this,u,"f")||(et(this,u,!0,"f"),He(this,c,"f").fire(),He(this,C,"f").$disposeWebview(He(this,R,"f")),He(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),He(this,m,"f")}get viewType(){return this.assertNotDisposed(),He(this,w,"f")}get title(){return this.assertNotDisposed(),He(this,d,"f")}set title(a){this.assertNotDisposed(),He(this,d,"f")!==a&&(et(this,d,a,"f"),He(this,C,"f").$setTitle(He(this,R,"f"),a))}get iconPath(){return this.assertNotDisposed(),He(this,S,"f")}set iconPath(a){this.assertNotDisposed(),He(this,S,"f")!==a&&(et(this,S,a,"f"),He(this,C,"f").$setIconPath(He(this,R,"f"),T.URI.isUri(a)?{light:a,dark:a}:a))}get options(){return He(this,s,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof He(this,v,"f")=="number"&&He(this,v,"f")<0))return He(this,v,"f")}get active(){return this.assertNotDisposed(),He(this,p,"f")}get visible(){return this.assertNotDisposed(),He(this,b,"f")}_updateViewState(a){He(this,u,"f")||(this.active!==a.active||this.visible!==a.visible||this.viewColumn!==a.viewColumn)&&(et(this,p,a.active,"f"),et(this,b,a.visible,"f"),et(this,v,a.viewColumn,"f"),He(this,t,"f").fire({webviewPanel:this}))}reveal(a,g){this.assertNotDisposed(),He(this,C,"f").$reveal(He(this,R,"f"),{viewColumn:a?D.ViewColumn.from(a):void 0,preserveFocus:!!g})}assertNotDisposed(){if(He(this,u,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,C=new WeakMap,w=new WeakMap,m=new WeakMap,s=new WeakMap,d=new WeakMap,S=new WeakMap,v=new WeakMap,b=new WeakMap,p=new WeakMap,u=new WeakMap,c=new WeakMap,t=new WeakMap;class o{constructor(a,g,E){this.webviews=g,this.workspace=E,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=a.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,I.generateUuid)()}createWebviewPanel(a,g,E,f,h={}){const A=typeof f=="object"?f.viewColumn:f,L={viewColumn:D.ViewColumn.from(A),preserveFocus:typeof f=="object"&&!!f.preserveFocus},B=(0,k.shouldSerializeBuffersForPostMessage)(a),ee=o.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(a),ee,g,{title:E,panelOptions:r(h),webviewOptions:(0,k.serializeWebviewOptions)(a,this.workspace,h),serializeBuffersForPostMessage:B},L);const j=this.webviews.createNewWebview(ee,h,a);return this.createNewWebviewPanel(ee,g,E,A,h,j)}$onDidChangeWebviewPanelViewStates(a){const g=Object.keys(a);g.sort((E,f)=>{const h=a[E],A=a[f];return h.active?1:A.active?-1:+h.visible-+A.visible});for(const E of g){const f=this.getWebviewPanel(E);if(!!f){const h=a[E];f._updateViewState({active:h.active,visible:h.visible,viewColumn:D.ViewColumn.to(h.position)})}}}async $onDidDisposeWebviewPanel(a){const g=this.getWebviewPanel(a);g==null||g.dispose(),this._webviewPanels.delete(a),this.webviews.deleteWebview(a)}registerWebviewPanelSerializer(a,g,E){if(this._serializers.has(g))throw new Error(`Serializer for '${g}' already registered`);return this._serializers.set(g,{serializer:E,extension:a}),this._proxy.$registerSerializer(g,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(a)}),new i.Disposable(()=>{this._serializers.delete(g),this._proxy.$unregisterSerializer(g)})}async $deserializeWebviewPanel(a,g,E,f){const h=this._serializers.get(g);if(!h)throw new Error(`No serializer found for '${g}'`);const{serializer:A,extension:L}=h,B=this.webviews.createNewWebview(a,E.webviewOptions,L),ee=this.createNewWebviewPanel(a,g,E.title,f,E.panelOptions,B);await A.deserializeWebviewPanel(ee,E.state)}createNewWebviewPanel(a,g,E,f,h,A){const L=new n(a,this._proxy,g,E,f,h,A);return this._webviewPanels.set(a,L),L}getWebviewPanel(a){return this._webviewPanels.get(a)}}e.ExtHostWebviewPanels=o;function r(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var et=this&&this.__classPrivateFieldSet||function(Q,e,_,P,T){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?T.call(Q,_):T?T.value=_:e.set(Q,_),_},He=this&&this.__classPrivateFieldGet||function(Q,e,_,P){if(_==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!P:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?P:_==="a"?P.call(Q):P?P.value:e.get(Q)};define(ge[252],pe([0,1,3,6,64,5,7]),function(Q,e,_,P,T,I,D){"use strict";var k,y,i,R,C,w,m,s,d,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class v extends P.Disposable{constructor(u,c,t,n,o,r){super();k.set(this,void 0),y.set(this,void 0),i.set(this,void 0),R.set(this,void 0),C.set(this,!1),w.set(this,void 0),m.set(this,void 0),s.set(this,void 0),d.set(this,this._register(new _.Emitter)),this.onDidChangeVisibility=He(this,d,"f").event,S.set(this,this._register(new _.Emitter)),this.onDidDispose=He(this,S,"f").event,et(this,i,t,"f"),et(this,m,n,"f"),et(this,k,u,"f"),et(this,y,c,"f"),et(this,R,o,"f"),et(this,w,r,"f")}dispose(){He(this,C,"f")||(et(this,C,!0,"f"),He(this,S,"f").fire(),He(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),He(this,m,"f")}set title(u){this.assertNotDisposed(),He(this,m,"f")!==u&&(et(this,m,u,"f"),He(this,y,"f").$setWebviewViewTitle(He(this,k,"f"),u))}get description(){return this.assertNotDisposed(),He(this,s,"f")}set description(u){this.assertNotDisposed(),He(this,s,"f")!==u&&(et(this,s,u,"f"),He(this,y,"f").$setWebviewViewDescription(He(this,k,"f"),u))}get visible(){return He(this,w,"f")}get webview(){return He(this,R,"f")}get viewType(){return He(this,i,"f")}_setVisible(u){u===He(this,w,"f")||He(this,C,"f")||(et(this,w,u,"f"),He(this,d,"f").fire())}show(u){this.assertNotDisposed(),He(this,y,"f").$show(He(this,k,"f"),!!u)}assertNotDisposed(){if(He(this,C,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,y=new WeakMap,i=new WeakMap,R=new WeakMap,C=new WeakMap,w=new WeakMap,m=new WeakMap,s=new WeakMap,d=new WeakMap,S=new WeakMap;class b{constructor(u,c){this._extHostWebview=c,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=u.getProxy(I.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(u,c,t,n){if(this._viewProviders.has(c))throw new Error(`View provider for '${c}' already registered`);return this._viewProviders.set(c,{provider:t,extension:u}),this._proxy.$registerWebviewViewProvider((0,T.toExtensionData)(u),c,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new D.Disposable(()=>{this._viewProviders.delete(c),this._proxy.$unregisterWebviewViewProvider(c)})}async $resolveWebviewView(u,c,t,n,o){const r=this._viewProviders.get(c);if(!r)throw new Error(`No view provider found for '${c}'`);const{provider:l,extension:a}=r,g=this._extHostWebview.createNewWebview(u,{},a),E=new v(u,this._proxy,c,t,g,!0);this._webviewViews.set(u,E),await l.resolveWebviewView(E,{state:n},o)}async $onDidChangeWebviewViewVisibility(u,c){this.getWebviewView(u)._setVisible(c)}async $disposeWebviewView(u){const c=this.getWebviewView(u);this._webviewViews.delete(u),c.dispose(),this._extHostWebview.deleteWebview(u)}getWebviewView(u){const c=this._webviewViews.get(u);if(!c)throw new Error("No webview found");return c}}e.ExtHostWebviewViews=b}),define(ge[125],pe([0,1,3,5,2,11,10,4,13]),function(Q,e,_,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let i=class Mn{constructor(C){this._onDidChangeWindowState=new _.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Mn.InitialState,this._proxy=C.getProxy(P.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(w=>this.$onDidChangeWindowFocus(w))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:C}),this._onDidChangeWindowState.fire(this._state))}openUri(C,w){let m;if(typeof C=="string"){m=C;try{C=T.URI.parse(C)}catch(s){return Promise.reject(`Invalid uri - '${C}'`)}}return(0,D.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===I.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,m,w)}async asExternalUri(C,w){if((0,D.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([I.Schemas.http,I.Schemas.https]).has(C.scheme))return Promise.reject(`Invalid scheme '${C.scheme}'`);const m=await this._proxy.$asExternalUri(C,w);return T.URI.from(m)}};i.InitialState={focused:!0},i=je([xe(0,y.IExtHostRpcService)],i),e.ExtHostWindow=i,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(ge[253],pe([0,1,8,48,28,51,6,5,2,13]),function(Q,e,_,P,T,I,D,k,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends D.Disposable{constructor(w,m){super();const s=w.getProxy(k.MainContext.MainThreadDownloadService);m.registerCommand(!1,"_workbench.downloadResource",async d=>{const S=y.URI.file((0,_.join)((0,P.tmpdir)(),(0,T.generateUuid)()));return await s.$download(d,S),S})}};R=je([xe(0,i.IExtHostRpcService),xe(1,I.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(ge[254],pe([0,1,2,8,145,26,37,63,27,13,6,12,110,45]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=e.ExtHostOutputChannelBackedByFile=void 0;class s{constructor(b,p){this.file=p,this.appender=(0,w.createRotatingLogger)(b,p,30*m.ByteSize.MB,1),this.appender.clearFormatters()}append(b){this.appender.critical(b)}flush(){this.appender.flush()}}class d extends k.AbstractExtHostOutputChannel{constructor(b,p,u){super(b,!1,_.URI.file(p.file),u);this._appender=p}append(b){super.append(b),this._appender.append(b),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(b,p){this._appender.flush(),super.show(b,p)}clear(){this._appender.flush(),super.clear()}}e.ExtHostOutputChannelBackedByFile=d;let S=class extends k.ExtHostOutputService{constructor(b,p,u){super(b);this.logService=p,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new R.MutableDisposable,this._logsLocation=u.logsLocation}$setVisibleChannel(b){if(b){const p=this._channels.get(b);p&&(this._visibleChannelDisposable.value=p.onDidAppend(()=>p.update()))}}createOutputChannel(b){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const p=this._doCreateOutChannel(b);return p.then(u=>u._id.then(c=>this._channels.set(c,u))),new k.LazyOutputChannel(b,p)}async _doCreateOutChannel(b){try{const p=(0,P.join)(this._logsLocation.fsPath,`output_logging_${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await I.SymlinkSupport.existsDirectory(p)||await D.promises.mkdir(p,{recursive:!0});const c=`${this._namePool++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=_.URI.file((0,P.join)(p,`${c}.log`)),n=new s(c,t.fsPath);return new d(b,n,this._proxy)}catch(p){return this.logService.error(p),new k.ExtHostPushOutputChannel(b,this._proxy)}}};S=je([xe(0,i.IExtHostRpcService),xe(1,C.ILogService),xe(2,y.IExtHostInitDataService)],S),e.ExtHostOutputService2=S}),define(ge[255],pe([0,1,5,13,6,27,2,38,25,37,26,7,9,50,3,72,12]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class v{constructor(g,E,f){this.remoteAddress=g,this.localAddress=E,this._dispose=f,this._onDispose=new s.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function b(a){const g=a.trim().split(`
`),E=[];return g.forEach(h=>{const A=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(h);A&&A.length>=3&&E.push({pid:parseInt(A[1],10),socket:parseInt(A[2],10)})}),E.reduce((h,A)=>(h[A.socket]=A,h),{})}e.getSockets=b;function p(...a){const g=[].concat(...a.map(c));return[...new Map(g.filter(E=>E.st==="0A").map(E=>{const f=E.local_address.split(":");return{socket:parseInt(E.inode,10),ip:u(f[0]),port:parseInt(f[1],16)}}).map(E=>[E.ip+":"+E.port,E])).values()]}e.loadListeningPorts=p;function u(a){let g="";if(a.length===8)for(let E=a.length-2;E>=0;E-=2)g+=parseInt(a.substr(E,2),16),E!==0&&(g+=".");else for(let E=a.length-4;E>=0;E-=4)g+=parseInt(a.substr(E,4),16).toString(16),E!==0&&(g+=":");return g}e.parseIpAddress=u;function c(a){const g=a.trim().split(`
`),E=g.shift().trim().split(/\s+/).filter(h=>h!=="rx_queue"&&h!=="tm->when");return g.map(h=>h.trim().split(/\s+/).reduce((A,L,B)=>(A[E[B]||B]=L,A),{}))}e.loadConnectionTable=c;function t(a){return!!a.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||a.indexOf("out/vs/server/main.js")!==-1||a.indexOf("_productName=VSCode")!==-1}function n(a){const g=a.trim().split(`
`),E=[];return g.forEach(f=>{const h=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(f);h&&h.length>=4&&E.push({pid:parseInt(h[1],10),ppid:parseInt(h[2]),cmd:h[3]})}),E}e.getRootProcesses=n;async function o(a,g,E){const f=E.reduce((A,L)=>(A[L.pid]=L,A),{}),h=[];return a.forEach(({socket:A,ip:L,port:B})=>{var ee;const j=g[A]?g[A].pid:void 0,x=j?(ee=f[j])===null||ee===void 0?void 0:ee.cmd:void 0;j&&x&&!t(x)&&h.push({host:L,port:B,detail:x,pid:j})}),h}e.findPorts=o;function r(a,g,E){const f=new Map,h=n(g);for(const A of a){const L=E.get(A.port);if(L){f.set(A.port,L);continue}const B=h.find(ee=>ee.cmd.includes(`${A.port}`));if(B){let ee=B,j;do j=h.find(x=>x.ppid===ee.pid),j&&(ee=j);while(j);f.set(A.port,{host:A.ip,port:A.port,pid:ee.pid,detail:ee.cmd,ppid:ee.ppid})}else f.set(A.port,{host:A.ip,port:A.port,ppid:Number.MAX_VALUE})}return f}e.tryFindRootPorts=r;let l=class extends T.Disposable{constructor(g,E,f){super();this.logService=f,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new s.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=g.getProxy(_.MainContext.MainThreadTunnelService),w.isLinux&&E.remote.isRemote&&E.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(g,E){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${g.identifier} called openTunnel API for ${E.remoteAddress.port}.`);const f=await this._proxy.$openTunnel(E,g.displayName);if(f){const h=new v(f.remoteAddress,f.localAddress,()=>this._proxy.$closeTunnel(f.remoteAddress));return this._register(h),h}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(g){return Math.max(g*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(g,E){const f=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(f,{selector:g,provider:E}),this._proxy.$registerPortsAttributesProvider(g,f),new C.Disposable(()=>{this._portAttributesProviders.delete(f),this._proxy.$unregisterPortsAttributesProvider(f)})}async $providePortAttributes(g,E,f,h,A){const L=[];for(const ee of g){const j=this._portAttributesProviders.get(ee);if(!j)return[];L.push(...await Promise.all(E.map(async x=>j.provider.providePortAttributes(x,f,h,A))))}const B=L.filter(ee=>!!ee);return B.length>0?B.map(ee=>({autoForwardAction:ee.autoForwardAction,port:ee.port})):[]}async $registerCandidateFinder(g){if(!(g&&this._candidateFindingEnabled)){this._candidateFindingEnabled=g;let E=new d.MovingAverage,f;for(;this._candidateFindingEnabled;){const h=new Date().getTime(),A=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${A.map(B=>B.port).join(", ")}`);const L=new Date().getTime()-h;E.update(L),(!f||JSON.stringify(f)!==JSON.stringify(A))&&(f=A,await this._proxy.$onFoundNewCandidates(f)),await new Promise(B=>setTimeout(()=>B(),this.calculateDelay(E.value)))}}}async setTunnelExtensionFunctions(g){var E;return g?(g.candidatePortSource!==void 0&&await this._proxy.$setCandidatePortSource(g.candidatePortSource),g.showCandidatePort&&(this._showCandidatePort=g.showCandidatePort,await this._proxy.$setCandidateFilter()),g.tunnelFactory&&(this._forwardPortProvider=g.tunnelFactory,await this._proxy.$setTunnelProvider((E=g.tunnelFeatures)!==null&&E!==void 0?E:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,T.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(g,E){if(this._extensionTunnels.has(g.host)){const f=this._extensionTunnels.get(g.host);f.has(g.port)&&(E&&f.get(g.port).disposeListener.dispose(),await f.get(g.port).tunnel.dispose(),f.delete(g.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(g,E){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const f=this._forwardPortProvider(g,E);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),f!==void 0){const h=await f;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(g.remoteAddress.host)||this._extensionTunnels.set(g.remoteAddress.host,new Map);const A=this._register(h.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(h.remoteAddress))));return this._extensionTunnels.get(g.remoteAddress.host).set(g.remoteAddress.port,{tunnel:h,disposeListener:A}),m.TunnelDto.fromApiTunnel(h)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(f){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(g){const E=await Promise.all(g.map(h=>{var A;return this._showCandidatePort(h.host,h.port,(A=h.detail)!==null&&A!==void 0?A:"")})),f=g.filter((h,A)=>E[A]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${g.map(h=>h.port).join(", ")} to ${f.map(h=>h.port).join(", ")}`),f}async findCandidatePorts(){let g="",E="";try{g=await i.promises.readFile("/proc/net/tcp","utf8"),E=await i.promises.readFile("/proc/net/tcp6","utf8")}catch(F){}const f=p(g,E),h=await new Promise(F=>{(0,k.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(U,M,N)=>{F(M)})}),A=b(h),L=await R.readdir("/proc"),B=[];for(let F of L)try{const U=Number(F),M=y.joinPath(D.URI.file("/proc"),F);if((await i.promises.stat(M.fsPath)).isDirectory()&&!isNaN(U)){const O=await i.promises.readlink(y.joinPath(M,"cwd").fsPath),V=await i.promises.readFile(y.joinPath(M,"cmdline").fsPath,"utf8");B.push({pid:U,cwd:O,cmd:V})}}catch(U){}const ee=[],j=f.filter(F=>{const U=A[F.socket];return U||ee.push(F),U}),x=o(j,A,B);let $;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${ee.length}`),ee.length>0){const F=await new Promise(U=>{(0,k.exec)("ps -F -A -l | grep root",(M,N,O)=>{U(N)})});this._foundRootPorts=r(ee,F,this._foundRootPorts),$=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${$.join(", ")}`)}return x.then(F=>$?F.concat($):F)}};l=je([xe(0,P.IExtHostRpcService),xe(1,I.IExtHostInitDataService),xe(2,S.ILogService)],l),e.ExtHostTunnelService=l}),define(ge[256],pe([0,1,19,21,18,3,6,98,226,123,22]),function(Q,e,_,P,T,I,D,k,y,i,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function w(r,l){try{return JSON.stringify(r,l)}catch(a){return"null"}}function m(r,l){return JSON.stringify(r,l)}function s(r){return r?(l,a)=>a&&a.$mid===1?r.transformOutgoing(a):a:null}var d;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const v=()=>{},b=Symbol.for("rpcProtocol"),p=Symbol.for("rpcProxy");class u extends D.Disposable{constructor(l,a=null,g=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new I.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=l,this._logger=a,this._uriTransformer=g,this._uriReplacer=s(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let E=0,f=i.ProxyIdentifier.count;E<f;E++)this._locals[E]=null,this._proxies[E]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new _.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(E=>this._receiveOneMessage(E))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(l=>{this._pendingRPCReplies[l].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(l){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(l){this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(l){this._responsiveState!==l&&(this._responsiveState=l,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(l){return this._uriTransformer?(0,k.transformIncomingURIs)(l,this._uriTransformer):l}getProxy(l){const{nid:a,sid:g}=l;return this._proxies[a]||(this._proxies[a]=this._createProxy(a,g)),this._proxies[a]}_createProxy(l,a){let g={get:(E,f)=>(typeof f=="string"&&!E[f]&&f.charCodeAt(0)===36&&(E[f]=(...h)=>this._remoteCall(l,f,h)),f===p?a:E[f])};return new Proxy(Object.create(null),g)}set(l,a){return this._locals[l.nid]=a,a}assertRegistered(l){for(let a=0,g=l.length;a<g;a++){const E=l[a];if(!this._locals[E.nid])throw new Error(`Missing actor ${E.sid} (isMain: ${E.isMain})`)}}_receiveOneMessage(l){if(!this._isDisposed){const a=l.byteLength,g=c.read(l,0),E=g.readUInt8(),f=g.readUInt32();switch(E){case 1:case 2:{let{rpcId:h,method:A,args:L}=t.deserializeRequestJSONArgs(g);this._uriTransformer&&(L=(0,k.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(a,f,h,A,L,E===2);break}case 3:case 4:{let{rpcId:h,method:A,args:L}=t.deserializeRequestMixedArgs(g);this._uriTransformer&&(L=(0,k.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(a,f,h,A,L,E===4);break}case 5:{this._logger&&this._logger.logIncoming(a,f,0,"ack"),this._onDidReceiveAcknowledge(f);break}case 6:{this._receiveCancel(a,f);break}case 7:{this._receiveReply(a,f,void 0);break}case 9:{let h=t.deserializeReplyOKJSON(g);this._uriTransformer&&(h=(0,k.transformIncomingURIs)(h,this._uriTransformer)),this._receiveReply(a,f,h);break}case 8:{let h=t.deserializeReplyOKVSBuffer(g);this._receiveReply(a,f,h);break}case 10:{let h=t.deserializeReplyErrError(g);this._uriTransformer&&(h=(0,k.transformIncomingURIs)(h,this._uriTransformer)),this._receiveReplyErr(a,f,h);break}case 11:{this._receiveReplyErr(a,f,void 0);break}default:console.error("received unexpected message"),console.error(l)}}}_receiveRequest(l,a,g,E,f,h){this._logger&&this._logger.logIncoming(l,a,1,`receiveRequest ${(0,i.getStringIdentifierForProxy)(g)}.${E}(`,f);const A=String(a);let L,B;if(h){const j=new P.CancellationTokenSource;f.push(j.token),L=this._invokeHandler(g,E,f),B=()=>j.cancel()}else L=this._invokeHandler(g,E,f),B=v;this._cancelInvokedHandlers[A]=B;const ee=t.serializeAcknowledged(a);this._logger&&this._logger.logOutgoing(ee.byteLength,a,1,"ack"),this._protocol.send(ee),L.then(j=>{delete this._cancelInvokedHandlers[A];const x=t.serializeReplyOK(a,j,this._uriReplacer);this._logger&&this._logger.logOutgoing(x.byteLength,a,1,"reply:",j),this._protocol.send(x)},j=>{delete this._cancelInvokedHandlers[A];const x=t.serializeReplyErr(a,j);this._logger&&this._logger.logOutgoing(x.byteLength,a,1,"replyErr:",j),this._protocol.send(x)})}_receiveCancel(l,a){this._logger&&this._logger.logIncoming(l,a,1,"receiveCancel");const g=String(a);this._cancelInvokedHandlers[g]&&this._cancelInvokedHandlers[g]()}_receiveReply(l,a,g){this._logger&&this._logger.logIncoming(l,a,0,"receiveReply:",g);const E=String(a);if(!!this._pendingRPCReplies.hasOwnProperty(E)){const f=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E],f.resolveOk(g)}}_receiveReplyErr(l,a,g){this._logger&&this._logger.logIncoming(l,a,0,"receiveReplyErr:",g);const E=String(a);if(!!this._pendingRPCReplies.hasOwnProperty(E)){const f=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E];let h;g&&(g.$isError?(h=new Error,h.name=g.name,h.message=g.message,h.stack=g.stack):h=g),f.resolveErr(h)}}_invokeHandler(l,a,g){try{return Promise.resolve(this._doInvokeHandler(l,a,g))}catch(E){return Promise.reject(E)}}_doInvokeHandler(l,a,g){const E=this._locals[l];if(!E)throw new Error("Unknown actor "+(0,i.getStringIdentifierForProxy)(l));let f=E[a];if(typeof f!="function")throw new Error("Unknown method "+a+" on actor "+(0,i.getStringIdentifierForProxy)(l));return f.apply(E,g)}_remoteCall(l,a,g){if(this._isDisposed)return Promise.reject(T.canceled());let E=null;if(g.length>0&&P.CancellationToken.isCancellationToken(g[g.length-1])&&(E=g.pop()),E&&E.isCancellationRequested)return Promise.reject(T.canceled());const f=t.serializeRequestArguments(g,this._uriReplacer),h=++this._lastMessageId,A=String(h),L=new y.LazyPromise;E&&E.onCancellationRequested(()=>{const ee=t.serializeCancel(h);this._logger&&this._logger.logOutgoing(ee.byteLength,h,0,"cancel"),this._protocol.send(t.serializeCancel(h))}),this._pendingRPCReplies[A]=L,this._onWillSendRequest(h);const B=t.serializeRequest(h,l,a,f,!!E);return this._logger&&this._logger.logOutgoing(B.byteLength,h,0,`request: ${(0,i.getStringIdentifierForProxy)(l)}.${a}(`,g),this._protocol.send(B),L}}e.RPCProtocol=u,C=b,u.UNRESPONSIVE_TIME=3*1e3;class c{constructor(l,a){this._buff=l,this._offset=a}static alloc(l,a,g){let E=new c(R.VSBuffer.alloc(g+1+4),0);return E.writeUInt8(l),E.writeUInt32(a),E}static read(l,a){return new c(l,a)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(l){this._buff.writeUInt8(l,this._offset),this._offset+=1}readUInt8(){const l=this._buff.readUInt8(this._offset);return this._offset+=1,l}writeUInt32(l){this._buff.writeUInt32BE(l,this._offset),this._offset+=4}readUInt32(){const l=this._buff.readUInt32BE(this._offset);return this._offset+=4,l}static sizeShortString(l){return 1+l.byteLength}writeShortString(l){this._buff.writeUInt8(l.byteLength,this._offset),this._offset+=1,this._buff.set(l,this._offset),this._offset+=l.byteLength}readShortString(){const l=this._buff.readUInt8(this._offset);this._offset+=1;const g=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,g}static sizeLongString(l){return 4+l.byteLength}writeLongString(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readLongString(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const g=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,g}writeBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}static sizeVSBuffer(l){return 4+l.byteLength}writeVSBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readVSBuffer(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const a=this._buff.slice(this._offset,this._offset+l);return this._offset+=l,a}static sizeMixedArray(l,a){let g=0;g+=1;for(let E=0,f=l.length;E<f;E++){const h=l[E],A=a[E];switch(g+=1,A){case 1:g+=this.sizeLongString(h);break;case 2:g+=this.sizeVSBuffer(h);break;case 3:break}}return g}writeMixedArray(l,a){this._buff.writeUInt8(l.length,this._offset),this._offset+=1;for(let g=0,E=l.length;g<E;g++){const f=l[g];switch(a[g]){case 1:this.writeUInt8(1),this.writeLongString(f);break;case 2:this.writeUInt8(2),this.writeVSBuffer(f);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const l=this._buff.readUInt8(this._offset);this._offset+=1;let a=new Array(l);for(let g=0;g<l;g++)switch(this.readUInt8()){case 1:a[g]=this.readLongString();break;case 2:a[g]=this.readVSBuffer();break;case 3:a[g]=void 0;break}return a}}class t{static _arrayContainsBufferOrUndefined(l){for(let a=0,g=l.length;a<g;a++)if(l[a]instanceof R.VSBuffer||typeof l[a]=="undefined")return!0;return!1}static serializeRequestArguments(l,a){if(this._arrayContainsBufferOrUndefined(l)){let g=[],E=[];for(let f=0,h=l.length;f<h;f++){const A=l[f];A instanceof R.VSBuffer?(g[f]=A,E[f]=2):typeof A=="undefined"?(g[f]=R.VSBuffer.alloc(0),E[f]=3):(g[f]=R.VSBuffer.fromString(m(A,a)),E[f]=1)}return{type:"mixed",args:g,argsType:E}}return{type:"simple",args:m(l,a)}}static serializeRequest(l,a,g,E,f){return E.type==="mixed"?this._requestMixedArgs(l,a,g,E.args,E.argsType,f):this._requestJSONArgs(l,a,g,E.args,f)}static _requestJSONArgs(l,a,g,E,f){const h=R.VSBuffer.fromString(g),A=R.VSBuffer.fromString(E);let L=0;L+=c.sizeUInt8(),L+=c.sizeShortString(h),L+=c.sizeLongString(A);let B=c.alloc(f?2:1,l,L);return B.writeUInt8(a),B.writeShortString(h),B.writeLongString(A),B.buffer}static deserializeRequestJSONArgs(l){const a=l.readUInt8(),g=l.readShortString(),E=l.readLongString();return{rpcId:a,method:g,args:JSON.parse(E)}}static _requestMixedArgs(l,a,g,E,f,h){const A=R.VSBuffer.fromString(g);let L=0;L+=c.sizeUInt8(),L+=c.sizeShortString(A),L+=c.sizeMixedArray(E,f);let B=c.alloc(h?4:3,l,L);return B.writeUInt8(a),B.writeShortString(A),B.writeMixedArray(E,f),B.buffer}static deserializeRequestMixedArgs(l){const a=l.readUInt8(),g=l.readShortString(),E=l.readMixedArray(),f=new Array(E.length);for(let h=0,A=E.length;h<A;h++){const L=E[h];typeof L=="string"?f[h]=JSON.parse(L):f[h]=L}return{rpcId:a,method:g,args:f}}static serializeAcknowledged(l){return c.alloc(5,l,0).buffer}static serializeCancel(l){return c.alloc(6,l,0).buffer}static serializeReplyOK(l,a,g){return typeof a=="undefined"?this._serializeReplyOKEmpty(l):a instanceof R.VSBuffer?this._serializeReplyOKVSBuffer(l,a):this._serializeReplyOKJSON(l,w(a,g))}static _serializeReplyOKEmpty(l){return c.alloc(7,l,0).buffer}static _serializeReplyOKVSBuffer(l,a){let g=0;g+=c.sizeVSBuffer(a);let E=c.alloc(8,l,g);return E.writeVSBuffer(a),E.buffer}static deserializeReplyOKVSBuffer(l){return l.readVSBuffer()}static _serializeReplyOKJSON(l,a){const g=R.VSBuffer.fromString(a);let E=0;E+=c.sizeLongString(g);let f=c.alloc(9,l,E);return f.writeLongString(g),f.buffer}static deserializeReplyOKJSON(l){const a=l.readLongString();return JSON.parse(a)}static serializeReplyErr(l,a){return a?this._serializeReplyErrEror(l,a):this._serializeReplyErrEmpty(l)}static _serializeReplyErrEror(l,a){const g=R.VSBuffer.fromString(w(T.transformErrorForSerialization(a),null));let E=0;E+=c.sizeLongString(g);let f=c.alloc(10,l,E);return f.writeLongString(g),f.buffer}static deserializeReplyErrError(l){const a=l.readLongString();return JSON.parse(a)}static _serializeReplyErrEmpty(l){return c.alloc(11,l,0).buffer}}var n;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var o;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(o||(o={}))}),define(ge[257],pe([0,1,4]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,_.createDecorator)("remoteAgentService")}),define(ge[258],pe([0,1,11,8,9,2,4,257]),function(Q,e,_,P,T,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,D.createDecorator)("pathService");let y=class{constructor(R,C){this.localUserHome=R,this.remoteAgentService=C,this.resolveOS=(async()=>{const w=await this.remoteAgentService.getEnvironment();return(w==null?void 0:w.os)||T.OS})(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(w==null?void 0:w.userHome)||R})()}async userHome(R){return(R==null?void 0:R.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(R=>R===1?P.win32:P.posix)}async fileURI(R){let C="";if(await this.resolveOS===1&&(R=R.replace(/\\/g,"/")),R[0]==="/"&&R[1]==="/"){const m=R.indexOf("/",2);m===-1?(C=R.substring(2),R="/"):(C=R.substring(2,m),R=R.substring(m)||"/")}return I.URI.from({scheme:_.Schemas.file,authority:C,path:R,query:"",fragment:""})}};y=je([xe(1,k.IRemoteAgentService)],y),e.AbstractPathService=y}),define(ge[31],pe([0,1,14,33,23,30,10,4,8,18]),function(Q,e,_,P,T,I,D,k,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const R="\u27EA ",C=" characters skipped \u27EB",w=(R.length+C.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var m;(function(F){F[F.file=0]="file",F[F.text=1]="text"})(m=e.SearchProviderType||(e.SearchProviderType={}));var s;(function(F){F[F.File=1]="File",F[F.Text=2]="Text"})(s=e.QueryType||(e.QueryType={}));function d(F){return!!F.preview}e.resultIsMatch=d;function S(F){return!!F.resource}e.isFileMatch=S;function v(F){return!!F.message}e.isProgressMessage=v;var b;(function(F){F[F.Normal=0]="Normal",F[F.NewSearchStarted=1]="NewSearchStarted"})(b=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(U){this.resource=U,this.results=[]}}e.FileMatch=p;class u{constructor(U,M,N){this.ranges=M;const O=Array.isArray(M)?M:[M];if(N&&N.matchLines===1&&c(O)){U=(0,D.getNLines)(U,N.matchLines);let V="",q=0,J=0;const me=Math.floor(N.charsPerLine/5),we=[];for(const Ae of O){const Pe=Math.max(Ae.startColumn-me,0),Fe=Ae.startColumn+N.charsPerLine;if(Pe>J+me+w){const z=R+(Pe-J)+C;V+=z+U.slice(Pe,Fe),q+=Pe-(J+z.length)}else V+=U.slice(J,Fe);we.push(new n(0,Ae.startColumn-q,Ae.endColumn-q)),J=Fe}this.preview={text:V,matches:Array.isArray(this.ranges)?we:we[0]}}else{const V=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:U,matches:(0,_.mapArrayOrNot)(M,q=>new t(q.startLineNumber-V,q.startColumn,q.endLineNumber-V,q.endColumn))}}}}e.TextSearchMatch=u;function c(F){const U=F[0].startLineNumber;for(const M of F)if(M.startLineNumber!==U||M.endLineNumber!==U)return!1;return!0}class t{constructor(U,M,N,O){this.startLineNumber=U,this.startColumn=M,this.endLineNumber=N,this.endColumn=O}}e.SearchRange=t;class n extends t{constructor(U,M,N){super(U,M,U,N)}}e.OneLineRange=n;var o;(function(F){F.Default="default",F.FileNames="fileNames",F.Type="type",F.Modified="modified",F.CountDescending="countDescending",F.CountAscending="countAscending"})(o=e.SearchSortOrder||(e.SearchSortOrder={}));function r(F,U=!0){const M=F&&F.files&&F.files.exclude,N=U&&F&&F.search&&F.search.exclude;if(!(!M&&!N)){if(!M||!N)return M||N;let O=Object.create(null);return O=T.mixin(O,T.deepClone(M)),O=T.mixin(O,T.deepClone(N),!0),O}}e.getExcludes=r;function l(F,U){return F.excludePattern&&P.match(F.excludePattern,U)?!1:F.includePattern||F.usingSearchPaths?F.includePattern&&P.match(F.includePattern,U)?!0:F.usingSearchPaths?!!F.folderQueries&&F.folderQueries.some(M=>{const N=M.folder.fsPath;if(I.isEqualOrParent(U,N)){const O=y.relative(N,U);return!M.includePattern||!!P.match(M.includePattern,O)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var a;(function(F){F[F.unknownEncoding=1]="unknownEncoding",F[F.regexParseError=2]="regexParseError",F[F.globParseError=3]="globParseError",F[F.invalidLiteral=4]="invalidLiteral",F[F.rgProcessError=5]="rgProcessError",F[F.other=6]="other",F[F.canceled=7]="canceled"})(a=e.SearchErrorCode||(e.SearchErrorCode={}));class g extends Error{constructor(U,M){super(U);this.code=M}}e.SearchError=g;function E(F){const U=F.message;if((0,i.isPromiseCanceledError)(F))return new g(U,a.canceled);try{const M=JSON.parse(U);return new g(M.message,M.code)}catch(M){return new g(U,a.other)}}e.deserializeSearchError=E;function f(F){const U={message:F.message,code:F.code};return new Error(JSON.stringify(U))}e.serializeSearchError=f;function h(F){return F.type==="error"?!0:F.type==="success"}e.isSerializedSearchComplete=h;function A(F){return F.type==="success"}e.isSerializedSearchSuccess=A;function L(F){return!!F.path}e.isSerializedFileMatch=L;function B(F,U){const M=F.searchPath?F.searchPath:F.relativePath;return(0,D.fuzzyContains)(M,U)}e.isFilePatternMatch=B;class ee{constructor(U){this.path=U,this.results=[]}addMatch(U){this.results.push(U)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ee;function j(F,U){const M=Object.assign(Object.assign({},F||{}),U||{});return Object.keys(M).filter(N=>{const O=M[N];return typeof O=="boolean"&&O})}e.resolvePatternsForProvider=j;class x{constructor(U,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},U.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=P.parse(this._excludeExpression);let N=U.includePattern;M.includePattern&&(N?N=Object.assign(Object.assign({},N),M.includePattern):N=M.includePattern),N&&(this._parsedIncludeExpression=P.parse(N))}includedInQuerySync(U,M,N){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(U,M,N)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(U,M,N))}includedInQuery(U,M,N){return Promise.resolve(this._parsedExcludeExpression(U,M,N)).then(V=>!!V).then(V=>V?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(U,M,N)).then(q=>!!q):Promise.resolve(!0)).then(V=>V)}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=x;function $(F){for(const U in F)if(typeof F[U]!="boolean")return!0;return!1}}),define(ge[32],pe([0,1,14,19,21,3,24,11,72,25,10,15,2,166,4,12,185,59,60,27,13,7,31,5]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d,S,v,b,p,u,c,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(A,L,B){return new i.ExtUri(ee=>g(ee,B)).isEqual(A,L)}function r(A,L,B){return o(A.uri,L.uri,B)?0:(0,R.compare)(A.uri.toString(),L.uri.toString())}function l(A,L,B){return A.index!==L.index?A.index<L.index?-1:1:o(A.uri,L.uri,B)?(0,R.compare)(A.name,L.name):(0,R.compare)(A.uri.toString(),L.uri.toString())}function a(A,L,B,ee){const j=A.slice(0).sort(($,F)=>B($,F,ee)),x=L.slice(0).sort(($,F)=>B($,F,ee));return(0,_.delta)(j,x,($,F)=>B($,F,ee))}function g(A,L){const B=L.getCapabilities(A.scheme);return!(B&&B&1024)}class E extends v.Workspace{constructor(L,B,ee,j,x,$){super(L,ee.map(F=>new v.WorkspaceFolder(F)),j,$);this._name=B,this._isUntitled=x,this._workspaceFolders=[],this._structure=D.TernarySearchTree.forUris($),ee.forEach(F=>{this._workspaceFolders.push(F),this._structure.set(F.uri,F)})}static toExtHostWorkspace(L,B,ee,j){if(!L)return{workspace:null,added:[],removed:[]};const{id:x,name:$,folders:F,configuration:U,isUntitled:M}=L,N=[],O=B;B?F.forEach((me,we)=>{const Ae=w.URI.revive(me.uri),Pe=E._findFolder(ee||B,Ae,j);Pe?(Pe.name=me.name,Pe.index=me.index,N.push(Pe)):N.push({uri:Ae,name:me.name,index:we})}):N.push(...F.map(({uri:me,name:we,index:Ae})=>({uri:w.URI.revive(me),name:we,index:Ae}))),N.sort((me,we)=>me.index<we.index?-1:1);const V=new E(x,$,N,U?w.URI.revive(U):null,!!M,me=>g(me,j)),{added:q,removed:J}=a(O?O.workspaceFolders:[],V.workspaceFolders,r,j);return{workspace:V,added:q,removed:J}}static _findFolder(L,B,ee){for(let j=0;j<L.folders.length;j++){const x=L.workspaceFolders[j];if(o(x.uri,B,ee))return x}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,B){return B&&this._structure.get(L)&&(L=(0,i.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let f=class{constructor(L,B,ee,j){this._onDidChangeWorkspace=new I.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidReceieveWorkspaceTrust=new I.Emitter,this.onDidReceiveWorkspaceTrust=this._onDidReceieveWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=j,this._extHostFileSystemInfo=ee,this._requestIdProvider=new y.Counter,this._barrier=new P.Barrier,this._proxy=L.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(n.MainContext.MainThreadMessageService);const x=B.workspace;this._confirmedWorkspace=x?new E(x.id,x.name,[],x.configuration?w.URI.revive(x.configuration):null,!!x.isUntitled,$=>g($,ee)):void 0}$initializeWorkspace(L,B){this._trusted=B,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?w.URI.from({scheme:k.Schemas.untitled,path:(0,i.basename)((0,i.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,B,ee,...j){const x=[];if(Array.isArray(j)&&j.forEach(N=>{w.URI.isUri(N.uri)&&!x.some(O=>o(O.uri,N.uri,this._extHostFileSystemInfo))&&x.push({uri:N.uri,name:N.name||(0,i.basenameOrAuthority)(N.uri)})}),this._unconfirmedWorkspace||[B,ee].some(N=>typeof N!="number"||N<0)||ee===0&&x.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+ee>$.length)return!1;const F=$.slice(0);F.splice(B,ee,...x.map(N=>({uri:N.uri,name:N.name||(0,i.basenameOrAuthority)(N.uri),index:void 0})));for(let N=0;N<F.length;N++){const O=F[N];if(F.some((V,q)=>q!==N&&o(O.uri,V.uri,this._extHostFileSystemInfo)))return!1}F.forEach((N,O)=>N.index=O);const{added:U,removed:M}=a($,F,l,this._extHostFileSystemInfo);if(U.length===0&&M.length===0)return!1;if(this._proxy){const N=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(N,B,ee,x).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(S.Severity.Error,(0,m.localize)(0,null,N,O.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(F),!0}getWorkspaceFolder(L,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,B)}async getWorkspaceFolder2(L,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,B)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!!this._actualWorkspace){const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}}getRelativePath(L,B){let ee,j="";if(typeof L=="string"?(ee=w.URI.file(L),j=L):typeof L!="undefined"&&(ee=L,j=L.fsPath),!ee)return j;const x=this.getWorkspaceFolder(ee,!0);if(!x)return j;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let $=(0,i.relativePath)(x.uri,ee);return B&&x.name&&($=`${x.name}/${$}`),$}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=E.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:B,added:ee,removed:j}=E.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ee,removed:j}))}findFiles(L,B,ee,j,x=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let $;if(B===null?$=!1:B&&(typeof B=="string"?$=B:$=B.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:F,folder:U}=h(L);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(F),(0,C.withUndefinedAsNull)(U),(0,C.withUndefinedAsNull)($),(0,C.withUndefinedAsNull)(ee),x).then(M=>Array.isArray(M)?M.map(N=>w.URI.revive(N)):[])}async findTextInFiles(L,B,ee,j,x=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),F=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:U,folder:M}=h(B.include),N=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,O={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:F,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:U,excludePattern:N},V=!1;if(this._activeSearchCallbacks[$]=q=>{if(!V){const J=w.URI.revive(q.resource);q.results.forEach(me=>{(0,t.resultIsMatch)(me)?ee({uri:J,preview:{text:me.preview.text,matches:(0,_.mapArrayOrNot)(me.preview.matches,we=>new c.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,_.mapArrayOrNot)(me.ranges,we=>new c.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):ee({uri:J,text:me.text,lineNumber:me.lineNumber})})}},x.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(L,(0,C.withUndefinedAsNull)(M),O,$,x);return delete this._activeSearchCallbacks[$],q||{}}catch(q){throw delete this._activeSearchCallbacks[$],q}}$handleTextSearchResult(L,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidReceiveWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidReceieveWorkspaceTrust.fire())}};f=je([xe(0,u.IExtHostRpcService),xe(1,p.IExtHostInitDataService),xe(2,b.IExtHostFileSystemInfo),xe(3,d.ILogService)],f),e.ExtHostWorkspace=f,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function h(A){let L,B;return A&&(typeof A=="string"?L=A:(L=A.pattern,B=A.baseFolder||w.URI.file(A.base))),{includePattern:L,folder:B}}}),define(ge[35],pe([0,1,23,3,32,5,7,187,82,15,19,4,13,12,2]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(n,o){if(o){const r=o.split(".");let l=n;for(let a=0;l&&a<r.length;a++)l=l[r[a]];return l}}function S(n){return n instanceof s.URI}function v(n){return n&&n.uri instanceof s.URI&&n.languageId&&typeof n.languageId=="string"}function b(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function p(n){return n&&n.uri instanceof s.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function u(n){if(S(n))return{resource:n};if(v(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(b(n))return{overrideIdentifier:n.languageId};if(p(n))return{resource:n.uri};if(n===null)return{resource:null}}let c=class{constructor(o,r,l){this._proxy=o.getProxy(I.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=l,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new t(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,r){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(o,r))}};c=je([xe(0,w.IExtHostRpcService),xe(1,T.IExtHostWorkspace),xe(2,m.ILogService)],c),e.ExtHostConfiguration=c;class t{constructor(o,r,l,a){this._onDidChangeConfiguration=new P.Emitter,this._proxy=o,this._logService=a,this._extHostWorkspace=r,this._configuration=k.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,r){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,l))}getConfiguration(o,r,l){const a=u(r)||{},g=this._toReadonlyValue(o?d(this._configuration.getValue(void 0,a,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,a,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,a,l==null?void 0:l.identifier);function E(h){if(h==null)return null;if(typeof h=="boolean")return h?1:4;switch(h){case D.ConfigurationTarget.Global:return 1;case D.ConfigurationTarget.Workspace:return 4;case D.ConfigurationTarget.WorkspaceFolder:return 5}}const f={has(h){return typeof d(g,h)!="undefined"},get:(h,A)=>{this._validateConfigurationAccess(o?`${o}.${h}`:h,a,l==null?void 0:l.identifier);let L=d(g,h);if(typeof L=="undefined")L=A;else{let B;const ee=(j,x)=>{let $;const F=()=>{B=B||(0,_.deepClone)(g),$=$||d(B,x)};return(0,i.isObject)(j)?new Proxy(j,{get:(U,M)=>{if(typeof M=="string"&&M.toLowerCase()==="tojson")return F(),()=>$;if(B)return $=$||d(B,x),$[M];const N=U[M];return typeof M=="string"?ee(N,`${x}.${M}`):N},set:(U,M,N)=>(F(),$&&($[M]=N),!0),deleteProperty:(U,M)=>(F(),$&&delete $[M],!0),defineProperty:(U,M,N)=>(F(),$&&Object.defineProperty($,M,N),!0)}):j};L=ee(L,h)}return L},update:(h,A,L,B)=>{h=o?`${o}.${h}`:h;const ee=E(L);return A!==void 0?this._proxy.$updateConfigurationOption(ee,h,A,a,B):this._proxy.$removeConfigurationOption(ee,h,a,B)},inspect:h=>{var A,L,B,ee,j,x,$,F;h=o?`${o}.${h}`:h;const U=(0,_.deepClone)(this._configuration.inspect(h,a,this._extHostWorkspace.workspace));if(U)return{key:h,defaultValue:(A=U.default)===null||A===void 0?void 0:A.value,globalValue:(L=U.user)===null||L===void 0?void 0:L.value,workspaceValue:(B=U.workspace)===null||B===void 0?void 0:B.value,workspaceFolderValue:(ee=U.workspaceFolder)===null||ee===void 0?void 0:ee.value,defaultLanguageValue:(j=U.default)===null||j===void 0?void 0:j.override,globalLanguageValue:(x=U.user)===null||x===void 0?void 0:x.override,workspaceLanguageValue:($=U.workspace)===null||$===void 0?void 0:$.override,workspaceFolderLanguageValue:(F=U.workspaceFolder)===null||F===void 0?void 0:F.override,languageIds:U.overrideIdentifiers}}};return typeof g=="object"&&(0,_.mixin)(f,g,!1),Object.freeze(f)}_toReadonlyValue(o){const r=l=>(0,i.isObject)(l)?new Proxy(l,{get:(a,g)=>r(a[g]),set:(a,g,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(g)}' of object`)},deleteProperty:(a,g)=>{throw new Error(`TypeError: Cannot delete read only property '${String(g)}' of object`)},defineProperty:(a,g)=>{throw new Error(`TypeError: Cannot define property '${String(g)}' for a readonly object`)},setPrototypeOf:a=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return r(o)}_validateConfigurationAccess(o,r,l){const a=y.OVERRIDE_PROPERTY_PATTERN.test(o)?4:this._configurationScopes.get(o),g=l?`[${l.value}] `:"";if(a===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${g}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(a===3){(r==null?void 0:r.resource)&&this._logService.warn(`${g}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,r){const l=new k.ConfigurationChangeEvent(o,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(a,g)=>l.affectsConfiguration(a,u(g))})}_toMap(o){return o.reduce((r,l)=>(r.set(l[0],l[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var et=this&&this.__classPrivateFieldSet||function(Q,e,_,P,T){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?T.call(Q,_):T?T.value=_:e.set(Q,_),_},He=this&&this.__classPrivateFieldGet||function(Q,e,_,P){if(_==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!P:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?P:_==="a"?P.call(Q):P?P.value:e.get(Q)};define(ge[65],pe([0,1,2,19,3,5,7,32,39,35,21,34,13,27,4,11,9,12,62,208,18]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d,S,v,b,p,u){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(j){function x(F){if(F!=null)return F}j.from=x;function $(F){if(F!=null)return F}j.to=$})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(j){function x(F){if(F!=null)return F}j.from=x;function $(F){if(F!=null)return F}j.to=$})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(j){function x(F){if(F!=null)return F}j.from=x;function $(F){if(F!=null)return F}j.to=$})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(j){function x(U){if(U){const M=U;return M&&!!M.process}else return!1}j.is=x;function $(U){if(U!=null){const M={process:U.process,args:U.args};return U.options&&(M.options=o.from(U.options)),M}}j.from=$;function F(U){if(U!=null)return new D.ProcessExecution(U.process,U.args,U.options)}j.to=F})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function(j){function x(F){if(F!=null)return F}j.from=x;function $(F){if(F!=null)return F}j.to=$})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var a;(function(j){function x(U){if(U){const M=U;return M&&(!!M.commandLine||!!M.command)}else return!1}j.is=x;function $(U){if(U!=null){const M={};return U.commandLine!==void 0?M.commandLine=U.commandLine:(M.command=U.command,M.args=U.args),U.options&&(M.options=l.from(U.options)),M}}j.from=$;function F(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new D.ShellExecution(U.commandLine,U.options):new D.ShellExecution(U.command,U.args?U.args:[],U.options)}j.to=F})(a=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var g;(function(j){function x(U){if(U){let M=U;return M&&M.customExecution==="customExecution"}else return!1}j.is=x;function $(U){return{customExecution:"customExecution"}}j.from=$;function F(U,M){return M.get(U)}j.to=F})(g=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var E;(function(j){function x($,F){let U;return $.scope!==void 0&&typeof $.scope!="number"?U=$.scope.uri:$.scope!==void 0&&typeof $.scope=="number"&&($.scope===D.TaskScope.Workspace&&F&&F.workspaceFile?U=F.workspaceFile:U=p.USER_TASKS_GROUP_KEY),{id:$._id,workspaceFolder:U}}j.from=x})(E=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(j){function x(U,M){if(U==null)return[];const N=[];for(let O of U){const V=$(O,M);V&&N.push(V)}return N}j.fromMany=x;function $(U,M){if(U!=null){let N;U.execution instanceof D.ProcessExecution?N=r.from(U.execution):U.execution instanceof D.ShellExecution?N=a.from(U.execution):U.execution&&U.execution instanceof D.CustomExecution&&(N=g.from(U.execution));const O=t.from(U.definition);let V;if(U.scope?typeof U.scope=="number"?V=U.scope:V=U.scope.uri:V=D.TaskScope.Workspace,!(!O||!V)){const q=U.group?U.group.id:void 0;return{_id:U._id,definition:O,name:U.name,source:{extensionId:M.identifier.value,label:U.source,scope:V},execution:N,isBackground:U.isBackground,group:q,presentationOptions:n.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}}}j.from=$;async function F(U,M,N){if(U!=null){let O;r.is(U.execution)?O=r.to(U.execution):a.is(U.execution)?O=a.to(U.execution):g.is(U.execution)&&(O=g.to(U._id,N));const V=t.to(U.definition);let q;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?q=U.source.scope:q=await M.resolveWorkspaceFolder(_.URI.revive(U.source.scope)):q=D.TaskScope.Workspace),!(!V||!q)){const J=new D.Task(V,q,U.name,U.source.label,O,U.problemMatchers);return U.isBackground!==void 0&&(J.isBackground=U.isBackground),U.group!==void 0&&(J.group=D.TaskGroup.from(U.group)),U.presentationOptions&&(J.presentationOptions=n.to(U.presentationOptions)),U._id&&(J._id=U._id),U.detail&&(J.detail=U.detail),J}}}j.to=F})(f=e.TaskDTO||(e.TaskDTO={}));var h;(function(j){function x(F){return F}j.from=x;function $(F){if(!!F)return Object.assign(Object.create(null),F)}j.to=$})(h=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(x,$,F){this._id=$,this._task=F,c.set(this,void 0),et(this,c,x,"f")}get task(){return this._task}terminate(){He(this,c,"f").terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}c=new WeakMap;var L;(function(j){function x($){return{id:$._id,task:void 0}}j.from=x})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let B=class{constructor(x,$,F,U,M,N,O,V){this._onDidExecuteTask=new T.Emitter,this._onDidTerminateTask=new T.Emitter,this._onDidTaskProcessStarted=new T.Emitter,this._onDidTaskProcessEnded=new T.Emitter,this._proxy=x.getProxy(I.MainContext.MainThreadTask),this._workspaceProvider=F,this._editorService=U,this._configurationService=M,this._terminalService=N,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=O,this._deprecationService=V,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,$,F){if(!F)return new D.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:$,provider:F,extension:x}),this._proxy.$registerTaskProvider(U,$),new D.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(x,$){this._proxy.$registerTaskSystem(x,$)}fetchTasks(x){return this._proxy.$fetchTasks(h.from(x)).then(async $=>{const F=[];for(let U of $){const M=await f.to(U,this._workspaceProvider,this._providedCustomExecutions2);M&&F.push(M)}return F})}get taskExecutions(){const x=[];return this._taskExecutions.forEach($=>x.push($)),x}terminateTask(x){if(!(x instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,$,F){const U=this._providedCustomExecutions2.get(x.id);if(U){if(this._activeCustomExecutions2.get(x.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(x.id,U),this._terminalService.attachPtyToTerminal($,await U.callback(F))}this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){const $=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:$})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const $=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:$,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const $=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:$,exitCode:x.exitCode})}$provideTasks(x,$){const F=this._handlers.get(x);if(!F)return Promise.reject(new Error("no handler found"));const U=[],M=(0,P.asPromise)(()=>F.provider.provideTasks(R.CancellationToken.None)).then(N=>this.provideTasksInternal($,U,F,N));return new Promise(N=>{M.then(O=>{Promise.all(U).then(()=>{N(O)})})})}async $resolveTask(x,$){const F=this._handlers.get(x);if(!F)return Promise.reject(new Error("no handler found"));if($.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${$.definition.type}] cannot be resolved by provider of type [${F.type}].`);const U=await f.to($,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const M=await F.provider.resolveTask(U,R.CancellationToken.None);if(!!M){this.checkDeprecation(M,F);const N=f.from(M,F.extension);if(!N)throw new Error("Unexpected: Task cannot be resolved.");if(M.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(N.execution)&&await this.addCustomExecution(N,M,!0),await this.resolveTaskInternal(N)}}nextHandle(){return this._handleCounter++}async addCustomExecution(x,$,F){const U=await this._proxy.$createTaskId(x);!F&&!this._providedCustomExecutions2.has(U)&&this._notProvidedCustomExecutions.add(U),this._providedCustomExecutions2.set(U,$.execution)}async getTaskExecution(x,$){if(typeof x=="string"){const M=this._taskExecutionPromises.get(x);if(!M)throw new Error("Unexpected: The specified task is missing an execution");return M}let F=this._taskExecutionPromises.get(x.id);if(F)return F;const U=new Promise(async(M,N)=>{const O=$||await f.to(x.task,this._workspaceProvider,this._providedCustomExecutions2);O?M(new A(this,x.id,O)):N("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(x.id,U),U.then(M=>(this._taskExecutions.set(x.id,M),M),M=>Promise.reject(M))}checkDeprecation(x,$){x._deprecated&&this._deprecationService.report("Task.constructor",$.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));let F=this._notProvidedCustomExecutions.values(),U=F.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=F.next()}};B=je([xe(0,w.IExtHostRpcService),xe(1,m.IExtHostInitDataService),xe(2,k.IExtHostWorkspace),xe(3,y.IExtHostDocumentsAndEditors),xe(4,i.IExtHostConfiguration),xe(5,C.IExtHostTerminalService),xe(6,v.ILogService),xe(7,b.IExtHostApiDeprecationService)],B),e.ExtHostTaskBase=B;let ee=class extends B{constructor(x,$,F,U,M,N,O,V){super(x,$,F,U,M,N,O,V);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:S.PlatformToString(0)})}async executeTask(x,$){if(!$.execution)throw new Error("Tasks to execute must include an execution");const F=f.from($,x);if(F===void 0)throw new Error("Task is not valid");if(g.is(F.execution))await this.addCustomExecution(F,$,!1);else throw new u.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(F),$);return this._proxy.$executeTask(F).catch(M=>{throw new Error(M)}),U}provideTasksInternal(x,$,F,U){const M=[];if(U)for(let N of U){this.checkDeprecation(N,F),(!N.definition||!x[N.definition.type])&&this._logService.warn(`The task [${N.source}, ${N.name}] uses an undefined task type. The task will be ignored in the future.`);const O=f.from(N,F.extension);O&&g.is(O.execution)?(M.push(O),$.push(this.addCustomExecution(O,N,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:M,extension:F.extension}}async resolveTaskInternal(x){if(g.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,$){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(x,$,F){}};ee=je([xe(0,w.IExtHostRpcService),xe(1,m.IExtHostInitDataService),xe(2,k.IExtHostWorkspace),xe(3,y.IExtHostDocumentsAndEditors),xe(4,i.IExtHostConfiguration),xe(5,C.IExtHostTerminalService),xe(6,v.ILogService),xe(7,b.IExtHostApiDeprecationService)],ee),e.WorkerExtHostTask=ee,e.IExtHostTask=(0,s.createDecorator)("IExtHostTask")});var mn=this&&this.__rest||function(Q,e){var _={};for(var P in Q)Object.prototype.hasOwnProperty.call(Q,P)&&e.indexOf(P)<0&&(_[P]=Q[P]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,P=Object.getOwnPropertySymbols(Q);T<P.length;T++)e.indexOf(P[T])<0&&Object.prototype.propertyIsEnumerable.call(Q,P[T])&&(_[P[T]]=Q[P[T]]);return _};define(ge[259],pe([0,1,14,19,22,21,3,69,6,23,15,2,28,5,39,13,20,7,32,221,121]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d,S,v,b,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const c=(f,h)=>`${f}:${h.toString()}`;let t=class{constructor(h,A,L){this.documents=A,this.workspace=L,this.resultsChangedEmitter=new D.Emitter,this.providers=new Map,this.ownedTests=new p.OwnedTestCollection,this.testSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=h.getProxy(m.MainContext.MainThreadTesting),this.workspaceObservers=new g(this.proxy),this.textDocumentObservers=new E(this.proxy,A)}registerTestProvider(h){const A=(0,w.generateUuid)();this.providers.set(A,h),this.proxy.$registerTestProvider(A);const L=[...this.testSubscriptions.keys()];return setTimeout(()=>{var B;for(const ee of L)(B=this.testSubscriptions.get(ee))===null||B===void 0||B.subscribeFn(A,h)},0),new v.Disposable(()=>{this.providers.delete(A),this.proxy.$unregisterTestProvider(A)})}createTextDocumentTestObserver(h){return this.textDocumentObservers.checkout(h.uri)}createWorkspaceTestObserver(h){return this.workspaceObservers.checkout(h.uri)}async runTests(h,A=I.CancellationToken.None){const L=B=>B.map(this.getInternalTestForReference,this).filter(R.isDefined).map(ee=>({src:ee.src,testId:ee.item.extId}));await this.proxy.$runTests({exclude:h.exclude?L(h.exclude).map(B=>B.testId):void 0,tests:L(h.tests),debug:h.debug},A)}publishExtensionProvidedResults(h,A){this.proxy.$publishExtensionProvidedResults(S.TestResults.from((0,w.generateUuid)(),h),A)}$publishTestResults(h){this.results=Object.freeze(h.map(A=>(0,i.deepFreeze)(S.TestResults.to(A))).concat(this.results).sort((A,L)=>L.completedAt-A.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(h,A){const L=C.URI.revive(A),B=c(h,L);if(!this.testSubscriptions.has(B)){const ee=new I.CancellationTokenSource;let j;if(h===1){let U=this.documents.getDocument(L);if(!U){const M=new y.DisposableStore;U=await new Promise(N=>{M.add((0,P.disposableTimeout)(()=>N(void 0),5e3)),M.add(this.documents.onDidAddDocuments(O=>{const V=O.find(q=>q.document.uri.toString()===L.toString());V&&N(V)}))}).finally(()=>M.dispose())}if(U){const M=await this.workspace.getWorkspaceFolder2(L,!1);j=N=>N.provideDocumentTestRoot?N.provideDocumentTestRoot(U.document,ee.token):(0,e.createDefaultDocumentTestRoot)(N,U.document,M,ee.token)}}else{const U=await this.workspace.getWorkspaceFolder2(L,!1);U&&(j=M=>M.provideWorkspaceTestRoot(U,ee.token))}if(!!j){const x=async(U,M)=>{try{const N=await j(M);N&&F.addRoot(N,U)}catch(N){console.error(N)}},$=new y.DisposableStore,F=$.add(this.ownedTests.createForHierarchy(U=>this.proxy.$publishDiff(h,A,U)));$.add((0,y.toDisposable)(()=>ee.dispose(!0)));for(const[U,M]of this.providers)x(U,M);F.pushDiff([3,-1]),this.testSubscriptions.set(B,{store:$,collection:F,subscribeFn:x})}}}async $expandTest(h,A){const L=(0,_.mapFind)(this.testSubscriptions.values(),B=>B.collection.treeId===h.src.tree?B:void 0);await(L==null?void 0:L.collection.expand(h.testId,A<0?Infinity:A)),this.flushCollectionDiffs()}$unsubscribeFromTests(h,A){var L;const B=C.URI.revive(A),ee=c(h,B);(L=this.testSubscriptions.get(ee))===null||L===void 0||L.store.dispose(),this.testSubscriptions.delete(ee)}$acceptDiff(h,A,L){h===1?this.textDocumentObservers.acceptDiff(C.URI.revive(A),L):this.workspaceObservers.acceptDiff(C.URI.revive(A),L)}async $runTestsForProvider(h,A){const L=this.providers.get(h.tests[0].src.provider);if(!!L){const B=h.tests.map(({testId:x,src:$})=>this.ownedTests.getTestById(x,$.tree)).filter(R.isDefined).map(([x,$])=>$),ee=h.excludeExtIds.map(x=>this.ownedTests.getTestById(x)).filter(R.isDefined).filter(([x,$])=>B.some(F=>x.comparePositions(F,$)===1));if(!!B.length){const j=x=>{for(const[$,F]of ee){const U=$.comparePositions(F,x.id);if(U===1||U===3)return!0}return!1};try{await L.runTests({appendOutput:x=>{this.proxy.$appendOutputToRun(h.runId,T.VSBuffer.fromString(x))},appendMessage:(x,$)=>{j(x)||(this.flushCollectionDiffs(),this.proxy.$appendTestMessageInRun(h.runId,x.id,S.TestMessage.from($)))},setState:(x,$,F)=>{j(x)||(this.flushCollectionDiffs(),this.proxy.$updateTestStateInRun(h.runId,x.id,$,F))},tests:B.map(x=>o.unwrap(x.actual)),exclude:ee.map(([,x])=>o.unwrap(x.actual)),debug:h.debug},A);for(const{collection:x}of this.testSubscriptions.values())x.flushDiff();return}catch(x){throw console.error(x),x}}}}$lookupTest(h){const A=this.ownedTests.getTestById(h.testId);if(!A)return Promise.resolve(void 0);const L=A[1],{actual:B,discoverCts:ee,expandLevels:j}=L,x=mn(L,["actual","discoverCts","expandLevels"]);return Promise.resolve(x)}flushCollectionDiffs(){for(const{collection:h}of this.testSubscriptions.values())h.flushDiff()}getInternalTestForReference(h){var A,L;return(L=(A=this.workspaceObservers.getMirroredTestDataByReference(h))!==null&&A!==void 0?A:(0,_.mapFind)(this.testSubscriptions.values(),B=>B.collection.getTestByReference(h)))!==null&&L!==void 0?L:this.textDocumentObservers.getMirroredTestDataByReference(h)}};t=je([xe(0,d.IExtHostRpcService),xe(1,s.IExtHostDocumentsAndEditors),xe(2,b.IExtHostWorkspace)],t),e.ExtHostTesting=t;const n=async(f,h,A,L)=>{if(!!A){const B=await f.provideWorkspaceTestRoot(A,L);if(!!B)return L.onCancellationRequested(()=>{o.removeFilter(h)}),o.getWrapperForTestItem(B,h)}};e.createDefaultDocumentTestRoot=n;class o extends v.TestItem{constructor(h,A,L){super(h.id,h.label,h.uri,h.expandable);if(this.actual=h,this.filterDocument=A,this.parent=L,!(h instanceof v.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${h.id} did not`);h[v.TestItemHookProperty]={setProp:(B,ee)=>this[B]=ee,created:B=>o.getWrapperForTestItem(B,this.filterDocument,this).refreshMatch(),invalidate:()=>this.invalidate(),delete:B=>this.children.delete(B)}}static removeFilter(h){this.wrapperMap.delete(h)}static getWrapperForTestItem(h,A,L){let B=this.wrapperMap.get(A);if(B==null?void 0:B.has(h))return B.get(h);B||(B=new WeakMap,this.wrapperMap.set(A,B));const ee=new o(h,A,L);return B.set(h,ee),ee}static unwrap(h){return h instanceof o?h.actual:h}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var h;const A=this._cachedMatchesFilter;for(const B of this.actual.children){const ee=o.getWrapperForTestItem(B,this.filterDocument,this);ee.hasNodeMatchingFilter?this.children.add(ee):this.children.delete(ee)}const L=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=L,L!==A&&((h=this.parent)===null||h===void 0||h.refreshMatch()),this._cachedMatchesFilter}}e.TestItemFilteredWrapper=o,o.wrapperMap=new WeakMap;class r extends u.IncrementalChangeCollector{constructor(h){super();this.emitter=h,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(h){this.added.add(h)}update(h){Object.assign(h.revived,S.TestItem.toPlain(h.item)),this.added.has(h)||this.updated.add(h)}remove(h){if(this.added.has(h)){this.added.delete(h);return}if(this.updated.delete(h),h.parent&&this.alreadyRemoved.has(h.parent)){this.alreadyRemoved.add(h.item.extId);return}this.removed.add(h)}getChangeEvent(){const{added:h,updated:A,removed:L}=this;return{get added(){return[...h].map(B=>B.revived)},get updated(){return[...A].map(B=>B.revived)},get removed(){return[...L].map(B=>B.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class l extends u.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new D.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(h){let A=[];for(const L of h){const B=this.items.get(L);B&&A.push(B.revived)}return A}getMirroredTestDataById(h){return this.items.get(h)}getMirroredTestDataByReference(h){return this.items.get(h.id)}createItem(h,A){return Object.assign(Object.assign({},h),{revived:S.TestItem.toPlain(h.item),depth:A?A.depth+1:0,children:new Set})}createChangeCollector(){return new r(this.changeEmitter)}}e.MirroredTestCollection=l;class a{constructor(){this.resources=new Map}checkout(h){var A,L;const B=h.toString(),ee=(A=this.resources.get(B))!==null&&A!==void 0?A:this.createObserverData(h);return(L=ee.pendingDeletion)===null||L===void 0||L.dispose(),ee.observers++,{onDidChangeTest:ee.tests.onDidChangeTests,onDidDiscoverInitialTests:new D.Emitter().event,get tests(){return ee.tests.rootTestItems},dispose:(0,k.once)(()=>{--ee.observers||(ee.pendingDeletion=this.eventuallyDispose(h))})}}getMirroredTestDataByReference(h){for(const{tests:A}of this.resources.values()){const L=A.getMirroredTestDataByReference(h);if(L)return L}}eventuallyDispose(h){return(0,P.disposableTimeout)(()=>this.unlisten(h),10*1e3)}createObserverData(h){const A=new l,L=this.listen(h,ee=>A.apply(ee)),B={observers:0,tests:A,listener:L};return this.resources.set(h.toString(),B),B}unlisten(h){var A;const L=h.toString(),B=this.resources.get(L);B&&(B.observers=-1,(A=B.pendingDeletion)===null||A===void 0||A.dispose(),B.listener.dispose(),this.resources.delete(L))}}class g extends a{constructor(h){super();this.proxy=h,this.diffListeners=new Map}acceptDiff(h,A){var L;(L=this.diffListeners.get(h.toString()))===null||L===void 0||L(A)}listen(h,A){this.proxy.$subscribeToDiffs(0,h);const L=h.toString();return this.diffListeners.set(L,A),new v.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,h),this.diffListeners.delete(L)})}}class E extends a{constructor(h,A){super();this.proxy=h,this.documents=A,this.diffListeners=new Map}acceptDiff(h,A){var L;(L=this.diffListeners.get(h.toString()))===null||L===void 0||L(A)}listen(h,A){if(!this.documents.getDocument(h))return new v.Disposable(()=>{});const B=h.toString();return this.diffListeners.set(B,A),this.proxy.$subscribeToDiffs(1,h),new v.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,h),this.diffListeners.delete(B)})}}}),define(ge[260],pe([0,1,14,53,33,75,24,11,8,25,10,15,2,139,172,83,59,213,258,31]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d,S,v,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(E,f,h,A){this.configurationService=E,this.workspaceContextService=f,this.editorGroupsService=h,this.pathService=A}text(E,f,h={}){E=this.getContentPattern(E,h);const A=this.configurationService.getValue(),L=f&&f.some(ee=>!this.configurationService.getValue({resource:ee}).search.useRipgrep),B=this.commonQuery(f==null?void 0:f.map(S.toWorkspaceFolder),h);return Object.assign(Object.assign({},B),{type:2,contentPattern:E,previewOptions:h.previewOptions,maxFileSize:h.maxFileSize,usePCRE2:A.search.usePCRE2||L||!1,beforeContext:h.beforeContext,afterContext:h.afterContext,userDisabledExcludesAndIgnoreFiles:h.disregardExcludeSettings&&h.disregardIgnoreFiles})}getContentPattern(E,f){const h=this.configurationService.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const A=Object.assign(Object.assign({},E),{wordSeparators:h.editor.wordSeparators});return this.isCaseSensitive(E,f)&&(A.isCaseSensitive=!0),this.isMultiline(E)&&(A.isMultiline=!0),A}file(E,f={}){const h=this.commonQuery(E,f);return Object.assign(Object.assign({},h),{type:1,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey})}handleIncludeExclude(E,f){return E?(E=Array.isArray(E)?E.map(r):r(E),f?this.parseSearchPaths(E):{pattern:t(...Array.isArray(E)?E:[E])}):{}}commonQuery(E=[],f={}){const h=this.handleIncludeExclude(f.includePattern,f.expandPatterns),A=this.handleIncludeExclude(f.excludePattern,f.expandPatterns),L=E.length>1,B=(h.searchPaths&&h.searchPaths.length?h.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,f,A)):E.map(x=>this.getFolderQueryForRoot(x,f,A,L))).filter(x=>!!x),ee={_reason:f._reason,folderQueries:B,usingSearchPaths:!!(h.searchPaths&&h.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:A.pattern,includePattern:h.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const $=_.coalesce(_.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(M=>M.resource)))).filter(U=>(0,p.pathIncludedInQuery)(ee,U.fsPath)),F=this.commonQueryFromFileList($);return Object.assign(Object.assign({},ee),F)}const j=f.extraFileResources&&f.extraFileResources.filter(x=>(0,p.pathIncludedInQuery)(ee,x.fsPath));return ee.extraFileResources=j&&j.length?j:void 0,ee}commonQueryFromFileList(E){const f=[],h=new D.ResourceMap,A={};let L=!1;return E.forEach(B=>{var ee,j;if(B.scheme!==k.Schemas.walkThrough)if((0,i.isAbsolutePath)(B)){const $=(j=(ee=this.workspaceContextService.getWorkspaceFolder(B))===null||ee===void 0?void 0:ee.uri)!==null&&j!==void 0?j:B.with({path:y.dirname(B.fsPath)});let F=h.get($);F||(L=!0,F={folder:$,includePattern:{}},f.push(F),h.set($,F));const U=y.relative($.fsPath,B.fsPath);(0,C.assertIsDefined)(F.includePattern)[U.replace(/\\/g,"/")]=!0}else B.fsPath&&(L=!0,A[B.fsPath]=!0)}),{folderQueries:f,includePattern:A,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(E,f){if(f.isSmartCase){if(E.isRegExp){if(R.containsUppercaseCharacter(E.pattern,!0))return!0}else if(R.containsUppercaseCharacter(E.pattern))return!0}return!!E.isCaseSensitive}isMultiline(E){return E.isMultiline||E.isRegExp&&(0,m.isMultilineRegexSource)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const f=F=>y.isAbsolute(F)||/^\.\.?([\/\\]|$)/.test(F),A=(Array.isArray(E)?E:n(E)).map(F=>{const U=this.pathService.resolvedUserHome;return U?(0,I.untildify)(F,U.scheme===k.Schemas.file?U.fsPath:U.path):F}),L=P.groupBy(A,F=>f(F)?"searchPaths":"exprSegments"),B=(L.exprSegments||[]).map(F=>R.rtrim(F,"/")).map(F=>R.rtrim(F,"\\")).map(F=>(F[0]==="."&&(F="*"+F),o(F))),ee={},j=this.expandSearchPathPatterns(L.searchPaths||[]);j&&j.length&&(ee.searchPaths=j);const x=_.flatten(B),$=t(...x);return $&&(ee.pattern=$),ee}getExcludesForFolder(E,f){return f.disregardExcludeSettings?void 0:(0,p.getExcludes)(E,!f.disregardSearchExcludeSettings)}expandSearchPathPatterns(E){if(!E||!E.length)return[];const f=_.flatten(E.map(A=>{let{pathPortion:L,globPortion:B}=c(A);B&&(B=l(B));const ee=this.expandOneSearchPath(L);return _.flatten(ee.map(j=>this.resolveOneSearchPathPattern(j,B)))})),h=new Map;return f.forEach(A=>{const L=A.searchPath.toString(),B=h.get(L);B?A.pattern&&(B.pattern=B.pattern||{},B.pattern[A.pattern]=!0):h.set(L,{searchPath:A.searchPath,pattern:A.pattern?t(A.pattern):void 0})}),Array.from(h.values())}expandOneSearchPath(E){if(y.isAbsolute(E)){const f=this.workspaceContextService.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==k.Schemas.file?[{searchPath:f[0].uri.with({path:E})}]:[{searchPath:w.URI.file(y.normalize(E))}]}if(this.workspaceContextService.getWorkbenchState()===2){const f=this.workspaceContextService.getWorkspace().folders[0].uri;if(E=r(E),E.startsWith("../")||E===".."){const A=y.posix.resolve(f.path,E);return[{searchPath:f.with({path:A})}]}const h=l(E);return[{searchPath:f,pattern:h}]}else{if(E==="./"||E===".\\")return[];{const f=E.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(f){const h=f[1],A=this.workspaceContextService.getWorkspace().folders.filter(L=>L.name===h);if(A.length)return A.map(L=>{const B=f[2];return{searchPath:L.uri,pattern:B&&l(B)}});{const L=s.localize(0,null,h);throw new Error(L)}}}}return[]}resolveOneSearchPathPattern(E,f){const h=E.pattern&&f?`${E.pattern}/${f}`:E.pattern||f,A=[{searchPath:E.searchPath,pattern:h}];return h&&!h.endsWith("**")&&A.push({searchPath:E.searchPath,pattern:h+"/**"}),A}getFolderQueryForSearchPath(E,f,h){const A=this.getFolderQueryForRoot((0,S.toWorkspaceFolder)(E.searchPath),f,h,!1);return A?Object.assign(Object.assign({},A),{includePattern:E.pattern}):null}getFolderQueryForRoot(E,f,h,A){let L;const B=w.URI.isUri(E)?E:E.uri;if(h.searchPaths){const F=h.searchPaths.filter(U=>(0,i.isEqual)(U.searchPath,B))[0];if(F&&!F.pattern)return null;F&&(L=F.pattern)}const ee=this.configurationService.getValue({resource:B}),j=this.getExcludesForFolder(ee,f),x=Object.assign(Object.assign({},j||{}),L||{}),$=w.URI.isUri(E)?(0,i.basename)(E):E.name;return{folder:B,folderName:A?$:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:ee.files&&ee.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!ee.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!ee.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!ee.search.followSymlinks}}};u=je([xe(0,d.IConfigurationService),xe(1,S.IWorkspaceContextService),xe(2,v.IEditorGroupsService),xe(3,b.IPathService)],u),e.QueryBuilder=u;function c(g){const E=g.match(/[\*\{\}\(\)\[\]\?]/);if(E){const f=E.index,h=g.substr(0,f).match(/[/|\\][^/\\]*$/);if(h){let A=g.substr(0,h.index);return A.match(/[/\\]/)||(A+="/"),{pathPortion:A,globPortion:g.substr((h.index||0)+1)}}}return{pathPortion:g}}function t(...g){return g.length?g.reduce((E,f)=>(E[f]=!0,E),Object.create(null)):void 0}function n(g){return T.splitGlobAware(g,",").map(E=>E.trim()).filter(E=>!!E.length)}function o(g){return[`**/${g}/**`,`**/${g}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function r(g){return g.replace(/\\/g,"/")}function l(g){return r(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function a(g,E){g=_.distinct(g,A=>A.toString());const f=[],h=E.getWorkspace();return g&&g.forEach(A=>{let L;if(E.getWorkbenchState()===2)L=(0,i.relativePath)(h.folders[0].uri,A),L&&L!=="."&&(L="./"+L);else{const B=E.getWorkspaceFolder(A);if(B){const ee=B.name;if(h.folders.filter(x=>x.name===ee).length===1){const x=(0,i.relativePath)(B.uri,A);x===""?L=`./${B.name}`:L=`./${B.name}/${x}`}else L=A.fsPath}}L&&f.push(L)}),f}e.resolveResourcesForSearchIncludes=a}),define(ge[261],pe([0,1,25,2,21,18,4,260,31,59]),function(Q,e,_,P,T,I,D,k,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function C(d,S){const v=S.activationEvents;if(!v)return Promise.resolve(void 0);const b=[],p=[];for(const r of v)if(/^workspaceContains:/.test(r)){const l=r.substr("workspaceContains:".length);l.indexOf("*")>=0||l.indexOf("?")>=0||d.forceUsingSearch?p.push(l):b.push(l)}if(b.length===0&&p.length===0)return Promise.resolve(void 0);let u;const c=new Promise((r,l)=>{u=r}),t=r=>u({activationEvent:r}),n=Promise.all(b.map(r=>w(d,r,t))).then(()=>{}),o=m(d,S.identifier,p,t);return Promise.all([n,o]).then(()=>{u(void 0)}),c}e.checkActivateWorkspaceContainsExtension=C;async function w(d,S,v){for(const b of d.folders)if(await d.exists(_.joinPath(P.URI.revive(b),S))){v(`workspaceContains:${S}`);return}}async function m(d,S,v,b){if(v.length===0)return Promise.resolve(void 0);const p=new T.CancellationTokenSource,u=d.checkExists(d.folders,v,p.token),c=setTimeout(async()=>{p.cancel(),b(`workspaceContainsTimeout:${v.join(",")}`)},R);let t=!1;try{t=await u}catch(n){I.isPromiseCanceledError(n)||I.onUnexpectedError(n)}p.dispose(),clearTimeout(c),t&&b(`workspaceContains:${v.join(",")}`)}function s(d,S,v,b){const p=d.get(D.IInstantiationService),u=d.get(y.ISearchService),t=p.createInstance(k.QueryBuilder).file(S.map(n=>(0,i.toWorkspaceFolder)(P.URI.revive(n))),{_reason:"checkExists",includePattern:v,exists:!0});return u.fileSearch(t,b).then(n=>!!n.limitHit,n=>I.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=s});var et=this&&this.__classPrivateFieldSet||function(Q,e,_,P,T){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!T:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?T.call(Q,_):T?T.value=_:e.set(Q,_),_},He=this&&this.__classPrivateFieldGet||function(Q,e,_,P){if(_==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!P:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?P:_==="a"?P.call(Q):P?P.value:e.get(Q)};define(ge[42],pe([0,1,161,8,66,25,19,6,24,2,12,5,35,224,89,32,41,222,18,29,11,22,195,7,114,4,27,90,13,81,50,34,3,261,87,196]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d,S,v,b,p,u,c,t,n,o,r,l,a,g,E,f,h,A,L,B,ee){"use strict";var j,x,$;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let F=class On extends k.Disposable{constructor(O,V,q,J,me,we,Ae,Pe,Fe,z){super();this._onDidChangeRemoteConnectionData=this._register(new A.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=V,this._extHostContext=q,this._initData=Ae,this._extHostWorkspace=J,this._extHostConfiguration=me,this._logService=we,this._extHostTunnelService=Fe,this._extHostTerminalService=z,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new D.Barrier,this._readyToStartExtensionHost=new D.Barrier,this._readyToRunExtensions=new D.Barrier,this._eagerExtensionsActivated=new D.Barrier,this._registry=new v.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new s.ExtHostStorage(this._extHostContext),this._secretState=new B.ExtHostSecretState(this._extHostContext),this._storagePath=Pe,this._instaService=O.createChild(new E.ServiceCollection([s.IExtHostStorage,this._storage],[B.IExtHostSecretState,this._secretState]));const Y=new Set;this._initData.hostExtensions.forEach(te=>Y.add(p.ExtensionIdentifier.toKey(te))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(te,ae)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(te,ae)},actualActivateExtension:async(te,ae)=>{if(Y.has(p.ExtensionIdentifier.toKey(te)))return await this._mainThreadExtensionsProxy.$activateExtension(te,ae),new m.HostExtension;const fe=this._registry.getExtensionDescription(te);return this._activateExtension(fe,ae)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),T.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){b.onUnexpectedError(O)}}async deactivateAll(){let O=[];try{O=this._registry.getAllExtensionDescriptions().map(me=>me.identifier).filter(me=>this.isActivated(me)).map(me=>this._deactivate(me))}catch(V){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,V){return this._activator.activateByEvent(O,V)}_activateById(O,V){return this._activator.activateById(O,V)}activateByIdWithErrors(O,V){return this._activateById(O,V).then(()=>{const q=this._activator.getActivatedExtension(O);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const O=y.TernarySearchTree.forPaths(),V=this._registry.getAllExtensionDescriptions().map(q=>{if(!!this._getEntryPoint(q))return this._hostUtils.realpath(q.extensionLocation.fsPath).then(J=>O.set(i.URI.file(J).fsPath,q))});this._extensionPathIndex=Promise.all(V).then(()=>O)}return this._extensionPathIndex}_deactivate(O){let V=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return V;const q=this._activator.getActivatedExtension(O);if(!q)return V;try{typeof q.module.deactivate=="function"&&(V=Promise.resolve(q.module.deactivate()).then(void 0,J=>Promise.resolve(void 0)))}catch(J){}try{(0,k.dispose)(q.subscriptions)}catch(J){}return V}async _activateExtension(O,V){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,V).then(q=>{const J=q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,J.codeLoadingTime,J.activateCallTime,J.activateResolvedTime,V),this._logExtensionActivationTimes(O,V,"success",J),q},q=>{throw this._logExtensionActivationTimes(O,V,"failure"),q})}_logExtensionActivationTimes(O,V,q,J){const me=U(O,V);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},me),J||{}),{outcome:q}))}_doActivateExtension(O,V){const q=U(O,V);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",q);const J=this._getEntryPoint(O);if(!J)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value} ${JSON.stringify(V)}`),this._logService.flush();const me=new m.ExtensionActivationTimesBuilder(V.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,I.joinPath)(O.extensionLocation,J),me),this._loadExtensionContext(O)]).then(we=>(T.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),On._callActivate(this._logService,O.identifier,we[0],we[1],me))).then(we=>(T.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),we))}_loadExtensionContext(O){const V=new t.ExtensionGlobalMemento(O,this._storage),q=new t.ExtensionMemento(O.identifier.value,!1,this._storage),J=new ee.ExtensionSecrets(O,this._secretState),me=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,we=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([V.whenReady,q.whenReady,this._storagePath.whenReady]).then(()=>{const Ae=this;let Pe;return Object.freeze({globalState:V,workspaceState:q,secrets:J,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Fe){return P.join(O.extensionLocation.fsPath,Fe)},get storagePath(){var Fe;return(Fe=Ae._storagePath.workspaceValue(O))===null||Fe===void 0?void 0:Fe.fsPath},get globalStoragePath(){return Ae._storagePath.globalValue(O).fsPath},get logPath(){return P.join(Ae._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return i.URI.joinPath(Ae._initData.logsLocation,O.identifier.value)},get storageUri(){return Ae._storagePath.workspaceValue(O)},get globalStorageUri(){return Ae._storagePath.globalValue(O)},get extensionMode(){return me},get extension(){return Pe===void 0&&(Pe=new M(Ae,O.identifier,O,we)),Pe},get extensionRuntime(){return(0,S.checkProposedApiEnabled)(O),Ae.extensionRuntime},get environmentVariableCollection(){return Ae._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,V,q,J,me){return q=q||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,V,q,J,me).then(we=>new m.ActivatedExtension(!1,null,me.build(),q,we,J.subscriptions))}static _callActivateOptional(O,V,q,J,me){if(typeof q.activate=="function")try{me.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${V.value}`);const we=typeof global=="object"?global:self,Ae=q.activate.apply(we,[J]);return me.activateCallStop(),me.activateResolveStart(),Promise.resolve(Ae).then(Pe=>(me.activateResolveStop(),Pe))}catch(we){return Promise.reject(we)}else return Promise.resolve(q)}_activateOneStartupFinished(O,V){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:V}).then(void 0,q=>{this._logService.error(q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(T.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const V of O.activationEvents)V==="onStartupFinished"&&this._activateOneStartupFinished(O,V)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,me=>{this._logService.error(me)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(me=>this._handleWorkspaceContainsEagerExtensions(me.added)));const V=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],q=this._handleWorkspaceContainsEagerExtensions(V),J=Promise.all([O,q]).then(()=>{});return Promise.race([J,(0,D.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),J}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(V=>this._handleWorkspaceContainsEagerExtension(O,V))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,V){if(!this.isActivated(V.identifier)){const q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,J={folders:O.map(we=>we.uri),forceUsingSearch:q,exists:we=>this._hostUtils.exists(we.fsPath),checkExists:(we,Ae,Pe)=>this._mainThreadWorkspaceProxy.$checkExists(we,Ae,Pe)},me=await(0,L.checkActivateWorkspaceContainsExtension)(J,V);if(!!me)return this._activateById(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:me.activationEvent}).then(void 0,we=>this._logService.error(we))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:V}=this._initData.environment;if(!O||!V||V.scheme!==u.Schemas.file)throw new Error(_.localize(0,null));const q=(0,I.originalFSPath)(V),J=await this._loadCommonJSModule(null,V,new m.ExtensionActivationTimesBuilder(!1));if(!J||typeof J.run!="function")throw new Error(_.localize(1,null,q));return new Promise((me,we)=>{const Ae=(Fe,z)=>{Fe?we(Fe):me(typeof z=="number"&&z>0?1:0)},Pe=J.run(q,Ae);Pe&&Pe.then&&Pe.then(()=>{me(0)}).catch(Fe=>{we(Fe.toString())})})}async $extensionTestsExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,V){return this._resolvers[O]=V,(0,k.toDisposable)(()=>{delete this._resolvers[O]})}async $resolveAuthority(O,V){const q=O.indexOf("+");if(q===-1)throw new Error("Not an authority that can be resolved!");const J=O.substr(0,q);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${J}`,!1);const me=this._resolvers[J];if(!me)return{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${J}.`,detail:void 0}};try{T.mark(`code/extHost/willResolveAuthority/${J}`);const we=await me.resolve(O,{resolveAttempt:V});T.mark(`code/extHost/didResolveAuthorityOK/${J}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(me));const Ae={authority:O,host:we.host,port:we.port,connectionToken:we.connectionToken},Pe={extensionHostEnv:we.extensionHostEnv};return{type:"ok",value:{authority:Ae,options:Pe,tunnelInformation:{environmentTunnels:we.environmentTunnels}}}}catch(we){if(T.mark(`code/extHost/didResolveAuthorityError/${J}`),we instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:we._code,message:we._message,detail:we._detail}};throw we}}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,V){return V===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(q=>this._activateByEvent(O,!1))}async $activate(O,V){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,V),!0):!1}async $deltaExtensions(O,V){O.forEach(J=>J.extensionLocation=i.URI.revive(J.extensionLocation));const q=await this.getExtensionPathIndex();return await Promise.all(V.map(async J=>{const me=this._registry.getExtensionDescription(J);if(!!me){const we=await this._hostUtils.realpath(me.extensionLocation.fsPath);q.delete(i.URI.file(we).fsPath)}})),await Promise.all(O.map(async J=>{const me=await this._hostUtils.realpath(J.extensionLocation.fsPath);q.set(i.URI.file(me).fsPath,J)})),this._registry.deltaExtensions(O,V),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let V=c.VSBuffer.alloc(O),q=Math.random()%256;for(let J=0;J<O;J++)V.writeUInt8(q,J);return V}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};F=je([xe(0,r.IInstantiationService),xe(1,e.IHostUtils),xe(2,g.IExtHostRpcService),xe(3,d.IExtHostWorkspace),xe(4,w.IExtHostConfiguration),xe(5,R.ILogService),xe(6,l.IExtHostInitDataService),xe(7,a.IExtensionStoragePaths),xe(8,f.IExtHostTunnelService),xe(9,h.IExtHostTerminalService)],F),e.AbstractExtHostExtensionService=F;function U(N,O){return{id:N.identifier.value,name:N.name,extensionVersion:N.version,publisherDisplayName:N.publisher,activationEvents:N.activationEvents?N.activationEvents.join(","):null,isBuiltin:N.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class M{constructor(O,V,q,J){j.set(this,void 0),x.set(this,void 0),$.set(this,void 0),et(this,j,O,"f"),et(this,x,V,"f"),et(this,$,q.identifier,"f"),this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=P.normalize((0,I.originalFSPath)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=J}get isActive(){return He(this,j,"f").isActivated(He(this,$,"f"))}get exports(){if(this.packageJSON.api!=="none")return He(this,j,"f").getExtensionExports(He(this,$,"f"))}activate(){return He(this,j,"f").activateByIdWithErrors(He(this,$,"f"),{startup:!1,extensionId:He(this,x,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=M,j=new WeakMap,x=new WeakMap,$=new WeakMap}),define(ge[46],pe([0,1,8,2,3,19,5,7,119,32,42,39,212,35,203,13,4,15,36]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let p=class{constructor(a,g,E,f,h){this._workspaceService=g,this._extensionService=E,this._editorsService=f,this._configurationService=h,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new T.Emitter,this._onDidTerminateDebugSession=new T.Emitter,this._onDidChangeActiveDebugSession=new T.Emitter,this._onDidReceiveDebugSessionCustomEvent=new T.Emitter,this._debugServiceProxy=a.getProxy(D.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new T.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new c(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(A=>{A.onDidChange(L=>{this.registerAllDebugTypes(A)}),this.registerAllDebugTypes(A)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(a,g){const E=a;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let f=`debug:${encodeURIComponent(E.path||"")}`,h="?";return g&&(f+=`${h}session=${encodeURIComponent(g.id)}`,h="&"),f+=`${h}ref=${E.sourceReference}`,P.URI.parse(f)}else{if(E.path)return P.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(a){const g=[];for(const E of a.getAllExtensionDescriptions())if(E.contributes){const f=E.contributes.debuggers;if(f&&f.length>0)for(const h of f)(0,s.isDebuggerMainContribution)(h)&&g.push(h.type)}this._debugServiceProxy.$registerDebugTypes(g)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const a=[];return this._breakpoints.forEach(g=>a.push(g)),a}addBreakpoints(a){this.startBreakpoints();const g=a.filter(h=>{const A=h.id;return this._breakpoints.has(A)?!1:(this._breakpoints.set(A,h),!0)});this.fireBreakpointChanges(g,[],[]);const E=[],f=new Map;for(const h of g)if(h instanceof k.SourceBreakpoint){let A=f.get(h.location.uri.toString());A||(A={type:"sourceMulti",uri:h.location.uri,lines:[]},f.set(h.location.uri.toString(),A),E.push(A)),A.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof k.FunctionBreakpoint&&E.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this._debugServiceProxy.$registerBreakpoints(E)}removeBreakpoints(a){this.startBreakpoints();const g=a.filter(A=>this._breakpoints.delete(A.id));this.fireBreakpointChanges([],g,[]);const E=g.filter(A=>A instanceof k.SourceBreakpoint).map(A=>A.id),f=g.filter(A=>A instanceof k.FunctionBreakpoint).map(A=>A.id),h=g.filter(A=>A instanceof k.DataBreakpoint).map(A=>A.id);return this._debugServiceProxy.$unregisterBreakpoints(E,f,h)}startDebugging(a,g,E){return this._debugServiceProxy.$startDebugging(a?a.uri:void 0,g,{parentSessionID:E.parentSession?E.parentSession.id:void 0,repl:E.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact})}stopDebugging(a){return this._debugServiceProxy.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,g,E){if(!g)return new k.Disposable(()=>{});const f=this._configProviderHandleCounter++;return this._configProviders.push({type:a,handle:f,provider:g}),this._debugServiceProxy.$registerDebugConfigurationProvider(a,E,!!g.provideDebugConfigurations,!!g.resolveDebugConfiguration,!!g.resolveDebugConfigurationWithSubstitutedVariables,f),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(h=>h.provider!==g),this._debugServiceProxy.$unregisterDebugConfigurationProvider(f)})}registerDebugAdapterDescriptorFactory(a,g,E){if(!E)return new k.Disposable(()=>{});if(!this.definesDebugType(a,g))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${g}' debugger.`);if(this.getAdapterDescriptorFactoryByType(g))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const f=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:g,handle:f,factory:E}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(g,f),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(h=>h.factory!==E),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(f)})}registerDebugAdapterTrackerFactory(a,g){if(!g)return new k.Disposable(()=>{});const E=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:a,handle:E,factory:g}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(f=>f.factory!==g)})}async $runInTerminal(a,g){return Promise.resolve(void 0)}async $substituteVariables(a,g){if(!this._variableResolver){const[h,A]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(h||[],this._editorsService,A)}let E;const f=await this.getFolder(a);return f&&(E={uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(E,g)}createDebugAdapter(a,g){if(a.type==="implementation")return new o(a.implementation)}createSignService(){}async $startDASession(a,g){const E=this,f=await this.getSession(g);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(f.type),f).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}' (extension might have failed to activate)`);const A=this.convertToDto(h),L=this.createDebugAdapter(A,f);if(!L)throw new Error(`Couldn't create a debug adapter for type '${f.type}'.`);const B=L;return this._debugAdapters.set(a,B),this.getDebugAdapterTrackers(f).then(ee=>(ee&&this._debugAdaptersTrackers.set(a,ee),B.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const x=j,$={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const F=await this._signService.sign(x.arguments.value);$.body={signature:F},B.sendResponse($)}else throw new Error("no signer")}catch(F){$.success=!1,$.message=F.message,B.sendResponse($)}}else ee&&ee.onDidSendMessage&&ee.onDidSendMessage(j),j=(0,s.convertToVSCPaths)(j,!0),E._debugServiceProxy.$acceptDAMessage(a,j)}),B.onError(j=>{ee&&ee.onError&&ee.onError(j),this._debugServiceProxy.$acceptDAError(a,j.name,j.message,j.stack)}),B.onExit(j=>{ee&&ee.onExit&&ee.onExit((0,v.withNullAsUndefined)(j),void 0),this._debugServiceProxy.$acceptDAExit(a,(0,v.withNullAsUndefined)(j),void 0)}),ee&&ee.onWillStartSession&&ee.onWillStartSession(),B.startSession()))})}$sendDAMessage(a,g){g=(0,s.convertToDAPaths)(g,!1);const E=this._debugAdaptersTrackers.get(a);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(g);const f=this._debugAdapters.get(a);f&&f.sendMessage(g)}$stopDASession(a){const g=this._debugAdaptersTrackers.get(a);this._debugAdaptersTrackers.delete(a),g&&g.onWillStopSession&&g.onWillStopSession();const E=this._debugAdapters.get(a);return this._debugAdapters.delete(a),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const g=[],E=[],f=[];if(a.added)for(const h of a.added){const A=h.id;if(A&&!this._breakpoints.has(A)){let L;if(h.type==="function")L=new k.FunctionBreakpoint(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")L=new k.DataBreakpoint(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const B=P.URI.revive(h.uri);L=new k.SourceBreakpoint(new k.Location(B,new k.Position(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}L._id=A,this._breakpoints.set(A,L),g.push(L)}}if(a.removed)for(const h of a.removed){const A=this._breakpoints.get(h);A&&(this._breakpoints.delete(h),E.push(A))}if(a.changed){for(const h of a.changed)if(h.id){const A=this._breakpoints.get(h.id);if(A){if(A instanceof k.FunctionBreakpoint&&h.type==="function"){const L=A;L.enabled=h.enabled,L.condition=h.condition,L.hitCondition=h.hitCondition,L.logMessage=h.logMessage,L.functionName=h.functionName}else if(A instanceof k.SourceBreakpoint&&h.type==="source"){const L=A;L.enabled=h.enabled,L.condition=h.condition,L.hitCondition=h.hitCondition,L.logMessage=h.logMessage,L.location=new k.Location(P.URI.revive(h.uri),new k.Position(h.line,h.character))}f.push(A)}}}this.fireBreakpointChanges(g,E,f)}$provideDebugConfigurations(a,g,E){return(0,I.asPromise)(async()=>{const f=this.getConfigProviderByHandle(a);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.getFolder(g);return f.provideDebugConfigurations(h,E)}).then(f=>{if(!f)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return f})}$resolveDebugConfiguration(a,g,E,f){return(0,I.asPromise)(async()=>{const h=this.getConfigProviderByHandle(a);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.getFolder(g);return h.resolveDebugConfiguration(A,E,f)})}$resolveDebugConfigurationWithSubstitutedVariables(a,g,E,f){return(0,I.asPromise)(async()=>{const h=this.getConfigProviderByHandle(a);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.getFolder(g);return h.resolveDebugConfigurationWithSubstitutedVariables(A,E,f)})}async $provideDebugAdapter(a,g){const E=this.getAdapterDescriptorFactoryByHandle(a);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const f=await this.getSession(g);return this.getAdapterDescriptor(E,f).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}'`);return this.convertToDto(h)})}async $acceptDebugSessionStarted(a){const g=await this.getSession(a);this._onDidStartDebugSession.fire(g)}async $acceptDebugSessionTerminated(a){const g=await this.getSession(a);g&&(this._onDidTerminateDebugSession.fire(g),this._debugSessions.delete(g.id))}async $acceptDebugSessionActiveChanged(a){this._activeDebugSession=a?await this.getSession(a):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(a,g){const E=await this.getSession(a);E&&E._acceptNameChanged(g)}async $acceptDebugSessionCustomEvent(a,g){const f={session:await this.getSession(a),event:g.event,body:g.body};this._onDidReceiveDebugSessionCustomEvent.fire(f)}convertToDto(a){if(a instanceof k.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof k.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(a){const g=this._adapterFactories.filter(E=>E.type===a);if(g.length>0)return g[0].factory}getAdapterDescriptorFactoryByHandle(a){const g=this._adapterFactories.filter(E=>E.handle===a);if(g.length>0)return g[0].factory}getConfigProviderByHandle(a){const g=this._configProviders.filter(E=>E.handle===a);if(g.length>0)return g[0].provider}definesDebugType(a,g){if(a.contributes){const E=a.contributes.debuggers;if(E&&E.length>0){for(const f of E)if(f.label&&f.type&&f.type===g)return!0}}return!1}getDebugAdapterTrackers(a){const E=a.configuration.type,f=this._trackerFactories.filter(h=>h.type===E||h.type==="*").map(h=>(0,I.asPromise)(()=>h.factory.createDebugAdapterTracker(a)).then(A=>A,A=>null));return Promise.race([Promise.all(f).then(h=>{const A=h.filter(L=>!!L);if(A.length>0)return new n(A)}),new Promise((h,A)=>{const L=setTimeout(()=>{clearTimeout(L),A(new Error("timeout"))},1e3)})]).catch(h=>{})}async getAdapterDescriptor(a,g){const E=g.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new k.DebugAdapterServer(E));if(a){const h=await this._extensionService.getExtensionRegistry();return(0,I.asPromise)(()=>a.createDebugAdapterDescriptor(g,this.daExecutableFromPackage(g,h))).then(A=>{if(A)return A})}const f=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(g,f))}daExecutableFromPackage(a,g){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(a,g,E){(a.length>0||g.length>0||E.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:a,removed:g,changed:E}))}async getSession(a){if(a)if(typeof a=="string"){const g=this._debugSessions.get(a);if(g)return g}else{let g=this._debugSessions.get(a.id);if(!g){const E=await this.getFolder(a.folderUri);g=new u(this._debugServiceProxy,a.id,a.type,a.name,E,a.configuration),this._debugSessions.set(g.id,g),this._debugServiceProxy.$sessionCached(g.id)}return g}throw new Error("cannot find session")}getFolder(a){if(a){const g=P.URI.revive(a);return this._workspaceService.resolveWorkspaceFolder(g)}return Promise.resolve(void 0)}};p=je([xe(0,d.IExtHostRpcService),xe(1,i.IExtHostWorkspace),xe(2,R.IExtHostExtensionService),xe(3,C.IExtHostDocumentsAndEditors),xe(4,m.IExtHostConfiguration)],p),e.ExtHostDebugServiceBase=p;class u{constructor(a,g,E,f,h,A){this._debugServiceProxy=a,this._id=g,this._type=E,this._name=f,this._workspaceFolder=h,this._configuration=A}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(a){this._name=a,this._debugServiceProxy.$setDebugSessionName(this._id,a)}_acceptNameChanged(a){this._name=a}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(a,g){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,a,g)}getDebugProtocolBreakpoint(a){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,a.id)}}e.ExtHostDebugSession=u;class c{constructor(a){this.value=Object.freeze({append(g){a.$appendDebugConsole(g)},appendLine(g){this.append(g+`
`)}})}}e.ExtHostDebugConsole=c;class t extends w.AbstractVariableResolverService{constructor(a,g,E,f){super({getFolderUri:h=>{const A=a.filter(L=>L.name===h);if(A&&A.length>0)return A[0].uri},getWorkspaceFolderCount:()=>a.length,getConfigurationValue:(h,A)=>E.getConfiguration(void 0,h).get(A),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(g){const h=g.activeEditor();if(h)return _.normalize(h.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(g&&f){const h=g.activeEditor();if(h){const A=f.getWorkspaceFolder(h.document.uri);if(A)return _.normalize(A.uri.fsPath)}}},getSelectedText:()=>{if(g){const h=g.activeEditor();if(h&&!h.selection.isEmpty)return h.document.getText(h.selection)}},getLineNumber:()=>{if(g){const h=g.activeEditor();if(h)return String(h.selection.end.line+1)}}},void 0,b.env)}}e.ExtHostVariableResolverService=t;class n{constructor(a){this.trackers=a}onWillStartSession(){this.trackers.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.trackers.forEach(g=>g.onWillReceiveMessage?g.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.trackers.forEach(g=>g.onDidSendMessage?g.onDidSendMessage(a):void 0)}onWillStopSession(){this.trackers.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.trackers.forEach(g=>g.onError?g.onError(a):void 0)}onExit(a,g){this.trackers.forEach(E=>E.onExit?E.onExit(a,g):void 0)}}class o extends y.AbstractDebugAdapter{constructor(a){super();this.implementation=a,a.onDidSendMessage(g=>{this.acceptMessage(g)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.implementation.handleMessage(a)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends p{constructor(a,g,E,f,h){super(a,g,E,f,h)}createVariableResolver(a,g,E){return new t(a,g,E)}};r=je([xe(0,d.IExtHostRpcService),xe(1,i.IExtHostWorkspace),xe(2,R.IExtHostExtensionService),xe(3,C.IExtHostDocumentsAndEditors),xe(4,m.IExtHostConfiguration)],r),e.WorkerExtHostDebugService=r}),define(ge[262],pe([0,1,66,2,5,35,41,29,13,27,4,42,36,12]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(p,u,c,t,n,o,r){this._apiFactory=p,this._extensionRegistry=u,this._instaService=c,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=o,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),_.mark("code/extHost/willWaitForConfig");const p=await this._extHostConfiguration.getConfigProvider();_.mark("code/extHost/didWaitForConfig");const u=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,u,this._extensionRegistry,p,this._logService)),this.register(this._instaService.createInstance(S)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(v,u,this._initData.environment.appUriScheme))}register(p){if(Array.isArray(p.nodeModuleName))for(let u of p.nodeModuleName)this._factories.set(u,p);else this._factories.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this._alternatives.push(u=>p.alternativeModuleName(u))}};s=je([xe(2,R.IInstantiationService),xe(3,I.IExtHostConfiguration),xe(4,C.IExtHostExtensionService),xe(5,i.IExtHostInitDataService),xe(6,m.ILogService)],s),e.RequireInterceptor=s;class d{constructor(p,u,c,t,n){this._apiFactory=p,this._extensionPaths=u,this._extensionRegistry=c,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(p,u){const c=this._extensionPaths.findSubstr(u.fsPath);if(c){let t=this._extApiImpl.get(k.ExtensionIdentifier.toKey(c.identifier));return t||(t=this._apiFactory(c,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(c.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,o)=>t+=`	${o} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${u.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(D.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(p,u){this.nodeModuleName="keytar";const{environment:c}=u,t=p.getProxy(T.MainContext.MainThreadKeytar);if(c.appRoot){let n=c.appRoot.fsPath;w.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,o)=>t.$getPassword(n,o),setPassword:(n,o,r)=>t.$setPassword(n,o,r),deletePassword:(n,o)=>t.$deletePassword(n,o),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(p,u){return this._impl}alternativeModuleName(p){const u=p.length;if(!(u<=7||!this.alternativeNames)){const c=u-7;if((p.charAt(c)==="/"||p.charAt(c)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.alternativeNames.has(p)))return"keytar"}}};S=je([xe(0,y.IExtHostRpcService),xe(1,i.IExtHostInitDataService)],S);let v=class{constructor(p,u,c){this._extensionPaths=p,this._appUriScheme=u,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=c.getProxy(T.MainContext.MainThreadTelemetry);const t=c.getProxy(T.MainContext.MainThreadWindow);this._impl=(n,o)=>{const r=P.URI.parse(n);return o?this.callOriginal(n,o):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,n,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,n,{}):this.callOriginal(n,o)}}load(p,u,c){const t=this._extensionPaths.findSubstr(u.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=c(p),this._impl}callOriginal(p,u){return this.sendNoForwardTelemetry(),this._original(p,u)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};v=je([xe(2,y.IExtHostRpcService)],v)}),define(ge[263],pe([0,1,167,9,7,204,32,42,39,35,34,13,46,188,207,19]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let S=class extends w.ExtHostDebugServiceBase{constructor(p,u,c,t,n,o){super(p,u,c,t,n);this._terminalService=o,this._integratedTerminalInstances=new v}createDebugAdapter(p,u){switch(p.type){case"server":return new I.SocketDebugAdapter(p);case"pipeServer":return new I.NamedPipeDebugAdapter(p);case"executable":return new I.ExecutableDebugAdapter(p,u.type)}return super.createDebugAdapter(p,u)}daExecutableFromPackage(p,u){const c=I.ExecutableDebugAdapter.platformAdapterExecutable(u.getAllExtensionDescriptions(),p.type);if(c)return new T.DebugAdapterExecutable(c.command,c.args,c.options)}createSignService(){return new m.SignService}async $runInTerminal(p,u){if(p.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(h=>{this._integratedTerminalInstances.onTerminalClosed(h)}));const c=await this._configurationService.getConfigProvider(),t=this._terminalService.getDefaultShell(!0,c),n=this._terminalService.getDefaultShellArgs(!0,c),o=JSON.stringify({shell:t,shellArgs:n});let r=await this._integratedTerminalInstances.checkout(o),l,a=!1;if(r)l=p.cwd;else{const h={shellPath:t,shellArgs:n,cwd:p.cwd,name:p.title||_.localize(0,null)};a=!0,r=this._terminalService.createTerminalFromOptions(h,!0),this._integratedTerminalInstances.insert(r,o)}r.show(!0);const g=await r.processId;a?await new Promise(h=>setTimeout(h,1e3)):c.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(t.indexOf("powershell")>=0||t.indexOf("pwsh")>=0||t.indexOf("cmd.exe")>=0?r.sendText("cls"):t.indexOf("bash")>=0?r.sendText("clear"):P.isWindows?r.sendText("cls"):r.sendText("clear"));const E=(0,s.prepareCommand)(t,p.args,l,p.env);r.sendText(E);const f=this.onDidTerminateDebugSession(h=>{h.id===u&&(this._integratedTerminalInstances.free(r),f.dispose())});return g}else if(p.kind==="external")return(0,s.runInExternalTerminal)(p,await this._configurationService.getConfigProvider());return super.$runInTerminal(p,u)}createVariableResolver(p,u,c){return new w.ExtHostVariableResolverService(p,u,c,this._workspaceService)}};S=je([xe(0,C.IExtHostRpcService),xe(1,D.IExtHostWorkspace),xe(2,k.IExtHostExtensionService),xe(3,y.IExtHostDocumentsAndEditors),xe(4,i.IExtHostConfiguration),xe(5,R.IExtHostTerminalService)],S),e.ExtHostDebugService=S;class v{constructor(){this._terminalInstances=new Map}async checkout(p){const c=[...this._terminalInstances.entries()].map(([t,n])=>(0,d.createCancelablePromise)(async o=>{if(n.lastUsedAt!==-1&&await(0,s.hasChildProcesses)(await t.processId))return null;const r=Date.now();return n.lastUsedAt+v.minUseDelay>r||o.isCancellationRequested||n.config!==p?null:(n.lastUsedAt=r,t)}));return await(0,d.firstParallel)(c,t=>!!t)}insert(p,u){this._terminalInstances.set(p,{lastUsedAt:Date.now(),config:u})}free(p){const u=this._terminalInstances.get(p);u&&(u.lastUsedAt=-1)}onTerminalClosed(p){this._terminalInstances.delete(p)}}v.minUseDelay=1e3}),define(ge[264],pe([0,1,8,2,77,32,46,39,35,34,13,27,65,11,12,62]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let S=class extends w.ExtHostTaskBase{constructor(b,p,u,c,t,n,o,r){super(b,p,u,c,t,n,o,r);this.workspaceService=u,p.remote.isRemote&&p.remote.authority?this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:p.remote.authority,platform:process.platform}):this.registerTaskSystem(m.Schemas.file,{scheme:m.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(b,p){const u=p;if(!p.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const c=w.TaskHandleDTO.from(u,this.workspaceService),t=await this._proxy.$getTaskExecution(c);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const n=await this.getTaskExecution(t,p);return this._proxy.$executeTask(c).catch(()=>{}),n}else{const c=w.TaskDTO.from(p,b);if(c===void 0)return Promise.reject(new Error("Task is not valid"));w.CustomExecutionDTO.is(c.execution)&&await this.addCustomExecution(c,p,!1);const t=await this.getTaskExecution(await this._proxy.$getTaskExecution(c),p);return this._proxy.$executeTask(c).catch(()=>{}),t}}provideTasksInternal(b,p,u,c){const t=[];if(c)for(let n of c){this.checkDeprecation(n,u),(!n.definition||!b[n.definition.type])&&this._logService.warn(`The task [${n.source}, ${n.name}] uses an undefined task type. The task will be ignored in the future.`);const o=w.TaskDTO.from(n,u.extension);o&&(t.push(o),w.CustomExecutionDTO.is(o.execution)&&p.push(this.addCustomExecution(o,n,!0)))}return{tasks:t,extension:u.extension}}async resolveTaskInternal(b){return b}async getVariableResolver(b){if(this._variableResolver===void 0){const p=await this._configurationService.getConfigProvider();this._variableResolver=new D.ExtHostVariableResolverService(b,this._editorService,p,this.workspaceService)}return this._variableResolver}async $resolveVariables(b,p){const u=P.URI.revive(b),c={process:void 0,variables:Object.create(null)},t=await this._workspaceProvider.resolveWorkspaceFolder(u),n=await this._workspaceProvider.getWorkspaceFolders2();if(!n||!t)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const o=await this.getVariableResolver(n),r={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}};for(let l of p.variables)c.variables[l]=await o.resolveAsync(r,l);if(p.process!==void 0){let l;if(p.process.path!==void 0){l=p.process.path.split(_.delimiter);for(let a=0;a<l.length;a++)l[a]=await o.resolveAsync(r,l[a])}c.process=await T.win32.findExecutable(await o.resolveAsync(r,p.process.name),p.process.cwd!==void 0?await o.resolveAsync(r,p.process.cwd):void 0,l)}return c}$getDefaultShellAndArgs(){return this._terminalService.$getDefaultShellAndArgs(!0)}async $jsonTasksSupported(){return!0}async $findExecutable(b,p,u){return T.win32.findExecutable(b,p,u)}};S=je([xe(0,R.IExtHostRpcService),xe(1,C.IExtHostInitDataService),xe(2,I.IExtHostWorkspace),xe(3,k.IExtHostDocumentsAndEditors),xe(4,y.IExtHostConfiguration),xe(5,i.IExtHostTerminalService),xe(6,s.ILogService),xe(7,d.IExtHostApiDeprecationService)],S),e.ExtHostTask=S}),define(ge[265],pe([0,1,9,15,28,148,12,35,46,39,13,34,32,210,211]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let d=class extends C.BaseExtHostTerminalService{constructor(v,b,p,u,c){super(!0,v);this._extHostConfiguration=b,this._extHostWorkspace=p,this._extHostDocumentsAndEditors=u,this._logService=c,this._isWorkspaceShellAllowed=!1,(0,I.getSystemShell)(_.platform,process.env).then(t=>this._defaultShell=t),this._updateLastActiveWorkspace(),this._variableResolverPromise=this._updateVariableResolver(),this._registerListeners()}createTerminal(v,b,p){const u=new C.ExtHostTerminal(this._proxy,(0,T.generateUuid)(),{name:v,shellPath:b,shellArgs:p},v);return this._terminals.push(u),u.create(b,p),u.value}createTerminalFromOptions(v,b){const p=new C.ExtHostTerminal(this._proxy,(0,T.generateUuid)(),v,v.name);return this._terminals.push(p),p.create((0,P.withNullAsUndefined)(v.shellPath),(0,P.withNullAsUndefined)(v.shellArgs),(0,P.withNullAsUndefined)(v.cwd),(0,P.withNullAsUndefined)(v.env),(0,P.withNullAsUndefined)(v.icon),(0,P.withNullAsUndefined)(v.message),void 0,(0,P.withNullAsUndefined)(v.strictEnv),(0,P.withNullAsUndefined)(v.hideFromUser),(0,P.withNullAsUndefined)(b),!0),p.value}getDefaultShell(v,b){var p;const u=c=>{const t=b.getConfiguration(c.substr(0,c.lastIndexOf("."))).inspect(c.substr(c.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(t)};return m.getDefaultShell(u,this._isWorkspaceShellAllowed,(p=this._defaultShell)!==null&&p!==void 0?p:(0,I.getSystemShellSync)(_.platform,process.env),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,m.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService,v)}getDefaultShellArgs(v,b){const p=u=>{const c=b.getConfiguration(u.substr(0,u.lastIndexOf("."))).inspect(u.substr(u.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(c)};return m.getDefaultShellArgs(p,this._isWorkspaceShellAllowed,v,m.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService)}_apiInspectConfigToPlain(v){return{userValue:v?v.globalValue:void 0,value:v?v.workspaceValue:void 0,defaultValue:v?v.defaultValue:void 0}}_registerListeners(){this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(()=>this._updateLastActiveWorkspace()),this._extHostWorkspace.onDidChangeWorkspace(()=>{this._variableResolverPromise=this._updateVariableResolver()})}_updateLastActiveWorkspace(){const v=this._extHostDocumentsAndEditors.activeEditor();v&&(this._lastActiveWorkspace=this._extHostWorkspace.getWorkspaceFolder(v.document.uri))}async _updateVariableResolver(){const v=await this._extHostConfiguration.getConfigProvider(),b=await this._extHostWorkspace.getWorkspaceFolders2();return this._variableResolver=new y.ExtHostVariableResolverService(b||[],this._extHostDocumentsAndEditors,v),this._variableResolver}async $getAvailableProfiles(v){const b=await(await this._extHostConfiguration.getConfigProvider()).getConfiguration().get("terminal.integrated");return(0,s.detectAvailableProfiles)(v,void 0,this._logService,b,await this._variableResolverPromise,this._lastActiveWorkspace)}async $getDefaultShellAndArgs(v){const b=await this._extHostConfiguration.getConfigProvider();return{shell:this.getDefaultShell(v,b),args:this.getDefaultShellArgs(v,b)}}$acceptWorkspacePermissionsChanged(v){this._isWorkspaceShellAllowed=v}};d=je([xe(0,R.IExtHostRpcService),xe(1,k.IExtHostConfiguration),xe(2,w.IExtHostWorkspace),xe(3,i.IExtHostDocumentsAndEditors),xe(4,D.ILogService)],d),e.ExtHostTerminalService=d}),define(ge[266],pe([0,1,19,18,66,6,2,5,256,12,78,81,27,184,13,61,42,34]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(u,c,t,n){this._disposables=new I.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const o=new y.RPCProtocol(u,null,n);c=b._transform(c,o);const r=new C.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());r.set(w.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},c)),r.set(s.IExtHostRpcService,new s.ExtHostRpcService(o)),r.set(d.IURITransformerService,new d.URITransformerService(n)),r.set(S.IHostUtils,t);const l=new m.InstantiationService(r,!0),a=l.invokeFunction(h=>h.get(v.IExtHostTerminalService));this._disposables.add(a),this._logService=l.invokeFunction(h=>h.get(i.ILogService)),T.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",c),this._extensionService=l.invokeFunction(h=>h.get(S.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const g=new WeakMap;this._extensionService.getExtensionPathIndex().then(h=>{Error.prepareStackTrace=(A,L)=>{let B="",ee,j;for(const x of L)B+=`
	at ${x.toString()}`,j=x.getFileName(),!ee&&j&&(ee=h.findSubstr(j));return g.set(A,ee),`${A.name||"Error"}: ${A.message||""}${B}`}});const E=o.getProxy(k.MainContext.MainThreadExtensionService),f=o.getProxy(k.MainContext.MainThreadErrors);P.setUnexpectedErrorHandler(h=>{const A=P.transformErrorForSerialization(h),L=g.get(h);L?E.$onExtensionRuntimeError(L.identifier,A):f.$onUnexpectedError(A)})}terminate(u){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${u}`),this._logService.flush(),this._disposables.dispose(),P.setUnexpectedErrorHandler(t=>{});const c=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,_.timeout)(4e3),c]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(u,c){u.extensions.forEach(n=>n.extensionLocation=D.URI.revive(c.transformIncomingURIs(n.extensionLocation))),u.environment.appRoot=D.URI.revive(c.transformIncomingURIs(u.environment.appRoot));const t=u.environment.extensionDevelopmentLocationURI;return t&&(u.environment.extensionDevelopmentLocationURI=t.map(n=>D.URI.revive(c.transformIncomingURIs(n)))),u.environment.extensionTestsLocationURI=D.URI.revive(c.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=D.URI.revive(c.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=D.URI.revive(c.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=D.URI.revive(c.transformIncomingURIs(u.logsLocation)),u.logFile=D.URI.revive(c.transformIncomingURIs(u.logFile)),u.workspace=c.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=b}),define(ge[267],pe([0,1,8,21,58,33,25,47,31]),function(Q,e,_,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class i{constructor(w,m,s){this.config=w,this.provider=m,this.sessionToken=s,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=w.filePattern,this.includePattern=w.includePattern&&I.parse(w.includePattern),this.maxResults=w.maxResults||void 0,this.exists=w.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=w.excludePattern&&I.parse(w.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(w=>w.cancel()),this.activeCancellationTokens=new Set}search(w){const m=this.config.folderQueries||[];return new Promise((s,d)=>{const S=v=>{this.resultCount++,w(v)};if(this.isCanceled)return s({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(v=>{const b=v.toString(),p=_.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,p)||this.matchFile(S,{base:v,basename:p})}),Promise.all(m.map(v=>this.searchInFolder(v,S))).then(v=>{s({limitHit:this.isLimitHit,stats:v[0]||void 0})},v=>{d(new Error((0,T.toErrorMessage)(v)))})})}async searchInFolder(w,m){const s=new P.CancellationTokenSource,d=this.getSearchOptionsForFolder(w),S=this.initDirectoryTree(),v=new y.QueryGlobTester(this.config,w),b=!v.hasSiblingExcludeClauses();let p;try{this.activeCancellationTokens.add(s),p=k.StopWatch.create();const u=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,s.token),c=p.elapsed(),t=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(u&&u.forEach(n=>{const o=_.posix.relative(w.folder.path,n.path);if(b){const r=_.basename(n.path);this.matchFile(m,{base:w.folder,relativePath:o,basename:r});return}this.addDirectoryEntries(S,w.folder,o,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(S,v,m),{providerTime:c,postProcessTime:t.elapsed()})}finally{s.dispose(),this.activeCancellationTokens.delete(s)}}getSearchOptionsForFolder(w){const m=(0,y.resolvePatternsForProvider)(this.config.includePattern,w.includePattern),s=(0,y.resolvePatternsForProvider)(this.config.excludePattern,w.excludePattern);return{folder:w.folder,excludes:s,includes:m,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,followSymlinks:!w.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const w={rootEntries:[],pathToEntries:Object.create(null)};return w.pathToEntries["."]=w.rootEntries,w}addDirectoryEntries({pathToEntries:w},m,s,d){if(s===this.filePattern){const v=_.basename(this.filePattern);this.matchFile(d,{base:m,relativePath:this.filePattern,basename:v})}function S(v){const b=_.basename(v),p=_.dirname(v);let u=w[p];u||(u=w[p]=[],S(p)),u.push({base:m,relativePath:v,basename:b})}S(s)}matchDirectoryTree({rootEntries:w,pathToEntries:m},s,d){const S=this,v=this.filePattern;function b(p){const u=I.hasSiblingFn(()=>p.map(c=>c.basename));for(let c=0,t=p.length;c<t;c++){const n=p[c],{relativePath:o,basename:r}=n;if(!!s.includedInQuerySync(o,r,v!==r?u:void 0)){const l=m[o];if(l)b(l);else{if(o===v)continue;S.matchFile(d,n)}if(S.isLimitHit)break}}}b(w)}matchFile(w,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||w(m))}}class R{constructor(){this.sessions=new Map}fileSearch(w,m,s,d){const S=this.getSessionTokenSource(w.cacheKey),v=new i(w,m,S&&S.token);let b=0;const p=u=>{b+=u.length,s(u.map(c=>this.rawMatchToSearchItem(c)))};return this.doSearch(v,R.BATCH_SIZE,p,d).then(u=>({limitHit:u.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:u.stats}}))}clearCache(w){const m=this.getSessionTokenSource(w);m&&m.cancel()}getSessionTokenSource(w){if(!!w)return this.sessions.has(w)||this.sessions.set(w,new P.CancellationTokenSource),this.sessions.get(w)}rawMatchToSearchItem(w){return w.relativePath?{resource:D.joinPath(w.base,w.relativePath)}:{resource:w.base}}doSearch(w,m,s,d){d.onCancellationRequested(()=>{w.cancel()});const S=b=>{b&&(v.push(b),m>0&&v.length>=m&&(s(v),v=[]))};let v=[];return w.search(S).then(b=>(v.length&&s(v),b),b=>(v.length&&s(v),Promise.reject(b)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(ge[126],pe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=e.Position=void 0;class _{constructor(I,D){this.line=I,this.character=D}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,D){return new _(0,0)}with(I){return new _(0,0)}}e.Position=_;class P{constructor(I,D,k,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new _(I,D),this.end=new _(k,y)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new P(0,0,0,0)}with(I){return new P(0,0,0,0)}}e.Range=P}),define(ge[127],pe([0,1,8,14,21,58,25,33,2,31,11]),function(Q,e,_,P,T,I,D,k,y,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class C{constructor(b,p,u){this.query=b,this.provider=p,this.fileUtils=u,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(b,p){const u=this.query.folderQueries||[],c=new T.CancellationTokenSource;return p.onCancellationRequested(()=>c.cancel()),new Promise((t,n)=>{this.collector=new m(b);let o=!1;const r=(l,a)=>{if(!o&&!this.isLimitHit){const g=this.resultSize(l);d(l)&&typeof this.query.maxResults=="number"&&this.resultCount+g>this.query.maxResults&&(this.isLimitHit=!0,o=!0,c.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const E=this.resultSize(l);this.resultCount+=E,(E>0||!d(l))&&this.collector.add(l,a)}};Promise.all(u.map((l,a)=>this.searchInFolder(l,g=>r(g,a),c.token))).then(l=>{c.dispose(),this.collector.flush();const a=l.some(g=>!!g&&!!g.limitHit);t({limitHit:this.isLimitHit||a,stats:{type:"textSearchProvider"}})},l=>{c.dispose();const a=(0,I.toErrorMessage)(l);n(new Error(a))})})}resultSize(b){return d(b)?Array.isArray(b.ranges)?b.ranges.length:1:0}trimResultToSize(b,p){const u=Array.isArray(b.ranges)?b.ranges:[b.ranges],c=Array.isArray(b.preview.matches)?b.preview.matches:[b.preview.matches];return{ranges:u.slice(0,p),preview:{matches:c.slice(0,p),text:b.preview.text},uri:b.uri}}async searchInFolder(b,p,u){const c=new i.QueryGlobTester(this.query,b),t=[],n={report:l=>{if(!!this.validateProviderResult(l)){const a=b.folder.scheme===R.Schemas.file?k.hasSiblingPromiseFn(()=>this.fileUtils.readdir(D.dirname(l.uri))):void 0,g=D.relativePath(b.folder,l.uri);g&&t.push(c.includedInQuery(g,_.basename(g),a).then(E=>{E&&p(l)}))}}},o=this.getSearchOptionsForFolder(b),r=await this.provider.provideTextSearchResults(w(this.query.contentPattern),o,n,u);return await Promise.all(t),r}validateProviderResult(b){if(d(b)){if(Array.isArray(b.ranges)){if(!Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(b.preview.matches.length!==b.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(b){const p=(0,i.resolvePatternsForProvider)(this.query.includePattern,b.includePattern),u=(0,i.resolvePatternsForProvider)(this.query.excludePattern,b.excludePattern),c={folder:y.URI.from(b.folder),excludes:u,includes:p,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,followSymlinks:!b.ignoreSymlinks,encoding:b.fileEncoding&&this.fileUtils.toCanonicalName(b.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return c.usePCRE2=this.query.usePCRE2,c}}e.TextSearchManager=C;function w(v){return{isCaseSensitive:v.isCaseSensitive||!1,isRegExp:v.isRegExp||!1,isWordMatch:v.isWordMatch||!1,isMultiline:v.isMultiline||!1,pattern:v.pattern}}class m{constructor(b){this._onResult=b,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new S(512,p=>this.sendItems(p))}add(b,p){this._currentFileMatch&&(this._currentFolderIdx!==p||!D.isEqual(this._currentUri,b.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=p,this._currentFileMatch={resource:b.uri,results:[]}),this._currentFileMatch.results.push(s(b))}pushToCollector(){const b=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,b)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(b){this._onResult(b)}}e.TextSearchResultsCollector=m;function s(v){return d(v)?{preview:{matches:(0,P.mapArrayOrNot)(v.preview.matches,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character})),text:v.preview.text},ranges:(0,P.mapArrayOrNot)(v.ranges,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character}))}:{text:v.text,lineNumber:v.lineNumber}}function d(v){return!!v.preview}e.extensionResultIsMatch=d;class S{constructor(b,p){this.maxBatchSize=b,this.cb=p,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(b,p){!b||this.addItemToBatch(b,p)}addItems(b,p){!b||this.addItemsToBatch(b,p)}addItemToBatch(b,p){this.batch.push(b),this.batchSize+=p,this.onUpdate()}addItemsToBatch(b,p){this.batch=this.batch.concat(b),this.batchSize+=p,this.onUpdate()}onUpdate(){this.totalNumberCompleted<S.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},S.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=S,S.TIMEOUT=4e3,S.START_BATCH_AFTER_COUNT=50}),define(ge[67],pe([0,1,6,5,4,267,13,61,12,2,127]),function(Q,e,_,P,T,I,D,k,y,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,T.createDecorator)("IExtHostSearch");let C=class{constructor(d,S,v){this.extHostRpc=d,this._uriTransformer=S,this._logService=v,this._proxy=this.extHostRpc.getProxy(P.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new I.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,S){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const v=this._handlePool++;return this._textSearchProvider.set(v,S),this._proxy.$registerTextSearchProvider(v,this._transformScheme(d)),(0,_.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}registerFileSearchProvider(d,S){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const v=this._handlePool++;return this._fileSearchProvider.set(v,S),this._proxy.$registerFileSearchProvider(v,this._transformScheme(d)),(0,_.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}$provideFileSearchResults(d,S,v,b){const p=w(v),u=this._fileSearchProvider.get(d);if(u)return this._fileSearchManager.fileSearch(p,u,c=>{this._proxy.$handleFileMatch(d,S,c.map(t=>t.resource))},b);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,S,v,b){const p=this._textSearchProvider.get(d);if(!p||!p.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const u=w(v);return this.createTextSearchManager(u,p).search(t=>this._proxy.$handleTextMatch(d,S,t),b)}createTextSearchManager(d,S){return new R.TextSearchManager(d,S,{readdir:v=>Promise.resolve([]),toCanonicalName:v=>v})}};C=je([xe(0,D.IExtHostRpcService),xe(1,k.IURITransformerService),xe(2,y.ILogService)],C),e.ExtHostSearch=C;function w(s){return Object.assign(Object.assign({},s),{folderQueries:s.folderQueries&&s.folderQueries.map(m),extraFileResources:s.extraFileResources&&s.extraFileResources.map(d=>i.URI.revive(d))})}e.reviveQuery=w;function m(s){return Object.assign(Object.assign({},s),{folder:i.URI.revive(s.folder)})}}),define(ge[268],pe([0,1,158,21,18,3,56,2,150,105,140,76,45,5,230,229,51,231,35,232,233,234,215,235,39,42,236,216,238,239,240,63,219,243,244,245,89,34,246,220,20,7,249,64,125,32,41,53,200,237,115,124,65,46,67,12,61,13,27,241,198,50,62,227,247,197,90,88,252,250,251,228,60,259,248,87,194,117,242]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d,S,v,b,p,u,c,t,n,o,r,l,a,g,E,f,h,A,L,B,ee,j,x,$,F,U,M,N,O,V,q,J,me,we,Ae,Pe,Fe,z,Y,te,ae,fe,De,Me,be,ke,Re,Be,Ee,Ke,X,re,_e,Ne,Ve,$e,Ze,K,oe,he,Z,ie,le,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ye(We){const Oe=We.get(Me.IExtHostInitDataService),qe=We.get(K.IExtHostFileSystemInfo),Ye=We.get(_e.IExtHostConsumerFileSystem),tt=We.get(r.IExtHostExtensionService),nt=We.get(q.IExtHostWorkspace),rt=We.get(le.IExtHostTelemetry),it=We.get(b.IExtHostConfiguration),gt=We.get(fe.IURITransformerService),ue=We.get(De.IExtHostRpcService),Ce=We.get(j.IExtHostStorage),ce=We.get(re.IExtensionStoragePaths),G=We.get(ae.ILogService),Ue=We.get(Re.IExtHostTunnelService),Te=We.get(Be.IExtHostApiDeprecationService),Xe=We.get(V.IExtHostWindow),Ge=We.get(Z.IExtHostSecretState);ue.set(m.ExtHostContext.ExtHostFileSystemInfo,qe),ue.set(m.ExtHostContext.ExtHostLogService,G),ue.set(m.ExtHostContext.ExtHostWorkspace,nt),ue.set(m.ExtHostContext.ExtHostConfiguration,it),ue.set(m.ExtHostContext.ExtHostExtensionService,tt),ue.set(m.ExtHostContext.ExtHostStorage,Ce),ue.set(m.ExtHostContext.ExtHostTunnelService,Ue),ue.set(m.ExtHostContext.ExtHostWindow,Xe),ue.set(m.ExtHostContext.ExtHostSecretState,Ge),ue.set(m.ExtHostContext.ExtHostTelemetry,rt);const lt=ue.set(m.ExtHostContext.ExtHostDecorations,We.get(Fe.IExtHostDecorations)),at=ue.set(m.ExtHostContext.ExtHostDocumentsAndEditors,We.get(o.IExtHostDocumentsAndEditors)),Qe=ue.set(m.ExtHostContext.ExtHostCommands,We.get(S.IExtHostCommands)),st=ue.set(m.ExtHostContext.ExtHostTerminalService,We.get(x.IExtHostTerminalService)),ut=ue.set(m.ExtHostContext.ExtHostDebugService,We.get(Y.IExtHostDebugService)),pt=ue.set(m.ExtHostContext.ExtHostSearch,We.get(te.IExtHostSearch)),vt=ue.set(m.ExtHostContext.ExtHostTask,We.get(z.IExtHostTask)),wt=ue.set(m.ExtHostContext.ExtHostOutputService,We.get(h.IExtHostOutputService)),Et=ue.set(m.ExtHostContext.ExtHostEditorTabs,new ie.ExtHostEditorTabs),yt=ue.set(m.ExtHostContext.ExtHostUrls,new N.ExtHostUrls(ue)),_t=ue.set(m.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(ue,at)),Ot=ue.set(m.ExtHostContext.ExtHostDocumentContentProviders,new c.ExtHostDocumentContentProvider(ue,at,G)),Rt=ue.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(G,_t,ue.getProxy(m.MainContext.MainThreadBulkEdits))),ft=ue.set(m.ExtHostContext.ExtHostNotebook,new be.ExtHostNotebookController(ue,Qe,at,_t,Oe.environment,G,ce)),qt=ue.set(m.ExtHostContext.ExtHostNotebookKernels,new ve.ExtHostNotebookKernels(ue,ft)),St=ue.set(m.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(ue,at)),zt=ue.set(m.ExtHostContext.ExtHostTreeViews,new F.ExtHostTreeViews(ue.getProxy(m.MainContext.MainThreadTreeViews),Qe,G)),Kt=ue.set(m.ExtHostContext.ExtHostEditorInsets,new we.ExtHostEditorInsets(ue.getProxy(m.MainContext.MainThreadEditorInsets),St,Oe.environment)),Nt=ue.set(m.ExtHostContext.ExtHostDiagnostics,new p.ExtHostDiagnostics(ue,G)),dt=ue.set(m.ExtHostContext.ExtHostLanguageFeatures,new g.ExtHostLanguageFeatures(ue,gt,_t,Qe,Nt,G,Te)),gn=ue.set(m.ExtHostContext.ExtHostFileSystem,new l.ExtHostFileSystem(ue,dt)),Pt=ue.set(m.ExtHostContext.ExtHostFileSystemEventService,new a.ExtHostFileSystemEventService(ue,G,at)),Lt=ue.set(m.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(ue,nt,Qe)),sn=ue.set(m.ExtHostContext.ExtHostSCM,new B.ExtHostSCM(ue,Qe,G)),pn=ue.set(m.ExtHostContext.ExtHostComments,new v.ExtHostComments(ue,Qe,_t)),on=ue.set(m.ExtHostContext.ExtHostProgress,new A.ExtHostProgress(ue.getProxy(m.MainContext.MainThreadProgress))),vn=ue.set(m.ExtHostContext.ExtHosLabelService,new Ae.ExtHostLabelService(ue)),an=ue.set(m.ExtHostContext.ExtHostTheming,new ke.ExtHostTheming(ue)),At=ue.set(m.ExtHostContext.ExtHostAuthentication,new Ee.ExtHostAuthentication(ue)),Gt=ue.set(m.ExtHostContext.ExtHostTimeline,new Ke.ExtHostTimeline(ue,Qe)),Qt=ue.set(m.ExtHostContext.ExtHostWebviews,new O.ExtHostWebviews(ue,Oe.environment,nt,G,Te)),Xt=ue.set(m.ExtHostContext.ExtHostWebviewPanels,new $e.ExtHostWebviewPanels(ue,Qt,nt)),wn=ue.set(m.ExtHostContext.ExtHostCustomEditors,new Ve.ExtHostCustomEditors(ue,_t,ce,Qt,Xt)),bn=ue.set(m.ExtHostContext.ExtHostWebviewViews,new Ne.ExtHostWebviewViews(ue,Qt)),Ct=ue.set(m.ExtHostContext.ExtHostTesting,new oe.ExtHostTesting(ue,at,nt)),_n=ue.set(m.ExtHostContext.ExtHostUriOpeners,new he.ExtHostUriOpeners(ue)),En=(0,me.values)(m.ExtHostContext);ue.assertRegistered(En);const Jt=new Ze.ExtHostBulkEdits(ue,at),Sn=new d.ExtHostClipboard(ue),Ut=new f.ExtHostMessageService(ue,G),Vt=new u.ExtHostDialogs(ue),xt=new ee.ExtHostStatusBar(ue,Qe.converter),Yt=new E.ExtHostLanguages(ue,_t);return s.ExtHostApiCommands.register(Qe),function(Le,Bt,Zt){const mt=function(){let ne=!Le.isUnderDevelopment;function de(Ie){ne||(G.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Ie(ct){if(Array.isArray(ct))ct.forEach(Ie);else if(typeof ct=="string")de(ct);else{const H=ct;typeof H.scheme=="undefined"&&de(ct),!Le.enableProposedApi&&typeof H.exclusive=="boolean"&&(0,J.throwProposedApiError)(Le)}return ct}}(),yn={getSession(ne,de,Ie){return At.getSession(Le,ne,de,Ie)},get onDidChangeSessions(){return At.onDidChangeSessions},registerAuthenticationProvider(ne,de,Ie,ct){return At.registerAuthenticationProvider(ne,de,Ie,ct)},get onDidChangeAuthenticationProviders(){return(0,J.checkProposedApiEnabled)(Le),At.onDidChangeAuthenticationProviders},get providers(){return(0,J.checkProposedApiEnabled)(Le),At.providers},logout(ne,de){return(0,J.checkProposedApiEnabled)(Le),At.removeSession(ne,de)}},Dn={registerCommand(ne,de,Ie){return Qe.registerCommand(!0,ne,de,Ie)},registerTextEditorCommand(ne,de,Ie){return Qe.registerCommand(!0,ne,(...ct)=>{const H=St.getActiveTextEditor();if(!H){G.warn("Cannot execute "+ne+" because there is no active text editor.");return}return H.edit(W=>{de.apply(Ie,[H,W,...ct])}).then(W=>{W||G.warn("Edits from command "+ne+" were not applied.")},W=>{G.warn("An error occurred while running command "+ne,W)})})},registerDiffInformationCommand:(ne,de,Ie)=>((0,J.checkProposedApiEnabled)(Le),Qe.registerCommand(!0,ne,async(...ct)=>{const H=at.activeEditor(!0);if(!H){G.warn("Cannot execute "+ne+" because there is no active text editor.");return}const W=await St.getDiffInformation(H.id);de.apply(Ie,[W,...ct])})),executeCommand(ne,...de){return Qe.executeCommand(ne,...de)},getCommands(ne=!1){return Qe.getCommands(ne)}},ln={get machineId(){return Oe.telemetryInfo.machineId},get sessionId(){return Oe.telemetryInfo.sessionId},get language(){return Oe.environment.appLanguage},get appName(){return Oe.environment.appName},get appRoot(){var ne,de;return(de=(ne=Oe.environment.appRoot)===null||ne===void 0?void 0:ne.fsPath)!==null&&de!==void 0?de:""},get uriScheme(){return Oe.environment.appUriScheme},get clipboard(){return Sn.value},get shell(){return st.getDefaultShell(!1,Zt)},get isTelemetryEnabled(){return rt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return rt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ne=Date.now()-new Date(Oe.telemetryInfo.firstSessionDate).getTime();return isNaN(ne)?!1:ne<1e3*60*60*24},openExternal(ne,de){return Xe.openUri(ne,{allowTunneling:!!Oe.remote.authority,allowContributedOpeners:de==null?void 0:de.allowContributedOpeners})},asExternalUri(ne){return ne.scheme===Oe.environment.appUriScheme?yt.createAppUri(ne):Xe.asExternalUri(ne,{allowTunneling:!!Oe.remote.authority})},get remoteName(){return(0,Pe.getRemoteName)(Oe.remote.authority)},get uiKind(){return Oe.uiKind}};Oe.environment.extensionTestsLocationURI||Object.freeze(ln);const cn=Oe.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,en={registerTestProvider(ne){return(0,J.checkProposedApiEnabled)(Le),Ct.registerTestProvider(ne)},createDocumentTestObserver(ne){return(0,J.checkProposedApiEnabled)(Le),Ct.createTextDocumentTestObserver(ne)},createWorkspaceTestObserver(ne){return(0,J.checkProposedApiEnabled)(Le),Ct.createWorkspaceTestObserver(ne)},runTests(ne){return(0,J.checkProposedApiEnabled)(Le),Ct.runTests(ne)},publishTestResult(ne,de=!0){return(0,J.checkProposedApiEnabled)(Le),Ct.publishExtensionProvidedResults(ne,de)},get onDidChangeTestResults(){return(0,J.checkProposedApiEnabled)(Le),Ct.onResultsChanged},get testResults(){return(0,J.checkProposedApiEnabled)(Le),Ct.results}},Cn={getExtension(ne){const de=Bt.getExtensionDescription(ne);if(de)return new r.Extension(tt,Le.identifier,de,cn)},get all(){return Bt.getAllExtensionDescriptions().map(ne=>new r.Extension(tt,Le.identifier,ne,cn))},get onDidChange(){return Bt.onDidChange}},kn={createDiagnosticCollection(ne){return Nt.createDiagnosticCollection(Le.identifier,ne)},get onDidChangeDiagnostics(){return Nt.onDidChangeDiagnostics},getDiagnostics:ne=>Nt.getDiagnostics(ne),getLanguages(){return Yt.getLanguages()},setTextDocumentLanguage(ne,de){return Yt.changeLanguage(ne.uri,de)},match(ne,de){return(0,C.score)(U.LanguageSelector.from(ne),de.uri,de.languageId,!0)},registerCodeActionsProvider(ne,de,Ie){return dt.registerCodeActionProvider(Le,mt(ne),de,Ie)},registerCodeLensProvider(ne,de){return dt.registerCodeLensProvider(Le,mt(ne),de)},registerDefinitionProvider(ne,de){return dt.registerDefinitionProvider(Le,mt(ne),de)},registerDeclarationProvider(ne,de){return dt.registerDeclarationProvider(Le,mt(ne),de)},registerImplementationProvider(ne,de){return dt.registerImplementationProvider(Le,mt(ne),de)},registerTypeDefinitionProvider(ne,de){return dt.registerTypeDefinitionProvider(Le,mt(ne),de)},registerHoverProvider(ne,de){return dt.registerHoverProvider(Le,mt(ne),de,Le.identifier)},registerEvaluatableExpressionProvider(ne,de){return dt.registerEvaluatableExpressionProvider(Le,mt(ne),de,Le.identifier)},registerInlineValuesProvider(ne,de){return dt.registerInlineValuesProvider(Le,mt(ne),de,Le.identifier)},registerDocumentHighlightProvider(ne,de){return dt.registerDocumentHighlightProvider(Le,mt(ne),de)},registerLinkedEditingRangeProvider(ne,de){return dt.registerLinkedEditingRangeProvider(Le,mt(ne),de)},registerReferenceProvider(ne,de){return dt.registerReferenceProvider(Le,mt(ne),de)},registerRenameProvider(ne,de){return dt.registerRenameProvider(Le,mt(ne),de)},registerDocumentSymbolProvider(ne,de,Ie){return dt.registerDocumentSymbolProvider(Le,mt(ne),de,Ie)},registerWorkspaceSymbolProvider(ne){return dt.registerWorkspaceSymbolProvider(Le,ne)},registerDocumentFormattingEditProvider(ne,de){return dt.registerDocumentFormattingEditProvider(Le,mt(ne),de)},registerDocumentRangeFormattingEditProvider(ne,de){return dt.registerDocumentRangeFormattingEditProvider(Le,mt(ne),de)},registerOnTypeFormattingEditProvider(ne,de,Ie,...ct){return dt.registerOnTypeFormattingEditProvider(Le,mt(ne),de,[Ie].concat(ct))},registerDocumentSemanticTokensProvider(ne,de,Ie){return dt.registerDocumentSemanticTokensProvider(Le,mt(ne),de,Ie)},registerDocumentRangeSemanticTokensProvider(ne,de,Ie){return dt.registerDocumentRangeSemanticTokensProvider(Le,mt(ne),de,Ie)},registerSignatureHelpProvider(ne,de,Ie,...ct){return typeof Ie=="object"?dt.registerSignatureHelpProvider(Le,mt(ne),de,Ie):dt.registerSignatureHelpProvider(Le,mt(ne),de,typeof Ie=="undefined"?[]:[Ie,...ct])},registerCompletionItemProvider(ne,de,...Ie){return dt.registerCompletionItemProvider(Le,mt(ne),de,Ie)},registerDocumentLinkProvider(ne,de){return dt.registerDocumentLinkProvider(Le,mt(ne),de)},registerColorProvider(ne,de){return dt.registerColorProvider(Le,mt(ne),de)},registerFoldingRangeProvider(ne,de){return dt.registerFoldingRangeProvider(Le,mt(ne),de)},registerSelectionRangeProvider(ne,de){return dt.registerSelectionRangeProvider(Le,ne,de)},registerCallHierarchyProvider(ne,de){return dt.registerCallHierarchyProvider(Le,ne,de)},setLanguageConfiguration:(ne,de)=>dt.setLanguageConfiguration(Le,ne,de),getTokenInformationAtPosition(ne,de){return(0,J.checkProposedApiEnabled)(Le),Yt.tokenAtPosition(ne,de)},registerInlineHintsProvider(ne,de){return(0,J.checkProposedApiEnabled)(Le),dt.registerInlineHintsProvider(Le,ne,de)}},Pn={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return st.activeTerminal},get terminals(){return st.terminals},async showTextDocument(ne,de,Ie){const ct=await(k.URI.isUri(ne)?Promise.resolve(un.openTextDocument(ne)):Promise.resolve(ne));return St.showTextDocument(ct,de,Ie)},createTextEditorDecorationType(ne){return St.createTextEditorDecorationType(ne)},onDidChangeActiveTextEditor(ne,de,Ie){return St.onDidChangeActiveTextEditor(ne,de,Ie)},onDidChangeVisibleTextEditors(ne,de,Ie){return St.onDidChangeVisibleTextEditors(ne,de,Ie)},onDidChangeTextEditorSelection(ne,de,Ie){return St.onDidChangeTextEditorSelection(ne,de,Ie)},onDidChangeTextEditorOptions(ne,de,Ie){return St.onDidChangeTextEditorOptions(ne,de,Ie)},onDidChangeTextEditorVisibleRanges(ne,de,Ie){return St.onDidChangeTextEditorVisibleRanges(ne,de,Ie)},onDidChangeTextEditorViewColumn(ne,de,Ie){return St.onDidChangeTextEditorViewColumn(ne,de,Ie)},onDidCloseTerminal(ne,de,Ie){return st.onDidCloseTerminal(ne,de,Ie)},onDidOpenTerminal(ne,de,Ie){return st.onDidOpenTerminal(ne,de,Ie)},onDidChangeActiveTerminal(ne,de,Ie){return st.onDidChangeActiveTerminal(ne,de,Ie)},onDidChangeTerminalDimensions(ne,de,Ie){return(0,J.checkProposedApiEnabled)(Le),st.onDidChangeTerminalDimensions(ne,de,Ie)},onDidWriteTerminalData(ne,de,Ie){return(0,J.checkProposedApiEnabled)(Le),st.onDidWriteTerminalData(ne,de,Ie)},get state(){return Xe.state},onDidChangeWindowState(ne,de,Ie){return Xe.onDidChangeWindowState(ne,de,Ie)},showInformationMessage(ne,...de){return Ut.showMessage(Le,D.default.Info,ne,de[0],de.slice(1))},showWarningMessage(ne,...de){return Ut.showMessage(Le,D.default.Warning,ne,de[0],de.slice(1))},showErrorMessage(ne,...de){return Ut.showMessage(Le,D.default.Error,ne,de[0],de.slice(1))},showQuickPick(ne,de,Ie){return Lt.showQuickPick(ne,!!Le.enableProposedApi,de,Ie)},showWorkspaceFolderPick(ne){return Lt.showWorkspaceFolderPick(ne)},showInputBox(ne,de){return Lt.showInput(ne,de)},showOpenDialog(ne){return Vt.showOpenDialog(ne)},showSaveDialog(ne){return Vt.showSaveDialog(ne)},createStatusBarItem(ne,de){let Ie,ct,H,W;return ne&&typeof ne!="number"?(Ie=ne.id,ct=ne.name,H=ne.alignment,de=ne.priority,W=ne.accessibilityInformation):(Ie=Le.identifier.value,ct=_.localize(0,null,Le.displayName||Le.name),H=ne),xt.createStatusBarEntry(Ie,ct,H,de,W)},setStatusBarMessage(ne,de){return xt.setStatusBarMessage(ne,de)},withScmProgress(ne){return Te.report("window.withScmProgress",Le,"Use 'withProgress' instead."),on.withProgress(Le,{location:M.ProgressLocation.SourceControl},(de,Ie)=>ne({report(ct){}}))},withProgress(ne,de){return on.withProgress(Le,ne,de)},createOutputChannel(ne){return wt.createOutputChannel(ne)},createWebviewPanel(ne,de,Ie,ct){return Xt.createWebviewPanel(Le,ne,de,Ie,ct)},createWebviewTextEditorInset(ne,de,Ie,ct){return(0,J.checkProposedApiEnabled)(Le),Kt.createWebviewEditorInset(ne,de,Ie,ct,Le)},createTerminal(ne,de,Ie){return typeof ne=="object"?"pty"in ne?st.createExtensionTerminal(ne):(ne.message&&(0,J.checkProposedApiEnabled)(Le),ne.icon&&(0,J.checkProposedApiEnabled)(Le),st.createTerminalFromOptions(ne)):st.createTerminal(ne,de,Ie)},registerTerminalLinkProvider(ne){return st.registerLinkProvider(ne)},registerTreeDataProvider(ne,de){return zt.registerTreeDataProvider(ne,de,Le)},createTreeView(ne,de){return zt.createTreeView(ne,de,Le)},registerWebviewPanelSerializer:(ne,de)=>Xt.registerWebviewPanelSerializer(Le,ne,de),registerCustomEditorProvider:(ne,de,Ie={})=>wn.registerCustomEditorProvider(Le,ne,de,Ie),registerFileDecorationProvider(ne){return lt.registerFileDecorationProvider(ne,Le.identifier)},registerUriHandler(ne){return yt.registerUriHandler(Le.identifier,ne)},createQuickPick(){return Lt.createQuickPick(Le.identifier,!!Le.enableProposedApi)},createInputBox(){return Lt.createInputBox(Le.identifier)},get activeColorTheme(){return an.activeColorTheme},onDidChangeActiveColorTheme(ne,de,Ie){return an.onDidChangeActiveColorTheme(ne,de,Ie)},registerWebviewViewProvider(ne,de,Ie){return bn.registerWebviewViewProvider(Le,ne,de,Ie==null?void 0:Ie.webviewOptions)},get activeNotebookEditor(){return(0,J.checkProposedApiEnabled)(Le),ft.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,de,Ie){return(0,J.checkProposedApiEnabled)(Le),ft.onDidChangeActiveNotebookEditor(ne,de,Ie)},get visibleNotebookEditors(){return(0,J.checkProposedApiEnabled)(Le),ft.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,J.checkProposedApiEnabled)(Le),ft.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,de,Ie){return(0,J.checkProposedApiEnabled)(Le),ft.onDidChangeNotebookEditorSelection(ne,de,Ie)},onDidChangeNotebookEditorVisibleRanges(ne,de,Ie){return(0,J.checkProposedApiEnabled)(Le),ft.onDidChangeNotebookEditorVisibleRanges(ne,de,Ie)},showNotebookDocument(ne,de){return(0,J.checkProposedApiEnabled)(Le),ft.showNotebookDocument(ne,de)},registerExternalUriOpener(ne,de,Ie){return(0,J.checkProposedApiEnabled)(Le),_n.registerExternalUriOpener(Le.identifier,ne,de,Ie)},get openEditors(){return(0,J.checkProposedApiEnabled)(Le),Et.tabs},get onDidChangeOpenEditors(){return(0,J.checkProposedApiEnabled)(Le),Et.onDidChangeTabs}},un={get rootPath(){return Te.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),nt.getPath()},set rootPath(ne){throw T.readonly()},getWorkspaceFolder(ne){return nt.getWorkspaceFolder(ne)},get workspaceFolders(){return nt.getWorkspaceFolders()},get name(){return nt.name},set name(ne){throw T.readonly()},get workspaceFile(){return nt.workspaceFile},set workspaceFile(ne){throw T.readonly()},updateWorkspaceFolders:(ne,de,...Ie)=>nt.updateWorkspaceFolders(Le,ne,de||0,...Ie),onDidChangeWorkspaceFolders:function(ne,de,Ie){return nt.onDidChangeWorkspace(ne,de,Ie)},asRelativePath:(ne,de)=>nt.getRelativePath(ne,de),findFiles:(ne,de,Ie,ct)=>nt.findFiles(U.GlobPattern.from(ne),U.GlobPattern.from(de),Ie,Le.identifier,ct),findTextInFiles:(ne,de,Ie,ct)=>{let H,W;return typeof de=="object"?(H=de,W=Ie):(H={},W=de,ct=Ie),nt.findTextInFiles(ne,H||{},W,Le.identifier,ct)},saveAll:ne=>nt.saveAll(ne),applyEdit(ne){return Jt.applyWorkspaceEdit(ne)},createFileSystemWatcher:(ne,de,Ie,ct)=>Pt.createFileSystemWatcher(U.GlobPattern.from(ne),de,Ie,ct),get textDocuments(){return _t.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw T.readonly()},openTextDocument(ne){let de;const Ie=ne;if(typeof ne=="string")de=Promise.resolve(k.URI.file(ne));else if(k.URI.isUri(ne))de=Promise.resolve(ne);else if(!Ie||typeof Ie=="object")de=_t.createDocumentData(Ie);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(ct=>_t.ensureDocumentData(ct).then(H=>H.document))},onDidOpenTextDocument:(ne,de,Ie)=>_t.onDidAddDocument(ne,de,Ie),onDidCloseTextDocument:(ne,de,Ie)=>_t.onDidRemoveDocument(ne,de,Ie),onDidChangeTextDocument:(ne,de,Ie)=>_t.onDidChangeDocument(ne,de,Ie),onDidSaveTextDocument:(ne,de,Ie)=>_t.onDidSaveDocument(ne,de,Ie),onWillSaveTextDocument:(ne,de,Ie)=>Rt.getOnWillSaveTextDocumentEvent(Le)(ne,de,Ie),onDidChangeConfiguration:(ne,de,Ie)=>Zt.onDidChangeConfiguration(ne,de,Ie),getConfiguration(ne,de){return de=arguments.length===1?void 0:de,Zt.getConfiguration(ne,de,Le)},registerTextDocumentContentProvider(ne,de){return Ot.registerTextDocumentContentProvider(ne,de)},registerTaskProvider:(ne,de)=>(Te.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Le,ne,de)),registerFileSystemProvider(ne,de,Ie){return gn.registerFileSystemProvider(Le.identifier,ne,de,Ie)},get fs(){return Ye.value},registerFileSearchProvider:(ne,de)=>((0,J.checkProposedApiEnabled)(Le),pt.registerFileSearchProvider(ne,de)),registerTextSearchProvider:(ne,de)=>((0,J.checkProposedApiEnabled)(Le),pt.registerTextSearchProvider(ne,de)),registerRemoteAuthorityResolver:(ne,de)=>((0,J.checkProposedApiEnabled)(Le),tt.registerRemoteAuthorityResolver(ne,de)),registerResourceLabelFormatter:ne=>((0,J.checkProposedApiEnabled)(Le),vn.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,de,Ie)=>Pt.onDidCreateFile(ne,de,Ie),onDidDeleteFiles:(ne,de,Ie)=>Pt.onDidDeleteFile(ne,de,Ie),onDidRenameFiles:(ne,de,Ie)=>Pt.onDidRenameFile(ne,de,Ie),onWillCreateFiles:(ne,de,Ie)=>Pt.getOnWillCreateFileEvent(Le)(ne,de,Ie),onWillDeleteFiles:(ne,de,Ie)=>Pt.getOnWillDeleteFileEvent(Le)(ne,de,Ie),onWillRenameFiles:(ne,de,Ie)=>Pt.getOnWillRenameFileEvent(Le)(ne,de,Ie),openTunnel:ne=>((0,J.checkProposedApiEnabled)(Le),Ue.openTunnel(Le,ne).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,J.checkProposedApiEnabled)(Le),Ue.getTunnels()},onDidChangeTunnels:(ne,de,Ie)=>((0,J.checkProposedApiEnabled)(Le),Ue.onDidChangeTunnels(ne,de,Ie)),registerPortAttributesProvider:(ne,de)=>((0,J.checkProposedApiEnabled)(Le),Ue.registerPortsAttributesProvider(ne,de)),registerTimelineProvider:(ne,de)=>((0,J.checkProposedApiEnabled)(Le),Gt.registerTimelineProvider(ne,de,Le.identifier,Qe.converter)),get isTrusted(){return(0,J.checkProposedApiEnabled)(Le),nt.trusted},requestWorkspaceTrust:ne=>((0,J.checkProposedApiEnabled)(Le),nt.requestWorkspaceTrust(ne)),onDidReceiveWorkspaceTrust:(ne,de,Ie)=>nt.onDidReceiveWorkspaceTrust(ne,de,Ie)},In={get inputBox(){return Te.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),sn.getLastInputBox(Le)},createSourceControl(ne,de,Ie){return sn.createSourceControl(Le,ne,de,Ie)}},dn={createCommentController(ne,de){return pn.createCommentController(Le,ne,de)}},jt={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},onDidStartDebugSession(ne,de,Ie){return ut.onDidStartDebugSession(ne,de,Ie)},onDidTerminateDebugSession(ne,de,Ie){return ut.onDidTerminateDebugSession(ne,de,Ie)},onDidChangeActiveDebugSession(ne,de,Ie){return ut.onDidChangeActiveDebugSession(ne,de,Ie)},onDidReceiveDebugSessionCustomEvent(ne,de,Ie){return ut.onDidReceiveDebugSessionCustomEvent(ne,de,Ie)},onDidChangeBreakpoints(ne,de,Ie){return ut.onDidChangeBreakpoints(ne,de,Ie)},registerDebugConfigurationProvider(ne,de,Ie){return ut.registerDebugConfigurationProvider(ne,de,Ie||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,de){return ut.registerDebugAdapterDescriptorFactory(Le,ne,de)},registerDebugAdapterTrackerFactory(ne,de){return ut.registerDebugAdapterTrackerFactory(ne,de)},startDebugging(ne,de,Ie){return!Ie||typeof Ie=="object"&&"configuration"in Ie?ut.startDebugging(ne,de,{parentSession:Ie}):ut.startDebugging(ne,de,Ie||{})},stopDebugging(ne){return ut.stopDebugging(ne)},addBreakpoints(ne){return ut.addBreakpoints(ne)},removeBreakpoints(ne){return ut.removeBreakpoints(ne)},asDebugSourceUri(ne,de){return ut.asDebugSourceUri(ne,de)}},hn={registerTaskProvider:(ne,de)=>vt.registerTaskProvider(Le,ne,de),fetchTasks:ne=>vt.fetchTasks(ne),executeTask:ne=>vt.executeTask(Le,ne),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(ne,de,Ie)=>vt.onDidStartTask(ne,de,Ie),onDidEndTask:(ne,de,Ie)=>vt.onDidEndTask(ne,de,Ie),onDidStartTaskProcess:(ne,de,Ie)=>vt.onDidStartTaskProcess(ne,de,Ie),onDidEndTaskProcess:(ne,de,Ie)=>vt.onDidEndTaskProcess(ne,de,Ie)},An={openNotebookDocument:ne=>((0,J.checkProposedApiEnabled)(Le),ft.openNotebookDocument(ne)),get onDidOpenNotebookDocument(){return(0,J.checkProposedApiEnabled)(Le),ft.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,J.checkProposedApiEnabled)(Le),ft.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,J.checkProposedApiEnabled)(Le),ft.onDidSaveNotebookDocument},get notebookDocuments(){return(0,J.checkProposedApiEnabled)(Le),ft.notebookDocuments.map(ne=>ne.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,J.checkProposedApiEnabled)(Le),ft.onDidChangeActiveNotebookKernel},registerNotebookSerializer(ne,de,Ie){return(0,J.checkProposedApiEnabled)(Le),ft.registerNotebookSerializer(Le,ne,de,Ie)},registerNotebookContentProvider:(ne,de,Ie)=>((0,J.checkProposedApiEnabled)(Le),ft.registerNotebookContentProvider(Le,ne,de,Ie)),registerNotebookKernelProvider:(ne,de)=>((0,J.checkProposedApiEnabled)(Le),ft.registerNotebookKernelProvider(Le,ne,de)),registerNotebookCellStatusBarItemProvider:(ne,de)=>((0,J.checkProposedApiEnabled)(Le),ft.registerNotebookCellStatusBarItemProvider(Le,ne,de)),createNotebookEditorDecorationType(ne){return(0,J.checkProposedApiEnabled)(Le),ft.createNotebookEditorDecorationType(ne)},onDidChangeNotebookDocumentMetadata(ne,de,Ie){return(0,J.checkProposedApiEnabled)(Le),ft.onDidChangeNotebookDocumentMetadata(ne,de,Ie)},onDidChangeNotebookCells(ne,de,Ie){return(0,J.checkProposedApiEnabled)(Le),ft.onDidChangeNotebookCells(ne,de,Ie)},onDidChangeCellExecutionState(ne,de,Ie){return(0,J.checkProposedApiEnabled)(Le),ft.onDidChangeNotebookCellExecutionState(ne,de,Ie)},onDidChangeCellOutputs(ne,de,Ie){return(0,J.checkProposedApiEnabled)(Le),ft.onDidChangeCellOutputs(ne,de,Ie)},onDidChangeCellMetadata(ne,de,Ie){return(0,J.checkProposedApiEnabled)(Le),ft.onDidChangeCellMetadata(ne,de,Ie)},createConcatTextDocument(ne,de){return(0,J.checkProposedApiEnabled)(Le),new X.ExtHostNotebookConcatDocument(ft,_t,ne,de)},createNotebookCellExecutionTask(ne,de,Ie){return(0,J.checkProposedApiEnabled)(Le),ft.createNotebookCellExecution(ne,de,Ie)},createNotebookController(ne){return(0,J.checkProposedApiEnabled)(Le),qt.createKernel(Le,ne)},createNotebookRendererCommunication(ne){return(0,J.checkProposedApiEnabled)(Le),ft.createNotebookCommunication(ne)}};return{version:Oe.version,authentication:yn,commands:Dn,comments:dn,debug:jt,env:ln,extensions:Cn,languages:kn,notebook:An,scm:In,tasks:hn,test:en,window:Pn,workspace:un,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:P.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,EventEmitter:I.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:w.FileType,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,Hover:M.Hover,IndentAction:R.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:i.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,UIKind:m.UIKind,Uri:k.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlineHint:M.InlineHint,InlineHintKind:M.InlineHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookCellRange:M.NotebookCellRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookDocumentMetadata:M.NotebookDocumentMetadata,NotebookCellMetadata:M.NotebookCellMetadata,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,NotebookCellStatusBarItem:M.NotebookCellStatusBarItem,LinkedEditingRanges:M.LinkedEditingRanges,TestItem:M.TestItem,TestResultState:M.TestResultState,TestMessage:M.TestMessage,TestMessageSeverity:M.TestMessageSeverity,WorkspaceTrustState:M.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=ye}),define(ge[269],pe([0,1,78,63,32,124,35,51,39,34,65,46,67,90,89,50,62,125,88,60,87,117]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d,S,v,b,p,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(m.IExtensionStoragePaths,m.ExtensionStoragePaths),(0,_.registerSingleton)(S.IExtHostApiDeprecationService,S.ExtHostApiDeprecationService),(0,_.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,_.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration),(0,_.registerSingleton)(b.IExtHostConsumerFileSystem,b.ExtHostConsumerFileSystem),(0,_.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,_.registerSingleton)(I.IExtHostDecorations,I.ExtHostDecorations),(0,_.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,_.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo),(0,_.registerSingleton)(P.IExtHostOutputService,P.ExtHostOutputService),(0,_.registerSingleton)(w.IExtHostSearch,w.ExtHostSearch),(0,_.registerSingleton)(s.IExtHostStorage,s.ExtHostStorage),(0,_.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,_.registerSingleton)(i.IExtHostTerminalService,i.WorkerExtHostTerminalService),(0,_.registerSingleton)(d.IExtHostTunnelService,d.ExtHostTunnelService),(0,_.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,_.registerSingleton)(T.IExtHostWorkspace,T.ExtHostWorkspace),(0,_.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,_.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry)}),define(ge[91],pe([0,1,14,12,31,126]),function(Q,e,_,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function D(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.anchorGlob=D;function k(C,w,m,s){const d=(0,_.mapArrayOrNot)(m,y),S=new T.TextSearchMatch(w,d,s),v=S.preview.matches;return{ranges:(0,_.mapArrayOrNot)(d,i),uri:C,preview:{text:S.preview.text,matches:(0,_.mapArrayOrNot)(v,i)}}}e.createTextSearchResult=k;function y(C){return new T.SearchRange(C.start.line,C.start.character,C.end.line,C.end.character)}function i(C){return new I.Range(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let R=class{constructor(w,m){this.prefix=w,this.logService=m}appendLine(w){this.logService.debug(`${this.prefix}#search`,w)}};R=je([xe(1,P.ILogService)],R),e.OutputChannel=R}),define(ge[270],pe([0,1,92,22]),function(Q,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function T(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(n=>n===t)}e.isUTFEncoding=T,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const I=512,D=512,k=512*8,y=512*128;class i{constructor(n){this.iconvLiteDecoder=n}static async create(n){let o;if(n!==e.UTF8)o=(await new Promise((l,a)=>{Q(["iconv-lite-umd"],l,a)})).getDecoder(m(n));else{const r=new TextDecoder;o={write(l){return r.decode(l,{stream:!0})},end(){return r.decode()}}}return new i(o)}write(n){return this.iconvLiteDecoder.write(n)}end(){return this.iconvLiteDecoder.end()}}function R(t,n){var o;const r=((o=n.minBytesRequiredForDetection)!==null&&o!==void 0?o:n.guessEncoding)?k:D;return new Promise((l,a)=>{const g=(0,_.newWriteableStream)(L=>L.join("")),E=[];let f=0,h;const A=async()=>{try{const L=await c({buffer:P.VSBuffer.concat(E),bytesRead:f},n.guessEncoding);L.encoding=await n.overwriteEncoding(L.encoding),h=await i.create(L.encoding);const B=h.write(P.VSBuffer.concat(E).buffer);g.write(B),E.length=0,f=0,l({stream:g,detected:L})}catch(L){a(L)}};(0,_.listenStream)(t,{onData:async L=>{h?g.write(h.write(L.buffer)):(E.push(L),f+=L.byteLength,f>=r&&(t.pause(),await A(),setTimeout(()=>t.resume())))},onError:L=>g.error(L),onEnd:async()=>{h||await A(),g.end(h==null?void 0:h.end())}})})}e.toDecodeStream=R;async function C(t,n,o){const l=(await new Promise((E,f)=>{Q(["iconv-lite-umd"],E,f)})).getEncoder(m(n),o);let a=!1,g=!1;return{read(){if(g)return null;const E=t.read();if(typeof E!="string"){if(g=!0,!a&&(o==null?void 0:o.addBOM))switch(n){case e.UTF8:case e.UTF8_with_bom:return P.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return P.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return P.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const f=l.end();return f&&f.length>0?(a=!0,P.VSBuffer.wrap(f)):null}return a=!0,P.VSBuffer.wrap(l.write(E))}}}e.toEncodeReadable=C;async function w(t){return(await new Promise((o,r)=>{Q(["iconv-lite-umd"],o,r)})).encodingExists(m(t))}e.encodingExists=w;function m(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=m;function s(t,n){if(!t||n<e.UTF16be_BOM.length)return null;const o=t.readUInt8(0),r=t.readUInt8(1);if(o===e.UTF16be_BOM[0]&&r===e.UTF16be_BOM[1])return e.UTF16be;if(o===e.UTF16le_BOM[0]&&r===e.UTF16le_BOM[1])return e.UTF16le;if(n<e.UTF8_BOM.length)return null;const l=t.readUInt8(2);return o===e.UTF8_BOM[0]&&r===e.UTF8_BOM[1]&&l===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=s;const d=["ascii","utf-16","utf-32"];async function S(t){const n=await new Promise((g,E)=>{Q(["jschardet"],g,E)}),o=t.slice(0,y),r=p(o.buffer),l=n.detect(r);if(!l||!l.encoding)return null;const a=l.encoding.toLowerCase();return 0<=d.indexOf(a)?null:b(l.encoding)}const v={ibm866:"cp866",big5:"cp950"};function b(t){const n=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return v[n]||n}function p(t){let n="";for(let o=0;o<t.length;o++)n+=String.fromCharCode(t[o]);return n}function u(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const n=t.match(/windows(\d+)/);return n?"windows-"+n[1]:t}}e.toCanonicalName=u;function c({buffer:t,bytesRead:n},o){let r=s(t,n),l=!1;if(r!==e.UTF16be&&r!==e.UTF16le&&t){let a=!0,g=!0,E=!1;for(let f=0;f<n&&f<I;f++){const h=f%2==1,A=t.readUInt8(f)===0;if(A&&(E=!0),a&&(h&&!A||!h&&A)&&(a=!1),g&&(h&&A||!h&&!A)&&(g=!1),A&&!a&&!g)break}E&&(a?r=e.UTF16le:g?r=e.UTF16be:l=!0)}return o&&!l&&!r&&t?S(t.slice(0,n)).then(a=>({seemsBinary:!1,encoding:a})):{seemsBinary:l,encoding:r}}e.detectEncodingFromBuffer=c,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ge[128],pe([0,1,270,26,127]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class I extends T.TextSearchManager{constructor(k,y,i=P){super(k,y,{readdir:R=>i.readdir(R.fsPath),toCanonicalName:R=>(0,_.toCanonicalName)(R)})}}e.NativeTextSearchManager=I}),define(ge[271],pe([0,1,272,286,287,2,288]),function(Q,e,_,P,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(C,w,m,s,d,S){const v=S.environment.useHostProxy,b=typeof v=="boolean"?v:!S.remote.isRemote,p=(0,D.createProxyResolver)({resolveProxy:c=>C.resolveProxy(c),getHttpProxySetting:()=>w.getConfiguration("http").get("proxy"),log:(c,t,...n)=>{switch(c){case D.LogLevel.Trace:s.trace(t,...n);break;case D.LogLevel.Debug:s.debug(t,...n);break;case D.LogLevel.Info:s.info(t,...n);break;case D.LogLevel.Warning:s.warn(t,...n);break;case D.LogLevel.Error:s.error(t,...n);break;case D.LogLevel.Critical:s.critical(t,...n);break;case D.LogLevel.Off:break;default:o(c,t,n);break}function o(r,l,...a){s.error("Unknown log level",r),s.error(l,...a)}},getLogLevel:()=>s.getLevel(),proxyResolveTelemetry:c=>{d.$publicLog2("resolveProxy",c)},useHostProxy:b,env:process.env}),u=y(w,p);return R(m,u)}e.connectProxyResolver=k;function y(C,w){const m={config:C.getConfiguration("http").get("proxySupport")||"off"};C.onDidChangeConfiguration(d=>{m.config=C.getConfiguration("http").get("proxySupport")||"off"});const s={config:!!C.getConfiguration("http").get("systemCertificates")};return C.onDidChangeConfiguration(d=>{s.config=!!C.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},_,(0,D.createHttpPatch)(_,w,{config:"off"},s,!0)),on:Object.assign({},_,(0,D.createHttpPatch)(_,w,{config:"on"},s,!0)),override:Object.assign({},_,(0,D.createHttpPatch)(_,w,{config:"override"},s,!0)),onRequest:Object.assign({},_,(0,D.createHttpPatch)(_,w,m,s,!0)),default:Object.assign(_,(0,D.createHttpPatch)(_,w,m,s,!1))},https:{off:Object.assign({},P,(0,D.createHttpPatch)(P,w,{config:"off"},s,!0)),on:Object.assign({},P,(0,D.createHttpPatch)(P,w,{config:"on"},s,!0)),override:Object.assign({},P,(0,D.createHttpPatch)(P,w,{config:"override"},s,!0)),onRequest:Object.assign({},P,(0,D.createHttpPatch)(P,w,m,s,!0)),default:Object.assign(P,(0,D.createHttpPatch)(P,w,m,s,!1))},tls:Object.assign(T,(0,D.createTlsPatch)(T))}}const i=new Map;function R(C,w){return C.getExtensionPathIndex().then(m=>{const s=Q.__$__nodeRequire("module"),d=s._load;s._load=function(v,b,p){if(v==="tls")return w.tls;if(v!=="http"&&v!=="https")return d.apply(this,arguments);const u=w[v],c=m.findSubstr(I.URI.file(b.filename).fsPath);let t=i.get(c);if(t||i.set(c,t={}),!t[v]){let n=u.default;c&&c.enableProposedApi&&(n=u[c.proxySupport]||u.onRequest),t[v]=Object.assign({},n)}return t[v]}})}}),define(ge[273],pe([0,1,38,8,74,30,9,10,91,274]),function(Q,e,_,P,T,I,D,k,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=i.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(p,u,c,t){const n=w(p,u,c,t),o=u.folder.fsPath;return{cmd:_.spawn(R,n.args,{cwd:o}),rgDiskPath:R,siblingClauses:n.siblingClauses,rgArgs:n,cwd:o}}e.spawnRipgrepCmd=C;function w(p,u,c,t){const n=["--files","--hidden","--case-sensitive"];s([u],c,!1).forEach(r=>{const l=(0,y.anchorGlob)(r);if(n.push("-g",l),D.isMacintosh){const a=(0,T.normalizeNFD)(l);a!==l&&n.push("-g",a)}});const o=m([u],t,void 0,!1);return o.globArgs.forEach(r=>{const l=`!${(0,y.anchorGlob)(r)}`;if(n.push("-g",l),D.isMacintosh){const a=(0,T.normalizeNFD)(l);a!==l&&n.push("-g",a)}}),u.disregardIgnoreFiles!==!1?n.push("--no-ignore"):n.push("--no-ignore-parent"),u.ignoreSymlinks||n.push("--follow"),p.exists&&n.push("--quiet"),n.push("--no-config"),u.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:o.siblingClauses}}function m(p,u,c,t=!0){const n=[];let o={};return p.forEach(r=>{const l=Object.assign({},r.excludePattern||{},u||{}),a=d(l,t?r.folder.fsPath:void 0,c);n.push(...a.globArgs),a.siblingClauses&&(o=Object.assign(o,a.siblingClauses))}),{globArgs:n,siblingClauses:o}}e.foldersToRgExcludeGlobs=m;function s(p,u,c=!0){const t=[];return p.forEach(n=>{const o=Object.assign({},u||{},n.includePattern||{}),r=d(o,c?n.folder.fsPath:void 0);t.push(...r.globArgs)}),t}e.foldersToIncludeGlobs=s;function d(p,u,c){const t=[],n={};return Object.keys(p).forEach(o=>{if(!(c&&c.has(o))&&!!o){const r=p[o];o=v(u?S(u,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof r=="boolean"&&r?(o.startsWith("\\\\")&&(o+="**"),t.push(b(o))):r&&r.when&&(n[o]=r)}}),{globArgs:t,siblingClauses:n}}function S(p,u){return P.isAbsolute(u)?u:P.join(p,u)}e.getAbsoluteGlob=S;function v(p){return p=k.rtrim(p,"\\"),k.rtrim(p,"/")}function b(p){return I.getRoot(p).toLowerCase()==="c:/"?p.replace(/^c:[/\\]/i,"/"):p}e.fixDriveC=b}),define(ge[275],pe([0,1,38,37,8,99,14,58,33,74,30,9,47,10,15,26,31,273,97]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const p=new Set;process.on("exit",()=>{p.forEach(o=>o())});class u{constructor(r){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=r,this.filePattern=r.filePattern||"",this.includePattern=r.includePattern&&y.parse(r.includePattern),this.maxResults=r.maxResults||null,this.exists=!!r.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=r.excludePattern&&y.parse(r.excludePattern),this.folderExcludePatterns=new Map,r.folderQueries.forEach(l=>{const a=Object.assign({},l.excludePattern||{},this.config.excludePattern||{}),g=l.folder.fsPath;r.folderQueries.map(E=>E.folder.fsPath).filter(E=>E!==g).forEach(E=>{(0,R.isEqualOrParent)(E,g)&&(a[T.relative(g,E)]=!0)}),this.folderExcludePatterns.set(g,new t(a,g))})}cancel(){this.isCanceled=!0}walk(r,l,a,g,E){if(this.fileWalkSW=w.StopWatch.create(!1),this.isCanceled)return E(null,this.isLimitHit);l.forEach(f=>{const h=T.basename(f.fsPath);this.globalExcludePattern&&this.globalExcludePattern(f.fsPath,h)||this.matchFile(a,{relativePath:f.fsPath,searchPath:void 0})}),this.cmdSW=w.StopWatch.create(!1),this.parallel(r,(f,h)=>{this.call(this.cmdTraversal,this,f,a,g,A=>{if(A){const L=(0,k.toErrorMessage)(A);console.error(L),this.errors.push(L),h(A,void 0)}else h(null,void 0)})},(f,h)=>{this.fileWalkSW.stop();const A=f?D.coalesce(f)[0]:null;E(A,this.isLimitHit)})}parallel(r,l,a){const g=new Array(r.length),E=new Array(r.length);let f=!1,h=0;if(r.length===0)return a(null,[]);r.forEach((A,L)=>{l(A,(B,ee)=>{if(B?(f=!0,g[L]=null,E[L]=B):(g[L]=ee,E[L]=null),++h===r.length)return a(f?E:null,g)})})}call(r,l,...a){try{r.apply(l,a)}catch(g){a[a.length-1](g)}}cmdTraversal(r,l,a,g){const E=r.folder.fsPath,f=C.isMacintosh;let h;const A=()=>h&&h.kill();p.add(A);let L=U=>{p.delete(A),L=()=>{},g(U)},B="";const ee=this.initDirectoryTree();let j;const x=(0,v.spawnRipgrepCmd)(this.config,r,this.config.includePattern,this.folderExcludePatterns.get(r.folder.fsPath).expression);h=x.cmd,j=!Object.keys(x.siblingClauses).length;const $=x.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let F=`${x.rgDiskPath} ${$}
 - cwd: ${x.cwd}`;x.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(x.rgArgs.siblingClauses)}`),a({message:F}),this.cmdResultCount=0,this.collectStdout(h,"utf8",a,(U,M,N)=>{if(U){L(U);return}if(this.isLimitHit){L();return}const V=(B+(f?i.normalizeNFC(M||""):M)).split(`
`);if(N){const q=V.length;V[q-1]=V[q-1].trim(),V[q-1]||V.pop()}else B=V.pop()||"";if(V.length&&V[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=V.length,j){for(const q of V)if(this.matchFile(l,{base:E,relativePath:q,searchPath:this.getSearchPath(r,q)}),this.isLimitHit){A();break}(N||this.isLimitHit)&&L();return}this.addDirectoryEntries(r,ee,E,V,l),N&&(this.matchDirectoryTree(ee,E,l),L())})}spawnFindCmd(r){const l=this.folderExcludePatterns.get(r.folder.fsPath),a=l.getBasenameTerms(),g=l.getPathTerms(),E=["-L","."];if(a.length||g.length){E.push("-not","(","(");for(const f of a)E.push("-name",f),E.push("-o");for(const f of g)E.push("-path",f),E.push("-o");E.pop(),E.push(")","-prune",")")}return E.push("-type","f"),_.spawn("find",E,{cwd:r.folder.fsPath})}readStdout(r,l,a){let g="";this.collectStdout(r,l,()=>{},(E,f,h)=>{if(E){a(E);return}g+=f,h&&a(null,g)})}collectStdout(r,l,a,g){let E=(A,L,B)=>{(A||B)&&(E=()=>{},this.cmdSW&&this.cmdSW.stop()),g(A,L,B)},f=!1;r.stdout?(this.forwardData(r.stdout,l,E),r.stdout.once("data",()=>f=!0)):a({message:"stdout is null"});let h;r.stderr?h=this.collectData(r.stderr):a({message:"stderr is null"}),r.on("error",A=>{E(A)}),r.on("close",A=>{let L;!f&&(L=this.decodeData(h,l))&&n(L)?E(new Error(`command failed with error code ${A}: ${this.decodeData(h,l)}`)):(this.exists&&A===0&&(this.isLimitHit=!0),E(null,"",!0))})}forwardData(r,l,a){const g=new I.StringDecoder(l);return r.on("data",E=>{a(null,g.write(E))}),g}collectData(r){const l=[];return r.on("data",a=>{l.push(a)}),l}decodeData(r,l){const a=new I.StringDecoder(l);return r.map(g=>a.write(g)).join("")}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries(r,{pathToEntries:l},a,g,E){g.indexOf(this.filePattern)!==-1&&this.matchFile(E,{base:a,relativePath:this.filePattern,searchPath:this.getSearchPath(r,this.filePattern)});const f=h=>{const A=T.basename(h),L=T.dirname(h);let B=l[L];B||(B=l[L]=[],f(L)),B.push({base:a,relativePath:h,basename:A,searchPath:this.getSearchPath(r,h)})};g.forEach(f)}matchDirectoryTree({rootEntries:r,pathToEntries:l},a,g){const E=this,f=this.folderExcludePatterns.get(a),h=this.filePattern;function A(L){E.directoriesWalked++;const B=y.hasSiblingFn(()=>L.map(ee=>ee.basename));for(let ee=0,j=L.length;ee<j;ee++){const x=L[ee],{relativePath:$,basename:F}=x;if(!f.test($,F,h!==F?B:void 0)){const U=l[$];if(U)A(U);else{if(E.filesWalked++,$===h)continue;E.matchFile(g,x)}if(E.isLimitHit)break}}}A(r)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(r,l,a,g,E){const f=r.folder,h=y.hasSiblingFn(()=>a);this.parallel(a,(A,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const B=l?[l,A].join(T.sep):A;if(this.folderExcludePatterns.get(r.folder.fsPath).test(B,A,this.config.filePattern!==A?h:void 0))return L(null);const ee=[f.fsPath,B].join(T.sep);P.lstat(ee,(j,x)=>{if(j||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(ee,x,($,F)=>$||this.isCanceled||this.isLimitHit?L(null):F.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(ee,x,(U,M)=>U||this.isCanceled||this.isLimitHit||(M=M||"",this.walkedPaths[M])?L(null):(this.walkedPaths[M]=!0,(0,d.readdir)(ee).then(N=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(r,B,N,g,O=>L(O||null))},N=>{L(null)})))):(this.filesWalked++,B===this.filePattern||this.maxFilesize&&s.isNumber(F.size)&&F.size>this.maxFilesize||this.matchFile(g,{base:f.fsPath,relativePath:B,searchPath:this.getSearchPath(r,B)}),L(null,void 0)))})},A=>{const L=A&&D.coalesce(A);return E(L&&L.length>0?L[0]:void 0)})}matchFile(r,l){this.isFileMatch(l)&&(!this.includePattern||this.includePattern(l.relativePath,T.basename(l.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||r(l))}isFileMatch(r){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,S.isFilePatternMatch)(r,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(r,l,a){return l.isSymbolicLink()?P.stat(r,a):a(null,l)}realPathIfNeeded(r,l,a){return l.isSymbolicLink()?P.realpath(r,(g,E)=>g?a(g):a(null,E)):a(null,r)}getSearchPath(r,l){return r.folderName?T.join(r.folderName,l):l}}e.FileWalker=u;class c{constructor(r){this.folderQueries=r.folderQueries,this.extraFiles=r.extraFileResources||[],this.walker=new u(r)}search(r,l,a){this.walker.walk(this.folderQueries,this.extraFiles,r,l,(g,E)=>{a(g,{limitHit:E,stats:this.walker.getStats()})})}cancel(){this.walker.cancel()}}e.Engine=c;class t{constructor(r,l){this.expression=r,this.root=l,this.init(r)}init(r){let l,a;Object.keys(r).filter(g=>r[g]).forEach(g=>{T.isAbsolute(g)?(l=l||y.getEmptyExpression(),l[g]=r[g]):(a=a||y.getEmptyExpression(),a[g]=r[g])}),this.absoluteParsedExpr=l&&y.parse(l,{trimForExclusions:!0}),this.relativeParsedExpr=a&&y.parse(a,{trimForExclusions:!0})}test(r,l,a){return this.relativeParsedExpr&&this.relativeParsedExpr(r,l,a)||this.absoluteParsedExpr&&this.absoluteParsedExpr(T.join(this.root,r),l,a)}getBasenameTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...y.getBasenameTerms(this.relativeParsedExpr)),r}getPathTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...y.getPathTerms(this.relativeParsedExpr)),r}}function n(o){const r=o.trim().split(`
`),l=r[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return m.uppercaseFirstLetter(r[r.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}e.rgErrorMsgForDisplay=n}),define(ge[129],pe([0,1,38,289,99,14,53,33,8,10,2,31,126,290,274,91]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const S=s.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class v{constructor(f){this.outputChannel=f}provideTextSearchResults(f,h,A,L){return this.outputChannel.appendLine(`provideTextSearchResults ${f.pattern}, ${JSON.stringify(Object.assign(Object.assign({},h),{folder:h.folder.toString()}))}`),new Promise((B,ee)=>{L.onCancellationRequested(()=>O());const j=n(f,h),x=h.folder.fsPath,$=j.map(we=>we.match(/^-/)?we:`'${we}'`).join(" ");this.outputChannel.appendLine(`${S} ${$}
 - cwd: ${x}`);let F=_.spawn(S,j,{cwd:x});F.on("error",we=>{console.error(we),this.outputChannel.appendLine("Error: "+(we&&we.message)),ee((0,C.serializeSearchError)(new C.SearchError(we&&we.message,C.SearchErrorCode.rgProcessError)))});let U=!1;const M=new u(h.maxResults,x,h.previewOptions);M.on("result",we=>{U=!0,q="",A.report(we)});let N=!1;const O=()=>{N=!0,F&&F.kill(),M&&M.cancel()};let V=!1;M.on("hitLimit",()=>{V=!0,O()});let q="";F.stdout.on("data",we=>{M.handleData(we),U||(q+=we)});let J=!1;F.stdout.once("data",()=>J=!0);let me="";F.stderr.on("data",we=>{const Ae=we.toString();this.outputChannel.appendLine(Ae),me+=Ae}),F.on("close",()=>{if(this.outputChannel.appendLine(J?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),q&&this.outputChannel.appendLine(`Got data without result: ${q}`),this.outputChannel.appendLine(""),N)B({limitHit:V});else{M.flush(),F=null;let we;me&&!J&&(we=b(me))?ee((0,C.serializeSearchError)(new C.SearchError(we.message,we.code))):B({limitHit:V})}})})}}e.RipgrepTextSearchEngine=v;function b(E){const f=E.split(`
`),h=f[0].trim();if(f.some(L=>L.startsWith("regex parse error")))return new C.SearchError(p(f),C.SearchErrorCode.regexParseError);const A=h.match(/grep config error: unknown encoding: (.*)/);if(A)return new C.SearchError(`Unknown encoding: ${A[1]}`,C.SearchErrorCode.unknownEncoding);if(h.startsWith("error parsing glob"))return new C.SearchError(h.charAt(0).toUpperCase()+h.substr(1),C.SearchErrorCode.globParseError);if(h.startsWith("the literal"))return new C.SearchError(h.charAt(0).toUpperCase()+h.substr(1),C.SearchErrorCode.invalidLiteral);if(h.startsWith("PCRE2: error compiling pattern"))return new C.SearchError(h,C.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function p(E){const f=["Regex parse error"],h=E.filter(A=>A.startsWith("PCRE2:"));if(h.length>=1){const A=h[0].replace("PCRE2:","");if(A.indexOf(":")!==-1&&A.split(":").length>=2){const L=A.split(":")[1];f.push(":"+L)}}return f.join("")}e.buildRegexParseError=p;class u extends P.EventEmitter{constructor(f,h,A){super();this.maxResults=f,this.rootFolder=h,this.previewOptions=A,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new T.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(f,h){return super.on(f,h),this}handleData(f){if(!this.isDone){const h=typeof f=="string"?f:this.stringDecoder.write(f);this.handleDecodedData(h)}}handleDecodedData(f){let h=f.indexOf(`
`);const A=this.remainder+f;if(h>=0)h+=this.remainder.length;else{this.remainder=A;return}let L=0;for(;h>=0;)this.handleLine(A.substring(L,h).trim()),L=h+1,h=A.indexOf(`
`,L);this.remainder=A.substring(L)}handleLine(f){if(!(this.isDone||!f)){let h;try{h=JSON.parse(f)}catch(A){throw new Error(`malformed line from rg: ${f}`)}if(h.type==="match"){const A=c(h.data.path),L=R.URI.file(y.join(this.rootFolder,A)),B=this.createTextSearchMatch(h.data,L);this.onResult(B),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(h.type==="context"){const A=c(h.data.path),L=R.URI.file(y.join(this.rootFolder,A));this.createTextSearchContext(h.data,L).forEach(ee=>this.onResult(ee))}}}createTextSearchMatch(f,h){const A=f.line_number-1;let L=!1,B=c(f.lines);A===0&&(0,i.startsWithUTF8BOM)(B)&&(L=!0,B=(0,i.stripUTF8BOM)(B));const ee=Buffer.from(B);let j=0,x=0,$=A;f.submatches.length===0&&f.submatches.push(B.length?{start:0,end:1,match:{text:B[0]}}:{start:0,end:0,match:{text:""}});const F=(0,I.coalesce)(f.submatches.map((U,M)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let N=c(U.match);A===0&&M===0&&L&&(N=(0,i.stripUTF8BOM)(N),U.start=U.start<=3?0:U.start-3,U.end=U.end<=3?0:U.end-3);const O=ee.slice(j,U.start).toString().length,V=x+O,q=t(N),J=$,me=q.numLines+J,we=q.numLines>0?q.lastLineLength:q.lastLineLength+V;return j=U.end,x=we,$=me,new w.Range(J,V,me,we)}));return(0,d.createTextSearchResult)(h,B,F,this.previewOptions)}createTextSearchContext(f,h){const A=c(f.lines),L=f.line_number;return A.replace(/\r?\n$/,"").split(`
`).map((B,ee)=>({text:B,uri:h,lineNumber:L+ee}))}onResult(f){this.emit("result",f)}}e.RipgrepParser=u;function c(E){return E.bytes?Buffer.from(E.bytes,"base64").toString():E.text}function t(E){const f=/\n/g;let h=0,A=-1,L;for(;L=f.exec(E);)h++,A=L.index;const B=A>=0?E.length-A-1:E.length;return{numLines:h,lastLineLength:B}}function n(E,f){const h=["--hidden"];h.push(E.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:A,otherIncludes:L}=(0,D.groupBy)(f.includes,ee=>ee.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const ee=new Set;L.forEach(j=>{ee.add(j)}),h.push("-g","!*"),ee.forEach(j=>{o(j).map(d.anchorGlob).forEach(x=>{h.push("-g",x)})})}A&&A.length&&A.forEach(ee=>{h.push("-g",ee)}),f.excludes.map(d.anchorGlob).forEach(ee=>h.push("-g",`!${ee}`)),f.maxFileSize&&h.push("--max-filesize",f.maxFileSize+""),f.useIgnoreFiles?h.push("--no-ignore-parent"):h.push("--no-ignore"),f.followSymlinks&&h.push("--follow"),f.encoding&&f.encoding!=="utf8"&&h.push("--encoding",f.encoding),E.pattern==="--"&&(E.isRegExp=!0,E.pattern="\\-\\-"),E.isMultiline&&!E.isRegExp&&(E.pattern=(0,i.escapeRegExpCharacters)(E.pattern),E.isRegExp=!0),f.usePCRE2&&h.push("--pcre2"),h.push("--crlf"),E.isRegExp&&(E.pattern=r(E.pattern),h.push("--auto-hybrid-regex"));let B;if(E.isWordMatch){const j=(0,i.createRegExp)(E.pattern,!!E.isRegExp,{wholeWord:E.isWordMatch}).source.replace(/\\\//g,"/");h.push("--regexp",j)}else if(E.isRegExp){let ee=a(E.pattern);ee=g(ee),h.push("--regexp",ee)}else B=E.pattern,h.push("--fixed-strings");return h.push("--no-config"),f.useGlobalIgnoreFiles||h.push("--no-ignore-global"),h.push("--json"),E.isMultiline&&h.push("--multiline"),f.beforeContext&&h.push("--before-context",f.beforeContext+""),f.afterContext&&h.push("--after-context",f.afterContext+""),h.push("--"),B&&h.push(B),h.push("."),h}function o(E){const f=(0,k.splitGlobAware)(E,"/");return f.map((h,A)=>f.slice(0,A+1).join("/"))}e.spreadGlobComponents=o;function r(E){const f=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;E.match(f);)E=E.replace(f,"$1\\x{$2}");const h=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;E.match(h);)E=E.replace(h,"$1\\x{$2}");return E}e.unicodeEscapesToPCRE2=r;const l=E=>E.type==="Assertion"&&E.kind==="lookbehind";function a(E){let f;try{f=new m.RegExpParser().parsePattern(E)}catch(j){return E}let h="",A=0;const L=(j,x,$)=>{h+=E.slice(A,j)+$,A=x},B=[];return new m.RegExpVisitor({onCharacterEnter(j){if(j.raw==="\\n"){const x=B[0];if(!x)L(j.start,j.end,"\\r?\\n");else if(!B.some(l))if(x.type==="CharacterClass"){const $=E.slice(x.start+1,j.start)+E.slice(j.end,x.end-1);L(x.start,x.end,$===""?"\\r?\\n":`(?:[${$}]|\\r?\\n)`)}else x.type==="Quantifier"&&L(j.start,j.end,"(?:\\r?\\n)")}},onQuantifierEnter(j){B.unshift(j)},onQuantifierLeave(){B.shift()},onCharacterClassRangeEnter(j){B.unshift(j)},onCharacterClassRangeLeave(){B.shift()},onCharacterClassEnter(j){B.unshift(j)},onCharacterClassLeave(){B.shift()},onAssertionEnter(j){l(j)&&B.push(j)},onAssertionLeave(j){B[0]===j&&B.shift()}}).visit(f),h+=E.slice(A),h}e.fixRegexNewline=a;function g(E){return E.replace(/\n/g,"\\r?\\n")}e.fixNewline=g}),define(ge[276],pe([0,1,21,129,112,11]),function(Q,e,_,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class D{constructor(i){this.outputChannel=i,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(i,R,C,w){const m=new P.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===I.Schemas.userData){const s=Object.assign(Object.assign({},R),{folder:R.folder.with({scheme:I.Schemas.file})}),d=new T.Progress(S=>C.report(Object.assign(Object.assign({},S),{uri:S.uri.with({scheme:R.folder.scheme})})));return this.withToken(w,S=>m.provideTextSearchResults(i,s,d,S))}else return this.withToken(w,s=>m.provideTextSearchResults(i,R,C,s))}async withToken(i,R){const C=k(i);this.inProgress.add(C);const w=await R(C.token);return this.inProgress.delete(C),w}dispose(){this.inProgress.forEach(i=>i.cancel())}}e.RipgrepSearchProvider=D;function k(y){const i=new _.CancellationTokenSource;return y.onCancellationRequested(()=>i.cancel()),i}}),define(ge[277],pe([0,1,26,129,128]),function(Q,e,_,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class I{constructor(y){this.query=y}search(y,i,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(m){R({message:m})}},w=new T.NativeTextSearchManager(this.query,new P.RipgrepTextSearchEngine(C),_);return new Promise((m,s)=>w.search(d=>{i(d.map(D))},y).then(d=>m({limitHit:d.limitHit,type:"success"}),s))}}e.TextSearchEngineAdapter=I;function D(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((y,i)=>{if(i.ranges){const R=i;return y+(Array.isArray(R.ranges)?R.ranges.length:1)}else return y+1},0)}}}),define(ge[278],pe([0,1,37,291,14,19,18,3,97,8,47,2,45,31,275,277]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,P.gracefulify(_);class S{constructor(){this.caches=Object.create(null)}fileSearch(t){let n;const o=p(t),r=new k.Emitter({onFirstListenerDidAdd:()=>{n=(0,I.createCancelablePromise)(l=>this.doFileSearchWithEngine(s.Engine,o,a=>r.fire(a),l)),n.then(l=>r.fire(l),l=>r.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}textSearch(t){let n;const o=p(t),r=new k.Emitter({onFirstListenerDidAdd:()=>{n=(0,I.createCancelablePromise)(l=>this.ripgrepTextSearch(o,a=>r.fire(a),l)),n.then(l=>r.fire(l),l=>r.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}ripgrepTextSearch(t,n,o){return t.maxFileSize=(0,w.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new d.TextSearchEngineAdapter(t).search(o,n,n)}doFileSearch(t,n,o){return this.doFileSearchWithEngine(s.Engine,t,n,o)}doFileSearchWithEngine(t,n,o,r,l=S.BATCH_SIZE){let a=0;const g=f=>{Array.isArray(f)?(a+=f.length,o(f.map(h=>this.rawMatchToSearchItem(h)))):f.relativePath?(a++,o(this.rawMatchToSearchItem(f))):o(f)};if(n.sortByScore){let f=this.trySortedSearchFromCache(n,g,r);if(!f){const h=n.maxResults?Object.assign({},n,{maxResults:null}):n,A=new t(h);f=this.doSortedSearch(A,n,o,g,r)}return new Promise((h,A)=>{f.then(([L,B])=>{const ee=B.map(j=>this.rawMatchToSearchItem(j));this.sendProgress(ee,o,l),h(L)},A)})}const E=new t(n);return this.doSearch(E,g,l,r).then(f=>({limitHit:f.limitHit,type:"success",stats:{detailStats:f.stats,type:"searchProcess",fromCache:!1,resultCount:a,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,i.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,n,o,r,l){const a=new k.Emitter;let g=(0,I.createCancelablePromise)(f=>{let h=[];const A=L=>{Array.isArray(L)?h=L:(r(L),a.fire(L))};return this.doSearch(t,A,-1,f).then(L=>[L,h])}),E;if(n.cacheKey){E=this.getOrCreateCache(n.cacheKey);const f={promise:g,event:a.event,resolved:!1};E.resultsToSearchCache[n.filePattern||""]=f,g.then(()=>{f.resolved=!0},h=>{delete E.resultsToSearchCache[n.filePattern||""]}),g=this.preventCancellation(g)}return g.then(([f,h])=>{const A=E?E.scorerCache:Object.create(null),L=(typeof n.maxResults!="number"||n.maxResults>0)&&R.StopWatch.create(!1);return this.sortResults(n,h,A,l).then(B=>{const ee=L?L.elapsed():-1;return[{type:"success",stats:{detailStats:f.stats,sortingTime:ee,fromCache:!1,type:"searchProcess",workspaceFolderCount:n.folderQueries.length,resultCount:B.length},limitHit:f.limitHit||typeof n.maxResults=="number"&&h.length>n.maxResults},B]})})}getOrCreateCache(t){const n=this.caches[t];return n||(this.caches[t]=new v)}trySortedSearchFromCache(t,n,o){const r=t.cacheKey&&this.caches[t.cacheKey];if(!!r){const l=this.getResultsFromCache(r,t.filePattern||"",n,o);if(l)return l.then(([a,g,E])=>{const f=R.StopWatch.create(!1);return this.sortResults(t,g,r.scorerCache,o).then(h=>{const A=f.elapsed(),L={fromCache:!0,detailStats:E,type:"searchProcess",resultCount:g.length,sortingTime:A};return[{type:"success",limitHit:a.limitHit||typeof t.maxResults=="number"&&g.length>t.maxResults,stats:L},h]})})}}sortResults(t,n,o,r){const l=(0,y.prepareQuery)(t.filePattern||""),a=(E,f)=>(0,y.compareItemsByFuzzyScore)(E,f,l,!0,b,o),g=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return T.topAsync(n,a,g,1e4,r)}sendProgress(t,n,o){if(o&&o>0)for(let r=0;r<t.length;r+=o)n(t.slice(r,r+o));else n(t)}getResultsFromCache(t,n,o,r){const l=R.StopWatch.create(!1),a=n.indexOf(i.sep)>=0;let g;for(const A in t.resultsToSearchCache)if(n.startsWith(A)){if(a&&A.indexOf(i.sep)<0&&A!=="")continue;const L=t.resultsToSearchCache[A];g={promise:this.preventCancellation(L.promise),event:L.event,resolved:L.resolved};break}if(!g)return null;const E=l.elapsed(),f=R.StopWatch.create(!1),h=g.event(o);return r&&r.onCancellationRequested(()=>{h.dispose()}),g.promise.then(([A,L])=>{if(r&&r.isCancellationRequested)throw(0,D.canceled)();const B=[],ee=(0,y.prepareQuery)(n).normalizedLowercase;for(const j of L)!(0,m.isFilePatternMatch)(j,ee)||B.push(j);return[A,B,{cacheWasResolved:g.resolved,cacheLookupTime:E,cacheFilterTime:f.elapsed(),cacheEntryCount:L.length}]})}doSearch(t,n,o,r){return new Promise((l,a)=>{let g=[];r&&r.onCancellationRequested(()=>t.cancel()),t.search(E=>{E&&(o?(g.push(E),o>0&&g.length>=o&&(n(g),g=[])):n(E))},E=>{n(E)},(E,f)=>{g.length&&n(g),E?a(E):l(f)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(n,o){return t.then(n,o)}catch(n){return this.then(void 0,n)}finally(n){return t.finally(n)}}}}e.SearchService=S,S.BATCH_SIZE=512;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(c){return(0,i.basename)(c.relativePath)}getItemDescription(c){return(0,i.dirname)(c.relativePath)}getItemPath(c){return c.relativePath}};function p(c){return Object.assign(Object.assign({},c),{folderQueries:c.folderQueries&&c.folderQueries.map(u),extraFileResources:c.extraFileResources&&c.extraFileResources.map(t=>C.URI.revive(t))})}function u(c){return Object.assign(Object.assign({},c),{folder:C.URI.revive(c.folder)})}}),define(ge[279],pe([0,1,6,2,26,12,31,278,276,91,13,61,27,67,11,128]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let S=class extends m.ExtHostSearch{constructor(b,p,u,c){super(b,u,c);this._pfs=T,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new i.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(s.Schemas.userData,new y.RipgrepSearchProvider(t)),p.remote.isRemote&&p.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const b=new i.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(s.Schemas.file,new y.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(s.Schemas.file,new k.SearchService)}registerInternalFileSearchProvider(b,p){const u=this._handlePool++;return this._internalFileSearchProvider=p,this._internalFileSearchHandle=u,this._proxy.$registerFileSearchProvider(u,this._transformScheme(b)),(0,_.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(u)})}$provideFileSearchResults(b,p,u,c){const t=(0,m.reviveQuery)(u);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,p,t,c):super.$provideFileSearchResults(b,p,u,c)}doInternalFileSearch(b,p,u,c){const t=n=>{if((0,D.isSerializedFileMatch)(n)&&(n=[n]),Array.isArray(n)){this._proxy.$handleFileMatch(b,p,n.map(o=>P.URI.file(o.path)));return}n.message&&this._logService.debug("ExtHostSearch",n.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(u,t,c)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,p){return new d.NativeTextSearchManager(b,p)}};S=je([xe(0,R.IExtHostRpcService),xe(1,w.IExtHostInitDataService),xe(2,C.IURITransformerService),xe(3,I.ILogService)],S),e.NativeExtHostSearch=S}),define(ge[130],pe([0,1,292,120,293,3,102,8,48,28,6,22,103,18,9]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(g){this.socket=g,this._errorListener=E=>{if(E){if(E.code==="EPIPE")return;(0,m.onUnexpectedError)(E)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(g){const E=f=>g(C.VSBuffer.wrap(f));return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(g){return this.socket.on("close",g),{dispose:()=>this.socket.off("close",g)}}onEnd(g){return this.socket.on("end",g),{dispose:()=>this.socket.off("end",g)}}write(g){if(!this.socket.destroyed)try{this.socket.write(g.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,m.onUnexpectedError)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,m.onUnexpectedError)(E)}}end(){this.socket.end()}drain(){return new Promise((g,E)=>{if(this.socket.bufferSize===0){g();return}const f=()=>{this.socket.off("close",f),this.socket.off("end",f),this.socket.off("error",f),this.socket.off("timeout",f),this.socket.off("drain",f),g()};this.socket.on("close",f),this.socket.on("end",f),this.socket.on("error",f),this.socket.on("timeout",f),this.socket.on("drain",f)})}}e.NodeSocket=d;var S;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var v;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(v||(v={}));class b extends R.Disposable{constructor(g,E,f,h){super();this._onDidZlibFlush=this._register(new I.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=g,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=E,this._recordInflateBytes=h,E?(this._zlibInflate=T.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",A=>{console.error(A),(0,m.onUnexpectedError)(A),this._onClose.fire()}),this._zlibInflate.on("data",A=>{this._pendingInflateData.push(A)}),f&&(this._zlibInflate.write(f.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=T.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{console.error(A),(0,m.onUnexpectedError)(A),this._onClose.fire()}),this._zlibDeflate.on("data",A=>{this._pendingDeflateData.push(A)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new w.ChunkStream,this._register(this.socket.onData(A=>this._acceptChunk(A))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(g){return this._onData.event(g)}onClose(g){return this._onClose.event(g)}onEnd(g){return this.socket.onEnd(g)}write(g){this._totalOutgoingDataBytes+=g.byteLength,this._zlibDeflate?(this._zlibDeflate.write(g.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let E=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,E=E.slice(0,E.length-4),this._isEnded||this._write(C.VSBuffer.wrap(E),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(g,!1)}_write(g,E){let f=2;g.byteLength<126?f+=0:g.byteLength<2**16?f+=2:f+=8;const h=C.VSBuffer.alloc(f);if(E?h.writeUInt8(194,0):h.writeUInt8(130,0),g.byteLength<126)h.writeUInt8(g.byteLength,1);else if(g.byteLength<2**16){h.writeUInt8(126,1);let A=1;h.writeUInt8(g.byteLength>>>8&255,++A),h.writeUInt8(g.byteLength>>>0&255,++A)}else{h.writeUInt8(127,1);let A=1;h.writeUInt8(0,++A),h.writeUInt8(0,++A),h.writeUInt8(0,++A),h.writeUInt8(0,++A),h.writeUInt8(g.byteLength>>>24&255,++A),h.writeUInt8(g.byteLength>>>16&255,++A),h.writeUInt8(g.byteLength>>>8&255,++A),h.writeUInt8(g.byteLength>>>0&255,++A)}this._totalOutgoingWireBytes+=h.byteLength+g.byteLength,this.socket.write(C.VSBuffer.concat([h,g]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(g){if(g.byteLength!==0){for(this._totalIncomingWireBytes+=g.byteLength,this._incomingData.acceptChunk(g);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const E=this._incomingData.peek(this._state.readLen),h=(E.readUInt8(0)&128)>>>7,A=E.readUInt8(1),L=(A&128)>>>7,B=A&127;this._state.state=2,this._state.readLen=2+(L?4:0)+(B===126?2:0)+(B===127?8:0),this._state.fin=h,this._state.mask=0}else if(this._state.state===2){const E=this._incomingData.read(this._state.readLen),f=E.readUInt8(1),h=(f&128)>>>7;let A=f&127,L=1;A===126?A=E.readUInt8(++L)*2**8+E.readUInt8(++L):A===127&&(A=E.readUInt8(++L)*0+E.readUInt8(++L)*0+E.readUInt8(++L)*0+E.readUInt8(++L)*0+E.readUInt8(++L)*2**24+E.readUInt8(++L)*2**16+E.readUInt8(++L)*2**8+E.readUInt8(++L));let B=0;h&&(B=E.readUInt8(++L)*2**24+E.readUInt8(++L)*2**16+E.readUInt8(++L)*2**8+E.readUInt8(++L)),this._state.state=3,this._state.readLen=A,this._state.mask=B}else if(this._state.state===3){const E=this._incomingData.read(this._state.readLen);p(E,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(E.buffer)),this._zlibInflate.write(E.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const f=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=f.length,this._onData.fire(C.VSBuffer.wrap(f))})):(this._totalIncomingDataBytes+=E.byteLength,this._onData.fire(E))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await I.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=b;function p(a,g){if(g!==0){let E=a.byteLength>>>2;for(let ee=0;ee<E;ee++){const j=a.readUInt32BE(ee*4);a.writeUInt32BE(j^g,ee*4)}let f=E*4,h=a.byteLength-f;const A=g>>>24&255,L=g>>>16&255,B=g>>>8&255;h>=1&&a.writeUInt8(a.readUInt8(f)^A,f),h>=2&&a.writeUInt8(a.readUInt8(f+1)^L,f+1),h>=3&&a.writeUInt8(a.readUInt8(f+2)^B,f+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function c(){const a=(0,i.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let g;return e.XDG_RUNTIME_DIR?g=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):g=(0,k.join)((0,y.tmpdir)(),`vscode-ipc-${a}.sock`),n(g),g}e.createRandomIPCHandle=c;function t(a,g,E){const f=(0,_.createHash)("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${f}-${E}-${g}-sock`;let h;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?h=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-${f.substr(0,8)}-${E}-${g}.sock`):h=(0,k.join)(a,`${E}-${g}.sock`),n(h),h}e.createStaticIPCHandle=t;function n(a){const g=u[s.platform];typeof g=="number"&&a.length>=g&&console.warn(`WARNING: IPC handle "${a}" is longer than ${g} chars, try a shorter --user-data-dir`)}class o extends D.IPCServer{constructor(g){super(o.toClientConnectionEvent(g));this.server=g}static toClientConnectionEvent(g){const E=I.Event.fromNodeEventEmitter(g,"connection");return I.Event.map(E,f=>({protocol:new w.Protocol(new d(f)),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(f,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function r(a){return new Promise((g,E)=>{const f=(0,P.createServer)();f.on("error",E),f.listen(a,()=>{f.removeListener("error",E),g(new o(f))})})}e.serve=r;function l(a,g){return new Promise((E,f)=>{const h=(0,P.createConnection)(a,()=>{h.removeListener("error",f),E(w.Client.fromSocket(new d(h),g))});h.once("error",f)})}e.connect=l}),define(ge[280],pe([0,1,130,272,37,51,2,116,12]),function(Q,e,_,P,T,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class i{constructor(w,m,s){this._commands=w,this.logService=m,this._ipcHandlePath=s,this._server=P.createServer((d,S)=>this.onRequest(d,S)),this.setup().catch(d=>(m.error(d),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",w=>this.logService.error(w))}catch(w){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(w,m){const s=[];w.setEncoding("utf8"),w.on("data",d=>s.push(d)),w.on("end",()=>{const d=JSON.parse(s.join(""));switch(d.type){case"open":this.open(d,m);break;case"openExternal":this.openExternal(d,m);break;case"status":this.getStatus(d,m);break;case"extensionManagement":this.manageExtensions(d,m).catch(this.logService.error);break;default:m.writeHead(404),m.write(`Unknown message type: ${d.type}`,S=>{S&&this.logService.error(S)}),m.end();break}})}open(w,m){let{fileURIs:s,folderURIs:d,forceNewWindow:S,diffMode:v,addMode:b,forceReuseWindow:p,gotoLineMode:u,waitMarkerFilePath:c}=w;const t=[];if(Array.isArray(d))for(const n of d)try{t.push({folderUri:D.URI.parse(n)})}catch(o){}if(Array.isArray(s))for(const n of s)try{(0,k.hasWorkspaceFileExtension)(n)?t.push({workspaceUri:D.URI.parse(n)}):t.push({fileUri:D.URI.parse(n)})}catch(o){}if(t.length){const n=c?D.URI.file(c):void 0,r={forceNewWindow:S,diffMode:v,addMode:b,gotoLineMode:u,forceReuseWindow:p,preferNewWindow:!p&&!n&&!b,waitMarkerFileURI:n};this._commands.executeCommand("_remoteCLI.windowOpen",t,r)}m.writeHead(200),m.end()}async openExternal(w,m){for(const s of w.uris){const d=D.URI.parse(s),S=d.scheme==="file"?d:s;await this._commands.executeCommand("_remoteCLI.openExternal",S)}m.writeHead(200),m.end()}async manageExtensions(w,m){try{const s=v=>v==null?void 0:v.map(b=>/\.vsix$/i.test(b)?D.URI.parse(b):b),d={list:w.list,install:s(w.install),uninstall:s(w.uninstall),force:w.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",d);m.writeHead(200),m.write(S)}catch(s){m.writeHead(500),m.write(String(s),d=>{d&&this.logService.error(d)})}m.end()}async getStatus(w,m){try{const s=await this._commands.executeCommand("_remoteCLI.getSystemStatus");m.writeHead(200),m.write(s),m.end()}catch(s){m.writeHead(500),m.write(String(s),d=>{d&&this.logService.error(d)}),m.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&T.existsSync(this._ipcHandlePath)&&T.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=i;let R=class extends i{constructor(w,m){super(w,m,(0,_.createRandomIPCHandle)())}};R=je([xe(0,I.IExtHostCommands),xe(1,y.ILogService)],R),e.CLIServer=R}),define(ge[281],pe([0,1,66,268,262,5,271,42,253,2,11,7,280,100]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class s extends T.RequireInterceptor{_installInterceptor(){const v=this,b=Q.__$__nodeRequire("module"),p=b._load;b._load=function(c,t,n){for(let o of v._alternatives){let r=o(c);if(r){c=r;break}}return v._factories.has(c)?v._factories.get(c).load(c,i.URI.file((0,m.realpathSync)(t.filename)),o=>p.apply(this,[o,t,n])):p.apply(this,arguments)}}}class d extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=C.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const v=this._instaService.invokeFunction(P.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(y.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(w.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(s,v,this._registry).install(),_.mark("code/extHost/didInitAPI");const p=await this._extHostConfiguration.getConfigProvider();await(0,D.connectProxyResolver)(this._extHostWorkspace,p,this,this._logService,this._mainThreadTelemetryProxy,this._initData),_.mark("code/extHost/didInitProxyResolver");const u=process.send,c=this._extHostContext.getProxy(I.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?u.apply(process,t):(c.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(v){return v.main}_loadCommonJSModule(v,b,p){if(b.scheme!==R.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let u=null;p.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{v&&_.mark(`code/extHost/willLoadExtensionCode/${v.value}`),u=Q.__$__nodeRequire(b.fsPath)}catch(c){return Promise.reject(c)}finally{v&&_.mark(`code/extHost/didLoadExtensionCode/${v.value}`),p.codeLoadingStop()}return Promise.resolve(u)}async $setRemoteEnvironment(v){if(!!this._initData.remote.isRemote)for(const b in v){const p=v[b];p===null?delete process.env[b]:process.env[b]=p}}}e.ExtHostExtensionService=d}),define(ge[282],pe([0,1,78,254,265,264,263,279,281,225,255,46,42,63,67,65,34,50,12]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d,S,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(w.IExtHostExtensionService,y.ExtHostExtensionService),(0,_.registerSingleton)(b.ILogService,i.ExtHostLogService),(0,_.registerSingleton)(C.IExtHostDebugService,D.ExtHostDebugService),(0,_.registerSingleton)(m.IExtHostOutputService,P.ExtHostOutputService2),(0,_.registerSingleton)(s.IExtHostSearch,k.NativeExtHostSearch),(0,_.registerSingleton)(d.IExtHostTask,I.ExtHostTask),(0,_.registerSingleton)(S.IExtHostTerminalService,T.ExtHostTerminalService),(0,_.registerSingleton)(v.IExtHostTunnelService,R.ExtHostTunnelService)}),define(ge[283],pe([0,1,120,294,66,18,103,130,186,223,266,22,98,26,100,19,269,282]),function(Q,e,_,P,T,I,D,k,y,i,R,C,w,m,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const S=P(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const o=Q.__$__nodeRequire("module"),r=o._load;o._load=function(l){if(l==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return r.apply(this,arguments)}})();const v=process.exit.bind(process);function b(o){process.exit=function(r){if(o)v(r);else{const l=new Error("An extension called process.exit() and this was prevented.");console.warn(l.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let p=function(o){v()};function u(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((o,r)=>{let l=null,a=setTimeout(()=>{r(new Error("VSCODE_EXTHOST_IPC_SOCKET timeout"))},6e4);const g=108e5,E=3e5,f=new d.RunOnceScheduler(()=>p("renderer disconnected for too long (1)"),g),h=new d.RunOnceScheduler(()=>p("renderer disconnected for too long (2)"),E);process.on("message",(L,B)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){const ee=C.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let j;if(L.skipWebSocketFrames)j=new k.NodeSocket(B);else{const x=C.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));j=new k.WebSocketNodeSocket(new k.NodeSocket(B),L.permessageDeflate,x,!1)}l?(f.cancel(),h.cancel(),l.beginAcceptReconnection(j,ee),l.endAcceptReconnection()):(clearTimeout(a),l=new D.PersistentProtocol(j,ee),l.onDidDispose(()=>p("renderer disconnected")),o(l),l.onSocketClose(()=>{f.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(h.isScheduled())return;f.isScheduled()&&h.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(A)});{const o=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,l)=>{const a=_.createConnection(o,()=>{a.removeListener("error",l),r(new D.PersistentProtocol(new k.NodeSocket(a)))});a.once("error",l)})}}async function c(){const o=await u();return new class{constructor(){this._onMessage=new D.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,o.onMessage(r=>{(0,i.isMessageOfType)(r,2)?(this._terminating=!0,p("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||o.send(r)}drain(){return o.drain()}}}function t(o){return new Promise(r=>{const l=o.onMessage(a=>{l.dispose();const g=JSON.parse(a.toString()),E=g.commit,f=y.default.commit;E&&f&&E!==f&&v(55);const h=[];process.on("unhandledRejection",(B,ee)=>{h.push(ee),setTimeout(()=>{const j=h.indexOf(ee);j>=0&&ee.catch(x=>{h.splice(j,1),console.warn(`rejected promise not handled within 1 second: ${x}`),x&&x.stack&&console.warn(`stack trace: ${x.stack}`),(0,I.onUnexpectedError)(B)})},1e3)}),process.on("rejectionHandled",B=>{const ee=h.indexOf(B);ee>=0&&h.splice(ee,1)}),process.on("uncaughtException",function(B){(0,I.onUnexpectedError)(B)});let A=0;setInterval(function(){try{process.kill(g.parentPid,0),A=0}catch(B){B&&B.code==="EPERM"?(A++,A>=3&&p(`parent process ${g.parentPid} does not exist anymore (3 x EPERM): ${B.message} (code: ${B.code}) (errno: ${B.errno})`)):p(`parent process ${g.parentPid} does not exist anymore: ${B.message} (code: ${B.code}) (errno: ${B.errno})`)}},1e3);let L;try{L=Q.__$__nodeRequire("native-watchdog"),L.start(g.parentPid)}catch(B){(0,I.onUnexpectedError)(B)}o.send((0,i.createMessageOfType)(0)),r({protocol:o,initData:g})});o.send((0,i.createMessageOfType)(1))})}async function n(){T.mark("code/extHost/willConnectToRenderer");const o=await c();T.mark("code/extHost/didConnectToRenderer");const r=await t(o);T.mark("code/extHost/didWaitForInitData");const{initData:l}=r;b(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=S.useHostProxy!==void 0?S.useHostProxy!=="false":void 0;const a=new class{exit(h){v(h)}exists(h){return(0,m.exists)(h)}realpath(h){return(0,s.realpath)(h)}};let g=null;if(l.remote.authority&&S.uriTransformerPath)try{const h=Q.__$__nodeRequire(S.uriTransformerPath)(l.remote.authority);g=new w.URITransformer(h)}catch(f){console.error(f)}const E=new R.ExtensionHostMain(r.protocol,l,a,g);p=f=>E.terminate(f)}e.startExtensionHostProcess=n}),define(ge[295],pe([0,1,283]),function(Q,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.startExtensionHostProcess)().catch(P=>console.log(P))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/25785b97e533b15ae3b12e48aaf4187416437e62/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
