/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/base/common/types","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/network","vs/platform/log/common/log","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/json","vs/base/common/linkedList","vs/base/common/process","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(ie){for(var e=[],E=0,k=ie.length;E<k;E++)e[E]=ve[ie[E]];return e};define(ve[42],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function E(k,P){if(!k)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}e.ok=E}),define(ve[50],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const E=Object.prototype.hasOwnProperty;function k(T){const C=[];for(let g in T)E.call(T,g)&&C.push(T[g]);return C}e.values=k;function P(T,C){for(let g in T)if(E.call(T,g)&&C({key:g,value:T[g]},function(){delete T[g]})===!1)return}e.forEach=P;function A(T,C){const g=Object.create(null);for(const f of T){const r=C(f);let s=g[r];s||(s=g[r]=[]),s.push(f)}return g}e.groupBy=A;function S(T){const C=Object.create(null);return T&&T.forEach((g,f)=>{C[f]=g}),C}e.fromMap=S;function D(T,C){const g=[],f=[];for(let r of T)C.has(r)||g.push(r);for(let r of C)T.has(r)||f.push(r);return{removed:g,added:f}}e.diffSets=D;function y(T,C){const g=[],f=[];for(let[r,s]of T)C.has(r)||g.push(s);for(let[r,s]of C)T.has(r)||f.push(s);return{removed:g,added:f}}e.diffMaps=y;class n{constructor(){this.map=new Map}add(C,g){let f=this.map.get(C);f||(f=new Set,this.map.set(C,f)),f.add(g)}delete(C,g){const f=this.map.get(C);!f||(f.delete(g),f.size===0&&this.map.delete(C))}forEach(C,g){const f=this.map.get(C);!f||f.forEach(g)}}e.SetMap=n}),define(ve[51],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function E(y){return(n,T,C)=>{let g=null,f=null;if(typeof C.value=="function"?(g="value",f=C.value):typeof C.get=="function"&&(g="get",f=C.get),!f)throw new Error("not supported");C[g]=y(f,T)}}e.createDecorator=E;let k=0;function P(){const y=`$memoize${k++}`;let n;const T=function(g,f,r){let s=null,b=null;if(typeof r.value=="function"?(s="value",b=r.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof r.get=="function"&&(s="get",b=r.get),!b)throw new Error("not supported");const h=`${y}:${f}`;r[s]=function(..._){return n=this,this.hasOwnProperty(h)||Object.defineProperty(this,h,{configurable:!0,enumerable:!1,writable:!0,value:b.apply(this,_)}),this[h]}};return T.clear=()=>{typeof n!="undefined"&&Object.getOwnPropertyNames(n).forEach(C=>{C.indexOf(y)===0&&delete n[C]})},T}e.createMemoizer=P;function A(y,n,T){return P()(y,n,T)}e.memoize=A;function S(y,n,T){return E((C,g)=>{const f=`$debounce$${g}`,r=`$debounce$result$${g}`;return function(...s){this[r]||(this[r]=T?T():void 0),clearTimeout(this[f]),n&&(this[r]=n(this[r],...s),s=[this[r]]),this[f]=setTimeout(()=>{C.apply(this,s),this[r]=T?T():void 0},y)}})}e.debounce=S;function D(y,n,T){return E((C,g)=>{const f=`$throttle$timer$${g}`,r=`$throttle$result$${g}`,s=`$throttle$lastRun$${g}`,b=`$throttle$pending$${g}`;return function(...h){if(this[r]||(this[r]=T?T():void 0),(this[s]===null||this[s]===void 0)&&(this[s]=-Number.MAX_VALUE),n&&(this[r]=n(this[r],...h)),!this[b]){const _=this[s]+y;_<=Date.now()?(this[s]=Date.now(),C.apply(this,[this[r]]),this[r]=T?T():void 0):(this[b]=!0,this[f]=setTimeout(()=>{this[b]=!1,this[s]=Date.now(),C.apply(this,[this[r]]),this[r]=T?T():void 0},_-Date.now()))}}})}e.throttle=D}),define(ve[10],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=E,e.errorHandler=new E;function k(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=k;function P(u){y(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=P;function A(u){y(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=A;function S(u){if(u instanceof Error){let{name:t,message:i}=u;const d=u.stacktrace||u.stack;return{$isError:!0,name:t,message:i,stack:d}}return u}e.transformErrorForSerialization=S;const D="Canceled";function y(u){return u instanceof Error&&u.name===D&&u.message===D}e.isPromiseCanceledError=y;class n extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=n;function T(){const u=new Error(D);return u.name=u.message,u}e.canceled=T;function C(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=C;function g(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=g;function f(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function r(u){const t=new Error(`${u} has been disposed`);return t.name="DISPOSED",t}e.disposed=r;function s(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=s;class b extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=b;class h extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=h;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=_;function v(u){const t=u;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=v;function c(u,t=Object.create(null)){const i=new Error(u);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=c}),define(ve[11],_e([0,1,10]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function k(M,N=0){return M[M.length-(1+N)]}e.tail=k;function P(M){if(M.length===0)throw new Error("Invalid tail call");return[M.slice(0,M.length-1),M[M.length-1]]}e.tail2=P;function A(M,N,W=(Q,$)=>Q===$){if(M===N)return!0;if(!M||!N||M.length!==N.length)return!1;for(let Q=0,$=M.length;Q<$;Q++)if(!W(M[Q],N[Q]))return!1;return!0}e.equals=A;function S(M,N,W){let Q=0,$=M.length-1;for(;Q<=$;){const Z=(Q+$)/2|0,re=W(M[Z],N);if(re<0)Q=Z+1;else if(re>0)$=Z-1;else return Z}return-(Q+1)}e.binarySearch=S;function D(M,N){let W=0,Q=M.length;if(Q===0)return 0;for(;W<Q;){const $=Math.floor((W+Q)/2);N(M[$])?Q=$:W=$+1}return W}e.findFirstInSorted=D;function y(M,N,W){if(M=M|0,M>=N.length)throw new TypeError("invalid index");let Q=N[Math.floor(N.length*Math.random())],$=[],Z=[],re=[];for(let se of N){const ye=W(se,Q);ye<0?$.push(se):ye>0?Z.push(se):re.push(se)}return M<$.length?y(M,$,W):M<$.length+re.length?re[0]:y(M-($.length+re.length),Z,W)}e.quickSelect=y;function n(M,N){const W=[];let Q;for(const $ of M.slice(0).sort(N))!Q||N(Q[0],$)!==0?(Q=[$],W.push(Q)):Q.push($);return W}e.groupBy=n;function T(M,N,W){const Q=[];function $(se,ye,Pe){if(!(ye===0&&Pe.length===0)){const $e=Q[Q.length-1];$e&&$e.start+$e.deleteCount===se?($e.deleteCount+=ye,$e.toInsert.push(...Pe)):Q.push({start:se,deleteCount:ye,toInsert:Pe})}}let Z=0,re=0;for(;;){if(Z===M.length){$(Z,0,N.slice(re));break}if(re===N.length){$(Z,M.length-Z,[]);break}const se=M[Z],ye=N[re],Pe=W(se,ye);Pe===0?(Z+=1,re+=1):Pe<0?($(Z,1,[]),Z+=1):Pe>0&&($(Z,0,[ye]),re+=1)}return Q}e.sortedDiff=T;function C(M,N,W){const Q=T(M,N,W),$=[],Z=[];for(const re of Q)$.push(...M.slice(re.start,re.start+re.deleteCount)),Z.push(...re.toInsert);return{removed:$,added:Z}}e.delta=C;function g(M,N,W){if(W===0)return[];const Q=M.slice(0,W).sort(N);return r(M,N,Q,W,M.length),Q}e.top=g;function f(M,N,W,Q,$){return W===0?Promise.resolve([]):new Promise((Z,re)=>{(async()=>{const se=M.length,ye=M.slice(0,W).sort(N);for(let Pe=W,$e=Math.min(W+Q,se);Pe<se;Pe=$e,$e=Math.min($e+Q,se)){if(Pe>W&&await new Promise(Re=>setTimeout(Re)),$&&$.isCancellationRequested)throw(0,E.canceled)();r(M,N,ye,Pe,$e)}return ye})().then(Z,re)})}e.topAsync=f;function r(M,N,W,Q,$){for(const Z=W.length;Q<$;Q++){const re=M[Q];if(N(re,W[Z-1])<0){W.pop();const se=D(W,ye=>N(re,ye)<0);W.splice(se,0,re)}}}function s(M){return M.filter(N=>!!N)}e.coalesce=s;function b(M){let N=0;for(let W=0;W<M.length;W++)M[W]&&(M[N]=M[W],N+=1);M.length=N}e.coalesceInPlace=b;function h(M,N,W){M.splice(W,0,M.splice(N,1)[0])}e.move=h;function _(M){return!Array.isArray(M)||M.length===0}e.isFalsyOrEmpty=_;function v(M){return Array.isArray(M)&&M.length>0}e.isNonEmptyArray=v;function c(M,N){if(!N)return M.filter((Q,$)=>M.indexOf(Q)===$);const W=Object.create(null);return M.filter(Q=>{const $=N(Q);return W[$]?!1:(W[$]=!0,!0)})}e.distinct=c;function u(M){const N=new Set;return M.filter(W=>N.has(W)?!1:(N.add(W),!0))}e.distinctES6=u;function t(M){const N=Object.create(null);return W=>{const Q=M(W);return N[Q]?!1:(N[Q]=!0,!0)}}e.uniqueFilter=t;function i(M,N){for(let W=M.length-1;W>=0;W--){const Q=M[W];if(N(Q))return W}return-1}e.lastIndex=i;function d(M,N){return M.length>0?M[0]:N}e.firstOrDefault=d;function a(M,N,W=(Q,$)=>Q===$){let Q=0;for(let $=0,Z=Math.min(M.length,N.length);$<Z&&W(M[$],N[$]);$++)Q++;return Q}e.commonPrefixLength=a;function l(M){return[].concat(...M)}e.flatten=l;function o(M,N){let W=typeof N=="number"?M:0;typeof N=="number"?W=M:(W=0,N=M);const Q=[];if(W<=N)for(let $=W;$<N;$++)Q.push($);else for(let $=W;$>N;$--)Q.push($);return Q}e.range=o;function w(M,N,W){return M.reduce((Q,$)=>(Q[N($)]=W?W($):$,Q),Object.create(null))}e.index=w;function I(M,N){return M.push(N),()=>p(M,N)}e.insert=I;function p(M,N){const W=M.indexOf(N);if(W>-1)return M.splice(W,1),N}e.remove=p;function m(M,N,W){const Q=M.slice(0,N),$=M.slice(N);return Q.concat(W,$)}e.arrayInsert=m;function R(M,N){let W;if(typeof N=="number"){let Q=N;W=()=>{const $=Math.sin(Q++)*179426549;return $-Math.floor($)}}else W=Math.random;for(let Q=M.length-1;Q>0;Q-=1){const $=Math.floor(W()*(Q+1)),Z=M[Q];M[Q]=M[$],M[$]=Z}}e.shuffle=R;function F(M,N){const W=M.indexOf(N);W>-1&&(M.splice(W,1),M.unshift(N))}e.pushToStart=F;function x(M,N){const W=M.indexOf(N);W>-1&&(M.splice(W,1),M.push(N))}e.pushToEnd=x;function ae(M,N){return Array.isArray(M)?M.map(N):N(M)}e.mapArrayOrNot=ae;function z(M){return Array.isArray(M)?M:[M]}e.asArray=z;function B(M){return M[Math.floor(Math.random()*M.length)]}e.getRandomElement=B;function G(M,N){for(const W of M){const Q=N(W);if(Q!==void 0)return Q}}e.mapFind=G}),define(ve[52],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(k){const P=this;let A=!1,S;return function(){return A||(A=!0,S=k.apply(P,arguments)),S}}e.once=E}),define(ve[53],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class E{constructor(P){this._prefix=P,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=E,e.defaultGenerator=new E("id#")}),define(ve[54],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(k){function P(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}k.is=P;const A=Object.freeze([]);function S(){return A}k.empty=S;function*D(u){yield u}k.single=D;function y(u){return u||A}k.from=y;function n(u){return!u||u[Symbol.iterator]().next().done===!0}k.isEmpty=n;function T(u){return u[Symbol.iterator]().next().value}k.first=T;function C(u,t){for(const i of u)if(t(i))return!0;return!1}k.some=C;function g(u,t){for(const i of u)if(t(i))return i}k.find=g;function*f(u,t){for(const i of u)t(i)&&(yield i)}k.filter=f;function*r(u,t){for(const i of u)yield t(i)}k.map=r;function*s(...u){for(const t of u)for(const i of t)yield i}k.concat=s;function*b(u){for(const t of u)for(const i of t)yield i}k.concatNested=b;function h(u,t,i){let d=i;for(const a of u)d=t(d,a);return d}k.reduce=h;function*_(u,t,i=u.length){for(t<0&&(t+=u.length),i<0?i+=u.length:i>u.length&&(i=u.length);t<i;t++)yield u[t]}k.slice=_;function v(u,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,u];const d=u[Symbol.iterator]();for(let a=0;a<t;a++){const l=d.next();if(l.done)return[i,k.empty()];i.push(l.value)}return[i,{[Symbol.iterator](){return d}}]}k.consume=v;function c(u,t,i=(d,a)=>d===a){const d=u[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const l=d.next(),o=a.next();if(l.done!==o.done)return!1;if(l.done)return!0;if(!i(l.value,o.value))return!1}}k.equals=c})(E=e.Iterable||(e.Iterable={}))}),define(ve[43],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function S(t,i=!1){let d=0,a=t.length,l="",o=0,w=16,I=0;function p(B){let G=0,M=0;for(;G<B;){const N=t.charCodeAt(d);if(N>=48&&N<=57)M=M*16+N-48;else if(N>=65&&N<=70)M=M*16+N-65+10;else if(N>=97&&N<=102)M=M*16+N-97+10;else break;d++,G++}return G<B&&(M=-1),M}function m(B){d=B,l="",o=0,w=16,I=0}function R(){const B=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&n(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&n(t.charCodeAt(d)))for(d++;d<t.length&&n(t.charCodeAt(d));)d++;else return I=3,t.substring(B,d);let G=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&n(t.charCodeAt(d))){for(d++;d<t.length&&n(t.charCodeAt(d));)d++;G=d}else I=3;return t.substring(B,G)}function F(){let B="",G=d;for(;;){if(d>=a){B+=t.substring(G,d),I=2;break}const M=t.charCodeAt(d);if(M===34){B+=t.substring(G,d),d++;break}if(M===92){if(B+=t.substring(G,d),d++,d>=a){I=2;break}switch(t.charCodeAt(d++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:const W=p(4);W>=0?B+=String.fromCharCode(W):I=4;break;default:I=5}G=d;continue}if(M>=0&&M<=31)if(y(M)){B+=t.substring(G,d),I=2;break}else I=6;d++}return B}function x(){if(l="",I=0,o=d,d>=a)return o=a,w=17;let B=t.charCodeAt(d);if(D(B)){do d++,l+=String.fromCharCode(B),B=t.charCodeAt(d);while(D(B));return w=15}if(y(B))return d++,l+=String.fromCharCode(B),B===13&&t.charCodeAt(d)===10&&(d++,l+=`
`),w=14;switch(B){case 123:return d++,w=1;case 125:return d++,w=2;case 91:return d++,w=3;case 93:return d++,w=4;case 58:return d++,w=6;case 44:return d++,w=5;case 34:return d++,l=F(),w=10;case 47:const G=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<a&&!y(t.charCodeAt(d));)d++;return l=t.substring(G,d),w=12}if(t.charCodeAt(d+1)===42){d+=2;const M=a-1;let N=!1;for(;d<M;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,N=!0;break}d++}return N||(d++,I=1),l=t.substring(G,d),w=13}return l+=String.fromCharCode(B),d++,w=16;case 45:if(l+=String.fromCharCode(B),d++,d===a||!n(t.charCodeAt(d)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=R(),w=11;default:for(;d<a&&ae(B);)d++,B=t.charCodeAt(d);if(o!==d){switch(l=t.substring(o,d),l){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return l+=String.fromCharCode(B),d++,w=16}}function ae(B){if(D(B)||y(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let B;do B=x();while(B>=12&&B<=15);return B}return{setPosition:m,getPosition:()=>d,scan:i?z:x,getToken:()=>w,getTokenValue:()=>l,getTokenOffset:()=>o,getTokenLength:()=>d-o,getTokenError:()=>I}}e.createScanner=S;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function n(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function C(t,i){const d=[],a=new Object;let l;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function I(p,m,R,F){o.value=p,o.offset=m,o.length=R,o.type=F,o.colonOffset=void 0,l=o}try{v(t,{onObjectBegin:(p,m)=>{if(i<=p)throw a;l=void 0,w=i>p,d.push("")},onObjectProperty:(p,m,R)=>{if(i<m||(I(p,m,R,"property"),d[d.length-1]=p,i<=m+R))throw a},onObjectEnd:(p,m)=>{if(i<=p)throw a;l=void 0,d.pop()},onArrayBegin:(p,m)=>{if(i<=p)throw a;l=void 0,d.push(0)},onArrayEnd:(p,m)=>{if(i<=p)throw a;l=void 0,d.pop()},onLiteralValue:(p,m,R)=>{if(i<m||(I(p,m,R,u(p)),i<=m+R))throw a},onSeparator:(p,m,R)=>{if(i<=m)throw a;if(p===":"&&l&&l.type==="property")l.colonOffset=m,w=!1,l=void 0;else if(p===","){const F=d[d.length-1];typeof F=="number"?d[d.length-1]=F+1:(w=!0,d[d.length-1]=""),l=void 0}}})}catch(p){if(p!==a)throw p}return{path:d,previousNode:l,isAtPropertyKey:w,matches:p=>{let m=0;for(let R=0;m<p.length&&R<d.length;R++)if(p[m]===d[R]||p[m]==="*")m++;else if(p[m]!=="**")return!1;return m===p.length}}}e.getLocation=C;function g(t,i=[],d=A.DEFAULT){let a=null,l=[];const o=[];function w(p){Array.isArray(l)?l.push(p):a!==null&&(l[a]=p)}return v(t,{onObjectBegin:()=>{const p={};w(p),o.push(l),l=p,a=null},onObjectProperty:p=>{a=p},onObjectEnd:()=>{l=o.pop()},onArrayBegin:()=>{const p=[];w(p),o.push(l),l=p,a=null},onArrayEnd:()=>{l=o.pop()},onLiteralValue:w,onError:(p,m,R)=>{i.push({error:p,offset:m,length:R})}},d),l[0]}e.parse=g;function f(t,i=[],d=A.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(p){a.type==="property"&&(a.length=p-a.offset,a=a.parent)}function o(p){return a.children.push(p),p}v(t,{onObjectBegin:p=>{a=o({type:"object",offset:p,length:-1,parent:a,children:[]})},onObjectProperty:(p,m,R)=>{a=o({type:"property",offset:m,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:p,offset:m,length:R,parent:a})},onObjectEnd:(p,m)=>{a.length=p+m-a.offset,a=a.parent,l(p+m)},onArrayBegin:(p,m)=>{a=o({type:"array",offset:p,length:-1,parent:a,children:[]})},onArrayEnd:(p,m)=>{a.length=p+m-a.offset,a=a.parent,l(p+m)},onLiteralValue:(p,m,R)=>{o({type:u(p),offset:m,length:R,parent:a,value:p}),l(m+R)},onSeparator:(p,m,R)=>{a.type==="property"&&(p===":"?a.colonOffset=m:p===","&&l(m))},onError:(p,m,R)=>{i.push({error:p,offset:m,length:R})}},d);const I=a.children[0];return I&&delete I.parent,I}e.parseTree=f;function r(t,i){if(!!t){let d=t;for(let a of i)if(typeof a=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let l=!1;for(const o of d.children)if(Array.isArray(o.children)&&o.children[0].value===a){d=o.children[1],l=!0;break}if(!l)return}else{const l=a;if(d.type!=="array"||l<0||!Array.isArray(d.children)||l>=d.children.length)return;d=d.children[l]}return d}}e.findNodeAtLocation=r;function s(t){if(!t.parent||!t.parent.children)return[];const i=s(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;i.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&i.push(d)}return i}e.getNodePath=s;function b(t){switch(t.type){case"array":return t.children.map(b);case"object":const i=Object.create(null);for(let d of t.children){const a=d.children[1];a&&(i[d.children[0].value]=b(a))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=b;function h(t,i,d=!1){return i>=t.offset&&i<t.offset+t.length||d&&i===t.offset+t.length}e.contains=h;function _(t,i,d=!1){if(h(t,i,d)){const a=t.children;if(Array.isArray(a))for(let l=0;l<a.length&&a[l].offset<=i;l++){const o=_(a[l],i,d);if(o)return o}return t}}e.findNodeAtOffset=_;function v(t,i,d=A.DEFAULT){const a=S(t,!1);function l(ye){return ye?()=>ye(a.getTokenOffset(),a.getTokenLength()):()=>!0}function o(ye){return ye?Pe=>ye(Pe,a.getTokenOffset(),a.getTokenLength()):()=>!0}const w=l(i.onObjectBegin),I=o(i.onObjectProperty),p=l(i.onObjectEnd),m=l(i.onArrayBegin),R=l(i.onArrayEnd),F=o(i.onLiteralValue),x=o(i.onSeparator),ae=l(i.onComment),z=o(i.onError),B=d&&d.disallowComments,G=d&&d.allowTrailingComma;function M(){for(;;){const ye=a.scan();switch(a.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:B||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(ye){case 12:case 13:B?N(10):ae();break;case 16:N(1);break;case 15:case 14:break;default:return ye}}}function N(ye,Pe=[],$e=[]){if(z(ye),Pe.length+$e.length>0){let Re=a.getToken();for(;Re!==17;){if(Pe.indexOf(Re)!==-1){M();break}else if($e.indexOf(Re)!==-1)break;Re=M()}}}function W(ye){const Pe=a.getTokenValue();return ye?F(Pe):I(Pe),M(),!0}function Q(){switch(a.getToken()){case 11:let ye=0;try{ye=JSON.parse(a.getTokenValue()),typeof ye!="number"&&(N(2),ye=0)}catch(Pe){N(2)}F(ye);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return M(),!0}function $(){return a.getToken()!==10?(N(3,[],[2,5]),!1):(W(!1),a.getToken()===6?(x(":"),M(),se()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function Z(){w(),M();let ye=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(ye||N(4,[],[]),x(","),M(),a.getToken()===2&&G)break}else ye&&N(6,[],[]);$()||N(4,[],[2,5]),ye=!0}return p(),a.getToken()!==2?N(7,[2],[]):M(),!0}function re(){m(),M();let ye=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(ye||N(4,[],[]),x(","),M(),a.getToken()===4&&G)break}else ye&&N(6,[],[]);se()||N(4,[],[4,5]),ye=!0}return R(),a.getToken()!==4?N(8,[4],[]):M(),!0}function se(){switch(a.getToken()){case 3:return re();case 1:return Z();case 10:return W(!0);default:return Q()}}return M(),a.getToken()===17?d.allowEmptyContent?!0:(N(4,[],[]),!1):se()?(a.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=v;function c(t,i){let d=S(t),a=[],l,o=0,w;do switch(w=d.getPosition(),l=d.scan(),l){case 12:case 13:case 17:o!==w&&a.push(t.substring(o,w)),i!==void 0&&a.push(d.getTokenValue().replace(/[^\r\n]/g,i)),o=d.getPosition();break}while(l!==17);return a.join("")}e.stripComments=c;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(ve[104],_e([0,1,43]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function k(y,n,T){let C,g,f,r,s;if(n){for(r=n.offset,s=r+n.length,f=r;f>0&&!D(y,f-1);)f--;let o=s;for(;o<y.length&&!D(y,o);)o++;g=y.substring(f,o),C=A(g,T)}else g=y,C=0,f=0,r=0,s=y.length;const b=S(T,y);let h=!1,_=0,v;T.insertSpaces?v=P(" ",T.tabSize||4):v="	";const c=(0,E.createScanner)(g,!1);let u=!1;function t(){return b+P(v,C+_)}function i(){let o=c.scan();for(h=!1;o===15||o===14;)h=h||o===14,o=c.scan();return u=o===16||c.getTokenError()!==0,o}const d=[];function a(o,w,I){!u&&w<s&&I>r&&y.substring(w,I)!==o&&d.push({offset:w,length:I-w,content:o})}let l=i();if(l!==17){const o=c.getTokenOffset()+f,w=P(v,C);a(w,f,o)}for(;l!==17;){let o=c.getTokenOffset()+c.getTokenLength()+f,w=i(),I="";for(;!h&&(w===12||w===13);){const m=c.getTokenOffset()+f;a(" ",o,m),o=c.getTokenOffset()+c.getTokenLength()+f,I=w===12?t():"",w=i()}if(w===2)l!==1&&(_--,I=t());else if(w===4)l!==3&&(_--,I=t());else{switch(l){case 3:case 1:_++,I=t();break;case 5:case 12:I=t();break;case 13:h?I=t():I=" ";break;case 6:I=" ";break;case 10:if(w===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:w===12||w===13?I=" ":w!==5&&w!==17&&(u=!0);break;case 16:u=!0;break}h&&(w===12||w===13)&&(I=t())}const p=c.getTokenOffset()+f;a(I,o,p),l=w}return d}e.format=k;function P(y,n){let T="";for(let C=0;C<n;C++)T+=y;return T}function A(y,n){let T=0,C=0;const g=n.tabSize||4;for(;T<y.length;){const f=y.charAt(T);if(f===" ")C++;else if(f==="	")C+=g;else break;T++}return Math.floor(C/g)}function S(y,n){for(let T=0;T<n.length;T++){const C=n.charAt(T);if(C==="\r")return T+1<n.length&&n.charAt(T+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=S;function D(y,n){return`\r
`.indexOf(y.charAt(n))!==-1}e.isEOL=D}),define(ve[105],_e([0,1,43,104]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function P(n,T,C){return A(n,T,void 0,C)}e.removeProperty=P;function A(n,T,C,g,f){const r=T.slice(),s=[],b=(0,E.parseTree)(n,s);let h,_;for(;r.length>0&&(_=r.pop(),h=(0,E.findNodeAtLocation)(b,r),h===void 0&&C!==void 0);)typeof _=="string"?C={[_]:C}:C=[C];if(h)if(h.type==="object"&&typeof _=="string"&&Array.isArray(h.children)){const v=(0,E.findNodeAtLocation)(h,[_]);if(v!==void 0)if(C===void 0){if(!v.parent)throw new Error("Malformed AST");const c=h.children.indexOf(v.parent);let u,t=v.parent.offset+v.parent.length;if(c>0){const i=h.children[c-1];u=i.offset+i.length}else u=h.offset+1,h.children.length>1&&(t=h.children[1].offset);return S(n,{offset:u,length:t-u,content:""},g)}else return S(n,{offset:v.offset,length:v.length,content:JSON.stringify(C)},g);else{if(C===void 0)return[];const c=`${JSON.stringify(_)}: ${JSON.stringify(C)}`,u=f?f(h.children.map(i=>i.children[0].value)):h.children.length;let t;if(u>0){const i=h.children[u-1];t={offset:i.offset+i.length,length:0,content:","+c}}else h.children.length===0?t={offset:h.offset+1,length:0,content:c}:t={offset:h.offset+1,length:0,content:c+","};return S(n,t,g)}}else if(h.type==="array"&&typeof _=="number"&&Array.isArray(h.children))if(C!==void 0){const v=`${JSON.stringify(C)}`;let c;if(h.children.length===0||_===0)c={offset:h.offset+1,length:0,content:h.children.length===0?v:v+","};else{const u=_===-1||_>h.children.length?h.children.length:_,t=h.children[u-1];c={offset:t.offset+t.length,length:0,content:","+v}}return S(n,c,g)}else{const v=_,c=h.children[v];let u;if(h.children.length===1)u={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===v){const t=h.children[v-1],i=t.offset+t.length,d=h.offset+h.length;u={offset:i,length:d-2-i,content:""}}else u={offset:c.offset,length:h.children[v+1].offset-c.offset,content:""};return S(n,u,g)}else throw new Error(`Can not add ${typeof _!="number"?"index":"property"} to parent of type ${h.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return S(n,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(C)},g)}}e.setProperty=A;function S(n,T,C){let g=D(n,T),f=T.offset,r=T.offset+T.content.length;if(T.length===0||T.content.length===0){for(;f>0&&!(0,k.isEOL)(g,f-1);)f--;for(;r<g.length&&!(0,k.isEOL)(g,r);)r++}const s=(0,k.format)(g,{offset:f,length:r-f},C);for(let h=s.length-1;h>=0;h--){const _=s[h];g=D(g,_),f=Math.min(f,_.offset),r=Math.max(r,_.offset+_.length),r+=_.content.length-_.length}const b=n.length-(g.length-r)-f;return[{offset:f,length:b,content:g.substring(f,r)}]}e.withFormatting=S;function D(n,T){return n.substring(0,T.offset)+T.content+n.substring(T.offset+T.length)}e.applyEdit=D;function y(n,T){let C=T.slice(0).sort((f,r)=>{const s=f.offset-r.offset;return s===0?f.length-r.length:s}),g=n.length;for(let f=C.length-1;f>=0;f--){let r=C[f];if(r.offset+r.length<=g)n=D(n,r);else throw new Error("Overlapping edit");g=r.offset}return n}e.applyEdits=y}),define(ve[106],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(P){this.executor=P,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(P){this._error=P}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(P){return new E(()=>P(this.getValue()))}}e.Lazy=E}),define(ve[6],_e([0,1,52,54]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const P=!1;let A=null;function S(v){A=v}if(e.setDisposableTracker=S,P){const v="__is_disposable_tracked__";A=new class{trackDisposable(c){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[v]||console.log(u)},3e3)}markTracked(c){if(c&&c!==s.None)try{c[v]=!0}catch(u){}}}}function D(v){!A||A.markTracked(v)}function y(v){return A&&A.trackDisposable(v),v}e.trackDisposable=y;class n extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=n;function T(v){return typeof v.dispose=="function"&&v.dispose.length===0}e.isDisposable=T;function C(v){if(k.Iterable.is(v)){let c=[];for(const u of v)if(u){D(u);try{u.dispose()}catch(t){c.push(t)}}if(c.length===1)throw c[0];if(c.length>1)throw new n(c);return Array.isArray(v)?[]:v}else if(v)return D(v),v.dispose(),v}e.dispose=C;function g(...v){return v.forEach(D),f(()=>C(v))}e.combinedDisposable=g;function f(v){const c=y({dispose:()=>{D(c),v()}});return c}e.toDisposable=f;class r{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{C(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return D(c),this._isDisposed?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=r,r.DISABLE_DISPOSED_WARNING=!1;class s{constructor(){this._store=new r,y(this)}dispose(){D(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=s,s.None=Object.freeze({dispose(){}});class b{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var u;this._isDisposed||c===this._value||((u=this._value)===null||u===void 0||u.dispose(),c&&D(c),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,D(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}}e.MutableDisposable=b;class h{constructor(){this.references=new Map}acquire(c,...u){let t=this.references.get(c);t||(t={counter:0,object:this.createReferencedObject(c,...u)},this.references.set(c,t));const{object:i}=t,d=(0,E.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(c,t.object),this.references.delete(c))});return t.counter++,{object:i,dispose:d}}}e.ReferenceCollection=h;class _{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=_}),define(ve[44],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(A){this.element=A,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class k{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,S){const D=new E(A);if(this._first===E.Undefined)this._first=D,this._last=D;else if(S){const n=this._last;this._last=D,D.prev=n,n.next=D}else{const n=this._first;this._first=D,D.next=n,n.prev=D}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(D))}}shift(){if(this._first!==E.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==E.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==E.Undefined&&A.next!==E.Undefined){const S=A.prev;S.next=A.next,A.next.prev=S}else A.prev===E.Undefined&&A.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):A.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):A.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==E.Undefined;)yield A.element,A=A.next}}e.LinkedList=k}),function(ie,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ie=typeof globalThis!="undefined"?globalThis:ie||self,ie.marked=e())}(this,function(){"use strict";function ie(H,ne){for(var he=0;he<ne.length;he++){var q=ne[he];q.enumerable=q.enumerable||!1,q.configurable=!0,"value"in q&&(q.writable=!0),Object.defineProperty(H,q.key,q)}}function e(H,ne,he){return ne&&ie(H.prototype,ne),he&&ie(H,he),H}function E(H,ne){if(!!H){if(typeof H=="string")return k(H,ne);var he=Object.prototype.toString.call(H).slice(8,-1);if(he==="Object"&&H.constructor&&(he=H.constructor.name),he==="Map"||he==="Set")return Array.from(H);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return k(H,ne)}}function k(H,ne){(ne==null||ne>H.length)&&(ne=H.length);for(var he=0,q=new Array(ne);he<ne;he++)q[he]=H[he];return q}function P(H,ne){var he;if(typeof Symbol=="undefined"||H[Symbol.iterator]==null){if(Array.isArray(H)||(he=E(H))||ne&&H&&typeof H.length=="number"){he&&(H=he);var q=0;return function(){return q>=H.length?{done:!0}:{done:!1,value:H[q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return he=H[Symbol.iterator](),he.next.bind(he)}function A(H){var ne={exports:{}};return H(ne,ne.exports),ne.exports}var S=A(function(H){function ne(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function he(q){H.exports.defaults=q}H.exports={defaults:ne(),getDefaults:ne,changeDefaults:he}}),D=/[&<>"']/,y=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},g=function(ne){return C[ne]};function f(H,ne){if(ne){if(D.test(H))return H.replace(y,g)}else if(n.test(H))return H.replace(T,g);return H}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(H){return H.replace(r,function(ne,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var b=/(^|[^\[])\^/g;function h(H,ne){H=H.source||H,ne=ne||"";var he={replace:function(Y,oe){return oe=oe.source||oe,oe=oe.replace(b,"$1"),H=H.replace(Y,oe),he},getRegex:function(){return new RegExp(H,ne)}};return he}var _=/[^\w:]/g,v=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(H,ne,he){if(H){var q;try{q=decodeURIComponent(s(he)).replace(_,"").toLowerCase()}catch(Y){return null}if(q.indexOf("javascript:")===0||q.indexOf("vbscript:")===0||q.indexOf("data:")===0)return null}ne&&!v.test(he)&&(he=a(ne,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch(Y){return null}return he}var u={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(H,ne){u[" "+H]||(t.test(H)?u[" "+H]=H+"/":u[" "+H]=I(H,"/",!0)),H=u[" "+H];var he=H.indexOf(":")===-1;return ne.substring(0,2)==="//"?he?ne:H.replace(i,"$1")+ne:ne.charAt(0)==="/"?he?ne:H.replace(d,"$1")+ne:H+ne}var l={exec:function(){}};function o(H){for(var ne=1,he,q;ne<arguments.length;ne++){he=arguments[ne];for(q in he)Object.prototype.hasOwnProperty.call(he,q)&&(H[q]=he[q])}return H}function w(H,ne){var he=H.replace(/\|/g,function(oe,fe,Ee){for(var Ne=!1,Fe=fe;--Fe>=0&&Ee[Fe]==="\\";)Ne=!Ne;return Ne?"|":" |"}),q=he.split(/ \|/),Y=0;if(q.length>ne)q.splice(ne);else for(;q.length<ne;)q.push("");for(;Y<q.length;Y++)q[Y]=q[Y].trim().replace(/\\\|/g,"|");return q}function I(H,ne,he){var q=H.length;if(q===0)return"";for(var Y=0;Y<q;){var oe=H.charAt(q-Y-1);if(oe===ne&&!he)Y++;else if(oe!==ne&&he)Y++;else break}return H.substr(0,q-Y)}function p(H,ne){if(H.indexOf(ne[1])===-1)return-1;for(var he=H.length,q=0,Y=0;Y<he;Y++)if(H[Y]==="\\")Y++;else if(H[Y]===ne[0])q++;else if(H[Y]===ne[1]&&(q--,q<0))return Y;return-1}function m(H){H&&H.sanitize&&!H.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(H,ne){if(ne<1)return"";for(var he="";ne>1;)ne&1&&(he+=H),ne>>=1,H+=H;return he+H}var F={escape:f,unescape:s,edit:h,cleanUrl:c,resolveUrl:a,noopTest:l,merge:o,splitCells:w,rtrim:I,findClosingBracket:p,checkSanitizeDeprecation:m,repeatString:R},x=S.defaults,ae=F.rtrim,z=F.splitCells,B=F.escape,G=F.findClosingBracket;function M(H,ne,he){var q=ne.href,Y=ne.title?B(ne.title):null,oe=H[1].replace(/\\([\[\]])/g,"$1");return H[0].charAt(0)!=="!"?{type:"link",raw:he,href:q,title:Y,text:oe}:{type:"image",raw:he,href:q,title:Y,text:B(oe)}}function N(H,ne){var he=H.match(/^(\s+)(?:```)/);if(he===null)return ne;var q=he[1];return ne.split(`
`).map(function(Y){var oe=Y.match(/^\s+/);if(oe===null)return Y;var fe=oe[0];return fe.length>=q.length?Y.slice(q.length):Y}).join(`
`)}var W=function(){function H(he){this.options=he||x}var ne=H.prototype;return ne.space=function(q){var Y=this.rules.block.newline.exec(q);if(Y)return Y[0].length>1?{type:"space",raw:Y[0]}:{raw:`
`}},ne.code=function(q){var Y=this.rules.block.code.exec(q);if(Y){var oe=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?oe:ae(oe,`
`)}}},ne.fences=function(q){var Y=this.rules.block.fences.exec(q);if(Y){var oe=Y[0],fe=N(oe,Y[3]||"");return{type:"code",raw:oe,lang:Y[2]?Y[2].trim():Y[2],text:fe}}},ne.heading=function(q){var Y=this.rules.block.heading.exec(q);if(Y){var oe=Y[2].trim();if(/#$/.test(oe)){var fe=ae(oe,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(oe=fe.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:oe}}},ne.nptable=function(q){var Y=this.rules.block.nptable.exec(q);if(Y){var oe={type:"table",header:z(Y[1].replace(/^ *| *\| *$/g,"")),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:Y[3]?Y[3].replace(/\n$/,"").split(`
`):[],raw:Y[0]};if(oe.header.length===oe.align.length){var fe=oe.align.length,Ee;for(Ee=0;Ee<fe;Ee++)/^ *-+: *$/.test(oe.align[Ee])?oe.align[Ee]="right":/^ *:-+: *$/.test(oe.align[Ee])?oe.align[Ee]="center":/^ *:-+ *$/.test(oe.align[Ee])?oe.align[Ee]="left":oe.align[Ee]=null;for(fe=oe.cells.length,Ee=0;Ee<fe;Ee++)oe.cells[Ee]=z(oe.cells[Ee],oe.header.length);return oe}}},ne.hr=function(q){var Y=this.rules.block.hr.exec(q);if(Y)return{type:"hr",raw:Y[0]}},ne.blockquote=function(q){var Y=this.rules.block.blockquote.exec(q);if(Y){var oe=Y[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:Y[0],text:oe}}},ne.list=function(q){var Y=this.rules.block.list.exec(q);if(Y){var oe=Y[0],fe=Y[2],Ee=fe.length>1,Ne={type:"list",raw:oe,ordered:Ee,start:Ee?+fe.slice(0,-1):"",loose:!1,items:[]},Fe=Y[0].match(this.rules.block.item),Ve=!1,Xe,tt,nt,rt,it,gt,ce,De,ue=Fe.length;nt=this.rules.block.listItemStart.exec(Fe[0]);for(var V=0;V<ue;V++){if(Xe=Fe[V],oe=Xe,V!==ue-1){if(rt=this.rules.block.listItemStart.exec(Fe[V+1]),this.options.pedantic?rt[1].length>nt[1].length:rt[1].length>nt[0].length||rt[1].length>3){Fe.splice(V,2,Fe[V]+`
`+Fe[V+1]),V--,ue--;continue}else(!this.options.pedantic||this.options.smartLists?rt[2][rt[2].length-1]!==fe[fe.length-1]:Ee===(rt[2].length===1))&&(it=Fe.slice(V+1).join(`
`),Ne.raw=Ne.raw.substring(0,Ne.raw.length-it.length),V=ue-1);nt=rt}tt=Xe.length,Xe=Xe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Xe.indexOf(`
 `)&&(tt-=Xe.length,Xe=this.options.pedantic?Xe.replace(/^ {1,4}/gm,""):Xe.replace(new RegExp("^ {1,"+tt+"}","gm"),"")),gt=Ve||/\n\n(?!\s*$)/.test(Xe),V!==ue-1&&(Ve=Xe.charAt(Xe.length-1)===`
`,gt||(gt=Ve)),gt&&(Ne.loose=!0),this.options.gfm&&(ce=/^\[[ xX]\] /.test(Xe),De=void 0,ce&&(De=Xe[1]!==" ",Xe=Xe.replace(/^\[[ xX]\] +/,""))),Ne.items.push({type:"list_item",raw:oe,task:ce,checked:De,loose:gt,text:Xe})}return Ne}},ne.html=function(q){var Y=this.rules.block.html.exec(q);if(Y)return{type:this.options.sanitize?"paragraph":"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):B(Y[0]):Y[0]}},ne.def=function(q){var Y=this.rules.block.def.exec(q);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var oe=Y[1].toLowerCase().replace(/\s+/g," ");return{tag:oe,raw:Y[0],href:Y[2],title:Y[3]}}},ne.table=function(q){var Y=this.rules.block.table.exec(q);if(Y){var oe={type:"table",header:z(Y[1].replace(/^ *| *\| *$/g,"")),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:Y[3]?Y[3].replace(/\n$/,"").split(`
`):[]};if(oe.header.length===oe.align.length){oe.raw=Y[0];var fe=oe.align.length,Ee;for(Ee=0;Ee<fe;Ee++)/^ *-+: *$/.test(oe.align[Ee])?oe.align[Ee]="right":/^ *:-+: *$/.test(oe.align[Ee])?oe.align[Ee]="center":/^ *:-+ *$/.test(oe.align[Ee])?oe.align[Ee]="left":oe.align[Ee]=null;for(fe=oe.cells.length,Ee=0;Ee<fe;Ee++)oe.cells[Ee]=z(oe.cells[Ee].replace(/^ *\| *| *\| *$/g,""),oe.header.length);return oe}}},ne.lheading=function(q){var Y=this.rules.block.lheading.exec(q);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1]}},ne.paragraph=function(q){var Y=this.rules.block.paragraph.exec(q);if(Y)return{type:"paragraph",raw:Y[0],text:Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1]}},ne.text=function(q){var Y=this.rules.block.text.exec(q);if(Y)return{type:"text",raw:Y[0],text:Y[0]}},ne.escape=function(q){var Y=this.rules.inline.escape.exec(q);if(Y)return{type:"escape",raw:Y[0],text:B(Y[1])}},ne.tag=function(q,Y,oe){var fe=this.rules.inline.tag.exec(q);if(fe)return!Y&&/^<a /i.test(fe[0])?Y=!0:Y&&/^<\/a>/i.test(fe[0])&&(Y=!1),!oe&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?oe=!0:oe&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(oe=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:Y,inRawBlock:oe,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):B(fe[0]):fe[0]}},ne.link=function(q){var Y=this.rules.inline.link.exec(q);if(Y){var oe=Y[2].trim();if(!this.options.pedantic&&/^</.test(oe)){if(!/>$/.test(oe))return;var fe=ae(oe.slice(0,-1),"\\");if((oe.length-fe.length)%2==0)return}else{var Ee=G(Y[2],"()");if(Ee>-1){var Ne=Y[0].indexOf("!")===0?5:4,Fe=Ne+Y[1].length+Ee;Y[2]=Y[2].substring(0,Ee),Y[0]=Y[0].substring(0,Fe).trim(),Y[3]=""}}var Ve=Y[2],Xe="";if(this.options.pedantic){var tt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ve);tt&&(Ve=tt[1],Xe=tt[3])}else Xe=Y[3]?Y[3].slice(1,-1):"";return Ve=Ve.trim(),/^</.test(Ve)&&(this.options.pedantic&&!/>$/.test(oe)?Ve=Ve.slice(1):Ve=Ve.slice(1,-1)),M(Y,{href:Ve&&Ve.replace(this.rules.inline._escapes,"$1"),title:Xe&&Xe.replace(this.rules.inline._escapes,"$1")},Y[0])}},ne.reflink=function(q,Y){var oe;if((oe=this.rules.inline.reflink.exec(q))||(oe=this.rules.inline.nolink.exec(q))){var fe=(oe[2]||oe[1]).replace(/\s+/g," ");if(fe=Y[fe.toLowerCase()],!fe||!fe.href){var Ee=oe[0].charAt(0);return{type:"text",raw:Ee,text:Ee}}return M(oe,fe,oe[0])}},ne.emStrong=function(q,Y,oe){oe===void 0&&(oe="");var fe=this.rules.inline.emStrong.lDelim.exec(q);if(!!fe&&!(fe[3]&&oe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ee=fe[1]||fe[2]||"";if(!Ee||Ee&&(oe===""||this.rules.inline.punctuation.exec(oe))){var Ne=fe[0].length-1,Fe,Ve,Xe=Ne,tt=0,nt=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(nt.lastIndex=0,Y=Y.slice(-1*q.length+Ne);(fe=nt.exec(Y))!=null;)if(Fe=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Fe){if(Ve=Fe.length,fe[3]||fe[4]){Xe+=Ve;continue}else if((fe[5]||fe[6])&&Ne%3&&!((Ne+Ve)%3)){tt+=Ve;continue}if(Xe-=Ve,!(Xe>0)){if(Xe+tt-Ve<=0&&!Y.slice(nt.lastIndex).match(nt)&&(Ve=Math.min(Ve,Ve+Xe+tt)),Math.min(Ne,Ve)%2)return{type:"em",raw:q.slice(0,Ne+fe.index+Ve+1),text:q.slice(1,Ne+fe.index+Ve)};if(Math.min(Ne,Ve)%2==0)return{type:"strong",raw:q.slice(0,Ne+fe.index+Ve+1),text:q.slice(2,Ne+fe.index+Ve-1)}}}}}},ne.codespan=function(q){var Y=this.rules.inline.code.exec(q);if(Y){var oe=Y[2].replace(/\n/g," "),fe=/[^ ]/.test(oe),Ee=/^ /.test(oe)&&/ $/.test(oe);return fe&&Ee&&(oe=oe.substring(1,oe.length-1)),oe=B(oe,!0),{type:"codespan",raw:Y[0],text:oe}}},ne.br=function(q){var Y=this.rules.inline.br.exec(q);if(Y)return{type:"br",raw:Y[0]}},ne.del=function(q){var Y=this.rules.inline.del.exec(q);if(Y)return{type:"del",raw:Y[0],text:Y[2]}},ne.autolink=function(q,Y){var oe=this.rules.inline.autolink.exec(q);if(oe){var fe,Ee;return oe[2]==="@"?(fe=B(this.options.mangle?Y(oe[1]):oe[1]),Ee="mailto:"+fe):(fe=B(oe[1]),Ee=fe),{type:"link",raw:oe[0],text:fe,href:Ee,tokens:[{type:"text",raw:fe,text:fe}]}}},ne.url=function(q,Y){var oe;if(oe=this.rules.inline.url.exec(q)){var fe,Ee;if(oe[2]==="@")fe=B(this.options.mangle?Y(oe[0]):oe[0]),Ee="mailto:"+fe;else{var Ne;do Ne=oe[0],oe[0]=this.rules.inline._backpedal.exec(oe[0])[0];while(Ne!==oe[0]);fe=B(oe[0]),oe[1]==="www."?Ee="http://"+fe:Ee=fe}return{type:"link",raw:oe[0],text:fe,href:Ee,tokens:[{type:"text",raw:fe,text:fe}]}}},ne.inlineText=function(q,Y,oe){var fe=this.rules.inline.text.exec(q);if(fe){var Ee;return Y?Ee=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):B(fe[0]):fe[0]:Ee=B(this.options.smartypants?oe(fe[0]):fe[0]),{type:"text",raw:fe[0],text:Ee}}},H}(),Q=F.noopTest,$=F.edit,Z=F.merge,re={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:Q,table:Q,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};re._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,re._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,re.def=$(re.def).replace("label",re._label).replace("title",re._title).getRegex(),re.bullet=/(?:[*+-]|\d{1,9}[.)])/,re.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,re.item=$(re.item,"gm").replace(/bull/g,re.bullet).getRegex(),re.listItemStart=$(/^( *)(bull)/).replace("bull",re.bullet).getRegex(),re.list=$(re.list).replace(/bull/g,re.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+re.def.source+")").getRegex(),re._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",re._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,re.html=$(re.html,"i").replace("comment",re._comment).replace("tag",re._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),re.paragraph=$(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",re._tag).getRegex(),re.blockquote=$(re.blockquote).replace("paragraph",re.paragraph).getRegex(),re.normal=Z({},re),re.gfm=Z({},re.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),re.gfm.nptable=$(re.gfm.nptable).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",re._tag).getRegex(),re.gfm.table=$(re.gfm.table).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",re._tag).getRegex(),re.pedantic=Z({},re.normal,{html:$(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",re._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:Q,paragraph:$(re.normal._paragraph).replace("hr",re.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",re.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var se={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:Q,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:Q,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};se._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",se.punctuation=$(se.punctuation).replace(/punctuation/g,se._punctuation).getRegex(),se.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,se.escapedEmSt=/\\\*|\\_/g,se._comment=$(re._comment).replace("(?:-->|$)","-->").getRegex(),se.emStrong.lDelim=$(se.emStrong.lDelim).replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimAst=$(se.emStrong.rDelimAst,"g").replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimUnd=$(se.emStrong.rDelimUnd,"g").replace(/punct/g,se._punctuation).getRegex(),se._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,se._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,se._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,se.autolink=$(se.autolink).replace("scheme",se._scheme).replace("email",se._email).getRegex(),se._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,se.tag=$(se.tag).replace("comment",se._comment).replace("attribute",se._attribute).getRegex(),se._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,se._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,se._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,se.link=$(se.link).replace("label",se._label).replace("href",se._href).replace("title",se._title).getRegex(),se.reflink=$(se.reflink).replace("label",se._label).getRegex(),se.reflinkSearch=$(se.reflinkSearch,"g").replace("reflink",se.reflink).replace("nolink",se.nolink).getRegex(),se.normal=Z({},se),se.pedantic=Z({},se.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:$(/^!?\[(label)\]\((.*?)\)/).replace("label",se._label).getRegex(),reflink:$(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",se._label).getRegex()}),se.gfm=Z({},se.normal,{escape:$(se.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),se.gfm.url=$(se.gfm.url,"i").replace("email",se.gfm._extended_email).getRegex(),se.breaks=Z({},se.gfm,{br:$(se.br).replace("{2,}","*").getRegex(),text:$(se.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ye={block:re,inline:se},Pe=S.defaults,$e=ye.block,Re=ye.inline,ze=F.repeatString;function U(H){return H.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(H){var ne="",he,q,Y=H.length;for(he=0;he<Y;he++)q=H.charCodeAt(he),Math.random()>.5&&(q="x"+q.toString(16)),ne+="&#"+q+";";return ne}var te=function(){function H(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||Pe,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var q={block:$e.normal,inline:Re.normal};this.options.pedantic?(q.block=$e.pedantic,q.inline=Re.pedantic):this.options.gfm&&(q.block=$e.gfm,this.options.breaks?q.inline=Re.breaks:q.inline=Re.gfm),this.tokenizer.rules=q}H.lex=function(q,Y){var oe=new H(Y);return oe.lex(q)},H.lexInline=function(q,Y){var oe=new H(Y);return oe.inlineTokens(q)};var ne=H.prototype;return ne.lex=function(q){return q=q.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(q,this.tokens,!0),this.inline(this.tokens),this.tokens},ne.blockTokens=function(q,Y,oe){Y===void 0&&(Y=[]),oe===void 0&&(oe=!0),this.options.pedantic&&(q=q.replace(/^ +$/gm,""));for(var fe,Ee,Ne,Fe;q;){if(fe=this.tokenizer.space(q)){q=q.substring(fe.raw.length),fe.type&&Y.push(fe);continue}if(fe=this.tokenizer.code(q)){q=q.substring(fe.raw.length),Fe=Y[Y.length-1],Fe&&Fe.type==="paragraph"?(Fe.raw+=`
`+fe.raw,Fe.text+=`
`+fe.text):Y.push(fe);continue}if(fe=this.tokenizer.fences(q)){q=q.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.heading(q)){q=q.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.nptable(q)){q=q.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.hr(q)){q=q.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.blockquote(q)){q=q.substring(fe.raw.length),fe.tokens=this.blockTokens(fe.text,[],oe),Y.push(fe);continue}if(fe=this.tokenizer.list(q)){for(q=q.substring(fe.raw.length),Ne=fe.items.length,Ee=0;Ee<Ne;Ee++)fe.items[Ee].tokens=this.blockTokens(fe.items[Ee].text,[],!1);Y.push(fe);continue}if(fe=this.tokenizer.html(q)){q=q.substring(fe.raw.length),Y.push(fe);continue}if(oe&&(fe=this.tokenizer.def(q))){q=q.substring(fe.raw.length),this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(q)){q=q.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.lheading(q)){q=q.substring(fe.raw.length),Y.push(fe);continue}if(oe&&(fe=this.tokenizer.paragraph(q))){q=q.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.text(q)){q=q.substring(fe.raw.length),Fe=Y[Y.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+fe.raw,Fe.text+=`
`+fe.text):Y.push(fe);continue}if(q){var Ve="Infinite loop on byte: "+q.charCodeAt(0);if(this.options.silent){console.error(Ve);break}else throw new Error(Ve)}}return Y},ne.inline=function(q){var Y,oe,fe,Ee,Ne,Fe,Ve=q.length;for(Y=0;Y<Ve;Y++)switch(Fe=q[Y],Fe.type){case"paragraph":case"text":case"heading":{Fe.tokens=[],this.inlineTokens(Fe.text,Fe.tokens);break}case"table":{for(Fe.tokens={header:[],cells:[]},Ee=Fe.header.length,oe=0;oe<Ee;oe++)Fe.tokens.header[oe]=[],this.inlineTokens(Fe.header[oe],Fe.tokens.header[oe]);for(Ee=Fe.cells.length,oe=0;oe<Ee;oe++)for(Ne=Fe.cells[oe],Fe.tokens.cells[oe]=[],fe=0;fe<Ne.length;fe++)Fe.tokens.cells[oe][fe]=[],this.inlineTokens(Ne[fe],Fe.tokens.cells[oe][fe]);break}case"blockquote":{this.inline(Fe.tokens);break}case"list":{for(Ee=Fe.items.length,oe=0;oe<Ee;oe++)this.inline(Fe.items[oe].tokens);break}}return q},ne.inlineTokens=function(q,Y,oe,fe){Y===void 0&&(Y=[]),oe===void 0&&(oe=!1),fe===void 0&&(fe=!1);var Ee,Ne,Fe=q,Ve,Xe,tt;if(this.tokens.links){var nt=Object.keys(this.tokens.links);if(nt.length>0)for(;(Ve=this.tokenizer.rules.inline.reflinkSearch.exec(Fe))!=null;)nt.includes(Ve[0].slice(Ve[0].lastIndexOf("[")+1,-1))&&(Fe=Fe.slice(0,Ve.index)+"["+ze("a",Ve[0].length-2)+"]"+Fe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ve=this.tokenizer.rules.inline.blockSkip.exec(Fe))!=null;)Fe=Fe.slice(0,Ve.index)+"["+ze("a",Ve[0].length-2)+"]"+Fe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ve=this.tokenizer.rules.inline.escapedEmSt.exec(Fe))!=null;)Fe=Fe.slice(0,Ve.index)+"++"+Fe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;q;){if(Xe||(tt=""),Xe=!1,Ee=this.tokenizer.escape(q)){q=q.substring(Ee.raw.length),Y.push(Ee);continue}if(Ee=this.tokenizer.tag(q,oe,fe)){q=q.substring(Ee.raw.length),oe=Ee.inLink,fe=Ee.inRawBlock;var rt=Y[Y.length-1];rt&&Ee.type==="text"&&rt.type==="text"?(rt.raw+=Ee.raw,rt.text+=Ee.text):Y.push(Ee);continue}if(Ee=this.tokenizer.link(q)){q=q.substring(Ee.raw.length),Ee.type==="link"&&(Ee.tokens=this.inlineTokens(Ee.text,[],!0,fe)),Y.push(Ee);continue}if(Ee=this.tokenizer.reflink(q,this.tokens.links)){q=q.substring(Ee.raw.length);var it=Y[Y.length-1];Ee.type==="link"?(Ee.tokens=this.inlineTokens(Ee.text,[],!0,fe),Y.push(Ee)):it&&Ee.type==="text"&&it.type==="text"?(it.raw+=Ee.raw,it.text+=Ee.text):Y.push(Ee);continue}if(Ee=this.tokenizer.emStrong(q,Fe,tt)){q=q.substring(Ee.raw.length),Ee.tokens=this.inlineTokens(Ee.text,[],oe,fe),Y.push(Ee);continue}if(Ee=this.tokenizer.codespan(q)){q=q.substring(Ee.raw.length),Y.push(Ee);continue}if(Ee=this.tokenizer.br(q)){q=q.substring(Ee.raw.length),Y.push(Ee);continue}if(Ee=this.tokenizer.del(q)){q=q.substring(Ee.raw.length),Ee.tokens=this.inlineTokens(Ee.text,[],oe,fe),Y.push(Ee);continue}if(Ee=this.tokenizer.autolink(q,K)){q=q.substring(Ee.raw.length),Y.push(Ee);continue}if(!oe&&(Ee=this.tokenizer.url(q,K))){q=q.substring(Ee.raw.length),Y.push(Ee);continue}if(Ee=this.tokenizer.inlineText(q,fe,U)){q=q.substring(Ee.raw.length),Ee.raw.slice(-1)!=="_"&&(tt=Ee.raw.slice(-1)),Xe=!0,Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=Ee.raw,Ne.text+=Ee.text):Y.push(Ee);continue}if(q){var gt="Infinite loop on byte: "+q.charCodeAt(0);if(this.options.silent){console.error(gt);break}else throw new Error(gt)}}return Y},e(H,null,[{key:"rules",get:function(){return{block:$e,inline:Re}}}]),H}(),le=S.defaults,me=F.cleanUrl,Se=F.escape,Me=function(){function H(he){this.options=he||le}var ne=H.prototype;return ne.code=function(q,Y,oe){var fe=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Ee=this.options.highlight(q,fe);Ee!=null&&Ee!==q&&(oe=!0,q=Ee)}return q=q.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+Se(fe,!0)+'">'+(oe?q:Se(q,!0))+`</code></pre>
`:"<pre><code>"+(oe?q:Se(q,!0))+`</code></pre>
`},ne.blockquote=function(q){return`<blockquote>
`+q+`</blockquote>
`},ne.html=function(q){return q},ne.heading=function(q,Y,oe,fe){return this.options.headerIds?"<h"+Y+' id="'+this.options.headerPrefix+fe.slug(oe)+'">'+q+"</h"+Y+`>
`:"<h"+Y+">"+q+"</h"+Y+`>
`},ne.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ne.list=function(q,Y,oe){var fe=Y?"ol":"ul",Ee=Y&&oe!==1?' start="'+oe+'"':"";return"<"+fe+Ee+`>
`+q+"</"+fe+`>
`},ne.listitem=function(q){return"<li>"+q+`</li>
`},ne.checkbox=function(q){return"<input "+(q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ne.paragraph=function(q){return"<p>"+q+`</p>
`},ne.table=function(q,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+q+`</thead>
`+Y+`</table>
`},ne.tablerow=function(q){return`<tr>
`+q+`</tr>
`},ne.tablecell=function(q,Y){var oe=Y.header?"th":"td",fe=Y.align?"<"+oe+' align="'+Y.align+'">':"<"+oe+">";return fe+q+"</"+oe+`>
`},ne.strong=function(q){return"<strong>"+q+"</strong>"},ne.em=function(q){return"<em>"+q+"</em>"},ne.codespan=function(q){return"<code>"+q+"</code>"},ne.br=function(){return this.options.xhtml?"<br/>":"<br>"},ne.del=function(q){return"<del>"+q+"</del>"},ne.link=function(q,Y,oe){if(q=me(this.options.sanitize,this.options.baseUrl,q),q===null)return oe;var fe='<a href="'+Se(q)+'"';return Y&&(fe+=' title="'+Y+'"'),fe+=">"+oe+"</a>",fe},ne.image=function(q,Y,oe){if(q=me(this.options.sanitize,this.options.baseUrl,q),q===null)return oe;var fe='<img src="'+q+'" alt="'+oe+'"';return Y&&(fe+=' title="'+Y+'"'),fe+=this.options.xhtml?"/>":">",fe},ne.text=function(q){return q},H}(),ge=function(){function H(){}var ne=H.prototype;return ne.strong=function(q){return q},ne.em=function(q){return q},ne.codespan=function(q){return q},ne.del=function(q){return q},ne.html=function(q){return q},ne.text=function(q){return q},ne.link=function(q,Y,oe){return""+oe},ne.image=function(q,Y,oe){return""+oe},ne.br=function(){return""},H}(),Ce=function(){function H(){this.seen={}}var ne=H.prototype;return ne.serialize=function(q){return q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ne.getNextSafeSlug=function(q,Y){var oe=q,fe=0;if(this.seen.hasOwnProperty(oe)){fe=this.seen[q];do fe++,oe=q+"-"+fe;while(this.seen.hasOwnProperty(oe))}return Y||(this.seen[q]=fe,this.seen[oe]=0),oe},ne.slug=function(q,Y){Y===void 0&&(Y={});var oe=this.serialize(q);return this.getNextSafeSlug(oe,Y.dryrun)},H}(),Ae=S.defaults,Be=F.unescape,be=function(){function H(he){this.options=he||Ae,this.options.renderer=this.options.renderer||new Me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ge,this.slugger=new Ce}H.parse=function(q,Y){var oe=new H(Y);return oe.parse(q)},H.parseInline=function(q,Y){var oe=new H(Y);return oe.parseInline(q)};var ne=H.prototype;return ne.parse=function(q,Y){Y===void 0&&(Y=!0);var oe="",fe,Ee,Ne,Fe,Ve,Xe,tt,nt,rt,it,gt,ce,De,ue,V,Oe,Ie,Je,Ge=q.length;for(fe=0;fe<Ge;fe++)switch(it=q[fe],it.type){case"space":continue;case"hr":{oe+=this.renderer.hr();continue}case"heading":{oe+=this.renderer.heading(this.parseInline(it.tokens),it.depth,Be(this.parseInline(it.tokens,this.textRenderer)),this.slugger);continue}case"code":{oe+=this.renderer.code(it.text,it.lang,it.escaped);continue}case"table":{for(nt="",tt="",Fe=it.header.length,Ee=0;Ee<Fe;Ee++)tt+=this.renderer.tablecell(this.parseInline(it.tokens.header[Ee]),{header:!0,align:it.align[Ee]});for(nt+=this.renderer.tablerow(tt),rt="",Fe=it.cells.length,Ee=0;Ee<Fe;Ee++){for(Xe=it.tokens.cells[Ee],tt="",Ve=Xe.length,Ne=0;Ne<Ve;Ne++)tt+=this.renderer.tablecell(this.parseInline(Xe[Ne]),{header:!1,align:it.align[Ne]});rt+=this.renderer.tablerow(tt)}oe+=this.renderer.table(nt,rt);continue}case"blockquote":{rt=this.parse(it.tokens),oe+=this.renderer.blockquote(rt);continue}case"list":{for(gt=it.ordered,ce=it.start,De=it.loose,Fe=it.items.length,rt="",Ee=0;Ee<Fe;Ee++)V=it.items[Ee],Oe=V.checked,Ie=V.task,ue="",V.task&&(Je=this.renderer.checkbox(Oe),De?V.tokens.length>0&&V.tokens[0].type==="text"?(V.tokens[0].text=Je+" "+V.tokens[0].text,V.tokens[0].tokens&&V.tokens[0].tokens.length>0&&V.tokens[0].tokens[0].type==="text"&&(V.tokens[0].tokens[0].text=Je+" "+V.tokens[0].tokens[0].text)):V.tokens.unshift({type:"text",text:Je}):ue+=Je),ue+=this.parse(V.tokens,De),rt+=this.renderer.listitem(ue,Ie,Oe);oe+=this.renderer.list(rt,gt,ce);continue}case"html":{oe+=this.renderer.html(it.text);continue}case"paragraph":{oe+=this.renderer.paragraph(this.parseInline(it.tokens));continue}case"text":{for(rt=it.tokens?this.parseInline(it.tokens):it.text;fe+1<Ge&&q[fe+1].type==="text";)it=q[++fe],rt+=`
`+(it.tokens?this.parseInline(it.tokens):it.text);oe+=Y?this.renderer.paragraph(rt):rt;continue}default:{var lt='Token with "'+it.type+'" type was not found.';if(this.options.silent){console.error(lt);return}else throw new Error(lt)}}return oe},ne.parseInline=function(q,Y){Y=Y||this.renderer;var oe="",fe,Ee,Ne=q.length;for(fe=0;fe<Ne;fe++)switch(Ee=q[fe],Ee.type){case"escape":{oe+=Y.text(Ee.text);break}case"html":{oe+=Y.html(Ee.text);break}case"link":{oe+=Y.link(Ee.href,Ee.title,this.parseInline(Ee.tokens,Y));break}case"image":{oe+=Y.image(Ee.href,Ee.title,Ee.text);break}case"strong":{oe+=Y.strong(this.parseInline(Ee.tokens,Y));break}case"em":{oe+=Y.em(this.parseInline(Ee.tokens,Y));break}case"codespan":{oe+=Y.codespan(Ee.text);break}case"br":{oe+=Y.br();break}case"del":{oe+=Y.del(this.parseInline(Ee.tokens,Y));break}case"text":{oe+=Y.text(Ee.text);break}default:{var Fe='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(Fe);return}else throw new Error(Fe)}}return oe},H}(),qe=F.merge,j=F.checkSanitizeDeprecation,X=F.escape,pe=S.getDefaults,Le=S.changeDefaults,He=S.defaults;function Ue(H,ne,he){if(typeof H=="undefined"||H===null)throw new Error("marked(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");if(typeof ne=="function"&&(he=ne,ne=null),ne=qe({},Ue.defaults,ne||{}),j(ne),he){var q=ne.highlight,Y;try{Y=te.lex(H,ne)}catch(Ne){return he(Ne)}var oe=function(Fe){var Ve;if(!Fe)try{Ve=be.parse(Y,ne)}catch(Xe){Fe=Xe}return ne.highlight=q,Fe?he(Fe):he(null,Ve)};if(!q||q.length<3||(delete ne.highlight,!Y.length))return oe();var fe=0;Ue.walkTokens(Y,function(Ne){Ne.type==="code"&&(fe++,setTimeout(function(){q(Ne.text,Ne.lang,function(Fe,Ve){if(Fe)return oe(Fe);Ve!=null&&Ve!==Ne.text&&(Ne.text=Ve,Ne.escaped=!0),fe--,fe===0&&oe()})},0))}),fe===0&&oe();return}try{var Ee=te.lex(H,ne);return ne.walkTokens&&Ue.walkTokens(Ee,ne.walkTokens),be.parse(Ee,ne)}catch(Ne){if(Ne.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+X(Ne.message+"",!0)+"</pre>";throw Ne}}Ue.options=Ue.setOptions=function(H){return qe(Ue.defaults,H),Le(Ue.defaults),Ue},Ue.getDefaults=pe,Ue.defaults=He,Ue.use=function(H){var ne=qe({},H);if(H.renderer&&function(){var q=Ue.defaults.renderer||new Me,Y=function(Ee){var Ne=q[Ee];q[Ee]=function(){for(var Fe=arguments.length,Ve=new Array(Fe),Xe=0;Xe<Fe;Xe++)Ve[Xe]=arguments[Xe];var tt=H.renderer[Ee].apply(q,Ve);return tt===!1&&(tt=Ne.apply(q,Ve)),tt}};for(var oe in H.renderer)Y(oe);ne.renderer=q}(),H.tokenizer&&function(){var q=Ue.defaults.tokenizer||new W,Y=function(Ee){var Ne=q[Ee];q[Ee]=function(){for(var Fe=arguments.length,Ve=new Array(Fe),Xe=0;Xe<Fe;Xe++)Ve[Xe]=arguments[Xe];var tt=H.tokenizer[Ee].apply(q,Ve);return tt===!1&&(tt=Ne.apply(q,Ve)),tt}};for(var oe in H.tokenizer)Y(oe);ne.tokenizer=q}(),H.walkTokens){var he=Ue.defaults.walkTokens;ne.walkTokens=function(q){H.walkTokens(q),he&&he(q)}}Ue.setOptions(ne)},Ue.walkTokens=function(H,ne){for(var he=P(H),q;!(q=he()).done;){var Y=q.value;switch(ne(Y),Y.type){case"table":{for(var oe=P(Y.tokens.header),fe;!(fe=oe()).done;){var Ee=fe.value;Ue.walkTokens(Ee,ne)}for(var Ne=P(Y.tokens.cells),Fe;!(Fe=Ne()).done;)for(var Ve=Fe.value,Xe=P(Ve),tt;!(tt=Xe()).done;){var nt=tt.value;Ue.walkTokens(nt,ne)}break}case"list":{Ue.walkTokens(Y.items,ne);break}default:Y.tokens&&Ue.walkTokens(Y.tokens,ne)}}},Ue.parseInline=function(H,ne){if(typeof H=="undefined"||H===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");ne=qe({},Ue.defaults,ne||{}),j(ne);try{var he=te.lexInline(H,ne);return ne.walkTokens&&Ue.walkTokens(he,ne.walkTokens),be.parseInline(he,ne)}catch(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+X(q.message+"",!0)+"</pre>";throw q}},Ue.Parser=be,Ue.parser=be.parse,Ue.Renderer=Me,Ue.TextRenderer=ge,Ue.Lexer=te,Ue.lexer=te.lex,Ue.Tokenizer=W,Ue.Slugger=Ce,Ue.parse=Ue;var Ze=Ue;return Ze}),define(ve[79],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(S,D,y){return Math.min(Math.max(S,D),y)}e.clamp=E;function k(S,D){return(D+S%D)%D}e.rot=k;class P{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=P;class A{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A});"use strict";(function(){function ie(P){const A=[];typeof P=="number"&&A.push("code/timeOrigin",P);function S(y){A.push(y,Date.now())}function D(){const y=[];for(let n=0;n<A.length;n+=2)y.push({name:A[n],startTime:A[n+1]});return y}return{mark:S,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const S of performance.getEntriesByType("mark"))A.push({name:S.name,startTime:Math.round(P+S.startTime)});return A}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function E(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=E(k))})(),define(ve[21],_e([0,1]),function(ie,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const k="en";let P=!1,A=!1,S=!1,D=!1,y=!1,n=!1,T=!1,C,g=k,f,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let s;typeof e.globals.vscode!="undefined"?s=e.globals.vscode.process:typeof process!="undefined"&&(s=process);const b=typeof((E=s==null?void 0:s.versions)===null||E===void 0?void 0:E.electron)=="string"&&s.type==="renderer";if(e.isElectronSandboxed=b&&(s==null?void 0:s.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const a=s==null?void 0:s.env.VSCODE_BROWSER_CODE_LOADING;if(typeof a=="string")return a==="none"||a==="code"||a==="bypassHeatCheck"||a==="bypassHeatCheckAndEagerCompile"?a:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!b)r=navigator.userAgent,P=r.indexOf("Windows")>=0,A=r.indexOf("Macintosh")>=0,T=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=r.indexOf("Linux")>=0,n=!0,C=navigator.language,g=C;else if(typeof s=="object"){P=s.platform==="win32",A=s.platform==="darwin",S=s.platform==="linux",D=S&&!!s.env.SNAP&&!!s.env.SNAP_REVISION,C=k,g=k;const a=s.env.VSCODE_NLS_CONFIG;if(a)try{const l=JSON.parse(a),o=l.availableLanguages["*"];C=l.locale,g=o||k,f=l._translationsConfigFile}catch(l){}y=!0}else console.error("Unable to resolve platform.");var h;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function _(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=_;let v=0;A?v=1:P?v=3:S&&(v=2),e.isWindows=P,e.isMacintosh=A,e.isLinux=S,e.isLinuxSnap=D,e.isNative=y,e.isWeb=n,e.isIOS=T,e.platform=v,e.userAgent=r,e.language=g;var c;(function(a){function l(){return e.language}a.value=l;function o(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=o;function w(){return e.language==="en"}a.isDefault=w})(c=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=f,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",I=>{if(I.data&&I.data.vscodeSetImmediateId)for(let p=0,m=o.length;p<m;p++){const R=o[p];if(R.id===I.data.vscodeSetImmediateId){o.splice(p,1),R.callback();return}}});let w=0;return I=>{const p=++w;o.push({id:p,callback:I}),e.globals.postMessage({vscodeSetImmediateId:p},"*")}}if(typeof(s==null?void 0:s.nextTick)=="function")return s.nextTick.bind(s);const l=Promise.resolve();return o=>l.then(o)}();var u;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(u=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||T?2:P?1:3;let t=!0,i=!1;function d(){if(!i){i=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,t=new Uint16Array(a.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=d}),define(ve[45],_e([0,1,21]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let k;if(typeof E.globals.vscode!="undefined"){const P=E.globals.vscode.process;k={get platform(){return P.platform},get env(){return P.env},cwd(){return P.cwd()},nextTick(A){return(0,E.setImmediate)(A)}}}else typeof process!="undefined"?k={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(P){return process.nextTick(P)}}:k={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},nextTick(P){return(0,E.setImmediate)(P)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=k.cwd,e.env=k.env,e.platform=k.platform,e.nextTick=k.nextTick}),define(ve[12],_e([0,1,45]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const k=65,P=97,A=90,S=122,D=46,y=47,n=92,T=58,C=63;class g extends Error{constructor(c,u,t){let i;typeof u=="string"&&u.indexOf("not ")===0?(i="must not be",u=u.replace(/^not /,"")):i="must be";const d=c.indexOf(".")!==-1?"property":"argument";let a=`The "${c}" ${d} ${i} of type ${u}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function f(v,c){if(typeof v!="string")throw new g(c,"string",v)}function r(v){return v===y||v===n}function s(v){return v===y}function b(v){return v>=k&&v<=A||v>=P&&v<=S}function h(v,c,u,t){let i="",d=0,a=-1,l=0,o=0;for(let w=0;w<=v.length;++w){if(w<v.length)o=v.charCodeAt(w);else{if(t(o))break;o=y}if(t(o)){if(!(a===w-1||l===1))if(l===2){if(i.length<2||d!==2||i.charCodeAt(i.length-1)!==D||i.charCodeAt(i.length-2)!==D){if(i.length>2){const I=i.lastIndexOf(u);I===-1?(i="",d=0):(i=i.slice(0,I),d=i.length-1-i.lastIndexOf(u)),a=w,l=0;continue}else if(i.length!==0){i="",d=0,a=w,l=0;continue}}c&&(i+=i.length>0?`${u}..`:"..",d=2)}else i.length>0?i+=`${u}${v.slice(a+1,w)}`:i=v.slice(a+1,w),d=w-a-1;a=w,l=0}else o===D&&l!==-1?++l:l=-1}return i}function _(v,c){if(c===null||typeof c!="object")throw new g("pathObject","Object",c);const u=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return u?u===c.root?`${u}${t}`:`${u}${v}${t}`:t}e.win32={resolve(...v){let c="",u="",t=!1;for(let i=v.length-1;i>=-1;i--){let d;if(i>=0){if(d=v[i],f(d,"path"),d.length===0)continue}else c.length===0?d=E.cwd():(d=E.env[`=${c}`]||E.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==c.toLowerCase()&&d.charCodeAt(2)===n)&&(d=`${c}\\`));const a=d.length;let l=0,o="",w=!1;const I=d.charCodeAt(0);if(a===1)r(I)&&(l=1,w=!0);else if(r(I))if(w=!0,r(d.charCodeAt(1))){let p=2,m=p;for(;p<a&&!r(d.charCodeAt(p));)p++;if(p<a&&p!==m){const R=d.slice(m,p);for(m=p;p<a&&r(d.charCodeAt(p));)p++;if(p<a&&p!==m){for(m=p;p<a&&!r(d.charCodeAt(p));)p++;(p===a||p!==m)&&(o=`\\\\${R}\\${d.slice(m,p)}`,l=p)}}}else l=1;else b(I)&&d.charCodeAt(1)===T&&(o=d.slice(0,2),l=2,a>2&&r(d.charCodeAt(2))&&(w=!0,l=3));if(o.length>0)if(c.length>0){if(o.toLowerCase()!==c.toLowerCase())continue}else c=o;if(t){if(c.length>0)break}else if(u=`${d.slice(l)}\\${u}`,t=w,w&&c.length>0)break}return u=h(u,!t,"\\",r),t?`${c}\\${u}`:`${c}${u}`||"."},normalize(v){f(v,"path");const c=v.length;if(c===0)return".";let u=0,t,i=!1;const d=v.charCodeAt(0);if(c===1)return s(d)?"\\":v;if(r(d))if(i=!0,r(v.charCodeAt(1))){let l=2,o=l;for(;l<c&&!r(v.charCodeAt(l));)l++;if(l<c&&l!==o){const w=v.slice(o,l);for(o=l;l<c&&r(v.charCodeAt(l));)l++;if(l<c&&l!==o){for(o=l;l<c&&!r(v.charCodeAt(l));)l++;if(l===c)return`\\\\${w}\\${v.slice(o)}\\`;l!==o&&(t=`\\\\${w}\\${v.slice(o,l)}`,u=l)}}}else u=1;else b(d)&&v.charCodeAt(1)===T&&(t=v.slice(0,2),u=2,c>2&&r(v.charCodeAt(2))&&(i=!0,u=3));let a=u<c?h(v.slice(u),!i,"\\",r):"";return a.length===0&&!i&&(a="."),a.length>0&&r(v.charCodeAt(c-1))&&(a+="\\"),t===void 0?i?`\\${a}`:a:i?`${t}\\${a}`:`${t}${a}`},isAbsolute(v){f(v,"path");const c=v.length;if(c===0)return!1;const u=v.charCodeAt(0);return r(u)||c>2&&b(u)&&v.charCodeAt(1)===T&&r(v.charCodeAt(2))},join(...v){if(v.length===0)return".";let c,u;for(let d=0;d<v.length;++d){const a=v[d];f(a,"path"),a.length>0&&(c===void 0?c=u=a:c+=`\\${a}`)}if(c===void 0)return".";let t=!0,i=0;if(typeof u=="string"&&r(u.charCodeAt(0))){++i;const d=u.length;d>1&&r(u.charCodeAt(1))&&(++i,d>2&&(r(u.charCodeAt(2))?++i:t=!1))}if(t){for(;i<c.length&&r(c.charCodeAt(i));)i++;i>=2&&(c=`\\${c.slice(i)}`)}return e.win32.normalize(c)},relative(v,c){if(f(v,"from"),f(c,"to"),v===c)return"";const u=e.win32.resolve(v),t=e.win32.resolve(c);if(u===t||(v=u.toLowerCase(),c=t.toLowerCase(),v===c))return"";let i=0;for(;i<v.length&&v.charCodeAt(i)===n;)i++;let d=v.length;for(;d-1>i&&v.charCodeAt(d-1)===n;)d--;const a=d-i;let l=0;for(;l<c.length&&c.charCodeAt(l)===n;)l++;let o=c.length;for(;o-1>l&&c.charCodeAt(o-1)===n;)o--;const w=o-l,I=a<w?a:w;let p=-1,m=0;for(;m<I;m++){const F=v.charCodeAt(i+m);if(F!==c.charCodeAt(l+m))break;F===n&&(p=m)}if(m!==I){if(p===-1)return t}else{if(w>I){if(c.charCodeAt(l+m)===n)return t.slice(l+m+1);if(m===2)return t.slice(l+m)}a>I&&(v.charCodeAt(i+m)===n?p=m:m===2&&(p=3)),p===-1&&(p=0)}let R="";for(m=i+p+1;m<=d;++m)(m===d||v.charCodeAt(m)===n)&&(R+=R.length===0?"..":"\\..");return l+=p,R.length>0?`${R}${t.slice(l,o)}`:(t.charCodeAt(l)===n&&++l,t.slice(l,o))},toNamespacedPath(v){if(typeof v!="string")return v;if(v.length===0)return"";const c=e.win32.resolve(v);if(c.length<=2)return v;if(c.charCodeAt(0)===n){if(c.charCodeAt(1)===n){const u=c.charCodeAt(2);if(u!==C&&u!==D)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(b(c.charCodeAt(0))&&c.charCodeAt(1)===T&&c.charCodeAt(2)===n)return`\\\\?\\${c}`;return v},dirname(v){f(v,"path");const c=v.length;if(c===0)return".";let u=-1,t=0;const i=v.charCodeAt(0);if(c===1)return r(i)?v:".";if(r(i)){if(u=t=1,r(v.charCodeAt(1))){let l=2,o=l;for(;l<c&&!r(v.charCodeAt(l));)l++;if(l<c&&l!==o){for(o=l;l<c&&r(v.charCodeAt(l));)l++;if(l<c&&l!==o){for(o=l;l<c&&!r(v.charCodeAt(l));)l++;if(l===c)return v;l!==o&&(u=t=l+1)}}}}else b(i)&&v.charCodeAt(1)===T&&(u=c>2&&r(v.charCodeAt(2))?3:2,t=u);let d=-1,a=!0;for(let l=c-1;l>=t;--l)if(r(v.charCodeAt(l))){if(!a){d=l;break}}else a=!1;if(d===-1){if(u===-1)return".";d=u}return v.slice(0,d)},basename(v,c){c!==void 0&&f(c,"ext"),f(v,"path");let u=0,t=-1,i=!0,d;if(v.length>=2&&b(v.charCodeAt(0))&&v.charCodeAt(1)===T&&(u=2),c!==void 0&&c.length>0&&c.length<=v.length){if(c===v)return"";let a=c.length-1,l=-1;for(d=v.length-1;d>=u;--d){const o=v.charCodeAt(d);if(r(o)){if(!i){u=d+1;break}}else l===-1&&(i=!1,l=d+1),a>=0&&(o===c.charCodeAt(a)?--a==-1&&(t=d):(a=-1,t=l))}return u===t?t=l:t===-1&&(t=v.length),v.slice(u,t)}for(d=v.length-1;d>=u;--d)if(r(v.charCodeAt(d))){if(!i){u=d+1;break}}else t===-1&&(i=!1,t=d+1);return t===-1?"":v.slice(u,t)},extname(v){f(v,"path");let c=0,u=-1,t=0,i=-1,d=!0,a=0;v.length>=2&&v.charCodeAt(1)===T&&b(v.charCodeAt(0))&&(c=t=2);for(let l=v.length-1;l>=c;--l){const o=v.charCodeAt(l);if(r(o)){if(!d){t=l+1;break}continue}i===-1&&(d=!1,i=l+1),o===D?u===-1?u=l:a!==1&&(a=1):u!==-1&&(a=-1)}return u===-1||i===-1||a===0||a===1&&u===i-1&&u===t+1?"":v.slice(u,i)},format:_.bind(null,"\\"),parse(v){f(v,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return c;const u=v.length;let t=0,i=v.charCodeAt(0);if(u===1)return r(i)?(c.root=c.dir=v,c):(c.base=c.name=v,c);if(r(i)){if(t=1,r(v.charCodeAt(1))){let p=2,m=p;for(;p<u&&!r(v.charCodeAt(p));)p++;if(p<u&&p!==m){for(m=p;p<u&&r(v.charCodeAt(p));)p++;if(p<u&&p!==m){for(m=p;p<u&&!r(v.charCodeAt(p));)p++;p===u?t=p:p!==m&&(t=p+1)}}}}else if(b(i)&&v.charCodeAt(1)===T){if(u<=2)return c.root=c.dir=v,c;if(t=2,r(v.charCodeAt(2))){if(u===3)return c.root=c.dir=v,c;t=3}}t>0&&(c.root=v.slice(0,t));let d=-1,a=t,l=-1,o=!0,w=v.length-1,I=0;for(;w>=t;--w){if(i=v.charCodeAt(w),r(i)){if(!o){a=w+1;break}continue}l===-1&&(o=!1,l=w+1),i===D?d===-1?d=w:I!==1&&(I=1):d!==-1&&(I=-1)}return l!==-1&&(d===-1||I===0||I===1&&d===l-1&&d===a+1?c.base=c.name=v.slice(a,l):(c.name=v.slice(a,d),c.base=v.slice(a,l),c.ext=v.slice(d,l))),a>0&&a!==t?c.dir=v.slice(0,a-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...v){let c="",u=!1;for(let t=v.length-1;t>=-1&&!u;t--){const i=t>=0?v[t]:E.cwd();f(i,"path"),i.length!==0&&(c=`${i}/${c}`,u=i.charCodeAt(0)===y)}return c=h(c,!u,"/",s),u?`/${c}`:c.length>0?c:"."},normalize(v){if(f(v,"path"),v.length===0)return".";const c=v.charCodeAt(0)===y,u=v.charCodeAt(v.length-1)===y;return v=h(v,!c,"/",s),v.length===0?c?"/":u?"./":".":(u&&(v+="/"),c?`/${v}`:v)},isAbsolute(v){return f(v,"path"),v.length>0&&v.charCodeAt(0)===y},join(...v){if(v.length===0)return".";let c;for(let u=0;u<v.length;++u){const t=v[u];f(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(v,c){if(f(v,"from"),f(c,"to"),v===c||(v=e.posix.resolve(v),c=e.posix.resolve(c),v===c))return"";const u=1,t=v.length,i=t-u,d=1,a=c.length-d,l=i<a?i:a;let o=-1,w=0;for(;w<l;w++){const p=v.charCodeAt(u+w);if(p!==c.charCodeAt(d+w))break;p===y&&(o=w)}if(w===l)if(a>l){if(c.charCodeAt(d+w)===y)return c.slice(d+w+1);if(w===0)return c.slice(d+w)}else i>l&&(v.charCodeAt(u+w)===y?o=w:w===0&&(o=0));let I="";for(w=u+o+1;w<=t;++w)(w===t||v.charCodeAt(w)===y)&&(I+=I.length===0?"..":"/..");return`${I}${c.slice(d+o)}`},toNamespacedPath(v){return v},dirname(v){if(f(v,"path"),v.length===0)return".";const c=v.charCodeAt(0)===y;let u=-1,t=!0;for(let i=v.length-1;i>=1;--i)if(v.charCodeAt(i)===y){if(!t){u=i;break}}else t=!1;return u===-1?c?"/":".":c&&u===1?"//":v.slice(0,u)},basename(v,c){c!==void 0&&f(c,"ext"),f(v,"path");let u=0,t=-1,i=!0,d;if(c!==void 0&&c.length>0&&c.length<=v.length){if(c===v)return"";let a=c.length-1,l=-1;for(d=v.length-1;d>=0;--d){const o=v.charCodeAt(d);if(o===y){if(!i){u=d+1;break}}else l===-1&&(i=!1,l=d+1),a>=0&&(o===c.charCodeAt(a)?--a==-1&&(t=d):(a=-1,t=l))}return u===t?t=l:t===-1&&(t=v.length),v.slice(u,t)}for(d=v.length-1;d>=0;--d)if(v.charCodeAt(d)===y){if(!i){u=d+1;break}}else t===-1&&(i=!1,t=d+1);return t===-1?"":v.slice(u,t)},extname(v){f(v,"path");let c=-1,u=0,t=-1,i=!0,d=0;for(let a=v.length-1;a>=0;--a){const l=v.charCodeAt(a);if(l===y){if(!i){u=a+1;break}continue}t===-1&&(i=!1,t=a+1),l===D?c===-1?c=a:d!==1&&(d=1):c!==-1&&(d=-1)}return c===-1||t===-1||d===0||d===1&&c===t-1&&c===u+1?"":v.slice(c,t)},format:_.bind(null,"/"),parse(v){f(v,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return c;const u=v.charCodeAt(0)===y;let t;u?(c.root="/",t=1):t=0;let i=-1,d=0,a=-1,l=!0,o=v.length-1,w=0;for(;o>=t;--o){const I=v.charCodeAt(o);if(I===y){if(!l){d=o+1;break}continue}a===-1&&(l=!1,a=o+1),I===D?i===-1?i=o:w!==1&&(w=1):i!==-1&&(w=-1)}if(a!==-1){const I=d===0&&u?1:d;i===-1||w===0||w===1&&i===a-1&&i===d+1?c.base=c.name=v.slice(I,a):(c.name=v.slice(I,i),c.base=v.slice(I,a),c.ext=v.slice(i,a))}return d>0?c.dir=v.slice(0,d-1):u&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=E.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E.platform==="win32"?e.win32.join:e.posix.join,e.resolve=E.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=E.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=E.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=E.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=E.platform==="win32"?e.win32.extname:e.posix.extname,e.format=E.platform==="win32"?e.win32.format:e.posix.format,e.parse=E.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=E.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=E.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[55],_e([0,1,21]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=E.globals.performance&&typeof E.globals.performance.now=="function";class P{constructor(S){this._highResolution=k&&S,this._startTime=this._now(),this._stopTime=-1}static create(S=!0){return new P(S)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}e.StopWatch=P}),define(ve[3],_e([0,1,10,52,6,44,55]),function(ie,e,E,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(h){h.None=()=>P.Disposable.None;function _(z){return(B,G=null,M)=>{let N=!1,W;return W=z(Q=>{if(!N)return W?W.dispose():N=!0,B.call(G,Q)},null,M),N&&W.dispose(),W}}h.once=_;function v(z,B){return a((G,M=null,N)=>z(W=>G.call(M,B(W)),null,N))}h.map=v;function c(z,B){return a((G,M=null,N)=>z(W=>{B(W),G.call(M,W)},null,N))}h.forEach=c;function u(z,B){return a((G,M=null,N)=>z(W=>B(W)&&G.call(M,W),null,N))}h.filter=u;function t(z){return z}h.signal=t;function i(...z){return(B,G=null,M)=>(0,P.combinedDisposable)(...z.map(N=>N(W=>B.call(G,W),null,M)))}h.any=i;function d(z,B,G){let M=G;return v(z,N=>(M=B(M,N),M))}h.reduce=d;function a(z){let B;const G=new g({onFirstListenerAdd(){B=z(G.fire,G)},onLastListenerRemove(){B.dispose()}});return G.event}h.snapshot=a;function l(z,B,G=100,M=!1,N){let W,Q,$,Z=0;const re=new g({leakWarningThreshold:N,onFirstListenerAdd(){W=z(se=>{Z++,Q=B(Q,se),M&&!$&&(re.fire(Q),Q=void 0),clearTimeout($),$=setTimeout(()=>{const ye=Q;Q=void 0,$=void 0,(!M||Z>1)&&re.fire(ye),Z=0},G)})},onLastListenerRemove(){W.dispose()}});return re.event}h.debounce=l;function o(z){const B=new Date().getTime();return v(_(z),G=>new Date().getTime()-B)}h.stopwatch=o;function w(z){let B=!0,G;return u(z,M=>{const N=B||M!==G;return B=!1,G=M,N})}h.latch=w;function I(z,B=!1,G=[]){let M=G.slice(),N=z($=>{M?M.push($):Q.fire($)});const W=()=>{M&&M.forEach($=>Q.fire($)),M=null},Q=new g({onFirstListenerAdd(){N||(N=z($=>Q.fire($)))},onFirstListenerDidAdd(){M&&(B?setTimeout(W):W())},onLastListenerRemove(){N&&N.dispose(),N=null}});return Q.event}h.buffer=I;class p{constructor(B){this.event=B}map(B){return new p(v(this.event,B))}forEach(B){return new p(c(this.event,B))}filter(B){return new p(u(this.event,B))}reduce(B,G){return new p(d(this.event,B,G))}latch(){return new p(w(this.event))}debounce(B,G=100,M=!1,N){return new p(l(this.event,B,G,M,N))}on(B,G,M){return this.event(B,G,M)}once(B,G,M){return _(this.event)(B,G,M)}}function m(z){return new p(z)}h.chain=m;function R(z,B,G=M=>M){const M=(...$)=>Q.fire(G(...$)),N=()=>z.on(B,M),W=()=>z.removeListener(B,M),Q=new g({onFirstListenerAdd:N,onLastListenerRemove:W});return Q.event}h.fromNodeEventEmitter=R;function F(z,B,G=M=>M){const M=(...$)=>Q.fire(G(...$)),N=()=>z.addEventListener(B,M),W=()=>z.removeEventListener(B,M),Q=new g({onFirstListenerAdd:N,onLastListenerRemove:W});return Q.event}h.fromDOMEventEmitter=F;function x(z){const B=new g;let G=!1;return z.then(void 0,()=>null).then(()=>{G?B.fire(void 0):setTimeout(()=>B.fire(void 0),0)}),G=!0,B.event}h.fromPromise=x;function ae(z){return new Promise(B=>_(z)(B))}h.toPromise=ae})(D=e.Event||(e.Event={}));class y{constructor(_){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${_}_${y._idPool++}`}start(_){this._stopWatch=new S.StopWatch(!0),this._listenerCount=_}stop(){if(this._stopWatch){const _=this._stopWatch.elapsed();this._elapsedOverall+=_,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${_.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let n=-1;function T(h){const _=n;return n=h,{dispose(){n=_}}}e.setGlobalLeakWarningThreshold=T;class C{constructor(_,v=Math.random().toString(18).slice(2,5)){this.customThreshold=_,this.name=v,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(_){let v=n;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),!(v<=0||_<v)){this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),u=this._stacks.get(c)||0;if(this._stacks.set(c,u+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let t,i=0;for(const[d,a]of this._stacks)(!t||i<a)&&(t=d,i=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${_} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}}class g{constructor(_){var v;this._disposed=!1,this._options=_,this._leakageMon=n>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((v=this._options)===null||v===void 0?void 0:v._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(_,v,c)=>{var u;this._listeners||(this._listeners=new A.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(v?[_,v]:_);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,_,v);const d=(u=this._leakageMon)===null||u===void 0?void 0:u.check(this._listeners.size);let a;return a={dispose:()=>{d&&d(),a.dispose=g._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},c instanceof P.DisposableStore?c.add(a):Array.isArray(c)&&c.push(a),a}),this._event}fire(_){var v,c;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let u of this._listeners)this._deliveryQueue.push([u,_]);for((v=this._perfMon)===null||v===void 0||v.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[u,t]=this._deliveryQueue.shift();try{typeof u=="function"?u.call(void 0,t):u[0].call(u[1],t)}catch(i){(0,E.onUnexpectedError)(i)}}(c=this._perfMon)===null||c===void 0||c.stop()}}dispose(){var _,v,c;(_=this._listeners)===null||_===void 0||_.clear(),(v=this._deliveryQueue)===null||v===void 0||v.clear(),(c=this._leakageMon)===null||c===void 0||c.dispose(),this._disposed=!0}}e.Emitter=g,g._noop=function(){};class f extends g{constructor(_){super(_);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=_==null?void 0:_.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const _=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(_))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(_){this._listeners&&(this._isPaused!==0?this._eventQueue.push(_):super.fire(_))}}e.PauseableEmitter=f;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(_){const v={event:_,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const c=()=>{this.hasListeners&&this.unhook(v);const u=this.events.indexOf(v);this.events.splice(u,1)};return(0,P.toDisposable)((0,k.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(_=>this.hook(_))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(_=>this.unhook(_))}hook(_){_.listener=_.event(v=>this.emitter.fire(v))}unhook(_){_.listener&&_.listener.dispose(),_.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class s{constructor(){this.buffers=[]}wrapEvent(_){return(v,c,u)=>_(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>v.call(c,t)):v.call(c,t)},void 0,u)}bufferEvents(_){const v=[];this.buffers.push(v);const c=_();return this.buffers.pop(),v.forEach(u=>u()),c}}e.EventBufferer=s;class b{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=P.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(_){this.inputEvent=_,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=_(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=b}),define(ve[20],_e([0,1,3]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const k=Object.freeze(function(D,y){const n=setTimeout(D.bind(y),0);return{dispose(){clearTimeout(n)}}});var P;(function(D){function y(n){return n===D.None||n===D.Cancelled||n instanceof A?!0:!n||typeof n!="object"?!1:typeof n.isCancellationRequested=="boolean"&&typeof n.onCancellationRequested=="function"}D.isCancellationToken=y,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(P=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class S{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=P.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=P.None}}e.CancellationTokenSource=S}),define(ve[36],_e([0,1,3]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class k{constructor(){this._icons=new Map,this._onDidRegister=new E.Emitter}add(T){const C=this._icons.get(T.id);C?T.description?C.description=T.description:console.error(`Duplicate registration of codicon ${T.id}`):(this._icons.set(T.id,T),this._onDidRegister.fire(T))}get(T){return this._icons.get(T)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const P=new k;e.iconRegistry=P;function A(n,T){return new S(n,T)}e.registerCodicon=A;class S{constructor(T,C,g){this.id=T,this.definition=C,this.description=g,P.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=S;function D(n,T){const C=["codicon","codicon-"+n];return T&&C.push("codicon-modifier-"+T),C}e.getClassNamesArray=D;var y;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const T=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function C(r){if(r instanceof S)return["codicon","codicon-"+r.id];const s=T.exec(r.id);if(!s)return C(S.error);let[,b,h]=s;const _=["codicon","codicon-"+b];return h&&_.push("codicon-modifier-"+h.substr(1)),_}n.asClassNameArray=C;function g(r){return C(r).join(" ")}n.asClassName=g;function f(r){return"."+C(r).join(".")}n.asCSSSelector=f})(y=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personAdd=new n("person-add",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(S=e.Codicon||(e.Codicon={}))}),define(ve[107],_e([0,1,10,6]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function P(h){const _=h;return _&&[_.on,_.pause,_.resume,_.destroy].every(v=>typeof v=="function")}e.isReadableStream=P;function A(h){const _=h;return _&&P(_.stream)&&Array.isArray(_.buffer)&&typeof _.ended=="boolean"}e.isReadableBufferedStream=A;function S(h,_){return new D(h,_)}e.newWriteableStream=S;class D{constructor(_,v){this.reducer=_,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(_){var v;if(!this.state.destroyed){if(this.state.flowing)this.emitData(_);else if(this.buffer.data.push(_),typeof((v=this.options)===null||v===void 0?void 0:v.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(_){this.state.destroyed||(this.state.flowing?this.emitError(_):this.buffer.error.push(_))}end(_){this.state.destroyed||(typeof _!="undefined"&&this.write(_),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(_){this.listeners.data.slice(0).forEach(v=>v(_))}emitError(_){this.listeners.error.length===0?(0,E.onUnexpectedError)(_):this.listeners.error.slice(0).forEach(v=>v(_))}emitEnd(){this.listeners.end.slice(0).forEach(_=>_())}on(_,v){if(!this.state.destroyed)switch(_){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(_,v){if(!this.state.destroyed){let c;switch(_){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const u=c.indexOf(v);u>=0&&c.splice(u,1)}}}flowData(){if(this.buffer.data.length>0){const _=this.reducer(this.buffer.data);this.emitData(_),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const _ of this.buffer.error)this.emitError(_);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(h,_){const v=[];let c;for(;(c=h.read())!==null;)v.push(c);return _(v)}e.consumeReadable=y;function n(h,_,v){const c=[];let u;for(;(u=h.read())!==null&&c.length<v;)c.push(u);return u===null&&c.length>0?_(c):{read:()=>{if(c.length>0)return c.shift();if(typeof u!="undefined"){const t=u;return u=void 0,t}return h.read()}}}e.peekReadable=n;function T(h,_){return new Promise((v,c)=>{const u=[];C(h,{onData:t=>{_&&u.push(t)},onError:t=>{_?c(t):v(void 0)},onEnd:()=>{v(_?_(u):void 0)}})})}e.consumeStream=T;function C(h,_){h.on("error",v=>_.onError(v)),h.on("end",()=>_.onEnd()),h.on("data",v=>_.onData(v))}e.listenStream=C;function g(h,_){return new Promise((v,c)=>{const u=new k.DisposableStore,t=[],i=l=>{if(t.push(l),t.length>_)return u.dispose(),h.pause(),v({stream:h,buffer:t,ended:!1})},d=l=>c(l),a=()=>v({stream:h,buffer:t,ended:!0});u.add((0,k.toDisposable)(()=>h.removeListener("error",d))),h.on("error",d),u.add((0,k.toDisposable)(()=>h.removeListener("end",a))),h.on("end",a),u.add((0,k.toDisposable)(()=>h.removeListener("data",i))),h.on("data",i)})}e.peekStream=g;function f(h,_){const v=S(_);return v.end(h),v}e.toStream=f;function r(){const h=S(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=r;function s(h){let _=!1;return{read:()=>_?null:(_=!0,h)}}e.toReadable=s;function b(h,_,v){const c=S(v);return C(h,{onData:u=>c.write(_.data(u)),onError:u=>c.error(_.error?_.error(u):u),onEnd:()=>c.end()}),c}e.transform=b}),define(ve[8],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function E(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=E;const k=/{(\d+)}/g;function P(H,...ne){return ne.length===0?H:H.replace(k,function(he,q){const Y=parseInt(q,10);return isNaN(Y)||Y<0||Y>=ne.length?he:ne[Y]})}e.format=P;function A(H){return H.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}e.escape=A;function S(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function D(H,ne){let he=0;const q=ne.charCodeAt(0);for(let Y=H.length-1;Y>=0;Y--)H.charCodeAt(Y)===q&&he++;return he}e.count=D;function y(H,ne,he="\u2026"){return H.length<=ne?H:`${H.substr(0,ne)}${he}`}e.truncate=y;function n(H,ne=" "){const he=T(H,ne);return C(he,ne)}e.trim=n;function T(H,ne){if(!H||!ne)return H;const he=ne.length;if(he===0||H.length===0)return H;let q=0;for(;H.indexOf(ne,q)===q;)q=q+he;return H.substring(q)}e.ltrim=T;function C(H,ne){if(!H||!ne)return H;const he=ne.length,q=H.length;if(he===0||q===0)return H;let Y=q,oe=-1;for(;oe=H.lastIndexOf(ne,Y-1),!(oe===-1||oe+he!==Y);){if(oe===0)return"";Y=oe}return H.substring(0,Y)}e.rtrim=C;function g(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function f(H){return H.replace(/\*/g,"")}e.stripWildcards=f;function r(H,ne,he={}){if(!H)throw new Error("Cannot create regex from empty string");ne||(H=S(H)),he.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let q="";return he.global&&(q+="g"),he.matchCase||(q+="i"),he.multiline&&(q+="m"),he.unicode&&(q+="u"),new RegExp(H,q)}e.createRegExp=r;function s(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=s;function b(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function h(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=h;function _(H){return H.split(/\r\n|\r|\n/)}e.splitLines=_;function v(H){for(let ne=0,he=H.length;ne<he;ne++){const q=H.charCodeAt(ne);if(q!==32&&q!==9)return ne}return-1}e.firstNonWhitespaceIndex=v;function c(H,ne=0,he=H.length){for(let q=ne;q<he;q++){const Y=H.charCodeAt(q);if(Y!==32&&Y!==9)return H.substring(ne,q)}return H.substring(ne,he)}e.getLeadingWhitespace=c;function u(H,ne=H.length-1){for(let he=ne;he>=0;he--){const q=H.charCodeAt(he);if(q!==32&&q!==9)return he}return-1}e.lastNonWhitespaceIndex=u;function t(H,ne){return H<ne?-1:H>ne?1:0}e.compare=t;function i(H,ne,he=0,q=H.length,Y=0,oe=ne.length){for(;he<q&&Y<oe;he++,Y++){let Ne=H.charCodeAt(he),Fe=ne.charCodeAt(Y);if(Ne<Fe)return-1;if(Ne>Fe)return 1}const fe=q-he,Ee=oe-Y;return fe<Ee?-1:fe>Ee?1:0}e.compareSubstring=i;function d(H,ne){return a(H,ne,0,H.length,0,ne.length)}e.compareIgnoreCase=d;function a(H,ne,he=0,q=H.length,Y=0,oe=ne.length){for(;he<q&&Y<oe;he++,Y++){let Ne=H.charCodeAt(he),Fe=ne.charCodeAt(Y);if(Ne!==Fe){const Ve=Ne-Fe;if(!(Ve===32&&o(Fe))&&!(Ve===-32&&o(Ne)))return l(Ne)&&l(Fe)?Ve:i(H.toLowerCase(),ne.toLowerCase(),he,q,Y,oe)}}const fe=q-he,Ee=oe-Y;return fe<Ee?-1:fe>Ee?1:0}e.compareSubstringIgnoreCase=a;function l(H){return H>=97&&H<=122}e.isLowerAsciiLetter=l;function o(H){return H>=65&&H<=90}e.isUpperAsciiLetter=o;function w(H){return l(H)||o(H)}function I(H,ne){return H.length===ne.length&&p(H,ne)}e.equalsIgnoreCase=I;function p(H,ne,he=H.length){for(let q=0;q<he;q++){const Y=H.charCodeAt(q),oe=ne.charCodeAt(q);if(Y!==oe){if(w(Y)&&w(oe)){const fe=Math.abs(Y-oe);if(fe!==0&&fe!==32)return!1}else if(String.fromCharCode(Y).toLowerCase()!==String.fromCharCode(oe).toLowerCase())return!1}}return!0}function m(H,ne){const he=ne.length;return ne.length>H.length?!1:p(H,ne,he)}e.startsWithIgnoreCase=m;function R(H,ne){let he,q=Math.min(H.length,ne.length);for(he=0;he<q;he++)if(H.charCodeAt(he)!==ne.charCodeAt(he))return he;return q}e.commonPrefixLength=R;function F(H,ne){let he,q=Math.min(H.length,ne.length);const Y=H.length-1,oe=ne.length-1;for(he=0;he<q;he++)if(H.charCodeAt(Y-he)!==ne.charCodeAt(oe-he))return he;return q}e.commonSuffixLength=F;function x(H){return 55296<=H&&H<=56319}e.isHighSurrogate=x;function ae(H){return 56320<=H&&H<=57343}e.isLowSurrogate=ae;function z(H,ne){return(H-55296<<10)+(ne-56320)+65536}e.computeCodePoint=z;function B(H,ne,he){const q=H.charCodeAt(he);if(x(q)&&he+1<ne){const Y=H.charCodeAt(he+1);if(ae(Y))return z(q,Y)}return q}e.getNextCodePoint=B;function G(H,ne){const he=H.charCodeAt(ne-1);if(ae(he)&&ne>1){const q=H.charCodeAt(ne-2);if(x(q))return z(q,he)}return he}function M(H,ne){const he=Ue.getInstance(),q=ne,Y=H.length,oe=B(H,Y,ne);ne+=oe>=65536?2:1;let fe=he.getGraphemeBreakType(oe);for(;ne<Y;){const Ee=B(H,Y,ne),Ne=he.getGraphemeBreakType(Ee);if(Le(fe,Ne))break;ne+=Ee>=65536?2:1,fe=Ne}return ne-q}e.nextCharLength=M;function N(H,ne){const he=Ue.getInstance(),q=ne,Y=G(H,ne);ne-=Y>=65536?2:1;let oe=he.getGraphemeBreakType(Y);for(;ne>0;){const fe=G(H,ne),Ee=he.getGraphemeBreakType(fe);if(Le(Ee,oe))break;ne-=fe>=65536?2:1,oe=Ee}return q-ne}e.prevCharLength=N;function W(H,ne){const he=Ue.getInstance(),q=H.length,Y=ne,oe=B(H,q,ne),fe=he.getGraphemeBreakType(oe);ne+=oe>=65536?2:1;let Ee=fe;for(;ne<q;){const Fe=B(H,q,ne),Ve=he.getGraphemeBreakType(Fe);if(Le(Ee,Ve))break;ne+=Fe>=65536?2:1,Ee=Ve}const Ne=ne;for(ne=Y,Ee=fe;ne>0;){const Fe=G(H,ne),Ve=he.getGraphemeBreakType(Fe);if(Le(Ve,Ee))break;ne-=Fe>=65536?2:1,Ee=Ve}return[ne,Ne]}function Q(H,ne){return ne>0&&ae(H.charCodeAt(ne))?W(H,ne-1):W(H,ne)}e.getCharContainingOffset=Q;function $(H){const ne=H.length;let he=0,q=0;for(;q<ne;){const fe=B(H,ne,q);q+=fe>=65536?2:1,fe<128?he+=1:fe<2048?he+=2:fe<65536?he+=3:he+=4}const Y=new Uint8Array(he);q=0;let oe=0;for(;q<ne;){const fe=B(H,ne,q);q+=fe>=65536?2:1,fe<128?Y[oe++]=fe:fe<2048?(Y[oe++]=192|(fe&1984)>>>6,Y[oe++]=128|(fe&63)>>>0):fe<65536?(Y[oe++]=224|(fe&61440)>>>12,Y[oe++]=128|(fe&4032)>>>6,Y[oe++]=128|(fe&63)>>>0):(Y[oe++]=240|(fe&1835008)>>>18,Y[oe++]=128|(fe&258048)>>>12,Y[oe++]=128|(fe&4032)>>>6,Y[oe++]=128|(fe&63)>>>0)}return Y}e.encodeUTF8=$;function Z(H){const ne=H.byteLength,he=[];let q=0;for(;q<ne;){const Y=H[q];let oe;if(Y>=240&&q+3<ne?oe=(H[q++]&7)<<18>>>0|(H[q++]&63)<<12>>>0|(H[q++]&63)<<6>>>0|(H[q++]&63)<<0>>>0:Y>=224&&q+2<ne?oe=(H[q++]&15)<<12>>>0|(H[q++]&63)<<6>>>0|(H[q++]&63)<<0>>>0:Y>=192&&q+1<ne?oe=(H[q++]&31)<<6>>>0|(H[q++]&63)<<0>>>0:oe=H[q++],oe>=0&&oe<=55295||oe>=57344&&oe<=65535)he.push(String.fromCharCode(oe));else if(oe>=65536&&oe<=1114111){const fe=oe-65536,Ee=55296+((fe&1047552)>>>10),Ne=56320+((fe&1023)>>>0);he.push(String.fromCharCode(Ee)),he.push(String.fromCharCode(Ne))}else he.push(String.fromCharCode(65533))}return he.join("")}e.decodeUTF8=Z;const re=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function se(H){return re.test(H)}e.containsRTL=se;const ye=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Pe(H){return ye.test(H)}e.containsEmoji=Pe;const $e=/^[\t\n\r\x20-\x7E]*$/;function Re(H){return $e.test(H)}e.isBasicASCII=Re,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ze(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=ze;function U(H){for(let ne=0,he=H.length;ne<he;ne++)if(K(H.charCodeAt(ne)))return!0;return!1}e.containsFullWidthCharacter=U;function K(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=K;function te(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=te;function le(H,ne){if(H.length<ne)return H;const he=/\b/g;let q=0;for(;he.test(H)&&!(H.length-he.lastIndex<ne);)q=he.lastIndex,he.lastIndex+=1;return H.substring(q).replace(/^\s/,"")}e.lcut=le;const me=/\x1B\x5B[12]?K/g,Se=/\x1b\[\d+m/g,Me=/\x1b\[0?m/g;function ge(H){return H&&(H=H.replace(me,""),H=H.replace(Se,""),H=H.replace(Me,"")),H}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Ae(H){return Ce(H)?H.substr(1):H}e.stripUTF8BOM=Ae;function Be(H,ne){if(!H||!ne||H.length<ne.length)return!1;const he=ne.length,q=H.toLowerCase();let Y=0,oe=-1;for(;Y<he;){const fe=q.indexOf(ne[Y],oe+1);if(fe<0)return!1;oe=fe,Y++}return!0}e.fuzzyContains=Be;function be(H,ne=!1){return H?(ne&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=be;function qe(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=qe;function j(H,ne=1){if(ne===0)return"";let he=-1;do he=H.indexOf(`
`,he+1),ne--;while(ne>0&&he>=0);return he===-1?H:(H[he-1]==="\r"&&he--,H.substr(0,he))}e.getNLines=j;function X(H){const ne=90-65+1;return H=H%(2*ne),H<ne?String.fromCharCode(97+H):String.fromCharCode(65+H-ne)}e.singleLetterHash=X;function pe(H){return Ue.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=pe;function Le(H,ne){return H===0?ne!==5&&ne!==7:H===2&&ne===3?!1:H===4||H===2||H===3||ne===4||ne===2||ne===3?!0:!(H===8&&(ne===8||ne===9||ne===11||ne===12)||(H===11||H===9)&&(ne===9||ne===10)||(H===12||H===10)&&ne===10||ne===5||ne===13||ne===7||H===1||H===13&&ne===14||H===6&&ne===6)}e.breakBetweenGraphemeBreakType=Le;var He;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})(He=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ue{constructor(){this._data=Ze()}static getInstance(){return Ue._INSTANCE||(Ue._INSTANCE=new Ue),Ue._INSTANCE}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const he=this._data,q=he.length/3;let Y=1;for(;Y<=q;)if(ne<he[3*Y])Y=2*Y;else if(ne>he[3*Y+1])Y=2*Y+1;else return he[3*Y+2];return 0}}Ue._INSTANCE=null;function Ze(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(ve[23],_e([0,1,8,107]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const P=typeof Buffer!="undefined",A=typeof TextEncoder!="undefined",S=typeof TextDecoder!="undefined";let D,y;class n{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return P?new n(Buffer.allocUnsafe(l)):new n(new Uint8Array(l))}static wrap(l){return P&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new n(l)}static fromString(l,o){return!((o==null?void 0:o.dontUseNodeBuffer)||!1)&&P?new n(Buffer.from(l)):A?(D||(D=new TextEncoder),new n(D.encode(l))):new n(E.encodeUTF8(l))}static concat(l,o){if(typeof o=="undefined"){o=0;for(let p=0,m=l.length;p<m;p++)o+=l[p].byteLength}const w=n.alloc(o);let I=0;for(let p=0,m=l.length;p<m;p++){const R=l[p];w.set(R,I),I+=R.byteLength}return w}toString(){return P?this.buffer.toString():S?(y||(y=new TextDecoder),y.decode(this.buffer)):E.decodeUTF8(this.buffer)}slice(l,o){return new n(this.buffer.subarray(l,o))}set(l,o){l instanceof n?this.buffer.set(l.buffer,o):this.buffer.set(l,o)}readUInt32BE(l){return g(this.buffer,l)}writeUInt32BE(l,o){f(this.buffer,l,o)}readUInt32LE(l){return r(this.buffer,l)}writeUInt32LE(l,o){s(this.buffer,l,o)}readUInt8(l){return b(this.buffer,l)}writeUInt8(l,o){h(this.buffer,l,o)}}e.VSBuffer=n;function T(a,l){return a[l+0]<<0>>>0|a[l+1]<<8>>>0}e.readUInt16LE=T;function C(a,l,o){a[o+0]=l&255,l=l>>>8,a[o+1]=l&255}e.writeUInt16LE=C;function g(a,l){return a[l]*2**24+a[l+1]*2**16+a[l+2]*2**8+a[l+3]}e.readUInt32BE=g;function f(a,l,o){a[o+3]=l,l=l>>>8,a[o+2]=l,l=l>>>8,a[o+1]=l,l=l>>>8,a[o]=l}e.writeUInt32BE=f;function r(a,l){return a[l+0]<<0>>>0|a[l+1]<<8>>>0|a[l+2]<<16>>>0|a[l+3]<<24>>>0}e.readUInt32LE=r;function s(a,l,o){a[o+0]=l&255,l=l>>>8,a[o+1]=l&255,l=l>>>8,a[o+2]=l&255,l=l>>>8,a[o+3]=l&255}e.writeUInt32LE=s;function b(a,l){return a[l]}e.readUInt8=b;function h(a,l,o){a[o]=l}e.writeUInt8=h;function _(a){return k.consumeReadable(a,l=>n.concat(l))}e.readableToBuffer=_;function v(a){return k.toReadable(a)}e.bufferToReadable=v;function c(a){return k.consumeStream(a,l=>n.concat(l))}e.streamToBuffer=c;async function u(a){return a.ended?n.concat(a.buffer):n.concat([...a.buffer,await c(a.stream)])}e.bufferedStreamToBuffer=u;function t(a){return k.toStream(a,l=>n.concat(l))}e.bufferToStream=t;function i(a){return k.transform(a,{data:l=>typeof l=="string"?n.fromString(l):n.wrap(l)},l=>n.concat(l))}e.streamToBufferReadableStream=i;function d(a){return k.newWriteableStream(l=>n.concat(l),a)}e.newWriteableBufferStream=d}),define(ve[56],_e([0,1,8]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function k(h){return P(h,0)}e.hash=k;function P(h,_){switch(typeof h){case"object":return h===null?A(349,_):Array.isArray(h)?y(h,_):n(h,_);case"string":return D(h,_);case"boolean":return S(h,_);case"number":return A(h,_);case"undefined":return A(937,_);default:return A(617,_)}}e.doHash=P;function A(h,_){return(_<<5)-_+h|0}function S(h,_){return A(h?433:863,_)}function D(h,_){_=A(149417,_);for(let v=0,c=h.length;v<c;v++)_=A(h.charCodeAt(v),_);return _}e.stringHash=D;function y(h,_){return _=A(104579,_),h.reduce((v,c)=>P(c,v),_)}function n(h,_){return _=A(181387,_),Object.keys(h).sort().reduce((v,c)=>(v=D(c,v),P(h[c],v)),_)}class T{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=P(_,this._value),this._value}}e.Hasher=T;var C;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function g(h,_,v=32){const c=v-_,u=~((1<<c)-1);return(h<<_|(u&h)>>>c)>>>0}function f(h,_=0,v=h.byteLength,c=0){for(let u=0;u<v;u++)h[_+u]=c}function r(h,_,v="0"){for(;h.length<_;)h=v+h;return h}function s(h,_=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(v=>v.toString(16).padStart(2,"0")).join(""):r((h>>>0).toString(16),_/4)}e.toHexString=s;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const v=_.length;if(v!==0){const c=this._buff;let u=this._buffLen,t=this._leftoverHighSurrogate,i,d;for(t!==0?(i=t,d=-1,t=0):(i=_.charCodeAt(0),d=0);;){let a=i;if(E.isHighSurrogate(i))if(d+1<v){const l=_.charCodeAt(d+1);E.isLowSurrogate(l)?(d++,a=E.computeCodePoint(i,l)):a=65533}else{t=i;break}else E.isLowSurrogate(i)&&(a=65533);if(u=this._push(c,u,a),d++,d<v)i=_.charCodeAt(d);else break}this._buffLen=u,this._leftoverHighSurrogate=t}}_push(_,v,c){return c<128?_[v++]=c:c<2048?(_[v++]=192|(c&1984)>>>6,_[v++]=128|(c&63)>>>0):c<65536?(_[v++]=224|(c&61440)>>>12,_[v++]=128|(c&4032)>>>6,_[v++]=128|(c&63)>>>0):(_[v++]=240|(c&1835008)>>>18,_[v++]=128|(c&258048)>>>12,_[v++]=128|(c&4032)>>>6,_[v++]=128|(c&63)>>>0),v>=64&&(this._step(),v-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),s(this._h0)+s(this._h1)+s(this._h2)+s(this._h3)+s(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=b._bigBlock32,v=this._buffDV;for(let w=0;w<64;w+=4)_.setUint32(w,v.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)_.setUint32(w,g(_.getUint32(w-12,!1)^_.getUint32(w-32,!1)^_.getUint32(w-56,!1)^_.getUint32(w-64,!1),1),!1);let c=this._h0,u=this._h1,t=this._h2,i=this._h3,d=this._h4,a,l,o;for(let w=0;w<80;w++)w<20?(a=u&t|~u&i,l=1518500249):w<40?(a=u^t^i,l=1859775393):w<60?(a=u&t|u&i|t&i,l=2400959708):(a=u^t^i,l=3395469782),o=g(c,5)+a+d+l+_.getUint32(w*4,!1)&4294967295,d=i,i=t,t=g(u,30),u=c,c=o;this._h0=this._h0+c&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+d&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ve[46],_e([0,1,8]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(k||(k={})),function(P){const A="error",S="warning",D="warn",y="info";function n(T){return T?E.equalsIgnoreCase(A,T)?P.Error:E.equalsIgnoreCase(S,T)||E.equalsIgnoreCase(D,T)?P.Warning:E.equalsIgnoreCase(y,T)?P.Info:P.Ignore:P.Ignore}P.fromValue=n}(k||(k={})),e.default=k}),define(ve[13],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function E(o){return Array.isArray(o)}e.isArray=E;function k(o){return typeof o=="string"}e.isString=k;function P(o){return Array.isArray(o)&&o.every(w=>k(w))}e.isStringArray=P;function A(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=A;function S(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=S;function D(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=D;function y(o){return o===!0||o===!1}e.isBoolean=y;function n(o){return typeof o=="undefined"}e.isUndefined=n;function T(o){return!C(o)}e.isDefined=T;function C(o){return n(o)||o===null}e.isUndefinedOrNull=C;function g(o,w){if(!o)throw new Error(w?`Unexpected type, expected '${w}'`:"Unexpected type")}e.assertType=g;function f(o){if(C(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=f;function r(...o){const w=[];for(let I=0;I<o.length;I++){const p=o[I];if(C(p))throw new Error(`Assertion Failed: argument at index ${I} is undefined or null`);w.push(p)}return w}e.assertAllDefined=r;const s=Object.prototype.hasOwnProperty;function b(o){if(!A(o))return!1;for(let w in o)if(s.call(o,w))return!1;return!0}e.isEmptyObject=b;function h(o){return typeof o=="function"}e.isFunction=h;function _(...o){return o.length>0&&o.every(h)}e.areFunctions=_;function v(o,w){const I=Math.min(o.length,w.length);for(let p=0;p<I;p++)c(o[p],w[p])}e.validateConstraints=v;function c(o,w){if(k(w)){if(typeof o!==w)throw new Error(`argument does not match constraint: typeof ${w}`)}else if(h(w)){try{if(o instanceof w)return}catch(I){}if(!C(o)&&o.constructor===w||w.length===1&&w.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function u(o){let w=[],I=Object.getPrototypeOf(o);for(;Object.prototype!==I;)w=w.concat(Object.getOwnPropertyNames(I)),I=Object.getPrototypeOf(I);return w}e.getAllPropertyNames=u;function t(o){const w=[];for(const I of u(o))typeof o[I]=="function"&&w.push(I);return w}e.getAllMethodNames=t;function i(o,w){const I=m=>function(){const R=Array.prototype.slice.call(arguments,0);return w(m,R)};let p={};for(const m of o)p[m]=I(m);return p}e.createProxyObject=i;function d(o){return o===null?void 0:o}e.withNullAsUndefined=d;function a(o){return typeof o=="undefined"?null:o}e.withUndefinedAsNull=a;function l(o){return class{constructor(){return new Proxy({},{get(w,I){if(w[I])return w[I];throw new Error(`Not Implemented: ${o}->${String(I)}`)}})}}}e.NotImplementedProxy=l}),define(ve[37],_e([0,1,21,8,12,13]),function(ie,e,E,k,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function S(i){return i===47||i===92}e.isPathSeparator=S;function D(i){return i.replace(/[\\/]/g,P.posix.sep)}e.toSlashes=D;function y(i,d=P.posix.sep){if(!i)return"";const a=i.length,l=i.charCodeAt(0);if(S(l)){if(S(i.charCodeAt(1))&&!S(i.charCodeAt(2))){let w=3;const I=w;for(;w<a&&!S(i.charCodeAt(w));w++);if(I!==w&&!S(i.charCodeAt(w+1))){for(w+=1;w<a;w++)if(S(i.charCodeAt(w)))return i.slice(0,w+1).replace(/[\\/]/g,d)}}return d}else if(b(l)&&i.charCodeAt(1)===58)return S(i.charCodeAt(2))?i.slice(0,2)+d:i.slice(0,2);let o=i.indexOf("://");if(o!==-1){for(o+=3;o<a;o++)if(S(i.charCodeAt(o)))return i.slice(0,o+1)}return""}e.getRoot=y;function n(i){if(!E.isWindows||!i||i.length<5)return!1;let d=i.charCodeAt(0);if(d!==92||(d=i.charCodeAt(1),d!==92))return!1;let a=2;const l=a;for(;a<i.length&&(d=i.charCodeAt(a),d!==92);a++);return!(l===a||(d=i.charCodeAt(a+1),isNaN(d)||d===92))}e.isUNC=n;const T=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(i,d=E.isWindows){const a=d?T:C;return!(!i||i.length===0||/^\s+$/.test(i)||(a.lastIndex=0,a.test(i))||d&&g.test(i)||i==="."||i===".."||d&&i[i.length-1]==="."||d&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=f;function r(i,d,a){const l=i===d;return!a||l?l:!i||!d?!1:(0,k.equalsIgnoreCase)(i,d)}e.isEqual=r;function s(i,d,a,l=P.sep){if(i===d)return!0;if(!i||!d||d.length>i.length)return!1;if(a){if(!(0,k.startsWithIgnoreCase)(i,d))return!1;if(d.length===i.length)return!0;let w=d.length;return d.charAt(d.length-1)===l&&w--,i.charAt(w)===l}return d.charAt(d.length-1)!==l&&(d+=l),i.indexOf(d)===0}e.isEqualOrParent=s;function b(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=b;function h(i,d){return E.isWindows&&i.endsWith(":")&&(i+=P.sep),(0,P.isAbsolute)(i)||(i=(0,P.join)(d,i)),i=(0,P.normalize)(i),E.isWindows?(i=(0,k.rtrim)(i,P.sep),i.endsWith(":")&&(i+=P.sep)):(i=(0,k.rtrim)(i,P.sep),i||(i=P.sep)),i}e.sanitizeFilePath=h;function _(i){const d=(0,P.normalize)(i);return E.isWindows?i.length>3?!1:v(d)&&(i.length===2||d.charCodeAt(2)===92):d===P.posix.sep}e.isRootOrDriveLetter=_;function v(i){return E.isWindows?b(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=v;function c(i){return v(i)?i[0]:void 0}e.getDriveLetter=c;function u(i,d,a){return d.length>i.length?-1:i===d?0:(a&&(i=i.toLowerCase(),d=d.toLowerCase()),i.indexOf(d))}e.indexOfPath=u;function t(i){const d=i.split(":");let a,l,o;if(d.forEach(w=>{const I=Number(w);(0,A.isNumber)(I)?l===void 0?l=I:o===void 0&&(o=I):a=a?[a,w].join(":"):w}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:l!==void 0?l:void 0,column:o!==void 0?o:l!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(ve[24],_e([0,1,13]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function k(r){if(!r||typeof r!="object"||r instanceof RegExp)return r;const s=Array.isArray(r)?[]:{};return Object.keys(r).forEach(b=>{r[b]&&typeof r[b]=="object"?s[b]=k(r[b]):s[b]=r[b]}),s}e.deepClone=k;function P(r){if(!r||typeof r!="object")return r;const s=[r];for(;s.length>0;){const b=s.shift();Object.freeze(b);for(const h in b)if(A.call(b,h)){const _=b[h];typeof _=="object"&&!Object.isFrozen(_)&&s.push(_)}}return r}e.deepFreeze=P;const A=Object.prototype.hasOwnProperty;function S(r,s){return D(r,s,new Set)}e.cloneAndChange=S;function D(r,s,b){if((0,E.isUndefinedOrNull)(r))return r;const h=s(r);if(typeof h!="undefined")return h;if((0,E.isArray)(r)){const _=[];for(const v of r)_.push(D(v,s,b));return _}if((0,E.isObject)(r)){if(b.has(r))throw new Error("Cannot clone recursive data-structure");b.add(r);const _={};for(let v in r)A.call(r,v)&&(_[v]=D(r[v],s,b));return b.delete(r),_}return r}function y(r,s,b=!0){return(0,E.isObject)(r)?((0,E.isObject)(s)&&Object.keys(s).forEach(h=>{h in r?b&&((0,E.isObject)(r[h])&&(0,E.isObject)(s[h])?y(r[h],s[h],b):r[h]=s[h]):r[h]=s[h]}),r):s}e.mixin=y;function n(r,s){if(r===s)return!0;if(r==null||s===null||s===void 0||typeof r!=typeof s||typeof r!="object"||Array.isArray(r)!==Array.isArray(s))return!1;let b,h;if(Array.isArray(r)){if(r.length!==s.length)return!1;for(b=0;b<r.length;b++)if(!n(r[b],s[b]))return!1}else{const _=[];for(h in r)_.push(h);_.sort();const v=[];for(h in s)v.push(h);if(v.sort(),!n(_,v))return!1;for(b=0;b<_.length;b++)if(!n(r[_[b]],s[_[b]]))return!1}return!0}e.equals=n;function T(r){const s=new Set;return JSON.stringify(r,(b,h)=>{if((0,E.isObject)(h)||Array.isArray(h)){if(s.has(h))return"[Circular]";s.add(h)}return h})}e.safeStringify=T;function C(r,s,b){const h=s(r);return typeof h=="undefined"?b:h}e.getOrDefault=C;function g(r,s){const b=Object.create(null);return!r||!s||Object.keys(s).forEach(_=>{const v=r[_],c=s[_];n(v,c)||(b[_]=c)}),b}e.distinct=g;function f(r,s){const b=s.toLowerCase(),h=Object.keys(r).find(_=>_.toLowerCase()===b);return h?r[h]:r[s]}e.getCaseInsensitive=f}),define(ve[80],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var E;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(E=e.Constants||(e.Constants={}));function k(A){return A<0?0:A>255?255:A|0}e.toUint8=k;function P(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=P}),define(ve[2],_e([0,1,21,12]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const P=/^\w[\w\d+.-]*$/,A=/^\//,S=/^\/\//;function D(d,a){if(!d.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!P.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!A.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(d,a){return!d&&!a?"file":d}function n(d,a){switch(d){case"https":case"http":case"file":a?a[0]!==C&&(a=C+a):a=C;break}return a}const T="",C="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(a,l,o,w,I,p=!1){typeof a=="object"?(this.scheme=a.scheme||T,this.authority=a.authority||T,this.path=a.path||T,this.query=a.query||T,this.fragment=a.fragment||T):(this.scheme=y(a,p),this.authority=l||T,this.path=n(this.scheme,o||T),this.query=w||T,this.fragment=I||T,D(this,p))}static isUri(a){return a instanceof f?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return v(this,!1)}with(a){if(!a)return this;let{scheme:l,authority:o,path:w,query:I,fragment:p}=a;return l===void 0?l=this.scheme:l===null&&(l=T),o===void 0?o=this.authority:o===null&&(o=T),w===void 0?w=this.path:w===null&&(w=T),I===void 0?I=this.query:I===null&&(I=T),p===void 0?p=this.fragment:p===null&&(p=T),l===this.scheme&&o===this.authority&&w===this.path&&I===this.query&&p===this.fragment?this:new s(l,o,w,I,p)}static parse(a,l=!1){const o=g.exec(a);return o?new s(o[2]||T,i(o[4]||T),i(o[5]||T),i(o[7]||T),i(o[9]||T),l):new s(T,T,T,T,T)}static file(a){let l=T;if(E.isWindows&&(a=a.replace(/\\/g,C)),a[0]===C&&a[1]===C){const o=a.indexOf(C,2);o===-1?(l=a.substring(2),a=C):(l=a.substring(2,o),a=a.substring(o)||C)}return new s("file",l,a,T,T)}static from(a){return new s(a.scheme,a.authority,a.path,a.query,a.fragment)}static joinPath(a,...l){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return E.isWindows&&a.scheme==="file"?o=f.file(k.win32.join(v(a,!0),...l)).path:o=k.posix.join(a.path,...l),a.with({path:o})}toString(a=!1){return c(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof f)return a;{const l=new s(a);return l._formatted=a.external,l._fsPath=a._sep===r?a.fsPath:null,l}}else return a}}e.URI=f;const r=E.isWindows?1:void 0;class s extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(a=!1){return a?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=r),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(d,a){let l,o=-1;for(let w=0;w<d.length;w++){const I=d.charCodeAt(w);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||a&&I===47)o!==-1&&(l+=encodeURIComponent(d.substring(o,w)),o=-1),l!==void 0&&(l+=d.charAt(w));else{l===void 0&&(l=d.substr(0,w));const p=b[I];p!==void 0?(o!==-1&&(l+=encodeURIComponent(d.substring(o,w)),o=-1),l+=p):o===-1&&(o=w)}}return o!==-1&&(l+=encodeURIComponent(d.substring(o))),l!==void 0?l:d}function _(d){let a;for(let l=0;l<d.length;l++){const o=d.charCodeAt(l);o===35||o===63?(a===void 0&&(a=d.substr(0,l)),a+=b[o]):a!==void 0&&(a+=d[l])}return a!==void 0?a:d}function v(d,a){let l;return d.authority&&d.path.length>1&&d.scheme==="file"?l=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?a?l=d.path.substr(1):l=d.path[1].toLowerCase()+d.path.substr(2):l=d.path,E.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=v;function c(d,a){const l=a?_:h;let o="",{scheme:w,authority:I,path:p,query:m,fragment:R}=d;if(w&&(o+=w,o+=":"),(I||w==="file")&&(o+=C,o+=C),I){let F=I.indexOf("@");if(F!==-1){const x=I.substr(0,F);I=I.substr(F+1),F=x.indexOf(":"),F===-1?o+=l(x,!1):(o+=l(x.substr(0,F),!1),o+=":",o+=l(x.substr(F+1),!1)),o+="@"}I=I.toLowerCase(),F=I.indexOf(":"),F===-1?o+=l(I,!1):(o+=l(I.substr(0,F),!1),o+=I.substr(F))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const F=p.charCodeAt(1);F>=65&&F<=90&&(p=`/${String.fromCharCode(F+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const F=p.charCodeAt(0);F>=65&&F<=90&&(p=`${String.fromCharCode(F+32)}:${p.substr(2)}`)}o+=l(p,!0)}return m&&(o+="?",o+=l(m,!1)),R&&(o+="#",o+=a?R:h(R,!1)),o}function u(d){try{return decodeURIComponent(d)}catch(a){return d.length>3?d.substr(0,3)+u(d.substr(3)):d}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(d){return d.match(t)?d.replace(t,a=>u(a)):d}}),define(ve[22],_e([0,1,2,8]),function(ie,e,E,k){"use strict";var P,A;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(c,u,t){let i=c.get(u);return i===void 0&&(i=t,c.set(u,i)),i}e.getOrSet=S;function D(c){const u=[];return c.forEach((t,i)=>{u.push(`${i} => ${t}`)}),`Map(${c.size}) {${u.join(", ")}}`}e.mapToString=D;function y(c){const u=[];return c.forEach(t=>{u.push(t)}),`Set(${c.size}) {${u.join(", ")}}`}e.setToString=y;class n{constructor(){this._value="",this._pos=0}reset(u){return this._value=u,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(u){const t=u.charCodeAt(0),i=this._value.charCodeAt(this._pos);return t-i}value(){return this._value[this._pos]}}e.StringIterator=n;class T{constructor(u=!0){this._caseSensitive=u}reset(u){return this._value=u,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let u=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(u)this._from++;else break;else u=!1;return this}cmp(u){return this._caseSensitive?(0,k.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class C{constructor(u=!0,t=!0){this._splitOnBackslash=u,this._caseSensitive=t}reset(u){return this._value=u.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let u=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(u)this._from++;else break;else u=!1}return this}cmp(u){return this._caseSensitive?(0,k.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=C;var g;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(g||(g={}));class f{constructor(u){this._ignorePathCasing=u,this._states=[],this._stateIdx=0}reset(u){return this._value=u,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new C(!1,!this._ignorePathCasing(u)),this._pathIterator.reset(u.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(u){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(u,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(u,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(u);if(this._states[this._stateIdx]===4)return(0,k.compare)(u,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(u,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class r{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class s{constructor(u){this._iter=u}static forUris(u=()=>!1){return new s(new f(u))}static forPaths(){return new s(new C)}static forStrings(){return new s(new n)}static forConfigKeys(){return new s(new T)}clear(){this._root=void 0}set(u,t){const i=this._iter.reset(u);let d;for(this._root||(this._root=new r,this._root.segment=i.value()),d=this._root;;){const l=i.cmp(d.segment);if(l>0)d.left||(d.left=new r,d.left.segment=i.value()),d=d.left;else if(l<0)d.right||(d.right=new r,d.right.segment=i.value()),d=d.right;else if(i.hasNext())i.next(),d.mid||(d.mid=new r,d.mid.segment=i.value()),d=d.mid;else break}const a=d.value;return d.value=t,d.key=u,a}get(u){var t;return(t=this._getNode(u))===null||t===void 0?void 0:t.value}_getNode(u){const t=this._iter.reset(u);let i=this._root;for(;i;){const d=t.cmp(i.segment);if(d>0)i=i.left;else if(d<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else break}return i}has(u){const t=this._getNode(u);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(u){return this._delete(u,!1)}deleteSuperstr(u){return this._delete(u,!0)}_delete(u,t){const i=this._iter.reset(u),d=[];let a=this._root;for(;a;){const l=i.cmp(a.segment);if(l>0)d.push([1,a]),a=a.left;else if(l<0)d.push([-1,a]),a=a.right;else if(i.hasNext())i.next(),d.push([0,a]),a=a.mid;else{for(t?(a.left=void 0,a.mid=void 0,a.right=void 0):a.value=void 0;d.length>0&&a.isEmpty();){let[o,w]=d.pop();switch(o){case 1:w.left=void 0;break;case 0:w.mid=void 0;break;case-1:w.right=void 0;break}a=w}break}}}findSubstr(u){const t=this._iter.reset(u);let i=this._root,d;for(;i;){const a=t.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(t.hasNext())t.next(),d=i.value||d,i=i.mid;else break}return i&&i.value||d}findSuperstr(u){const t=this._iter.reset(u);let i=this._root;for(;i;){const d=t.cmp(i.segment);if(d>0)i=i.left;else if(d<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(u){for(const[t,i]of this)u(i,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(u){u&&(yield*this._entries(u.left),u.value&&(yield[u.key,u.value]),yield*this._entries(u.mid),yield*this._entries(u.right))}}e.TernarySearchTree=s;class b{constructor(u,t){this[P]="ResourceMap",u instanceof b?(this.map=new Map(u.map),this.toKey=t!=null?t:b.defaultToKey):(this.map=new Map,this.toKey=u!=null?u:b.defaultToKey)}set(u,t){return this.map.set(this.toKey(u),t),this}get(u){return this.map.get(this.toKey(u))}has(u){return this.map.has(this.toKey(u))}get size(){return this.map.size}clear(){this.map.clear()}delete(u){return this.map.delete(this.toKey(u))}forEach(u,t){typeof t!="undefined"&&(u=u.bind(t));for(let[i,d]of this.map)u(d,E.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let u of this.map.keys())yield E.URI.parse(u)}*entries(){for(let u of this.map.entries())yield[E.URI.parse(u[0]),u[1]]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(let u of this.map)yield[E.URI.parse(u[0]),u[1]]}}e.ResourceMap=b,b.defaultToKey=c=>c.toString();var h;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(h=e.Touch||(e.Touch={}));class _{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var u;return(u=this._head)===null||u===void 0?void 0:u.value}get last(){var u;return(u=this._tail)===null||u===void 0?void 0:u.value}has(u){return this._map.has(u)}get(u,t=0){const i=this._map.get(u);if(!!i)return t!==0&&this.touch(i,t),i.value}set(u,t,i=0){let d=this._map.get(u);if(d)d.value=t,i!==0&&this.touch(d,i);else{switch(d={key:u,value:t,next:void 0,previous:void 0},i){case 0:this.addItemLast(d);break;case 1:this.addItemFirst(d);break;case 2:this.addItemLast(d);break;default:this.addItemLast(d);break}this._map.set(u,d),this._size++}return this}delete(u){return!!this.remove(u)}remove(u){const t=this._map.get(u);if(!!t)return this._map.delete(u),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const u=this._head;return this._map.delete(u.key),this.removeItem(u),this._size--,u.value}}forEach(u,t){const i=this._state;let d=this._head;for(;d;){if(t?u.bind(t)(d.value,d.key,this):u(d.value,d.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const u=this,t=this._state;let i=this._head;const d={[Symbol.iterator](){return d},next(){if(u._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const a={value:i.key,done:!1};return i=i.next,a}else return{value:void 0,done:!0}}};return d}values(){const u=this,t=this._state;let i=this._head;const d={[Symbol.iterator](){return d},next(){if(u._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const a={value:i.value,done:!1};return i=i.next,a}else return{value:void 0,done:!0}}};return d}entries(){const u=this,t=this._state;let i=this._head;const d={[Symbol.iterator](){return d},next(){if(u._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const a={value:[i.key,i.value],done:!1};return i=i.next,a}else return{value:void 0,done:!0}}};return d}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(u){if(!(u>=this.size)){if(u===0){this.clear();return}let t=this._head,i=this.size;for(;t&&i>u;)this._map.delete(t.key),t=t.next,i--;this._head=t,this._size=i,t&&(t.previous=void 0),this._state++}}addItemFirst(u){if(!this._head&&!this._tail)this._tail=u;else if(this._head)u.next=this._head,this._head.previous=u;else throw new Error("Invalid list");this._head=u,this._state++}addItemLast(u){if(!this._head&&!this._tail)this._head=u;else if(this._tail)u.previous=this._tail,this._tail.next=u;else throw new Error("Invalid list");this._tail=u,this._state++}removeItem(u){if(u===this._head&&u===this._tail)this._head=void 0,this._tail=void 0;else if(u===this._head){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this._head=u.next}else if(u===this._tail){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this._tail=u.previous}else{const t=u.next,i=u.previous;if(!t||!i)throw new Error("Invalid list");t.previous=i,i.next=t}u.next=void 0,u.previous=void 0,this._state++}touch(u,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(u===this._head)return;const i=u.next,d=u.previous;u===this._tail?(d.next=void 0,this._tail=d):(i.previous=d,d.next=i),u.previous=void 0,u.next=this._head,this._head.previous=u,this._head=u,this._state++}else if(t===2){if(u===this._tail)return;const i=u.next,d=u.previous;u===this._head?(i.previous=void 0,this._head=i):(i.previous=d,d.next=i),u.next=void 0,u.previous=this._tail,this._tail.next=u,this._tail=u,this._state++}}}toJSON(){const u=[];return this.forEach((t,i)=>{u.push([i,t])}),u}fromJSON(u){this.clear();for(const[t,i]of u)this.set(t,i)}}e.LinkedMap=_;class v extends _{constructor(u,t=1){super();this._limit=u,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(u){this._limit=u,this.checkTrim()}get ratio(){return this._ratio}set ratio(u){this._ratio=Math.min(Math.max(0,u),1),this.checkTrim()}get(u,t=2){return super.get(u,t)}peek(u){return super.get(u,0)}set(u,t){return super.set(u,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=v}),define(ve[108],_e([0,1,22,8]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function P(...ge){return function(Ce,Ae){for(let Be=0,be=ge.length;Be<be;Be++){const qe=ge[Be](Ce,Ae);if(qe)return qe}return null}}e.or=P,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(ge,Ce,Ae){if(!Ae||Ae.length<Ce.length)return null;let Be;return ge?Be=k.startsWithIgnoreCase(Ae,Ce):Be=Ae.indexOf(Ce)===0,Be?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function S(ge,Ce){const Ae=Ce.toLowerCase().indexOf(ge.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+ge.length}]}e.matchesContiguousSubString=S;function D(ge,Ce){return y(ge.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=D;function y(ge,Ce,Ae,Be){if(Ae===ge.length)return[];if(Be===Ce.length)return null;if(ge[Ae]===Ce[Be]){let be=null;return(be=y(ge,Ce,Ae+1,Be+1))?h({start:Be,end:Be+1},be):null}return y(ge,Ce,Ae,Be+1)}function n(ge){return 97<=ge&&ge<=122}function T(ge){return 65<=ge&&ge<=90}e.isUpper=T;function C(ge){return 48<=ge&&ge<=57}function g(ge){return ge===32||ge===9||ge===10||ge===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(ge=>f.add(ge.charCodeAt(0)));function r(ge){return g(ge)||f.has(ge)}function s(ge,Ce){return ge===Ce||r(ge)&&r(Ce)}function b(ge){return n(ge)||T(ge)||C(ge)}function h(ge,Ce){return Ce.length===0?Ce=[ge]:ge.end===Ce[0].start?Ce[0].start=ge.start:Ce.unshift(ge),Ce}function _(ge,Ce){for(let Ae=Ce;Ae<ge.length;Ae++){const Be=ge.charCodeAt(Ae);if(T(Be)||C(Be)||Ae>0&&!b(ge.charCodeAt(Ae-1)))return Ae}return ge.length}function v(ge,Ce,Ae,Be){if(Ae===ge.length)return[];if(Be===Ce.length)return null;if(ge[Ae]!==Ce[Be].toLowerCase())return null;{let be=null,qe=Be+1;for(be=v(ge,Ce,Ae+1,Be+1);!be&&(qe=_(Ce,qe))<Ce.length;)be=v(ge,Ce,Ae+1,qe),qe++;return be===null?null:h({start:Be,end:Be+1},be)}}function c(ge){let Ce=0,Ae=0,Be=0,be=0,qe=0;for(let He=0;He<ge.length;He++)qe=ge.charCodeAt(He),T(qe)&&Ce++,n(qe)&&Ae++,b(qe)&&Be++,C(qe)&&be++;const j=Ce/ge.length,X=Ae/ge.length,pe=Be/ge.length,Le=be/ge.length;return{upperPercent:j,lowerPercent:X,alphaPercent:pe,numericPercent:Le}}function u(ge){const{upperPercent:Ce,lowerPercent:Ae}=ge;return Ae===0&&Ce>.6}function t(ge){const{upperPercent:Ce,lowerPercent:Ae,alphaPercent:Be,numericPercent:be}=ge;return Ae>.2&&Ce<.8&&Be>.6&&be<.2}function i(ge){let Ce=0,Ae=0,Be=0,be=0;for(let qe=0;qe<ge.length;qe++)Be=ge.charCodeAt(qe),T(Be)&&Ce++,n(Be)&&Ae++,g(Be)&&be++;return(Ce===0||Ae===0)&&be===0?ge.length<=30:Ce<=5}function d(ge,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!i(ge)||Ce.length>60)return null;const Ae=c(Ce);if(!t(Ae)){if(!u(Ae))return null;Ce=Ce.toLowerCase()}let Be=null,be=0;for(ge=ge.toLowerCase();be<Ce.length&&(Be=v(ge,Ce,0,be))===null;)be=_(Ce,be+1);return Be}e.matchesCamelCase=d;function a(ge,Ce,Ae=!1){if(!Ce||Ce.length===0)return null;let Be=null,be=0;for(ge=ge.toLowerCase(),Ce=Ce.toLowerCase();be<Ce.length&&(Be=l(ge,Ce,0,be,Ae))===null;)be=o(Ce,be+1);return Be}e.matchesWords=a;function l(ge,Ce,Ae,Be,be){if(Ae===ge.length)return[];if(Be===Ce.length)return null;if(s(ge.charCodeAt(Ae),Ce.charCodeAt(Be))){let qe=null,j=Be+1;if(qe=l(ge,Ce,Ae+1,Be+1,be),!be)for(;!qe&&(j=o(Ce,j))<Ce.length;)qe=l(ge,Ce,Ae+1,j,be),j++;return qe===null?null:h({start:Be,end:Be+1},qe)}else return null}function o(ge,Ce){for(let Ae=Ce;Ae<ge.length;Ae++)if(r(ge.charCodeAt(Ae))||Ae>0&&r(ge.charCodeAt(Ae-1)))return Ae;return ge.length}const w=P(e.matchesPrefix,d,S),I=P(e.matchesPrefix,d,D),p=new E.LRUCache(1e4);function m(ge,Ce,Ae=!1){if(typeof ge!="string"||typeof Ce!="string")return null;let Be=p.get(ge);Be||(Be=new RegExp(k.convertSimple2RegExpPattern(ge),"i"),p.set(ge,Be));const be=Be.exec(Ce);return be?[{start:be.index,end:be.index+be[0].length}]:Ae?I(ge,Ce):w(ge,Ce)}e.matchesFuzzy=m;function R(ge,Ce){const Ae=U(ge,ge.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Ae?x(Ae):null}e.matchesFuzzy2=R;function F(ge,Ce,Ae,Be,be,qe){const j=Math.min(13,ge.length);for(;Ae<j;Ae++){const X=U(ge,Ce,Ae,Be,be,qe,!1);if(X)return X}return[0,qe]}e.anyScore=F;function x(ge){if(typeof ge=="undefined")return[];const Ce=[],Ae=ge[1];for(let Be=ge.length-1;Be>1;Be--){const be=ge[Be]+Ae,qe=Ce[Ce.length-1];qe&&qe.end===be?qe.end=be+1:Ce.push({start:be,end:be+1})}return Ce}e.createMatches=x;const ae=128;function z(){const ge=[],Ce=[];for(let Ae=0;Ae<=ae;Ae++)Ce[Ae]=0;for(let Ae=0;Ae<=ae;Ae++)ge.push(Ce.slice(0));return ge}function B(ge){const Ce=[];for(let Ae=0;Ae<=ge;Ae++)Ce[Ae]=0;return Ce}const G=B(2*ae),M=B(2*ae),N=z(),W=z(),Q=z(),$=!1;function Z(ge,Ce,Ae,Be,be){function qe(X,pe,Le=" "){for(;X.length<pe;)X=Le+X;return X}let j=` |   |${Be.split("").map(X=>qe(X,3)).join("|")}
`;for(let X=0;X<=Ae;X++)X===0?j+=" |":j+=`${Ce[X-1]}|`,j+=ge[X].slice(0,be+1).map(pe=>qe(pe.toString(),3)).join("|")+`
`;return j}function re(ge,Ce,Ae,Be){ge=ge.substr(Ce),Ae=Ae.substr(Be),console.log(Z(W,ge,ge.length,Ae,Ae.length)),console.log(Z(Q,ge,ge.length,Ae,Ae.length)),console.log(Z(N,ge,ge.length,Ae,Ae.length))}function se(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;const Ae=ge.codePointAt(Ce);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(Ae)}}function ye(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;switch(ge.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function Pe(ge,Ce,Ae){return Ce[ge]!==Ae[ge]}function $e(ge,Ce,Ae,Be,be,qe,j=!1){for(;Ce<Ae&&be<qe;)ge[Ce]===Be[be]&&(j&&(G[Ce]=be),Ce+=1),be+=1;return Ce===Ae}e.isPatternInWord=$e;var Re;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})(Re||(Re={}));var ze;(function(ge){ge.Default=[-100,0];function Ce(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}ge.isDefault=Ce})(ze=e.FuzzyScore||(e.FuzzyScore={}));function U(ge,Ce,Ae,Be,be,qe,j){const X=ge.length>ae?ae:ge.length,pe=Be.length>ae?ae:Be.length;if(!(Ae>=X||qe>=pe||X-Ae>pe-qe)&&!!$e(Ce,Ae,X,be,qe,pe,!0)){K(X,pe,Ae,qe,Ce,be);let Le=1,He=1,Ue=Ae,Ze=qe;const H=[!1];for(Le=1,Ue=Ae;Ue<X;Le++,Ue++){const oe=G[Ue],fe=M[Ue],Ee=Ue+1<X?M[Ue+1]:pe;for(He=oe-qe+1,Ze=oe;Ze<Ee;He++,Ze++){let Ne=Number.MIN_SAFE_INTEGER,Fe=!1;Ze<=fe&&(Ne=te(ge,Ce,Ue,Ae,Be,be,Ze,pe,qe,N[Le-1][He-1]===0,H));let Ve=0;Ne!==Number.MAX_SAFE_INTEGER&&(Fe=!0,Ve=Ne+W[Le-1][He-1]);const Xe=Ze>oe,tt=Xe?W[Le][He-1]+(N[Le][He-1]>0?-5:0):0,nt=Ze>oe+1&&N[Le][He-1]>0,rt=nt?W[Le][He-2]+(N[Le][He-2]>0?-5:0):0;if(nt&&(!Xe||rt>=tt)&&(!Fe||rt>=Ve))W[Le][He]=rt,Q[Le][He]=3,N[Le][He]=0;else if(Xe&&(!Fe||tt>=Ve))W[Le][He]=tt,Q[Le][He]=2,N[Le][He]=0;else if(Fe)W[Le][He]=Ve,Q[Le][He]=1,N[Le][He]=N[Le-1][He-1]+1;else throw new Error("not possible")}}if($&&re(ge,Ae,Be,qe),!(!H[0]&&!j)){Le--,He--;const ne=[W[Le][He],qe];let he=0,q=0;for(;Le>=1;){let oe=He;do{const fe=Q[Le][oe];if(fe===3)oe=oe-2;else if(fe===2)oe=oe-1;else break}while(oe>=1);he>1&&Ce[Ae+Le-1]===be[qe+He-1]&&!Pe(oe+qe-1,Be,be)&&he+1>N[Le][oe]&&(oe=He),oe===He?he++:he=1,q||(q=oe),Le--,He=oe-1,ne.push(He)}pe===X&&(ne[0]+=2);const Y=q-X;return ne[0]-=Y,ne}}}e.fuzzyScore=U;function K(ge,Ce,Ae,Be,be,qe){let j=ge-1,X=Ce-1;for(;j>=Ae&&X>=Be;)be[j]===qe[X]&&(M[j]=X,j--),X--}function te(ge,Ce,Ae,Be,be,qe,j,X,pe,Le,He){if(Ce[Ae]!==qe[j])return Number.MIN_SAFE_INTEGER;let Ue=1,Ze=!1;return j===Ae-Be?Ue=ge[Ae]===be[j]?7:5:Pe(j,be,qe)&&(j===0||!Pe(j-1,be,qe))?(Ue=ge[Ae]===be[j]?7:5,Ze=!0):se(qe,j)&&(j===0||!se(qe,j-1))?Ue=5:(se(qe,j-1)||ye(qe,j-1))&&(Ue=5,Ze=!0),Ue>1&&Ae===Be&&(He[0]=!0),Ze||(Ze=Pe(j,be,qe)||se(qe,j-1)||ye(qe,j-1)),Ae===Be?j>pe&&(Ue-=Ze?3:5):Le?Ue+=Ze?2:0:Ue+=Ze?0:1,j+1===X&&(Ue-=Ze?3:5),Ue}function le(ge,Ce,Ae,Be,be,qe,j){return Se(ge,Ce,Ae,Be,be,qe,!0,j)}e.fuzzyScoreGracefulAggressive=le;function me(ge,Ce,Ae,Be,be,qe,j){return Se(ge,Ce,Ae,Be,be,qe,!1,j)}e.fuzzyScoreGraceful=me;function Se(ge,Ce,Ae,Be,be,qe,j,X){let pe=U(ge,Ce,Ae,Be,be,qe,X);if(pe&&!j)return pe;if(ge.length>=3){const Le=Math.min(7,ge.length-1);for(let He=Ae+1;He<Le;He++){const Ue=Me(ge,He);if(Ue){const Ze=U(Ue,Ue.toLowerCase(),Ae,Be,be,qe,X);Ze&&(Ze[0]-=3,(!pe||Ze[0]>pe[0])&&(pe=Ze))}}}return pe}function Me(ge,Ce){if(!(Ce+1>=ge.length)){const Ae=ge[Ce],Be=ge[Ce+1];if(Ae!==Be)return ge.slice(0,Ce)+Be+Ae+ge.slice(Ce+2)}}}),define(ve[109],_e([0,1,36,108,8]),function(ie,e,E,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(`(\\\\)?${A.source}`,"g");function D(s){return s.replace(S,(b,h)=>h?b:`\\${b}`)}e.escapeIcons=D;const y=new RegExp(`\\\\${A.source}`,"g");function n(s){return s.replace(y,b=>`\\${b}`)}e.markdownEscapeEscapedIcons=n;const T=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function C(s){return s.indexOf(e.iconStartMarker)===-1?s:s.replace(T,(b,h,_,v)=>_?b:h||v||"")}e.stripIcons=C;function g(s){const b=s.indexOf(e.iconStartMarker);return b===-1?{text:s}:f(s,b)}e.parseLabelWithIcons=g;function f(s,b){const h=[];let _="";function v(o){if(o){_+=o;for(const w of o)h.push(t)}}let c=-1,u="",t=0,i,d,a=b;const l=s.length;for(v(s.substr(0,b));a<l;)i=s[a],d=s[a+1],i===e.iconStartMarker[0]&&d===e.iconStartMarker[1]?(c=a,v(u),u=e.iconStartMarker,a++):i===")"&&c!==-1?(t+=a-c+1,c=-1,u=""):c!==-1?/^[a-z0-9\-]$/i.test(i)?u+=i:(v(u),c=-1,u=""):v(i),a++;return v(u),{text:_,iconOffsets:h}}function r(s,b,h=!1){const{text:_,iconOffsets:v}=b;if(!v||v.length===0)return(0,k.matchesFuzzy)(s,_,h);const c=(0,P.ltrim)(_," "),u=_.length-c.length,t=(0,k.matchesFuzzy)(s,c,h);if(t)for(const i of t){const d=v[i.start+u]+u;i.start+=d,i.end+=d}return t}e.matchesFuzzyIconAware=r}),define(ve[81],_e([0,1,11,109,10]),function(ie,e,E,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(s="",b=!1){var h,_;if(this.value=s,typeof this.value!="string")throw(0,P.illegalArgument)("value");typeof b=="boolean"?(this.isTrusted=b,this.supportThemeIcons=!1):(this.isTrusted=(h=b.isTrusted)!==null&&h!==void 0?h:void 0,this.supportThemeIcons=(_=b.supportThemeIcons)!==null&&_!==void 0?_:!1)}appendText(s,b=0){return this.value+=C(this.supportThemeIcons?(0,k.escapeIcons)(s):s).replace(/([ \t]+)/g,(h,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,b===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,b){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=b,this.value+="\n```\n",this}}e.MarkdownString=S;function D(r){return y(r)?!r.value:Array.isArray(r)?r.every(D):!0}e.isEmptyMarkdownString=D;function y(r){return r instanceof S?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function n(r,s){return!r&&!s?!0:!r||!s?!1:Array.isArray(r)&&Array.isArray(s)?(0,E.equals)(r,s,T):y(r)&&y(s)?T(r,s):!1}e.markedStringsEquals=n;function T(r,s){return r===s?!0:!r||!s?!1:r.value===s.value&&r.isTrusted===s.isTrusted&&r.supportThemeIcons===s.supportThemeIcons}function C(r){return r.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function g(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=g;function f(r){const s=[],b=r.split("|").map(_=>_.trim());r=b[0];const h=b[1];if(h){const _=/height=(\d+)/.exec(h),v=/width=(\d+)/.exec(h),c=_?_[1]:"",u=v?v[1]:"",t=isFinite(parseInt(u)),i=isFinite(parseInt(c));t&&s.push(`width="${u}"`),i&&s.push(`height="${c}"`)}return{href:r,dimensions:s}}e.parseHrefAndDimensions=f}),define(ve[57],_e([0,1,23,8,2]),function(ie,e,E,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(n){return JSON.stringify(n,D)}e.stringify=A;function S(n){let T=JSON.parse(n);return T=y(T),T}e.parse=S;function D(n,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,k.regExpFlags)(T)}:T}function y(n,T=0){if(!n||T>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return P.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof E.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let C=0;C<n.length;++C)n[C]=y(n[C],T+1);else for(const C in n)Object.hasOwnProperty.call(n,C)&&(n[C]=y(n[C],T+1))}return n}e.revive=y}),define(ve[18],_e([0,1,2,21]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var P;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file"})(P=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,n,T){this._hosts[y]=n,this._ports[y]=T}setConnectionToken(y,n){this._connectionTokens[y]=n}rewrite(y){if(this._delegate)return this._delegate(y);const n=y.authority;let T=this._hosts[n];T&&T.indexOf(":")!==-1&&(T=`[${T}]`);const C=this._ports[n],g=this._connectionTokens[n];let f=`path=${encodeURIComponent(y.path)}`;return typeof g=="string"&&(f+=`&tkn=${encodeURIComponent(g)}`),E.URI.from({scheme:k.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${T}:${C}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new A;class S{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,n,T){const C=this.toUri(y,n);return C.scheme===P.vscodeRemote?e.RemoteAuthorities.rewrite(C):k.isNative&&(T||k.isPreferringBrowserCodeLoad)&&C.scheme===P.file?C.with({scheme:P.vscodeFileResource,authority:C.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(y,n){const T=this.toUri(y,n);return T.scheme===P.vscodeFileResource?T.with({scheme:P.file,authority:T.authority!==this.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(y,n){return E.URI.isUri(y)?y:E.URI.parse(n.toUrl(y))}}e.FileAccess=new S}),define(ve[25],_e([0,1,37,12,2,8,18,21]),function(ie,e,E,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(f){return(0,P.uriToFsPath)(f,!0)}e.originalFSPath=y;class n{constructor(r){this._ignorePathCasing=r}compare(r,s,b=!1){return r===s?0:(0,A.compare)(this.getComparisonKey(r,b),this.getComparisonKey(s,b))}isEqual(r,s,b=!1){return r===s?!0:!r||!s?!1:this.getComparisonKey(r,b)===this.getComparisonKey(s,b)}getComparisonKey(r,s=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,s,b=!1){if(r.scheme===s.scheme){if(r.scheme===S.Schemas.file)return E.isEqualOrParent(y(r),y(s),this._ignorePathCasing(r))&&r.query===s.query&&(b||r.fragment===s.fragment);if((0,e.isEqualAuthority)(r.authority,s.authority))return E.isEqualOrParent(r.path,s.path,this._ignorePathCasing(r),"/")&&r.query===s.query&&(b||r.fragment===s.fragment)}return!1}joinPath(r,...s){return P.URI.joinPath(r,...s)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return k.posix.basename(r.path)}extname(r){return k.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let s;return r.scheme===S.Schemas.file?s=P.URI.file(k.dirname(y(r))).path:(s=k.posix.dirname(r.path),r.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${r.toString})) resulted in a relative path`),s="/")),r.with({path:s})}normalizePath(r){if(!r.path.length)return r;let s;return r.scheme===S.Schemas.file?s=P.URI.file(k.normalize(y(r))).path:s=k.posix.normalize(r.path),r.with({path:s})}relativePath(r,s){if(!(r.scheme!==s.scheme||!(0,e.isEqualAuthority)(r.authority,s.authority))){if(r.scheme===S.Schemas.file){const _=k.relative(y(r),y(s));return D.isWindows?E.toSlashes(_):_}let b=r.path||"/",h=s.path||"/";if(this._ignorePathCasing(r)){let _=0;for(const v=Math.min(b.length,h.length);_<v&&!(b.charCodeAt(_)!==h.charCodeAt(_)&&b.charAt(_).toLowerCase()!==h.charAt(_).toLowerCase());_++);b=h.substr(0,_)+b.substr(_)}return k.posix.relative(b,h)}}resolvePath(r,s){if(r.scheme===S.Schemas.file){const b=P.URI.file(k.resolve(y(r),s));return r.with({authority:b.authority,path:b.path})}return s.indexOf("/")===-1&&(s=E.toSlashes(s),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s)),r.with({path:k.posix.resolve(r.path,s)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,s){return r===s||(0,A.equalsIgnoreCase)(r,s)}hasTrailingPathSeparator(r,s=k.sep){if(r.scheme===S.Schemas.file){const b=y(r);return b.length>E.getRoot(b).length&&b[b.length-1]===s}else{const b=r.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,s=k.sep){return(0,e.hasTrailingPathSeparator)(r,s)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,s=k.sep){let b=!1;if(r.scheme===S.Schemas.file){const h=y(r);b=h!==void 0&&h.length===E.getRoot(h).length&&h[h.length-1]===s}else{s="/";const h=r.path;b=h.length===1&&h.charCodeAt(h.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(r,s)?r.with({path:r.path+"/"}):r}}e.ExtUri=n,e.extUri=new n(()=>!1),e.extUriBiasedIgnorePathCase=new n(f=>f.scheme===S.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new n(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(f,r){const s=[];for(let b=0;b<f.length;b++){const h=r(f[b]);f.some((_,v)=>v===b?!1:(0,e.isEqualOrParent)(h,r(_)))||s.push(f[b])}return s}e.distinctParents=T;var C;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function r(s){const b=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(v=>{const[c,u]=v.split(":");c&&u&&b.set(c,u)});const _=s.path.substring(0,s.path.indexOf(";"));return _&&b.set(f.META_DATA_MIME,_),b}f.parseMetaData=r})(C=e.DataUri||(e.DataUri={}));function g(f,r,s){if(r){let b=f.path;return b&&b[0]!==k.posix.sep&&(b=k.posix.sep+b),f.with({scheme:s,authority:r,path:b})}return f.with({scheme:s})}e.toLocalResource=g}),define(ve[14],_e([0,1,20,10,3,6,44,25]),function(ie,e,E,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(W){return!!W&&typeof W.then=="function"}e.isThenable=y;function n(W){const Q=new E.CancellationTokenSource,$=W(Q.token),Z=new Promise((re,se)=>{Q.token.onCancellationRequested(()=>{se((0,k.canceled)())}),Promise.resolve($).then(ye=>{Q.dispose(),re(ye)},ye=>{Q.dispose(),se(ye)})});return new class{cancel(){Q.cancel()}then(re,se){return Z.then(re,se)}catch(re){return this.then(void 0,re)}finally(re){return Z.finally(re)}}}e.createCancelablePromise=n;function T(W,Q,$){return Promise.race([W,new Promise(Z=>Q.onCancellationRequested(()=>Z($)))])}e.raceCancellation=T;async function C(W){let Q=-1;const $=W.map((re,se)=>re.then(ye=>(Q=se,ye))),Z=await Promise.race($);return W.forEach((re,se)=>{se!==Q&&re.cancel()}),Z}e.raceCancellablePromises=C;function g(W,Q,$){let Z;const re=setTimeout(()=>{Z==null||Z(void 0),$==null||$()},Q);return Promise.race([W.finally(()=>clearTimeout(re)),new Promise(se=>Z=se)])}e.raceTimeout=g;function f(W){return new Promise((Q,$)=>{const Z=W();y(Z)?Z.then(Q,$):Q(Z)})}e.asPromise=f;class r{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Q){if(this.activePromise){if(this.queuedPromiseFactory=Q,!this.queuedPromise){const $=()=>{this.queuedPromise=null;const Z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Z};this.queuedPromise=new Promise(Z=>{this.activePromise.then($,$).then(Z)})}return new Promise(($,Z)=>{this.queuedPromise.then($,Z)})}return this.activePromise=Q(),new Promise(($,Z)=>{this.activePromise.then(re=>{this.activePromise=null,$(re)},re=>{this.activePromise=null,Z(re)})})}}e.Throttler=r;class s{constructor(){this.current=Promise.resolve(null)}queue(Q){return this.current=this.current.then(()=>Q(),()=>Q())}}e.Sequencer=s;class b{constructor(){this.promiseMap=new Map}queue(Q,$){var Z;const se=((Z=this.promiseMap.get(Q))!==null&&Z!==void 0?Z:Promise.resolve()).catch(()=>{}).then($).finally(()=>{this.promiseMap.get(Q)===se&&this.promiseMap.delete(Q)});return this.promiseMap.set(Q,se),se}}e.SequencerByKey=b;class h{constructor(Q){this.defaultDelay=Q,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Q,$=this.defaultDelay){return this.task=Q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Z,re)=>{this.doResolve=Z,this.doReject=re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Z=this.task;return this.task=null,Z()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},$),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,k.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=h;class _{constructor(Q){this.delayer=new h(Q),this.throttler=new r}trigger(Q,$){return this.delayer.trigger(()=>this.throttler.queue(Q),$)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=_;class v{constructor(){this._isOpen=!1,this._promise=new Promise((Q,$)=>{this._completePromise=Q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=v;class c extends v{constructor(Q){super();this._timeout=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function u(W,Q){return Q?new Promise(($,Z)=>{const re=setTimeout($,W);Q.onCancellationRequested(()=>{clearTimeout(re),Z((0,k.canceled)())})}):n($=>u(W,$))}e.timeout=u;function t(W,Q=0){const $=setTimeout(W,Q);return(0,A.toDisposable)(()=>clearTimeout($))}e.disposableTimeout=t;function i(W){return W.then(void 0,Q=>{})}e.ignoreErrors=i;function d(W){const Q=[];let $=0;const Z=W.length;function re(){return $<Z?W[$++]():null}function se(ye){ye!=null&&Q.push(ye);const Pe=re();return Pe?Pe.then(se):Promise.resolve(Q)}return Promise.resolve(null).then(se)}e.sequence=d;function a(W,Q=Z=>!!Z,$=null){let Z=0;const re=W.length,se=()=>{if(Z>=re)return Promise.resolve($);const ye=W[Z++];return Promise.resolve(ye()).then($e=>Q($e)?Promise.resolve($e):se())};return se()}e.first=a;function l(W,Q=Z=>!!Z,$=null){if(W.length===0)return Promise.resolve($);let Z=W.length;const re=()=>{var se,ye;Z=-1;for(const Pe of W)(ye=(se=Pe).cancel)===null||ye===void 0||ye.call(se)};return new Promise((se,ye)=>{for(const Pe of W)Pe.then($e=>{--Z>=0&&Q($e)?(re(),se($e)):Z===0&&se($)}).catch($e=>{--Z>=0&&(re(),ye($e))})})}e.firstParallel=l;class o{constructor(Q){this._size=0,this.maxDegreeOfParalellism=Q,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new P.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Q){return this._size++,new Promise(($,Z)=>{this.outstandingPromises.push({factory:Q,c:$,e:Z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Q=this.outstandingPromises.shift();this.runningPromises++;const $=Q.factory();$.then(Q.c,Q.e),$.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class w extends o{constructor(){super(1)}}e.Queue=w;class I{constructor(){this.queues=new Map}queueFor(Q,$=D.extUri){const Z=$.getComparisonKey(Q);let re=this.queues.get(Z);return re||(re=new w,P.Event.once(re.onFinished)(()=>{re==null||re.dispose(),this.queues.delete(Z)}),this.queues.set(Z,re)),re}dispose(){this.queues.forEach(Q=>Q.dispose()),this.queues.clear()}}e.ResourceQueue=I;class p{constructor(Q,$){this._token=-1,typeof Q=="function"&&typeof $=="number"&&this.setIfNotSet(Q,$)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Q,$){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Q()},$)}setIfNotSet(Q,$){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Q()},$))}}e.TimeoutTimer=p;class m{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Q,$){this.cancel(),this._token=setInterval(()=>{Q()},$)}}e.IntervalTimer=m;class R{constructor(Q,$){this.timeoutToken=-1,this.runner=Q,this.timeout=$,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Q)}get delay(){return this.timeout}set delay(Q){this.timeout=Q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class F extends R{constructor(Q,$){super(Q,$);this.units=[]}work(Q){this.units.push(Q),this.isScheduled()||this.schedule()}doRun(){const Q=this.units;this.units=[],this.runner&&this.runner(Q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const W=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=Q=>{const $=setTimeout(()=>Q(W));let Z=!1;return{dispose(){Z||(Z=!0,clearTimeout($))}}}}else e.runWhenIdle=(W,Q)=>{const $=requestIdleCallback(W,typeof Q=="number"?{timeout:Q}:void 0);let Z=!1;return{dispose(){Z||(Z=!0,cancelIdleCallback($))}}}}();class x{constructor(Q){this._didRun=!1,this._executor=()=>{try{this._value=Q()}catch($){this._error=$}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=x;async function ae(W,Q,$){let Z;for(let re=0;re<$;re++)try{return await W()}catch(se){Z=se,await u(Q)}throw Z}e.retry=ae;class z{hasPending(Q){return this._pending?typeof Q=="number"?this._pending.taskId===Q:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var Q;(Q=this._pending)===null||Q===void 0||Q.cancel()}setPending(Q,$,Z){return this._pending={taskId:Q,cancel:()=>Z==null?void 0:Z(),promise:$},$.then(()=>this.donePending(Q),()=>this.donePending(Q)),$}donePending(Q){this._pending&&Q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Q=this._next;this._next=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}setNext(Q){if(this._next)this._next.run=Q;else{let $,Z;const re=new Promise((se,ye)=>{$=se,Z=ye});this._next={run:Q,promise:re,promiseResolve:$,promiseReject:Z}}return this._next.promise}}e.TaskSequentializer=z;class B{constructor(Q){this.interval=Q,this.lastIncrementTime=0,this.value=0}increment(){const Q=Date.now();return Q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Q,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class G{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Q,$)=>{this.completeCallback=Q,this.errorCallback=$})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Q){return new Promise($=>{this.completeCallback(Q),this.resolved=!0,$()})}error(Q){return new Promise($=>{this.errorCallback(Q),this.rejected=!0,$()})}cancel(){new Promise(Q=>{this.errorCallback((0,k.canceled)()),this.rejected=!0,Q()})}}e.DeferredPromise=G;class M extends P.Emitter{async fireAsync(Q,$,Z){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const re of this._listeners)this._asyncDeliveryQueue.push([re,Q]);for(;this._asyncDeliveryQueue.size>0&&!$.isCancellationRequested;){const[re,se]=this._asyncDeliveryQueue.shift(),ye=[],Pe=Object.assign(Object.assign({},se),{waitUntil:$e=>{if(Object.isFrozen(ye))throw new Error("waitUntil can NOT be called asynchronous");Z&&($e=Z($e,typeof re=="function"?re:re[0])),ye.push($e)}});try{typeof re=="function"?re.call(void 0,Pe):re[0].call(re[1],Pe)}catch($e){(0,k.onUnexpectedError)($e);continue}Object.freeze(ye),await N.settled(ye).catch($e=>(0,k.onUnexpectedError)($e))}}}}e.AsyncEmitter=M;var N;(function(W){async function Q(se){return typeof Promise.allSettled=="function"?$(se):Z(se)}W.allSettled=Q;async function $(se){return Promise.allSettled(se)}async function Z(se){return Promise.all(se.map(ye=>ye.then(Pe=>({status:"fulfilled",value:Pe}),Pe=>({status:"rejected",reason:Pe}))))}async function re(se){let ye;const Pe=await Promise.all(se.map($e=>$e.then(Re=>Re,Re=>{ye||(ye=Re)})));if(typeof ye!="undefined")throw ye;return Pe}W.settled=re})(N=e.Promises||(e.Promises={}))}),define(ve[110],_e([0,1,12,14]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const P=new k.IdleValue(()=>{const c=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:c,collatorIsNumeric:c.resolvedOptions().numeric}}),A=new k.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),S=new k.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(c,u,t=!1){const i=c||"",d=u||"",a=P.value.collator.compare(i,d);return P.value.collatorIsNumeric&&a===0&&i!==d?i<d?-1:1:a}e.compareFileNames=D;function y(c,u){const t=A.value.collator;return c=c||"",u=u||"",s(t,c,u)}e.compareFileNamesDefault=y;function n(c,u,t=!1){t||(c=c&&c.toLowerCase(),u=u&&u.toLowerCase());const[i,d]=f(c),[a,l]=f(u);return i!==a?i<a?-1:1:d===l?0:d<l?-1:1}e.noIntlCompareFileNames=n;function T(c,u){const[t,i]=f(c),[d,a]=f(u);let l=P.value.collator.compare(i,a);if(l===0){if(P.value.collatorIsNumeric&&i!==a)return i<a?-1:1;if(l=P.value.collator.compare(t,d),P.value.collatorIsNumeric&&l===0&&t!==d)return t<d?-1:1}return l}e.compareFileExtensions=T;function C(c,u){c=c||"",u=u||"";const t=r(c),i=r(u),d=A.value.collator,a=S.value.collator;let l;return l=s(a,t,i),l!==0?l:s(d,c,u)}e.compareFileExtensionsDefault=C;const g=/^(.*?)(\.([^.]*))?$/;function f(c,u=!1){const t=c?g.exec(c):[];let i=[t&&t[1]||"",t&&t[3]||""];return u&&(!i[0]&&i[1]||i[0]&&i[0].charAt(0)===".")&&(i=[i[0]+"."+i[1],""]),i}function r(c){const u=c?g.exec(c):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function s(c,u,t){let i=c.compare(u,t);return i!==0?i:u.length!==t.length?u.length<t.length?-1:1:0}function b(c,u,t=!1){return t||(c=c&&c.toLowerCase(),u=u&&u.toLowerCase()),c===u?0:c<u?-1:1}function h(c,u,t=!1){const i=c.split(E.sep),d=u.split(E.sep),a=i.length-1,l=d.length-1;let o,w;for(let I=0;;I++){if(o=a===I,w=l===I,o&&w)return D(i[I],d[I],t);if(o)return-1;if(w)return 1;const p=b(i[I],d[I],t);if(p!==0)return p}}e.comparePaths=h;function _(c,u,t){const i=c.toLowerCase(),d=u.toLowerCase(),a=v(c,u,t);if(a)return a;const l=i.endsWith(t),o=d.endsWith(t);if(l!==o)return l?-1:1;const w=D(i,d);return w!==0?w:i.localeCompare(d)}e.compareAnything=_;function v(c,u,t){const i=c.toLowerCase(),d=u.toLowerCase(),a=i.startsWith(t),l=d.startsWith(t);if(a!==l)return a?-1:1;if(a&&l){if(i.length<d.length)return-1;if(i.length>d.length)return 1}return 0}e.compareByPrefix=v}),define(ve[28],_e([0,1,8,37,12,22,14]),function(ie,e,E,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const y="**",n="/",T="[/\\\\]",C="[^/\\\\]",g=/\//g;function f($){switch($){case 0:return"";case 1:return`${C}*?`;default:return`(?:${T}|${C}+${T}|${T}${C}+)*?`}}function r($,Z){if(!$)return[];const re=[];let se=!1,ye=!1,Pe="";for(const $e of $){switch($e){case Z:if(!se&&!ye){re.push(Pe),Pe="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":ye=!0;break;case"]":ye=!1;break}Pe+=$e}return Pe&&re.push(Pe),re}e.splitGlobAware=r;function s($){if(!$)return"";let Z="";const re=r($,n);if(re.every(se=>se===y))Z=".*";else{let se=!1;re.forEach((ye,Pe)=>{if(ye===y){se||(Z+=f(2),se=!0);return}let $e=!1,Re="",ze=!1,U="";for(const K of ye){if(K!=="}"&&$e){Re+=K;continue}if(ze&&(K!=="]"||!U)){let te;K==="-"?te=K:(K==="^"||K==="!")&&!U?te="^":K===n?te="":te=E.escapeRegExpCharacters(K),U+=te;continue}switch(K){case"{":$e=!0;continue;case"[":ze=!0;continue;case"}":Z+=`(?:${r(Re,",").map(me=>s(me)).join("|")})`,$e=!1,Re="";break;case"]":Z+="["+U+"]",ze=!1,U="";break;case"?":Z+=C;continue;case"*":Z+=f(1);continue;default:Z+=E.escapeRegExpCharacters(K)}}Pe<re.length-1&&(re[Pe+1]!==y||Pe+2<re.length)&&(Z+=T),se=!1})}return Z}const b=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),i=function(){return!1},d=function(){return null};function a($,Z){if(!$)return d;let re;typeof $!="string"?re=$.pattern:re=$,re=re.trim();const se=`${re}_${!!Z.trimForExclusions}`;let ye=t.get(se);if(ye)return l(ye,$);let Pe;if(b.test(re)){const $e=re.substr(4);ye=function(Re,ze){return typeof Re=="string"&&Re.endsWith($e)?re:null}}else(Pe=h.exec(o(re,Z)))?ye=w(Pe[1],re):(Z.trimForExclusions?v:_).test(re)?ye=I(re,Z):(Pe=c.exec(o(re,Z)))?ye=p(Pe[1].substr(1),re,!0):(Pe=u.exec(o(re,Z)))?ye=p(Pe[1],re,!1):ye=m(re);return t.set(se,ye),l(ye,$)}function l($,Z){return typeof Z=="string"?$:function(re,se){return k.isEqualOrParent(re,Z.base)?$(P.relative(Z.base,re),se):null}}function o($,Z){return Z.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function w($,Z){const re=`/${$}`,se=`\\${$}`,ye=function($e,Re){return typeof $e!="string"?null:Re?Re===$?Z:null:$e===$||$e.endsWith(re)||$e.endsWith(se)?Z:null},Pe=[$];return ye.basenames=Pe,ye.patterns=[Z],ye.allBasenames=Pe,ye}function I($,Z){const re=Q($.slice(1,-1).split(",").map(Re=>a(Re,Z)).filter(Re=>Re!==d),$),se=re.length;if(!se)return d;if(se===1)return re[0];const ye=function(Re,ze){for(let U=0,K=re.length;U<K;U++)if(re[U](Re,ze))return $;return null},Pe=re.find(Re=>!!Re.allBasenames);Pe&&(ye.allBasenames=Pe.allBasenames);const $e=re.reduce((Re,ze)=>ze.allPaths?Re.concat(ze.allPaths):Re,[]);return $e.length&&(ye.allPaths=$e),ye}function p($,Z,re){const se=P.sep===P.posix.sep,ye=se?$:$.replace(g,P.sep),Pe=P.sep+ye,$e=P.posix.sep+$,Re=re?function(ze,U){return typeof ze=="string"&&(ze===ye||ze.endsWith(Pe)||!se&&(ze===$||ze.endsWith($e)))?Z:null}:function(ze,U){return typeof ze=="string"&&(ze===ye||!se&&ze===$)?Z:null};return Re.allPaths=[(re?"*/":"./")+$],Re}function m($){try{const Z=new RegExp(`^${s($)}$`);return function(re){return Z.lastIndex=0,typeof re=="string"&&Z.test(re)?$:null}}catch(Z){return d}}function R($,Z,re){return!$||typeof Z!="string"?!1:F($)(Z,void 0,re)}e.match=R;function F($,Z={}){if(!$)return i;if(typeof $=="string"||B($)){const re=a($,Z);if(re===d)return i;const se=function(ye,Pe){return!!re(ye,Pe)};return re.allBasenames&&(se.allBasenames=re.allBasenames),re.allPaths&&(se.allPaths=re.allPaths),se}return N($,Z)}e.parse=F;function x($){if(!!$){let Z;return re=>(Z||(Z=($()||Promise.resolve([])).then(se=>se?z(se):{})),Z.then(se=>!!se[re]))}}e.hasSiblingPromiseFn=x;function ae($){if(!!$){let Z;return re=>{if(!Z){const se=$();Z=se?z(se):{}}return!!Z[re]}}}e.hasSiblingFn=ae;function z($){const Z={};for(const re of $)Z[re]=!0;return Z}function B($){const Z=$;return Z&&typeof Z.base=="string"&&typeof Z.pattern=="string"}e.isRelativePattern=B;function G($){return $.allBasenames||[]}e.getBasenameTerms=G;function M($){return $.allPaths||[]}e.getPathTerms=M;function N($,Z){const re=Q(Object.getOwnPropertyNames($).map(Re=>W(Re,$[Re],Z)).filter(Re=>Re!==d)),se=re.length;if(!se)return d;if(!re.some(Re=>!!Re.requiresSiblings)){if(se===1)return re[0];const Re=function(K,te){for(let le=0,me=re.length;le<me;le++){const Se=re[le](K,te);if(Se)return Se}return null},ze=re.find(K=>!!K.allBasenames);ze&&(Re.allBasenames=ze.allBasenames);const U=re.reduce((K,te)=>te.allPaths?K.concat(te.allPaths):K,[]);return U.length&&(Re.allPaths=U),Re}const ye=function(Re,ze,U){let K;for(let te=0,le=re.length;te<le;te++){const me=re[te];me.requiresSiblings&&U&&(ze||(ze=P.basename(Re)),K||(K=ze.substr(0,ze.length-P.extname(Re).length)));const Se=me(Re,ze,K,U);if(Se)return Se}return null},Pe=re.find(Re=>!!Re.allBasenames);Pe&&(ye.allBasenames=Pe.allBasenames);const $e=re.reduce((Re,ze)=>ze.allPaths?Re.concat(ze.allPaths):Re,[]);return $e.length&&(ye.allPaths=$e),ye}function W($,Z,re){if(Z===!1)return d;const se=a($,re);if(se===d)return d;if(typeof Z=="boolean")return se;if(Z){const ye=Z.when;if(typeof ye=="string"){const Pe=($e,Re,ze,U)=>{if(!U||!se($e,Re))return null;const K=ye.replace("$(basename)",ze),te=U(K);return(0,S.isThenable)(te)?te.then(le=>le?$:null):te?$:null};return Pe.requiresSiblings=!0,Pe}}return se}function Q($,Z){const re=$.filter(Re=>!!Re.basenames);if(re.length<2)return $;const se=re.reduce((Re,ze)=>{const U=ze.basenames;return U?Re.concat(U):Re},[]);let ye;if(Z){ye=[];for(let Re=0,ze=se.length;Re<ze;Re++)ye.push(Z)}else ye=re.reduce((Re,ze)=>{const U=ze.patterns;return U?Re.concat(U):Re},[]);const Pe=function(Re,ze){if(typeof Re!="string")return null;if(!ze){let K;for(K=Re.length;K>0;K--){const te=Re.charCodeAt(K-1);if(te===47||te===92)break}ze=Re.substr(K)}const U=se.indexOf(ze);return U!==-1?ye[U]:null};Pe.basenames=se,Pe.patterns=ye,Pe.allBasenames=se;const $e=$.filter(Re=>!Re.basenames);return $e.push(Pe),$e}}),define(ve[58],_e([0,1,2,12,8,18,21,25,37]),function(ie,e,E,k,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function n(a,l,o){if(typeof a=="string"&&(a=E.URI.file(a)),o){const I=o.getWorkspaceFolder(a);if(I){const p=o.getWorkspace().folders.length>1;let m;if((0,D.isEqual)(I.uri,a)?m="":m=(0,D.relativePath)(I.uri,a),p){const R=I.name?I.name:(0,D.basename)(I.uri);m=m?R+" \u2022 "+m:R}return m}}if(a.scheme!==A.Schemas.file&&a.scheme!==A.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(a.fsPath))return(0,k.normalize)(C(a.fsPath));let w=(0,k.normalize)(a.fsPath);return!S.isWindows&&(l==null?void 0:l.userHome)&&(w=f(w,l.userHome.fsPath)),w}e.getPathLabel=n;function T(a){if(!!a){typeof a=="string"&&(a=E.URI.file(a));const l=(0,D.basename)(a)||(a.scheme===A.Schemas.file?a.fsPath:a.path);return S.isWindows&&(0,y.isRootOrDriveLetter)(l)?C(l):l}}e.getBaseLabel=T;function C(a){return(0,y.hasDriveLetter)(a)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=C;let g=Object.create(null);function f(a,l){if(S.isWindows||!a||!l)return a;let o=g.original===l?g.normalized:void 0;return o||(o=`${(0,P.rtrim)(l,k.posix.sep)}${k.posix.sep}`,g={original:l,normalized:o}),(S.isLinux?a.startsWith(o):(0,P.startsWithIgnoreCase)(a,o))&&(a=`~/${a.substr(o.length)}`),a}e.tildify=f;function r(a,l){return a.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=r;const s="\u2026",b="\\\\",h="~";function _(a,l=k.sep){const o=new Array(a.length);let w=!1;for(let I=0;I<a.length;I++){let p=a[I];if(p===""){o[I]=`.${l}`;continue}if(!p){o[I]=p;continue}w=!0;let m="";p.indexOf(b)===0?(m=p.substr(0,p.indexOf(b)+b.length),p=p.substr(p.indexOf(b)+b.length)):p.indexOf(l)===0?(m=p.substr(0,p.indexOf(l)+l.length),p=p.substr(p.indexOf(l)+l.length)):p.indexOf(h)===0&&(m=p.substr(0,p.indexOf(h)+h.length),p=p.substr(p.indexOf(h)+h.length));const R=p.split(l);for(let F=1;w&&F<=R.length;F++)for(let x=R.length-F;w&&x>=0;x--){w=!1;let ae=R.slice(x,x+F).join(l);for(let z=0;!w&&z<a.length;z++)if(z!==I&&a[z]&&a[z].indexOf(ae)>-1){const B=x+F===R.length,G=x>0&&a[z].indexOf(l)>-1?l+ae:ae,M=a[z].endsWith(G);w=!B||M}if(!w){let z="";(R[0].endsWith(":")||m!=="")&&(x===1&&(x=0,F++,ae=R[0]+l+ae),x>0&&(z=R[0]+l),z=m+z),x>0&&(z=z+s+l),z=z+ae,x+F<R.length&&(z=z+l+s),o[I]=z}}w&&(o[I]=p)}return o}e.shorten=_;var v;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function c(a,l=Object.create(null)){const o=[];let w=!1,I="";for(const p of a)if(p==="$"||w&&p==="{")I&&o.push({value:I,type:v.TEXT}),I="",w=!0;else if(p==="}"&&w){const m=l[I];if(typeof m=="string")m.length&&o.push({value:m,type:v.VARIABLE});else if(m){const R=o[o.length-1];(!R||R.type!==v.SEPARATOR)&&o.push({value:m.label,type:v.SEPARATOR})}I="",w=!1}else I+=p;return I&&!w&&o.push({value:I,type:v.TEXT}),o.filter((p,m)=>{if(p.type===v.SEPARATOR){const R=o[m-1],F=o[m+1];return[R,F].every(x=>x&&(x.type===v.VARIABLE||x.type===v.TEXT)&&x.value.length>0)}return!0}).map(p=>p.value).join("")}e.template=c;function u(a,l){return S.isMacintosh||l?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,S.isMacintosh?"&":"&&"):a.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function t(a,l){return S.isMacintosh||l?a.replace(/\(&&\w\)|&&/g,""):S.isWindows?a.replace(/&&|&/g,o=>o==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=i;function d(a){const l=a.indexOf("/")!==-1?k.posix:k.win32,o=l.basename(a),w=l.dirname(a);return o.length?{name:o,parentPath:w}:{name:w,parentPath:""}}e.splitName=d}),define(ve[111],_e([0,1,2]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(T){return T.toJSON()}class P{constructor(C){this._uriTransformer=C}transformIncoming(C){const g=this._uriTransformer.transformIncoming(C);return g===C?C:k(E.URI.from(g))}transformOutgoing(C){const g=this._uriTransformer.transformOutgoing(C);return g===C?C:k(E.URI.from(g))}transformOutgoingURI(C){const g=this._uriTransformer.transformOutgoing(C);return g===C?C:E.URI.from(g)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=P,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function A(T,C,g){if(!T||g>200)return null;if(typeof T=="object"){if(T instanceof E.URI)return C.transformOutgoing(T);for(let f in T)if(Object.hasOwnProperty.call(T,f)){const r=A(T[f],C,g+1);r!==null&&(T[f]=r)}}return null}function S(T,C){const g=A(T,C,0);return g===null?T:g}e.transformOutgoingURIs=S;function D(T,C,g,f){if(!T||f>200)return null;if(typeof T=="object"){if(T.$mid===1)return g?E.URI.revive(C.transformIncoming(T)):C.transformIncoming(T);for(let r in T)if(Object.hasOwnProperty.call(T,r)){const s=D(T[r],C,g,f+1);s!==null&&(T[r]=s)}}return null}function y(T,C){const g=D(T,C,!1,0);return g===null?T:g}e.transformIncomingURIs=y;function n(T,C){const g=D(T,C,!0,0);return g===null?T:g}e.transformAndReviveIncomingURIs=n}),define(ve[29],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(y){return E.test(y)}e.isUUID=k;const P=new Uint8Array(16),A=[];for(let y=0;y<256;y++)A.push(y.toString(16).padStart(2,"0"));let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(y){for(let n=0;n<y.length;n++)y[n]=Math.floor(Math.random()*256);return y};function D(){S(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let y=0,n="";return n+=A[P[y++]],n+=A[P[y++]],n+=A[P[y++]],n+=A[P[y++]],n+="-",n+=A[P[y++]],n+=A[P[y++]],n+="-",n+=A[P[y++]],n+=A[P[y++]],n+="-",n+=A[P[y++]],n+=A[P[y++]],n+="-",n+=A[P[y++]],n+=A[P[y++]],n+=A[P[y++]],n+=A[P[y++]],n+=A[P[y++]],n+=A[P[y++]],n}e.generateUuid=D}),define(ve[82],_e([0,1,80]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class k{constructor(D){let y=(0,E.toUint8)(D);this._defaultValue=y,this._asciiMap=k._createAsciiMap(y),this._map=new Map}static _createAsciiMap(D){let y=new Uint8Array(256);for(let n=0;n<256;n++)y[n]=D;return y}set(D,y){let n=(0,E.toUint8)(y);D>=0&&D<256?this._asciiMap[D]=n:this._map.set(D,n)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=k;var P;(function(S){S[S.False=0]="False",S[S.True=1]="True"})(P||(P={}));class A{constructor(){this._actual=new k(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=A}),define(ve[112],_e([0,1,82]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var k;(function(S){S[S.Regular=0]="Regular",S[S.Whitespace=1]="Whitespace",S[S.WordSeparator=2]="WordSeparator"})(k=e.WordCharacterClass||(e.WordCharacterClass={}));class P extends E.CharacterClassifier{constructor(D){super(0);for(let y=0,n=D.length;y<n;y++)this.set(D.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=P;function A(S){let D={};return y=>(D.hasOwnProperty(y)||(D[y]=S(y)),D[y])}e.getMapForWordSeparators=A(S=>new P(S))}),define(ve[38],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class E{constructor(P,A){this.lineNumber=P,this.column=A}with(P=this.lineNumber,A=this.column){return P===this.lineNumber&&A===this.column?this:new E(P,A)}delta(P=0,A=0){return this.with(this.lineNumber+P,this.column+A)}equals(P){return E.equals(this,P)}static equals(P,A){return!P&&!A?!0:!!P&&!!A&&P.lineNumber===A.lineNumber&&P.column===A.column}isBefore(P){return E.isBefore(this,P)}static isBefore(P,A){return P.lineNumber<A.lineNumber?!0:A.lineNumber<P.lineNumber?!1:P.column<A.column}isBeforeOrEqual(P){return E.isBeforeOrEqual(this,P)}static isBeforeOrEqual(P,A){return P.lineNumber<A.lineNumber?!0:A.lineNumber<P.lineNumber?!1:P.column<=A.column}static compare(P,A){let S=P.lineNumber|0,D=A.lineNumber|0;if(S===D){let y=P.column|0,n=A.column|0;return y-n}return S-D}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(P){return new E(P.lineNumber,P.column)}static isIPosition(P){return P&&typeof P.lineNumber=="number"&&typeof P.column=="number"}}e.Position=E}),define(ve[32],_e([0,1,38]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class k{constructor(A,S,D,y){A>D||A===D&&S>y?(this.startLineNumber=D,this.startColumn=y,this.endLineNumber=A,this.endColumn=S):(this.startLineNumber=A,this.startColumn=S,this.endLineNumber=D,this.endColumn=y)}isEmpty(){return k.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return k.containsPosition(this,A)}static containsPosition(A,S){return!(S.lineNumber<A.startLineNumber||S.lineNumber>A.endLineNumber||S.lineNumber===A.startLineNumber&&S.column<A.startColumn||S.lineNumber===A.endLineNumber&&S.column>A.endColumn)}containsRange(A){return k.containsRange(this,A)}static containsRange(A,S){return!(S.startLineNumber<A.startLineNumber||S.endLineNumber<A.startLineNumber||S.startLineNumber>A.endLineNumber||S.endLineNumber>A.endLineNumber||S.startLineNumber===A.startLineNumber&&S.startColumn<A.startColumn||S.endLineNumber===A.endLineNumber&&S.endColumn>A.endColumn)}strictContainsRange(A){return k.strictContainsRange(this,A)}static strictContainsRange(A,S){return!(S.startLineNumber<A.startLineNumber||S.endLineNumber<A.startLineNumber||S.startLineNumber>A.endLineNumber||S.endLineNumber>A.endLineNumber||S.startLineNumber===A.startLineNumber&&S.startColumn<=A.startColumn||S.endLineNumber===A.endLineNumber&&S.endColumn>=A.endColumn)}plusRange(A){return k.plusRange(this,A)}static plusRange(A,S){let D,y,n,T;return S.startLineNumber<A.startLineNumber?(D=S.startLineNumber,y=S.startColumn):S.startLineNumber===A.startLineNumber?(D=S.startLineNumber,y=Math.min(S.startColumn,A.startColumn)):(D=A.startLineNumber,y=A.startColumn),S.endLineNumber>A.endLineNumber?(n=S.endLineNumber,T=S.endColumn):S.endLineNumber===A.endLineNumber?(n=S.endLineNumber,T=Math.max(S.endColumn,A.endColumn)):(n=A.endLineNumber,T=A.endColumn),new k(D,y,n,T)}intersectRanges(A){return k.intersectRanges(this,A)}static intersectRanges(A,S){let D=A.startLineNumber,y=A.startColumn,n=A.endLineNumber,T=A.endColumn,C=S.startLineNumber,g=S.startColumn,f=S.endLineNumber,r=S.endColumn;return D<C?(D=C,y=g):D===C&&(y=Math.max(y,g)),n>f?(n=f,T=r):n===f&&(T=Math.min(T,r)),D>n||D===n&&y>T?null:new k(D,y,n,T)}equalsRange(A){return k.equalsRange(this,A)}static equalsRange(A,S){return!!A&&!!S&&A.startLineNumber===S.startLineNumber&&A.startColumn===S.startColumn&&A.endLineNumber===S.endLineNumber&&A.endColumn===S.endColumn}getEndPosition(){return k.getEndPosition(this)}static getEndPosition(A){return new E.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return k.getStartPosition(this)}static getStartPosition(A){return new E.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,S){return new k(this.startLineNumber,this.startColumn,A,S)}setStartPosition(A,S){return new k(A,S,this.endLineNumber,this.endColumn)}collapseToStart(){return k.collapseToStart(this)}static collapseToStart(A){return new k(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,S=A){return new k(A.lineNumber,A.column,S.lineNumber,S.column)}static lift(A){return A?new k(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,S){return!(A.endLineNumber<S.startLineNumber||A.endLineNumber===S.startLineNumber&&A.endColumn<S.startColumn||S.endLineNumber<A.startLineNumber||S.endLineNumber===A.startLineNumber&&S.endColumn<A.startColumn)}static areIntersecting(A,S){return!(A.endLineNumber<S.startLineNumber||A.endLineNumber===S.startLineNumber&&A.endColumn<=S.startColumn||S.endLineNumber<A.startLineNumber||S.endLineNumber===A.startLineNumber&&S.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,S){if(A&&S){const n=A.startLineNumber|0,T=S.startLineNumber|0;if(n===T){const C=A.startColumn|0,g=S.startColumn|0;if(C===g){const f=A.endLineNumber|0,r=S.endLineNumber|0;if(f===r){const s=A.endColumn|0,b=S.endColumn|0;return s-b}return f-r}return C-g}return n-T}return(A?1:0)-(S?1:0)}static compareRangesUsingEnds(A,S){return A.endLineNumber===S.endLineNumber?A.endColumn===S.endColumn?A.startLineNumber===S.startLineNumber?A.startColumn-S.startColumn:A.startLineNumber-S.startLineNumber:A.endColumn-S.endColumn:A.endLineNumber-S.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}}e.Range=k}),define(ve[113],_e([0,1,38,32]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var P;(function(S){S[S.LTR=0]="LTR",S[S.RTL=1]="RTL"})(P=e.SelectionDirection||(e.SelectionDirection={}));class A extends k.Range{constructor(D,y,n,T){super(D,y,n,T);this.selectionStartLineNumber=D,this.selectionStartColumn=y,this.positionLineNumber=n,this.positionColumn=T}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return A.selectionsEqual(this,D)}static selectionsEqual(D,y){return D.selectionStartLineNumber===y.selectionStartLineNumber&&D.selectionStartColumn===y.selectionStartColumn&&D.positionLineNumber===y.positionLineNumber&&D.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,y){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,D,y):new A(D,y,this.startLineNumber,this.startColumn)}getPosition(){return new E.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(D,y){return this.getDirection()===0?new A(D,y,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,D,y)}static fromPositions(D,y=D){return new A(D.lineNumber,D.column,y.lineNumber,y.column)}static liftSelection(D){return new A(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,y){if(D&&!y||!D&&y)return!1;if(!D&&!y)return!0;if(D.length!==y.length)return!1;for(let n=0,T=D.length;n<T;n++)if(!this.selectionsEqual(D[n],y[n]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,y,n,T,C){return C===0?new A(D,y,n,T):new A(n,T,D,y)}}e.Selection=A}),define(ve[83],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var E;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(E=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(P=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(r){this.tabSize=Math.max(1,r.tabSize|0),this.indentSize=r.tabSize|0,this.insertSpaces=Boolean(r.insertSpaces),this.defaultEOL=r.defaultEOL|0,this.trimAutoWhitespace=Boolean(r.trimAutoWhitespace)}equals(r){return this.tabSize===r.tabSize&&this.indentSize===r.indentSize&&this.insertSpaces===r.insertSpaces&&this.defaultEOL===r.defaultEOL&&this.trimAutoWhitespace===r.trimAutoWhitespace}createChangeEvent(r){return{tabSize:this.tabSize!==r.tabSize,indentSize:this.indentSize!==r.indentSize,insertSpaces:this.insertSpaces!==r.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==r.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class y{constructor(r,s){this.range=r,this.matches=s}}e.FindMatch=y;var n;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var T;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(T=e.ModelConstants||(e.ModelConstants={}));class C{constructor(r,s,b,h,_,v){this.identifier=r,this.range=s,this.text=b,this.forceMoveMarkers=h,this.isAutoWhitespaceEdit=_,this._isTracked=v}}e.ValidAnnotatedEditOperation=C;class g{constructor(r,s,b){this.reverseEdits=r,this.changes=s,this.trimAutoWhitespaceLineNumbers=b}}e.ApplyEditsResult=g}),define(ve[114],_e([0,1,8,112,38,32,83]),function(ie,e,E,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class y{constructor(v,c,u,t){this.searchString=v,this.isRegex=c,this.matchCase=u,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=n(this.searchString):v=this.searchString.indexOf(`
`)>=0;let c=null;try{c=E.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch(t){return null}if(!c)return null;let u=!this.isRegex&&!v;return u&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(u=this.matchCase),new T(c,this.wordSeparators?(0,k.getMapForWordSeparators)(this.wordSeparators):null,u?this.searchString:null)}}e.SearchParams=y;function n(_){if(!_||_.length===0)return!1;for(let v=0,c=_.length;v<c;v++)if(_.charCodeAt(v)===92){if(v++,v>=c)break;const t=_.charCodeAt(v);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=n;class T{constructor(v,c,u){this.regex=v,this.wordSeparators=c,this.simpleSearch=u}}e.SearchData=T;function C(_,v,c){if(!c)return new S.FindMatch(_,null);let u=[];for(let t=0,i=v.length;t<i;t++)u[t]=v[t];return new S.FindMatch(_,u)}e.createFindMatch=C;class g{constructor(v){let c=[],u=0;for(let t=0,i=v.length;t<i;t++)v.charCodeAt(t)===10&&(c[u++]=t);this._lineFeedsOffsets=c}findLineFeedCountBeforeOffset(v){const c=this._lineFeedsOffsets;let u=0,t=c.length-1;if(t===-1||v<=c[0])return 0;for(;u<t;){const i=u+((t-u)/2>>0);c[i]>=v?t=i-1:c[i+1]>=v?(u=i,t=i):u=i+1}return u+1}}class f{static findMatches(v,c,u,t,i){const d=c.parseSearchRequest();return d?d.regex.multiline?this._doFindMatchesMultiline(v,u,new h(d.wordSeparators,d.regex),t,i):this._doFindMatchesLineByLine(v,u,d,t,i):[]}static _getMultilineMatchRange(v,c,u,t,i,d){let a,l=0;t?(l=t.findLineFeedCountBeforeOffset(i),a=c+i+l):a=c+i;let o;if(t){let m=t.findLineFeedCountBeforeOffset(i+d.length)-l;o=a+d.length+m}else o=a+d.length;const w=v.getPositionAt(a),I=v.getPositionAt(o);return new A.Range(w.lineNumber,w.column,I.lineNumber,I.column)}static _doFindMatchesMultiline(v,c,u,t,i){const d=v.getOffsetAt(c.getStartPosition()),a=v.getValueInRange(c,1),l=v.getEOL()===`\r
`?new g(a):null,o=[];let w=0,I;for(u.reset(0);I=u.next(a);)if(o[w++]=C(this._getMultilineMatchRange(v,d,a,l,I.index,I[0]),I,t),w>=i)return o;return o}static _doFindMatchesLineByLine(v,c,u,t,i){const d=[];let a=0;if(c.startLineNumber===c.endLineNumber){const o=v.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return a=this._findMatchesInLine(u,o,c.startLineNumber,c.startColumn-1,a,d,t,i),d}const l=v.getLineContent(c.startLineNumber).substring(c.startColumn-1);a=this._findMatchesInLine(u,l,c.startLineNumber,c.startColumn-1,a,d,t,i);for(let o=c.startLineNumber+1;o<c.endLineNumber&&a<i;o++)a=this._findMatchesInLine(u,v.getLineContent(o),o,0,a,d,t,i);if(a<i){const o=v.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);a=this._findMatchesInLine(u,o,c.endLineNumber,0,a,d,t,i)}return d}static _findMatchesInLine(v,c,u,t,i,d,a,l){const o=v.wordSeparators;if(!a&&v.simpleSearch){const p=v.simpleSearch,m=p.length,R=c.length;let F=-m;for(;(F=c.indexOf(p,F+m))!==-1;)if((!o||b(o,c,R,F,m))&&(d[i++]=new S.FindMatch(new A.Range(u,F+1+t,u,F+1+m+t),null),i>=l))return i;return i}const w=new h(v.wordSeparators,v.regex);let I;w.reset(0);do if(I=w.next(c),I&&(d[i++]=C(new A.Range(u,I.index+1+t,u,I.index+1+I[0].length+t),I,a),i>=l))return i;while(I);return i}static findNextMatch(v,c,u,t){const i=c.parseSearchRequest();if(!i)return null;const d=new h(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(v,u,d,t):this._doFindNextMatchLineByLine(v,u,d,t)}static _doFindNextMatchMultiline(v,c,u,t){const i=new P.Position(c.lineNumber,1),d=v.getOffsetAt(i),a=v.getLineCount(),l=v.getValueInRange(new A.Range(i.lineNumber,i.column,a,v.getLineMaxColumn(a)),1),o=v.getEOL()===`\r
`?new g(l):null;u.reset(c.column-1);let w=u.next(l);return w?C(this._getMultilineMatchRange(v,d,l,o,w.index,w[0]),w,t):c.lineNumber!==1||c.column!==1?this._doFindNextMatchMultiline(v,new P.Position(1,1),u,t):null}static _doFindNextMatchLineByLine(v,c,u,t){const i=v.getLineCount(),d=c.lineNumber,a=v.getLineContent(d),l=this._findFirstMatchInLine(u,a,d,c.column,t);if(l)return l;for(let o=1;o<=i;o++){const w=(d+o-1)%i,I=v.getLineContent(w+1),p=this._findFirstMatchInLine(u,I,w+1,1,t);if(p)return p}return null}static _findFirstMatchInLine(v,c,u,t,i){v.reset(t-1);const d=v.next(c);return d?C(new A.Range(u,d.index+1,u,d.index+1+d[0].length),d,i):null}static findPreviousMatch(v,c,u,t){const i=c.parseSearchRequest();if(!i)return null;const d=new h(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(v,u,d,t):this._doFindPreviousMatchLineByLine(v,u,d,t)}static _doFindPreviousMatchMultiline(v,c,u,t){const i=this._doFindMatchesMultiline(v,new A.Range(1,1,c.lineNumber,c.column),u,t,10*D);if(i.length>0)return i[i.length-1];const d=v.getLineCount();return c.lineNumber!==d||c.column!==v.getLineMaxColumn(d)?this._doFindPreviousMatchMultiline(v,new P.Position(d,v.getLineMaxColumn(d)),u,t):null}static _doFindPreviousMatchLineByLine(v,c,u,t){const i=v.getLineCount(),d=c.lineNumber,a=v.getLineContent(d).substring(0,c.column-1),l=this._findLastMatchInLine(u,a,d,t);if(l)return l;for(let o=1;o<=i;o++){const w=(i+d-o-1)%i,I=v.getLineContent(w+1),p=this._findLastMatchInLine(u,I,w+1,t);if(p)return p}return null}static _findLastMatchInLine(v,c,u,t){let i=null,d;for(v.reset(0);d=v.next(c);)i=C(new A.Range(u,d.index+1,u,d.index+1+d[0].length),d,t);return i}}e.TextModelSearch=f;function r(_,v,c,u,t){if(u===0)return!0;const i=v.charCodeAt(u-1);if(_.get(i)!==0||i===13||i===10)return!0;if(t>0){const d=v.charCodeAt(u);if(_.get(d)!==0)return!0}return!1}function s(_,v,c,u,t){if(u+t===c)return!0;const i=v.charCodeAt(u+t);if(_.get(i)!==0||i===13||i===10)return!0;if(t>0){const d=v.charCodeAt(u+t-1);if(_.get(d)!==0)return!0}return!1}function b(_,v,c,u,t){return r(_,v,c,u,t)&&s(_,v,c,u,t)}e.isValidMatch=b;class h{constructor(v,c){this._wordSeparators=v,this._searchRegex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(v){this._searchRegex.lastIndex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(v){const c=v.length;let u;do{if(this._prevMatchStartIndex+this._prevMatchLength===c||(u=this._searchRegex.exec(v),!u))return null;const t=u.index,i=u[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){E.getNextCodePoint(v,c,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||b(this._wordSeparators,v,c,t,i))return u}while(u);return null}}e.Searcher=h}),define(ve[84],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function E(D=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const n of e.USUAL_WORD_SEPARATORS)D.indexOf(n)>=0||(y+="\\"+n);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=E();function k(D){let y=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)y=D;else{let n="g";D.ignoreCase&&(n+="i"),D.multiline&&(n+="m"),D.unicode&&(n+="u"),y=new RegExp(D.source,n)}return y.lastIndex=0,y}e.ensureValidWordDefinition=k;const P={maxLen:1e3,windowSize:15,timeBudget:150};function A(D,y,n,T,C=P){if(n.length>C.maxLen){let b=D-C.maxLen/2;return b<0?b=0:T+=b,n=n.substring(b,D+C.maxLen/2),A(D,y,n,T,C)}const g=Date.now(),f=D-1-T;let r=-1,s=null;for(let b=1;!(Date.now()-g>=C.timeBudget);b++){const h=f-C.windowSize*b;y.lastIndex=Math.max(0,h);const _=S(y,n,f,r);if(!_&&s||(s=_,h<=0))break;r=h}if(s){let b={word:s[0],startColumn:T+1+s.index,endColumn:T+1+s.index+s[0].length};return y.lastIndex=0,b}return null}e.getWordAtText=A;function S(D,y,n,T){let C;for(;C=D.exec(y);){const g=C.index||0;if(g<=n&&D.lastIndex>=n)return C;if(T>0&&g>T)return null}return null}}),define(ve[115],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var E;(function(S){S[S.None=0]="None",S[S.Indent=1]="Indent",S[S.IndentOutdent=2]="IndentOutdent",S[S.Outdent=3]="Outdent"})(E=e.IndentAction||(e.IndentAction={}));class k{constructor(D){if(this.open=D.open,this.close=D.close,this._standardTokenMask=0,Array.isArray(D.notIn))for(let y=0,n=D.notIn.length;y<n;y++)switch(D.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(D){return(this._standardTokenMask&D)==0}}e.StandardAutoClosingPairConditional=k;class P{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of D)A(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),A(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),A(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),A(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&A(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=P;function A(S,D,y){S.has(D)?S.get(D).push(y):S.set(D,[y])}}),define(ve[59],_e([0,1,28,12]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function P(A,S,D,y){if(Array.isArray(A)){let n=0;for(const T of A){const C=P(T,S,D,y);if(C===10)return C;C>n&&(n=C)}return n}else{if(typeof A=="string")return y?A==="*"?5:A===D?10:0:0;if(A){const{language:n,pattern:T,scheme:C,hasAccessToAllModels:g}=A;if(!y&&!g)return 0;let f=0;if(C)if(C===S.scheme)f=10;else if(C==="*")f=5;else return 0;if(n)if(n===D)f=10;else if(n==="*")f=Math.max(f,5);else return 0;if(T){let r;if(typeof T=="string"?r=T:r=Object.assign(Object.assign({},T),{base:(0,k.normalize)(T.base)}),r===S.fsPath||(0,E.match)(r,S.fsPath))f=10;else return 0}return f}else return 0}}e.score=P}),define(ve[116],_e([0,1,82]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var k;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(k=e.State||(e.State={}));class P{constructor(r,s,b){const h=new Uint8Array(r*s);for(let _=0,v=r*s;_<v;_++)h[_]=b;this._data=h,this.rows=r,this.cols=s}get(r,s){return this._data[r*this.cols+s]}set(r,s,b){this._data[r*this.cols+s]=b}}e.Uint8Matrix=P;class A{constructor(r){let s=0,b=0;for(let _=0,v=r.length;_<v;_++){let[c,u,t]=r[_];u>s&&(s=u),c>b&&(b=c),t>b&&(b=t)}s++,b++;let h=new P(b,s,0);for(let _=0,v=r.length;_<v;_++){let[c,u,t]=r[_];h.set(c,u,t)}this._states=h,this._maxCharCode=s}nextState(r,s){return s<0||s>=this._maxCharCode?0:this._states.get(r,s)}}e.StateMachine=A;let S=null;function D(){return S===null&&(S=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),S}var y;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let n=null;function T(){if(n===null){n=new E.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let s=0;s<f.length;s++)n.set(f.charCodeAt(s),1);const r=".,;";for(let s=0;s<r.length;s++)n.set(r.charCodeAt(s),2)}return n}class C{static _createLink(r,s,b,h,_){let v=_-1;do{const c=s.charCodeAt(v);if(r.get(c)!==2)break;v--}while(v>h);if(h>0){const c=s.charCodeAt(h-1),u=s.charCodeAt(v);(c===40&&u===41||c===91&&u===93||c===123&&u===125)&&v--}return{range:{startLineNumber:b,startColumn:h+1,endLineNumber:b,endColumn:v+2},url:s.substring(h,v+1)}}static computeLinks(r,s=D()){const b=T();let h=[];for(let _=1,v=r.getLineCount();_<=v;_++){const c=r.getLineContent(_),u=c.length;let t=0,i=0,d=0,a=1,l=!1,o=!1,w=!1,I=!1;for(;t<u;){let p=!1;const m=c.charCodeAt(t);if(a===13){let R;switch(m){case 40:l=!0,R=0;break;case 41:R=l?0:1;break;case 91:w=!0,o=!0,R=0;break;case 93:w=!1,R=o?0:1;break;case 123:I=!0,R=0;break;case 125:R=I?0:1;break;case 39:R=d===34||d===96?0:1;break;case 34:R=d===39||d===96?0:1;break;case 96:R=d===39||d===34?0:1;break;case 42:R=d===42?1:0;break;case 124:R=d===124?1:0;break;case 32:R=w?0:1;break;default:R=b.get(m)}R===1&&(h.push(C._createLink(b,c,_,i,t)),p=!0)}else if(a===12){let R;m===91?(o=!0,R=0):R=b.get(m),R===1?p=!0:a=13}else a=s.nextState(a,m),a===0&&(p=!0);p&&(a=1,l=!1,o=!1,I=!1,i=t+1,d=m),t++}a===13&&h.push(C._createLink(b,c,_,i,u))}return h}}e.LinkComputer=C;function g(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:C.computeLinks(f)}e.computeLinks=g}),define(ve[117],_e([0,1,3,6]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class P{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(S){this._onDidChange.fire({changedLanguages:S,changedColorMap:!1})}register(S,D){return this._map.set(S,D),this.fire([S]),(0,k.toDisposable)(()=>{this._map.get(S)===D&&(this._map.delete(S),this.fire([S]))})}registerPromise(S,D){let y=null,n=!1;return this._promises.set(S,D.then(T=>{this._promises.delete(S),!(n||!T)&&(y=this.register(S,T))})),(0,k.toDisposable)(()=>{n=!0,y&&y.dispose()})}getPromise(S){const D=this.get(S);if(D)return Promise.resolve(D);const y=this._promises.get(S);return y?y.then(n=>this.get(S)):null}get(S){return this._map.get(S)||null}setColorMap(S){this._colorMap=S,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=P}),define(ve[85],_e([0,1,23,21]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var P;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(P||(P={}));function A(C){for(let g=0,f=C.length;g<f;g+=4){const r=C[g+0],s=C[g+1],b=C[g+2],h=C[g+3];C[g+0]=h,C[g+1]=b,C[g+2]=s,C[g+3]=r}}function S(C){const g=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return k.isLittleEndian()||A(g),E.VSBuffer.wrap(g)}function D(C){const g=C.buffer;if(k.isLittleEndian()||A(g),g.byteOffset%4==0)return new Uint32Array(g.buffer,g.byteOffset,g.length/4);{const f=new Uint8Array(g.byteLength);return f.set(g),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function y(C){const g=new Uint32Array(n(C));let f=0;if(g[f++]=C.id,C.type==="full")g[f++]=1,g[f++]=C.data.length,g.set(C.data,f),f+=C.data.length;else{g[f++]=2,g[f++]=C.deltas.length;for(const r of C.deltas)g[f++]=r.start,g[f++]=r.deleteCount,r.data?(g[f++]=r.data.length,g.set(r.data,f),f+=r.data.length):g[f++]=0}return S(g)}e.encodeSemanticTokensDto=y;function n(C){let g=0;if(g+=1+1,C.type==="full")g+=1+C.data.length;else{g+=1,g+=(1+1+1)*C.deltas.length;for(const f of C.deltas)f.data&&(g+=f.data.length)}return g}function T(C){const g=D(C);let f=0;const r=g[f++];if(g[f++]===1){const _=g[f++],v=g.subarray(f,f+_);return f+=_,{id:r,type:"full",data:v}}const b=g[f++];let h=[];for(let _=0;_<b;_++){const v=g[f++],c=g[f++],u=g[f++];let t;u>0&&(t=g.subarray(f,f+u),f+=u),h[_]={start:v,deleteCount:c,data:t}}return{id:r,type:"delta",deltas:h}}e.decodeSemanticTokensDto=T}),define(ve[86],_e([0,1,80]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class k{constructor(S,D){this.index=S,this.remainder=D}}e.PrefixSumIndexOfResult=k;class P{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,D){S=(0,E.toUint32)(S);const y=this.values,n=this.prefixSum,T=D.length;return T===0?!1:(this.values=new Uint32Array(y.length+T),this.values.set(y.subarray(0,S),0),this.values.set(y.subarray(S),S+T),this.values.set(D,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(S,D){return S=(0,E.toUint32)(S),D=(0,E.toUint32)(D),this.values[S]===D?!1:(this.values[S]=D,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,D){S=(0,E.toUint32)(S),D=(0,E.toUint32)(D);const y=this.values,n=this.prefixSum;if(S>=y.length)return!1;let T=y.length-S;return D>=T&&(D=T),D===0?!1:(this.values=new Uint32Array(y.length-D),this.values.set(y.subarray(0,S),0),this.values.set(y.subarray(S+D),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(S){return S<0?0:(S=(0,E.toUint32)(S),this._getAccumulatedValue(S))}_getAccumulatedValue(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),S>=this.values.length&&(S=this.values.length-1);for(let y=D;y<=S;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalValue();let D=0,y=this.values.length-1,n=0,T=0,C=0;for(;D<=y;)if(n=D+(y-D)/2|0,T=this.prefixSum[n],C=T-this.values[n],S<C)y=n-1;else if(S>=T)D=n+1;else break;return new k(n,S-C)}}e.PrefixSumComputer=P}),define(ve[118],_e([0,1,8,38,86]),function(ie,e,E,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(D,y,n,T){this._uri=D,this._lines=y,this._eol=n,this._versionId=T,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const y=D.changes;for(const n of y)this._acceptDeleteRange(n.range),this._acceptInsertText(new k.Position(n.range.startLineNumber,n.range.startColumn),n.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,y=this._lines.length,n=new Uint32Array(y);for(let T=0;T<y;T++)n[T]=this._lines[T].length+D;this._lineStarts=new P.PrefixSumComputer(n)}}_setLineText(D,y){this._lines[D]=y,this._lineStarts&&this._lineStarts.changeValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,y){if(y.length!==0){let n=(0,E.splitLines)(y);if(n.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+n[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}n[n.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+n[0]);let T=new Uint32Array(n.length-1);for(let C=1;C<n.length;C++)this._lines.splice(D.lineNumber+C-1,0,n[C]),T[C-1]=n[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,T)}}}e.MirrorTextModel=A}),define(ve[119],_e([16,17]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(ve[60],_e([0,1,119,13,11]),function(ie,e,E,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(n,T){return T&&(n.stack||n.stacktrace)?E.localize(0,null,D(n),S(n.stack)||S(n.stacktrace)):D(n)}function S(n){return Array.isArray(n)?n.join(`
`):n}function D(n){return typeof n.code=="string"&&typeof n.errno=="number"&&typeof n.syscall=="string"?E.localize(1,null,n.message):n.message||E.localize(2,null)}function y(n=null,T=!1){if(!n)return E.localize(3,null);if(Array.isArray(n)){const C=P.coalesce(n),g=y(C[0],T);return C.length>1?E.localize(4,null,g,C.length):g}if(k.isString(n))return n;if(n.detail){const C=n.detail;if(C.error)return A(C.error,T);if(C.exception)return A(C.exception,T)}return n.stack?A(n,T):n.message?n.message:E.localize(5,null)}e.toErrorMessage=y}),define(ve[120],_e([16,17]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(ve[121],_e([0,1,120,21,84]),function(ie,e,E,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(j){j[j.None=0]="None",j[j.Keep=1]="Keep",j[j.Brackets=2]="Brackets",j[j.Advanced=3]="Advanced",j[j.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=S;class D{constructor(){this._values=[]}_read(X){return this._values[X]}get(X){return this._values[X]}_write(X,pe){this._values[X]=pe}}e.ValidatedEditorOptions=D;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class n{constructor(X,pe,Le,He){this.id=X,this.name=pe,this.defaultValue=Le,this.schema=He}compute(X,pe,Le){return Le}}class T{constructor(X,pe=null){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(X){return this.defaultValue}}class C{constructor(X,pe,Le,He){this.id=X,this.name=pe,this.defaultValue=Le,this.schema=He}validate(X){return typeof X=="undefined"?this.defaultValue:X}compute(X,pe,Le){return Le}}function g(j,X){return typeof j=="undefined"?X:j==="false"?!1:Boolean(j)}e.boolean=g;class f extends C{constructor(X,pe,Le,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Le),super(X,pe,Le,He)}validate(X){return g(X,this.defaultValue)}}class r extends C{constructor(X,pe,Le,He,Ue,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="integer",Ze.default=Le,Ze.minimum=He,Ze.maximum=Ue),super(X,pe,Le,Ze),this.minimum=He,this.maximum=Ue}static clampedInt(X,pe,Le,He){if(typeof X=="undefined")return pe;let Ue=parseInt(X,10);return isNaN(Ue)?pe:(Ue=Math.max(Le,Ue),Ue=Math.min(He,Ue),Ue|0)}validate(X){return r.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class s extends C{constructor(X,pe,Le,He,Ue){typeof Ue!="undefined"&&(Ue.type="number",Ue.default=Le),super(X,pe,Le,Ue),this.validationFn=He}static clamp(X,pe,Le){return X<pe?pe:X>Le?Le:X}static float(X,pe){if(typeof X=="number")return X;if(typeof X=="undefined")return pe;const Le=parseFloat(X);return isNaN(Le)?pe:Le}validate(X){return this.validationFn(s.float(X,this.defaultValue))}}class b extends C{static string(X,pe){return typeof X!="string"?pe:X}constructor(X,pe,Le,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Le),super(X,pe,Le,He)}validate(X){return b.string(X,this.defaultValue)}}function h(j,X,pe){return typeof j!="string"||pe.indexOf(j)===-1?X:j}e.stringSet=h;class _ extends C{constructor(X,pe,Le,He,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="string",Ue.enum=He,Ue.default=Le),super(X,pe,Le,Ue),this._allowedValues=He}validate(X){return h(X,this.defaultValue,this._allowedValues)}}class v extends n{constructor(X,pe,Le,He,Ue,Ze,H=void 0){typeof H!="undefined"&&(H.type="string",H.enum=Ue,H.default=He),super(X,pe,Le,H),this._allowedValues=Ue,this._convert=Ze}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function c(j){switch(j){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class u extends n{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[E.localize(0,null),E.localize(1,null),E.localize(2,null)],default:"auto",description:E.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,pe,Le){return Le===0?X.accessibilitySupport:Le}}class t extends n{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:E.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:E.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{insertSpace:g(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(j){j[j.Hidden=0]="Hidden",j[j.Blink=1]="Blink",j[j.Smooth=2]="Smooth",j[j.Phase=3]="Phase",j[j.Expand=4]="Expand",j[j.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function d(j){switch(j){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var a;(function(j){j[j.Line=1]="Line",j[j.Block=2]="Block",j[j.Underline=3]="Underline",j[j.LineThin=4]="LineThin",j[j.BlockOutline=5]="BlockOutline",j[j.UnderlineThin=6]="UnderlineThin"})(a=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(j){switch(j){case a.Line:return"line";case a.Block:return"block";case a.Underline:return"underline";case a.LineThin:return"line-thin";case a.BlockOutline:return"block-outline";case a.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function o(j){switch(j){case"line":return a.Line;case"block":return a.Block;case"underline":return a.Underline;case"line-thin":return a.LineThin;case"block-outline":return a.BlockOutline;case"underline-thin":return a.UnderlineThin}}class w extends T{constructor(){super(123,[62,31])}compute(X,pe,Le){const He=["monaco-editor"];return pe.get(31)&&He.push(pe.get(31)),X.extraEditorClassName&&He.push(X.extraEditorClassName),pe.get(62)==="default"?He.push("mouse-default"):pe.get(62)==="copy"&&He.push("mouse-copy"),pe.get(97)&&He.push("showUnused"),pe.get(121)&&He.push("showDeprecated"),He.join(" ")}}class I extends f{constructor(){super(30,"emptySelectionClipboard",!0,{description:E.localize(6,null)})}compute(X,pe,Le){return Le&&X.emptySelectionClipboard}}class p extends n{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:E.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:X.seedSearchStringFromSelection,description:E.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[E.localize(9,null),E.localize(10,null),E.localize(11,null)],description:E.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:E.localize(13,null),included:k.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:E.localize(14,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:E.localize(15,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{cursorMoveOnType:g(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:g(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":h(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(pe.loop,this.defaultValue.loop)}}}class m extends n{constructor(){super(41,"fontLigatures",m.OFF,{anyOf:[{type:"boolean",description:E.localize(16,null)},{type:"string",description:E.localize(17,null)}],description:E.localize(18,null),default:!1})}validate(X){return typeof X=="undefined"?this.defaultValue:typeof X=="string"?X==="false"?m.OFF:X==="true"?m.ON:X:Boolean(X)?m.ON:m.OFF}}e.EditorFontLigatures=m,m.OFF='"liga" off, "calt" off',m.ON='"liga" on, "calt" on';class R extends T{constructor(){super(40)}compute(X,pe,Le){return X.fontInfo}}class F extends C{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:E.localize(19,null)})}validate(X){let pe=s.float(X,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(pe,6,100)}compute(X,pe,Le){return X.fontInfo.fontSize}}class x extends n{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.MINIMUM_VALUE,maximum:x.MAXIMUM_VALUE,errorMessage:E.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:E.localize(21,null)})}validate(X){return X==="normal"||X==="bold"?X:String(r.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,x.MINIMUM_VALUE,x.MAXIMUM_VALUE))}}x.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],x.MINIMUM_VALUE=1,x.MAXIMUM_VALUE=1e3;class ae extends n{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[E.localize(22,null),E.localize(23,null),E.localize(24,null)]};super(47,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:E.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:E.localize(26,null)},pe),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:E.localize(27,null)},pe),"editor.gotoLocation.multipleDeclarations":Object.assign({description:E.localize(28,null)},pe),"editor.gotoLocation.multipleImplementations":Object.assign({description:E.localize(29,null)},pe),"editor.gotoLocation.multipleReferences":Object.assign({description:E.localize(30,null)},pe),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,description:E.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,description:E.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,description:E.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,description:E.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,description:E.localize(35,null)}})}validate(X){var pe,Le,He,Ue,Ze;if(!X||typeof X!="object")return this.defaultValue;const H=X;return{multiple:h(H.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(pe=H.multipleDefinitions)!==null&&pe!==void 0?pe:h(H.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Le=H.multipleTypeDefinitions)!==null&&Le!==void 0?Le:h(H.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(He=H.multipleDeclarations)!==null&&He!==void 0?He:h(H.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Ue=H.multipleImplementations)!==null&&Ue!==void 0?Ue:h(H.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ze=H.multipleReferences)!==null&&Ze!==void 0?Ze:h(H.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:b.string(H.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:b.string(H.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:b.string(H.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:b.string(H.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:b.string(H.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class z extends n{constructor(){const X={enabled:!0,delay:300,sticky:!0};super(50,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:E.localize(36,null)},"editor.hover.delay":{type:"number",default:X.delay,description:E.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:E.localize(38,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:g(pe.enabled,this.defaultValue.enabled),delay:r.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:g(pe.sticky,this.defaultValue.sticky)}}}var B;(function(j){j[j.None=0]="None",j[j.Text=1]="Text",j[j.Blocks=2]="Blocks"})(B=e.RenderMinimap||(e.RenderMinimap={}));class G extends T{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(X,pe,Le){return G.computeLayout(pe,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const pe=X.height/X.lineHeight,Le=X.scrollBeyondLastLine?pe-1:0,He=(X.viewLineCount+Le)/(X.pixelRatio*X.height),Ue=Math.floor(X.viewLineCount/He);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:Le,desiredRatio:He,minimapLineCount:Ue}}static _computeMinimapLayout(X,pe){const Le=X.outerWidth,He=X.outerHeight,Ue=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ue*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const Ze=pe.stableMinimapLayoutInput,H=Ze&&X.outerHeight===Ze.outerHeight&&X.lineHeight===Ze.lineHeight&&X.typicalHalfwidthCharacterWidth===Ze.typicalHalfwidthCharacterWidth&&X.pixelRatio===Ze.pixelRatio&&X.scrollBeyondLastLine===Ze.scrollBeyondLastLine&&X.minimap.enabled===Ze.minimap.enabled&&X.minimap.side===Ze.minimap.side&&X.minimap.size===Ze.minimap.size&&X.minimap.showSlider===Ze.minimap.showSlider&&X.minimap.renderCharacters===Ze.minimap.renderCharacters&&X.minimap.maxColumn===Ze.minimap.maxColumn&&X.minimap.scale===Ze.minimap.scale&&X.verticalScrollbarWidth===Ze.verticalScrollbarWidth&&X.isViewportWrapping===Ze.isViewportWrapping,ne=X.lineHeight,he=X.typicalHalfwidthCharacterWidth,q=X.scrollBeyondLastLine,Y=X.minimap.renderCharacters;let oe=Ue>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const fe=X.minimap.maxColumn,Ee=X.minimap.size,Ne=X.minimap.side,Fe=X.verticalScrollbarWidth,Ve=X.viewLineCount,Xe=X.remainingWidth,tt=X.isViewportWrapping,nt=Y?2:3;let rt=Math.floor(Ue*He);const it=rt/Ue;let gt=!1,ce=!1,De=nt*oe,ue=oe/Ue,V=1;if(Ee==="fill"||Ee==="fit"){const{typicalViewportLineCount:Qe,extraLinesBeyondLastLine:st,desiredRatio:ct,minimapLineCount:pt}=G.computeContainedMinimapLineCount({viewLineCount:Ve,scrollBeyondLastLine:q,height:He,lineHeight:ne,pixelRatio:Ue});if(Ve/pt>1)gt=!0,ce=!0,oe=1,De=1,ue=oe/Ue;else{let bt=!1,wt=oe+1;if(Ee==="fit"){const yt=Math.ceil((Ve+st)*De);tt&&H&&Xe<=pe.stableFitRemainingWidth?(bt=!0,wt=pe.stableFitMaxMinimapScale):(bt=yt>rt,tt&&bt?(pe.stableMinimapLayoutInput=X,pe.stableFitRemainingWidth=Xe):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0))}if(Ee==="fill"||bt){gt=!0;const yt=oe;De=Math.min(ne*Ue,Math.max(1,Math.floor(1/ct))),oe=Math.min(wt,Math.max(1,Math.floor(De/nt))),oe>yt&&(V=Math.min(2,oe/yt)),ue=oe/Ue/V,rt=Math.ceil(Math.max(Qe,Ve+st)*De),tt&&bt&&(pe.stableFitMaxMinimapScale=oe)}}}const Oe=Math.floor(fe*ue),Ie=Math.min(Oe,Math.max(0,Math.floor((Xe-Fe-2)*ue/(he+ue)))+e.MINIMAP_GUTTER_WIDTH);let Je=Math.floor(Ue*Ie);const Ge=Je/Ue;Je=Math.floor(Je*V);const lt=Y?1:2,at=Ne==="left"?0:Le-Ie-Fe;return{renderMinimap:lt,minimapLeft:at,minimapWidth:Ie,minimapHeightIsEditorHeight:gt,minimapIsSampling:ce,minimapScale:oe,minimapLineHeight:De,minimapCanvasInnerWidth:Je,minimapCanvasInnerHeight:rt,minimapCanvasOuterWidth:Ge,minimapCanvasOuterHeight:it}}static computeLayout(X,pe){const Le=pe.outerWidth|0,He=pe.outerHeight|0,Ue=pe.lineHeight|0,Ze=pe.lineNumbersDigitCount|0,H=pe.typicalHalfwidthCharacterWidth,ne=pe.maxDigitWidth,he=pe.pixelRatio,q=pe.viewLineCount,Y=X.get(118),oe=Y==="inherit"?X.get(117):Y,fe=oe==="inherit"?X.get(113):oe,Ee=X.get(116),Ne=X.get(2),Fe=pe.isDominatedByLongLines,Ve=X.get(46),Xe=X.get(56).renderType!==0,tt=X.get(57),nt=X.get(91),rt=X.get(61),it=X.get(89),gt=it.verticalScrollbarSize,ce=it.verticalHasArrows,De=it.arrowSize,ue=it.horizontalScrollbarSize,V=X.get(54),Oe=X.get(35);let Ie;if(typeof V=="string"&&/^\d+(\.\d+)?ch$/.test(V)){const Tt=parseFloat(V.substr(0,V.length-2));Ie=r.clampedInt(Tt*H,0,0,1e3)}else Ie=r.clampedInt(V,0,0,1e3);Oe&&(Ie+=16);let Je=0;if(Xe){const Tt=Math.max(Ze,tt);Je=Math.round(Tt*ne)}let Ge=0;Ve&&(Ge=Ue);let lt=0,at=lt+Ge,Qe=at+Je,st=Qe+Ie;const ct=Le-Ge-Je-Ie;let pt=!1,vt=!1,bt=-1;Ne!==2&&(oe==="inherit"&&Fe?(pt=!0,vt=!0):fe==="on"||fe==="bounded"?vt=!0:fe==="wordWrapColumn"&&(bt=Ee));const wt=G._computeMinimapLayout({outerWidth:Le,outerHeight:He,lineHeight:Ue,typicalHalfwidthCharacterWidth:H,pixelRatio:he,scrollBeyondLastLine:nt,minimap:rt,verticalScrollbarWidth:gt,viewLineCount:q,remainingWidth:ct,isViewportWrapping:vt},pe.memory||new y);wt.renderMinimap!==0&&wt.minimapLeft===0&&(lt+=wt.minimapWidth,at+=wt.minimapWidth,Qe+=wt.minimapWidth,st+=wt.minimapWidth);const yt=ct-wt.minimapWidth,_t=Math.max(1,Math.floor((yt-gt-2)/H)),Mt=ce?De:0;return vt&&(bt=Math.max(1,_t),fe==="bounded"&&(bt=Math.min(bt,Ee))),{width:Le,height:He,glyphMarginLeft:lt,glyphMarginWidth:Ge,lineNumbersLeft:at,lineNumbersWidth:Je,decorationsLeft:Qe,decorationsWidth:Ie,contentLeft:st,contentWidth:yt,minimap:wt,viewportColumn:_t,isWordWrapMinified:pt,isViewportWrapping:vt,wrappingColumn:bt,verticalScrollbarWidth:gt,horizontalScrollbarHeight:ue,overviewRuler:{top:Mt,width:gt,height:He-2*Mt,right:0}}}}e.EditorLayoutInfoComputer=G;class M extends n{constructor(){const X={enabled:!0};super(53,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:E.localize(39,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:g(X.enabled,this.defaultValue.enabled)}}}class N extends n{constructor(){const X={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",X,{"editor.inlineHints.enabled":{type:"boolean",default:X.enabled,description:E.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:X.fontSize,description:E.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:X.fontFamily,description:E.localize(42,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:g(pe.enabled,this.defaultValue.enabled),fontSize:r.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:b.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class W extends r{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:E.localize(43,null)})}compute(X,pe,Le){return X.fontInfo.lineHeight}}class Q extends n{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:E.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[E.localize(45,null),E.localize(46,null),E.localize(47,null)],default:X.size,description:E.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:E.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:E.localize(50,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:E.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:E.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:E.localize(53,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:g(pe.enabled,this.defaultValue.enabled),size:h(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(pe.side,this.defaultValue.side,["right","left"]),showSlider:h(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(pe.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(pe.scale,1,1,3),maxColumn:r.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function $(j){return j==="ctrlCmd"?k.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Z extends n{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:E.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:E.localize(55,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{top:r.clampedInt(pe.top,0,0,1e3),bottom:r.clampedInt(pe.bottom,0,0,1e3)}}}class re extends n{constructor(){const X={enabled:!0,cycle:!1};super(72,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:E.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:E.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:g(pe.enabled,this.defaultValue.enabled),cycle:g(pe.cycle,this.defaultValue.cycle)}}}class se extends T{constructor(){super(124)}compute(X,pe,Le){return X.pixelRatio}}class ye extends n{constructor(){const X={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",X,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:X.strings,description:E.localize(58,null)},comments:{type:"boolean",default:X.comments,description:E.localize(59,null)},other:{type:"boolean",default:X.other,description:E.localize(60,null)}}}],default:X,description:E.localize(61,null)});this.defaultValue=X}validate(X){if(typeof X=="boolean")return X;if(X&&typeof X=="object"){const pe=X,Le={other:g(pe.other,this.defaultValue.other),comments:g(pe.comments,this.defaultValue.comments),strings:g(pe.strings,this.defaultValue.strings)};return Le.other&&Le.comments&&Le.strings?!0:!Le.other&&!Le.comments&&!Le.strings?!1:Le}return this.defaultValue}}var Pe;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval",j[j.Custom=4]="Custom"})(Pe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class $e extends n{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[E.localize(62,null),E.localize(63,null),E.localize(64,null),E.localize(65,null)],default:"on",description:E.localize(66,null)})}validate(X){let pe=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof X!="undefined"&&(typeof X=="function"?(pe=4,Le=X):X==="interval"?pe=3:X==="relative"?pe=2:X==="on"?pe=1:pe=0),{renderType:pe,renderFn:Le}}}function Re(j){const X=j.get(84);return X==="editable"?j.get(77):X!=="on"}e.filterValidationDecorations=Re;class ze extends n{constructor(){const X=[],pe={type:"number",description:E.localize(67,null)};super(88,"rulers",X,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:E.localize(68,null),format:"color-hex"}}}]},default:X,description:E.localize(69,null)})}validate(X){if(Array.isArray(X)){let pe=[];for(let Le of X)if(typeof Le=="number")pe.push({column:r.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const He=Le;pe.push({column:r.clampedInt(He.column,0,0,1e4),color:He.color})}return pe.sort((Le,He)=>Le.column-He.column),pe}return this.defaultValue}}function U(j,X){if(typeof j!="string")return X;switch(j){case"hidden":return 2;case"visible":return 3;default:return 1}}class K extends n{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X,Le=r.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=r.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:U(pe.vertical,this.defaultValue.vertical),horizontal:U(pe.horizontal,this.defaultValue.horizontal),useShadows:g(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:r.clampedInt(pe.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:He,verticalSliderSize:r.clampedInt(pe.verticalSliderSize,He,0,1e3),scrollByPage:g(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class te extends n{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[E.localize(70,null),E.localize(71,null)],default:X.insertMode,description:E.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:E.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:E.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:E.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:E.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:E.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:E.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:E.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:E.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:E.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:E.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:E.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:E.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:E.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:E.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:E.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:E.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:E.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:E.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:E.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:E.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:E.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:E.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:E.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:E.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:E.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:E.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:E.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:E.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:E.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:E.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:E.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:E.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:E.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:E.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:E.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:E.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:E.localize(109,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{insertMode:h(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:g(pe.showIcons,this.defaultValue.showIcons),showStatusBar:g(pe.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:g(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(pe.showMethods,this.defaultValue.showMethods),showFunctions:g(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:g(pe.showConstructors,this.defaultValue.showConstructors),showFields:g(pe.showFields,this.defaultValue.showFields),showVariables:g(pe.showVariables,this.defaultValue.showVariables),showClasses:g(pe.showClasses,this.defaultValue.showClasses),showStructs:g(pe.showStructs,this.defaultValue.showStructs),showInterfaces:g(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:g(pe.showModules,this.defaultValue.showModules),showProperties:g(pe.showProperties,this.defaultValue.showProperties),showEvents:g(pe.showEvents,this.defaultValue.showEvents),showOperators:g(pe.showOperators,this.defaultValue.showOperators),showUnits:g(pe.showUnits,this.defaultValue.showUnits),showValues:g(pe.showValues,this.defaultValue.showValues),showConstants:g(pe.showConstants,this.defaultValue.showConstants),showEnums:g(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:g(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(pe.showKeywords,this.defaultValue.showKeywords),showWords:g(pe.showWords,this.defaultValue.showWords),showColors:g(pe.showColors,this.defaultValue.showColors),showFiles:g(pe.showFiles,this.defaultValue.showFiles),showReferences:g(pe.showReferences,this.defaultValue.showReferences),showFolders:g(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:g(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(pe.showSnippets,this.defaultValue.showSnippets),showUsers:g(pe.showUsers,this.defaultValue.showUsers),showIssues:g(pe.showIssues,this.defaultValue.showIssues)}}}class le extends n{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:E.localize(110,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class me extends T{constructor(){super(125,[77])}compute(X,pe,Le){return pe.get(77)?!0:X.tabFocusMode}}var Se;(function(j){j[j.None=0]="None",j[j.Same=1]="Same",j[j.Indent=2]="Indent",j[j.DeepIndent=3]="DeepIndent"})(Se=e.WrappingIndent||(e.WrappingIndent={}));function Me(j){switch(j){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends T{constructor(){super(127,[126])}compute(X,pe,Le){const He=pe.get(126);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Ae="Menlo, Monaco, 'Courier New', monospace",Be="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:k.isMacintosh?Ae:k.isLinux?Be:Ce,fontWeight:"normal",fontSize:k.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function be(j){return e.editorOptionsRegistry[j.id]=j,j}var qe;(function(j){j[j.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",j[j.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",j[j.accessibilitySupport=2]="accessibilitySupport",j[j.accessibilityPageSize=3]="accessibilityPageSize",j[j.ariaLabel=4]="ariaLabel",j[j.autoClosingBrackets=5]="autoClosingBrackets",j[j.autoClosingDelete=6]="autoClosingDelete",j[j.autoClosingOvertype=7]="autoClosingOvertype",j[j.autoClosingQuotes=8]="autoClosingQuotes",j[j.autoIndent=9]="autoIndent",j[j.automaticLayout=10]="automaticLayout",j[j.autoSurround=11]="autoSurround",j[j.codeLens=12]="codeLens",j[j.codeLensFontFamily=13]="codeLensFontFamily",j[j.codeLensFontSize=14]="codeLensFontSize",j[j.colorDecorators=15]="colorDecorators",j[j.columnSelection=16]="columnSelection",j[j.comments=17]="comments",j[j.contextmenu=18]="contextmenu",j[j.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",j[j.cursorBlinking=20]="cursorBlinking",j[j.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",j[j.cursorStyle=22]="cursorStyle",j[j.cursorSurroundingLines=23]="cursorSurroundingLines",j[j.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",j[j.cursorWidth=25]="cursorWidth",j[j.disableLayerHinting=26]="disableLayerHinting",j[j.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",j[j.domReadOnly=28]="domReadOnly",j[j.dragAndDrop=29]="dragAndDrop",j[j.emptySelectionClipboard=30]="emptySelectionClipboard",j[j.extraEditorClassName=31]="extraEditorClassName",j[j.fastScrollSensitivity=32]="fastScrollSensitivity",j[j.find=33]="find",j[j.fixedOverflowWidgets=34]="fixedOverflowWidgets",j[j.folding=35]="folding",j[j.foldingStrategy=36]="foldingStrategy",j[j.foldingHighlight=37]="foldingHighlight",j[j.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",j[j.fontFamily=39]="fontFamily",j[j.fontInfo=40]="fontInfo",j[j.fontLigatures=41]="fontLigatures",j[j.fontSize=42]="fontSize",j[j.fontWeight=43]="fontWeight",j[j.formatOnPaste=44]="formatOnPaste",j[j.formatOnType=45]="formatOnType",j[j.glyphMargin=46]="glyphMargin",j[j.gotoLocation=47]="gotoLocation",j[j.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",j[j.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",j[j.hover=50]="hover",j[j.inDiffEditor=51]="inDiffEditor",j[j.letterSpacing=52]="letterSpacing",j[j.lightbulb=53]="lightbulb",j[j.lineDecorationsWidth=54]="lineDecorationsWidth",j[j.lineHeight=55]="lineHeight",j[j.lineNumbers=56]="lineNumbers",j[j.lineNumbersMinChars=57]="lineNumbersMinChars",j[j.linkedEditing=58]="linkedEditing",j[j.links=59]="links",j[j.matchBrackets=60]="matchBrackets",j[j.minimap=61]="minimap",j[j.mouseStyle=62]="mouseStyle",j[j.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",j[j.mouseWheelZoom=64]="mouseWheelZoom",j[j.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",j[j.multiCursorModifier=66]="multiCursorModifier",j[j.multiCursorPaste=67]="multiCursorPaste",j[j.occurrencesHighlight=68]="occurrencesHighlight",j[j.overviewRulerBorder=69]="overviewRulerBorder",j[j.overviewRulerLanes=70]="overviewRulerLanes",j[j.padding=71]="padding",j[j.parameterHints=72]="parameterHints",j[j.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",j[j.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",j[j.quickSuggestions=75]="quickSuggestions",j[j.quickSuggestionsDelay=76]="quickSuggestionsDelay",j[j.readOnly=77]="readOnly",j[j.renameOnType=78]="renameOnType",j[j.renderControlCharacters=79]="renderControlCharacters",j[j.renderIndentGuides=80]="renderIndentGuides",j[j.renderFinalNewline=81]="renderFinalNewline",j[j.renderLineHighlight=82]="renderLineHighlight",j[j.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",j[j.renderValidationDecorations=84]="renderValidationDecorations",j[j.renderWhitespace=85]="renderWhitespace",j[j.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",j[j.roundedSelection=87]="roundedSelection",j[j.rulers=88]="rulers",j[j.scrollbar=89]="scrollbar",j[j.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",j[j.scrollBeyondLastLine=91]="scrollBeyondLastLine",j[j.scrollPredominantAxis=92]="scrollPredominantAxis",j[j.selectionClipboard=93]="selectionClipboard",j[j.selectionHighlight=94]="selectionHighlight",j[j.selectOnLineNumbers=95]="selectOnLineNumbers",j[j.showFoldingControls=96]="showFoldingControls",j[j.showUnused=97]="showUnused",j[j.snippetSuggestions=98]="snippetSuggestions",j[j.smartSelect=99]="smartSelect",j[j.smoothScrolling=100]="smoothScrolling",j[j.stickyTabStops=101]="stickyTabStops",j[j.stopRenderingLineAfter=102]="stopRenderingLineAfter",j[j.suggest=103]="suggest",j[j.suggestFontSize=104]="suggestFontSize",j[j.suggestLineHeight=105]="suggestLineHeight",j[j.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",j[j.suggestSelection=107]="suggestSelection",j[j.tabCompletion=108]="tabCompletion",j[j.tabIndex=109]="tabIndex",j[j.unusualLineTerminators=110]="unusualLineTerminators",j[j.useTabStops=111]="useTabStops",j[j.wordSeparators=112]="wordSeparators",j[j.wordWrap=113]="wordWrap",j[j.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",j[j.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",j[j.wordWrapColumn=116]="wordWrapColumn",j[j.wordWrapOverride1=117]="wordWrapOverride1",j[j.wordWrapOverride2=118]="wordWrapOverride2",j[j.wrappingIndent=119]="wrappingIndent",j[j.wrappingStrategy=120]="wrappingStrategy",j[j.showDeprecated=121]="showDeprecated",j[j.inlineHints=122]="inlineHints",j[j.editorClassName=123]="editorClassName",j[j.pixelRatio=124]="pixelRatio",j[j.tabFocusMode=125]="tabFocusMode",j[j.layoutInfo=126]="layoutInfo",j[j.wrappingInfo=127]="wrappingInfo"})(qe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:be(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:E.localize(111,null)})),acceptSuggestionOnEnter:be(new _(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",E.localize(112,null),""],markdownDescription:E.localize(113,null)})),accessibilitySupport:be(new u),accessibilityPageSize:be(new r(3,"accessibilityPageSize",10,1,1073741824,{description:E.localize(114,null)})),ariaLabel:be(new b(4,"ariaLabel",E.localize(115,null))),autoClosingBrackets:be(new _(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(116,null),E.localize(117,null),""],description:E.localize(118,null)})),autoClosingDelete:be(new _(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",E.localize(119,null),""],description:E.localize(120,null)})),autoClosingOvertype:be(new _(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",E.localize(121,null),""],description:E.localize(122,null)})),autoClosingQuotes:be(new _(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(123,null),E.localize(124,null),""],description:E.localize(125,null)})),autoIndent:be(new v(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[E.localize(126,null),E.localize(127,null),E.localize(128,null),E.localize(129,null),E.localize(130,null)],description:E.localize(131,null)})),automaticLayout:be(new f(10,"automaticLayout",!1)),autoSurround:be(new _(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[E.localize(132,null),E.localize(133,null),E.localize(134,null),""],description:E.localize(135,null)})),stickyTabStops:be(new f(101,"stickyTabStops",!1,{description:E.localize(136,null)})),codeLens:be(new f(12,"codeLens",!0,{description:E.localize(137,null)})),codeLensFontFamily:be(new b(13,"codeLensFontFamily","",{description:E.localize(138,null)})),codeLensFontSize:be(new r(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:E.localize(139,null)})),colorDecorators:be(new f(15,"colorDecorators",!0,{description:E.localize(140,null)})),columnSelection:be(new f(16,"columnSelection",!1,{description:E.localize(141,null)})),comments:be(new t),contextmenu:be(new f(18,"contextmenu",!0)),copyWithSyntaxHighlighting:be(new f(19,"copyWithSyntaxHighlighting",!0,{description:E.localize(142,null)})),cursorBlinking:be(new v(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],d,{description:E.localize(143,null)})),cursorSmoothCaretAnimation:be(new f(21,"cursorSmoothCaretAnimation",!1,{description:E.localize(144,null)})),cursorStyle:be(new v(22,"cursorStyle",a.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],o,{description:E.localize(145,null)})),cursorSurroundingLines:be(new r(23,"cursorSurroundingLines",0,0,1073741824,{description:E.localize(146,null)})),cursorSurroundingLinesStyle:be(new _(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[E.localize(147,null),E.localize(148,null)],description:E.localize(149,null)})),cursorWidth:be(new r(25,"cursorWidth",0,0,1073741824,{markdownDescription:E.localize(150,null)})),disableLayerHinting:be(new f(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:be(new f(27,"disableMonospaceOptimizations",!1)),domReadOnly:be(new f(28,"domReadOnly",!1)),dragAndDrop:be(new f(29,"dragAndDrop",!0,{description:E.localize(151,null)})),emptySelectionClipboard:be(new I),extraEditorClassName:be(new b(31,"extraEditorClassName","")),fastScrollSensitivity:be(new s(32,"fastScrollSensitivity",5,j=>j<=0?5:j,{markdownDescription:E.localize(152,null)})),find:be(new p),fixedOverflowWidgets:be(new f(34,"fixedOverflowWidgets",!1)),folding:be(new f(35,"folding",!0,{description:E.localize(153,null)})),foldingStrategy:be(new _(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[E.localize(154,null),E.localize(155,null)],description:E.localize(156,null)})),foldingHighlight:be(new f(37,"foldingHighlight",!0,{description:E.localize(157,null)})),unfoldOnClickAfterEndOfLine:be(new f(38,"unfoldOnClickAfterEndOfLine",!1,{description:E.localize(158,null)})),fontFamily:be(new b(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:E.localize(159,null)})),fontInfo:be(new R),fontLigatures2:be(new m),fontSize:be(new F),fontWeight:be(new x),formatOnPaste:be(new f(44,"formatOnPaste",!1,{description:E.localize(160,null)})),formatOnType:be(new f(45,"formatOnType",!1,{description:E.localize(161,null)})),glyphMargin:be(new f(46,"glyphMargin",!0,{description:E.localize(162,null)})),gotoLocation:be(new ae),hideCursorInOverviewRuler:be(new f(48,"hideCursorInOverviewRuler",!1,{description:E.localize(163,null)})),highlightActiveIndentGuide:be(new f(49,"highlightActiveIndentGuide",!0,{description:E.localize(164,null)})),hover:be(new z),inDiffEditor:be(new f(51,"inDiffEditor",!1)),letterSpacing:be(new s(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,j=>s.clamp(j,-5,20),{description:E.localize(165,null)})),lightbulb:be(new M),lineDecorationsWidth:be(new C(54,"lineDecorationsWidth",10)),lineHeight:be(new W),lineNumbers:be(new $e),lineNumbersMinChars:be(new r(57,"lineNumbersMinChars",5,1,300)),linkedEditing:be(new f(58,"linkedEditing",!1,{description:E.localize(166,null)})),links:be(new f(59,"links",!0,{description:E.localize(167,null)})),matchBrackets:be(new _(60,"matchBrackets","always",["always","near","never"],{description:E.localize(168,null)})),minimap:be(new Q),mouseStyle:be(new _(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:be(new s(63,"mouseWheelScrollSensitivity",1,j=>j===0?1:j,{markdownDescription:E.localize(169,null)})),mouseWheelZoom:be(new f(64,"mouseWheelZoom",!1,{markdownDescription:E.localize(170,null)})),multiCursorMergeOverlapping:be(new f(65,"multiCursorMergeOverlapping",!0,{description:E.localize(171,null)})),multiCursorModifier:be(new v(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],$,{markdownEnumDescriptions:[E.localize(172,null),E.localize(173,null)],markdownDescription:E.localize(174,null)})),multiCursorPaste:be(new _(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[E.localize(175,null),E.localize(176,null)],markdownDescription:E.localize(177,null)})),occurrencesHighlight:be(new f(68,"occurrencesHighlight",!0,{description:E.localize(178,null)})),overviewRulerBorder:be(new f(69,"overviewRulerBorder",!0,{description:E.localize(179,null)})),overviewRulerLanes:be(new r(70,"overviewRulerLanes",3,0,3)),padding:be(new Z),parameterHints:be(new re),peekWidgetDefaultFocus:be(new _(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[E.localize(180,null),E.localize(181,null)],description:E.localize(182,null)})),definitionLinkOpensInPeek:be(new f(74,"definitionLinkOpensInPeek",!1,{description:E.localize(183,null)})),quickSuggestions:be(new ye),quickSuggestionsDelay:be(new r(76,"quickSuggestionsDelay",10,0,1073741824,{description:E.localize(184,null)})),readOnly:be(new f(77,"readOnly",!1)),renameOnType:be(new f(78,"renameOnType",!1,{description:E.localize(185,null),markdownDeprecationMessage:E.localize(186,null)})),renderControlCharacters:be(new f(79,"renderControlCharacters",!1,{description:E.localize(187,null)})),renderIndentGuides:be(new f(80,"renderIndentGuides",!0,{description:E.localize(188,null)})),renderFinalNewline:be(new f(81,"renderFinalNewline",!0,{description:E.localize(189,null)})),renderLineHighlight:be(new _(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",E.localize(190,null)],description:E.localize(191,null)})),renderLineHighlightOnlyWhenFocus:be(new f(83,"renderLineHighlightOnlyWhenFocus",!1,{description:E.localize(192,null)})),renderValidationDecorations:be(new _(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:be(new _(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",E.localize(193,null),E.localize(194,null),E.localize(195,null),""],description:E.localize(196,null)})),revealHorizontalRightPadding:be(new r(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:be(new f(87,"roundedSelection",!0,{description:E.localize(197,null)})),rulers:be(new ze),scrollbar:be(new K),scrollBeyondLastColumn:be(new r(90,"scrollBeyondLastColumn",5,0,1073741824,{description:E.localize(198,null)})),scrollBeyondLastLine:be(new f(91,"scrollBeyondLastLine",!0,{description:E.localize(199,null)})),scrollPredominantAxis:be(new f(92,"scrollPredominantAxis",!0,{description:E.localize(200,null)})),selectionClipboard:be(new f(93,"selectionClipboard",!0,{description:E.localize(201,null),included:k.isLinux})),selectionHighlight:be(new f(94,"selectionHighlight",!0,{description:E.localize(202,null)})),selectOnLineNumbers:be(new f(95,"selectOnLineNumbers",!0)),showFoldingControls:be(new _(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[E.localize(203,null),E.localize(204,null)],description:E.localize(205,null)})),showUnused:be(new f(97,"showUnused",!0,{description:E.localize(206,null)})),showDeprecated:be(new f(121,"showDeprecated",!0,{description:E.localize(207,null)})),inlineHints:be(new N),snippetSuggestions:be(new _(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[E.localize(208,null),E.localize(209,null),E.localize(210,null),E.localize(211,null)],description:E.localize(212,null)})),smartSelect:be(new le),smoothScrolling:be(new f(100,"smoothScrolling",!1,{description:E.localize(213,null)})),stopRenderingLineAfter:be(new r(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:be(new te),suggestFontSize:be(new r(104,"suggestFontSize",0,0,1e3,{markdownDescription:E.localize(214,null)})),suggestLineHeight:be(new r(105,"suggestLineHeight",0,0,1e3,{markdownDescription:E.localize(215,null)})),suggestOnTriggerCharacters:be(new f(106,"suggestOnTriggerCharacters",!0,{description:E.localize(216,null)})),suggestSelection:be(new _(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[E.localize(217,null),E.localize(218,null),E.localize(219,null)],description:E.localize(220,null)})),tabCompletion:be(new _(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[E.localize(221,null),E.localize(222,null),E.localize(223,null)],description:E.localize(224,null)})),tabIndex:be(new r(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:be(new _(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[E.localize(225,null),E.localize(226,null),E.localize(227,null)],description:E.localize(228,null)})),useTabStops:be(new f(111,"useTabStops",!0,{description:E.localize(229,null)})),wordSeparators:be(new b(112,"wordSeparators",P.USUAL_WORD_SEPARATORS,{description:E.localize(230,null)})),wordWrap:be(new _(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[E.localize(231,null),E.localize(232,null),E.localize(233,null),E.localize(234,null)],description:E.localize(235,null)})),wordWrapBreakAfterCharacters:be(new b(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:be(new b(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:be(new r(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:E.localize(236,null)})),wordWrapOverride1:be(new _(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:be(new _(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:be(new v(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Me,{enumDescriptions:[E.localize(237,null),E.localize(238,null),E.localize(239,null),E.localize(240,null)],description:E.localize(241,null)})),wrappingStrategy:be(new _(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[E.localize(242,null),E.localize(243,null)],description:E.localize(244,null)})),editorClassName:be(new w),pixelRatio:be(new se),tabFocusMode:be(new me),layoutInfo:be(new G),wrappingInfo:be(new ge)}}),define(ve[122],_e([16,17]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[123],_e([16,17]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[124],_e([16,17]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(ve[125],_e([16,17]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(ve[126],_e([16,17]),function(ie,e){return ie.create("vs/platform/theme/common/iconRegistry",e)}),define(ve[127],_e([16,17]),function(ie,e){return ie.create("vs/platform/workspaces/common/workspaces",e)}),define(ve[128],_e([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHost.api.impl",e)}),define(ve[129],_e([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ve[130],_e([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(ve[131],_e([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ve[132],_e([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostProgress",e)}),define(ve[133],_e([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ve[134],_e([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ve[135],_e([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ve[136],_e([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ve[137],_e([16,17]),function(ie,e){return ie.create("vs/workbench/common/views",e)}),define(ve[138],_e([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ve[139],_e([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ve[140],_e([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ve[141],_e([16,17]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[142],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var E;(function(S){S[S.ACTIVATE=0]="ACTIVATE",S[S.RESTORE=1]="RESTORE",S[S.PRESERVE=2]="PRESERVE"})(E=e.EditorActivation||(e.EditorActivation={}));var k;(function(S){S[S.PICK=1]="PICK",S[S.DISABLED=2]="DISABLED"})(k=e.EditorOverride||(e.EditorOverride={}));var P;(function(S){S[S.API=0]="API",S[S.USER=1]="USER"})(P=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(S){S[S.Center=0]="Center",S[S.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",S[S.NearTop=2]="NearTop",S[S.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ve[143],_e([0,1,123]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function P(C){return C=C.trim(),C==="*"||k.test(C)}e.isValidVersionStr=P;function A(C){if(!P(C))return null;if(C=C.trim(),C==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=C.match(k);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=A;function S(C){if(!C)return null;let g=C.majorBase,f=C.majorMustEqual,r=C.minorBase,s=C.minorMustEqual,b=C.patchBase,h=C.patchMustEqual;return C.hasCaret&&(g===0||(s=!1),h=!1),{majorBase:g,majorMustEqual:f,minorBase:r,minorMustEqual:s,patchBase:b,patchMustEqual:h,isMinimum:C.hasGreaterEquals}}e.normalizeVersion=S;function D(C,g){let f;typeof C=="string"?f=S(A(C)):f=C;let r;if(typeof g=="string"?r=S(A(g)):r=g,!f||!r)return!1;let s=f.majorBase,b=f.minorBase,h=f.patchBase,_=r.majorBase,v=r.minorBase,c=r.patchBase,u=r.majorMustEqual,t=r.minorMustEqual,i=r.patchMustEqual;return r.isMinimum?s>_?!0:s<_?!1:b>v?!0:b<v?!1:h>=c:(s===1&&_===0&&(!u||!t||!i)&&(_=1,v=0,c=0,u=!0,t=!1,i=!1),s<_?!1:s>_?!u:b<v?!1:b>v?!t:h<c?!1:h>c?!i:!0)}e.isValidVersion=D;function y(C,g,f){return g.isBuiltin||typeof g.main=="undefined"?!0:T(C,g.engines.vscode,f)}e.isValidExtensionVersion=y;function n(C,g){return C==="*"||T(g,C)}e.isEngineValid=n;function T(C,g,f=[]){let r=S(A(g));if(!r)return f.push(E.localize(0,null,g)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return f.push(E.localize(1,null,g)),!1}else if(!r.majorMustEqual)return f.push(E.localize(2,null,g)),!1;return D(C,r)?!0:(f.push(E.localize(3,null,C,g)),!1)}e.isVersionValid=T}),define(ve[87],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class E{constructor(A,S=[],D=!1){this.ctor=A,this.staticArguments=S,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=E;const k=(P,...A)=>new E(P,A);e.createSyncDescriptor=k}),define(ve[61],_e([0,1,87]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const k=[];function P(S,D,y){D instanceof E.SyncDescriptor||(D=new E.SyncDescriptor(D,[],y)),k.push([S,D])}e.registerSingleton=P;function A(){return k}e.getSingletonServiceDescriptors=A}),define(ve[144],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=E;class k{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let S of this._nodes.values())S.outgoing.size===0&&A.push(S);return A}insertEdge(A,S){const D=this.lookupOrInsertNode(A),y=this.lookupOrInsertNode(S);D.outgoing.set(this._hashFn(S),y),y.incoming.set(this._hashFn(A),D)}removeNode(A){const S=this._hashFn(A);this._nodes.delete(S);for(let D of this._nodes.values())D.outgoing.delete(S),D.incoming.delete(S)}lookupOrInsertNode(A){const S=this._hashFn(A);let D=this._nodes.get(S);return D||(D=new E(A),this._nodes.set(S,D)),D}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[S,D]of this._nodes)A.push(`${S}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return A.join(`
`)}}e.Graph=k}),define(ve[4],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function y(n){return n[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=y})(E=e._util||(e._util={})),e.IInstantiationService=P("instantiationService");function k(D,y,n,T){y[E.DI_TARGET]===y?y[E.DI_DEPENDENCIES].push({id:D,index:n,optional:T}):(y[E.DI_DEPENDENCIES]=[{id:D,index:n,optional:T}],y[E.DI_TARGET]=y)}function P(D){if(E.serviceIds.has(D))return E.serviceIds.get(D);const y=function(n,T,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(y,n,C,!1)};return y.toString=()=>D,E.serviceIds.set(D,y),y}e.createDecorator=P;function A(D){return D}e.refineServiceDecorator=A;function S(D){return function(y,n,T){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");k(D,y,T,!0)}}e.optional=S}),define(ve[145],_e([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,E.createDecorator)("modelService");function k(P){return!P.isTooLargeForSyncing()&&!P.isForSimpleWidget}e.shouldSynchronizeModel=k}),define(ve[146],_e([0,1,3,56,6,22,79,59,145]),function(ie,e,E,k,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function n(g){return typeof g=="string"?!1:Array.isArray(g)?g.every(n):!!g.exclusive}class T{constructor(){this._clock=0,this._entries=[],this._onDidChange=new E.Emitter}get onDidChange(){return this._onDidChange.event}register(f,r){let s={selector:f,provider:r,_score:-1,_time:this._clock++};return this._entries.push(s),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,P.toDisposable)(()=>{if(s){let b=this._entries.indexOf(s);b>=0&&(this._entries.splice(b,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),s=void 0)}})}has(f){return this.all(f).length>0}all(f){if(!f)return[];this._updateScores(f);const r=[];for(let s of this._entries)s._score>0&&r.push(s.provider);return r}ordered(f){const r=[];return this._orderedForEach(f,s=>r.push(s.provider)),r}orderedGroups(f){const r=[];let s,b;return this._orderedForEach(f,h=>{s&&b===h._score?s.push(h.provider):(b=h._score,s=[h.provider],r.push(s))}),r}_orderedForEach(f,r){if(!!f){this._updateScores(f);for(const s of this._entries)s._score>0&&r(s)}}_updateScores(f){let r={uri:f.uri.toString(),language:f.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===r.language&&this._lastCandidate.uri===r.uri)){this._lastCandidate=r;for(let s of this._entries)if(s._score=(0,D.score)(s.selector,f.uri,f.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(f)),n(s.selector)&&s._score>0){for(let b of this._entries)b._score=0;s._score=1e3;break}this._entries.sort(T._compareByScoreAndTime)}}static _compareByScoreAndTime(f,r){return f._score<r._score?1:f._score>r._score?-1:f._time<r._time?1:f._time>r._time?-1:0}}e.LanguageFeatureRegistry=T;class C{constructor(f,r,s=Number.MAX_SAFE_INTEGER){this._registry=f,this.min=r,this.max=s,this._cache=new A.LRUCache(50,.7)}_key(f){return f.id+(0,k.hash)(this._registry.all(f))}_clamp(f){return f===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(f*1.3)))}get(f){const r=this._key(f),s=this._cache.get(r);return this._clamp(s==null?void 0:s.value)}update(f,r){const s=this._key(f);let b=this._cache.get(s);return b||(b=new S.MovingAverage,this._cache.set(s,b)),b.update(r),this.get(f)}}e.LanguageFeatureRequestDelays=C}),define(ve[62],_e([0,1,2,32,146,117,36]),function(ie,e,E,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var D;(function(p){p[p.Null=0]="Null",p[p.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));class y{constructor(m,R){this.language=m,this.id=R}}e.LanguageIdentifier=y;var n;(function(p){p[p.NotSet=-1]="NotSet",p[p.None=0]="None",p[p.Italic=1]="Italic",p[p.Bold=2]="Bold",p[p.Underline=4]="Underline"})(n=e.FontStyle||(e.FontStyle={}));var T;(function(p){p[p.None=0]="None",p[p.DefaultForeground=1]="DefaultForeground",p[p.DefaultBackground=2]="DefaultBackground"})(T=e.ColorId||(e.ColorId={}));var C;(function(p){p[p.Other=0]="Other",p[p.Comment=1]="Comment",p[p.String=2]="String",p[p.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var g;(function(p){p[p.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",p[p.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",p[p.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",p[p.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",p[p.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",p[p.ITALIC_MASK=2048]="ITALIC_MASK",p[p.BOLD_MASK=4096]="BOLD_MASK",p[p.UNDERLINE_MASK=8192]="UNDERLINE_MASK",p[p.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",p[p.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",p[p.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",p[p.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",p[p.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",p[p.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",p[p.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",p[p.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",p[p.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",p[p.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(g=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(m){return(m&255)>>>0}static getTokenType(m){return(m&1792)>>>8}static getFontStyle(m){return(m&14336)>>>11}static getForeground(m){return(m&8372224)>>>14}static getBackground(m){return(m&4286578688)>>>23}static getClassNameFromMetadata(m){let R=this.getForeground(m),F="mtk"+R,x=this.getFontStyle(m);return x&1&&(F+=" mtki"),x&2&&(F+=" mtkb"),x&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(m,R){const F=this.getForeground(m),x=this.getFontStyle(m);let ae=`color: ${R[F]};`;return x&1&&(ae+="font-style: italic;"),x&2&&(ae+="font-weight: bold;"),x&4&&(ae+="text-decoration: underline;"),ae}}e.TokenMetadata=f;var r;(function(p){p[p.Method=0]="Method",p[p.Function=1]="Function",p[p.Constructor=2]="Constructor",p[p.Field=3]="Field",p[p.Variable=4]="Variable",p[p.Class=5]="Class",p[p.Struct=6]="Struct",p[p.Interface=7]="Interface",p[p.Module=8]="Module",p[p.Property=9]="Property",p[p.Event=10]="Event",p[p.Operator=11]="Operator",p[p.Unit=12]="Unit",p[p.Value=13]="Value",p[p.Constant=14]="Constant",p[p.Enum=15]="Enum",p[p.EnumMember=16]="EnumMember",p[p.Keyword=17]="Keyword",p[p.Text=18]="Text",p[p.Color=19]="Color",p[p.File=20]="File",p[p.Reference=21]="Reference",p[p.Customcolor=22]="Customcolor",p[p.Folder=23]="Folder",p[p.TypeParameter=24]="TypeParameter",p[p.User=25]="User",p[p.Issue=26]="Issue",p[p.Snippet=27]="Snippet"})(r=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let p=Object.create(null);return p[0]="symbol-method",p[1]="symbol-function",p[2]="symbol-constructor",p[3]="symbol-field",p[4]="symbol-variable",p[5]="symbol-class",p[6]="symbol-struct",p[7]="symbol-interface",p[8]="symbol-module",p[9]="symbol-property",p[10]="symbol-event",p[11]="symbol-operator",p[12]="symbol-unit",p[13]="symbol-value",p[14]="symbol-constant",p[15]="symbol-enum",p[16]="symbol-enum-member",p[17]="symbol-keyword",p[27]="symbol-snippet",p[18]="symbol-text",p[19]="symbol-color",p[20]="symbol-file",p[21]="symbol-reference",p[22]="symbol-customcolor",p[23]="symbol-folder",p[24]="symbol-type-parameter",p[25]="account",p[26]="issues",function(m){const R=p[m];let F=R&&S.iconRegistry.get(R);return F||(console.info("No codicon found for CompletionItemKind "+m),F=S.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let p=Object.create(null);return p.method=0,p.function=1,p.constructor=2,p.field=3,p.variable=4,p.class=5,p.struct=6,p.interface=7,p.module=8,p.property=9,p.event=10,p.operator=11,p.unit=12,p.value=13,p.constant=14,p.enum=15,p["enum-member"]=16,p.enumMember=16,p.keyword=17,p.snippet=27,p.text=18,p.color=19,p.file=20,p.reference=21,p.customcolor=22,p.folder=23,p["type-parameter"]=24,p.typeParameter=24,p.account=25,p.issue=26,function(m,R){let F=p[m];return typeof F=="undefined"&&!R&&(F=9),F}}();var s;(function(p){p[p.Deprecated=1]="Deprecated"})(s=e.CompletionItemTag||(e.CompletionItemTag={}));var b;(function(p){p[p.KeepWhitespace=1]="KeepWhitespace",p[p.InsertAsSnippet=4]="InsertAsSnippet"})(b=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var h;(function(p){p[p.Invoke=0]="Invoke",p[p.TriggerCharacter=1]="TriggerCharacter",p[p.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(p){p[p.Invoke=1]="Invoke",p[p.Auto=2]="Auto"})(_=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var v;(function(p){p[p.Invoke=1]="Invoke",p[p.TriggerCharacter=2]="TriggerCharacter",p[p.ContentChange=3]="ContentChange"})(v=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var c;(function(p){p[p.Text=0]="Text",p[p.Read=1]="Read",p[p.Write=2]="Write"})(c=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function u(p){return p&&E.URI.isUri(p.uri)&&k.Range.isIRange(p.range)&&(k.Range.isIRange(p.originSelectionRange)||k.Range.isIRange(p.targetSelectionRange))}e.isLocationLink=u;var t;(function(p){p[p.File=0]="File",p[p.Module=1]="Module",p[p.Namespace=2]="Namespace",p[p.Package=3]="Package",p[p.Class=4]="Class",p[p.Method=5]="Method",p[p.Property=6]="Property",p[p.Field=7]="Field",p[p.Constructor=8]="Constructor",p[p.Enum=9]="Enum",p[p.Interface=10]="Interface",p[p.Function=11]="Function",p[p.Variable=12]="Variable",p[p.Constant=13]="Constant",p[p.String=14]="String",p[p.Number=15]="Number",p[p.Boolean=16]="Boolean",p[p.Array=17]="Array",p[p.Object=18]="Object",p[p.Key=19]="Key",p[p.Null=20]="Null",p[p.EnumMember=21]="EnumMember",p[p.Struct=22]="Struct",p[p.Event=23]="Event",p[p.Operator=24]="Operator",p[p.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var i;(function(p){p[p.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var d;(function(p){const m=new Map;m.set("file",0),m.set("module",1),m.set("namespace",2),m.set("package",3),m.set("class",4),m.set("method",5),m.set("property",6),m.set("field",7),m.set("constructor",8),m.set("enum",9),m.set("interface",10),m.set("function",11),m.set("variable",12),m.set("constant",13),m.set("string",14),m.set("number",15),m.set("boolean",16),m.set("array",17),m.set("object",18),m.set("key",19),m.set("null",20),m.set("enum-member",21),m.set("struct",22),m.set("event",23),m.set("operator",24),m.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function F(z){return m.get(z)}p.fromString=F;function x(z){return R.get(z)}p.toString=x;function ae(z,B){const G=R.get(z);let M=G&&S.iconRegistry.get("symbol-"+G);return M||(console.info("No codicon found for SymbolKind "+z),M=S.Codicon.symbolProperty),`${B?"inline":"block"} ${M.classNames}`}p.toCssClassName=ae})(d=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(m){this.value=m}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var l;(function(p){p[p.Collapsed=0]="Collapsed",p[p.Expanded=1]="Expanded"})(l=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var o;(function(p){p[p.Editing=0]="Editing",p[p.Preview=1]="Preview"})(o=e.CommentMode||(e.CommentMode={}));var w;(function(p){p[p.Other=0]="Other",p[p.Type=1]="Type",p[p.Parameter=2]="Parameter"})(w=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new P.LanguageFeatureRegistry,e.RenameProviderRegistry=new P.LanguageFeatureRegistry,e.CompletionProviderRegistry=new P.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new P.LanguageFeatureRegistry,e.HoverProviderRegistry=new P.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new P.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new P.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new P.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new P.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new P.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new P.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new P.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new P.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new P.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new P.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new P.LanguageFeatureRegistry,e.LinkProviderRegistry=new P.LanguageFeatureRegistry,e.ColorProviderRegistry=new P.LanguageFeatureRegistry,e.SelectionRangeRegistry=new P.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new P.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var I;(function(p){p[p.None=0]="None",p[p.Option=1]="Option",p[p.Default=2]="Default",p[p.Preferred=3]="Preferred"})(I=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[147],_e([0,1,6,13,4,3,44,54]),function(ie,e,E,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,P.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new A.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(y,n){if(!y)throw new Error("invalid command");if(typeof y=="string"){if(!n)throw new Error("invalid command");return this.registerCommand({id:y,handler:n})}if(y.description){const r=[];for(let b of y.description.args)r.push(b.constraint);const s=y.handler;y.handler=function(b,...h){return(0,k.validateConstraints)(h,r),s(b,...h)}}const{id:T}=y;let C=this._commands.get(T);C||(C=new S.LinkedList,this._commands.set(T,C));let g=C.unshift(y),f=(0,E.toDisposable)(()=>{g();const r=this._commands.get(T);(r==null?void 0:r.isEmpty())&&this._commands.delete(T)});return this._onDidRegisterCommand.fire(T),f}registerCommandAlias(y,n){return e.CommandsRegistry.registerCommand(y,(T,...C)=>T.get(e.ICommandService).executeCommand(n,...C))}getCommand(y){const n=this._commands.get(y);if(!(!n||n.isEmpty()))return D.Iterable.first(n)}getCommands(){const y=new Map;for(const n of this._commands.keys()){const T=this.getCommand(n);T&&y.set(n,T)}return y}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>E.Disposable.None,onDidExecuteCommand:()=>E.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(ve[63],_e([0,1,8,4,21]),function(ie,e,E,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=P.userAgent||"";const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",P.isMacintosh),S.set("isLinux",P.isLinux),S.set("isWindows",P.isWindows),S.set("isWeb",P.isWeb),S.set("isMacNative",P.isMacintosh&&!P.isWeb),S.set("isEdge",A.indexOf("Edg/")>=0),S.set("isFirefox",A.indexOf("Firefox")>=0),S.set("isChrome",A.indexOf("Chrome")>=0),S.set("isSafari",A.indexOf("Safari")>=0),S.set("isIPad",A.indexOf("iPad")>=0);const D=Object.prototype.hasOwnProperty;var y;(function(p){p[p.False=0]="False",p[p.True=1]="True",p[p.Defined=2]="Defined",p[p.Not=3]="Not",p[p.Equals=4]="Equals",p[p.NotEquals=5]="NotEquals",p[p.And=6]="And",p[p.Regex=7]="Regex",p[p.NotRegex=8]="NotRegex",p[p.Or=9]="Or",p[p.In=10]="In",p[p.NotIn=11]="NotIn",p[p.Greater=12]="Greater",p[p.GreaterEquals=13]="GreaterEquals",p[p.Smaller=14]="Smaller",p[p.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class n{static false(){return C.INSTANCE}static true(){return g.INSTANCE}static has(m){return f.create(m)}static equals(m,R){return r.create(m,R)}static notEquals(m,R){return h.create(m,R)}static regex(m,R){return i.create(m,R)}static in(m,R){return s.create(m,R)}static not(m){return _.create(m)}static and(...m){return a.create(m)}static or(...m){return l.create(m)}static greater(m,R){return v.create(m,R)}static less(m,R){return u.create(m,R)}static deserialize(m,R=!1){if(!!m)return this._deserializeOrExpression(m,R)}static _deserializeOrExpression(m,R){let F=m.split("||");return l.create(F.map(x=>this._deserializeAndExpression(x,R)))}static _deserializeAndExpression(m,R){let F=m.split("&&");return a.create(F.map(x=>this._deserializeOne(x,R)))}static _deserializeOne(m,R){if(m=m.trim(),m.indexOf("!=")>=0){let F=m.split("!=");return h.create(F[0].trim(),this._deserializeValue(F[1],R))}if(m.indexOf("==")>=0){let F=m.split("==");return r.create(F[0].trim(),this._deserializeValue(F[1],R))}if(m.indexOf("=~")>=0){let F=m.split("=~");return i.create(F[0].trim(),this._deserializeRegexValue(F[1],R))}if(m.indexOf(" in ")>=0){let F=m.split(" in ");return s.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(m)){const F=m.split(">=");return c.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(m)){const F=m.split(">");return v.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(m)){const F=m.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(m)){const F=m.split("<");return u.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(m)?_.create(m.substr(1).trim()):f.create(m)}static _deserializeValue(m,R){if(m=m.trim(),m==="true")return!0;if(m==="false")return!1;let F=/^'([^']*)'$/.exec(m);return F?F[1].trim():m}static _deserializeRegexValue(m,R){if((0,E.isFalsyOrWhitespace)(m)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=m.indexOf("/"),x=m.lastIndexOf("/");if(F===x||F<0){if(R)throw new Error(`bad regexp-value '${m}', missing /-enclosure`);return console.warn(`bad regexp-value '${m}', missing /-enclosure`),null}let ae=m.slice(F+1,x),z=m[x+1]==="i"?"i":"";try{return new RegExp(ae,z)}catch(B){if(R)throw new Error(`bad regexp-value '${m}', parse error: ${B}`);return console.warn(`bad regexp-value '${m}', parse error: ${B}`),null}}}e.ContextKeyExpr=n;function T(p,m){return p.cmp(m)}class C{constructor(){this.type=0}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}evaluate(m){return!1}serialize(){return"false"}keys(){return[]}map(m){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class g{constructor(){this.type=1}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}evaluate(m){return!0}serialize(){return"true"}keys(){return[]}map(m){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class f{constructor(m){this.key=m,this.type=2}static create(m){const R=S.get(m);return typeof R=="boolean"?R?g.INSTANCE:C.INSTANCE:new f(m)}cmp(m){return m.type!==this.type?this.type-m.type:w(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}evaluate(m){return!!m.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(m){return m.mapDefined(this.key)}negate(){return _.create(this.key)}}e.ContextKeyDefinedExpr=f;class r{constructor(m,R){this.key=m,this.value=R,this.type=4}static create(m,R){if(typeof R=="boolean")return R?f.create(m):_.create(m);const F=S.get(m);return typeof F=="boolean"?R===(F?"true":"false")?g.INSTANCE:C.INSTANCE:new r(m,R)}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return m.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(m){return m.mapEquals(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeyEqualsExpr=r;class s{constructor(m,R){this.key=m,this.valueKey=R,this.type=10}static create(m,R){return new s(m,R)}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.valueKey,m.key,m.valueKey)}equals(m){return m.type===this.type?this.key===m.key&&this.valueKey===m.valueKey:!1}evaluate(m){const R=m.getValue(this.valueKey),F=m.getValue(this.key);return Array.isArray(R)?R.indexOf(F)>=0:typeof F=="string"&&typeof R=="object"&&R!==null?D.call(R,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(m){return m.mapIn(this.key,this.valueKey)}negate(){return b.create(this)}}e.ContextKeyInExpr=s;class b{constructor(m){this._actual=m,this.type=11}static create(m){return new b(m)}cmp(m){return m.type!==this.type?this.type-m.type:this._actual.cmp(m._actual)}equals(m){return m.type===this.type?this._actual.equals(m._actual):!1}evaluate(m){return!this._actual.evaluate(m)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(m){return new b(this._actual.map(m))}negate(){return this._actual}}e.ContextKeyNotInExpr=b;class h{constructor(m,R){this.key=m,this.value=R,this.type=5}static create(m,R){if(typeof R=="boolean")return R?_.create(m):f.create(m);const F=S.get(m);return typeof F=="boolean"?R===(F?"true":"false")?C.INSTANCE:g.INSTANCE:new h(m,R)}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return m.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(m){return m.mapNotEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=h;class _{constructor(m){this.key=m,this.type=3}static create(m){const R=S.get(m);return typeof R=="boolean"?R?C.INSTANCE:g.INSTANCE:new _(m)}cmp(m){return m.type!==this.type?this.type-m.type:w(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}evaluate(m){return!m.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(m){return m.mapNot(this.key)}negate(){return f.create(this.key)}}e.ContextKeyNotExpr=_;class v{constructor(m,R){this.key=m,this.value=R,this.type=12}static create(m,R){return new v(m,R)}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=v;class c{constructor(m,R){this.key=m,this.value=R,this.type=13}static create(m,R){return new c(m,R)}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreaterEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=c;class u{constructor(m,R){this.key=m,this.value=R,this.type=14}static create(m,R){return new u(m,R)}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmaller(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerExpr=u;class t{constructor(m,R){this.key=m,this.value=R,this.type=15}static create(m,R){return new t(m,R)}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmallerEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(m,R){this.key=m,this.regexp=R,this.type=7}static create(m,R){return new i(m,R)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.key<m.key)return-1;if(this.key>m.key)return 1;const R=this.regexp?this.regexp.source:"",F=m.regexp?m.regexp.source:"";return R<F?-1:R>F?1:0}equals(m){if(m.type===this.type){const R=this.regexp?this.regexp.source:"",F=m.regexp?m.regexp.source:"";return this.key===m.key&&R===F}return!1}evaluate(m){let R=m.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const m=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${m}`}keys(){return[this.key]}map(m){return m.mapRegex(this.key,this.regexp)}negate(){return d.create(this)}}e.ContextKeyRegexExpr=i;class d{constructor(m){this._actual=m,this.type=8}static create(m){return new d(m)}cmp(m){return m.type!==this.type?this.type-m.type:this._actual.cmp(m._actual)}equals(m){return m.type===this.type?this._actual.equals(m._actual):!1}evaluate(m){return!this._actual.evaluate(m)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(m){return new d(this._actual.map(m))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=d;class a{constructor(m){this.expr=m,this.type=6}static create(m){return a._normalizeArr(m)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let R=0,F=this.expr.length;R<F;R++){const x=T(this.expr[R],m.expr[R]);if(x!==0)return x}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].equals(m.expr[R]))return!1;return!0}return!1}evaluate(m){for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].evaluate(m))return!1;return!0}static _normalizeArr(m){const R=[];let F=!1;for(const x of m)if(!!x){if(x.type===1){F=!0;continue}if(x.type===0)return C.INSTANCE;if(x.type===6){R.push(...x.expr);continue}R.push(x)}if(R.length===0&&F)return g.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(T);R.length>1;){const x=R[R.length-1];if(x.type!==9)break;R.pop();const ae=R.pop(),z=l.create(x.expr.map(B=>a.create([B,ae])));z&&(R.push(z),R.sort(T))}return R.length===1?R[0]:new a(R)}}serialize(){return this.expr.map(m=>m.serialize()).join(" && ")}keys(){const m=[];for(let R of this.expr)m.push(...R.keys());return m}map(m){return new a(this.expr.map(R=>R.map(m)))}negate(){let m=[];for(let R of this.expr)m.push(R.negate());return l.create(m)}}e.ContextKeyAndExpr=a;class l{constructor(m){this.expr=m,this.type=9}static create(m){const R=l._normalizeArr(m);if(R.length!==0)return R.length===1?R[0]:new l(R)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let R=0,F=this.expr.length;R<F;R++){const x=T(this.expr[R],m.expr[R]);if(x!==0)return x}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].equals(m.expr[R]))return!1;return!0}return!1}evaluate(m){for(let R=0,F=this.expr.length;R<F;R++)if(this.expr[R].evaluate(m))return!0;return!1}static _normalizeArr(m){let R=[],F=!1;if(m){for(let x=0,ae=m.length;x<ae;x++){const z=m[x];if(!!z){if(z.type===0){F=!0;continue}if(z.type===1)return[g.INSTANCE];if(z.type===9){R=R.concat(z.expr);continue}R.push(z)}}if(R.length===0&&F)return[C.INSTANCE];R.sort(T)}return R}serialize(){return this.expr.map(m=>m.serialize()).join(" || ")}keys(){const m=[];for(let R of this.expr)m.push(...R.keys());return m}map(m){return new l(this.expr.map(R=>R.map(m)))}negate(){let m=[];for(let F of this.expr)m.push(F.negate());const R=F=>F.type===9?F.expr:[F];for(;m.length>1;){const F=m.shift(),x=m.shift(),ae=[];for(const z of R(F))for(const B of R(x))ae.push(n.and(z,B));m.unshift(n.or(...ae))}return m[0]}}e.ContextKeyOrExpr=l;class o extends f{constructor(m,R,F){super(m);this._defaultValue=R,typeof F=="object"?o._info.push(Object.assign(Object.assign({},F),{key:m})):F!==!0&&o._info.push({key:m,description:F,type:R!=null?typeof R:void 0})}static all(){return o._info.values()}bindTo(m){return m.createKey(this.key,this._defaultValue)}getValue(m){return m.getContextKeyValue(this.key)}toNegated(){return n.not(this.key)}isEqualTo(m){return n.equals(this.key,m)}notEqualsTo(m){return n.notEquals(this.key,m)}}e.RawContextKey=o,o._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function w(p,m){return p<m?-1:p>m?1:0}function I(p,m,R,F){return p<R?-1:p>R?1:m<F?-1:m>F?1:0}}),define(ve[148],_e([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[26],_e([0,1,8,4]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function P(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=P,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class S{constructor(T){this.value=T,this._lower=T.toLowerCase()}static equals(T,C){if(typeof T=="undefined"||T===null)return typeof C=="undefined"||C===null;if(typeof C=="undefined"||C===null)return!1;if(typeof T=="string"||typeof C=="string"){let g=typeof T=="string"?T:T.value,f=typeof C=="string"?C:C.value;return E.equalsIgnoreCase(g,f)}return T._lower===C._lower}static toKey(T){return typeof T=="string"?T.toLowerCase():T._lower}}e.ExtensionIdentifier=S;function D(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function y(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[149],_e([0,1,8,26]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function P(f,r){return f.uuid&&r.uuid?f.uuid===r.uuid:f.id===r.id?!0:(0,E.compareIgnoreCase)(f.id,r.id)===0}e.areSameExtensions=P;class A{constructor(r,s){this.version=s,this.id=r.id,this.uuid=r.uuid}key(){return`${this.id}-${this.version}`}equals(r){return r instanceof A?P(this,r)&&this.version===r.version:!1}}e.ExtensionIdentifierWithVersion=A;function S(f,r){return`${f}.${r}`}e.getExtensionId=S;function D(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function y(f,r){return D(S(f,r))}e.getGalleryExtensionId=y;function n(f,r){const s=[],b=h=>{for(const _ of s)if(_.some(v=>P(r(v),r(h))))return _;return null};for(const h of f){const _=b(h);_?_.push(h):s.push([h])}return s}e.groupByExtension=n;function T(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=T;function C(f){return Object.assign({id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0)},f.telemetryData)}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function g(f){const r=new Set;for(const s of f)s.malicious&&r.add(s.id.id);return r}e.getMaliciousExtensionsSet=g}),define(ve[64],_e([0,1,124,12,2,4,8,13,22]),function(ie,e,E,k,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,A.createDecorator)("fileService");function n(z){return z.create===!0}e.isFileOpenForWriteOptions=n;var T;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(T=e.FileType||(e.FileType={}));var C;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=g;function f(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=f;function r(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=r;function s(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=s;var b;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(B,G){super(B);this.code=G}}e.FileSystemProviderError=h;function _(z,B){const G=new h(z.toString(),B);return c(G,B),G}e.createFileSystemProviderError=_;function v(z){return z||_((0,E.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=v;function c(z,B){return z.name=B?`${B} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=c;function u(z){if(!z)return b.Unknown;if(z instanceof h)return z.code;const B=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!B)return b.Unknown;switch(B[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=u;function t(z){if(z instanceof w)return z.fileOperationResult;switch(u(z)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var i;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class d{constructor(B,G,M){this.resource=B,this.operation=G,this.target=M}isOperation(B){return this.operation===B}}e.FileOperationEvent=d;var a;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class l{constructor(B,G){this.ignorePathCasing=G,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=B;for(const M of B)switch(M.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(M.resource,M);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(M.resource,M);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(M.resource,M);break}}contains(B,...G){return this.doContains(B,{includeChildren:!1},...G)}affects(B,...G){return this.doContains(B,{includeChildren:!0},...G)}doContains(B,G,...M){var N,W,Q,$,Z,re;if(!B)return!1;const se=M.length>0;return!!((!se||M.includes(1))&&(((N=this.added)===null||N===void 0?void 0:N.get(B))||G.includeChildren&&((W=this.added)===null||W===void 0?void 0:W.findSuperstr(B)))||(!se||M.includes(0))&&(((Q=this.updated)===null||Q===void 0?void 0:Q.get(B))||G.includeChildren&&(($=this.updated)===null||$===void 0?void 0:$.findSuperstr(B)))||(!se||M.includes(2))&&(((Z=this.deleted)===null||Z===void 0?void 0:Z.findSubstr(B))||G.includeChildren&&((re=this.deleted)===null||re===void 0?void 0:re.findSuperstr(B))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(B){const G=[],M=B===1?this.added:B===0?this.updated:this.deleted;if(M)for(const[,N]of M)G.push(N);return G}filter(B){return new l(this.changes.filter(G=>B(G)),this.ignorePathCasing)}}e.FileChangesEvent=l;function o(z,B,G){return!z||!B||z===B||B.length>z.length?!1:(B.charAt(B.length-1)!==k.sep&&(B+=k.sep),G?(0,S.startsWithIgnoreCase)(z,B):z.indexOf(B)===0)}e.isParent=o;class w extends Error{constructor(B,G,M){super(B);this.fileOperationResult=G,this.options=M}static isFileOperationError(B){return B instanceof Error&&!(0,D.isUndefinedOrNull)(B.fileOperationResult)}}e.FileOperationError=w;var I;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(I=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var p;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(p=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function m(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=m;async function R(z,B){if(!B.canHandleResource(P.URI.from({scheme:z.scheme})))return new Promise(G=>{const M=B.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===z.scheme&&N.added&&(M.dispose(),G())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(B){return(0,D.isNumber)(B)||(B=0),B<F.KB?(0,E.localize)(1,null,B.toFixed(0)):B<F.MB?(0,E.localize)(2,null,(B/F.KB).toFixed(2)):B<F.GB?(0,E.localize)(3,null,(B/F.MB).toFixed(2)):B<F.TB?(0,E.localize)(4,null,(B/F.GB).toFixed(2)):(0,E.localize)(5,null,(B/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var x;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(x=e.Arch||(e.Arch={}));function ae(z){return{maxFileSize:z===0?300*F.MB:16*F.GB,maxHeapSize:z===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=ae}),define(ve[65],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...P){this._entries=new Map;for(let[A,S]of P)this.set(A,S)}set(P,A){const S=this._entries.get(P);return this._entries.set(P,A),S}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}e.ServiceCollection=E}),define(ve[150],_e([0,1,10,144,87,4,65,14]),function(ie,e,E,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class n extends Error{constructor(r){super("cyclic dependency between services");this.message=r.toString()}}class T{constructor(r=new S.ServiceCollection,s=!1,b){this._activeInstantiations=new Set,this._services=r,this._strict=s,this._parent=b,this._services.set(A.IInstantiationService,this)}createChild(r){return new T(r,this._strict,this)}invokeFunction(r,...s){let b=g.traceInvocation(r),h=!1;try{return r({get:(v,c)=>{if(h)throw(0,E.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(v,b);if(!u&&c!==A.optional)throw new Error(`[invokeFunction] unknown service '${v}'`);return u}},...s)}finally{h=!0,b.stop()}}createInstance(r,...s){let b,h;return r instanceof P.SyncDescriptor?(b=g.traceCreation(r.ctor),h=this._createInstance(r.ctor,r.staticArguments.concat(s),b)):(b=g.traceCreation(r),h=this._createInstance(r,s,b)),b.stop(),h}_createInstance(r,s=[],b){let h=A._util.getServiceDependencies(r).sort((c,u)=>c.index-u.index),_=[];for(const c of h){let u=this._getOrCreateServiceInstance(c.id,b);if(!u&&this._strict&&!c.optional)throw new Error(`[createInstance] ${r.name} depends on UNKNOWN service ${c.id}.`);_.push(u)}let v=h.length>0?h[0].index:s.length;if(s.length!==v){console.warn(`[createInstance] First service dependency of ${r.name} at position ${v+1} conflicts with ${s.length} static arguments`);let c=v-s.length;c>0?s=s.concat(new Array(c)):s=s.slice(0,v)}return new r(...[...s,..._])}_setServiceInstance(r,s){if(this._services.get(r)instanceof P.SyncDescriptor)this._services.set(r,s);else if(this._parent)this._parent._setServiceInstance(r,s);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){let s=this._services.get(r);return!s&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):s}_getOrCreateServiceInstance(r,s){let b=this._getServiceInstanceOrDescriptor(r);return b instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,b,s.branch(r,!0)):(s.branch(r,!1),b)}_safeCreateAndCacheServiceInstance(r,s,b){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,s,b)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,s,b){const h=new k.Graph(c=>c.id.toString());let _=0;const v=[{id:r,desc:s,_trace:b}];for(;v.length;){const c=v.pop();if(h.lookupOrInsertNode(c),_++>1e3)throw new n(h);for(let u of A._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(u.id);if(!t&&!u.optional&&console.warn(`[createInstance] ${r} depends on ${u.id} which is NOT registered.`),t instanceof P.SyncDescriptor){const i={id:u.id,desc:t,_trace:c._trace.branch(u.id,!0)};h.insertEdge(c,i),v.push(i)}}}for(;;){const c=h.roots();if(c.length===0){if(!h.isEmpty())throw new n(h);break}for(const{data:u}of c){if(this._getServiceInstanceOrDescriptor(u.id)instanceof P.SyncDescriptor){const i=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,i)}h.removeNode(u)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,s,b=[],h,_){if(this._services.get(r)instanceof P.SyncDescriptor)return this._createServiceInstance(s,b,h,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,s,b,h,_);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}_createServiceInstance(r,s=[],b,h){if(b){const _=new D.IdleValue(()=>this._createInstance(r,s,h));return new Proxy(Object.create(null),{get(v,c){if(c in v)return v[c];let u=_.value,t=u[c];return typeof t!="function"||(t=t.bind(u),v[c]=t),t},set(v,c,u){return _.value[c]=u,!0}})}else return this._createInstance(r,s,h)}}e.InstantiationService=T;var C;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(C||(C={}));class g{constructor(r,s){this.type=r,this.name=s,this._start=Date.now(),this._dep=[]}static traceInvocation(r){return y?new g(1,r.name||r.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(r){return y?new g(0,r.name):g._None}branch(r,s){let b=new g(2,r.toString());return this._dep.push([r,s,b]),b}stop(){let r=Date.now()-this._start;g._totals+=r;let s=!1;function b(_,v){let c=[],u=new Array(_+1).join("	");for(const[t,i,d]of v._dep)if(i&&d){s=!0,c.push(`${u}CREATES -> ${t}`);let a=b(_+1,d);a&&c.push(a)}else c.push(`${u}uses -> ${t}`);return c.join(`
`)}let h=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(r>2||s)&&console.log(h.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(ve[19],_e([0,1,4,6,21,3,60]),function(ie,e,E,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function D(){return new Date().toISOString()}var y;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class n extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=n;class T extends n{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(y.Error))if(t instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=t.stack,this.log(y.Error,this.format(d))}else this.log(y.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let d=0;d<t.length;d++){let a=t[d];if(typeof a=="object")try{a=JSON.stringify(a)}catch(l){}i+=(d>0?" ":"")+a}return i}}e.AbstractMessageLogger=T;class C extends n{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!P.isWindows}trace(t,...i){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...i):console.log(`[main ${D()}]`,t,...i))}debug(t,...i){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...i):console.log(`[main ${D()}]`,t,...i))}info(t,...i){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...i):console.log(`[main ${D()}]`,t,...i))}warn(t,...i){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,t,...i):console.warn(`[main ${D()}]`,t,...i))}error(t,...i){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,t,...i):console.error(`[main ${D()}]`,t,...i))}critical(t,...i){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,t,...i):console.error(`[main ${D()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class g extends n{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=g;class f extends n{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,S.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class r extends n{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const d of this.logServices)d.trace(t,...i)}debug(t,...i){for(const d of this.logServices)d.debug(t,...i)}info(t,...i){for(const d of this.logServices)d.info(t,...i)}warn(t,...i){for(const d of this.logServices)d.warn(t,...i)}error(t,...i){for(const d of this.logServices)d.error(t,...i)}critical(t,...i){for(const d of this.logServices)d.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=r;class s extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=s;class b extends k.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(d=>{this.logLevel=d,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(d))}))}createLogger(t,i){let d=this.loggers.get(t.toString());return d||(d=this.doCreateLogger(t,(i==null?void 0:i.always)?y.Trace:this.logLevel,i),this.loggers.set(t.toString(),d),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(d)),d}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class h{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=h;function _(u){if(u.verbose)return y.Trace;if(typeof u.logLevel=="string"){const t=v(u.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=_;function v(u){switch(u){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=v;function c(u){switch(u){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=c}),define(ve[88],_e([0,1,4,125,46]),function(ie,e,E,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var S;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(S=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function n(r,s){return s-r}y.compare=n;const T=Object.create(null);T[y.Error]=(0,k.localize)(0,null),T[y.Warning]=(0,k.localize)(1,null),T[y.Info]=(0,k.localize)(2,null);function C(r){return T[r]||""}y.toString=C;function g(r){switch(r){case P.default.Error:return y.Error;case P.default.Warning:return y.Warning;case P.default.Info:return y.Info;case P.default.Ignore:return y.Hint}}y.fromSeverity=g;function f(r){switch(r){case y.Error:return P.default.Error;case y.Warning:return P.default.Warning;case y.Info:return P.default.Info;case y.Hint:return P.default.Ignore}}y.toSeverity=f}(S=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(y){const n="";function T(g){return C(g,!0)}y.makeKey=T;function C(g,f){let r=[n];return g.source?r.push(g.source.replace("\xA6","\\\xA6")):r.push(n),g.code?typeof g.code=="string"?r.push(g.code.replace("\xA6","\\\xA6")):r.push(g.code.value.replace("\xA6","\\\xA6")):r.push(n),g.severity!==void 0&&g.severity!==null?r.push(S.toString(g.severity)):r.push(n),g.message&&f?r.push(g.message.replace("\xA6","\\\xA6")):r.push(n),g.startLineNumber!==void 0&&g.startLineNumber!==null?r.push(g.startLineNumber.toString()):r.push(n),g.startColumn!==void 0&&g.startColumn!==null?r.push(g.startColumn.toString()):r.push(n),g.endLineNumber!==void 0&&g.endLineNumber!==null?r.push(g.endLineNumber.toString()):r.push(n),g.endColumn!==void 0&&g.endColumn!==null?r.push(g.endColumn.toString()):r.push(n),r.push(n),r.join("\xA6")}y.makeKeyOptionalMessage=C})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(ve[151],_e([0,1,46,4,3]),function(ie,e,E,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=E.default,e.INotificationService=(0,k.createDecorator)("notificationService");var A;(function(n){n[n.WORKSPACE=0]="WORKSPACE",n[n.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var S;(function(n){n[n.OFF=0]="OFF",n[n.SILENT=1]="SILENT",n[n.ERROR=2]="ERROR"})(S=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new y,this.onDidClose=P.Event.None,this.onDidChangeVisibility=P.Event.None}updateSeverity(T){}updateMessage(T){}updateActions(T){}close(){}}e.NoOpNotification=D;class y{infinite(){}done(){}total(T){}worked(T){}}e.NoOpProgress=y});var je=this&&this.__decorate||function(ie,e,E,k){var P=arguments.length,A=P<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,E):k,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ie,e,E,k);else for(var D=ie.length-1;D>=0;D--)(S=ie[D])&&(A=(P<3?S(A):P>3?S(e,E,A):S(e,E))||A);return P>3&&A&&Object.defineProperty(e,E,A),A},Ke=this&&this.__param||function(ie,e){return function(E,k){e(E,k,ie)}};define(ve[152],_e([0,1,4,20,6,14]),function(ie,e,E,k,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,E.createDecorator)("progressService");var S;(function(T){T[T.Explorer=1]="Explorer",T[T.Scm=3]="Scm",T[T.Extensions=5]="Extensions",T[T.Window=10]="Window",T[T.Notification=15]="Notification",T[T.Dialog=20]="Dialog"})(S=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let y=class extends P.Disposable{constructor(C,g){super();this.deferred=new A.DeferredPromise,g.withProgress(C,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,P.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};y=je([Ke(1,e.IProgressService)],y),e.UnmanagedProgress=y;class n extends P.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new P.DisposableStore)}start(C){this.stop();const g=++this.currentOperationId,f=new k.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{g===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,P.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,P.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,P.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:g,token:f.token,stop:()=>this.doStop(g),isCurrent:()=>this.currentOperationId===g}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=n,e.IEditorProgressService=(0,E.createDecorator)("editorProgressService")}),define(ve[30],_e([0,1,13,42]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.data=new Map}add(S,D){k.ok(E.isString(S)),k.ok(E.isObject(D)),k.ok(!this.data.has(S),"There is already an extension with this id"),this.data.set(S,D)}knows(S){return this.data.has(S)}as(S){return this.data.get(S)||null}}e.Registry=new P}),define(ve[89],_e([0,1,30,3]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class A{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,n){this.schemasById[P(y)]=n,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const S=new A;E.Registry.add(e.Extensions.JSONContribution,S)}),define(ve[66],_e([0,1,122,3,30,13,89]),function(ie,e,E,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=P.Registry.as(S.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:E.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(h,_=!0){this.registerConfigurations([h],_)}registerConfigurations(h,_=!0){const v=[];h.forEach(c=>{v.push(...this.validateAndRegisterProperties(c,_,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterConfigurations(h){const _=[],v=c=>{if(c.properties)for(const u in c.properties)_.push(u),delete this.configurationProperties[u],this.removeFromSchema(u,c.properties[u]);c.allOf&&c.allOf.forEach(u=>v(u))};for(const c of h){v(c);const u=this.configurationContributors.indexOf(c);u!==-1&&this.configurationContributors.splice(u,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}registerDefaultConfigurations(h){const _=[],v=[];for(const c of h)for(const u in c)if(_.push(u),e.OVERRIDE_PROPERTY_PATTERN.test(u)){this.defaultValues[u]=Object.assign(Object.assign({},this.defaultValues[u]||{}),c[u]);const t={type:"object",default:this.defaultValues[u],description:E.localize(1,null,u),$ref:e.resourceLanguageSettingsSchemaId};v.push(C(u)),this.configurationProperties[u]=t,this.defaultLanguageConfigurationOverridesNode.properties[u]=t}else{this.defaultValues[u]=c[u];const t=this.configurationProperties[u];t&&(this.updatePropertyDefaultValue(u,t),this.updateSchema(u,t))}this.registerOverrideIdentifiers(v),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}deregisterDefaultConfigurations(h){const _=[];for(const v of h)for(const c in v)if(_.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const u=this.configurationProperties[c];u&&(this.updatePropertyDefaultValue(c,u),this.updateSchema(c,u))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}notifyConfigurationSchemaUpdated(...h){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(h){for(const _ of h)this.overrideIdentifiers.add(_);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(h,_=!0,v,c=3){var u;c=A.isUndefinedOrNull(h.scope)?c:h.scope;let t=[],i=h.properties;if(i)for(let a in i){if(_&&r(a)){delete i[a];continue}const l=i[a];if(this.updatePropertyDefaultValue(a,l),e.OVERRIDE_PROPERTY_PATTERN.test(a)?l.scope=void 0:(l.scope=A.isUndefinedOrNull(l.scope)?c:l.scope,l.requireTrust=A.isUndefinedOrNull(l.requireTrust)?!!((u=v==null?void 0:v.requireTrustForConfigurations)===null||u===void 0?void 0:u.includes(a)):l.requireTrust),i[a].hasOwnProperty("included")&&!i[a].included){this.excludedConfigurationProperties[a]=i[a],delete i[a];continue}else this.configurationProperties[a]=i[a];!i[a].deprecationMessage&&i[a].markdownDeprecationMessage&&(i[a].deprecationMessage=i[a].markdownDeprecationMessage),t.push(a)}let d=h.allOf;if(d)for(let a of d)t.push(...this.validateAndRegisterProperties(a,_,v,c));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(h){const _=v=>{let c=v.properties;if(c)for(const t in c)this.updateSchema(t,c[t]);let u=v.allOf;u&&u.forEach(_)};_(h)}updateSchema(h,_){switch(e.allSettings.properties[h]=_,_.scope){case 1:e.applicationSettings.properties[h]=_;break;case 2:e.machineSettings.properties[h]=_;break;case 6:e.machineOverridableSettings.properties[h]=_;break;case 3:e.windowSettings.properties[h]=_;break;case 4:e.resourceSettings.properties[h]=_;break;case 5:e.resourceSettings.properties[h]=_,this.resourceLanguageSettingsSchema.properties[h]=_;break}}removeFromSchema(h,_){switch(delete e.allSettings.properties[h],_.scope){case 1:delete e.applicationSettings.properties[h];break;case 2:delete e.machineSettings.properties[h];break;case 6:delete e.machineOverridableSettings.properties[h];break;case 3:delete e.windowSettings.properties[h];break;case 4:case 5:delete e.resourceSettings.properties[h];break}}updateOverridePropertyPatternKey(){for(const h of this.overrideIdentifiers.values()){const _=`[${h}]`,v={type:"object",description:E.localize(2,null),errorMessage:E.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(_,v),e.allSettings.properties[_]=v,e.applicationSettings.properties[_]=v,e.machineSettings.properties[_]=v,e.machineOverridableSettings.properties[_]=v,e.windowSettings.properties[_]=v,e.resourceSettings.properties[_]=v}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(h,_){let v=this.defaultValues[h];A.isUndefined(v)&&(v=_.default),A.isUndefined(v)&&(v=g(_.type)),_.default=v}}const T="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(T);function C(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=C;function g(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const f=new n;P.Registry.add(e.Extensions.Configuration,f);function r(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?E.localize(5,null,b):f.getConfigurationProperties()[b]!==void 0?E.localize(6,null,b):null:E.localize(4,null)}e.validateProperty=r;function s(){const b=[],h=f.getConfigurationProperties();for(const _ of Object.keys(h))b.push([_,h[_].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=s}),define(ve[90],_e([0,1,24,13,2,30,4,66]),function(ie,e,E,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function y(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof P.URI)}e.isConfigurationOverrides=y;var n;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(n=e.ConfigurationTarget||(e.ConfigurationTarget={}));function T(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=T;function C(i,d){const a=d?i?d.keys.filter(R=>i.keys.indexOf(R)===-1):[...d.keys]:[],l=i?d?i.keys.filter(R=>d.keys.indexOf(R)===-1):[...i.keys]:[],o=[];if(d&&i){for(const R of i.keys)if(d.keys.indexOf(R)!==-1){const F=h(i.contents,R),x=h(d.contents,R);E.equals(F,x)||o.push(R)}}const w=[],I=R=>{const F={};for(const x of R)for(const ae of x.identifiers)F[u(ae)]=x;return F},p=d?I(d.overrides):{},m=i?I(i.overrides):{};if(Object.keys(p).length)for(const R of a){const F=p[R];F&&w.push([(0,D.overrideIdentifierFromKey)(R),F.keys])}if(Object.keys(m).length)for(const R of l){const F=m[R];F&&w.push([(0,D.overrideIdentifierFromKey)(R),F.keys])}if(Object.keys(p).length&&Object.keys(m).length)for(const R of o){const F=m[R],x=p[R];if(F&&x){const ae=C({contents:F.contents,keys:F.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});w.push([(0,D.overrideIdentifierFromKey)(R),[...ae.added,...ae.removed,...ae.updated]])}}return{added:a,removed:l,updated:o,overrides:w}}e.compare=C;function g(i,d){const a=[];for(const l of Object.keys(i))if(D.OVERRIDE_PROPERTY_PATTERN.test(l)){const o={};for(const w in i[l])o[w]=i[l][w];a.push({identifiers:[(0,D.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(o),contents:f(o,d)})}return a}e.toOverrides=g;function f(i,d){const a=Object.create(null);for(let l in i)r(a,l,i[l],d);return a}e.toValuesTree=f;function r(i,d,a,l){const o=d.split("."),w=o.pop();let I=i;for(let p=0;p<o.length;p++){let m=o[p],R=I[m];switch(typeof R){case"undefined":R=I[m]=Object.create(null);break;case"object":break;default:l(`Ignoring ${d} as ${o.slice(0,p+1).join(".")} is ${JSON.stringify(R)}`);return}I=R}if(typeof I=="object"&&I!==null)try{I[w]=a}catch(p){l(`Ignoring ${d} as ${o.join(".")} is ${JSON.stringify(I)}`)}else l(`Ignoring ${d} as ${o.join(".")} is ${JSON.stringify(I)}`)}e.addToValueTree=r;function s(i,d){const a=d.split(".");b(i,a)}e.removeFromValueTree=s;function b(i,d){const a=d.shift();if(d.length===0){delete i[a];return}if(Object.keys(i).indexOf(a)!==-1){const l=i[a];typeof l=="object"&&!Array.isArray(l)&&(b(l,d),Object.keys(l).length===0&&delete i[a])}}function h(i,d,a){function l(I,p){let m=I;for(const R of p){if(typeof m!="object"||m===null)return;m=m[R]}return m}const o=d.split("."),w=l(i,o);return typeof w=="undefined"?a:w}e.getConfigurationValue=h;function _(i,d,a){Object.keys(d).forEach(l=>{l!=="__proto__"&&(l in i?k.isObject(i[l])&&k.isObject(d[l])?_(i[l],d[l],a):a&&(i[l]=d[l]):i[l]=d[l])})}e.merge=_;function v(){const i=A.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=v;function c(){const i=Object.create(null),d=A.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let a in d){let l=d[a].default;r(i,a,l,o=>console.error(`Conflict in default settings: ${o}`))}return i}e.getDefaultValues=c;function u(i){return`[${i}]`}e.keyFromOverrideIdentifier=u;function t(i,d,a){const l=i.inspect(d),o=i.inspect(a);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:l.defaultValue}e.getMigratedSettingValue=t}),define(ve[153],_e([0,1,43,22,11,13,24,2,66,90,30,6,3]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},i=[],d=[]){this._contents=t,this._keys=i,this._overrides=d,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const d=this.getContentsForOverrideIdentifer(i);return d?t?(0,n.getConfigurationValue)(d,t):d:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let d={};for(const a of P.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[a],o=i[a];o&&(typeof l=="object"&&typeof o=="object"?(l=S.deepClone(l),this.mergeContents(l,o)):l=o),d[a]=l}return new f(d,this.keys,this.overrides)}merge(...t){const i=S.deepClone(this.contents),d=S.deepClone(this.overrides),a=[...this.keys];for(const l of t){this.mergeContents(i,l.contents);for(const o of l.overrides){const[w]=d.filter(I=>P.equals(I.identifiers,o.identifiers));w?this.mergeContents(w.contents,o.contents):d.push(S.deepClone(o))}for(const o of l.keys)a.indexOf(o)===-1&&a.push(o)}return new f(i,a,d)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const d of Object.keys(i)){if(d in t&&A.isObject(t[d])&&A.isObject(i[d])){this.mergeContents(t[d],i[d]);continue}t[d]=S.deepClone(i[d])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?S.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,n.addToValueTree)(this.contents,t,i,d=>{throw new Error(d)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let d=0;d<i;d++)t.indexOf(this.keys[d])===0&&(i=d);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=f;class r extends f{constructor(){const t=(0,n.getDefaultValues)(),i=(0,n.getConfigurationKeys)(),d=[];for(const a of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(a)&&d.push({identifiers:[(0,y.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(t[a]),contents:(0,n.toValuesTree)(t[a],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,i,d)}}e.DefaultConfigurationModel=r;class s{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!A.isUndefinedOrNull(t)){const d=this.doParseContent(t);this.parseRaw(d,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:d,keys:a,overrides:l,untrusted:o}=this.doParseRaw(t,i);this._configurationModel=new f(d,a,l),this._untrustedConfigurations=o||[]}doParseContent(t){let i={},d=null,a=[],l=[],o=[];function w(p){Array.isArray(a)?a.push(p):d&&(a[d]=p)}let I={onObjectBegin:()=>{let p={};w(p),l.push(a),a=p,d=null},onObjectProperty:p=>{d=p},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{let p=[];w(p),l.push(a),a=p,d=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:w,onError:(p,m,R)=>{o.push({error:p,offset:m,length:R})}};if(t)try{E.visit(t,I),i=a[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return i}doParseRaw(t,i){const d=T.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),a=this.filter(t,d,!0,i);t=a.raw;const l=(0,n.toValuesTree)(t,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),o=Object.keys(t),w=(0,n.toOverrides)(t,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:l,keys:o,overrides:w,untrusted:a.untrusted}}filter(t,i,d,a){if(!(a==null?void 0:a.scopes)&&!(a==null?void 0:a.isUntrusted))return{raw:t,untrusted:[]};const l={},o=[];for(let w in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(w)&&d){const I=this.filter(t[w],i,!1,a);l[w]=I.raw,o.push(...I.untrusted)}else{const I=i[w],p=I?typeof I.scope!="undefined"?I.scope:3:void 0;(p===void 0||a.scopes===void 0||a.scopes.includes(p))&&(a.isUntrusted&&(I==null?void 0:I.requireTrust)?o.push(w):l[w]=t[w])}return{raw:l,untrusted:o}}}e.ConfigurationModelParser=s;class b extends C.Disposable{constructor(t,i,d,a){super();this.userSettingsResource=t,this.scopes=i,this.fileService=a,this._onDidChange=this._register(new g.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new s(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(d.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(g.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=b;class h{constructor(t,i,d=new f,a=new f,l=new k.ResourceMap,o=new f,w=new k.ResourceMap,I=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=d,this._workspaceConfiguration=a,this._folderConfigurations=l,this._memoryConfiguration=o,this._memoryConfigurationByResource=w,this._freeze=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,i,d){return this.getConsolidateConfigurationModel(i,d).getValue(t)}updateValue(t,i,d={}){let a;d.resource?(a=this._memoryConfigurationByResource.get(d.resource),a||(a=new f,this._memoryConfigurationByResource.set(d.resource,a))):a=this._memoryConfiguration,i===void 0?a.removeValue(t):a.setValue(t,i),d.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,d){const a=this.getConsolidateConfigurationModel(i,d),l=this.getFolderConfigurationModelForResource(i.resource,d),o=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,w=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),I=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),p=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),m=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=d?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=l?i.overrideIdentifier?l.freeze().override(i.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,x=i.overrideIdentifier?o.override(i.overrideIdentifier).getValue(t):o.getValue(t),ae=a.getValue(t),z=P.distinct(P.flatten(a.overrides.map(B=>B.identifiers))).filter(B=>a.getOverrideValue(t,B)!==void 0);return{defaultValue:w,userValue:I,userLocalValue:p,userRemoteValue:m,workspaceValue:R,workspaceFolderValue:F,memoryValue:x,value:ae,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:I!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:p!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:m!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:l==null?void 0:l.freeze().getValue(t),override:i.overrideIdentifier?l==null?void 0:l.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:o.getValue(t),override:i.overrideIdentifier?o.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const d=i.filter(a=>y.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const l=(0,y.overrideIdentifierFromKey)(a),o=this._defaultConfiguration.getKeysForOverrideIdentifier(l),w=t.getKeysForOverrideIdentifier(l),I=[...w.filter(p=>o.indexOf(p)===-1),...o.filter(p=>w.indexOf(p)===-1),...o.filter(p=>!S.equals(this._defaultConfiguration.override(l).getValue(p),t.override(l).getValue(p)))];return[l,I]});return this.updateDefaultConfiguration(t),{keys:i,overrides:d}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:d,removed:a,overrides:l}=(0,n.compare)(this.localUserConfiguration,t),o=[...i,...d,...a];return o.length&&this.updateLocalUserConfiguration(t),{keys:o,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:d,removed:a,overrides:l}=(0,n.compare)(this.remoteUserConfiguration,t);let o=[...i,...d,...a];return o.length&&this.updateRemoteUserConfiguration(t),{keys:o,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:d,removed:a,overrides:l}=(0,n.compare)(this.workspaceConfiguration,t);let o=[...i,...d,...a];return o.length&&this.updateWorkspaceConfiguration(t),{keys:o,overrides:l}}compareAndUpdateFolderConfiguration(t,i){const d=this.folderConfigurations.get(t),{added:a,updated:l,removed:o,overrides:w}=(0,n.compare)(d,i);let I=[...a,...l,...o];return(I.length||!d)&&this.updateFolderConfiguration(t,i),{keys:I,overrides:w}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:d,updated:a,removed:l,overrides:o}=(0,n.compare)(i,void 0);return{keys:[...d,...a,...l],overrides:o}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let d=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?d.override(t.overrideIdentifier):d}getConsolidatedConfigurationModelForResource({resource:t},i){let d=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const a=i.getFolder(t);a&&(d=this.getFolderConsolidatedConfiguration(a.uri)||d);const l=this._memoryConfigurationByResource.get(t);l&&(d=d.merge(l))}return d}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const d=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(i=d.merge(a),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=d}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const d=i.getFolder(t);if(d)return this._folderConfigurations.get(d.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:d,overrides:a,keys:l}=this._folderConfigurations.get(i);return t.push([i,{contents:d,overrides:a,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(d=>t.add(d))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(d=>i.add(d)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(d=>i.add(d)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(d=>i.add(d)),this._folderConfigurations.forEach(d=>d.getKeysForOverrideIdentifier(t).forEach(a=>i.add(a))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),d=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((o,w)=>(o.set(D.URI.revive(w[0]),this.parseConfigurationModel(w[1])),o),new k.ResourceMap);return new h(i,d,new f,a,l,new f,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=h;function _(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const t=new Set,i=new Map;for(const a of u)a.keys.forEach(l=>t.add(l)),a.overrides.forEach(([l,o])=>{const w=(0,k.getOrSet)(i,l,new Set);o.forEach(I=>w.add(I))});const d=[];return i.forEach((a,l)=>d.push([l,[...a.values()]])),{keys:[...t.values()],overrides:d}}e.mergeChanges=_;class v{constructor(t,i,d,a){this.change=t,this.previous=i,this.currentConfiguraiton=d,this.currentWorkspace=a,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(w=>l.add(w)),t.overrides.forEach(([,w])=>w.forEach(I=>l.add(I))),this.affectedKeys=[...l.values()];const o=new f;this.affectedKeys.forEach(w=>o.setValue(w,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var d;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const a=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(d=this.previous)===null||d===void 0?void 0:d.workspace):void 0,l=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!S.equals(a,l)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let d=(0,n.toValuesTree)({[i]:!0},()=>{}),a;for(;typeof d=="object"&&(a=Object.keys(d)[0]);){if(t=t[a],!t)return!1;d=d[a]}return!0}}e.ConfigurationChangeEvent=v;class c extends v{constructor(t,i,d,a){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=d,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=c}),define(ve[91],_e([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,E.createDecorator)("remoteAuthorityResolverService");var k;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends Error{constructor(S,D=k.Unknown,y){super(S);this._message=S,this._code=D,this._detail=y,this.isHandled=D===k.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}static isTemporarilyNotAvailable(S){return S instanceof P&&S._code===k.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof P&&S._code===k.NoResolverFound}static isHandled(S){return S instanceof P&&S.isHandled}}e.RemoteAuthorityResolverError=P}),define(ve[92],_e([0,1,18]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function k(y){return y.scheme===E.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=k;function P(y){if(!!y){const n=y.indexOf("+");return n<0?y:y.substr(0,n)}}e.getRemoteName=P;function A(y){return y.scheme!==E.Schemas.file&&y.scheme!==E.Schemas.vscodeRemote}function S(y){const n=y.configuration;if(n&&A(n))return n;if(y.folders.length){const T=y.folders[0].uri;if(A(T))return T}}e.getVirtualWorkspaceLocation=S;function D(y){var n;return(n=S(y))===null||n===void 0?void 0:n.scheme}e.getVirtualWorkspaceScheme=D}),define(ve[154],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class E{constructor(P){this._callback=P,this._terminalBufferMap=new Map}dispose(){for(const P of this._terminalBufferMap.values())P.dispose()}startBuffering(P,A,S=5){let D;return D=A(y=>{const n=typeof y=="string"?y:y.data;let T=this._terminalBufferMap.get(P);if(T){T.data.push(n);return}const C=setTimeout(()=>this.flushBuffer(P),S);T={data:[n],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(P),D.dispose()}},this._terminalBufferMap.set(P,T)}),D}stopBuffering(P){const A=this._terminalBufferMap.get(P);A&&A.dispose()}flushBuffer(P){const A=this._terminalBufferMap.get(P);A&&(this._terminalBufferMap.delete(P),this._callback(P,A.data.join("")))}}e.TerminalDataBufferer=E}),define(ve[155],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var E;(function(k){k.DARK="dark",k.LIGHT="light",k.HIGH_CONTRAST="hc"})(E=e.ColorScheme||(e.ColorScheme={}))}),define(ve[156],_e([0,1,4,6,30,3,155,36]),function(ie,e,E,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,E.createDecorator)("themeService");var y;(function(b){function h(_){return _&&typeof _=="object"&&typeof _.id=="string"}b.isThemeColor=h})(y=e.ThemeColor||(e.ThemeColor={}));function n(b){return{id:b}}e.themeColorFromId=n;var T;(function(b){function h(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||y.isThemeColor(t.color))}b.isThemeIcon=h;const _=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function v(t){const i=_.exec(t);if(!!i){let[,d]=i;return{id:d}}}b.fromString=v;function c(t,i){let d=t.id;const a=d.lastIndexOf("~");return a!==-1&&(d=d.substring(0,a)),i&&(d=`${d}~${i}`),{id:d}}b.modify=c;function u(t,i){var d,a;return t.id===i.id&&((d=t.color)===null||d===void 0?void 0:d.id)===((a=i.color)===null||a===void 0?void 0:a.id)}b.isEqual=u,b.asClassNameArray=D.CSSIcon.asClassNameArray,b.asClassName=D.CSSIcon.asClassName,b.asCSSSelector=D.CSSIcon.asCSSSelector})(T=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function C(b){switch(b){case S.ColorScheme.DARK:return"vs-dark";case S.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(h){return this.themingParticipants.push(h),this.onThemingParticipantAddedEmitter.fire(h),(0,k.toDisposable)(()=>{const _=this.themingParticipants.indexOf(h);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new g;P.Registry.add(e.Extensions.ThemingContribution,f);function r(b){return f.onColorThemeChange(b)}e.registerThemingParticipant=r;class s extends k.Disposable{constructor(h){super();this.themeService=h,this.theme=h.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(h){this.theme=h,this.updateStyles()}updateStyles(){}getColor(h,_){let v=this.theme.getColor(h);return v&&_&&(v=_(v,this.theme)),v?v.toString():null}}e.Themable=s}),define(ve[157],_e([0,1,30,156,3,126,89,14,36]),function(ie,e,E,k,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class n{constructor(){this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(h,_,v,c){const u=this.iconsById[h];if(u){if(v&&!u.description){u.description=v,this.iconSchema.properties[h].markdownDescription=`${v} $(${h})`;const d=this.iconReferenceSchema.enum.indexOf(h);d!==-1&&(this.iconReferenceSchema.enumDescriptions[d]=v),this._onDidChange.fire()}return u}let t={id:h,description:v,defaults:_,deprecationMessage:c};this.iconsById[h]=t;let i={$ref:"#/definitions/icons"};return c&&(i.deprecationMessage=c),v&&(i.markdownDescription=`${v}: $(${h})`),this.iconSchema.properties[h]=i,this.iconReferenceSchema.enum.push(h),this.iconReferenceSchema.enumDescriptions.push(v||""),this._onDidChange.fire(),{id:h}}deregisterIcon(h){delete this.iconsById[h],delete this.iconSchema.properties[h];const _=this.iconReferenceSchema.enum.indexOf(h);_!==-1&&(this.iconReferenceSchema.enum.splice(_,1),this.iconReferenceSchema.enumDescriptions.splice(_,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(h=>this.iconsById[h])}getIcon(h){return this.iconsById[h]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(h,_){const v=this.iconFontsById[h];if(v)return v;let c={id:h,definition:_};return this.iconFontsById[h]=c,this._onDidChange.fire(),c}deregisterIconFont(h){delete this.iconFontsById[h]}getIconFonts(){return Object.keys(this.iconFontsById).map(h=>this.iconFontsById[h])}getIconFont(h){return this.iconFontsById[h]}toString(){const h=(u,t)=>u.id.localeCompare(t.id),_=u=>{for(;k.ThemeIcon.isThemeIcon(u.defaults);)u=this.iconsById[u.defaults.id];return`codicon codicon-${u?u.id:""}`};let v=[];v.push("| preview     | identifier                        | default codicon ID                | description"),v.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.iconsById).map(u=>this.iconsById[u]);for(const u of c.filter(t=>!!t.description).sort(h))v.push(`|<i class="${_(u)}"></i>|${u.id}|${k.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);v.push("| preview     | identifier                        "),v.push("| ----------- | --------------------------------- |");for(const u of c.filter(t=>!k.ThemeIcon.isThemeIcon(t.defaults)).sort(h))v.push(`|<i class="${_(u)}"></i>|${u.id}|`);return v.join(`
`)}}const T=new n;E.Registry.add(e.Extensions.IconContribution,T);function C(b,h,_,v){return T.registerIcon(b,h,_,v)}e.registerIcon=C;function g(){return T}e.getIconRegistry=g;function f(){for(const b of y.iconRegistry.all)T.registerIcon(b.id,b.definition,b.description);y.iconRegistry.onDidRegister(b=>T.registerIcon(b.id,b.definition,b.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let r=E.Registry.as(S.Extensions.JSONContribution);r.registerSchema(e.iconsSchemaId,T.getIconSchema());const s=new D.RunOnceScheduler(()=>r.notifySchemaChanged(e.iconsSchemaId),200);T.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.widgetClose=C("widget-close",y.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=C("goto-previous-location",y.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=C("goto-next-location",y.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=k.ThemeIcon.modify(y.Codicon.sync,"spin")}),define(ve[47],_e([0,1,2,25,4,22]),function(ie,e,E,k,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");var S;(function(g){g[g.EMPTY=1]="EMPTY",g[g.FOLDER=2]="FOLDER",g[g.WORKSPACE=3]="WORKSPACE"})(S=e.WorkbenchState||(e.WorkbenchState={}));function D(g){const f=g;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=D;function y(g){const f=g;return!!(f&&typeof f=="object"&&E.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=y;class n{constructor(f,r,s,b){this._id=f,this._configuration=s,this._ignorePathCasing=b,this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=n;class T{constructor(f,r){this.raw=r,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,k.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=T;function C(g){return new T({uri:g,index:0,name:(0,k.basenameOrAuthority)(g)},{uri:g.toString()})}e.toWorkspaceFolder=C}),define(ve[158],_e([0,1,4,127,47,2,21,12,25,105,43,18,58,37,92]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const s=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(G){return(typeof G=="string"?(0,D.extname)(G):(0,y.extname)(G))===s}e.hasWorkspaceFileExtension=b,e.IWorkspacesService=(0,E.createDecorator)("workspacesService");function h(G){return G.hasOwnProperty("workspace")}e.isRecentWorkspace=h;function _(G){return G.hasOwnProperty("folderUri")}e.isRecentFolder=_;function v(G){return G.hasOwnProperty("fileUri")}e.isRecentFile=v;function c(G){const M=G;return typeof(M==null?void 0:M.id)=="string"&&A.URI.isUri(M.uri)}e.isSingleFolderWorkspaceIdentifier=c;function u(G){if(G.configuration)return{id:G.id,configPath:G.configuration};if(G.folders.length===1)return{id:G.id,uri:G.folders[0].uri}}e.toWorkspaceIdentifier=u;function t(G){const M=G;return typeof(M==null?void 0:M.id)=="string"&&A.URI.isUri(M.configPath)}e.isWorkspaceIdentifier=t;function i(G){const M=G;if(M==null?void 0:M.uri)return{id:M.id,uri:A.URI.revive(M.uri)};const N=G;if(N==null?void 0:N.configPath)return{id:N.id,configPath:A.URI.revive(N.configPath)};if(G==null?void 0:G.id)return{id:G.id}}e.reviveIdentifier=i;function d(G,M){return y.extUriBiasedIgnorePathCase.isEqualOrParent(G,M.untitledWorkspacesHome)}e.isUntitledWorkspace=d;function a(G){return l(G)||o(G)}e.isStoredWorkspaceFolder=a;function l(G){const M=G;return typeof(M==null?void 0:M.path)=="string"&&(!M.name||typeof M.name=="string")}e.isRawFileWorkspaceFolder=l;function o(G){const M=G;return typeof(M==null?void 0:M.uri)=="string"&&(!M.name||typeof M.name=="string")}e.isRawUriWorkspaceFolder=o;function w(G,M,N,W,Q=!S.isWindows,$){if(G.scheme!==W.scheme)return{name:N,uri:G.toString(!0)};let Z=M?void 0:$.relativePath(W,G);if(Z!==void 0)Z.length===0?Z=".":S.isWindows&&G.scheme===C.Schemas.file&&!Q&&(Z=Z.replace(/\//g,"\\"));else if(G.scheme===C.Schemas.file)Z=G.fsPath,S.isWindows&&(Z=(0,g.normalizeDriveLetter)(Z),Q&&(Z=(0,f.toSlashes)(Z)));else{if(!$.isEqualAuthority(G.authority,W.authority))return{name:N,uri:G.toString(!0)};Z=G.path}return{name:N,path:Z}}e.getStoredWorkspaceFolder=w;function I(G,M,N){let W=[],Q=new Set;const $=N.dirname(M);for(let Z of G){let re=null;if(l(Z))Z.path&&(re=N.resolvePath($,Z.path));else if(o(Z))try{re=A.URI.parse(Z.uri),re.path[0]!=="/"&&(re=re.with({path:"/"+re.path}))}catch(se){console.warn(se)}if(re){let se=N.getComparisonKey(re);if(!Q.has(se)){Q.add(se);const ye=Z.name||N.basenameOrAuthority(re);W.push(new P.WorkspaceFolder({uri:re,name:ye,index:W.length},Z))}}}return W}e.toWorkspaceFolders=I;function p(G,M,N,W,Q){let $=m(M,G);const Z=Q.dirname(M),re=Q.dirname(W),se=[],ye=R($.folders);for(const ze of $.folders){const U=l(ze)?Q.resolvePath(Z,ze.path):A.URI.parse(ze.uri);let K;N?K=!1:K=!l(ze)||(0,D.isAbsolute)(ze.path),se.push(w(U,K,ze.name,re,ye,Q))}const Pe={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},$e=n.setProperty(G,["folders"],se,Pe);let Re=n.applyEdits(G,$e);return $.remoteAuthority===(0,r.getRemoteAuthority)(W)&&(Re=n.applyEdits(Re,n.removeProperty(Re,["remoteAuthority"],Pe))),Re}e.rewriteWorkspaceFileForNewLocation=p;function m(G,M){let N=T.parse(M);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(W=>a(W));else throw new Error(`${G} looks like an invalid workspace file.`);return N}function R(G){return S.isWindows?G.some(M=>l(M)&&M.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function F(G){return G.workspace&&typeof G.workspace=="object"&&typeof G.workspace.id=="string"&&typeof G.workspace.configPath=="string"}function x(G){return typeof G.folderUri=="string"}function ae(G){return typeof G.fileUri=="string"}function z(G,M){const N={workspaces:[],files:[]};if(G){const W=function($,Z){for(let re=0;re<$.length;re++)try{Z($[re],re)}catch(se){M.warn(`Error restoring recent entry ${JSON.stringify($[re])}: ${se.toString()}. Skip entry.`)}},Q=G;if(Array.isArray(Q.entries))W(Q.entries,$=>{const Z=$.label,re=$.remoteAuthority;F($)?N.workspaces.push({label:Z,remoteAuthority:re,workspace:{id:$.workspace.id,configPath:A.URI.parse($.workspace.configPath)}}):x($)?N.workspaces.push({label:Z,remoteAuthority:re,folderUri:A.URI.parse($.folderUri)}):ae($)&&N.files.push({label:Z,remoteAuthority:re,fileUri:A.URI.parse($.fileUri)})});else{const $=G;Array.isArray($.workspaces3)&&W($.workspaces3,(Z,re)=>{const se=Array.isArray($.workspaceLabels)&&$.workspaceLabels[re]||void 0;typeof Z=="object"&&typeof Z.id=="string"&&typeof Z.configURIPath=="string"?N.workspaces.push({label:se,workspace:{id:Z.id,configPath:A.URI.parse(Z.configURIPath)}}):typeof Z=="string"&&N.workspaces.push({label:se,folderUri:A.URI.parse(Z)})}),Array.isArray($.files2)&&W($.files2,(Z,re)=>{const se=Array.isArray($.fileLabels)&&$.fileLabels[re]||void 0;typeof Z=="string"&&N.files.push({label:se,fileUri:A.URI.parse(Z)})})}}return N}e.restoreRecentlyOpened=z;function B(G){const M={entries:[]};for(const N of G.workspaces)_(N)?M.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):M.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of G.files)M.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return M}e.toStoreData=B}),define(ve[67],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class E{constructor(P){this.id=P,this._data=new Map,this._idPool=1}add(P){const A=this._idPool++;return this._data.set(A,P),this.logDebugInfo(),A}get(P,A){return this._data.has(P)?this._data.get(P)[A]:void 0}delete(P){this._data.delete(P),this.logDebugInfo()}logDebugInfo(){!E.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=E,E.enableDebugLogging=!1}),define(ve[159],_e([0,1,2,3]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class P{constructor(){this._onDidChangeTabs=new k.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(S){this._tabs=S.map(D=>({name:D.name,group:D.group,resource:E.URI.revive(D.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=P}),define(ve[48],_e([0,1,18,4]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(E.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(S,D){D===null?this._providerInfo.delete(S):this._providerInfo.set(S,D)}isFreeScheme(S){return!this._providerInfo.has(S)&&!this._systemSchemes.has(S)}getCapabilities(S){return this._providerInfo.get(S)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(ve[27],_e([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,E.createDecorator)("IExtHostInitDataService")}),define(ve[160],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class E{constructor(A,S,D){this._id=A,this._shared=S,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)})}get whenReady(){return this._init}get(A,S){let D=this._value[A];return typeof D=="undefined"&&(D=S),D}update(A,S){return this._value[A]=S,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=E;class k extends E{constructor(A,S){super(A.identifier.value,!0,S);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=k}),define(ve[15],_e([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,E.createDecorator)("IExtHostRpcService");class k{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=k});var et=this&&this.__classPrivateFieldSet||function(ie,e,E,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(ie,E):P?P.value=E:e.set(ie,E),E},xe=this&&this.__classPrivateFieldGet||function(ie,e,E,k){if(E==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?k:E==="a"?k.call(ie):k?k.value:e.get(ie)};define(ve[161],_e([0,1,26,3]),function(ie,e,E,k){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(D,y){P.set(this,void 0),this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._id=E.ExtensionIdentifier.toKey(D.identifier),et(this,P,y,"f"),xe(this,P,"f").onDidChangePassword(n=>{n.extensionId===this._id&&this._onDidChange.fire({key:n.key})})}get(D){return xe(this,P,"f").get(this._id,D)}store(D,y){return xe(this,P,"f").store(this._id,D,y)}delete(D){return xe(this,P,"f").delete(this._id,D)}}e.ExtensionSecrets=A,P=new WeakMap}),define(ve[93],_e([0,1,4,3]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class P{constructor(){this._onDidChangeTelemetryEnabled=new k.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(S){this._enabled=S}$onDidChangeTelemetryEnabled(S){this._enabled=S,this._onDidChangeTelemetryEnabled.fire(S)}}e.ExtHostTelemetry=P,e.IExtHostTelemetry=(0,E.createDecorator)("IExtHostTelemetry")}),define(ve[68],_e([0,1,4,3,15]),function(ie,e,E,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(D){function y(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public}}D.fromApiTunnel=y;function n(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.public}}D.fromServiceTunnel=n})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,E.createDecorator)("IExtHostTunnelService");let S=class{constructor(y){this.onDidChangeTunnels=new k.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,n){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,n){return{dispose:()=>{}}}async $providePortAttributes(y,n,T,C,g){return[]}async $forwardPort(y,n){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};S=je([Ke(0,P.IExtHostRpcService)],S),e.ExtHostTunnelService=S});var et=this&&this.__classPrivateFieldSet||function(ie,e,E,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(ie,E):P?P.value=E:e.set(ie,E),E},xe=this&&this.__classPrivateFieldGet||function(ie,e,E,k){if(E==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?k:E==="a"?k.call(ie):k?k.value:e.get(ie)};define(ve[7],_e([0,1,11,10,81,22,13,2,29,64,91]),function(ie,e,E,k,P,A,S,D,y,n,T){"use strict";var C,g,f,r,s,b,h,_,v,c,u,t,i,d,a,l,o,w;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItem=e.TestChildrenCollection=e.TestItemHookProperty=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function I(O){function L(){return Reflect.construct(O,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(O,"name")),Object.setPrototypeOf(L,O),Object.setPrototypeOf(L.prototype,O.prototype),L}let p=s=class{constructor(L){C.set(this,void 0),et(this,C,L,"f")}static from(...L){let ee=L;return new s(function(){if(ee){for(const we of ee)we&&typeof we.dispose=="function"&&we.dispose();ee=void 0}})}dispose(){typeof xe(this,C,"f")=="function"&&(xe(this,C,"f").call(this),et(this,C,void 0,"f"))}};C=new WeakMap,p=s=je([I],p),e.Disposable=p;let m=b=class{constructor(L,ee){if(L<0)throw(0,k.illegalArgument)("line must be non-negative");if(ee<0)throw(0,k.illegalArgument)("character must be non-negative");this._line=L,this._character=ee}static Min(...L){if(L.length===0)throw new TypeError;let ee=L[0];for(let we=1;we<L.length;we++){const We=L[we];We.isBefore(ee)&&(ee=We)}return ee}static Max(...L){if(L.length===0)throw new TypeError;let ee=L[0];for(let we=1;we<L.length;we++){const We=L[we];We.isAfter(ee)&&(ee=We)}return ee}static isPosition(L){if(!L)return!1;if(L instanceof b)return!0;let{line:ee,character:we}=L;return typeof ee=="number"&&typeof we=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,ee=0){if(L===null||ee===null)throw(0,k.illegalArgument)();let we;return typeof L=="undefined"?we=0:typeof L=="number"?we=L:(we=typeof L.lineDelta=="number"?L.lineDelta:0,ee=typeof L.characterDelta=="number"?L.characterDelta:0),we===0&&ee===0?this:new b(this.line+we,this.character+ee)}with(L,ee=this.character){if(L===null||ee===null)throw(0,k.illegalArgument)();let we;return typeof L=="undefined"?we=this.line:typeof L=="number"?we=L:(we=typeof L.line=="number"?L.line:this.line,ee=typeof L.character=="number"?L.character:this.character),we===this.line&&ee===this.character?this:new b(we,ee)}toJSON(){return{line:this.line,character:this.character}}};m=b=je([I],m),e.Position=m;let R=h=class{constructor(L,ee,we,We){let Ye,ot;if(typeof L=="number"&&typeof ee=="number"&&typeof we=="number"&&typeof We=="number"?(Ye=new m(L,ee),ot=new m(we,We)):L instanceof m&&ee instanceof m&&(Ye=L,ot=ee),!Ye||!ot)throw new Error("Invalid arguments");Ye.isBefore(ot)?(this._start=Ye,this._end=ot):(this._start=ot,this._end=Ye)}static isRange(L){return L instanceof h?!0:L?m.isPosition(L.start)&&m.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof h?this.contains(L._start)&&this.contains(L._end):L instanceof m?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const ee=m.Max(L.start,this._start),we=m.Min(L.end,this._end);if(!ee.isAfter(we))return new h(ee,we)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ee=m.Min(L.start,this._start),we=m.Max(L.end,this.end);return new h(ee,we)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,ee=this.end){if(L===null||ee===null)throw(0,k.illegalArgument)();let we;return L?m.isPosition(L)?we=L:(we=L.start||this.start,ee=L.end||this.end):we=this.start,we.isEqual(this._start)&&ee.isEqual(this.end)?this:new h(we,ee)}toJSON(){return[this.start,this.end]}};R=h=je([I],R),e.Range=R;let F=_=class extends R{constructor(L,ee,we,We){let Ye,ot;if(typeof L=="number"&&typeof ee=="number"&&typeof we=="number"&&typeof We=="number"?(Ye=new m(L,ee),ot=new m(we,We)):L instanceof m&&ee instanceof m&&(Ye=L,ot=ee),!Ye||!ot)throw new Error("Invalid arguments");super(Ye,ot);this._anchor=Ye,this._active=ot}static isSelection(L){return L instanceof _?!0:L?R.isRange(L)&&m.isPosition(L.anchor)&&m.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};F=_=je([I],F),e.Selection=F;class x{constructor(L,ee,we){if(typeof L!="string"||L.length===0)throw(0,k.illegalArgument)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,k.illegalArgument)("port");if(typeof we!="undefined"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z\-]+$/.test(we)))throw(0,k.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(ee),this.connectionToken=we}}e.ResolvedAuthority=x;class ae extends Error{constructor(L,ee=T.RemoteAuthorityResolverErrorCode.Unknown,we){super(L);this._message=L,this._code=ee,this._detail=we,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ae.prototype)}static NotAvailable(L,ee){return new ae(L,T.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(L){return new ae(L,T.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=ae;var z;(function(O){O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(z=e.EndOfLine||(e.EndOfLine={}));var B;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(B=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let G=v=class{constructor(L,ee){this._range=L,this._newText=ee}static isTextEdit(L){return L instanceof v?!0:L?R.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ee){return new v(L,ee)}static insert(L,ee){return v.replace(new R(L,L),ee)}static delete(L){return v.replace(L,"")}static setEndOfLine(L){const ee=new v(new R(new m(0,0),new m(0,0)),"");return ee.newEol=L,ee}get range(){return this._range}set range(L){if(L&&!R.isRange(L))throw(0,k.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,k.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,k.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};G=v=je([I],G),e.TextEdit=G;var M;(function(O){O[O.File=1]="File",O[O.Text=2]="Text",O[O.Cell=3]="Cell",O[O.CellOutput=4]="CellOutput",O[O.CellReplace=5]="CellReplace",O[O.CellOutputItem=6]="CellOutputItem"})(M=e.FileEditType||(e.FileEditType={}));let N=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,ee,we,We){this._edits.push({_type:1,from:L,to:ee,options:we,metadata:We})}createFile(L,ee,we){this._edits.push({_type:1,from:void 0,to:L,options:ee,metadata:we})}deleteFile(L,ee,we){this._edits.push({_type:1,from:L,to:void 0,options:ee,metadata:we})}replaceNotebookMetadata(L,ee,we){this._edits.push({_type:3,metadata:we,uri:L,edit:{editType:5,metadata:ee},notebookMetadata:ee})}replaceNotebookCells(L,ee,we,We,Ye){(ee!==we||We.length>0)&&this._edits.push({_type:5,uri:L,index:ee,count:we-ee,cells:We,metadata:Ye})}replaceNotebookCellOutput(L,ee,we,We){this._editNotebookCellOutput(L,ee,!1,we,We)}appendNotebookCellOutput(L,ee,we,We){this._editNotebookCellOutput(L,ee,!0,we,We)}replaceNotebookCellOutputItems(L,ee,we,We,Ye){this._editNotebookCellOutputItems(L,ee,we,!1,We,Ye)}appendNotebookCellOutputItems(L,ee,we,We,Ye){this._editNotebookCellOutputItems(L,ee,we,!0,We,Ye)}_editNotebookCellOutputItems(L,ee,we,We,Ye,ot){this._edits.push({_type:6,metadata:ot,uri:L,index:ee,outputId:we,append:We,newOutputItems:Ye})}_editNotebookCellOutput(L,ee,we,We,Ye){this._edits.push({_type:4,metadata:Ye,uri:L,index:ee,append:we,newOutputs:We,newMetadata:void 0})}replaceNotebookCellMetadata(L,ee,we,We){this._edits.push({_type:3,metadata:We,uri:L,edit:{editType:11,index:ee,metadata:we}})}replace(L,ee,we,We){this._edits.push({_type:2,uri:L,edit:new G(ee,we),metadata:We})}insert(L,ee,we,We){this.replace(L,new R(ee,ee),we,We)}delete(L,ee,we){this.replace(L,ee,"",we)}has(L){return this._edits.some(ee=>ee._type===2&&ee.uri.toString()===L.toString())}set(L,ee){if(ee)for(const we of ee)we&&this._edits.push({_type:2,uri:L,edit:we});else{for(let we=0;we<this._edits.length;we++){const We=this._edits[we];We._type===2&&We.uri.toString()===L.toString()&&(this._edits[we]=void 0)}(0,E.coalesceInPlace)(this._edits)}}get(L){const ee=[];for(let we of this._edits)we._type===2&&we.uri.toString()===L.toString()&&ee.push(we.edit);return ee}entries(){const L=new A.ResourceMap;for(let ee of this._edits)if(ee._type===2){let we=L.get(ee.uri);we||(we=[ee.uri,[]],L.set(ee.uri,we)),we[1].push(ee.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};N=je([I],N),e.WorkspaceEdit=N;let W=c=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof c?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=c._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ee=this._tabstop++){if(typeof L=="function"){const we=new c;we._tabstop=this._tabstop,L(we),this._tabstop=we._tabstop,L=we.value}else L=c._escape(L);return this.value+="${",this.value+=ee,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ee=this._tabstop++){const we=L.map(We=>We.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(L,ee){if(typeof ee=="function"){const we=new c;we._tabstop=this._tabstop,ee(we),this._tabstop=we._tabstop,ee=we.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};W=c=je([I],W),e.SnippetString=W;var Q;(function(O){O[O.Unnecessary=1]="Unnecessary",O[O.Deprecated=2]="Deprecated"})(Q=e.DiagnosticTag||(e.DiagnosticTag={}));var $;(function(O){O[O.Hint=3]="Hint",O[O.Information=2]="Information",O[O.Warning=1]="Warning",O[O.Error=0]="Error"})($=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Z=u=class{constructor(L,ee){if(this.uri=L,ee)if(ee instanceof R)this.range=ee;else if(ee instanceof m)this.range=new R(ee,ee);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof u?!0:L?R.isRange(L.range)&&D.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Z=u=je([I],Z),e.Location=Z;let re=class{constructor(L,ee){this.location=L,this.message=ee}static is(L){return L?typeof L.message=="string"&&L.location&&R.isRange(L.location.range)&&D.URI.isUri(L.location.uri):!1}static isEqual(L,ee){return L===ee?!0:!L||!ee?!1:L.message===ee.message&&L.location.range.isEqual(ee.location.range)&&L.location.uri.toString()===ee.location.uri.toString()}};re=je([I],re),e.DiagnosticRelatedInformation=re;let se=class{constructor(L,ee,we=$.Error){if(!R.isRange(L))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=L,this.message=ee,this.severity=we}toJSON(){return{severity:$[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ee){return L===ee?!0:!L||!ee?!1:L.message===ee.message&&L.severity===ee.severity&&L.code===ee.code&&L.severity===ee.severity&&L.source===ee.source&&L.range.isEqual(ee.range)&&(0,E.equals)(L.tags,ee.tags)&&(0,E.equals)(L.relatedInformation,ee.relatedInformation,re.isEqual)}};se=je([I],se),e.Diagnostic=se;let ye=class{constructor(L,ee){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:(0,P.isMarkdownString)(L)?this.contents=[L]:this.contents=[L],this.range=ee}};ye=je([I],ye),e.Hover=ye;var Pe;(function(O){O[O.Text=0]="Text",O[O.Read=1]="Read",O[O.Write=2]="Write"})(Pe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let $e=class{constructor(L,ee=Pe.Text){this.range=L,this.kind=ee}toJSON(){return{range:this.range,kind:Pe[this.kind]}}};$e=je([I],$e),e.DocumentHighlight=$e;var Re;(function(O){O[O.File=0]="File",O[O.Module=1]="Module",O[O.Namespace=2]="Namespace",O[O.Package=3]="Package",O[O.Class=4]="Class",O[O.Method=5]="Method",O[O.Property=6]="Property",O[O.Field=7]="Field",O[O.Constructor=8]="Constructor",O[O.Enum=9]="Enum",O[O.Interface=10]="Interface",O[O.Function=11]="Function",O[O.Variable=12]="Variable",O[O.Constant=13]="Constant",O[O.String=14]="String",O[O.Number=15]="Number",O[O.Boolean=16]="Boolean",O[O.Array=17]="Array",O[O.Object=18]="Object",O[O.Key=19]="Key",O[O.Null=20]="Null",O[O.EnumMember=21]="EnumMember",O[O.Struct=22]="Struct",O[O.Event=23]="Event",O[O.Operator=24]="Operator",O[O.TypeParameter=25]="TypeParameter"})(Re=e.SymbolKind||(e.SymbolKind={}));var ze;(function(O){O[O.Deprecated=1]="Deprecated"})(ze=e.SymbolTag||(e.SymbolTag={}));let U=t=class{constructor(L,ee,we,We,Ye){this.name=L,this.kind=ee,this.containerName=Ye,typeof we=="string"&&(this.containerName=we),We instanceof Z?this.location=We:we instanceof R&&(this.location=new Z(We,we)),t.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Re[this.kind],location:this.location,containerName:this.containerName}}};U=t=je([I],U),e.SymbolInformation=U;let K=i=class{constructor(L,ee,we,We,Ye){this.name=L,this.detail=ee,this.kind=we,this.range=We,this.selectionRange=Ye,this.children=[],i.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(i.validate)}};K=i=je([I],K),e.DocumentSymbol=K;var te;(function(O){O[O.Invoke=1]="Invoke",O[O.Automatic=2]="Automatic"})(te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(L,ee){this.title=L,this.kind=ee}};le=je([I],le),e.CodeAction=le;let me=d=class{constructor(L){this.value=L}append(L){return new d(this.value?this.value+d.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+d.sep)}};me.sep=".",me=d=je([I],me),e.CodeActionKind=me,me.Empty=new me(""),me.QuickFix=me.Empty.append("quickfix"),me.Refactor=me.Empty.append("refactor"),me.RefactorExtract=me.Refactor.append("extract"),me.RefactorInline=me.Refactor.append("inline"),me.RefactorRewrite=me.Refactor.append("rewrite"),me.Source=me.Empty.append("source"),me.SourceOrganizeImports=me.Source.append("organizeImports"),me.SourceFixAll=me.Source.append("fixAll");let Se=class{constructor(L,ee){if(this.range=L,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Se=je([I],Se),e.SelectionRange=Se;class Me{constructor(L,ee,we,We,Ye,ot){this.kind=L,this.name=ee,this.detail=we,this.uri=We,this.range=Ye,this.selectionRange=ot}}e.CallHierarchyItem=Me;class ge{constructor(L,ee){this.fromRanges=ee,this.from=L}}e.CallHierarchyIncomingCall=ge;class Ce{constructor(L,ee){this.fromRanges=ee,this.to=L}}e.CallHierarchyOutgoingCall=Ce;let Ae=class{constructor(L,ee){this.range=L,this.command=ee}get isResolved(){return!!this.command}};Ae=je([I],Ae),e.CodeLens=Ae;let Be=a=class{constructor(L,ee=!1){g.set(this,void 0),et(this,g,new P.MarkdownString(L,{supportThemeIcons:ee}),"f")}static isMarkdownString(L){return L instanceof a?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return xe(this,g,"f").value}set value(L){xe(this,g,"f").value=L}get isTrusted(){return xe(this,g,"f").isTrusted}set isTrusted(L){xe(this,g,"f").isTrusted=L}get supportThemeIcons(){return xe(this,g,"f").supportThemeIcons}appendText(L){return xe(this,g,"f").appendText(L),this}appendMarkdown(L){return xe(this,g,"f").appendMarkdown(L),this}appendCodeblock(L,ee){return xe(this,g,"f").appendCodeblock(ee!=null?ee:"",L),this}};g=new WeakMap,Be=a=je([I],Be),e.MarkdownString=Be;let be=class{constructor(L,ee){this.label=L,this.documentation=ee}};be=je([I],be),e.ParameterInformation=be;let qe=class{constructor(L,ee){this.label=L,this.documentation=ee,this.parameters=[]}};qe=je([I],qe),e.SignatureInformation=qe;let j=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};j=je([I],j),e.SignatureHelp=j;var X;(function(O){O[O.Invoke=1]="Invoke",O[O.TriggerCharacter=2]="TriggerCharacter",O[O.ContentChange=3]="ContentChange"})(X=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var pe;(function(O){O[O.Other=0]="Other",O[O.Type=1]="Type",O[O.Parameter=2]="Parameter"})(pe=e.InlineHintKind||(e.InlineHintKind={}));let Le=class{constructor(L,ee,we){this.text=L,this.range=ee,this.kind=we}};Le=je([I],Le),e.InlineHint=Le;var He;(function(O){O[O.Invoke=0]="Invoke",O[O.TriggerCharacter=1]="TriggerCharacter",O[O.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ue;(function(O){O[O.Text=0]="Text",O[O.Method=1]="Method",O[O.Function=2]="Function",O[O.Constructor=3]="Constructor",O[O.Field=4]="Field",O[O.Variable=5]="Variable",O[O.Class=6]="Class",O[O.Interface=7]="Interface",O[O.Module=8]="Module",O[O.Property=9]="Property",O[O.Unit=10]="Unit",O[O.Value=11]="Value",O[O.Enum=12]="Enum",O[O.Keyword=13]="Keyword",O[O.Snippet=14]="Snippet",O[O.Color=15]="Color",O[O.File=16]="File",O[O.Reference=17]="Reference",O[O.Folder=18]="Folder",O[O.EnumMember=19]="EnumMember",O[O.Constant=20]="Constant",O[O.Struct=21]="Struct",O[O.Event=22]="Event",O[O.Operator=23]="Operator",O[O.TypeParameter=24]="TypeParameter",O[O.User=25]="User",O[O.Issue=26]="Issue"})(Ue=e.CompletionItemKind||(e.CompletionItemKind={}));var Ze;(function(O){O[O.Deprecated=1]="Deprecated"})(Ze=e.CompletionItemTag||(e.CompletionItemTag={}));let H=class{constructor(L,ee){this.label=L,this.kind=ee}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Ue[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};H=je([I],H),e.CompletionItem=H;let ne=class{constructor(L=[],ee=!1){this.items=L,this.isIncomplete=ee}};ne=je([I],ne),e.CompletionList=ne;var he;(function(O){O[O.Active=-1]="Active",O[O.Beside=-2]="Beside",O[O.One=1]="One",O[O.Two=2]="Two",O[O.Three=3]="Three",O[O.Four=4]="Four",O[O.Five=5]="Five",O[O.Six=6]="Six",O[O.Seven=7]="Seven",O[O.Eight=8]="Eight",O[O.Nine=9]="Nine"})(he=e.ViewColumn||(e.ViewColumn={}));var q;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(q=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Y;(function(O){O[O.Off=0]="Off",O[O.On=1]="On",O[O.Relative=2]="Relative"})(Y=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var oe;(function(O){O[O.Manual=1]="Manual",O[O.AfterDelay=2]="AfterDelay",O[O.FocusOut=3]="FocusOut"})(oe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var fe;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(fe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ee;(function(O){O[O.Keyboard=1]="Keyboard",O[O.Mouse=2]="Mouse",O[O.Command=3]="Command"})(Ee=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ne;(function(O){O[O.OpenOpen=0]="OpenOpen",O[O.ClosedClosed=1]="ClosedClosed",O[O.OpenClosed=2]="OpenClosed",O[O.ClosedOpen=3]="ClosedOpen"})(Ne=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(O){function L(ee){switch(ee){case"keyboard":return O.Keyboard;case"mouse":return O.Mouse;case"api":return O.Command}}O.fromValue=L}(Ee=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Fe=class{constructor(L,ee){if(ee&&!D.URI.isUri(ee))throw(0,k.illegalArgument)("target");if(!R.isRange(L)||L.isEmpty)throw(0,k.illegalArgument)("range");this.range=L,this.target=ee}};Fe=je([I],Fe),e.DocumentLink=Fe;let Ve=class{constructor(L,ee,we,We){this.red=L,this.green=ee,this.blue=we,this.alpha=We}};Ve=je([I],Ve),e.Color=Ve;let Xe=class{constructor(L,ee){if(ee&&!(ee instanceof Ve))throw(0,k.illegalArgument)("color");if(!R.isRange(L)||L.isEmpty)throw(0,k.illegalArgument)("range");this.range=L,this.color=ee}};Xe=je([I],Xe),e.ColorInformation=Xe;let tt=class{constructor(L){if(!L||typeof L!="string")throw(0,k.illegalArgument)("label");this.label=L}};tt=je([I],tt),e.ColorPresentation=tt;var nt;(function(O){O[O.RGB=0]="RGB",O[O.HEX=1]="HEX",O[O.HSL=2]="HSL"})(nt=e.ColorFormat||(e.ColorFormat={}));var rt;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information"})(rt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var it;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(it=e.TaskRevealKind||(e.TaskRevealKind={}));var gt;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(gt=e.TaskPanelKind||(e.TaskPanelKind={}));let ce=l=class{constructor(L,ee){if(typeof L!="string"||typeof ee!="string")throw(0,k.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}get id(){return this._id}};ce.Clean=new l("clean","Clean"),ce.Build=new l("build","Build"),ce.Rebuild=new l("rebuild","Rebuild"),ce.Test=new l("test","Test"),ce=l=je([I],ce),e.TaskGroup=ce;function De(O){let L="";for(let ee=0;ee<O.length;ee++)L+=O[ee].replace(/,/g,",,")+",";return L}let ue=class{constructor(L,ee,we){if(typeof L!="string")throw(0,k.illegalArgument)("process");this._args=[],this._process=L,ee!==void 0&&(Array.isArray(ee)?(this._args=ee,this._options=we):this._options=ee)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,k.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let ee of this._args)L.push(ee);return De(L)}};ue=je([I],ue),e.ProcessExecution=ue;let V=class{constructor(L,ee,we){if(this._args=[],Array.isArray(ee)){if(!L)throw(0,k.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,k.illegalArgument)("command");this._command=L,this._args=ee,this._options=we}else{if(typeof L!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=L,this._options=ee}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,k.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ee of this._args)L.push(typeof ee=="string"?ee:ee.value);return De(L)}};V=je([I],V),e.ShellExecution=V;var Oe;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(Oe=e.ShellQuoting||(e.ShellQuoting={}));var Ie;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace"})(Ie=e.TaskScope||(e.TaskScope={}));class Je{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,y.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=Je;let Ge=o=class{constructor(L,ee,we,We,Ye,ot){this.__deprecated=!1,this._definition=this.definition=L;let ht;typeof ee=="string"?(this._name=this.name=ee,this._source=this.source=we,this.execution=We,ht=Ye,this.__deprecated=!0):ee===Ie.Global||ee===Ie.Workspace?(this.target=ee,this._name=this.name=we,this._source=this.source=We,this.execution=Ye,ht=ot):(this.target=ee,this._name=this.name=we,this._source=this.source=We,this.execution=Ye,ht=ot),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ue?this._definition={type:o.ProcessType,id:this._execution.computeId()}:this._execution instanceof V?this._definition={type:o.ShellType,id:this._execution.computeId()}:this._execution instanceof Je?this._definition={type:o.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:o.EmptyType,id:(0,y.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,k.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,k.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const ee=this._definition.type;(o.EmptyType===ee||o.ProcessType===ee||o.ShellType===ee||o.ExtensionCallbackType===ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,k.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};Ge.ExtensionCallbackType="customExecution",Ge.ProcessType="process",Ge.ShellType="shell",Ge.EmptyType="$empty",Ge=o=je([I],Ge),e.Task=Ge;var lt;(function(O){O[O.SourceControl=1]="SourceControl",O[O.Window=10]="Window",O[O.Notification=15]="Notification"})(lt=e.ProgressLocation||(e.ProgressLocation={}));let at=class{constructor(L,ee=Qe.None){this.collapsibleState=ee,D.URI.isUri(L)?this.resourceUri=L:this.label=L}};at=je([I],at),e.TreeItem=at;var Qe;(function(O){O[O.None=0]="None",O[O.Collapsed=1]="Collapsed",O[O.Expanded=2]="Expanded"})(Qe=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let st=class{constructor(L,ee){this.id=L,this.color=ee}};st=je([I],st),e.ThemeIcon=st,st.File=new st("file"),st.Folder=new st("folder");let ct=class{constructor(L){this.id=L}};ct=je([I],ct),e.ThemeColor=ct;var pt;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.WorkspaceFolder=3]="WorkspaceFolder"})(pt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let vt=class{constructor(L,ee){if(typeof L!="string"&&(!L||!D.URI.isUri(L)&&!D.URI.isUri(L.uri)))throw(0,k.illegalArgument)("base");if(typeof ee!="string")throw(0,k.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=D.URI.file(L),this.base=L):D.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=ee}};vt=je([I],vt),e.RelativePattern=vt;let bt=class{constructor(L,ee,we,We){this.enabled=typeof L=="boolean"?L:!0,typeof ee=="string"&&(this.condition=ee),typeof we=="string"&&(this.hitCondition=we),typeof We=="string"&&(this.logMessage=We)}get id(){return this._id||(this._id=(0,y.generateUuid)()),this._id}};bt=je([I],bt),e.Breakpoint=bt;let wt=class extends bt{constructor(L,ee,we,We,Ye){super(ee,we,We,Ye);if(L===null)throw(0,k.illegalArgument)("location");this.location=L}};wt=je([I],wt),e.SourceBreakpoint=wt;let yt=class extends bt{constructor(L,ee,we,We,Ye){super(ee,we,We,Ye);this.functionName=L}};yt=je([I],yt),e.FunctionBreakpoint=yt;let _t=class extends bt{constructor(L,ee,we,We,Ye,ot,ht){super(We,Ye,ot,ht);if(!ee)throw(0,k.illegalArgument)("dataId");this.label=L,this.dataId=ee,this.canPersist=we}};_t=je([I],_t),e.DataBreakpoint=_t;let Mt=class{constructor(L,ee,we){this.command=L,this.args=ee||[],this.options=we}};Mt=je([I],Mt),e.DebugAdapterExecutable=Mt;let Tt=class{constructor(L,ee){this.port=L,this.host=ee}};Tt=je([I],Tt),e.DebugAdapterServer=Tt;let ft=class{constructor(L){this.path=L}};ft=je([I],ft),e.DebugAdapterNamedPipeServer=ft;let zt=class{constructor(L){this.implementation=L}};zt=je([I],zt),e.DebugAdapterInlineImplementation=zt;let Et=class{constructor(L,ee){this.range=L,this.expression=ee}};Et=je([I],Et),e.EvaluatableExpression=Et;let Bt=class{constructor(L,ee){this.range=L,this.text=ee}};Bt=je([I],Bt),e.InlineValueText=Bt;let Vt=class{constructor(L,ee,we=!0){this.range=L,this.variableName=ee,this.caseSensitiveLookup=we}};Vt=je([I],Vt),e.InlineValueVariableLookup=Vt;let Ot=class{constructor(L,ee){this.range=L,this.expression=ee}};Ot=je([I],Ot),e.InlineValueEvaluatableExpression=Ot;let dt=class{constructor(L,ee){this.frameId=L,this.stoppedLocation=ee}};dt=je([I],dt),e.InlineValueContext=dt;var dn;(function(O){O[O.Changed=1]="Changed",O[O.Created=2]="Created",O[O.Deleted=3]="Deleted"})(dn=e.FileChangeType||(e.FileChangeType={}));let kt=w=class extends Error{constructor(L,ee=n.FileSystemProviderErrorCode.Unknown,we){var We;super(D.URI.isUri(L)?L.toString(!0):L);this.code=(We=we==null?void 0:we.name)!==null&&We!==void 0?We:"Unknown",(0,n.markAsFileSystemProviderError)(this,ee),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}static FileExists(L){return new w(L,n.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(L){return new w(L,n.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(L){return new w(L,n.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(L){return new w(L,n.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(L){return new w(L,n.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(L){return new w(L,n.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}};kt=w=je([I],kt),e.FileSystemError=kt;let Rt=class{constructor(L,ee,we){this.start=L,this.end=ee,this.kind=we}};Rt=je([I],Rt),e.FoldingRange=Rt;var en;(function(O){O[O.Comment=1]="Comment",O[O.Imports=2]="Imports",O[O.Region=3]="Region"})(en=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hn;(function(O){O[O.Collapsed=0]="Collapsed",O[O.Expanded=1]="Expanded"})(hn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var tn;(function(O){O[O.Editing=0]="Editing",O[O.Preview=1]="Preview"})(tn=e.CommentMode||(e.CommentMode={}));class fn{constructor(L,ee=[]){this.tokenTypes=L,this.tokenModifiers=ee}}e.SemanticTokensLegend=fn;function nn(O){return typeof O=="undefined"||(0,S.isStringArray)(O)}class Pt{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let ee=0,we=L.tokenTypes.length;ee<we;ee++)this._tokenTypeStrToInt.set(L.tokenTypes[ee],ee);for(let ee=0,we=L.tokenModifiers.length;ee<we;ee++)this._tokenModifierStrToInt.set(L.tokenModifiers[ee],ee)}}push(L,ee,we,We,Ye){if(typeof L=="number"&&typeof ee=="number"&&typeof we=="number"&&typeof We=="number"&&(typeof Ye=="number"||typeof Ye=="undefined"))return typeof Ye=="undefined"&&(Ye=0),this._pushEncoded(L,ee,we,We,Ye);if(R.isRange(L)&&typeof ee=="string"&&nn(we))return this._push(L,ee,we);throw(0,k.illegalArgument)()}_push(L,ee,we){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ee))throw new Error("`tokenType` is not in the provided legend");const We=L.start.line,Ye=L.start.character,ot=L.end.character-L.start.character,ht=this._tokenTypeStrToInt.get(ee);let St=0;if(we)for(const Ct of we){if(!this._tokenModifierStrToInt.has(Ct))throw new Error("`tokenModifier` is not in the provided legend");const It=this._tokenModifierStrToInt.get(Ct);St|=1<<It>>>0}this._pushEncoded(We,Ye,ot,ht,St)}_pushEncoded(L,ee,we,We,Ye){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let Ct=0,It=0;for(let At=0;At<St;At++){let Ft=this._data[5*At],Xt=this._data[5*At+1];Ft===0?(Ft=Ct,Xt+=It):Ft+=Ct,this._data[5*At]=Ft,this._data[5*At+1]=Xt,Ct=Ft,It=Xt}}let ot=L,ht=ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=we,this._data[this._dataLen++]=We,this._data[this._dataLen++]=Ye,this._prevLine=L,this._prevChar=ee}static _sortAndDeltaEncode(L){let ee=[];const we=L.length/5|0;for(let ht=0;ht<we;ht++)ee[ht]=ht;ee.sort((ht,St)=>{const Ct=L[5*ht],It=L[5*St];if(Ct===It){const At=L[5*ht+1],Ft=L[5*St+1];return At-Ft}return Ct-It});const We=new Uint32Array(L.length);let Ye=0,ot=0;for(let ht=0;ht<we;ht++){const St=5*ee[ht],Ct=L[St+0],It=L[St+1],At=L[St+2],Ft=L[St+3],Xt=L[St+4],kn=Ct-Ye,Tn=kn===0?It-ot:It,Zt=5*ht;We[Zt+0]=kn,We[Zt+1]=Tn,We[Zt+2]=At,We[Zt+3]=Ft,We[Zt+4]=Xt,Ye=Ct,ot=It}return We}build(L){return this._dataIsSortedAndDeltaEncoded?new jt(new Uint32Array(this._data),L):new jt(Pt._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=Pt;class jt{constructor(L,ee){this.resultId=ee,this.data=L}}e.SemanticTokens=jt;class qt{constructor(L,ee,we){this.start=L,this.deleteCount=ee,this.data=we}}e.SemanticTokensEdit=qt;class Kt{constructor(L,ee){this.resultId=ee,this.edits=L}}e.SemanticTokensEdits=Kt;var mn;(function(O){O[O.Separate=0]="Separate",O[O.MergeWithParent=1]="MergeWithParent"})(mn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var gn;(function(O){O[O.Initial=1]="Initial",O[O.Dynamic=2]="Dynamic"})(gn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Dt=class{constructor(){}};Dt.Back={iconPath:new st("arrow-left")},Dt=je([I],Dt),e.QuickInputButtons=Dt;var pn;(function(O){O[O.UI=1]="UI",O[O.Workspace=2]="Workspace"})(pn=e.ExtensionKind||(e.ExtensionKind={}));class vn{constructor(L,ee,we){this.badge=L,this.tooltip=ee,this.color=we}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=vn;let Gt=class{constructor(L){this.kind=L}};Gt=je([I],Gt),e.ColorTheme=Gt;var bn;(function(O){O[O.Light=1]="Light",O[O.Dark=2]="Dark",O[O.HighContrast=3]="HighContrast"})(bn=e.ColorThemeKind||(e.ColorThemeKind={}));class Nt{constructor(L,ee){if(L<0)throw(0,k.illegalArgument)("start must be positive");if(ee<L)throw(0,k.illegalArgument)("end cannot be smaller than start");this._start=L,this._end=ee}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let ee=this._start,we=this._end;return L.start!==void 0&&(ee=L.start),L.end!==void 0&&(we=L.end),ee===this._start&&we===this._end?this:new Nt(ee,we)}}e.NotebookCellRange=Nt;class Wt{constructor(L,ee,we,We,Ye,ot){this.editable=L,this.breakpointMargin=ee,this.statusMessage=we,this.inputCollapsed=We,this.outputCollapsed=Ye,this.custom=ot}with(L){let{editable:ee,breakpointMargin:we,statusMessage:We,inputCollapsed:Ye,outputCollapsed:ot,custom:ht}=L;return ee===void 0?ee=this.editable:ee===null&&(ee=void 0),we===void 0?we=this.breakpointMargin:we===null&&(we=void 0),We===void 0?We=this.statusMessage:We===null&&(We=void 0),Ye===void 0?Ye=this.inputCollapsed:Ye===null&&(Ye=void 0),ot===void 0?ot=this.outputCollapsed:ot===null&&(ot=void 0),ht===void 0?ht=this.custom:ht===null&&(ht=void 0),ee===this.editable&&we===this.breakpointMargin&&We===this.statusMessage&&Ye===this.inputCollapsed&&ot===this.outputCollapsed&&ht===this.custom?this:new Wt(ee,we,We,Ye,ot,ht)}}e.NotebookCellMetadata=Wt;class Ut{constructor(L=!0,ee=!0,we={},We=!0){this.editable=L,this.cellEditable=ee,this.custom=we,this.trusted=We}with(L){let{editable:ee,cellEditable:we,custom:We,trusted:Ye}=L;return ee===void 0?ee=this.editable:ee===null&&(ee=void 0),we===void 0?we=this.cellEditable:we===null&&(we=void 0),We===void 0?We=this.custom:We===null&&(We=void 0),Ye===void 0?Ye=this.trusted:Ye===null&&(Ye=void 0),ee===this.editable&&we===this.cellEditable&&We===this.custom&&Ye===this.trusted?this:new Ut(ee,we,We,Ye)}}e.NotebookDocumentMetadata=Ut;class Qt{constructor(L,ee,we,We,Ye,ot){this.kind=L,this.source=ee,this.language=we,this.outputs=We!=null?We:[],this.metadata=Ye,this.latestExecutionSummary=ot}}e.NotebookCellData=Qt;class Te{constructor(L,ee){this.cells=L,this.metadata=ee!=null?ee:new Ut}}e.NotebookData=Te;class xt{constructor(L,ee,we){this.mime=L,this.value=ee,this.metadata=we}static isNotebookCellOutputItem(L){return L instanceof xt}}e.NotebookCellOutputItem=xt;class Jt{constructor(L,ee,we){this.outputs=L,typeof ee=="string"?(this.id=ee,this.metadata=we):(this.id=(0,y.generateUuid)(),this.metadata=ee!=null?ee:we)}}e.NotebookCellOutput=Jt;var mt;(function(O){O[O.Markdown=1]="Markdown",O[O.Code=2]="Code"})(mt=e.NotebookCellKind||(e.NotebookCellKind={}));var _n;(function(O){O[O.Idle=1]="Idle",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(_n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var wn;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(wn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var rn;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(rn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class sn{constructor(L,ee,we,We,Ye,ot){this.text=L,this.alignment=ee,this.command=we,this.tooltip=We,this.priority=Ye,this.accessibilityInformation=ot}}e.NotebookCellStatusBarItem=sn;let Yt=class{constructor(L,ee){this.label=L,this.timestamp=ee}};Yt=je([I],Yt),e.TimelineItem=Yt;var En;(function(O){O[O.Production=1]="Production",O[O.Development=2]="Development",O[O.Test=3]="Test"})(En=e.ExtensionMode||(e.ExtensionMode={}));var yn;(function(O){O[O.Node=1]="Node",O[O.Webworker=2]="Webworker"})(yn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Sn;(function(O){O[O.Other=0]="Other",O[O.Comment=1]="Comment",O[O.String=2]="String",O[O.RegEx=4]="RegEx"})(Sn=e.StandardTokenType||(e.StandardTokenType={}));class on{constructor(L,ee){this.ranges=L,this.wordPattern=ee}}e.LinkedEditingRanges=on;var Dn;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(Dn=e.TestResultState||(e.TestResultState={}));var an;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information",O[O.Hint=3]="Hint"})(an=e.TestMessageSeverity||(e.TestMessageSeverity={})),e.TestItemHookProperty=Symbol("TestItemHookProperty");const Ht=(O,L,ee)=>{let we=ee;return{enumerable:!0,configurable:!1,get(){return we},set(We){var Ye;(Ye=O[e.TestItemHookProperty])===null||Ye===void 0||Ye.setProp(L,We),we=We}}};class ln{constructor(L){f.set(this,new Map),r.set(this,void 0),et(this,r,L,"f")}get size(){return xe(this,f,"f").size}add(L){const ee=xe(this,f,"f"),we=xe(this,r,"f").call(this),We=ee.get(L.id);We!==L&&(We&&(we==null||we.delete(L.id)),ee.set(L.id,L),we==null||we.created(L))}get(L){return xe(this,f,"f").get(L)}clear(){for(const L of xe(this,f,"f").keys())this.delete(L)}delete(L){var ee;const we=typeof L=="string"?L:L.id;xe(this,f,"f").has(we)&&(xe(this,f,"f").delete(we),(ee=xe(this,r,"f").call(this))===null||ee===void 0||ee.delete(we))}toJSON(){return[...xe(this,f,"f").values()]}[(f=new WeakMap,r=new WeakMap,Symbol.iterator)](){return xe(this,f,"f").values()}}e.TestChildrenCollection=ln;class Cn{constructor(L,ee,we,We){this.label=ee,this.expandable=We,Object.defineProperties(this,{id:{value:L,enumerable:!0,writable:!1},uri:{value:we,enumerable:!0,writable:!1},children:{value:new ln(()=>this[e.TestItemHookProperty]),enumerable:!0,writable:!1},[e.TestItemHookProperty]:{enumerable:!1,writable:!0,configurable:!1},range:Ht(this,"range",void 0),description:Ht(this,"description",void 0),runnable:Ht(this,"runnable",!0),debuggable:Ht(this,"debuggable",!0)})}invalidate(){var L;(L=this[e.TestItemHookProperty])===null||L===void 0||L.invalidate(this.id)}discoverChildren(L,ee){L.report({busy:!1})}}e.TestItem=Cn;class J{constructor(L){this.message=L,this.severity=an.Error}static diff(L,ee,we){const We=new J(L);return We.expectedOutput=ee,We.actualOutput=we,We}}e.TestMessage=J;var de;(function(O){O[O.None=0]="None",O[O.Option=1]="Option",O[O.Default=2]="Default",O[O.Preferred=3]="Preferred"})(de=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ke;(function(O){O[O.Untrusted=0]="Untrusted",O[O.Trusted=1]="Trusted",O[O.Unspecified=2]="Unspecified"})(ke=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ut;(function(O){O[O.Notify=1]="Notify",O[O.OpenBrowser=2]="OpenBrowser",O[O.OpenPreview=3]="OpenPreview",O[O.Silent=4]="Silent",O[O.Ignore=5]="Ignore"})(ut=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ve[94],_e([0,1,42,18,8,118,84,7,11]),function(ie,e,E,k,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const n=new Map;function T(r,s){s?n.set(r,s):n.delete(r)}e.setWordDefinitionFor=T;function C(r){return n.get(r)}e.getWordDefinitionFor=C;class g extends A.MirrorTextModel{constructor(s,b,h,_,v,c,u,t){super(b,h,_,v);this._proxy=s,this._languageId=c,this._isDirty=u,this._notebook=t,this._isDisposed=!1}dispose(){(0,E.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(s){return(0,y.equals)(this._lines,s)}get document(){if(!this._document){const s=this;this._document={get uri(){return s._uri},get fileName(){return s._uri.fsPath},get isUntitled(){return s._uri.scheme===k.Schemas.untitled},get languageId(){return s._languageId},get version(){return s._versionId},get isClosed(){return s._isDisposed},get isDirty(){return s._isDirty},get notebook(){return s._notebook},save(){return s._save()},getText(b){return b?s._getTextInRange(b):s.getText()},get eol(){return s._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return s._lines.length},lineAt(b){return s._lineAt(b)},offsetAt(b){return s._offsetAt(b)},positionAt(b){return s._positionAt(b)},validateRange(b){return s._validateRange(b)},validatePosition(b){return s._validatePosition(b)},getWordRangeAtPosition(b,h){return s._getWordRangeAtPosition(b,h)}}}return Object.freeze(this._document)}_acceptLanguageId(s){(0,E.ok)(!this._isDisposed),this._languageId=s}_acceptIsDirty(s){(0,E.ok)(!this._isDisposed),this._isDirty=s}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(s){const b=this._validateRange(s);if(b.isEmpty)return"";if(b.isSingleLine)return this._lines[b.start.line].substring(b.start.character,b.end.character);const h=this._eol,_=b.start.line,v=b.end.line,c=[];c.push(this._lines[_].substring(b.start.character));for(let u=_+1;u<v;u++)c.push(this._lines[u]);return c.push(this._lines[v].substring(0,b.end.character)),c.join(h)}_lineAt(s){let b;if(s instanceof D.Position?b=s.line:typeof s=="number"&&(b=s),typeof b!="number"||b<0||b>=this._lines.length||Math.floor(b)!==b)throw new Error("Illegal value for `line`");return new f(b,this._lines[b],b===this._lines.length-1)}_offsetAt(s){return s=this._validatePosition(s),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(s.line-1)+s.character}_positionAt(s){s=Math.floor(s),s=Math.max(0,s),this._ensureLineStarts();const b=this._lineStarts.getIndexOf(s),h=this._lines[b.index].length;return new D.Position(b.index,Math.min(b.remainder,h))}_validateRange(s){if(!(s instanceof D.Range))throw new Error("Invalid argument");const b=this._validatePosition(s.start),h=this._validatePosition(s.end);return b===s.start&&h===s.end?s:new D.Range(b.line,b.character,h.line,h.character)}_validatePosition(s){if(!(s instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return s.with(0,0);let{line:b,character:h}=s,_=!1;if(b<0)b=0,h=0,_=!0;else if(b>=this._lines.length)b=this._lines.length-1,h=this._lines[b].length,_=!0;else{const v=this._lines[b].length;h<0?(h=0,_=!0):h>v&&(h=v,_=!0)}return _?new D.Position(b,h):s}_getWordRangeAtPosition(s,b){const h=this._validatePosition(s);if(!b)b=C(this._languageId);else if((0,P.regExpLeadsToEndlessLoop)(b))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${b.source}' because it matches the empty string.`);const _=(0,S.getWordAtText)(h.character+1,(0,S.ensureValidWordDefinition)(b),this._lines[h.line],0);if(_)return new D.Range(h.line,_.startColumn-1,h.line,_.endColumn-1)}}e.ExtHostDocumentData=g;class f{constructor(s,b,h){this._line=s,this._text=b,this._isLastLine=h}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(ve[162],_e([0,1,7,3,86,6,59,22,2,29]),function(ie,e,E,k,P,A,S,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class T{constructor(g,f,r,s){this._notebook=r,this._selector=s,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,n.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(h=>{const _=this._cellUris.get(h.document.uri);_!==void 0&&(this._cellLengths.changeValue(_,this._cells[_].document.getText().length+1),this._cellLines.changeValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const b=h=>{h===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(g.onDidChangeNotebookCells(h=>b(h.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new D.ResourceMap;const g=[],f=[];for(const r of this._notebook.getCells())r.kind===E.NotebookCellKind.Code&&(!this._selector||(0,S.score)(this._selector,r.document.uri,r.document.languageId,!0))&&(this._cellUris.set(r.document.uri,this._cells.length),this._cells.push(r),g.push(r.document.getText().length+1),f.push(r.document.lineCount));this._cellLengths=new P.PrefixSumComputer(new Uint32Array(g)),this._cellLines=new P.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(g){var f,r;if(!g){let v="";for(const c of this._cells)v+=c.document.getText()+`
`;return v=v.slice(0,-1),v}if(g.isEmpty)return"";const s=this.locationAt(g.start),b=this.locationAt(g.end),h=this._cells[(f=this._cellUris.get(s.uri))!==null&&f!==void 0?f:-1],_=this._cells[(r=this._cellUris.get(b.uri))!==null&&r!==void 0?r:-1];if(!h||!_)return"";if(h===_)return h.document.getText(new E.Range(s.range.start,b.range.end));{const v=h.document.getText(new E.Range(s.range.start,new E.Position(h.document.lineCount,0))),c=_.document.getText(new E.Range(new E.Position(0,0),b.range.end));return v+`
`+c}}offsetAt(g){const f=this._cellLines.getIndexOf(g.line),r=this._cellLengths.getAccumulatedValue(f.index-1),s=this._cells[f.index].document.offsetAt(g.with(f.remainder));return r+s}positionAt(g){if(typeof g=="number"){const r=this._cellLengths.getIndexOf(g),s=this._cellLines.getAccumulatedValue(r.index-1);return this._cells[r.index].document.positionAt(r.remainder).translate(s)}const f=this._cellUris.get(g.uri);if(f!==void 0){const r=this._cellLines.getAccumulatedValue(f-1);return new E.Position(r+g.range.start.line,g.range.start.character)}return new E.Position(0,0)}locationAt(g){E.Range.isRange(g)||(g=new E.Range(g,g));const f=this._cellLines.getIndexOf(g.start.line);let r=f;g.isEmpty||(r=this._cellLines.getIndexOf(g.end.line));const s=new E.Position(f.remainder,g.start.character),b=new E.Position(r.remainder,g.end.character),h=new E.Range(s,b),_=this._cells[f.index];return new E.Location(_.document.uri,_.document.validateRange(h))}contains(g){return this._cellUris.has(g)}validateRange(g){const f=this.validatePosition(g.start),r=this.validatePosition(g.end);return g.with(f,r)}validatePosition(g){const f=this._cellLines.getIndexOf(g.line),r=new E.Position(f.remainder,g.character),s=this._cells[f.index].document.validatePosition(r),b=this._cellLines.getAccumulatedValue(f.index-1);return new E.Position(b+s.line,s.character)}}e.ExtHostNotebookConcatDocument=T}),define(ve[163],_e([0,1,7,15,3]),function(ie,e,E,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(D){this._actual=new E.ColorTheme(E.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new P.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let y=D==="light"?E.ColorThemeKind.Light:D==="dark"?E.ColorThemeKind.Dark:E.ColorThemeKind.HighContrast;this._actual=new E.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=je([Ke(0,k.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(ve[69],_e([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,E.createDecorator)("IURITransformerService");class k{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=S=>S,this.transformOutgoing=S=>S,this.transformOutgoingURI=S=>S,this.transformOutgoingScheme=S=>S)}}e.URITransformerService=k}),define(ve[164],_e([0,1,23]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class k{constructor(){this.buffers=[]}add(y){let n=this.buffers.indexOf(y);return n<0&&(n=this.buffers.length,this.buffers.push(y)),n}}function P(D,y){if(y){const n=new k,T=(f,r)=>{if(r instanceof ArrayBuffer){const s=n.add(r);return{$$vscode_array_buffer_reference$$:!0,index:s}}else if(ArrayBuffer.isView(r)){const s=A(r);if(s){const b=n.add(r.buffer);return{$$vscode_array_buffer_reference$$:!0,index:b,view:{type:s,byteLength:r.byteLength,byteOffset:r.byteOffset}}}}return r},C=JSON.stringify(D,T),g=n.buffers.map(f=>{const r=new Uint8Array(f);return E.VSBuffer.wrap(r)});return{message:C,buffers:g}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=P;function A(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function S(D,y){const n=y.map(g=>{const f=new ArrayBuffer(g.byteLength);return new Uint8Array(f).set(g.buffer),f}),T=y.length?(g,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const r=f,{index:s}=r,b=n[s];if(r.view)switch(r.view.type){case 1:return new Int8Array(b,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(b,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(b,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(b,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(b,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(b,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(b,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(b,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(b,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(b,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(b,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return b}return f}:void 0;return{message:JSON.parse(D,T),arrayBuffers:n}}e.deserializeWebviewMessage=S}),define(ve[70],_e([0,1,2]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function k(A,S,D){const y=A.webviewResourceRoot.replace("{{resource}}",D.scheme+P(D)).replace("{{uuid}}",S);return E.URI.parse(y)}e.asWebviewUri=k;function P(A){return A.toString().replace(/^\S+?:/,"")}}),define(ve[165],_e([0,1,3,6,70,29]),function(ie,e,E,k,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class S{constructor(y,n,T){this._proxy=y,this._editors=n,this._initData=T,this._handlePool=0,this._disposables=new k.DisposableStore,this._insets=new Map,this._disposables.add(n.onDidChangeVisibleTextEditors(()=>{const C=n.getVisibleTextEditors();for(const g of this._insets.values())C.indexOf(g.editor)<0&&g.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,n,T,C,g){let f;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===y){f=c;break}if(!f)throw new Error("not a visible editor");const r=this,s=this._handlePool++,b=new E.Emitter,h=new E.Emitter,_=new class{constructor(){this._uuid=(0,A.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,P.asWebviewUri)(r._initData,this._uuid,c)}get cspSource(){return r._initData.webviewCspSource}set options(c){this._options=c,r._proxy.$setOptions(s,c)}get options(){return this._options}set html(c){this._html=c,r._proxy.$setHtml(s,c)}get html(){return this._html}get onDidReceiveMessage(){return b.event}postMessage(c){return r._proxy.$postMessage(s,c)}},v=new class{constructor(){this.editor=y,this.line=n,this.height=T,this.webview=_,this.onDidDispose=h.event}dispose(){r._insets.has(s)&&(r._insets.delete(s),r._proxy.$disposeEditorInset(s),h.fire(),h.dispose(),b.dispose())}};return this._proxy.$createEditorInset(s,f.id,f.value.document.uri,n+1,T,C||{},g.identifier,g.extensionLocation),this._insets.set(s,{editor:y,inset:v,onDidReceiveMessage:b}),v}$onDidDispose(y){const n=this._insets.get(y);n&&n.inset.dispose()}$onDidReceiveMessage(y,n){const T=this._insets.get(y);T&&T.onDidReceiveMessage.fire(n)}}e.ExtHostEditorInsets=S}),define(ve[166],_e([0,1,3,63,137,4,6,22,30,11,50,24,36,157]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",g.Codicon.window,(0,P.localize)(0,null));var r;(function(l){l.ViewContainersRegistry="workbench.registry.view.containers",l.ViewsRegistry="workbench.registry.view"})(r=e.Extensions||(e.Extensions={}));var s;(function(l){l[l.Sidebar=0]="Sidebar",l[l.Panel=1]="Panel"})(s=e.ViewContainerLocation||(e.ViewContainerLocation={}));function b(l){switch(l){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=b;function h(l){return`viewContainer.${l}.enabled`}e.getEnabledViewContainerContextKey=h;class _ extends S.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new E.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new E.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,n.flatten)([...this.viewContainers.values()])}registerViewContainer(o,w,I){var p;const m=this.get(o.id);if(m)return m;const R=o;return R.openCommandActionDescriptor=(I==null?void 0:I.donotRegisterOpenCommand)?void 0:(p=R.openCommandActionDescriptor)!==null&&p!==void 0?p:{id:R.id},(0,D.getOrSet)(this.viewContainers,w,[]).push(R),(I==null?void 0:I.isDefault)&&this.defaultViewContainers.push(R),this._onDidRegister.fire({viewContainer:R,viewContainerLocation:w}),R}deregisterViewContainer(o){for(const w of this.viewContainers.keys()){const I=this.viewContainers.get(w),p=I==null?void 0:I.indexOf(o);if(p!==-1){I==null||I.splice(p,1),I.length===0&&this.viewContainers.delete(w),this._onDidDeregister.fire({viewContainer:o,viewContainerLocation:w});return}}}get(o){return this.all.filter(w=>w.id===o)[0]}getViewContainers(o){return[...this.viewContainers.get(o)||[]]}getViewContainerLocation(o){return[...this.viewContainers.keys()].filter(w=>this.getViewContainers(w).filter(I=>(I==null?void 0:I.id)===o.id).length>0)[0]}getDefaultViewContainer(o){return this.defaultViewContainers.find(w=>this.getViewContainerLocation(w)===o)}}y.Registry.add(r.ViewContainersRegistry,new _);var v;(function(l){l.Open="2_open",l.Debug="4_debug",l.SCM="5_scm",l.More="9_more"})(v=e.ViewContentGroups||(e.ViewContentGroups={}));function c(l,o){var w,I,p,m;const R=(w=l.group)!==null&&w!==void 0?w:v.More,F=(I=o.group)!==null&&I!==void 0?I:v.More;return R!==F?R.localeCompare(F):((p=l.order)!==null&&p!==void 0?p:5)-((m=o.order)!==null&&m!==void 0?m:5)}class u extends S.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new E.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new E.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new E.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new E.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new T.SetMap}registerViews(o,w){this.registerViews2([{views:o,viewContainer:w}])}registerViews2(o){o.forEach(({views:w,viewContainer:I})=>this.addViews(w,I)),this._onViewsRegistered.fire(o)}deregisterViews(o,w){const I=this.removeViews(o,w);I.length&&this._onViewsDeregistered.fire({views:I,viewContainer:w})}moveViews(o,w){for(const I of this._views.keys())if(I!==w){const p=this.removeViews(o,I);p.length&&(this.addViews(p,w),this._onDidChangeContainer.fire({views:p,from:I,to:w}))}}getViews(o){return this._views.get(o)||[]}getView(o){for(const w of this._viewContainers){const I=(this._views.get(w)||[]).filter(p=>p.id===o)[0];if(I)return I}return null}getViewContainer(o){for(const w of this._viewContainers)if((this._views.get(w)||[]).filter(p=>p.id===o)[0])return w;return null}registerViewWelcomeContent(o,w){return this._viewWelcomeContents.add(o,w),this._onDidChangeViewWelcomeContent.fire(o),(0,S.toDisposable)(()=>{this._viewWelcomeContents.delete(o,w),this._onDidChangeViewWelcomeContent.fire(o)})}registerViewWelcomeContent2(o,w){const I=new Map;for(const[p,m]of w)this._viewWelcomeContents.add(o,m),I.set(p,(0,S.toDisposable)(()=>{this._viewWelcomeContents.delete(o,m),this._onDidChangeViewWelcomeContent.fire(o)}));return this._onDidChangeViewWelcomeContent.fire(o),I}getViewWelcomeContent(o){const w=[];return this._viewWelcomeContents.forEach(o,I=>w.push(I)),w.sort(c)}addViews(o,w){let I=this._views.get(w);I||(I=[],this._views.set(w,I),this._viewContainers.push(w));for(const p of o){if(this.getView(p.id)!==null)throw new Error((0,P.localize)(1,null,p.id));I.push(p)}}removeViews(o,w){const I=this._views.get(w);if(!I)return[];const p=[],m=[];for(const R of I)o.includes(R)?p.push(R):m.push(R);return p.length&&(m.length?this._views.set(w,m):(this._views.delete(w),this._viewContainers.splice(this._viewContainers.indexOf(w),1))),p}}y.Registry.add(r.ViewsRegistry,new u),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new k.RawContextKey("focusedView","",(0,P.localize)(2,null));function t(l){return`view.${l}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var i;(function(l){l[l.Default=0]="Default",l[l.Expand=1]="Expand"})(i=e.ViewVisibilityState||(e.ViewVisibilityState={}));var d;(function(l){l[l.None=0]="None",l[l.Collapsed=1]="Collapsed",l[l.Expanded=2]="Expanded"})(d=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class a{constructor(o,w){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,o),this._hasResolve=!!w,this.resolve=async I=>{var p,m;if(w&&!this.resolved){const R=await w(I);R&&(this.tooltip=(p=this.tooltip)!==null&&p!==void 0?p:R.tooltip,this.command=(m=this.command)!==null&&m!==void 0?m:R.command)}I.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=a}),define(ve[167],_e([0,1,2,147,158,19,148,166]),function(ie,e,E,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function y(s){return(b,...h)=>s(b.get(k.ICommandService),...h)}class n{static execute(b,h){const _={forceReuseWindow:h&&h.reuseWindow,remoteAuthority:h&&h.remoteAuthority};return b.executeCommand("_files.newWindow",_)}}e.NewWindowAPICommand=n,n.ID="vscode.newWindow",k.CommandsRegistry.registerCommand({id:n.ID,handler:y(n.execute),description:{description:"Opens an new window",args:[]}}),k.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(s,b){return s.get(P.IWorkspacesService).removeRecentlyOpened([b])});class T{static execute(b,h){return typeof h=="string"?h=h.match(/^[^:/?#]+:\/\//)?E.URI.parse(h):E.URI.file(h):h=E.URI.revive(h),b.executeCommand("_workbench.removeFromRecentlyOpened",h)}}e.RemoveFromRecentlyOpenedAPICommand=T,T.ID="vscode.removeFromRecentlyOpened",k.CommandsRegistry.registerCommand(T.ID,y(T.execute));class C{static execute(b,h){const _=typeof h=="string"?{extensionId:h}:h;return b.executeCommand("workbench.action.openIssueReporter",_)}}e.OpenIssueReporter=C,C.ID="vscode.openIssueReporter",k.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(s,b){const h=s.get(P.IWorkspacesService);let _;const v=b.uri,c=b.label,u=b.remoteAuthority;return b.type==="workspace"?_={workspace:await h.getWorkspaceIdentifier(v),label:c,remoteAuthority:u}:b.type==="folder"?_={folderUri:v,label:c,remoteAuthority:u}:_={fileUri:v,label:c,remoteAuthority:u},h.addRecentlyOpened([_])}),k.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(s){return s.get(P.IWorkspacesService).getRecentlyOpened()}),k.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(s,b){const h=s.get(A.ILogService),_=s.get(S.IEnvironmentService);_.isExtensionDevelopment&&!!_.extensionTestsLocationURI&&h.setLevel(b)}),k.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(s){return s.get(A.ILogService).getLevel()}),k.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(s,b){const h=s.get(D.IViewDescriptorService),_=h.getViewContainerById(b.destinationId);if(!!_){for(const v of b.viewIds){const c=h.getViewDescriptorById(v);(c==null?void 0:c.canMoveView)&&h.moveViewsToContainer([c],_,D.ViewVisibilityState.Default)}await s.get(D.IViewsService).openViewContainer(_.id,!0)}});class g{static execute(b,h){return!Array.isArray(h==null?void 0:h.viewIds)||typeof(h==null?void 0:h.destinationId)!="string"?Promise.reject("Invalid arguments"):b.executeCommand("_workbench.action.moveViews",h)}}e.MoveViewsAPICommand=g,g.ID="vscode.moveViews",k.CommandsRegistry.registerCommand({id:g.ID,handler:y(g.execute),description:{description:"Move Views",args:[]}});class f{static execute(b,h){return b.executeCommand("_workbench.open",h)}}f.ID="vscode.open",k.CommandsRegistry.registerCommand(f.ID,y(f.execute));class r{static execute(b,h,_,v,c){return b.executeCommand("_workbench.diff",[h,_,v])}}r.ID="vscode.diff",k.CommandsRegistry.registerCommand(r.ID,y(r.execute))}),define(ve[168],_e([0,1,3,14,138]),function(ie,e,E,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new E.Emitter,this._onExit=new E.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,y,n,T){const C={command:D};if(y&&Object.keys(y).length>0&&(C.arguments=y),this.internalSend("request",C),typeof T=="number"){const g=setTimeout(()=>{clearTimeout(g);const f=this.pendingRequests.get(C.seq);if(f){this.pendingRequests.delete(C.seq);const r={type:"response",seq:0,request_seq:C.seq,success:!1,command:D,message:(0,P.localize)(0,null,T,D)};f(r)}},T)}return n&&this.pendingRequests.set(C.seq,n),C.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,y){return D.type!=="event"||y.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,k.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":const y=D,n=this.pendingRequests.get(y.request_seq);n&&(this.pendingRequests.delete(y.request_seq),n(y));break}}}internalSend(D,y){y.type=D,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((y,n)=>D.set(n,y)),await(0,k.timeout)(500),D.forEach((y,n)=>{y({type:"response",seq:0,request_seq:n,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(n)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(ve[169],_e([0,1,8,2,12,24,18]),function(ie,e,E,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function y(i,d,a){return i.replace(D,function(l,o){return d&&o.length>0&&o[0]!=="_"?l:a&&a.hasOwnProperty(o)?a[o]:l})}e.formatPII=y;function n(i){const d={};for(const a of Object.keys(i))a.startsWith("!")||(d[a]=i[a]);return d}e.filterExceptionsFromTelemetry=n;function T(i){return i.configuration.request==="attach"&&!C(i)}e.isSessionAttach=T;function C(i){let d=i.configuration.type;if(!!d)return d==="vslsShare"&&(d=i.configuration.adapterProxy.configuration.type),(0,E.equalsIgnoreCase)(d,"extensionhost")||(0,E.equalsIgnoreCase)(d,"pwa-extensionhost")?i:i.parentSession?C(i.parentSession):void 0}e.getExtensionHostDebugSession=C;function g(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=g;function f(i,d,a){let l,o=0,w=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,I=null;for(;I=w.exec(i);){let p=I.index+1,m=p+I[0].length;if(p<=d&&m>=a){l=I[0],o=p;break}}if(l){let p=/\w+/g,m=null;for(;(m=p.exec(l))&&!(m.index+1+o+m[0].length>=a););m&&(l=l.substring(0,p.lastIndex))}return l?{start:o,end:o+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function s(i){return!!(i&&i.match(r))}e.isUri=s;function b(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(s(i.path))return k.URI.parse(i.path);if((0,P.isAbsolute)(i.path))return k.URI.file(i.path)}return i.path}function h(i){if(typeof i.path=="object"){const d=k.URI.revive(i.path);if(d)return d.scheme===S.Schemas.file?d.fsPath:d.toString()}return i.path}function _(i,d){const a=d?b:h,l=(0,A.deepClone)(i);return c(l,(o,w)=>{o&&w&&(w.path=a(w))}),l}e.convertToDAPaths=_;function v(i,d){const a=d?b:h,l=(0,A.deepClone)(i);return c(l,(o,w)=>{!o&&w&&(w.path=a(w))}),l}e.convertToVSCPaths=v;function c(i,d){switch(i.type){case"event":const a=i;switch(a.event){case"output":d(!1,a.body.source);break;case"loadedSource":d(!1,a.body.source);break;case"breakpoint":d(!1,a.body.breakpoint.source);break;default:break}break;case"request":const l=i;switch(l.command){case"setBreakpoints":d(!0,l.arguments.source);break;case"breakpointLocations":d(!0,l.arguments.source);break;case"source":d(!0,l.arguments.source);break;case"gotoTargets":d(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(w=>d(!1,w));break;default:break}break;case"response":const o=i;if(o.success&&o.body)switch(o.command){case"stackTrace":o.body.stackFrames.forEach(w=>d(!1,w.source));break;case"loadedSources":o.body.sources.forEach(w=>d(!1,w));break;case"scopes":o.body.scopes.forEach(w=>d(!1,w.source));break;case"setFunctionBreakpoints":o.body.breakpoints.forEach(w=>d(!1,w.source));break;case"setBreakpoints":o.body.breakpoints.forEach(w=>d(!1,w.source));break;default:break}break}}function u(i){return i.filter(d=>{var a;return!((a=d.presentation)===null||a===void 0?void 0:a.hidden)}).sort((d,a)=>d.presentation?a.presentation?d.presentation.group?a.presentation.group?d.presentation.group!==a.presentation.group?d.presentation.group.localeCompare(a.presentation.group):t(d.presentation.order,a.presentation.order):-1:a.presentation.group?1:t(d.presentation.order,a.presentation.order):-1:a.presentation?1:0)}e.getVisibleAndSorted=u;function t(i,d){return typeof i!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:i-d}}),define(ve[71],_e([0,1,28,18,12,21,63]),function(ie,e,E,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(F){F[F.Markdown=1]="Markdown",F[F.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,cellEditable:!0,custom:{},trusted:!0};var n;(function(F){F[F.Idle=1]="Idle",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var T;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(T=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var C;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.CellClearOutput=3]="CellClearOutput",F[F.CellsClearOutput=4]="CellsClearOutput",F[F.ChangeLanguage=5]="ChangeLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.Unknown=12]="Unknown"})(C=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.OutputsSplice=6]="OutputsSplice",F[F.Move=7]="Move",F[F.Unknown=8]="Unknown",F[F.CellContent=9]="CellContent",F[F.OutputItems=10]="OutputItems",F[F.PartialMetadata=11]="PartialMetadata"})(f=e.CellEditType||(e.CellEditType={}));function r(F){const x=s.parse(F);return x?x.notebook.toString():F.toString()}e.getCellUndoRedoComparisonKey=r;var s;(function(F){F.scheme=k.Schemas.vscodeNotebookCell;const x=/^ch(\d{7,})/;function ae(M,N){return M.with({scheme:F.scheme,fragment:`ch${N.toString().padStart(7,"0")}${M.scheme!==k.Schemas.file?M.scheme:""}`})}F.generate=ae;function z(M){if(M.scheme===F.scheme){const N=x.exec(M.fragment);if(!!N)return{handle:Number(N[1]),notebook:M.with({scheme:M.fragment.substr(N[0].length)||k.Schemas.file,fragment:null})}}}F.parse=z;function B(M,N){return M.with({scheme:k.Schemas.vscodeNotebookCellMetadata,fragment:`ch${N.toString().padStart(7,"0")}${M.scheme!==k.Schemas.file?M.scheme:""}`})}F.generateCellMetadataUri=B;function G(M){if(M.scheme===k.Schemas.vscodeNotebookCellMetadata){const N=x.exec(M.fragment);if(!!N)return{handle:Number(N[1]),notebook:M.with({scheme:M.fragment.substr(N[0].length)||k.Schemas.file,fragment:null})}}}F.parseCellMetadataUri=G})(s=e.CellUri||(e.CellUri={}));const b=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function h(F){var x,ae;return(ae=(x=b.get(F))===null||x===void 0?void 0:x.alwaysSecure)!==null&&ae!==void 0?ae:!1}e.mimeTypeIsAlwaysSecure=h;function _(F){var x,ae;return(ae=(x=b.get(F))===null||x===void 0?void 0:x.supportedByCore)!==null&&ae!==void 0?ae:!1}e.mimeTypeSupportedByCore=_;function v(F){var x,ae;return(ae=(x=b.get(F))===null||x===void 0?void 0:x.mergeable)!==null&&ae!==void 0?ae:!1}e.mimeTypeIsMergeable=v;function c(F,x){return A.isWindows&&(F=F.replace(/\//g,"\\"),x=x.replace(/\//g,"\\")),E.match(F,x)}function u(F,x,ae){let z=0;for(let B=0;B<x.length;B++){if(c(x[B],F))return z;z++}for(let B=0;B<ae.length;B++){if(c(ae[B],F))return z;z++}return z}function t(F,x,ae){return F.sort((z,B)=>u(z,x,ae)-u(B,x,ae))}e.sortMimeTypes=t;function i(F,x,ae,z=(B,G)=>B===G){const B=[];function G(W,Q,$){if(!(Q===0&&$.length===0)){const Z=B[B.length-1];Z&&Z.start+Z.deleteCount===W?(Z.deleteCount+=Q,Z.toInsert.push(...$)):B.push({start:W,deleteCount:Q,toInsert:$})}}let M=0,N=0;for(;;){if(M===F.length){G(M,0,x.slice(N));break}if(N===x.length){G(M,F.length-M,[]);break}const W=F[M],Q=x[N];if(z(W,Q)){M+=1,N+=1;continue}ae(Q)?(G(M,1,[]),M+=1):(G(M,0,[Q]),N+=1)}return B}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var d;(function(F){F.default="default",F.option="option"})(d=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(F){const x=F;return!!((typeof x.include=="string"||E.isRelativePattern(x.include))&&(typeof x.exclude=="string"||E.isRelativePattern(x.exclude)))}e.isDocumentExcludePattern=a;function l(F,x,ae){if(Array.isArray(F.viewType)&&F.viewType.indexOf(x)>=0||F.viewType===x)return!0;if(F.filenamePattern){let z=a(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,B=a(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(E.match(z,(0,P.basename)(ae.fsPath).toLowerCase()))return!(B&&E.match(B,(0,P.basename)(ae.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class o{constructor(x){this.textModel=x}getElements(){const x=new Int32Array(this.textModel.cells.length);for(let ae=0;ae<this.textModel.cells.length;ae++)x[ae]=this.textModel.cells[ae].getHashValue();return x}}e.CellSequence=o,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var w;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(w=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function I(F){F.sort((ae,z)=>ae-z);const x=F.shift();return x===void 0?[]:F.reduce(function(ae,z){return z<=ae[0][1]?ae[0][1]=z+1:ae.unshift([z,z+1]),ae},[[x,x+1]]).reverse().map(ae=>({start:ae[0],end:ae[1]}))}e.cellIndexesToRanges=I;function p(F){return F.reduce((ae,z)=>{for(let B=z.start;B<z.end;B++)ae.push(B);return ae},[])}e.cellRangesToIndexes=p;function m(F){const x=F.sort((z,B)=>z.start-B.start),ae=x[0];return ae?x.reduce((z,B)=>{const G=z[z.length-1];return G.end>=B.start?G.end=Math.max(G.end,B.end):z.push(B),z},[ae]):[]}e.reduceRanges=m;function R(F,x){return x.start>=F.start&&x.end<=F.end}e.cellRangeContains=R}),define(ve[170],_e([0,1,140,4,63]),function(ie,e,E,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new P.RawContextKey("customExecutionSupported",!0,E.localize(0,null)),e.ShellExecutionSupportedContext=new P.RawContextKey("shellExecutionSupported",!1,E.localize(1,null)),e.ProcessExecutionSupportedContext=new P.RawContextKey("processExecutionSupported",!1,E.localize(2,null)),e.ITaskService=(0,k.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ve[171],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function E(P){return[...P.entries()]}e.serializeEnvironmentVariableCollection=E;function k(P){return new Map(P)}e.deserializeEnvironmentVariableCollection=k}),define(ve[95],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var E;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));const k=(y,n)=>{n.expand!==void 0&&(y.expand=n.expand),n.item!==void 0&&Object.assign(y.item,n.item)};e.applyTestItemUpdate=k;var P;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.DeltaRootsComplete=3]="DeltaRootsComplete",y[y.Retire=4]="Retire"})(P=e.TestDiffOpType||(e.TestDiffOpType={}));const A=(y,n)=>`${y}:${n.toString()}`;e.getTestSubscriptionKey=A;class S{add(n){}update(n){}remove(n,T){}complete(){}}e.IncrementalChangeCollector=S;class D{constructor(){this.items=new Map,this.roots=new Set,this.busyProviderCount=0,this.pendingRootCount=0}apply(n){const T=this.createChangeCollector();for(const C of n)switch(C[0]){case 0:{const g=C[1];if(g.parent){if(this.items.has(g.parent)){const f=this.items.get(g.parent);f.children.add(g.item.extId);const r=this.createItem(g,f);this.items.set(g.item.extId,r),T.add(r)}}else{this.roots.add(g.item.extId);const f=this.createItem(g);this.items.set(g.item.extId,f),T.add(f)}g.expand===2&&this.updateBusyProviders(1);break}case 1:{const g=C[1],f=this.items.get(g.extId);if(!f)break;(0,e.applyTestItemUpdate)(f,g),T.update(f),g.expand!==void 0&&f.expand===2&&g.expand!==2&&this.updateBusyProviders(-1);break}case 2:{const g=this.items.get(C[1]);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g.item.extId);const f=[[C[1]]];for(;f.length;)for(const r of f.pop()){const s=this.items.get(r);s&&(f.push(s.children),this.items.delete(r),T.remove(s,s!==g),s.expand===2&&this.updateBusyProviders(-1))}break}case 4:this.retireTest(C[1]);break;case 3:this.updatePendingRoots(C[1]);break}T.complete()}retireTest(n){}updateBusyProviders(n){this.busyProviderCount+=n}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new S}}e.AbstractIncrementalTestCollection=D}),define(ve[172],_e([0,1,12,45,13,24,21,58,141]),function(ie,e,E,k,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class n{constructor(C,g,f,r){if(this._contributedVariables=new Map,this._context=C,this._labelService=g,f)if(S.isWindows){const s=Object.create(null);this._envVariables=s,Object.keys(f).forEach(b=>{s[b.toLowerCase()]=f[b]})}else this._envVariables=f}resolveWithEnvironment(C,g,f){return this.recursiveResolve(C,g?g.uri:void 0,f)}async resolveAsync(C,g){return this.recursiveResolve(this._envVariables,C?C.uri:void 0,g)}resolve(C,g){return this.recursiveResolve(this._envVariables,C?C.uri:void 0,g)}resolveAnyBase(C,g,f,r){const s=A.deepClone(g);return S.isWindows&&s.windows?Object.keys(s.windows).forEach(b=>s[b]=s.windows[b]):S.isMacintosh&&s.osx?Object.keys(s.osx).forEach(b=>s[b]=s.osx[b]):S.isLinux&&s.linux&&Object.keys(s.linux).forEach(b=>s[b]=s.linux[b]),delete s.windows,delete s.osx,delete s.linux,this.recursiveResolve(this._envVariables,C?C.uri:void 0,s,f,r)}resolveAny(C,g,f){return this.resolveAnyBase(C,g,f)}async resolveAnyAsync(C,g,f){return this.resolveAnyBase(C,g,f)}resolveAnyMap(C,g,f){const r=new Map;return{newConfig:this.resolveAnyBase(C,g,f,r),resolvedVariables:r}}resolveWithInteractionReplace(C,g,f,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,g,f,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,g){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,g)}recursiveResolve(C,g,f,r,s){if(P.isString(f))return this.resolveString(C,g,f,r,s);if(P.isArray(f))return f.map(b=>this.recursiveResolve(C,g,b,r,s));if(P.isObject(f)){let b=Object.create(null);return Object.keys(f).forEach(h=>{const _=this.resolveString(C,g,h,r,s);b[_]=this.recursiveResolve(C,g,f[h],r,s)}),b}return f}resolveString(C,g,f,r,s){return f.replace(n.VARIABLE_REGEXP,(h,_)=>{if(_.includes(n.VARIABLE_LHS))return h;let v=this.evaluateSingleVariable(C,h,_,g,r);return s&&s.set(_,v),v})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,g,f,r,s){let b;const h=f.split(":");h.length>1&&(f=h[0],b=h[1]);const _=()=>{const u=this._context.getFilePath();if(u)return u;throw new Error((0,y.localize)(0,null,g))},v=()=>{const u=_();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,g,E.basename(u)))},c=()=>{if(b){const u=this._context.getFolderUri(b);if(u)return u;throw new Error((0,y.localize)(2,null,g,b))}if(r)return r;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,g)):new Error((0,y.localize)(4,null,g))};switch(f){case"env":if(b){if(C){const u=C[S.isWindows?b.toLowerCase():b];if(P.isString(u))return u}return""}throw new Error((0,y.localize)(5,null,g));case"config":if(b){const u=this._context.getConfigurationValue(r,b);if(P.isUndefinedOrNull(u))throw new Error((0,y.localize)(6,null,g,b));if(P.isObject(u))throw new Error((0,y.localize)(7,null,g,b));return u}throw new Error((0,y.localize)(8,null,g));case"command":return this.resolveFromMap(g,b,s,"command");case"input":return this.resolveFromMap(g,b,s,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return r||b?(0,D.normalizeDriveLetter)(this.fsPath(c())):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return E.basename(this.fsPath(c()));case"lineNumber":const u=this._context.getLineNumber();if(u)return u;throw new Error((0,y.localize)(9,null,g));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,g));case"file":return _();case"fileWorkspaceFolder":return v();case"relativeFile":return r||b?E.relative(this.fsPath(c()),_()):_();case"relativeFileDirname":const i=E.dirname(_());if(r||b){const o=E.relative(this.fsPath(c()),i);return o.length===0?".":o}return i;case"fileDirname":return E.dirname(_());case"fileExtname":return E.extname(_());case"fileBasename":return E.basename(_());case"fileBasenameNoExtension":const d=E.basename(_());return d.slice(0,d.length-E.extname(d).length);case"fileDirnameBasename":return E.basename(E.dirname(_()));case"execPath":const a=this._context.getExecPath();return a||g;case"execInstallFolder":const l=this._context.getAppRoot();return l||g;case"pathSeparator":return E.sep;default:try{const o=b?`${f}:${b}`:f;return this.resolveFromMap(g,o,s,void 0)}catch(o){return g}}}}resolveFromMap(C,g,f,r){if(g&&f){const s=r===void 0?f[g]:f[r+":"+g];if(typeof s=="string")return s;throw new Error((0,y.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=n,n.VARIABLE_LHS="${",n.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[173],_e([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,E.createDecorator)("editorGroupsService");var k;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var P;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var S;(function(g){g[g.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(S=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));var y;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y=e.GroupsOrder||(e.GroupsOrder={}));var n;(function(g){g[g.GROUP_ACTIVE=0]="GROUP_ACTIVE",g[g.GROUP_INDEX=1]="GROUP_INDEX",g[g.EDITOR_OPEN=2]="EDITOR_OPEN",g[g.EDITOR_CLOSE=3]="EDITOR_CLOSE",g[g.EDITOR_MOVE=4]="EDITOR_MOVE",g[g.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",g[g.EDITOR_LABEL=6]="EDITOR_LABEL",g[g.EDITOR_PIN=7]="EDITOR_PIN",g[g.EDITOR_STICKY=8]="EDITOR_STICKY",g[g.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(n=e.GroupChangeKind||(e.GroupChangeKind={}));var T;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function C(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(ve[174],_e([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,E.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ve[9],_e([0,1,11,81,228,57,24,13,2,32,62,142,88,71,174,7]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g,f,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var b;(function(ce){function De(V){const{selectionStartLineNumber:Oe,selectionStartColumn:Ie,positionLineNumber:Je,positionColumn:Ge}=V,lt=new s.Position(Oe-1,Ie-1),at=new s.Position(Je-1,Ge-1);return new s.Selection(lt,at)}ce.to=De;function ue(V){const{anchor:Oe,active:Ie}=V;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Ie.line+1,positionColumn:Ie.character+1}}ce.from=ue})(b=e.Selection||(e.Selection={}));var h;(function(ce){function De(V){if(!!V){const{start:Oe,end:Ie}=V;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Ie.line+1,endColumn:Ie.character+1}}}ce.from=De;function ue(V){if(!!V){const{startLineNumber:Oe,startColumn:Ie,endLineNumber:Je,endColumn:Ge}=V;return new s.Range(Oe-1,Ie-1,Je-1,Ge-1)}}ce.to=ue})(h=e.Range||(e.Range={}));var _;(function(ce){function De(ue){switch(ue){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 4:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}ce.to=De})(_=e.TokenType||(e.TokenType={}));var v;(function(ce){function De(V){return new s.Position(V.lineNumber-1,V.column-1)}ce.to=De;function ue(V){return{lineNumber:V.line+1,column:V.character+1}}ce.from=ue})(v=e.Position||(e.Position={}));var c;(function(ce){function De(V){switch(V){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}ce.from=De;function ue(V){switch(V){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}ce.to=ue})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var u;(function(ce){function De(V){let Oe;return V.code&&((0,D.isString)(V.code)||(0,D.isNumber)(V.code)?Oe=String(V.code):Oe={value:String(V.code.value),target:V.code.target}),Object.assign(Object.assign({},h.from(V.range)),{message:V.message,source:V.source,code:Oe,severity:i.from(V.severity),relatedInformation:V.relatedInformation&&V.relatedInformation.map(t.from),tags:Array.isArray(V.tags)?(0,E.coalesce)(V.tags.map(c.from)):void 0})}ce.from=De;function ue(V){var Oe;const Ie=new s.Diagnostic(h.to(V),V.message,i.to(V.severity));return Ie.source=V.source,Ie.code=(0,D.isString)(V.code)?V.code:(Oe=V.code)===null||Oe===void 0?void 0:Oe.value,Ie.relatedInformation=V.relatedInformation&&V.relatedInformation.map(t.to),Ie.tags=V.tags&&(0,E.coalesce)(V.tags.map(c.to)),Ie}ce.to=ue})(u=e.Diagnostic||(e.Diagnostic={}));var t;(function(ce){function De(V){return Object.assign(Object.assign({},h.from(V.location.range)),{message:V.message,resource:V.location.uri})}ce.from=De;function ue(V){return new s.DiagnosticRelatedInformation(new s.Location(V.resource,h.to(V)),V.message)}ce.to=ue})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(ce){function De(V){switch(V){case s.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}ce.from=De;function ue(V){switch(V){case g.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}ce.to=ue})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var d;(function(ce){function De(V){return typeof V=="number"&&V>=s.ViewColumn.One?V-1:V===s.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}ce.from=De;function ue(V){if(typeof V=="number"&&V>=0)return V+1;throw new Error("invalid 'EditorGroupColumn'")}ce.to=ue})(d=e.ViewColumn||(e.ViewColumn={}));function a(ce){return typeof ce.range!="undefined"}function l(ce){return ce.length===0?!0:!!a(ce[0])}e.isDecorationOptionsArr=l;var o;(function(ce){function De(Ge){return Ge.map(ce.from)}ce.fromMany=De;function ue(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function V(Ge){let lt;if(ue(Ge)){const{language:ct,value:pt}=Ge;lt={value:"```"+ct+`
`+pt+"\n```\n"}}else s.MarkdownString.isMarkdownString(Ge)?lt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons}:typeof Ge=="string"?lt={value:Ge}:lt={value:""};const at=Object.create(null);lt.uris=at;const Qe=ct=>{try{let pt=y.URI.parse(ct,!0);pt=pt.with({query:Oe(pt.query,at)}),at[ct]=pt}catch(pt){}return""},st=new P.Renderer;return st.link=Qe,st.image=ct=>Qe(k.parseHrefAndDimensions(ct).href),P(lt.value,{renderer:st}),lt}ce.from=V;function Oe(Ge,lt){if(!Ge)return Ge;let at;try{at=(0,A.parse)(Ge)}catch(st){}if(!at)return Ge;let Qe=!1;return at=(0,S.cloneAndChange)(at,st=>{if(y.URI.isUri(st)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[ct]=st,Qe=!0,ct}else return}),Qe?JSON.stringify(at):Ge}function Ie(Ge){const lt=new s.MarkdownString(Ge.value,Ge.supportThemeIcons);return lt.isTrusted=Ge.isTrusted,lt}ce.to=Ie;function Je(Ge){if(!!Ge)return typeof Ge=="string"?Ge:ce.from(Ge)}ce.fromStrict=Je})(o=e.MarkdownString||(e.MarkdownString={}));function w(ce){return l(ce)?ce.map(De=>({range:h.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?o.fromMany(De.hoverMessage):De.hoverMessage?o.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):ce.map(De=>({range:h.from(De)}))}e.fromRangeOrRangeWithMessage=w;function I(ce){return typeof ce=="undefined"?ce:typeof ce=="string"?y.URI.file(ce):ce}e.pathOrURIToURI=I;var p;(function(ce){function De(ue){return typeof ue=="undefined"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?I(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}ce.from=De})(p=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var m;(function(ce){function De(ue){return typeof ue=="undefined"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?I(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?p.from(ue.before):void 0,after:ue.after?p.from(ue.after):void 0}}ce.from=De})(m=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(ce){function De(ue){if(typeof ue=="undefined")return ue;switch(ue){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}ce.from=De})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var F;(function(ce){function De(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?R.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?m.from(ue.light):void 0,dark:ue.dark?m.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?I(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?p.from(ue.before):void 0,after:ue.after?p.from(ue.after):void 0}}ce.from=De})(F=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var x;(function(ce){function De(V){return{text:V.newText,eol:V.newEol&&X.from(V.newEol),range:h.from(V.range)}}ce.from=De;function ue(V){const Oe=new s.TextEdit(h.to(V.range),V.text);return Oe.newEol=typeof V.eol=="undefined"?void 0:X.to(V.eol),Oe}ce.to=ue})(x=e.TextEdit||(e.TextEdit={}));var ae;(function(ce){function De(V,Oe,Ie){var Je,Ge,lt;const at={edits:[]};if(V instanceof s.WorkspaceEdit)for(let Qe of V._allEntries())if(Qe._type===1)at.edits.push({_type:1,oldUri:Qe.from,newUri:Qe.to,options:Qe.options,metadata:Qe.metadata});else if(Qe._type===2){const st=Oe==null?void 0:Oe.getDocument(Qe.uri);at.edits.push({_type:2,resource:Qe.uri,edit:x.from(Qe.edit),modelVersionId:st==null?void 0:st.version,metadata:Qe.metadata})}else Qe._type===3?at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:(Je=Ie==null?void 0:Ie.lookupNotebookDocument(Qe.uri))===null||Je===void 0?void 0:Je.notebookDocument.version}):Qe._type===4?(Qe.newOutputs&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:2,index:Qe.index,append:Qe.append,outputs:Qe.newOutputs.map(Ne.from)}}),Qe.newMetadata&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:11,index:Qe.index,metadata:Qe.newMetadata}})):Qe._type===5?at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:(Ge=Ie==null?void 0:Ie.lookupNotebookDocument(Qe.uri))===null||Ge===void 0?void 0:Ge.notebookDocument.version,edit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(fe.from)}}):Qe._type===6&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:10,outputId:Qe.outputId,items:((lt=Qe.newOutputItems)===null||lt===void 0?void 0:lt.map(Ee.from))||[],append:Qe.append}});return at}ce.from=De;function ue(V){const Oe=new s.WorkspaceEdit;for(const Ie of V.edits)Ie.edit?Oe.replace(y.URI.revive(Ie.resource),h.to(Ie.edit.range),Ie.edit.text):Oe.renameFile(y.URI.revive(Ie.oldUri),y.URI.revive(Ie.newUri),Ie.options);return Oe}ce.to=ue})(ae=e.WorkspaceEdit||(e.WorkspaceEdit={}));var z;(function(ce){const De=Object.create(null);De[s.SymbolKind.File]=0,De[s.SymbolKind.Module]=1,De[s.SymbolKind.Namespace]=2,De[s.SymbolKind.Package]=3,De[s.SymbolKind.Class]=4,De[s.SymbolKind.Method]=5,De[s.SymbolKind.Property]=6,De[s.SymbolKind.Field]=7,De[s.SymbolKind.Constructor]=8,De[s.SymbolKind.Enum]=9,De[s.SymbolKind.Interface]=10,De[s.SymbolKind.Function]=11,De[s.SymbolKind.Variable]=12,De[s.SymbolKind.Constant]=13,De[s.SymbolKind.String]=14,De[s.SymbolKind.Number]=15,De[s.SymbolKind.Boolean]=16,De[s.SymbolKind.Array]=17,De[s.SymbolKind.Object]=18,De[s.SymbolKind.Key]=19,De[s.SymbolKind.Null]=20,De[s.SymbolKind.EnumMember]=21,De[s.SymbolKind.Struct]=22,De[s.SymbolKind.Event]=23,De[s.SymbolKind.Operator]=24,De[s.SymbolKind.TypeParameter]=25;function ue(Oe){return typeof De[Oe]=="number"?De[Oe]:6}ce.from=ue;function V(Oe){for(const Ie in De)if(De[Ie]===Oe)return Number(Ie);return s.SymbolKind.Property}ce.to=V})(z=e.SymbolKind||(e.SymbolKind={}));var B;(function(ce){function De(V){switch(V){case s.SymbolTag.Deprecated:return 1}}ce.from=De;function ue(V){switch(V){case 1:return s.SymbolTag.Deprecated}}ce.to=ue})(B=e.SymbolTag||(e.SymbolTag={}));var G;(function(ce){function De(V){return{name:V.name,kind:z.from(V.kind),tags:V.tags&&V.tags.map(B.from),containerName:V.containerName,location:$.from(V.location)}}ce.from=De;function ue(V){const Oe=new s.SymbolInformation(V.name,z.to(V.kind),V.containerName,$.to(V.location));return Oe.tags=V.tags&&V.tags.map(B.to),Oe}ce.to=ue})(G=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var M;(function(ce){function De(V){var Oe,Ie;const Je={name:V.name||"!!MISSING: name!!",detail:V.detail,range:h.from(V.range),selectionRange:h.from(V.selectionRange),kind:z.from(V.kind),tags:(Ie=(Oe=V.tags)===null||Oe===void 0?void 0:Oe.map(B.from))!==null&&Ie!==void 0?Ie:[]};return V.children&&(Je.children=V.children.map(De)),Je}ce.from=De;function ue(V){const Oe=new s.DocumentSymbol(V.name,V.detail,z.to(V.kind),h.to(V.range),h.to(V.selectionRange));return(0,E.isNonEmptyArray)(V.tags)&&(Oe.tags=V.tags.map(B.to)),V.children&&(Oe.children=V.children.map(ue)),Oe}ce.to=ue})(M=e.DocumentSymbol||(e.DocumentSymbol={}));var N;(function(ce){function De(ue){const V=new s.CallHierarchyItem(z.to(ue.kind),ue.name,ue.detail||"",y.URI.revive(ue.uri),h.to(ue.range),h.to(ue.selectionRange));return V._sessionId=ue._sessionId,V._itemId=ue._itemId,V}ce.to=De})(N=e.CallHierarchyItem||(e.CallHierarchyItem={}));var W;(function(ce){function De(ue){return new s.CallHierarchyIncomingCall(N.to(ue.from),ue.fromRanges.map(V=>h.to(V)))}ce.to=De})(W=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Q;(function(ce){function De(ue){return new s.CallHierarchyOutgoingCall(N.to(ue.to),ue.fromRanges.map(V=>h.to(V)))}ce.to=De})(Q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var $;(function(ce){function De(V){return{range:V.range&&h.from(V.range),uri:V.uri}}ce.from=De;function ue(V){return new s.Location(y.URI.revive(V.uri),h.to(V.range))}ce.to=ue})($=e.location||(e.location={}));var Z;(function(ce){function De(V){const Oe=V,Ie=V;return{originSelectionRange:Oe.originSelectionRange?h.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Ie.uri,range:h.from(Oe.targetRange?Oe.targetRange:Ie.range),targetSelectionRange:Oe.targetSelectionRange?h.from(Oe.targetSelectionRange):void 0}}ce.from=De;function ue(V){return{targetUri:y.URI.revive(V.uri),targetRange:h.to(V.range),targetSelectionRange:V.targetSelectionRange?h.to(V.targetSelectionRange):void 0,originSelectionRange:V.originSelectionRange?h.to(V.originSelectionRange):void 0}}ce.to=ue})(Z=e.DefinitionLink||(e.DefinitionLink={}));var re;(function(ce){function De(V){return{range:h.from(V.range),contents:o.fromMany(V.contents)}}ce.from=De;function ue(V){return new s.Hover(V.contents.map(o.to),h.to(V.range))}ce.to=ue})(re=e.Hover||(e.Hover={}));var se;(function(ce){function De(V){return{range:h.from(V.range),expression:V.expression}}ce.from=De;function ue(V){return new s.EvaluatableExpression(h.to(V.range),V.expression)}ce.to=ue})(se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ye;(function(ce){function De(V){if(V instanceof s.InlineValueText)return{type:"text",range:h.from(V.range),text:V.text};if(V instanceof s.InlineValueVariableLookup)return{type:"variable",range:h.from(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};if(V instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:h.from(V.range),expression:V.expression};throw new Error("Unknown 'InlineValue' type")}ce.from=De;function ue(V){switch(V.type){case"text":return{range:h.to(V.range),text:V.text};case"variable":return{range:h.to(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};case"expression":return{range:h.to(V.range),expression:V.expression}}}ce.to=ue})(ye=e.InlineValue||(e.InlineValue={}));var Pe;(function(ce){function De(V){return{frameId:V.frameId,stoppedLocation:h.from(V.stoppedLocation)}}ce.from=De;function ue(V){return new s.InlineValueContext(V.frameId,h.to(V.stoppedLocation))}ce.to=ue})(Pe=e.InlineValueContext||(e.InlineValueContext={}));var $e;(function(ce){function De(V){return{range:h.from(V.range),kind:V.kind}}ce.from=De;function ue(V){return new s.DocumentHighlight(h.to(V.range),V.kind)}ce.to=ue})($e=e.DocumentHighlight||(e.DocumentHighlight={}));var Re;(function(ce){function De(ue){switch(ue){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}ce.to=De})(Re=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ze;(function(ce){function De(ue){return{triggerKind:Re.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}ce.to=De})(ze=e.CompletionContext||(e.CompletionContext={}));var U;(function(ce){function De(V){switch(V){case s.CompletionItemTag.Deprecated:return 1}}ce.from=De;function ue(V){switch(V){case 1:return s.CompletionItemTag.Deprecated}}ce.to=ue})(U=e.CompletionItemTag||(e.CompletionItemTag={}));var K;(function(ce){const De=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function ue(Ie){var Je;return(Je=De.get(Ie))!==null&&Je!==void 0?Je:9}ce.from=ue;const V=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Oe(Ie){var Je;return(Je=V.get(Ie))!==null&&Je!==void 0?Je:s.CompletionItemKind.Property}ce.to=Oe})(K=e.CompletionItemKind||(e.CompletionItemKind={}));var te;(function(ce){function De(ue,V){var Oe;const Ie=new s.CompletionItem(typeof ue.label=="string"?ue.label:ue.label.name);return typeof ue.label!="string"&&(Ie.label2=ue.label),Ie.insertText=ue.insertText,Ie.kind=K.to(ue.kind),Ie.tags=(Oe=ue.tags)===null||Oe===void 0?void 0:Oe.map(U.to),Ie.detail=ue.detail,Ie.documentation=k.isMarkdownString(ue.documentation)?o.to(ue.documentation):ue.documentation,Ie.sortText=ue.sortText,Ie.filterText=ue.filterText,Ie.preselect=ue.preselect,Ie.commitCharacters=ue.commitCharacters,n.Range.isIRange(ue.range)?Ie.range=h.to(ue.range):typeof ue.range=="object"&&(Ie.range={inserting:h.to(ue.range.insert),replacing:h.to(ue.range.replace)}),Ie.keepWhitespace=typeof ue.insertTextRules=="undefined"?!1:Boolean(ue.insertTextRules&1),typeof ue.insertTextRules!="undefined"&&ue.insertTextRules&4?Ie.insertText=new s.SnippetString(ue.insertText):(Ie.insertText=ue.insertText,Ie.textEdit=Ie.range instanceof s.Range?new s.TextEdit(Ie.range,Ie.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(Ie.additionalTextEdits=ue.additionalTextEdits.map(Je=>x.to(Je))),Ie.command=V&&ue.command?V.fromInternal(ue.command):void 0,Ie}ce.to=De})(te=e.CompletionItem||(e.CompletionItem={}));var le;(function(ce){function De(V){return{label:V.label,documentation:V.documentation?o.fromStrict(V.documentation):void 0}}ce.from=De;function ue(V){return{label:V.label,documentation:k.isMarkdownString(V.documentation)?o.to(V.documentation):V.documentation}}ce.to=ue})(le=e.ParameterInformation||(e.ParameterInformation={}));var me;(function(ce){function De(V){return{label:V.label,documentation:V.documentation?o.fromStrict(V.documentation):void 0,parameters:Array.isArray(V.parameters)?V.parameters.map(le.from):[],activeParameter:V.activeParameter}}ce.from=De;function ue(V){return{label:V.label,documentation:k.isMarkdownString(V.documentation)?o.to(V.documentation):V.documentation,parameters:Array.isArray(V.parameters)?V.parameters.map(le.to):[],activeParameter:V.activeParameter}}ce.to=ue})(me=e.SignatureInformation||(e.SignatureInformation={}));var Se;(function(ce){function De(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(me.from):[]}}ce.from=De;function ue(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(me.to):[]}}ce.to=ue})(Se=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(ce){function De(V){var Oe;return{text:V.text,range:h.from(V.range),kind:ge.from((Oe=V.kind)!==null&&Oe!==void 0?Oe:s.InlineHintKind.Other),description:V.description&&o.fromStrict(V.description),whitespaceBefore:V.whitespaceBefore,whitespaceAfter:V.whitespaceAfter}}ce.from=De;function ue(V){const Oe=new s.InlineHint(V.text,h.to(V.range),ge.to(V.kind));return Oe.whitespaceAfter=V.whitespaceAfter,Oe.whitespaceBefore=V.whitespaceBefore,Oe.description=k.isMarkdownString(V.description)?o.to(V.description):V.description,Oe}ce.to=ue})(Me=e.InlineHint||(e.InlineHint={}));var ge;(function(ce){function De(V){return V}ce.from=De;function ue(V){return V}ce.to=ue})(ge=e.InlineHintKind||(e.InlineHintKind={}));var Ce;(function(ce){function De(V){return{range:h.from(V.range),url:V.target,tooltip:V.tooltip}}ce.from=De;function ue(V){let Oe;if(V.url)try{Oe=typeof V.url=="string"?y.URI.parse(V.url,!0):y.URI.revive(V.url)}catch(Ie){}return new s.DocumentLink(h.to(V.range),Oe)}ce.to=ue})(Ce=e.DocumentLink||(e.DocumentLink={}));var Ae;(function(ce){function De(V){const Oe=new s.ColorPresentation(V.label);return V.textEdit&&(Oe.textEdit=x.to(V.textEdit)),V.additionalTextEdits&&(Oe.additionalTextEdits=V.additionalTextEdits.map(Ie=>x.to(Ie))),Oe}ce.to=De;function ue(V){return{label:V.label,textEdit:V.textEdit?x.from(V.textEdit):void 0,additionalTextEdits:V.additionalTextEdits?V.additionalTextEdits.map(Oe=>x.from(Oe)):void 0}}ce.from=ue})(Ae=e.ColorPresentation||(e.ColorPresentation={}));var Be;(function(ce){function De(V){return new s.Color(V[0],V[1],V[2],V[3])}ce.to=De;function ue(V){return[V.red,V.green,V.blue,V.alpha]}ce.from=ue})(Be=e.Color||(e.Color={}));var be;(function(ce){function De(V){return{range:h.from(V.range)}}ce.from=De;function ue(V){return new s.SelectionRange(h.to(V.range))}ce.to=ue})(be=e.SelectionRange||(e.SelectionRange={}));var qe;(function(ce){function De(ue){switch(ue){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}ce.to=De})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var j;(function(ce){function De(V){switch(V){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}ce.from=De;function ue(V){switch(V){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}ce.to=ue})(j=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var X;(function(ce){function De(V){if(V===s.EndOfLine.CRLF)return 1;if(V===s.EndOfLine.LF)return 0}ce.from=De;function ue(V){if(V===1)return s.EndOfLine.CRLF;if(V===0)return s.EndOfLine.LF}ce.to=ue})(X=e.EndOfLine||(e.EndOfLine={}));var pe;(function(ce){function De(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ce.from=De})(pe=e.ProgressLocation||(e.ProgressLocation={}));var Le;(function(ce){function De(ue){const V={start:ue.start+1,end:ue.end+1};return ue.kind&&(V.kind=He.from(ue.kind)),V}ce.from=De})(Le=e.FoldingRange||(e.FoldingRange={}));var He;(function(ce){function De(ue){if(ue)switch(ue){case s.FoldingRangeKind.Comment:return T.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return T.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return T.FoldingRangeKind.Region}}ce.from=De})(He=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ue;(function(ce){function De(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?h.from(ue.selection):void 0,override:typeof ue.override=="boolean"?C.EditorOverride.DISABLED:void 0}}ce.from=De})(Ue=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ze;(function(ce){function De(V){return V instanceof s.RelativePattern||typeof V=="string"?V:ue(V)?new s.RelativePattern(V.base,V.pattern):V}ce.from=De;function ue(V){const Oe=V;return Oe&&typeof Oe.base=="string"&&typeof Oe.pattern=="string"}})(Ze=e.GlobPattern||(e.GlobPattern={}));var H;(function(ce){function De(ue){if(ue){if(Array.isArray(ue))return ue.map(De);if(typeof ue=="string")return ue;{const V=ue;return{language:V.language,scheme:V.scheme,pattern:typeof V.pattern=="undefined"?void 0:Ze.from(V.pattern),exclusive:V.exclusive}}}else return}ce.from=De})(H=e.LanguageSelector||(e.LanguageSelector={}));var ne;(function(ce){function De(V){return{start:V.start,end:V.end}}ce.from=De;function ue(V){return new s.NotebookCellRange(V.start,V.end)}ce.to=ue})(ne=e.NotebookCellRange||(e.NotebookCellRange={}));var he;(function(ce){function De(ue){return new s.NotebookCellMetadata(ue.editable,ue.breakpointMargin,ue.statusMessage,ue.inputCollapsed,ue.outputCollapsed,ue.custom)}ce.to=De})(he=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var q;(function(ce){function De(V){return V}ce.from=De;function ue(V){return new s.NotebookDocumentMetadata(V.editable,V.cellEditable,V.custom,V.trusted)}ce.to=ue})(q=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var Y;(function(ce){function De(V){return{duration:V.lastRunDuration,executionOrder:V.executionOrder,success:V.lastRunSuccess}}ce.to=De;function ue(V){return{lastRunSuccess:V.success,lastRunDuration:V.duration,executionOrder:V.executionOrder}}ce.from=ue})(Y=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var oe;(function(ce){function De(V){switch(V){case s.NotebookCellKind.Markdown:return f.CellKind.Markdown;case s.NotebookCellKind.Code:default:return f.CellKind.Code}}ce.from=De;function ue(V){switch(V){case f.CellKind.Markdown:return s.NotebookCellKind.Markdown;case f.CellKind.Code:default:return s.NotebookCellKind.Code}}ce.to=ue})(oe=e.NotebookCellKind||(e.NotebookCellKind={}));var fe;(function(ce){function De(V){var Oe;return{cellKind:oe.from(V.kind),language:V.language,source:V.source,metadata:Object.assign(Object.assign({},V.metadata),Y.from((Oe=V.latestExecutionSummary)!==null&&Oe!==void 0?Oe:{})),outputs:V.outputs?V.outputs.map(Ne.from):[]}}ce.from=De;function ue(V){return new s.NotebookCellData(oe.to(V.cellKind),V.source,V.language,V.outputs?V.outputs.map(Ne.to):void 0,V.metadata?he.to(V.metadata):void 0)}ce.to=ue})(fe=e.NotebookCellData||(e.NotebookCellData={}));var Ee;(function(ce){function De(V){return{mime:V.mime,value:V.value,metadata:V.metadata}}ce.from=De;function ue(V){return new s.NotebookCellOutputItem(V.mime,V.value,V.metadata)}ce.to=ue})(Ee=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ne;(function(ce){function De(V){return{outputId:V.id,outputs:V.outputs.map(Ee.from),metadata:V.metadata}}ce.from=De;function ue(V){const Oe=V.outputs.map(Ee.to);return new s.NotebookCellOutput(Oe,V.outputId,V.metadata)}ce.to=ue})(Ne=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Fe;(function(ce){function De(Ie){if(Ie!=null){if(Ie instanceof s.RelativePattern||typeof Ie=="string")return Ie;if(Oe(Ie))return new s.RelativePattern(Ie.base,Ie.pattern);if(V(Ie))return{include:Ze.from(Ie.include)||void 0,exclude:Ze.from(Ie.exclude)||void 0}}}ce.from=De;function ue(Ie){return typeof Ie=="string"?Ie:Oe(Ie)?{base:Ie.base,pattern:Ie.pattern}:{include:Ie.include,exclude:Ie.exclude}}ce.to=ue;function V(Ie){const Je=Ie,Ge=Ze.from(Je.include);if(!(Ge&&Ge instanceof s.RelativePattern||typeof Ge=="string"))return!1;const lt=Ze.from(Je.exclude);return!!(lt&&lt instanceof s.RelativePattern||typeof lt=="string")}function Oe(Ie){const Je=Ie;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(Fe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ve;(function(ce){function De(ue){return{backgroundColor:ue.backgroundColor,borderColor:ue.borderColor,top:ue.top?p.from(ue.top):void 0}}ce.from=De})(Ve=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Xe;(function(ce){function De(ue,V,Oe){const Ie=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{alignment:ue.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:V.toInternal(Ie,Oe),text:ue.text,tooltip:ue.tooltip,accessibilityInformation:ue.accessibilityInformation,priority:ue.priority}}ce.from=De})(Xe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var tt;(function(ce){function De(ue){var V;return{transientOutputs:(V=ue==null?void 0:ue.transientOutputs)!==null&&V!==void 0?V:!1,transientMetadata:Object.assign(Object.assign({},ue==null?void 0:ue.transientMetadata),{executionOrder:!0,lastRunDuration:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,lastRunSuccess:!0})}}ce.from=De})(tt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var nt;(function(ce){function De(V){return{message:o.fromStrict(V.message)||"",severity:V.severity,expectedOutput:V.expectedOutput,actualOutput:V.actualOutput,location:V.location?$.from(V.location):void 0}}ce.from=De;function ue(V){const Oe=new s.TestMessage(typeof V.message=="string"?V.message:o.to(V.message));return Oe.severity=V.severity,Oe.actualOutput=V.actualOutput,Oe.expectedOutput=V.expectedOutput,Oe}ce.to=ue})(nt=e.TestMessage||(e.TestMessage={}));var rt;(function(ce){function De(Ie){var Je,Ge;return{extId:Ie.id,label:Ie.label,uri:Ie.uri,range:h.from(Ie.range),debuggable:(Je=Ie.debuggable)!==null&&Je!==void 0?Je:!1,description:Ie.description,runnable:(Ge=Ie.runnable)!==null&&Ge!==void 0?Ge:!0,expandable:Ie.expandable}}ce.from=De;function ue(Ie){return{extId:Ie.id,label:Ie.label,uri:Ie.uri,range:h.from(Ie.range),debuggable:!1,description:Ie.description,runnable:!0,expandable:!0}}ce.fromResultSnapshot=ue;function V(Ie){return{id:Ie.extId,label:Ie.label,uri:y.URI.revive(Ie.uri),range:h.to(Ie.range),expandable:Ie.expandable,debuggable:Ie.debuggable,description:Ie.description,runnable:Ie.runnable}}ce.toPlain=V;function Oe(Ie){const Je=new s.TestItem(Ie.extId,Ie.label,y.URI.revive(Ie.uri),Ie.expandable);return Je.range=h.to(Ie.range),Je.debuggable=Ie.debuggable,Je.description=Ie.description,Je.runnable=Ie.runnable,Je}ce.to=Oe})(rt=e.TestItem||(e.TestItem={}));var it;(function(ce){function De(Oe,Ie){var Je,Ge,lt;const at={completedAt:Ie.completedAt,id:Oe,output:Ie.output,items:[]},Qe=[[null,Ie.results]];for(;Qe.length;){const[st,ct]=Qe.pop();for(const pt of ct){const vt={children:(Ge=(Je=pt.children)===null||Je===void 0?void 0:Je.map(bt=>bt.id))!==null&&Ge!==void 0?Ge:[],computedState:pt.state,item:rt.fromResultSnapshot(pt),state:{state:pt.state,duration:pt.duration,messages:pt.messages.map(nt.from)},retired:void 0,expand:3,parent:(lt=st==null?void 0:st.item.extId)!==null&&lt!==void 0?lt:null,src:{provider:"",tree:-1},direct:!st};at.items.push(vt),pt.children&&Qe.push([vt,pt.children])}}return at}ce.from=De;const ue=(Oe,Ie)=>Object.assign(Object.assign({},rt.toPlain(Oe.item)),{state:Oe.state.state,duration:Oe.state.duration,messages:Oe.state.messages.map(nt.to),children:Oe.children.map(Je=>Ie.get(Je)).filter(D.isDefined).map(Je=>ue(Je,Ie))});function V(Oe){const Ie=[],Je=new Map;for(const Ge of Oe.items)Je.set(Ge.item.extId,Ge),Ge.direct&&Ie.push(Ge);return{completedAt:Oe.completedAt,results:Ie.map(Ge=>ue(Ge,Je))}}ce.to=V})(it=e.TestResults||(e.TestResults={}));var gt;(function(ce){function De(ue){switch(ue){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}ce.to=De})(gt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ve[175],_e([0,1,2,10,7,9,44]),function(ie,e,E,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(n,T,C,g={timeout:1500,errors:3}){this._logService=n,this._documents=T,this._mainThreadBulkEdits=C,this._thresholds=g,this._callbacks=new S.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(n){return(T,C,g)=>{const r={dispose:this._callbacks.push([T,C,n])};return Array.isArray(g)&&g.push(r),r}}async $participateInSave(n,T){const C=E.URI.revive(n);let g=!1;const f=setTimeout(()=>g=!0,this._thresholds.timeout),r=[];try{for(let s of[...this._callbacks]){if(g)break;const b=this._documents.getDocument(C),h=await this._deliverEventAsyncAndBlameBadListeners(s,{document:b,reason:A.TextDocumentSaveReason.to(T)});r.push(h)}}finally{clearTimeout(f)}return r}_deliverEventAsyncAndBlameBadListeners([n,T,C],g){const f=this._badListeners.get(n);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,n,T,g).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const s=this._badListeners.get(n);this._badListeners.set(n,s?s+1:1),typeof s=="number"&&s>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(n,T,C,g){const f=[],r=Date.now(),{document:s,reason:b}=g,{version:h}=s,_=Object.freeze({document:s,reason:b,waitUntil(v){if(Object.isFrozen(f))throw(0,k.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(v))}});try{T.apply(C,[_])}catch(v){return Promise.reject(v)}return Object.freeze(f),new Promise((v,c)=>{const u=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${n.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(u),v(t)}).catch(t=>{clearTimeout(u),c(t)})}).then(v=>{const c={edits:[]};for(const u of v)if(Array.isArray(u)&&u.every(t=>t instanceof P.TextEdit))for(const{newText:t,newEol:i,range:d}of u)c.edits.push({_type:2,resource:s.uri,edit:{range:d&&A.Range.from(d),text:t,eol:i&&A.EndOfLine.from(i)}});if(c.edits.length!==0)return h===s.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(ve[176],_e([0,1,3,14,28,2,9,7]),function(ie,e,E,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(C,g,f,r,s){this._onDidCreate=new E.Emitter,this._onDidChange=new E.Emitter,this._onDidDelete=new E.Emitter,this._config=0,f&&(this._config+=1),r&&(this._config+=2),s&&(this._config+=4);const b=(0,P.parse)(g),h=C(_=>{if(!f)for(let v of _.created){const c=A.URI.revive(v);b(c.fsPath)&&this._onDidCreate.fire(c)}if(!r)for(let v of _.changed){const c=A.URI.revive(v);b(c.fsPath)&&this._onDidChange.fire(c)}if(!s)for(let v of _.deleted){const c=A.URI.revive(v);b(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=D.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,h)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class n{constructor(C,g,f){this._logService=g,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new E.Emitter,this._onDidRenameFile=new E.Emitter,this._onDidCreateFile=new E.Emitter,this._onDidDeleteFile=new E.Emitter,this._onWillRenameFile=new k.AsyncEmitter,this._onWillCreateFile=new k.AsyncEmitter,this._onWillDeleteFile=new k.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,g,f,r){return new y(this._onFileSystemEvent.event,C,g,f,r)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,g){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:g.map(f=>({oldUri:A.URI.revive(f.source),newUri:A.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:g.map(f=>A.URI.revive(f.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:g.map(f=>A.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,g){return(f,r,s)=>{const b=function(_){f.call(r,_)};return b.extension=C,g.event(b,void 0,s)}}async $onWillRunFileOperation(C,g,f,r){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:g.map(s=>({oldUri:A.URI.revive(s.source),newUri:A.URI.revive(s.target)}))},f,r);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:g.map(s=>A.URI.revive(s.target))},f,r);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:g.map(s=>A.URI.revive(s.target))},f,r)}}async _fireWillEvent(C,g,f,r){const s=new Set,b=[];if(await C.fireAsync(g,r,async(_,v)=>{var c;const u=Date.now(),t=await Promise.resolve(_);t instanceof D.WorkspaceEdit&&(b.push(t),s.add((c=v.extension.displayName)!==null&&c!==void 0?c:v.extension.identifier.value)),Date.now()-u>f&&this._logService.warn("SLOW file-participant",v.extension.identifier)}),!r.isCancellationRequested&&b.length!==0){const h={edits:[]};for(let _ of b){let{edits:v}=S.WorkspaceEdit.from(_,this._extHostDocumentsAndEditors);h.edits=h.edits.concat(v)}return{edit:h,extensionNames:Array.from(s)}}}}e.ExtHostFileSystemEventService=n}),define(ve[177],_e([0,1,3,6,18,24,2,9,7,71]),function(ie,e,E,k,P,A,S,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class T{constructor(r,s,b,h){this.start=r,this.deletedCount=s,this.deletedItems=b,this.items=h}static asApiEvents(r){return r.map(s=>({start:s.start,deletedCount:s.deletedCount,deletedItems:s.deletedItems,items:s.items.map(b=>b.cell)}))}}class C{constructor(r,s,b){var h;this._notebook=r,this._extHostDocument=s,this._cellData=b,this._onDidDispose=new E.Emitter,this.onDidDispose=this._onDidDispose.event,this.handle=b.handle,this.uri=S.URI.revive(b.uri),this.cellKind=b.cellKind,this._outputs=b.outputs.map(D.NotebookCellOutput.to),this._internalMetadata=(h=b.metadata)!==null&&h!==void 0?h:{},this._metadata=D.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=D.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(r,s){return{EOL:s.eol,lines:s.source,modeId:s.language,uri:s.uri,isDirty:!1,versionId:1,notebook:r}}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get internalMetadata(){return this._internalMetadata}get cell(){if(!this._cell){const r=this,s=this._extHostDocument.getDocument(this.uri);if(!s)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return r._notebook.getCellIndex(r)},notebook:r._notebook.notebookDocument,kind:D.NotebookCellKind.to(this._cellData.cellKind),document:s.document,get outputs(){return r._outputs.slice(0)},get metadata(){return r._metadata},get latestExecutionSummary(){return r._previousResult}})}return this._cell}setOutputs(r){this._outputs=r.map(D.NotebookCellOutput.to)}setOutputItems(r,s,b){const h=b.map(D.NotebookCellOutputItem.to),_=this._outputs.find(v=>v.id===r);_&&(s||(_.outputs.length=0),_.outputs.push(...h))}setMetadata(r){this._internalMetadata=r,this._metadata=D.NotebookCellMetadata.to(r),this._previousResult=D.NotebookCellPreviousExecutionResult.to(r)}}e.ExtHostCell=C;class g extends k.Disposable{constructor(r,s,b,h,_,v,c){super();this._proxy=r,this._textDocumentsAndEditors=s,this._textDocuments=b,this._emitter=h,this._viewType=_,this._metadata=v,this.uri=c,this.handle=g._handlePool++,this._cells=[],this._cellDisposableMapping=new Map,this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0,super.dispose(),(0,k.dispose)(this._cellDisposableMapping.values())}get notebookDocument(){if(!this._notebook){const r=this;this._notebook=Object.freeze({get uri(){return r.uri},get version(){return r._versionId},get fileName(){return r.uri.fsPath},get viewType(){return r._viewType},get isDirty(){return r._isDirty},get isUntitled(){return r.uri.scheme===P.Schemas.untitled},get isClosed(){return r._disposed},get metadata(){return r._metadata},get cellCount(){return r._cells.length},cellAt(s){return s=r._validateIndex(s),r._cells[s].cell},getCells(s){return(s?r._getCells(s):r._cells).map(h=>h.cell)},save(){return r._save()}})}return this._notebook}updateBackup(r){var s;(s=this._backup)===null||s===void 0||s.delete(),this._backup=r}disposeBackup(){var r;(r=this._backup)===null||r===void 0||r.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(r){r.metadata&&(this._metadata=this._metadata.with(r.metadata))}acceptModelChanged(r,s){this._versionId=r.versionId,this._isDirty=s;for(const b of r.rawEvents)b.kind===n.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(b.changes,!0),b.kind===n.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(b.changes,!1):b.kind===n.NotebookCellsChangeType.Move?this._moveCell(b.index,b.newIdx):b.kind===n.NotebookCellsChangeType.Output?this._setCellOutputs(b.index,b.outputs):b.kind===n.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(b.index,b.outputId,b.append,b.outputItems):b.kind===n.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(b.index,b.language):b.kind===n.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(b.index,b.metadata)}_validateIndex(r){return r<0?0:r>=this._cells.length?this._cells.length-1:r}_validateRange(r){return r.start<0&&(r=r.with({start:0})),r.end>this._cells.length&&(r=r.with({end:this._cells.length})),r}_getCells(r){r=this._validateRange(r);const s=[];for(let b=r.start;b<r.end;b++)s.push(this._cells[b]);return s}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(r,s){if(!this._disposed){const b=[],h=[],_=[];r.reverse().forEach(v=>{var c;const t=v[2].map(a=>{const l=new C(this,this._textDocumentsAndEditors,a);if(s||h.push(C.asModelAddData(this.notebookDocument,a)),!this._cellDisposableMapping.has(l.handle)){const o=new k.DisposableStore;o.add(l),this._cellDisposableMapping.set(l.handle,o)}return l});for(let a=v[0];a<v[0]+v[1];a++)(c=this._cellDisposableMapping.get(this._cells[a].handle))===null||c===void 0||c.dispose(),this._cellDisposableMapping.delete(this._cells[a].handle);const i=new T(v[0],v[1],[],t),d=this._cells.splice(v[0],v[1],...t);for(let a of d)_.push(a.uri),i.deletedItems.push(a.cell);b.push(i)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:_}),s||this._emitter.emitModelChange((0,A.deepFreeze)({document:this.notebookDocument,changes:T.asApiEvents(b)}))}}_moveCell(r,s){const b=this._cells.splice(r,1);this._cells.splice(s,0,...b);const h=[new T(r,1,b.map(_=>_.cell),[]),new T(s,0,[],b)];this._emitter.emitModelChange((0,A.deepFreeze)({document:this.notebookDocument,changes:T.asApiEvents(h)}))}_setCellOutputs(r,s){const b=this._cells[r];b.setOutputs(s),this._emitter.emitCellOutputsChange((0,A.deepFreeze)({document:this.notebookDocument,cells:[b.cell]}))}_setCellOutputItems(r,s,b,h){const _=this._cells[r];_.setOutputItems(s,b,h),this._emitter.emitCellOutputsChange((0,A.deepFreeze)({document:this.notebookDocument,cells:[_.cell]}))}_changeCellLanguage(r,s){const b=this._cells[r];b.cell.document.languageId!==s&&this._textDocuments.$acceptModelModeChanged(b.uri,s)}_changeCellMetadata(r,s){var b;const h=this._cells[r],_=h.internalMetadata,v=h.cell.metadata;h.setMetadata(s);const c=h.cell.metadata;if((0,A.equals)(v,c)||this._emitter.emitCellMetadataChange((0,A.deepFreeze)({document:this.notebookDocument,cell:h.cell})),_.runState!==s.runState){const u=(b=s.runState)!==null&&b!==void 0?b:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,A.deepFreeze)({document:this.notebookDocument,cell:h.cell,executionState:u}))}}getCellFromIndex(r){return this._cells[r]}getCell(r){return this._cells.find(s=>s.handle===r)}getCellIndex(r){return this._cells.indexOf(r)}}e.ExtHostNotebookDocument=g,g._handlePool=0}),define(ve[178],_e([0,1,7,9]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,y){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:D,metadata:y})}replaceCellOutput(D,y){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:D,outputs:y.map(n=>k.NotebookCellOutput.from(n))})}replaceCells(D,y,n){this._throwIfFinalized(),!(D===y&&n.length===0)&&this._collectedEdits.push({editType:1,index:D,count:y-D,cells:n.map(k.NotebookCellData.from)})}}class A{constructor(D,y,n,T,C,g){this.id=D,this._proxy=y,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=C,this._visibleRanges=T,this._viewColumn=g}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.notebookDocument},get selections(){return D._selections},get visibleRanges(){return D._visibleRanges},revealRange(y,n){D._proxy.$tryRevealRange(D.id,k.NotebookCellRange.from(y),n!=null?n:E.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(y){const n=new P(this.document.version);return y(n),D._applyEdit(n.finalize())},get kernel(){return D._kernel},setDecorations(y,n){return D.setDecorations(y,n)}}}return this._editor}_acceptKernel(D){this._kernel=D}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const y=[];let n=-1;for(let T=0;T<D.cellEdits.length;T++){if(n<0){y.push(D.cellEdits[T]),n++;continue}const g=y[n],f=D.cellEdits[T];if(g.editType===1&&f.editType===1&&g.index===f.index){g.cells.push(...D.cellEdits[T].cells),g.count+=D.cellEdits[T].count;continue}y.push(D.cellEdits[T]),n++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,y)}setDecorations(D,y){if(!(y.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return y.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,k.NotebookCellRange.from(y),D.key)}}e.ExtHostNotebookEditor=A}),define(ve[179],_e([0,1,9,152,132,20,51]),function(ie,e,E,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}withProgress(C,g,f){const r=this._handles++,{title:s,location:b,cancellable:h}=g,_={label:(0,P.localize)(0,null,C.displayName||C.name),id:C.identifier.value};return this._proxy.$startProgress(r,{location:E.ProgressLocation.from(b),title:s,source:_,cancellable:h},C),this._withProgress(r,f,!!h)}_withProgress(C,g,f){let r;f&&(r=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,r));const s=h=>{this._proxy.$progressEnd(h),this._mapHandleToCancellationSource.delete(h),r&&r.dispose()};let b;try{b=g(new n(this._proxy,C),f&&r?r.token:A.CancellationToken.None)}catch(h){throw s(C),h}return b.then(h=>s(C),h=>s(C)),b}$acceptProgressCanceled(C){const g=this._mapHandleToCancellationSource.get(C);g&&(g.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=D;function y(T,C){return T.message=C.message,typeof C.increment=="number"&&(typeof T.increment=="number"?T.increment+=C.increment:T.increment=C.increment),T}class n extends k.Progress{constructor(C,g){super(f=>this.throttledReport(f));this._proxy=C,this._handle=g}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}je([(0,S.throttle)(100,(T,C)=>y(T,C),()=>Object.create(null))],n.prototype,"throttledReport",null)}),define(ve[96],_e([0,1,42,10,53,9,7]),function(ie,e,E,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(g,f){const r=D._Keys.nextId();g.$registerTextEditorDecorationType(r,A.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:r,dispose(){g.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=D,D._Keys=new P.IdGenerator("TextEditorDecorationType");class y{constructor(g,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=g,this._documentVersionId=g.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(g,f){this._throwIfFinalized();let r=null;if(g instanceof S.Position)r=new S.Range(g,g);else if(g instanceof S.Range)r=g;else throw new Error("Unrecognized location");this._pushEdit(r,f,!1)}insert(g,f){this._throwIfFinalized(),this._pushEdit(new S.Range(g,g),f,!0)}delete(g){this._throwIfFinalized();let f=null;if(g instanceof S.Range)f=g;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(g,f,r){const s=this._document.validateRange(g);this._collectedEdits.push({range:s,text:f,forceMoveMarkers:r})}setEndOfLine(g){if(this._throwIfFinalized(),g!==S.EndOfLine.LF&&g!==S.EndOfLine.CRLF)throw(0,k.illegalArgument)("endOfLine");this._setEndOfLine=g}}e.TextEditorEdit=y;class n{constructor(g,f,r,s){this._proxy=g,this._id=f,this._accept(r),this._logService=s;const b=this;this.value={get tabSize(){return b._tabSize},set tabSize(h){b._setTabSize(h)},get insertSpaces(){return b._insertSpaces},set insertSpaces(h){b._setInsertSpaces(h)},get cursorStyle(){return b._cursorStyle},set cursorStyle(h){b._setCursorStyle(h)},get lineNumbers(){return b._lineNumbers},set lineNumbers(h){b._setLineNumbers(h)}}}_accept(g){this._tabSize=g.tabSize,this._insertSpaces=g.insertSpaces,this._cursorStyle=g.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(g.lineNumbers)}_validateTabSize(g){if(g==="auto")return"auto";if(typeof g=="number"){const f=Math.floor(g);return f>0?f:null}if(typeof g=="string"){const f=parseInt(g,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(g){const f=this._validateTabSize(g);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(g){return g==="auto"?"auto":g==="false"?!1:Boolean(g)}_setInsertSpaces(g){const f=this._validateInsertSpaces(g);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(g){this._cursorStyle!==g&&(this._cursorStyle=g,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:g})))}_setLineNumbers(g){this._lineNumbers!==g&&(this._lineNumbers=g,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(g)})))}assign(g){const f={};let r=!1;if(typeof g.tabSize!="undefined"){const s=this._validateTabSize(g.tabSize);s==="auto"?(r=!0,f.tabSize=s):typeof s=="number"&&this._tabSize!==s&&(this._tabSize=s,r=!0,f.tabSize=s)}if(typeof g.insertSpaces!="undefined"){const s=this._validateInsertSpaces(g.insertSpaces);s==="auto"?(r=!0,f.insertSpaces=s):this._insertSpaces!==s&&(this._insertSpaces=s,r=!0,f.insertSpaces=s)}typeof g.cursorStyle!="undefined"&&this._cursorStyle!==g.cursorStyle&&(this._cursorStyle=g.cursorStyle,r=!0,f.cursorStyle=g.cursorStyle),typeof g.lineNumbers!="undefined"&&this._lineNumbers!==g.lineNumbers&&(this._lineNumbers=g.lineNumbers,r=!0,f.lineNumbers=A.TextEditorLineNumbersStyle.from(g.lineNumbers)),r&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(g){g.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=n;class T{constructor(g,f,r,s,b,h,_,v){this.id=g,this._proxy=f,this._logService=r,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=b,this._options=new n(this._proxy,this.id,h,r),this._visibleRanges=_,this._viewColumn=v;const c=this;this.value=Object.freeze({get document(){return s.getValue()},set document(u){throw(0,k.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(u){if(!(u instanceof S.Selection))throw(0,k.illegalArgument)("selection");c._selections=[u],c._trySetSelection()},get selections(){return c._selections},set selections(u){if(!Array.isArray(u)||u.some(t=>!(t instanceof S.Selection)))throw(0,k.illegalArgument)("selections");c._selections=u,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(u){throw(0,k.readonly)("visibleRanges")},get options(){return c._options.value},set options(u){c._disposed||c._options.assign(u)},get viewColumn(){return c._viewColumn},set viewColumn(u){throw(0,k.readonly)("viewColumn")},edit(u,t={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new y(s.getValue(),t);return u(i),c._applyEdit(i)},insertSnippet(u,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=c._selections.map(a=>A.Range.from(a));else if(t instanceof S.Position){const{lineNumber:a,column:l}=A.Position.from(t);d=[{startLineNumber:a,startColumn:l,endLineNumber:a,endColumn:l}]}else if(t instanceof S.Range)d=[A.Range.from(t)];else{d=[];for(const a of t)if(a instanceof S.Range)d.push(A.Range.from(a));else{const{lineNumber:l,column:o}=A.Position.from(a);d.push({startLineNumber:l,startColumn:o,endLineNumber:l,endColumn:o})}}return f.$tryInsertSnippet(g,u.value,d,i)},setDecorations(u,t){const i=t.length===0;i&&!c._hasDecorationsForKey.has(u.key)||(i?c._hasDecorationsForKey.delete(u.key):c._hasDecorationsForKey.add(u.key),c._runOnProxy(()=>{if(A.isDecorationOptionsArr(t))return f.$trySetDecorations(g,u.key,A.fromRangeOrRangeWithMessage(t));{const d=new Array(4*t.length);for(let a=0,l=t.length;a<l;a++){const o=t[a];d[4*a]=o.start.line+1,d[4*a+1]=o.start.character+1,d[4*a+2]=o.end.line+1,d[4*a+3]=o.end.character+1}return f.$trySetDecorationsFast(g,u.key,d)}}))},revealRange(u,t){c._runOnProxy(()=>f.$tryRevealRange(g,A.Range.from(u),t||S.TextEditorRevealType.Default))},show(u){f.$tryShowEditor(g,A.ViewColumn.from(u))},hide(){f.$tryHideEditor(g)}})}dispose(){(0,E.ok)(!this._disposed),this._disposed=!0}_acceptOptions(g){(0,E.ok)(!this._disposed),this._options._accept(g)}_acceptVisibleRanges(g){(0,E.ok)(!this._disposed),this._visibleRanges=g}_acceptViewColumn(g){(0,E.ok)(!this._disposed),this._viewColumn=g}_acceptSelections(g){(0,E.ok)(!this._disposed),this._selections=g}async _trySetSelection(){const g=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,g)),this.value}_applyEdit(g){const f=g.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const r=f.edits.map(b=>b.range);r.sort((b,h)=>b.end.line===h.end.line?b.end.character===h.end.character?b.start.line===h.start.line?b.start.character-h.start.character:b.start.line-h.start.line:b.end.character-h.end.character:b.end.line-h.end.line);for(let b=0,h=r.length-1;b<h;b++){const _=r[b].end;if(r[b+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=f.edits.map(b=>({range:A.Range.from(b.range),text:b.text,forceMoveMarkers:b.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,s,{setEndOfLine:typeof f.setEndOfLine=="number"?A.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(g){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):g().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=T}),define(ve[180],_e([0,1,135,25,2,3,6,14,7,13,11,9,20]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(b,h){if((0,n.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let _;return Array.isArray(b.highlights)&&(_=b.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),_=_.length?_:void 0),{label:b.label,highlights:_}}}class r{constructor(h,_,v){this._proxy=h,this.commands=_,this.logService=v,this.treeViews=new Map;function c(u){return u&&u.$treeViewId&&u.$treeItemHandle}_.registerArgumentProcessor({processArgument:u=>c(u)?this.convertArgument(u):Array.isArray(u)&&u.length>0?u.map(t=>c(t)?this.convertArgument(t):t):u})}registerTreeDataProvider(h,_,v){const c=this.createTreeView(h,{treeDataProvider:_},v);return{dispose:()=>c.dispose()}}createTreeView(h,_,v){if(!_||!_.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=this._proxy.$registerTreeViewDataProvider(h,{showCollapseAll:!!_.showCollapseAll,canSelectMany:!!_.canSelectMany}),u=this.createExtHostTreeView(h,_,v);return{get onDidCollapseElement(){return u.onDidCollapseElement},get onDidExpandElement(){return u.onDidExpandElement},get selection(){return u.selectedElements},get onDidChangeSelection(){return u.onDidChangeSelection},get visible(){return u.visible},get onDidChangeVisibility(){return u.onDidChangeVisibility},get message(){return u.message},set message(t){u.message=t},get title(){return u.title},set title(t){u.title=t},get description(){return u.description},set description(t){u.description=t},reveal:(t,i)=>u.reveal(t,i),dispose:async()=>{await c,this.treeViews.delete(h),u.dispose()}}}$getChildren(h,_){const v=this.treeViews.get(h);return v?v.getChildren(_):Promise.reject(new Error((0,E.localize)(0,null,h)))}async $hasResolve(h){const _=this.treeViews.get(h);if(!_)throw new Error((0,E.localize)(1,null,h));return _.hasResolve}$resolve(h,_,v){const c=this.treeViews.get(h);if(!c)throw new Error((0,E.localize)(2,null,h));return c.resolveTreeItem(_,v)}$setExpanded(h,_,v){const c=this.treeViews.get(h);if(!c)throw new Error((0,E.localize)(3,null,h));c.setExpanded(_,v)}$setSelection(h,_){const v=this.treeViews.get(h);if(!v)throw new Error((0,E.localize)(4,null,h));v.setSelection(_)}$setVisible(h,_){const v=this.treeViews.get(h);if(!v)throw new Error((0,E.localize)(5,null,h));v.setVisible(_)}createExtHostTreeView(h,_,v){const c=new s(h,_,this._proxy,this.commands.converter,this.logService,v);return this.treeViews.set(h,c),c}convertArgument(h){const _=this.treeViews.get(h.$treeViewId);return _?_.getExtensionElement(h.$treeItemHandle):null}}e.ExtHostTreeViews=r;class s extends S.Disposable{constructor(h,_,v,c,u,t){super();if(this.viewId=h,this.proxy=v,this.commands=c,this.logService=u,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new g.CancellationTokenSource,t.contributes&&t.contributes.views)for(const a in t.contributes.views)for(const l of t.contributes.views[a])l.id===h&&(this._title=l.name);this.dataProvider=_.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(a=>this._onDidChangeData.fire({message:!1,element:a})));let i,d;this._register(A.Event.debounce(this._onDidChangeData.event,(a,l)=>(a||(a={message:!1,elements:[]}),l.element!==!1&&(i||(i=new Promise(o=>d=o),this.refreshPromise=this.refreshPromise.then(()=>i)),a.elements.push(l.element)),l.message&&(a.message=!0),a),200,!0)(({message:a,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const o=d;return i=null,this.refresh(l).then(()=>o())})),a&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(h=>this.getExtensionElement(h)).filter(h=>!(0,n.isUndefinedOrNull)(h))}getChildren(h){const _=h?this.getExtensionElement(h):void 0;if(h&&!_)return this.logService.error(`No tree item with id '${h}' found.`),Promise.resolve([]);const v=this.getChildrenNodes(h);return(v?Promise.resolve(v):this.fetchChildrenNodes(_)).then(c=>c.map(u=>u.item))}getExtensionElement(h){return this.elements.get(h)}reveal(h,_){_=_||{select:!0,focus:!1};const v=(0,n.isUndefinedOrNull)(_.select)?!0:_.select,c=(0,n.isUndefinedOrNull)(_.focus)?!1:_.focus,u=(0,n.isUndefinedOrNull)(_.expand)?!1:_.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.refreshPromise.then(()=>this.resolveUnknownParentChain(h)).then(t=>this.resolveTreeNode(h,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(d=>d.item)},{select:v,focus:c,expand:u})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:v,focus:c,expand:u})}get message(){return this._message}set message(h){this._message=h,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(h){this._title=h,this.proxy.$setTitle(this.viewId,h,this._description)}get description(){return this._description}set description(h){this._description=h,this.proxy.$setTitle(this.viewId,this._title,h)}setExpanded(h,_){const v=this.getExtensionElement(h);v&&(_?this._onDidExpandElement.fire(Object.freeze({element:v})):this._onDidCollapseElement.fire(Object.freeze({element:v})))}setSelection(h){(0,T.equals)(this._selectedHandles,h)||(this._selectedHandles=h,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(h){h!==this._visible&&(this._visible=h,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(h,_){var v;if(!!this.dataProvider.resolveTreeItem){const c=this.elements.get(h);if(c){const u=this.nodes.get(c);if(u){const t=(v=await this.dataProvider.resolveTreeItem(u.extensionItem,c,_))!==null&&v!==void 0?v:u.extensionItem;return u.item.tooltip=this.getTooltip(t.tooltip),u.item.command=this.getCommand(u.disposableStore,t.command),u.item}}}}resolveUnknownParentChain(h){return this.resolveParent(h).then(_=>_?this.resolveUnknownParentChain(_).then(v=>this.resolveTreeNode(_,v[v.length-1]).then(c=>(v.push(c),v))):Promise.resolve([]))}resolveParent(h){const _=this.nodes.get(h);return _?Promise.resolve(_.parent?this.elements.get(_.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(h))}resolveTreeNode(h,_){const v=this.nodes.get(h);return v?Promise.resolve(v):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(h)).then(c=>this.createHandle(h,c,_,!0)).then(c=>this.getChildren(_?_.item.handle:void 0).then(()=>{const u=this.getExtensionElement(c);if(u){const t=this.nodes.get(u);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(h){if(h){let _;if(typeof h=="string"){const v=this.getExtensionElement(h);_=v?this.nodes.get(v):void 0}else _=h;return _&&_.children||null}return this.roots}async fetchChildrenNodes(h){this.clearChildren(h);const _=new g.CancellationTokenSource(this._refreshCancellationSource.token);try{const v=h?this.nodes.get(h):void 0,c=await this.dataProvider.getChildren(h);if(_.token.isCancellationRequested)return[];const u=await Promise.all((0,T.coalesce)(c||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!_.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,v):null}));return _.token.isCancellationRequested?[]:(0,T.coalesce)(u)}finally{_.dispose()}}refresh(h){if(h.some(v=>!v))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new g.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const v=this.getHandlesToRefresh(h);if(v.length)return this.refreshHandles(v)}return Promise.resolve(void 0)}getHandlesToRefresh(h){const _=new Set,v=h.map(u=>this.nodes.get(u));for(const u of v)if(u&&!_.has(u.item.handle)){let t=u;for(;t&&t.parent&&v.findIndex(i=>t&&t.parent&&i&&i.item.handle===t.parent.item.handle)===-1;){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&_.add(u.item.handle)}const c=[];return _.forEach(u=>{const t=this.elements.get(u);if(t){const i=this.nodes.get(t);i&&(!i.parent||!_.has(i.parent.item.handle))&&c.push(u)}}),c}refreshHandles(h){const _={};return Promise.all(h.map(v=>this.refreshNode(v).then(c=>{c&&(_[v]=c.item)}))).then(()=>Object.keys(_).length?this.proxy.$refresh(this.viewId,_):void 0)}refreshNode(h){const _=this.getExtensionElement(h);if(_){const v=this.nodes.get(_);if(v)return this.clearChildren(_),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(_)).then(c=>{if(c){const u=this.createTreeNode(_,c,v.parent);return this.updateNodeCache(_,u,v,v.parent),v.dispose(),u}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(h,_,v){const c=this.createTreeNode(h,_,v);if(_.id&&this.elements.has(c.item.handle))throw new Error((0,E.localize)(6,null,_.id));return this.addNodeToCache(h,c),this.addNodeToParentCache(c,v),c}getTooltip(h){return y.MarkdownString.isMarkdownString(h)?C.MarkdownString.from(h):h}getCommand(h,_){return _?this.commands.toInternal(_,h):void 0}createTreeNode(h,_,v){const c=new S.DisposableStore,u=this.createHandle(h,_,v),t=this.getLightIconPath(_);return{item:{handle:u,parentHandle:v?v.item.handle:void 0,label:f(_.label,this.extension),description:_.description,resourceUri:_.resourceUri,tooltip:this.getTooltip(_.tooltip),command:this.getCommand(c,_.command),contextValue:_.contextValue,icon:t,iconDark:this.getDarkIconPath(_)||t,themeIcon:this.getThemeIcon(_),collapsibleState:(0,n.isUndefinedOrNull)(_.collapsibleState)?y.TreeItemCollapsibleState.None:_.collapsibleState,accessibilityInformation:_.accessibilityInformation},extensionItem:_,parent:v,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(h){return h.iconPath instanceof y.ThemeIcon?h.iconPath:void 0}createHandle(h,{id:_,label:v,resourceUri:c},u,t){if(_)return`${s.ID_HANDLE_PREFIX}/${_}`;const i=f(v,this.extension),d=u?u.item.handle:s.LABEL_HANDLE_PREFIX;let a=i?i.label:c?(0,k.basename)(c):"";a=a.indexOf("/")!==-1?a.replace("/","//"):a;const l=this.nodes.has(h)?this.nodes.get(h).item.handle:void 0,o=this.getChildrenNodes(u)||[];let w,I=0;do{if(w=`${d}/${I}:${a}`,t||!this.elements.has(w)||l===w)break;I++}while(I<=o.length);return w}getLightIconPath(h){if(h.iconPath&&!(h.iconPath instanceof y.ThemeIcon))return typeof h.iconPath=="string"||P.URI.isUri(h.iconPath)?this.getIconPath(h.iconPath):this.getIconPath(h.iconPath.light)}getDarkIconPath(h){if(h.iconPath&&!(h.iconPath instanceof y.ThemeIcon)&&h.iconPath.dark)return this.getIconPath(h.iconPath.dark)}getIconPath(h){return P.URI.isUri(h)?h:P.URI.file(h)}addNodeToCache(h,_){this.elements.set(_.item.handle,h),this.nodes.set(h,_)}updateNodeCache(h,_,v,c){this.elements.delete(_.item.handle),this.nodes.delete(h),_.item.handle!==v.item.handle&&this.elements.delete(v.item.handle),this.addNodeToCache(h,_);const u=this.getChildrenNodes(c)||[],t=u.filter(i=>i.item.handle===v.item.handle)[0];t&&u.splice(u.indexOf(t),1,_)}addNodeToParentCache(h,_){_?(_.children||(_.children=[]),_.children.push(h)):(this.roots||(this.roots=[]),this.roots.push(h))}clearChildren(h){if(h){const _=this.nodes.get(h);if(_){if(_.children)for(const v of _.children){const c=this.elements.get(v.item.handle);c&&this.clear(c)}_.children=void 0}}else this.clearAll()}clear(h){const _=this.nodes.get(h);if(_){if(_.children)for(const v of _.children){const c=this.elements.get(v.item.handle);c&&this.clear(c)}this.nodes.delete(h),this.elements.delete(_.item.handle),_.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(h=>h.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}s.LABEL_HANDLE_PREFIX="0",s.ID_HANDLE_PREFIX="1"}),define(ve[181],_e([0,1,11,14,20,9,7,95]),function(ie,e,E,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class y{constructor(){this.testIdsToInternal=new Map}getTestById(r,s){if(s!==void 0){const b=this.testIdsToInternal.get(s),h=b==null?void 0:b.get(r);if(h)return[b,h]}return(0,E.mapFind)(this.testIdsToInternal.values(),b=>{const h=b.get(r);return h&&[b,h]})}createForHierarchy(r=()=>{}){return new g(this.createIdMap(T++),r)}createIdMap(r){const s=new C(r);return this.testIdsToInternal.set(s.id,s),{object:s,dispose:()=>this.testIdsToInternal.delete(s.id)}}}e.OwnedTestCollection=y;var n;(function(f){f[f.Disconnected=0]="Disconnected",f[f.IsChild=1]="IsChild",f[f.IsParent=2]="IsParent",f[f.IsSame=3]="IsSame"})(n=e.TestPosition||(e.TestPosition={}));let T=0;class C{constructor(r){this.id=r,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(r){if(this.map.has(r.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${r.item.extId}`);this.map.set(r.item.extId,r),r.parent||this._roots.add(r)}has(r){return this.map.has(r)}delete(r){const s=this.map.get(r);return s?(this.map.delete(r),this._roots.delete(s),!0):!1}get(r){return this.map.get(r)}comparePositions(r,s){const b=typeof r=="string"?this.map.get(r):r,h=typeof s=="string"?this.map.get(s):s;if(!b||!h)return 0;if(b===h)return 3;for(let _=this.map.get(h.parent);_;_=this.map.get(_.parent))if(_===b)return 1;for(let _=this.map.get(b.parent);_;_=this.map.get(_.parent))if(_===h)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=C;class g{constructor(r,s){this.testIdToInternal=r,this.publishDiff=s,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new k.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(r,s){this.addItem(r,s,null)}getTestByReference(r){return this.testItemToInternal.get(r)}collectDiff(){const r=this.diff;return this.diff=[],r}pushDiff(r){const s=this.diff[this.diff.length-1];if(s&&r[0]===1){if(s[0]===1&&s[1].extId===r[1].extId){(0,D.applyTestItemUpdate)(s[1],r[1]);return}if(s[0]===0&&s[1].item.extId===r[1].extId){(0,D.applyTestItemUpdate)(s[1],r[1]);return}}this.diff.push(r),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(r,s){var b;const h=this.testIdToInternal.object.get(r);if(!!h){if((h.expandLevels===void 0||s>h.expandLevels)&&(h.expandLevels=s),h.expand===1){const _=this.refreshChildren(h);return _.isSettled?this.expandChildren(h,s-1):_.p.then(()=>this.expandChildren(h,s-1))}else if(h.expand===3)return((b=h.initialExpand)===null||b===void 0?void 0:b.isSettled)===!1?h.initialExpand.p.then(()=>this.expandChildren(h,s-1)):this.expandChildren(h,s-1)}}dispose(){var r;for(const s of this.testItemToInternal.values())(r=s.discoverCts)===null||r===void 0||r.dispose(!0),s.actual[S.TestItemHookProperty]=void 0;this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}addItem(r,s,b){if(!(r instanceof S.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${r.id} did not`);if(this.testItemToInternal.has(r))throw new Error(`Attempted to add a single TestItem ${r.id} multiple times to the tree`);if(this.testIdToInternal.object.has(r.id))throw new Error(`Attempted to insert a duplicate test item ID ${r.id}`);const h=b?b.item.extId:null,_=r.expandable?1:0,v=b==null?void 0:b.expandLevels,c={provider:s,tree:this.testIdToInternal.object.id},u={actual:r,parent:h,item:A.TestItem.from(r),expandLevels:v&&_===1?v-1:void 0,expand:_,src:c};this.testIdToInternal.object.add(u),this.testItemToInternal.set(r,u),this.pushDiff([0,{parent:h,src:c,expand:_,item:u.item}]),r[S.TestItemHookProperty]={created:t=>this.addItem(t,s,u),delete:t=>this.removeItembyId(t),invalidate:t=>this.pushDiff([4,t]),setProp:(t,i)=>this.pushDiff([1,{extId:r.id,item:{[t]:t==="range"?A.Range.from(i):i}}])};for(const t of r.children)this.addItem(t,s,u)}expandChildren(r,s){if(!(s<0)){const b=[...r.actual.children].map(h=>this.expand(h.id,s-1)).filter(k.isThenable);if(b.length)return Promise.all(b).then(()=>{})}}refreshChildren(r){r.discoverCts&&r.discoverCts.dispose(!0),r.expand=2,r.discoverCts=new P.CancellationTokenSource,this.pushExpandStateUpdate(r);const s=new k.DeferredPromise;return r.initialExpand=s,r.actual.discoverChildren({report:b=>{b.busy?(r.expand=2,this.pushExpandStateUpdate(r)):(r.expand=3,s.isSettled||s.complete(),this.pushExpandStateUpdate(r))}},r.discoverCts.token),s}pushExpandStateUpdate(r){this.pushDiff([1,{extId:r.actual.id,expand:r.expand}])}removeItembyId(r){var s;this.pushDiff([2,r]);const b=[this.testIdToInternal.object.get(r)];for(;b.length;){const h=b.pop();if(!!h){(s=h.discoverCts)===null||s===void 0||s.dispose(!0),this.testIdToInternal.object.delete(h.item.extId),this.testItemToInternal.delete(h.actual);for(const _ of h.actual.children)b.push(this.testIdToInternal.object.get(_.id))}}}flushDiff(){const r=this.collectDiff();r.length&&this.publishDiff(r)}}e.SingleUseTestCollection=g}),define(ve[182],_e([0,1,26,3,12]),function(ie,e,E,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(T){this.removedDueToLooping=T}}e.DeltaExtensionsResult=A;class S{constructor(T){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=T,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const T of this._extensionDescriptions){if(this._extensionsMap.has(E.ExtensionIdentifier.toKey(T.identifier))){console.error("Extension `"+T.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(E.ExtensionIdentifier.toKey(T.identifier),T),this._extensionsArr.push(T),Array.isArray(T.activationEvents))for(let C of T.activationEvents)C==="onUri"&&(C=`onUri:${E.ExtensionIdentifier.toKey(T.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(T)}}keepOnly(T){const C=new Set;T.forEach(g=>C.add(E.ExtensionIdentifier.toKey(g))),this._extensionDescriptions=this._extensionDescriptions.filter(g=>C.has(E.ExtensionIdentifier.toKey(g.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(T,C){T.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(T));const g=S._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(g.map(f=>f.identifier)),C.length>0){const f=new Set;C.forEach(r=>f.add(E.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>!f.has(E.ExtensionIdentifier.toKey(r.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(g)}static _findLoopingExtensions(T){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(b){this._nodesSet.has(b)||(this._nodesSet.add(b),this._nodesArr.push(b))}addArc(b,h){this.addNode(b),this.addNode(h),this._arcs.has(b)?this._arcs.get(b).push(h):this._arcs.set(b,[h])}getArcs(b){return this._arcs.has(b)?this._arcs.get(b):[]}hasOnlyGoodArcs(b,h){const _=C.getArcs(b);for(let v=0;v<_.length;v++)if(!h.has(_[v]))return!1;return!0}getNodes(){return this._nodesArr}};let g=new Map;for(let b of T){const h=E.ExtensionIdentifier.toKey(b.identifier);if(g.set(h,b),b.extensionDependencies)for(let _ of b.extensionDependencies){const v=E.ExtensionIdentifier.toKey(_);C.addArc(h,v)}}let f=new Set;C.getNodes().filter(b=>C.getArcs(b).length===0).forEach(b=>f.add(b));let r=C.getNodes().filter(b=>!f.has(b)),s;do{s=!1;for(let b=0;b<r.length;b++){const h=r[b];C.hasOnlyGoodArcs(h,f)&&(r.splice(b,1),b--,f.add(h),s=!0)}}while(s);return r.map(b=>g.get(b))}containsActivationEvent(T){return this._activationMap.has(T)}containsExtension(T){return this._extensionsMap.has(E.ExtensionIdentifier.toKey(T))}getExtensionDescriptionsForActivationEvent(T){const C=this._activationMap.get(T);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(T){const C=this._extensionsMap.get(E.ExtensionIdentifier.toKey(T));return C||void 0}}e.ExtensionDescriptionRegistry=S;var D;(function(n){n[n.Builtin=0]="Builtin",n[n.User=1]="User",n[n.Dev=2]="Dev"})(D||(D={}));function y(n,T){const C=n.isBuiltin?0:n.isUnderDevelopment?2:1,g=T.isBuiltin?0:T.isUnderDevelopment?2:1;if(C!==g)return C-g;const f=P.posix.basename(n.extensionLocation.path),r=P.posix.basename(T.extensionLocation.path);return f<r?-1:f>r?1:0}}),define(ve[183],_e([0,1,23]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var k;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(k=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var P;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(P=e.MessageType||(e.MessageType={}));function A(D){const y=E.VSBuffer.alloc(1);switch(D){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=A;function S(D,y){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=S}),define(ve[33],_e([0,1,3,2,4,26,149]),function(ie,e,E,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,P.createDecorator)("extensionService");class D{constructor(_){this.dependency=_}}e.MissingDependencyError=D;var y;(function(h){h[h.LocalProcess=0]="LocalProcess",h[h.LocalWebWorker=1]="LocalWebWorker",h[h.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(_,v,c,u){this.codeLoadingTime=_,this.activateCallTime=v,this.activateResolvedTime=c,this.activationReason=u}}e.ActivationTimes=n;class T{constructor(_,v){this.description=_,this.value=v}}e.ExtensionPointContribution=T,e.ExtensionHostLogFileName="exthost";var C;(function(h){h[h.Normal=0]="Normal",h[h.Immediate=1]="Immediate"})(C=e.ActivationKind||(e.ActivationKind={}));function g(h){h.enableProposedApi||f(h)}e.checkProposedApiEnabled=g;function f(h){throw new Error(`[${h.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${h.identifier.value}`)}e.throwProposedApiError=f;function r(h){return{type:h.isBuiltin?0:1,isBuiltin:h.isBuiltin||h.isUserBuiltin,identifier:{id:(0,S.getGalleryExtensionId)(h.publisher,h.name),uuid:h.uuid},manifest:h,location:h.extensionLocation}}e.toExtension=r;function s(h){return Object.assign(Object.assign({identifier:new A.ExtensionIdentifier(h.identifier.id),isBuiltin:h.type===0,isUserBuiltin:h.type===1&&h.isBuiltin,isUnderDevelopment:!1,extensionLocation:h.location},h.manifest),{uuid:h.identifier.uuid})}e.toExtensionDescription=s;class b{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None}activateByEvent(_){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(_){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(_){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(_){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(_,v){}_activateById(_,v){return Promise.resolve()}_onWillActivateExtension(_){}_onDidActivateExtension(_,v,c,u,t){}_onExtensionRuntimeError(_,v){}_onExtensionHostExit(_){}}e.NullExtensionService=b}),define(ve[184],_e([0,1,130,26,33,19]),function(ie,e,E,k,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class D{constructor(s,b,h,_){this.startup=s,this.codeLoadingTime=b,this.activateCallTime=h,this.activateResolvedTime=_}}e.ExtensionActivationTimes=D,D.NONE=new D(!1,-1,-1,-1);class y{constructor(s){this._startup=s,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(s,b){return s===-1||b===-1?-1:b-s}build(){return new D(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class n{constructor(s,b,h,_,v,c){this.activationFailed=s,this.activationFailedError=b,this.activationTimes=h,this.module=_,this.exports=v,this.subscriptions=c}}e.ActivatedExtension=n;class T extends n{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class C extends n{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=C;class g extends n{constructor(s){super(!0,s,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=g;let f=class{constructor(s,b,h,_,v){this._logService=v,this._registry=s,this._resolvedExtensionsSet=new Set,b.forEach(c=>this._resolvedExtensionsSet.add(k.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,h.forEach(c=>this._hostExtensionsMap.set(k.ExtensionIdentifier.toKey(c),c)),this._host=_,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(s){const b=k.ExtensionIdentifier.toKey(s);return this._activatedExtensions.has(b)}getActivatedExtension(s){const b=k.ExtensionIdentifier.toKey(s),h=this._activatedExtensions.get(b);if(!h)throw new Error("Extension `"+s.value+"` is not known or not activated");return h}activateByEvent(s,b){if(this._alreadyActivatedEvents[s])return S;const h=this._registry.getExtensionDescriptionsForActivationEvent(s);return this._activateExtensions(h.map(_=>({id:_.identifier,reason:{startup:b,extensionId:_.identifier,activationEvent:s}}))).then(()=>{this._alreadyActivatedEvents[s]=!0})}activateById(s,b){const h=this._registry.getExtensionDescription(s);if(!h)throw new Error("Extension `"+s+"` is not known");return this._activateExtensions([{id:h.identifier,reason:b}])}_handleActivateRequest(s,b,h){if(this._hostExtensionsMap.has(k.ExtensionIdentifier.toKey(s.id))){b[k.ExtensionIdentifier.toKey(s.id)]=s;return}const _=this._registry.getExtensionDescription(s.id);if(!_){this._host.onExtensionActivationError(s.id,new P.MissingDependencyError(s.id.value));const u=new Error(`Unknown dependency '${s.id.value}'`);this._activatedExtensions.set(k.ExtensionIdentifier.toKey(s.id),new g(u));return}const v=typeof _.extensionDependencies=="undefined"?[]:_.extensionDependencies;let c=!0;for(let u=0,t=v.length;u<t;u++){const i=v[u];if(!this._resolvedExtensionsSet.has(k.ExtensionIdentifier.toKey(i))){const d=this._activatedExtensions.get(k.ExtensionIdentifier.toKey(i));if(!(d&&!d.activationFailed)){if(d&&d.activationFailed){this._host.onExtensionActivationError(_.identifier,E.localize(0,null,_.displayName||_.identifier.value,i));const o=new Error(`Dependency ${i} failed to activate`);o.detail=d.activationFailedError,this._activatedExtensions.set(k.ExtensionIdentifier.toKey(_.identifier),new g(o));return}if(this._hostExtensionsMap.has(k.ExtensionIdentifier.toKey(i))){c=!1,b[k.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(k.ExtensionIdentifier.toKey(i)),reason:s.reason};continue}const a=this._registry.getExtensionDescription(i);if(a){c=!1,b[k.ExtensionIdentifier.toKey(i)]={id:a.identifier,reason:s.reason};continue}this._host.onExtensionActivationError(_.identifier,new P.MissingDependencyError(i));const l=new Error(`Unknown dependency '${i}'`);this._activatedExtensions.set(k.ExtensionIdentifier.toKey(_.identifier),new g(l));return}}}c?b[k.ExtensionIdentifier.toKey(_.identifier)]=s:h.push(s)}_activateExtensions(s){if(s.length===0||(s=s.filter(v=>!this._activatedExtensions.has(k.ExtensionIdentifier.toKey(v.id))),s.length===0))return Promise.resolve(void 0);const b=Object.create(null),h=[];for(let v=0,c=s.length;v<c;v++)this._handleActivateRequest(s[v],b,h);for(let v=0,c=h.length;v<c;v++){const u=k.ExtensionIdentifier.toKey(h[v].id);b[u]&&delete b[u]}const _=Object.keys(b).map(v=>b[v]);return h.length===0?Promise.all(_.map(v=>this._activateExtension(v.id,v.reason))).then(v=>{}):this._activateExtensions(_).then(v=>this._activateExtensions(h))}_activateExtension(s,b){const h=k.ExtensionIdentifier.toKey(s);if(this._activatedExtensions.has(h))return Promise.resolve(void 0);const _=this._activatingExtensions.get(h);if(_)return _;const v=this._host.actualActivateExtension(s,b).then(void 0,c=>(this._host.onExtensionActivationError(s,E.localize(1,null,s.value,c.message)),this._logService.error(`Activating extension ${s.value} failed due to an error:`),this._logService.error(c),new g(c))).then(c=>{this._activatedExtensions.set(h,c),this._activatingExtensions.delete(h)});return this._activatingExtensions.set(h,v),v}};f=je([Ke(4,A.ILogService)],f),e.ExtensionsActivator=f}),define(ve[185],_e([0,1,10]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class k{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,S)=>{this._actualOk=A,this._actualErr=S,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,E.onUnexpectedError)(A))}then(A,S){return this._ensureActual().then(A,S)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=k}),define(ve[97],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class E{constructor(y,n){this.isMain=y,this.sid=n,this.nid=++E.count}}e.ProxyIdentifier=E,E.count=0;const k=[];function P(D){const y=new E(!0,D);return k[y.nid]=y,y}e.createMainContextProxyIdentifier=P;function A(D){const y=new E(!1,D);return k[y.nid]=y,y}e.createExtHostContextProxyIdentifier=A;function S(D){return k[D].sid}e.getStringIdentifierForProxy=S}),define(ve[5],_e([0,1,2,97,57]),function(ie,e,E,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var S;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(S=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var n;(function(c){c[c.Markdown=1]="Markdown",c[c.Code=2]="Code"})(n=e.CellKind||(e.CellKind={}));var T;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var g;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(g=e.CandidatePortSource||(e.CandidatePortSource={}));var f;(function(c){c.name="$ident";function u(i,d){return Object.defineProperty(i,c.name,{value:d,enumerable:!0}),i}c.mixin=u;function t(i){return i[c.name]}c.of=t})(f=e.ObjectIdentifier||(e.ObjectIdentifier={}));class r{static mixin(u){return u._id=r._n++,u}}e.IdObject=r,r._n=0;var s;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n",c.label2="o"})(s=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var b;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(b=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var h;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(h=e.WorkspaceEditType||(e.WorkspaceEditType={}));function _(c){if(c&&c.edits)for(const u of c.edits)typeof u.resource=="object"?u.resource=E.URI.revive(u.resource):(u.newUri=E.URI.revive(u.newUri),u.oldUri=E.URI.revive(u.oldUri)),u.metadata&&u.metadata.iconPath&&(u.metadata=(0,P.revive)(u.metadata));return c}e.reviveWorkspaceEditDto=_;var v;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,k.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,k.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,k.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,k.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,k.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,k.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ve[72],_e([0,1,5,3,4]),function(ie,e,E,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(D){this._onDidChangePassword=new k.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(E.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,y){return this._proxy.$getPassword(D,y)}store(D,y,n){return this._proxy.$setPassword(D,y,n)}delete(D,y){return this._proxy.$deletePassword(D,y)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,P.createDecorator)("IExtHostSecretState")}),define(ve[73],_e([0,1,4,19,5,15]),function(ie,e,E,k,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,E.createDecorator)("IExtHostApiDeprecationService");let S=class{constructor(y,n){this._extHostLogService=n,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(P.MainContext.MainThreadTelemetry)}report(y,n,T){const C=this.getUsageKey(y,n);this._reportedUsages.has(C)||(this._reportedUsages.add(C),n.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${T}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:n.identifier.value,apiId:y}))}getUsageKey(y,n){return`${y}-${n.identifier.value}`}};S=je([Ke(0,A.IExtHostRpcService),Ke(1,k.ILogService)],S),e.ExtHostApiDeprecationService=S,e.NullApiDeprecationService=Object.freeze(new class{report(D,y,n){}})}),define(ve[186],_e([0,1,3,5,7,26]),function(ie,e,E,k,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class S{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new E.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new E.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(k.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(y,n,T,C={}){const g=A.ExtensionIdentifier.toKey(y.identifier),f=this._inFlightRequests.get(g)||[],r=T.sort().join(" ");let s=f.find(b=>b.scopes===r);if(s)return s.result;{const b=this._getSession(y,g,n,T,C);s={scopes:r,result:b},f.push(s),this._inFlightRequests.set(g,f);try{await b}finally{const h=f.findIndex(_=>_.scopes===r);h>-1&&(f.splice(h),this._inFlightRequests.set(g,f))}return b}}async _getSession(y,n,T,C,g={}){await this._proxy.$ensureProvider(T);const f=y.displayName||y.name;return this._proxy.$getSession(T,C,n,f,g)}async removeSession(y,n){const T=this._authenticationProviders.get(y);return T?T.provider.removeSession(n):this._proxy.$removeSession(y,n)}registerAuthenticationProvider(y,n,T,C){var g;if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:n,provider:T,options:C!=null?C:{supportsMultipleAccounts:!1}}),this._providers.find(r=>r.id===y)||this._providers.push({id:y,label:n});const f=T.onDidChangeSessions(r=>{var s,b,h;this._proxy.$sendDidChangeSessions(y,{added:(s=r.added)!==null&&s!==void 0?s:[],changed:(b=r.changed)!==null&&b!==void 0?b:[],removed:(h=r.removed)!==null&&h!==void 0?h:[]})});return this._proxy.$registerAuthenticationProvider(y,n,(g=C==null?void 0:C.supportsMultipleAccounts)!==null&&g!==void 0?g:!1),new P.Disposable(()=>{f.dispose(),this._authenticationProviders.delete(y);const r=this._providers.findIndex(s=>s.id===y);r>-1&&this._providers.splice(r),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,n){const T=this._authenticationProviders.get(y);if(T)return Promise.resolve(T.provider.createSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,n){const T=this._authenticationProviders.get(y);if(T)return Promise.resolve(T.provider.removeSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,n){const T=this._authenticationProviders.get(y);if(T)return Promise.resolve(T.provider.getSessions(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,n){return this._onDidChangeSessions.fire({provider:{id:y,label:n}}),Promise.resolve()}$onDidChangeAuthenticationProviders(y,n){return y.forEach(T=>{this._providers.some(C=>C.id===T.id)||this._providers.push(T)}),n.forEach(T=>{const C=this._providers.findIndex(g=>g.id===T.id);C>-1&&this._providers.splice(C)}),this._onDidChangeAuthenticationProviders.fire({added:y,removed:n}),Promise.resolve()}}e.ExtHostAuthentication=S}),define(ve[187],_e([0,1,5,15,9]),function(ie,e,E,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(D,y){this._extHostDocumentsAndEditors=y,this._proxy=D.getProxy(E.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(D){const y=P.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};A=je([Ke(0,k.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(ve[188],_e([0,1,5]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class k{constructor(A){const S=A.getProxy(E.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return S.$readText()},writeText(D){return S.$writeText(D)}})}}e.ExtHostClipboard=k}),define(ve[74],_e([0,1,13,7,9,24,5,11,19,57,32,38,2,6,4,15]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g,f,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let b=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(S.MainContext.MainThreadCommands),this._logService=i,this.converter=new h(this,d=>{const a=this._apiCommands.get(d);return(a==null?void 0:a.result)===v.Void?a:void 0},i),this._argumentProcessors=[{processArgument(d){return(0,n.revive)(d)}},{processArgument(d){return(0,A.cloneAndChange)(d,function(a){if(T.Range.isIRange(a))return P.Range.to(a);if(C.Position.isIPosition(a))return P.Position.to(a);if(T.Range.isIRange(a.range)&&g.URI.isUri(a.uri))return P.location.to(a);if(!Array.isArray(a))return a})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...d)=>{const a=t.args.map((o,w)=>{if(!o.validate(d[w]))throw new Error(`Invalid argument '${o.name}' when running '${t.id}', received: ${d[w]}`);return o.convert(d[w])}),l=await this.executeCommand(t.internalId,...a);return t.result.convert(l,d,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new k.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,d,a,l){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:d,thisArg:a,description:l}),t&&this._proxy.$registerCommand(i),new k.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,d){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const a=(0,A.cloneAndChange)(i,function(l){if(l instanceof k.Position)return P.Position.from(l);if(l instanceof k.Range)return P.Range.from(l);if(l instanceof k.Location)return P.location.from(l);if(!Array.isArray(l))return l});try{const l=await this._proxy.$executeCommand(t,a,d);return(0,n.revive)(l)}catch(l){if(l instanceof Error&&l.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw l}}}async _executeContributedCommand(t,i){const d=this._commands.get(t);if(!d)throw new Error("Unknown command");let{callback:a,thisArg:l,description:o}=d;if(o)for(let w=0;w<o.args.length;w++)try{(0,E.validateConstraint)(i[w],o.args[w].constraint)}catch(I){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${o.args[w].name}' - ${o.args[w].description}`)}try{return await a.apply(l,i)}catch(w){if(t===this.converter.delegatingCommandId){const I=this.converter.getActualCommand(...i);I&&(t=I.command)}throw this._logService.error(w,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(d=>this._argumentProcessors.reduce((a,l)=>l.processArgument(a),d)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(d=>d[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,d]of this._commands){let{description:a}=d;a&&(t[i]=a)}return Promise.resolve(t)}};b=je([Ke(0,s.IExtHostRpcService),Ke(1,y.ILogService)],b),e.ExtHostCommands=b,e.IExtHostCommands=(0,r.createDecorator)("IExtHostCommands");class h{constructor(t,i,d){this._commands=t,this._lookupApiCommand=i,this._logService=d,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!!t){const d={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return d;const a=this._lookupApiCommand(t.command);if(a)d.id=a.internalId,d.arguments=a.args.map((l,o)=>l.convert(t.arguments&&t.arguments[o]));else if((0,D.isNonEmptyArray)(t.arguments)){const l=++this._cachIdPool;this._cache.set(l,t),i.add((0,f.toDisposable)(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),d.$ident=l,d.id=this.delegatingCommandId,d.arguments=[l],this._logService.trace("CommandsConverter#CREATE",t.command,l)}return d}}fromInternal(t){const i=S.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=h;class _{constructor(t,i,d,a){this.name=t,this.description=i,this.validate=d,this.convert=a}optional(){return new _(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new _(t!=null?t:this.name,i!=null?i:this.description,this.validate,this.convert)}}e.ApiCommandArgument=_,_.Uri=new _("uri","Uri of a text document",u=>g.URI.isUri(u),u=>u),_.Position=new _("position","A position in a text document",u=>k.Position.isPosition(u),P.Position.from),_.Range=new _("range","A range in a text document",u=>k.Range.isRange(u),P.Range.from),_.Selection=new _("selection","A selection in a text document",u=>k.Selection.isSelection(u),P.Selection.from),_.Number=new _("number","",u=>typeof u=="number",u=>u),_.String=new _("string","",u=>typeof u=="string",u=>u),_.CallHierarchyItem=new _("item","A call hierarchy item",u=>u instanceof k.CallHierarchyItem,P.CallHierarchyItem.to);class v{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=v,v.Void=new v("no result",u=>u);class c{constructor(t,i,d,a,l){this.id=t,this.internalId=i,this.description=d,this.args=a,this.result=l}}e.ApiCommand=c}),define(ve[189],_e([0,1,6,9,7,62,74,167,11,85]),function(ie,e,E,k,P,A,S,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const T=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",g(k.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(r,s)=>{if(!(0,y.isFalsyOrEmpty)(r)){class b extends P.SymbolInformation{static to(_){const v=new b(_.name,k.SymbolKind.to(_.kind),_.containerName||"",new P.Location(s[0],k.Range.to(_.range)));return v.detail=_.detail,v.range=v.location.range,v.selectionRange=k.Range.to(_.selectionRange),v.children=_.children?_.children.map(b.to):[],v}}return r.map(b.to)}})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(k.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(k.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new S.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(k.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",g(k.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",g(k.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(s=>P.Position.isPosition(s)),r=>r.map(k.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(s=>{let b;for(const h of s.reverse())b=new P.SelectionRange(k.Range.to(h),b);return b}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>{const s=[];if(Array.isArray(r))for(let b of r)s.push(...b[1].map(k.WorkspaceSymbol.to));return s})),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(k.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(k.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(k.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return k.WorkspaceEdit.to(r)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(k.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new P.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const s=(0,n.decodeSemanticTokensDto)(r);if(s.type==="full")return new P.SemanticTokens(s.data,void 0)}})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new P.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const s=(0,n.decodeSemanticTokensDto)(r);if(s.type==="full")return new P.SemanticTokens(s.data,void 0)}})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,s,b)=>{if(!r)return new P.CompletionList([]);const h=r.suggestions.map(_=>k.CompletionItem.to(_,b));return new P.CompletionList(h,r.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return k.SignatureHelp.to(r)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,s,b)=>g(h=>new P.CodeLens(k.Range.to(h.range),h.command&&b.fromInternal(h.command)))(r))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>P.Range.isRange(r),r=>P.Selection.isSelection(r)?k.Selection.from(r):k.Range.from(r)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,s,b)=>g(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return b.fromInternal(h.command)}else{const _=new P.CodeAction(h.title,h.kind?new P.CodeActionKind(h.kind):void 0);return h.edit&&(_.edit=k.WorkspaceEdit.to(h.edit)),h.command&&(_.command=b.fromInternal(h.command)),_.isPreferred=h.isPreferred,_}})(r))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(s=>new P.ColorInformation(k.Range.to(s.range),k.Color.to(s.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",r=>r instanceof P.Color,k.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:k.Range.from(r.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(k.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineHint objects",r=>r.map(k.InlineHint.to))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",g(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientMetadata:r.options.transientMetadata},filenamePattern:r.filenamePattern.map(s=>k.NotebookExclusiveDocumentPattern.to(s))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(k.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)]).optional()],S.ApiCommandResult.Void)];class C{constructor(s){this._disposables=new E.DisposableStore,this._commands=s}static register(s){return T.forEach(s.registerApiCommand,s),new C(s).registerCommands()}registerCommands(){const s=b=>(...h)=>b(this._commands,...h);this._register(D.RemoveFromRecentlyOpenedAPICommand.ID,s(D.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:b=>typeof b=="string"}]}),this._register(D.OpenIssueReporter.ID,s(D.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:b=>typeof b=="string"||typeof b=="object"&&typeof b.extensionId=="string"}]})}_register(s,b,h){const _=this._commands.registerCommand(!1,s,b,this,h);this._disposables.add(_)}}e.ExtHostApiCommands=C;function g(r){return s=>{if(Array.isArray(s))return s.map(r)}}function f(r){if(!!Array.isArray(r)){const s=[];for(const b of r)A.isLocationLink(b)?s.push(k.DefinitionLink.to(b)):s.push(k.location.to(b));return s}}}),define(ve[190],_e([0,1,14,51,3,6,2,62,26,9,7,5]),function(ie,e,E,k,P,A,S,D,y,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class g{constructor(c,u,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=c.getProxy(C.MainContext.MainThreadComments),u.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const d=this._commentControllers.get(i.handle);return d||i}else if(i&&i.$mid===7){const d=this._commentControllers.get(i.commentControlHandle);if(!d)return i;const a=d.getCommentThread(i.commentThreadHandle);return a||i}else if(i&&i.$mid===8){const d=this._commentControllers.get(i.thread.commentControlHandle);if(!d)return i;const a=d.getCommentThread(i.thread.commentThreadHandle);return a?{thread:a,text:i.text}:i}else if(i&&i.$mid===9){const d=this._commentControllers.get(i.thread.commentControlHandle);if(!d)return i;const a=d.getCommentThread(i.thread.commentThreadHandle);if(!a)return i;let l=i.commentUniqueId,o=a.getCommentByUniqueId(l);return o||i}else if(i&&i.$mid===10){const d=this._commentControllers.get(i.thread.commentControlHandle);if(!d)return i;const a=d.getCommentThread(i.thread.commentThreadHandle);if(!a)return i;let l=i.text,o=i.commentUniqueId,w=a.getCommentByUniqueId(o);return w?(w.body=l,w):i}return i}})}createCommentController(c,u,t){const i=g.handlePool++,d=new r(c,i,this._proxy,u,t);this._commentControllers.set(d.handle,d);const a=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(c.identifier))||[];return a.push(d),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(c.identifier),a),d}$createCommentThreadTemplate(c,u,t){const i=this._commentControllers.get(c);!i||i.$createCommentThreadTemplate(u,t)}async $updateCommentThreadTemplate(c,u,t){const i=this._commentControllers.get(c);!i||i.$updateCommentThreadTemplate(u,t)}$deleteCommentThread(c,u){const t=this._commentControllers.get(c);t&&t.$deleteCommentThread(u)}$provideCommentingRanges(c,u,t){const i=this._commentControllers.get(c);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const d=this._documents.getDocument(S.URI.revive(u));return(0,E.asPromise)(()=>i.commentingRangeProvider.provideCommentingRanges(d,t)).then(a=>a?a.map(l=>n.Range.from(l)):void 0)}$toggleReaction(c,u,t,i,d){const a=this._commentControllers.get(c);return!a||!a.reactionHandler?Promise.resolve(void 0):(0,E.asPromise)(()=>{const l=a.getCommentThread(u);if(l){const o=l.getCommentByUniqueId(i.uniqueIdInThread);if(a!==void 0&&o&&a.reactionHandler)return a.reactionHandler(o,h(d))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=g,g.handlePool=0;class f{constructor(c,u,t,i,d,a,l){this._proxy=c,this._commentController=u,this._id=t,this._uri=i,this._range=d,this._comments=a,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new P.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${u.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,n.Range.from(this._range),l),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=a}set threadId(c){this._id=c}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(c){c.isEqual(this._range)||(this._range=c,this.modifications.range=c,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(c){this._canReply!==c&&(this._canReply=c,this.modifications.canReply=c,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(c){this._label=c,this.modifications.label=c,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(c){this._contextValue=c,this.modifications.contextValue=c,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(c){this._comments=c,this.modifications.comments=c,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(c){this._collapseState=c,this.modifications.collapsibleState=c,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const c=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),u={};c("range")&&(u.range=n.Range.from(this._range)),c("label")&&(u.label=this.label),c("contextValue")&&(u.contextValue=this.contextValue),c("comments")&&(u.comments=this._comments.map(t=>s(this,this._commentController,t,this._commentsMap))),c("collapsibleState")&&(u.collapseState=_(this._collapseState)),c("canReply")&&(u.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,u)}}getCommentByUniqueId(c){for(let u of this._commentsMap){let t=u[0],i=u[1];if(c===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(c=>c.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}f._handlePool=0,je([(0,k.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=f;class r{constructor(c,u,t,i,d){this._extension=c,this._handle=u,this._proxy=t,this._id=i,this._label=d,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,d)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(c){this._reactionHandler=c,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this._options}set options(c){this._options=c,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(c,u,t,i){if(typeof c=="string"){const d=new f(this._proxy,this,c,u,t,i,this._extension.identifier);return this._threads.set(d.handle,d),d}else{const d=new f(this._proxy,this,void 0,c,u,t,this._extension.identifier);return this._threads.set(d.handle,d),d}}$createCommentThreadTemplate(c,u){const t=new f(this._proxy,this,void 0,S.URI.revive(c),n.Range.to(u),[],this._extension.identifier);return t.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(c,u){let t=this._threads.get(c);t&&(t.range=n.Range.to(u))}$deleteCommentThread(c){let u=this._threads.get(c);u&&u.dispose(),this._threads.delete(c)}getCommentThread(c){return this._threads.get(c)}dispose(){this._threads.forEach(c=>{c.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function s(v,c,u,t){let i=t.get(u);i||(i=++v.commentHandle,t.set(u,i));const d=u.author&&u.author.iconPath?u.author.iconPath.toString():void 0;return{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:i,body:n.MarkdownString.from(u.body),userName:u.author.name,userIconPath:d,label:u.label,commentReactions:u.reactions?u.reactions.map(a=>b(a)):void 0}}function b(v){return{label:v.label,iconPath:v.iconPath?n.pathOrURIToURI(v.iconPath):void 0,count:v.count,hasReacted:v.authorHasReacted}}function h(v){return{label:v.label||"",count:v.count||0,iconPath:v.iconPath?S.URI.revive(v.iconPath):"",authorHasReacted:v.hasReacted||!1}}function _(v){if(v!==void 0)switch(v){case T.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}}),define(ve[98],_e([0,1,2,5,7,4,15,19,11,8,12]),function(ie,e,E,k,P,A,S,D,y,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class un{constructor(f,r){this._logService=r,this._provider=new Map,this._proxy=f.getProxy(k.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,r){const s=un._handlePool++;this._provider.set(s,{provider:f,extensionId:r}),this._proxy.$registerDecorationProvider(s,r.value);const b=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(h=>{if(!h){this._proxy.$onDidChange(s,null);return}let _=(0,y.asArray)(h);if(_.length<=un._maxEventSize){this._proxy.$onDidChange(s,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",r.value,_.length);const v=_.map(t=>({uri:t,rank:(0,n.count)(t.path,"/")})),c=(0,y.groupBy)(v,(t,i)=>t.rank-i.rank||(0,n.compare)(t.uri.path,i.uri.path));let u=[];e:for(let t of c){let i;for(let d of t){let a=(0,T.dirname)(d.uri.path);if(i!==a&&(i=a,u.push(d.uri)>=un._maxEventSize))break e}}this._proxy.$onDidChange(s,u)});return new P.Disposable(()=>{b==null||b.dispose(),this._proxy.$unregisterDecorationProvider(s),this._provider.delete(s)})}async $provideDecorations(f,r,s){if(!this._provider.has(f))return Object.create(null);const b=Object.create(null),{provider:h,extensionId:_}=this._provider.get(f);return await Promise.all(r.map(async v=>{try{const{uri:c,id:u}=v,t=await Promise.resolve(h.provideFileDecoration(E.URI.revive(c),s));if(!t)return;try{P.FileDecoration.validate(t),b[u]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${_.value}': ${i}`)}}catch(c){this._logService.error(c)}})),b}};C._handlePool=0,C._maxEventSize=250,C=je([Ke(0,S.IExtHostRpcService),Ke(1,D.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(ve[191],_e([0,1,129,88,2,5,7,9,3,19,22]),function(ie,e,E,k,P,A,S,D,y,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{constructor(r,s,b,h,_){this._name=r,this._owner=s,this._maxDiagnosticsPerFile=b,this._proxy=h,this._onDidChangeDiagnostics=_,this._isDisposed=!1,this._data=new T.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(r,s){if(!r){this.clear();return}this._checkDisposed();let b=[];if(P.URI.isUri(r)){if(!s){this.delete(r);return}this._data.set(r,s.slice()),b=[r]}else if(Array.isArray(r)){b=[];let _;r=[...r].sort(C._compareIndexedTuplesByUri);for(const v of r){const[c,u]=v;if((!_||c.toString()!==_.toString())&&(_&&this._data.get(_).length===0&&this._data.delete(_),_=c,b.push(c),this._data.set(c,[])),u){const t=this._data.get(c);t&&t.push(...u)}else{const t=this._data.get(c);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(b),!!this._proxy){const h=[];for(let _ of b){let v=[];const c=this._data.get(_);if(c)if(c.length>this._maxDiagnosticsPerFile){v=[];const u=[S.DiagnosticSeverity.Error,S.DiagnosticSeverity.Warning,S.DiagnosticSeverity.Information,S.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of c)if(i.severity===u[t]&&v.push(D.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;v.push({severity:k.MarkerSeverity.Info,message:(0,E.localize)(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:v[v.length-1].startLineNumber,startColumn:v[v.length-1].startColumn,endLineNumber:v[v.length-1].endLineNumber,endColumn:v[v.length-1].endColumn})}else v=c.map(u=>D.Diagnostic.from(u));h.push([_,v])}this._proxy.$changeMany(this._owner,h)}}delete(r){this._checkDisposed(),this._onDidChangeDiagnostics.fire([r]),this._data.delete(r),this._proxy&&this._proxy.$changeMany(this._owner,[[r,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(r,s){this._checkDisposed();for(let b of this._data.keys())r.apply(s,[b,this.get(b),this])}get(r){this._checkDisposed();const s=this._data.get(r);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(r){return this._checkDisposed(),Array.isArray(this._data.get(r))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(r,s){return r[0].toString()<s[0].toString()?-1:r[0].toString()>s[0].toString()?1:0}}e.DiagnosticCollection=C;let g=class $t{constructor(r,s){this._logService=s,this._collections=new Map,this._onDidChangeDiagnostics=new y.Emitter,this.onDidChangeDiagnostics=y.Event.map(y.Event.debounce(this._onDidChangeDiagnostics.event,$t._debouncer,50),$t._mapper),this._proxy=r.getProxy(A.MainContext.MainThreadDiagnostics)}static _debouncer(r,s){return r?r.concat(s):s}static _mapper(r){const s=[],b=new Set;for(const h of r)typeof h=="string"?b.has(h)||(b.add(h),s.push(P.URI.parse(h))):b.has(h.toString())||(b.add(h.toString()),s.push(h));return Object.freeze(s),{uris:s}}createDiagnosticCollection(r,s){const{_collections:b,_proxy:h,_onDidChangeDiagnostics:_,_logService:v}=this,c=new class{$changeMany(i,d){h.$changeMany(i,d),v.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,i,d.length===0?"CLEARING":d)}$clear(i){h.$clear(i),v.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,i)}dispose(){h.dispose()}};let u;if(!s)s="_generated_diagnostic_collection_name_#"+$t._idPool++,u=s;else if(!b.has(s))u=s;else{this._logService.warn(`DiagnosticCollection with name '${s}' does already exist.`);do u=s+$t._idPool++;while(b.has(u))}return new class extends C{constructor(){super(s,u,$t._maxDiagnosticsPerFile,c,_);b.set(u,this)}dispose(){super.dispose(),b.delete(u)}}}getDiagnostics(r){if(r)return this._getDiagnostics(r);{const s=new Map,b=[];for(const h of this._collections.values())h.forEach((_,v)=>{let c=s.get(_.toString());typeof c=="undefined"&&(c=b.length,s.set(_.toString(),c),b.push([_,[]])),b[c][1]=b[c][1].concat(...v)});return b}}_getDiagnostics(r){let s=[];for(let b of this._collections.values())b.has(r)&&(s=s.concat(b.get(r)));return s}$acceptMarkersChange(r){if(!this._mirrorCollection){const s="_generated_mirror",b=new C(s,s,$t._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(s,b),this._mirrorCollection=b}for(const[s,b]of r)this._mirrorCollection.set(P.URI.revive(s),b.map(D.Diagnostic.to))}};g._idPool=0,g._maxDiagnosticsPerFile=1e3,g=je([Ke(1,n.ILogService)],g),e.ExtHostDiagnostics=g}),define(ve[192],_e([0,1,2,5]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class P{constructor(S){this._proxy=S.getProxy(k.MainContext.MainThreadDialogs)}showOpenDialog(S){return this._proxy.$showOpenDialog(S).then(D=>D?D.map(y=>E.URI.revive(y)):void 0)}showSaveDialog(S){return this._proxy.$showSaveDialog(S).then(D=>D?E.URI.revive(D):void 0)}}e.ExtHostDialogs=P}),define(ve[193],_e([0,1,10,2,7,5,18,20,8]),function(ie,e,E,k,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class n{constructor(C,g,f){this._documentsAndEditors=g,this._logService=f,this._documentContentProviders=new Map,this._proxy=C.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,g){if(Object.keys(S.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const f=n._handlePool++;this._documentContentProviders.set(f,g),this._proxy.$registerTextContentProvider(f,C);let r;return typeof g.onDidChange=="function"&&(r=g.onDidChange(s=>{if(s.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(s)&&this.$provideTextDocumentContent(f,s).then(b=>{if(!(!b&&typeof b!="string")){const h=this._documentsAndEditors.getDocument(s);if(!!h){const _=(0,y.splitLines)(b);if(!h.equalLines(_))return this._proxy.$onVirtualDocumentChange(s,b)}}},E.onUnexpectedError)})),new P.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),r&&(r.dispose(),r=void 0)})}$provideTextDocumentContent(C,g){const f=this._documentContentProviders.get(C);return f?Promise.resolve(f.provideTextDocumentContent(k.URI.revive(g),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${g.scheme}`))}}e.ExtHostDocumentContentProvider=n,n._handlePool=0}),define(ve[194],_e([0,1,3,6,2,5,94,9,13,24]),function(ie,e,E,k,P,A,S,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(g,f){this._onDidAddDocument=new E.Emitter,this._onDidRemoveDocument=new E.Emitter,this._onDidChangeDocument=new E.Emitter,this._onDidSaveDocument=new E.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new k.DisposableStore,this._documentLoader=new Map,this._proxy=g.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const s of r)this._onDidRemoveDocument.fire(s.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const s of r)this._onDidAddDocument.fire(s.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(g){if(!!g){const f=this._documentsAndEditors.getDocument(g);if(f)return f}}getDocument(g){const f=this.getDocumentData(g);if(!(f==null?void 0:f.document))throw new Error(`Unable to retrieve document from URI '${g}'`);return f.document}ensureDocumentData(g){const f=this._documentsAndEditors.getDocument(g);if(f)return Promise.resolve(f);let r=this._documentLoader.get(g.toString());return r||(r=this._proxy.$tryOpenDocument(g).then(s=>{this._documentLoader.delete(g.toString());const b=P.URI.revive(s);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(b))},s=>(this._documentLoader.delete(g.toString()),Promise.reject(s))),this._documentLoader.set(g.toString(),r)),r}createDocumentData(g){return this._proxy.$tryCreateDocument(g).then(f=>P.URI.revive(f))}$acceptModelModeChanged(g,f){const r=P.URI.revive(g),s=this._documentsAndEditors.getDocument(r);if(!s)throw new Error("unknown document");this._onDidRemoveDocument.fire(s.document),s._acceptLanguageId(f),this._onDidAddDocument.fire(s.document)}$acceptModelSaved(g){const f=P.URI.revive(g),r=this._documentsAndEditors.getDocument(f);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(g,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(g,f){const r=P.URI.revive(g),s=this._documentsAndEditors.getDocument(r);if(!s)throw new Error("unknown document");s._acceptIsDirty(f),this._onDidChangeDocument.fire({document:s.document,contentChanges:[]})}$acceptModelChanged(g,f,r){const s=P.URI.revive(g),b=this._documentsAndEditors.getDocument(s);if(!b)throw new Error("unknown document");b._acceptIsDirty(r),b.onEvents(f),this._onDidChangeDocument.fire((0,n.deepFreeze)({document:b.document,contentChanges:f.changes.map(h=>({range:D.Range.to(h.range),rangeOffset:h.rangeOffset,rangeLength:h.rangeLength,text:h.text}))}))}setWordDefinitionFor(g,f){(0,S.setWordDefinitionFor)(g,f)}}e.ExtHostDocuments=T}),define(ve[39],_e([0,1,42,3,6,2,4,5,94,15,96,9,19,22,18,54,106]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g,f,r,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class h{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(c,u){this._extHostRpc=c,this._logService=u,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new k.Emitter,this._onDidRemoveDocuments=new k.Emitter,this._onDidChangeVisibleTextEditors=new k.Emitter,this._onDidChangeActiveTextEditor=new k.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const u=[],t=[],i=[];if(c.removedDocuments)for(const d of c.removedDocuments){const a=A.URI.revive(d),l=this._documents.get(a);(l==null?void 0:l.unref())&&(this._documents.delete(a),u.push(l.value))}if(c.addedDocuments)for(const d of c.addedDocuments){const a=A.URI.revive(d.uri);let l=this._documents.get(a);if(l&&a.scheme!==r.Schemas.vscodeNotebookCell)throw new Error(`document '${a} already exists!'`);l||(l=new h(new y.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),a,d.lines,d.EOL,d.versionId,d.modeId,d.isDirty,d.notebook)),this._documents.set(a,l),t.push(l.value)),l.ref()}if(c.removedEditors)for(const d of c.removedEditors){const a=this._editors.get(d);this._editors.delete(d),a&&i.push(a)}if(c.addedEditors)for(const d of c.addedEditors){const a=A.URI.revive(d.documentUri);E.ok(this._documents.has(a),`document '${a}' does not exist`),E.ok(!this._editors.has(d.id),`editor '${d.id}' already exists!`);const l=this._documents.get(a).value,o=new T.ExtHostTextEditor(d.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new b.Lazy(()=>l.document),d.selections.map(C.Selection.to),d.options,d.visibleRanges.map(w=>C.Range.to(w)),typeof d.editorPosition=="number"?C.ViewColumn.to(d.editorPosition):void 0);this._editors.set(d.id,o)}c.newActiveEditor!==void 0&&(E.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,P.dispose)(u),(0,P.dispose)(i),c.removedDocuments&&this._onDidRemoveDocuments.fire(u),c.addedDocuments&&this._onDidAddDocuments.fire(t),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(d=>d.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){var u;return(u=this._documents.get(c))===null||u===void 0?void 0:u.value}allDocuments(){return s.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!!this._activeEditorId){const u=this._editors.get(this._activeEditorId);return c?u:u==null?void 0:u.value}}allEditors(){return[...this._editors.values()]}};_=je([Ke(0,n.IExtHostRpcService),Ke(1,g.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,S.createDecorator)("IExtHostDocumentsAndEditors")}),define(ve[195],_e([0,1,2,5,6,7,9,116,8,23]),function(ie,e,E,k,P,A,S,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const r=this._schemes.indexOf(f);r>=0&&(this._schemes.splice(r,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),r=[];let s,b,h=14,_=14;for(const v of f){let c=s?(0,y.commonPrefixLength)(s,v):0;for(c===0?b=1:b=_;c<v.length;c++)c+1===v.length?(h=_,_=9):_+=1,r.push([b,v.toUpperCase().charCodeAt(c),_]),r.push([b,v.toLowerCase().charCodeAt(c),_]),b=_;s=v,_=h}r.push([9,58,10]),r.push([10,47,12]),this._stateMachine=new D.StateMachine(r)}}provideDocumentLinks(f){this._initStateMachine();const r=[],s=D.LinkComputer.computeLinks({getLineContent(b){return f.lineAt(b-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const b of s){const h=S.DocumentLink.to(b);h.target&&r.push(h)}return r}}class C{constructor(f,r){this._extHostLanguageFeatures=r,this._linkProvider=new T,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(k.MainContext.MainThreadFileSystem)}dispose(){var f;(f=this._linkProviderRegistration)===null||f===void 0||f.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,r,s,b={}){if(this._registeredSchemes.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const h=this._handlePool++;this._linkProvider.add(r),this._registeredSchemes.add(r),this._fsProvider.set(h,s);let _=2;b.isCaseSensitive&&(_+=1024),b.isReadonly&&(_+=2048),typeof s.copy=="function"&&(_+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&(_+=4),this._proxy.$registerFileSystemProvider(h,r,_).catch(c=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${r}`),console.error(c)});const v=s.onDidChangeFile(c=>{const u=[];for(const t of c){let{uri:i,type:d}=t;if(i.scheme===r){let a;switch(d){case A.FileChangeType.Changed:a=0;break;case A.FileChangeType.Created:a=1;break;case A.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}u.push({resource:i,type:a})}}this._proxy.$onFileSystemChange(h,u)});return(0,P.toDisposable)(()=>{v.dispose(),this._linkProvider.delete(r),this._registeredSchemes.delete(r),this._fsProvider.delete(h),this._proxy.$unregisterProvider(h)})}static _asIStat(f){const{type:r,ctime:s,mtime:b,size:h}=f;return{type:r,ctime:s,mtime:b,size:h}}$stat(f,r){return Promise.resolve(this._getFsProvider(f).stat(E.URI.revive(r))).then(C._asIStat)}$readdir(f,r){return Promise.resolve(this._getFsProvider(f).readDirectory(E.URI.revive(r)))}$readFile(f,r){return Promise.resolve(this._getFsProvider(f).readFile(E.URI.revive(r))).then(s=>n.VSBuffer.wrap(s))}$writeFile(f,r,s,b){return Promise.resolve(this._getFsProvider(f).writeFile(E.URI.revive(r),s.buffer,b))}$delete(f,r,s){return Promise.resolve(this._getFsProvider(f).delete(E.URI.revive(r),s))}$rename(f,r,s,b){return Promise.resolve(this._getFsProvider(f).rename(E.URI.revive(r),E.URI.revive(s),b))}$copy(f,r,s,b){const h=this._getFsProvider(f);if(!h.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(h.copy(E.URI.revive(r),E.URI.revive(s),b))}$mkdir(f,r){return Promise.resolve(this._getFsProvider(f).createDirectory(E.URI.revive(r)))}$watch(f,r,s,b){const h=this._getFsProvider(f).watch(E.URI.revive(s),b);this._watches.set(r,h)}$unwatch(f,r){const s=this._watches.get(r);s&&(s.dispose(),this._watches.delete(r))}$open(f,r,s){const b=this._getFsProvider(f);if(!b.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(b.open(E.URI.revive(r),s))}$close(f,r){const s=this._getFsProvider(f);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(r))}$read(f,r,s,b){const h=this._getFsProvider(f);if(!h.read)throw new Error('FileSystemProvider does not implement "read"');const _=n.VSBuffer.alloc(b);return Promise.resolve(h.read(r,s,_.buffer,0,b)).then(v=>_.slice(0,v))}$write(f,r,s,b){const h=this._getFsProvider(f);if(!h.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(h.write(r,s,b.buffer,0,b.byteLength))}_getFsProvider(f){const r=this._fsProvider.get(f);if(!r){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return r}}e.ExtHostFileSystem=C}),define(ve[75],_e([0,1,5,64,7,23,4,15,48]),function(ie,e,E,k,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let n=class Lt{constructor(C,g){const f=C.getProxy(E.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(r){return f.$stat(r).catch(Lt._handleError)},readDirectory(r){return f.$readdir(r).catch(Lt._handleError)},createDirectory(r){return f.$mkdir(r).catch(Lt._handleError)},async readFile(r){return f.$readFile(r).then(s=>s.buffer).catch(Lt._handleError)},writeFile(r,s){return f.$writeFile(r,A.VSBuffer.wrap(s)).catch(Lt._handleError)},delete(r,s){return f.$delete(r,Object.assign({recursive:!1,useTrash:!1},s)).catch(Lt._handleError)},rename(r,s,b){return f.$rename(r,s,Object.assign({overwrite:!1},b)).catch(Lt._handleError)},copy(r,s,b){return f.$copy(r,s,Object.assign({overwrite:!1},b)).catch(Lt._handleError)},isWritableFileSystem(r){const s=g.getCapabilities(r);if(typeof s=="number")return!(s&2048)}})}static _handleError(C){if(!(C instanceof Error))throw new P.FileSystemError(String(C));if(C.name==="ENOPRO")throw P.FileSystemError.Unavailable(C.message);switch(C.name){case k.FileSystemProviderErrorCode.FileExists:throw P.FileSystemError.FileExists(C.message);case k.FileSystemProviderErrorCode.FileNotFound:throw P.FileSystemError.FileNotFound(C.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw P.FileSystemError.FileNotADirectory(C.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw P.FileSystemError.FileIsADirectory(C.message);case k.FileSystemProviderErrorCode.NoPermissions:throw P.FileSystemError.NoPermissions(C.message);case k.FileSystemProviderErrorCode.Unavailable:throw P.FileSystemError.Unavailable(C.message);default:throw new P.FileSystemError(C.message,C.name)}}};n=je([Ke(0,D.IExtHostRpcService),Ke(1,y.IExtHostFileSystemInfo)],n),e.ExtHostConsumerFileSystem=n,e.IExtHostConsumerFileSystem=(0,S.createDecorator)("IExtHostConsumerFileSystem")}),define(ve[196],_e([0,1,6,5]),function(ie,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class P{constructor(S){this._handlePool=0,this._proxy=S.getProxy(k.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(S){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,S),(0,E.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=P}),define(ve[197],_e([0,1,2,24,9,7,14,5,8,32,11,13,113,6,85,53,67,55,10]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g,f,r,s,b,h,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class v{constructor(U,K){this._documents=U,this._provider=K}provideDocumentSymbols(U,K){const te=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideDocumentSymbols(te,K)).then(le=>{if(!(0,T.isFalsyOrEmpty)(le))return le[0]instanceof A.DocumentSymbol?le.map(P.DocumentSymbol.from):v._asDocumentSymbolTree(le)})}static _asDocumentSymbolTree(U){var K;U=U.slice(0).sort((me,Se)=>{let Me=me.location.range.start.compareTo(Se.location.range.start);return Me===0&&(Me=Se.location.range.end.compareTo(me.location.range.end)),Me});const te=[],le=[];for(const me of U){const Se={name:me.name||"!!MISSING: name!!",kind:P.SymbolKind.from(me.kind),tags:((K=me.tags)===null||K===void 0?void 0:K.map(P.SymbolTag.from))||[],detail:"",containerName:me.containerName,range:P.Range.from(me.location.range),selectionRange:P.Range.from(me.location.range),children:[]};for(;;){if(le.length===0){le.push(Se),te.push(Se);break}const Me=le[le.length-1];if(n.Range.containsRange(Me.range,Se.range)&&!n.Range.equalsRange(Me.range,Se.range)){Me.children&&Me.children.push(Se),le.push(Se);break}le.pop()}}return te}}class c{constructor(U,K,te){this._documents=U,this._commands=K,this._provider=te,this._cache=new b.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(U,K){const te=this._documents.getDocument(U),le=await this._provider.provideCodeLenses(te,K);if(!(!le||K.isCancellationRequested)){const me=this._cache.add(le),Se=new f.DisposableStore;this._disposables.set(me,Se);const Me={cacheId:me,lenses:[]};for(let ge=0;ge<le.length;ge++)Me.lenses.push({cacheId:[me,ge],range:P.Range.from(le[ge].range),command:this._commands.toInternal(le[ge].command,Se)});return Me}}async resolveCodeLens(U,K){var te;const le=U.cacheId&&this._cache.get(...U.cacheId);if(!!le){let me;if(typeof this._provider.resolveCodeLens!="function"||le.isResolved?me=le:me=await this._provider.resolveCodeLens(le,K),me||(me=le),!K.isCancellationRequested){const Se=U.cacheId&&this._disposables.get(U.cacheId[0]);if(!!Se)return U.command=this._commands.toInternal((te=me.command)!==null&&te!==void 0?te:c._badCmd,Se),U}}}releaseCodeLenses(U){var K;(K=this._disposables.get(U))===null||K===void 0||K.dispose(),this._disposables.delete(U),this._cache.delete(U)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function u(ze){return Array.isArray(ze)?ze.map(P.DefinitionLink.from):ze?[P.DefinitionLink.from(ze)]:[]}class t{constructor(U,K){this._documents=U,this._provider=K}provideDefinition(U,K,te){const le=this._documents.getDocument(U),me=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideDefinition(le,me,te)).then(u)}}class i{constructor(U,K){this._documents=U,this._provider=K}provideDeclaration(U,K,te){const le=this._documents.getDocument(U),me=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideDeclaration(le,me,te)).then(u)}}class d{constructor(U,K){this._documents=U,this._provider=K}provideImplementation(U,K,te){const le=this._documents.getDocument(U),me=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideImplementation(le,me,te)).then(u)}}class a{constructor(U,K){this._documents=U,this._provider=K}provideTypeDefinition(U,K,te){const le=this._documents.getDocument(U),me=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideTypeDefinition(le,me,te)).then(u)}}class l{constructor(U,K){this._documents=U,this._provider=K}provideHover(U,K,te){const le=this._documents.getDocument(U),me=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideHover(le,me,te)).then(Se=>{if(!(!Se||(0,T.isFalsyOrEmpty)(Se.contents)))return Se.range||(Se.range=le.getWordRangeAtPosition(me)),Se.range||(Se.range=new A.Range(me,me)),P.Hover.from(Se)})}}class o{constructor(U,K){this._documents=U,this._provider=K}provideEvaluatableExpression(U,K,te){const le=this._documents.getDocument(U),me=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideEvaluatableExpression(le,me,te)).then(Se=>{if(Se)return P.EvaluatableExpression.from(Se)})}}class w{constructor(U,K){this._documents=U,this._provider=K}provideInlineValues(U,K,te,le){const me=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideInlineValues(me,P.Range.to(K),P.InlineValueContext.to(te),le)).then(Se=>{if(Array.isArray(Se))return Se.map(Me=>P.InlineValue.from(Me))})}}class I{constructor(U,K){this._documents=U,this._provider=K}provideDocumentHighlights(U,K,te){const le=this._documents.getDocument(U),me=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideDocumentHighlights(le,me,te)).then(Se=>{if(Array.isArray(Se))return Se.map(P.DocumentHighlight.from)})}}class p{constructor(U,K){this._documents=U,this._provider=K}provideLinkedEditingRanges(U,K,te){const le=this._documents.getDocument(U),me=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideLinkedEditingRanges(le,me,te)).then(Se=>{if(Se&&Array.isArray(Se.ranges))return{ranges:(0,T.coalesce)(Se.ranges.map(P.Range.from)),wordPattern:Se.wordPattern}})}}class m{constructor(U,K){this._documents=U,this._provider=K}provideReferences(U,K,te,le){const me=this._documents.getDocument(U),Se=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideReferences(me,Se,te,le)).then(Me=>{if(Array.isArray(Me))return Me.map(P.location.from)})}}class R{constructor(U,K,te,le,me,Se,Me){this._documents=U,this._commands=K,this._diagnostics=te,this._provider=le,this._logService=me,this._extension=Se,this._apiDeprecation=Me,this._cache=new b.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(U,K,te,le){const me=this._documents.getDocument(U),Se=g.Selection.isISelection(K)?P.Selection.to(K):P.Range.to(K),Me=[];for(const Ce of this._diagnostics.getDiagnostics(U))if(Se.intersection(Ce.range)&&Me.push(Ce)>R._maxCodeActionsPerFile)break;const ge={diagnostics:Me,only:te.only?new A.CodeActionKind(te.only):void 0,triggerKind:P.CodeActionTriggerKind.to(te.trigger)};return(0,S.asPromise)(()=>this._provider.provideCodeActions(me,Se,ge,le)).then(Ce=>{var Ae;if(!(!(0,T.isNonEmptyArray)(Ce)||le.isCancellationRequested)){const Be=this._cache.add(Ce),be=new f.DisposableStore;this._disposables.set(Be,be);const qe=[];for(let j=0;j<Ce.length;j++){const X=Ce[j];!X||(R._isCommand(X)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:X.title,command:this._commands.toInternal(X,be)})):(ge.only&&(X.kind?ge.only.contains(X.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action is of kind '${X.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[Be,j],title:X.title,command:X.command&&this._commands.toInternal(X.command,be),diagnostics:X.diagnostics&&X.diagnostics.map(P.Diagnostic.from),edit:X.edit&&P.WorkspaceEdit.from(X.edit),kind:X.kind&&X.kind.value,isPreferred:X.isPreferred,disabled:(Ae=X.disabled)===null||Ae===void 0?void 0:Ae.reason})))}return{cacheId:Be,actions:qe}}})}async resolveCodeAction(U,K){var te;const[le,me]=U,Se=this._cache.get(le,me);if(!(!Se||R._isCommand(Se))&&!!this._provider.resolveCodeAction){const Me=(te=await this._provider.resolveCodeAction(Se,K))!==null&&te!==void 0?te:Se;return(Me==null?void 0:Me.edit)?P.WorkspaceEdit.from(Me.edit):void 0}}releaseCodeActions(U){var K;(K=this._disposables.get(U))===null||K===void 0||K.dispose(),this._disposables.delete(U),this._cache.delete(U)}static _isCommand(U){return typeof U.command=="string"&&typeof U.title=="string"}}R._maxCodeActionsPerFile=1e3;class F{constructor(U,K){this._documents=U,this._provider=K}provideDocumentFormattingEdits(U,K,te){const le=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideDocumentFormattingEdits(le,K,te)).then(me=>{if(Array.isArray(me))return me.map(P.TextEdit.from)})}}class x{constructor(U,K){this._documents=U,this._provider=K}provideDocumentRangeFormattingEdits(U,K,te,le){const me=this._documents.getDocument(U),Se=P.Range.to(K);return(0,S.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(me,Se,te,le)).then(Me=>{if(Array.isArray(Me))return Me.map(P.TextEdit.from)})}}class ae{constructor(U,K){this._documents=U,this._provider=K,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(U,K,te,le,me){const Se=this._documents.getDocument(U),Me=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Se,Me,te,le,me)).then(ge=>{if(Array.isArray(ge))return ge.map(P.TextEdit.from)})}}class z{constructor(U,K){this._provider=U,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(U,K){const te=D.IdObject.mixin({symbols:[]});return(0,S.asPromise)(()=>this._provider.provideWorkspaceSymbols(U,K)).then(le=>{if((0,T.isNonEmptyArray)(le)){for(const me of le)if(!!me){if(!me.name){this._logService.warn("INVALID SymbolInformation, lacks name",me);continue}const Se=D.IdObject.mixin(P.WorkspaceSymbol.from(me));this._symbolCache.set(Se._id,me),te.symbols.push(Se)}}}).then(()=>(te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te))}async resolveWorkspaceSymbol(U,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return U;const te=this._symbolCache.get(U._id);if(te){const le=await(0,S.asPromise)(()=>this._provider.resolveWorkspaceSymbol(te,K));return le&&(0,k.mixin)(U,P.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(U){const K=this._resultCache.get(U);if(K){for(let[te,le]=K;te<=le;te++)this._symbolCache.delete(te);this._resultCache.delete(U)}}}class B{constructor(U,K,te){this._documents=U,this._provider=K,this._logService=te}static supportsResolving(U){return typeof U.prepareRename=="function"}provideRenameEdits(U,K,te,le){const me=this._documents.getDocument(U),Se=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideRenameEdits(me,Se,te,le)).then(Me=>{if(!!Me)return P.WorkspaceEdit.from(Me)},Me=>{const ge=B._asMessage(Me);return ge?{rejectReason:ge,edits:void 0}:Promise.reject(Me)})}resolveRenameLocation(U,K,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(U),me=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.prepareRename(le,me,te)).then(Se=>{let Me,ge;if(A.Range.isRange(Se)?(Me=Se,ge=le.getText(Se)):(0,C.isObject)(Se)&&(Me=Se.range,ge=Se.placeholder),!!Me){if(Me.start.line>me.line||Me.end.line<me.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:P.Range.from(Me),text:ge}}},Se=>{const Me=B._asMessage(Se);return Me?{rejectReason:Me,range:void 0,text:void 0}:Promise.reject(Se)})}static _asMessage(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class G{constructor(U,K){this.resultId=U,this.tokens=K}}class M{constructor(U,K){this._documents=U,this._provider=K,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(U,K,te){const le=this._documents.getDocument(U),me=K!==0?this._previousResults.get(K):null;return(0,S.asPromise)(()=>me&&typeof me.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(le,me.resultId,te):this._provider.provideDocumentSemanticTokens(le,te)).then(Se=>(me&&this._previousResults.delete(K),Se?(Se=M._fixProvidedSemanticTokens(Se),this._send(M._convertToEdits(me,Se),Se)):null))}async releaseDocumentSemanticColoring(U){this._previousResults.delete(U)}static _fixProvidedSemanticTokens(U){return M._isSemanticTokens(U)?M._isCorrectSemanticTokens(U)?U:new A.SemanticTokens(new Uint32Array(U.data),U.resultId):M._isSemanticTokensEdits(U)?M._isCorrectSemanticTokensEdits(U)?U:new A.SemanticTokensEdits(U.edits.map(K=>new A.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),U.resultId):U}static _isSemanticTokens(U){return U&&!!U.data}static _isCorrectSemanticTokens(U){return U.data instanceof Uint32Array}static _isSemanticTokensEdits(U){return U&&Array.isArray(U.edits)}static _isCorrectSemanticTokensEdits(U){for(const K of U.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(U,K){if(!M._isSemanticTokens(K)||!U||!U.tokens)return K;const te=U.tokens,le=te.length,me=K.data,Se=me.length;let Me=0;const ge=Math.min(le,Se);for(;Me<ge&&te[Me]===me[Me];)Me++;if(Me===le&&Me===Se)return new A.SemanticTokensEdits([],K.resultId);let Ce=0;const Ae=ge-Me;for(;Ce<Ae&&te[le-Ce-1]===me[Se-Ce-1];)Ce++;return new A.SemanticTokensEdits([{start:Me,deleteCount:le-Me-Ce,data:me.subarray(Me,Se-Ce)}],K.resultId)}_send(U,K){if(M._isSemanticTokens(U)){const te=this._nextResultId++;return this._previousResults.set(te,new G(U.resultId,U.data)),(0,r.encodeSemanticTokensDto)({id:te,type:"full",data:U.data})}if(M._isSemanticTokensEdits(U)){const te=this._nextResultId++;return M._isSemanticTokens(K)?this._previousResults.set(te,new G(K.resultId,K.data)):this._previousResults.set(te,new G(U.resultId)),(0,r.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(U.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=M;class N{constructor(U,K){this._documents=U,this._provider=K}provideDocumentRangeSemanticTokens(U,K,te){const le=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(le,P.Range.to(K),te)).then(me=>me?this._send(me):null)}_send(U){return(0,r.encodeSemanticTokensDto)({id:0,type:"full",data:U.data})}}e.DocumentRangeSemanticTokensAdapter=N;class W{constructor(U,K,te,le,me){this._documents=U,this._commands=K,this._provider=te,this._apiDeprecation=le,this._extension=me,this._cache=new b.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}async provideCompletionItems(U,K,te,le){const me=this._documents.getDocument(U),Se=P.Position.to(K),Me=me.getWordRangeAtPosition(Se)||new A.Range(Se,Se),ge=Me.with({end:Se}),Ce=new h.StopWatch(!0),Ae=await(0,S.asPromise)(()=>this._provider.provideCompletionItems(me,Se,le,P.CompletionContext.to(te)));if(!!Ae&&!le.isCancellationRequested){const Be=Array.isArray(Ae)?new A.CompletionList(Ae):Ae,be=W.supportsResolving(this._provider)?this._cache.add(Be.items):this._cache.add([]),qe=new f.DisposableStore;this._disposables.set(be,qe);const j=[],X={x:be,b:j,a:{replace:P.Range.from(Me),insert:P.Range.from(ge)},c:Be.isIncomplete||void 0,d:Ce.elapsed()};for(let pe=0;pe<Be.items.length;pe++){const Le=Be.items[pe],He=this._convertCompletionItem(Le,[be,pe],ge,Me);j.push(He)}return X}}async resolveCompletionItem(U,K){if(typeof this._provider.resolveCompletionItem=="function"){const te=this._cache.get(...U);if(!!te){const le=await(0,S.asPromise)(()=>this._provider.resolveCompletionItem(te,K));if(!!le)return this._convertCompletionItem(le,U)}}}releaseCompletionItems(U){var K;(K=this._disposables.get(U))===null||K===void 0||K.dispose(),this._disposables.delete(U),this._cache.delete(U)}_convertCompletionItem(U,K,te,le){var me;const Se=this._disposables.get(K[0]);if(!Se)throw Error("DisposableStore is missing...");const Me={x:K,a:(me=U.label)!==null&&me!==void 0?me:"",o:U.label2,b:U.kind!==void 0?P.CompletionItemKind.from(U.kind):void 0,n:U.tags&&U.tags.map(P.CompletionItemTag.from),c:U.detail,d:typeof U.documentation=="undefined"?void 0:P.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters,l:U.additionalTextEdits&&U.additionalTextEdits.map(P.TextEdit.from),m:this._commands.toInternal(U.command,Se)};U.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Me.h=U.textEdit.newText):typeof U.insertText=="string"?Me.h=U.insertText:U.insertText instanceof A.SnippetString&&(Me.h=U.insertText.value,Me.i|=4);let ge;return U.textEdit?ge=U.textEdit.range:U.range&&(ge=U.range),A.Range.isRange(ge)?Me.j=P.Range.from(ge):ge&&(!(te==null?void 0:te.isEqual(ge.inserting))||!(le==null?void 0:le.isEqual(ge.replacing)))&&(Me.j={insert:P.Range.from(ge.inserting),replace:P.Range.from(ge.replacing)}),Me}}class Q{constructor(U,K){this._documents=U,this._provider=K,this._cache=new b.Cache("SignatureHelp")}provideSignatureHelp(U,K,te,le){const me=this._documents.getDocument(U),Se=P.Position.to(K),Me=this.reviveContext(te);return(0,S.asPromise)(()=>this._provider.provideSignatureHelp(me,Se,le,Me)).then(ge=>{if(ge){const Ce=this._cache.add([ge]);return Object.assign(Object.assign({},P.SignatureHelp.from(ge)),{id:Ce})}})}reviveContext(U){let K;if(U.activeSignatureHelp){const te=P.SignatureHelp.to(U.activeSignatureHelp),le=this._cache.get(U.activeSignatureHelp.id,0);le?(K=le,K.activeSignature=te.activeSignature,K.activeParameter=te.activeParameter):K=te}return Object.assign(Object.assign({},U),{activeSignatureHelp:K})}releaseSignatureHelp(U){this._cache.delete(U)}}class ${constructor(U,K){this._documents=U,this._provider=K}provideInlineHints(U,K,te){const le=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideInlineHints(le,P.Range.to(K),te)).then(me=>me?{hints:me.map(P.InlineHint.from)}:void 0)}}class Z{constructor(U,K){this._documents=U,this._provider=K,this._cache=new b.Cache("DocumentLink")}provideLinks(U,K){const te=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideDocumentLinks(te,K)).then(le=>{if(!(!Array.isArray(le)||le.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.map(P.DocumentLink.from)};{const me=this._cache.add(le),Se={links:[],id:me};for(let Me=0;Me<le.length;Me++){const ge=P.DocumentLink.from(le[Me]);ge.cacheId=[me,Me],Se.links.push(ge)}return Se}}})}resolveLink(U,K){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const te=this._cache.get(...U);return te?(0,S.asPromise)(()=>this._provider.resolveDocumentLink(te,K)).then(le=>le&&P.DocumentLink.from(le)||void 0):Promise.resolve(void 0)}releaseLinks(U){this._cache.delete(U)}}class re{constructor(U,K){this._documents=U,this._provider=K}provideColors(U,K){const te=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideDocumentColors(te,K)).then(le=>Array.isArray(le)?le.map(Se=>({color:P.Color.from(Se.color),range:P.Range.from(Se.range)})):[])}provideColorPresentations(U,K,te){const le=this._documents.getDocument(U),me=P.Range.to(K.range),Se=P.Color.to(K.color);return(0,S.asPromise)(()=>this._provider.provideColorPresentations(Se,{document:le,range:me},te)).then(Me=>{if(!!Array.isArray(Me))return Me.map(P.ColorPresentation.from)})}}class se{constructor(U,K){this._documents=U,this._provider=K}provideFoldingRanges(U,K,te){const le=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideFoldingRanges(le,K,te)).then(me=>{if(!!Array.isArray(me))return me.map(P.FoldingRange.from)})}}class ye{constructor(U,K,te){this._documents=U,this._provider=K,this._logService=te}provideSelectionRanges(U,K,te){const le=this._documents.getDocument(U),me=K.map(P.Position.to);return(0,S.asPromise)(()=>this._provider.provideSelectionRanges(le,me,te)).then(Se=>{if(!(0,T.isNonEmptyArray)(Se))return[];if(Se.length!==me.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Me=[];for(let ge=0;ge<me.length;ge++){const Ce=[];Me.push(Ce);let Ae=me[ge],Be=Se[ge];for(;;){if(!Be.range.contains(Ae))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(P.SelectionRange.from(Be)),!Be.parent)break;Ae=Be.range,Be=Be.parent}}return Me})}}class Pe{constructor(U,K){this._documents=U,this._provider=K,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(U,K,te){const le=this._documents.getDocument(U),me=P.Position.to(K),Se=await this._provider.prepareCallHierarchy(le,me,te);if(!!Se){const Me=this._idPool.nextId();return this._cache.set(Me,new Map),Array.isArray(Se)?Se.map(ge=>this._cacheAndConvertItem(Me,ge)):[this._cacheAndConvertItem(Me,Se)]}}async provideCallsTo(U,K,te){const le=this._itemFromCache(U,K);if(!le)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyIncomingCalls(le,te);if(!!me)return me.map(Se=>({from:this._cacheAndConvertItem(U,Se.from),fromRanges:Se.fromRanges.map(Me=>P.Range.from(Me))}))}async provideCallsFrom(U,K,te){const le=this._itemFromCache(U,K);if(!le)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyOutgoingCalls(le,te);if(!!me)return me.map(Se=>({to:this._cacheAndConvertItem(U,Se.to),fromRanges:Se.fromRanges.map(Me=>P.Range.from(Me))}))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,K){var te;const le=this._cache.get(U),me={_sessionId:U,_itemId:le.size.toString(36),name:K.name,detail:K.detail,kind:P.SymbolKind.from(K.kind),uri:K.uri,range:P.Range.from(K.range),selectionRange:P.Range.from(K.selectionRange),tags:(te=K.tags)===null||te===void 0?void 0:te.map(P.SymbolTag.from)};return le.set(me._itemId,K),me}_itemFromCache(U,K){const te=this._cache.get(U);return te==null?void 0:te.get(K)}}class $e{constructor(U,K){this.adapter=U,this.extension=K}}class Re{constructor(U,K,te,le,me,Se,Me){this._adapter=new Map,this._uriTransformer=K,this._proxy=U.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=le,this._diagnostics=me,this._logService=Se,this._apiDeprecation=Me}_transformDocumentSelector(U){return(0,T.coalesce)((0,T.asArray)(U).map(K=>this._doTransformDocumentSelector(K)))}_doTransformDocumentSelector(U){if(typeof U=="string")return{$serialized:!0,language:U};if(U)return{$serialized:!0,language:U.language,scheme:this._transformScheme(U.scheme),pattern:typeof U.pattern=="undefined"?void 0:P.GlobPattern.from(U.pattern),exclusive:U.exclusive}}_transformScheme(U){return this._uriTransformer&&typeof U=="string"?this._uriTransformer.transformOutgoingScheme(U):U}_createDisposable(U){return new A.Disposable(()=>{this._adapter.delete(U),this._proxy.$unregister(U)})}_nextHandle(){return Re._handlePool++}_withAdapter(U,K,te,le,me=!1){const Se=this._adapter.get(U);if(!Se)return Promise.resolve(le);if(Se.adapter instanceof K){let Me;Se.extension&&(Me=Date.now(),this._logService.trace(`[${Se.extension.identifier.value}] INVOKE provider '${K.name}'`));const ge=te(Se.adapter,Se.extension),Ce=Se.extension;return Ce&&Promise.resolve(ge).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Me}ms`),Ae=>{me&&Ae instanceof _.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Ae))}),ge}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(U,K){const te=this._nextHandle();return this._adapter.set(te,new $e(U,K)),te}static _extLabel(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,K,te,le){const me=this._addNewAdapter(new v(this._documents,te),U),Se=le&&le.label||Re._extLabel(U);return this._proxy.$registerDocumentSymbolProvider(me,this._transformDocumentSelector(K),Se),this._createDisposable(me)}$provideDocumentSymbols(U,K,te){return this._withAdapter(U,v,le=>le.provideDocumentSymbols(E.URI.revive(K),te),void 0)}registerCodeLensProvider(U,K,te){const le=this._nextHandle(),me=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new $e(new c(this._documents,this._commands.converter,te),U)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(K),me);let Se=this._createDisposable(le);if(me!==void 0){const Me=te.onDidChangeCodeLenses(ge=>this._proxy.$emitCodeLensEvent(me));Se=A.Disposable.from(Se,Me)}return Se}$provideCodeLenses(U,K,te){return this._withAdapter(U,c,le=>le.provideCodeLenses(E.URI.revive(K),te),void 0)}$resolveCodeLens(U,K,te){return this._withAdapter(U,c,le=>le.resolveCodeLens(K,te),void 0)}$releaseCodeLenses(U,K){this._withAdapter(U,c,te=>Promise.resolve(te.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(U,K,te){const le=this._addNewAdapter(new t(this._documents,te),U);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideDefinition(U,K,te,le){return this._withAdapter(U,t,me=>me.provideDefinition(E.URI.revive(K),te,le),[])}registerDeclarationProvider(U,K,te){const le=this._addNewAdapter(new i(this._documents,te),U);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideDeclaration(U,K,te,le){return this._withAdapter(U,i,me=>me.provideDeclaration(E.URI.revive(K),te,le),[])}registerImplementationProvider(U,K,te){const le=this._addNewAdapter(new d(this._documents,te),U);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideImplementation(U,K,te,le){return this._withAdapter(U,d,me=>me.provideImplementation(E.URI.revive(K),te,le),[])}registerTypeDefinitionProvider(U,K,te){const le=this._addNewAdapter(new a(this._documents,te),U);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideTypeDefinition(U,K,te,le){return this._withAdapter(U,a,me=>me.provideTypeDefinition(E.URI.revive(K),te,le),[])}registerHoverProvider(U,K,te,le){const me=this._addNewAdapter(new l(this._documents,te),U);return this._proxy.$registerHoverProvider(me,this._transformDocumentSelector(K)),this._createDisposable(me)}$provideHover(U,K,te,le){return this._withAdapter(U,l,me=>me.provideHover(E.URI.revive(K),te,le),void 0)}registerEvaluatableExpressionProvider(U,K,te,le){const me=this._addNewAdapter(new o(this._documents,te),U);return this._proxy.$registerEvaluatableExpressionProvider(me,this._transformDocumentSelector(K)),this._createDisposable(me)}$provideEvaluatableExpression(U,K,te,le){return this._withAdapter(U,o,me=>me.provideEvaluatableExpression(E.URI.revive(K),te,le),void 0)}registerInlineValuesProvider(U,K,te,le){const me=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Se=this._addNewAdapter(new w(this._documents,te),U);this._proxy.$registerInlineValuesProvider(Se,this._transformDocumentSelector(K),me);let Me=this._createDisposable(Se);if(me!==void 0){const ge=te.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(me));Me=A.Disposable.from(Me,ge)}return Me}$provideInlineValues(U,K,te,le,me){return this._withAdapter(U,w,Se=>Se.provideInlineValues(E.URI.revive(K),te,le,me),void 0)}registerDocumentHighlightProvider(U,K,te){const le=this._addNewAdapter(new I(this._documents,te),U);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideDocumentHighlights(U,K,te,le){return this._withAdapter(U,I,me=>me.provideDocumentHighlights(E.URI.revive(K),te,le),void 0)}registerLinkedEditingRangeProvider(U,K,te){const le=this._addNewAdapter(new p(this._documents,te),U);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideLinkedEditingRanges(U,K,te,le){return this._withAdapter(U,p,async me=>{const Se=await me.provideLinkedEditingRanges(E.URI.revive(K),te,le);if(Se)return{ranges:Se.ranges,wordPattern:Se.wordPattern?Re._serializeRegExp(Se.wordPattern):void 0}},void 0)}registerReferenceProvider(U,K,te){const le=this._addNewAdapter(new m(this._documents,te),U);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideReferences(U,K,te,le,me){return this._withAdapter(U,m,Se=>Se.provideReferences(E.URI.revive(K),te,le,me),void 0)}registerCodeActionProvider(U,K,te,le){var me,Se;const Me=new f.DisposableStore,ge=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,te,this._logService,U,this._apiDeprecation),U);return this._proxy.$registerQuickFixSupport(ge,this._transformDocumentSelector(K),{providedKinds:(me=le==null?void 0:le.providedCodeActionKinds)===null||me===void 0?void 0:me.map(Ce=>Ce.value),documentation:(Se=le==null?void 0:le.documentation)===null||Se===void 0?void 0:Se.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Me)}))},Re._extLabel(U),Boolean(te.resolveCodeAction)),Me.add(this._createDisposable(ge)),Me}$provideCodeActions(U,K,te,le,me){return this._withAdapter(U,R,Se=>Se.provideCodeActions(E.URI.revive(K),te,le,me),void 0)}$resolveCodeAction(U,K,te){return this._withAdapter(U,R,le=>le.resolveCodeAction(K,te),void 0)}$releaseCodeActions(U,K){this._withAdapter(U,R,te=>Promise.resolve(te.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(U,K,te){const le=this._addNewAdapter(new F(this._documents,te),U);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(K),U.identifier,U.displayName||U.name),this._createDisposable(le)}$provideDocumentFormattingEdits(U,K,te,le){return this._withAdapter(U,F,me=>me.provideDocumentFormattingEdits(E.URI.revive(K),te,le),void 0)}registerDocumentRangeFormattingEditProvider(U,K,te){const le=this._addNewAdapter(new x(this._documents,te),U);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(K),U.identifier,U.displayName||U.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(U,K,te,le,me){return this._withAdapter(U,x,Se=>Se.provideDocumentRangeFormattingEdits(E.URI.revive(K),te,le,me),void 0)}registerOnTypeFormattingEditProvider(U,K,te,le){const me=this._addNewAdapter(new ae(this._documents,te),U);return this._proxy.$registerOnTypeFormattingSupport(me,this._transformDocumentSelector(K),le,U.identifier),this._createDisposable(me)}$provideOnTypeFormattingEdits(U,K,te,le,me,Se){return this._withAdapter(U,ae,Me=>Me.provideOnTypeFormattingEdits(E.URI.revive(K),te,le,me,Se),void 0)}registerWorkspaceSymbolProvider(U,K){const te=this._addNewAdapter(new z(K,this._logService),U);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(U,K,te){return this._withAdapter(U,z,le=>le.provideWorkspaceSymbols(K,te),{symbols:[]})}$resolveWorkspaceSymbol(U,K,te){return this._withAdapter(U,z,le=>le.resolveWorkspaceSymbol(K,te),void 0)}$releaseWorkspaceSymbols(U,K){this._withAdapter(U,z,te=>te.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(U,K,te){const le=this._addNewAdapter(new B(this._documents,te,this._logService),U);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(K),B.supportsResolving(te)),this._createDisposable(le)}$provideRenameEdits(U,K,te,le,me){return this._withAdapter(U,B,Se=>Se.provideRenameEdits(E.URI.revive(K),te,le,me),void 0)}$resolveRenameLocation(U,K,te,le){return this._withAdapter(U,B,me=>me.resolveRenameLocation(E.URI.revive(K),te,le),void 0)}registerDocumentSemanticTokensProvider(U,K,te,le){const me=this._nextHandle(),Se=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(me,new $e(new M(this._documents,te),U)),this._proxy.$registerDocumentSemanticTokensProvider(me,this._transformDocumentSelector(K),le,Se);let Me=this._createDisposable(me);if(Se){const ge=te.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(Se));Me=A.Disposable.from(Me,ge)}return Me}$provideDocumentSemanticTokens(U,K,te,le){return this._withAdapter(U,M,me=>me.provideDocumentSemanticTokens(E.URI.revive(K),te,le),null,!0)}$releaseDocumentSemanticTokens(U,K){this._withAdapter(U,M,te=>te.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(U,K,te,le){const me=this._addNewAdapter(new N(this._documents,te),U);return this._proxy.$registerDocumentRangeSemanticTokensProvider(me,this._transformDocumentSelector(K),le),this._createDisposable(me)}$provideDocumentRangeSemanticTokens(U,K,te,le){return this._withAdapter(U,N,me=>me.provideDocumentRangeSemanticTokens(E.URI.revive(K),te,le),null,!0)}registerCompletionItemProvider(U,K,te,le){const me=this._addNewAdapter(new W(this._documents,this._commands.converter,te,this._apiDeprecation,U),U);return this._proxy.$registerSuggestSupport(me,this._transformDocumentSelector(K),le,W.supportsResolving(te),`${U.identifier.value}(${le.join("")})`),this._createDisposable(me)}$provideCompletionItems(U,K,te,le,me){return this._withAdapter(U,W,Se=>Se.provideCompletionItems(E.URI.revive(K),te,le,me),void 0)}$resolveCompletionItem(U,K,te){return this._withAdapter(U,W,le=>le.resolveCompletionItem(K,te),void 0)}$releaseCompletionItems(U,K){this._withAdapter(U,W,te=>te.releaseCompletionItems(K),void 0)}registerSignatureHelpProvider(U,K,te,le){const me=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,Se=this._addNewAdapter(new Q(this._documents,te),U);return this._proxy.$registerSignatureHelpProvider(Se,this._transformDocumentSelector(K),me),this._createDisposable(Se)}$provideSignatureHelp(U,K,te,le,me){return this._withAdapter(U,Q,Se=>Se.provideSignatureHelp(E.URI.revive(K),te,le,me),void 0)}$releaseSignatureHelp(U,K){this._withAdapter(U,Q,te=>te.releaseSignatureHelp(K),void 0)}registerInlineHintsProvider(U,K,te){const le=typeof te.onDidChangeInlineHints=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new $(this._documents,te),U);this._proxy.$registerInlineHintsProvider(me,this._transformDocumentSelector(K),le);let Se=this._createDisposable(me);if(le!==void 0){const Me=te.onDidChangeInlineHints(ge=>this._proxy.$emitInlineHintsEvent(le));Se=A.Disposable.from(Se,Me)}return Se}$provideInlineHints(U,K,te,le){return this._withAdapter(U,$,me=>me.provideInlineHints(E.URI.revive(K),te,le),void 0)}registerDocumentLinkProvider(U,K,te){const le=this._addNewAdapter(new Z(this._documents,te),U);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(K),typeof te.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(U,K,te){return this._withAdapter(U,Z,le=>le.provideLinks(E.URI.revive(K),te),void 0)}$resolveDocumentLink(U,K,te){return this._withAdapter(U,Z,le=>le.resolveLink(K,te),void 0)}$releaseDocumentLinks(U,K){this._withAdapter(U,Z,te=>te.releaseLinks(K),void 0)}registerColorProvider(U,K,te){const le=this._addNewAdapter(new re(this._documents,te),U);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideDocumentColors(U,K,te){return this._withAdapter(U,re,le=>le.provideColors(E.URI.revive(K),te),[])}$provideColorPresentations(U,K,te,le){return this._withAdapter(U,re,me=>me.provideColorPresentations(E.URI.revive(K),te,le),void 0)}registerFoldingRangeProvider(U,K,te){const le=this._nextHandle(),me=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new $e(new se(this._documents,te),U)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(K),me);let Se=this._createDisposable(le);if(me!==void 0){const Me=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(me));Se=A.Disposable.from(Se,Me)}return Se}$provideFoldingRanges(U,K,te,le){return this._withAdapter(U,se,me=>me.provideFoldingRanges(E.URI.revive(K),te,le),void 0)}registerSelectionRangeProvider(U,K,te){const le=this._addNewAdapter(new ye(this._documents,te,this._logService),U);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideSelectionRanges(U,K,te,le){return this._withAdapter(U,ye,me=>me.provideSelectionRanges(E.URI.revive(K),te,le),[])}registerCallHierarchyProvider(U,K,te){const le=this._addNewAdapter(new Pe(this._documents,te),U);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$prepareCallHierarchy(U,K,te,le){return this._withAdapter(U,Pe,me=>Promise.resolve(me.prepareSession(E.URI.revive(K),te,le)),void 0)}$provideCallHierarchyIncomingCalls(U,K,te,le){return this._withAdapter(U,Pe,me=>me.provideCallsTo(K,te,le),void 0)}$provideCallHierarchyOutgoingCalls(U,K,te,le){return this._withAdapter(U,Pe,me=>me.provideCallsFrom(K,te,le),void 0)}$releaseCallHierarchy(U,K){this._withAdapter(U,Pe,te=>Promise.resolve(te.releaseSession(K)),void 0)}static _serializeRegExp(U){return{pattern:U.source,flags:(0,y.regExpFlags)(U)}}static _serializeIndentationRule(U){return{decreaseIndentPattern:Re._serializeRegExp(U.decreaseIndentPattern),increaseIndentPattern:Re._serializeRegExp(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Re._serializeRegExp(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Re._serializeRegExp(U.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(U){return{beforeText:Re._serializeRegExp(U.beforeText),afterText:U.afterText?Re._serializeRegExp(U.afterText):void 0,previousLineText:U.previousLineText?Re._serializeRegExp(U.previousLineText):void 0,action:U.action}}static _serializeOnEnterRules(U){return U.map(Re._serializeOnEnterRule)}setLanguageConfiguration(U,K,te){let{wordPattern:le}=te;if(le&&(0,y.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(K,le):this._documents.setWordDefinitionFor(K,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const me=this._nextHandle(),Se={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?Re._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?Re._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?Re._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(me,K,Se),this._createDisposable(me)}$setWordDefinitions(U){for(const K of U)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=Re,Re._handlePool=0}),define(ve[198],_e([0,1,5,9,7]),function(ie,e,E,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class A{constructor(D,y){this._proxy=D.getProxy(E.MainContext.MainThreadLanguages),this._documents=y}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(D,y){await this._proxy.$changeLanguage(D,y);const n=this._documents.getDocumentData(D);if(!n)throw new Error(`document '${D.toString}' NOT found`);return n.document}async tokenAtPosition(D,y){var n;const T=D.version,C=k.Position.from(y),g=await this._proxy.$tokensAtPosition(D.uri,C),f={type:P.StandardTokenType.Other,range:(n=D.getWordRangeAtPosition(y))!==null&&n!==void 0?n:new P.Range(y.line,y.character,y.line,y.character)};if(!g)return f;const r={range:k.Range.to(g.range),type:k.TokenType.to(g.type)};return!r.range.contains(y)||T!==D.version?f:r}}e.ExtHostLanguages=A}),define(ve[199],_e([0,1,5,19,33]),function(ie,e,E,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(D){return D&&D.title}let S=class{constructor(y,n){this._logService=n,this._proxy=y.getProxy(E.MainContext.MainThreadMessageService)}showMessage(y,n,T,C,g){const f={extension:y};let r;typeof C=="string"||A(C)?r=[C,...g]:(f.modal=C&&C.modal,f.useCustom=C&&C.useCustom,r=g),f.useCustom&&(0,P.checkProposedApiEnabled)(y);const s=[];for(let b=0;b<r.length;b++){const h=r[b];if(typeof h=="string")s.push({title:h,handle:b,isCloseAffordance:!1});else if(typeof h=="object"){let{title:_,isCloseAffordance:v}=h;s.push({title:_,isCloseAffordance:!!v,handle:b})}else this._logService.warn("Invalid message item:",h)}return this._proxy.$showMessage(n,T,f,s).then(b=>{if(typeof b=="number")return r[b]})}};S=je([Ke(1,k.ILogService)],S),e.ExtHostMessageService=S}),define(ve[200],_e([0,1,20,3,6,2,29,5,9,7,70,71,22,177,178,53,13,23,56,67]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g,f,r,s,b,h,_,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class c extends P.Disposable{constructor(o,w,I,p,m){super();this._editorId=o,this.uri=w,this._proxy=I,this._webviewInitData=p,this.document=m,this._onDidReceiveDocumentMessage=new k.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:R=>this._proxy.$postMessage(this._editorId,void 0,R),asWebviewUri:R=>this._asWebviewUri(R)}}onDidReceiveMessage(o,w){var I;this._onDidReceiveDocumentMessage.fire(w),o!==void 0&&((I=this._rendererIdToEmitters.get(o))===null||I===void 0||I.fire(w))}getRendererComm(o){const w=new k.Emitter;return this._rendererIdToEmitters.set(o,w),{editorId:this._editorId,onDidReceiveMessage:w.event,postMessage:I=>this._proxy.$postMessage(this._editorId,o,I),asWebviewUri:I=>this._asWebviewUri(I)}}_asWebviewUri(o){return(0,T.asWebviewUri)(this._webviewInitData,this._editorId,o)}}class u extends P.Disposable{constructor(o,w,I,p){super();this._proxy=o,this._handle=w,this._extension=I,this._provider=p,this._kernelToFriendlyId=new g.ResourceMap,this._friendlyIdToKernel=new g.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(m=>{const R=m==null?void 0:m.uri;this._proxy.$onNotebookKernelChange(this._handle,R)}))}async provideKernels(o,w){const I=await this._provider.provideKernels(o.notebookDocument,w)||[],p=new Map;let m=0;const R=new Set,F=this._kernelToFriendlyId.get(o.uri),x=I.map(z=>{var B;let G=F==null?void 0:F.get(z);return G===void 0&&(z.id&&R.has(z.id)?G=`${this._extension.identifier.value}_${z.id}_${m++}`:G=`${this._extension.identifier.value}_${z.id||S.generateUuid()}`),p.set(z,G),{id:z.id,friendlyId:G,label:z.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:z.description,detail:z.detail,isPreferred:z.isPreferred,preloads:(B=z.preloads)===null||B===void 0?void 0:B.map(M=>(A.URI.isUri(M)&&(M={uri:M,provides:[]}),{uri:M.uri,provides:typeof M.provides=="string"?[M.provides]:M.provides===void 0?[]:M.provides})),supportedLanguages:z.supportedLanguages,implementsInterrupt:!!z.interrupt}});this._kernelToFriendlyId.set(o.uri,p);const ae=new Map;return p.forEach((z,B)=>{ae.set(z,B)}),this._friendlyIdToKernel.set(o.uri,ae),x}getKernelByFriendlyId(o,w){var I;return(I=this._friendlyIdToKernel.get(o))===null||I===void 0?void 0:I.get(w)}async resolveNotebook(o,w,I,p){var m;const R=(m=this._friendlyIdToKernel.get(w.uri))===null||m===void 0?void 0:m.get(o);if(R&&this._provider.resolveKernel)return this._provider.resolveKernel(R,w.notebookDocument,I,p)}async executeNotebook(o,w,I){var p;const m=(p=this._friendlyIdToKernel.get(w.uri))===null||p===void 0?void 0:p.get(o);if(!!m){const R=I.map(F=>y.NotebookCellRange.to(F));return m.executeCellsRequest(w.notebookDocument,R)}}async interruptNotebookExecution(o,w){var I;const p=(I=this._friendlyIdToKernel.get(w.uri))===null||I===void 0?void 0:I.get(o);if(!(!p||!p.interrupt))return p.interrupt(w.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=u;class t{constructor(o,w){const I=t._Keys.nextId();o.$registerNotebookEditorDecorationType(I,y.NotebookDecorationRenderOptions.from(w)),this.value={key:I,dispose(){o.$removeNotebookEditorDecorationType(I)}}}}e.NotebookEditorDecorationType=t,t._Keys=new s.IdGenerator("NotebookEditorDecorationType");class i{constructor(o,w,I,p,m,R,F){this._textDocumentsAndEditors=I,this._textDocuments=p,this._webviewInitData=m,this.logService=R,this._extensionStoragePaths=F,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new g.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new k.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new k.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new k.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new k.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new k.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new k.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new k.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new k.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new k.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new k.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new k.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new k.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new k.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new g.ResourceMap,this._statusBarCache=new v.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._rendererIpcEmitters=new Map,this._notebookProxy=o.getProxy(D.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(D.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(D.MainContext.MainThreadNotebookEditors),this._commandsConverter=w.converter,w.registerArgumentProcessor({processArgument:x=>{var ae;if(x&&x.$mid===12){const z=(ae=x.notebookEditor)===null||ae===void 0?void 0:ae.notebookUri,B=x.cell.handle,G=this._documents.get(z),M=G==null?void 0:G.getCell(B);if(M)return M.cell}return x}})}get activeNotebookEditor(){var o;return(o=this._activeNotebookEditor)===null||o===void 0?void 0:o.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(o){return this._documents.get(o)}_getNotebookDocument(o){const w=this._documents.get(o);if(!w)throw new Error(`NO notebook document for '${o}'`);return w}_getProviderData(o){const w=this._notebookContentProviders.get(o);if(!w)throw new Error(`NO provider for '${o}'`);return w}registerNotebookContentProvider(o,w,I,p){var m,R,F;if(this._notebookContentProviders.has(w))throw new Error(`Notebook provider for '${w}' already registered`);this._notebookContentProviders.set(w,{extension:o,provider:I});let x;I.onDidChangeNotebookContentOptions&&(x=I.onDidChangeNotebookContentOptions(()=>{const B=y.NotebookDocumentContentOptions.from(I.options);this._notebookProxy.$updateNotebookProviderOptions(w,B)}));const ae=(m=p==null?void 0:p.viewOptions)===null||m===void 0?void 0:m.filenamePattern.map(B=>y.NotebookExclusiveDocumentPattern.from(B)).filter(B=>B!==void 0);((R=p==null?void 0:p.viewOptions)===null||R===void 0?void 0:R.filenamePattern)&&!ae&&console.warn(`Notebook content provider view options file name pattern is invalid ${(F=p==null?void 0:p.viewOptions)===null||F===void 0?void 0:F.filenamePattern}`);const z=y.NotebookDocumentContentOptions.from(p);return this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation,description:o.description},w,{transientOutputs:z.transientOutputs,transientMetadata:z.transientMetadata,viewOptions:(p==null?void 0:p.viewOptions)&&ae?{displayName:p.viewOptions.displayName,filenamePattern:ae,exclusive:p.viewOptions.exclusive||!1}:void 0}),new n.Disposable(()=>{x==null||x.dispose(),this._notebookContentProviders.delete(w),this._notebookProxy.$unregisterNotebookProvider(w)})}registerNotebookKernelProvider(o,w,I){const p=i._notebookKernelProviderHandlePool++,m=new u(this._notebookProxy,p,o,I);return this._notebookKernelProviders.set(p,m),this._notebookProxy.$registerNotebookKernelProvider({id:o.identifier,location:o.extensionLocation,description:o.description},p,{viewType:w.viewType,filenamePattern:w.filenamePattern?y.NotebookExclusiveDocumentPattern.from(w.filenamePattern):void 0}),new n.Disposable(()=>{m.dispose(),this._notebookKernelProviders.delete(p),this._notebookProxy.$unregisterNotebookKernelProvider(p)})}registerNotebookCellStatusBarItemProvider(o,w,I){const p=i._notebookStatusBarItemProviderHandlePool++,m=typeof I.onDidChangeCellStatusBarItems=="function"?i._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(p,I),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(p,m,{viewType:w.viewType,filenamePattern:w.filenamePattern?y.NotebookExclusiveDocumentPattern.from(w.filenamePattern):void 0});let R;return m!==void 0&&(R=I.onDidChangeCellStatusBarItems(F=>this._notebookProxy.$emitCellStatusBarEvent(m))),new n.Disposable(()=>{this._notebookStatusBarItemProviders.delete(p),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(p,m),R&&R.dispose()})}createNotebookEditorDecorationType(o){return new t(this._notebookEditorsProxy,o).value}async openNotebookDocument(o){const w=this._documents.get(o);if(w)return w.notebookDocument;const I=await this._notebookDocumentsProxy.$tryOpenDocument(o),p=this._documents.get(A.URI.revive(I));return(0,b.assertIsDefined)(p==null?void 0:p.notebookDocument)}_withAdapter(o,w,I){const p=this._documents.get(A.URI.revive(w));if(!p)return[];const m=this._notebookKernelProviders.get(o);return m?I(m,p):[]}async showNotebookDocument(o,w){var I;A.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let p;typeof w=="object"?p={position:y.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selections:w.selections&&w.selections.map(y.NotebookCellRange.from),pinned:typeof w.preview=="boolean"?!w.preview:void 0}:p={preserveFocus:!1};const m=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.viewType,p),R=m&&((I=this._editors.get(m))===null||I===void 0?void 0:I.apiEditor);if(R)return R;throw m?new Error(`Could NOT open editor for "${o.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.toString()}".`)}async $provideNotebookKernels(o,w,I){return this._withAdapter(o,w,(p,m)=>p.provideKernels(m,I))}async $resolveNotebookKernel(o,w,I,p,m){await this._withAdapter(o,I,async(R,F)=>{const x=this._webviewComm.get(w);x&&await R.resolveNotebook(p,F,x.contentProviderComm,m)})}async $provideNotebookCellStatusBarItems(o,w,I,p){var m;const R=this._notebookStatusBarItemProviders.get(o),F=A.URI.revive(w),x=this._documents.get(F);if(!(!x||!R)){const ae=x.getCellFromIndex(I);if(!!ae){const z=await R.provideCellStatusBarItems(ae.cell,p);if(!!z){const B=new P.DisposableStore,G=this._statusBarCache.add([B]),M=(m=z&&z.map(N=>y.NotebookStatusBarItem.from(N,this._commandsConverter,B)))!==null&&m!==void 0?m:void 0;return{cacheId:G,items:M}}}}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}async $resolveNotebookEditor(o,w,I){const p=this._notebookContentProviders.get(o),m=A.URI.revive(w),R=this._documents.get(m);if(!(!R||!p)){let F=this._webviewComm.get(I);F||(F=new c(I,m,this._notebookProxy,this._webviewInitData,R),this._webviewComm.set(I,F))}}async $executeNotebookKernelFromProvider(o,w,I,p){await this._withAdapter(o,w,async(m,R)=>m.executeNotebook(I,R,p))}registerNotebookSerializer(o,w,I,p){const m=this._handlePool++;this._notebookSerializer.set(m,I);const R=y.NotebookDocumentContentOptions.from(p);return this._notebookProxy.$registerNotebookSerializer(m,{id:o.identifier,location:o.extensionLocation,description:o.description},w,R),(0,P.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(m)})}async $dataToNotebook(o,w){const I=this._notebookSerializer.get(o);if(!I)throw new Error("NO serializer found");const p=await I.dataToNotebook(w.buffer);return{metadata:y.NotebookDocumentMetadata.from(p.metadata),cells:p.cells.map(y.NotebookCellData.from)}}async $notebookToData(o,w){const I=this._notebookSerializer.get(o);if(!I)throw new Error("NO serializer found");const p=await I.notebookToData({metadata:y.NotebookDocumentMetadata.to(w.metadata),cells:w.cells.map(y.NotebookCellData.to)});return h.VSBuffer.wrap(p)}async $cancelNotebookCellExecution(o,w,I,p){await this._withAdapter(o,w,async(R,F)=>R.interruptNotebookExecution(I,F));const m=this._documents.get(A.URI.revive(w));if(!!m)for(let R of p)for(let F=R.start;F<R.end;F++){const x=m.getCellFromIndex(F);x&&this.cancelOneNotebookCellExecution(x)}}cancelOneNotebookCellExecution(o){const w=this._activeExecutions.get(o.uri);w==null||w.cancel()}async $openNotebook(o,w,I,p,m){const{provider:R}=this._getProviderData(o),F=await R.openNotebook(A.URI.revive(w),{backupId:I,untitledDocumentData:p==null?void 0:p.buffer},m);return{metadata:y.NotebookDocumentMetadata.from(F.metadata),cells:F.cells.map(y.NotebookCellData.from)}}async $saveNotebook(o,w,I){const p=this._getNotebookDocument(A.URI.revive(w)),{provider:m}=this._getProviderData(o);return await m.saveNotebook(p.notebookDocument,I),!0}async $saveNotebookAs(o,w,I,p){const m=this._getNotebookDocument(A.URI.revive(w)),{provider:R}=this._getProviderData(o);return await R.saveNotebookAs(A.URI.revive(I),m.notebookDocument,p),!0}async $backupNotebook(o,w,I){var p;const m=this._getNotebookDocument(A.URI.revive(w)),R=this._getProviderData(o),F=(p=this._extensionStoragePaths.workspaceValue(R.extension))!==null&&p!==void 0?p:this._extensionStoragePaths.globalValue(R.extension),x=String((0,_.hash)([m.uri.toString(),this._backupIdPool++])),ae=A.URI.joinPath(F,x),z=await R.provider.backupNotebook(m.notebookDocument,{destination:ae},I);return m.updateBackup(z),z.id}$acceptNotebookActiveKernelChange(o){o.providerHandle!==void 0&&this._withAdapter(o.providerHandle,o.uri,async(w,I)=>{const p=o.kernelFriendlyId?w.getKernelByFriendlyId(A.URI.revive(o.uri),o.kernelFriendlyId):void 0;this._editors.forEach(m=>{m.notebookData===I&&m._acceptKernel(p)}),this._onDidChangeActiveNotebookKernel.fire({document:I.notebookDocument,kernel:p})})}$onDidReceiveMessage(o,w,I){var p;(p=this._webviewComm.get(o))===null||p===void 0||p.onDidReceiveMessage(w,I)}$acceptModelChanged(o,w,I){this._getNotebookDocument(A.URI.revive(o)).acceptModelChanged(w,I)}$acceptDirtyStateChanged(o,w){const I=this._getNotebookDocument(A.URI.revive(o));I.acceptModelChanged({rawEvents:[],versionId:I.notebookDocument.version},w)}$acceptModelSaved(o){const w=this._getNotebookDocument(A.URI.revive(o));this._onDidSaveNotebookDocument.fire(w.notebookDocument)}$acceptEditorPropertiesChanged(o,w){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",o,w);const I=this._editors.get(o);if(!I)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);w.visibleRanges&&I._acceptVisibleRanges(w.visibleRanges.ranges.map(y.NotebookCellRange.to)),w.selections&&I._acceptSelections(w.selections.selections.map(y.NotebookCellRange.to)),w.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:I.apiEditor,visibleRanges:I.apiEditor.visibleRanges}),w.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:I.apiEditor,selections:I.apiEditor.selections}))}_editorIdFromApiEditor(o){for(const[w,I]of this._editors)if(I.apiEditor===o)return w}createNotebookCommunication(o){const w=this,I=this._handlePool++,p=new k.Emitter,m=this._notebookEditorsProxy.$addRendererIpc(o,I),R={rendererId:o,onDidReceiveMessage:p.event,dispose(){p.dispose(),w._rendererIpcEmitters.delete(I),w._notebookEditorsProxy.$removeRendererIpc(o,I)},async postMessage(F,x){let ae;return x&&(ae=w._editorIdFromApiEditor(x),!ae)?!1:(await m,w._notebookEditorsProxy.$postRendererIpcMessage(o,I,ae,F))},asWebviewUri(F,x){const ae=w._editorIdFromApiEditor(x);if(!ae)throw new Error("invalid editor");return(0,T.asWebviewUri)(w._webviewInitData,ae,F)}};return this._rendererIpcEmitters.set(I,{emitter:p}),R}$acceptEditorIpcMessage(o,w,I,p){var m;const R=this._editors.get(o);if(!R)throw new Error("sending ipc message for UNKNOWN editor");for(const F of I)(m=this._rendererIpcEmitters.get(F))===null||m===void 0||m.emitter.fire({editor:R.apiEditor,message:p})}$acceptEditorViewColumns(o){for(const w in o){const I=this._editors.get(w);if(!I)throw new Error(`unknown text editor: ${w}. known editors: ${[...this._editors.keys()]} `);I._acceptViewColumn(y.ViewColumn.to(o[w]))}}$acceptDocumentPropertiesChanged(o,w){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",o.path,w);const I=this._getNotebookDocument(A.URI.revive(o));I.acceptDocumentPropertiesChanged(w),w.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:I.notebookDocument})}_createExtHostEditor(o,w,I){if(this._editors.has(w))throw new Error(`editor with id ALREADY EXSIST: ${w}`);const p=o.uri;let m=this._webviewComm.get(w);m||(m=new c(w,p,this._notebookProxy,this._webviewInitData,o),this._webviewComm.set(w,m));const R=new r.ExtHostNotebookEditor(w,this._notebookEditorsProxy,o,I.visibleRanges.map(y.NotebookCellRange.to),I.selections.map(y.NotebookCellRange.to),typeof I.viewColumn=="number"?y.ViewColumn.to(I.viewColumn):void 0);this._editors.set(w,R)}$acceptDocumentAndEditorsDelta(o){var w,I,p;if(o.removedDocuments)for(const R of o.removedDocuments){const F=A.URI.revive(R),x=this._documents.get(F);x&&(x.dispose(),this._documents.delete(F),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:x.notebookDocument.getCells().map(ae=>ae.document.uri)}),this._onDidCloseNotebookDocument.fire(x.notebookDocument));for(const ae of this._editors.values())ae.notebookData.uri.toString()===F.toString()&&this._editors.delete(ae.id)}if(o.addedDocuments){const R=[];for(const F of o.addedDocuments){const x=A.URI.revive(F.uri),ae=F.viewType;if(this._documents.has(x))throw new Error(`adding EXISTING notebook ${x} `);const z=this,B=new f.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(G){z._onDidChangeNotebookCells.fire(G)},emitCellOutputsChange(G){z._onDidChangeCellOutputs.fire(G)},emitCellMetadataChange(G){z._onDidChangeCellMetadata.fire(G)},emitCellExecutionStateChange(G){z._onDidChangeCellExecutionState.fire(G)}},ae,F.metadata?y.NotebookDocumentMetadata.to(F.metadata):new n.NotebookDocumentMetadata,x);B.acceptModelChanged({versionId:F.versionId,rawEvents:[{kind:C.NotebookCellsChangeType.Initialize,changes:[[0,0,F.cells]]}]},!1),R.push(...F.cells.map(G=>f.ExtHostCell.asModelAddData(B.notebookDocument,G))),(w=this._documents.get(x))===null||w===void 0||w.dispose(),this._documents.set(x,B),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:R}),this._onDidOpenNotebookDocument.fire(B.notebookDocument)}}if(o.addedEditors)for(const R of o.addedEditors){if(this._editors.has(R.id))return;const F=A.URI.revive(R.documentUri),x=this._documents.get(F);x&&this._createExtHostEditor(x,R.id,R)}const m=[];if(o.removedEditors)for(const R of o.removedEditors){const F=this._editors.get(R);F&&(this._editors.delete(R),((I=this._activeNotebookEditor)===null||I===void 0?void 0:I.id)===F.id&&(this._activeNotebookEditor=void 0),m.push(F))}if(o.visibleEditors){this._visibleNotebookEditors=o.visibleEditors.map(F=>this._editors.get(F)).filter(F=>!!F);const R=new Set;this._visibleNotebookEditors.forEach(F=>R.add(F.id));for(const F of this._editors.values()){const x=R.has(F.id);F._acceptVisibility(x)}this._visibleNotebookEditors=[...this._editors.values()].map(F=>F).filter(F=>F.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.newActiveEditor===null?this._activeNotebookEditor=void 0:o.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.newActiveEditor)),o.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((p=this._activeNotebookEditor)===null||p===void 0?void 0:p.apiEditor)}createNotebookCellExecution(o,w,I){const p=this.lookupNotebookDocument(o);if(!p)throw new Error(`Invalid cell uri / index: ${o}, ${w} `);const m=p.getCellFromIndex(w);if(!m)throw new Error(`Invalid cell uri / index: ${o}, ${w} `);if(!this._activeExecutions.has(m.uri)){const R=new a(o,p,m,this._notebookDocumentsProxy);this._activeExecutions.set(m.uri,R);const F=R.onDidChangeState(()=>{R.state===d.Resolved&&(R.dispose(),F.dispose(),this._activeExecutions.delete(m.uri))});return R.asApiObject()}}}e.ExtHostNotebookController=i,i._notebookKernelProviderHandlePool=0,i._notebookStatusBarItemProviderHandlePool=0;var d;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(d||(d={}));class a extends P.Disposable{constructor(o,w,I,p){super();this._uri=o,this._document=w,this._cell=I,this._proxy=p,this._onDidChangeState=new k.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=d.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._executionOrder=I.internalMetadata.executionOrder,this.mixinMetadata({runState:n.NotebookCellExecutionState.Pending,lastRunDuration:null,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEdits(o){return this._proxy.$applyEdits(this._uri,o,!1)}verifyStateForOutput(){if(this._state===d.Init)throw new Error("Must call start before modifying cell output");if(this._state===d.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(o){const w=[{editType:11,handle:this._cell.handle,metadata:o}];this.applyEdits(w)}cellIndexToHandle(o){const w=typeof o=="number"?this._document.getCellFromIndex(o):this._cell;if(!!w)return w.handle}asApiObject(){const o=this;return Object.freeze({get document(){return o._document.notebookDocument},get cell(){return o._cell.cell},get executionOrder(){return o._executionOrder},set executionOrder(w){o._executionOrder=w,o.mixinMetadata({executionOrder:w})},start(w){if(o._state===d.Resolved||o._state===d.Started)throw new Error("Cannot call start again");o._state=d.Started,o._onDidChangeState.fire(),o.mixinMetadata({runState:n.NotebookCellExecutionState.Executing,runStartTime:w==null?void 0:w.startTime})},end(w){var I,p;if(o._state===d.Resolved)throw new Error("Cannot call resolve twice");o._state=d.Resolved,o._onDidChangeState.fire(),o.mixinMetadata({runState:n.NotebookCellExecutionState.Idle,lastRunSuccess:(I=w==null?void 0:w.success)!==null&&I!==void 0?I:null,lastRunDuration:(p=w==null?void 0:w.duration)!==null&&p!==void 0?p:null})},clearOutput(w){return o.verifyStateForOutput(),this.replaceOutput([],w)},async appendOutput(w,I){o.verifyStateForOutput();const p=o.cellIndexToHandle(I);if(typeof p=="number")return w=Array.isArray(w)?w:[w],o.applyEdits([{editType:2,handle:p,append:!0,outputs:w.map(y.NotebookCellOutput.from)}])},async replaceOutput(w,I){o.verifyStateForOutput();const p=o.cellIndexToHandle(I);if(typeof p=="number")return w=Array.isArray(w)?w:[w],o.applyEdits([{editType:2,handle:p,outputs:w.map(y.NotebookCellOutput.from)}])},async appendOutputItems(w,I){return o.verifyStateForOutput(),w=Array.isArray(w)?w:[w],o.applyEdits([{editType:10,append:!0,items:w.map(y.NotebookCellOutputItem.from),outputId:I}])},async replaceOutputItems(w,I){return o.verifyStateForOutput(),w=Array.isArray(w)?w:[w],o.applyEdits([{editType:10,items:w.map(y.NotebookCellOutputItem.from),outputId:I}])},token:o._tokenSource.token})}}}),define(ve[201],_e([0,1,3,6,5,2,9,11]),function(ie,e,E,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class y{constructor(T,C){this._extHostNotebook=C,this._kernelData=new Map,this._handlePool=0,this._proxy=T.getProxy(P.MainContext.MainThreadNotebookKernels)}createKernel(T,C){var g,f;const r=this._handlePool++,s=this;let b=!1;const h=new k.DisposableStore,_=new E.Emitter;this._kernelData.set(r,{id:C.id,executeHandler:C.executeHandler,onDidChangeSelection:_});const v={id:C.id,selector:C.selector,extensionId:T.identifier,extensionLocation:T.extensionLocation,label:C.label,supportedLanguages:[]};this._proxy.$addKernel(r,v);let c=0;const u=()=>{if(!b){const i=++c;Promise.resolve().then(()=>{i===c&&this._proxy.$updateKernel(r,v)})}},t={get id(){return v.id},get selector(){return v.selector},onDidChangeNotebookAssociation:_.event,get label(){return v.label},set label(i){v.label=i,u()},get description(){var i;return(i=v.description)!==null&&i!==void 0?i:""},set description(i){v.description=i,u()},get supportedLanguages(){return v.supportedLanguages},set supportedLanguages(i){v.supportedLanguages=(0,D.isNonEmptyArray)(i)?i:["plaintext"],u()},get hasExecutionOrder(){var i;return(i=v.hasExecutionOrder)!==null&&i!==void 0?i:!1},set hasExecutionOrder(i){v.hasExecutionOrder=i,u()},get executeHandler(){return s._kernelData.get(r).executeHandler},get interruptHandler(){return s._kernelData.get(r).interruptHandler},set interruptHandler(i){s._kernelData.get(r).interruptHandler=i,v.supportsInterrupt=Boolean(i),u()},createNotebookCellExecutionTask(i){if(b)throw new Error("object disposed");return s._extHostNotebook.createNotebookCellExecution(i.document.uri,i.index,v.id)},dispose:()=>{b||(b=!0,this._kernelData.delete(r),h.dispose(),_.dispose(),this._proxy.$removeKernel(r))}};return t.supportedLanguages=(g=C.supportedLanguages)!==null&&g!==void 0?g:[],t.interruptHandler=C.interruptHandler,t.hasExecutionOrder=(f=C.hasExecutionOrder)!==null&&f!==void 0?f:!1,t}$acceptSelection(T,C,g){const f=this._kernelData.get(T);f&&f.onDidChangeSelection.fire({selected:g,notebook:this._extHostNotebook.lookupNotebookDocument(A.URI.revive(C)).notebookDocument})}$executeCells(T,C,g){const f=this._kernelData.get(T);if(!!f){const r=this._extHostNotebook.lookupNotebookDocument(A.URI.revive(C));if(!r)throw new Error("MISSING notebook");const s=[];for(let b of g){const h=r.notebookDocument.getCells(S.NotebookCellRange.to(b));for(let _ of h){const v=this._extHostNotebook.createNotebookCellExecution(r.uri,_.index,f.id);v?s.push(v):console.warn("could NOT create notebook cell execution task for: "+_.document.uri)}}try{f.executeHandler(s)}catch(b){console.error(b)}}}$cancelCells(T,C,g){const f=this._kernelData.get(T);if(!!f){const r=this._extHostNotebook.lookupNotebookDocument(A.URI.revive(C));if(!r)throw new Error("MISSING notebook");f.interruptHandler&&f.interruptHandler(r.notebookDocument)}}}e.ExtHostNotebookKernels=y}),define(ve[99],_e([0,1,5,3,6,23,4,15]),function(ie,e,E,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends P.Disposable{constructor(r,s,b,h){super();this._onDidAppend=this._register(new k.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=r,this._proxy=h,this._id=h.$register(this.name,s,b),this._disposed=!1,this._offset=0}get name(){return this._name}append(r){this.validate(),this._offset+=r?A.VSBuffer.fromString(r).byteLength:0}update(){this._id.then(r=>this._proxy.$update(r))}appendLine(r){this.validate(),this.append(r+`
`)}clear(){this.validate();const r=this._offset;this._id.then(s=>this._proxy.$clear(s,r))}show(r,s){this.validate(),this._id.then(b=>this._proxy.$reveal(b,!!(typeof r=="boolean"?r:s)))}hide(){this.validate(),this._id.then(r=>this._proxy.$close(r))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(r=>this._proxy.$dispose(r)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class n extends y{constructor(r,s){super(r,!1,void 0,s)}append(r){super.append(r),this._id.then(s=>this._proxy.$append(s,r)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=n;class T extends y{constructor(r,s,b){super(r,!0,s,b)}append(r){throw new Error("Not supported")}}class C{constructor(r,s){this.name=r,this._channel=s}append(r){this._channel.then(s=>s.append(r))}appendLine(r){this._channel.then(s=>s.appendLine(r))}clear(){this._channel.then(r=>r.clear())}show(r,s){this._channel.then(b=>b.show(r,s))}hide(){this._channel.then(r=>r.hide())}dispose(){this._channel.then(r=>r.dispose())}}e.LazyOutputChannel=C;let g=class{constructor(r){this._proxy=r.getProxy(E.MainContext.MainThreadOutputService)}$setVisibleChannel(r){}createOutputChannel(r){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");return new n(r,this._proxy)}createOutputChannelFromLogFile(r,s){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");if(!s)throw new Error("illegal argument `file`. must not be falsy");return new T(r,s,this._proxy)}};g=je([Ke(0,D.IExtHostRpcService)],g),e.ExtHostOutputService=g,e.IExtHostOutputService=(0,S.createDecorator)("IExtHostOutputService")}),define(ve[202],_e([0,1,14,20,3,6,5,2,7,10,11,46]),function(ie,e,E,k,P,A,S,D,y,n,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(f,r,s){const b=f.getProxy(S.MainContext.MainThreadQuickOpen);class h{constructor(a,l){this._sessions=new Map,this._instances=0,this._workspace=a,this._commands=l}showQuickPick(a,l,o,w=k.CancellationToken.None){this._onDidSelectItem=void 0;const I=Promise.resolve(a),p=++this._instances,m=b.$show(p,{title:o==null?void 0:o.title,placeHolder:o==null?void 0:o.placeHolder,matchOnDescription:o==null?void 0:o.matchOnDescription,matchOnDetail:o==null?void 0:o.matchOnDetail,ignoreFocusLost:o==null?void 0:o.ignoreFocusOut,canPickMany:o==null?void 0:o.canPickMany},w),R={},F=m.then(()=>R);return Promise.race([F,I]).then(x=>{if(x!==R)return I.then(ae=>{const z=[];for(let B=0;B<ae.length;B++){const G=ae[B];let M,N,W,Q,$;typeof G=="string"?M=G:(M=G.label,N=G.description,W=G.detail,Q=G.picked,$=G.alwaysShow),z.push({label:M,description:N,handle:B,detail:W,picked:Q,alwaysShow:$})}return o&&typeof o.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{o.onDidSelectItem(ae[B])}),b.$setItems(p,z),m.then(B=>{if(typeof B=="number")return ae[B];if(Array.isArray(B))return B.map(G=>ae[G])})})}).then(void 0,x=>{if(!(0,n.isPromiseCanceledError)(x))return b.$setError(p,x),Promise.reject(x)})}$onItemSelected(a){this._onDidSelectItem&&this._onDidSelectItem(a)}showInput(a,l=k.CancellationToken.None){return this._validateInput=a?a.validateInput:void 0,b.$input(a,typeof this._validateInput=="function",l).then(void 0,o=>{if(!(0,n.isPromiseCanceledError)(o))return Promise.reject(o)})}$validateInput(a){return this._validateInput?(0,E.asPromise)(()=>this._validateInput(a)):Promise.resolve(void 0)}async showWorkspaceFolderPick(a,l=k.CancellationToken.None){const o=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[a]);if(!!o){const w=await this._workspace.getWorkspaceFolders2();if(!!w)return w.find(I=>I.uri.toString()===o.uri.toString())}}createQuickPick(a,l){const o=new t(a,l,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}createInputBox(a){const l=new i(a,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(a,l){const o=this._sessions.get(a);o&&o._fireDidChangeValue(l)}$onDidAccept(a){const l=this._sessions.get(a);l&&l._fireDidAccept()}$onDidChangeActive(a,l){const o=this._sessions.get(a);o instanceof t&&o._fireDidChangeActive(l)}$onDidChangeSelection(a,l){const o=this._sessions.get(a);o instanceof t&&o._fireDidChangeSelection(l)}$onDidTriggerButton(a,l){const o=this._sessions.get(a);o&&o._fireDidTriggerButton(l)}$onDidHide(a){const l=this._sessions.get(a);l&&l._fireDidHide()}}class _{constructor(a,l){this._extensionId=a,this._onDidDispose=l,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new P.Emitter,this._onDidChangeValueEmitter=new P.Emitter,this._onDidTriggerButtonEmitter=new P.Emitter,this._onDidHideEmitter=new P.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(a){this._title=a,this.update({title:a})}get step(){return this._steps}set step(a){this._steps=a,this.update({step:a})}get totalSteps(){return this._totalSteps}set totalSteps(a){this._totalSteps=a,this.update({totalSteps:a})}get enabled(){return this._enabled}set enabled(a){this._enabled=a,this.update({enabled:a})}get busy(){return this._busy}set busy(a){this._busy=a,this.update({busy:a})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(a){this._ignoreFocusOut=a,this.update({ignoreFocusOut:a})}get value(){return this._value}set value(a){this._value=a,this.update({value:a})}get placeholder(){return this._placeholder}set placeholder(a){this._placeholder=a,this.update({placeholder:a})}get buttons(){return this._buttons}set buttons(a){this._buttons=a.slice(),this._handlesToButtons.clear(),a.forEach((l,o)=>{const w=l===y.QuickInputButtons.Back?-1:o;this._handlesToButtons.set(w,l)}),this.update({buttons:a.map((l,o)=>({iconPath:v(l.iconPath),tooltip:l.tooltip,handle:l===y.QuickInputButtons.Back?-1:o}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(a){this._value=a,this._onDidChangeValueEmitter.fire(a)}_fireDidTriggerButton(a){const l=this._handlesToButtons.get(a);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),b.$dispose(this._id))}update(a){if(!this._disposed){for(const l of Object.keys(a)){const o=a[l];this._pendingUpdate[l]=o===void 0?null:o}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){b.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}_._nextId=1;function v(d){if(d instanceof y.ThemeIcon)return{id:d.id};const a=u(d),l=c(d);return{dark:typeof a=="string"?D.URI.file(a):a,light:typeof l=="string"?D.URI.file(l):l}}function c(d){return typeof d=="object"&&"light"in d?d.light:d}function u(d){return typeof d=="object"&&"dark"in d?d.dark:d}class t extends _{constructor(a,l,o){super(a,o);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new P.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new P.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(a){this._items=a.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),a.forEach((l,o)=>{this._handlesToItems.set(o,l),this._itemsToHandles.set(l,o)}),this.update({items:a.map((l,o)=>({label:l.label,description:l.description,handle:o,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(a){this._canSelectMany=a,this.update({canSelectMany:a})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(a){this._matchOnDescription=a,this.update({matchOnDescription:a})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(a){this._matchOnDetail=a,this.update({matchOnDetail:a})}get sortByLabel(){return this._sortByLabel}set sortByLabel(a){this._sortByLabel=a,this.update({sortByLabel:a})}get activeItems(){return this._activeItems}set activeItems(a){this._activeItems=a.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(a){this._selectedItems=a.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(a){const l=(0,T.coalesce)(a.map(o=>this._handlesToItems.get(o)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(a){const l=(0,T.coalesce)(a.map(o=>this._handlesToItems.get(o)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}}class i extends _{constructor(a,l){super(a,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(a){this._password=a,this.update({password:a})}get prompt(){return this._prompt}set prompt(a){this._prompt=a,this.update({prompt:a})}get validationMessage(){return this._validationMessage}set validationMessage(a){this._validationMessage=a,this.update({validationMessage:a,severity:a?C.default.Error:C.default.Ignore})}}return new h(r,s)}e.createExtHostQuickOpen=g}),define(ve[203],_e([0,1,2,3,51,6,14,5,11,110,19,26,33]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(a){if(a)return typeof a.iconPath=="string"?E.URI.file(a.iconPath):a.iconPath}function r(a,l){if(!a.iconPath&&!l.iconPath)return 0;if(a.iconPath){if(!l.iconPath)return 1}else return-1;const o=typeof a.iconPath=="string"?a.iconPath:a.iconPath.fsPath,w=typeof l.iconPath=="string"?l.iconPath:l.iconPath.fsPath;return(0,n.comparePaths)(o,w)}function s(a,l){let o=0;if(a.strikeThrough!==l.strikeThrough)return a.strikeThrough?1:-1;if(a.faded!==l.faded)return a.faded?1:-1;if(a.tooltip!==l.tooltip)return(a.tooltip||"").localeCompare(l.tooltip||"");if(o=r(a,l),o!==0)return o;if(a.light&&l.light)o=r(a.light,l.light);else{if(a.light)return 1;if(l.light)return-1}if(o!==0)return o;if(a.dark&&l.dark)o=r(a.dark,l.dark);else{if(a.dark)return 1;if(l.dark)return-1}return o}function b(a,l){if(a.command!==l.command)return a.command<l.command?-1:1;if(a.title!==l.title)return a.title<l.title?-1:1;if(a.tooltip!==l.tooltip){if(a.tooltip!==void 0&&l.tooltip!==void 0)return a.tooltip<l.tooltip?-1:1;if(a.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(a.arguments===l.arguments)return 0;if(a.arguments)if(l.arguments){if(a.arguments.length!==l.arguments.length)return a.arguments.length-l.arguments.length}else return 1;else return-1;for(let o=0;o<a.arguments.length;o++){const w=a.arguments[o],I=l.arguments[o];if(w!==I)return w<I?-1:1}return 0}function h(a,l){let o=(0,n.comparePaths)(a.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(o!==0)return o;if(a.command&&l.command)o=b(a.command,l.command);else{if(a.command)return 1;if(l.command)return-1}if(o!==0)return o;if(a.decorations&&l.decorations)o=s(a.decorations,l.decorations);else{if(a.decorations)return 1;if(l.decorations)return-1}return o}function _(a,l){for(let o=0;o<a.length;o++)if(a[o]!==l[o])return!1;return!0}function v(a,l){return a.command===l.command&&a.title===l.title&&a.tooltip===l.tooltip&&(a.arguments&&l.arguments?_(a.arguments,l.arguments):a.arguments===l.arguments)}function c(a,l){return(0,y.equals)(a,l,v)}class u{constructor(l,o,w){this._extension=l,this._proxy=o,this._sourceControlHandle=w,this._value="",this._onDidChange=new k.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(l){this._proxy.$setInputBoxValue(this._sourceControlHandle,l),this.updateValue(l)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(l){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,l),this._placeholder=l}get validateInput(){return(0,g.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(l){if((0,g.checkProposedApiEnabled)(this._extension),l&&typeof l!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=l,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!l)}get visible(){return this._visible}set visible(l){l=!!l,this._visible!==l&&(this._visible=l,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,l))}focus(){(0,g.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(l,o){(0,g.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,l,o)}$onInputBoxValueChange(l){this.updateValue(l)}updateValue(l){this._value=l,this._onDidChange.fire(l)}}e.ExtHostSCMInputBox=u;class t{constructor(l,o,w,I,p){this._proxy=l,this._commands=o,this._sourceControlHandle=w,this._id=I,this._label=p,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new k.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new k.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(l){this._label=l,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,l)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(l){this._hideWhenEmpty=l,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(l){this._resourceStates=[...l],this._onDidUpdateResourceStates.fire()}getResourceState(l){return this._resourceStatesMap.get(l)}$executeResourceCommand(l,o){const w=this._resourceStatesCommandsMap.get(l);return w?(0,S.asPromise)(()=>this._commands.executeCommand(w.command,...w.arguments||[],o)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var l;const o=[...this._resourceStates].sort(h),I=(0,y.sortedDiff)(this._resourceSnapshot,o,h).map(R=>{const F=R.toInsert.map(x=>{const ae=this._resourceHandlePool++;this._resourceStatesMap.set(ae,x);const z=x.resourceUri,B=f(x.decorations),G=x.decorations&&f(x.decorations.light)||B,M=x.decorations&&f(x.decorations.dark)||B,N=[];let W;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"){const ye=new A.DisposableStore;W=this._commands.converter.toInternal(x.command,ye),this._resourceStatesDisposablesMap.set(ae,ye)}else this._resourceStatesCommandsMap.set(ae,x.command);G&&N.push(G),M&&M.toString()!==(G==null?void 0:G.toString())&&N.push(M);const Q=x.decorations&&x.decorations.tooltip||"",$=x.decorations&&!!x.decorations.strikeThrough,Z=x.decorations&&!!x.decorations.faded,re=x.contextValue||"";return{rawResource:[ae,z,N,Q,$,Z,re,W],handle:ae}});return{start:R.start,deleteCount:R.deleteCount,toInsert:F}}),p=I.map(({start:R,deleteCount:F,toInsert:x})=>[R,F,x.map(ae=>ae.rawResource)]),m=I.reverse();for(const{start:R,deleteCount:F,toInsert:x}of m){const ae=x.map(B=>B.handle),z=this._handlesSnapshot.splice(R,F,...ae);for(const B of z)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),(l=this._resourceStatesDisposablesMap.get(B))===null||l===void 0||l.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=o,p}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(l,o,w,I,p,m){this._proxy=o,this._commands=w,this._id=I,this._label=p,this._rootUri=m,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new k.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new u(l,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,I,p,m)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(l){this._count!==l&&(this._count=l,this._proxy.$updateSourceControl(this.handle,{count:l}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(l){this._quickDiffProvider=l,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!l})}get commitTemplate(){return this._commitTemplate}set commitTemplate(l){l!==this._commitTemplate&&(this._commitTemplate=l,this._proxy.$updateSourceControl(this.handle,{commitTemplate:l}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(l){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=l;const o=this._commands.converter.toInternal(l,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:o})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(l){if(!(this._statusBarCommands&&l&&c(this._statusBarCommands,l))){this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=l;const o=(l||[]).map(w=>this._commands.converter.toInternal(w,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:o})}}get selected(){return this._selected}createResourceGroup(l,o){const w=new t(this._proxy,this._commands,this.handle,l,o),I=k.Event.once(w.onDidDispose)(()=>this.createdResourceGroups.delete(w));return this.createdResourceGroups.set(w,I),this.eventuallyAddResourceGroups(),w}eventuallyAddResourceGroups(){const l=[],o=[];for(const[w,I]of this.createdResourceGroups){I.dispose();const p=w.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(w),this.eventuallyUpdateResourceStates()});k.Event.once(w.onDidDispose)(()=>{this.updatedResourceGroups.delete(w),p.dispose(),this._groups.delete(w.handle),this._proxy.$unregisterGroup(this.handle,w.handle)}),l.push([w.handle,w.id,w.label,w.features]);const m=w._takeResourceStateSnapshot();m.length>0&&o.push([w.handle,m]),this._groups.set(w.handle,w)}this._proxy.$registerGroups(this.handle,l,o),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const l=[];this.updatedResourceGroups.forEach(o=>{const w=o._takeResourceStateSnapshot();w.length!==0&&l.push([o.handle,w])}),l.length>0&&this._proxy.$spliceResourceStates(this.handle,l),this.updatedResourceGroups.clear()}getResourceGroup(l){return this._groups.get(l)}setSelectionState(l){this._selected=l,this._onDidChangeSelection.fire(l)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(l=>l.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,je([(0,P.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),je([(0,P.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let d=class In{constructor(l,o,w){this._commands=o,this.logService=w,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new k.Emitter,this._proxy=l.getProxy(D.MainContext.MainThreadSCM),this._telemetry=l.getProxy(D.MainContext.MainThreadTelemetry),o.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===3){const p=this._sourceControls.get(I.sourceControlHandle);if(!p)return I;const m=p.getResourceGroup(I.groupHandle);return m?m.getResourceState(I.handle):I}else if(I&&I.$mid===4){const p=this._sourceControls.get(I.sourceControlHandle);return p?p.getResourceGroup(I.groupHandle):I}else if(I&&I.$mid===5){const p=this._sourceControls.get(I.handle);return p||I}return I}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(l,o,w,I){this.logService.trace("ExtHostSCM#createSourceControl",l.identifier.value,o,w,I),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const p=In._handlePool++,m=new i(l,this._proxy,this._commands,o,w,I);this._sourceControls.set(p,m);const R=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(l.identifier))||[];return R.push(m),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(l.identifier),R),m}getLastInputBox(l){this.logService.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const o=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(l.identifier)),w=o&&o[o.length-1];return w&&w.inputBox}$provideOriginalResource(l,o,w){const I=E.URI.revive(o);this.logService.trace("ExtHostSCM#$provideOriginalResource",l,I.toString());const p=this._sourceControls.get(l);return!p||!p.quickDiffProvider||!p.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,S.asPromise)(()=>p.quickDiffProvider.provideOriginalResource(I,w)).then(m=>m||null)}$onInputBoxValueChange(l,o){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",l);const w=this._sourceControls.get(l);return w&&w.inputBox.$onInputBoxValueChange(o),Promise.resolve(void 0)}$executeResourceCommand(l,o,w,I){this.logService.trace("ExtHostSCM#$executeResourceCommand",l,o,w);const p=this._sourceControls.get(l);if(!p)return Promise.resolve(void 0);const m=p.getResourceGroup(o);return m?m.$executeResourceCommand(w,I):Promise.resolve(void 0)}$validateInput(l,o,w){this.logService.trace("ExtHostSCM#$validateInput",l);const I=this._sourceControls.get(l);return!I||!I.inputBox.validateInput?Promise.resolve(void 0):(0,S.asPromise)(()=>I.inputBox.validateInput(o,w)).then(p=>p?Promise.resolve([p.message,p.type]):Promise.resolve(void 0))}$setSelectedSourceControl(l){var o,w;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&((o=this._sourceControls.get(l))===null||o===void 0||o.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((w=this._sourceControls.get(this._selectedSourceControlHandle))===null||w===void 0||w.setSelectionState(!1)),this._selectedSourceControlHandle=l,Promise.resolve(void 0)}};d._handlePool=0,d=je([Ke(2,T.ILogService)],d),e.ExtHostSCM=d});var et=this&&this.__classPrivateFieldSet||function(ie,e,E,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(ie,E):P?P.value=E:e.set(ie,E),E},xe=this&&this.__classPrivateFieldGet||function(ie,e,E,k){if(E==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?k:E==="a"?k.call(ie):k?k.value:e.get(ie)};define(ve[204],_e([0,1,7,5,133,6]),function(ie,e,E,k,P,A){"use strict";var S,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{constructor(g,f,r,s,b=E.StatusBarAlignment.Left,h,_){S.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,et(this,S,g,"f"),et(this,D,f,"f"),this._id=y.ID_GEN++,this._statusId=r,this._statusName=s,this._alignment=b,this._priority=h,this._accessibilityInformation=_}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var g;return(g=this._command)===null||g===void 0?void 0:g.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(g){this._text=g,this.update()}set tooltip(g){this._tooltip=g,this.update()}set color(g){this._color=g,this.update()}set backgroundColor(g){g&&!y.ALLOWED_BACKGROUND_COLORS.has(g.id)&&(g=void 0),this._backgroundColor=g,this.update()}set command(g){var f;((f=this._command)===null||f===void 0?void 0:f.fromApi)!==g&&(this._internalCommandRegistration.clear(),typeof g=="string"?this._command={fromApi:g,internal:xe(this,D,"f").toInternal({title:"",command:g},this._internalCommandRegistration)}:g?this._command={fromApi:g,internal:xe(this,D,"f").toInternal(g,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(g){this._accessibilityInformation=g,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,xe(this,S,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var g;this._timeoutHandle=void 0;let f=this._color;this._backgroundColor&&(f=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),xe(this,S,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(g=this._command)===null||g===void 0?void 0:g.internal,f,this._backgroundColor,this._alignment===E.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y,S=new WeakMap,D=new WeakMap,y.ID_GEN=0,y.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new E.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(g){this._messages=[],this._item=g.createStatusBarEntry("status.extensionMessage",(0,P.localize)(0,null),E.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(g){const f={message:g};return this._messages.unshift(f),this._update(),new E.Disposable(()=>{const r=this._messages.indexOf(f);r>=0&&(this._messages.splice(r,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class T{constructor(g,f){this._proxy=g.getProxy(k.MainContext.MainThreadStatusBar),this._commands=f,this._statusMessage=new n(this)}createStatusBarEntry(g,f,r,s,b){return new y(this._proxy,this._commands,g,f,r,s,b)}setStatusBarMessage(g,f){const r=this._statusMessage.setMessage(g);let s;return typeof f=="number"?s=setTimeout(()=>r.dispose(),f):typeof f!="undefined"&&f.then(()=>r.dispose(),()=>r.dispose()),new E.Disposable(()=>{r.dispose(),clearTimeout(s)})}}e.ExtHostStatusBar=T}),define(ve[76],_e([0,1,5,3,4]),function(ie,e,E,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(D){this._onDidChangeStorage=new k.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(E.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,y){this._proxy.$registerExtensionStorageKeysToSync(D,y)}getValue(D,y,n){return this._proxy.$getValue(D,y).then(T=>T||n)}setValue(D,y,n){return this._proxy.$setValue(D,y,n)}$acceptValue(D,y,n){this._onDidChangeStorage.fire({shared:D,key:y,value:n})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,P.createDecorator)("IExtHostStorage")}),define(ve[77],_e([0,1,4,27,19,75,2]),function(ie,e,E,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,E.createDecorator)("IExtensionStoragePaths");let D=class{constructor(n,T,C){var g;this._logService=T,this._extHostFileSystem=C,this._workspace=(g=n.workspace)!==null&&g!==void 0?g:void 0,this._environment=n.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(f=>this._value=f)}async _getOrCreateWorkspaceStoragePath(){var n;if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,C=S.URI.joinPath(this._environment.workspaceStorageHome,T);try{return await this._extHostFileSystem.value.stat(C),this._logService.trace("[ExtHostStorage] storage dir already exists",C),C}catch(g){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",C),await this._extHostFileSystem.value.createDirectory(C),await this._extHostFileSystem.value.writeFile(S.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(n=S.URI.revive(this._workspace.configuration))===null||n===void 0?void 0:n.toString(),name:this._workspace.name},void 0,2))),C}catch(g){this._logService.error("[ExtHostStorage]",g);return}}workspaceValue(n){if(this._value)return S.URI.joinPath(this._value,n.identifier.value)}globalValue(n){return S.URI.joinPath(this._environment.globalStorageHome,n.identifier.value.toLowerCase())}};D=je([Ke(0,k.IExtHostInitDataService),Ke(1,P.ILogService),Ke(2,A.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(ve[40],_e([0,1,3,5,4,2,15,6,7,134,10,171,20,29,154]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,P.createDecorator)("IExtHostTerminalService");class s{constructor(t,i,d,a){this._proxy=t,this._id=i,this._creationOptions=d,this._name=a,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(o=>this._pidPromiseComplete=o);const l=this;this.value={get name(){return l._name||""},get processId(){return l._pidPromise},get creationOptions(){return l._creationOptions},get exitStatus(){return l._exitStatus},sendText(o,w=!0){l._checkDisposed(),l._proxy.$sendText(l._id,o,w)},show(o){l._checkDisposed(),l._proxy.$show(l._id,o)},hide(){l._checkDisposed(),l._proxy.$hide(l._id)},dispose(){l._disposed||(l._disposed=!0,l._proxy.$dispose(l._id))},get dimensions(){if(!(l._cols===void 0||l._rows===void 0))return{columns:l._cols,rows:l._rows}}}}async create(t,i,d,a,l,o,w,I,p,m,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:i,cwd:d,env:a,icon:l,initialText:o,waitOnExit:w,strictEnv:I,hideFromUser:p,isFeatureTerminal:m,isExtensionOwnedTerminal:R})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,i){return t===this._cols&&i===this._rows||t===0||i===0?!1:(this._cols=t,this._rows=i,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=s;class b{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new E.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new E.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new E.Emitter,this._onProcessTitleChanged=new E.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new E.Emitter,this._onProcessShellTypeChanged=new E.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,i){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:i})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose&&this._pty.onDidClose((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i&&{cols:i.columns,rows:i.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=b;let h=1,_=class extends D.Disposable{constructor(t,i){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new E.Emitter,this._onDidOpenTerminal=new E.Emitter,this._onDidChangeActiveTerminal=new E.Emitter,this._onDidChangeTerminalDimensions=new E.Emitter,this._proxy=i.getProxy(k.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new E.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[d,a]of this._terminalProcesses)a.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const i=new s(this._proxy,(0,f.generateUuid)(),t,t.name),d=new b(t.pty);return i.createExtensionTerminal().then(a=>{const l=this._setupExtHostProcessListeners(a,d);this._terminalProcessDisposables[a]=l}),this._terminals.push(i),i.value}attachPtyToTerminal(t,i){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const a=new b(i),l=this._setupExtHostProcessListeners(t,a);this._terminalProcessDisposables[t]=l}async $acceptActiveTerminalChanged(t){const i=this._activeTerminal;if(t===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const d=this._getTerminalById(t);d&&(this._activeTerminal=d,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,i){const d=this._getTerminalById(t);d&&this._onDidWriteTerminalData.fire({terminal:d.value,data:i})}async $acceptTerminalDimensions(t,i,d){const a=this._getTerminalById(t);a&&a.setDimensions(i,d)&&this._onDidChangeTerminalDimensions.fire({terminal:a.value,dimensions:a.value.dimensions})}async $acceptTerminalMaximumDimensions(t,i,d){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.resize(i,d)}async $acceptTerminalTitleChange(t,i){const d=this._getTerminalById(t);d&&(d.name=i)}async $acceptTerminalClosed(t,i){const d=this._getTerminalObjectIndexById(this._terminals,t);if(d!==null){const a=this._terminals.splice(d,1)[0];a.setExitCode(i),this._onDidCloseTerminal.fire(a.value)}}$acceptTerminalOpened(t,i,d,a){if(i){const w=this._getTerminalObjectIndexById(this._terminals,i);if(w!==null){this._terminals[w]._id=t,this._onDidOpenTerminal.fire(this.terminals[w]),this._terminals[w].isOpen=!0;return}}const l={name:a.name,shellPath:a.executable,shellArgs:a.args,cwd:typeof a.cwd=="string"?a.cwd:A.URI.revive(a.cwd),env:a.env,hideFromUser:a.hideFromUser},o=new s(this._proxy,t,l,d);this._terminals.push(o),this._onDidOpenTerminal.fire(o.value),o.isOpen=!0}async $acceptTerminalProcessId(t,i){const d=this._getTerminalById(t);d&&d._setProcessId(i)}async $startExtensionTerminal(t,i){const d=this._getTerminalById(t);if(!d)return{message:(0,n.localize)(0,null,t)};d.isOpen||await new Promise(l=>{const o=this.onDidOpenTerminal(async w=>{w===d.value&&(o.dispose(),l())})});const a=this._terminalProcesses.get(t);a?a.startSendingEvents(i):this._extensionTerminalAwaitingStart[t]={initialDimensions:i}}_setupExtHostProcessListeners(t,i){const d=new D.DisposableStore;d.add(i.onProcessReady(l=>this._proxy.$sendProcessReady(t,l.pid,l.cwd))),d.add(i.onProcessTitleChanged(l=>this._proxy.$sendProcessTitle(t,l))),this._bufferer.startBuffering(t,i.onProcessData),d.add(i.onProcessExit(l=>this._onProcessExit(t,l))),i.onProcessOverrideDimensions&&d.add(i.onProcessOverrideDimensions(l=>this._proxy.$sendOverrideDimensions(t,l))),this._terminalProcesses.set(t,i);const a=this._extensionTerminalAwaitingStart[t];return a&&i instanceof b&&(i.startSendingEvents(a.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),d}$acceptProcessAckDataEvent(t,i){var d;(d=this._terminalProcesses.get(t))===null||d===void 0||d.acknowledgeDataEvent(i)}$acceptProcessInput(t,i){var d;(d=this._terminalProcesses.get(t))===null||d===void 0||d.input(i)}$acceptProcessResize(t,i,d){var a;try{(a=this._terminalProcesses.get(t))===null||a===void 0||a.resize(i,d)}catch(l){if(l.code!=="EPIPE"&&l.code!=="ERR_IPC_CHANNEL_CLOSED")throw l}}$acceptProcessShutdown(t,i){var d;(d=this._terminalProcesses.get(t))===null||d===void 0||d.shutdown(i)}$acceptProcessRequestInitialCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getInitialCwd().then(d=>this._proxy.$sendProcessInitialCwd(t,d))}$acceptProcessRequestCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getCwd().then(d=>this._proxy.$sendProcessCwd(t,d))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,i){const d=this._getTerminalById(t);if(!d)return[];this._terminalLinkCache.delete(t);const a=this._terminalLinkCancellationSource.get(t);a&&a.dispose(!0);const l=new g.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,l);const o=[],w={terminal:d.value,line:i},I=[];for(const R of this._linkProviders)I.push(new Promise(async F=>{l.token.onCancellationRequested(()=>F({provider:R,links:[]}));const x=await R.provideTerminalLinks(w,l.token)||[];l.token.isCancellationRequested||F({provider:R,links:x})}));const p=await Promise.all(I);if(l.token.isCancellationRequested)return[];const m=new Map;for(const R of p)R&&R.links.length>0&&o.push(...R.links.map(F=>{const x={id:h++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return m.set(x.id,{provider:R.provider,link:F}),x}));return this._terminalLinkCache.set(t,m),o}$activateLink(t,i){var d;const a=(d=this._terminalLinkCache.get(t))===null||d===void 0?void 0:d.get(i);!a||a.provider.handleTerminalLink(a.link)}_onProcessExit(t,i){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const d=this._terminalProcessDisposables[t];d&&(d.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,i)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,i){const d=this._getTerminalObjectIndexById(t,i);return d!==null?t[d]:null}_getTerminalObjectIndexById(t,i){let d=null;return t.some((a,l)=>a._id===i?(d=l,!0):!1),d}getEnvironmentVariableCollection(t){let i=this._environmentVariableCollections.get(t.identifier.value);return i||(i=new v,this._setEnvironmentVariableCollection(t.identifier.value,i)),i}_syncEnvironmentVariableCollection(t,i){const d=(0,C.serializeEnvironmentVariableCollection)(i.map);this._proxy.$setEnvironmentVariableCollection(t,i.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(t){t.forEach(i=>{const d=i[0],a=new v(i[1]);this._setEnvironmentVariableCollection(d,a)})}_setEnvironmentVariableCollection(t,i){this._environmentVariableCollections.set(t,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,i)})}};_=je([Ke(1,S.IExtHostRpcService)],_),e.BaseExtHostTerminalService=_;class v{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new E.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Replace})}append(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,i){const d=this.map.get(t);(!d||d.value!==i.value||d.type!==i.type)&&(this.map.set(t,i),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,i){this.map.forEach((d,a)=>t.call(i,a,d,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=v;let c=class extends _{constructor(t){super(!1,t)}createTerminal(t,i,d){throw new T.NotSupportedError}createTerminalFromOptions(t){throw new T.NotSupportedError}getDefaultShell(t,i){throw new T.NotSupportedError}getDefaultShellArgs(t,i){throw new T.NotSupportedError}$getAvailableProfiles(t){throw new T.NotSupportedError}async $getDefaultShellAndArgs(t){throw new T.NotSupportedError}$acceptWorkspacePermissionsChanged(t){throw new T.NotSupportedError}};c=je([Ke(0,S.IExtHostRpcService)],c),e.WorkerExtHostTerminalService=c}),define(ve[205],_e([0,1,3,11,5,96,9,7]),function(ie,e,E,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(T,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new E.Emitter,this._onDidChangeTextEditorOptions=new E.Emitter,this._onDidChangeTextEditorVisibleRanges=new E.Emitter,this._onDidChangeTextEditorViewColumn=new E.Emitter,this._onDidChangeActiveTextEditor=new E.Emitter,this._onDidChangeVisibleTextEditors=new E.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=T.getProxy(P.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(g=>this._onDidChangeVisibleTextEditors.fire(g)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(g=>this._onDidChangeActiveTextEditor.fire(g))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(T){const C=this._extHostDocumentsAndEditors.allEditors();return T?C:C.map(g=>g.value)}async showTextDocument(T,C,g){let f;typeof C=="number"?f={position:S.ViewColumn.from(C),preserveFocus:g}:typeof C=="object"?f={position:S.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?S.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:f={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(T.uri,f),s=r&&this._extHostDocumentsAndEditors.getEditor(r);if(s)return s.value;throw r?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T){return new A.TextEditorDecorationType(this._proxy,T).value}$acceptEditorPropertiesChanged(T,C){const g=this._extHostDocumentsAndEditors.getEditor(T);if(!g)throw new Error("unknown text editor");if(C.options&&g._acceptOptions(C.options),C.selections){const f=C.selections.selections.map(S.Selection.to);g._acceptSelections(f)}if(C.visibleRanges){const f=k.coalesce(C.visibleRanges.map(S.Range.to));g._acceptVisibleRanges(f)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:g.value,options:Object.assign(Object.assign({},C.options),{lineNumbers:S.TextEditorLineNumbersStyle.to(C.options.lineNumbers)})}),C.selections){const f=D.TextEditorSelectionChangeKind.fromValue(C.selections.source),r=C.selections.selections.map(S.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:g.value,selections:r,kind:f})}if(C.visibleRanges){const f=k.coalesce(C.visibleRanges.map(S.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:g.value,visibleRanges:f})}}$acceptEditorPositionData(T){for(const C in T){const g=this._extHostDocumentsAndEditors.getEditor(C);if(!g)throw new Error("Unknown text editor");const f=S.ViewColumn.to(T[C]);g.value.viewColumn!==f&&(g._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:g.value,viewColumn:f}))}}getDiffInformation(T){return Promise.resolve(this._proxy.$getDiffInformation(T))}}e.ExtHostEditors=y});var cn=this&&this.__rest||function(ie,e){var E={};for(var k in ie)Object.prototype.hasOwnProperty.call(ie,k)&&e.indexOf(k)<0&&(E[k]=ie[k]);if(ie!=null&&typeof Object.getOwnPropertySymbols=="function")for(var P=0,k=Object.getOwnPropertySymbols(ie);P<k.length;P++)e.indexOf(k[P])<0&&Object.prototype.propertyIsEnumerable.call(ie,k[P])&&(E[k[P]]=ie[k[P]]);return E};define(ve[206],_e([0,1,2,4,5,6,7]),function(ie,e,E,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,k.createDecorator)("IExtHostTimeline");class D{constructor(T,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=T.getProxy(P.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:g=>{var f,r;if(g&&g.$mid===11){const s=g.uri===void 0?void 0:E.URI.revive(g.uri);return(r=(f=this._itemsBySourceAndUriMap.get(g.source))===null||f===void 0?void 0:f.get(y(s)))===null||r===void 0?void 0:r.get(g.handle)}return g}})}async $getTimeline(T,C,g,f,r){const s=this._providers.get(T);return s==null?void 0:s.provideTimeline(E.URI.revive(C),g,f,r)}registerTimelineProvider(T,C,g,f){const r=new A.DisposableStore,s=this.convertTimelineItem(C.id,f,r).bind(this);let b;C.onDidChange&&(b=C.onDidChange(_=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},_),{id:C.id})),this));const h=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},C),{scheme:T,onDidChange:void 0,async provideTimeline(_,v,c,u){var t;(u==null?void 0:u.resetCache)&&(r.clear(),(t=h.get(C.id))===null||t===void 0||t.clear());const i=await C.provideTimeline(_,v,c);if(i!=null){const d=s(_,u);return Object.assign(Object.assign({},i),{source:C.id,items:i.items.map(d)})}},dispose(){var _;for(const v of h.values())(_=v.get(C.id))===null||_===void 0||_.clear();b==null||b.dispose(),r.dispose()}}))}convertTimelineItem(T,C,g){return(f,r)=>{let s;if(r==null?void 0:r.cacheResults){let b=this._itemsBySourceAndUriMap.get(T);b===void 0&&(b=new Map,this._itemsBySourceAndUriMap.set(T,b));const h=y(f);s=b.get(h),s===void 0&&(s=new Map,b.set(h,s))}return b=>{var h,_;const{iconPath:v}=b,c=cn(b,["iconPath"]),u=`${T}|${(h=b.id)!==null&&h!==void 0?h:b.timestamp}`;s==null||s.set(u,b);let t,i,d;return b.iconPath&&(v instanceof S.ThemeIcon?d={id:v.id}:E.URI.isUri(v)?(t=v,i=v):{light:t,dark:i}=v),Object.assign(Object.assign({},c),{id:(_=c.id)!==null&&_!==void 0?_:void 0,handle:u,source:T,command:b.command?C.toInternal(b.command,g):void 0,icon:t,iconDark:i,themeIcon:d,accessibilityInformation:b.accessibilityInformation})}}}registerTimelineProviderCore(T){if(this._providers.get(T.id))throw new Error(`Timeline Provider ${T.id} already exists.`);return this._proxy.$registerTimelineProvider({id:T.id,label:T.label,scheme:T.scheme}),this._providers.set(T.id,T),(0,A.toDisposable)(()=>{var g;for(const f of this._itemsBySourceAndUriMap.values())(g=f.get(T.id))===null||g===void 0||g.clear();this._providers.delete(T.id),this._proxy.$unregisterTimelineProvider(T.id),T.dispose()})}}e.ExtHostTimeline=D;function y(n){return n==null?void 0:n.toString()}}),define(ve[207],_e([0,1,6,18,2,5]),function(ie,e,E,k,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class S{constructor(y){this._openers=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,n,T,C){if(this._openers.has(n))throw new Error(`Opener with id '${n}' already registered`);const g=C.schemes.find(f=>!S.supportedSchemes.has(f));if(g)throw new Error(`Scheme '${g}' is not supported. Only http and https are currently supported.`);return this._openers.set(n,T),this._proxy.$registerUriOpener(n,C.schemes,y,C.label),(0,E.toDisposable)(()=>{this._openers.delete(n),this._proxy.$unregisterUriOpener(n)})}async $canOpenUri(y,n,T){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener with id: ${y}`);const g=P.URI.revive(n);return C.canOpenExternalUri(g,T)}async $openUri(y,n,T){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener id: '${y}'`);return C.openExternalUri(P.URI.revive(n.resolvedUri),{sourceUri:P.URI.revive(n.sourceUri)},T)}}e.ExtHostUriOpeners=S,S.supportedSchemes=new Set([k.Schemas.http,k.Schemas.https])}),define(ve[208],_e([0,1,5,2,6,10,26]),function(ie,e,E,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(n){this.handles=new Set,this.handlers=new Map,this._proxy=n.getProxy(E.MainContext.MainThreadUrls)}registerUriHandler(n,T){if(this.handles.has(S.ExtensionIdentifier.toKey(n)))throw new Error(`Protocol handler already registered for extension ${n}`);const C=D.HandlePool++;return this.handles.add(S.ExtensionIdentifier.toKey(n)),this.handlers.set(C,T),this._proxy.$registerUriHandler(C,n),(0,P.toDisposable)(()=>{this.handles.delete(S.ExtensionIdentifier.toKey(n)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(n,T){const C=this.handlers.get(n);if(!C)return Promise.resolve(void 0);try{C.handleUri(k.URI.revive(T))}catch(g){(0,A.onUnexpectedError)(g)}return Promise.resolve(void 0)}async createAppUri(n){return k.URI.revive(await this._proxy.$createAppUri(n))}}e.ExtHostUrls=D,D.HandlePool=0});var et=this&&this.__classPrivateFieldSet||function(ie,e,E,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(ie,E):P?P.value=E:e.set(ie,E),E},xe=this&&this.__classPrivateFieldGet||function(ie,e,E,k){if(E==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?k:E==="a"?k.call(ie):k?k.value:e.get(ie)};define(ve[49],_e([0,1,23,3,2,143,164,70,5]),function(ie,e,E,k,P,A,S,D,y){"use strict";var n,T,C,g,f,r,s,b,h,_,v,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.serializeMessage=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class u{constructor(p,m,R,F,x,ae,z){n.set(this,void 0),T.set(this,void 0),C.set(this,void 0),g.set(this,void 0),f.set(this,void 0),r.set(this,void 0),s.set(this,""),b.set(this,void 0),h.set(this,!1),_.set(this,!1),v.set(this,!1),this._onMessageEmitter=new k.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new k.Emitter),this._onDidDispose=xe(this,c,"f").event,et(this,n,p,"f"),et(this,T,m,"f"),et(this,b,R,"f"),et(this,g,F,"f"),et(this,f,x,"f"),et(this,r,ae,"f"),et(this,v,t(ae),"f"),et(this,C,z,"f")}dispose(){et(this,h,!0,"f"),xe(this,c,"f").fire(),xe(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return et(this,_,!0,"f"),(0,D.asWebviewUri)(xe(this,g,"f"),xe(this,n,"f"),p)}get cspSource(){return xe(this,g,"f").webviewCspSource.replace("{{uuid}}",xe(this,n,"f"))}get html(){return this.assertNotDisposed(),xe(this,s,"f")}set html(p){this.assertNotDisposed(),xe(this,s,"f")!==p&&(et(this,s,p,"f"),!xe(this,_,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(et(this,_,!0,"f"),xe(this,C,"f").report("Webview vscode-resource: uris",xe(this,r,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),xe(this,T,"f").$setHtml(xe(this,n,"f"),p))}get options(){return this.assertNotDisposed(),xe(this,b,"f")}set options(p){this.assertNotDisposed(),xe(this,T,"f").$setOptions(xe(this,n,"f"),l(xe(this,r,"f"),xe(this,f,"f"),p)),et(this,b,p,"f")}async postMessage(p){if(xe(this,h,"f"))return!1;const m=i(p,{serializeBuffersForPostMessage:xe(this,v,"f")});return xe(this,T,"f").$postMessage(xe(this,n,"f"),m.message,...m.buffers)}assertNotDisposed(){if(xe(this,h,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=u,n=new WeakMap,T=new WeakMap,C=new WeakMap,g=new WeakMap,f=new WeakMap,r=new WeakMap,s=new WeakMap,b=new WeakMap,h=new WeakMap,_=new WeakMap,v=new WeakMap,c=new WeakMap;function t(I){if(!I.enableProposedApi)return!1;try{const p=(0,A.normalizeVersion)((0,A.parseVersion)(I.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=56}catch(p){return!1}}e.shouldSerializeBuffersForPostMessage=t;function i(I,p){if(p.serializeBuffersForPostMessage){const m=[],R=(x,ae)=>{if(ae&&ae instanceof ArrayBuffer){let z=m.findIndex(B=>B.original===ae);if(z===-1){const B=new Uint8Array(ae),G=E.VSBuffer.wrap(B);z=m.length,m.push({original:ae,vsBuffer:G})}return{$$vscode_array_buffer_reference$$:!0,index:z}}return ae};return{message:JSON.stringify(I,R),buffers:m.map(x=>x.vsBuffer)}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeMessage=i;class d{constructor(p,m,R,F,x){this.initData=m,this.workspace=R,this._logService=F,this._deprecationService=x,this._webviews=new Map,this._webviewProxy=p.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(p,m,...R){const F=this.getWebview(p);if(F){const{message:x}=(0,S.deserializeWebviewMessage)(m,R);F._onMessageEmitter.fire(x)}}$onMissingCsp(p,m){this._logService.warn(`${m} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,m,R){const F=new u(p,this._webviewProxy,o(m),this.initData,this.workspace,R,this._deprecationService);return this._webviews.set(p,F),F._onDidDispose(()=>{this._webviews.delete(p)}),F}deleteWebview(p){this._webviews.delete(p)}getWebview(p){return this._webviews.get(p)}}e.ExtHostWebviews=d;function a(I){return{id:I.identifier,location:I.extensionLocation}}e.toExtensionData=a;function l(I,p,m){return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,portMapping:m.portMapping,localResourceRoots:m.localResourceRoots||w(I,p)}}e.serializeWebviewOptions=l;function o(I){var p;return{enableCommandUris:I.enableCommandUris,enableScripts:I.enableScripts,portMapping:I.portMapping,localResourceRoots:(p=I.localResourceRoots)===null||p===void 0?void 0:p.map(m=>P.URI.from(m))}}e.reviveOptions=o;function w(I,p){return[...((p==null?void 0:p.getWorkspaceFolders())||[]).map(m=>m.uri),I.extensionLocation]}}),define(ve[209],_e([0,1,20,56,6,18,25,2,9,49,67,5,7]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new T.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=c(this.document.uri)+this._backupCounter++;return(0,S.joinPath)(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class r{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,d){const a=this.key(t,i.uri);if(this._documents.has(a))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const l=new f(i,d);return this._documents.set(a,l),l}delete(t,i){const d=this.key(t,i.uri);this._documents.delete(d)}key(t,i){return`${t}@@@${i}`}}var s;(function(u){u[u.Text=0]="Text",u[u.Custom=1]="Custom"})(s||(s={}));class b{constructor(){this._providers=new Map}addTextProvider(t,i,d){return this.add(0,t,i,d)}addCustomProvider(t,i,d){return this.add(1,t,i,d)}get(t){return this._providers.get(t)}add(t,i,d,a){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:d,provider:a}),new g.Disposable(()=>this._providers.delete(i))}}class h{constructor(t,i,d,a,l){this._extHostDocuments=i,this._extensionStoragePaths=d,this._extHostWebview=a,this._extHostWebviewPanels=l,this._editorProviders=new b,this._documents=new r,this._proxy=t.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,d,a){const l=new P.DisposableStore;return _(d)?(l.add(this._editorProviders.addTextProvider(i,t,d)),this._proxy.$registerTextEditorProvider((0,n.toExtensionData)(t),i,a.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,n.shouldSerializeBuffersForPostMessage)(t))):(l.add(this._editorProviders.addCustomProvider(i,t,d)),this.supportEditing(d)&&l.add(d.onDidChangeCustomDocument(o=>{const w=this.getCustomDocumentEntry(i,o.document.uri);if(v(o)){const I=w.addEdit(o);this._proxy.$onDidEdit(o.document.uri,i,I,o.label)}else this._proxy.$onContentChange(o.document.uri,i)})),this._proxy.$registerCustomEditorProvider((0,n.toExtensionData)(t),i,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,n.shouldSerializeBuffersForPostMessage)(t))),g.Disposable.from(l,new g.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,d,a,l){var o;const w=this._editorProviders.get(i);if(!w)throw new Error(`No provider found for '${i}'`);if(w.type!==1)throw new Error(`Invalid provide type for '${i}'`);const I=D.URI.revive(t),p=await w.provider.openCustomDocument(I,{backupId:d,untitledDocumentData:a==null?void 0:a.buffer},l);let m;return this.supportEditing(w.provider)&&this._extensionStoragePaths&&(m=(o=this._extensionStoragePaths.workspaceValue(w.extension))!==null&&o!==void 0?o:this._extensionStoragePaths.globalValue(w.extension)),this._documents.add(i,p,m),{editable:this.supportEditing(w.provider)}}async $disposeCustomDocument(t,i){const d=this._editorProviders.get(i);if(!d)throw new Error(`No provider found for '${i}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${i}'`);const a=D.URI.revive(t),{document:l}=this.getCustomDocumentEntry(i,a);this._documents.delete(i,l),l.dispose()}async $resolveWebviewEditor(t,i,d,a,l,o){const w=this._editorProviders.get(d);if(!w)throw new Error(`No provider found for '${d}'`);const I=y.ViewColumn.to(l),p=this._extHostWebview.createNewWebview(i,a.webviewOptions,w.extension),m=this._extHostWebviewPanels.createNewWebviewPanel(i,d,a.title,I,a.panelOptions,p),R=D.URI.revive(t);switch(w.type){case 1:{const{document:F}=this.getCustomDocumentEntry(d,R);return w.provider.resolveCustomEditor(F,m,o)}case 0:{const F=this._extHostDocuments.getDocument(R);return w.provider.resolveCustomTextEditor(F,m,o)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,d){this.getCustomDocumentEntry(i,t).disposeEdits(d)}async $onMoveCustomEditor(t,i,d){const a=this._editorProviders.get(d);if(!a)throw new Error(`No provider found for '${d}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const l=this._extHostWebviewPanels.getWebviewPanel(t);if(!l)throw new Error("No webview found");const o=D.URI.revive(i),w=this._extHostDocuments.getDocument(o);await a.provider.moveCustomTextEditor(w,l,E.CancellationToken.None)}async $undo(t,i,d,a){return this.getCustomDocumentEntry(i,t).undo(d,a)}async $redo(t,i,d,a){return this.getCustomDocumentEntry(i,t).redo(d,a)}async $revert(t,i,d){const a=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(a.document,d),a.disposeBackup()}async $onSave(t,i,d){const a=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(a.document,d),a.disposeBackup()}async $onSaveAs(t,i,d,a){const l=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(l.document,D.URI.revive(d),a)}async $backup(t,i,d){const a=this.getCustomDocumentEntry(i,t),o=await this.getCustomEditorProvider(i).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},d);return a.updateBackup(o),o.id}getCustomDocumentEntry(t,i){const d=this._documents.get(t,D.URI.revive(i));if(!d)throw new Error("No custom document found");return d}getCustomEditorProvider(t){const i=this._editorProviders.get(t),d=i==null?void 0:i.provider;if(!d||!this.supportEditing(d))throw new Error("Custom document is not editable");return d}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=h;function _(u){return typeof u.resolveCustomTextEditor=="function"}function v(u){return typeof u.undo=="function"&&typeof u.redo=="function"}function c(u){const t=u.scheme===A.Schemas.file||u.scheme===A.Schemas.untitled?u.fsPath:u.toString();return(0,k.hash)(t)+""}});var et=this&&this.__classPrivateFieldSet||function(ie,e,E,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(ie,E):P?P.value=E:e.set(ie,E),E},xe=this&&this.__classPrivateFieldGet||function(ie,e,E,k){if(E==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?k:E==="a"?k.call(ie):k?k.value:e.get(ie)};define(ve[210],_e([0,1,3,6,2,29,9,49,5,7]),function(ie,e,E,k,P,A,S,D,y,n){"use strict";var T,C,g,f,r,s,b,h,_,v,c,u,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends k.Disposable{constructor(o,w,I,p,m,R,F){super();T.set(this,void 0),C.set(this,void 0),g.set(this,void 0),f.set(this,void 0),r.set(this,void 0),s.set(this,void 0),b.set(this,void 0),h.set(this,void 0),_.set(this,!0),v.set(this,!0),c.set(this,!1),u.set(this,this._register(new E.Emitter)),this.onDidDispose=xe(this,u,"f").event,t.set(this,this._register(new E.Emitter)),this.onDidChangeViewState=xe(this,t,"f").event,et(this,T,o,"f"),et(this,C,w,"f"),et(this,g,I,"f"),et(this,r,R,"f"),et(this,h,m,"f"),et(this,s,p,"f"),et(this,f,F,"f")}dispose(){xe(this,c,"f")||(et(this,c,!0,"f"),xe(this,u,"f").fire(),xe(this,C,"f").$disposeWebview(xe(this,T,"f")),xe(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),xe(this,f,"f")}get viewType(){return this.assertNotDisposed(),xe(this,g,"f")}get title(){return this.assertNotDisposed(),xe(this,s,"f")}set title(o){this.assertNotDisposed(),xe(this,s,"f")!==o&&(et(this,s,o,"f"),xe(this,C,"f").$setTitle(xe(this,T,"f"),o))}get iconPath(){return this.assertNotDisposed(),xe(this,b,"f")}set iconPath(o){this.assertNotDisposed(),xe(this,b,"f")!==o&&(et(this,b,o,"f"),xe(this,C,"f").$setIconPath(xe(this,T,"f"),P.URI.isUri(o)?{light:o,dark:o}:o))}get options(){return xe(this,r,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof xe(this,h,"f")=="number"&&xe(this,h,"f")<0))return xe(this,h,"f")}get active(){return this.assertNotDisposed(),xe(this,v,"f")}get visible(){return this.assertNotDisposed(),xe(this,_,"f")}_updateViewState(o){xe(this,c,"f")||(this.active!==o.active||this.visible!==o.visible||this.viewColumn!==o.viewColumn)&&(et(this,v,o.active,"f"),et(this,_,o.visible,"f"),et(this,h,o.viewColumn,"f"),xe(this,t,"f").fire({webviewPanel:this}))}reveal(o,w){this.assertNotDisposed(),xe(this,C,"f").$reveal(xe(this,T,"f"),{viewColumn:o?S.ViewColumn.from(o):void 0,preserveFocus:!!w})}assertNotDisposed(){if(xe(this,c,"f"))throw new Error("Webview is disposed")}}T=new WeakMap,C=new WeakMap,g=new WeakMap,f=new WeakMap,r=new WeakMap,s=new WeakMap,b=new WeakMap,h=new WeakMap,_=new WeakMap,v=new WeakMap,c=new WeakMap,u=new WeakMap,t=new WeakMap;class d{constructor(o,w,I){this.webviews=w,this.workspace=I,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=o.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(o,w,I,p,m={}){const R=typeof p=="object"?p.viewColumn:p,F={viewColumn:S.ViewColumn.from(R),preserveFocus:typeof p=="object"&&!!p.preserveFocus},x=(0,D.shouldSerializeBuffersForPostMessage)(o),ae=d.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(o),ae,w,{title:I,panelOptions:a(m),webviewOptions:(0,D.serializeWebviewOptions)(o,this.workspace,m),serializeBuffersForPostMessage:x},F);const z=this.webviews.createNewWebview(ae,m,o);return this.createNewWebviewPanel(ae,w,I,R,m,z)}$onDidChangeWebviewPanelViewStates(o){const w=Object.keys(o);w.sort((I,p)=>{const m=o[I],R=o[p];return m.active?1:R.active?-1:+m.visible-+R.visible});for(const I of w){const p=this.getWebviewPanel(I);if(!!p){const m=o[I];p._updateViewState({active:m.active,visible:m.visible,viewColumn:S.ViewColumn.to(m.position)})}}}async $onDidDisposeWebviewPanel(o){const w=this.getWebviewPanel(o);w==null||w.dispose(),this._webviewPanels.delete(o),this.webviews.deleteWebview(o)}registerWebviewPanelSerializer(o,w,I){if(this._serializers.has(w))throw new Error(`Serializer for '${w}' already registered`);return this._serializers.set(w,{serializer:I,extension:o}),this._proxy.$registerSerializer(w,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(o)}),new n.Disposable(()=>{this._serializers.delete(w),this._proxy.$unregisterSerializer(w)})}async $deserializeWebviewPanel(o,w,I,p){const m=this._serializers.get(w);if(!m)throw new Error(`No serializer found for '${w}'`);const{serializer:R,extension:F}=m,x=this.webviews.createNewWebview(o,I.webviewOptions,F),ae=this.createNewWebviewPanel(o,w,I.title,p,I.panelOptions,x);await R.deserializeWebviewPanel(ae,I.state)}createNewWebviewPanel(o,w,I,p,m,R){const F=new i(o,this._proxy,w,I,p,m,R);return this._webviewPanels.set(o,F),F}getWebviewPanel(o){return this._webviewPanels.get(o)}}e.ExtHostWebviewPanels=d;function a(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var et=this&&this.__classPrivateFieldSet||function(ie,e,E,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(ie,E):P?P.value=E:e.set(ie,E),E},xe=this&&this.__classPrivateFieldGet||function(ie,e,E,k){if(E==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?k:E==="a"?k.call(ie):k?k.value:e.get(ie)};define(ve[211],_e([0,1,3,6,49,5,7]),function(ie,e,E,k,P,A,S){"use strict";var D,y,n,T,C,g,f,r,s,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class h extends k.Disposable{constructor(c,u,t,i,d,a){super();D.set(this,void 0),y.set(this,void 0),n.set(this,void 0),T.set(this,void 0),C.set(this,!1),g.set(this,void 0),f.set(this,void 0),r.set(this,void 0),s.set(this,this._register(new E.Emitter)),this.onDidChangeVisibility=xe(this,s,"f").event,b.set(this,this._register(new E.Emitter)),this.onDidDispose=xe(this,b,"f").event,et(this,n,t,"f"),et(this,f,i,"f"),et(this,D,c,"f"),et(this,y,u,"f"),et(this,T,d,"f"),et(this,g,a,"f")}dispose(){xe(this,C,"f")||(et(this,C,!0,"f"),xe(this,b,"f").fire(),xe(this,T,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),xe(this,f,"f")}set title(c){this.assertNotDisposed(),xe(this,f,"f")!==c&&(et(this,f,c,"f"),xe(this,y,"f").$setWebviewViewTitle(xe(this,D,"f"),c))}get description(){return this.assertNotDisposed(),xe(this,r,"f")}set description(c){this.assertNotDisposed(),xe(this,r,"f")!==c&&(et(this,r,c,"f"),xe(this,y,"f").$setWebviewViewDescription(xe(this,D,"f"),c))}get visible(){return xe(this,g,"f")}get webview(){return xe(this,T,"f")}get viewType(){return xe(this,n,"f")}_setVisible(c){c===xe(this,g,"f")||xe(this,C,"f")||(et(this,g,c,"f"),xe(this,s,"f").fire())}show(c){this.assertNotDisposed(),xe(this,y,"f").$show(xe(this,D,"f"),!!c)}assertNotDisposed(){if(xe(this,C,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,y=new WeakMap,n=new WeakMap,T=new WeakMap,C=new WeakMap,g=new WeakMap,f=new WeakMap,r=new WeakMap,s=new WeakMap,b=new WeakMap;class _{constructor(c,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,u,t,i){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:t,extension:c}),this._proxy.$registerWebviewViewProvider((0,P.toExtensionData)(c),u,{retainContextWhenHidden:i==null?void 0:i.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new S.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(c,u,t,i,d){const a=this._viewProviders.get(u);if(!a)throw new Error(`No view provider found for '${u}'`);const{provider:l,extension:o}=a,w=this._extHostWebview.createNewWebview(c,{},o),I=new h(c,this._proxy,u,t,w,!0);this._webviewViews.set(c,I),await l.resolveWebviewView(I,{state:i},d)}async $onDidChangeWebviewViewVisibility(c,u){this.getWebviewView(c)._setVisible(u)}async $disposeWebviewView(c){const u=this.getWebviewView(c);this._webviewViews.delete(c),u.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const u=this._webviewViews.get(c);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=_}),define(ve[100],_e([0,1,3,5,2,18,8,4,15]),function(ie,e,E,k,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let n=class Pn{constructor(C){this._onDidChangeWindowState=new E.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Pn.InitialState,this._proxy=C.getProxy(k.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(g=>this.$onDidChangeWindowFocus(g))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:C}),this._onDidChangeWindowState.fire(this._state))}openUri(C,g){let f;if(typeof C=="string"){f=C;try{C=P.URI.parse(C)}catch(r){return Promise.reject(`Invalid uri - '${C}'`)}}return(0,S.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,f,g)}async asExternalUri(C,g){if((0,S.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([A.Schemas.http,A.Schemas.https]).has(C.scheme))return Promise.reject(`Invalid scheme '${C.scheme}'`);const f=await this._proxy.$asExternalUri(C,g);return P.URI.from(f)}};n.InitialState={focused:!0},n=je([Ke(0,y.IExtHostRpcService)],n),e.ExtHostWindow=n,e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(ve[212],_e([0,1,19,5,27,15]),function(ie,e,E,k,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let S=class extends E.AbstractLogger{constructor(y,n){super();this._proxy=y.getProxy(k.MainContext.MainThreadLog),this._logFile=n.logFile.toJSON(),this.setLevel(n.logLevel)}$setLevel(y){this.setLevel(y)}trace(y,...n){this.getLevel()<=E.LogLevel.Trace&&this._proxy.$log(this._logFile,E.LogLevel.Trace,Array.from(arguments))}debug(y,...n){this.getLevel()<=E.LogLevel.Debug&&this._proxy.$log(this._logFile,E.LogLevel.Debug,Array.from(arguments))}info(y,...n){this.getLevel()<=E.LogLevel.Info&&this._proxy.$log(this._logFile,E.LogLevel.Info,Array.from(arguments))}warn(y,...n){this.getLevel()<=E.LogLevel.Warning&&this._proxy.$log(this._logFile,E.LogLevel.Warning,Array.from(arguments))}error(y,...n){this.getLevel()<=E.LogLevel.Error&&this._proxy.$log(this._logFile,E.LogLevel.Error,Array.from(arguments))}critical(y,...n){this.getLevel()<=E.LogLevel.Critical&&this._proxy.$log(this._logFile,E.LogLevel.Critical,Array.from(arguments))}flush(){}};S=je([Ke(0,A.IExtHostRpcService),Ke(1,P.IExtHostInitDataService)],S),e.ExtHostLogService=S}),define(ve[213],_e([0,1,14,20,10,3,6,111,185,97,23]),function(ie,e,E,k,P,A,S,D,y,n,T){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function g(a,l){try{return JSON.stringify(a,l)}catch(o){return"null"}}function f(a,l){return JSON.stringify(a,l)}function r(a){return a?(l,o)=>o&&o.$mid===1?a.transformOutgoing(o):o:null}var s;(function(a){a[a.LocalSide=0]="LocalSide",a[a.OtherSide=1]="OtherSide"})(s=e.RequestInitiator||(e.RequestInitiator={}));var b;(function(a){a[a.Responsive=0]="Responsive",a[a.Unresponsive=1]="Unresponsive"})(b=e.ResponsiveState||(e.ResponsiveState={}));const h=()=>{},_=Symbol.for("rpcProtocol"),v=Symbol.for("rpcProxy");class c extends S.Disposable{constructor(l,o=null,w=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=l,this._logger=o,this._uriTransformer=w,this._uriReplacer=r(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let I=0,p=n.ProxyIdentifier.count;I<p;I++)this._locals[I]=null,this._proxies[I]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new E.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(I=>this._receiveOneMessage(I))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(l=>{this._pendingRPCReplies[l].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(l){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(l){this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(l){this._responsiveState!==l&&(this._responsiveState=l,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(l){return this._uriTransformer?(0,D.transformIncomingURIs)(l,this._uriTransformer):l}getProxy(l){const{nid:o,sid:w}=l;return this._proxies[o]||(this._proxies[o]=this._createProxy(o,w)),this._proxies[o]}_createProxy(l,o){let w={get:(I,p)=>(typeof p=="string"&&!I[p]&&p.charCodeAt(0)===36&&(I[p]=(...m)=>this._remoteCall(l,p,m)),p===v?o:I[p])};return new Proxy(Object.create(null),w)}set(l,o){return this._locals[l.nid]=o,o}assertRegistered(l){for(let o=0,w=l.length;o<w;o++){const I=l[o];if(!this._locals[I.nid])throw new Error(`Missing actor ${I.sid} (isMain: ${I.isMain})`)}}_receiveOneMessage(l){if(!this._isDisposed){const o=l.byteLength,w=u.read(l,0),I=w.readUInt8(),p=w.readUInt32();switch(I){case 1:case 2:{let{rpcId:m,method:R,args:F}=t.deserializeRequestJSONArgs(w);this._uriTransformer&&(F=(0,D.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(o,p,m,R,F,I===2);break}case 3:case 4:{let{rpcId:m,method:R,args:F}=t.deserializeRequestMixedArgs(w);this._uriTransformer&&(F=(0,D.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(o,p,m,R,F,I===4);break}case 5:{this._logger&&this._logger.logIncoming(o,p,0,"ack"),this._onDidReceiveAcknowledge(p);break}case 6:{this._receiveCancel(o,p);break}case 7:{this._receiveReply(o,p,void 0);break}case 9:{let m=t.deserializeReplyOKJSON(w);this._uriTransformer&&(m=(0,D.transformIncomingURIs)(m,this._uriTransformer)),this._receiveReply(o,p,m);break}case 8:{let m=t.deserializeReplyOKVSBuffer(w);this._receiveReply(o,p,m);break}case 10:{let m=t.deserializeReplyErrError(w);this._uriTransformer&&(m=(0,D.transformIncomingURIs)(m,this._uriTransformer)),this._receiveReplyErr(o,p,m);break}case 11:{this._receiveReplyErr(o,p,void 0);break}default:console.error("received unexpected message"),console.error(l)}}}_receiveRequest(l,o,w,I,p,m){this._logger&&this._logger.logIncoming(l,o,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(w)}.${I}(`,p);const R=String(o);let F,x;if(m){const z=new k.CancellationTokenSource;p.push(z.token),F=this._invokeHandler(w,I,p),x=()=>z.cancel()}else F=this._invokeHandler(w,I,p),x=h;this._cancelInvokedHandlers[R]=x;const ae=t.serializeAcknowledged(o);this._logger&&this._logger.logOutgoing(ae.byteLength,o,1,"ack"),this._protocol.send(ae),F.then(z=>{delete this._cancelInvokedHandlers[R];const B=t.serializeReplyOK(o,z,this._uriReplacer);this._logger&&this._logger.logOutgoing(B.byteLength,o,1,"reply:",z),this._protocol.send(B)},z=>{delete this._cancelInvokedHandlers[R];const B=t.serializeReplyErr(o,z);this._logger&&this._logger.logOutgoing(B.byteLength,o,1,"replyErr:",z),this._protocol.send(B)})}_receiveCancel(l,o){this._logger&&this._logger.logIncoming(l,o,1,"receiveCancel");const w=String(o);this._cancelInvokedHandlers[w]&&this._cancelInvokedHandlers[w]()}_receiveReply(l,o,w){this._logger&&this._logger.logIncoming(l,o,0,"receiveReply:",w);const I=String(o);if(!!this._pendingRPCReplies.hasOwnProperty(I)){const p=this._pendingRPCReplies[I];delete this._pendingRPCReplies[I],p.resolveOk(w)}}_receiveReplyErr(l,o,w){this._logger&&this._logger.logIncoming(l,o,0,"receiveReplyErr:",w);const I=String(o);if(!!this._pendingRPCReplies.hasOwnProperty(I)){const p=this._pendingRPCReplies[I];delete this._pendingRPCReplies[I];let m;w&&(w.$isError?(m=new Error,m.name=w.name,m.message=w.message,m.stack=w.stack):m=w),p.resolveErr(m)}}_invokeHandler(l,o,w){try{return Promise.resolve(this._doInvokeHandler(l,o,w))}catch(I){return Promise.reject(I)}}_doInvokeHandler(l,o,w){const I=this._locals[l];if(!I)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(l));let p=I[o];if(typeof p!="function")throw new Error("Unknown method "+o+" on actor "+(0,n.getStringIdentifierForProxy)(l));return p.apply(I,w)}_remoteCall(l,o,w){if(this._isDisposed)return Promise.reject(P.canceled());let I=null;if(w.length>0&&k.CancellationToken.isCancellationToken(w[w.length-1])&&(I=w.pop()),I&&I.isCancellationRequested)return Promise.reject(P.canceled());const p=t.serializeRequestArguments(w,this._uriReplacer),m=++this._lastMessageId,R=String(m),F=new y.LazyPromise;I&&I.onCancellationRequested(()=>{const ae=t.serializeCancel(m);this._logger&&this._logger.logOutgoing(ae.byteLength,m,0,"cancel"),this._protocol.send(t.serializeCancel(m))}),this._pendingRPCReplies[R]=F,this._onWillSendRequest(m);const x=t.serializeRequest(m,l,o,p,!!I);return this._logger&&this._logger.logOutgoing(x.byteLength,m,0,`request: ${(0,n.getStringIdentifierForProxy)(l)}.${o}(`,w),this._protocol.send(x),F}}e.RPCProtocol=c,C=_,c.UNRESPONSIVE_TIME=3*1e3;class u{constructor(l,o){this._buff=l,this._offset=o}static alloc(l,o,w){let I=new u(T.VSBuffer.alloc(w+1+4),0);return I.writeUInt8(l),I.writeUInt32(o),I}static read(l,o){return new u(l,o)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(l){this._buff.writeUInt8(l,this._offset),this._offset+=1}readUInt8(){const l=this._buff.readUInt8(this._offset);return this._offset+=1,l}writeUInt32(l){this._buff.writeUInt32BE(l,this._offset),this._offset+=4}readUInt32(){const l=this._buff.readUInt32BE(this._offset);return this._offset+=4,l}static sizeShortString(l){return 1+l.byteLength}writeShortString(l){this._buff.writeUInt8(l.byteLength,this._offset),this._offset+=1,this._buff.set(l,this._offset),this._offset+=l.byteLength}readShortString(){const l=this._buff.readUInt8(this._offset);this._offset+=1;const w=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,w}static sizeLongString(l){return 4+l.byteLength}writeLongString(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readLongString(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const w=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,w}writeBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}static sizeVSBuffer(l){return 4+l.byteLength}writeVSBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readVSBuffer(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const o=this._buff.slice(this._offset,this._offset+l);return this._offset+=l,o}static sizeMixedArray(l,o){let w=0;w+=1;for(let I=0,p=l.length;I<p;I++){const m=l[I],R=o[I];switch(w+=1,R){case 1:w+=this.sizeLongString(m);break;case 2:w+=this.sizeVSBuffer(m);break;case 3:break}}return w}writeMixedArray(l,o){this._buff.writeUInt8(l.length,this._offset),this._offset+=1;for(let w=0,I=l.length;w<I;w++){const p=l[w];switch(o[w]){case 1:this.writeUInt8(1),this.writeLongString(p);break;case 2:this.writeUInt8(2),this.writeVSBuffer(p);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const l=this._buff.readUInt8(this._offset);this._offset+=1;let o=new Array(l);for(let w=0;w<l;w++)switch(this.readUInt8()){case 1:o[w]=this.readLongString();break;case 2:o[w]=this.readVSBuffer();break;case 3:o[w]=void 0;break}return o}}class t{static _arrayContainsBufferOrUndefined(l){for(let o=0,w=l.length;o<w;o++)if(l[o]instanceof T.VSBuffer||typeof l[o]=="undefined")return!0;return!1}static serializeRequestArguments(l,o){if(this._arrayContainsBufferOrUndefined(l)){let w=[],I=[];for(let p=0,m=l.length;p<m;p++){const R=l[p];R instanceof T.VSBuffer?(w[p]=R,I[p]=2):typeof R=="undefined"?(w[p]=T.VSBuffer.alloc(0),I[p]=3):(w[p]=T.VSBuffer.fromString(f(R,o)),I[p]=1)}return{type:"mixed",args:w,argsType:I}}return{type:"simple",args:f(l,o)}}static serializeRequest(l,o,w,I,p){return I.type==="mixed"?this._requestMixedArgs(l,o,w,I.args,I.argsType,p):this._requestJSONArgs(l,o,w,I.args,p)}static _requestJSONArgs(l,o,w,I,p){const m=T.VSBuffer.fromString(w),R=T.VSBuffer.fromString(I);let F=0;F+=u.sizeUInt8(),F+=u.sizeShortString(m),F+=u.sizeLongString(R);let x=u.alloc(p?2:1,l,F);return x.writeUInt8(o),x.writeShortString(m),x.writeLongString(R),x.buffer}static deserializeRequestJSONArgs(l){const o=l.readUInt8(),w=l.readShortString(),I=l.readLongString();return{rpcId:o,method:w,args:JSON.parse(I)}}static _requestMixedArgs(l,o,w,I,p,m){const R=T.VSBuffer.fromString(w);let F=0;F+=u.sizeUInt8(),F+=u.sizeShortString(R),F+=u.sizeMixedArray(I,p);let x=u.alloc(m?4:3,l,F);return x.writeUInt8(o),x.writeShortString(R),x.writeMixedArray(I,p),x.buffer}static deserializeRequestMixedArgs(l){const o=l.readUInt8(),w=l.readShortString(),I=l.readMixedArray(),p=new Array(I.length);for(let m=0,R=I.length;m<R;m++){const F=I[m];typeof F=="string"?p[m]=JSON.parse(F):p[m]=F}return{rpcId:o,method:w,args:p}}static serializeAcknowledged(l){return u.alloc(5,l,0).buffer}static serializeCancel(l){return u.alloc(6,l,0).buffer}static serializeReplyOK(l,o,w){return typeof o=="undefined"?this._serializeReplyOKEmpty(l):o instanceof T.VSBuffer?this._serializeReplyOKVSBuffer(l,o):this._serializeReplyOKJSON(l,g(o,w))}static _serializeReplyOKEmpty(l){return u.alloc(7,l,0).buffer}static _serializeReplyOKVSBuffer(l,o){let w=0;w+=u.sizeVSBuffer(o);let I=u.alloc(8,l,w);return I.writeVSBuffer(o),I.buffer}static deserializeReplyOKVSBuffer(l){return l.readVSBuffer()}static _serializeReplyOKJSON(l,o){const w=T.VSBuffer.fromString(o);let I=0;I+=u.sizeLongString(w);let p=u.alloc(9,l,I);return p.writeLongString(w),p.buffer}static deserializeReplyOKJSON(l){const o=l.readLongString();return JSON.parse(o)}static serializeReplyErr(l,o){return o?this._serializeReplyErrEror(l,o):this._serializeReplyErrEmpty(l)}static _serializeReplyErrEror(l,o){const w=T.VSBuffer.fromString(g(P.transformErrorForSerialization(o),null));let I=0;I+=u.sizeLongString(w);let p=u.alloc(10,l,I);return p.writeLongString(w),p.buffer}static deserializeReplyErrError(l){const o=l.readLongString();return JSON.parse(o)}static _serializeReplyErrEmpty(l){return u.alloc(11,l,0).buffer}}var i;(function(a){a[a.RequestJSONArgs=1]="RequestJSONArgs",a[a.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",a[a.RequestMixedArgs=3]="RequestMixedArgs",a[a.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",a[a.Acknowledged=5]="Acknowledged",a[a.Cancel=6]="Cancel",a[a.ReplyOKEmpty=7]="ReplyOKEmpty",a[a.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",a[a.ReplyOKJSON=9]="ReplyOKJSON",a[a.ReplyErrError=10]="ReplyErrError",a[a.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var d;(function(a){a[a.String=1]="String",a[a.VSBuffer=2]="VSBuffer",a[a.Undefined=3]="Undefined"})(d||(d={}))}),define(ve[214],_e([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const E=function(A){const S=D=>{self.removeEventListener("message",S);const y=D.data;Object.defineProperties(self,{postMessage:{value(n,T){y.postMessage(n,T)}},onmessage:{get(){return y.onmessage},set(n){y.onmessage=n}}}),y.addEventListener("message",n=>{self.dispatchEvent(new MessageEvent("message",{data:n.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",S)}.toString();class k extends EventTarget{constructor(A,S,D){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${E})('${S}'))`,n=new Blob([y],{type:"application/javascript"}),T=URL.createObjectURL(n),C=new MessageChannel,g=T,f={type:"_newWorker",id:g,port:C.port2,url:T,options:D};A(f,[C.port2]),this.postMessage=C.port1.postMessage.bind(C.port1),this.terminate=()=>{const r={type:"_terminateWorker",id:g};C.port1.postMessage(r),URL.revokeObjectURL(T),C.port1.close(),C.port2.close()},Object.defineProperties(this,{onmessage:{get(){return C.port1.onmessage},set(r){C.port1.onmessage=r}},onmessageerror:{get(){return C.port1.onmessageerror},set(r){C.port1.onmessageerror=r}}}),C.port1.addEventListener("messageerror",r=>{const s=new MessageEvent("messageerror",{data:r.data});this.dispatchEvent(s)}),C.port1.addEventListener("message",r=>{const s=new MessageEvent("message",{data:r.data});this.dispatchEvent(s)}),C.port1.start()}}e.NestedWorker=k}),define(ve[215],_e([0,1,4]),function(ie,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,E.createDecorator)("remoteAgentService")}),define(ve[216],_e([0,1,18,12,21,2,4,215]),function(ie,e,E,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let y=class{constructor(T,C){this.localUserHome=T,this.remoteAgentService=C,this.resolveOS=(async()=>{const g=await this.remoteAgentService.getEnvironment();return(g==null?void 0:g.os)||P.OS})(),this.resolveUserHome=(async()=>{const g=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(g==null?void 0:g.userHome)||T})()}async userHome(T){return(T==null?void 0:T.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(T=>T===1?k.win32:k.posix)}async fileURI(T){let C="";if(await this.resolveOS===1&&(T=T.replace(/\\/g,"/")),T[0]==="/"&&T[1]==="/"){const f=T.indexOf("/",2);f===-1?(C=T.substring(2),T="/"):(C=T.substring(2,f),T=T.substring(f)||"/")}return A.URI.from({scheme:E.Schemas.file,authority:C,path:T,query:"",fragment:""})}};y=je([Ke(1,D.IRemoteAgentService)],y),e.AbstractPathService=y}),define(ve[41],_e([0,1,11,28,24,37,8,4,12,10]),function(ie,e,E,k,P,A,S,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const T="\u27EA ",C=" characters skipped \u27EB",g=(T.length+C.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var f;(function(M){M[M.file=0]="file",M[M.text=1]="text"})(f=e.SearchProviderType||(e.SearchProviderType={}));var r;(function(M){M[M.File=1]="File",M[M.Text=2]="Text"})(r=e.QueryType||(e.QueryType={}));function s(M){return!!M.preview}e.resultIsMatch=s;function b(M){return!!M.resource}e.isFileMatch=b;function h(M){return!!M.message}e.isProgressMessage=h;var _;(function(M){M[M.Normal=0]="Normal",M[M.NewSearchStarted=1]="NewSearchStarted"})(_=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(N){this.resource=N,this.results=[]}}e.FileMatch=v;class c{constructor(N,W,Q){this.ranges=W;const $=Array.isArray(W)?W:[W];if(Q&&Q.matchLines===1&&u($)){N=(0,S.getNLines)(N,Q.matchLines);let Z="",re=0,se=0;const ye=Math.floor(Q.charsPerLine/5),Pe=[];for(const $e of $){const Re=Math.max($e.startColumn-ye,0),ze=$e.startColumn+Q.charsPerLine;if(Re>se+ye+g){const U=T+(Re-se)+C;Z+=U+N.slice(Re,ze),re+=Re-(se+U.length)}else Z+=N.slice(se,ze);Pe.push(new i(0,$e.startColumn-re,$e.endColumn-re)),se=ze}this.preview={text:Z,matches:Array.isArray(this.ranges)?Pe:Pe[0]}}else{const Z=Array.isArray(W)?W[0].startLineNumber:W.startLineNumber;this.preview={text:N,matches:(0,E.mapArrayOrNot)(W,re=>new t(re.startLineNumber-Z,re.startColumn,re.endLineNumber-Z,re.endColumn))}}}}e.TextSearchMatch=c;function u(M){const N=M[0].startLineNumber;for(const W of M)if(W.startLineNumber!==N||W.endLineNumber!==N)return!1;return!0}class t{constructor(N,W,Q,$){this.startLineNumber=N,this.startColumn=W,this.endLineNumber=Q,this.endColumn=$}}e.SearchRange=t;class i extends t{constructor(N,W,Q){super(N,W,N,Q)}}e.OneLineRange=i;var d;(function(M){M.Default="default",M.FileNames="fileNames",M.Type="type",M.Modified="modified",M.CountDescending="countDescending",M.CountAscending="countAscending"})(d=e.SearchSortOrder||(e.SearchSortOrder={}));function a(M,N=!0){const W=M&&M.files&&M.files.exclude,Q=N&&M&&M.search&&M.search.exclude;if(!(!W&&!Q)){if(!W||!Q)return W||Q;let $=Object.create(null);return $=P.mixin($,P.deepClone(W)),$=P.mixin($,P.deepClone(Q),!0),$}}e.getExcludes=a;function l(M,N){return M.excludePattern&&k.match(M.excludePattern,N)?!1:M.includePattern||M.usingSearchPaths?M.includePattern&&k.match(M.includePattern,N)?!0:M.usingSearchPaths?!!M.folderQueries&&M.folderQueries.some(W=>{const Q=W.folder.fsPath;if(A.isEqualOrParent(N,Q)){const $=y.relative(Q,N);return!W.includePattern||!!k.match(W.includePattern,$)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var o;(function(M){M[M.unknownEncoding=1]="unknownEncoding",M[M.regexParseError=2]="regexParseError",M[M.globParseError=3]="globParseError",M[M.invalidLiteral=4]="invalidLiteral",M[M.rgProcessError=5]="rgProcessError",M[M.other=6]="other",M[M.canceled=7]="canceled"})(o=e.SearchErrorCode||(e.SearchErrorCode={}));class w extends Error{constructor(N,W){super(N);this.code=W}}e.SearchError=w;function I(M){const N=M.message;if((0,n.isPromiseCanceledError)(M))return new w(N,o.canceled);try{const W=JSON.parse(N);return new w(W.message,W.code)}catch(W){return new w(N,o.other)}}e.deserializeSearchError=I;function p(M){const N={message:M.message,code:M.code};return new Error(JSON.stringify(N))}e.serializeSearchError=p;function m(M){return M.type==="error"?!0:M.type==="success"}e.isSerializedSearchComplete=m;function R(M){return M.type==="success"}e.isSerializedSearchSuccess=R;function F(M){return!!M.path}e.isSerializedFileMatch=F;function x(M,N){const W=M.searchPath?M.searchPath:M.relativePath;return(0,S.fuzzyContains)(W,N)}e.isFilePatternMatch=x;class ae{constructor(N){this.path=N,this.results=[]}addMatch(N){this.results.push(N)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ae;function z(M,N){const W=Object.assign(Object.assign({},M||{}),N||{});return Object.keys(W).filter(Q=>{const $=W[Q];return typeof $=="boolean"&&$})}e.resolvePatternsForProvider=z;class B{constructor(N,W){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},N.excludePattern||{}),W.excludePattern||{}),this._parsedExcludeExpression=k.parse(this._excludeExpression);let Q=N.includePattern;W.includePattern&&(Q?Q=Object.assign(Object.assign({},Q),W.includePattern):Q=W.includePattern),Q&&(this._parsedIncludeExpression=k.parse(Q))}includedInQuerySync(N,W,Q){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(N,W,Q)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(N,W,Q))}includedInQuery(N,W,Q){return Promise.resolve(this._parsedExcludeExpression(N,W,Q)).then(Z=>!!Z).then(Z=>Z?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(N,W,Q)).then(re=>!!re):Promise.resolve(!0)).then(Z=>Z)}hasSiblingExcludeClauses(){return G(this._excludeExpression)}}e.QueryGlobTester=B;function G(M){for(const N in M)if(typeof M[N]!="boolean")return!0;return!1}}),define(ve[31],_e([0,1,11,14,20,3,22,18,79,25,8,13,2,136,4,19,151,47,48,27,15,7,41,5]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g,f,r,s,b,h,_,v,c,u,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function d(R,F,x){return new n.ExtUri(ae=>w(ae,x)).isEqual(R,F)}function a(R,F,x){return d(R.uri,F.uri,x)?0:(0,T.compare)(R.uri.toString(),F.uri.toString())}function l(R,F,x){return R.index!==F.index?R.index<F.index?-1:1:d(R.uri,F.uri,x)?(0,T.compare)(R.name,F.name):(0,T.compare)(R.uri.toString(),F.uri.toString())}function o(R,F,x,ae){const z=R.slice(0).sort((G,M)=>x(G,M,ae)),B=F.slice(0).sort((G,M)=>x(G,M,ae));return(0,E.delta)(z,B,(G,M)=>x(G,M,ae))}function w(R,F){const x=F.getCapabilities(R.scheme);return!(x&&x&1024)}class I extends h.Workspace{constructor(F,x,ae,z,B,G){super(F,ae.map(M=>new h.WorkspaceFolder(M)),z,G);this._name=x,this._isUntitled=B,this._workspaceFolders=[],this._structure=S.TernarySearchTree.forUris(G),ae.forEach(M=>{this._workspaceFolders.push(M),this._structure.set(M.uri,M)})}static toExtHostWorkspace(F,x,ae,z){if(!F)return{workspace:null,added:[],removed:[]};const{id:B,name:G,folders:M,configuration:N,isUntitled:W}=F,Q=[],$=x;x?M.forEach((ye,Pe)=>{const $e=g.URI.revive(ye.uri),Re=I._findFolder(ae||x,$e,z);Re?(Re.name=ye.name,Re.index=ye.index,Q.push(Re)):Q.push({uri:$e,name:ye.name,index:Pe})}):Q.push(...M.map(({uri:ye,name:Pe,index:$e})=>({uri:g.URI.revive(ye),name:Pe,index:$e}))),Q.sort((ye,Pe)=>ye.index<Pe.index?-1:1);const Z=new I(B,G,Q,N?g.URI.revive(N):null,!!W,ye=>w(ye,z)),{added:re,removed:se}=o($?$.workspaceFolders:[],Z.workspaceFolders,a,z);return{workspace:Z,added:re,removed:se}}static _findFolder(F,x,ae){for(let z=0;z<F.folders.length;z++){const B=F.workspaceFolders[z];if(d(B.uri,x,ae))return B}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,x){return x&&this._structure.get(F)&&(F=(0,n.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let p=class{constructor(F,x,ae,z){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidReceieveWorkspaceTrust=new A.Emitter,this.onDidReceiveWorkspaceTrust=this._onDidReceieveWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=z,this._extHostFileSystemInfo=ae,this._requestIdProvider=new y.Counter,this._barrier=new k.Barrier,this._proxy=F.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(i.MainContext.MainThreadMessageService);const B=x.workspace;this._confirmedWorkspace=B?new I(B.id,B.name,[],B.configuration?g.URI.revive(B.configuration):null,!!B.isUntitled,G=>w(G,ae)):void 0}$initializeWorkspace(F,x){this._trusted=x,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?g.URI.from({scheme:D.Schemas.untitled,path:(0,n.basename)((0,n.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,x,ae,...z){const B=[];if(Array.isArray(z)&&z.forEach(Q=>{g.URI.isUri(Q.uri)&&!B.some($=>d($.uri,Q.uri,this._extHostFileSystemInfo))&&B.push({uri:Q.uri,name:Q.name||(0,n.basenameOrAuthority)(Q.uri)})}),this._unconfirmedWorkspace||[x,ae].some(Q=>typeof Q!="number"||Q<0)||ae===0&&B.length===0)return!1;const G=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(x+ae>G.length)return!1;const M=G.slice(0);M.splice(x,ae,...B.map(Q=>({uri:Q.uri,name:Q.name||(0,n.basenameOrAuthority)(Q.uri),index:void 0})));for(let Q=0;Q<M.length;Q++){const $=M[Q];if(M.some((Z,re)=>re!==Q&&d($.uri,Z.uri,this._extHostFileSystemInfo)))return!1}M.forEach((Q,$)=>Q.index=$);const{added:N,removed:W}=o(G,M,l,this._extHostFileSystemInfo);if(N.length===0&&W.length===0)return!1;if(this._proxy){const Q=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(Q,x,ae,B).then(void 0,$=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(b.Severity.Error,(0,f.localize)(0,null,Q,$.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders(M),!0}getWorkspaceFolder(F,x){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,x)}async getWorkspaceFolder2(F,x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,x)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!!this._actualWorkspace){const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}}getRelativePath(F,x){let ae,z="";if(typeof F=="string"?(ae=g.URI.file(F),z=F):typeof F!="undefined"&&(ae=F,z=F.fsPath),!ae)return z;const B=this.getWorkspaceFolder(ae,!0);if(!B)return z;typeof x=="undefined"&&this._actualWorkspace&&(x=this._actualWorkspace.folders.length>1);let G=(0,n.relativePath)(B.uri,ae);return x&&B.name&&(G=`${B.name}/${G}`),G}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=I.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:x,added:ae,removed:z}=I.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=x||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ae,removed:z}))}findFiles(F,x,ae,z,B=P.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let G;if(x===null?G=!1:x&&(typeof x=="string"?G=x:G=x.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:M,folder:N}=m(F);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(M),(0,C.withUndefinedAsNull)(N),(0,C.withUndefinedAsNull)(G),(0,C.withUndefinedAsNull)(ae),B).then(W=>Array.isArray(W)?W.map(Q=>g.URI.revive(Q)):[])}async findTextInFiles(F,x,ae,z,B=P.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const G=this._requestIdProvider.getNext(),M=typeof x.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,{includePattern:N,folder:W}=m(x.include),Q=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,$={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:M,afterContext:x.afterContext,beforeContext:x.beforeContext,includePattern:N,excludePattern:Q},Z=!1;if(this._activeSearchCallbacks[G]=re=>{if(!Z){const se=g.URI.revive(re.resource);re.results.forEach(ye=>{(0,t.resultIsMatch)(ye)?ae({uri:se,preview:{text:ye.preview.text,matches:(0,E.mapArrayOrNot)(ye.preview.matches,Pe=>new u.Range(Pe.startLineNumber,Pe.startColumn,Pe.endLineNumber,Pe.endColumn))},ranges:(0,E.mapArrayOrNot)(ye.ranges,Pe=>new u.Range(Pe.startLineNumber,Pe.startColumn,Pe.endLineNumber,Pe.endColumn))}):ae({uri:se,text:ye.text,lineNumber:ye.lineNumber})})}},B.isCancellationRequested)return{};try{const re=await this._proxy.$startTextSearch(F,(0,C.withUndefinedAsNull)(W),$,G,B);return delete this._activeSearchCallbacks[G],re||{}}catch(re){throw delete this._activeSearchCallbacks[G],re}}$handleTextSearchResult(F,x){this._activeSearchCallbacks[x]&&this._activeSearchCallbacks[x](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trusted(){return this._trusted}requestWorkspaceTrust(F){return this._proxy.$requestWorkspaceTrust(F)}$onDidReceiveWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidReceieveWorkspaceTrust.fire())}};p=je([Ke(0,c.IExtHostRpcService),Ke(1,v.IExtHostInitDataService),Ke(2,_.IExtHostFileSystemInfo),Ke(3,s.ILogService)],p),e.ExtHostWorkspace=p,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function m(R){let F,x;return R&&(typeof R=="string"?F=R:(F=R.pattern,x=R.baseFolder||g.URI.file(R.base))),{includePattern:F,folder:x}}}),define(ve[34],_e([0,1,24,3,31,5,7,153,66,13,14,4,15,19,2]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function s(i,d){if(d){const a=d.split(".");let l=i;for(let o=0;l&&o<a.length;o++)l=l[a[o]];return l}}function b(i){return i instanceof r.URI}function h(i){return i&&i.uri instanceof r.URI&&i.languageId&&typeof i.languageId=="string"}function _(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function v(i){return i&&i.uri instanceof r.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function c(i){if(b(i))return{resource:i};if(h(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(_(i))return{overrideIdentifier:i.languageId};if(v(i))return{resource:i.uri};if(i===null)return{resource:null}}let u=class{constructor(d,a,l){this._proxy=d.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=a,this._logService=l,this._barrier=new T.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(d=>this._actual)}$initializeConfiguration(d){this._actual=new t(this._proxy,this._extHostWorkspace,d,this._logService),this._barrier.open()}$acceptConfigurationChanged(d,a){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(d,a))}};u=je([Ke(0,g.IExtHostRpcService),Ke(1,P.IExtHostWorkspace),Ke(2,f.ILogService)],u),e.ExtHostConfiguration=u;class t{constructor(d,a,l,o){this._onDidChangeConfiguration=new k.Emitter,this._proxy=d,this._logService=o,this._extHostWorkspace=a,this._configuration=D.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(d,a){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(d),this._configurationScopes=this._toMap(d.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(a,l))}getConfiguration(d,a,l){const o=c(a)||{},w=this._toReadonlyValue(d?s(this._configuration.getValue(void 0,o,this._extHostWorkspace.workspace),d):this._configuration.getValue(void 0,o,this._extHostWorkspace.workspace));d&&this._validateConfigurationAccess(d,o,l==null?void 0:l.identifier);function I(m){if(m==null)return null;if(typeof m=="boolean")return m?1:4;switch(m){case S.ConfigurationTarget.Global:return 1;case S.ConfigurationTarget.Workspace:return 4;case S.ConfigurationTarget.WorkspaceFolder:return 5}}const p={has(m){return typeof s(w,m)!="undefined"},get:(m,R)=>{this._validateConfigurationAccess(d?`${d}.${m}`:m,o,l==null?void 0:l.identifier);let F=s(w,m);if(typeof F=="undefined")F=R;else{let x;const ae=(z,B)=>{let G;const M=()=>{x=x||(0,E.deepClone)(w),G=G||s(x,B)};return(0,n.isObject)(z)?new Proxy(z,{get:(N,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return M(),()=>G;if(x)return G=G||s(x,B),G[W];const Q=N[W];return typeof W=="string"?ae(Q,`${B}.${W}`):Q},set:(N,W,Q)=>(M(),G&&(G[W]=Q),!0),deleteProperty:(N,W)=>(M(),G&&delete G[W],!0),defineProperty:(N,W,Q)=>(M(),G&&Object.defineProperty(G,W,Q),!0)}):z};F=ae(F,m)}return F},update:(m,R,F,x)=>{m=d?`${d}.${m}`:m;const ae=I(F);return R!==void 0?this._proxy.$updateConfigurationOption(ae,m,R,o,x):this._proxy.$removeConfigurationOption(ae,m,o,x)},inspect:m=>{var R,F,x,ae,z,B,G,M;m=d?`${d}.${m}`:m;const N=(0,E.deepClone)(this._configuration.inspect(m,o,this._extHostWorkspace.workspace));if(N)return{key:m,defaultValue:(R=N.default)===null||R===void 0?void 0:R.value,globalValue:(F=N.user)===null||F===void 0?void 0:F.value,workspaceValue:(x=N.workspace)===null||x===void 0?void 0:x.value,workspaceFolderValue:(ae=N.workspaceFolder)===null||ae===void 0?void 0:ae.value,defaultLanguageValue:(z=N.default)===null||z===void 0?void 0:z.override,globalLanguageValue:(B=N.user)===null||B===void 0?void 0:B.override,workspaceLanguageValue:(G=N.workspace)===null||G===void 0?void 0:G.override,workspaceFolderLanguageValue:(M=N.workspaceFolder)===null||M===void 0?void 0:M.override,languageIds:N.overrideIdentifiers}}};return typeof w=="object"&&(0,E.mixin)(p,w,!1),Object.freeze(p)}_toReadonlyValue(d){const a=l=>(0,n.isObject)(l)?new Proxy(l,{get:(o,w)=>a(o[w]),set:(o,w,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(o,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(o,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:o=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return a(d)}_validateConfigurationAccess(d,a,l){const o=y.OVERRIDE_PROPERTY_PATTERN.test(d)?4:this._configurationScopes.get(d),w=l?`[${l.value}] `:"";if(o===4){typeof(a==null?void 0:a.resource)=="undefined"&&this._logService.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(o===3){(a==null?void 0:a.resource)&&this._logService.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(d,a){const l=new D.ConfigurationChangeEvent(d,a,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(o,w)=>l.affectsConfiguration(o,c(w))})}_toMap(d){return d.reduce((a,l)=>(a.set(l[0],l[1]),a),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var et=this&&this.__classPrivateFieldSet||function(ie,e,E,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(ie,E):P?P.value=E:e.set(ie,E),E},xe=this&&this.__classPrivateFieldGet||function(ie,e,E,k){if(E==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?k:E==="a"?k.call(ie):k?k.value:e.get(ie)};define(ve[101],_e([0,1,2,14,3,5,7,31,39,34,20,40,15,27,4,18,21,19,73,170,10]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g,f,r,s,b,h,_,v,c){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(z){function B(M){if(M!=null)return M}z.from=B;function G(M){if(M!=null)return M}z.to=G})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(z){function B(M){if(M!=null)return M}z.from=B;function G(M){if(M!=null)return M}z.to=G})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var d;(function(z){function B(M){if(M!=null)return M}z.from=B;function G(M){if(M!=null)return M}z.to=G})(d=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var a;(function(z){function B(N){if(N){const W=N;return W&&!!W.process}else return!1}z.is=B;function G(N){if(N!=null){const W={process:N.process,args:N.args};return N.options&&(W.options=d.from(N.options)),W}}z.from=G;function M(N){if(N!=null)return new S.ProcessExecution(N.process,N.args,N.options)}z.to=M})(a=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function(z){function B(M){if(M!=null)return M}z.from=B;function G(M){if(M!=null)return M}z.to=G})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var o;(function(z){function B(N){if(N){const W=N;return W&&(!!W.commandLine||!!W.command)}else return!1}z.is=B;function G(N){if(N!=null){const W={};return N.commandLine!==void 0?W.commandLine=N.commandLine:(W.command=N.command,W.args=N.args),N.options&&(W.options=l.from(N.options)),W}}z.from=G;function M(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new S.ShellExecution(N.commandLine,N.options):new S.ShellExecution(N.command,N.args?N.args:[],N.options)}z.to=M})(o=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var w;(function(z){function B(N){if(N){let W=N;return W&&W.customExecution==="customExecution"}else return!1}z.is=B;function G(N){return{customExecution:"customExecution"}}z.from=G;function M(N,W){return W.get(N)}z.to=M})(w=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var I;(function(z){function B(G,M){let N;return G.scope!==void 0&&typeof G.scope!="number"?N=G.scope.uri:G.scope!==void 0&&typeof G.scope=="number"&&(G.scope===S.TaskScope.Workspace&&M&&M.workspaceFile?N=M.workspaceFile:N=v.USER_TASKS_GROUP_KEY),{id:G._id,workspaceFolder:N}}z.from=B})(I=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(z){function B(N,W){if(N==null)return[];const Q=[];for(let $ of N){const Z=G($,W);Z&&Q.push(Z)}return Q}z.fromMany=B;function G(N,W){if(N!=null){let Q;N.execution instanceof S.ProcessExecution?Q=a.from(N.execution):N.execution instanceof S.ShellExecution?Q=o.from(N.execution):N.execution&&N.execution instanceof S.CustomExecution&&(Q=w.from(N.execution));const $=t.from(N.definition);let Z;if(N.scope?typeof N.scope=="number"?Z=N.scope:Z=N.scope.uri:Z=S.TaskScope.Workspace,!(!$||!Z)){const re=N.group?N.group.id:void 0;return{_id:N._id,definition:$,name:N.name,source:{extensionId:W.identifier.value,label:N.source,scope:Z},execution:Q,isBackground:N.isBackground,group:re,presentationOptions:i.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}}}z.from=G;async function M(N,W,Q){if(N!=null){let $;a.is(N.execution)?$=a.to(N.execution):o.is(N.execution)?$=o.to(N.execution):w.is(N.execution)&&($=w.to(N._id,Q));const Z=t.to(N.definition);let re;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?re=N.source.scope:re=await W.resolveWorkspaceFolder(E.URI.revive(N.source.scope)):re=S.TaskScope.Workspace),!(!Z||!re)){const se=new S.Task(Z,re,N.name,N.source.label,$,N.problemMatchers);return N.isBackground!==void 0&&(se.isBackground=N.isBackground),N.group!==void 0&&(se.group=S.TaskGroup.from(N.group)),N.presentationOptions&&(se.presentationOptions=i.to(N.presentationOptions)),N._id&&(se._id=N._id),N.detail&&(se.detail=N.detail),se}}}z.to=M})(p=e.TaskDTO||(e.TaskDTO={}));var m;(function(z){function B(M){return M}z.from=B;function G(M){if(!!M)return Object.assign(Object.create(null),M)}z.to=G})(m=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(B,G,M){this._id=G,this._task=M,u.set(this,void 0),et(this,u,B,"f")}get task(){return this._task}terminate(){xe(this,u,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}u=new WeakMap;var F;(function(z){function B(G){return{id:G._id,task:void 0}}z.from=B})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let x=class{constructor(B,G,M,N,W,Q,$,Z){this._onDidExecuteTask=new P.Emitter,this._onDidTerminateTask=new P.Emitter,this._onDidTaskProcessStarted=new P.Emitter,this._onDidTaskProcessEnded=new P.Emitter,this._proxy=B.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=M,this._editorService=N,this._configurationService=W,this._terminalService=Q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=$,this._deprecationService=Z,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(B,G,M){if(!M)return new S.Disposable(()=>{});const N=this.nextHandle();return this._handlers.set(N,{type:G,provider:M,extension:B}),this._proxy.$registerTaskProvider(N,G),new S.Disposable(()=>{this._handlers.delete(N),this._proxy.$unregisterTaskProvider(N)})}registerTaskSystem(B,G){this._proxy.$registerTaskSystem(B,G)}fetchTasks(B){return this._proxy.$fetchTasks(m.from(B)).then(async G=>{const M=[];for(let N of G){const W=await p.to(N,this._workspaceProvider,this._providedCustomExecutions2);W&&M.push(W)}return M})}get taskExecutions(){const B=[];return this._taskExecutions.forEach(G=>B.push(G)),B}terminateTask(B){if(!(B instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(B._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(B,G,M){const N=this._providedCustomExecutions2.get(B.id);if(N){if(this._activeCustomExecutions2.get(B.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(B.id,N),this._terminalService.attachPtyToTerminal(G,await N.callback(M))}this._lastStartedTask=B.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(B)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(B){const G=await this.getTaskExecution(B);this._taskExecutionPromises.delete(B.id),this._taskExecutions.delete(B.id),this.customExecutionComplete(B),this._onDidTerminateTask.fire({execution:G})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(B){const G=await this.getTaskExecution(B.id);this._onDidTaskProcessStarted.fire({execution:G,processId:B.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(B){const G=await this.getTaskExecution(B.id);this._onDidTaskProcessEnded.fire({execution:G,exitCode:B.exitCode})}$provideTasks(B,G){const M=this._handlers.get(B);if(!M)return Promise.reject(new Error("no handler found"));const N=[],W=(0,k.asPromise)(()=>M.provider.provideTasks(T.CancellationToken.None)).then(Q=>this.provideTasksInternal(G,N,M,Q));return new Promise(Q=>{W.then($=>{Promise.all(N).then(()=>{Q($)})})})}async $resolveTask(B,G){const M=this._handlers.get(B);if(!M)return Promise.reject(new Error("no handler found"));if(G.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${G.definition.type}] cannot be resolved by provider of type [${M.type}].`);const N=await p.to(G,this._workspaceProvider,this._providedCustomExecutions2);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const W=await M.provider.resolveTask(N,T.CancellationToken.None);if(!!W){this.checkDeprecation(W,M);const Q=p.from(W,M.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return w.is(Q.execution)&&await this.addCustomExecution(Q,W,!0),await this.resolveTaskInternal(Q)}}nextHandle(){return this._handleCounter++}async addCustomExecution(B,G,M){const N=await this._proxy.$createTaskId(B);!M&&!this._providedCustomExecutions2.has(N)&&this._notProvidedCustomExecutions.add(N),this._providedCustomExecutions2.set(N,G.execution)}async getTaskExecution(B,G){if(typeof B=="string"){const W=this._taskExecutionPromises.get(B);if(!W)throw new Error("Unexpected: The specified task is missing an execution");return W}let M=this._taskExecutionPromises.get(B.id);if(M)return M;const N=new Promise(async(W,Q)=>{const $=G||await p.to(B.task,this._workspaceProvider,this._providedCustomExecutions2);$?W(new R(this,B.id,$)):Q("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(B.id,N),N.then(W=>(this._taskExecutions.set(B.id,W),W),W=>Promise.reject(W))}checkDeprecation(B,G){B._deprecated&&this._deprecationService.report("Task.constructor",G.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(B){this._activeCustomExecutions2.get(B.id)&&this._activeCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.has(B.id)&&this._lastStartedTask!==B.id&&(this._providedCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.delete(B.id));let M=this._notProvidedCustomExecutions.values(),N=M.next();for(;!N.done;)!this._activeCustomExecutions2.has(N.value)&&this._lastStartedTask!==N.value&&(this._providedCustomExecutions2.delete(N.value),this._notProvidedCustomExecutions.delete(N.value)),N=M.next()}};x=je([Ke(0,g.IExtHostRpcService),Ke(1,f.IExtHostInitDataService),Ke(2,D.IExtHostWorkspace),Ke(3,y.IExtHostDocumentsAndEditors),Ke(4,n.IExtHostConfiguration),Ke(5,C.IExtHostTerminalService),Ke(6,h.ILogService),Ke(7,_.IExtHostApiDeprecationService)],x),e.ExtHostTaskBase=x;let ae=class extends x{constructor(B,G,M,N,W,Q,$,Z){super(B,G,M,N,W,Q,$,Z);this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:b.PlatformToString(0)})}async executeTask(B,G){if(!G.execution)throw new Error("Tasks to execute must include an execution");const M=p.from(G,B);if(M===void 0)throw new Error("Task is not valid");if(w.is(M.execution))await this.addCustomExecution(M,G,!1);else throw new c.NotSupportedError;const N=await this.getTaskExecution(await this._proxy.$getTaskExecution(M),G);return this._proxy.$executeTask(M).catch(W=>{throw new Error(W)}),N}provideTasksInternal(B,G,M,N){const W=[];if(N)for(let Q of N){this.checkDeprecation(Q,M),(!Q.definition||!B[Q.definition.type])&&this._logService.warn(`The task [${Q.source}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`);const $=p.from(Q,M.extension);$&&w.is($.execution)?(W.push($),G.push(this.addCustomExecution($,Q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:W,extension:M.extension}}async resolveTaskInternal(B){if(w.is(B.execution))return B;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(B,G){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(B,G,M){}};ae=je([Ke(0,g.IExtHostRpcService),Ke(1,f.IExtHostInitDataService),Ke(2,D.IExtHostWorkspace),Ke(3,y.IExtHostDocumentsAndEditors),Ke(4,n.IExtHostConfiguration),Ke(5,C.IExtHostTerminalService),Ke(6,h.ILogService),Ke(7,_.IExtHostApiDeprecationService)],ae),e.WorkerExtHostTask=ae,e.IExtHostTask=(0,r.createDecorator)("IExtHostTask")});var cn=this&&this.__rest||function(ie,e){var E={};for(var k in ie)Object.prototype.hasOwnProperty.call(ie,k)&&e.indexOf(k)<0&&(E[k]=ie[k]);if(ie!=null&&typeof Object.getOwnPropertySymbols=="function")for(var P=0,k=Object.getOwnPropertySymbols(ie);P<k.length;P++)e.indexOf(k[P])<0&&Object.prototype.propertyIsEnumerable.call(ie,k[P])&&(E[k[P]]=ie[k[P]]);return E};define(ve[217],_e([0,1,11,14,23,20,3,52,6,24,13,2,29,5,39,15,9,7,31,181,95]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g,f,r,s,b,h,_,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const u=(p,m)=>`${p}:${m.toString()}`;let t=class{constructor(m,R,F){this.documents=R,this.workspace=F,this.resultsChangedEmitter=new S.Emitter,this.providers=new Map,this.ownedTests=new v.OwnedTestCollection,this.testSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=m.getProxy(f.MainContext.MainThreadTesting),this.workspaceObservers=new w(this.proxy),this.textDocumentObservers=new I(this.proxy,R)}registerTestProvider(m){const R=(0,g.generateUuid)();this.providers.set(R,m),this.proxy.$registerTestProvider(R);const F=[...this.testSubscriptions.keys()];return setTimeout(()=>{var x;for(const ae of F)(x=this.testSubscriptions.get(ae))===null||x===void 0||x.subscribeFn(R,m)},0),new h.Disposable(()=>{this.providers.delete(R),this.proxy.$unregisterTestProvider(R)})}createTextDocumentTestObserver(m){return this.textDocumentObservers.checkout(m.uri)}createWorkspaceTestObserver(m){return this.workspaceObservers.checkout(m.uri)}async runTests(m,R=A.CancellationToken.None){const F=x=>x.map(this.getInternalTestForReference,this).filter(T.isDefined).map(ae=>({src:ae.src,testId:ae.item.extId}));await this.proxy.$runTests({exclude:m.exclude?F(m.exclude).map(x=>x.testId):void 0,tests:F(m.tests),debug:m.debug},R)}publishExtensionProvidedResults(m,R){this.proxy.$publishExtensionProvidedResults(b.TestResults.from((0,g.generateUuid)(),m),R)}$publishTestResults(m){this.results=Object.freeze(m.map(R=>(0,n.deepFreeze)(b.TestResults.to(R))).concat(this.results).sort((R,F)=>F.completedAt-R.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(m,R){const F=C.URI.revive(R),x=u(m,F);if(!this.testSubscriptions.has(x)){const ae=new A.CancellationTokenSource;let z;if(m===1){let N=this.documents.getDocument(F);if(!N){const W=new y.DisposableStore;N=await new Promise(Q=>{W.add((0,k.disposableTimeout)(()=>Q(void 0),5e3)),W.add(this.documents.onDidAddDocuments($=>{const Z=$.find(re=>re.document.uri.toString()===F.toString());Z&&Q(Z)}))}).finally(()=>W.dispose())}if(N){const W=await this.workspace.getWorkspaceFolder2(F,!1);z=Q=>Q.provideDocumentTestRoot?Q.provideDocumentTestRoot(N.document,ae.token):(0,e.createDefaultDocumentTestRoot)(Q,N.document,W,ae.token)}}else{const N=await this.workspace.getWorkspaceFolder2(F,!1);N&&(z=W=>W.provideWorkspaceTestRoot(N,ae.token))}if(!!z){const B=async(N,W)=>{try{const Q=await z(W);Q&&M.addRoot(Q,N)}catch(Q){console.error(Q)}},G=new y.DisposableStore,M=G.add(this.ownedTests.createForHierarchy(N=>this.proxy.$publishDiff(m,R,N)));G.add((0,y.toDisposable)(()=>ae.dispose(!0)));for(const[N,W]of this.providers)B(N,W);M.pushDiff([3,-1]),this.testSubscriptions.set(x,{store:G,collection:M,subscribeFn:B})}}}async $expandTest(m,R){const F=(0,E.mapFind)(this.testSubscriptions.values(),x=>x.collection.treeId===m.src.tree?x:void 0);await(F==null?void 0:F.collection.expand(m.testId,R<0?Infinity:R)),this.flushCollectionDiffs()}$unsubscribeFromTests(m,R){var F;const x=C.URI.revive(R),ae=u(m,x);(F=this.testSubscriptions.get(ae))===null||F===void 0||F.store.dispose(),this.testSubscriptions.delete(ae)}$acceptDiff(m,R,F){m===1?this.textDocumentObservers.acceptDiff(C.URI.revive(R),F):this.workspaceObservers.acceptDiff(C.URI.revive(R),F)}async $runTestsForProvider(m,R){const F=this.providers.get(m.tests[0].src.provider);if(!!F){const x=m.tests.map(({testId:B,src:G})=>this.ownedTests.getTestById(B,G.tree)).filter(T.isDefined).map(([B,G])=>G),ae=m.excludeExtIds.map(B=>this.ownedTests.getTestById(B)).filter(T.isDefined).filter(([B,G])=>x.some(M=>B.comparePositions(M,G)===1));if(!!x.length){const z=B=>{for(const[G,M]of ae){const N=G.comparePositions(M,B.id);if(N===1||N===3)return!0}return!1};try{await F.runTests({appendOutput:B=>{this.proxy.$appendOutputToRun(m.runId,P.VSBuffer.fromString(B))},appendMessage:(B,G)=>{z(B)||(this.flushCollectionDiffs(),this.proxy.$appendTestMessageInRun(m.runId,B.id,b.TestMessage.from(G)))},setState:(B,G,M)=>{z(B)||(this.flushCollectionDiffs(),this.proxy.$updateTestStateInRun(m.runId,B.id,G,M))},tests:x.map(B=>d.unwrap(B.actual)),exclude:ae.map(([,B])=>d.unwrap(B.actual)),debug:m.debug},R);for(const{collection:B}of this.testSubscriptions.values())B.flushDiff();return}catch(B){throw console.error(B),B}}}}$lookupTest(m){const R=this.ownedTests.getTestById(m.testId);if(!R)return Promise.resolve(void 0);const F=R[1],{actual:x,discoverCts:ae,expandLevels:z}=F,B=cn(F,["actual","discoverCts","expandLevels"]);return Promise.resolve(B)}flushCollectionDiffs(){for(const{collection:m}of this.testSubscriptions.values())m.flushDiff()}getInternalTestForReference(m){var R,F;return(F=(R=this.workspaceObservers.getMirroredTestDataByReference(m))!==null&&R!==void 0?R:(0,E.mapFind)(this.testSubscriptions.values(),x=>x.collection.getTestByReference(m)))!==null&&F!==void 0?F:this.textDocumentObservers.getMirroredTestDataByReference(m)}};t=je([Ke(0,s.IExtHostRpcService),Ke(1,r.IExtHostDocumentsAndEditors),Ke(2,_.IExtHostWorkspace)],t),e.ExtHostTesting=t;const i=async(p,m,R,F)=>{if(!!R){const x=await p.provideWorkspaceTestRoot(R,F);if(!!x)return F.onCancellationRequested(()=>{d.removeFilter(m)}),d.getWrapperForTestItem(x,m)}};e.createDefaultDocumentTestRoot=i;class d extends h.TestItem{constructor(m,R,F){super(m.id,m.label,m.uri,m.expandable);if(this.actual=m,this.filterDocument=R,this.parent=F,!(m instanceof h.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${m.id} did not`);m[h.TestItemHookProperty]={setProp:(x,ae)=>this[x]=ae,created:x=>d.getWrapperForTestItem(x,this.filterDocument,this).refreshMatch(),invalidate:()=>this.invalidate(),delete:x=>this.children.delete(x)}}static removeFilter(m){this.wrapperMap.delete(m)}static getWrapperForTestItem(m,R,F){let x=this.wrapperMap.get(R);if(x==null?void 0:x.has(m))return x.get(m);x||(x=new WeakMap,this.wrapperMap.set(R,x));const ae=new d(m,R,F);return x.set(m,ae),ae}static unwrap(m){return m instanceof d?m.actual:m}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var m;const R=this._cachedMatchesFilter;for(const x of this.actual.children){const ae=d.getWrapperForTestItem(x,this.filterDocument,this);ae.hasNodeMatchingFilter?this.children.add(ae):this.children.delete(ae)}const F=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=F,F!==R&&((m=this.parent)===null||m===void 0||m.refreshMatch()),this._cachedMatchesFilter}}e.TestItemFilteredWrapper=d,d.wrapperMap=new WeakMap;class a extends c.IncrementalChangeCollector{constructor(m){super();this.emitter=m,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(m){this.added.add(m)}update(m){Object.assign(m.revived,b.TestItem.toPlain(m.item)),this.added.has(m)||this.updated.add(m)}remove(m){if(this.added.has(m)){this.added.delete(m);return}if(this.updated.delete(m),m.parent&&this.alreadyRemoved.has(m.parent)){this.alreadyRemoved.add(m.item.extId);return}this.removed.add(m)}getChangeEvent(){const{added:m,updated:R,removed:F}=this;return{get added(){return[...m].map(x=>x.revived)},get updated(){return[...R].map(x=>x.revived)},get removed(){return[...F].map(x=>x.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class l extends c.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new S.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(m){let R=[];for(const F of m){const x=this.items.get(F);x&&R.push(x.revived)}return R}getMirroredTestDataById(m){return this.items.get(m)}getMirroredTestDataByReference(m){return this.items.get(m.id)}createItem(m,R){return Object.assign(Object.assign({},m),{revived:b.TestItem.toPlain(m.item),depth:R?R.depth+1:0,children:new Set})}createChangeCollector(){return new a(this.changeEmitter)}}e.MirroredTestCollection=l;class o{constructor(){this.resources=new Map}checkout(m){var R,F;const x=m.toString(),ae=(R=this.resources.get(x))!==null&&R!==void 0?R:this.createObserverData(m);return(F=ae.pendingDeletion)===null||F===void 0||F.dispose(),ae.observers++,{onDidChangeTest:ae.tests.onDidChangeTests,onDidDiscoverInitialTests:new S.Emitter().event,get tests(){return ae.tests.rootTestItems},dispose:(0,D.once)(()=>{--ae.observers||(ae.pendingDeletion=this.eventuallyDispose(m))})}}getMirroredTestDataByReference(m){for(const{tests:R}of this.resources.values()){const F=R.getMirroredTestDataByReference(m);if(F)return F}}eventuallyDispose(m){return(0,k.disposableTimeout)(()=>this.unlisten(m),10*1e3)}createObserverData(m){const R=new l,F=this.listen(m,ae=>R.apply(ae)),x={observers:0,tests:R,listener:F};return this.resources.set(m.toString(),x),x}unlisten(m){var R;const F=m.toString(),x=this.resources.get(F);x&&(x.observers=-1,(R=x.pendingDeletion)===null||R===void 0||R.dispose(),x.listener.dispose(),this.resources.delete(F))}}class w extends o{constructor(m){super();this.proxy=m,this.diffListeners=new Map}acceptDiff(m,R){var F;(F=this.diffListeners.get(m.toString()))===null||F===void 0||F(R)}listen(m,R){this.proxy.$subscribeToDiffs(0,m);const F=m.toString();return this.diffListeners.set(F,R),new h.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,m),this.diffListeners.delete(F)})}}class I extends o{constructor(m,R){super();this.proxy=m,this.documents=R,this.diffListeners=new Map}acceptDiff(m,R){var F;(F=this.diffListeners.get(m.toString()))===null||F===void 0||F(R)}listen(m,R){if(!this.documents.getDocument(m))return new h.Disposable(()=>{});const x=m.toString();return this.diffListeners.set(x,R),this.proxy.$subscribeToDiffs(1,m),new h.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,m),this.diffListeners.delete(x)})}}}),define(ve[218],_e([0,1,11,50,28,58,22,18,12,25,8,13,2,114,139,90,47,173,216,41]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g,f,r,s,b,h,_,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let c=class{constructor(I,p,m,R){this.configurationService=I,this.workspaceContextService=p,this.editorGroupsService=m,this.pathService=R}text(I,p,m={}){I=this.getContentPattern(I,m);const R=this.configurationService.getValue(),F=p&&p.some(ae=>!this.configurationService.getValue({resource:ae}).search.useRipgrep),x=this.commonQuery(p==null?void 0:p.map(b.toWorkspaceFolder),m);return Object.assign(Object.assign({},x),{type:2,contentPattern:I,previewOptions:m.previewOptions,maxFileSize:m.maxFileSize,usePCRE2:R.search.usePCRE2||F||!1,beforeContext:m.beforeContext,afterContext:m.afterContext,userDisabledExcludesAndIgnoreFiles:m.disregardExcludeSettings&&m.disregardIgnoreFiles})}getContentPattern(I,p){const m=this.configurationService.getValue();I.isRegExp&&(I.pattern=I.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},I),{wordSeparators:m.editor.wordSeparators});return this.isCaseSensitive(I,p)&&(R.isCaseSensitive=!0),this.isMultiline(I)&&(R.isMultiline=!0),R}file(I,p={}){const m=this.commonQuery(I,p);return Object.assign(Object.assign({},m),{type:1,filePattern:p.filePattern?p.filePattern.trim():p.filePattern,exists:p.exists,sortByScore:p.sortByScore,cacheKey:p.cacheKey})}handleIncludeExclude(I,p){return I?(I=Array.isArray(I)?I.map(a):a(I),p?this.parseSearchPaths(I):{pattern:t(...Array.isArray(I)?I:[I])}):{}}commonQuery(I=[],p={}){const m=this.handleIncludeExclude(p.includePattern,p.expandPatterns),R=this.handleIncludeExclude(p.excludePattern,p.expandPatterns),F=I.length>1,x=(m.searchPaths&&m.searchPaths.length?m.searchPaths.map(B=>this.getFolderQueryForSearchPath(B,p,R)):I.map(B=>this.getFolderQueryForRoot(B,p,R,F))).filter(B=>!!B),ae={_reason:p._reason,folderQueries:x,usingSearchPaths:!!(m.searchPaths&&m.searchPaths.length),extraFileResources:p.extraFileResources,excludePattern:R.pattern,includePattern:m.pattern,onlyOpenEditors:p.onlyOpenEditors,maxResults:p.maxResults};if(p.onlyOpenEditors){const G=E.coalesce(E.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(W=>W.resource)))).filter(N=>(0,v.pathIncludedInQuery)(ae,N.fsPath)),M=this.commonQueryFromFileList(G);return Object.assign(Object.assign({},ae),M)}const z=p.extraFileResources&&p.extraFileResources.filter(B=>(0,v.pathIncludedInQuery)(ae,B.fsPath));return ae.extraFileResources=z&&z.length?z:void 0,ae}commonQueryFromFileList(I){const p=[],m=new S.ResourceMap,R={};let F=!1;return I.forEach(x=>{var ae,z;if(x.scheme!==D.Schemas.walkThrough)if((0,n.isAbsolutePath)(x)){const G=(z=(ae=this.workspaceContextService.getWorkspaceFolder(x))===null||ae===void 0?void 0:ae.uri)!==null&&z!==void 0?z:x.with({path:y.dirname(x.fsPath)});let M=m.get(G);M||(F=!0,M={folder:G,includePattern:{}},p.push(M),m.set(G,M));const N=y.relative(G.fsPath,x.fsPath);(0,C.assertIsDefined)(M.includePattern)[N.replace(/\\/g,"/")]=!0}else x.fsPath&&(F=!0,R[x.fsPath]=!0)}),{folderQueries:p,includePattern:R,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(I,p){if(p.isSmartCase){if(I.isRegExp){if(T.containsUppercaseCharacter(I.pattern,!0))return!0}else if(T.containsUppercaseCharacter(I.pattern))return!0}return!!I.isCaseSensitive}isMultiline(I){return I.isMultiline||I.isRegExp&&(0,f.isMultilineRegexSource)(I.pattern)||I.pattern.indexOf(`
`)>=0?!0:!!I.isMultiline}parseSearchPaths(I){const p=M=>y.isAbsolute(M)||/^\.\.?([\/\\]|$)/.test(M),R=(Array.isArray(I)?I:i(I)).map(M=>{const N=this.pathService.resolvedUserHome;return N?(0,A.untildify)(M,N.scheme===D.Schemas.file?N.fsPath:N.path):M}),F=k.groupBy(R,M=>p(M)?"searchPaths":"exprSegments"),x=(F.exprSegments||[]).map(M=>T.rtrim(M,"/")).map(M=>T.rtrim(M,"\\")).map(M=>(M[0]==="."&&(M="*"+M),d(M))),ae={},z=this.expandSearchPathPatterns(F.searchPaths||[]);z&&z.length&&(ae.searchPaths=z);const B=E.flatten(x),G=t(...B);return G&&(ae.pattern=G),ae}getExcludesForFolder(I,p){return p.disregardExcludeSettings?void 0:(0,v.getExcludes)(I,!p.disregardSearchExcludeSettings)}expandSearchPathPatterns(I){if(!I||!I.length)return[];const p=E.flatten(I.map(R=>{let{pathPortion:F,globPortion:x}=u(R);x&&(x=l(x));const ae=this.expandOneSearchPath(F);return E.flatten(ae.map(z=>this.resolveOneSearchPathPattern(z,x)))})),m=new Map;return p.forEach(R=>{const F=R.searchPath.toString(),x=m.get(F);x?R.pattern&&(x.pattern=x.pattern||{},x.pattern[R.pattern]=!0):m.set(F,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(m.values())}expandOneSearchPath(I){if(y.isAbsolute(I)){const p=this.workspaceContextService.getWorkspace().folders;return p[0]&&p[0].uri.scheme!==D.Schemas.file?[{searchPath:p[0].uri.with({path:I})}]:[{searchPath:g.URI.file(y.normalize(I))}]}if(this.workspaceContextService.getWorkbenchState()===2){const p=this.workspaceContextService.getWorkspace().folders[0].uri;if(I=a(I),I.startsWith("../")||I===".."){const R=y.posix.resolve(p.path,I);return[{searchPath:p.with({path:R})}]}const m=l(I);return[{searchPath:p,pattern:m}]}else{if(I==="./"||I===".\\")return[];{const p=I.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(p){const m=p[1],R=this.workspaceContextService.getWorkspace().folders.filter(F=>F.name===m);if(R.length)return R.map(F=>{const x=p[2];return{searchPath:F.uri,pattern:x&&l(x)}});{const F=r.localize(0,null,m);throw new Error(F)}}}}return[]}resolveOneSearchPathPattern(I,p){const m=I.pattern&&p?`${I.pattern}/${p}`:I.pattern||p,R=[{searchPath:I.searchPath,pattern:m}];return m&&!m.endsWith("**")&&R.push({searchPath:I.searchPath,pattern:m+"/**"}),R}getFolderQueryForSearchPath(I,p,m){const R=this.getFolderQueryForRoot((0,b.toWorkspaceFolder)(I.searchPath),p,m,!1);return R?Object.assign(Object.assign({},R),{includePattern:I.pattern}):null}getFolderQueryForRoot(I,p,m,R){let F;const x=g.URI.isUri(I)?I:I.uri;if(m.searchPaths){const M=m.searchPaths.filter(N=>(0,n.isEqual)(N.searchPath,x))[0];if(M&&!M.pattern)return null;M&&(F=M.pattern)}const ae=this.configurationService.getValue({resource:x}),z=this.getExcludesForFolder(ae,p),B=Object.assign(Object.assign({},z||{}),F||{}),G=g.URI.isUri(I)?(0,n.basename)(I):I.name;return{folder:x,folderName:R?G:void 0,excludePattern:Object.keys(B).length>0?B:void 0,fileEncoding:ae.files&&ae.files.encoding,disregardIgnoreFiles:typeof p.disregardIgnoreFiles=="boolean"?p.disregardIgnoreFiles:!ae.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof p.disregardGlobalIgnoreFiles=="boolean"?p.disregardGlobalIgnoreFiles:!ae.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof p.ignoreSymlinks=="boolean"?p.ignoreSymlinks:!ae.search.followSymlinks}}};c=je([Ke(0,s.IConfigurationService),Ke(1,b.IWorkspaceContextService),Ke(2,h.IEditorGroupsService),Ke(3,_.IPathService)],c),e.QueryBuilder=c;function u(w){const I=w.match(/[\*\{\}\(\)\[\]\?]/);if(I){const p=I.index,m=w.substr(0,p).match(/[/|\\][^/\\]*$/);if(m){let R=w.substr(0,m.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:w.substr((m.index||0)+1)}}}return{pathPortion:w}}function t(...w){return w.length?w.reduce((I,p)=>(I[p]=!0,I),Object.create(null)):void 0}function i(w){return P.splitGlobAware(w,",").map(I=>I.trim()).filter(I=>!!I.length)}function d(w){return[`**/${w}/**`,`**/${w}`].map(p=>p.replace(/\*\*\/\*\*/g,"**"))}function a(w){return w.replace(/\\/g,"/")}function l(w){return a(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(w,I){w=E.distinct(w,R=>R.toString());const p=[],m=I.getWorkspace();return w&&w.forEach(R=>{let F;if(I.getWorkbenchState()===2)F=(0,n.relativePath)(m.folders[0].uri,R),F&&F!=="."&&(F="./"+F);else{const x=I.getWorkspaceFolder(R);if(x){const ae=x.name;if(m.folders.filter(B=>B.name===ae).length===1){const B=(0,n.relativePath)(x.uri,R);B===""?F=`./${x.name}`:F=`./${x.name}/${B}`}else F=R.fsPath}}F&&p.push(F)}),p}e.resolveResourcesForSearchIncludes=o}),define(ve[219],_e([0,1,25,2,20,10,4,218,41,47]),function(ie,e,E,k,P,A,S,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const T=7e3;function C(s,b){const h=b.activationEvents;if(!h)return Promise.resolve(void 0);const _=[],v=[];for(const a of h)if(/^workspaceContains:/.test(a)){const l=a.substr("workspaceContains:".length);l.indexOf("*")>=0||l.indexOf("?")>=0||s.forceUsingSearch?v.push(l):_.push(l)}if(_.length===0&&v.length===0)return Promise.resolve(void 0);let c;const u=new Promise((a,l)=>{c=a}),t=a=>c({activationEvent:a}),i=Promise.all(_.map(a=>g(s,a,t))).then(()=>{}),d=f(s,b.identifier,v,t);return Promise.all([i,d]).then(()=>{c(void 0)}),u}e.checkActivateWorkspaceContainsExtension=C;async function g(s,b,h){for(const _ of s.folders)if(await s.exists(E.joinPath(k.URI.revive(_),b))){h(`workspaceContains:${b}`);return}}async function f(s,b,h,_){if(h.length===0)return Promise.resolve(void 0);const v=new P.CancellationTokenSource,c=s.checkExists(s.folders,h,v.token),u=setTimeout(async()=>{v.cancel(),_(`workspaceContainsTimeout:${h.join(",")}`)},T);let t=!1;try{t=await c}catch(i){A.isPromiseCanceledError(i)||A.onUnexpectedError(i)}v.dispose(),clearTimeout(u),t&&_(`workspaceContains:${h.join(",")}`)}function r(s,b,h,_){const v=s.get(S.IInstantiationService),c=s.get(y.ISearchService),t=v.createInstance(D.QueryBuilder).file(b.map(i=>(0,n.toWorkspaceFolder)(k.URI.revive(i))),{_reason:"checkExists",includePattern:h,exists:!0});return c.fileSearch(t,_).then(i=>!!i.limitHit,i=>A.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=r});var et=this&&this.__classPrivateFieldSet||function(ie,e,E,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!P:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(ie,E):P?P.value=E:e.set(ie,E),E},xe=this&&this.__classPrivateFieldGet||function(ie,e,E,k){if(E==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?k:E==="a"?k.call(ie):k?k.value:e.get(ie)};define(ve[35],_e([0,1,131,12,78,25,14,6,22,2,19,5,34,184,76,31,33,182,10,26,18,23,160,7,91,4,27,77,15,65,68,40,3,219,72,161]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g,f,r,s,b,h,_,v,c,u,t,i,d,a,l,o,w,I,p,m,R,F,x,ae){"use strict";var z,B,G;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let M=class An extends D.Disposable{constructor($,Z,re,se,ye,Pe,$e,Re,ze,U){super();this._onDidChangeRemoteConnectionData=this._register(new R.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Z,this._extHostContext=re,this._initData=$e,this._extHostWorkspace=se,this._extHostConfiguration=ye,this._logService=Pe,this._extHostTunnelService=ze,this._extHostTerminalService=U,this._disposables=new D.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new S.Barrier,this._readyToStartExtensionHost=new S.Barrier,this._readyToRunExtensions=new S.Barrier,this._eagerExtensionsActivated=new S.Barrier,this._registry=new h.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new r.ExtHostStorage(this._extHostContext),this._secretState=new x.ExtHostSecretState(this._extHostContext),this._storagePath=Re,this._instaService=$.createChild(new I.ServiceCollection([r.IExtHostStorage,this._storage],[x.IExtHostSecretState,this._secretState]));const K=new Set;this._initData.hostExtensions.forEach(te=>K.add(v.ExtensionIdentifier.toKey(te))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(te,le)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(te,le)},actualActivateExtension:async(te,le)=>{if(K.has(v.ExtensionIdentifier.toKey(te)))return await this._mainThreadExtensionsProxy.$activateExtension(te,le),new f.HostExtension;const me=this._registry.getExtensionDescription(te);return this._activateExtension(me,le)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),P.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch($){_.onUnexpectedError($)}}async deactivateAll(){let $=[];try{$=this._registry.getAllExtensionDescriptions().map(ye=>ye.identifier).filter(ye=>this.isActivated(ye)).map(ye=>this._deactivate(ye))}catch(Z){}await Promise.all($)}isActivated($){return this._readyToRunExtensions.isOpen()?this._activator.isActivated($):!1}_activateByEvent($,Z){return this._activator.activateByEvent($,Z)}_activateById($,Z){return this._activator.activateById($,Z)}activateByIdWithErrors($,Z){return this._activateById($,Z).then(()=>{const re=this._activator.getActivatedExtension($);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then($=>this._registry)}getExtensionExports($){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension($).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const $=y.TernarySearchTree.forPaths(),Z=this._registry.getAllExtensionDescriptions().map(re=>{if(!!this._getEntryPoint(re))return this._hostUtils.realpath(re.extensionLocation.fsPath).then(se=>$.set(n.URI.file(se).fsPath,re))});this._extensionPathIndex=Promise.all(Z).then(()=>$)}return this._extensionPathIndex}_deactivate($){let Z=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated($))return Z;const re=this._activator.getActivatedExtension($);if(!re)return Z;try{typeof re.module.deactivate=="function"&&(Z=Promise.resolve(re.module.deactivate()).then(void 0,se=>Promise.resolve(void 0)))}catch(se){}try{(0,D.dispose)(re.subscriptions)}catch(se){}return Z}async _activateExtension($,Z){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension($.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension($.identifier),this._doActivateExtension($,Z).then(re=>{const se=re.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension($.identifier,se.codeLoadingTime,se.activateCallTime,se.activateResolvedTime,Z),this._logExtensionActivationTimes($,Z,"success",se),re},re=>{throw this._logExtensionActivationTimes($,Z,"failure"),re})}_logExtensionActivationTimes($,Z,re,se){const ye=N($,Z);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},ye),se||{}),{outcome:re}))}_doActivateExtension($,Z){const re=N($,Z);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",re);const se=this._getEntryPoint($);if(!se)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${$.identifier.value} ${JSON.stringify(Z)}`),this._logService.flush();const ye=new f.ExtensionActivationTimesBuilder(Z.startup);return Promise.all([this._loadCommonJSModule($.identifier,(0,A.joinPath)($.extensionLocation,se),ye),this._loadExtensionContext($)]).then(Pe=>(P.mark(`code/extHost/willActivateExtension/${$.identifier.value}`),An._callActivate(this._logService,$.identifier,Pe[0],Pe[1],ye))).then(Pe=>(P.mark(`code/extHost/didActivateExtension/${$.identifier.value}`),Pe))}_loadExtensionContext($){const Z=new t.ExtensionGlobalMemento($,this._storage),re=new t.ExtensionMemento($.identifier.value,!1,this._storage),se=new ae.ExtensionSecrets($,this._secretState),ye=$.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Pe=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${$.identifier.value}`),Promise.all([Z.whenReady,re.whenReady,this._storagePath.whenReady]).then(()=>{const $e=this;let Re;return Object.freeze({globalState:Z,workspaceState:re,secrets:se,subscriptions:[],get extensionUri(){return $.extensionLocation},get extensionPath(){return $.extensionLocation.fsPath},asAbsolutePath(ze){return k.join($.extensionLocation.fsPath,ze)},get storagePath(){var ze;return(ze=$e._storagePath.workspaceValue($))===null||ze===void 0?void 0:ze.fsPath},get globalStoragePath(){return $e._storagePath.globalValue($).fsPath},get logPath(){return k.join($e._initData.logsLocation.fsPath,$.identifier.value)},get logUri(){return n.URI.joinPath($e._initData.logsLocation,$.identifier.value)},get storageUri(){return $e._storagePath.workspaceValue($)},get globalStorageUri(){return $e._storagePath.globalValue($)},get extensionMode(){return ye},get extension(){return Re===void 0&&(Re=new W($e,$.identifier,$,Pe)),Re},get extensionRuntime(){return(0,b.checkProposedApiEnabled)($),$e.extensionRuntime},get environmentVariableCollection(){return $e._extHostTerminalService.getEnvironmentVariableCollection($)}})})}static _callActivate($,Z,re,se,ye){return re=re||{activate:void 0,deactivate:void 0},this._callActivateOptional($,Z,re,se,ye).then(Pe=>new f.ActivatedExtension(!1,null,ye.build(),re,Pe,se.subscriptions))}static _callActivateOptional($,Z,re,se,ye){if(typeof re.activate=="function")try{ye.activateCallStart(),$.trace(`ExtensionService#_callActivateOptional ${Z.value}`);const Pe=typeof global=="object"?global:self,$e=re.activate.apply(Pe,[se]);return ye.activateCallStop(),ye.activateResolveStart(),Promise.resolve($e).then(Re=>(ye.activateResolveStop(),Re))}catch(Pe){return Promise.reject(Pe)}else return Promise.resolve(re)}_activateOneStartupFinished($,Z){this._activateById($.identifier,{startup:!1,extensionId:$.identifier,activationEvent:Z}).then(void 0,re=>{this._logService.error(re)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(P.getMarks());for(const $ of this._registry.getAllExtensionDescriptions())if($.activationEvents)for(const Z of $.activationEvents)Z==="onStartupFinished"&&this._activateOneStartupFinished($,Z)}_handleEagerExtensions(){const $=this._activateByEvent("*",!0).then(void 0,ye=>{this._logService.error(ye)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ye=>this._handleWorkspaceContainsEagerExtensions(ye.added)));const Z=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],re=this._handleWorkspaceContainsEagerExtensions(Z),se=Promise.all([$,re]).then(()=>{});return Promise.race([se,(0,S.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),se}_handleWorkspaceContainsEagerExtensions($){return $.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Z=>this._handleWorkspaceContainsEagerExtension($,Z))).then(()=>{})}async _handleWorkspaceContainsEagerExtension($,Z){if(!this.isActivated(Z.identifier)){const re=!this._initData.remote.isRemote&&!!this._initData.remote.authority,se={folders:$.map(Pe=>Pe.uri),forceUsingSearch:re,exists:Pe=>this._hostUtils.exists(Pe.fsPath),checkExists:(Pe,$e,Re)=>this._mainThreadWorkspaceProxy.$checkExists(Pe,$e,Re)},ye=await(0,F.checkActivateWorkspaceContainsExtension)(se,Z);if(!!ye)return this._activateById(Z.identifier,{startup:!0,extensionId:Z.identifier,activationEvent:ye.activationEvent}).then(void 0,Pe=>this._logService.error(Pe))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch($){throw console.error($),$}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:$,extensionTestsLocationURI:Z}=this._initData.environment;if(!$||!Z||Z.scheme!==c.Schemas.file)throw new Error(E.localize(0,null));const re=(0,A.originalFSPath)(Z),se=await this._loadCommonJSModule(null,Z,new f.ExtensionActivationTimesBuilder(!1));if(!se||typeof se.run!="function")throw new Error(E.localize(1,null,re));return new Promise((ye,Pe)=>{const $e=(ze,U)=>{ze?Pe(ze):ye(typeof U=="number"&&U>0?1:0)},Re=se.run(re,$e);Re&&Re.then&&Re.then(()=>{ye(0)}).catch(ze=>{Pe(ze.toString())})})}async $extensionTestsExit($){this._logService.info(`extension host terminating: test runner requested exit with code ${$}`),this._logService.info(`exiting with code ${$}`),this._logService.flush(),this._hostUtils.exit($)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver($,Z){return this._resolvers[$]=Z,(0,D.toDisposable)(()=>{delete this._resolvers[$]})}async $resolveAuthority($,Z){const re=$.indexOf("+");if(re===-1)throw new Error("Not an authority that can be resolved!");const se=$.substr(0,re);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${se}`,!1);const ye=this._resolvers[se];if(!ye)return{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${se}.`,detail:void 0}};try{P.mark(`code/extHost/willResolveAuthority/${se}`);const Pe=await ye.resolve($,{resolveAttempt:Z});P.mark(`code/extHost/didResolveAuthorityOK/${se}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(ye));const $e={authority:$,host:Pe.host,port:Pe.port,connectionToken:Pe.connectionToken},Re={extensionHostEnv:Pe.extensionHostEnv};return{type:"ok",value:{authority:$e,options:Re,tunnelInformation:{environmentTunnels:Pe.environmentTunnels}}}}catch(Pe){if(P.mark(`code/extHost/didResolveAuthorityError/${se}`),Pe instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:Pe._code,message:Pe._message,detail:Pe._detail}};throw Pe}}$startExtensionHost($){return this._registry.keepOnly($),this._startExtensionHost()}$activateByEvent($,Z){return Z===1?this._activateByEvent($,!1):this._readyToRunExtensions.wait().then(re=>this._activateByEvent($,!1))}async $activate($,Z){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription($)?(await this._activateById($,Z),!0):!1}async $deltaExtensions($,Z){$.forEach(se=>se.extensionLocation=n.URI.revive(se.extensionLocation));const re=await this.getExtensionPathIndex();return await Promise.all(Z.map(async se=>{const ye=this._registry.getExtensionDescription(se);if(!!ye){const Pe=await this._hostUtils.realpath(ye.extensionLocation.fsPath);re.delete(n.URI.file(Pe).fsPath)}})),await Promise.all($.map(async se=>{const ye=await this._hostUtils.realpath(se.extensionLocation.fsPath);re.set(n.URI.file(ye).fsPath,se)})),this._registry.deltaExtensions($,Z),Promise.resolve(void 0)}async $test_latency($){return $}async $test_up($){return $.byteLength}async $test_down($){let Z=u.VSBuffer.alloc($),re=Math.random()%256;for(let se=0;se<$;se++)Z.writeUInt8(re,se);return Z}async $updateRemoteConnectionData($){this._remoteConnectionData=$,this._onDidChangeRemoteConnectionData.fire()}};M=je([Ke(0,a.IInstantiationService),Ke(1,e.IHostUtils),Ke(2,w.IExtHostRpcService),Ke(3,s.IExtHostWorkspace),Ke(4,g.IExtHostConfiguration),Ke(5,T.ILogService),Ke(6,l.IExtHostInitDataService),Ke(7,o.IExtensionStoragePaths),Ke(8,p.IExtHostTunnelService),Ke(9,m.IExtHostTerminalService)],M),e.AbstractExtHostExtensionService=M;function N(Q,$){return{id:Q.identifier.value,name:Q.name,extensionVersion:Q.version,publisherDisplayName:Q.publisher,activationEvents:Q.activationEvents?Q.activationEvents.join(","):null,isBuiltin:Q.isBuiltin,reason:$.activationEvent,reasonId:$.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class W{constructor($,Z,re,se){z.set(this,void 0),B.set(this,void 0),G.set(this,void 0),et(this,z,$,"f"),et(this,B,Z,"f"),et(this,G,re.identifier,"f"),this.id=re.identifier.value,this.extensionUri=re.extensionLocation,this.extensionPath=k.normalize((0,A.originalFSPath)(re.extensionLocation)),this.packageJSON=re,this.extensionKind=se}get isActive(){return xe(this,z,"f").isActivated(xe(this,G,"f"))}get exports(){if(this.packageJSON.api!=="none")return xe(this,z,"f").getExtensionExports(xe(this,G,"f"))}activate(){return xe(this,z,"f").activateByIdWithErrors(xe(this,G,"f"),{startup:!1,extensionId:xe(this,B,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=W,z=new WeakMap,B=new WeakMap,G=new WeakMap}),define(ve[102],_e([0,1,12,2,3,14,5,7,168,31,35,39,172,34,169,15,4,13,45]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g,f,r,s,b,h,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,b.createDecorator)("IExtHostDebugService");let v=class{constructor(o,w,I,p,m){this._workspaceService=w,this._extensionService=I,this._editorsService=p,this._configurationService=m,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new P.Emitter,this._onDidTerminateDebugSession=new P.Emitter,this._onDidChangeActiveDebugSession=new P.Emitter,this._onDidReceiveDebugSessionCustomEvent=new P.Emitter,this._debugServiceProxy=o.getProxy(S.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new P.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new u(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(R=>{R.onDidChange(F=>{this.registerAllDebugTypes(R)}),this.registerAllDebugTypes(R)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(o,w){const I=o;if(typeof I.sourceReference=="number"&&I.sourceReference>0){let p=`debug:${encodeURIComponent(I.path||"")}`,m="?";return w&&(p+=`${m}session=${encodeURIComponent(w.id)}`,m="&"),p+=`${m}ref=${I.sourceReference}`,k.URI.parse(p)}else{if(I.path)return k.URI.file(I.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(o){const w=[];for(const I of o.getAllExtensionDescriptions())if(I.contributes){const p=I.contributes.debuggers;if(p&&p.length>0)for(const m of p)(0,r.isDebuggerMainContribution)(m)&&w.push(m.type)}this._debugServiceProxy.$registerDebugTypes(w)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const o=[];return this._breakpoints.forEach(w=>o.push(w)),o}addBreakpoints(o){this.startBreakpoints();const w=o.filter(m=>{const R=m.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,m),!0)});this.fireBreakpointChanges(w,[],[]);const I=[],p=new Map;for(const m of w)if(m instanceof D.SourceBreakpoint){let R=p.get(m.location.uri.toString());R||(R={type:"sourceMulti",uri:m.location.uri,lines:[]},p.set(m.location.uri.toString(),R),I.push(R)),R.lines.push({id:m.id,enabled:m.enabled,condition:m.condition,hitCondition:m.hitCondition,logMessage:m.logMessage,line:m.location.range.start.line,character:m.location.range.start.character})}else m instanceof D.FunctionBreakpoint&&I.push({type:"function",id:m.id,enabled:m.enabled,hitCondition:m.hitCondition,logMessage:m.logMessage,condition:m.condition,functionName:m.functionName});return this._debugServiceProxy.$registerBreakpoints(I)}removeBreakpoints(o){this.startBreakpoints();const w=o.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],w,[]);const I=w.filter(R=>R instanceof D.SourceBreakpoint).map(R=>R.id),p=w.filter(R=>R instanceof D.FunctionBreakpoint).map(R=>R.id),m=w.filter(R=>R instanceof D.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(I,p,m)}startDebugging(o,w,I){return this._debugServiceProxy.$startDebugging(o?o.uri:void 0,w,{parentSessionID:I.parentSession?I.parentSession.id:void 0,repl:I.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:I.noDebug,compact:I.compact})}stopDebugging(o){return this._debugServiceProxy.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,w,I){if(!w)return new D.Disposable(()=>{});const p=this._configProviderHandleCounter++;return this._configProviders.push({type:o,handle:p,provider:w}),this._debugServiceProxy.$registerDebugConfigurationProvider(o,I,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,p),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(m=>m.provider!==w),this._debugServiceProxy.$unregisterDebugConfigurationProvider(p)})}registerDebugAdapterDescriptorFactory(o,w,I){if(!I)return new D.Disposable(()=>{});if(!this.definesDebugType(o,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.getAdapterDescriptorFactoryByType(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const p=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:w,handle:p,factory:I}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(w,p),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(m=>m.factory!==I),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(p)})}registerDebugAdapterTrackerFactory(o,w){if(!w)return new D.Disposable(()=>{});const I=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:o,handle:I,factory:w}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(p=>p.factory!==w)})}async $runInTerminal(o,w){return Promise.resolve(void 0)}async $substituteVariables(o,w){if(!this._variableResolver){const[m,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(m||[],this._editorsService,R)}let I;const p=await this.getFolder(o);return p&&(I={uri:p.uri,name:p.name,index:p.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(I,w)}createDebugAdapter(o,w){if(o.type==="implementation")return new d(o.implementation)}createSignService(){}async $startDASession(o,w){const I=this,p=await this.getSession(w);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(p.type),p).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}' (extension might have failed to activate)`);const R=this.convertToDto(m),F=this.createDebugAdapter(R,p);if(!F)throw new Error(`Couldn't create a debug adapter for type '${p.type}'.`);const x=F;return this._debugAdapters.set(o,x),this.getDebugAdapterTrackers(p).then(ae=>(ae&&this._debugAdaptersTrackers.set(o,ae),x.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const B=z,G={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(B.arguments.value);G.body={signature:M},x.sendResponse(G)}else throw new Error("no signer")}catch(M){G.success=!1,G.message=M.message,x.sendResponse(G)}}else ae&&ae.onDidSendMessage&&ae.onDidSendMessage(z),z=(0,r.convertToVSCPaths)(z,!0),I._debugServiceProxy.$acceptDAMessage(o,z)}),x.onError(z=>{ae&&ae.onError&&ae.onError(z),this._debugServiceProxy.$acceptDAError(o,z.name,z.message,z.stack)}),x.onExit(z=>{ae&&ae.onExit&&ae.onExit((0,h.withNullAsUndefined)(z),void 0),this._debugServiceProxy.$acceptDAExit(o,(0,h.withNullAsUndefined)(z),void 0)}),ae&&ae.onWillStartSession&&ae.onWillStartSession(),x.startSession()))})}$sendDAMessage(o,w){w=(0,r.convertToDAPaths)(w,!1);const I=this._debugAdaptersTrackers.get(o);I&&I.onWillReceiveMessage&&I.onWillReceiveMessage(w);const p=this._debugAdapters.get(o);p&&p.sendMessage(w)}$stopDASession(o){const w=this._debugAdaptersTrackers.get(o);this._debugAdaptersTrackers.delete(o),w&&w.onWillStopSession&&w.onWillStopSession();const I=this._debugAdapters.get(o);return this._debugAdapters.delete(o),I?I.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const w=[],I=[],p=[];if(o.added)for(const m of o.added){const R=m.id;if(R&&!this._breakpoints.has(R)){let F;if(m.type==="function")F=new D.FunctionBreakpoint(m.functionName,m.enabled,m.condition,m.hitCondition,m.logMessage);else if(m.type==="data")F=new D.DataBreakpoint(m.label,m.dataId,m.canPersist,m.enabled,m.hitCondition,m.condition,m.logMessage);else{const x=k.URI.revive(m.uri);F=new D.SourceBreakpoint(new D.Location(x,new D.Position(m.line,m.character)),m.enabled,m.condition,m.hitCondition,m.logMessage)}F._id=R,this._breakpoints.set(R,F),w.push(F)}}if(o.removed)for(const m of o.removed){const R=this._breakpoints.get(m);R&&(this._breakpoints.delete(m),I.push(R))}if(o.changed){for(const m of o.changed)if(m.id){const R=this._breakpoints.get(m.id);if(R){if(R instanceof D.FunctionBreakpoint&&m.type==="function"){const F=R;F.enabled=m.enabled,F.condition=m.condition,F.hitCondition=m.hitCondition,F.logMessage=m.logMessage,F.functionName=m.functionName}else if(R instanceof D.SourceBreakpoint&&m.type==="source"){const F=R;F.enabled=m.enabled,F.condition=m.condition,F.hitCondition=m.hitCondition,F.logMessage=m.logMessage,F.location=new D.Location(k.URI.revive(m.uri),new D.Position(m.line,m.character))}p.push(R)}}}this.fireBreakpointChanges(w,I,p)}$provideDebugConfigurations(o,w,I){return(0,A.asPromise)(async()=>{const p=this.getConfigProviderByHandle(o);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const m=await this.getFolder(w);return p.provideDebugConfigurations(m,I)}).then(p=>{if(!p)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return p})}$resolveDebugConfiguration(o,w,I,p){return(0,A.asPromise)(async()=>{const m=this.getConfigProviderByHandle(o);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(w);return m.resolveDebugConfiguration(R,I,p)})}$resolveDebugConfigurationWithSubstitutedVariables(o,w,I,p){return(0,A.asPromise)(async()=>{const m=this.getConfigProviderByHandle(o);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(w);return m.resolveDebugConfigurationWithSubstitutedVariables(R,I,p)})}async $provideDebugAdapter(o,w){const I=this.getAdapterDescriptorFactoryByHandle(o);if(!I)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const p=await this.getSession(w);return this.getAdapterDescriptor(I,p).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}'`);return this.convertToDto(m)})}async $acceptDebugSessionStarted(o){const w=await this.getSession(o);this._onDidStartDebugSession.fire(w)}async $acceptDebugSessionTerminated(o){const w=await this.getSession(o);w&&(this._onDidTerminateDebugSession.fire(w),this._debugSessions.delete(w.id))}async $acceptDebugSessionActiveChanged(o){this._activeDebugSession=o?await this.getSession(o):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(o,w){const I=await this.getSession(o);I&&I._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(o,w){const p={session:await this.getSession(o),event:w.event,body:w.body};this._onDidReceiveDebugSessionCustomEvent.fire(p)}convertToDto(o){if(o instanceof D.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof D.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(o){const w=this._adapterFactories.filter(I=>I.type===o);if(w.length>0)return w[0].factory}getAdapterDescriptorFactoryByHandle(o){const w=this._adapterFactories.filter(I=>I.handle===o);if(w.length>0)return w[0].factory}getConfigProviderByHandle(o){const w=this._configProviders.filter(I=>I.handle===o);if(w.length>0)return w[0].provider}definesDebugType(o,w){if(o.contributes){const I=o.contributes.debuggers;if(I&&I.length>0){for(const p of I)if(p.label&&p.type&&p.type===w)return!0}}return!1}getDebugAdapterTrackers(o){const I=o.configuration.type,p=this._trackerFactories.filter(m=>m.type===I||m.type==="*").map(m=>(0,A.asPromise)(()=>m.factory.createDebugAdapterTracker(o)).then(R=>R,R=>null));return Promise.race([Promise.all(p).then(m=>{const R=m.filter(F=>!!F);if(R.length>0)return new i(R)}),new Promise((m,R)=>{const F=setTimeout(()=>{clearTimeout(F),R(new Error("timeout"))},1e3)})]).catch(m=>{})}async getAdapterDescriptor(o,w){const I=w.configuration.debugServer;if(typeof I=="number")return Promise.resolve(new D.DebugAdapterServer(I));if(o){const m=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>o.createDebugAdapterDescriptor(w,this.daExecutableFromPackage(w,m))).then(R=>{if(R)return R})}const p=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(w,p))}daExecutableFromPackage(o,w){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(o,w,I){(o.length>0||w.length>0||I.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:o,removed:w,changed:I}))}async getSession(o){if(o)if(typeof o=="string"){const w=this._debugSessions.get(o);if(w)return w}else{let w=this._debugSessions.get(o.id);if(!w){const I=await this.getFolder(o.folderUri);w=new c(this._debugServiceProxy,o.id,o.type,o.name,I,o.configuration),this._debugSessions.set(w.id,w),this._debugServiceProxy.$sessionCached(w.id)}return w}throw new Error("cannot find session")}getFolder(o){if(o){const w=k.URI.revive(o);return this._workspaceService.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}};v=je([Ke(0,s.IExtHostRpcService),Ke(1,n.IExtHostWorkspace),Ke(2,T.IExtHostExtensionService),Ke(3,C.IExtHostDocumentsAndEditors),Ke(4,f.IExtHostConfiguration)],v),e.ExtHostDebugServiceBase=v;class c{constructor(o,w,I,p,m,R){this._debugServiceProxy=o,this._id=w,this._type=I,this._name=p,this._workspaceFolder=m,this._configuration=R}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(o){this._name=o,this._debugServiceProxy.$setDebugSessionName(this._id,o)}_acceptNameChanged(o){this._name=o}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(o,w){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,o,w)}getDebugProtocolBreakpoint(o){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,o.id)}}e.ExtHostDebugSession=c;class u{constructor(o){this.value=Object.freeze({append(w){o.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.ExtHostDebugConsole=u;class t extends g.AbstractVariableResolverService{constructor(o,w,I,p){super({getFolderUri:m=>{const R=o.filter(F=>F.name===m);if(R&&R.length>0)return R[0].uri},getWorkspaceFolderCount:()=>o.length,getConfigurationValue:(m,R)=>I.getConfiguration(void 0,m).get(R),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(w){const m=w.activeEditor();if(m)return E.normalize(m.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(w&&p){const m=w.activeEditor();if(m){const R=p.getWorkspaceFolder(m.document.uri);if(R)return E.normalize(R.uri.fsPath)}}},getSelectedText:()=>{if(w){const m=w.activeEditor();if(m&&!m.selection.isEmpty)return m.document.getText(m.selection)}},getLineNumber:()=>{if(w){const m=w.activeEditor();if(m)return String(m.selection.end.line+1)}}},void 0,_.env)}}e.ExtHostVariableResolverService=t;class i{constructor(o){this.trackers=o}onWillStartSession(){this.trackers.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.trackers.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.trackers.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(o):void 0)}onWillStopSession(){this.trackers.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.trackers.forEach(w=>w.onError?w.onError(o):void 0)}onExit(o,w){this.trackers.forEach(I=>I.onExit?I.onExit(o,w):void 0)}}class d extends y.AbstractDebugAdapter{constructor(o){super();this.implementation=o,o.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.implementation.handleMessage(o)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends v{constructor(o,w,I,p,m){super(o,w,I,p,m)}createVariableResolver(o,w,I){return new t(o,w,I)}};a=je([Ke(0,s.IExtHostRpcService),Ke(1,n.IExtHostWorkspace),Ke(2,T.IExtHostExtensionService),Ke(3,C.IExtHostDocumentsAndEditors),Ke(4,f.IExtHostConfiguration)],a),e.WorkerExtHostDebugService=a}),define(ve[220],_e([0,1,78,2,5,34,33,26,15,27,4,35,45,19]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(v,c,u,t,i,d,a){this._apiFactory=v,this._extensionRegistry=c,this._instaService=u,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=d,this._logService=a,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),E.mark("code/extHost/willWaitForConfig");const v=await this._extHostConfiguration.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const c=await this._extHostExtensionService.getExtensionPathIndex();this.register(new s(this._apiFactory,c,this._extensionRegistry,v,this._logService)),this.register(this._instaService.createInstance(b)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(h,c,this._initData.environment.appUriScheme))}register(v){if(Array.isArray(v.nodeModuleName))for(let c of v.nodeModuleName)this._factories.set(c,v);else this._factories.set(v.nodeModuleName,v);typeof v.alternativeModuleName=="function"&&this._alternatives.push(c=>v.alternativeModuleName(c))}};r=je([Ke(2,T.IInstantiationService),Ke(3,A.IExtHostConfiguration),Ke(4,C.IExtHostExtensionService),Ke(5,n.IExtHostInitDataService),Ke(6,f.ILogService)],r),e.RequireInterceptor=r;class s{constructor(v,c,u,t,i){this._apiFactory=v,this._extensionPaths=c,this._extensionRegistry=u,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(v,c){const u=this._extensionPaths.findSubstr(c.fsPath);if(u){let t=this._extApiImpl.get(D.ExtensionIdentifier.toKey(u.identifier));return t||(t=this._apiFactory(u,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(u.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,d)=>t+=`	${d} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${c.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(S.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let b=class{constructor(v,c){this.nodeModuleName="keytar";const{environment:u}=c,t=v.getProxy(P.MainContext.MainThreadKeytar);if(u.appRoot){let i=u.appRoot.fsPath;g.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,d)=>t.$getPassword(i,d),setPassword:(i,d,a)=>t.$setPassword(i,d,a),deletePassword:(i,d)=>t.$deletePassword(i,d),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(v,c){return this._impl}alternativeModuleName(v){const c=v.length;if(!(c<=7||!this.alternativeNames)){const u=c-7;if((v.charAt(u)==="/"||v.charAt(u)==="\\")&&v.endsWith("keytar")&&(v=v.replace(/\\/g,"/"),this.alternativeNames.has(v)))return"keytar"}}};b=je([Ke(0,y.IExtHostRpcService),Ke(1,n.IExtHostInitDataService)],b);let h=class{constructor(v,c,u){this._extensionPaths=v,this._appUriScheme=c,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=u.getProxy(P.MainContext.MainThreadTelemetry);const t=u.getProxy(P.MainContext.MainThreadWindow);this._impl=(i,d)=>{const a=k.URI.parse(i);return d?this.callOriginal(i,d):a.scheme==="http"||a.scheme==="https"?t.$openUri(a,i,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this._appUriScheme?t.$openUri(a,i,{}):this.callOriginal(i,d)}}load(v,c,u){const t=this._extensionPaths.findSubstr(c.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=u(v),this._impl}callOriginal(v,c){return this.sendNoForwardTelemetry(),this._original(v,c)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};h=je([Ke(2,y.IExtHostRpcService)],h)}),define(ve[221],_e([0,1,14,10,78,6,2,5,213,19,61,65,27,150,15,69,35,40]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g,f,r,s,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(c,u,t,i){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const d=new y.RPCProtocol(c,null,i);u=_._transform(u,d);const a=new C.ServiceCollection(...(0,T.getSingletonServiceDescriptors)());a.set(g.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},u)),a.set(r.IExtHostRpcService,new r.ExtHostRpcService(d)),a.set(s.IURITransformerService,new s.URITransformerService(i)),a.set(b.IHostUtils,t);const l=new f.InstantiationService(a,!0),o=l.invokeFunction(m=>m.get(h.IExtHostTerminalService));this._disposables.add(o),this._logService=l.invokeFunction(m=>m.get(n.ILogService)),P.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",u),this._extensionService=l.invokeFunction(m=>m.get(b.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const w=new WeakMap;this._extensionService.getExtensionPathIndex().then(m=>{Error.prepareStackTrace=(R,F)=>{let x="",ae,z;for(const B of F)x+=`
	at ${B.toString()}`,z=B.getFileName(),!ae&&z&&(ae=m.findSubstr(z));return w.set(R,ae),`${R.name||"Error"}: ${R.message||""}${x}`}});const I=d.getProxy(D.MainContext.MainThreadExtensionService),p=d.getProxy(D.MainContext.MainThreadErrors);k.setUnexpectedErrorHandler(m=>{const R=k.transformErrorForSerialization(m),F=w.get(m);F?I.$onExtensionRuntimeError(F.identifier,R):p.$onUnexpectedError(R)})}terminate(c){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),k.setUnexpectedErrorHandler(t=>{});const u=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,E.timeout)(4e3),u]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(c,u){c.extensions.forEach(i=>i.extensionLocation=S.URI.revive(u.transformIncomingURIs(i.extensionLocation))),c.environment.appRoot=S.URI.revive(u.transformIncomingURIs(c.environment.appRoot));const t=c.environment.extensionDevelopmentLocationURI;return t&&(c.environment.extensionDevelopmentLocationURI=t.map(i=>S.URI.revive(u.transformIncomingURIs(i)))),c.environment.extensionTestsLocationURI=S.URI.revive(u.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=S.URI.revive(u.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=S.URI.revive(u.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=S.URI.revive(u.transformIncomingURIs(c.logsLocation)),c.logFile=S.URI.revive(u.transformIncomingURIs(c.logFile)),c.workspace=u.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=_}),define(ve[222],_e([0,1,12,20,60,28,25,55,41]),function(ie,e,E,k,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class n{constructor(g,f,r){this.config=g,this.provider=f,this.sessionToken=r,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=g.filePattern,this.includePattern=g.includePattern&&A.parse(g.includePattern),this.maxResults=g.maxResults||void 0,this.exists=g.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=g.excludePattern&&A.parse(g.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(g=>g.cancel()),this.activeCancellationTokens=new Set}search(g){const f=this.config.folderQueries||[];return new Promise((r,s)=>{const b=h=>{this.resultCount++,g(h)};if(this.isCanceled)return r({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(h=>{const _=h.toString(),v=E.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,v)||this.matchFile(b,{base:h,basename:v})}),Promise.all(f.map(h=>this.searchInFolder(h,b))).then(h=>{r({limitHit:this.isLimitHit,stats:h[0]||void 0})},h=>{s(new Error((0,P.toErrorMessage)(h)))})})}async searchInFolder(g,f){const r=new k.CancellationTokenSource,s=this.getSearchOptionsForFolder(g),b=this.initDirectoryTree(),h=new y.QueryGlobTester(this.config,g),_=!h.hasSiblingExcludeClauses();let v;try{this.activeCancellationTokens.add(r),v=D.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},s,r.token),u=v.elapsed(),t=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(i=>{const d=E.posix.relative(g.folder.path,i.path);if(_){const a=E.basename(i.path);this.matchFile(f,{base:g.folder,relativePath:d,basename:a});return}this.addDirectoryEntries(b,g.folder,d,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(b,h,f),{providerTime:u,postProcessTime:t.elapsed()})}finally{r.dispose(),this.activeCancellationTokens.delete(r)}}getSearchOptionsForFolder(g){const f=(0,y.resolvePatternsForProvider)(this.config.includePattern,g.includePattern),r=(0,y.resolvePatternsForProvider)(this.config.excludePattern,g.excludePattern);return{folder:g.folder,excludes:r,includes:f,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,followSymlinks:!g.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const g={rootEntries:[],pathToEntries:Object.create(null)};return g.pathToEntries["."]=g.rootEntries,g}addDirectoryEntries({pathToEntries:g},f,r,s){if(r===this.filePattern){const h=E.basename(this.filePattern);this.matchFile(s,{base:f,relativePath:this.filePattern,basename:h})}function b(h){const _=E.basename(h),v=E.dirname(h);let c=g[v];c||(c=g[v]=[],b(v)),c.push({base:f,relativePath:h,basename:_})}b(r)}matchDirectoryTree({rootEntries:g,pathToEntries:f},r,s){const b=this,h=this.filePattern;function _(v){const c=A.hasSiblingFn(()=>v.map(u=>u.basename));for(let u=0,t=v.length;u<t;u++){const i=v[u],{relativePath:d,basename:a}=i;if(!!r.includedInQuerySync(d,a,h!==a?c:void 0)){const l=f[d];if(l)_(l);else{if(d===h)continue;b.matchFile(s,i)}if(b.isLimitHit)break}}}_(g)}matchFile(g,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||g(f))}}class T{constructor(){this.sessions=new Map}fileSearch(g,f,r,s){const b=this.getSessionTokenSource(g.cacheKey),h=new n(g,f,b&&b.token);let _=0;const v=c=>{_+=c.length,r(c.map(u=>this.rawMatchToSearchItem(u)))};return this.doSearch(h,T.BATCH_SIZE,v,s).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:c.stats}}))}clearCache(g){const f=this.getSessionTokenSource(g);f&&f.cancel()}getSessionTokenSource(g){if(!!g)return this.sessions.has(g)||this.sessions.set(g,new k.CancellationTokenSource),this.sessions.get(g)}rawMatchToSearchItem(g){return g.relativePath?{resource:S.joinPath(g.base,g.relativePath)}:{resource:g.base}}doSearch(g,f,r,s){s.onCancellationRequested(()=>{g.cancel()});const b=_=>{_&&(h.push(_),f>0&&h.length>=f&&(r(h),h=[]))};let h=[];return g.search(b).then(_=>(h.length&&r(h),_),_=>(h.length&&r(h),Promise.reject(_)))}}e.FileSearchManager=T,T.BATCH_SIZE=512}),define(ve[223],_e([0,1,12,11,20,60,25,28,2,41,18]),function(ie,e,E,k,P,A,S,D,y,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class C{constructor(_,v,c){this.query=_,this.provider=v,this.fileUtils=c,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(_,v){const c=this.query.folderQueries||[],u=new P.CancellationTokenSource;return v.onCancellationRequested(()=>u.cancel()),new Promise((t,i)=>{this.collector=new f(_);let d=!1;const a=(l,o)=>{if(!d&&!this.isLimitHit){const w=this.resultSize(l);s(l)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,d=!0,u.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const I=this.resultSize(l);this.resultCount+=I,(I>0||!s(l))&&this.collector.add(l,o)}};Promise.all(c.map((l,o)=>this.searchInFolder(l,w=>a(w,o),u.token))).then(l=>{u.dispose(),this.collector.flush();const o=l.some(w=>!!w&&!!w.limitHit);t({limitHit:this.isLimitHit||o,stats:{type:"textSearchProvider"}})},l=>{u.dispose();const o=(0,A.toErrorMessage)(l);i(new Error(o))})})}resultSize(_){return s(_)?Array.isArray(_.ranges)?_.ranges.length:1:0}trimResultToSize(_,v){const c=Array.isArray(_.ranges)?_.ranges:[_.ranges],u=Array.isArray(_.preview.matches)?_.preview.matches:[_.preview.matches];return{ranges:c.slice(0,v),preview:{matches:u.slice(0,v),text:_.preview.text},uri:_.uri}}async searchInFolder(_,v,c){const u=new n.QueryGlobTester(this.query,_),t=[],i={report:l=>{if(!!this.validateProviderResult(l)){const o=_.folder.scheme===T.Schemas.file?D.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(l.uri))):void 0,w=S.relativePath(_.folder,l.uri);w&&t.push(u.includedInQuery(w,E.basename(w),o).then(I=>{I&&v(l)}))}}},d=this.getSearchOptionsForFolder(_),a=await this.provider.provideTextSearchResults(g(this.query.contentPattern),d,i,c);return await Promise.all(t),a}validateProviderResult(_){if(s(_)){if(Array.isArray(_.ranges)){if(!Array.isArray(_.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(_.preview.matches.length!==_.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(_.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(_){const v=(0,n.resolvePatternsForProvider)(this.query.includePattern,_.includePattern),c=(0,n.resolvePatternsForProvider)(this.query.excludePattern,_.excludePattern),u={folder:y.URI.from(_.folder),excludes:c,includes:v,useIgnoreFiles:!_.disregardIgnoreFiles,useGlobalIgnoreFiles:!_.disregardGlobalIgnoreFiles,followSymlinks:!_.ignoreSymlinks,encoding:_.fileEncoding&&this.fileUtils.toCanonicalName(_.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return u.usePCRE2=this.query.usePCRE2,u}}e.TextSearchManager=C;function g(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class f{constructor(_){this._onResult=_,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new b(512,v=>this.sendItems(v))}add(_,v){this._currentFileMatch&&(this._currentFolderIdx!==v||!S.isEqual(this._currentUri,_.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=v,this._currentFileMatch={resource:_.uri,results:[]}),this._currentFileMatch.results.push(r(_))}pushToCollector(){const _=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,_)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(_){this._onResult(_)}}e.TextSearchResultsCollector=f;function r(h){return s(h)?{preview:{matches:(0,k.mapArrayOrNot)(h.preview.matches,_=>({startLineNumber:_.start.line,startColumn:_.start.character,endLineNumber:_.end.line,endColumn:_.end.character})),text:h.preview.text},ranges:(0,k.mapArrayOrNot)(h.ranges,_=>({startLineNumber:_.start.line,startColumn:_.start.character,endLineNumber:_.end.line,endColumn:_.end.character}))}:{text:h.text,lineNumber:h.lineNumber}}function s(h){return!!h.preview}e.extensionResultIsMatch=s;class b{constructor(_,v){this.maxBatchSize=_,this.cb=v,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(_,v){!_||this.addItemToBatch(_,v)}addItems(_,v){!_||this.addItemsToBatch(_,v)}addItemToBatch(_,v){this.batch.push(_),this.batchSize+=v,this.onUpdate()}addItemsToBatch(_,v){this.batch=this.batch.concat(_),this.batchSize+=v,this.onUpdate()}onUpdate(){this.totalNumberCompleted<b.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},b.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=b,b.TIMEOUT=4e3,b.START_BATCH_AFTER_COUNT=50}),define(ve[103],_e([0,1,6,5,4,222,15,69,19,2,223]),function(ie,e,E,k,P,A,S,D,y,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,P.createDecorator)("IExtHostSearch");let C=class{constructor(s,b,h){this.extHostRpc=s,this._uriTransformer=b,this._logService=h,this._proxy=this.extHostRpc.getProxy(k.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(s){return this._uriTransformer.transformOutgoingScheme(s)}registerTextSearchProvider(s,b){if(this._textSearchUsedSchemes.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this._textSearchUsedSchemes.add(s);const h=this._handlePool++;return this._textSearchProvider.set(h,b),this._proxy.$registerTextSearchProvider(h,this._transformScheme(s)),(0,E.toDisposable)(()=>{this._textSearchUsedSchemes.delete(s),this._textSearchProvider.delete(h),this._proxy.$unregisterProvider(h)})}registerFileSearchProvider(s,b){if(this._fileSearchUsedSchemes.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this._fileSearchUsedSchemes.add(s);const h=this._handlePool++;return this._fileSearchProvider.set(h,b),this._proxy.$registerFileSearchProvider(h,this._transformScheme(s)),(0,E.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(s),this._fileSearchProvider.delete(h),this._proxy.$unregisterProvider(h)})}$provideFileSearchResults(s,b,h,_){const v=g(h),c=this._fileSearchProvider.get(s);if(c)return this._fileSearchManager.fileSearch(v,c,u=>{this._proxy.$handleFileMatch(s,b,u.map(t=>t.resource))},_);throw new Error("unknown provider: "+s)}$clearCache(s){return this._fileSearchManager.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,b,h,_){const v=this._textSearchProvider.get(s);if(!v||!v.provideTextSearchResults)throw new Error(`Unknown provider ${s}`);const c=g(h);return this.createTextSearchManager(c,v).search(t=>this._proxy.$handleTextMatch(s,b,t),_)}createTextSearchManager(s,b){return new T.TextSearchManager(s,b,{readdir:h=>Promise.resolve([]),toCanonicalName:h=>h})}};C=je([Ke(0,S.IExtHostRpcService),Ke(1,D.IURITransformerService),Ke(2,y.ILogService)],C),e.ExtHostSearch=C;function g(r){return Object.assign(Object.assign({},r),{folderQueries:r.folderQueries&&r.folderQueries.map(f),extraFileResources:r.extraFileResources&&r.extraFileResources.map(s=>n.URI.revive(s))})}e.reviveQuery=g;function f(r){return Object.assign(Object.assign({},r),{folder:n.URI.revive(r.folder)})}}),define(ve[224],_e([0,1,128,20,10,3,46,2,121,83,115,59,64,5,189,188,74,190,34,191,192,193,175,194,39,35,195,176,197,198,199,99,179,202,203,204,76,40,205,180,9,7,208,49,100,31,33,50,165,196,92,98,101,102,103,19,69,15,27,200,163,68,73,186,206,162,77,75,211,209,210,187,48,217,207,72,159,93,201]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g,f,r,s,b,h,_,v,c,u,t,i,d,a,l,o,w,I,p,m,R,F,x,ae,z,B,G,M,N,W,Q,$,Z,re,se,ye,Pe,$e,Re,ze,U,K,te,le,me,Se,Me,ge,Ce,Ae,Be,be,qe,j,X,pe,Le,He,Ue,Ze,H,ne,he,q,Y,oe,fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ee(Ne){const Fe=Ne.get(Me.IExtHostInitDataService),Ve=Ne.get(H.IExtHostFileSystemInfo),Xe=Ne.get(pe.IExtHostConsumerFileSystem),tt=Ne.get(a.IExtHostExtensionService),nt=Ne.get(re.IExtHostWorkspace),rt=Ne.get(oe.IExtHostTelemetry),it=Ne.get(_.IExtHostConfiguration),gt=Ne.get(me.IURITransformerService),ce=Ne.get(Se.IExtHostRpcService),De=Ne.get(z.IExtHostStorage),ue=Ne.get(X.IExtensionStoragePaths),V=Ne.get(le.ILogService),Oe=Ne.get(Ae.IExtHostTunnelService),Ie=Ne.get(Be.IExtHostApiDeprecationService),Je=Ne.get(Z.IExtHostWindow),Ge=Ne.get(q.IExtHostSecretState);ce.set(f.ExtHostContext.ExtHostFileSystemInfo,Ve),ce.set(f.ExtHostContext.ExtHostLogService,V),ce.set(f.ExtHostContext.ExtHostWorkspace,nt),ce.set(f.ExtHostContext.ExtHostConfiguration,it),ce.set(f.ExtHostContext.ExtHostExtensionService,tt),ce.set(f.ExtHostContext.ExtHostStorage,De),ce.set(f.ExtHostContext.ExtHostTunnelService,Oe),ce.set(f.ExtHostContext.ExtHostWindow,Je),ce.set(f.ExtHostContext.ExtHostSecretState,Ge),ce.set(f.ExtHostContext.ExtHostTelemetry,rt);const lt=ce.set(f.ExtHostContext.ExtHostDecorations,Ne.get(ze.IExtHostDecorations)),at=ce.set(f.ExtHostContext.ExtHostDocumentsAndEditors,Ne.get(d.IExtHostDocumentsAndEditors)),Qe=ce.set(f.ExtHostContext.ExtHostCommands,Ne.get(b.IExtHostCommands)),st=ce.set(f.ExtHostContext.ExtHostTerminalService,Ne.get(B.IExtHostTerminalService)),ct=ce.set(f.ExtHostContext.ExtHostDebugService,Ne.get(K.IExtHostDebugService)),pt=ce.set(f.ExtHostContext.ExtHostSearch,Ne.get(te.IExtHostSearch)),vt=ce.set(f.ExtHostContext.ExtHostTask,Ne.get(U.IExtHostTask)),bt=ce.set(f.ExtHostContext.ExtHostOutputService,Ne.get(m.IExtHostOutputService)),wt=ce.set(f.ExtHostContext.ExtHostEditorTabs,new Y.ExtHostEditorTabs),yt=ce.set(f.ExtHostContext.ExtHostUrls,new Q.ExtHostUrls(ce)),_t=ce.set(f.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(ce,at)),Mt=ce.set(f.ExtHostContext.ExtHostDocumentContentProviders,new u.ExtHostDocumentContentProvider(ce,at,V)),Tt=ce.set(f.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(V,_t,ce.getProxy(f.MainContext.MainThreadBulkEdits))),ft=ce.set(f.ExtHostContext.ExtHostNotebook,new ge.ExtHostNotebookController(ce,Qe,at,_t,Fe.environment,V,ue)),zt=ce.set(f.ExtHostContext.ExtHostNotebookKernels,new fe.ExtHostNotebookKernels(ce,ft)),Et=ce.set(f.ExtHostContext.ExtHostEditors,new G.ExtHostEditors(ce,at)),Bt=ce.set(f.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(ce.getProxy(f.MainContext.MainThreadTreeViews),Qe,V)),Vt=ce.set(f.ExtHostContext.ExtHostEditorInsets,new Pe.ExtHostEditorInsets(ce.getProxy(f.MainContext.MainThreadEditorInsets),Et,Fe.environment)),Ot=ce.set(f.ExtHostContext.ExtHostDiagnostics,new v.ExtHostDiagnostics(ce,V)),dt=ce.set(f.ExtHostContext.ExtHostLanguageFeatures,new w.ExtHostLanguageFeatures(ce,gt,_t,Qe,Ot,V,Ie)),dn=ce.set(f.ExtHostContext.ExtHostFileSystem,new l.ExtHostFileSystem(ce,dt)),kt=ce.set(f.ExtHostContext.ExtHostFileSystemEventService,new o.ExtHostFileSystemEventService(ce,V,at)),Rt=ce.set(f.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(ce,nt,Qe)),en=ce.set(f.ExtHostContext.ExtHostSCM,new x.ExtHostSCM(ce,Qe,V)),hn=ce.set(f.ExtHostContext.ExtHostComments,new h.ExtHostComments(ce,Qe,_t)),tn=ce.set(f.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(ce.getProxy(f.MainContext.MainThreadProgress))),fn=ce.set(f.ExtHostContext.ExtHosLabelService,new $e.ExtHostLabelService(ce)),nn=ce.set(f.ExtHostContext.ExtHostTheming,new Ce.ExtHostTheming(ce)),Pt=ce.set(f.ExtHostContext.ExtHostAuthentication,new be.ExtHostAuthentication(ce)),jt=ce.set(f.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(ce,Qe)),qt=ce.set(f.ExtHostContext.ExtHostWebviews,new $.ExtHostWebviews(ce,Fe.environment,nt,V,Ie)),Kt=ce.set(f.ExtHostContext.ExtHostWebviewPanels,new Ue.ExtHostWebviewPanels(ce,qt,nt)),mn=ce.set(f.ExtHostContext.ExtHostCustomEditors,new He.ExtHostCustomEditors(ce,_t,ue,qt,Kt)),gn=ce.set(f.ExtHostContext.ExtHostWebviewViews,new Le.ExtHostWebviewViews(ce,qt)),Dt=ce.set(f.ExtHostContext.ExtHostTesting,new ne.ExtHostTesting(ce,at,nt)),pn=ce.set(f.ExtHostContext.ExtHostUriOpeners,new he.ExtHostUriOpeners(ce)),vn=(0,ye.values)(f.ExtHostContext);ce.assertRegistered(vn);const Gt=new Ze.ExtHostBulkEdits(ce,at),bn=new s.ExtHostClipboard(ce),Nt=new p.ExtHostMessageService(ce,V),Wt=new c.ExtHostDialogs(ce),Ut=new ae.ExtHostStatusBar(ce,Qe.converter),Qt=new I.ExtHostLanguages(ce,_t);return r.ExtHostApiCommands.register(Qe),function(Te,xt,Jt){const mt=function(){let J=!Te.isUnderDevelopment;function de(ke){J||(V.info(`Extension '${Te.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),J=!0)}return function ke(ut){if(Array.isArray(ut))ut.forEach(ke);else if(typeof ut=="string")de(ut);else{const O=ut;typeof O.scheme=="undefined"&&de(ut),!Te.enableProposedApi&&typeof O.exclusive=="boolean"&&(0,se.throwProposedApiError)(Te)}return ut}}(),_n={getSession(J,de,ke){return Pt.getSession(Te,J,de,ke)},get onDidChangeSessions(){return Pt.onDidChangeSessions},registerAuthenticationProvider(J,de,ke,ut){return Pt.registerAuthenticationProvider(J,de,ke,ut)},get onDidChangeAuthenticationProviders(){return(0,se.checkProposedApiEnabled)(Te),Pt.onDidChangeAuthenticationProviders},get providers(){return(0,se.checkProposedApiEnabled)(Te),Pt.providers},logout(J,de){return(0,se.checkProposedApiEnabled)(Te),Pt.removeSession(J,de)}},wn={registerCommand(J,de,ke){return Qe.registerCommand(!0,J,de,ke)},registerTextEditorCommand(J,de,ke){return Qe.registerCommand(!0,J,(...ut)=>{const O=Et.getActiveTextEditor();if(!O){V.warn("Cannot execute "+J+" because there is no active text editor.");return}return O.edit(L=>{de.apply(ke,[O,L,...ut])}).then(L=>{L||V.warn("Edits from command "+J+" were not applied.")},L=>{V.warn("An error occurred while running command "+J,L)})})},registerDiffInformationCommand:(J,de,ke)=>((0,se.checkProposedApiEnabled)(Te),Qe.registerCommand(!0,J,async(...ut)=>{const O=at.activeEditor(!0);if(!O){V.warn("Cannot execute "+J+" because there is no active text editor.");return}const L=await Et.getDiffInformation(O.id);de.apply(ke,[L,...ut])})),executeCommand(J,...de){return Qe.executeCommand(J,...de)},getCommands(J=!1){return Qe.getCommands(J)}},rn={get machineId(){return Fe.telemetryInfo.machineId},get sessionId(){return Fe.telemetryInfo.sessionId},get language(){return Fe.environment.appLanguage},get appName(){return Fe.environment.appName},get appRoot(){var J,de;return(de=(J=Fe.environment.appRoot)===null||J===void 0?void 0:J.fsPath)!==null&&de!==void 0?de:""},get uriScheme(){return Fe.environment.appUriScheme},get clipboard(){return bn.value},get shell(){return st.getDefaultShell(!1,Jt)},get isTelemetryEnabled(){return rt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return rt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const J=Date.now()-new Date(Fe.telemetryInfo.firstSessionDate).getTime();return isNaN(J)?!1:J<1e3*60*60*24},openExternal(J,de){return Je.openUri(J,{allowTunneling:!!Fe.remote.authority,allowContributedOpeners:de==null?void 0:de.allowContributedOpeners})},asExternalUri(J){return J.scheme===Fe.environment.appUriScheme?yt.createAppUri(J):Je.asExternalUri(J,{allowTunneling:!!Fe.remote.authority})},get remoteName(){return(0,Re.getRemoteName)(Fe.remote.authority)},get uiKind(){return Fe.uiKind}};Fe.environment.extensionTestsLocationURI||Object.freeze(rn);const sn=Fe.remote.isRemote?W.ExtensionKind.Workspace:W.ExtensionKind.UI,Yt={registerTestProvider(J){return(0,se.checkProposedApiEnabled)(Te),Dt.registerTestProvider(J)},createDocumentTestObserver(J){return(0,se.checkProposedApiEnabled)(Te),Dt.createTextDocumentTestObserver(J)},createWorkspaceTestObserver(J){return(0,se.checkProposedApiEnabled)(Te),Dt.createWorkspaceTestObserver(J)},runTests(J){return(0,se.checkProposedApiEnabled)(Te),Dt.runTests(J)},publishTestResult(J,de=!0){return(0,se.checkProposedApiEnabled)(Te),Dt.publishExtensionProvidedResults(J,de)},get onDidChangeTestResults(){return(0,se.checkProposedApiEnabled)(Te),Dt.onResultsChanged},get testResults(){return(0,se.checkProposedApiEnabled)(Te),Dt.results}},En={getExtension(J){const de=xt.getExtensionDescription(J);if(de)return new a.Extension(tt,Te.identifier,de,sn)},get all(){return xt.getAllExtensionDescriptions().map(J=>new a.Extension(tt,Te.identifier,J,sn))},get onDidChange(){return xt.onDidChange}},yn={createDiagnosticCollection(J){return Ot.createDiagnosticCollection(Te.identifier,J)},get onDidChangeDiagnostics(){return Ot.onDidChangeDiagnostics},getDiagnostics:J=>Ot.getDiagnostics(J),getLanguages(){return Qt.getLanguages()},setTextDocumentLanguage(J,de){return Qt.changeLanguage(J.uri,de)},match(J,de){return(0,C.score)(N.LanguageSelector.from(J),de.uri,de.languageId,!0)},registerCodeActionsProvider(J,de,ke){return dt.registerCodeActionProvider(Te,mt(J),de,ke)},registerCodeLensProvider(J,de){return dt.registerCodeLensProvider(Te,mt(J),de)},registerDefinitionProvider(J,de){return dt.registerDefinitionProvider(Te,mt(J),de)},registerDeclarationProvider(J,de){return dt.registerDeclarationProvider(Te,mt(J),de)},registerImplementationProvider(J,de){return dt.registerImplementationProvider(Te,mt(J),de)},registerTypeDefinitionProvider(J,de){return dt.registerTypeDefinitionProvider(Te,mt(J),de)},registerHoverProvider(J,de){return dt.registerHoverProvider(Te,mt(J),de,Te.identifier)},registerEvaluatableExpressionProvider(J,de){return dt.registerEvaluatableExpressionProvider(Te,mt(J),de,Te.identifier)},registerInlineValuesProvider(J,de){return dt.registerInlineValuesProvider(Te,mt(J),de,Te.identifier)},registerDocumentHighlightProvider(J,de){return dt.registerDocumentHighlightProvider(Te,mt(J),de)},registerLinkedEditingRangeProvider(J,de){return dt.registerLinkedEditingRangeProvider(Te,mt(J),de)},registerReferenceProvider(J,de){return dt.registerReferenceProvider(Te,mt(J),de)},registerRenameProvider(J,de){return dt.registerRenameProvider(Te,mt(J),de)},registerDocumentSymbolProvider(J,de,ke){return dt.registerDocumentSymbolProvider(Te,mt(J),de,ke)},registerWorkspaceSymbolProvider(J){return dt.registerWorkspaceSymbolProvider(Te,J)},registerDocumentFormattingEditProvider(J,de){return dt.registerDocumentFormattingEditProvider(Te,mt(J),de)},registerDocumentRangeFormattingEditProvider(J,de){return dt.registerDocumentRangeFormattingEditProvider(Te,mt(J),de)},registerOnTypeFormattingEditProvider(J,de,ke,...ut){return dt.registerOnTypeFormattingEditProvider(Te,mt(J),de,[ke].concat(ut))},registerDocumentSemanticTokensProvider(J,de,ke){return dt.registerDocumentSemanticTokensProvider(Te,mt(J),de,ke)},registerDocumentRangeSemanticTokensProvider(J,de,ke){return dt.registerDocumentRangeSemanticTokensProvider(Te,mt(J),de,ke)},registerSignatureHelpProvider(J,de,ke,...ut){return typeof ke=="object"?dt.registerSignatureHelpProvider(Te,mt(J),de,ke):dt.registerSignatureHelpProvider(Te,mt(J),de,typeof ke=="undefined"?[]:[ke,...ut])},registerCompletionItemProvider(J,de,...ke){return dt.registerCompletionItemProvider(Te,mt(J),de,ke)},registerDocumentLinkProvider(J,de){return dt.registerDocumentLinkProvider(Te,mt(J),de)},registerColorProvider(J,de){return dt.registerColorProvider(Te,mt(J),de)},registerFoldingRangeProvider(J,de){return dt.registerFoldingRangeProvider(Te,mt(J),de)},registerSelectionRangeProvider(J,de){return dt.registerSelectionRangeProvider(Te,J,de)},registerCallHierarchyProvider(J,de){return dt.registerCallHierarchyProvider(Te,J,de)},setLanguageConfiguration:(J,de)=>dt.setLanguageConfiguration(Te,J,de),getTokenInformationAtPosition(J,de){return(0,se.checkProposedApiEnabled)(Te),Qt.tokenAtPosition(J,de)},registerInlineHintsProvider(J,de){return(0,se.checkProposedApiEnabled)(Te),dt.registerInlineHintsProvider(Te,J,de)}},Sn={get activeTextEditor(){return Et.getActiveTextEditor()},get visibleTextEditors(){return Et.getVisibleTextEditors()},get activeTerminal(){return st.activeTerminal},get terminals(){return st.terminals},async showTextDocument(J,de,ke){const ut=await(D.URI.isUri(J)?Promise.resolve(on.openTextDocument(J)):Promise.resolve(J));return Et.showTextDocument(ut,de,ke)},createTextEditorDecorationType(J){return Et.createTextEditorDecorationType(J)},onDidChangeActiveTextEditor(J,de,ke){return Et.onDidChangeActiveTextEditor(J,de,ke)},onDidChangeVisibleTextEditors(J,de,ke){return Et.onDidChangeVisibleTextEditors(J,de,ke)},onDidChangeTextEditorSelection(J,de,ke){return Et.onDidChangeTextEditorSelection(J,de,ke)},onDidChangeTextEditorOptions(J,de,ke){return Et.onDidChangeTextEditorOptions(J,de,ke)},onDidChangeTextEditorVisibleRanges(J,de,ke){return Et.onDidChangeTextEditorVisibleRanges(J,de,ke)},onDidChangeTextEditorViewColumn(J,de,ke){return Et.onDidChangeTextEditorViewColumn(J,de,ke)},onDidCloseTerminal(J,de,ke){return st.onDidCloseTerminal(J,de,ke)},onDidOpenTerminal(J,de,ke){return st.onDidOpenTerminal(J,de,ke)},onDidChangeActiveTerminal(J,de,ke){return st.onDidChangeActiveTerminal(J,de,ke)},onDidChangeTerminalDimensions(J,de,ke){return(0,se.checkProposedApiEnabled)(Te),st.onDidChangeTerminalDimensions(J,de,ke)},onDidWriteTerminalData(J,de,ke){return(0,se.checkProposedApiEnabled)(Te),st.onDidWriteTerminalData(J,de,ke)},get state(){return Je.state},onDidChangeWindowState(J,de,ke){return Je.onDidChangeWindowState(J,de,ke)},showInformationMessage(J,...de){return Nt.showMessage(Te,S.default.Info,J,de[0],de.slice(1))},showWarningMessage(J,...de){return Nt.showMessage(Te,S.default.Warning,J,de[0],de.slice(1))},showErrorMessage(J,...de){return Nt.showMessage(Te,S.default.Error,J,de[0],de.slice(1))},showQuickPick(J,de,ke){return Rt.showQuickPick(J,!!Te.enableProposedApi,de,ke)},showWorkspaceFolderPick(J){return Rt.showWorkspaceFolderPick(J)},showInputBox(J,de){return Rt.showInput(J,de)},showOpenDialog(J){return Wt.showOpenDialog(J)},showSaveDialog(J){return Wt.showSaveDialog(J)},createStatusBarItem(J,de){let ke,ut,O,L;return J&&typeof J!="number"?(ke=J.id,ut=J.name,O=J.alignment,de=J.priority,L=J.accessibilityInformation):(ke=Te.identifier.value,ut=E.localize(0,null,Te.displayName||Te.name),O=J),Ut.createStatusBarEntry(ke,ut,O,de,L)},setStatusBarMessage(J,de){return Ut.setStatusBarMessage(J,de)},withScmProgress(J){return Ie.report("window.withScmProgress",Te,"Use 'withProgress' instead."),tn.withProgress(Te,{location:W.ProgressLocation.SourceControl},(de,ke)=>J({report(ut){}}))},withProgress(J,de){return tn.withProgress(Te,J,de)},createOutputChannel(J){return bt.createOutputChannel(J)},createWebviewPanel(J,de,ke,ut){return Kt.createWebviewPanel(Te,J,de,ke,ut)},createWebviewTextEditorInset(J,de,ke,ut){return(0,se.checkProposedApiEnabled)(Te),Vt.createWebviewEditorInset(J,de,ke,ut,Te)},createTerminal(J,de,ke){return typeof J=="object"?"pty"in J?st.createExtensionTerminal(J):(J.message&&(0,se.checkProposedApiEnabled)(Te),J.icon&&(0,se.checkProposedApiEnabled)(Te),st.createTerminalFromOptions(J)):st.createTerminal(J,de,ke)},registerTerminalLinkProvider(J){return st.registerLinkProvider(J)},registerTreeDataProvider(J,de){return Bt.registerTreeDataProvider(J,de,Te)},createTreeView(J,de){return Bt.createTreeView(J,de,Te)},registerWebviewPanelSerializer:(J,de)=>Kt.registerWebviewPanelSerializer(Te,J,de),registerCustomEditorProvider:(J,de,ke={})=>mn.registerCustomEditorProvider(Te,J,de,ke),registerFileDecorationProvider(J){return lt.registerFileDecorationProvider(J,Te.identifier)},registerUriHandler(J){return yt.registerUriHandler(Te.identifier,J)},createQuickPick(){return Rt.createQuickPick(Te.identifier,!!Te.enableProposedApi)},createInputBox(){return Rt.createInputBox(Te.identifier)},get activeColorTheme(){return nn.activeColorTheme},onDidChangeActiveColorTheme(J,de,ke){return nn.onDidChangeActiveColorTheme(J,de,ke)},registerWebviewViewProvider(J,de,ke){return gn.registerWebviewViewProvider(Te,J,de,ke==null?void 0:ke.webviewOptions)},get activeNotebookEditor(){return(0,se.checkProposedApiEnabled)(Te),ft.activeNotebookEditor},onDidChangeActiveNotebookEditor(J,de,ke){return(0,se.checkProposedApiEnabled)(Te),ft.onDidChangeActiveNotebookEditor(J,de,ke)},get visibleNotebookEditors(){return(0,se.checkProposedApiEnabled)(Te),ft.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,se.checkProposedApiEnabled)(Te),ft.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(J,de,ke){return(0,se.checkProposedApiEnabled)(Te),ft.onDidChangeNotebookEditorSelection(J,de,ke)},onDidChangeNotebookEditorVisibleRanges(J,de,ke){return(0,se.checkProposedApiEnabled)(Te),ft.onDidChangeNotebookEditorVisibleRanges(J,de,ke)},showNotebookDocument(J,de){return(0,se.checkProposedApiEnabled)(Te),ft.showNotebookDocument(J,de)},registerExternalUriOpener(J,de,ke){return(0,se.checkProposedApiEnabled)(Te),pn.registerExternalUriOpener(Te.identifier,J,de,ke)},get openEditors(){return(0,se.checkProposedApiEnabled)(Te),wt.tabs},get onDidChangeOpenEditors(){return(0,se.checkProposedApiEnabled)(Te),wt.onDidChangeTabs}},on={get rootPath(){return Ie.report("workspace.rootPath",Te,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),nt.getPath()},set rootPath(J){throw P.readonly()},getWorkspaceFolder(J){return nt.getWorkspaceFolder(J)},get workspaceFolders(){return nt.getWorkspaceFolders()},get name(){return nt.name},set name(J){throw P.readonly()},get workspaceFile(){return nt.workspaceFile},set workspaceFile(J){throw P.readonly()},updateWorkspaceFolders:(J,de,...ke)=>nt.updateWorkspaceFolders(Te,J,de||0,...ke),onDidChangeWorkspaceFolders:function(J,de,ke){return nt.onDidChangeWorkspace(J,de,ke)},asRelativePath:(J,de)=>nt.getRelativePath(J,de),findFiles:(J,de,ke,ut)=>nt.findFiles(N.GlobPattern.from(J),N.GlobPattern.from(de),ke,Te.identifier,ut),findTextInFiles:(J,de,ke,ut)=>{let O,L;return typeof de=="object"?(O=de,L=ke):(O={},L=de,ut=ke),nt.findTextInFiles(J,O||{},L,Te.identifier,ut)},saveAll:J=>nt.saveAll(J),applyEdit(J){return Gt.applyWorkspaceEdit(J)},createFileSystemWatcher:(J,de,ke,ut)=>kt.createFileSystemWatcher(N.GlobPattern.from(J),de,ke,ut),get textDocuments(){return _t.getAllDocumentData().map(J=>J.document)},set textDocuments(J){throw P.readonly()},openTextDocument(J){let de;const ke=J;if(typeof J=="string")de=Promise.resolve(D.URI.file(J));else if(D.URI.isUri(J))de=Promise.resolve(J);else if(!ke||typeof ke=="object")de=_t.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(ut=>_t.ensureDocumentData(ut).then(O=>O.document))},onDidOpenTextDocument:(J,de,ke)=>_t.onDidAddDocument(J,de,ke),onDidCloseTextDocument:(J,de,ke)=>_t.onDidRemoveDocument(J,de,ke),onDidChangeTextDocument:(J,de,ke)=>_t.onDidChangeDocument(J,de,ke),onDidSaveTextDocument:(J,de,ke)=>_t.onDidSaveDocument(J,de,ke),onWillSaveTextDocument:(J,de,ke)=>Tt.getOnWillSaveTextDocumentEvent(Te)(J,de,ke),onDidChangeConfiguration:(J,de,ke)=>Jt.onDidChangeConfiguration(J,de,ke),getConfiguration(J,de){return de=arguments.length===1?void 0:de,Jt.getConfiguration(J,de,Te)},registerTextDocumentContentProvider(J,de){return Mt.registerTextDocumentContentProvider(J,de)},registerTaskProvider:(J,de)=>(Ie.report("window.registerTaskProvider",Te,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Te,J,de)),registerFileSystemProvider(J,de,ke){return dn.registerFileSystemProvider(Te.identifier,J,de,ke)},get fs(){return Xe.value},registerFileSearchProvider:(J,de)=>((0,se.checkProposedApiEnabled)(Te),pt.registerFileSearchProvider(J,de)),registerTextSearchProvider:(J,de)=>((0,se.checkProposedApiEnabled)(Te),pt.registerTextSearchProvider(J,de)),registerRemoteAuthorityResolver:(J,de)=>((0,se.checkProposedApiEnabled)(Te),tt.registerRemoteAuthorityResolver(J,de)),registerResourceLabelFormatter:J=>((0,se.checkProposedApiEnabled)(Te),fn.$registerResourceLabelFormatter(J)),onDidCreateFiles:(J,de,ke)=>kt.onDidCreateFile(J,de,ke),onDidDeleteFiles:(J,de,ke)=>kt.onDidDeleteFile(J,de,ke),onDidRenameFiles:(J,de,ke)=>kt.onDidRenameFile(J,de,ke),onWillCreateFiles:(J,de,ke)=>kt.getOnWillCreateFileEvent(Te)(J,de,ke),onWillDeleteFiles:(J,de,ke)=>kt.getOnWillDeleteFileEvent(Te)(J,de,ke),onWillRenameFiles:(J,de,ke)=>kt.getOnWillRenameFileEvent(Te)(J,de,ke),openTunnel:J=>((0,se.checkProposedApiEnabled)(Te),Oe.openTunnel(Te,J).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,se.checkProposedApiEnabled)(Te),Oe.getTunnels()},onDidChangeTunnels:(J,de,ke)=>((0,se.checkProposedApiEnabled)(Te),Oe.onDidChangeTunnels(J,de,ke)),registerPortAttributesProvider:(J,de)=>((0,se.checkProposedApiEnabled)(Te),Oe.registerPortsAttributesProvider(J,de)),registerTimelineProvider:(J,de)=>((0,se.checkProposedApiEnabled)(Te),jt.registerTimelineProvider(J,de,Te.identifier,Qe.converter)),get isTrusted(){return(0,se.checkProposedApiEnabled)(Te),nt.trusted},requestWorkspaceTrust:J=>((0,se.checkProposedApiEnabled)(Te),nt.requestWorkspaceTrust(J)),onDidReceiveWorkspaceTrust:(J,de,ke)=>nt.onDidReceiveWorkspaceTrust(J,de,ke)},Dn={get inputBox(){return Ie.report("scm.inputBox",Te,"Use 'SourceControl.inputBox' instead"),en.getLastInputBox(Te)},createSourceControl(J,de,ke){return en.createSourceControl(Te,J,de,ke)}},an={createCommentController(J,de){return hn.createCommentController(Te,J,de)}},Ht={get activeDebugSession(){return ct.activeDebugSession},get activeDebugConsole(){return ct.activeDebugConsole},get breakpoints(){return ct.breakpoints},onDidStartDebugSession(J,de,ke){return ct.onDidStartDebugSession(J,de,ke)},onDidTerminateDebugSession(J,de,ke){return ct.onDidTerminateDebugSession(J,de,ke)},onDidChangeActiveDebugSession(J,de,ke){return ct.onDidChangeActiveDebugSession(J,de,ke)},onDidReceiveDebugSessionCustomEvent(J,de,ke){return ct.onDidReceiveDebugSessionCustomEvent(J,de,ke)},onDidChangeBreakpoints(J,de,ke){return ct.onDidChangeBreakpoints(J,de,ke)},registerDebugConfigurationProvider(J,de,ke){return ct.registerDebugConfigurationProvider(J,de,ke||W.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(J,de){return ct.registerDebugAdapterDescriptorFactory(Te,J,de)},registerDebugAdapterTrackerFactory(J,de){return ct.registerDebugAdapterTrackerFactory(J,de)},startDebugging(J,de,ke){return!ke||typeof ke=="object"&&"configuration"in ke?ct.startDebugging(J,de,{parentSession:ke}):ct.startDebugging(J,de,ke||{})},stopDebugging(J){return ct.stopDebugging(J)},addBreakpoints(J){return ct.addBreakpoints(J)},removeBreakpoints(J){return ct.removeBreakpoints(J)},asDebugSourceUri(J,de){return ct.asDebugSourceUri(J,de)}},ln={registerTaskProvider:(J,de)=>vt.registerTaskProvider(Te,J,de),fetchTasks:J=>vt.fetchTasks(J),executeTask:J=>vt.executeTask(Te,J),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(J,de,ke)=>vt.onDidStartTask(J,de,ke),onDidEndTask:(J,de,ke)=>vt.onDidEndTask(J,de,ke),onDidStartTaskProcess:(J,de,ke)=>vt.onDidStartTaskProcess(J,de,ke),onDidEndTaskProcess:(J,de,ke)=>vt.onDidEndTaskProcess(J,de,ke)},Cn={openNotebookDocument:J=>((0,se.checkProposedApiEnabled)(Te),ft.openNotebookDocument(J)),get onDidOpenNotebookDocument(){return(0,se.checkProposedApiEnabled)(Te),ft.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,se.checkProposedApiEnabled)(Te),ft.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,se.checkProposedApiEnabled)(Te),ft.onDidSaveNotebookDocument},get notebookDocuments(){return(0,se.checkProposedApiEnabled)(Te),ft.notebookDocuments.map(J=>J.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,se.checkProposedApiEnabled)(Te),ft.onDidChangeActiveNotebookKernel},registerNotebookSerializer(J,de,ke){return(0,se.checkProposedApiEnabled)(Te),ft.registerNotebookSerializer(Te,J,de,ke)},registerNotebookContentProvider:(J,de,ke)=>((0,se.checkProposedApiEnabled)(Te),ft.registerNotebookContentProvider(Te,J,de,ke)),registerNotebookKernelProvider:(J,de)=>((0,se.checkProposedApiEnabled)(Te),ft.registerNotebookKernelProvider(Te,J,de)),registerNotebookCellStatusBarItemProvider:(J,de)=>((0,se.checkProposedApiEnabled)(Te),ft.registerNotebookCellStatusBarItemProvider(Te,J,de)),createNotebookEditorDecorationType(J){return(0,se.checkProposedApiEnabled)(Te),ft.createNotebookEditorDecorationType(J)},onDidChangeNotebookDocumentMetadata(J,de,ke){return(0,se.checkProposedApiEnabled)(Te),ft.onDidChangeNotebookDocumentMetadata(J,de,ke)},onDidChangeNotebookCells(J,de,ke){return(0,se.checkProposedApiEnabled)(Te),ft.onDidChangeNotebookCells(J,de,ke)},onDidChangeCellExecutionState(J,de,ke){return(0,se.checkProposedApiEnabled)(Te),ft.onDidChangeNotebookCellExecutionState(J,de,ke)},onDidChangeCellOutputs(J,de,ke){return(0,se.checkProposedApiEnabled)(Te),ft.onDidChangeCellOutputs(J,de,ke)},onDidChangeCellMetadata(J,de,ke){return(0,se.checkProposedApiEnabled)(Te),ft.onDidChangeCellMetadata(J,de,ke)},createConcatTextDocument(J,de){return(0,se.checkProposedApiEnabled)(Te),new j.ExtHostNotebookConcatDocument(ft,_t,J,de)},createNotebookCellExecutionTask(J,de,ke){return(0,se.checkProposedApiEnabled)(Te),ft.createNotebookCellExecution(J,de,ke)},createNotebookController(J){return(0,se.checkProposedApiEnabled)(Te),zt.createKernel(Te,J)},createNotebookRendererCommunication(J){return(0,se.checkProposedApiEnabled)(Te),ft.createNotebookCommunication(J)}};return{version:Fe.version,authentication:_n,commands:wn,comments:an,debug:Ht,env:rn,extensions:En,languages:yn,notebook:Cn,scm:Dn,tasks:ln,test:Yt,window:Sn,workspace:on,Breakpoint:W.Breakpoint,CallHierarchyIncomingCall:W.CallHierarchyIncomingCall,CallHierarchyItem:W.CallHierarchyItem,CallHierarchyOutgoingCall:W.CallHierarchyOutgoingCall,CancellationError:P.CancellationError,CancellationTokenSource:k.CancellationTokenSource,CandidatePortSource:f.CandidatePortSource,CodeAction:W.CodeAction,CodeActionKind:W.CodeActionKind,CodeActionTriggerKind:W.CodeActionTriggerKind,CodeLens:W.CodeLens,Color:W.Color,ColorInformation:W.ColorInformation,ColorPresentation:W.ColorPresentation,ColorThemeKind:W.ColorThemeKind,CommentMode:W.CommentMode,CommentThreadCollapsibleState:W.CommentThreadCollapsibleState,CompletionItem:W.CompletionItem,CompletionItemKind:W.CompletionItemKind,CompletionItemTag:W.CompletionItemTag,CompletionList:W.CompletionList,CompletionTriggerKind:W.CompletionTriggerKind,ConfigurationTarget:W.ConfigurationTarget,CustomExecution:W.CustomExecution,DebugAdapterExecutable:W.DebugAdapterExecutable,DebugAdapterInlineImplementation:W.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:W.DebugAdapterNamedPipeServer,DebugAdapterServer:W.DebugAdapterServer,DebugConfigurationProviderTriggerKind:W.DebugConfigurationProviderTriggerKind,DebugConsoleMode:W.DebugConsoleMode,DecorationRangeBehavior:W.DecorationRangeBehavior,Diagnostic:W.Diagnostic,DiagnosticRelatedInformation:W.DiagnosticRelatedInformation,DiagnosticSeverity:W.DiagnosticSeverity,DiagnosticTag:W.DiagnosticTag,Disposable:W.Disposable,DocumentHighlight:W.DocumentHighlight,DocumentHighlightKind:W.DocumentHighlightKind,DocumentLink:W.DocumentLink,DocumentSymbol:W.DocumentSymbol,EndOfLine:W.EndOfLine,EnvironmentVariableMutatorType:W.EnvironmentVariableMutatorType,EvaluatableExpression:W.EvaluatableExpression,InlineValueText:W.InlineValueText,InlineValueVariableLookup:W.InlineValueVariableLookup,InlineValueEvaluatableExpression:W.InlineValueEvaluatableExpression,EventEmitter:A.Emitter,ExtensionKind:W.ExtensionKind,ExtensionMode:W.ExtensionMode,ExternalUriOpenerPriority:W.ExternalUriOpenerPriority,FileChangeType:W.FileChangeType,FileDecoration:W.FileDecoration,FileSystemError:W.FileSystemError,FileType:g.FileType,FoldingRange:W.FoldingRange,FoldingRangeKind:W.FoldingRangeKind,FunctionBreakpoint:W.FunctionBreakpoint,Hover:W.Hover,IndentAction:T.IndentAction,Location:W.Location,MarkdownString:W.MarkdownString,OverviewRulerLane:n.OverviewRulerLane,ParameterInformation:W.ParameterInformation,PortAutoForwardAction:W.PortAutoForwardAction,Position:W.Position,ProcessExecution:W.ProcessExecution,ProgressLocation:W.ProgressLocation,QuickInputButtons:W.QuickInputButtons,Range:W.Range,RelativePattern:W.RelativePattern,Selection:W.Selection,SelectionRange:W.SelectionRange,SemanticTokens:W.SemanticTokens,SemanticTokensBuilder:W.SemanticTokensBuilder,SemanticTokensEdit:W.SemanticTokensEdit,SemanticTokensEdits:W.SemanticTokensEdits,SemanticTokensLegend:W.SemanticTokensLegend,ShellExecution:W.ShellExecution,ShellQuoting:W.ShellQuoting,SignatureHelp:W.SignatureHelp,SignatureHelpTriggerKind:W.SignatureHelpTriggerKind,SignatureInformation:W.SignatureInformation,SnippetString:W.SnippetString,SourceBreakpoint:W.SourceBreakpoint,StandardTokenType:W.StandardTokenType,StatusBarAlignment:W.StatusBarAlignment,SymbolInformation:W.SymbolInformation,SymbolKind:W.SymbolKind,SymbolTag:W.SymbolTag,Task:W.Task,TaskGroup:W.TaskGroup,TaskPanelKind:W.TaskPanelKind,TaskRevealKind:W.TaskRevealKind,TaskScope:W.TaskScope,TextDocumentSaveReason:W.TextDocumentSaveReason,TextEdit:W.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:W.TextEditorLineNumbersStyle,TextEditorRevealType:W.TextEditorRevealType,TextEditorSelectionChangeKind:W.TextEditorSelectionChangeKind,ThemeColor:W.ThemeColor,ThemeIcon:W.ThemeIcon,TreeItem:W.TreeItem,TreeItemCollapsibleState:W.TreeItemCollapsibleState,UIKind:f.UIKind,Uri:D.URI,ViewColumn:W.ViewColumn,WorkspaceEdit:W.WorkspaceEdit,InlineHint:W.InlineHint,InlineHintKind:W.InlineHintKind,RemoteAuthorityResolverError:W.RemoteAuthorityResolverError,ResolvedAuthority:W.ResolvedAuthority,SourceControlInputBoxValidationType:W.SourceControlInputBoxValidationType,ExtensionRuntime:W.ExtensionRuntime,TimelineItem:W.TimelineItem,NotebookCellRange:W.NotebookCellRange,NotebookCellKind:W.NotebookCellKind,NotebookCellExecutionState:W.NotebookCellExecutionState,NotebookDocumentMetadata:W.NotebookDocumentMetadata,NotebookCellMetadata:W.NotebookCellMetadata,NotebookCellData:W.NotebookCellData,NotebookData:W.NotebookData,NotebookCellStatusBarAlignment:W.NotebookCellStatusBarAlignment,NotebookEditorRevealType:W.NotebookEditorRevealType,NotebookCellOutput:W.NotebookCellOutput,NotebookCellOutputItem:W.NotebookCellOutputItem,NotebookCellStatusBarItem:W.NotebookCellStatusBarItem,LinkedEditingRanges:W.LinkedEditingRanges,TestItem:W.TestItem,TestResultState:W.TestResultState,TestMessage:W.TestMessage,TestMessageSeverity:W.TestMessageSeverity,WorkspaceTrustState:W.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ee}),define(ve[225],_e([0,1,61,99,31,98,34,74,39,40,101,102,103,77,76,68,73,100,75,48,72,93]),function(ie,e,E,k,P,A,S,D,y,n,T,C,g,f,r,s,b,h,_,v,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.registerSingleton)(f.IExtensionStoragePaths,f.ExtensionStoragePaths),(0,E.registerSingleton)(b.IExtHostApiDeprecationService,b.ExtHostApiDeprecationService),(0,E.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands),(0,E.registerSingleton)(S.IExtHostConfiguration,S.ExtHostConfiguration),(0,E.registerSingleton)(_.IExtHostConsumerFileSystem,_.ExtHostConsumerFileSystem),(0,E.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,E.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,E.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,E.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo),(0,E.registerSingleton)(k.IExtHostOutputService,k.ExtHostOutputService),(0,E.registerSingleton)(g.IExtHostSearch,g.ExtHostSearch),(0,E.registerSingleton)(r.IExtHostStorage,r.ExtHostStorage),(0,E.registerSingleton)(T.IExtHostTask,T.WorkerExtHostTask),(0,E.registerSingleton)(n.IExtHostTerminalService,n.WorkerExtHostTerminalService),(0,E.registerSingleton)(s.IExtHostTunnelService,s.ExtHostTunnelService),(0,E.registerSingleton)(h.IExtHostWindow,h.ExtHostWindow),(0,E.registerSingleton)(P.IExtHostWorkspace,P.ExtHostWorkspace),(0,E.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,E.registerSingleton)(u.IExtHostTelemetry,u.ExtHostTelemetry)}),define(ve[226],_e([0,1,224,35,220,7,14,5]),function(ie,e,E,k,P,A,S,D){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var n;(function(r){var s;const b=(s=self.trustedTypes)===null||s===void 0?void 0:s.createPolicy("TrustedFunctionWorkaround",{createScript:(_,...v)=>{v.forEach(i=>{var d;if(!((d=self.trustedTypes)===null||d===void 0?void 0:d.isScript(i)))throw new Error("TrustedScripts only, please")});const c=v.slice(0,-1).join(","),u=v.pop().toString();return`(function anonymous(${c}) {
${u}
})`}});function h(..._){return b?self.eval(b.createScript("",..._)):new Function(..._)}r.create=h})(n||(n={}));class T extends P.RequireInterceptor{_installInterceptor(){}getModule(s,b){for(let h of this._alternatives){let _=h(s);if(_){s=_;break}}if(this._factories.has(s))return this._factories.get(s).load(s,b,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class C extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const s=this._extHostContext.getProxy(D.MainContext.MainThreadConsole);f(s,this._initData.environment.isExtensionDevelopmentDebug);const b=this._instaService.invokeFunction(E.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(T,b,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(s){return s.browser}async _loadCommonJSModule(s,b,h){var _,v,c,u,t,i,d,a;b=b.with({path:g(b.path,".js")}),s&&performance.mark(`code/extHost/willFetchExtensionCode/${s.value}`);const l=await fetch(b.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s.value}`),l.status!==200)throw new Error(l.statusText);const o=await l.text(),w=`${b.toString(!0)}#vscode-extension`,I=`${o}
//# sourceURL=${w}`;let p;try{p=n.create((v=(_=C._ttpExtensionScripts)===null||_===void 0?void 0:_.createScript("module"))!==null&&v!==void 0?v:"module",(u=(c=C._ttpExtensionScripts)===null||c===void 0?void 0:c.createScript("exports"))!==null&&u!==void 0?u:"exports",(i=(t=C._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&i!==void 0?i:"require",(a=(d=C._ttpExtensionScripts)===null||d===void 0?void 0:d.createScript(I))!==null&&a!==void 0?a:I)}catch(x){throw s?console.error(`Loading code for extension ${s.value} failed: ${x.message}`):console.error(`Loading code failed: ${x.message}`),console.error(`${b.toString(!0)}${typeof x.line=="number"?` line ${x.line}`:""}${typeof x.column=="number"?` column ${x.column}`:""}`),console.error(x),x}const m={},R={exports:m},F=x=>{const ae=this._fakeModules.getModule(x,b);if(ae===void 0)throw new Error(`Cannot load module '${x}'`);return ae};try{return h.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s.value}`),p(R,m,F),R.exports!==m?R.exports:m}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s.value}`),h.codeLoadingStop()}}async $setRemoteEnvironment(s){throw new Error("Not supported")}async _waitForDebuggerAttachment(s=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const b=Date.now()+s;for(;Date.now()<b&&!("__jsDebugIsReady"in globalThis);)await(0,S.timeout)(10)}}}e.ExtHostExtensionService=C,C._ttpExtensionScripts=(y=self.trustedTypes)===null||y===void 0?void 0:y.createPolicy("ExtensionScripts",{createScript:r=>r});function g(r,s){return r.endsWith(s)?r:r+s}function f(r,s){b("info","log"),b("log","log"),b("warn","warn"),b("error","error");function b(v,c){const u=console[v];console[v]=function(){r.$logExtensionHostMessage({type:"__$console",severity:c,arguments:_(arguments)}),s&&u.apply(console,arguments)}}const h=1e5;function _(v){const c=[],u=[];if(v.length)for(let t=0;t<v.length;t++){if(typeof v[t]=="undefined")v[t]="undefined";else if(v[t]instanceof Error){const i=v[t];i.stack?v[t]=i.stack:v[t]=i.toString()}u.push(v[t])}try{const t=JSON.stringify(u,function(i,d){if(d&&typeof d=="object"){if(c.indexOf(d)!==-1)return"[Circular]";c.push(d)}return d});return t.length>h?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(ve[227],_e([0,1,61,19,35,226,212]),function(ie,e,E,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.registerSingleton)(P.IExtHostExtensionService,A.ExtHostExtensionService),(0,E.registerSingleton)(k.ILogService,S.ExtHostLogService)}),define(ve[229],_e([0,1,23,3,183,221,214,12,78,225,227]),function(ie,e,E,k,P,A,S,D,y){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0});const T=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const C=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const b=(n=self.trustedTypes)===null||n===void 0?void 0:n.createPolicy("extensionHostWorker",{createScriptURL:_=>_}),h=self.Worker;Worker=function(_,v){const c=`importScripts('${_}');`;v=v||{},v.name=v.name||D.basename(_.toString());const u=new Blob([c],{type:"application/javascript"}),t=URL.createObjectURL(u);return new h(b?b.createScriptURL(t):t,v)}}else self.Worker=class extends S.NestedWorker{constructor(b,h){super(C,b,Object.assign({name:D.basename(b.toString())},h))}};const g=new class{exit(b){T()}async exists(b){return!0}async realpath(b){return b}};class f{constructor(){const h=new MessageChannel,_=new k.Emitter;let v=!1;C(h.port2,[h.port2]),h.port1.onmessage=c=>{const{data:u}=c;if(!(u instanceof ArrayBuffer)){console.warn("UNKNOWN data received",u);return}const t=E.VSBuffer.wrap(new Uint8Array(u,0,u.byteLength));if((0,P.isMessageOfType)(t,2)){v=!0,s("received terminate message from renderer");return}_.fire(t)},this.protocol={onMessage:_.event,send:c=>{if(!v){const u=c.buffer.buffer.slice(c.buffer.byteOffset,c.buffer.byteOffset+c.buffer.byteLength);h.port1.postMessage(u,[u])}}}}}function r(b){return new Promise(h=>{const _=b.onMessage(v=>{_.dispose();const c=JSON.parse(v.toString());b.send((0,P.createMessageOfType)(0)),h({protocol:b,initData:c})});b.send((0,P.createMessageOfType)(1))})}let s=b=>T();(function(){const h=new f;y.mark("code/extHost/willConnectToRenderer"),r(h.protocol).then(_=>{y.mark("code/extHost/didWaitForInitData");const v=new A.ExtensionHostMain(_.protocol,_.initData,g,null);s=c=>v.terminate(c)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/25785b97e533b15ae3b12e48aaf4187416437e62/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
